;--------------------------------------------------------------------------------
function read_sdn_data, loc_id, start_list, array_size, increment_list, output_data

pro_name = 'read_sdn_data'
;@getinfo1

BAD = 0
CATCH, BAD

if BAD ne 0 then begin
    CATCH,/CANCEL
    output_data = -9999
    close_hdf5_dataspace, memory_space_id
    close_hdf5_dataspace, dataspace_id
    return, -1
endif

start = reverse(start_list)
edge = reverse(array_size)
stride = reverse(increment_list)

dataspace_id = H5D_GET_SPACE(loc_id)

H5S_SELECT_HYPERSLAB, dataspace_id, start, edge, STRIDE=stride, /RESET
memory_space_id = H5S_CREATE_SIMPLE(edge)

output_data = H5D_READ(loc_id, FILE_SPACE=dataspace_id, $
    MEMORY_SPACE=memory_space_id)

close_hdf5_dataspace, memory_space_id
close_hdf5_dataspace, dataspace_id

return, 0

end

