;===========================================================================
;    IDL PROGRAM TO VIEW A HDF FILE
;    98.11.04 Kam-Pui Lee (757) 827-4864 k.lee@larc.nasa.gov
;===========================================================================
 
;------------------------------------------------------------------
;	add_digital	
;------------------------------------------------------------------
function add_digital, Event

pro_name = 'add_digital'
@getinfo1
 
widget_control, get_uvalue=info, event.top
widget_control, get_uvalue=digital_name_list, event.id

	info.digital.name_sel=digital_name_list(event.value) 
	print, 'digital_data_sel = ', info.digital.name_sel
	info.digital.indices_sel= [ long(event.value) ]
	print, 'digital_indices_sel = ', info.digital.indices_sel

widget_control, set_uvalue=info, event.top

END

;------------------------------------------------------------------
;	add_quality	
;------------------------------------------------------------------
function add_quality, Event

pro_name = 'add_quality'
@getinfo1
 
widget_control, get_uvalue=info, event.top
widget_control, get_uvalue=quality_name_list, event.id

	info.quality.name_sel=quality_name_list(event.value) 
	loc = strpos(info.quality.name_sel, '*')
	if loc ne -1 then begin
	    info.quality.name_sel = strmid(info.quality.name_sel, 0, loc)
	endif
	print, 'quality_data_sel = ', info.quality.name_sel
	info.quality.indices_sel= [ long(event.value) ]
	print, 'quality_indices_sel = ', info.quality.indices_sel

widget_control, set_uvalue=info, event.top

END

;------------------------------------------------------------------
;	add_vfield_quality	
;------------------------------------------------------------------
function add_vfield_quality, Event

pro_name = 'add_vfield_quality'
@getinfo1
 
widget_control, get_uvalue=info, event.top
widget_control, get_uvalue=quality_name_list, event.id

	info.quality.name_sel=quality_name_list(event.value) 
	print, 'quality_data_sel = ', info.quality.name_sel
	info.quality.indices_sel= [ long(event.value) ]
	print, 'quality_indices_sel = ', info.quality.indices_sel

widget_control, set_uvalue=info, info.base

END

;------------------------------------------------------------------
;	add_vfieldCB	
;------------------------------------------------------------------
function add_vfieldCB, event

pro_name = 'add_vfieldCB'
@getinfo1

widget_control, get_uvalue=info, event.top

info.vfield.name_sel = info.name_list_vfield(event.value) 

info.vfield.indices_sel= [ long(event.value) ]

widget_control, set_uvalue=info, event.top

END

;--------------------------------------------------------------------------------
function array_type, type, sizeof

pro_name = 'array_type'
@getinfo1

dims=[1L,1L,1L,1L,1L,1L,1L,1L]

dims(where(sizeof ne 0)) = reverse(sizeof(where(sizeof ne 0)))

version_number = !VERSION.RELEASE
ver_num = float(version_number)

if ver_num gt 5.19 then begin
    CASE type of
	4: array = strarr(dims(0), dims(1), dims(2), dims(3), dims(4))
	5: array = fltarr(dims(0), dims(1), dims(2), dims(3), dims(4))
	6: array = dblarr(dims(0), dims(1), dims(2), dims(3), dims(4))
	20: array = bytarr(dims(0), dims(1), dims(2), dims(3), dims(4))
	21: array = bytarr(dims(0), dims(1), dims(2), dims(3), dims(4))
	22: array = intarr(dims(0), dims(1), dims(2), dims(3), dims(4))
	23: array = uintarr(dims(0), dims(1), dims(2), dims(3), dims(4))
	24: array = lonarr(dims(0), dims(1), dims(2), dims(3), dims(4))
	25: array = ulonarr(dims(0), dims(1), dims(2), dims(3), dims(4))
	else: array = -1
    ENDCASE
endif else begin
    CASE type of
	4: array = strarr(dims(0), dims(1), dims(2), dims(3), dims(4))
	5: array = fltarr(dims(0), dims(1), dims(2), dims(3), dims(4))
	6: array = dblarr(dims(0), dims(1), dims(2), dims(3), dims(4))
	20: array = bytarr(dims(0), dims(1), dims(2), dims(3), dims(4))
	21: array = intarr(dims(0), dims(1), dims(2), dims(3), dims(4))
	22: array = intarr(dims(0), dims(1), dims(2), dims(3), dims(4))
	23: array = lonarr(dims(0), dims(1), dims(2), dims(3), dims(4))
	24: array = lonarr(dims(0), dims(1), dims(2), dims(3), dims(4))
	25: array = dblarr(dims(0), dims(1), dims(2), dims(3), dims(4))
	else: array = -1
    ENDCASE
endelse 

return, array

end

;--------------------------------------------------------------------------------
function get_number, input_value

pro_name = 'get_number'
@getinfo1

if input_value eq 0 then return, input_value

temp = input_value
if abs(temp) ge 1.0 then begin
    temp2 = abs(temp) - abs(fix(temp))
    if temp2 lt 0.3 then begin
	temp1 = float(fix(temp))
    endif else if temp2 ge 0.3 and temp2 lt 0.7 then begin
	if temp gt 0.0 then begin
	    temp1 = float(fix(temp)+0.5)
	endif else begin
	    temp1 = float(fix(temp)-0.5)
	endelse
    endif else begin
	if temp gt 0.0 then begin
            temp1 = float(fix(temp)+1)
        endif else begin
            temp1 = float(fix(temp)-1)
        endelse
    endelse
    return,temp1
endif

num_dec = 1
while(num_dec lt 6) do begin
   temp = temp * 10.0
   if abs(fix(temp)) ge 1.0 then begin
	temp2 = abs(temp) - abs(fix(temp))
	if temp2 lt 0.3 then begin
	    temp1 = float(fix(temp)) / 10^num_dec
	endif else if temp2 ge 0.3 and temp2 lt 0.7 then begin
	    if temp gt 0.0 then begin
		temp1 = float(fix(temp)+0.5) / 10^num_dec
	    endif else begin
		temp1 = float(fix(temp)-0.5) / 10^num_dec
	    endelse
	endif else begin
	    if temp gt 0.0 then begin
		temp1 = float(fix(temp)+1) / 10^num_dec
	    endif else begin
		temp1 = float(fix(temp)-1) / 10^num_dec
	    endelse
	endelse
	return, temp1
    endif
    num_dec = num_dec + 1
endwhile

return, input_value

end

;--------------------------------------------------------------------------------
function get_optionCB, event

pro_name = 'get_optionCB'
@getinfo1

widget_control, get_uvalue=cid, event.top

widget_control,set_uvalue=event.value,cid
widget_control,event.top,/destroy

end

;--------------------------------------------------------------------------------
function get_option, default_option, list, title, message, info, $
    base_leader=base_leader

pro_name = 'get_option'
@getinfo1

if keyword_set(base_leader) then baseleader = base_leader else baseleader = info.base

id=default_option
base_b = widget_base (uvalue = id, map=0)
widget_control, base_b, /realize

num_line = n_elements(message)

base_loc = widget_info(baseleader, /geometry)
xoffset = base_loc.xoffset + 100
yoffset = base_loc.yoffset + 100

base=widget_base(group_leader=baseleader, /modal, column=1, xoffset=xoffset, $
	yoffset=yoffset, TITLE=title, uvalue=base_b)

if num_line gt 0 then begin
	temp_text = ''
	junk = widget_label(base,value=temp_text,/ALIGN_LEFT, $
		font=info.font)
	for i = 0,num_line-1 do begin
		temp_text = message(i)
		junk = widget_label(base,value=temp_text,/ALIGN_LEFT, $
			font=info.font)
	endfor
	temp_text = ''
	junk = widget_label(base,value=temp_text,/ALIGN_LEFT, $
		font=info.font)
endif

the_pick=CW_BGROUP(base, list, FONT=info.font, EVENT_FUNCT='get_optionCB', $
	/EXCLUSIVE)

widget_control, base, /realize
widget_control, set_uvalue=base_b, base
xmanager, 'main_widget', base
    
widget_control, get_uvalue=picked_val, base_b
widget_control, base_b, /destroy

return,picked_val
 
end

;--------------------------------------------------------------------------------
;  remove the array memory
pro undefine, varname

pro_name = 'undefine'
@getinfo

tempvar = size(temporary(varname))

end

;--------------------------------------------------------------------------------
pro getfieldvalueCB, event

pro_name = 'getfieldvalueCB'
@getinfo

widget_control, get_uvalue=base_b, event.top
widget_control, get_uvalue=field_id, event.id

widget_control, field_id, get_value=fields_value

widget_control,set_uvalue=fields_value,base_b

widget_control,event.top,/destroy

end

;--------------------------------------------------------------------------------
pro cancelvalueCB, event

pro_name = 'cancelvalueCB'
@getinfo

widget_control, get_uvalue=base_b, event.top
widget_control, get_uvalue=field_id, event.id

fields_value = 'cancel'

widget_control,set_uvalue=fields_value,base_b

widget_control,event.top,/destroy

end

;--------------------------------------------------------------------------------
function get_field_value, i_value, xsize, title, f_title, message, info, $
    base_leader = base_leader

pro_name = 'get_field_value'
@getinfo1

if keyword_set(base_leader) then baseleader = base_leader else baseleader = info.base

id=string(i_value)
base_b = widget_base (uvalue = id, map=0)
widget_control, base_b, /realize

num_line = n_elements(message)

base_loc = widget_info(baseleader, /geometry)
xoffset = base_loc.xoffset + 100
yoffset = base_loc.yoffset + 100

base=widget_base(group_leader=baseleader, /modal, column=1, xoffset=xoffset, $
	yoffset=yoffset, TITLE=title, uvalue=base_b)

if num_line gt 0 then begin
	temp_text = ''
	junk = widget_label(base,value=temp_text,/ALIGN_LEFT, $
		font=info.font)
	for i = 0,num_line-1 do begin
		temp_text = message(i)
		junk = widget_label(base,value=temp_text,/ALIGN_LEFT, $
			font=info.font)
	endfor
	temp_text = ''
	junk = widget_label(base,value=temp_text,/ALIGN_LEFT, $
		font=info.font)
endif

c_group=widget_base(base, row=1,map=1)

if xsize lt 1 then xszie = 20
field_id = CW_FIELD(c_group, VALUE=i_value, ROW=1, /STRING, $
	FIELDFONT=info.font, FONT=info.font, TITLE=f_title, XSIZE=xsize)

group2=widget_base(base, row=1,map=1, space=40, /align_center)

button1=widget_button(group2, FONT=info.font, EVENT_PRO='getfieldvalueCB', VALUE="Done",$
/ALIGN_CENTER, uvalue=field_id)

button2=widget_button(group2, FONT=info.font, EVENT_PRO='cancelvalueCB', VALUE="Cancel",$
/ALIGN_CENTER, uvalue=field_id)

widget_control, /realize, base
widget_control, DEFAULT_BUTTON=button1, CANCEL_BUTTON=button2, base

widget_control, set_uvalue=base_b, base
widget_control, set_uvalue=field_id, button1
xmanager, 'main_widget', base
    
widget_control, get_uvalue=picked_val, base_b
widget_control, base_b, /destroy

return,picked_val
 
end

;--------------------------------------------------------------------------------
pro getnfieldvalueCB, event

pro_name = 'getnfieldvalueCB'
@getinfo

widget_control, get_uvalue=base_b, event.top
widget_control, get_uvalue=field_id, event.id

num_values = n_elements(field_id)
fields_value = ''
for i = 0, num_values-1 do begin
    widget_control, field_id(i), get_value=field_value
    fields_value = [fields_value, field_value]
endfor

fields_value = fields_value(1:num_values)
;print,'fields_value = ',fields_value

widget_control,set_uvalue=fields_value,base_b

widget_control,event.top,/destroy

end

;--------------------------------------------------------------------------------
function get_n_field_value, num_values, i_value, xsize, title, f_title, $
    message, top_base, info

pro_name = 'get_n_field_value'
@getinfo1

field_id = lonarr(num_values)
num = n_elements(i_value)
if num lt num_values then begin
    for i = num, num_values-1 do begin
	i_value = [i_value, i_value(num-1)]
    endfor
endif
num = n_elements(f_title)
if num lt num_values then begin
    for i = num, num_values-1 do begin
	f_title = [f_title, f_title(num-1)]
    endfor
endif
num = n_elements(xsize)
if num lt num_values then begin
    for i = num, num_values-1 do begin
	xsize = [xsize, xsize(num-1)]
    endfor
endif

id=string(i_value)
base_b = widget_base (uvalue = id, map=0)
widget_control, base_b, /realize

num_line = n_elements(message)

base_loc = widget_info(top_base, /geometry)
xoffset = base_loc.xoffset + 100
yoffset = base_loc.yoffset + 100

base=widget_base(group_leader=top_base, /modal, column=1, xoffset=xoffset, $
	yoffset=yoffset, TITLE=title, uvalue=base_b)

if num_line gt 0 then begin
	temp_text = ''
	junk = widget_label(base,value=temp_text,/ALIGN_LEFT, $
		font=info.font)
	for i = 0,num_line-1 do begin
		temp_text = message(i)
		junk = widget_label(base,value=temp_text,/ALIGN_LEFT, $
			font=info.font)
	endfor
	temp_text = ''
	junk = widget_label(base,value=temp_text,/ALIGN_LEFT, $
		font=info.font)
endif

for i = 0, num_values-1 do begin
    c_group=widget_base(base, row=1,map=1)
    if xsize(i) lt 1 then fsize = 20 else fsize = xsize(i)
    value1 = i_value(i)
    field1 = f_title(i)
    field_id(i) = CW_FIELD(c_group, VALUE=value1, ROW=1, /STRING, $
	FIELDFONT=info.font, FONT=info.font, TITLE=field1, XSIZE=fsize)
endfor

group2=widget_base(base, row=1,map=1, space=40, /align_center)

button1=widget_button(group2, FONT=info.font, EVENT_PRO='getnfieldvalueCB', VALUE="Done",$
/ALIGN_CENTER, uvalue=field_id)

button2=widget_button(group2, FONT=info.font, EVENT_PRO='cancelvalueCB', VALUE="Cancel",$
/ALIGN_CENTER, uvalue=field_id)

widget_control, /realize, base
widget_control, DEFAULT_BUTTON=button1, CANCEL_BUTTON=button2, base

widget_control, set_uvalue=base_b, base
widget_control, set_uvalue=field_id, button1
xmanager, 'main_widget', base
    
widget_control, get_uvalue=picked_val, base_b
widget_control, base_b, /destroy

return,picked_val
 
end

;--------------------------------------------------------------------------------
pro getmnfieldvalueCB, event

pro_name = 'getmnfieldvalueCB'
@getinfo

widget_control, get_uvalue=base_b, event.top
widget_control, get_uvalue=field_id, event.id

num_values = n_elements(field_id)
fields_value = ''
for i = 0, num_values-1 do begin
    widget_control, field_id(i), get_value=field_value
    fields_value = [fields_value, field_value]
endfor

fields_value = fields_value(1:num_values)
;print,'fields_value = ',fields_value

widget_control,set_uvalue=fields_value,base_b

widget_control,event.top,/destroy

end

;--------------------------------------------------------------------------------
function get_mn_field_value, m_value, n_value, i_value, title, m_title, $
    n_title, message, top_base, info

pro_name = 'get_mn_field_value'
@getinfo1

num_values = m_value*n_value
num = n_elements(n_title)
name_flag = 0
if num - n_value eq 1 then begin
    name_variable = n_title(0)
    n_title = n_title(1:*)
    name_flag = 1
endif

if name_flag eq 1 then field_id = lonarr(num_values+1) $
    else field_id = lonarr(num_values)

num = n_elements(i_value)
if num lt num_values then begin
    if num-n_value ge 0 then begin
	for i = num, num_values-1, n_value do begin
	    for j = 0,n_value-1 do begin
		i_value = [i_value, i_value(num-n_value+j)]
	    endfor
	endfor
    endif else begin
	for i = num, num_values-1 do begin
	    i_value = [i_value, i_value(num-1)]
	endfor
    endelse
endif
num = n_elements(m_title)
if num lt m_value then begin
    for i = num, m_values-1 do begin
	m_title = [m_title, m_title(num-1)]
    endfor
endif
if num lt n_value then begin
    for i = num, n_value-1 do begin
	n_title = [n_title, n_title(num-1)]
    endfor
endif

id=string(i_value)
base_b = widget_base (uvalue = id, map=0)
widget_control, base_b, /realize

num_line = n_elements(message)

base_loc = widget_info(top_base, /geometry)
xoffset = base_loc.xoffset + 100
yoffset = base_loc.yoffset + 100

base=widget_base(group_leader=top_base, /modal, column=1, xoffset=xoffset, $
	yoffset=yoffset, TITLE=title, uvalue=base_b)

if num_line gt 0 then begin
	temp_text = ''
	junk = widget_label(base,value=temp_text,/ALIGN_LEFT, $
		font=info.font)
	for i = 0,num_line-1 do begin
		temp_text = message(i)
		junk = widget_label(base,value=temp_text,/ALIGN_LEFT, $
			font=info.font)
	endfor
	temp_text = ''
	junk = widget_label(base,value=temp_text,/ALIGN_LEFT, $
		font=info.font)
endif

if name_flag eq 1 then begin
    field_id(0) = CW_FIELD(base, VALUE=name_variable, ROW=1, string=1, $
	FIELDFONT=info.font, FONT=info.font, TITLE='Variable Name:', XSIZE=50)
    temp_text = ''
	junk = widget_label(base,value=temp_text,/ALIGN_LEFT, $
	    font=info.font)
endif

max_char = max(strlen(m_title)) + 1
name_size = float(fix(max_char/6) + 1.0) * 0.5
if name_size gt 3.0 then name_size = 3.0
label_size = 2.3

label_group = widget_base(base, row=1, map=1, space=30)
name_button = widget_label(label_group, /ALIGN_CENTER, FONT=info.font, $
    value=' ', units=1, xsize=name_size)
 
for i = 0, n_value-1 do begin
    label1 = n_title(i)
    n_label = widget_label(label_group, /ALIGN_CENTER, FONT=info.font, $
	value=label1, units=1, xsize=label_size)
endfor

k = 0
for i = 0, m_value-1 do begin
    group1=widget_base(base, row=1,map=1, space=30)
    dim_name = m_title(i)
    name_button = widget_label(group1, /ALIGN_CENTER, FONT=info.font, $
	value=dim_name, units=1, xsize=name_size)
    for j = 0, n_value-1 do begin
	value1 = i_value(k)
	field_id(k+1) = CW_FIELD(group1, VALUE=value1, ROW=1, /STRING, $
	    FIELDFONT=info.font, FONT=info.font, TITLE=' ', XSIZE=20)
	k = k + 1
    endfor
endfor

group2=widget_base(base, row=1,map=1, space=40, /align_center)

button1=widget_button(group2, FONT=info.font, EVENT_PRO='getmnfieldvalueCB', VALUE="Done",$
    /ALIGN_CENTER, uvalue=field_id)

button2=widget_button(group2, FONT=info.font, EVENT_PRO='cancelvalueCB', VALUE="Cancel",$
    /ALIGN_CENTER, uvalue=field_id)

widget_control, /realize, base
widget_control, DEFAULT_BUTTON=button1, CANCEL_BUTTON=button2, base

widget_control, set_uvalue=base_b, base
widget_control, set_uvalue=field_id, button1
xmanager, 'main_widget', base
    
widget_control, get_uvalue=picked_val, base_b
widget_control, base_b, /destroy

return,picked_val
 
end

;--------------------------------------------------------------------------------
pro get2fieldvalueCB, event

pro_name = 'get2fieldvalueCB'
@getinfo

widget_control, get_uvalue=base_b, event.top
widget_control, get_uvalue=field_id, event.id

widget_control, field_id(0), get_value=field_value_1
widget_control, field_id(1), get_value=field_value_2

fields_value = [field_value_1 , field_value_2]
print,'scale = ',fields_value(0),' and offset = ',fields_value(1)

widget_control,set_uvalue=fields_value,base_b

widget_control,event.top,/destroy

end

;--------------------------------------------------------------------------------
function get_2_field_value, i_value, xsize, title, f_title, message, info

pro_name = 'get_2_field_value'
@getinfo1

field_id = lonarr(2)
if n_elements(i_value) lt 2 then i_value = [i_value, i_value]
if n_elements(f_title) lt 2 then f_title = [f_title, f_title]
if n_elements(xsize) lt 2 then xsize = [xsize, xsize]

id=string(i_value)
base_b = widget_base (uvalue = id, map=0)
widget_control, base_b, /realize

num_line = n_elements(message)

base_loc = widget_info(info.base, /geometry)
xoffset = base_loc.xoffset + 100
yoffset = base_loc.yoffset + 100

base=widget_base(group_leader=info.base, /modal, column=1, xoffset=xoffset, $
	yoffset=yoffset, TITLE=title, uvalue=base_b)

if num_line gt 0 then begin
	temp_text = ''
	junk = widget_label(base,value=temp_text,/ALIGN_LEFT, $
		font=info.font)
	for i = 0,num_line-1 do begin
		temp_text = message(i)
		junk = widget_label(base,value=temp_text,/ALIGN_LEFT, $
			font=info.font)
	endfor
	temp_text = ''
	junk = widget_label(base,value=temp_text,/ALIGN_LEFT, $
		font=info.font)
endif

c_group_1=widget_base(base, row=1,map=1)
if xsize(0) lt 1 then fsize = 20 else fsize = xsize(0)
value1 = i_value(0)
field1 = f_title(0)
field_id(0) = CW_FIELD(c_group_1, VALUE=value1, ROW=1, /STRING, $
	FIELDFONT=info.font, FONT=info.font, TITLE=field1, XSIZE=fsize)

c_group_2=widget_base(base, row=1,map=1)
if xsize(1) lt 1 then fsize = 20 else fsize = xsize(1)
value1 = i_value(1)
field1 = f_title(1)
field_id(1) = CW_FIELD(c_group_2, VALUE=value1, ROW=1, /STRING, $
	FIELDFONT=info.font, FONT=info.font, TITLE=field1, XSIZE=fsize)

group2=widget_base(base, row=1,map=1, space=40, /align_center)

button1=widget_button(group2, FONT=info.font, EVENT_PRO='get2fieldvalueCB', VALUE="Done",$
/ALIGN_CENTER, uvalue=field_id)

button2=widget_button(group2, FONT=info.font, EVENT_PRO='cancelvalueCB', VALUE="Cancel",$
/ALIGN_CENTER, uvalue=field_id)

widget_control, /realize, base
widget_control, DEFAULT_BUTTON=button1, CANCEL_BUTTON=button2, base

widget_control, set_uvalue=base_b, base
widget_control, set_uvalue=field_id, button1
xmanager, 'main_widget', base
    
widget_control, get_uvalue=picked_val, base_b
widget_control, base_b, /destroy

return,picked_val
 
end

;--------------------------------------------------------------------------------
pro displayfileCB, event

pro_name = 'displayfileCB'
@getinfo

widget_control, /hourglass

widget_control, get_uvalue=display_info, event.id

case display_info.type of
	1: command_line = "emacs " + display_info.file + " &"
	2: begin
		command_line = display_info.ieditor + " -geometry 757x531+75+104"
		command_line = command_line + " -title 'Display ASCII Input file' "
		command_line = command_line + display_info.file + " &"
	   end
	3: command_line = 'start edit "' + display_info.file + '"'
	4: begin
		if !D.Name eq 'X' then begin
			command_line = display_info.editor + " " + display_info.file + " &"
		endif else begin
			command_line = 'start ' + display_info.editor + ' "' + display_info.file + '"'
		endelse
	   end
	5: begin
		command_line="xterm -bg \#73a1ff -fn "
		command_line=command_line+ $
			"-adobe-courier-bold-r-normal--14-100-100-100-m-90-iso8859-1"
		command_line=command_line + " -e emacs " + display_info.file + " &"
	   end
	else: begin
		command_line="xterm -bg \#73a1ff -fn "
		command_line=command_line+ $
			"-adobe-courier-bold-r-normal--14-100-100-100-m-90-iso8859-1"
		command_line=command_line + " -e vi -R " + display_info.file + " &"
	   end
endcase

spawn, command_line, results

end

;--------------------------------------------------------------------------------
pro getlistfieldCB, event

pro_name = 'getlistfieldCB'
@getinfo

widget_control, get_uvalue=base_b, event.top
widget_control, get_uvalue=field_id, event.id

num_values = n_elements(field_id)
fields_value = ''
for i = 0, num_values-1 do begin
    widget_control, field_id(i), get_value=field_value
    fields_value = [fields_value, field_value]
endfor

fields_value = fields_value(1:num_values)
;print,'fields_value = ',fields_value

widget_control,set_uvalue=fields_value,base_b

widget_control,event.top,/destroy

end

;--------------------------------------------------------------------------------
function get_list_field, num_values, i_value, xsize, title, f_title, $
    message, filename, top_base, info

pro_name = 'get_list_field'
@getinfo1

field_id = lonarr(num_values)
num = n_elements(i_value)
if num lt num_values then begin
    for i = num, num_values-1 do begin
	i_value = [i_value, i_value(num-1)]
    endfor
endif
num = n_elements(f_title)
if num lt num_values then begin
    for i = num, num_values-1 do begin
	f_title = [f_title, f_title(num-1)]
    endfor
endif
num = n_elements(xsize)
if num lt num_values then begin
    for i = num, num_values-1 do begin
	xsize = [xsize, xsize(num-1)]
    endfor
endif

id=string(i_value)
base_b = widget_base (uvalue = id, map=0)
widget_control, base_b, /realize

num_line = n_elements(message)

display_info = {file: filename, type: info.editor_type, editor: info.editor, $
    ieditor: info.ieditor}

base_loc = widget_info(top_base, /geometry)
xoffset = base_loc.xoffset + 100
yoffset = base_loc.yoffset + 100

base=widget_base(group_leader=top_base, /modal, column=1, xoffset=xoffset, $
	yoffset=yoffset, TITLE=title, uvalue=base_b)

if num_line gt 0 then begin
	temp_text = ''
	junk = widget_label(base,value=temp_text,/ALIGN_LEFT, $
		font=info.font)
	for i = 0,num_line-1 do begin
		temp_text = message(i)
		junk = widget_label(base,value=temp_text,/ALIGN_LEFT, $
			font=info.font)
	endfor
	temp_text = ''
	junk = widget_label(base,value=temp_text,/ALIGN_LEFT, $
		font=info.font)
endif

for i = 0, num_values-1 do begin
    c_group=widget_base(base, row=1,map=1)
    if xsize(i) lt 1 then fsize = 20 else fsize = xsize(i)
    value1 = i_value(i)
    field1 = f_title(i)
    field_id(i) = CW_FIELD(c_group, VALUE=value1, ROW=1, /STRING, $
	FIELDFONT=info.font, FONT=info.font, TITLE=field1, XSIZE=fsize)
endfor

group2=widget_base(base, row=1,map=1, space=40, /align_center)

button1=widget_button(group2, FONT=info.font, EVENT_PRO='getnfieldvalueCB', VALUE="Done",$
/ALIGN_CENTER, uvalue=field_id)

button2=widget_button(group2, FONT=info.font, EVENT_PRO='cancelvalueCB', VALUE="Cancel",$
/ALIGN_CENTER, uvalue=field_id)

button3=widget_button(group2, FONT=info.font, EVENT_PRO='displayfileCB', VALUE="Display File",$
/ALIGN_CENTER, uvalue=display_info)

widget_control, /realize, base
widget_control, DEFAULT_BUTTON=button1, CANCEL_BUTTON=button2, base

widget_control, set_uvalue=base_b, base
widget_control, set_uvalue=field_id, button1
xmanager, 'main_widget', base
    
widget_control, get_uvalue=picked_val, base_b
widget_control, base_b, /destroy

return,picked_val
 
end

;--------------------------------------------------------------------------------
function convert_idltypename_hdftype, type

pro_name = 'convert_idltypename_hdftype'
@getinfo1

case type of
	'FLOAT': data_type = 5
	'DOUBLE': data_type = 6
	'BYTE': data_type = 21
	'INT': data_type = 22
	'LONG': data_type = 24
	'STRING': data_type = 4
	'UINT': data_type = 23
	'ULONG': data_type = 25
	'LONG64': data_type = 26
	'ULONG64': data_type = 27
	else: data_type = 5
endcase

return, long(data_type)

end

;--------------------------------------------------------------------------------
function convert_idltypename_hdftypename, type

pro_name = 'convert_idltypename_hdftypename'
@getinfoa

data_type = ''
case type of
	'FLOAT': data_type = 'DFNT_FLOAT32'
	'DOUBLE': data_type = 'DFNT_FLOAT64'
	'BYTE': data_type = 'DFNT_UINT8'
	'INT': data_type = 'DFNT_INT16'
	'LONG': data_type = 'DFNT_INT32'
	'STRING': data_type = 'DFNT_CHAR'
	'UINT': data_type = 'DFNT_UINT16'
	'ULONG': data_type = 'DFNT_UINT32'
	'LONG64': data_type = 'DFNT_INT64'
	'ULONG64': data_type = 'DFNT_UINT64'
	else: data_type = 'UNKNOWN'
endcase

return, data_type

end

;--------------------------------------------------------------------------------
function convert_idltypename_idltype, type

pro_name = 'convert_idltypename_idltype'
@getinfo1

case type of
	'FLOAT': data_type = 4
	'DOUBLE': data_type = 5
	'BYTE': data_type = 1
	'INT': data_type = 2
	'LONG': data_type = 3
	'STRING': data_type = 7
	'UINT': data_type = 12
	'ULONG': data_type = 13
	'LONG64': data_type = 14
	'ULONG64': data_type = 15
	else: data_type = 4
endcase

return, data_type

end

;--------------------------------------------------------------------------------
function convert_idltype_hdftype, type

pro_name = 'convert_idltype_hdftype'
@getinfo1

case type of
	4: data_type = 5
	5: data_type = 6
	1: data_type = 21
	2: data_type = 22
	3: data_type = 24
	7: data_type = 4
	12: data_type = 23
	13: data_type = 25
	14: data_type = 26
	15: data_type = 27
	else: data_type = 5
endcase

return, data_type

end

;--------------------------------------------------------------------------------
function convert_hdftypename_hdftype, type

pro_name = 'convert_hdftypename_hdftype'
@getinfo1

case type of
	'DFNT_UCHAR8': data_type = 3
	'DFNT_CHAR': data_type = 4
	'DFNT_CHAR8': data_type = 4
	'DFNT_FLOAT32': data_type = 5
	'DFNT_FLOAT64': data_type = 6
	'DFNT_DOUBLE': data_type = 6
	'DFNT_INT8': data_type = 20
	'DFNT_UINT8': data_type = 21
	'DFNT_INT16': data_type = 22
	'DFNT_UINT16': data_type = 23
	'DFNT_INT32': data_type = 24
	'DFNT_UINT32': data_type = 25
	'DFNT_INT64': data_type = 26
	'DFNT_UINT64': data_type = 27
	else: data_type = 5
endcase

return, long(data_type)

end

;--------------------------------------------------------------------------------
function convert_hdftype_idltype, type

pro_name = 'convert_hdftype_idltype'
@getinfo1

case type of
	3: data_type = 1
	4: data_type = 1
	5: data_type = 4
	6: data_type = 5
	20: data_type = 1
	21: data_type = 1
	22: data_type = 2
	23: data_type = 12
	24: data_type = 3
	25: data_type = 13
	26: data_type = 14
	27: data_type = 15
	else: data_type = 4
endcase

return, long(data_type)

end

;--------------------------------------------------------------------------------
function get_real_sds_dims, info, this_subset, sds_rank

pro_name = 'get_real_sds_dims'
@getinfo1

data_name = info.subset.data(this_subset).subset_name
data_name = data_name(0)
filename = info.subset.data(this_subset).src_filename
filename = filename(0)

check_hdf = HDF_ISHDF(filename)
if check_hdf eq 0 then return, -9999

sd_id = HDF_SD_START(filename, /READ)
if sd_id eq -1 then begin
	result=dialog_message('Problem to open '+filename+'!', $
		title='View HDF Warning!')
	return, -9999
endif

sds_ref = info.subset.data(this_subset).src_ref
sds_id = HDF_SD_SELECT(sd_id, sds_ref)
if sds_id eq -1 then begin
	result=dialog_message('Problem to select '+data_name+'!',$
		title='View HDF Warning!')
	HDF_SD_END,sd_id
	return, -9999
endif

HDF_SD_GETINFO, sds_id, NDIMS=sds_rank, DIMS=sds_dims, /NOREVERSE
HDF_SD_ENDACCESS, sds_id

HDF_SD_END, sd_id

return, sds_dims

end

;--------------------------------------------------------------------------------
function get_sds_dims, filename, data_name, num_sds, sds_ref, sds_rank, sds_dims, sds_type

pro_name = 'get_sds_dims'
@getinfoa

sd_id = HDF_SD_START(filename, /READ)
if sd_id eq -1 then begin
	result=dialog_message('Problem to open '+filename+'!', $
		title='View HDF Warning!')
	return, 'BAD'
endif

sds_id = HDF_SD_SELECT(sd_id, sds_ref)
if sds_id eq -1 then begin
	result=dialog_message('Problem to select '+data_name+'!',$
		title='View HDF Warning!')
	HDF_SD_END,sd_id
	return, 'BAD'
endif

HDF_SD_GETINFO, sds_id, NAME=sds_name, NDIMS=sds_rank, DIMS=sds_dims, $
	HDF_TYPE=type, NATTS=nattrs, TYPE=idl_type, /NOREVERSE
HDF_SD_ENDACCESS, sds_id

print,'hdf_type = ',type
print,'idl_type = ',idl_type

if data_name ne sds_name then begin
    print,data_name,' is not equal to ',sds_name
    old_quiet = !QUIET
    !QUIET=1
    index = HDF_SD_NAMETOINDEX(sd_id, data_name)
    !QUIET=old_quiet
    if index eq -1 then begin
	result=dialog_message('Problem to find the index of '+data_name+'!', $
		title='View HDF Warning!')
	HDF_SD_END, sd_id
	return, 'BAD'
    endif

    if num_sds gt 1 then begin
	first_index = index
	num_match = 1
	HDF_SD_FILEINFO,sd_id,ndatasets,nglobal_attr
	i = first_index + 1
	while num_match lt num_sds and i lt ndatasets do begin
	    sds_id = HDF_SD_SELECT(sd_id, i)
	    if sds_id eq -1 then begin
		result=dialog_message('Problem to select SDS data!',$
		   title='View HDF Warning!')
		HDF_SD_END,sd_id
		return, 'BAD'
	    endif
	    HDF_SD_GETINFO, sds_id, NAME=sds_name, NDIMS=sds_rank, DIMS=sds_dims, $
		HDF_TYPE=type, NATTS=nattrs, /NOREVERSE
	    if data_name eq sds_name then num_match = num_match + 1
	    if num_match eq num_sds then index = i
	    HDF_SD_ENDACCESS, sds_id
	    i = i + 1
	endwhile
	if i eq ndatasets then index = first_index
    endif
    sds_ref = index
    print,'in get_sds_dims, index = ',index
    sds_id = HDF_SD_SELECT(sd_id, index)
    HDF_SD_GETINFO, sds_id, NAME=sds_name, NDIMS=sds_rank, DIMS=sds_dims, $
	HDF_TYPE=type, NATTS=nattrs, /NOREVERSE
    HDF_SD_ENDACCESS, sds_id
endif

HDF_SD_END, sd_id

sds_type = convert_hdftypename_hdftype(type)
print,'sds_ref = ',sds_ref
print,'sds_name = ',sds_name
print,'sds_rank = ',sds_rank
print,'sds_dims = ',sds_dims
print,'sds_type = ',sds_type

return, 'GOOD'

end

;--------------------------------------------------------------------------------
function get_sds_attr_value, filename, data_name, sds_ref, attr_match

pro_name = 'get_sds_attr_value'
@getinfoa

sd_id = HDF_SD_START(filename, /READ)
if sd_id eq -1 then begin
	result=dialog_message('Problem to open '+filename+'!', $
		title='View HDF Warning!')
	return, 'BAD'
endif

sds_id = HDF_SD_SELECT(sd_id, sds_ref)
if sds_id eq -1 then begin
	result=dialog_message('Problem to select '+data_name+'!',$
		title='View HDF Warning!')
	HDF_SD_END,sd_id
	return, 'BAD'
endif

HDF_SD_GETINFO, sds_id, NAME=sds_name, NATTS=nattrs
if nattrs eq 0 then begin
	HDF_SD_ENDACCESS, sds_id
	HDF_SD_END,sd_id
	return, 'BAD'
endif

result = ''
j = 0
for i = 0, nattrs-1 do begin
    HDF_SD_ATTRINFO,sds_id,i,NAME=attr_name,DATA=attr_value,TYPE=attr_type, $
	COUNT=count
    loc = strpos(attr_name,attr_match)
    if loc ne -1 then begin
	if attr_type ne 'STRING' then begin
	    if attr_type eq 'BYTE' then attr_value = fix(attr_value)
	    temp_value = strcompress(strtrim(string(attr_value(0)),2))
	    for k = 1, count-1 do begin
		temp_name = strcompress(strtrim(string(attr_value(k)),2))
		temp_value = temp_value + ';'+temp_name
	    endfor
	endif else begin
	    temp_value = strcompress(strtrim(attr_value,2))
	endelse
	if j eq 0 then result = temp_value $
	    else result = result + '|' + temp_value
	j = j + 1
    endif
endfor

HDF_SD_ENDACCESS, sds_id
HDF_SD_END, sd_id

return,result

end

;--------------------------------------------------------------------------------
function get_sds_attr_name, filename, data_name, sds_ref

pro_name = 'get_sds_attr_name'
@getinfoa

sd_id = HDF_SD_START(filename, /READ)
if sd_id eq -1 then begin
	result=dialog_message('Problem to open '+filename+'!', $
		title='View HDF Warning!')
	return, 'BAD'
endif

sds_id = HDF_SD_SELECT(sd_id, sds_ref)
if sds_id eq -1 then begin
	result=dialog_message('Problem to select '+data_name+'!',$
		title='View HDF Warning!')
	HDF_SD_END,sd_id
	return, 'BAD'
endif

HDF_SD_GETINFO, sds_id, NAME=sds_name, NDIMS=rank, DIMS=dimsize, $
	NATTS=nattrs, /NOREVERSE
if nattrs eq 0 then begin
	HDF_SD_ENDACCESS, sds_id
	HDF_SD_END,sd_id
	return, 'BAD'
endif

result = ''
if nattrs gt dimsize(rank-1) then begin
    j = 0
    for i = 0, nattrs-1 do begin
	HDF_SD_ATTRINFO,sds_id,i,NAME=attr_name,DATA=attr_value
	loc = strpos(attr_name,'long_name')
	if loc ne -1 then begin
	    temp_value = strcompress(strtrim(attr_value,2))
	    if j eq 0 then result = temp_value $
		else result = result + '|' + temp_value
	    j = j + 1
	endif
    endfor
endif else begin
    for i = 0, nattrs-1 do begin
	HDF_SD_ATTRINFO,sds_id,i,NAME=attr_name
	loc = strpos(attr_name,'-')
	if( loc ne -1) then begin
	    temp_value=strmid(attr_name,0,loc)
	endif else begin
	    temp_value=attr_name
	endelse
	if i eq 0 then result = temp_value $
	    else result = result + '|' + temp_value
    endfor
endelse

if strlen(result) eq 0 then result = 'BAD'

HDF_SD_ENDACCESS, sds_id
HDF_SD_END, sd_id

return,result

end

;--------------------------------------------------------------------------------
function get_sds_attr, filename, data_name, sds_ref

pro_name = 'get_sds_attr'
@getinfoa

check_hdf = HDF_ISHDF(filename)
if check_hdf eq 0 then return, 'No Data'

sd_id = HDF_SD_START(filename, /READ)
if sd_id eq -1 then begin
	result=dialog_message('Problem to open '+filename+'!', $
		title='View HDF Warning!')
	return, 'BAD'
endif

sds_id = HDF_SD_SELECT(sd_id, sds_ref)
if sds_id eq -1 then begin
	result=dialog_message('Problem to select '+data_name+'!',$
		title='View HDF Warning!')
	HDF_SD_END,sd_id
	return, 'BAD'
endif

HDF_SD_GETINFO, sds_id, NAME=sds_name, NATTS=nattrs

if nattrs eq 0 then begin
	HDF_SD_ENDACCESS, sds_id
	HDF_SD_END,sd_id
	return, 'No Data'
endif

result = ''
j = 0
for i = 0, nattrs-1 do begin
    HDF_SD_ATTRINFO,sds_id,i,NAME=attr_name,DATA=attr_value, $
	TYPE=attr_type,COUNT=count
    if attr_type ne 'STRING' then begin
	if attr_type eq 'BYTE' then attr_value = fix(attr_value)
	temp_value = strcompress(strtrim(string(attr_value(0)),2))
	for k = 1, count-1 do begin
	    temp_name = strcompress(strtrim(string(attr_value(k)),2))
	    temp_value = temp_value + ';'+temp_name
	endfor
    endif else begin
	temp_value = strcompress(strtrim(attr_value,2))
    endelse
    if j eq 0 then result = attr_name + ': ' + temp_value $
	else result = result + '|' + attr_name + ': ' + temp_value
    j = j + 1
endfor

HDF_SD_ENDACCESS, sds_id
HDF_SD_END, sd_id

return,result

end

;--------------------------------------------------------------------------------
function get_global_attr, filename

pro_name = 'get_global_attr'
@getinfoa

check_hdf = HDF_ISHDF(filename)
if check_hdf eq 0 then return, 'No Data'

sd_id = HDF_SD_START(filename, /READ)
if sd_id eq -1 then begin
	result=dialog_message('Problem to open '+filename+'!', $
		title='View HDF Warning!')
	return, 'BAD'
endif

HDF_SD_FILEINFO, sd_id, ndatasets, nattrs
print,'ndatasets = ',ndatasets,', nattrs = ',nattrs

if nattrs eq 0 then begin
    HDF_SD_END,sd_id
    return, 'No Data'
endif

result = ''
j = 0
for i = 0, nattrs-1 do begin
    HDF_SD_ATTRINFO,sd_id,i,NAME=attr_name,DATA=attr_value, $
	TYPE=attr_type,COUNT=count
    if attr_type ne 'STRING' then begin
	if attr_type eq 'BYTE' then attr_value = fix(attr_value)
	temp_value = strcompress(strtrim(string(attr_value(0)),2))
	for k = 1, count-1 do begin
	    temp_name = strcompress(strtrim(string(attr_value(k)),2))
	    temp_value = temp_value + ';'+temp_name
	endfor
    endif else begin
	temp_value = strcompress(strtrim(attr_value,2))
    endelse
    if j eq 0 then result = attr_name + ': ' + temp_value $
	else result = result + '|' + attr_name + ': ' + temp_value
    j = j + 1
endfor

HDF_SD_END, sd_id

return,result

end

;--------------------------------------------------------------------------------
function read_sds, filename, data_name, sds_ref, start_list, count_list, $
	increment_list, sds_data

pro_name = 'read_sds'
@getinfo1

sd_id = HDF_SD_START(filename, /READ)
if sd_id eq -1 then begin
	result=dialog_message('Problem to open '+filename+'!', $
		title='View HDF Warning!')
	return, -1
endif

sds_id = HDF_SD_SELECT(sd_id, sds_ref)
if sds_id eq -1 then begin
	result=dialog_message('Problem to select '+data_name+'!',$
		title='View HDF Warning!')
	HDF_SD_END,sd_id
	return, -1
endif

start = reverse(start_list)
edge = reverse(count_list)
stride = reverse(increment_list)

HDF_SD_GETDATA,sds_id,sds_data,START=start,COUNT=edge,STRIDE=stride

; If data_type is DFNT_INT8, convert sds_data > 127 to negative number
HDF_SD_GETINFO,sds_id,HDF_TYPE=data_type
if data_type eq 'DFNT_INT8' then begin
    the_type = size(sds_data, /type)
    if the_type eq 1 then sds_data = fix(sds_data)
    sub_neg = where(sds_data gt 127, count)
    if count ne 0 then sds_data(sub_neg) = sds_data(sub_neg) - 256
endif

HDF_SD_ENDACCESS,sds_id
HDF_SD_END, sd_id

end

;--------------------------------------------------------------------------------
function get_vfield_unit, filename, data_name, vdata_ref, vfield_index

pro_name = 'get_vfield_unit'
@getinfoa

filename = filename(0)
file_id = HDF_OPEN(filename, /READ)
if file_id eq -1 then begin
	result=dialog_message('Unable to open '+filename+'!',$
		title='View HDF Warning!')
	return, 'BAD'
endif

vdata_id = HDF_VD_ATTACH(file_id, vdata_ref, /READ)
;if vdata_id eq 0 then begin
if vdata_id le 0 then begin
	result=dialog_message('Unable to attach '+data_name+'!',$
		title='View HDF Warning!')
	HDF_CLOSE,file_id
	return, 'BAD'
endif

findex = vfield_index(0)
HDF_VD_GETINFO, vdata_id, findex, ORDER=output_order, TYPE=type, $
	NAME=fieldname
print,'fieldname = ',fieldname

nattr = HDF_VD_NATTRS(vdata_id, findex)
print,'nattr for field = ',nattr

the_result = 'BAD'

if nattr ne -1 then begin
    found = 0
    i = 0L
    while (found eq 0 ) and (i lt nattr) do begin
	HDF_VD_ATTRINFO, vdata_id, findex, i, data=buffer, name=attr_name
	attr_name =strlowcase(attr_name)
	loc = strpos(attr_name, 'units')
	if loc eq -1 then loc = strpos(attr_name, 'unit')
	if loc ne -1 then begin
	    if loc eq 0 then begin
		the_result = buffer
		found = 1
	    endif else begin
		buffer = strcompress(buffer)
		loc_start = strpos(buffer, 'unit is')
		if loc_start eq -1 then begin
		    loc_start = strpos(buffer, 'units is')
		    if loc_start ne -1 then offset = 9
		endif else offset = 8
		if loc_start ne -1 then begin
		    loc_start = loc_start + offset
		    length = strlen(buffer)
		    loc_end = strpos(buffer, ';', loc_start)
		    if loc_end eq -1 then loc_end = length + 1
		    the_result = strmid(buffer, loc_start, loc_end-loc_start)
		    found = 1
		endif
	    endelse
	endif
	i = i + 1
    endwhile
endif

if the_result eq 'BAD' then begin
    nattr = HDF_VD_NATTRS(vdata_id, -1)
    print,'nattr for vdata = ',nattr
    if nattr ne -1 then begin
	found = 0
	i = 0L
	while (found eq 0 ) and (i lt nattr) do begin
	    HDF_VD_ATTRINFO, vdata_id, -1, i, data=buffer, name=attr_name
	    attr_name =strlowcase(attr_name)
	    loc = strpos(attr_name, 'units')
	    if loc eq -1 then loc = strpos(attr_name, 'unit')
	    if loc ne -1 then begin
		if loc eq 0 then begin
		    the_result = buffer
		    found = 1
		endif else begin
		    buffer = strcompress(buffer)
		    loc_start = strpos(buffer, 'unit is')
		    if loc_start eq -1 then begin
			loc_start = strpos(buffer, 'units is')
			if loc_start ne -1 then offset = 9
		    endif else offset = 8
		    if loc_start ne -1 then begin
			loc_start = loc_start + offset
			length = strlen(buffer)
			loc_end = strpos(buffer, ';', loc_start)
			if loc_end eq -1 then loc_end = length + 1
			the_result = strmid(buffer, loc_start, loc_end-loc_start)
			found = 1
		    endif
		endelse
	    endif
	    i = i + 1
	endwhile
    endif
endif

HDF_VD_DETACH, vdata_id
HDF_CLOSE, file_id

return, the_result

end

;--------------------------------------------------------------------------------
function get_vfield_attr, filename, data_name, vdata_ref

pro_name = 'get_vfield_attr'
@getinfoa

filename = filename(0)
file_id = HDF_OPEN(filename, /READ)
if file_id eq -1 then begin
	result=dialog_message('Unable to open '+filename+'!',$
		title='View HDF Warning!')
	return, 'BAD'
endif

vdata_id = HDF_VD_ATTACH(file_id, vdata_ref, /READ)
;if vdata_id eq 0 then begin
if vdata_id le 0 then begin
	result=dialog_message('Unable to attach '+data_name+'!',$
		title='View HDF Warning!')
	HDF_CLOSE,file_id
	return, 'BAD'
endif

;check the attributes for field
print,'data_name = ',data_name
nattr = HDF_VD_NATTRS(vdata_id, data_name)
print,'nattr for field = ',nattr

the_result = ''
j = 0

if nattr gt 0 then begin
    for i = 0, nattr-1 do begin
	HDF_VD_ATTRINFO, vdata_id, data_name, i, count=count, data=attr_value, $
	    name=attr_name, type=attr_type
	if attr_type ne 'STRING' then begin
	    if attr_type eq 'BYTE' then attr_value = fix(attr_value)
	    temp_value = strcompress(strtrim(string(attr_value(0)),2))
	    for ic = 1, count-1 do begin
		temp_name = strcompress(strtrim(string(attr_value(ic)),2))
		temp_value = temp_value + ';'+temp_name
	    endfor
	endif else begin
	    temp_value = strcompress(strtrim(attr_value,2))
	endelse
	if strlen(temp_value) gt 0 then begin
	    if j eq 0 then the_result = attr_name + ': ' + temp_value $
		else the_result = the_result + '|' + attr_name + ': ' + temp_value
	    j = j + 1
	endif
    endfor
endif

;check the attributes for vdata
nattr = HDF_VD_NATTRS(vdata_id, -1)
print,'nattr for vdata = ',nattr
if nattr gt 0 then begin
    k = 0
    for i = 0, nattr-1 do begin
	HDF_VD_ATTRINFO, vdata_id, -1, i, count=count, data=attr_value, $
	    name=attr_name, type=attr_type
	if attr_type ne 'STRING' then begin
	    if attr_type eq 'BYTE' then attr_value = fix(attr_value)
	    temp_value = strcompress(strtrim(string(attr_value(0)),2))
	    for ic = 1, count-1 do begin
		temp_name = strcompress(strtrim(string(attr_value(ic)),2))
		temp_value = temp_value + ';'+temp_name
	    endfor
	endif else begin
	    temp_value = strcompress(strtrim(attr_value,2))
	endelse
	if strlen(temp_value) gt 0 then begin
	    if k eq 0 then begin
		HDF_VD_GET, vdata_id, name=vdata_name
		temp_global = vdata_name + ' Global attributes:'
		if j eq 0 then the_result = temp_global $
		    else the_result = the_result + '| |'+temp_global
		k = 1
	    endif
	    the_result = the_result+'|'+attr_name+':'+temp_value
	    j = j + 1
	endif
    endfor
endif else begin
    if j eq 0 then the_result = 'No Data'
endelse

HDF_VD_DETACH, vdata_id
HDF_CLOSE, file_id

print,'the_result = ',the_result
return, the_result

end

;--------------------------------------------------------------------------------
function get_vdata_fields, filename, data_name, num_field, num_vdata, vdata_ref, $
	n_records

pro_name = 'get_vdata_fields'
@getinfoa

filename = filename(0)
file_id = HDF_OPEN(filename, /READ)
if file_id eq -1 then begin
	result=dialog_message('Unable to open '+filename+'!',$
		title='View HDF Warning!')
	return, 'BAD'
endif

data_name = data_name[0]
current_vref = HDF_VD_FIND(file_id, data_name)

;if current_vref eq 0 then begin
if current_vref le 0 then begin
    result=dialog_message('Unable to find '+data_name+'!',$
	title='View HDF Warning!')
    HDF_CLOSE,file_id
    return, 'BAD'
endif

first_vref = current_vref
num_match = 1
continue_flag = 1
while num_match lt num_vdata and continue_flag eq 1 do begin
	previous_vref = current_vref
	current_vref = HDF_VD_GETID(file_id, previous_vref)
	if current_vref ne -1 then begin
		vdata_id = HDF_VD_ATTACH(file_id, current_vref, /READ)
		;if vdata_id ne 0 then begin
		if vdata_id gt 0 then begin
			HDF_VD_GET,vdata_id,NAME=vdata_name
			if vdata_name eq data_name then $
				num_match = num_match + 1
			HDF_VD_DETACH,vdata_id
		endif else begin
			current_vref = first_vref
			continue_flag = 0
		endelse
	endif else begin
		current_vref = first_vref
		continue_flag = 0
	endelse
endwhile

vdata_ref = current_vref
vdata_id = HDF_VD_ATTACH(file_id, current_vref, /READ)
;if vdata_id ne 0 then begin
if vdata_id gt 0 then begin
	HDF_VD_GET,vdata_id,NFIELDS=num_field,COUNT=n_records,FIELDS=fieldname
	HDF_VD_DETACH,vdata_id
endif else fieldname = 'BAD'

HDF_CLOSE, file_id

return, fieldname

end

;--------------------------------------------------------------------------------
function get_vfield_type, filename, data_name, vdata_ref, vfield_index, $
	output_type, output_order, version, library,status, flag

pro_name = 'get_vfield_type'
@getinfoa

filename = filename(0)
file_id = HDF_OPEN(filename, /READ)
if file_id eq -1 then begin
	result=dialog_message('Unable to open '+filename+'!',$
		title='View HDF Warning!')
	return, 'BAD'
endif

vdata_id = HDF_VD_ATTACH(file_id, vdata_ref, /READ)
;if vdata_id eq 0 then begin
if vdata_id le 0 then begin
	result=dialog_message('Unable to attach '+data_name+'!',$
		title='View HDF Warning!')
	HDF_CLOSE,file_id
	return, 'BAD'
endif

findex = vfield_index(0)
HDF_VD_GETINFO, vdata_id, findex, ORDER=output_order, TYPE=type, $
	NAME=fieldname
if flag eq 1 then begin
    if type eq 'BYTE' then begin
	temp_name = '"' + data_name + ' - ' + fieldname + '"'
	result=dialog_message('Is ' + temp_name + ' a text data?', $
		title='View HDF Question!', /QUESTION)
	if result eq 'Yes' then type = 'STRING'
    endif
endif

output_type = convert_idltypename_hdftype(type)
if flag eq 1 then begin
	print,'fieldname = ',fieldname
	print,'order = ',output_order
	print,'type = ',output_type,'; ',type
endif

HDF_VD_DETACH, vdata_id
HDF_CLOSE, file_id

CD, '.', CURRENT = PWD

print,'version = ',version
if version lt 5.5 then begin
    if status eq 1 then begin
	;the_result = CALL_EXTERNAL(PWD+'/' + library,   $
	the_result = CALL_EXTERNAL(library,   $
	'get_vfield_unit', $
	filename,	$
	data_name,	$
	vdata_ref,	$
	findex,		$
	/s_value)
    endif else the_result = 'BAD'
endif else begin
    the_result = get_vfield_unit(filename, data_name, vdata_ref, vfield_index)
endelse

return, the_result

end

;--------------------------------------------------------------------------------
function read_vdata, filename, data_name, vdata_ref, num_record, the_order, $
	the_type, fieldname, vdata_data

pro_name = 'read_vdata'
@getinfo1

fieldname = fieldname(0)
file_id = HDF_OPEN(filename, /READ)
if file_id eq -1 then begin
	result=dialog_message('Problem to open '+filename+'!', $
		title='View HDF Warning!')
	return, -1
endif

vdata_id = HDF_VD_ATTACH(file_id, vdata_ref, /READ)
;if vdata_id eq 0 then begin
if vdata_id le 0 then begin
	result=dialog_message('Problem to attach '+data_name+'!',$
		title='View HDF Warning!')
	HDF_CLOSE,file_id
	return, -1
endif

nread = HDF_VD_READ(vdata_id, temp_data, FIELD=fieldname)
if nread ne num_record + 1 then begin
	the_message = ['Number of records read is not equal to',$
		'    number of records defined!', 'Check output']
	result=dialog_message(the_message, title='View HDF Warning!')
endif

HDF_VD_DETACH, vdata_id
HDF_CLOSE, file_id

size_data = size(temp_data)
if size_data(0) eq 1 then begin
    if num_record eq 0 then data_order = size_data(1) else data_order = 1 
endif else if size_data(0) eq 0 then begin
    data_order = 1
endif else data_order = size_data(1)
if data_order ne the_order then begin
	the_message = ['The order of data read is not equal to',$
                '    the order of data defined!', 'Check output']
        result=dialog_message(the_message, title='View HDF Warning!')
endif

type = size_data(size_data(0) + 1)
hdf_type = convert_idltype_hdftype(type)
if the_type eq 4 then begin
	blank = array_type(hdf_type, data_order+1)
endif else begin
	blank = array_type(hdf_type, data_order)
endelse

single_record=create_struct( 'components' + '0', blank)

vdata_data=replicate(single_record, nread)

if data_order gt 1 then begin
    for i = 0L, nread-1 do begin
	for j = 0L, data_order-1 do begin
		vdata_data(i).components0(j) = temp_data(j,i)
	endfor
    endfor
endif else begin
    for i = 0L, nread-1 do begin
	vdata_data(i).components0(0) = temp_data(i)
    endfor
endelse

return, 0


end

;--------------------------------------------------------------------------------
function open_hdf5_file, filename

pro_name = 'open_hdf5_file'
;@getinfo1

BAD = 0
CATCH, BAD

if BAD ne 0 then begin
    CATCH,/CANCEL
    file_id = -1
    return,file_id
endif

file_id = H5F_OPEN(filename)

return,file_id

end

;--------------------------------------------------------------------------------
function open_hdf5_dataset, fileid, dataset_name

pro_name = 'open_hdf5_dataset'
;@getinfo1

BAD = 0
CATCH, BAD

if BAD ne 0 then begin
    CATCH,/CANCEL
    dataset_id = -1
    return,dataset_id
endif

dataset_id = H5D_OPEN(fileid, dataset_name)

return,dataset_id

end

;--------------------------------------------------------------------------------
function read_hdf5_attribute, loc_id

pro_name = 'read_hdf5_attribute'
;@getinfo1

BAD = 0
CATCH, BAD

if BAD ne 0 then begin
    CATCH,/CANCEL
    datatype_id = H5A_GET_TYPE(loc_id)
    attr_class = H5T_GET_CLASS(datatype_id)
    attribute_value = attr_class + ' cannot convert to IDL type'
    H5T_CLOSE, datatype_id
    return,attribute_value
endif

attribute_value = H5A_READ(loc_id)

return, attribute_value

end

;--------------------------------------------------------------------------------
pro close_hdf5_dataspace, loc_id

pro_name = 'close_hdf5_dataspace'
;@getinfo

BAD = 0
CATCH, BAD

if BAD ne 0 then begin
    CATCH,/CANCEL
    return
endif

H5S_CLOSE, loc_id

return

end

;--------------------------------------------------------------------------------
function get_hdf5_datatype, dataclass, datasize, datasign

pro_name = 'get_hdf5_datatype'
;@getinfo1

case dataclass of
        'H5T_FLOAT': begin
	    case datasize of
		4: data_type = 5
		8: data_type = 6
		else: data_type = 5
	    endcase
	end
	'H5T_INTEGER': begin
	    case datasize of
		1: if datasign eq 0 then data_type = 21 else data_type = 20 
		2: if datasign eq 0 then data_type = 23 else data_type = 22
		4: if datasign eq 0 then data_type = 25 else data_type = 24
		8: if datasign eq 0 then data_type = 27 else data_type = 26
	 	else: data_type = 24
	    endcase
	end
	'H5T_BITFIELD': begin
	    case datasize of
		1: if datasign eq 0 then data_type = 21 else data_type = 20 
		2: if datasign eq 0 then data_type = 23 else data_type = 22
		4: if datasign eq 0 then data_type = 25 else data_type = 24
		8: if datasign eq 0 then data_type = 27 else data_type = 26
	 	else: data_type = 24
	    endcase
	end
	'H5T_ENUM': begin
	    case datasize of
		1: if datasign eq 0 then data_type = 21 else data_type = 20 
		2: if datasign eq 0 then data_type = 23 else data_type = 22
		4: if datasign eq 0 then data_type = 25 else data_type = 24
		8: if datasign eq 0 then data_type = 27 else data_type = 26
	 	else: data_type = 24
	    endcase
	end
	'H5T_STRING': data_type = 4
	'H5T_TIME': data_type = 4
	'H5T_ARRAY': data_type = -1
        else: data_type = -9
endcase

return, long(data_type)

end

;--------------------------------------------------------------------------------
function get_hdf5_data_attr, filename, data_name, index

pro_name = 'get_hdf5_data_attr'
@getinfoa

check_hdf5 = H5F_IS_HDF5(filename)
if check_hdf5 eq 0 then return, 'No Data'

fileid = open_hdf5_file(filename)
if fileid eq -1 then begin
    result=dialog_message('Problem open HDF5 file!',$
        title='View HDF Warning!')
    return, 'BAD'
endif

temp_name = data_name
loc_start=strpos(data_name, '/')
if( loc_start ne -1 and loc_start ne 0) then begin
    loc_end = rstrpos(data_name, ')')
    if loc_end ne -1 then begin
	length = loc_end - loc_start
	temp_name=strmid(data_name,loc_start, length)
	print,'temp_name = ',temp_name
    endif
endif

dataset_id = open_hdf5_dataset(fileid, temp_name)
if dataset_id eq -1 then begin
	result=dialog_message('Problem to open '+data_name+' dataset!',$
		title='View HDF Warning!')
	H5F_CLOSE, fileid
	return, 'BAD'
endif

if index lt 0 then begin
    nattrs = H5A_GET_NUM_ATTRS(dataset_id)

    if nattrs eq 0 then begin
	H5D_CLOSE, dataset_id
	H5F_CLOSE, fileid
	return, 'No Data'
    endif

    result = ''
    j = 0
    for i = 0, nattrs-1 do begin
	attribute_id = H5A_OPEN_IDX(dataset_id, i)
	attr_name = H5A_GET_NAME(attribute_id)
	attr_value = read_hdf5_attribute(attribute_id)

	datatype_id = H5A_GET_TYPE(attribute_id)
	attr_type = H5T_GET_CLASS(datatype_id)

	H5T_CLOSE, datatype_id
	H5A_CLOSE, attribute_id

	if attr_type ne 'H5T_STRING' and attr_type ne 'H5T_TiIME' then begin
	    count = n_elements(attr_value)
	    temp_value = strcompress(strtrim(string(attr_value(0)),2))
	    for k = 1, count-1 do begin
		temp_name = strcompress(strtrim(string(attr_value(k)),2))
		temp_value = temp_value + ';'+temp_name
	    endfor
	endif else begin
	    temp_value = strcompress(strtrim(attr_value,2))
	endelse
	if j eq 0 then result = attr_name + ': ' + temp_value $
	    else result = result + '|' + attr_name + ': ' + temp_value
	j = j + 1
    endfor
endif else begin

    ;datatype_id = H5D_GET_TYPE(dataset_id)
    ;field_datatype_id = H5T_GET_MEMBER_TYPE(datatype_id, index)

    ;result = ''
    ;nattrs = H5A_GET_NUM_ATTRS(field_datatype_id)
    ;if nattrs gt 0 then begin
;	j = 0
;	for i = 0, nattrs-1 do begin
;	    attribute_id = H5A_OPEN_IDX(field_datatype_id, i)
;	    attr_name = H5A_GET_NAME(attribute_id)
;	    attr_value = read_hdf5_attribute(attribute_id)
;
;	    attr_datatype_id = H5A_GET_TYPE(attribute_id)
;	    attr_type = H5T_GET_CLASS(attr_datatype_id)
;
;	    H5T_CLOSE, attr_datatype_id
;	    H5A_CLOSE, attribute_id
;
;	    if attr_type ne 'H5T_STRING' and attr_type ne 'H5T_TiIME' then begin
;		count = n_elements(attr_value)
;		temp_value = strcompress(strtrim(string(attr_value(0)),2))
;		for k = 1, count-1 do begin
;		    temp_name = strcompress(strtrim(string(attr_value(k)),2))
;		    temp_value = temp_value + ';'+temp_name
;		endfor
;	    endif else begin
;		temp_value = strcompress(strtrim(attr_value,2))
;	    endelse
;	    if j eq 0 then result = attr_name + ': ' + temp_value $
;	    else result = result + '|' + attr_name + ': ' + temp_value
;	    j = j + 1
;	endfor
;    endif else begin
	nattrs = H5A_GET_NUM_ATTRS(dataset_id)
	if nattrs gt 0 then begin
	    j = 0
	    for i = 0, nattrs-1 do begin
		attribute_id = H5A_OPEN_IDX(dataset_id, i)
		attr_name = H5A_GET_NAME(attribute_id)
		attr_value = read_hdf5_attribute(attribute_id)

		attr_datatype_id = H5A_GET_TYPE(attribute_id)
		attr_type = H5T_GET_CLASS(attr_datatype_id)

		H5T_CLOSE, attr_datatype_id
		H5A_CLOSE, attribute_id

		if attr_type ne 'H5T_STRING' and attr_type ne 'H5T_TiIME' then begin
		    count = n_elements(attr_value)
		    temp_value = strcompress(strtrim(string(attr_value(0)),2))
		    for k = 1, count-1 do begin
			temp_name = strcompress(strtrim(string(attr_value(k)),2))
			temp_value = temp_value + ';'+temp_name
		    endfor
		endif else begin
		    temp_value = strcompress(strtrim(attr_value,2))
		endelse
		if j eq 0 then result = attr_name + ': ' + temp_value $
		else result = result + '|' + attr_name + ': ' + temp_value
		j = j + 1
	    endfor
	endif else result = 'No Data'
;    endelse

;    H5T_CLOSE, field_datatype_id
;    H5T_CLOSE, datatype_id
endelse

H5D_CLOSE, dataset_id
H5F_CLOSE, fileid

return,result

end

;--------------------------------------------------------------------------------
function subset_output_data, rank, start_list, end_list, increment_list, $
    output_data

pro_name = 'subset_output_data'
@getinfoa

case rank of
    1: begin
	this_start = start_list[0]
	this_end = end_list[0] - 1
	this_increment = increment_list[0]
	if this_end gt this_start then begin
	    output_data = output_data[this_start:this_end]

	    if (this_increment gt 1) then begin
		indices = lindgen(this_end-this_start+1)
		indices = indices mod this_increment
		indices = [where(indices eq 0) ]
		output_data = output_data[indices]
	    endif
	endif
    end
    2: begin
	this_start = start_list[0]
	this_end = end_list[0] - 1
	this_increment = increment_list[0]
	if this_end gt this_start then begin
	    output_data = output_data[*, this_start:this_end]

	    if (this_increment gt 1) then begin
		indices = lindgen(this_end-this_start+1)
		indices = indices mod this_increment
		indices = [where(indices eq 0) ]
		output_data = output_data[*, indices]
	    endif
	endif

	this_start = start_list[1]
	this_end = end_list[1] - 1
	this_increment = increment_list[1]
	if this_end gt this_start then begin
	    output_data = output_data[this_start:this_end, *]

	    if (this_increment gt 1) then begin
		indices = lindgen(this_end-this_start+1)
		indices = indices mod this_increment
		indices = [where(indices eq 0) ]
		output_data = output_data[indices, *]
	    endif
	endif
    end
    3: begin
	this_start = start_list[0]
	this_end = end_list[0] - 1
	this_increment = increment_list[0]
	if this_end gt this_start then begin
	    output_data = output_data[*, *, this_start:this_end]

	    if (this_increment gt 1) then begin
		indices = lindgen(this_end-this_start+1)
		indices = indices mod this_increment
		indices = [where(indices eq 0) ]
		output_data = output_data[*, *, indices]
	    endif
	endif

	this_start = start_list[1]
	this_end = end_list[1] - 1
	this_increment = increment_list[1]
	if this_end gt this_start then begin
	    output_data = output_data[*, this_start:this_end, *]

	    if (this_increment gt 1) then begin
		indices = lindgen(this_end-this_start+1)
		indices = indices mod this_increment
		indices = [where(indices eq 0) ]
		output_data = output_data[*, indices, *]
	    endif
	endif

	this_start = start_list[2]
	this_end = end_list[2] - 1
	this_increment = increment_list[2]
	if this_end gt this_start then begin
	    output_data = output_data[this_start:this_end, *, *]

	    if (this_increment gt 1) then begin
		indices = lindgen(this_end-this_start+1)
		indices = indices mod this_increment
		indices = [where(indices eq 0) ]
		output_data = output_data[indices, *, *]
	    endif
	endif
    end
    4: begin
	this_start = start_list[0]
	this_end = end_list[0] - 1
	this_increment = increment_list[0]
	if this_end gt this_start then begin
	    output_data = output_data[*, *, *, this_start:this_end]

	    if (this_increment gt 1) then begin
		indices = lindgen(this_end-this_start+1)
		indices = indices mod this_increment
		indices = [where(indices eq 0) ]
		output_data = output_data[*, *, *, indices]
	    endif
	endif

	this_start = start_list[1]
	this_end = end_list[1] - 1
	this_increment = increment_list[1]
	if this_end gt this_start then begin
	    output_data = output_data[*, *, this_start:this_end, *]

	    if (this_increment gt 1) then begin
		indices = lindgen(this_end-this_start+1)
		indices = indices mod this_increment
		indices = [where(indices eq 0) ]
		output_data = output_data[*, *, indices, *]
	    endif
	endif

	this_start = start_list[2]
	this_end = end_list[2] - 1
	this_increment = increment_list[2]
	if this_end gt this_start then begin
	    output_data = output_data[*, this_start:this_end, *, *]

	    if (this_increment gt 1) then begin
		indices = lindgen(this_end-this_start+1)
		indices = indices mod this_increment
		indices = [where(indices eq 0) ]
		output_data = output_data[*, indices, *, *]
	    endif
	endif

	this_start = start_list[3]
	this_end = end_list[3] - 1
	this_increment = increment_list[3]
	if this_end gt this_start then begin
	    output_data = output_data[this_start:this_end, *, *, *]

	    if (this_increment gt 1) then begin
		indices = lindgen(this_end-this_start+1)
		indices = indices mod this_increment
		indices = [where(indices eq 0) ]
		output_data = output_data[indices, *, *, *]
	    endif
	endif
    end
    else: begin
	result=dialog_message('Do not support the rank greater than 4!',$
	    title='View HDF Warning!')
    end
endcase

return, output_data

end

;--------------------------------------------------------------------------------
function get_cdn_field_unit, field_datatype_id, field_name, dataset_id

pro_name = 'get_cdn_field_unit'
@getinfoa

unit_list = [ 'None' ]
;num_attr = H5A_GET_NUM_ATTRS(field_name)
;print,'num_attr = ',num_attr
;if num_attr gt 0 then begin
;    for i = 0, num_attr-1 do begin
;        attribute_id = H5A_OPEN_IDX(field_datatype_id, i)
;        attribute_name = H5A_GET_NAME(attribute_id)
;        attribute_value = read_hdf5_attribute(attribute_id)
;        attribute_name =strlowcase(attribute_name)
;        if strpos(attribute_name,"unit") ne -1 then unit_list = [unit_list, attribute_value]
;        H5A_CLOSE, attribute_id
;    endfor
;endif

;num_item = n_elements(unit_list)
;if num_item gt 1 then unit_list = unit_list[1:num_item-1]

if unit_list[0] eq 'None' then begin
    num_attr = H5A_GET_NUM_ATTRS(dataset_id)
    if num_attr gt 0 then begin
	for i = 0, num_attr-1 do begin
	    attribute_id = H5A_OPEN_IDX(dataset_id, i)
	    attribute_name = H5A_GET_NAME(attribute_id)
	    attribute_value = read_hdf5_attribute(attribute_id)
	    attribute_name =strlowcase(attribute_name)
	    if strpos(attribute_name,"unit") ne -1 then unit_list = [unit_list, attribute_value]
	    H5A_CLOSE, attribute_id
	endfor
    endif
endif

num_item = n_elements(unit_list)
if num_item gt 1 then unit_list = unit_list[1:num_item-1]

if unit_list[0] eq 'None' then the_result = 'BAD' $
else the_result = unit_list

return, the_result

end

;--------------------------------------------------------------------------------
function get_hdf5_cdn_fields, loc_id, num_field

pro_name = 'get_hdf5_cdn_fields'
@getinfoa

datatype_id = H5D_GET_TYPE(loc_id)
data_class = H5T_GET_CLASS(datatype_id)
if data_class ne 'H5T_COMPOUND' then begin
    H5T_CLOSE, datatype_id
    return, "BAD"
endif

nmember = H5T_GET_NMEMBERS(datatype_id)
if nmember eq 0 then begin
    H5T_CLOSE, datatype_id
    return, "BAD"
endif

fieldname = ''
for i = 0L, nmember-1 do begin
    membername = H5T_GET_MEMBER_NAME(datatype_id, i)
    fieldname = [fieldname, membername]
endfor

num_field = nmember
fieldname = fieldname[1:nmember]

H5T_CLOSE, datatype_id
return, fieldname

end

;--------------------------------------------------------------------------------
function get_cdn_field_type, dataset_id, field_index, output_type, output_rank, $
    output_dims

pro_name = 'get_cdn_field_type'
@getinfoa

datatype_id = H5D_GET_TYPE(dataset_id)

class_type = H5T_GET_CLASS(datatype_id)
if class_type ne 'H5T_COMPOUND' then return, 'BAD'

structure_size = H5T_GET_SIZE(datatype_id)

num_field = H5T_GET_NMEMBERS(datatype_id)
if field_index ge num_field then return, 'BAD'

field_datatype_id = H5T_GET_MEMBER_TYPE(datatype_id, field_index)
field_name = H5T_GET_MEMBER_NAME(datatype_id, field_index)

;  Get the data type
dataclass = H5T_GET_CLASS(field_datatype_id)
datasize = H5T_GET_SIZE(field_datatype_id)
datasign = H5T_GET_SIGN(field_datatype_id)

output_type = get_hdf5_datatype(dataclass, datasize, datasign)
if output_type eq -1 then begin
    super_datatype_id = H5T_GET_SUPER(field_datatype_id)
    dataclass = H5T_GET_CLASS(super_datatype_id)
    datasize = H5T_GET_SIZE(super_datatype_id)
    datasign = H5T_GET_SIGN(super_datatype_id)
    output_type = get_hdf5_datatype(dataclass, datasize, datasign)
    H5T_CLOSE, super_datatype_id
    output_rank = H5T_GET_ARRAY_NDIMS(field_datatype_id)
    output_dims = H5T_GET_ARRAY_DIMS(field_datatype_id)
endif else begin
    output_rank = 0
    output_dims = [1]
endelse

the_result = get_cdn_field_unit(field_datatype_id, field_name, dataset_id)

H5T_CLOSE, field_datatype_id
H5T_CLOSE, datatype_id

return, the_result

end

;--------------------------------------------------------------------------------
function read_cdn_data, loc_id, field_index, output_data

pro_name = 'read_cdn_data'
;@getinfo1

BAD = 0
CATCH, BAD

if BAD ne 0 then begin
    CATCH,/CANCEL
    output_data = -9999
    return, -1
endif

cdn_data = H5D_READ(loc_id)

; test it is a structure
type = size(cdn_data, /TYPE)

if type ne 8 then begin
    output_data = -9999
    return, -1
endif

; check field_index is within number of tags
num_tag = n_tags(cdn_data)
if field_index gt num_tag then begin
    output_data = -9999
    return, -1
endif

output_data = cdn_data.(field_index)

return, 0

end

;--------------------------------------------------------------------------------
function get_error_data, hdf_data_x

pro_name = 'get_error_data'
@getinfo1

size_x = size(hdf_data_x)
case size_x(0) of 
	0: temp_data = -9999999.9
	1: temp_data = hdf_data_x(0)
	2: temp_data = hdf_data_x(0,0)
	3: temp_data = hdf_data_x(0,0,0)
	else: temp_data = hdf_data_x
endcase

return, temp_data

end

;--------------------------------------------------------------------------------
function check_command, command_name

pro_name = 'check_command'
@getinfo1

command_line = 'which '+command_name
spawn,command_line,result
num_line = n_elements(result)
valid_command = -1
i = 0
while(valid_command eq -1 and i lt num_line) do begin
	;loc=strpos(result(i),"Command not found")
	loc=strpos(result(i)," not ")
	if loc ne -1 then valid_command = loc
	i = i + 1
endwhile

return,valid_command

end

;--------------------------------------------------------------------------------
function check_directory, directory_name, home_directory

pro_name = 'check_directory'
@getinfo1

if !D.Name eq 'X' then begin
	temp_file = '/temp_file'
	rm_command = "\rm -f "
	temp_pro = '/temp_file.pro'
endif else begin
	temp_file = '\temp_file'
	rm_command = "del "
	temp_pro = "\temp_file.pro"
endelse

temp_directory = ''
temp_directory = home_directory + temp_file
test_file = findfile(temp_directory, count=count)
if count ne 0 then begin
	if !D.Name eq 'X' then begin
	    command_line=rm_command + temp_directory
	endif else begin
	    command_line=rm_command + '"'+temp_directory+'"'
	endelse
	results = ''
	spawn,command_line,results
endif

test_directory = ''
test_directory = directory_name + temp_pro
test_file = findfile(test_directory, count=count)
if count ne 0 then begin
	if !D.Name eq 'X' then begin
	    command_line=rm_command + test_directory
	endif else begin
	    command_line=rm_command + '"'+test_directory+'"'
	endelse
	results = ''
	spawn,command_line,results
endif

CD, '.', CURRENT = pwd
if !D.Name eq 'X' then begin
   command_line = 'cp '+pwd+'/getinfo.pro ' + test_directory + ' >& ' + temp_directory
endif else begin
   command_line = 'copy "'+pwd+'\getinfo.pro" "' + test_directory + '" > ' + temp_directory
endelse

result = ''
spawn, command_line, result

test_file = findfile(temp_directory, count=count)
if count ne 0 then begin
	if !D.Name eq 'X' then begin
	    command_line=rm_command + temp_directory
	endif else begin
	    command_line=rm_command + '"'+temp_directory+'"'
	endelse
	results = ''
	spawn,command_line,results
endif

test_file = findfile(test_directory, count=count)
if count ne 0 then begin
	if !D.Name eq 'X' then begin
	    command_line=rm_command + test_directory
	endif else begin
	    command_line=rm_command + '"'+test_directory+'"'
	endelse
	results = ''
	spawn,command_line,results
endif

return, count

end

;--------------------------------------------------------------------------------
function check_exist_dir, directory_name

pro_name = 'check_exist_dir'
;@getinfo1

BAD = 0
CATCH, BAD

if BAD ne 0 then begin
	CATCH,/CANCEL
	count = 0
	return,count
endif

CD, directory_name, CURRENT=pwd
count = 1
CD,pwd

return,count

end

;--------------------------------------------------------------------------------
function check_library, library

pro_name = 'check_library'

ErrorNo = 0
Catch, ErrorNo
if (ErrorNo ne 0) then begin
	help, /last_message, output=errtext
	print,'errtext = ',errtext[0]
	Catch, /CANCEL
	return, 0
endif

CD, '.', CURRENT = PWD

temp_string = 'This is for checking library'
temp_long = 123L

print,'check library = ',library
print,'PWD = ',PWD

;the_result = CALL_EXTERNAL(PWD+'/' + library,   $
the_result = CALL_EXTERNAL(library,   $
	'check_library',                $
	temp_string,                    $
	temp_long)

print,'the_result = ',the_result

if the_result eq 1 then return, 1 $
else return,0

end

;--------------------------------------------------------------------------------
function check_path, directory_name

pro_name = 'check_path'
@getinfo1

length=strlen(directory_name)
char=strmid(directory_name,length-1,1)
if char eq '/' then count = 1 $
	else count = 0

return, count

end

;--------------------------------------------------------------------------------
function check_gif_support, info

pro_name = 'check_gif_support'

ErrorNo = 0
Catch, ErrorNo
if (ErrorNo ne 0) then begin
	Catch, /CANCEL
	return, 0
endif

if !D.Name eq 'X' then begin
    check_gif_file = info.gif_out.check_path+'/check_gif.gif'
endif else begin
    check_gif_file = info.gif_out.check_path+'\check_gif.gif'
endelse
read_gif,check_gif_file,image

return,1

end

;--------------------------------------------------------------------------------
function check_png_support, info

pro_name = 'check_png_support'

ErrorNo = 0
Catch, ErrorNo
if (ErrorNo ne 0) then begin
	Catch, /CANCEL
	return, 0
endif

if !D.Name eq 'X' then begin
    check_png_file = info.gif_out.check_path+'/check_png.png'
endif else begin
    check_png_file = info.gif_out.check_path+'\check_png.png'
endelse
image = read_png(check_png_file)

return,1

end

;--------------------------------------------------------------------------------
function check_compile_status, compile_pro_name

pro_name = 'check_compile_status'
;@getinfo1

BAD = 0
CATCH, BAD

if BAD ne 0 then begin
    print,'problem to resolve the ',compile_pro_name
    CATCH,/CANCEL
    status = -1
    return,status
endif

resolve_routine, compile_pro_name
status = 0

return,status

end

;--------------------------------------------------------------------------------
function check_restore_status, restore_pro_name

pro_name = 'check_restore_status'
;@getinfo1

BAD = 0
CATCH, BAD

if BAD ne 0 then begin
    print,'problem to restore the ',restore_pro_name
    CATCH,/CANCEL
    status = -1
    return,status
endif

restore, restore_pro_name
status = 1

return,status

end

;--------------------------------------------------------------------------------
function check_sds_index, filename, data_name

pro_name = 'check_sds_index'
@getinfo1

check_hdf = HDF_ISHDF(filename)
if check_hdf eq 1 then begin
    sd_id = HDF_SD_START(filename)
    if sd_id ne -1 then begin
	old_quiet = !QUIET
	!QUIET=1
	sds_index = HDF_SD_NAMETOINDEX(sd_id, data_name)
	!QUIET=old_quiet
	HDF_SD_END, sd_id
    endif else sds_index = -1
endif else sds_index = -1

return, sds_index

end

;--------------------------------------------------------------------------------
function check_color_table, top_color

pro_name = 'check_color_table'
@getinfo1

bw_color_table = 0
TVLCT, R, G, B, /GET
mid_value = (top_color -  20)/2
if mid_value gt 0 then begin
  if(R(10) eq G(10)) and (G(10) eq B(10)) then begin
    if(R(mid_value) eq G(mid_value)) and (G(mid_value) eq B(mid_value)) then begin
	if(R(top_color-10) eq G(top_color-10)) and (G(top_color-10) eq B(top_color-10)) then begin
		bw_color_table = 1
	endif
    endif
  endif
endif

return, bw_color_table

end

;--------------------------------------------------------------------------------
function get_max_value, this_type, filldata

pro_name = 'get_max_value'
@getinfo1

if filldata lt 0 then fill_data = 3.4E+38 else fill_data = filldata

case this_type of
	 5: max_value = fill_data
	 6: max_value = fill_data
	20: max_value = 126
	21: max_value = 254
	22: max_value = 32766
	23: max_value = 65534
	24: max_value = 2147483646
	25: max_value = 2147483646
	26: max_value = long64(2) ^ 63 - 2
	27: max_value = ulong64(2) ^ 64 - 2
	else: max_value = fill_data
endcase

return, max_value

end

;--------------------------------------------------------------------------------
function get_filldata_value, this_type, filldata

pro_name = 'get_filldata_value'
@getinfo1

if filldata lt 0 then return, filldata

case this_type of
	 5: filldata_value = filldata
	 6: filldata_value = filldata
	20: filldata_value = 127
	21: filldata_value = 255
	22: filldata_value = 32767
	23: filldata_value = 65535
	24: filldata_value = 2147483647
	25: filldata_value = 2147483647
	26: filldata_value = long64(2) ^ 63 - 1
	27: filldata_value = ulong64(2) ^ 64 - 1
	else: filldata_value = filldata
endcase

return, filldata_value

end

;--------------------------------------------------------------------------------
function get_filldata, this_type, maxdata

pro_name = 'get_filldata'
@getinfo1

if maxdata lt 0 then return, maxdata

case this_type of
	20: filldata = 127
	21: filldata = 255
	22: filldata = 32767
	23: filldata = 65535
	24: filldata = 2147483647
	25: filldata = 2147483647
	26: filldata = long64(2) ^ 63 - 1
	27: filldata = ulong64(2) ^ 64 - 1
	else: begin
		if maxdata le 32767 then begin
			filldata = maxdata
		endif else if maxdata LT 3.0E+37 then begin
			filldata = maxdata * 10
		endif else filldata = 3.0E+38
	     end
endcase

return, filldata

end

;--------------------------------------------------------------------------------
function get_bit_values, num_data, start_bit, num_bit, hdf_data, version

pro_name = 'get_bit_values'
@getinfo1

if version lt 5.19 then begin
	hdf_data = long(hdf_data)
	hdf_data_z = make_array(num_data, /LONG, VALUE=0)
endif else begin
	hdf_data = ulong(hdf_data)
	;hdf_data_z = make_array(num_data, /ULONG, VALUE=0)
	;  /ulong is not work in 5.5, need to use type=13=ulong
	hdf_data_z = make_array(num_data, TYPE=13, VALUE=0)
endelse
top_bit = 32
end_bit = start_bit + num_bit - 1
num_shift = (top_bit-1)-end_bit
hdf_data_z = ishft(hdf_data,num_shift)
num_shift = (top_bit-1)-(end_bit-start_bit)
hdf_data_z = ishft(hdf_data_z,-num_shift)
;max_z = max(hdf_data_z, min=min_z)

return, hdf_data_z

end

;--------------------------------------------------------------------------------
function get_crit_string, this_subset, info

pro_name = 'get_crit_string'
@getinfoa

crit_string = ''

temp_string = info.subset.data(this_subset).src_crit_name
temp_name = str_sep(temp_string,'|')
temp_string = info.subset.data(this_subset).src_crit_min
temp_min = str_sep(temp_string,'|')
temp_string = info.subset.data(this_subset).src_crit_max
temp_max = str_sep(temp_string,'|')
temp_string = info.subset.data(this_subset).src_crit_type
temp_type = str_sep(temp_string,'|')
num_crit = n_elements(temp_name)
crit_string = 'Criterion: '
for i = 0, num_crit-1 do begin
	dot=strpos(temp_name(i), '[')
	if( dot ne -1) then begin
		criterion_name=strmid(temp_name(i),0,dot)
	endif else begin
		criterion_name=temp_name(i)
	endelse

	if i gt 0 then begin
		temp_mod = i mod 2
		if temp_mod eq 1 then $
			crit_string = crit_string + '   ;   ' $
		else begin
			if !D.Name eq 'PS' or !D.Name eq 'PRINTER' then $
				crit_string = crit_string + '!C                ' $
			else crit_string = crit_string + '!C          '
		endelse
	endif
	if fix(temp_type(i)) eq 0 then begin
		left_crit_sign = ' <= '
		right_crit_sign = ' <= '
	endif else begin
		left_crit_sign = ' > '
		right_crit_sign = ' OR > '
	endelse
	;crit_string = crit_string + temp_min(i) + ' <= ' + criterion_name
	;crit_string = crit_string + ' <= ' + temp_max(i)
	crit_string = crit_string + temp_min(i) + left_crit_sign + criterion_name
	crit_string = crit_string + right_crit_sign + temp_max(i)
endfor

return, crit_string
	
end

;--------------------------------------------------------------------------------
function get_data_name, data_name

pro_name = 'get_data_name'
@getinfoa

if strpos(data_name,"Data-Set") ne -1 or $
   strpos(data_name,"fakeDim") ne -1 then begin
	check_name=str_sep(data_name, ":")
	true_name = check_name(0)
endif else true_name = data_name

return, true_name

end
 
;--------------------------------------------------------------------------------
function get_vgroup_name, data_name, info

pro_name = 'get_vgroup_name'
@getinfoa

nlayer = info.vgroup.nlayer
temp_title = strtrim(info.vgroup.name_string(1), 2)
for ij = 2 , nlayer do begin
	temp_title = temp_title + ' ' + strtrim(info.vgroup.name_string(ij), 2)
endfor
if strlen(temp_title) gt 0 then begin
	temp_title = '('+temp_title + ')'
	dot = strpos(data_name,'[')
	if dot ne -1 then begin
		num_char = strlen(data_name)
		rest_char = num_char - dot
		temp1 = strmid(data_name,0,dot)
		temp2 = strmid(data_name,dot,rest_char)
		data_name = temp1 + ' ' + temp_title + temp2
	endif else data_name = data_name + ' ' + temp_title
endif

return, data_name

end

;--------------------------------------------------------------------------------
function get_default_file, fullpath

pro_name = 'get_default_file'
@getinfoa

filename = ''

file_length = strlen(fullpath)
if file_length gt 0 then begin
	if !D.Name eq 'X' then path_char = '/' else path_char = '\'
	;file_start = rstrpos(fullpath, '/')
	file_start = rstrpos(fullpath, path_char)
	if file_start ne -1 then begin
		file_start = file_start + 1
		length = file_length - file_start
		if length gt 0 then $
			filename = strmid(fullpath, file_start, length) $
		else filename = 'None'
	endif else filename = fullpath
endif else filename = 'None'
print,'filename = ',filename

return, filename

end

;------------------------------------------------------------------
;		initial_info
;------------------------------------------------------------------
function initial_info, info

pro_name = 'initial_info'
@getinfo1

	info.widgets.x_start=0L
	info.widgets.x_end=0L
	info.widgets.y_start=0L
	info.widgets.y_end=0L
	info.widgets.z_start=0L
	info.widgets.z_end=0L
	info.slide.select = 0

return, info

end

;------------------------------------------------------------------
;		initial_open_file
;------------------------------------------------------------------
function initial_open_file, info

pro_name = 'initial_open_file'
@getinfo1

	info.rangetype.get_time = 0
	info.rangetype.old_start(*) = 0
	info.rangetype.old_end(*) = 0
	info.rangetype.old_increment(*) = 0
	info.rangetype.old_dim(*) = 0
	info.geolocated.flag = 0
	info.geolocated.selected = 0
	info.scaledata.flag = 0
	;info.scaledata.auto = 0
	info.scaledata.type = 0
	info.scaledata.eq_num = 0
	info.scaledata.vscale = 1
	info.scaledata.voffset = 0
	info.scaledata.nscale = ''
	info.scaledata.noffset = ''
	info.ascii_file.flag = 0
	info.overlay.flag = 0
	info.overlay.offflag = 0

return, info

end

;------------------------------------------------------------------
;		initial_subset_data
;------------------------------------------------------------------
function initial_subset_data, info, this_subset

pro_name = 'initial_subset_data'
@getinfo1

info.subset.data(this_subset).subset_name='subset00'
info.subset.data(this_subset).src_filename=' '
info.subset.data(this_subset).src_unitname=' '
info.subset.data(this_subset).src_type_flag=0
info.subset.data(this_subset).src_transpose=0
info.subset.data(this_subset).src_crit_flag=0
info.subset.data(this_subset).src_crit_name=' '
info.subset.data(this_subset).src_crit_min=' '
info.subset.data(this_subset).src_crit_max=' '
info.subset.data(this_subset).src_crit_type=' '
info.subset.data(this_subset).src_num=0L
info.subset.data(this_subset).src_ref=0L
info.subset.data(this_subset).src_rank=0
info.subset.data(this_subset).src_start(*)=0L
info.subset.data(this_subset).src_end(*)=0L
info.subset.data(this_subset).src_increment(*)=0L
info.subset.data(this_subset).src_org_rank=0
info.subset.data(this_subset).src_org_start(*)=0L
info.subset.data(this_subset).src_org_end(*)=0L
info.subset.data(this_subset).src_org_increment(*)=0L
info.subset.data(this_subset).src_fnames(*)=''
info.subset.data(this_subset).src_findex(*)=-9L
info.subset.data(this_subset).src_types(*)=0L
info.subset.data(this_subset).src_order(*)=0L
info.subset.data(this_subset).src_data=ptr_new()
info.subset.data(this_subset).src_time=ptr_new()

return, info

end

;------------------------------------------------------------------
;		initial_addtext
;------------------------------------------------------------------
function initial_addtext, info

pro_name = 'initial_addtext'
@getinfo1

	info.addtext.flag=0
	info.addtext.key=0
	info.addtext.text=''
	info.addtext.charsize=''
	info.addtext.xloc=0.0
	info.addtext.yloc=0.0
	info.addtext.x_loc=''
	info.addtext.y_loc=''
	info.addtext.temp_text = ''
	info.addtext.temp_charsize=''
	info.addtext.temp_x_loc=''
	info.addtext.temp_y_loc=''

return, info

end

;------------------------------------------------------------------
;		initial_vgroup
;------------------------------------------------------------------
function initial_vgroup, info

pro_name = 'initial_vgroup'
@getinfo1

	for j = 0, 7 do begin
		if(widget_info(info.vgroup.base(j), /VALID_ID)) then $
			widget_control, info.vgroup.base(j), /destroy
	endfor
	info.vgroup.flag=0
	info.vgroup.nlayer=0
	info.vgroup.base(*)=0L
	info.vgroup.ref(*)=0L
	info.vgroup.id(*) = 0L
	info.vgroup.vref = ''
	info.vgroup.sref = ''
	info.vgroup.name_string(*) = ''
	info.vgroup.vg_id(*)=''
	info.vgroup.vg_name(*)=''

return, info

end

;------------------------------------------------------------------
;		initial_hdf5
;------------------------------------------------------------------
function initial_hdf5, info

pro_name = 'initial_hdf5'
@getinfo1

	for j = 0, 7 do begin
		if(widget_info(info.hdf5.base(j), /VALID_ID)) then $
			widget_control, info.hdf5.base(j), /destroy
	endfor
	info.hdf5.flag=0
	info.hdf5.nlayer=0
	info.hdf5.base(*)=0L
	info.hdf5.ref(*)=0L
	info.hdf5.id(*) = 0L
	info.hdf5.name_string(*) = ''
	info.hdf5.g_name(*)=''
	info.hdf5.sdn_name(*) = ''
	info.hdf5.cdn_name(*) = ''

return, info

end

;--------------------------------------------------------------------------------
function diff_graph, event

pro_name = 'diff_graph'
@getinfo1

widget_control, get_uvalue=info, event.top

info.multiple.xy_diff=event.value

widget_control, set_uvalue=info, info.base
widget_control, set_uvalue=info, event.top

end

;------------------------------------------------------------------
;		name_to_index
;------------------------------------------------------------------
function name_to_index, name_of_data, name_list

pro_name = 'name_to_index'
@getinfo1

; Map the field name to the actual index

result = where(name_list eq name_of_data, count)
if count eq 0 then result = -1

return, result

end

;--------------------------------------------------------------------------------
function open_vdata, filename,vdata_name,file_id

pro_name = 'open_vdata'
@getinfo1

file_id = HDF_OPEN(filename, /READ)
if file_id eq -1 then begin
	result=dialog_message('Unable to open '+filename+'!',$
		title='View HDF Warning!')
	return, 0
endif

vdata_name = vdata_name[0]
vdata_ref = HDF_VD_FIND(file_id, vdata_name)
if vdata_ref eq 0 then begin
	result=dialog_message('Unable to find '+vdata_name+'!',$
		title='View HDF Warning!')
	HDF_CLOSE,file_id
	return, 0
endif
vdata_id = HDF_VD_ATTACH(file_id, vdata_ref, /READ)
;if vdata_id eq 0 then begin
if vdata_id le 0 then begin
	result=dialog_message('Unable to attach '+vdata_name+'!',$
		title='View HDF Warning!')
	HDF_CLOSE,file_id
	return, 0
endif

return,vdata_id

end

;--------------------------------------------------------------------------------
function set_log_range, log_range, default_min, default_max

pro_name = 'set_log_range'
@getinfo1

log_min = log_range(0)
log_max = log_range(1)

if log_min eq 0 and log_max eq 0 then begin
	log_min = default_min
	log_max = default_max
endif

if log_min le 0 then log_min = 1
if log_max le 0 then log_max = 1
if log_min eq log_max then log_max = log_max + 1

factor = floor(alog10(log_min))
if factor lt 0 then log_min = 10D^factor $
	else log_min = 10L^factor
factor = ceil(alog10(log_max))
if factor lt 0 then log_max = 10D^factor $
	else log_max = 10L^factor

log_range = [log_min, log_max]

return, log_range

end

;--------------------------------------------------------------------------------
function set_criterion_type, event

pro_name = 'set_criterion_type'
@getinfo1

widget_control, get_uvalue=info, event.top

info.criterion.type=event.value

widget_control, set_uvalue=info, event.top

end

;--------------------------------------------------------------------------------
function set_geolocated_data, info, this_subset

pro_name = 'set_geolocated_data'
@getinfo1

widget_control, get_uvalue=info, info.base

if ptr_valid(info.geolocated.temp_long) then $
	hdf_data_x = *info.geolocated.temp_long $ 
else begin
	result=dialog_message('Cannot find geolocated data!.', $
	title='View HDF Warning!')
	return, -1
endelse

if ptr_valid(info.geolocated.temp_colat) then $
	hdf_data_y = *info.geolocated.temp_colat
if ptr_valid(info.geolocated.temp_sate_long) then $
	satellite_x = *info.geolocated.temp_sate_long $
else info.greenwich.satellite = 0
if ptr_valid(info.geolocated.temp_sate_colat) then $
	satellite_y = *info.geolocated.temp_sate_colat $
else info.greenwich.satellite = 0
if ptr_valid(info.geolocated.temp_sun_long) then $
	sun_x = *info.geolocated.temp_sun_long $
else info.greenwich.sun = 0
if ptr_valid(info.geolocated.temp_sun_colat) then $
	sun_y = *info.geolocated.temp_sun_colat $
else info.greenwich.sun = 0

if info.geolocated.selected eq 1 then begin
    x_starting=info.subset.data(this_subset).src_start(0)
    x_ending=info.subset.data(this_subset).src_end(0)
    if info.subset.data(this_subset).src_type_flag eq 1 then x_ending = x_ending + 1
    x_increment=info.subset.data(this_subset).src_increment(0)
    org_rank=info.subset.data(this_subset).src_org_rank

    long_index = info.geolocated.long_index
    long_starting=info.subset.data(long_index).src_start(0)
    long_ending=info.subset.data(long_index).src_end(0)
    long_increment=info.subset.data(long_index).src_increment(0)
    long_rank=info.subset.data(long_index).src_org_rank

    if org_rank eq long_rank then begin
	if info.subset.data(long_index).src_type_flag eq 1 then long_ending = long_ending + 1
	if(long_starting gt x_starting or long_ending lt x_ending) then begin
	    the_message = ['The range of geolocated data is less than selected data!',$
		'Increase the range of geolocated data and do it again!!!']
	    result=dialog_message(the_message, title='View HDF Warning!')
	    return, -1
	endif

	if(long_increment ne 1 and long_increment ne x_increment) then begin
	    the_message = ['The increment of geolocated data is not equal selected data,',$
		'or the increment of geolocated data is not equal to ONE!', $
		'Change the increment of geolocated data and do it again!!!']
	    result=dialog_message(the_message, title='View HDF Warning!')
	    return, -1
	endif
    endif
endif

if info.subset.data(this_subset).src_type_flag eq 0 then begin
    hdf_data_z = *info.subset.data(this_subset).src_data
endif else begin
    hdf_z_temp = ptr_new(*info.subset.data(this_subset).src_data)
    hdf_data_z = reform((*hdf_z_temp).components0, n_elements((*hdf_z_temp).components0))
    ptr_free, hdf_z_temp
endelse
num_z = n_elements(hdf_data_z)
num_x = n_elements(hdf_data_x)
num_y = n_elements(hdf_data_y)

if(num_z ne num_x or num_z ne num_y) then begin
    if info.subset.data(this_subset).src_type_flag eq 0 then begin
	;hdf_data_z = *info.subset.data(this_subset).src_data
	this_rank = info.subset.data(this_subset).src_rank
	start_list = info.subset.data(this_subset).src_start(0:this_rank-1)
	end_list = info.subset.data(this_subset).src_end(0:this_rank-1)
	increment_list = info.subset.data(this_subset).src_increment(0:this_rank-1)

  	hdf_size_z = size(hdf_data_z)
	hdf_size_x = size(hdf_data_x)

	if this_rank eq 1 then begin
		true_start = info.subset.data(this_subset).src_start(this_rank)
		true_end = info.subset.data(this_subset).src_end(this_rank)
    		if true_start ne start_list(0) or true_end ne end_list(0) then begin
			starting = true_start - info.geolocated.starting
			ending = true_end - info.geolocated.starting - 1
			increment = 1
			;hdf_data_z = reform(hdf_data_z, n_elements(hdf_data_z), 1)
			if hdf_size_x(0) eq 1 then begin
				hdf_data_x = reform(hdf_data_x, n_elements(hdf_data_x), 1)
				hdf_data_y = reform(hdf_data_y, n_elements(hdf_data_y), 1)
			endif
		endif else begin
			starting = start_list(0)
			ending = end_list(0) - 1
			;starting = start_list(0) - info.geolocated.starting
			;ending = end_list(0) - info.geolocated.starting - 1
			increment = increment_list(0)
		endelse
	endif else begin
		if hdf_size_x(0) eq 1 and hdf_size_z(0) eq 1 then begin
			hdf_data_x = reform(hdf_data_x, n_elements(hdf_data_x), 1)
			hdf_data_y = reform(hdf_data_y, n_elements(hdf_data_y), 1)
		endif 
		starting = start_list(0) - info.geolocated.starting
		ending = end_list(0) - info.geolocated.starting - 1
		increment = increment_list(0)
	endelse
	hdf_size_z = size(hdf_data_z)
	hdf_size_x = size(hdf_data_x)

	if info.geolocated.selected eq 1 then begin
	    if (long_increment ne 1) and (long_increment eq increment) then begin
		    starting = starting/increment
		    ;ending = long((ending+1.0)/increment + 0.9) - 1
		    ending = long(ending/increment + 1.0) - 1
		    increment = 1
	    endif
	endif
				
	temp_error_data = get_error_data(satellite_x)
	if temp_error_data ge -180.0 then begin
		satellite_x = satellite_x(starting:ending)
		satellite_y = satellite_y(starting:ending)
	endif else info.greenwich.satellite = 0
	temp_error_data = get_error_data(sun_x)
	if temp_error_data ge -180.0 then begin
		sun_x = sun_x(starting:ending)
		sun_y = sun_y(starting:ending)
	endif else info.greenwich.sun = 0

	case hdf_size_x(0) of
	   1: begin
			hdf_data_x = hdf_data_x(starting:ending)
			hdf_data_y = hdf_data_y(starting:ending)
	      end
	   2: begin
			hdf_data_x = hdf_data_x(*, starting:ending)
                	hdf_data_y = hdf_data_y(*, starting:ending)
	      end
	   else: begin
		result=dialog_message('Do not support the data with rank of '+ $
			strcompress(string(hdf_size_x(0)), /REMOVE_ALL) + $
			' for Geolocated Data!',$
			title='View HDF Warning!')
		return, -1
	      end
	endcase
	hdf_size_x=size(hdf_data_x)

	case hdf_size_z(0) of
	   1: begin
		if increment eq 1 then begin
		   case hdf_size_x(0) of
			1: begin
				;hdf_data_x = hdf_data_x(x_starting:x_ending)
				;hdf_data_y = hdf_data_y(x_starting:x_ending)
			   end
		   	2: begin
				temp = 168
				if hdf_size_x(1) lt 168 then temp = fix(hdf_size_x(1) / 2)
				hdf_data_x = hdf_data_x(temp,*)
				hdf_data_y = hdf_data_y(temp,*)
			   end
			else: begin
				result=dialog_message('Do not support the data with rank of '+ $
					strcompress(string(hdf_size_x(0)), /REMOVE_ALL) + $
					' for Geolocated Data!',$
					title='View HDF Warning!')
				return, -1
			   end
		   endcase
		endif else begin
		    if this_rank eq 1 then begin
			x_starting = start_list(0)
			x_ending = end_list(0)-1
			x_increment = increment_list(0)
		    endif else begin
			if end_list(0) - start_list(0) gt 1 then begin
			    x_starting = start_list(0)
			    x_ending = end_list(0)-1
			    x_increment = increment_list(0)
			endif else if end_list(1) - start_list(1) gt 1 then begin
			    x_starting = start_list(1)
			    x_ending = end_list(1)-1
			    x_increment = increment_list(1)
			endif else if end_list(2) - start_list(2) gt 1 then begin
			    x_starting = start_list(2)
			    x_ending = end_list(2)-1
			    x_increment = increment_list(2)
			endif else begin
			    x_starting = start_list(0)
			    x_ending = end_list(0)-1
			    x_increment = increment_list(0)
			endelse
		    endelse

			;array_size = long((x_ending-x_starting+1)/float(x_increment) + 0.9)
			array_size = long((x_ending-x_starting)/float(x_increment) + 1.0)
			x_temp_data = array_type(5, array_size)
			if (x_temp_data(0) eq -1) then begin
				result=dialog_message('Unable to allocate memory for temporary x data!',$
					title='View HDF Warning!')
        			return, -1
			endif
			y_temp_data = array_type(5, array_size)
			if (y_temp_data(0) eq -1) then begin
				result=dialog_message('Unable to allocate memory for temporary y data!',$
					title='View HDF Warning!')
        			return, -1
			endif
			jj = 0L
			kk = 0L
			for j = x_starting, x_ending, x_increment do begin
			    case hdf_size_x(0) of
				 1: begin
					x_temp_data(jj) = hdf_data_x(kk)
					y_temp_data(jj) = hdf_data_y(kk)
				    end
				 2: begin
					temp = 168
					if hdf_size_x(1) lt 168 then temp = fix(hdf_size_x(1) / 2)
					x_temp_data(jj) = hdf_data_x(temp,kk)
					y_temp_data(jj) = hdf_data_y(temp,kk)
				    end
				 else: begin
					result=dialog_message('Do not support the data with rank of '+ $
						strcompress(string(hdf_size_z(0)), /REMOVE_ALL) + $
						' for Geolocated Data!',$
						title='View HDF Warning!')
					return, -1
			   	    end
		   	    endcase
				jj = jj + 1
				kk = kk + x_increment
			endfor
			hdf_data_x = x_temp_data
			hdf_data_y = y_temp_data
		endelse
	      end 
	   2: begin
		x_starting = starting
		x_ending = ending
		x_increment = increment
		y_starting = start_list(1)
		y_ending = end_list(1)-1
		y_increment = increment_list(1)
		if hdf_size_x(0) eq 2 then begin
		    if info.geolocated.selected eq 1 then begin
			long_starting=info.subset.data(long_index).src_start(1)
			long_ending=info.subset.data(long_index).src_end(1)
			long_increment=info.subset.data(long_index).src_increment(1)
			if(long_starting gt y_starting or long_ending lt y_ending) then begin
			    the_message = ['The range of geolocated data is less than selected data!',$
				'Increase the range of geolocated data and do it again!!!']
			    result=dialog_message(the_message, title='View HDF Warning!')
			    return, -1
			endif

			if(long_increment ne 1 and long_increment ne y_increment) then begin
			    the_message = ['The increment of geolocated data is not equal selected data,',$
				'or the increment of geolocated data is not equal to ONE!', $
				'Change the increment of geolocated data and do it again!!!']
			    result=dialog_message(the_message, title='View HDF Warning!')
			    return, -1
			endif

			y_starting = y_starting - long_starting
			y_ending = y_ending - long_starting
			if (long_increment ne 1) and (long_increment eq y_increment) then begin
			    y_starting = y_starting/y_increment
			    ;y_ending = long((y_ending+1.0)/y_increment + 0.9) - 1
			    y_ending = long(y_ending/y_increment + 1.0) - 1
			    y_increment = 1
			endif

		    endif
		    hdf_data_x = hdf_data_x(y_starting:y_ending, *)
		    hdf_data_y = hdf_data_y(y_starting:y_ending, *)
		endif
	
		if x_increment eq 1 and y_increment eq 1 then begin
		    case hdf_size_x(0) of
			  1: begin
				temp = 168
				if hdf_size_z(1) lt 168 then temp = fix(hdf_size_z(1)/2)
				hdf_data_z = hdf_data_z(temp, *)
			     end
		   	  2: begin
				;hdf_data_x = hdf_data_x(y_starting:y_ending, *)
				;hdf_data_y = hdf_data_y(y_starting:y_ending, *)
			     end
			  else: begin
				result=dialog_message('Do not support the data with rank of '+ $
					strcompress(string(hdf_size_z(0)), /REMOVE_ALL) + $
					' for Geolocated Data!',$
					title='View HDF Warning!')
				return, -1
			     end
		    endcase
		endif else begin
			if hdf_size_x(0) eq 1 then begin
				;array_size = long((end_list(0) - start_list(0)) $
				;	/float(increment_list(0)) + 0.9)  $
				array_size = long((end_list(0) - start_list(0) - 1) $
					/float(increment_list(0)) + 1.0)
			endif else begin
				;array_size = long((end_list-start_list)/float(increment_list) + 0.9)
				array_size = long((end_list-start_list-1)/float(increment_list) + 1.0)
			endelse
			x_temp_data = array_type(5, array_size)
			if (x_temp_data(0) eq -1) then begin
				result=dialog_message('Unable to allocate memory for temporary x data!',$
					title='View HDF Warning!')
        			return, -1
			endif
			y_temp_data = array_type(5, array_size)
			if (y_temp_data(0) eq -1) then begin
				result=dialog_message('Unable to allocate memory for temporary y data!',$
					title='View HDF Warning!')
        			return, -1
			endif
			if hdf_size_x(0) eq 1 then begin
				this_type = info.subset.data(this_subset).src_types
				this_type = this_type(0)
				z_temp_data = array_type(this_type, array_size)
				if (z_temp_data(0) eq -1) then begin
					result=dialog_message('Unable to allocate memory for temporary z data!',$
						title='View HDF Warning!')
        				return, -1
				endif
			endif
			jj = 0L
			ii = 0L
			for j = x_starting, x_ending, x_increment do begin
			    case hdf_size_x(0) of
				 1: begin
					temp = 168
					if hdf_size_z(1) lt 168 then temp = fix(hdf_size_z(1)/2)
					z_temp_data(jj) = hdf_data_z(temp, jj)
					x_temp_data(jj) = hdf_data_x(ii)
					y_temp_data(jj) = hdf_data_y(ii)
				    end
				 2: begin
					kk = 0L
					mm = 0L
					for k = y_starting, y_ending, y_increment do begin
						x_temp_data(kk,jj) = hdf_data_x(mm,ii)
						y_temp_data(kk,jj) = hdf_data_y(mm,ii)
						kk = kk + 1
						mm = mm + y_increment
					endfor
				    end
				 else: begin
					result=dialog_message('Do not support the data with rank of '+ $
						strcompress(string(hdf_size_z(0)), /REMOVE_ALL) + $
						' for Geolocated Data!',$
						title='View HDF Warning!')
					return, -1
			   	    end
			    endcase
				ii = ii + x_increment
				jj = jj + 1
			endfor
			if hdf_size_x(0) eq 1 then hdf_data_z = z_temp_data
			hdf_data_x = x_temp_data
			hdf_data_y = y_temp_data
		endelse
	      end 
	    else: begin
			result=dialog_message('Do not support the data with rank of '+ $
				strcompress(string(hdf_size_z(0)), /REMOVE_ALL) + $
				' for Geolocated Data!',$
				title='View HDF Warning!')
		return, -1
	      end
	endcase
    endif else begin
	;hdf_z_temp = ptr_new(*info.subset.data(this_subset).src_data, /NO_COPY)
	;hdf_z_temp = ptr_new(*info.subset.data(this_subset).src_data)
	;hdf_data_z = reform((*hdf_z_temp).components0, n_elements((*hdf_z_temp).components0))
	;ptr_free, hdf_z_temp
  	this_order = info.subset.data(this_subset).src_order(0)
	this_end = info.subset.data(this_subset).src_end(0)
	this_start = info.subset.data(this_subset).src_start(0)
	this_increment = info.subset.data(this_subset).src_increment(0)

	starting = this_start - info.geolocated.starting
	ending = this_end - info.geolocated.starting

	hdf_size_z = size(hdf_data_z)
	hdf_size_x = size(hdf_data_x)

	if info.geolocated.selected eq 1 then begin
	    if (long_increment ne 1) and (long_increment eq this_increment) then begin
		starting = starting/this_increment
		;ending = long((ending+1.0)/this_increment + 0.9) - 1
		ending = long(ending/this_increment + 1.0) - 1
		this_increment = 1
	    endif
	endif

	temp_error_data = get_error_data(satellite_x)
	if temp_error_data ge -180.0 then begin
		satellite_x = satellite_x(starting:ending)
		satellite_y = satellite_y(starting:ending)
	endif else info.greenwich.satellite = 0
	temp_error_data = get_error_data(sun_x)
	if temp_error_data ge -180.0 then begin
		sun_x = sun_x(starting:ending)
		sun_y = sun_y(starting:ending)
	endif else info.greenwich.sun = 0

	hdf_size_x = size(hdf_data_x)
	case hdf_size_x(0) of
	   1: begin
		hdf_data_x = hdf_data_x(starting:ending)
		hdf_data_y = hdf_data_y(starting:ending)
	      end
	   2: begin
		hdf_data_x = hdf_data_x(*, starting:ending)
                hdf_data_y = hdf_data_y(*, starting:ending)
	      end
	   else: begin
		result=dialog_message('Do not support the data with rank of '+ $
			strcompress(string(hdf_size_x(0)), /REMOVE_ALL) + $
			' for Geolocated Data!',$
			title='View HDF Warning!')
		return, -1
	      end
	endcase
	hdf_size_x=size(hdf_data_x)

	if this_order eq 1 and this_increment eq 1 then begin
	   case hdf_size_x(0) of
		1: 
	   	2: begin
			temp = 168
			if hdf_size_x(1) lt 168 then temp = fix(hdf_size_x(1) / 2)
			hdf_data_x = hdf_data_x(temp,*)
			hdf_data_y = hdf_data_y(temp,*)
		   end
		else: begin
			result=dialog_message('Do not support the longitude data with rank of '+ $
				strcompress(string(hdf_size_z(0)), /REMOVE_ALL) + $
				' for Geolocated Data!',$
				title='View HDF Warning!')
			return, -1
		   end
	   endcase
	endif else begin
		this_range = (this_end - this_start)/this_increment
		this_range = this_range + 1
		this_interval = 492/this_order
		array_size = this_range * this_order
		x_temp_data = array_type(5, array_size)
		if (x_temp_data(0) eq -1) then begin
			result=dialog_message('Unable to allocate memory for temporary x data!',$
				title='View HDF Warning!')
       			return, -1
		endif
		y_temp_data = array_type(5, array_size)
		if (y_temp_data(0) eq -1) then begin
			result=dialog_message('Unable to allocate memory for temporary y data!',$
				title='View HDF Warning!')
       			return, -1
		endif
		if hdf_size_x(0) eq 1 and this_order gt 1 then begin
			this_type = info.subset.data(this_subset).src_types
			this_type = this_type(0)
			z_temp_data = array_type(this_type, array_size)
			if (z_temp_data(0) eq -1) then begin
				result=dialog_message('Unable to allocate memory for temporary z data!',$
					title='View HDF Warning!')
        			return, -1
			endif
		endif
		k = 0L
		jj = 0L
		for i = this_start, this_end, this_increment do begin
			case hdf_size_x(0) of
			     1: begin
				  if this_order gt 1 then begin
					ijk = k * this_order
					z_temp_data(k) = hdf_data_z(ijk)
				  endif
				  x_temp_data(k) = hdf_data_x(jj)
				  y_temp_data(k) = hdf_data_y(jj)
          			  k = k + 1
				  jj = jj + this_increment
				end
			     2: begin
				  for j = 0, this_order-1 do begin
					ijk = 168 + j * this_interval
					x_temp_data(k) = hdf_data_x(ijk, jj)
					y_temp_data(k) = hdf_data_y(ijk, jj)
					k = k + 1
				  endfor
				  jj = jj + this_increment
				end
			     else: begin
					result=dialog_message('Do not support the data with rank of '+ $
						strcompress(string(hdf_size_z(0)), /REMOVE_ALL) + $
						' for Geolocated Data!',$
						title='View HDF Warning!')
					return, -1
	      			    end
			endcase
    		endfor

		hdf_data_x = x_temp_data
		hdf_data_y = y_temp_data
		if hdf_data_x(0) eq 1 and this_order gt 1 then hdf_data_z = z_temp_data
	endelse
    endelse
endif

	if ptr_valid(info.geolocated.hdf_z) then ptr_free, $
		info.geolocated.hdf_z
	info.geolocated.hdf_z = ptr_new(hdf_data_z, /NO_COPY)

	if ptr_valid(info.geolocated.long) then ptr_free, $
		info.geolocated.long
	info.geolocated.long=ptr_new(hdf_data_x, /NO_COPY)

	if ptr_valid(info.geolocated.colat) then ptr_free, $
		info.geolocated.colat
	info.geolocated.colat=ptr_new(hdf_data_y, /NO_COPY)
 
	temp_error_data = get_error_data(satellite_x)
	if ptr_valid(info.geolocated.sate_long) then ptr_free, $
		info.geolocated.sate_long
	if ptr_valid(info.geolocated.sate_colat) then ptr_free, $
		info.geolocated.sate_colat
	if temp_error_data ge -180.0 then begin
		info.geolocated.sate_long=ptr_new(satellite_x, /NO_COPY)
		info.geolocated.sate_colat=ptr_new(satellite_y, /NO_COPY)
	endif else info.greenwich.satellite = 0

	temp_error_data = get_error_data(sun_x)
	if ptr_valid(info.geolocated.sun_long) then ptr_free, $
		info.geolocated.sun_long
	if ptr_valid(info.geolocated.sun_colat) then ptr_free, $
		info.geolocated.sun_colat
	if temp_error_data ge -180.0 then begin
		info.geolocated.sun_long=ptr_new(sun_x, /NO_COPY)
		info.geolocated.sun_colat=ptr_new(sun_y, /NO_COPY)
	endif

widget_control, set_uvalue=info, info.base

return, 0

end

;------------------------------------------------------------------
function set_previous_file, event

pro_name = 'set_previous_file'
@getinfo1

widget_control, get_uvalue=info, event.top

info.previous_file.current = info.previous_file.store(event.value) 

widget_control, set_uvalue=info, event.top

END

;--------------------------------------------------------------------------------
function store_open_file, info

pro_name = 'store_open_file'
@getinfo1

filename = info.current_file
filename = filename(0)
max_file = info.open_file.max

subscript = where(info.open_file.file eq filename, count)
if count eq 0 then begin
	info.open_file.file(1:max_file-1) = info.open_file.file(0:max_file-2)
	info.open_file.sds_list(1:max_file-1) = info.open_file.sds_list(0:max_file-2)
	info.open_file.vdata_list(1:max_file-1) = info.open_file.vdata_list(0:max_file-2)
	info.open_file.flag(1:max_file-1) = info.open_file.flag(0:max_file-2)
	info.open_file.ssf_file(1:max_file-1) = info.open_file.ssf_file(0:max_file-2)
	info.open_file.bds_file(1:max_file-1) = info.open_file.bds_file(0:max_file-2)
	info.open_file.ascii_flag(1:max_file-1) = info.open_file.ascii_flag(0:max_file-2)
	info.open_file.ascii_skip(1:max_file-1) = info.open_file.ascii_skip(0:max_file-2)
	info.open_file.ascii_heading(1:max_file-1) = info.open_file.ascii_heading(0:max_file-2)
	info.open_file.ascii_skiphead(1:max_file-1) = info.open_file.ascii_skiphead(0:max_file-2)
	info.open_file.ascii_sep(1:max_file-1) = info.open_file.ascii_sep(0:max_file-2)
	info.open_file.fill_data(1:max_file-1) = info.open_file.fill_data(0:max_file-2)
	info.open_file.vref(1:max_file-1) = info.open_file.vref(0:max_file-2)
	info.open_file.vg_id(1:max_file-1) = info.open_file.vg_id(0:max_file-2)
	info.open_file.vg_name(1:max_file-1) = info.open_file.vg_name(0:max_file-2)
	info.open_file.hdf5_flag(1:max_file-1) = info.open_file.hdf5_flag(0:max_file-2)
	info.open_file.hdf5_g_name(1:max_file-1) = info.open_file.hdf5_g_name(0:max_file-2)
	info.open_file.hdf5_sdn_name(1:max_file-1) = info.open_file.hdf5_sdn_name(0:max_file-2)
	info.open_file.hdf5_cdn_name(1:max_file-1) = info.open_file.hdf5_cdn_name(0:max_file-2)
	if info.open_file.count lt info.open_file.max then $
		info.open_file.count = info.open_file.count + 1
endif else begin
	if subscript(0) ne 0 then begin
	    info.open_file.file(1:subscript(0)) = info.open_file.file(0:subscript(0)-1)
	    info.open_file.sds_list(1:subscript(0)) = info.open_file.sds_list(0:subscript(0)-1)
	    info.open_file.vdata_list(1:subscript(0)) = info.open_file.vdata_list(0:subscript(0)-1)
	    info.open_file.flag(1:subscript(0)) = info.open_file.flag(0:subscript(0)-1)
	    info.open_file.ssf_file(1:subscript(0)) = info.open_file.ssf_file(0:subscript(0)-1)
	    info.open_file.bds_file(1:subscript(0)) = info.open_file.bds_file(0:subscript(0)-1)
	    info.open_file.ascii_flag(1:subscript(0)) = info.open_file.ascii_flag(0:subscript(0)-1)
	    info.open_file.ascii_skip(1:subscript(0)) = info.open_file.ascii_skip(0:subscript(0)-1)
	    info.open_file.ascii_heading(1:subscript(0)) = info.open_file.ascii_heading(0:subscript(0)-1)
	    info.open_file.ascii_skiphead(1:subscript(0)) = info.open_file.ascii_skiphead(0:subscript(0)-1)
	    info.open_file.ascii_sep(1:subscript(0)) = info.open_file.ascii_sep(0:subscript(0)-1)
	    info.open_file.fill_data(1:subscript(0)) = info.open_file.fill_data(0:subscript(0)-1)
	    info.open_file.vref(1:subscript(0)) = info.open_file.vref(0:subscript(0)-1)
	    info.open_file.vg_id(1:subscript(0)) = info.open_file.vg_id(0:subscript(0)-1)
	    info.open_file.vg_name(1:subscript(0)) = info.open_file.vg_name(0:subscript(0)-1)
	    info.open_file.hdf5_flag(1:subscript(0)) = info.open_file.hdf5_flag(0:subscript(0)-1)
	    info.open_file.hdf5_g_name(1:subscript(0)) = info.open_file.hdf5_g_name(0:subscript(0)-1)
	    info.open_file.hdf5_sdn_name(1:subscript(0)) = info.open_file.hdf5_sdn_name(0:subscript(0)-1)
	    info.open_file.hdf5_cdn_name(1:subscript(0)) = info.open_file.hdf5_cdn_name(0:subscript(0)-1)
	endif else return, info
endelse

info.open_file.file(0) = filename
info.open_file.sds_list(0) = ''
info.open_file.vdata_list(0) = ''
info.open_file.flag(0) = 0
info.open_file.ssf_file(0) = info.ssf.file
info.open_file.bds_file(0) = info.bds_file
info.open_file.ascii_flag(0) = 0
info.open_file.ascii_skip(0) = 0
info.open_file.ascii_heading(0) = 1
info.open_file.ascii_skiphead(0) = 0
info.open_file.ascii_sep(0) = 'tab'
info.open_file.fill_data(0) = info.filldata
info.open_file.vref(0) = ''
info.open_file.vg_id(0) = ''
info.open_file.vg_name(0) = ''
info.open_file.hdf5_flag(0) = 0
info.open_file.hdf5_g_name(0) = ''
info.open_file.hdf5_sdn_name(0) = ''
info.open_file.hdf5_cdn_name(0) = ''

if info.vgroup.flag eq 1 then begin
	info.open_file.flag(0) = 1
	info.open_file.vg_id(0) = info.vgroup.vg_id(0)
	info.open_file.vg_name(0) = info.vgroup.vg_name(0)
	length = strlen(info.vgroup.vref)
	if length gt 0 then begin
		info.open_file.vref(0) = info.vgroup.vref
		num_list = n_elements(info.name_list_vdata)
		if num_list gt 0 then begin
			vdata_list = info.name_list_vdata(0)
			for i = 1, num_list-1 do begin
				vdata_list = vdata_list + '|'
				vdata_list = vdata_list + info.name_list_vdata(i)
			endfor
			info.open_file.vdata_list(0) = vdata_list
		endif
	endif
endif else if info.hdf5.flag eq 1 then begin
	info.open_file.hdf5_flag(0) = 1
	info.open_file.hdf5_g_name(0) = info.hdf5.g_name(0)
	info.open_file.hdf5_sdn_name(0) = info.hdf5.sdn_name(0)
	info.open_file.hdf5_cdn_name(0) = info.hdf5.cdn_name(0)
endif else begin
	num_list = n_elements(info.name_list_sds)
	if num_list gt 0 then begin
		sds_list = info.name_list_sds(0)
		for i = 1, num_list-1 do begin
			sds_list = sds_list + '|'
			sds_list = sds_list + info.name_list_sds(i)
		endfor
		info.open_file.sds_list(0) = sds_list
	endif
	num_list = n_elements(info.name_list_vdata)
	if num_list gt 0 then begin
		vdata_list = info.name_list_vdata(0)
		for i = 1, num_list-1 do begin
			vdata_list = vdata_list + '|'
			vdata_list = vdata_list + info.name_list_vdata(i)
		endfor
		info.open_file.vdata_list(0) = vdata_list
	endif
endelse

if info.ascii_file.flag eq 1 then begin
    info.open_file.ascii_flag(0) = 1
    info.open_file.ascii_skip(0) = info.ascii_file.skip_line
    info.open_file.ascii_heading(0) = info.ascii_file.num_heading
    info.open_file.ascii_skiphead(0) = info.ascii_file.skip_ahead
    info.open_file.ascii_sep(0) = info.ascii_file.sep_char
endif

return, info

end

;--------------------------------------------------------------------------------
function store_previous_file, info

pro_name = 'store_previous_file'
@getinfo1

current_file = info.current_file
current_file = current_file(0)
max_file = info.previous_file.max

subscript = where(info.previous_file.store eq current_file, count)
if count eq 0 then begin
	info.previous_file.store(1:max_file-1) = info.previous_file.store(0:max_file-2)
	info.previous_file.store(0) = current_file
endif else begin
	if subscript(0) ne 0 then begin
	    info.previous_file.store(1:subscript(0)) = info.previous_file.store(0:subscript(0)-1)
	    info.previous_file.store(0) = current_file
	endif
endelse

return, info

end

;--------------------------------------------------------------------------------
pro tvscl24, image2d, DATA=image

pro_name = 'tvscl24'
@getinfo

case 1 of
    n_elements(image2d) gt 0 : begin
	size_image = size(image2d)
	case size_image(0) of
	    3: begin
		device, decomposed=1
		erase
		tv, image2d, true=1
		device, decomposed=0
	    end
	    2: begin
		erase
		tv, image2d
	    end
	    else:
	endcase
    end

    n_elements(image) gt 0 : begin
	size_image = size(image)
	case size_image(0) of
	    3: begin
		device, decomposed=1
		erase
		tv, image, true=1
		device, decomposed=0
	    end
	    2: begin
		erase
		tv, image
	    end
	    else:
	endcase
    end

    else:
endcase

end

;--------------------------------------------------------------------------------
pro xloadct24, image, color_table_file

pro_name = 'xloadct24'
@getinfo

xloadct, file=color_table_file, /use_current, updatecallback='tvscl24', $
    updatecbdata=image

end

;--------------------------------------------------------------------------------
pro about_view_hdf, info, flag

pro_name = 'about_view_hdf'
@getinfo

if flag eq 0 then begin
	text2="http://asd-www.larc.nasa.gov/ceres/view_hdf"
	text5="Contact: Kam-Pui Lee"
	text6="(757) 827-4864"
	text7="k.lee@larc.nasa.gov"
	xsize = 400
	ysize = 270
endif else begin
	text2="http://eosweb.larc.nasa.gov/HPDOCS/view_hdf.html"
	text5="Contact: Science, User and Data Services Office"
	text8="Atmospheric Sciences Data Center"
	text9="NASA Langley Research Center"
	text6="(757) 864-8656"
	text7="larc@eos.nasa.gov"
	xsize = 420
	ysize = 320
endelse

base = widget_base(COLUMN=1, MAP=1, TITLE='About View_HDF', XSIZE=xsize, YSIZE=ysize)

textspid=widget_label(base, value = " ", /ALIGN_CENTER, FONT=info.font)

textid=widget_label(base, value = "View_HDF", /ALIGN_CENTER, FONT=info.font)

text2id=widget_label(base, value = text2, /ALIGN_CENTER, FONT=info.font)

textsp1id=widget_label(base, value = " ", /ALIGN_CENTER, FONT=info.font)

text3="Version Number: 5.0.0"
text3id=widget_label(base, value = text3, /ALIGN_CENTER, FONT=info.font)

text4="Last Updated: September 21, 2007"
text4id=widget_label(base, value = text4, /ALIGN_CENTER, FONT=info.font)

text5id=widget_label(base, value = text5, /ALIGN_CENTER, FONT=info.font)

if flag eq 1 then begin
    text8id=widget_label(base, value = text8, /ALIGN_CENTER, FONT=info.font)
    text9id=widget_label(base, value = text9, /ALIGN_CENTER, FONT=info.font)
endif

text6id=widget_label(base, value = text6, /ALIGN_CENTER, FONT=info.font)

text7id=widget_label(base, value = text7, /ALIGN_CENTER, FONT=info.font)

textsp2id=widget_label(base, value = " ", /ALIGN_CENTER, FONT=info.font)

button2=widget_button(base, FONT=info.font, EVENT_PRO='doneCB', VALUE="Done",$
	 /ALIGN_CENTER)

widget_control, /realize, base

end

;------------------------------------------------------------------
pro addtext_message, info

pro_name = 'addtext_message'
@getinfo

if(widget_info(info.widgets.base, /VALID_ID)) then begin
	info.addtext.flag = 1
	widget_control, set_uvalue=info, info.widgets.base
endif else begin
	the_message = [ 'Problem to add text in this draw window.',$
		'You may need to close this window and do it again.']
	result= dialog_message(the_message, title='View HDF Warning')
	return
endelse

the_message = [ 'Move the CURSOR to the location where ',$
	'text will be added and PRESS LEFT MOUSE BUTTON.']
result= dialog_message(the_message, /information, $
	title='Select Position to add text')


end

;--------------------------------------------------------------------------------
pro add_text_doneCB, event

pro_name = 'add_text_doneCB'
@getinfo

widget_control, get_uvalue=uval, event.id
widget_control, get_uvalue=info, event.top

case uval of 

   'add': begin
	widget_control, get_value=temp, info.text_widgets.text
	temp=temp(0)
	length = strlen(temp)
	if length eq 0 then return
	widget_control, get_value=charsize, info.text_widgets.size
	x = info.addtext.xloc
	y = info.addtext.yloc
	;xyouts, x, y, temp, /NORMAL, font=info.char.font, charsize=charsize, /noclip
	xyouts, x, y, temp, /DATA, font=info.char.font, charsize=charsize, /noclip
	widget_control, info.text_widgets.add, sensitive=0
	widget_control, info.text_widgets.clear, sensitive=0
	widget_control, info.text_widgets.next, sensitive=1
	widget_control, info.text_widgets.remove, sensitive=1
   end

   'clear': begin
	temp=''
	widget_control, set_value=temp, info.text_widgets.text
   end

   'next': begin
	widget_control, get_value=temp, info.text_widgets.text
	temp=temp(0)
	length = strlen(temp)
	if length gt 0 then begin
		widget_control, get_value=charsize, info.text_widgets.size
		x = info.addtext.xloc
		y = info.addtext.yloc
		length=strlen(info.addtext.text)
		if length eq 0 or info.addtext.key eq 0 then begin
			info.addtext.text = strtrim(temp, 2) + '|'
			info.addtext.charsize = strtrim(string(charsize),2) + '|'
			info.addtext.x_loc = strtrim(string(x),2) + '|'
			info.addtext.y_loc = strtrim(string(y),2) + '|'
			info.addtext.key = 1
		endif else begin
			info.addtext.text = info.addtext.text + strtrim(temp,2) + '|'
			info.addtext.charsize = info.addtext.charsize + strtrim(string(charsize),2) + '|'
			info.addtext.x_loc = info.addtext.x_loc + strtrim(string(x),2) + '|'
			info.addtext.y_loc = info.addtext.y_loc + strtrim(string(y),2) + '|'
		endelse
		norm_coord = convert_coord(x,y,/DATA, /TO_NORMAL)
		x_norm = norm_coord(0,0)
		y_norm = norm_coord(1,0)
		y_norm = y_norm - 0.03 * charsize
		data_coord = convert_coord(x_norm, y_norm, /NORMAL, /TO_DATA)
		info.addtext.yloc = data_coord(1,0)
		;info.addtext.yloc = info.addtext.yloc - 0.03 * charsize
		widget_control, set_uvalue=info, event.top
	endif
	temp = ''
	widget_control, info.text_widgets.text, set_value=temp
	widget_control, info.text_widgets.add, sensitive=1
        widget_control, info.text_widgets.clear, sensitive=1
        widget_control, info.text_widgets.next, sensitive=0
        widget_control, info.text_widgets.remove, sensitive=0
   end

   'done': begin
	widget_control, get_value=temp, info.text_widgets.text
	temp=temp(0)
	length = strlen(temp)
	if length gt 0 then begin
		widget_control, get_value=charsize, info.text_widgets.size
		x = info.addtext.xloc
		y = info.addtext.yloc
		;xyouts, x, y, temp, /NORMAL, font=info.char.font, charsize=charsize
		xyouts, x, y, temp, /DATA, font=info.char.font, charsize=charsize, /noclip
		length=strlen(info.addtext.text)
		if length eq 0 or info.addtext.key eq 0 then begin
			info.addtext.text = strtrim(temp, 2)
			info.addtext.charsize = strtrim(string(charsize),2)
			info.addtext.x_loc = strtrim(string(x),2)
			info.addtext.y_loc = strtrim(string(y),2)
			info.addtext.key = 1
		endif else begin
			info.addtext.text = info.addtext.text + strtrim(temp,2)
			info.addtext.charsize = info.addtext.charsize + strtrim(string(charsize),2)
			info.addtext.x_loc = info.addtext.x_loc + strtrim(string(x),2)
			info.addtext.y_loc = info.addtext.y_loc + strtrim(string(y),2)
		endelse 
	endif
	length = strlen(info.addtext.temp_text)
	if length gt 0 then begin
		len_text = strlen(info.addtext.text)
		if len_text gt 0 then begin
			info.addtext.text = info.addtext.temp_text + '|' + info.addtext.text
			info.addtext.charsize = info.addtext.temp_charsize + '|' + $
				info.addtext.charsize
			info.addtext.x_loc = info.addtext.temp_x_loc + '|' + info.addtext.x_loc
			info.addtext.y_loc = info.addtext.temp_y_loc + '|' + info.addtext.y_loc
		endif else begin
			info.addtext.text = info.addtext.temp_text
			info.addtext.charsize = info.addtext.temp_charsize
			info.addtext.x_loc = info.addtext.temp_x_loc
			info.addtext.y_loc = info.addtext.temp_y_loc
		endelse
	endif
	info.addtext.flag = 0
	if(widget_info(info.widgets.base, /VALID_ID)) then $
		widget_control, set_uvalue=info, info.widgets.base
	widget_control, set_uvalue=info, info.base
	widget_control, event.top, /destroy
   end

   'cancel': begin
	widget_control, get_value=temp, info.text_widgets.text
	temp=temp(0)
	length = strlen(temp)
	if length gt 0 then begin
		widget_control, get_value=charsize, info.text_widgets.size
		x = info.addtext.xloc
		y = info.addtext.yloc
		color = !P.BACKGROUND
		;xyouts, x , y, temp, /NORMAL, font=info.char.font, charsize=charsize, $
		xyouts, x , y, temp, /DATA, font=info.char.font, charsize=charsize, $
			color=color, /noclip
	endif
	length = strlen(info.addtext.text)
	if length gt 0 then begin
		color = !P.BACKGROUND
		text_array = str_sep(info.addtext.text, '|')
		size_array = str_sep(info.addtext.charsize, '|')
		xloc_array = str_sep(info.addtext.x_loc, '|')
		yloc_array = str_sep(info.addtext.y_loc, '|')
		num_text = n_elements(text_array)
		for i=0, num_text-1 do begin
			xyouts, float(xloc_array(i)), float(yloc_array(i)), $
				;text_array(i), /NORMAL, font=info.char.font, $
				text_array(i), /DATA, font=info.char.font, $
				charsize=float(size_array(i)), color=color, /noclip
		endfor
	endif
	length = strlen(info.addtext.temp_text)
	if length gt 0 then begin
		info.addtext.text = info.addtext.temp_text
		info.addtext.charsize = info.addtext.temp_charsize
		info.addtext.x_loc = info.addtext.temp_x_loc
		info.addtext.y_loc = info.addtext.temp_y_loc
	endif else info = initial_addtext(info)

	if(widget_info(info.widgets.base, /VALID_ID)) then $
		widget_control, set_uvalue=info, info.widgets.base
	widget_control, set_uvalue=info, info.base
	widget_control, event.top, /destroy
   end

   'remove': begin
	widget_control, get_value=temp, info.text_widgets.text
	temp=temp(0)
	length = strlen(temp)
	if length gt 0 then begin
		widget_control, get_value=charsize, info.text_widgets.size
		x = info.addtext.xloc
		y = info.addtext.yloc
		color = !P.BACKGROUND
		;xyouts, x, y, temp, /NORMAL, font=info.char.font, charsize=charsize, $
		xyouts, x, y, temp, /DATA, font=info.char.font, charsize=charsize, $
			color=color, /noclip
	endif
	temp=''
	widget_control, info.text_widgets.text, set_value=temp
	widget_control, info.text_widgets.add, sensitive=1
	widget_control, info.text_widgets.clear, sensitive=1
	widget_control, info.text_widgets.next, sensitive=0
	widget_control, info.text_widgets.remove, sensitive=0
   end

   else:

endcase

end

;------------------------------------------------------------------
pro add_text, x, y, info

pro_name = 'add_text'
@getinfo

info.addtext.xloc = x
info.addtext.yloc = y

info.addtext.temp_text = info.addtext.text
info.addtext.temp_charsize = info.addtext.charsize
info.addtext.temp_x_loc = info.addtext.x_loc
info.addtext.temp_y_loc = info.addtext.y_loc
info.addtext.text = ''
info.addtext.charsize = ''
info.addtext.x_loc = ''
info.addtext.y_loc = ''

base = widget_base(COLUMN=1, MAP=1, UVALUE=info, $
	EVENT_PRO='add_text_doneCB', TITLE='Add Text')

info.text_widgets.text = CW_FIELD(base, ROW=1, STRING=1, $
	FIELDFONT=info.font, FONT=info.font, TITLE='Text:', $
	XSIZE=50)

info.text_widgets.size = CW_FIELD(base, ROW=1, FLOATING=1, $
	FIELDFONT=info.font, FONT=info.font, TITLE='Character Size:', $
	XSIZE=10, value=1.0)

group1=widget_base(base, row=1,map=1, space=100, /align_center)

info.text_widgets.add=widget_button(group1, FONT=info.font, $
	VALUE="Add", /ALIGN_CENTER, uvalue='add')

info.text_widgets.clear=widget_button(group1, FONT=info.font, $
	VALUE="Clear", /ALIGN_CENTER, uvalue='clear')

group2=widget_base(base, row=1,map=1, space=30, /align_center)

info.text_widgets.next=widget_button(group2, FONT=info.font, $
	VALUE="Next Line", /ALIGN_CENTER, uvalue='next')

button4=widget_button(group2, FONT=info.font, VALUE="Done",$
	 /ALIGN_CENTER, uvalue='done')

button5=widget_button(group2, FONT=info.font, VALUE="Cancel",$
	 /ALIGN_CENTER, uvalue='cancel')

info.text_widgets.remove=widget_button(group2, FONT=info.font, $
	VALUE="Remove", /ALIGN_CENTER, uvalue='remove')

widget_control, /realize, base

widget_control, info.text_widgets.next, sensitive=0
widget_control, info.text_widgets.remove, sensitive=0

widget_control, set_uvalue=info, base
if(widget_info(info.widgets.base, /VALID_ID)) then $
	widget_control, set_uvalue=info, info.widgets.base
widget_control, set_uvalue=info, info.base

end

;------------------------------------------------------------------
pro write_add_text, info

pro_name = 'write_add_text'
@getinfo

length = strlen(info.addtext.text)
if length gt 0 then begin
	text_array = str_sep(info.addtext.text, '|')
	size_array = str_sep(info.addtext.charsize, '|')
	xloc_array = str_sep(info.addtext.x_loc, '|')
	yloc_array = str_sep(info.addtext.y_loc, '|')
	num_text = n_elements(text_array)
	for i=0, num_text-1 do begin
		xyouts, float(xloc_array(i)), float(yloc_array(i)), $
			;text_array(i), /NORMAL, font=info.char.font, $
			text_array(i), /DATA, font=info.char.font, $
			charsize=float(size_array(i)), /noclip
	endfor
endif

end

;--------------------------------------------------------------------------------
pro assign_geolocated_data, this_subset, info, hdf_data_x, hdf_data_y, satellite_x, $
	satellite_y, sun_x, sun_y

pro_name = 'assign_geolocated_data'
@getinfo

;widget_control,info.widgets.current_file, get_value=current_filename
current_filename=info.subset.data(this_subset).src_filename
current_filename=current_filename(0)

temp_error_data = get_error_data(hdf_data_x)
if temp_error_data lt -9999999.0 then begin
	if ptr_valid(info.geolocated.temp_long) then begin
		ptr_free, info.geolocated.temp_long
		widget_control, set_uvalue=info, info.base
	endif
	return
endif

info.geolocated.flag = 1
if info.geolocated.selected eq 1 then the_subset = info.geolocated.long_index $
	else the_subset = this_subset
info.geolocated.filename = current_filename
this_start = info.subset.data(the_subset).src_start(0)
this_end = info.subset.data(the_subset).src_end(0)
this_increment = info.subset.data(the_subset).src_increment(0)
if info.subset.data(the_subset).src_type_flag eq 0 then begin
	the_rank = info.subset.data(the_subset).src_rank
	if the_rank eq 1 then begin
		true_start = info.subset.data(the_subset).src_start(the_rank)
		true_end = info.subset.data(the_subset).src_end(the_rank)
		if true_start ne this_start or true_end ne this_end then begin
			this_start = true_start
			this_end = true_end
			this_increment = 1
		endif
	endif
endif else this_end = this_end + 1

info.geolocated.starting = this_start
info.geolocated.ending = this_end
info.geolocated.increment = this_increment

if ptr_valid(info.geolocated.temp_long) then ptr_free, $
	info.geolocated.temp_long
info.geolocated.temp_long=ptr_new(hdf_data_x, /NO_COPY)

if ptr_valid(info.geolocated.temp_colat) then ptr_free, $
	info.geolocated.temp_colat
info.geolocated.temp_colat=ptr_new(hdf_data_y, /NO_COPY)

temp_error_data = get_error_data(satellite_x)
if ptr_valid(info.geolocated.temp_sate_long) then ptr_free, $
	info.geolocated.temp_sate_long
if ptr_valid(info.geolocated.temp_sate_colat) then ptr_free, $
	info.geolocated.temp_sate_colat
if temp_error_data ge -180.0 then begin
	info.geolocated.temp_sate_long=ptr_new(satellite_x, /NO_COPY)
	info.geolocated.temp_sate_colat=ptr_new(satellite_y, /NO_COPY)
endif else info.greenwich.satellite = 0

temp_error_data = get_error_data(sun_x)
if ptr_valid(info.geolocated.temp_sun_long) then ptr_free, $
	info.geolocated.temp_sun_long
if ptr_valid(info.geolocated.temp_sun_colat) then ptr_free, $
	info.geolocated.temp_sun_colat
if temp_error_data ge -180.0 then begin
	info.geolocated.temp_sun_long=ptr_new(sun_x, /NO_COPY)
	info.geolocated.temp_sun_colat=ptr_new(sun_y, /NO_COPY)
endif else info.greenwich.sun = 0

widget_control, set_uvalue=info, info.base

end

;--------------------------------------------------------------------------------
pro auto_scale, event

pro_name = 'auto_scale'
@getinfo

widget_control, get_uvalue=info, event.top
widget_control, get_uvalue=info, info.base

info.scaledata.auto = event.index

widget_control, set_uvalue=info, info.base

end

;--------------------------------------------------------------------------------
PRO axis_dialogueCB, Event

pro_name = 'axis_dialogueCB'
@getinfo

widget_control, get_uvalue=info, event.top

widget_control, info.widgets.x_start, get_value=x_start
widget_control, info.widgets.x_end, get_value=x_end

info.range.x_start = x_start
info.range.x_end = x_end

if (info.widgets.y_start ne 0) then begin
	widget_control, info.widgets.y_start, get_value=y_start
	widget_control, info.widgets.y_end, get_value=y_end

	info.range.y_start = y_start
	info.range.y_end = y_end
endif

if (info.widgets.z_start ne 0) then begin
	widget_control, info.widgets.z_start, get_value=z_start
	widget_control, info.widgets.z_end, get_value=z_end

	info.range.z_start = z_start
	info.range.z_end = z_end
endif


widget_control, set_uvalue=info, info.base
widget_control, event.top, /destroy

END

;-----------------------------------------------------------------
PRO cancel_axis_selected, Event

pro_name = 'cancel_axis_selected'
@getinfo
 
widget_control, get_uvalue=info, event.top
widget_control, get_uvalue=old_axis_state, event.id

widget_control, event.top, /destroy

info.axis_state = old_axis_state

if(widget_info(info.widgets.base, /VALID_ID)) then $
	widget_control, set_uvalue=info, info.widgets.base
widget_control, set_uvalue=info, info.base

end

;-----------------------------------------------------------------
PRO axis_selected, Event

pro_name = 'axis_selected'
@getinfo
 
widget_control, get_uvalue=info, event.top
widget_control, get_uvalue=base_id, event.id

if (info.widgets.x_start ne 0) then begin
	widget_control, info.widgets.x_start, get_value=x_start
	widget_control, info.widgets.x_end, get_value=x_end
	info.range.x_start = x_start
	info.range.x_end = x_end
	print, "X Axis values are: ", x_start, x_end
endif

if (info.widgets.y_start ne 0) then begin
	widget_control, info.widgets.y_start, get_value=y_start
	widget_control, info.widgets.y_end, get_value=y_end
	info.range.y_start = y_start
	info.range.y_end = y_end
	print, "Y Axis values are: ", y_start, y_end
endif

if (info.widgets.z_start ne 0) then begin
	widget_control, info.widgets.z_start, get_value=z_start
	widget_control, info.widgets.z_end, get_value=z_end
	info.range.z_start = z_start
	info.range.z_end = z_end
	print, "z values are: ", z_start, z_end
endif

if (info.widgets.y2_start ne 0) then begin
	widget_control, info.widgets.y2_start, get_value=y2_start
	widget_control, info.widgets.y2_end, get_value=y2_end
	info.range.y2_start = y2_start
	info.range.y2_end = y2_end
	print, "y2 values are: ", y2_start, y2_end
endif

if(widget_info(info.widgets.base, /VALID_ID)) then $
	widget_control, set_uvalue=info, info.widgets.base
widget_control, set_uvalue=info, info.base
widget_control, event.top, /destroy

if base_id eq info.widgets.base then begin
	redraw_graph, info
endif

END

;------------------------------------------------------------------
pro axis_setup, info, base_id, old_axis_state

pro_name = 'axis_setup'
@getinfo
 
font1=info.font

axis_state = info.axis_state

CASE axis_state of

	1: title = 'Define X Axis'
	2: title = 'Define Y Axis'
	3: title = 'Define Z Axis'
	4: title = 'Define X & Y Axis'
	5: title = 'Define X, Y & Z Axis'
	6: title = 'Define Y2 Axis'
	7: title = 'Define Y & Y2 Axis'
	8: title = 'Define X & Y2 Axis'
	9: title = 'Define X, Y & Y2 Axis'
ENDCASE

base=widget_base( COLUMN=1, MAP=1, TITLE=title)
widget_control, set_uvalue=info, base

info.widgets.x_start=0L
info.widgets.x_end=0L
info.widgets.y_start=0L
info.widgets.y_end=0L
info.widgets.z_start=0L
info.widgets.z_end=0L
info.widgets.y2_start=0L
info.widgets.y2_end=0L

x_group=widget_base(base, row=1,map=1)
y_group=widget_base(base, row=1,map=1)
z_group=widget_base(base, row=1,map=1)
y2_group=widget_base(base, row=1,map=1)


if (axis_state eq 1 or axis_state eq 4 or axis_state eq 5 or axis_state eq 8 or $
	axis_state eq 9) then begin

	x_start_widget= CW_FIELD(x_group,VALUE=info.range.x_start, ROW=1,$
	 FLOATING=1, FIELDFONT=font1, FONT=font1, TITLE='X Start:',$
	 XSIZE=20 )

	x_end_widget= CW_FIELD(x_group,VALUE=info.range.x_end, ROW=1,$
	 FLOATING=1, FIELDFONT=font1, FONT=font1, TITLE='X End:',$
	 XSIZE=20 )

	info.widgets.x_start=x_start_widget
	info.widgets.x_end=x_end_widget
endif


if (axis_state eq 2 or axis_state eq 4 or axis_state eq 5 or axis_state eq 7 or $
	axis_state eq 9) then begin

	y_start_widget= CW_FIELD(y_group,VALUE=info.range.y_start, ROW=1,$
	 FLOATING=1, FIELDFONT=font1, FONT=font1, TITLE='Y Start:',$
	 XSIZE=20 )

	y_end_widget= CW_FIELD(y_group,VALUE=info.range.y_end, ROW=1,$
	 FLOATING=1, FIELDFONT=font1, FONT=font1, TITLE='Y End:',$
	 XSIZE=20 )

	info.widgets.y_start=y_start_widget
	info.widgets.y_end=y_end_widget
endif

if (axis_state eq 3 or axis_state eq 5 ) then begin

	z_start_widget= CW_FIELD(z_group,VALUE=info.range.z_start, ROW=1,$
	 FLOATING=1, FIELDFONT=font1, FONT=font1, TITLE='Z Start:',$
	 XSIZE=20 )

	z_end_widget= CW_FIELD(z_group,VALUE=info.range.z_end, ROW=1,$
	 FLOATING=1, FIELDFONT=font1, FONT=font1, TITLE='Z End:',$
	 XSIZE=20 )

	info.widgets.z_start=z_start_widget
	info.widgets.z_end=z_end_widget
endif

if (axis_state eq 6 or axis_state eq 7 or axis_state eq 8 or axis_state eq 9) then begin

	y2_start_widget= CW_FIELD(y2_group,VALUE=info.range.y2_start, ROW=1,$
	 FLOATING=1, FIELDFONT=font1, FONT=font1, TITLE='Y2 Start:',$
	 XSIZE=20 )

	y2_end_widget= CW_FIELD(y2_group,VALUE=info.range.y2_end, ROW=1,$
	 FLOATING=1, FIELDFONT=font1, FONT=font1, TITLE='Y2 End:',$
	 XSIZE=20 )

	info.widgets.y2_start=y2_start_widget
	info.widgets.y2_end=y2_end_widget
endif

group2=widget_base(base, row=1,map=1, space=100, /align_center)

button1=widget_button(group2, FONT=info.font, EVENT_PRO='axis_selected', VALUE="Done",$
	/ALIGN_CENTER, uvalue=base_id)

button2=widget_button(group2, FONT=info.font, EVENT_PRO='cancel_axis_selected', $
	VALUE="Cancel", /ALIGN_CENTER, uvalue=old_axis_state)

widget_control, set_uvalue=info, base

widget_control, /realize, base

end

;--------------------------------------------------------------------------------
pro output_dir, event

pro_name = 'output_dir'
@getinfo

widget_control, get_uvalue=info, event.id
widget_control, get_uvalue=info, info.base

widget_control, /hourglass

output_path = ''
widget_control, info.widgets.outputdir, get_value=output_path

old_output_path = info.output_path
output_path = output_path(0)
info.output_path=output_path
print,'Output Path = ',info.output_path

;count = check_directory(info.output_path, info.home_path)
count = check_exist_dir(info.output_path)
if count eq 0 then begin
	message = [ "Your New output path is invali!d", info.output_path , $
		"It is set to previous output path.", $
		"Use Change Output Path to change the output path."] 
	result=dialog_message( message, title='View HDF Warning!')
	CD, '.', CURRENT=pwd
	info.output_path = old_output_path
	widget_control, info.widgets.outputdir, set_value=info.output_path
endif
CD, info.output_path, CURRENT=old_dir
output_name_list=findfile(info.filter, count=count)
if count eq 0 then output_name_list = [ 'None' ]

widget_control, info.widgets.output, set_value=output_name_list
 
CD, old_dir
 
widget_control, set_uvalue=info, info.base


end

;--------------------------------------------------------------------------------
pro output_filter, event

pro_name = 'output_filter'
@getinfo

widget_control, get_uvalue=info, event.id
widget_control, get_uvalue=info, info.base

widget_control, /hourglass

file_filter = ''
widget_control, info.widgets.filter, get_value=file_filter

file_filter = file_filter(0)
info.filter=file_filter

;count = check_directory(info.output_path, info.home_path)
count = check_exist_dir(info.output_path)
if count eq 0 then begin
	message = [ "Your output path is invali!d", info.output_path , $
		"It is set to current directory.", $
		"Use Change Output Path to change the output path."] 
	result=dialog_message( message, title='View HDF Warning!')
	CD, '.', CURRENT=pwd
	info.output_path = pwd
endif
CD, info.output_path, CURRENT=old_dir
output_name_list=findfile(info.filter, count=count)
if count eq 0 then output_name_list = [ 'None' ]

widget_control, info.widgets.output, set_value=output_name_list
 
CD, old_dir
 
widget_control, set_uvalue=info, info.base


end

;--------------------------------------------------------------------------------
pro barlocationCB, event

pro_name = 'barlocationCB'
@getinfo

widget_control, get_uvalue=info, event.top

widget_control, info.widgets.barlocation, get_value=barlocation

info.barlocation=barlocation
print,'Color Bar Location=',info.barlocation

if(widget_info(info.widgets.base, /VALID_ID)) then $
	widget_control, set_uvalue=info, info.widgets.base
widget_control, set_uvalue=info, info.base

widget_control, event.top, /destroy

end

;--------------------------------------------------------------------------------
pro bar_location, info

pro_name = 'bar_location'
@getinfo

base = widget_base(COLUMN=1, MAP=1, TITLE='Color Bar Location')

b_group=widget_base(base, row=1,map=1)

info.widgets.barlocation = CW_FIELD(b_group, VALUE=info.barlocation, $
		ROW=1, FLOATING=1, FIELDFONT=info.font, $
		FONT=info.font, TITLE='Color Bar Location:', XSIZE=40)

group2=widget_base(base, row=1,map=1, space=40, /align_center)

button1=widget_button(group2, FONT=info.font, EVENT_PRO='barlocationCB', VALUE="Done",$
	/ALIGN_CENTER, uvalue=info)

button2=widget_button(group2, FONT=info.font, EVENT_PRO='doneCB', VALUE="Cancel",$
	 /ALIGN_CENTER)

widget_control, /realize, base

widget_control, set_uvalue=info, base
if(widget_info(info.widgets.base, /VALID_ID)) then $
	widget_control, set_uvalue=info, info.widgets.base
widget_control, set_uvalue=info, info.base

end

;--------------------------------------------------------------------------------
pro create_gui, info, new_flag

pro_name = 'create_gui'
@getinfo

widget_control, /hourglass

IF N_ELEMENTS(Group) EQ 0 THEN GROUP=0

junk   = { CW_PDMENU_S, flags:0, name:'' }

info.base = WIDGET_BASE(GROUP_LEADER=Group, $
                COLUMN=1, $
                MAP=1, $
		TITLE='View_HDF  Version 5.0.0', $
                MBAR=bar)

MenuDesc = [ $
                { CW_PDMENU_S,       1, 'File' }, $
;                { CW_PDMENU_S,       0, 'Open...Without Attribute' }, $
;                { CW_PDMENU_S,       0, 'Open...With Attribute' }, $
;                { CW_PDMENU_S,       0, 'Open...With Vgroup' }, $
		{ CW_PDMENU_S,       0, 'Open HDF Files' }, $
		{ CW_PDMENU_S,       0, 'Open ASCII Files' }, $
		{ CW_PDMENU_S,       0, 'Open Previous Files' }, $
		{ CW_PDMENU_S,       0, 'Display Global Attributes' }, $
		{ CW_PDMENU_S,       0, 'Display Metadata' }, $
;		{ CW_PDMENU_S,       0, 'Open File Filter' }, $
;		{ CW_PDMENU_S,       0, 'Add User Defined Module' }, $
;		{ CW_PDMENU_S,       0, 'Remove User Defined Module' }, $
                { CW_PDMENU_S,       1, 'Export List...' }, $
		{ CW_PDMENU_S,       1, 'Without Filldata' }, $
		{ CW_PDMENU_S,       0, 'Without Reference' }, $
		{ CW_PDMENU_S,       2, 'With Reference' }, $
		{ CW_PDMENU_S,       2, 'With Filldata' }, $
                { CW_PDMENU_S,       1, 'Export Tecplot...' }, $
		{ CW_PDMENU_S,       1, 'Without Filldata' }, $
		{ CW_PDMENU_S,       0, 'Without Reference' }, $
		{ CW_PDMENU_S,       2, 'With Reference' }, $
		{ CW_PDMENU_S,       2, 'With Filldata' }, $
		{ CW_PDMENU_S,       0, 'Create an HDF File' }, $
		{ CW_PDMENU_S,       0, 'Add Data To an HDF File' }, $
;		{ CW_PDMENU_S,       0, 'Change Open File Path' }, $
;		{ CW_PDMENU_S,       0, 'Change Output Path' }, $
;		{ CW_PDMENU_S,	     0, 'Change Home Directory' }, $
;		{ CW_PDMENU_S,       0, 'Change Temporary Directory' }, $
		{ CW_PDMENU_S,       0, 'Read Configuration File' }, $
		{ CW_PDMENU_S,       0, 'Change Preferences' }, $
                { CW_PDMENU_S,       0, 'Restart' }, $
                { CW_PDMENU_S,       2, 'Exit' }, $
                { CW_PDMENU_S,       1, 'Graphic' }, $
		{ CW_PDMENU_S,       0, 'Multi Y Variables' }, $
		{ CW_PDMENU_S,       0, 'Multi X Variables' }, $
                { CW_PDMENU_S,       0, 'X-Y Plot' }, $
                { CW_PDMENU_S,       0, 'X-Y-Z Plot' }, $
                { CW_PDMENU_S,       0, 'Y1-Y2 Plot' }, $
		{ CW_PDMENU_S,       0, 'Scatter Contour Plot' }, $
		{ CW_PDMENU_S,       2, '3D Mesh Plot' }, $
                { CW_PDMENU_S,       1, 'Compute' }, $
                { CW_PDMENU_S,       0, 'Y1 Plus Y2, [Y1 + Y2]' }, $
                { CW_PDMENU_S,       0, 'Y1 Minus Y2, [Y1 - Y2]' }, $
                { CW_PDMENU_S,       0, 'Y1 Times Y2, [Y1 * Y2]' }, $
                { CW_PDMENU_S,       0, 'Y1 Divided By Y2, [Y1 / Y2]' }, $
		{ CW_PDMENU_S,       0, 'Y1 Raised To The Y2 Power, [Y1 ** Y2]' }, $
		{ CW_PDMENU_S,       0, 'log(Y1)' }, $
		{ CW_PDMENU_S,       0, 'log10(Y1)' }, $
		{ CW_PDMENU_S,       0, 'exp(Y1)' }, $
		{ CW_PDMENU_S,       0, 'abs(Y1)' }, $
		{ CW_PDMENU_S,       0, 'cos(Y1)' }, $
		{ CW_PDMENU_S,       0, 'sin(Y1)' }, $
		{ CW_PDMENU_S,       0, 'tan(Y1)' }, $
		{ CW_PDMENU_S,       0, 'acos(Y1)' }, $
		{ CW_PDMENU_S,       0, 'asin(Y1)' }, $
		{ CW_PDMENU_S,       0, 'atan(Y1)' }, $
		{ CW_PDMENU_S,       0, 'Extract Bits' }, $
		{ CW_PDMENU_S,       0, 'Matrices Multiplication' }, $
		{ CW_PDMENU_S,       2, 'Run User Defined Module' }, $
                { CW_PDMENU_S,       1, 'Curve Fit' }, $
                { CW_PDMENU_S,       0, 'Polynomial Fit' }, $
                { CW_PDMENU_S,       0, 'Exponential' }, $
                { CW_PDMENU_S,       0, 'Geometric' }, $
                { CW_PDMENU_S,       0, 'Logsquare' }, $
                { CW_PDMENU_S,       2, 'Linear Fit With Fixed Intercept' } $
		]
MenuDesc = [ MenuDesc, $
                { CW_PDMENU_S,       1, 'Colors' }, $
                { CW_PDMENU_S,       0, 'Select Colors...' }, $
                { CW_PDMENU_S,       0, 'Edit Colors...' }, $
                { CW_PDMENU_S,       0, 'Load User Color Table' }, $
                { CW_PDMENU_S,       0, 'Load Discrete Color Table' }, $
                { CW_PDMENU_S,       0, 'Background' }, $
                { CW_PDMENU_S,       2, 'Foreground' }, $
;		{ CW_PDMENU_S,       1, 'Settings' }, $
;		{ CW_PDMENU_S,       0, 'Axis' }, $
;		{ CW_PDMENU_S,       0, 'Map' }, $
;		{ CW_PDMENU_S,       0, 'Grid Start' }, $
;		{ CW_PDMENU_S,       0, 'Color Bar' }, $
;		{ CW_PDMENU_S,       0, 'Style' }, $
;		{ CW_PDMENU_S,       0, 'Editor' }, $
;		{ CW_PDMENU_S,       0, 'Fill Data Value' }, $
;		{ CW_PDMENU_S,       0, 'Display Time Type' }, $
;		{ CW_PDMENU_S,       2, 'Auto Select Scale Factors' } $
;		{ CW_PDMENU_S,       2, 'Misc' } $
;		]
       		{ CW_PDMENU_S,       1, 'Axis' }, $
         	{ CW_PDMENU_S,       1, 'Manual' }, $
           	{ CW_PDMENU_S,       0, 'X Only' }, $
           	{ CW_PDMENU_S,       0, 'Y Only' }, $
           	{ CW_PDMENU_S,       0, 'Z Only' }, $
           	{ CW_PDMENU_S,       0, 'XY Only' }, $
           	{ CW_PDMENU_S,       0, 'XYZ' }, $
           	{ CW_PDMENU_S,       0, 'Y2 Only' }, $
           	{ CW_PDMENU_S,       0, 'YY2 Only' }, $
           	{ CW_PDMENU_S,       2, 'XYY2 Only' }, $
         	{ CW_PDMENU_S,       0, 'Auto' }, $
         	{ CW_PDMENU_S,       1, 'Grid' }, $
         	{ CW_PDMENU_S,       0, 'With XY Grid' }, $
         	{ CW_PDMENU_S,       0, 'With X Grid Only' }, $
         	{ CW_PDMENU_S,       0, 'With Y Grid Only' }, $
         	{ CW_PDMENU_S,       2, 'Without Grid' }, $
 		{ CW_PDMENU_S,       1, 'Logarithmic Axis' }, $
 		{ CW_PDMENU_S,       0, 'With Linear Axes' }, $
 		{ CW_PDMENU_S,       0, 'With Logarithmic X Axis' }, $
 		{ CW_PDMENU_S,       0, 'With Logarithmic Y Axis' }, $
 		{ CW_PDMENU_S,       0, 'With Logarithmic XY Axes' }, $
 		{ CW_PDMENU_S,       0, 'With Logarithmic Y2 Axis' }, $
 		{ CW_PDMENU_S,       0, 'With Logarithmic XY2 Axes' }, $
 		{ CW_PDMENU_S,       0, 'With Logarithmic YY2 Axes' }, $
 		{ CW_PDMENU_S,       2, 'With Logarithmic XYY2 Axes' }, $
         	{ CW_PDMENU_S,       2, '' } $
 		]
;MenuDesc = [ MenuDesc, $
;      		{ CW_PDMENU_S,       1, 'Map' }, $ 	
;     		{ CW_PDMENU_S,       1, 'Greenwich Location' }, $ 	
;       	{ CW_PDMENU_S,       0, 'Left' }, $ 
;       	{ CW_PDMENU_S,       0, 'Center' }, $ 
;       	{ CW_PDMENU_S,       2, 'Other' }, $ 
;		{ CW_PDMENU_S,       0, 'Center Location' }, $
;      		{ CW_PDMENU_S,       1, 'Projection' }, $ 	
;        	{ CW_PDMENU_S,       0, 'Cylindrical' }, $ 
;        	{ CW_PDMENU_S,       0, 'Orthographic' }, $ 
;        	{ CW_PDMENU_S,       0, 'Stereographic' }, $ 
;        	{ CW_PDMENU_S,       2, 'Hammer-Aitoff' }, $ 
;      		{ CW_PDMENU_S,       1, 'Lat-Longitude' }, $ 	
;        	{ CW_PDMENU_S,       0, 'Default' }, $ 
;        	{ CW_PDMENU_S,       2, 'Select' }, $ 
;      		{ CW_PDMENU_S,       1, 'Label' }, $ 	
;        	{ CW_PDMENU_S,       0, 'With Label' }, $ 
;        	{ CW_PDMENU_S,       2, 'Without Label' }, $ 
;      		{ CW_PDMENU_S,       1, 'Expand' }, $ 	
;        	{ CW_PDMENU_S,       0, 'With Expand' }, $ 
;        	{ CW_PDMENU_S,       2, 'Without Expand' }, $ 
;      		{ CW_PDMENU_S,       1, 'Satellite' }, $ 	
;        	{ CW_PDMENU_S,       0, 'Show Satellite' }, $ 
;        	{ CW_PDMENU_S,       2, 'Show No Satellite' }, $ 
;      		{ CW_PDMENU_S,       1, 'Sun' }, $ 	
;        	{ CW_PDMENU_S,       0, 'Show Sun' }, $ 
;        	{ CW_PDMENU_S,       2, 'Show No Sun' }, $ 
;      		{ CW_PDMENU_S,       1, 'Continents' }, $ 	
;        	{ CW_PDMENU_S,       0, 'Redraw Continents' }, $ 
;        	{ CW_PDMENU_S,       0, 'No Redraw Continents' }, $ 
;		{ CW_PDMENU_S,       2, 'Thickness' }, $
;		{ CW_PDMENU_S,       1, 'Contour Geolocated' }, $
;		{ CW_PDMENU_S,       0, 'With Smoothing' }, $
;		{ CW_PDMENU_S,       0, 'Without Smoothing' }, $
;		{ CW_PDMENU_S,       0, 'Filter With Smoothing' }, $
;		{ CW_PDMENU_S,       0, 'Filter Without Smoothing' }, $
;		{ CW_PDMENU_S,       0, 'Average With Smoothing' }, $
;		{ CW_PDMENU_S,       0, 'Average Without Smoothing' }, $
;		{ CW_PDMENU_S,       2, 'Set Number of Grids' }, $
;        	{ CW_PDMENU_S,       2, 'Reread Geolocated Data' }, $ 
;      		{ CW_PDMENU_S,       1, 'Grid Start' }, $ 	
;      		{ CW_PDMENU_S,       0, 'Auto' }, $ 	
;        	{ CW_PDMENU_S,       0, '   0' }, $ 
;        	{ CW_PDMENU_S,       0, '-180' }, $ 
;        	{ CW_PDMENU_S,       2, 'Other' } $ 
;		]
MenuDesc = [ MenuDesc, $
;      		{ CW_PDMENU_S,       1, 'Color Bar' }, $ 	
;        	{ CW_PDMENU_S,       1, 'With Color Bar' }, $ 
;        	{ CW_PDMENU_S,       0, 'Discrete' }, $ 
;        	{ CW_PDMENU_S,       2, 'Continuous' }, $ 
;        	{ CW_PDMENU_S,       0, 'Without Color Bar' }, $
;        	{ CW_PDMENU_S,       2, 'Location' }, $
       		{ CW_PDMENU_S,       1, 'Style' }, $ 	
       		{ CW_PDMENU_S,       1, 'Line Type' }, $ 	
         	{ CW_PDMENU_S,       0, 'Solid' }, $ 
         	{ CW_PDMENU_S,       0, 'Dotted' }, $ 
         	{ CW_PDMENU_S,       0, 'Dashed' }, $ 
         	{ CW_PDMENU_S,       0, 'Dashed Dot' }, $ 
         	{ CW_PDMENU_S,       0, 'Dashed Dot Dot Dot' }, $ 
         	{ CW_PDMENU_S,       2, 'Long Dashes' }, $ 
       		{ CW_PDMENU_S,       1, 'Symbol' }, $ 	
         	{ CW_PDMENU_S,       0, 'No Symbol' }, $ 
         	{ CW_PDMENU_S,       0, 'Plus sign' }, $ 
         	{ CW_PDMENU_S,       0, 'Asterisk' }, $ 
         	{ CW_PDMENU_S,       0, 'Period' }, $ 
         	{ CW_PDMENU_S,       0, 'Diamond' }, $ 
       		{ CW_PDMENU_S,       0, 'Triangle' }, $ 	
         	{ CW_PDMENU_S,       0, 'Square' }, $ 
         	{ CW_PDMENU_S,       0, 'X' }, $ 
 		{ CW_PDMENU_S,       0, 'Circle' }, $   
 		{ CW_PDMENU_S,       0, 'FOV' }, $   
 		{ CW_PDMENU_S,       0, 'Filled Triangle' }, $
 		{ CW_PDMENU_S,       0, 'Filled Square' }, $
 		{ CW_PDMENU_S,       0, 'Filled Circle' }, $
 		{ CW_PDMENU_S,       2, 'Filled FOV' }, $
       		{ CW_PDMENU_S,       1, 'Symbol With Line' }, $ 	
         	{ CW_PDMENU_S,       0, 'Without Line' }, $ 
         	{ CW_PDMENU_S,       2, 'With Line' }, $ 
		{ CW_PDMENU_S,	     0, 'Line Thickness' }, $
         	{ CW_PDMENU_S,       0, 'Symbol Size' }, $ 
         	{ CW_PDMENU_S,       2, 'Data Color' }, $ 
		{ CW_PDMENU_S,       1, 'Settings' }, $
		{ CW_PDMENU_S,       0, 'Axis' }, $
		{ CW_PDMENU_S,       0, 'Map' }, $
		{ CW_PDMENU_S,       0, 'Grid Start' }, $
		{ CW_PDMENU_S,       0, 'Color Bar' }, $
		{ CW_PDMENU_S,       0, 'Style' }, $
		{ CW_PDMENU_S,       0, 'Select Font' }, $
;		{ CW_PDMENU_S,       0, 'Editor' }, $
		{ CW_PDMENU_S,       0, 'Fill Data Value' }, $
		{ CW_PDMENU_S,       0, 'Plot Character Size' }, $
		{ CW_PDMENU_S,       0, 'Display Time Type' }, $
		{ CW_PDMENU_S,       0, 'Auto Select Scale Factors' }, $
		{ CW_PDMENU_S,       0, 'Using HDF 4.2r1 Version' }, $
		{ CW_PDMENU_S,       0, 'Diplay Plot Result Question' }, $
		{ CW_PDMENU_S,	     0, 'Multiple Variables Style' }, $
		{ CW_PDMENU_S,	     0, '2D Image Plot' }, $
		{ CW_PDMENU_S,	     0, '3D Mesh Surface Array Sort' }, $
		{ CW_PDMENU_S,       0, 'Browse Image Plot Type' }, $
		{ CW_PDMENU_S,       2, 'Encapsulated Postscript' } $
;		{ CW_PDMENU_S,       2, 'Misc' } $
		]
;MenuDesc = [ MenuDesc, $
;      		{ CW_PDMENU_S,       1, 'Editor' }, $ 	
;        	{ CW_PDMENU_S,       0, 'VI' }, $ 
;        	{ CW_PDMENU_S,       0, 'Emacs' }, $ 
;        	{ CW_PDMENU_S,       0, 'Emacs with Xterm' }, $ 
;        	{ CW_PDMENU_S,       0, 'Ieditor' }, $ 
;        	{ CW_PDMENU_S,       0, 'Edit (PC)' }, $ 
;        	{ CW_PDMENU_S,       2, 'Other' } $
;		] 
;        	{ CW_PDMENU_S,       2, 'Other' }, $ 
;      		{ CW_PDMENU_S,       1, 'Add Criterion' }, $ 	
;        	{ CW_PDMENU_S,       0, 'With Criterion' }, $ 
;        	{ CW_PDMENU_S,       2, 'Without Criterion' } $ 
;		]

PDMENU3 = CW_PDMENU(bar, MenuDesc, /RETURN_FULL_NAME, $
	FONT=info.font, UVALUE='MAIN',/MBAR)

helpmenu = widget_button(bar, value='Help', FONT=info.font, /MENU, /HELP)

user_guide = widget_button(helpmenu, value='User Guide', FONT=info.font, $
	uvalue='userguide')

user_guide = widget_button(helpmenu, value='Release Note', FONT=info.font, $
	uvalue='releasenote')

idlhelpbut = widget_button(helpmenu, value='IDL Online Help', FONT=info.font, $
	uvalue='IDLhelp')

;about_viewhdf_i = widget_button(helpmenu, value='About View_HDF(for CERES)...', FONT=info.font, $
;	uvalue='aboutviewhdfi')

;about_viewhdf_o = widget_button(helpmenu, value='About View_HDF(for others)...', FONT=info.font, $
;	uvalue='aboutviewhdfo')

about_viewhdf = widget_button(helpmenu, value='About View_HDF...', FONT=info.font, $
	uvalue='aboutviewhdf')

open_file_base=widget_base(info.base, row=1,map=1, event_pro='open_file')

info.widgets.current_file = CW_FIELD( open_file_base, $
                VALUE='None', ROW=1, STRING=1, FIELDFONT=info.font, $
                FONT= info.font, TITLE='Current Filename:', /RETURN_EVENTS, $
                UVALUE=info,  XSIZE=80)

switch_file = widget_button(open_file_base, EVENT_PRO='switch_open_file', $
	VALUE='Switch File', FONT=info.font, /ALIGN_CENTER, UVALUE=info)

;------------------------
; Toolbar
;------------------------
;the_toolbar = widget_base(info.base, row=1, map=1, uvalue=info, space=10)

;toolbar_label = widget_label(the_toolbar, FONT=info.font, $
;       /align_left, value="Tools:");

;read_x11_bitmap, 'graph_button.xbm', graph_button, expand_to_bytes

;info.widgets.graph_button = widget_button(the_toolbar, EVENT_PRO='tool_graph',$
;	 VALUE=graph_button, /ALIGN_CENTER)

;precision_tool = widget_button(the_toolbar, $
;                EVENT_PRO='precision_dialogueCB', VALUE='Format', $
;		FONT=info.font, $
;                /ALIGN_CENTER)

;filldata_tool = widget_button(the_toolbar, $
;                EVENT_PRO='filldata_dialogueCB', VALUE='Fill Data', $
;		FONT=info.font, $
;                /ALIGN_CENTER)

;input_list = [ 'Record Number', 'Time' ]
;range_input_tool = widget_droplist(the_toolbar, $
;		TITLE='Range Type:', VALUE=input_list, UVALUE = info, $
;                EVENT_PRO='range_input', FONT=info.font, $
;                /ALIGN_CENTER)

;screen_size_list = [ '1024x600', '1152x614', 'Other' ]
;info.widgets.screen = widget_droplist(the_toolbar, $
;		TITLE='Screen Size:', VALUE=screen_size_list, UVALUE = info, $
;                EVENT_PRO='screen_size', FONT=info.font, $
;                /ALIGN_CENTER)

;show_list = [ 'Hours', 'Minutes', 'Seconds' ]
;info.widgets.time_type = widget_droplist(the_toolbar, $
;		TITLE='Time Type:', VALUE=show_list, UVALUE = info, $
;                EVENT_PRO='show_time', FONT=info.font, $
;                /ALIGN_CENTER)

;scale_data_list = [ 'Auto Select Off', 'Auto Select On' ]
;scaledata_widget = widget_droplist(the_toolbar, $
;		TITLE='Scale Data:', VALUE=scale_data_list, UVALUE = info, $
;		EVENT_PRO='auto_scale', FONT=info.font, $
;		/ALIGN_CENTER)

;info.widgets.criterion = widget_button(the_toolbar, FONT=info.font, $
;	/align_center, value="With Criterion", event_pro='unset_criterion')

;WIDGET_CONTROL, info.widgets.criterion, SENSITIVE = 0

;------------------------
; Layout
;------------------------
layout_widget=widget_base(info.base,row=1,map=1)

toc_widget=widget_base(layout_widget,column=1,map=1,frame=5)

if info.device eq 'X' then xspace=72 else xspace=60
in_group=widget_base(toc_widget,row=1,map=1,space=xspace, /base_align_top)
;sds_group_title=widget_label(toc_widget, $
sds_group_title=widget_label(in_group, $
	FONT=info.font, /align_center, value="INPUT")

input_list = [ 'Record Number', 'Time', 'Multi Files' ]
;range_input_tool = widget_droplist(toc_widget, $
info.rangetype.widget = widget_droplist(in_group, $
	TITLE='Range Type:', VALUE=input_list, UVALUE = info, $
	EVENT_PRO='range_input', FONT=info.font, /ALIGN_CENTER)

;------------------------
;SDS List
;------------------------
if info.device eq 'X' then xspace=1 else xspace=8
attr_group=widget_base(toc_widget,row=1,map=1, space=xspace, /base_align_top)

stitle_widget=widget_label(attr_group, $
	FONT=info.font, /align_center, value="Scientific Data Sets")

attr_list = [ 'Do Not Display Attributes', 'Display Attributes', $
	'Display Attributes Only' ]
attr_widget = widget_droplist(attr_group, VALUE=attr_list, $
	EVENT_PRO='set_attr', FONT=info.font, /ALIGN_CENTER)

sds_group=widget_base(toc_widget,column=1,map=1)

if info.device eq 'X' then begin
    xsize=25 
    ysize = 11
endif else begin
    xsize=52
    ysize = 12
endelse

info.widgets.sds=widget_list(sds_group,value="None", $
	FONT=info.font,  event_pro="select_sdsCB", xsize=xsize, ysize=ysize )

;------------------------
; Vdata List
;------------------------
vdata_group=widget_base(toc_widget,column=1,map=1)

vtitle_widget=widget_label(vdata_group, $
             FONT=info.font, /align_left, value="VData Sets")

info.widgets.vdata=widget_list(vdata_group,value="None", $
	FONT=info.font, event_pro="select_vdataCB", xsize=xsize, ysize=10)

;------------------------
; Subset List
;------------------------
subset_group=widget_base(layout_widget, column=1, map=1, frame=5, uvalue=info)

sds_group_title=widget_label(subset_group, $
	FONT=info.font, $
	/align_left, value="PROCESSING")

sub_group=widget_base(subset_group,row=1,map=1,space=42)
btitle_widget=widget_label(sub_group, $
	FONT=info.font, $
	/align_center, value="Current Subsets")

rem_button=widget_button(sub_group, FONT=info.font, EVENT_PRO='remove_dataset', $
	VALUE="Remove Subset(s)", uvalue=info, /ALIGN_CENTER)

info.widgets.subset_list=widget_list(subset_group,value='None', $
             FONT=info.font, $
             event_pro="select_subsetCB", $
             xsize=20,ysize=20 )

plot_text = ['Click on any subset data to plot or display single variable.', $
	     'If you want to plot more than one variable, use the "Graphic" menu.']

if info.device eq 'X' then xsize=20 else xsize=35
plot_text=widget_text(subset_group, value = plot_text, FONT=info.font, $
		/wrap, xsize=xsize, ysize=4 )

;------------------------
; Output List
;------------------------
output_group=widget_base(layout_widget,column=1,map=1,frame=5)

output_group1=widget_base(output_group, row=1,map=1, $
			event_pro='output_dir')

info.widgets.outputdir = CW_FIELD(output_group1, $
	/STRING, /ROW, XSIZE = 18, YSIZE=1, TITLE = 'OUTPUT: ', $
	VALUE = info.output_path, UVALUE = info, FONT = info.font, $
	FIELDFONT = info.font, /RETURN_EVENTS)

;output_group_title=widget_label(output_group, $
;	FONT=info.font, $
;	/align_left, value="OUTPUT")

output_group2=widget_base(output_group, row=1,map=1, $
			event_pro='output_filter')

info.widgets.filter = CW_FIELD(output_group2, $
	/STRING, /ROW, XSIZE = 11, YSIZE=1, TITLE = 'Exported Data: ', $
	VALUE = info.filter, UVALUE = info, FONT = info.font, $
	FIELDFONT = info.font, /RETURN_EVENTS)

;count = check_directory(info.output_path, info.home_path)
count = check_exist_dir(info.output_path)
if count eq 0 then begin
	message = [ "Your output path is invali!d", info.output_path , $
		"It is set to current directory.", $
		"Use Change Output Path to change the output path."] 
	result=dialog_message( message, title='View HDF Warning!')
	CD, '.', CURRENT=pwd
	info.output_path = pwd
endif
CD, info.output_path, CURRENT=old_dir
output_name_list=findfile(info.filter, count=count)
if count eq 0 then output_name_list = [ 'None' ]

if info.device eq 'X' then ysize=20 else ysize=22
info.widgets.output=widget_list(output_group,value=output_name_list, uvalue=info, $
	FONT=info.font, event_pro="select_output",  xsize=15,ysize=ysize )

CD, old_dir

output_text = 'Click on any data file to display or remove.'

if info.device eq 'X' then xsize=21 else xsize=30
output_text=widget_text(output_group, value = output_text, FONT=info.font, $
	/wrap, xsize=xsize, ysize=1 )

WIDGET_CONTROL, info.base, /REALIZE
;widget_control, info.widgets.screen, set_droplist_select=info.screen.pick
;widget_control, info.widgets.time_type, set_droplist_select=info.time_type.new
widget_control, info.base, set_uvalue=info

count = check_directory(info.temp_dir, info.home_path)
if count eq 0 then begin
	CD, '.', CURRENT=pwd
	;count = check_directory(info.open_path, info.home_path)
	count = check_directory(pwd, info.home_path)
	if count eq 0 then begin
		message = [ "You don't have permission to write in", info.temp_dir , $
		    "You need to choose the other valid directory" ] 
		result=dialog_message( message, title='View HDF Warning!')
		get_temp_directory, info
	endif else begin
		;info.temp_dir = info.open_path
		info.temp_dir = pwd
		if info.device eq 'X' then begin
		   command_line="\rm -f "+ info.temp_dir+"/temp_file.pro"
		endif else begin
		   command_line='del "'+ info.temp_dir+'\temp_file.pro"'
		endelse
		results=''
		spawn,command_line,results
	endelse
endif else begin
	if info.device eq 'X' then begin
	   command_line="\rm -f "+ info.temp_dir+"/temp_file.pro"
	endif else begin
	   command_line='del "'+ info.temp_dir+'\temp_file.pro"'
	endelse
	results=''
	spawn,command_line,results
endelse

if info.device eq 'X' then begin
    command_line="\rm -f "+info.temp_dir+"/."+info.tempname+"_*"
endif else begin
    command_line='del "'+info.temp_dir+'\.'+info.tempname+'_*"'
endelse
spawn,command_line,results

if info.version lt 5.19 and info.library_status eq 0 then begin
    the_message = ['The C shared library is not compatible with your system!', $
	'The unsigned integer types are not supported.', $
	'Result for unsigned integer types may not be corrected.', $
	'THIS IS NOT AND ERROR, JUST A WARNING!']
    result=dialog_message(the_message, title='View HDF Warning!')
endif

if new_flag eq 1 then set_preferences, info.base, info

XMANAGER, 'PDMENU3', info.base

end

;--------------------------------------------------------------------------------
function create_info

pro_name = 'create_info'
@getinfo1

device_name = !D.Name
print,'device name = ',device_name

base_list = widget_base (uvalue = "None", map=0)
widget_control, base_list, /realize

username = ' '
userhome = ' '
if device_name eq 'X' then begin
   username = getenv('USER')
   username = strlowcase(username)
   userhome = getenv('HOME')
endif else begin
   username = getenv('username')
   userhome = 'c:'
endelse
len_username = strlen(username)
if len_username eq 0 or len_username gt 12 then username = 'user'

if device_name eq 'X' then begin
	command_line = "echo `hostname`"
	spawn,command_line,hostname,/sh
endif else begin
	hostname = ' '
	hostname = getenv('HOSTNAME')
	hostname = strlowcase(hostname)
endelse
print,'hostname = ',hostname
hostname=hostname(0)
len_hostname = strlen(hostname)
if len_hostname eq 0 or len_hostname gt 12 then begin
        hostname = getenv('HOST')
        len_hostname = strlen(hostname)
        if len_hostname eq 0 or len_hostname gt 12 then hostname=username
endif
hostname = strlowcase(hostname)
;if strlen(hostname) eq 0 then hostname=username
;hostname = strlowcase(hostname)
print,'hostname = ',hostname

CD, '.', CURRENT = pwd

version_number = !VERSION.RELEASE
ver_num = float(version_number)

;library_name = "ies_bds_rel2.so"
;case hostname of
;  'thunder': pdfreader = "/usr/slocal/acrobat64-3.0/bin/acroread"
;  'lightning': pdfreader = "/usr/slocal/acrobat64-3.0/bin/acroread"
;  'asdsun':  pdfreader = "/usr/slocal/adobe/acrobat-3/bin/acroread"
;  'big_wong': pdfreader = "start acrord32"
;  else:      pdfreader = "acroread"
;endcase
pdfreader = "acroread"

if device_name eq 'X' then begin
   if ver_num lt 5.19 then library_name = "ies_bds_rel2.so" $
	else library_name = "ies_bds_rel2_n32.so"
   if ver_num gt 5.4 then library_name = "ies_bds_rel2_5.5.so"
   if ver_num gt 5.5 then library_name = "ies_bds_rel2_5.6.so"
   default_library = library_name
   textedit = "ieditor"
   spawn, "uname", result, /sh
   result = result(0)
   result = strlowcase(result)
   dot=strpos(result,'sunos')
   if( dot ne -1) then begin
	library_name = "ies_bds_solaris.so"
	textedit = "textedit"
	library_list=findfile('./'+library_name, count=count)
	if count eq 0 then library_name = default_library
   endif
   dot=strpos(result,'solaris')
   if( dot ne -1) then begin
	library_name = "ies_bds_solaris.so"
	textedit = "textedit"
	library_list=findfile('./'+library_name, count=count)
	if count eq 0 then library_name = default_library
   endif
   if library_name eq "ies_bds_solaris.so" and ver_num gt 5.4 then $
	library_name = "ies_bds_solaris_5.5.so"
   ;print,'library_name = ', library_name
   default_editor = 'vi'
   default_editor_type = 0
   top_color = 200
   forecolor = 199L
endif else begin
   pdfreader = "start acrord32"
   textedit = "edit"
   default_editor = 'edit'
   default_editor_type = 3
   library_name = "ies_bds_rel2.dll"
   if ver_num gt 5.4 then library_name = "ies_bds_rel2_5.5.dll"
   if !D.n_colors gt 256 then top_color = 256 $
	else top_color = !D.n_colors
   forecolor = long(top_color-1)
endelse

if device_name eq 'X' then begin
	library_name = PWD +'/'+library_name
endif else begin
	library_name = PWD + '\'+library_name
endelse

library_status = check_library(library_name)

print,'library_name = ',library_name,', library_status = ',library_status

graph_list = [ '2D Graph','2D Image','2D Image With Scale','3D Graph','3D Surface', $
	'Contour','Grid Contour','Grid Contour - Region','Grid Cell', $
	'Grid Cell - Region','Statistics', 'Statistics For Whole Subset','Histogram', $
	'XY Graph','XYZ Graph', '3D Mesh Surface', '3D Color Mesh Graph', 'Geolocated', $
	'Contour Geolocated','Create Subset','Subsampling','Array Average - 2D', 'Array Average', $
	'Regression', 'Extract Bits', 'Browse Image','Browse Image With Average', $
	'Vertical Feature Mask', 'Old Vertical Feature Mask', 'Transpose', $
	'Display Data', 'Display Attribute','Export Data','Export Data Without Filldata', $
	'Change Name', 'Change Data Type','Replace Data Value','Scale Data Value','Remove']

graph_list = graph_list(sort(graph_list))

num_graph_list = n_elements(graph_list)

vdata_max = 5L
sds_rank = 8L

;-----------------------------------------------
; Setup the Subsetting Structure Definition
;-----------------------------------------------

first_record={the_subset_record, $
                        subset_name:    'subset00',             $
                        src_filename:   ' ',                    $
                        src_unitname:   ' ',                    $
                        src_type_flag:  0,                      $
			src_transpose:  0,			$
			src_crit_flag:  0,			$
			src_crit_name:  ' ',			$
			src_crit_min:	' ',			$
			src_crit_max:	' ',			$
			src_crit_type:	' ',			$
			src_num:	0L,			$
			src_ref:	0L,			$
                        src_rank:       0,                      $
                        src_start:      lonarr(sds_rank),       $
                        src_end:        lonarr(sds_rank),       $
                        src_increment:  lonarr(sds_rank),       $
                        src_org_rank:       0,                      $
                        src_org_start:      lonarr(sds_rank),       $
                        src_org_end:        lonarr(sds_rank),       $
                        src_org_increment:  lonarr(sds_rank),       $
                        src_fnames:     strarr(vdata_max),      $
			src_findex:     lonarr(vdata_max),      $
                        src_types:      lonarr(vdata_max),      $
                        src_order:      lonarr(vdata_max),      $
                        src_data:       ptr_new(),        $
                        src_time:       ptr_new()         $
                     }

maximum_subsets=20
max_userdefine=5
if device_name eq 'X' then begin
	font = '-adobe-helvetica-bold-r-normal--14-140-75-75-p-82-iso8859-1'
endif else begin
	font = 'Times New Roman*Bold*18'
endelse

save_list = { $
	subset: { maximum: maximum_subsets,$
		count: 0,$
		selected: 0,$
		data: replicate({the_subset_record},maximum_subsets)},$
		name_list_subset: ['None']}

info = { $

	base: 0L,$	
	list_base: base_list, $
	font: font, $
        current_tool: 'graph',$
	current_printer: 'saihp5m5',$
	current_file: 'None', $
        graph_style: '2D Graph',$
        axis_state: 0,$
	color_bar: 1, $
        precision: 'f18.9',$   
	filldata: 1.0E+35, $
	barlocation: 0.13, $
	tempname: username, $
	home_path: userhome, $
	oldhome_path: userhome, $
	printname: hostname, $
	open_path: pwd, $
	ps_path: pwd, $
	ps_file: 'plot.ps', $
;	eps_path: pwd, $
;	eps_file: 'plot.eps', $
	export_path: pwd, $
	export_file: 'export.dat', $
	hdf_path: pwd, $
	hdf_filename: 'export.hdf', $
	list_path: pwd, $
	output_path: pwd, $
	gif_path: pwd, $
	gif_file: 'plot.gif', $
	png_path: pwd, $
	png_file: 'plot.png', $
	stats_path: pwd, $
	stats_file: 'stats.dat', $
	temp_dir: '/CERES/scratch/idltemp', $
	library: library_name, $
	library_status: library_status, $
	hdf421: 0, $
	pdfread: pdfreader, $
	ieditor: textedit, $
	editor: default_editor, $
	top_color: top_color, $
;	image_order: 0, $
	array_sort: 1, $
;	eps_type: 0, $
	editor_type: default_editor_type, $
	printcommand: '', $
	canceloption: 'No', $
	variablename: '', $
	unitname: '', $
	open_filter: '*', $
	filter: '*.dat', $
	color_table: 39, $
	pick_color_table: 0, $
	bds_file: 0, $
	show_attr: 0, $
	subset_locate: 0, $
	plot_error: 1, $
	device: device_name, $
	version: ver_num, $

        flags: { data_read: 0,$
		 print: 0 },$

	previous_file: { max: 5,$
			 current: '',$
			 store: strarr(5) },$

	open_file: { max: 5,$
			count: 0, $
			file: strarr(5), $
			sds_list: strarr(5), $
			vdata_list: strarr(5), $
			flag: intarr(5), $
			ssf_file: intarr(5), $
			bds_file: intarr(5), $
			ascii_flag: intarr(5), $
			ascii_skip: intarr(5), $
			ascii_heading: intarr(5), $
			ascii_skiphead: intarr(5), $
			ascii_sep: strarr(5), $
			fill_data: fltarr(5), $
			vref: strarr(5), $
			vg_id: strarr(5), $
			vg_name: strarr(5), $
			hdf5_flag: intarr(5), $
			hdf5_g_name: strarr(5), $
			hdf5_sdn_name: strarr(5), $
			hdf5_cdn_name: strarr(5) },$

	ascii_file: { flag: 0,$
		skip_line: 0, $
		num_heading: 1, $
		skip_ahead: 0, $
		sep_char: 'tab', $
		open_path: pwd, $
		unitname: '', $
		output: ptr_new() }, $

	mpeg: { flag: 0,$
		id: obj_new(), $
		winid: 0, $
		frame: 100L, $
		file: '', $
		path: pwd}, $

	eps_out: { type: 0,$
		flag: 0, $
		newsize: 0, $
		title: 0, $
		check: 0, $
		preview: 1, $
		p_xsize: 7.0, $
		p_ysize: 5.40, $
		l_xsize: 9.0, $
		l_ysize: 6.95, $
		file: 'plot.eps', $
		path: pwd}, $

	gif_out: { gif_flag: 0,$
		png_flag: 0, $
		jpg_quality: 75, $
		check_path: pwd}, $

	userdefine: { count: 0,$
		index: 0,$
		max: max_userdefine, $
		old_path: pwd, $
		file: '', $
		num_para: intarr(max_userdefine),$
		path: strarr(max_userdefine), $
		name: strarr(max_userdefine) },$

        sds: { rank: sds_rank,$
	       	     dims: lonarr(8),$
	       	     type: 1L,$
		     ref:  0L,$
	       	     index: 0 },$

	vdata: { max: vdata_max,$
		 nrec: 0L,$
		 ref:  0L,$
		 field_names: '',$
		 name_sel: ''},$

	vfield: { name_sel: '',$
		  indices_sel: [0L]},$

	vgroup: { flag: 0, $
		  nlayer: 0, $
		  base: lonarr(8),$
		  ref:  lonarr(8),$
		  id:   lonarr(8), $
		  vref: '', $
		  sref: '', $
		  name_string: strarr(8), $
		  vg_id: strarr(8), $
		  vg_name: strarr(8)},$

	hdf5: {   exist: 0, $
		  flag: 0, $
		  nlayer: 0, $
		  base: lonarr(8),$
		  ref:  lonarr(8),$
		  id:   lonarr(8), $
		  name_string: strarr(8), $
		  g_name: strarr(8), $
		  sdn_name: strarr(8), $
		  cdn_name: strarr(8)},$

	digital: { name_sel: '',$
		  indices_sel: [0L]},$

	quality: { name_sel: '',$
		  indices_sel: [0L]},$

	subset: { maximum: maximum_subsets,$
		count: 0,$
		selected: 0,$
		data: replicate({the_subset_record},maximum_subsets)},$

	rangetype: { type: 0, $
		     flag: 0, $
		     widget: 0L, $
		     start_rec: 0L, $
		     end_rec: 0L, $
		     get_time: 0, $
		     time_type: 0, $
		     julian: 0.0D, $
		     jul_start:0.0D, $
		     jul_end:0.0D, $
		     old_start: lonarr(sds_rank), $
		     old_end:   lonarr(sds_rank), $
		     old_increment: lonarr(sds_rank), $
		     old_dim: lonarr(sds_rank), $
		     dim_name: strarr(sds_rank), $
		     time: ptr_new()}, $

	multifile: { num_digit: 2, $
		     start_num: 0, $
		     last_num: 23, $
		     skip_num: 1, $
		     skip_data: replicate(1,sds_rank), $
		     has_time: 1, $
		     with_geo: 0, $
		     with_time: 0}, $

	style: { linetype: 0, $
		 symbol:  0, $
		 usersym: 0, $
		 symbolsize: 1.0, $
		 symbolline: 0, $
		 linethick: 1.0, $
		 colorindex: 255, $
		 xlog: 0, $
		 ylog: 0, $
		 y2log: 0, $
		 grid: 0 }, $

	overlay: { flag: 0, $
		 linetype: 0, $
		 symbol:  0, $
		 usersym: 0, $
		 symbolsize: 1.0, $
		 symbolline: 0, $
		 linethick: 1.0, $
		 numcolor: 0, $
		 range: 0, $
		 zmax: 0.0, $
		 zmin: 0.0, $
		 colorindex: !P.COLOR, $
		 image: ptr_new(), $
		 xindex: 0, $
		 yindex: 0, $
		 zindex: 0, $
		 offflag: 0, $
		 offbase: 0L, $
		 offreset: 0, $
		 long_offset: 0.0, $
		 long_delt: 0.01, $
		 lat_offset: 0.0, $
		 lat_delt: 0.01 }, $

	char: { size: 1.0, $
		sgi: 0, $
		font: -1, $
		fontname: '', $
		fontsize: 12, $
		spacesize: 12 }, $

	xyvalue: { x_index: ptr_new(), $
		   y_index: ptr_new() }, $

	geolocated: {	flag: 0, $
			filename:   ' ',                    $
			starting: 0L, $
			ending: 0L, $
			increment: 0L, $
			selected: 0, $
			long_index: 0, $
			hdf_z: ptr_new(), $
			colat: ptr_new(), $
			long: ptr_new(), $
			sate_colat: ptr_new(), $
			sate_long: ptr_new(), $
			sun_colat: ptr_new(), $
			sun_long: ptr_new(), $
			temp_colat: ptr_new(), $
			temp_long: ptr_new(), $
			temp_sate_colat: ptr_new(), $
			temp_sate_long: ptr_new(), $
			temp_sun_colat: ptr_new(), $
			temp_sun_long: ptr_new() }, $

	geo_name: {	long: 'None' , $
			colat: 'None', $
			lat: 'None', $
			satelong: 'None', $
			satecol: 'None', $
			satelat: 'None', $
			sunlong: 'None', $
			suncol: 'None', $
			sunlat: 'None' }, $

	geo_widgets: {	long_field: 0L , $
			col_field: 0L, $
			lat_field: 0L,  $
			satelong_field: 0L, $
			satecol_field: 0L, $
			satelat_field: 0L, $
			sunlong_field: 0L, $
			suncol_field: 0L, $
			sunlat_field: 0L }, $

	greenwich: {	greenloca: 0.0, $
			lat_loc: 0.0, $
			projection: 0, $
			default: 1, $
			label: 1, $
			whole: 0, $
			with_level: 0, $
			ext_level: 0, $
			n_level: 10, $
			in_level: 0, $
			barsize: 0.011, $
			setformat: 0, $
			bformat: 'f8.1',$
			colborder: 1, $
			displaybad: 1, $
			baddata: !P.BACKGROUND, $
			range: '', $
			expand: 1, $
			satellite: 1, $
			sun: 1, $
			smooth: 1, $
			n_x_grid: 360, $
                        n_y_grid: 180, $
			noborder: 0, $
			contour: 0, $
			altitude: 2.0, $
			rotation: 0.0, $
			tilt: 0.0, $
			grid: 1, $
			glinethick: 1.0, $
			mlinethick: 1.0, $
			high_resol: 1, $
			coasts:	1, $
			continents: 0 }, $

	grid_start: {   long: 500.0, $
			lat: 0 }, $

	sview: {	long: [0.0 , 360.0], $
			lat: [-90.0, 90.0], $
			xsize: 768, $
			ysize: 384, $
			ratio: 3, $
			window_id: 0, $
			map_old: !MAP, $
			p_old: !P, $
			x_old: !X, $
			y_old: !Y }, $

	view: {		p_old: !P, $
			d_old: !D, $
			x_old: !X, $
			y_old: !Y }, $

	time_type: {	old: 2, $
			new: 2 }, $

	widgets: { current_file: 0L,$
			axis_tool: 0L,$
			graph_button: 0L,$
			sds: 0L,$
                        vdata: 0L,$
			subset_name: 0L,$
			subset_list: 0L,$
			output: 0L, $
			changeopath: 0L, $
			changeopen: 0L, $
			printcommand: 0L, $
			variablename: 0L, $
			gettempdir: 0L, $
			colortable: 0L, $
        		starting_field: lonarr(sds_rank),$
        		ending_field: lonarr(sds_rank),$
        		increment_field: lonarr(sds_rank),$
			start_time: 0L, $
			end_time: 0L, $
			julian_start: 0L, $
			julian_end: 0L, $
			c_min: 0L, $
			c_max: 0L, $
			start_bit: 0L, $
			num_bit: 0L, $
			x_start: 0L,$
                        x_end: 0L,$
                        y_start: 0L,$
                        y_end: 0L,$
                        z_start: 0L,$
                        z_end: 0L,$
			y2_start: 0L, $
			y2_end: 0L, $
			precision: 0L, $
			filldata: 0L, $
			openfilter: 0L, $
			filter: 0L, $
			outputdir: 0L, $
			rotateax: 0L, $
			rotateaz: 0L, $
			background: 0L, $
			foreground: forecolor, $
			screen: 0L, $
			screen_size_tool: 0L, $
			time_type: 0L, $
			show_time_list: 0L, $
			;criterion: 0L, $
			location: 0L, $
			sxsize: 0L, $
			sysize: 0L, $
			charsize: 0L, $
			sview_xsize: 0L, $
			sview_ysize: 0L, $
			sview_ratio: 0L, $
			barlocation: 0L, $
			numlevel: 0L, $
			symbolsize: 0L, $
			greenlocation: 0L, $
			gridstart: 0L, $
			base: 0L, $
			stop: 0L, $
			pause: 0L, $
			rangefield: 0L, $
			startslide: 0L, $
			startfield: 0L, $
			show_subset: 0L, $
			subset_base: 0L, $
			cons_value: 0L, $
			xfield: 0L, $
			yfield: 0L, $
			zfield: 0L },$

          field_name:{ x:'None',$
                       y:'None',$
                       z:'None'},$

	screen:{ pick:0, $
		 new:0, $
		 xsize:1024, $
		 ysize:600 }, $
 
	menu_order:{ flag:0, $
		name:graph_list, $
		pick:replicate(0,num_graph_list), $
		select:'' }, $

	rotate:{ ax:30, $
		 az:20 }, $
 
	d2_image:{ image_order:0, $
		   colorbar:0, $
		   yoffset:0.15, $
		   deltx:0.44, $
		   delty:0.022, $
		   bar_offset:0.038 }, $
 
	range:{ x_start:0.0,$
 		x_end: 500.0,$
		y_start: 0.0,$
		y_end: 500.0,$
		z_start: 0.0,$
		z_end: 500.0,$
		y2_start: 0.0,$
		y2_end: 500.0,$
		real_y_end: 1.0},$

	slide:{ select:0, $
		x_start:0.0, $
		x_end:500.0, $
		y_start:0.0, $
		y_end: 500.0}, $

	save:{	axis_state: 0, $
		x_start: 0.0, $
		x_end: 500.0, $
		y_start: 0.0, $
		y_end: 500.0}, $

	criterion:{	flag: 0, $
			type: 0, $
			index: 0, $
			name: 'None', $
			max: 0.0, $
			min: 0.0}, $

	replace:{	type: 0, $
			w_min: 0L, $
			w_max: 0L, $
			w_val: 0L, $
			max: 0.0, $
			min: 0.0, $
			val: 0.0}, $

	scaledata:{	flag: 0, $
			auto: 0, $
			type: 0, $
			eq_num: 0, $
			vscale: 1.0D, $
			voffset: 0.0D, $
			nscale: '', $
			noffset: ''}, $

	addtext:{	flag: 0, $
			key: 0, $
			xloc: 0.0, $
			yloc: 0.0, $
			charsize: '', $
			text: '', $
			x_loc: '', $
			y_loc: '', $
			temp_charsize: '', $
			temp_text: '', $
			temp_x_loc: '', $
			temp_y_loc: ''}, $

	browse_image:{  base: 0L, $
			type: 0, $
			btype: 0, $
			rtype: 0, $
			utype: 0, $
			ytype: 0, $
			feature: 0, $
			xwidget: 0L, $
			pwidget: 0L, $
			twidget: 0L, $
			rwidget: 0L, $
			xswidget: 0L, $
			xewidget: 0L, $
			yswidget: 0L, $
			yewidget: 0L, $
			linewidget: 0L, $
			xstart: 0.0, $
			xend: 0.0, $
			ystart: 0.0, $
			yend: 0.0, $
			range: 0, $
			window_id: 0, $
			number: 0, $
			max_num: 10, $
			findex: -1, $
			xindex: -1, $
			scale: 1.0, $
			xvalue: 0.0, $
			pvalue: 0L, $
			npvalue: 0L, $
			line: 0.0, $
			threflag: 1, $
			lineflag: 1, $
			profile: 'full', $
			rootname: '', $
			proscale: 1, $
			shotscale: 3, $
			swift: 0.0, $
			pindex: 0, $
			saveimage: 0, $
			useprofile: 0, $
			colorint: 0, $
			setfcolor: 0, $
			xlocat: 0.045, $
			xformat: 'f8.1',$
			farray: intarr(10), $
			image: ptr_new(), $
			xarray: ptr_new(), $
			yarray: ptr_new(), $
			tarray: ptr_new(), $
			barray: ptr_new(), $
			aarray: ptr_new(), $
			parray: ptr_new(), $
			x: ptr_new(), $
			y: ptr_new(), $
			z: ptr_new() }, $

	vfm:{	type: 0, $
		feature: 8, $
		major: 1, $
		auto: 0, $
		fmax: 7, $
		fmin: 0, $
		usesubset: 0, $
		xtitle: -1, $
		xlocat: 0.045, $
		xformat: 'f8.1',$
		data: ptr_new() }, $

	average:{	row_flag: 1, $
			row_value: 1, $
			row_first: 1, $
			col_flag: 0, $
			col_value: 0, $
			col_first: 0, $
			contain_fill: 0 }, $

	text_widgets:{	text: 0L, $
			size: 0L, $
			add: 0L, $
			clear: 0L, $
			next: 0L, $
			remove: 0L}, $

	bit:{	index: 0, $
		name: 'None', $
		start_bit: 0, $
		num_bit: 0}, $

	histogram:{  binsize: 10.0, $
		     max: 0.0, $
		     min: 0.0, $
		     binwidget: 0L, $
		     maxwidget: 0L, $
		     minwidget: 0L}, $

	curvefit:{  type: 0, $
		    coeff: 0, $
		    data: .0, $
		    result: 0, $
		    error: 0, $
		    display: 0, $
		    points: 100}, $

	region:{  index: 0, $
		  size: 0.0, $
		  sizewidget: 0L}, $

	out: { pick:replicate(0,maximum_subsets),$
	       x_index:0, $
               increment:0},$

	ssf: {	file: 0, $
		key: 0, $
		select: 0L, $
		layer: 0L},  $

	y1y2: {	cons_value1: 0.0D, $
		cons_value2: 0.0D,  $
		tri_flag: 0, $
		out_flag: 0, $
		operator: ' - ' }, $

	multiple: { flag: 0, $
		    key: 0,  $
		    y1y2: 0, $
		    xy_diff: 'Sample', $
		    number: 0, $
		    styleflag: 0, $
		    resetflag: 0, $
		    linearray: intarr(maximum_subsets), $
		    symarray: intarr(maximum_subsets), $
		    symlinearray:  intarr(maximum_subsets), $
		    colorarray: intarr(maximum_subsets), $
		    colorindex: !P.COLOR, $
		    linetype: 0, $
		    symbol:  0, $
		    symbolsize: 1.0, $
		    symbolline: 0 }, $

	name_list_vdata: ['None'],$
	name_list_vfield: ['None'],$
	name_list_sds: ['None'],$
	name_list_vg: ['None'], $
	name_list_vg1: ['None'], $
	name_list_ssf: ['None'],$
	name_list_units: ['None'], $
	name_list_indep: ['None'], $
	name_list_userdefine: ['None'], $
	name_list_subset: ['None']}

widget_control, set_uvalue=save_list, info.list_base

return, info

end

;--------------------------------------------------------------------------------
function redefine_info, info, new_name, flag

pro_name = 'redefine_info'
@getinfo1

name_list_vdata = info.name_list_vdata
name_list_vfield = info.name_list_vfield
name_list_sds = info.name_list_sds
name_list_vg = info.name_list_vg
name_list_vg1 = info.name_list_vg1
name_list_ssf = info.name_list_ssf
name_list_units = info.name_list_units
name_list_indep = info.name_list_indep
name_list_userdefine = info.name_list_userdefine
name_list_subset = info.name_list_subset

CASE flag of

	0: begin
		;if (name_list_vdata(0) eq 'None') then name_list_vdata=$
		;new_name else name_list_vdata = [name_list_vdata, new_name]
		name_list_vdata = new_name
	end
	1: begin
		;new_name else name_list_vfield = [name_list_vfield, new_name]
		name_list_vfield=new_name
	end
	2: begin
		;if (name_list_sds(0) eq 'None') then name_list_sds=$
		;new_name else name_list_sds = [name_list_sds, new_name]
		name_list_sds = new_name
	end
	3: begin
		if (name_list_subset(0) eq 'None') then name_list_subset=$
		new_name else name_list_subset = [name_list_subset, new_name]
	end
	4: begin
		name_list_subset = new_name
	end
	5: begin
		name_list_sds = new_name
		name_list_vdata = new_name
		name_list_vfield = new_name
		name_list_vg = new_name
		name_list_vg1 = new_name
		name_list_ssf = new_name
		name_list_units = new_name
	end
	6: begin
		name_list_ssf = new_name
	end
	7: begin
		name_list_units = new_name
	end
	8: begin
		name_list_indep = new_name
	end
	9: begin
		name_list_vg = new_name
	end
	10: begin
		name_list_vg1 = new_name
	end
	11: begin
		if (name_list_userdefine(0) eq 'None') then name_list_userdefine=$
		new_name else name_list_userdefine = [name_list_userdefine, new_name]
	end
	12: begin
		name_list_userdefine = new_name
	end
	else:
ENDCASE

info = { $

	base: info.base,$	
	list_base: info.list_base, $
	font: info.font, $
        current_tool: info.current_tool,$
	current_printer: info.current_printer,$
	current_file: info.current_file,$
        graph_style: info.graph_style,$
        axis_state: info.axis_state,$
	color_bar: info.color_bar, $
        precision: info.precision,$   
        filldata: info.filldata,$   
        barlocation: info.barlocation,$   
	tempname: info.tempname, $
	home_path: info.home_path, $
	oldhome_path: info.oldhome_path, $
	printname: info.printname, $
	open_path: info.open_path, $
	ps_path: info.ps_path, $
	ps_file: info.ps_file, $
;	eps_path: info.eps_path, $
;	eps_file: info.eps_file, $
	export_path: info.export_path, $
	export_file: info.export_file, $
	hdf_path: info.hdf_path, $
	hdf_filename: info.hdf_filename, $
	list_path: info.list_path, $
	output_path: info.output_path, $
	gif_path: info.gif_path, $
	gif_file: info.gif_file, $
	png_path: info.png_path, $
	png_file: info.png_file, $
	stats_path: info.stats_path, $
	stats_file: info.stats_file, $
	temp_dir: info.temp_dir, $
	library: info.library, $
	library_status: info.library_status, $
	hdf421: info.hdf421, $
	pdfread: info.pdfread, $
	ieditor: info.ieditor, $
	editor: info.editor, $
	top_color: info.top_color, $
;	image_order: info.image_order, $
	array_sort: info.array_sort, $
;	eps_type: info.eps_type, $
	editor_type: info.editor_type, $
	printcommand: info.printcommand, $
	canceloption: info.canceloption, $
	variablename: info.variablename, $
	unitname: info.unitname, $
	open_filter: info.open_filter, $
	filter: info.filter, $
	color_table: info.color_table, $
	pick_color_table: info.pick_color_table, $
	bds_file: info.bds_file, $
	grid_start: info.grid_start, $
	show_attr:  info.show_attr, $
	subset_locate:  info.subset_locate, $
	plot_error:  info.plot_error, $
	device: info.device, $
	version:  info.version, $

        flags: info.flags,$

	previous_file: info.previous_file, $

	open_file: info.open_file, $

	ascii_file: info.ascii_file, $

	mpeg: info.mpeg, $

	eps_out: info.eps_out, $

	gif_out: info.gif_out, $

	userdefine: info.userdefine, $

        sds: info.sds,$

	vdata: info.vdata,$

	vfield: info.vfield,$

	vgroup: info.vgroup,$

	hdf5: info.hdf5,$

	digital: info.digital,$

	quality: info.quality,$

	subset: info.subset,$ 

	rangetype: info.rangetype, $

	multifile: info.multifile, $

	style: info.style, $

	overlay: info.overlay, $

	char: info.char, $

	xyvalue: info.xyvalue,$ 

	geolocated: info.geolocated,$ 

	geo_name: info.geo_name, $
	
	geo_widgets: info.geo_widgets, $

	greenwich: info.greenwich,$ 

	sview: info.sview,$ 

	view: info.view,$ 

	time_type: info.time_type, $

	widgets: info.widgets,$ 

	field_name: info.field_name,$ 

	screen: info.screen, $

	menu_order: info.menu_order, $

	rotate: info.rotate, $

	d2_image: info.d2_image, $

	range: info.range,$

	slide: info.slide, $

	save: info.save, $

	criterion: info.criterion, $

	replace: info.replace, $

	scaledata: info.scaledata, $

	addtext: info.addtext, $

	browse_image: info.browse_image, $

	vfm: info.vfm, $

	average: info.average, $

	text_widgets: info.text_widgets, $

	bit: info.bit, $

	histogram: info.histogram, $

	curvefit:  info.curvefit, $

	region: info.region, $

	out: info.out,$

	ssf: info.ssf,$

	y1y2: info.y1y2, $

	multiple: info.multiple, $

	name_list_vdata: name_list_vdata,$
	name_list_vfield: name_list_vfield,$
	name_list_sds: name_list_sds,$
	name_list_vg: name_list_vg, $
	name_list_vg1: name_list_vg1, $
	name_list_ssf: name_list_ssf,$
	name_list_units: name_list_units,$
	name_list_indep: name_list_indep,$
	name_list_userdefine: name_list_userdefine,$
	name_list_subset: name_list_subset }


return, info

end

;--------------------------------------------------------------------------------
function redefine_save_list, info

pro_name = 'redefine_save_list'
@getinfo1

save_list = { $
	subset: info.subset,$
	name_list_subset: info.name_list_subset }

return,save_list

end

;------------------------------------------------------------------
pro create_curve_fields, x_field, y_field, z_field, x_group, y_group, $
z_group, xflag, yflag, zflag, type_flag, info

pro_name = 'create_curve_fields'
@getinfo
 
font1=info.font

if (xflag gt 0) then begin

	x_field= CW_FIELD( x_group, VALUE=info.field_name.x, $
        ROW=1, STRING=1, FIELDFONT= font1, FONT= font1, $
        TITLE='X Field:', XSIZE=40, /noedit)
	
	info.widgets.xfield= x_field
endif


if (yflag gt 0) then begin

	y_field= CW_FIELD( y_group, VALUE=info.field_name.y, $
        ROW=1, STRING=1, FIELDFONT= font1, FONT= font1, $
        TITLE='Y Field:', XSIZE=40, /noedit)

	info.widgets.yfield = y_field
endif

if (zflag gt 0) then begin

	if type_flag eq 0 then begin
	    title = 'Degree of Polynomial:'
	    i_value = '1'
	endif else begin
	    title = 'Intercept Value:'
	    i_value = '0.0'
	endelse
	z_field= CW_FIELD( z_group, VALUE=i_value, $
        ROW=1, STRING=1, FIELDFONT= font1, FONT= font1, $
        TITLE=title, XSIZE=10, /return_event) 

	info.widgets.zfield =z_field
endif

  widget_control, set_uvalue=info, info.base
end

;------------------------------------------------------------------
pro create_xyz_fields, x_field, y_field, z_field, x_group, y_group, z_group,$
xflag, yflag, zflag, info

pro_name = 'create_xyz_fields'
@getinfo
 
font1=info.font

if (xflag gt 0) then begin

	x_field= CW_FIELD( x_group, VALUE=info.field_name.x, $
        ROW=1, STRING=1, FIELDFONT= font1, FONT= font1, $
        TITLE='X Field:', XSIZE=40, /noedit)
	
	info.widgets.xfield= x_field
endif


if (yflag gt 0) then begin

	y_field= CW_FIELD( y_group, VALUE=info.field_name.y, $
        ROW=1, STRING=1, FIELDFONT= font1, FONT= font1, $
        TITLE='Y Field:', XSIZE=40, /noedit)

	info.widgets.yfield = y_field
endif

if (zflag gt 0) then begin

	z_field= CW_FIELD( z_group, VALUE=info.field_name.z, $
        ROW=1, STRING=1, FIELDFONT= font1, FONT= font1, $
        TITLE='Z Field:', XSIZE=40, /noedit) 

	info.widgets.zfield =z_field
endif

  widget_control, set_uvalue=info, info.base
end

;------------------------------------------------------------------
pro create_rgb_fields, x_field, y_field, z_field, x_group, y_group, z_group,$
xflag, yflag, zflag, info

pro_name = 'create_rgb_fields'
@getinfo
 
;font1 = '-adobe-helvetica-bold-o-normal--14-140-75-75-p-82-iso8859-1'
font1=info.font

if (xflag gt 0) then begin

	x_field= CW_FIELD( x_group, VALUE=info.field_name.x, $
        ROW=1, STRING=1, FIELDFONT= font1, FONT= font1, $
        TITLE='Red Field:', XSIZE=40, /noedit)
	
	info.widgets.xfield= x_field
endif


if (yflag gt 0) then begin

	y_field= CW_FIELD( y_group, VALUE=info.field_name.y, $
        ROW=1, STRING=1, FIELDFONT= font1, FONT= font1, $
        TITLE='Green Field:', XSIZE=40, /noedit)

	info.widgets.yfield = y_field
endif

if (zflag gt 0) then begin

	z_field= CW_FIELD( z_group, VALUE=info.field_name.z, $
        ROW=1, STRING=1, FIELDFONT= font1, FONT= font1, $
        TITLE='Blue Field:', XSIZE=40, /noedit) 

	info.widgets.zfield =z_field
endif

  widget_control, set_uvalue=info, info.base
end

;------------------------------------------------------------------
pro create_y1y2_fields, x_field, y_field, x_group, y_group, xflag, yflag, info

pro_name = 'create_y1y2_fields'
@getinfo
 
font1=info.font

if (xflag gt 0) then begin

	cons_id = 1
	x_value = ''
	if info.field_name.x eq "Constant" then $
	   x_value = string(info.y1y2.cons_value1) $
	else x_value = info.field_name.x
	x_field= CW_FIELD( x_group, VALUE=x_value, $
        ROW=1, STRING=1, FIELDFONT= font1, FONT= font1, $
        TITLE='Y1 Field:', XSIZE=40, uvalue=cons_id, /return_event)
	
	info.widgets.xfield= x_field
endif


if (yflag gt 0) then begin

	cons_id = 2
	y_value = ''
	if info.field_name.y eq "Constant" then $
	  y_value = string(info.y1y2.cons_value2) $
	else y_value = info.field_name.y
	y_field= CW_FIELD( y_group, VALUE=y_value, $
        ROW=1, STRING=1, FIELDFONT= font1, FONT= font1, $
        TITLE='Y2 Field:', XSIZE=40, uvalue=cons_id, /return_event)

	info.widgets.yfield = y_field
endif

  widget_control, set_uvalue=info, info.base
end

;------------------------------------------------------------------
pro create_y1tri_fields, x_field, y_field, x_group, y_group, xflag, yflag, $
	info, t1_group, t2_group

pro_name = 'create_y1tri_fields'
@getinfo
 
if !D.Name eq 'X' then begin
   font1='-adobe-helvetica-bold-o-normal--14-140-75-75-p-82-iso8859-1'
endif else begin
   font1 = 'Times New Roman*Bold*18'
endelse

if (xflag gt 0) then begin

	cons_id = 1
	x_value = ''
	if info.field_name.x eq "Constant" then $
	   x_value = string(info.y1y2.cons_value1) $
	else x_value = info.field_name.x
	x_field= CW_FIELD( x_group, VALUE=x_value, $
        ROW=1, STRING=1, FIELDFONT= font1, FONT= font1, $
        TITLE='Y1 Field:', XSIZE=40, uvalue=cons_id, /return_event)
	
	info.widgets.xfield= x_field
endif

text1 = ' '
text1id=widget_label(t1_group, value = text1, /ALIGN_CENTER, FONT=font1)
text2 = 'Select Constant option to set Y2 = 0 for degree or Y2 = 1 for radian'
text2id=widget_label(t2_group, value = text2, /ALIGN_CENTER, FONT=font1)

if (yflag gt 0) then begin

	cons_id = 2
	y_value = ''
	info.field_name.y = "Constant" 
	if info.y1y2.cons_value2 lt 0 or info.y1y2.cons_value2 gt 1 then $
		info.y1y2.cons_value2 = 0
	y_value = string(info.y1y2.cons_value2) 
	y_field= CW_FIELD( y_group, VALUE=y_value, $
        ROW=1, STRING=1, FIELDFONT= font1, FONT= font1, $
        TITLE='Y2 Field:', XSIZE=40, uvalue=cons_id, /return_event)

	info.widgets.yfield = y_field
endif

  widget_control, set_uvalue=info, info.base
end

;------------------------------------------------------------------
pro create_grid_data, hdf_data_x, hdf_data_y, hdf_data_z, gridspace, gridlimit, $
    filldata_value, gridlon, gridlat, griddata1

pro_name = 'create_grid_data'
@getinfo
 
long_min = gridlimit(0)
lat_min = gridlimit(1)
long_max = gridlimit(2)
lat_max = gridlimit(3)

long_space = gridspace(0)
lat_space = gridspace(1)


num_long = long((long_max - long_min)/long_space + 1.0009)
num_lat = long((lat_max - lat_min)/lat_space + 1.0009)

long_array = long((hdf_data_x - long_min)/long_space + 0.00009) - 1
lat_array = long((hdf_data_y - lat_min)/lat_space + 0.00009) - 1
subscripts = where(long_array lt 0, count)
if count ne 0 then long_array(subscripts) = 0
subscripts = where(lat_array lt 0, count)
if count ne 0 then lat_array(subscripts) = 0

gridlon = findgen(num_long-1) * long_space + long_min + 0.5*long_space
gridlat = findgen(num_lat-1) * lat_space + lat_min + 0.5*lat_space

griddata1 = make_array(num_long-1, num_lat-1, /double, value=0)
num_point = make_array(num_long-1, num_lat-1, /long, value=0)

num_elem = n_elements(hdf_data_z)

for i = 0L, num_elem-1 do begin
	griddata1(long_array(i), lat_array(i)) = griddata1(long_array(i), lat_array(i)) + $
		hdf_data_z(i)
	num_point(long_array(i), lat_array(i)) = num_point(long_array(i), lat_array(i)) + 1
endfor

subscripts = where(num_point gt 0, count)
if count ne 0 then begin
	griddata1(subscripts) = griddata1(subscripts)/num_point(subscripts)
endif else begin
	griddata1(*,*) = filldata_value
	return
endelse

subscripts = where(num_point eq 0, count)
if count ne 0 then griddata1(subscripts) = filldata_value

end

;--------------------------------------------------------------------------------
function make_second_time, time

pro_name = 'make_second_time'
@getinfo1

time = time(0)
timearray = str_sep(time, ':')
n_timearray = n_elements(timearray)
case n_timearray of
   1: begin
	hours = 0
	minutes = 0
	seconds = long(timearray(0))
      end
   2: begin
	hours = 0
	minutes = long(timearray(0))
	seconds = long(timearray(1))
      end
   3: begin
	hours = long(timearray(0))
	minutes = long(timearray(1))
	seconds = long(timearray(2))
      end
   else: begin
	message=['Cannot interpret time format!', $
		 'The right format is hh:mm:ss or,', $
		 '                       mm:ss or,', $
		 '                          ss']
	result=dialog_message(message, title='View HDF Warning!')
		return, -1
      end

endcase
   
result = long(1)
result = hours * 3600 + minutes * 60 + seconds
return, result

end

;--------------------------------------------------------------------------------
pro clear_geo_field, event

pro_name = 'clear_geo_field'
@getinfo

widget_control, get_uvalue=info, event.top
widget_control, get_uvalue=info, info.base 

field_name = 'None'

info.geo_name.long = field_name
widget_control, info.geo_widgets.long_field, set_value=field_name

info.geo_name.colat = field_name
widget_control, info.geo_widgets.col_field, set_value=field_name

info.geo_name.lat = field_name
widget_control, info.geo_widgets.lat_field, set_value=field_name

info.geo_name.satelong = field_name
widget_control, info.geo_widgets.satelong_field, set_value=field_name

info.geo_name.satecol = field_name
widget_control, info.geo_widgets.satecol_field, set_value=field_name

info.geo_name.satelat = field_name
widget_control, info.geo_widgets.satelat_field, set_value=field_name

info.geo_name.sunlong = field_name
widget_control, info.geo_widgets.sunlong_field, set_value=field_name

info.geo_name.suncol = field_name
widget_control, info.geo_widgets.suncol_field, set_value=field_name

info.geo_name.sunlat = field_name
widget_control, info.geo_widgets.sunlat_field, set_value=field_name

widget_control, set_uvalue=info, info.base

end

;------------------------------------------------------------------
function get_image, r1, g1, b1

pro_name = 'get_image'
@getinfo1

device, get_visual_depth = thisDepth

if thisDepth gt 8 then begin
    device, decomposed=1
    snapshot = TVRD(True=1)
    device, decomposed=0
    image2d = color_quan(snapshot, 1, r1,g1,b1,colors=256, /Dither)
endif else begin
    tvlct,r1,g1,b1,/get
    image2d = TVRD()
endelse

return, image2d

end

;------------------------------------------------------------------
function get_image24

pro_name = 'get_image24'
@getinfo1

device, get_visual_depth = thisDepth

if thisDepth gt 8 then begin
    device, decomposed=1
    image2d = TVRD(True=1)
    device, decomposed=0
endif else begin
    image2d = TVRD()
endelse

return, image2d

end

;------------------------------------------------------------------
function convert_image24_image8

pro_name = 'convert_image24_image8'
@getinfo1

widget_control, /hourglass

imagech1 = tvrd(channel=1)
imagech2 = tvrd(channel=2)
imagech3 = tvrd(channel=3)
size_image = size(imagech1)
num_pixel = n_elements(imagech1)
imagech1 = reform(imagech1, num_pixel)
imagech2 = reform(imagech2, num_pixel)
imagech3 = reform(imagech3, num_pixel)
image2d = make_array(num_pixel, /long, value=0L)
image_temp = long(imagech1) + (long(imagech2)*256L) + (long(imagech3)*256L^2)
tvlct, rcol, gcol, bcol, /get
pcol = long(rcol) + (long(gcol)*256L) + (long(bcol)*256L^2)
num_color = n_elements(pcol)
for i=0L, num_color-1 do begin
    sub_col = where(image_temp eq pcol(i), count)
    ;print,'number of color ',i,': ',pcol(i),' is ',count, ': ',rcol(i),', ',gcol(i),', ',bcol(i)
    if count ne 0 then image2d(sub_col) = i
endfor
image2d = byte(image2d)
image2d = reform(image2d, size_image(1), size_image(2))

return,image2d

end

;------------------------------------------------------------------
function get_num_decimal, label

pro_name = 'get_num_decimal'
@getinfo1

if label eq 0 then return, 1
label_temp = abs(label)

;  Try to use mulitpy by 10, 100, 1000, 10000
if label_temp * 10 gt 1 then begin
    num_decimal = 1
endif else if label_temp * 100 gt 1 then begin
    num_decimal = 2
endif else if label_temp * 1000 gt 1 then begin
    num_decimal = 3
endif else if label_temp * 10000 gt 1 then begin
    num_decimal = 4
endif else num_decimal = 5

return, num_decimal

end

;------------------------------------------------------------------
function check_exp_string, label_string

pro_name = 'check_exp_string'
@getinfoa

eloc = strpos(label_string,'e')
celoc = strpos(label_string,'E')

;  If it is in exponential notation, try to remove the front 0s
if eloc ne -1 or celoc ne -1 then begin
    if eloc ne -1 then loc = eloc else loc = celoc

    length = strlen(label_string)

    ;  Search the '-' or '+' sign
    eloc = strpos(label_string,'-',loc)
    celoc = strpos(label_string,'+',loc)
    sloc = loc
    if eloc ne -1 then sloc = eloc
    if celoc ne -1 then sloc = celoc

    ;  sloc cannot smaller than the loc
    if sloc ge loc then begin
	eloc = sloc
	loc = strpos(label_string,'0',eloc)
	while loc ne -1 do begin
	    eloc = loc + 1
	    loc = strpos(label_string,'0',eloc)
	endwhile

	celoc = eloc
	;  if celoc equal to sloc, there is no zero existed
	if celoc eq sloc then celoc = celoc + 1
	s_len = sloc+1
	e_len = length - eloc

	;  now remove the string
	temp_string = strmid(label_string, 0, s_len) + $
	    strmid(label_string, celoc, e_len)
	label_string = temp_string
    endif
endif

return,label_string

end

;------------------------------------------------------------------
function get_label_string, inlabel, setformat, bformat, num_decimal, $
    y_delta

pro_name = 'get_label_string'
@getinfoa

;  if setformat eq 1, use user defines format
if setformat eq 1 then begin
    out_format = '('+bformat+')'
    label_string = strtrim(string(inlabel, format=out_format), 2)
    temp_label = check_exp_string(label_string)
    ; return, label_string
    return, temp_label
endif

; otherwise set label string
;  Add a small amount for float number
if inlabel ne 0.0 then label = inlabel + 0.0000005 else label = inlabel

;  if y_delta is larger than 100 and inlabel great that 0, make it as integer
if y_delta gt 100.0 and label gt 0.0 then label = round(label)

;  Set the max and min: win E with 3 digits
if !D.Name ne 'WIN' then begin
    max_value = 100000.0
    min_value = 0.0001
endif else begin
    max_value = 1000000.0
    min_value = 0.00001
endelse

if (abs(label) lt min_value and label ne 0.0) then begin
    if y_delta lt min_value then begin
	label_string = strtrim(string(label, format='(E10.3)'), 2)
    endif else if y_delta lt min_value*10 then begin
	label_string = strtrim(string(label, format='(E10.2)'), 2)
    endif else label_string = strtrim(string(label, format='(E10.1)'), 2)
endif else if abs(label) gt max_value then begin
    if y_delta lt max_value/100 then begin
	label_string = strtrim(string(label, format='(E10.3)'), 2)
    endif else if y_delta lt max_value/10 then begin
	label_string = strtrim(string(label, format='(E10.2)'), 2)
    endif else label_string = strtrim(string(label, format='(E10.1)'), 2)
endif else begin
    label_string = strcompress(string(label),/remove_all)
    loc = strpos(label_string,'.')
    if loc ne -1 then begin
	eloc = strpos(label_string,'e')
	celoc = strpos(label_string,'E')
	if eloc eq -1 and celoc eq -1 then begin
	    length = strlen(label_string)
	    num_characters = loc+num_decimal+1
	    if num_characters lt length then begin
		label_string = strmid(label_string, 0, num_characters)
		flength = strlen(label_string)
		rloc = rstrpos(label_string,'0')
		rploc = rstrpos(label_string,'.')
		if rloc eq flength-1 and rploc eq flength-2 then begin
		    label_string = strmid(label_string, 0, flength-2)
		endif else if rloc eq flength-1 then begin
		    label_string = strmid(label_string, 0, flength-1)
		endif
	    endif
	endif else begin
	    label_string = strtrim(string(label, format='(e10.3)'), 2)
	endelse
    endif

    if strlen(label_string) gt 10 then begin
	label_string = strtrim(string(label, format='(E10.3)'), 2)
    endif
endelse

temp_label = check_exp_string(label_string)

; return, label_string
return, temp_label

end

;------------------------------------------------------------------
function get_instrument_id, info

pro_name = 'get_instrument_id'
@getinfo1
 
widget_control,info.widgets.current_file,get_value=filename
filename = filename(0)


result = where(info.name_list_vdata eq 'Converted Digital Data' or $
	info.name_list_vdata eq 'Converted Instrument Status Data', count)
if count ne 0 then begin

    the_vdata_name = ''
    the_vdata_name = info.name_list_vdata(result)

    number_of_fields=0L

    CD, '.', CURRENT = PWD


    ;the_result = CALL_EXTERNAL(PWD+'/' + info.library, $
;    the_result = CALL_EXTERNAL(info.library, $
;			'get_vdata_fields',  		$
;                	filename,			$
;			the_vdata_name,			$
;			number_of_fields,		$
;			/s_value)

    num_vdata = 1
    the_result = get_vdata_fields(filename,the_vdata_name,number_of_fields,num_vdata,$
	vdata_ref, the_nrec)

    if the_result ne "BAD" then begin
    
    	the_vfield_list = str_sep(the_result, ',')

;	CD, '.', CURRENT = PWD

	;the_result = CALL_EXTERNAL(PWD+'/' + info.library,   $
;	the_result = CALL_EXTERNAL(info.library, 		$
;			'get_vdata_n_rec',  		$
;                	filename,			$
;			the_vdata_name)

;	the_nrec=the_result

    endif else begin
	result=dialog_message('Problem reading Vdata Fields!',$
			title='View HDF Warning!')
	return, -1
    endelse 

    result = where(the_vfield_list eq 'Instrument ID Number', count)
    if count ne 0 then begin

	the_name = ''
	the_index = result
	the_name = the_vfield_list(the_index)
	the_types=long(1)
	the_order=long(1)

	this_start = 0L
	this_end = 1L
	this_increment = 1L

	CD, '.', CURRENT = PWD

	;the_result = CALL_EXTERNAL(PWD+'/' + info.library,   $
;	the_result = CALL_EXTERNAL(info.library, 		$
;		'get_vfield_types',  	$
;		filename, 		$
;		the_vdata_name,		$ 
;		the_index,		$
;		long(1),		$
;		the_types,		$
;		the_order,		$
;		/s_value)

	if info.version lt 5.19 and info.library_status eq 1 then begin
		the_result = CALL_EXTERNAL(info.library,   $
			'get_vfield_types_eos', $
			filename,               $
			the_vdata_name,         $
			vdata_ref,              $
			the_index,              $
			long(1),                $
			the_types,              $
			the_order,              $
			/s_value)

		blank = array_type(the_types(0), the_order)

		single_record=create_struct( 'components' + '0', blank) 

		output_data=replicate(single_record, (the_nrec))

;-------------------------------------------
; Now read in the vdata from the HDF file
;-------------------------------------------

		CD, '.', CURRENT = PWD

		the_types = [the_types]
		the_order = [the_order]
	;the_result = CALL_EXTERNAL(PWD+'/' + info.library,   $
;	the_result = CALL_EXTERNAL(info.library, 		$
;		'read_vdata',  			$
;		filename, 			$
;		the_vdata_name,			$
;		long(1), 			$
;		this_start,            	 	$
;		the_nrec-1,			$
;		this_increment,			$
;		the_name, 			$
;		the_types,			$
;		the_order,			$
;		output_data)

		the_result = CALL_EXTERNAL(info.library,   $
			'read_vdata_eos',	$
			filename,		$
			the_vdata_name,		$
			vdata_ref,		$
			long(1),		$
			this_start,		$
			the_nrec-1,		$
			this_increment,		$
			the_name,		$
			the_types,		$
			the_order,		$
			output_data)
        endif else begin
		the_result = get_vfield_type(filename,the_vdata_name,vdata_ref, $
			the_index,the_types,the_order,info.version, $
			info.library, info.library_status, 0)
		the_result = read_vdata(filename, the_vdata_name, vdata_ref, $
			the_nrec-1, the_order, the_types, the_name, output_data)
	endelse

	output_data = reform(output_data.components0, n_elements(output_data.components0))

	return, output_data(0)

    endif else begin
        result=dialog_message('Problem reading Instrument ID Number Fields!',$
                        title='View HDF Warning!')
        return, -1
    endelse

endif else begin
	result=dialog_message('Converted Digital Data vdata not found!',$
			title='View HDF Warning!')
	return, -1
endelse 

end

;--------------------------------------------------------------------------------
function check_window, wid

pro_name = 'check_window'
;@getinfo1

BAD = 0
CATCH, BAD

if BAD ne 0 then begin
	CATCH,/CANCEL
	return, 0
endif

wshow, wid
return, 1

end

;--------------------------------------------------------------------------------
pro delete_window, wid

pro_name = 'delete_window'
;@getinfo

BAD = 0
CATCH, BAD

if BAD ne 0 then begin
        CATCH,/CANCEL
        return
endif

wshow, wid
wdelete, wid

end

;------------------------------------------------------------------
;	digital_done	
;------------------------------------------------------------------
PRO digital_done, Event

pro_name = 'digital_done'
@getinfo
 
	widget_control, get_uvalue=info, event.top
	widget_control,event.top,/destroy

	font1=info.font

if (info.subset.count lt info.subset.maximum) then begin

	;-----------------------------------
	; Ask the user to Subset the data
	;-----------------------------------

	subset_name=info.digital.name_sel + '[' + strcompress(string(info.subset.count)) +']'

	if info.rangetype.type eq 1 then begin
	   info.rangetype.flag=0
	   get_time_range, subset_name, 0, info
	   widget_control, get_uvalue=info, info.base
	   if info.canceloption eq 'Yes' then begin
		info.canceloption = 'No'
		widget_control, set_uvalue=info, info.base
		return
	   endif 
	   if info.rangetype.flag eq 0 then begin
		info.rangetype.type = 0
		widget_control, info.rangetype.widget, set_droplist_select=info.rangetype.type
	   endif
	endif

	if info.rangetype.type eq 0 or info.rangetype.flag eq 1 then $
	  record_range_buttons, subset_name, 0, 'digital_subset_done', info $
	else return
	;if info.rangetype.type eq 1 then begin
	;  time_range_buttons, subset_name, 'digital_subset_done', info
	;endif else begin
	;  record_range_buttons, subset_name, 0, 'digital_subset_done', info
	;endelse

	widget_control, set_uvalue=info, info.base

endif else begin

	the_message = ["You have maximum sets of data", "Please remove at least one set of data."]
        result=dialog_message(the_message, title='View HDF Warning!')
        return

endelse

END

;------------------------------------------------------------------
;	digital_subset_done
;------------------------------------------------------------------
pro digital_subset_done, Event

pro_name = 'digital_subset_done'
@getinfo
 
	widget_control, /hourglass
	widget_control,get_uvalue=info,event.id

	widget_control, info.widgets.subset_name, get_value=temp_name
	temp_name=temp_name(0)
	if info.vgroup.flag eq 1 then $
		temp_name = get_vgroup_name(temp_name,info)

if info.rangetype.type eq 1 and info.rangetype.flag eq 0 then begin
   time_record = *info.rangetype.time
   start_time = ' '
   end_time = ' '
   widget_control, info.widgets.start_time, get_value=start_time
   widget_control, info.widgets.end_time, get_value=end_time
   starttime = make_second_time(start_time) - 1
   endtime = make_second_time(end_time) + 1
   if (starttime gt endtime) then begin
	the_message=['The start time is greater than end time', $
		'Please, check the time and input it again.']
	result=dialog_message(the_message, title='View HDF Warning!')
	return
   endif

   subscript=where((time_record ge starttime) and (time_record le endtime), count)
   if(count lt 2) then begin
	result=dialog_message('There are no records in the time range!', $
		title='View HDF Warning!')
	return
   endif

   this_start = long(subscript(0))
   this_end = long(subscript(count-1))
   this_increment = 1L
   
endif else begin

	widget_control,info.widgets.starting_field(0),get_value=this_start
	this_start=long(this_start) - 1
	if this_start lt 0 then this_start = 0L

	widget_control,info.widgets.ending_field(0),get_value=this_end
	this_end=long(this_end)-1

	widget_control,info.widgets.increment_field(0),get_value=this_increment
	this_increment=long(this_increment)

endelse

	info.rangetype.old_start(0) = this_start + 1
	info.rangetype.old_end(0) = this_end + 1
	info.rangetype.old_increment(0) = this_increment
	info.rangetype.old_dim(0) = info.sds.dims(0)

	widget_control,event.top,/destroy

	widget_control,info.widgets.current_file,get_value=filename
	filename=filename(0)

	digital_nrec = info.sds.dims(0)
	output_data = lonarr(digital_nrec)

	;-------------------------------------------
	; Now read in the digital data from the HDF file
	;-------------------------------------------
       	CD, '.', CURRENT = PWD

	instr_id = long(get_instrument_id(info))
	if instr_id lt 0 then begin
		result=dialog_message('Problem reading Instrument ID Number!',$
			title='View HDF Warning!')
		return
	endif 

	indices_sel = info.digital.indices_sel(0)
       	;the_result = CALL_EXTERNAL(PWD+'/' + info.library,   $
	the_result = CALL_EXTERNAL(info.library, 		$
       		'get_digital_data', 			$
               	filename, 				$
		indices_sel,	$
		;info.digital.indices_sel,	$
		digital_nrec,				$
		instr_id, $
		output_data)

	if (the_result eq -1) then begin
		result=dialog_message('Problem to read digital data!',$
			title='View HDF Warning!')
		return
	endif

		 output_data = output_data(this_start:this_end)
		 this_increment = this_increment(0)

		if (this_increment gt 1) then begin
			indices = lindgen(this_end-this_start+1)
			indices = indices mod this_increment
			indices = [where(indices eq 0) ]
			output_data = output_data(indices)
		endif

		num_output_data = n_elements(output_data)
	
		;-------------------------------------------
		; Stuff the data into subset_data 
		;-------------------------------------------
		info.subset.count=info.subset.count+1
		info.subset.data(info.subset.count-1).subset_name=string(temp_name)
		info.subset.data(info.subset.count-1).src_filename=filename
		info.subset.data(info.subset.count-1).src_unitname=''
		info.subset.data(info.subset.count-1).src_type_flag=0			
		info.subset.data(info.subset.count-1).src_crit_flag = 0
		info.subset.data(info.subset.count-1).src_crit_name = ''
		info.subset.data(info.subset.count-1).src_crit_min = ''
		info.subset.data(info.subset.count-1).src_crit_max = ''
		info.subset.data(info.subset.count-1).src_crit_type = ''
		info.subset.data(info.subset.count-1).src_num = num_output_data
		info.subset.data(info.subset.count-1).src_ref = info.sds.ref
		info.subset.data(info.subset.count-1).src_rank=1
		info.subset.data(info.subset.count-1).src_start(0)=this_start
		info.subset.data(info.subset.count-1).src_end(0)=this_end+1
		info.subset.data(info.subset.count-1).src_increment(0)=this_increment
		info.subset.data(info.subset.count-1).src_org_rank=1
		info.subset.data(info.subset.count-1).src_org_start(0)=this_start
		info.subset.data(info.subset.count-1).src_org_end(0)=this_end+1
		info.subset.data(info.subset.count-1).src_org_increment(0)=this_increment
		info.subset.data(info.subset.count-1).src_fnames=info.digital.name_sel
		info.subset.data(info.subset.count-1).src_types=24
		info.subset.data(info.subset.count-1).src_order=0
		info.subset.data(info.subset.count-1).src_start(1)=this_start
		info.subset.data(info.subset.count-1).src_end(1)=this_end+1

		if ptr_valid(info.subset.data(info.subset.count-1).src_data) then begin
		    *info.subset.data(info.subset.count-1).src_data=output_data
		endif else begin
		    info.subset.data(info.subset.count-1).src_data=ptr_new(output_data)
		endelse

		if ptr_valid(info.rangetype.time) then begin
		    if ptr_valid(info.subset.data(info.subset.count-1).src_time) then begin
			*info.subset.data(info.subset.count-1).src_time=*info.rangetype.time
		    endif else begin
			info.subset.data(info.subset.count-1).src_time= $
			    ptr_new(*info.rangetype.time)
		    endelse
		endif

		;-------------------------------------------
		; Add to the subset list
		;-------------------------------------------

        info = redefine_info(info, temp_name, 3 )
 
        widget_control, info.widgets.subset_list, set_value=info.name_list_subset
 
	widget_control, set_uvalue=info, info.base
	save_list = redefine_save_list(info)
	widget_control, set_uvalue=save_list, info.list_base

end

;--------------------------------------------------------------------------------
function make_string_time, seconds, julian_date, julian_time

pro_name = 'make_string_time'
@getinfoa

julian_time = julian_date + seconds/86400.0

result=''

seconds = long(seconds)
minutes = long(seconds/60)
seconds = seconds - minutes * 60
hours = long(minutes/60)
minutes = minutes - hours * 60

result=string(format='(I2.2,":",I2.2,":",I2.2)', hours, minutes, seconds)
return, result

end

;--------------------------------------------------------------------------------
function get_data_range, this_subset, info

pro_name = 'get_data_range'
@getinfoa

range_string = ''

;if info.subset.data(this_subset).src_transpose eq 0 then begin
;   startrecord = info.subset.data(this_subset).src_start(0)
;   endrecord = info.subset.data(this_subset).src_end(0)
;   if info.subset.data(this_subset).src_type_flag eq 0 then begin
;       the_rank = info.subset.data(this_subset).src_rank
;       if the_rank eq 1 then begin
;               true_start = info.subset.data(this_subset).src_start(the_rank)
;               true_end = info.subset.data(this_subset).src_end(the_rank)
;               if true_start ne startrecord or true_end ne endrecord then begin
;                       startrecord = true_start
;                       endrecord = true_end
;               endif
;       endif
;       endrecord = endrecord - 1
;   endif
;endif else begin
;   if info.subset.data(this_subset).src_rank eq 1 then begin
;       startrecord = info.subset.data(this_subset).src_start(0)
;       endrecord = info.subset.data(this_subset).src_end(0)
;   endif else begin
;       startrecord = info.subset.data(this_subset).src_start(1)
;       endrecord = info.subset.data(this_subset).src_end(1)
;   endelse
;   endrecord = endrecord - 1
;endelse

startrecord = info.subset.data(this_subset).src_org_start(0)
endrecord = info.subset.data(this_subset).src_org_end(0)
if info.subset.data(this_subset).src_type_flag eq 0 then $
	endrecord = endrecord - 1

if ptr_valid(info.subset.data(this_subset).src_time) then begin
	time_record = *info.subset.data(this_subset).src_time
	time_dimen = size(time_record, /N_DIMENSIONS)
	starttime = ' '
	endtime = ' '
	if time_dimen eq 2 then begin
		size_time = size(time_record)
		startsample = info.subset.data(this_subset).src_org_start(1)
		if startsample gt size_time(1) then startsample = size_time(1) - 1
		endsample = info.subset.data(this_subset).src_org_end(1) - 1
		if endsample gt size_time(1) then endsample = size_time(1) - 1
		starttime = make_string_time(time_record(startsample,startrecord), $
		    info.rangetype.julian, julian_start_time)
		endtime = make_string_time(time_record(endsample,endrecord), $
		    info.rangetype.julian, julian_end_time)
	endif else begin
		starttime = make_string_time(time_record(startrecord), $
		    info.rangetype.julian, julian_start_time)
		endtime = make_string_time(time_record(endrecord), $
		    info.rangetype.julian, julian_end_time)
	endelse
	if info.rangetype.time_type eq 1 then begin
	    starttime=string(format='(f20.7)', julian_start_time)
	    endtime=string(format='(f20.7)', julian_end_time)
	    starttime=strcompress(starttime, /REMOVE_ALL)
	    endtime=strcompress(endtime, /REMOVE_ALL)
	endif
	range_string=starttime + ' - ' + endtime + ' ('
endif 

if info.subset.data(this_subset).src_type_flag eq 0 then begin

	org_rank = info.subset.data(this_subset).src_org_rank
	for i = 0, org_rank-1 do begin
		range_string=range_string+ $
			strcompress(string(info.subset.data(this_subset).src_org_start(i)+1))
		range_string=range_string+':'
		range_string=range_string+ $
			strcompress(string(info.subset.data(this_subset).src_org_end(i)))
		range_string=range_string+':'
		range_string=range_string + $
			strcompress(string(info.subset.data(this_subset).src_org_increment(i)))
		if i lt org_rank-1 then $
			range_string=range_string+';' $
		else begin
			if ptr_valid(info.subset.data(this_subset).src_time) then $
				range_string = range_string+')'
		endelse
	endfor
endif else begin
	increcord = info.subset.data(this_subset).src_increment(0)
	start_order = info.subset.data(this_subset).src_start(1)
	end_order = info.subset.data(this_subset).src_end(1)
	increment_order = info.subset.data(this_subset).src_increment(1)
		range_string=range_string+strtrim(string(startrecord+1), 2)+':'
		range_string=range_string+ strtrim(string(endrecord+1),2)+':'
		range_string=range_string+ strtrim(string(increcord),2)+';'
		range_string=range_string+' Order: '+strtrim(string(start_order),2)+':'
		range_string=range_string+ strtrim(string(end_order),2)+':'
		range_string=range_string+ strtrim(string(increment_order),2)
	if ptr_valid(info.subset.data(this_subset).src_time) then begin
		range_string=range_string + ')'
	endif
endelse

return, range_string

end

;--------------------------------------------------------------------------------
pro editcwclrindexCB, event

pro_name = 'editcwclrindexCB'
@getinfo

if event.type ne 0 then return
if event.ch ne 10b then return

clr_index = widget_info(event.id,/parent)
widget_control, get_uvalue=type, clr_index
color_label = widget_info(clr_index, /child)
widget_control, color_label, get_uvalue=color_state
widget_control, get_value=initial_color, event.id
initial_color = initial_color(0)
initial_color = strcompress(initial_color, /remove_all)

loc_start = strpos(initial_color, '(')
if loc_start ne -1 then begin
    loc_end = strpos(initial_color,')')
    if loc_end ne -1 then length = loc_end - loc_start - 1 $
	else length = strlen(initial_color) - loc_start - 1
    initial_value = fix(strmid(initial_color, loc_start+1, length))
endif else initial_value = fix(initial_color)

if initial_value lt 0 or initial_value gt !d.N_COLORS-1 or $
    initial_value gt 255 then begin
    if(initial_value gt 255) then initial_value = 255 $
	else initial_value = 255   ;  set back to default
	;else initial_value = !P.color   ;  set back to default
    initial_color = '(' + strtrim(initial_value,2) + ')'
    widget_control, color_state.txt_id, set_value = initial_color
endif

widget_control, get_uvalue=info, event.top
case type of
    'color': begin
	info.style.colorindex = initial_value
	widget_control, set_uvalue=info, event.top
	end
    'overlay': begin
	info.overlay.colorindex = initial_value
	widget_control, set_uvalue=info, event.top
	end
    'bar': begin
	info.greenwich.baddata = initial_value
	widget_control, set_uvalue=info, event.top
	end
    'multiple': begin
	widget_control, get_uvalue=base_b, event.top
	widget_control, get_uvalue=set_value, base_b
	set_value(3) = initial_value
	widget_control, set_uvalue=set_value, base_b
	end
    else:
endcase

old_win = !d.window
color_state.value = initial_value
widget_control, color_state.rect_id, get_value = i
wset, i
device, get_visual_depth=thisDepth  ; check the decomposed
if thisDepth gt 8 then device, decomposed=0
tv, replicate(initial_value, !d.x_size, !d.y_size)
wset, old_win
widget_control, color_label, set_uvalue = color_state, /NO_COPY

end

;--------------------------------------------------------------------------------
pro editable_cw_clr_index, clr_index

pro_name = 'editable_cw_clr_index'
@getinfo

widget_control, widget_info(clr_index, /child), get_uvalue=color_state
widget_control, color_state.txt_id, /EDITABLE, /ALL_TEXT_EVENTS, $
    EVENT_PRO = 'editcwclrindexCB'

end

;--------------------------------------------------------------------------------
pro initial_cw_clr_index, clr_index, initial_value

pro_name = 'initial_cw_clr_index'
@getinfo

color_label = widget_info(clr_index, /child)
widget_control, color_label, get_uvalue=color_state
initial_color = '(' + strtrim(string(initial_value),2) + ')'
widget_control, color_state.txt_id, set_value = initial_color
old_win = !d.window
version_number = !VERSION.RELEASE
ver_num = float(version_number)
if ver_num lt 5.19 then begin
    device, get_visual_depth=thisDepth
endif else begin
    device, get_visual_depth=thisDepth, get_decomposed=thisState
endelse
if thisDepth gt 8 then device, decomposed=0
widget_control, color_state.pwin_id, get_value = i
wset, i
x = long(color_state.scale * findgen(!d.x_size))  ;0 to n_colors-1
tv, x # replicate(1, !d.y_size) + color_state.start_color

color_state.value = initial_value
widget_control, color_state.rect_id, get_value = i
wset, i
tv, replicate(initial_value, !d.x_size, !d.y_size)
wset, old_win
widget_control, color_label, set_uvalue = color_state, /NO_COPY
if ver_num gt 5.19 then device, decomposed = thisState

end

;--------------------------------------------------------------------------------
pro morestyleset_event, event

pro_name = 'morestyleset_event'
@getinfo

if TAG_NAMES(event,/structure_name) eq 'CW_COLOR_INDEX' then begin
    widget_control, get_uvalue=base_b, event.top
    widget_control, get_uvalue=set_value, base_b
    set_value(3)=event.value
    widget_control, set_uvalue=set_value, base_b
    return    
end

widget_control, get_value=v, event.id
widget_control, get_uvalue=fieldid, event.id

if v.cancel eq 1 then begin
    widget_control, get_uvalue=base_b, event.top
    widget_control, get_uvalue=set_value, base_b
    set_value(0)=-9999
    widget_control, set_uvalue=set_value, base_b
    widget_control, /destroy, event.top
    return
endif

if event.tag eq 'SYMBOL' then begin
    if event.value gt 0 then begin
	widget_control, fieldid(6), sensitive = 1
	if v.with gt 0 then $
	    widget_control, fieldid(3), sensitive = 1 $
	    else widget_control, fieldid(3), sensitive = 0
    endif else begin
	widget_control, fieldid(3), sensitive = 1
	widget_control, fieldid(6), sensitive = 0
    endelse
endif

if event.tag eq 'WITH' then begin
    if event.value gt 0 then $
	widget_control, fieldid(3), sensitive = 1 $
        else widget_control, fieldid(3), sensitive = 0
endif

if v.done eq 1 then begin
    widget_control, get_uvalue=base_b, event.top
    widget_control, get_uvalue=set_value, base_b
    set_value(0) = v.line
    set_value(1) = v.symbol
    set_value(2) = v.with

    widget_control, set_uvalue=set_value, base_b

    widget_control, event.top, /destroy

endif

end

;--------------------------------------------------------------------------------
function more_style_set, info, num, temp_name

pro_name = 'more_style_set'
@getinfo1

widget_control, /hourglass

set_value = intarr(4)
set_value(3) = info.multiple.colorarray(num)
base_b = widget_base(uvalue=set_value, map=0)
widget_control, base_b, /realize

;temp_name = info.name_list_subset(this_subset)
;temp_name = temp_name(0)

length = strlen(temp_name)
if length gt 65 then begin
    data_name = strmid(temp_name, 0, 60) + '...'
endif else data_name = temp_name
temp_text = 'Variable: '+data_name

line_type = strcompress(string(info.multiple.linearray(num)), /REMOVE_ALL)
sym_type = strcompress(string(info.multiple.symarray(num)), /REMOVE_ALL)
with_line = strcompress(string(info.multiple.symlinearray(num)), /REMOVE_ALL)
numcolor = strcompress(string(info.multiple.colorarray(num)), /REMOVE_ALL)

desc = [ $
	'0, label, Variable Style Setting, center, font='+info.font, $
	'0, label, '+temp_text+', center, font='+info.font, $
	'0, label, "   ", center, font=' + info.font, $
	'1, base, , column', $
	'2, droplist, Solid|Dotted|Dashed|Dashed Dot|Dashed Dot Dot Dot|Long Dashes, ' $
	    + 'label_left=Line Type:, set_value='+line_type+', tag=line, ' $
	    + 'font='+info.font+', labelfont='+info.font, $
	'0, droplist, No Symbol|Plus sign|Asterisk|Period|Diamond|Triangle|' $
	    + 'Square|X|Circle|FOV|Filled Triangle|Filled Square|Filled Circle|' $
	    + 'Filled FOV, label_left=Symbol Type:, set_value='+sym_type $
	    + ', tag=symbol, font='+info.font+', labelfont='+info.font, $
	'1, base, , column, frame', $
	'2, droplist, No|Yes, label_left=Symbol With Line:, set_value='+with_line $
	    + ', tag=with, font='+info.font+', labelfont='+info.font, $
	'1, base, , row, space=60, center', $
	'0, button, Done, QUIT, tag=done, font='+info.font, $
	'2, button, Cancel, QUIT, tag=cancel, font='+info.font]
	
if(widget_info(info.widgets.base, /VALID_ID)) then begin
    top_base = info.widgets.base
endif else begin
    top_base = info.base
endelse

base_loc = widget_info(top_base, /geometry)
xoffset = base_loc.xoffset + 100
yoffset = base_loc.yoffset + 100

base=widget_base(group_leader=top_base, /modal, column=1, map=1, xoffset=xoffset, $
    yoffset=yoffset, TITLE='Select Variable Style Setting')
formid = cw_form(base, desc, /column, ids=fieldid)

if !d.n_colors gt 192 then bar_size = !d.n_colors else bar_size = 192
if !d.n_colors gt 256 then begin
    bar_size = 256
    color_values =indgen(bar_size)
    if info.multiple.colorarray(num) gt 255 then info.multiple.colorarray(num) = 255
endif else color_values =indgen(!d.n_colors)
if info.version lt 5.39 then begin
    clr_index = cw_clr_index(base, color_values=color_values, label='Color: ', $
	xsize=bar_size, uvalue='multiple')
endif else begin
    clr_index = cw_clr_index(base, color_values=color_values, label='Color: ', $
	xsize=bar_size, value=info.multiple.colorarray(num), uvalue='multiple')
endelse

widget_control, base, /realize
widget_control, set_uvalue=base_b, base
widget_control, set_uvalue=fieldid, formid

if info.version lt 5.39 then $
    initial_cw_clr_index, clr_index, info.multiple.colorarray(num)

editable_cw_clr_index, clr_index

if info.multiple.symarray(num) gt 0 then begin
    widget_control, fieldid(6), sensitive = 1
    if info.multiple.symlinearray(num) gt 0 then $
	    widget_control, fieldid(3), sensitive = 1 $
	    else widget_control, fieldid(3), sensitive = 0
endif else begin
	widget_control, fieldid(6), sensitive = 0
endelse

xmanager, 'morestyleset', base

widget_control, get_uvalue=style_value, base_b
widget_control, base_b, /destroy

return,style_value

end

;--------------------------------------------------------------------------------
pro get_input_style, info, temp_name, num, linetype, plot_symbol, colorindex

pro_name = 'get_input_style'
@getinfo

if info.multiple.resetflag eq 1 then begin
    old_window_id = !d.window
    style_value = more_style_set(info, num, temp_name)
    if style_value(0) lt -999 then begin
	wset, old_window_id
	linetype = -9999
	return
    endif

    info.multiple.linearray(num) = style_value(0)
    info.multiple.symarray(num) = style_value(1)
    info.multiple.symlinearray(num) = style_value(2)
    info.multiple.colorarray(num) = style_value(3)
    wset, old_window_id
endif

linetype = info.multiple.linearray(num)
check_symbol = info.multiple.symarray(num)
if check_symbol ne 0 then begin
    if check_symbol gt 7 then begin
	usersym = check_symbol - 7
	plot_symbol = 8
	set_user_symbol, usersym
    endif else plot_symbol = check_symbol

    if info.multiple.symlinearray(num) eq 1 then plot_symbol = - plot_symbol
endif else plot_symbol = 0

colorindex = info.multiple.colorarray(num)

end

;--------------------------------------------------------------------------------
pro display_value, info, this_subset

pro_name = 'display_value'
@getinfo

widget_control, /hourglass

if info.device eq 'X' then begin
   check=check_path(info.temp_dir)
   if check eq 1 then begin
	table_filename=info.temp_dir+"."+info.tempname+"_table" + $
 	   strcompress(string(info.subset.count),/REMOVE_ALL)
   endif else begin
	table_filename=info.temp_dir+"/."+info.tempname+"_table" + $
	   strcompress(string(info.subset.count),/REMOVE_ALL)
   endelse
endif else begin
   table_filename=info.temp_dir+"\."+info.tempname+"_table" + $
	strcompress(string(info.subset.count),/REMOVE_ALL)
endelse

get_lun, unit
openw, unit, table_filename 

;--------------------------
; Write file header
;--------------------------
filename=info.subset.data(this_subset).src_filename
filename=filename(0)

printf, unit, format='("Source Data Filename: ",A)', filename
printf, unit, format='("Subset Name: ",A)', info.name_list_subset(this_subset)
unit_name = info.subset.data(info.subset.selected).src_unitname
unit_name = unit_name(0)
temp_length = strlen(unit_name)
unitlabel = ''
if (temp_length gt 0) then $
	unitlabel = strmid(unit_name,2,temp_length-2)
printf,unit, format='("Unit:  ",A)', unitlabel
data_range = ''
data_range = get_data_range(this_subset,info)
printf,unit, format='("Data Range:  ",A)',data_range

if info.subset.data(this_subset).src_crit_flag eq 1 then begin
	crit_string = ''
	crit_string = get_crit_string(this_subset, info)
	; temp_name = str_sep(crit_string, '!C')
	temp_name = strsplit(crit_string, '!C' , /EXTRACT)
	num_temp = n_elements(temp_name)
	for i = 0, num_temp-1 do begin
		temp_length = strlen(temp_name(i))
		dot=strpos(temp_name(i),';')
		if( dot ne -1) then begin
			crit1 = strtrim(strmid(temp_name(i),0,dot),2)
			crit2 = strtrim(strmid(temp_name(i),dot+1,temp_length-1),2)
			if i eq 0 then printf,unit,crit1 $
				else printf,unit,'           '+crit1
				printf,unit,'           '+crit2
		endif else begin
			crit1 = strtrim(temp_name(i),2)
			if i eq 0 then printf,unit,crit1 $
				else printf,unit,'           '+crit1
		endelse
	endfor
	printf,unit
endif

;-------------------------------
; Get values from the widgets
;-------------------------------

hdf_data = *info.subset.data(this_subset).src_data

temp='('+info.precision+')'
temp=temp(0)
;if info.subset.data(this_subset).src_type_flag eq 0 then printf, unit, hdf_data $
if info.subset.data(this_subset).src_type_flag eq 0 then begin
	;if info.subset.data(this_subset).src_types(0) eq 4 then begin
	if info.subset.data(this_subset).src_types(0) eq 4 or $
	    info.subset.data(this_subset).src_types(0) eq 3 then begin
		test_string = strlowcase(temp)
		dot=strpos(test_string,'a')
		if( dot ne -1) then printf, unit, format=temp, hdf_data $
			else printf, unit, hdf_data
	endif else begin
		printf, unit, format=temp, hdf_data
	endelse
endif else begin
	;if info.subset.data(this_subset).src_types(0) eq 4 then begin
	if info.subset.data(this_subset).src_types(0) eq 4 or $
	    info.subset.data(this_subset).src_types(0) eq 3 then begin
		test_string = strlowcase(temp)
		dot=strpos(test_string,'a')
		if( dot ne -1) then printf, unit, format=temp, hdf_data(*).components0 $
			else printf, unit, hdf_data(*).components0
	endif else begin
		;temp='('+info.precision+')'
		;temp=temp(0)
		printf, unit, format=temp, hdf_data(*).components0
		;printf, unit, hdf_data(*).components0
	endelse
endelse

close,unit
free_lun, unit

case info.editor_type of
	1: command_line = "emacs " + table_filename + " &"
	2: begin 
		command_line = info.ieditor + " -geometry 757x531+75+104"
		command_line = command_line + " -title 'Display Data' "
		command_line = command_line + table_filename + " &"
	   end
	3: command_line = 'start edit "' + table_filename + '"'
	4: begin
		if !D.Name eq 'X' then begin
		    command_line = info.editor + " " + table_filename + " &"
		endif else begin
		    command_line = 'start ' + info.editor + ' "' + table_filename + '"'
		endelse
	   end
	5: begin
		command_line="xterm -bg \#73a1ff -fn "
		command_line=command_line+ $
			"-adobe-courier-bold-r-normal--14-100-100-100-m-90-iso8859-1"
		command_line=command_line + " -e emacs " + table_filename + " &"
	   end
	else: begin
		command_line="xterm -bg \#73a1ff -fn "
		command_line=command_line+ $
			"-adobe-courier-bold-r-normal--14-100-100-100-m-90-iso8859-1"
		command_line=command_line + " -e vi -R " + table_filename + " &"
	   end
endcase
spawn, command_line,results

end

;--------------------------------------------------------------------------------
pro do_2d_graph, info, name_of_data, this_subset, print_flag, plot_status

pro_name = 'do_2d_graph'
@getinfo

dot=strpos(name_of_data,'[')
if( dot ne -1) then begin
  ytitle=strmid(name_of_data,0,dot)
endif else begin
  ytitle = name_of_data
endelse

if info.multiple.key eq 1 then begin
  legend_title = ytitle
  if info.multiple.y1y2 eq 0 then ytitle = ''
  the_title='Multiple Y Variables'
endif else the_title = ytitle

data_range = ''
data_range = get_data_range(this_subset,info)
the_title = the_title + ' Data Range: ' + data_range

this_type = info.subset.data(this_subset).src_types
this_type = this_type(0)
filldata_value = get_filldata_value(this_type, info.filldata)
if filldata_value gt info.filldata then filldata_value = info.filldata
max_value = get_max_value(this_type, info.filldata)
if info.filldata gt 0 then begin
    if max_value gt info.filldata then max_value = info.filldata
endif

;--------------------------
; If this is an SDS then
;--------------------------

set_axis_ranges, info, YRange, Ystyle, XRange, Xstyle, ZRange, Zstyle

change_scale = 0
max_y_range = max_value
if info.multiple.key eq 1 then max_y_range = info.range.real_y_end

if info.subset.data(this_subset).src_type_flag eq 0 then begin

	hdf_data = *info.subset.data(this_subset).src_data

        hdf_temp_data = reform(hdf_data, n_elements(hdf_data))
	if filldata_value gt 0 then begin
	    subscript = where(hdf_temp_data lt filldata_value, count)
	endif else begin
	    subscript = where(hdf_temp_data gt filldata_value, count)
	endelse

        if count eq 0 then begin

        	result=dialog_message('All Data is FILL data!',$
                           title='View HDF Warning!')
			   plot_status = 0
                           return
        endif

	hdf_temp_data = hdf_temp_data(subscript)
	hdf_max = max(hdf_temp_data, min=hdf_min)
	min_value = hdf_min
	if info.axis_state eq 2 or info.axis_state eq 4 or info.axis_state eq 5 or $
	    info.axis_state eq 7 or info.axis_state eq 9 then begin
		if(YRange(0) le YRange(1)) then begin
		    min_value = YRange(0)
		    if info.multiple.key ne 1 then max_y_range = YRange(1)
		endif else begin
		    min_value = YRange(1)
		    if info.multiple.key ne 1 then max_y_range = YRange(0)
		endelse
	endif
	hdf_size = size(hdf_data)
	n_hdf_size = n_elements(hdf_size)
	info.slide.x_start = 0.0
	info.slide.x_end = hdf_size(n_hdf_size - 1)

	if ((print_flag eq 0) or (print_flag eq 3)) then plot_dialogue , name_of_data, info

	if info.style.symbolline eq 1 then plot_symbol = - info.style.symbol $
		else plot_symbol = info.style.symbol

	if info.multiple.flag ne 1 then begin

		if !D.Name eq 'PRINTER' or !D.Name eq 'WIN' or info.char.font eq 0 then begin
		    xtitle='Sample'
		endif else xtitle='!CSample!C'
		if !D.Name eq 'PS' or !D.Name eq 'PRINTER' then begin
			old_charsize = !X.CHARSIZE
			!X.CHARSIZE = 0.9
			!Y.CHARSIZE = 0.9	
		endif else !P.Position = [0.060, 0.100, 0.98, 0.96]
			
		if info.multiple.key ne 1 then begin
			temp_name = info.subset.data(this_subset).src_unitname
			temp_name = temp_name(0)
			dot=strpos(temp_name,'N/A')
			if( dot eq -1) then ytitle = ytitle + temp_name
		endif

        	if info.subset.data(this_subset).src_crit_flag eq 1 then begin
			crit_string = ''
			crit_string = get_crit_string(this_subset, info)
			if !D.Name eq 'PS' and  info.eps_out.type eq 1 then  $
				!P.Position = [0.235, 0.15, 0.99, 0.95] $
				else !P.Position = [0.060, 0.120, 0.98, 0.96]
			temp_name = str_sep(crit_string, '!C')
			num_temp = n_elements(temp_name)
			!P.Position(1) = !P.Position(1) + (num_temp-1)*0.025
		endif

		if info.style.xlog gt 0 then begin
		    default_max = n_elements(hdf_data)
		    XRange = set_log_range(XRange, 1, default_max)
		endif

		if info.style.ylog gt 0 then begin
		    YRange = set_log_range(YRange, hdf_min, hdf_max)
		endif

		if (info.multiple.key eq 1 and info.multiple.y1y2 eq 1) then begin
			temp_name = info.subset.data(this_subset).src_unitname
			temp_name = temp_name(0)
			dot=strpos(temp_name,'N/A')
			if( dot eq -1) then ytitle = ytitle + temp_name
			if !P.Position(2) gt 0.0 then !P.Position(2) = !P.Position(2) - 0.03
			old_x_margin = !X.MARGIN
			!X.MARGIN = [10, 10]
			ystyle = ystyle + 8
		endif

		get_ticklen, info.style.grid, xticklen, yticklen 

		plot, hdf_data, MAX_VALUE = max_value, MIN_VALUE = min_value, /YNOZERO, /NODATA, $
			FONT=info.char.font, charsize=info.char.size, title=the_title, $
			xtitle=xtitle, ytitle=ytitle, xticklen=xticklen, yticklen=yticklen, $
			subtitle=info.subset.data(this_subset).src_filename  + "  Date:" + systime(0), $
			XRange = XRange, YRange = YRange, Xstyle=Xstyle, Ystyle = Ystyle, $
			xlog = info.style.xlog, ylog=info.style.ylog

		if info.subset.data(this_subset).src_crit_flag eq 1 then begin
			if !D.Name eq 'PS' or !D.Name eq 'PRINTER' then begin
				charsize = 0.9*info.char.size
				y_location = 0.125
			endif else begin
				charsize = info.char.size
				y_location = 0.11
			endelse
			;xyouts, !P.Position(0), !P.Position(1)-y_location, crit_string, /NORMAL, $
			xyouts, 0.08, !P.Position(1)-y_location, crit_string, /NORMAL, $
				font=info.char.font, charsize=charsize
		endif

		if info.addtext.key eq 1 then write_add_text, info

		if !D.Name eq 'PS' or !D.Name eq 'PRINTER' then begin
			!X.CHARSIZE = old_charsize
			!Y.CHARSIZE = old_charsize
		endif
	endif

	if ((info.multiple.key eq 1 and info.multiple.y1y2 eq 1) and $
	     info.multiple.number eq 1) then begin
		temp_name = info.subset.data(this_subset).src_unitname
		temp_name = temp_name(0)
		dot=strpos(temp_name,'N/A')
		if( dot eq -1) then ytitle = ytitle + temp_name
		if filldata_value gt 0 then begin
		    subscripts = where(hdf_data lt filldata_value, count)
		endif else begin
		    subscripts = where(hdf_data gt filldata_value, count)
		endelse
		if count ne 0 then begin
		    if info.axis_state lt 6 then begin
			hdf_temp_data = hdf_data(subscripts)
			hdf_max = max(hdf_temp_data, min=hdf_min)
			if hdf_max le !y.crange(1) and hdf_min ge !y.crange(0) then begin
				toler=(info.range.y_end - info.range.y_start)/5
				max_diff = info.range.y_end - hdf_max
				min_diff = hdf_min - info.range.y_start
				if abs(max_diff) le toler and abs(min_diff) le toler then begin
					ymax=info.range.y_end
					ymin=info.range.y_start
				endif else begin
					get_range, hdf_max, hdf_min, ymax, ymin
					max_y_range = ymax
					ymax = ymax + (ymax - ymin)*0.15
				endelse
			endif else begin
				get_range, hdf_max, hdf_min, ymax, ymin
				max_y_range = ymax
				ymax = ymax + (ymax - ymin)*0.15
			endelse
			min_value = hdf_min
		    endif else begin
			ymin = info.range.y2_start
			ymax = info.range.y2_end
			max_y_range = ymax
			min_value = ymin
			ymax = ymax + (ymax - ymin)*0.15
		    endelse
			old_x = !X
			old_y = !Y
			change_scale = 1
			if info.style.y2log gt 0 then begin
			    y2range = [ymin, ymax]
			    y2range = set_log_range(y2range, ymin, ymax)
			    ymin = y2range(0)
			    ymax = y2range(1)
			endif else if !Y.TYPE eq 1 then !Y.TYPE = 0
			Axis, YAXIS=1, ytitle = ytitle, /YNOZERO, YRANGE=[ymin, ymax], $
				FONT=info.char.font, charsize=info.char.size, ystyle=3, $
				ticklen=0.01, ylog=info.style.y2log, /SAVE
		endif else begin
			Axis, YAXIS=1, ytitle = ytitle, FONT=info.char.font, $
				charsize=info.char.size, ystyle=2, ticklen=0.01, $
				ylog=info.style.ylog, /SAVE
		endelse
	endif

		;oplot, hdf_data, MAX_VALUE = max_value, $
		oplot, hdf_data, MAX_VALUE = max_y_range, MIN_VALUE = min_value, $
			psym = plot_symbol, linestyle=info.style.linetype, $
			symsize = info.style.symbolsize, thick=info.style.linethick, $
			color = info.style.colorindex

		if info.multiple.key eq 1 then begin
			temp_name = info.subset.data(this_subset).src_unitname
			temp_name = temp_name(0)
			dot=strpos(temp_name,'N/A')
			if( dot eq -1) then legend_title = legend_title + temp_name

			y_leg = !Y.WINDOW(1) - 0.03 - 0.025 * info.multiple.number
			y_leg_t = y_leg - 0.005
			x_leg_s = !X.WINDOW(0) + 0.03 
			x_leg_e = x_leg_s + 0.05
			leg_start = convert_coord(x_leg_s, y_leg, /NORMAL, /TO_DATA)
			leg_end   = convert_coord(x_leg_e, y_leg, /NORMAL, /TO_DATA)
			oplot, [leg_start(0), leg_end(0)], [leg_start(1), leg_end(1)], $
				psym = plot_symbol, linestyle=info.style.linetype, $
                        	symsize = info.style.symbolsize, thick=info.style.linethick, $
				color = info.style.colorindex

			xyouts, x_leg_e+0.01, y_leg_t, legend_title, /NORMAL, font=info.char.font, $
				charsize=info.char.size
		endif

		if change_scale eq 1 then begin
			!X = old_x
			!Y = old_y
		endif

;--------------------------
; For a Vdata do this
;--------------------------
endif else begin

	hdf_data = *info.subset.data(this_subset).src_data
        hdf_temp_data = reform(hdf_data.components0, n_elements(hdf_data.components0))
	if filldata_value gt 0 then begin
	    subscript = where(hdf_temp_data lt filldata_value, count)
	endif else begin
	    subscript = where(hdf_temp_data gt filldata_value, count)
	endelse

        if count eq 0 then begin
	        result=dialog_message('All Data is FILL data!',$
                           title='View HDF Warning!')
			   plot_status = 0
                           return
        endif

	hdf_temp_data = hdf_temp_data(subscript)
	hdf_max = max(hdf_temp_data, min=hdf_min)
	min_value = hdf_min
	if info.axis_state eq 2 or info.axis_state eq 4 or info.axis_state eq 5 or $
	    info.axis_state eq 7 or info.axis_state eq 9 then begin
		if YRange(0) le YRange(1) then begin
		    min_value = YRange(0)
		    if info.multiple.key ne 1 then max_y_range = YRange(1)
		endif else begin
		    min_value = YRange(1)
		    if info.multiple.key ne 1 then max_y_range = YRange(0)
		endelse
	endif
	hdf_size = size(hdf_temp_data)
	n_hdf_size = n_elements(hdf_size)
	info.slide.x_start = 0.0
	info.slide.x_end = hdf_size(n_hdf_size - 1)

	if ((print_flag eq 0) or (print_flag eq 3)) then plot_dialogue , name_of_data, info

	if info.style.symbolline eq 1 then plot_symbol = - info.style.symbol $
		else plot_symbol = info.style.symbol

	if info.multiple.flag ne 1 then begin

	  if !D.Name eq 'PRINTER' or !D.Name eq 'WIN' or info.char.font eq 0 then begin
	    xtitle='Sample'
	  endif else xtitle='!CSample!C'
	  if !D.Name eq 'PS' or !D.Name eq 'PRINTER' then begin
		old_charsize = !X.CHARSIZE
		!X.CHARSIZE = 0.9
		!Y.CHARSIZE = 0.9	
	  endif else !P.Position = [0.060, 0.100, 0.98, 0.96]
			
	  if info.multiple.key ne 1 then begin
		temp_name = info.subset.data(this_subset).src_unitname
		temp_name = temp_name(0)
		dot=strpos(temp_name,'N/A')
		if( dot eq -1) then ytitle = ytitle + temp_name
	  endif

          if info.subset.data(this_subset).src_crit_flag eq 1 then begin
		crit_string = ''
		crit_string = get_crit_string(this_subset, info)
		if !D.Name eq 'PS' and info.eps_out.type eq 1 then $
			!P.Position = [0.235, 0.15, 0.99, 0.95] $
			else !P.Position = [0.060, 0.120, 0.98, 0.96]
                temp_name = str_sep(crit_string, '!C')
                num_temp = n_elements(temp_name)
                !P.Position(1) = !P.Position(1) + (num_temp-1)*0.025
          endif

	  if info.style.xlog gt 0 then begin
		default_max = n_elements(hdf_data)
		XRange = set_log_range(XRange, 1, default_max)
	  endif

	  if info.style.ylog gt 0 then begin
		YRange = set_log_range(YRange, hdf_min, hdf_max)
	  endif

          if (info.multiple.key eq 1 and info.multiple.y1y2 eq 1) then begin
		temp_name = info.subset.data(this_subset).src_unitname
		temp_name = temp_name(0)
		dot=strpos(temp_name,'N/A')
		if( dot eq -1) then ytitle = ytitle + temp_name
		if !P.Position(2) gt 0.0 then !P.Position(2) = !P.Position(2) - 0.03
		old_x_margin = !X.MARGIN
		!X.MARGIN = [10, 10]
		ystyle = ystyle + 8
          endif
 
	  get_ticklen, info.style.grid, xticklen, yticklen 

	  plot, hdf_data(*).components0, MAX_VALUE = max_value, MIN_VALUE = min_value, $
		/YNOZERO, /NODATA, $
		FONT=info.char.font, charsize=info.char.size, title=the_title, $
		xtitle=xtitle, ytitle=ytitle,xticklen=xticklen, yticklen=yticklen, $
		subtitle=info.subset.data(this_subset).src_filename + "  Date:" + systime(0), $
		XRange = XRange, YRange = YRange, Xstyle=Xstyle, Ystyle = Ystyle, $
		xlog=info.style.xlog, ylog=info.style.ylog

	  if info.subset.data(this_subset).src_crit_flag eq 1 then begin
		if !D.Name eq 'PS' or !D.Name eq 'PRINTER' then begin
			charsize = 0.9*info.char.size
			y_location = 0.125
		endif else begin
			charsize = info.char.size
			y_location = 0.11
		endelse
		;xyouts, !P.Position(0), !P.Position(1)-y_location, crit_string, /NORMAL, $
		xyouts, 0.08, !P.Position(1)-y_location, crit_string, /NORMAL, $
			font=info.char.font, charsize=charsize
	  endif

	  if info.addtext.key eq 1 then write_add_text, info

	  if !D.Name eq 'PS' or !D.Name eq 'PRINTER' then begin
		!X.CHARSIZE = old_charsize
		!Y.CHARSIZE = old_charsize
	  endif

	endif

        if ((info.multiple.key eq 1 and info.multiple.y1y2 eq 1) and $
             info.multiple.number eq 1) then begin
                temp_name = info.subset.data(this_subset).src_unitname
                temp_name = temp_name(0)
                dot=strpos(temp_name,'N/A')
                if( dot eq -1) then ytitle = ytitle + temp_name
        	hdf_temp_data = reform(hdf_data.components0, n_elements(hdf_data.components0))
		if filldata_value gt 0 then begin
		    subscripts = where(hdf_temp_data lt filldata_value, count)
		endif else begin
		    subscripts = where(hdf_temp_data gt filldata_value, count)
		endelse
                if count ne 0 then begin
		    if info.axis_state lt 6 then begin
                        hdf_temp_data = hdf_temp_data(subscripts)
                        hdf_max = max(hdf_temp_data, min=hdf_min)
			if hdf_max le !y.crange(1) and hdf_min ge !y.crange(0) then begin
				toler=(info.range.y_end - info.range.y_start)/5
				max_diff = info.range.y_end - hdf_max
				min_diff = hdf_min - info.range.y_start
				if abs(max_diff) le toler and abs(min_diff) le toler then begin
					ymax=info.range.y_end
					ymin=info.range.y_start
				endif else begin
					get_range, hdf_max, hdf_min, ymax, ymin
					max_y_range = ymax
					ymax = ymax + (ymax - ymin)*0.15
				endelse
			endif else begin
				get_range, hdf_max, hdf_min, ymax, ymin
				max_y_range = ymax
				ymax = ymax + (ymax - ymin)*0.15
			endelse
			min_value = hdf_min
		    endif else begin
			ymin = info.range.y2_start
			ymax = info.range.y2_end
			max_y_range = ymax
			min_value = ymin
			ymax = ymax + (ymax - ymin)*0.15
		    endelse
			old_x = !X
			old_y = !Y
			change_scale = 1
			if info.style.y2log gt 0 then begin
			    y2range = [ymin, ymax]
			    y2range = set_log_range(y2range, ymin, ymax)
			    ymin = y2range(0)
			    ymax = y2range(1)
			endif else if !Y.TYPE eq 1 then !Y.TYPE = 0
			Axis, YAXIS=1, ytitle = ytitle, /YNOZERO, YRANGE=[ymin, ymax], $
				FONT=info.char.font, charsize=info.char.size, ystyle=3, $
				ticklen=0.01, ylog=info.style.y2log, /SAVE
                endif else begin
                        Axis, YAXIS=1, ytitle = ytitle, FONT=info.char.font, $
                                charsize=info.char.size, ystyle=2, ticklen=0.01, $
				ylog=info.style.ylog, /SAVE
                endelse
        endif
 
	;oplot, hdf_data(*).components0, MAX_VALUE = max_value, $
	oplot, hdf_data(*).components0, MAX_VALUE = max_y_range, MIN_VALUE = min_value, $
		psym = plot_symbol, linestyle=info.style.linetype, $
		symsize = info.style.symbolsize, thick=info.style.linethick, $
		color = info.style.colorindex

	if info.multiple.key eq 1 then begin
		temp_name = info.subset.data(this_subset).src_unitname
		temp_name = temp_name(0)
		dot=strpos(temp_name,'N/A')
		if( dot eq -1) then legend_title = legend_title + temp_name

		y_leg = !Y.WINDOW(1) - 0.03 - 0.025 * info.multiple.number
		y_leg_t = y_leg - 0.005
		x_leg_s = !X.WINDOW(0) + 0.03
		x_leg_e = x_leg_s + 0.05
		leg_start = convert_coord(x_leg_s, y_leg, /NORMAL, /TO_DATA)
		leg_end   = convert_coord(x_leg_e, y_leg, /NORMAL, /TO_DATA)
		oplot, [leg_start(0), leg_end(0)], [leg_start(1), leg_end(1)], $
			psym = plot_symbol, linestyle=info.style.linetype, $
			symsize = info.style.symbolsize, thick=info.style.linethick, $
			color = info.style.colorindex

		xyouts, x_leg_e+0.01, y_leg_t, legend_title, /NORMAL, font=info.char.font, $
			charsize=info.char.size
	endif

	if change_scale eq 1 then begin
		!X = old_x
		!Y = old_y
	endif

endelse

	check_x_margin = size(old_x_margin)
	if check_x_margin(0) ne 0 then !X.MARGIN=old_x_margin

	!P.Position=[0.0, 0.0, 0.0, 0.0]

	widget_control, set_uvalue=info, info.widgets.base
	widget_control, set_uvalue=info, info.base

end

;--------------------------------------------------------------------------------
pro do_2d_image, info, name_of_data, this_subset, print_flag, scale_flag, plot_status

pro_name = 'do_2d_image'
@getinfo

;--------------------------
;  If this is an SDS then
;--------------------------

hdf_data = *info.subset.data(this_subset).src_data
size_hdf = size(hdf_data)

if(size_hdf(0) eq 2) then begin

	this_type = info.subset.data(this_subset).src_types
	this_type = this_type(0)
	filldata_value = get_filldata_value(this_type, info.filldata)
	if filldata_value gt info.filldata then filldata_value = info.filldata
	hdf_temp_data = reform(hdf_data, n_elements(hdf_data))
	if filldata_value gt 0 then begin
	    subscript = where(hdf_temp_data lt filldata_value, count)
	endif else begin
	    subscript = where(hdf_temp_data gt filldata_value, count)
	endelse
	if count eq 0 then begin
	    result=dialog_message('All Data is FILL data!',$
		title='View HDF Warning!')
	    plot_status = 0
	    return
	endif

	top_color = !d.n_colors - 2
	if top_color gt 254 then top_color = 254
	hdf_temp_data = hdf_temp_data(subscript)
	z_max = max(hdf_temp_data, min=z_min)

	if filldata_value gt 0 then begin
	    subscript = where(hdf_data ge filldata_value, count)
	endif else begin
	    subscript = where(hdf_data le filldata_value, count)
	endelse
	if count ne 0 then hdf_data(subscript) = z_min - (z_max - z_min)/top_color

	if ((print_flag eq 0) or (print_flag eq 3)) then plot_dialogue , name_of_data, info

	erase,!P.BACKGROUND

	baroffset = info.d2_image.yoffset * info.screen.ysize

	if scale_flag eq 1 then begin
		xscreen = info.screen.xsize
		yscreen = info.screen.ysize
		if info.d2_image.colorbar eq 1 then yscreen = yscreen - baroffset
		xdata_size = size_hdf(1)
		ydata_size = size_hdf(2)
		xscale = float(xscreen)/float(xdata_size)
		yscale = float(yscreen)/float(ydata_size)

		if xscale gt yscale then scale = yscale else scale = xscale
		xsize = fix(scale * xdata_size)
		ysize = fix(scale * ydata_size)

		;expand, hdf_data, xsize, ysize, hdf_data_z, MAXVAL=info.filldata
		expand, hdf_data, xsize, ysize, hdf_data_z, MAXVAL=z_max
		;tv,hdf_data
        	;tvscl,hdf_data
		if info.d2_image.colorbar eq 1 then begin
		    tvscl,hdf_data_z,0,baroffset,top=top_color, order=info.d2_image.image_order
		endif else begin
		    tvscl,hdf_data_z, top=top_color, order=info.d2_image.image_order
		endelse
        endif else begin
		xsize = size_hdf[1]
		ysize = size_hdf[2]
		if(xsize gt info.screen.xsize) then xsize = info.screen.xsize
		if info.d2_image.colorbar eq 1 then begin
		    tvscl,hdf_data,0,baroffset,top=top_color, order=info.d2_image.image_order
		endif else begin
		    tvscl,hdf_data, top=top_color, order=info.d2_image.image_order
		endelse
	endelse

	if info.d2_image.colorbar eq 1 then begin
	    temp_name = info.subset.data(this_subset).src_unitname
	    temp_name = temp_name(0)
	    temp_length = strlen(temp_name)
	    unitlabel = ''
	    if (temp_length gt 0) then begin
		dot=strpos(temp_name,'N/A')
		if( dot eq -1) then unitlabel = strmid(temp_name,2,temp_length-2)
	    endif
	    deltx = info.d2_image.deltx / 40.0
	    delty = info.d2_image.delty
	    bar_offset = info.d2_image.bar_offset
	    barlength = 40 * deltx
	    x_location = 0.5 * (double(xsize) / info.screen.xsize - barlength)
	    if(x_location lt 0.01) then x_location = 0.01
	    ; x_location = 0.22
	    y_location = baroffset/info.screen.ysize - delty - 0.011
	    if y_location lt 0.0 then y_location = 0.0
	    ;print,'location = ',x_location,', ',y_location
	    draw_color_bar, top_color, z_min, z_max, y_location, x_location, $
		info.char.size, info.char.font, info.greenwich.setformat, $
		info.greenwich.bformat, unitlabel,bar_offset=bar_offset, $
		deltx=deltx, delty=delty
	endif

	print,'xsize = ',xsize,', ysize = ',ysize

	if info.addtext.key eq 1 then write_add_text, info

endif else begin

	the_message = [ 'Data record is not a 2 dimensional array', $
                '2D Image is not valid']
 
	result= dialog_message(the_message, $
		title='View HDF Message!')
 
endelse

end

;--------------------------------------------------------------------------------
pro do_3d_graph, info, name_of_data, this_subset, print_flag, plot_status

pro_name = 'do_3d_graph'
@getinfo

;--------------------------
;  If this is an SDS then
;--------------------------

	this_type = info.subset.data(this_subset).src_types
	this_type = this_type(0)
	filldata_value = get_filldata_value(this_type, info.filldata)
	if filldata_value gt info.filldata then filldata_value = info.filldata
	max_value = get_max_value(this_type, info.filldata)
	if info.filldata gt 0 then begin
	    if max_value gt info.filldata then max_value = info.filldata
	endif

	hdf_data=*info.subset.data(this_subset).src_data
	size_hdf = size(hdf_data)

if(size_hdf(0) eq 2) then begin

        hdf_temp_data = reform(hdf_data, n_elements(hdf_data))
	if filldata_value gt 0 then begin
            subscript = where(hdf_temp_data lt filldata_value, count)
	endif else begin
	    subscript = where(hdf_temp_data gt filldata_value, count)
	endelse
	if count eq 0 then begin
	    result=dialog_message('All Data is FILL data!',$
		title='View HDF Warning!')
	    plot_status = 0
	    return
	endif

	hdf_temp_data = hdf_temp_data(subscript)
	hdf_max = max(hdf_temp_data, min=hdf_min)
	hdf_range = (hdf_max - hdf_min) * 0.05
        hdf_max = hdf_max + hdf_range
        hdf_min = hdf_min - hdf_range

	starting=info.subset.data(this_subset).src_start(0)
	ending=info.subset.data(this_subset).src_end(0)

	info.slide.x_start = info.subset.data(this_subset).src_start(1)
	info.slide.x_end = info.subset.data(this_subset).src_end(1)
	info.slide.y_start = info.subset.data(this_subset).src_start(0)
	info.slide.y_end = info.subset.data(this_subset).src_end(0)

	set_axis_ranges, info, YRange, Ystyle, XRange, Xstyle, ZRange, Zstyle

	rstart = starting
	rend = ending - 1

	hdf_size = size(hdf_data)

	if info.graph_style ne 'Contour' then begin
	   if (info.axis_state eq 1) or (info.axis_state eq 4) or $
	      (info.axis_state eq 5) then begin
		xstart = long(Xrange(0)) - info.subset.data(this_subset).src_start(1)
		if(xstart lt 0) then xstart = 0
		xend = long(Xrange(1)) - info.subset.data(this_subset).src_start(1)
		if(xend gt hdf_size(1)-1) then xend = hdf_size(1)-1
		hdf_data = hdf_data(xstart:xend, *)
		XRange = [0,0]
		Xstyle = 0
	   endif

	   if (info.axis_state eq 2) or (info.axis_state eq 4) or $
	      (info.axis_state eq 5) then begin
		ystart = long(Yrange(0)) - info.subset.data(this_subset).src_start(0)
		if(ystart lt 0) then ystart = 0
		yend = long(Yrange(1)) - info.subset.data(this_subset).src_start(0)
		if(yend gt hdf_size(2)-1) then yend = hdf_size(2)-1
		hdf_data = hdf_data(* , ystart:yend)
		rstart = Yrange(0)
		rend = Yrange(1)
		YRange = [0,0]
		Ystyle = 0
	   endif
	endif

	if (info.axis_state eq 3) or (info.axis_state eq 5) then begin
	    if info.filldata gt 0 then begin
		if ZRange(1) gt info.filldata then hdf_max = info.filldata $
		    else hdf_max = ZRange(1)
	    endif
	    hdf_min = ZRange(0)
	endif

	if (print_flag eq 0) then plot_dialogue , name_of_data, info

	dot=strpos(name_of_data,'[')
	if( dot ne -1) then begin
	  ztitle=strmid(name_of_data,0,dot)
	endif else begin
	  ztitle = name_of_data
	endelse

	data_range = ''
	data_range = get_data_range(this_subset,info)
	the_title = ztitle + ' Data Range: ' + data_range

	temp_name = info.subset.data(this_subset).src_unitname
	temp_name = temp_name(0)
	dot=strpos(temp_name,'N/A')
	if( dot eq -1) then ztitle = ztitle + temp_name

	if info.subset.data(this_subset).src_crit_flag eq 1 then begin
		crit_string = ''
		crit_string = get_crit_string(this_subset, info)
		if info.graph_style ne 'Contour' then the_title = the_title + '!C' + crit_string
	endif

	if(info.graph_style eq '3D Graph') then begin
           ;surface, hdf_data, MAX_VALUE = max_value, $
	    surface, hdf_data, MAX_VALUE = hdf_max, MIN_VALUE = hdf_min, $
	        charsize=info.char.size, $
		linestyle=info.style.linetype, $
                ax=info.rotate.ax, $
                az=info.rotate.az, $
		title=the_title, $
                xtitle='Sample Number', $
                ytitle='Record Number', $
		ztitle=ztitle,ticklen=-0.01, $
                subtitle=info.subset.data(this_subset).src_filename + "  Date:" + systime(0), $
        	xrange=XRange, yrange=YRange, xstyle=Xstyle, ystyle=Ystyle
	endif else if(info.graph_style eq 'Contour') then begin
		if !D.Name eq 'PS' or !D.Name eq 'PRINTER' then begin
			old_charsize = !X.CHARSIZE
			!X.CHARSIZE = 0.9
			!Y.CHARSIZE = 0.9	
		endif else !P.Position = [0.060, 0.100, 0.98, 0.96]
			
		if info.subset.data(this_subset).src_crit_flag eq 1 then begin
			if !D.Name eq 'PS' and info.eps_out.type eq 1 then $
				!P.Position = [0.235, 0.15, 0.99, 0.95] $
				else !P.Position = [0.060, 0.120, 0.98, 0.96]
			temp_name = str_sep(crit_string, '!C')
			num_temp = n_elements(temp_name)
			!P.Position(1) = !P.Position(1) + (num_temp-1)*0.025
		endif

 		get_ticklen, info.style.grid, xticklen, yticklen 

		if !D.Name eq 'PRINTER' or !D.Name eq 'WIN' or info.char.font eq 0 then begin
		    xtitle='Sample Number'
		endif else xtitle='!CSample Number!C'
		c_labels = make_array(info.greenwich.n_level, /int, value=0)
                label_incr = fix((info.greenwich.n_level-1)/10) + 1
                for i = 0, info.greenwich.n_level-1, label_incr do c_labels(i) = 1
           ;contour, hdf_data, MAX_VALUE = max_value, $
	   contour, hdf_data, MAX_VALUE = hdf_max, MIN_VALUE = hdf_min, $
		FONT=info.char.font, $
	        charsize=info.char.size, $
		nlevels = info.greenwich.n_level, $
		c_labels=c_labels, $
		c_linestyle=info.style.linetype, $
		title=the_title, $
                xtitle=xtitle, $
                ytitle='Record Number', $
		ztitle=ztitle,xticklen=xticklen, yticklen=yticklen, $
                subtitle=info.subset.data(this_subset).src_filename + "  Date:" + systime(0), $
        	xrange=XRange, yrange=YRange, xstyle=Xstyle, ystyle=Ystyle

                if info.subset.data(this_subset).src_crit_flag eq 1 then begin
			if !D.Name eq 'PS' or !D.Name eq 'PRINTER' then begin
				charsize = 0.9*info.char.size
				y_location = 0.125
			endif else begin
				charsize = info.char.size
				y_location = 0.11
			endelse
                        ;xyouts, !P.Position(0), !P.Position(1)-y_location, crit_string, /NORMAL, $
                        xyouts, 0.08, !P.Position(1)-y_location, crit_string, /NORMAL, $
			font=info.char.font, charsize=charsize
                endif
		!P.Position=[0.0, 0.0, 0.0, 0.0]
		if !D.Name eq 'PS' or !D.Name eq 'PRINTER' then begin
			!X.CHARSIZE = old_charsize
			!Y.CHARSIZE = old_charsize
		endif
 
	endif else begin
           ;shade_surf, hdf_data, MAX_VALUE = max_value, $
	   shade_surf, hdf_data, MAX_VALUE = hdf_max, MIN_VALUE = hdf_min, $
	        charsize=info.char.size, $
                ax=info.rotate.ax, $
                az=info.rotate.az, $
		title=the_title, $
                xtitle='Sample Number', $
                ytitle='Record Number', $
		ztitle=ztitle,ticklen=-0.01, $
                subtitle=info.subset.data(this_subset).src_filename + "  Date:" + systime(0), $
        	xrange=XRange, yrange=YRange, xstyle=Xstyle, ystyle=Ystyle, $
                /lego
	endelse

	if info.addtext.key eq 1 then write_add_text, info

endif else begin

;--------------------------
; Vdata
;--------------------------

if(info.graph_style eq '3D Graph') then begin
	the_message = [ 'Data record is not a 2 dimensional array', $
                '3D Graph plot is not valid']
endif else if(info.graph_style eq 'Contour') then begin
	the_message = [ 'Data record is not a 2 dimensional array', $
                'Contour plot is not valid']
endif else begin
	the_message = [ 'Data record is not a 2 dimensional array', $
                '3D Surface plot is not valid']
endelse
 
result= dialog_message(the_message, $
          title='View HDF Message!')
plot_status = 0
return
 
endelse

widget_control, set_uvalue = info, info.widgets.base
widget_control, set_uvalue = info, info.base

end

;--------------------------------------------------------------------------------
pro map_create, info, map_charsize, the_title, xrange, yrange, londel, latdel

pro_name = 'map_create'
@getinfo

; Set the e_struct according the setting
if info.greenwich.high_resol eq 1 then begin
    if info.greenwich.coasts eq 1 then begin
	e_struct = {hires:1, coasts:1, mlinethick:info.greenwich.mlinethick}
    endif else begin
	e_struct = {hires:1, mlinethick:info.greenwich.mlinethick}
    endelse
endif else begin
    if info.greenwich.coasts eq 1 then begin
	e_struct = {coasts:1, mlinethick:info.greenwich.mlinethick}
    endif else begin
	e_struct = {mlinethick:info.greenwich.mlinethick}
    endelse
endelse

;  Turn off the !QUIET
old_quiet = !QUIET
!QUIET=1
!P.FONT = info.char.font

case info.greenwich.projection of
    1: begin
	if info.axis_state eq 0 or info.axis_state eq 3 or info.greenwich.whole eq 1 then begin
	    londel = 15
	    map_set,info.greenwich.lat_loc,info.greenwich.greenloca, /orthographic, $
		/isotropic, /horizon, charsize=map_charsize, title=the_title, $
		noborder=info.greenwich.noborder, e_continents=e_struct
	endif else begin
	    londiff = XRange(1) - XRange(0)
	    londel = get_number(londiff/6.0)
	    latdiff = YRange(1) - YRange(0)
	    latdel = get_number(latdiff/6.0)
	    map_set,info.greenwich.lat_loc,info.greenwich.greenloca, /orthographic, $
		/isotropic, charsize=map_charsize, title=the_title, /horizon, $
		noborder=info.greenwich.noborder, e_continents=e_struct, $
		limit=[YRange(0), XRange(0), YRange(1), XRange(1)]
	endelse
    end
    2  : begin
	if info.axis_state eq 0 or info.axis_state eq 3 or info.greenwich.whole eq 1 then begin
	    londel = 15
	    map_set,info.greenwich.lat_loc,info.greenwich.greenloca, /stereographic, $
		/isotropic, /horizon, charsize=map_charsize, title=the_title, $
		noborder=info.greenwich.noborder, e_continents=e_struct
	endif else begin
	    londiff = XRange(1) - XRange(0)
	    londel = get_number(londiff/6.0)
	    latdiff = YRange(1) - YRange(0)
	    latdel = get_number(latdiff/6.0)
	    map_set,info.greenwich.lat_loc,info.greenwich.greenloca, /stereographic, $
		/isotropic, charsize=map_charsize, title=the_title, /horizon, $
		noborder=info.greenwich.noborder, e_continents=e_struct, $
		limit=[YRange(0), XRange(0), YRange(1), XRange(1)]
	endelse
    end
    3: begin
	if info.axis_state eq 0 or info.axis_state eq 3 or info.greenwich.whole eq 1 then begin
	    londel = 30
	    map_set,info.greenwich.lat_loc,info.greenwich.greenloca, /hammer, $
		/isotropic, /horizon, charsize=map_charsize, title=the_title, $
		noborder=info.greenwich.noborder, e_continents=e_struct
	endif else begin
	    londiff = XRange(1) - XRange(0)
	    londel = get_number(londiff/6.0)
	    latdiff = YRange(1) - YRange(0)
	    latdel = get_number(latdiff/6.0)
	    map_set,info.greenwich.lat_loc,info.greenwich.greenloca, /hammer, $
		/isotropic, charsize=map_charsize, title=the_title, /horizon, $
		noborder=info.greenwich.noborder, e_continents=e_struct, $
		limit=[YRange(0), XRange(0), YRange(1), XRange(1)]
	endelse
    end
    4: begin
	sat_p = [info.greenwich.altitude, info.greenwich.tilt, info.greenwich.rotation]
	if info.axis_state eq 0 or info.axis_state eq 3 or info.greenwich.whole eq 1 then begin
	    londel = 30
	    map_set,info.greenwich.lat_loc,info.greenwich.greenloca, /satellite, $
		/isotropic, charsize=map_charsize, title=the_title, /horizon, $
		noborder=info.greenwich.noborder, e_continents=e_struct, $
		sat_p=sat_p
	endif else begin
	    londiff = XRange(1) - XRange(0)
	    londel = get_number(londiff/6.0)
	    latdiff = YRange(1) - YRange(0)
	    latdel = get_number(latdiff/6.0)
	    map_set,info.greenwich.lat_loc,info.greenwich.greenloca, /satellite, $
		/isotropic, charsize=map_charsize, title=the_title, /horizon, $
		noborder=info.greenwich.noborder, e_continents=e_struct, $
		limit=[YRange(0), XRange(0), YRange(1), XRange(1)], sat_p=sat_p
	endelse
    end
    else: begin
	if info.axis_state eq 0 or info.axis_state eq 3 or info.greenwich.whole eq 1 then begin
	    londel = 45
	    map_set,info.greenwich.lat_loc,info.greenwich.greenloca, /cylindrical, $
		/isotropic, charsize=map_charsize, title=the_title, $
		noborder=info.greenwich.noborder, e_continents=e_struct
	endif else begin
	    londiff = XRange(1) - XRange(0)
	    londel = get_number(londiff/6.0)
	    latdiff = YRange(1) - YRange(0)
	    latdel = get_number(latdiff/6.0)
	    map_set,info.greenwich.lat_loc,info.greenwich.greenloca, /cylindrical, $
		/isotropic, charsize=map_charsize, title=the_title, $
		noborder=info.greenwich.noborder, e_continents=e_struct, $
		limit=[YRange(0), XRange(0), YRange(1), XRange(1)]
	endelse
    end
endcase

!QUIET = old_quiet

if info.greenwich.grid eq 1 then begin
    if info.axis_state eq 0 or info.axis_state eq 3 then begin
	map_grid, LABEL=info.greenwich.label, charsize = map_charsize, londel=londel, $
	    glinethick = info.greenwich.glinethick
    endif else begin
	map_grid, LABEL=info.greenwich.label, charsize = map_charsize, londel=londel, $
		latdel=latdel, glinethick = info.greenwich.glinethick
    endelse
endif

end

;--------------------------------------------------------------------------------
pro adjust_plot_size, this_subset, goodratio, ydelt, bar_offset, x_bar_offset, info

pro_name = 'adjust_plot_size'
@getinfo

if goodratio lt 1.0 then begin
    goodyrange = (!P.position(2) - !p.position(0))*goodratio
    if goodyrange + 0.001 lt !P.position(3) - !p.position(1) then begin
	halfyrange = 0.5 * goodyrange
	goodymin = 0.5 - halfyrange - ydelt
	goodymax = 0.5 + halfyrange + ydelt
	;if info.eps_out.newsize eq 1 and info.eps_out.flag eq 1 and info.eps_out.type eq 1 then begin
	if info.eps_out.newsize eq 1 and info.eps_out.flag eq 1 then begin
	    new_y_size = !d.y_size * (goodymax-goodymin)/(!P.position(3) - !p.position(1))
	    low_region = !p.position(1) * new_y_size
	    if low_region lt 2540 then begin
		top_region = new_y_size * (1.0 - !p.position(1))
		if info.color_bar eq 1 then new_y_size = new_y_size + 1250
		if info.subset.data(this_subset).src_crit_flag eq 1 then begin
		    if info.color_bar eq 1 then new_y_size = new_y_size + 500 $
			else new_y_size = new_y_size + 1250
		endif
		if info.greenwich.projection eq 4 then begin
		    if info.color_bar eq 1 then begin
			new_y_size = new_y_size + 500
		    endif else if info.subset.data(this_subset).src_crit_flag eq 1 then begin
			new_y_size = new_y_size + 250 
		    endif else new_y_size = new_y_size + 1250
		endif
		!p.position(1) = 1.0 - (top_region / new_y_size)
	    endif
	    bar_offset = bar_offset * !d.y_size / new_y_size
	    if(abs(bar_offset) lt 0.03) then begin
		if bar_offset gt 0.0 then bar_offset = 0.03 else bar_offset = - 0.03
	    endif
	    new_y_size = new_y_size/2540
	    device, /inches, xsize=!d.x_size/2540, ysize=new_y_size
	endif else begin
	    if goodymin gt !P.position(1) then !p.position(1) = goodymin
	    if goodymax lt !P.position(3) then !p.position(3) = goodymax
	endelse
    endif
endif else begin
    ;if info.eps_out.newsize eq 1 and info.eps_out.flag eq 1 and info.eps_out.type eq 0 then begin
    if info.eps_out.newsize eq 1 and info.eps_out.flag eq 1 then begin
	goodxrange = (!P.position(3) - !p.position(1))/goodratio
	if goodxrange + 0.001 lt !P.position(2) - !p.position(0) then begin
	    halfxrange = 0.5 * goodxrange
	    goodxmin = 0.5 - halfxrange - ydelt
	    goodxmax = 0.5 + halfxrange + ydelt
	    new_x_size = !d.x_size * (goodxmax-goodxmin)/(!P.position(2) - !p.position(0))
	    new_x_size = new_x_size + 2540.0 * 2.0
	    x_bar_offset = x_bar_offset * !d.x_size / new_x_size
	    bar_start = !P.Position(0) + (!P.Position(2) - !P.Position(0))/2. - x_bar_offset
	    if bar_start lt 0.07 then begin
		left_region = new_x_size * (1.0 - !p.position(0))
		new_x_size = new_x_size + 2540.0
		!p.position(0) = 1.0 - ((left_region + 1270.0) / (new_x_size-1270.0))
	    endif
	    new_x_size = new_x_size/2540
	    if info.eps_out.type eq 1 then begin
		yoffset = new_x_size + new_x_size * 1.25 / 9.0
		device, /inches, xsize=new_x_size, ysize=!d.y_size/2540, yoffset=yoffset
	    endif else device, /inches, xsize=new_x_size, ysize=!d.y_size/2540
	endif
    endif
endelse

end

;--------------------------------------------------------------------------------
pro do_grid_contour, info, name_of_data, this_subset, print_flag, plot_type, plot_status

pro_name = 'do_grid_contour'
@getinfo

;--------------------------
; If this is an SDS then
;--------------------------

if print_flag eq 0 then begin
	hdf_data_array=*info.subset.data(this_subset).src_data
	if plot_type eq 1 or plot_type eq 3 then begin
		get_region_number, this_subset, info
		widget_control, get_uvalue=info, info.base
		if info.canceloption eq 'Yes' then begin
			info.canceloption = 'No'
			widget_control, set_uvalue=info, info.base
			plot_status = 0
			return
		endif
		hdf_data_array=*info.xyvalue.x_index
	endif else begin
		if ptr_valid(info.xyvalue.x_index) then $
			ptr_free, info.xyvalue.x_index
		info.xyvalue.x_index=ptr_new(hdf_data_array)
	endelse
	info.overlay.flag = 0
	info.overlay.offflag = 0
endif else begin
	hdf_data_array=*info.xyvalue.x_index
endelse
hdf_array_size = size(hdf_data_array)

if hdf_array_size(0) eq 3 then begin
	end_plot = hdf_array_size(3)
endif else if hdf_array_size(0) eq 2 then begin
	end_plot = 1
	check_zone=strpos(name_of_data,'Z)')
	if info.vgroup.flag eq 1 and check_zone eq -1 then begin
		check_string = strlowcase(info.vgroup.name_string)
		check_vg=strpos(check_string, 'zon')
		check_sub = where(check_vg ne -1, count)
		if count gt 0 then check_zone = 1
	endif
	if( check_zone ne -1) then begin
		hdf_data_temp = replicate(hdf_data_array(0,0), 2*hdf_array_size(1), $
			hdf_array_size(1), hdf_array_size(2))
		for j = 0, hdf_array_size(2)-1 do begin
			for i = 0, hdf_array_size(1) - 1 do begin
				hdf_data_temp(*, i, j) = hdf_data_array(i, j)
			endfor
		endfor
		hdf_data_array = hdf_data_temp
		hdf_array_size = size(hdf_data_array)
		end_plot = hdf_array_size(3)
	endif

	if (hdf_array_size(1) eq 180) and (hdf_array_size(2) ne 360) then begin
		hdf_data_temp = replicate(hdf_data_array(0,0), 2*hdf_array_size(1), $
			hdf_array_size(1), hdf_array_size(2))
		for j = 0, hdf_array_size(2)-1 do begin
			for i = 0, hdf_array_size(1) - 1 do begin
				hdf_data_temp(*, i, j) = hdf_data_array(i, j)
			endfor
		endfor
		hdf_data_array = hdf_data_temp
		hdf_array_size = size(hdf_data_array)
		end_plot = hdf_array_size(3)
	endif

endif else if hdf_array_size(0) eq 1 then begin
	check_zone=strpos(name_of_data,'Z)')
	if info.vgroup.flag eq 1 and check_zone eq -1 then begin
		check_string = strlowcase(info.vgroup.name_string)
		check_vg=strpos(check_string, 'zon')
		;check_vg=strpos(info.vgroup.name_string, 'Zon')
		check_sub = where(check_vg ne -1, count)
		if count gt 0 then check_zone = 1
	endif
	if( check_zone ne -1) then begin
		hdf_data_temp = replicate(hdf_data_array(0), 2*hdf_array_size(1), $
			hdf_array_size(1))
		for i = 0, hdf_array_size(1) - 1 do begin
			hdf_data_temp(*, i) = hdf_data_array(i)
		endfor
		hdf_data_array = hdf_data_temp
		hdf_array_size = size(hdf_data_array)
		end_plot = 1
	endif else if (hdf_array_size(1) eq 180) and (hdf_array_size(2) ne 360) then begin
		hdf_data_temp = replicate(hdf_data_array(0), 2*hdf_array_size(1), $
			hdf_array_size(1))
		for i = 0, hdf_array_size(1) - 1 do begin
			hdf_data_temp(*, i) = hdf_data_array(i)
		endfor
		hdf_data_array = hdf_data_temp
		hdf_array_size = size(hdf_data_array)
		end_plot = 1
	endif else begin
		the_message=[ 'The data set is not two or three dimensional arrays', $
			'It is not valid for Grid Cell or Grid Contour']
		result=dialog_message(the_message, title='View HDF Warning!')
		plot_status = 0
		return
	endelse

endif else begin
	the_message=[ 'The data set is not two or three dimensional arrays', $
		'It is not valid for Grid Cell or Grid Contour']
	result=dialog_message(the_message, title='View HDF Warning!')
	plot_status = 0
	return
endelse

ijk = 0
while ijk lt end_plot do begin

  if hdf_array_size(0) eq 3 then hdf_data = hdf_data_array(*,*,ijk) $
	else hdf_data = hdf_data_array

  hdf_size = size(hdf_data)

  if(hdf_size(0) eq 2) then begin

	xinterval = 360.0 / hdf_size(1)
	yinterval = 180.0 / hdf_size(2)
	if hdf_array_size(0) eq 3 then begin
		info.slide.x_start = info.subset.data(this_subset).src_start(2) * xinterval
		info.slide.x_end = info.subset.data(this_subset).src_end(2) * xinterval
		info.slide.y_start = info.subset.data(this_subset).src_start(1) * yinterval
		info.slide.y_end = info.subset.data(this_subset).src_end(1) * yinterval
	endif else begin
		info.slide.x_start = info.subset.data(this_subset).src_start(1) * xinterval
		info.slide.x_end = info.subset.data(this_subset).src_end(1) * xinterval
		info.slide.y_start = info.subset.data(this_subset).src_start(0) * yinterval
		info.slide.y_end = info.subset.data(this_subset).src_end(0) * yinterval
	endelse

	set_axis_ranges, info, YRange, Ystyle, XRange, Xstyle, ZRange, Zstyle
	y_axis_state = 0
	if info.axis_state eq 2 or info.axis_state eq 4 or info.axis_state eq 5 then begin
	    if YRange[0] ge YRange[1] then begin
		the_message = ['The range of latitude is not right!', $
			'Check the range and do it again!']
		result=dialog_message(the_message, title='View HDF Warning!')
		plot_status = 0
		return
	    endif
	    y_axis_state = 1
	endif

	cross_green = 0
	x_axis_state = 0
	if info.axis_state eq 1 or info.axis_state eq 4 or info.axis_state eq 5 then begin
	    If XRange[0] lt 0.0 and XRange[1] ge 0.0 then begin
		If XRange[0] ge -180.0 and XRange[1] le 180.0 then cross_green = 1 $
		else begin
		    the_message = ['The ranges of longitude is not right!', $
			'Check the ranges and do it again!']
		    result=dialog_message(the_message, title='View HDF Warning!')
		    plot_status = 0
		    return
		endelse
	    endif

	    if XRange[0] gt XRange[1] then begin
		if XRange[0] lt 360.0 and XRange[1] ge 0.0 then begin
		    XRange[0] = XRange[0] - 360.0
		    cross_green = 1
		endif else begin
		    the_message = ['The ranges of longitude is not right!', $
			'Check the ranges and do it again!']
		    result=dialog_message(the_message, title='View HDF Warning!')
		    plot_status = 0
		    return
		endelse
	    endif
	    x_axis_state = 1
	    ;if x axis is set, cannot use map_image
	    if (plot_type lt 2) and (info.greenwich.contour eq 1) then $
		info.greenwich.contour = 0
	endif

	if (print_flag eq 0) then plot_dialogue , name_of_data, info

	print_flag = 1

	dot=strpos(name_of_data,'[')
	if( dot ne -1) then begin
		ytitle=strmid(name_of_data,0,dot)
	endif else begin
		ytitle = name_of_data
	endelse

	the_title=ytitle
	if hdf_array_size(0) eq 3 then begin
		the_start = info.subset.data(this_subset).src_start(0)
		the_incre = info.subset.data(this_subset).src_increment(0)
		the_end = info.subset.data(this_subset).src_end(0)
		the_current = the_start + ijk * the_incre
		the_title = the_title + ' (' + strcompress(string(the_current+1)) + ' of ' $
			+ strcompress(string(the_end)) + ')'
	endif

	data_range = ''
	data_range = get_data_range(this_subset, info)
	the_title = the_title + ' Data Range: ' + data_range

	if !D.Name eq 'PS' or !D.Name eq 'PRINTER' or !D.Name eq 'WIN' or info.char.font eq 0 then begin
		the_title=the_title+'!C'+info.subset.data(this_subset).src_filename+ ' '+systime(0)
	endif else begin
		the_title=the_title+'!C!C'+info.subset.data(this_subset).src_filename+ ' '+systime(0)
	endelse

	top_color = !d.n_colors - 2
	if top_color gt 254 then top_color = 254

	if info.color_table ne 0 and info.pick_color_table eq 0 then $
		check_bw = check_color_table(top_color) $
		else check_bw = 0
	if check_bw eq 1 then begin
		if info.device eq 'X' then begin
		    color_table_file=info.home_path+"/"+"view_hdf_color.tbl"
		endif else begin
		    color_table_file=info.home_path+"\"+"view_hdf_color.tbl"
		endelse
		test_file = findfile(color_table_file, count=count)
		if count eq 0 then color_table_file = 'view_hdf_color.tbl'
		loadct, info.color_table, file=color_table_file, ncolors=info.top_color
        endif

	if info.subset.data(this_subset).src_crit_flag eq 1 or $
	    info.greenwich.projection eq 4 then begin
		crit_string = ''
		if info.subset.data(this_subset).src_crit_flag eq 1 then $
		    crit_string = get_crit_string(this_subset, info)
		if !D.Name eq 'PS' or !D.Name eq 'PRINTER' then begin
			if info.eps_out.type eq 1 then $
				!P.Position = [0.25, 0.16, 0.99, 0.825] $
			else !P.Position = [0.01, 0.16, 0.99, 0.825]
		endif else begin
			!P.Position = [0.01, 0.150, 0.99, 0.93]
			if(top_color gt info.top_color) then top_color = info.top_color
		endelse
		if info.greenwich.projection eq 4 then begin
		    if info.subset.data(this_subset).src_crit_flag eq 1 then begin
			if !D.Name eq 'PS' or !D.Name eq 'PRINTER' or !D.Name eq 'WIN' or $
			  info.char.font eq 0 then begin
			    sat_string = '!C'
			endif else sat_string = '!C!C'
		    endif else sat_string = ''
		    sat_string = sat_string+'Satellite projection: altitude = '+ $
			strcompress(string((info.greenwich.altitude-1.0)*6371.0), /REMOVE_ALL)+' km'
		    sat_string = sat_string + ', tilt angle = '+ $
			strcompress(string(info.greenwich.tilt), /REMOVE_ALL)+' deg'
		    sat_string = sat_string + ', rotation angle = '+ $
			strcompress(string(info.greenwich.rotation), /REMOVE_ALL)+' deg'
		    crit_string = crit_string + sat_string
		endif
		temp_name = str_sep(crit_string, '!C')
		num_temp = n_elements(temp_name)
		!P.Position(1) = !P.Position(1) + (num_temp-1)*0.025
		;if info.color_bar eq 1 then barlocation = !P.Position(1) - 0.03 $
		;	else barlocation = !P.Position(1) + 0.04
		if info.color_bar eq 1 then bar_offset = - 0.03 else bar_offset = -0.01
	endif else begin
		if !D.Name eq 'PS' or !D.Name eq 'PRINTER' then begin
			if info.eps_out.type eq 1 then $
	                        !P.Position = [0.25, 0.16, 0.99, 0.825] $
			else !P.Position = [0.01, 0.16, 0.99, 0.825]
		endif else begin
			!P.Position = [0.01, 0.13, 0.99, 0.93]
			if(top_color gt info.top_color) then top_color = info.top_color
		endelse
        	;barlocation = !P.Position(1) - 0.03
		bar_offset = - 0.03
	endelse

	x_bar_offset = 0.22
	if info.eps_out.flag eq 1 and info.eps_out.title eq 1 then !P.Position(3) = 0.93

	if (Xrange(0) eq Xrange(1)) or info.greenwich.whole eq 1 then begin
	    xmax = 180.0
	    xmin = -180.0
	    if Xrange(0) eq Xrange(1) then begin
		Xrange(0) = -180.0
		Xrange(1) = 180.0
	    endif
	endif else begin
	    xmax = Xrange(1)
	    xmin = Xrange(0)
	endelse
	if (Yrange(0) eq Yrange(1)) or info.greenwich.whole eq 1 then begin
	    ymax = 90.0
	    ymin = -90.0
	    if Yrange(0) eq Yrange(1) then begin
		Yrange(0) = -90.0
		Yrange(1) = 90.0
	    endif
	endif else begin
	    ymax = Yrange(1)
	    ymin = Yrange(0)
	endelse
	ratio = (ymax - ymin)/(xmax - xmin)
	if !D.Name eq 'PS' or !D.Name eq 'PRINTER' then begin
	    goodratio = 1.357142 * ratio 
	    ydelt = 0.01
	endif else begin
	    goodratio = 1.63265 * ratio
	    ydelt = 0.03
	endelse

	adjust_plot_size, this_subset, goodratio, ydelt, bar_offset, x_bar_offset, info

	barlocation = !P.Position(1) + bar_offset

	map_charsize = 0.75 * info.char.size
	;map_color = !d.n_colors/3
	map_color = top_color/3
	;map_color = top_color
	if info.eps_out.flag eq 1 and info.eps_out.title eq 1 then the_title = ''
	map_create, info, map_charsize, the_title, xrange, yrange, londel, latdel
        ;map_continents,mlinethick=info.greenwich.mlinethick

	;  Don't need to redraw the continents, it already does in map_create
	;  Turn off the warning in case no high resolution maps are installed.
	;if info.greenwich.high_resol eq 1 then begin
	    ;old_quiet = !QUIET
	    ;!QUIET=1
	    ;if info.greenwich.coasts eq 1 then begin
		;map_continents,/coasts, /hires, mlinethick=info.greenwich.mlinethick
	    ;endif else begin
		;map_continents, /hires, mlinethick=info.greenwich.mlinethick
	    ;endelse
	    ;!QUIET = old_quiet
	;endif else begin
	    ;map_continents,/coasts, mlinethick=info.greenwich.mlinethick
	;endelse

	this_type = info.subset.data(this_subset).src_types
	this_type = this_type(0)
	filldata_value = get_filldata_value(this_type, info.filldata)
	if filldata_value gt info.filldata then filldata_value = info.filldata
	max_value = get_max_value(this_type, info.filldata)
	if info.filldata gt 0 then begin
	    if max_value gt info.filldata then max_value = info.filldata
	endif

	sizehdf = size(hdf_data)
	if sizehdf(0) ne 2 then begin
		if(info.graph_style eq 'Grid Contour' or $
		   info.graph_style eq 'Grid Contour - Region') then begin
			the_message = [ 'Data record is not a 2 dimensional array', $
				'Grid Contour plot is not valid']
		endif else begin
			the_message = [ 'Data record is not a 2 dimensional array', $
				'Grid Cell plot is not valid']
		endelse
                result=dialog_message(the_message, title='View HDF Warning!')
		return
        endif
	if plot_type ne 1 and plot_type ne 3 then begin
	    src_rank = info.subset.data(this_subset).src_rank
	    src_start = info.subset.data(this_subset).src_start
	    src_end = info.subset.data(this_subset).src_end
	    src_increment = info.subset.data(this_subset).src_increment
	    src_org_rank = info.subset.data(this_subset).src_org_rank
	    src_org_start = info.subset.data(this_subset).src_org_start
	    src_org_end = info.subset.data(this_subset).src_org_end
	    real_org_dims = get_real_sds_dims(info, this_subset, real_org_rank)
	    if real_org_dims(0) lt 0.0 then begin
		whole_array = 1
		whole_y_array = 1
		whole_x_array = 1
		real_x_dim = sizehdf(1)
		real_y_dim = sizehdf(2)
	    endif else begin
		;  Check the orginal dimensions for the data set
		if src_rank eq 3 then start_i = 1 else start_i = 0
		get_dim = -1
		org_i = 0
		while(get_dim lt 0 and org_i lt src_org_rank) do begin
		    if(src_end(start_i) eq src_org_end(org_i)) then begin
			real_y_dim = real_org_dims(org_i)
			real_x_dim = real_org_dims(org_i+1)
			get_dim = 1
		    endif else org_i = org_i + 1
		endwhile
	
		if get_dim lt 0 then begin
		    whole_array = 1
		    whole_y_array = 1
		    whole_x_array = 1
		    real_x_dim = sizehdf(1)
		    real_y_dim = sizehdf(2)
		endif else begin

		    whole_array = 1
		    whole_y_array = 1
		    whole_x_array = 1
		    if real_y_dim ne sizehdf(2) or real_x_dim ne sizehdf(1) then begin
			whole_array = 0
			if real_y_dim ne sizehdf(2) then whole_y_array = 0
			if real_x_dim ne sizehdf(1) then whole_x_array = 0
		    endif
		endelse
	    endelse
	endif else begin
	    whole_array = 1
	    whole_y_array = 1
	    whole_x_array = 1
	    real_x_dim = sizehdf(1)
	    real_y_dim = sizehdf(2)
        endelse

	;  if dimensions are not equal to real, need to set to whole_array
	if whole_array eq 0 then begin
	    size_hdf = size(hdf_data)
	    x_size = src_end(start_i+1) - src_start(start_i+1)
	    y_size = src_end(start_i) - src_start(start_i)
	    ;print,'size_hdf[1] = ',size_hdf[1],', size_hdf[2] = ', size_hdf[2]
	    ;print,'x_size = ',x_size,', y_size = ',y_size
	    if size_hdf[1] ne x_size or size_hdf[2] ne y_size then begin
		if src_increment(start_i+1) eq 1 and src_increment(start_i) eq 1 then begin
		    whole_array = 1
		    whole_y_array = 1
		    whole_x_array = 1
		    real_x_dim = sizehdf(1)
		    real_y_dim = sizehdf(2)
		endif else begin
		    ;x_size = ((src_end(start_i+1) - src_start(start_i+1)) / src_increment(start_i+1)) + 1
		    ;y_size = ((src_end(start_i) - src_start(start_i)) / src_increment(start_i)) + 1
		    x_size = long((src_end(start_i+1)-src_start(start_i+1)-1)/float(src_increment(start_i+1)) + 1.0)
		    y_size = long((src_end(start_i)-src_start(start_i)-1)/float(src_increment(start_i+1)) + 1.0)
		    ;print,'x_size = ',x_size,', y_size = ',y_size,', size_hdf = ',size_hdf[1],size_hdf[2]
		    if size_hdf[1] ne x_size or size_hdf[2] ne y_size then begin
			whole_array = 1
			whole_y_array = 1
			whole_x_array = 1
			real_x_dim = sizehdf(1)
			real_y_dim = sizehdf(2)
		    endif else begin
			src_start(start_i+1) = src_start(start_i+1) / src_increment(start_i+1)
			src_end(start_i+1) = src_end(start_i+1) / src_increment(start_i+1) 
			src_start(start_i) = src_start(start_i) / src_increment(start_i)
			src_end(start_i) = src_end(start_i) / src_increment(start_i)
			real_x_dim = real_x_dim / src_increment(start_i+1)
			real_y_dim = real_y_dim / src_increment(start_i)
			;print,' real_x_dim = ', real_x_dim,', real_y_dim = ',real_y_dim
			;print,'src_start = ',src_start
			;print,'src_end = ',src_end
			whole_array = 1
			whole_y_array = 1
			whole_x_array = 1
			if real_y_dim ne sizehdf(2) or real_x_dim ne sizehdf(1) then begin
			    whole_array = 0
			    if real_y_dim ne sizehdf(2) then whole_y_array = 0
			    if real_x_dim ne sizehdf(1) then whole_x_array = 0
			endif
			; Check one more time when whole_array eq 0
			if whole_array eq 0 then begin
			    x_size = src_end(start_i+1) - src_start(start_i+1)
			    y_size = src_end(start_i) - src_start(start_i)
			    if size_hdf[1] ne x_size or size_hdf[2] ne y_size then begin
				whole_array = 1
				whole_y_array = 1
				whole_x_array = 1
				real_x_dim = sizehdf(1)
				real_y_dim = sizehdf(2)
			    endif
			endif
		    endelse
		endelse
	    endif
	endif

	;print,'whole_array = ',whole_array,', whole_y_array = ',whole_y_array,', whole_x_array = ',whole_x_array
	
	;xinterval = 360.0 / sizehdf(1)
	;yinterval = 180.0 / sizehdf(2)
	;hdf_data_x = findgen(sizehdf(1)) * xinterval + xinterval/2.0
	;hdf_data_y = findgen(sizehdf(2)) * yinterval + yinterval/2.0
	xinterval = 360.0 / real_x_dim
	yinterval = 180.0 / real_y_dim
	hdf_data_x = findgen(real_x_dim) * xinterval + xinterval/2.0
	hdf_data_y = findgen(real_y_dim) * yinterval + yinterval/2.0
	hdf_data_y(*) = 90.0 - hdf_data_y(*)

	if whole_array eq 0 then begin
	    filldata = get_filldata(this_type, info.filldata)
	    hdf_data_temp = make_array(real_x_dim, real_y_dim, /float, value = filldata)
	    hdf_data_temp(src_start(start_i+1):src_end(start_i+1)-1, $
	    src_start(start_i):src_end(start_i)-1) = hdf_data
	    hdf_data = hdf_data_temp
	endif

	; if south to north, reverse to north to south
	if info.grid_start.lat eq 1 then hdf_data = reverse(hdf_data, 2)

	if info.grid_start.long gt 180 and info.grid_start.long le 360 then $
		grid_start = info.grid_start.long - 360 $
	else grid_start = info.grid_start.long
	if grid_start gt 360 or grid_start lt -180 then begin
		;if sizehdf(1) eq 360 then grid_start = -180 $
		if real_x_dim eq 360 then grid_start = -180 $
			else grid_start = 0
	endif
	num_data_shift = fix(grid_start / xinterval)
	;if ABS(num_data_shift) gt sizehdf(1) then num_data_shift = 0
	if ABS(num_data_shift) gt real_x_dim then num_data_shift = 0
	if num_data_shift ne 0 then $
		hdf_data = shift(hdf_data, num_data_shift, 0)
	final_shift = num_data_shift

	z_temp_max = max(hdf_data, min=z_temp_min)
	hdf_data_temp = hdf_data
	bad_data = hdf_data_temp(0,0) + 1.0
	if bad_data gt 0 then bad_data = -32760
	if filldata_value gt 0 then begin
	    subscripts = where(hdf_data_temp gt bad_data and hdf_data_temp lt filldata_value, count)
	endif else begin
	    subscripts = where(hdf_data_temp gt bad_data and hdf_data_temp gt filldata_value, count)
	endelse
	if(count ne 0) then begin
		hdf_data_temp = hdf_data_temp(subscripts)

	if (info.axis_state eq 3) or (info.axis_state eq 5) then begin
		z_min = ZRange(0)
		z_max = ZRange(1)
		Zstyle = 0
	endif else begin
		z_max = max(hdf_data_temp, min = z_min)
		if plot_type eq 0 then begin
		    hdf_range = (z_max - z_min) * 0.05
		    z_max = z_max + hdf_range
		    z_min = z_min - hdf_range
		endif
		get_max_min, z_max, z_min
	endelse

	info.overlay.zmax = z_max
	info.overlay.zmin = z_min

	if info.greenwich.with_level eq 2 then begin
	    info.greenwich.in_level = 0
	    if z_max lt 1.0 then info.greenwich.with_level = 1 $
	    else begin
		if z_min lt 1.0 then z_min = 1.0
	    endelse
	endif

	n_level = info.greenwich.n_level

	; manual set level range
	if info.greenwich.in_level eq 1 then begin
	    temp_range = str_sep(info.greenwich.range, ';')
	    num_range = n_elements(temp_range)
	    if info.greenwich.ext_level eq 0 then begin
		n_level = num_range + 1
		vlevel = double(temp_range)
		vlevel = [vlevel(0), vlevel, vlevel(num_range-1)]
	    endif else begin
		n_level = num_range - 1
		vlevel = double(temp_range)
	    endelse
	    if z_min gt vlevel(0) then z_min = vlevel(0)
	    if z_max lt vlevel(n_level) then z_max = vlevel(n_level)
	    data_interval = vlevel(n_level-1)-vlevel(n_level-2)
	    tempa = findgen(n_level)
	; auto set level range
	endif else begin
	    tempa = findgen(n_level)
	    if info.greenwich.with_level eq 2 then begin
		if ((info.axis_state eq 3) or (info.axis_state eq 5)) and  $
		  info.greenwich.ext_level eq 0 then begin
		    ;data_interval = (alog10(z_max) - alog10(z_min))/float(n_level-1)
		    ;vlevel = [0, tempa+1]
		    ;vlevel(n_level) = vlevel(n_level-1)
		    data_interval = (alog10(z_max) - alog10(z_min))/float(n_level-2)
		    vlevel = [0, tempa]
		    vlevel(n_level) = vlevel(n_level-1)
		endif else begin
		    data_interval = (alog10(z_max) - alog10(z_min))/float(n_level)
		    vlevel = [0, tempa+1]
		endelse
		vlevel = alog10(z_min) + vlevel * data_interval
		vlevel = 10 ^ vlevel
	    endif else begin
		if ((info.axis_state eq 3) or (info.axis_state eq 5)) and $
		  info.greenwich.ext_level eq 0 then begin
		    ;data_interval = (z_max - z_min)/float(n_level-1)
		    ;vlevel = [0, tempa+1]
		    ;vlevel(n_level) = vlevel(n_level-1)
		    data_interval = (z_max - z_min)/float(n_level-2)
		    vlevel = [0, tempa]
		    vlevel(n_level) = vlevel(n_level-1)
		endif else begin
		    data_interval = (z_max - z_min)/float(n_level)
		    vlevel = [0, tempa+1]
		endelse
		vlevel = z_min + vlevel * data_interval
	    endelse
	endelse

	color_interval = top_color/float(n_level)
	clevel = fix(color_interval * (tempa(*) + 1))

;	subscripts = where(hdf_data gt z_max, count)
;	if count ne 0 then begin
;		hdf_data(subscripts) = filldata_value
;		hdf_data = reform(hdf_data, sizehdf(1), sizehdf(2))
;		hdf_data = reform(hdf_data, real_x_dim, real_y_dim)
;	endif

	;nlevel = vlevel
	;levels = [nlevel, z_max]
	;if(z_temp_min lt z_min) then $
	;	levels = [z_temp_min, levels] $
	;else levels = [bad_data, levels]
	;c_colors = [clevel, !P.background, !P.background]
	levels = vlevel
	num_level = n_elements(levels)
	if levels(0) eq levels(1) then begin
	    if levels(0) gt z_min then levels(0) = z_min else levels(0) = levels(0) - 1000
	endif
	if levels(num_level-1) eq levels(num_level-2) then begin
	   if levels(num_level-1) lt z_max then levels(num_level-1) = z_max $
		else levels(num_level-1) = levels(num_level-1) + 1000
	endif
	num_color = n_elements(clevel)
	if info.greenwich.ext_level eq 0 then begin
	    c_colors = [clevel, clevel(num_color-1)]
	endif else begin
	    ;c_colors = [clevel, !P.background]
	    c_colors = [clevel, info.greenwich.baddata]
	endelse
	c_labels = make_array(n_level+2, /integer, value=info.greenwich.label)

	if(plot_type ge 2) then begin
	    if info.greenwich.greenloca gt 180.0 then $
		greenloca = info.greenwich.greenloca - 360.0 $
	    else greenloca = info.greenwich.greenloca

	    geofrac = (180.0 - greenloca)/360.0
	    ;separate_point = fix(sizehdf(1)*geofrac)
	    separate_point = fix(real_x_dim*geofrac)
	    ;if(separate_point gt 0 and separate_point lt sizehdf(1)) then begin
	    if(separate_point gt 0 and separate_point lt real_x_dim) then begin
		;rest_point = sizehdf(1) - separate_point
		;rest_point = real_x_dim - separate_point
		;hdf_data_temp = hdf_data
		;hdf_data(0:separate_point-1, *) = hdf_data_temp(rest_point:*, *)
		;hdf_data(separate_point:*, *) = hdf_data_temp(0:rest_point-1, *)
		;hdf_data_x_temp = hdf_data_x
		;hdf_data_x(0:separate_point-1) = hdf_data_x_temp(rest_point:*)
		;hdf_data_x(separate_point:*) = hdf_data_x_temp(0:rest_point-1)
		hdf_data = shift(hdf_data, separate_point, 0)
		hdf_data_x = shift(hdf_data_x, separate_point)
	    endif
	endif

	;if info.version ge 5.2 then begin
	;    map_proj_info, /CURRENT, NAME=proj_name, azimuthal=az, circle=cir, cylindrical=cyl, $
	;	ll_limits=lllimits, uv_limits=uvlimits, uv_range=uvrange
	;    print,'name = ',proj_name
	;    print,'az = ',az
	;    print,'cir = ',cir
	;    print,'cyl = ',cyl
	;    print,'ll_limits = ',lllimits
	;    print,'uv_limits = ',uvlimits
	;    print,'uv_range = ',uvrange
	;endif

	if plot_type ge 2 then begin
	 if cross_green eq 0 then begin
	    if XRange(1) eq 0.0 and XRange(0) lt 0.0 then XRange(1) = 360.0
	    ;if XRange(0) lt 0.0 and XRange(0) gt -180.0 then XRange(0) = 360.0 + XRange(0)
	    ;if XRange(1) lt 0.0 and XRange(1) gt -180.0 then XRange(1) = 360.0 + XRange(1)
	    if XRange(0) lt 0.0 and XRange(0) ge -180.0 then XRange(0) = 360.0 + XRange(0)
	    if XRange(1) lt 0.0 and XRange(1) ge -180.0 then XRange(1) = 360.0 + XRange(1)
	 endif else begin
	    neg_long = where(hdf_data_x gt 180.0, count)
	    if count ne 0 then hdf_data_x(neg_long) = hdf_data_x(neg_long) - 360.0
	 endelse
	 ;for j =0, sizehdf(2)-1 do begin
	 ;for j =0, real_y_dim-1 do begin
	 j = 0L
	 !UserDone = 0
	 while(j lt real_y_dim and !UserStop eq 1) do begin
	   if(y_axis_state eq 0) or (hdf_data_y(j) ge YRange(0) and hdf_data_y(j) le YRange(1)) then begin
	    y_m_half = hdf_data_y(j) - yinterval/2.0
	    y_p_half = hdf_data_y(j)+yinterval/2.0
	    ;if(y_m_half lt -89.999) then y_m_half = -89.999
	    if(y_m_half lt -90.0) then y_m_half = -90.0
	    if(y_p_half gt 90.0) then y_p_half = 90.0
	    ;for i = 0 , sizehdf(1)-1 do begin
	    ;  Check the stop and pause buttons
	    if !D.Name ne 'WIN' then begin
		result = widget_event(info.widgets.stop,/Nowait, /save_hourglass)
		result = widget_event(info.widgets.pause,/Nowait, /save_hourglass)
	    endif else begin
		;  If put a hourglass in WIN, it will not get the signal of stop or pause widget
		result = widget_event(info.widgets.stop,/Nowait)
		result = widget_event(info.widgets.pause,/Nowait)
	    endelse
	    for i = 0 , real_x_dim-1 do begin
	     if(x_axis_state eq 0) or (hdf_data_x(i) ge XRange(0) and hdf_data_x(i) le XRange(1)) then begin
	      x_m_half = hdf_data_x(i)-xinterval/2.0
	      x_p_half = hdf_data_x(i)+xinterval/2.0
	      if cross_green eq 0 then begin
		;if(x_m_half lt 0.001) then x_m_half = 0.001
		;if(x_p_half gt 359.999) then x_p_half = 359.999
		;if(hdf_data_x(i) lt 180.0 and x_p_half ge 180.0) then x_p_half = 179.999
		;if(hdf_data_x(i) gt 180.0 and x_m_half le 180.0) then x_m_half = 180.001
		if(x_m_half lt 0.00) then x_m_half = 0.00
		if(x_p_half gt 360.0) then x_p_half = 360.0
		;if(hdf_data_x(i) lt 180.0 and x_p_half ge 180.0) then x_p_half = 179.999
		;if(hdf_data_x(i) gt 180.0 and x_m_half le 180.0) then x_m_half = 180.001
	      endif else begin
		;if(x_m_half lt -179.999) then x_m_half = -179.999
		;if(x_p_half gt 179.999) then x_p_half = 179.999
		if(x_m_half lt -180.0) then x_m_half = -180.0
		if(x_p_half gt 180.0) then x_p_half = 180.0
		;if(hdf_data_x(i) lt 180.0 and x_p_half ge 180.0) then x_p_half = 179.999
		;if(hdf_data_x(i) gt 180.0 and x_m_half le 180.0) then x_m_half = 180.001
	      endelse
	      if info.greenwich.projection eq 0 or info.greenwich.projection eq 3 then begin
	       if i eq 0 then begin
		;vert1 = convert_coord(hdf_data_x(0)-xinterval/2.0+0.001, hdf_data_y(j)-yinterval/2.0, /to_device)
		;vert2 = convert_coord(hdf_data_x(0)+xinterval/2.0, hdf_data_y(j)-yinterval/2.0, /to_device)
		;vert3 = convert_coord(hdf_data_x(0)+xinterval/2.0, hdf_data_y(j)+yinterval/2.0, /to_device)
		;vert4 = convert_coord(hdf_data_x(0)-xinterval/2.0+0.001, hdf_data_y(j)+yinterval/2.0, /to_device)
		;vert5 = convert_coord(hdf_data_x(0), hdf_data_y(j)-yinterval/2.0, /to_device)
		;vert6 = convert_coord(hdf_data_x(0)+xinterval/2.0, hdf_data_y(j), /to_device)
		;vert7 = convert_coord(hdf_data_x(0), hdf_data_y(j)+yinterval/2.0, /to_device)
		;vert8 = convert_coord(hdf_data_x(0)-xinterval/2.0+0.001, hdf_data_y(j), /to_device)
		vert1 = convert_coord(x_m_half+0.001, y_m_half, /to_device)
		vert2 = convert_coord(x_p_half, y_m_half, /to_device)
		vert3 = convert_coord(x_p_half, y_p_half, /to_device)
		vert4 = convert_coord(x_m_half+0.001, y_p_half, /to_device)
		vert5 = convert_coord(hdf_data_x(0), y_m_half, /to_device)
		vert6 = convert_coord(x_p_half, hdf_data_y(j), /to_device)
		vert7 = convert_coord(hdf_data_x(0), y_p_half, /to_device)
		vert8 = convert_coord(x_m_half+0.001, hdf_data_y(j), /to_device)
	       endif else begin
		;vert1 = convert_coord(hdf_data_x(i)-xinterval/2.0, hdf_data_y(j)-yinterval/2.0, /to_device)
		;vert2 = convert_coord(hdf_data_x(i)+xinterval/2.0, hdf_data_y(j)-yinterval/2.0, /to_device)
		;vert3 = convert_coord(hdf_data_x(i)+xinterval/2.0, hdf_data_y(j)+yinterval/2.0, /to_device)
		;vert4 = convert_coord(hdf_data_x(i)-xinterval/2.0, hdf_data_y(j)+yinterval/2.0, /to_device)
		;vert5 = convert_coord(hdf_data_x(i), hdf_data_y(j)-yinterval/2.0, /to_device)
		;vert6 = convert_coord(hdf_data_x(i)+xinterval/2.0, hdf_data_y(j), /to_device)
		;vert7 = convert_coord(hdf_data_x(i), hdf_data_y(j)+yinterval/2.0, /to_device)
		;vert8 = convert_coord(hdf_data_x(i)-xinterval/2.0, hdf_data_y(j), /to_device)
		vert1 = convert_coord(x_m_half, y_m_half, /to_device)
		vert2 = convert_coord(x_p_half, y_m_half, /to_device)
		vert3 = convert_coord(x_p_half, y_p_half, /to_device)
		vert4 = convert_coord(x_m_half, y_p_half, /to_device)
		vert5 = convert_coord(hdf_data_x(i), y_m_half, /to_device)
		vert6 = convert_coord(x_p_half, hdf_data_y(j), /to_device)
		vert7 = convert_coord(hdf_data_x(i), y_p_half, /to_device)
		vert8 = convert_coord(x_m_half, hdf_data_y(j), /to_device)
	       endelse
	       x = [vert4(0), vert7(0), vert3(0), vert6(0), vert2(0), vert5(0), vert1(0), vert8(0)]
	       y = [vert4(1), vert7(1), vert3(1), vert6(1), vert2(1), vert5(1), vert1(1), vert8(1)]
	      endif else begin
	       if i eq 0 then begin
		x = [x_m_half+0.001, hdf_data_x(0), x_p_half, x_p_half, x_p_half, hdf_data_x(i), $
		    x_m_half+0.001, x_m_half+0.001]
		y = [y_p_half, y_p_half, y_p_half, hdf_data_y(j), y_m_half, y_m_half, y_m_half, hdf_data_y(j)]
	       endif else begin
		x = [x_m_half, hdf_data_x(i), x_p_half, x_p_half, x_p_half, hdf_data_x(i), x_m_half, x_m_half]
		y = [y_p_half, y_p_half, y_p_half, hdf_data_y(j), y_m_half, y_m_half, y_m_half, hdf_data_y(j)]
	       endelse
	      endelse

		;the_color = !P.BACKGROUND
		the_color = info.greenwich.baddata
		if info.greenwich.in_level eq 0 then begin
		    ;if abs(data_interval) ge 1.0 then begin
		;	if info.greenwich.with_level eq 2 then begin
		;	    the_color = fix(fix((alog10(hdf_data(i,j)) - alog10(z_min))/data_interval + 1.0) * $
		;		color_interval)
		;	endif else begin
		;	    the_color = fix(fix((hdf_data(i, j) - z_min)/data_interval + 1.0) * color_interval)
		;	endelse
		;    endif else begin
		;	if info.greenwich.with_level eq 2 then begin
		;	    the_color = fix(fix((alog10(hdf_data(i,j)) - alog10(z_min))/data_interval + 0.99999) * $
		;		color_interval)
		;	endif else begin
		;	    the_color = fix(fix((hdf_data(i, j) - z_min)/data_interval + 0.99999) * color_interval)
		;	endelse
		;    endelse
		    check_color = 0
		    icheck = 0
		    while (icheck le n_level-1) and (check_color eq 0) do begin
			sigma_interval = (vlevel(icheck+1) - vlevel(icheck)) * 0.0001
			if (hdf_data(i,j) ge vlevel(icheck) - sigma_interval and $
			  hdf_data(i,j) lt vlevel(icheck+1) + sigma_interval) then begin
			    the_color = clevel(icheck)
			    check_color = 1
			endif
			icheck = icheck + 1
		    endwhile
		    if ((info.axis_state eq 3) or (info.axis_state eq 5)) and $
		      info.greenwich.ext_level eq 0 then begin
			if hdf_data(i,j) gt vlevel(n_level-1) then the_color = clevel(n_level-1)
			if hdf_data(i,j) lt vlevel[1] then the_color = clevel[0]
		    endif
		endif else begin
		    if hdf_data(i,j) lt vlevel(1) then begin
			if info.greenwich.ext_level eq 0 then begin
			    the_color = clevel(0)
			endif else begin
			    if hdf_data(i,j) ge vlevel(0) then the_color = clevel(0)
			endelse
		    endif else if hdf_data(i,j) gt vlevel(n_level-1) then begin
			if info.greenwich.ext_level eq 0 then begin
			    the_color = clevel(n_level-1)
			endif else begin
			    if hdf_data(i,j) le vlevel(n_level) then the_color = clevel(n_level-1)
			endelse
		    endif else begin
			check_color = 0
			icheck = 1
			;the_color = !P.BACKGROUND
			while (icheck lt n_level-1) and (check_color eq 0) do begin
			    if (hdf_data(i,j) ge vlevel(icheck) and hdf_data(i,j) lt vlevel(icheck+1)) then begin
				the_color = clevel(icheck)
				check_color = 1
			    endif
			    icheck = icheck + 1
			endwhile
		    endelse
		endelse
		if filldata_value gt 0 then begin
		    ;if hdf_data(i,j) ge filldata_value then the_color = !P.BACKGROUND
		    if hdf_data(i,j) ge filldata_value then the_color = info.greenwich.baddata
		endif else begin
		    ;if hdf_data(i,j) le filldata_value then the_color = !P.BACKGROUND
		    if hdf_data(i,j) le filldata_value then the_color = info.greenwich.baddata
		endelse
		;if the_color lt 0 or the_color gt top_color then the_color = !P.BACKGROUND

		sub_x = where(finite(x) eq 0, count_x)
		sub_y = where(finite(y) eq 0, count_y)
		if(count_x eq 0 and count_y eq 0) then begin
		    if info.greenwich.projection eq 0 or info.greenwich.projection eq 3 then begin
			;if(max(x) - min(x) lt info.screen.xsize/4.0) then $
			if(max(x) - min(x) lt !d.x_size/4.0) then $
			    polyfill, x, y, color = the_color , /DEVICE
		    endif else begin
			polyfill, x, y, color = the_color , /DATA
		    endelse
		endif

		;if info.greenwich.projection eq 1 or info.greenwich.projection eq 4 then begin
		;if info.greenwich.projection eq 1 then begin
		;    sub_x = where(finite(x) eq 0, count_x)
		;    sub_y = where(finite(y) eq 0, count_y)
		;    if(count_x eq 0 and count_y eq 0) then begin
		;	polyfill, x, y, color = the_color , /DEVICE
		;    endif
		;endif else if info.greenwich.projection eq 2 then begin
		;    if info.greenwich.lat_loc eq 90.0 then begin
		;	if hdf_data_y(j) ge 0.0 and hdf_data_y(j) le 90.0 then begin
		;	    polyfill, x, y, color = the_color , /DEVICE
		;	endif
		;    endif else if info.greenwich.lat_loc eq -90.0 then begin
		;	if hdf_data_y(j) le 0.0 and hdf_data_y(j) ge -90.0 then begin
		;	    polyfill, x, y, color = the_color , /DEVICE
		;	endif
		;    endif else begin
		;	if hdf_data_x(i) gt 180 then junk = hdf_data_x(i) - 360.0 $
		;	else junk = hdf_data_x(i)
		;	lowlimit = info.greenwich.greenloca - 90.0
		;	if lowlimit lt -180.0 then lowlimit = lowlimit + 360.0
		;	uplimit = info.greenwich.greenloca + 90	
		;	if uplimit gt 180 then uplimit = uplimit - 360.0
		;	if fix(abs(info.greenwich.greenloca)+0.9999) eq 180 then begin
		;		if junk gt lowlimit or junk lt uplimit then $
		;			polyfill, x, y, color = the_color , /DEVICE
		;	endif else begin
		;		if junk gt lowlimit and junk lt uplimit then $
		;			polyfill, x, y, color = the_color , /DEVICE
		;	endelse
		;    endelse
		;endif else begin
		;    polyfill, x, y, color = the_color , /DEVICE
		;endelse
	     endif
	    endfor
	   endif
	   j = j + 1
	  endwhile
	  ;endfor
	endif else begin
	  if !D.Name eq 'PS' or !D.Name eq 'PRINTER' then begin
		old_background = !P.BACKGROUND
		!P.BACKGROUND = 0
	  endif

	  ;if filldata_value gt 0 then begin
	  ;   check_fill = where(hdf_data(0,*) lt filldata_value, count)
	  ;endif else begin
	  ;   check_fill = where(hdf_data(0,*) gt filldata_value, count)
	  ;endelse
	  ;if count ne 0 then begin
	;	hdf_data = hdf_data(*,check_fill(0):check_fill(count-1))
	;	hdf_data_y = hdf_data_y(check_fill(0):check_fill(count-1))
	;  endif

	  if(info.greenwich.whole eq 1) and (x_axis_state eq 1 or y_axis_state eq 1) then begin
	     if x_axis_state eq 1 then begin
		if cross_green eq 0 then begin
		    ;  The hdf_data_x range is from 0 to 360, so check the yrange
		    if xrange(0) lt 0.0 then xrmin = 360.0 + xrange(0) else xrmin = xrange(0)
		    if xrange(1) lt 0.0 then xrmax = 360.0 + xrange(1) else xrmax = xrange(1)
		    if xrmin gt xrmax then begin
			xrtemp = xrmin
			xrmin = xrmax
			xrmax = xrtemp
		    endif
		    r_sub = where(hdf_data_x ge xrmin and hdf_data_x le xrmax, count)
		    if count ne 0 then begin
			hdf_data_x = hdf_data_x(r_sub)
			hdf_data = hdf_data(r_sub, *)
		    endif else begin
			result=dialog_message('All Longitude data are out of Range!',$
			    title='View HDF Warning!')
			return
		    endelse
		endif else begin
		;  If cross the greenwich, the longitude is from -180 to 180
		    if info.greenwich.greenloca gt 180.0 then $
			greenloca = info.greenwich.greenloca - 360.0 $
		    else greenloca = info.greenwich.greenloca
		    geofrac = (180.0 - greenloca)/360.0
		    ;separate_point = fix(sizehdf(1)*geofrac)
		    separate_point = fix(real_x_dim*geofrac)
		    ;if(separate_point gt 0 and separate_point lt sizehdf(1)) then begin
		    if(separate_point gt 0 and separate_point lt real_x_dim) then begin
			hdf_data = shift(hdf_data, separate_point, 0)
			hdf_data_x = shift(hdf_data_x, separate_point)
			final_shift = final_shift + separate_point
		    endif

		    neg_long = where(hdf_data_x gt 180.0, count)
		    if count ne 0 then hdf_data_x(neg_long) = hdf_data_x(neg_long) - 360.0
		    r_sub = where(hdf_data_x ge XRange(0) and hdf_data_x le XRange(1), count)
		    if count ne 0 then begin
			hdf_data_x = hdf_data_x(r_sub)
			hdf_data = hdf_data(r_sub, *)
		    endif else begin
			result=dialog_message('All Longitude data are out of Range!',$
			    title='View HDF Warning!')
			return
		    endelse
		endelse
	    endif

	    if y_axis_state eq 1 then begin
		; The hdf_data_y range is from 90.0 to -90.0
		r_sub = where(hdf_data_y ge YRange(0) and hdf_data_y le YRange(1), count)
		if count ne 0 then begin
		    hdf_data_y = hdf_data_y(r_sub)
		    hdf_data = hdf_data(*, r_sub)
		endif else begin
		    result=dialog_message('All Latitude data are out of Range!',$
			title='View HDF Warning!')
		    return
		endelse
	    endif 
	  endif

	  if info.greenwich.projection eq 1 or info.greenwich.projection eq 4 then begin
	  ;if info.greenwich.projection eq 1 then begin
		num_x = n_elements(hdf_data_x)
		num_y = n_elements(hdf_data_y)
		num_fill = 0
		for i = 0L, num_y-1 do begin
		    temp_y = make_array(num_x, value=hdf_data_y(i))
		    result = convert_coord(hdf_data_x, temp_y, /data, /to_device)
		    x_coord = reform(result(0,*))
		    check_x = where(finite(x_coord) eq 0, count)
		    ;if count ne 0 then hdf_data(check_x, i) = max_value
		    if count eq num_x then hdf_data(check_x, i) = max_value
		    num_fill = [num_fill, count]
		endfor
		num_fill = num_fill(1:num_y)
		check_fill=where(num_fill lt num_x,count)
		if count ne 0 then begin
		    hdf_data = hdf_data(*,check_fill(0):check_fill(count-1))
		    hdf_data_y = hdf_data_y(check_fill(0):check_fill(count-1))
		endif
	  endif else if info.greenwich.projection eq 2 then begin
		count = 0
		if info.greenwich.lat_loc eq 90.0 then begin
		    sub_y = where(hdf_data_y ge 0.0, count)
		endif else if info.greenwich.lat_loc eq -90.0 then begin
		    sub_y = where(hdf_data_y le 0.0, count)
		endif else if(info.greenwich.lat_loc gt 0.0) and $
		    (info.greenwich.lat_loc lt 90.0) then begin
			y_limit = info.greenwich.lat_loc - 90.0
			sub_y = where(hdf_data_y gt y_limit and hdf_data_y le 90.0, count)
		endif else if(info.greenwich.lat_loc lt 0.0) and $
		    (info.greenwich.lat_loc gt -90.0) then begin
			y_limit = info.greenwich.lat_loc + 90.0
			sub_y = where(hdf_data_y gt -90.0 and hdf_data_y le y_limit, count)
		endif
		if count ne 0 then begin
		    hdf_data = hdf_data(*,sub_y)
		    hdf_data_y = hdf_data_y(sub_y)
		endif
	  endif

	  ; contour must be ascending order and no gap, 0 to 360
	  if(x_axis_state eq 0) then begin
		hdf_data_x = hdf_data_x - xinterval/2.0
		sub_x = where(hdf_data_x lt 0.0, count_x)
		if count_x ne 0 then hdf_data_x(sub_x) = 0.0
		if info.greenwich.contour eq 1 then begin
		    sub_neg = where(hdf_data_x gt 180.0 and hdf_data_x le 360.0, count)
		    if count ne 0 then hdf_data_x(sub_neg) = hdf_data_x(sub_neg) - 360.0
		    sub_neg = where(hdf_data_x lt 0.0, count)
		    if count ne 0 then begin
			hdf_data_x = shift(hdf_data_x, -sub_neg(0))
			hdf_data = shift(hdf_data, -sub_neg(0), 0)
			num_x = n_elements(hdf_data_x)
			hdf_data_x = [-hdf_data_x(num_x-1), hdf_data_x]
			hdf_data = [hdf_data(num_x-1,*), hdf_data]
			final_shift = final_shift - sub_neg(0) + 1
		    endif
		endif else begin
		    hdf_data_x = [hdf_data_x, hdf_data_x(0)+360.0]
		    hdf_data = [hdf_data, hdf_data(0,*)]
		endelse
	  endif

	;revese the hdf_data_y - contour must be ascending order
	  hdf_data_y = reverse(hdf_data_y)
	  hdf_data = reverse(hdf_data, 2)

	  ;Remove the filldata data points on the boundary for do contour
	  ;Remove the y first
	  check_size = size(hdf_data)
	  if whole_y_array eq 0 then begin
	    iydim = 0
	    allfill = 1
	    iystart = 0
	    iyend = check_size(2)-1
	    if filldata_value gt 0 then begin
	      while(allfill eq 1 and iydim lt check_size(2) ) do begin
		check_fill = where(hdf_data(*,iydim) lt filldata_value, count)
		if count ne 0 then begin
		    iystart = iydim
		    allfill = 0
		endif
		iydim = iydim + 1
	      endwhile
	      if iydim ge check_size(2) then iystart = check_size(2)

	      allfill = 1
	      iydim = check_size(2)-1
	      while(allfill eq 1 and iydim ge 0) do begin
		check_fill = where(hdf_data(*,iydim) lt filldata_value, count)
		if count ne 0 then begin
		    iyend = iydim
		    allfill = 0
		endif
		iydim = iydim - 1
	      endwhile
	      if iydim lt 0 then iyend = -1
	    endif else begin
	      while(allfill eq 1 and iydim lt check_size(2) ) do begin
		check_fill = where(hdf_data(*,iydim) gt filldata_value, count)
		if count ne 0 then begin
		    iystart = iydim
		    allfill = 0
		endif
		iydim = iydim + 1
	      endwhile
	      if iydim ge check_size(2) then iystart = check_size(2)

	      allfill = 1
	      iydim = check_size(2)-1
	      while(allfill eq 1 and iydim ge 0) do begin
		check_fill = where(hdf_data(*,iydim) gt filldata_value, count)
		if count ne 0 then begin
		    iyend = iydim
		    allfill = 0
		endif
		iydim = iydim - 1
	      endwhile
	      if iydim lt 0 then iyend = -1
	    endelse

	    if iystart gt iyend then begin
	      result=dialog_message('All Data is FILL data!', title='View HDF Warning!')
	      return
	    endif

            if(iystart ne 0) or (iyend ne check_size(2)-1) then begin
                hdf_data = hdf_data(*,iystart:iyend)
                hdf_data_y = hdf_data_y(iystart:iyend)
            endif
	  endif

	  ;Remove the x second if info.greenwich.contour eq 0
	  if (whole_x_array eq 0) and (info.greenwich.contour eq 0) then begin
	    ; shift back the array to orginal if final_shift ne 0 and number 
	    ;    of x equal to orginal
	    if (final_shift ne 0) and (n_elements(hdf_data_x) ge real_x_dim) then begin
		hdf_data_x= shift(hdf_data_x, -final_shift+1)
		hdf_data = shift(hdf_data, -final_shift+1, 0)
	    endif
	    ixdim = 0
	    allfill = 1
	    ixstart = 0
	    ixend = check_size(1)-1
	    if filldata_value gt 0 then begin
	      while(allfill eq 1 and ixdim lt check_size(1) ) do begin
		check_fill = where(hdf_data(ixdim,*) lt filldata_value, count)
		if count ne 0 then begin
		    ixstart = ixdim
		    allfill = 0
		endif
		ixdim = ixdim + 1
	      endwhile
	      if ixdim ge check_size(1) then ixstart = check_size(1)

	      allfill = 1
	      ixdim = check_size(1)-1
	      while(allfill eq 1 and ixdim ge 0) do begin
		check_fill = where(hdf_data(ixdim,*) lt filldata_value, count)
		if count ne 0 then begin
		    ixend = ixdim
		    allfill = 0
		endif
		ixdim = ixdim - 1
	      endwhile
	      if ixdim lt 0 then ixend = -1
	    endif else begin
	      while(allfill eq 1 and ixdim lt check_size(1) ) do begin
		check_fill = where(hdf_data(ixdim,*) gt filldata_value, count)
		if count ne 0 then begin
		    ixstart = ixdim
		    allfill = 0
		endif
		ixdim = ixdim + 1
	      endwhile
	      if ixdim ge check_size(1) then ixstart = check_size(1)

	      allfill = 1
	      ixdim = check_size(1)-1
	      while(allfill eq 1 and ixdim ge 0) do begin
		check_fill = where(hdf_data(ixdim,*) gt filldata_value, count)
		if count ne 0 then begin
		    ixend = ixdim
		    allfill = 0
		endif
		ixdim = ixdim - 1
	      endwhile
	      if ixdim lt 0 then ixend = -1
	    endelse

	    if ixstart gt ixend then begin
	      result=dialog_message('All Data is FILL data!', title='View HDF Warning!')
	      return
	    endif

            if(ixstart ne 0) or (ixend ne check_size(1)-1) then begin
                hdf_data = hdf_data(ixstart:ixend,*)
                hdf_data_x = hdf_data_x(ixstart:ixend)
            endif

	  endif

	  if info.greenwich.contour eq 1 then begin
	    sub_grid = where(hdf_data_x gt 180.0 and hdf_data_x le 360.0, count)
	    if count ne 0 then hdf_data_x(sub_grid) = hdf_data_x(sub_grid) - 360.0
	    if(x_axis_state ne 0) then begin
		sub_neg = where(hdf_data_x lt 0.0, count)
		if count ne 0 then begin
		    hdf_data_x = shift(hdf_data_x, -sub_neg(0))
		    hdf_data = shift(hdf_data, -sub_neg(0), 0)
		endif
	    endif
	    size_grid = size(hdf_data)
	    ;my_color = make_array(n_elements(hdf_data), /INT, value=top_color+10)
	    my_color = make_array(n_elements(hdf_data), /INT, value=info.greenwich.baddata)
	    if info.greenwich.in_level eq 0 then begin
		for i = 0, n_level-2 do begin
		    sub_color = where(hdf_data ge vlevel(i) and hdf_data lt vlevel(i+1), count_color)
		    if count_color ne 0 then my_color(sub_color) = clevel(i)
		endfor
		if ((info.axis_state eq 3) or (info.axis_state eq 5)) and $
		  info.greenwich.ext_level eq 0 then begin
		    sub_color = where(hdf_data gt vlevel(n_level-1), count_color)
		    if count_color ne 0 then my_color(sub_color) = clevel(n_level-1)
		    sub_color = where(hdf_data lt vlevel(1), count_color)
                    if count_color ne 0 then my_color(sub_color) = clevel(0)
		endif else begin
		    sub_color = where(hdf_data ge vlevel(n_level-1) and hdf_data lt vlevel(n_level), count_color)
		    if count_color ne 0 then my_color(sub_color) = clevel(n_level-1)
		endelse
	    endif else begin
		if info.greenwich.ext_level eq 0 then begin
		    sub_color = where(hdf_data lt vlevel(1), count_color)
		    if count_color ne 0 then my_color(sub_color) = clevel(0)
		    sub_color = where(hdf_data gt vlevel(n_level-1), count_color)
		    if count_color ne 0 then my_color(sub_color) = clevel(n_level-1)
		endif else begin
		    sub_color = where(hdf_data lt vlevel(1) and hdf_data ge vlevel(0), count_color)
		    if count_color ne 0 then my_color(sub_color) = clevel(0)
		    sub_color = where(hdf_data gt vlevel(n_level-1) and hdf_data le vlevel(n_level), count_color)
		    if count_color ne 0 then my_color(sub_color) = clevel(n_level-1)
		endelse
		for i = 1, n_level-2 do begin
		    sub_color = where(hdf_data ge vlevel(i) and hdf_data lt vlevel(i+1), count_color)
		    if count_color ne 0 then my_color(sub_color) = clevel(i)
		endfor
		;sub_color = where(hdf_data gt vlevel(n_level-1), count_color)
		;if count_color ne 0 then my_color(sub_color) = clevel(n_level-1)
	    endelse

	    if filldata_value gt 0 then begin
		subscript = where(hdf_data ge filldata_value, count)
	    endif else begin
		subscript = where(hdf_data le filldata_value, count)
	    endelse
	    ;if count ne 0 then my_color(subscript) = top_color + 10
	    if count ne 0 then my_color(subscript) = info.greenwich.baddata

	    my_color = reform(my_color, size_grid(1), size_grid(2))

	    num_lat = n_elements(hdf_data_y)
	    num_lon = n_elements(hdf_data_x)
	    con_image = map_image(my_color, startx, starty, xsize, ysize, latmin=hdf_data_y(0), $
		latmax=hdf_data_y(num_lat-1), lonmin=hdf_data_x(0), lonmax=hdf_data_x(num_lon-1), $
		compress=1, /bilinear, missing=!P.BACKGROUND)
	    ;sub_fill = where(con_image gt top_color, fill_count)
	    ;if fill_count ne 0 then con_image(sub_fill) = !P.BACKGROUND
	    ;if fill_count ne 0 then con_image(sub_fill) = info.greenwich.baddata
	    ;tvscl, con_image, startx, starty, xsize=xsize, ysize=ysize
	    tv, con_image, startx, starty, xsize=xsize, ysize=ysize
	  endif else begin
	    max_temp = max(hdf_data, min=min_temp)
	    temp_lev = [min_temp, max_temp]
	    temp_col = [info.greenwich.baddata]
	    contour, hdf_data, hdf_data_x, hdf_data_y, /overplot, levels = temp_lev, $
		c_colors = temp_col, /follow, /cell_fill, /closed, zrange=[min_temp,max_temp]
	    contour, hdf_data, hdf_data_x, hdf_data_y, /overplot, levels = levels, $
		c_colors = c_colors, /follow, /cell_fill, /closed, max_value=max_value, $
		zrange=[z_min,z_max]
	  endelse

	  if !D.Name eq 'PS' or !D.Name eq 'PRINTER' then !P.BACKGROUND = old_background
	endelse

	if info.greenwich.continents eq 1 and !UserStop eq 1 then begin
	    if info.greenwich.high_resol eq 1 then begin
		old_quiet = !QUIET
		!QUIET=1
		if info.greenwich.coasts eq 1 then begin
		    map_continents,/coasts, /hires, mlinethick=info.greenwich.mlinethick
		endif else begin
		    map_continents, /hires, mlinethick=info.greenwich.mlinethick
		endelse
		!QUIET = old_quiet
	    endif else begin
		map_continents,/coasts, mlinethick=info.greenwich.mlinethick
	    endelse
	    ;map_continents,mlinethick=info.greenwich.mlinethick
	endif
	if info.greenwich.grid eq 1 and !UserStop eq 1 then begin
	    if info.axis_state eq 0 or info.axis_state eq 3 then begin
		map_grid, LABEL=info.greenwich.label, charsize = map_charsize, $
		    londel=londel, glinethick=info.greenwich.glinethick
	    endif else begin
		map_grid, LABEL=info.greenwich.label, charsize = map_charsize, $
		    londel=londel, latdel = latdel, glinethick=info.greenwich.glinethick
	    endelse
	endif
	;map_continents,/coasts, mlinethick=info.greenwich.mlinethick
	;map_grid, LABEL=info.greenwich.label, charsize = map_charsize
	;map_continents,/coasts, mlinethick=1, color=map_color
	;map_grid, LABEL=info.greenwich.label, charsize = map_charsize, color=top_color

	; Reset the control
	!UserStop = 1
	!UserPause = 1
	!UserDone = 1
	widget_control, set_button=0, info.widgets.pause

	crit_location = barlocation + (3.0 * bar_offset) - 0.01
	if info.color_bar eq 1 then begin
	  ;x_location = !P.Position(0) + (!P.Position(2) - !P.Position(0))/2. - 0.22
	  ; x_location = !P.Position(0) + (!P.Position(2) - !P.Position(0))/2. - x_bar_offset
          ; deltx = (x_bar_offset)/20.0
	  x_bar_location = 20.0 * info.greenwich.barsize
	  x_location = !P.Position(0) + (!P.Position(2) - !P.Position(0))/2. - x_bar_location
	  temp_name = info.subset.data(this_subset).src_unitname
	  temp_name = temp_name(0)
	  temp_length = strlen(temp_name)
	  unitlabel = ''
	  if (temp_length gt 0) then begin
	    dot=strpos(temp_name,'N/A')
	    if( dot eq -1) then unitlabel = strmid(temp_name,2,temp_length-2)
	  endif
	  draw_contour_bar, clevel, z_min, z_max, barlocation, x_location, n_level, $
		info.char.size, info.char.font, unitlabel, vlevel, info.greenwich.baddata, $
		info.greenwich.setformat, info.greenwich.bformat, info.greenwich.colborder, $
		info.greenwich.displaybad, bar_offset=abs(bar_offset), deltx=info.greenwich.barsize
		; bar_offset=abs(bar_offset), deltx=deltx
	endif

	if info.subset.data(this_subset).src_crit_flag eq 1 or $
	    info.greenwich.projection eq 4 then begin
		if !D.Name eq 'PS' or !D.Name eq 'PRINTER' then charsize = 0.9*info.char.size $
		else charsize = info.char.size
		;xyouts, !X.Window(0), barlocation-0.10, crit_string, /NORMAL, font=info.char.font, $
		;xyouts, 0.08, barlocation-0.10, crit_string, /NORMAL, font=info.char.font, $
		xyouts, 0.08, crit_location, crit_string, /NORMAL, font=info.char.font, $
		    charsize=charsize
	endif

	if info.addtext.key eq 1 then write_add_text, info

	test = !d.flags and 128
	if test ne 0 then begin
	    ;image = tvrd()
	    image = get_image24()
	    if ptr_valid(info.overlay.image) then ptr_free, info.overlay.image
	    info.overlay.image = ptr_new(image, /NO_COPY)
	endif

	if info.overlay.flag eq 1 then do_overlay, info

    endif else begin
                result=dialog_message('All Data is FILL data!',$
                           title='View HDF Warning!')
                           ;return
    endelse

  ; store the system variables
  !P.Position = [ 0.0 , 0.0 , 0.0 , 0.0]
  endif else begin

;--------------------------
; Vdata
;--------------------------

    the_message = [ 'Data record is not a 2 dimensional array', $
                'contour plot is not valid']
 
    result= dialog_message(the_message, $
          title='View HDF Message!')
    plot_status = 0
    return
 
  endelse

  ijk = ijk + 1
  result = 'No'
  while result eq 'No' and ijk lt end_plot do begin
	the_current = the_start + ijk * the_incre
	the_message = ['Do you want to continue to plot the next one: ' $
		+ strcompress(string(the_current+1)) + ' ?', $
		'Press Cancel to stop.']
	result=dialog_message(the_message, /Question, /Cancel, title='View HDF Question!')

	if result eq 'No' then ijk = ijk + 1 $
		else if result eq 'Cancel' then ijk = end_plot
   endwhile

endwhile

widget_control, set_uvalue=info, info.widgets.base
widget_control, set_uvalue=info, info.base

end

;--------------------------------------------------------------------------------
pro do_geolocated, info, name_of_data, this_subset, print_flag, plot_type, plot_status

pro_name = 'do_geolocated'
@getinfo

;widget_control,info.widgets.current_file, get_value=current_filename
current_filename = info.geolocated.filename
current_filename=current_filename(0)
filename = info.subset.data(this_subset).src_filename
filename=filename(0)
;if current_filename ne filename then begin
;	the_message=['The subset file is not equal current file,', $
;		     'Unable to make geolocated plot.', $
;		     'Please open the subset file:', filename]
;	result=dialog_message(the_message, title='View HDF Warning!')
;	return
;endif
if current_filename ne filename then begin
	info.geolocated.flag = 0
	info.geolocated.selected = 0
endif

if (print_flag ne 1) and (print_flag ne 3) then begin

  info.field_name.z = info.subset.data(this_subset).subset_name

  if plot_type eq 0 then info.graph_style = 'Geolocated' $
	else info.graph_style = 'Contour Geolocated'

  widget_control, /hourglass

  ;widget_control, get_uvalue=info, info.base

  ;if info.geolocated.selected eq 1 then begin
;	info.geolocated.flag = 0
;	info.geolocated.selected = 0
;  endif

  info.overlay.flag = 0
  info.overlay.offflag = 0

  if info.geolocated.flag eq 0 then $
	get_geolocated_data, info, this_subset $
  else begin
	this_start = info.subset.data(this_subset).src_start(0)
	this_end = info.subset.data(this_subset).src_end(0)
	this_increment = info.subset.data(this_subset).src_increment(0)
	if info.subset.data(this_subset).src_type_flag eq 0 then begin
		the_rank = info.subset.data(this_subset).src_rank
		if the_rank eq 1 then begin
			true_start = info.subset.data(this_subset).src_start(the_rank)
			true_end = info.subset.data(this_subset).src_end(the_rank)
			if true_start ne this_start or true_end ne this_end then begin
				this_start = true_start
				this_end = true_end
				this_increment = 1
			endif
		endif
	endif
	if (this_increment eq info.geolocated.increment) or $
		(info.geolocated.increment eq 1) then incre_ok = 1 $
		else incre_ok = 0
	if (this_start lt info.geolocated.starting) or $
	   (this_end gt info.geolocated.ending) or $
	   (incre_ok eq 0) then $
		get_geolocated_data, info, this_subset
  endelse

  test_status = set_geolocated_data(info,this_subset)
  if test_status eq -1 then begin
	info.geolocated.flag = 0
	info.geolocated.selected = 0
	plot_status = 0
	return
  endif
 
endif

  ;  If put a hourglass in WIN, it will not get the signal of stop or pause widget
  if plot_type ne 0 or !D.Name ne 'WIN' then widget_control, /hourglass
  widget_control, get_uvalue=info, info.base

  if ptr_valid(info.geolocated.hdf_z) then $
	hdf_data_z=*info.geolocated.hdf_z $
  else begin
	result=dialog_message('Cannot find geolocated data!', $
		title='View HDF Warning!')
	plot_status = 0
	return
  endelse

  if ptr_valid(info.geolocated.long) then $
	hdf_data_x = *info.geolocated.long $
  else begin
	result=dialog_message('Cannot find geolocated data!', $
		title='View HDF Warning!')
	plot_status = 0
	return
  endelse

  if ptr_valid(info.geolocated.colat) then $
	hdf_data_y = *info.geolocated.colat $
  else begin
        result=dialog_message('Cannot find geolocated data!', $
                title='View HDF Warning!')
	plot_status = 0
        return
  endelse
  if ptr_valid(info.geolocated.sate_long) then $
	satellite_x = *info.geolocated.sate_long $
  else info.greenwich.satellite = 0
  if ptr_valid(info.geolocated.sate_colat) then $
	satellite_y = *info.geolocated.sate_colat $
  else info.greenwich.satellite = 0
  if ptr_valid(info.geolocated.sun_long) then $
	sun_x = *info.geolocated.sun_long $
  else info.greenwich.sun = 0
  if ptr_valid(info.geolocated.sun_colat) then $
	sun_y = *info.geolocated.sun_colat $
  else info.greenwich.sun = 0
	
starting=info.subset.data(this_subset).src_start(0)
ending=info.subset.data(this_subset).src_end(0)

set_axis_ranges, info, YRange, Ystyle, XRange, Xstyle, ZRange, Zstyle
;if YRange[0] ge YRange[1] or XRange[0] ge XRange[1] then begin
if YRange[0] ge YRange[1] then begin
	;the_message = ['The ranges of longitude and/or latitude is not right!', $
	the_message = ['The ranges of latitude is not right!', $
		'Check the ranges and do it again!']
	result=dialog_message(the_message, title='View HDF Warning!')
	plot_status = 0
	return
endif

cross_green = 0
if info.axis_state eq 1 or info.axis_state eq 4 or info.axis_state eq 5 then begin
    If XRange[0] lt 0.0 and XRange[1] ge 0.0 then begin
	If XRange[0] ge -180.0 and XRange[1] le 180.0 then cross_green = 1 $
	else begin
		the_message = ['The ranges of longitude is not right!', $
			'Check the ranges and do it again!']
		result=dialog_message(the_message, title='View HDF Warning!')
		plot_status = 0
		return
	endelse
    endif

    if XRange[0] gt XRange[1] then begin
	if XRange[0] lt 360.0 and XRange[1] ge 0.0 then begin
		XRange[0] = XRange[0] - 360.0
		cross_green = 1
	endif else begin
		the_message = ['The ranges of longitude is not right!', $
			'Check the ranges and do it again!']
		result=dialog_message(the_message, title='View HDF Warning!')
		plot_status = 0
		return
	endelse
    endif
endif

size_hdf_x = size(hdf_data_x)
size_hdf_y = size(hdf_data_y)
size_hdf_z = size(hdf_data_z)

n_size_hdf_x = n_elements(size_hdf_x)
n_size_hdf_y = n_elements(size_hdf_y)
n_size_hdf_z = n_elements(size_hdf_z)
 
if((size_hdf_x(n_size_hdf_x-1) eq size_hdf_y(n_size_hdf_y-1)) and $
   (size_hdf_x(n_size_hdf_x-1) eq size_hdf_z(n_size_hdf_z-1))) then begin
 
if plot_type eq 1 then begin
    if info.greenwich.with_level eq 0 then info.greenwich.with_level = 1
    if info.greenwich.n_level lt 2 then info.greenwich.n_level = 10
endif

if info.filldata gt 0 then begin
    subscript = where(hdf_data_x lt info.filldata, count)
endif else begin
    subscript = where(hdf_data_x gt info.filldata, count)
endelse
if(count ne 0) then begin
     hdf_data_x = hdf_data_x(subscript)
     hdf_data_y = hdf_data_y(subscript)
     hdf_data_z = hdf_data_z(subscript)
endif else begin
	result=dialog_message('All the FOV longitude data are fill data!',$
	    title='View HDF Warning!')
	plot_status = 0
	return
endelse
 
if info.filldata gt 0 then begin
    subscript = where(hdf_data_y lt info.filldata, count)
endif else begin
    subscript = where(hdf_data_y gt info.filldata, count)
endelse
if(count ne 0) then begin
     hdf_data_x = hdf_data_x(subscript)
     hdf_data_y = hdf_data_y(subscript)
     hdf_data_z = hdf_data_z(subscript)
endif else begin
	result=dialog_message('All the FOV latitude data are fill data!',$
	    title='View HDF Warning!')
	plot_status = 0
	return
endelse
 
this_type = info.subset.data(this_subset).src_types
this_type = this_type(0)
filldata_value = get_filldata_value(this_type, info.filldata)
if filldata_value gt info.filldata then filldata_value = info.filldata

if filldata_value gt 0 then begin
    subscript = where(hdf_data_z lt filldata_value, count)
endif else begin
    subscript = where(hdf_data_z gt filldata_value, count)
endelse
if(count ne 0) then begin
   if info.greenwich.with_level eq 0 then begin
     hdf_data_x = hdf_data_x(subscript)
     hdf_data_y = hdf_data_y(subscript)
     hdf_data_z = hdf_data_z(subscript)
   endif
endif else begin
	result=dialog_message('All Data is FILL data!',$
	    title='View HDF Warning!')
	plot_status = 0
	return
endelse
 
if (info.axis_state eq 3) or (info.axis_state eq 5) then begin
        z_max = info.range.z_end
        z_min = info.range.z_start
endif else begin
	if(info.greenwich.with_level gt 0) then begin
		hdf_data_z_temp = hdf_data_z
		if filldata_value gt 0 then begin
		    subscript = where(hdf_data_z_temp lt filldata_value, count)
		endif else begin
		    subscript = where(hdf_data_z_temp gt filldata_value, count)
		endelse
		if(count ne 0) then hdf_data_z_temp = hdf_data_z_temp(subscript) $
		else begin
        	  result=dialog_message('All Data is FILL data!',$
                    title='View HDF Warning!')
		  plot_status = 0
         	  return
		endelse
		z_max = max(hdf_data_z_temp, min = z_min)
		if plot_type eq 1 then begin
		    hdf_range = (z_max - z_min) * 0.05
		    z_max = z_max + hdf_range
		    z_min = z_min - hdf_range
		endif
	endif else z_max = max(hdf_data_z, min = z_min)
	get_max_min, z_max, z_min
endelse
 
top_color = !d.n_colors - 2
if top_color gt 254 then top_color = 254

if((!D.Name ne 'PS' and !D.Name ne 'PRINTER') and top_color gt info.top_color) then $
	top_color = info.top_color

dot=strpos(name_of_data, 'ERBE scene identification')
if dot ne -1 then begin
    if info.device eq 'X' then begin
	color_table_file=info.home_path+"/"+"view_hdf_color.tbl"
    endif else begin
	color_table_file=info.home_path+"\"+"view_hdf_color.tbl"
    endelse
    test_file = findfile(color_table_file, count=count)
    if count eq 0 then color_table_file = 'view_hdf_color.tbl'
    loadct,41, file=color_table_file, /silent
    z_max = 13
    z_min = 0
    info.greenwich.with_level = 1
    info.greenwich.n_level = 13
endif else begin
    if info.color_table ne 0 and info.pick_color_table eq 0 then $
	check_bw = check_color_table(top_color) $
	else check_bw = 0
    if check_bw eq 1 then begin
	if info.device eq 'X' then begin
	    color_table_file=info.home_path+"/"+"view_hdf_color.tbl"
	endif else begin
	    color_table_file=info.home_path+"\"+"view_hdf_color.tbl"
	endelse
	test_file = findfile(color_table_file, count=count)
	if count eq 0 then color_table_file = 'view_hdf_color.tbl'
	loadct, info.color_table, file=color_table_file, ncolors=info.top_color
    endif
endelse

info.overlay.zmax = z_max
info.overlay.zmin = z_min

my_color=bytscl(hdf_data_z, max=z_max, min=z_min, top=top_color)

x_max = max(hdf_data_x, min=x_min)
if x_max eq x_min then begin
    plot_status = 0
    return
endif

y_max = max(hdf_data_y, min=y_min)
info.slide.x_end = x_max
info.slide.x_start = x_min
info.slide.y_end = y_max
info.slide.y_start = y_min

filename = info.subset.data(this_subset).src_filename

temp_name = info.subset.data(this_subset).subset_name
temp_name = temp_name(0)

dot=strpos(temp_name,'[')
if( dot ne -1) then begin
  xtitle=strmid(temp_name,0,dot)
endif else begin
  xtitle = temp_name
endelse

if (print_flag eq 0) or (print_flag eq 3) then plot_dialogue , name_of_data, info

data_range = ''
data_range = get_data_range(this_subset, info)
the_title = xtitle + ' Data Range: ' + data_range

if !D.Name eq 'PS' or !D.Name eq 'PRINTER' or !D.Name eq 'WIN' or info.char.font eq 0 then begin
	the_title=the_title+'!C'+filename+ ' '+systime(0)
endif else begin
	the_title=the_title+'!C!C'+filename+ ' '+systime(0)
endelse

if info.subset.data(this_subset).src_crit_flag eq 1 or $
    info.greenwich.projection eq 4 then begin
	crit_string = ''
	if info.subset.data(this_subset).src_crit_flag eq 1 then $
	    crit_string = get_crit_string(this_subset, info)
	if !D.Name eq 'PS' or !D.Name eq 'PRINTER' then begin
	    if info.eps_out.type eq 1 then $
		!P.Position = [0.25, 0.16, 0.99, 0.825] $
	    else !P.Position = [0.01, 0.16, 0.99, 0.825]
	endif else begin
	    !P.Position = [0.01, 0.150, 0.99, 0.93]
	    if(top_color gt info.top_color) then top_color = info.top_color
	endelse
	if info.greenwich.projection eq 4 then begin
	    if info.subset.data(this_subset).src_crit_flag eq 1 then begin
		if !D.Name eq 'PS' or !D.Name eq 'PRINTER' or !D.Name eq 'WIN' or $
		    info.char.font eq 0 then begin
			sat_string = '!C'
		endif else sat_string = '!C!C'
	    endif else sat_string = ''
	    sat_string = sat_string+'Satellite projection: altitude = '+ $
		strcompress(string((info.greenwich.altitude-1.0)*6371.0), /REMOVE_ALL)+' km'
	    sat_string = sat_string + ', tilt angle = '+ $
		strcompress(string(info.greenwich.tilt), /REMOVE_ALL)+' deg'
	    sat_string = sat_string + ', rotation angle = '+ $
		strcompress(string(info.greenwich.rotation), /REMOVE_ALL)+' deg'
	    crit_string = crit_string + sat_string
	endif
	temp_name = str_sep(crit_string, '!C')
	num_temp = n_elements(temp_name)
	!P.Position(1) = !P.Position(1) + (num_temp-1)*0.025
	;if info.color_bar eq 1 then barlocation = !P.Position(1) - 0.03 $
	;    else barlocation = !P.Position(1) + 0.04
	if info.color_bar eq 1 then bar_offset = - 0.03 else bar_offset = -0.01
endif else begin
	if !D.Name eq 'PS' or !D.Name eq 'PRINTER' then begin
	    if info.eps_out.type eq 1 then $
		!P.Position = [0.25, 0.16, 0.99, 0.825] $
	    else !P.Position = [0.01, 0.16, 0.99, 0.825]
	endif else begin
	    !P.Position = [0.01, 0.13, 0.99, 0.93]
	    if(top_color gt info.top_color) then top_color = info.top_color
	endelse
	;barlocation = !P.Position(1) - 0.03
	bar_offset = - 0.03
endelse

x_bar_offset = 0.22

if info.eps_out.flag eq 1 and info.eps_out.title eq 1 then !P.Position(3) = 0.93

if (Xrange(0) eq Xrange(1)) or info.greenwich.whole eq 1 then begin
    xmax = 180.0
    xmin = -180.0
    if Xrange(0) eq Xrange(1) then begin
	Xrange(0) = -180.0
	Xrange(1) = 180.0
    endif
endif else begin
    xmax = Xrange(1)
    xmin = Xrange(0)
endelse
if (Yrange(0) eq Yrange(1)) or info.greenwich.whole eq 1 then begin
    ymax = 90.0
    ymin = -90.0
    if Yrange(0) eq Yrange(1) then begin
	Yrange(0) = -90.0
	Yrange(1) = 90.0
    endif
endif else begin
    ymax = Yrange(1)
    ymin = Yrange(0)
endelse
ratio = (ymax - ymin)/(xmax - xmin)
if !D.Name eq 'PS' or !D.Name eq 'PRINTER' then begin
    goodratio = 1.357142 * ratio 
    ydelt = 0.01
endif else begin
    goodratio = 1.63265 * ratio
    ydelt = 0.03
endelse

adjust_plot_size, this_subset, goodratio, ydelt, bar_offset, x_bar_offset, info

barlocation = !P.Position(1) + bar_offset

map_charsize = info.char.size
if !D.NAME eq "PRINTER" then map_charsize = 0.75 * info.char.size
; print,'!D.NAME = ',!D.NAME,' and map_charsize = ',map_charsize
;map_color = !d.n_colors/3
map_color = top_color/3
if !D.Name ne 'PS' and !D.Name ne 'PRINTER' then !P.CHARSIZE = info.char.size
if info.eps_out.flag eq 1 and info.eps_out.title eq 1 then the_title = ''
map_create, info, map_charsize, the_title, xrange, yrange, londel, latdel

;  It already draws the continents in the map_create function
;map_continents,/coasts,color=map_color
;if info.greenwich.high_resol eq 1 then begin
    ;old_quiet = !QUIET
    ;!QUIET=1
    ;if info.greenwich.coasts eq 1 then begin
	;map_continents,/coasts, /hires, mlinethick=info.greenwich.mlinethick
    ;endif else begin
	;map_continents, /hires, mlinethick=info.greenwich.mlinethick
    ;endelse
    ;!QUIET = old_quiet
;endif else begin
    ;map_continents,/coasts, mlinethick=info.greenwich.mlinethick
;endelse
;map_continents,mlinethick=info.greenwich.mlinethick

if info.mpeg.flag eq 1 then begin
   print,'window id = ',info.mpeg.winid
   mpeg_put, info.mpeg.id, /order, window=info.mpeg.winid, frame=0
   ;image2d = get_image()
   ;mpeg_put, info.mpeg.id, /order, image=image2d, frame=0
endif

with_level_flag = 0
if info.greenwich.with_level gt 0 then begin
	if info.greenwich.with_level eq 2 then begin
	    if z_max lt 1.0 then info.greenwich.with_level = 1 $
	    else begin
		if z_min lt 1.0 then z_min = 1.0
	    endelse
	endif
	n_level = info.greenwich.n_level
	if info.greenwich.in_level eq 1 then begin
	    temp_range = str_sep(info.greenwich.range, ';')
	    num_range = n_elements(temp_range)
	    if info.greenwich.ext_level eq 0 then begin
		n_level = num_range + 1
		vlevel = double(temp_range)
		vlevel = [vlevel(0), vlevel, vlevel(num_range-1)]
	    endif else begin
		n_level = num_range - 1
		vlevel = double(temp_range)
	    endelse
	    if z_min gt vlevel(0) then z_min = vlevel(0)
	    if z_max lt vlevel(n_level) then z_max = vlevel(n_level)
	    data_interval = vlevel(n_level-1)-vlevel(n_level-2)
	    tempa=findgen(n_level)
	endif else begin
	    tempa=findgen(n_level)
	    if info.greenwich.with_level eq 2 then begin
		if ((info.axis_state eq 3) or (info.axis_state eq 5)) and $
		  info.greenwich.ext_level eq 0 then begin
		    ;data_interval = (alog10(z_max) - alog10(z_min))/float(n_level-1)
		    ;vlevel = [0, tempa+1]
		    data_interval = (alog10(z_max) - alog10(z_min))/float(n_level-2)
		    vlevel = [0, tempa]
		    vlevel(n_level) = vlevel(n_level-1)
		endif else begin
		    data_interval = (alog10(z_max) - alog10(z_min))/float(n_level)
		    vlevel = [0, tempa+1]
		endelse
		vlevel = alog10(z_min) + vlevel * data_interval
		vlevel = 10 ^ vlevel
	    endif else begin
		if ((info.axis_state eq 3) or (info.axis_state eq 5)) and $
		  info.greenwich.ext_level eq 0 then begin
		    ;data_interval = (z_max - z_min)/float(n_level-1)
		    ;vlevel = [0, tempa+1]
		    data_interval = (z_max - z_min)/float(n_level-2)
		    vlevel = [0, tempa]
		    vlevel(n_level) = vlevel(n_level-1)
		endif else begin
		    data_interval = (z_max - z_min)/float(n_level)
		    vlevel = [0, tempa+1]
		endelse
		vlevel = z_min + vlevel * data_interval
	    endelse
	endelse

	color_interval = top_color/float(n_level)
	clevel = fix(color_interval * (tempa(*) + 1))

	my_color = make_array(n_elements(hdf_data_z), /INT, VALUE=top_color + 10)
	if info.greenwich.in_level eq 0 then begin
	    ;if abs(data_interval) ge 1.0 then begin
	;	if info.greenwich.with_level eq 2 then begin
	;	    my_color(*) = fix(fix((alog10(hdf_data_z(*)) - alog10(z_min))/data_interval + 1.0) * $
	;		color_interval)
	;	endif else begin
	;	    my_color(*) = fix(fix((hdf_data_z(*) - z_min)/data_interval + 1.0) * $
	;		color_interval)
	;	endelse
	;    endif else begin
	;	if info.greenwich.with_level eq 2 then begin
	;	    my_color(*) = fix(fix((alog10(hdf_data_z(*)) - alog10(z_min))/data_interval + 0.99999) * $
	;		color_interval)
	;	endif else begin
	;	    my_color(*) = fix(fix((hdf_data_z(*) - z_min)/data_interval + 0.99999) * $
	;		color_interval)
	;	endelse
	;    endelse
	    ;my_color(*) = top_color + 10
	    for i = 0, n_level-2 do begin
		sub_color = where(hdf_data_z ge vlevel(i) and hdf_data_z lt vlevel(i+1), count_color)
		if count_color ne 0 then my_color(sub_color) = clevel(i)
	    endfor
	    if ((info.axis_state eq 3) or (info.axis_state eq 5)) and $
	      info.greenwich.ext_level eq 0 then begin
		sub_color = where(hdf_data_z gt vlevel(n_level-1), count_color)
		if count_color ne 0 then my_color(sub_color) = clevel(n_level-1)
		sub_color = where(hdf_data_z lt vlevel(1), count_color)
		if count_color ne 0 then my_color(sub_color) = clevel(0)
		with_level_flag = 1
	    endif else begin
		sub_color = where(hdf_data_z ge vlevel(n_level-1) and hdf_data_z lt vlevel(n_level), count_color)
		if count_color ne 0 then my_color(sub_color) = clevel(n_level-1)
	    endelse
	endif else begin
	    if info.greenwich.ext_level eq 0 then begin
		sub_color = where(hdf_data_z lt vlevel(1), count_color)
		if count_color ne 0 then my_color(sub_color) = clevel(0)
		sub_color = where(hdf_data_z gt vlevel(n_level-1), count_color)
		if count_color ne 0 then my_color(sub_color) = clevel(n_level-1)
	    endif else begin
		sub_color = where(hdf_data_z lt vlevel(1) and hdf_data_z ge vlevel(0), count_color)
		if count_color ne 0 then my_color(sub_color) = clevel(0)
		sub_color = where(hdf_data_z gt vlevel(n_level-1) and hdf_data_z le vlevel(n_level), count_color)
		if count_color ne 0 then my_color(sub_color) = clevel(n_level-1)
	    endelse
	    for i = 1, n_level-2 do begin
		sub_color = where(hdf_data_z ge vlevel(i) and hdf_data_z lt vlevel(i+1), count_color)
		if count_color ne 0 then my_color(sub_color) = clevel(i)
	    endfor
	    ;sub_color = where(hdf_data_z gt vlevel(n_level-1), count_color)
	    ;if count_color ne 0 then my_color(sub_color) = clevel(n_level-1)
	    with_level_flag = 1
	endelse

	if filldata_value gt 0 then begin
	    subscript = where(hdf_data_z ge filldata_value, count)
	endif else begin
	    subscript = where(hdf_data_z le filldata_value, count)
	endelse
	if count ne 0 then my_color(subscript) = top_color + 10

	;subscripts = where(my_color gt top_color, count)
	;if count ne 0 then my_color(subscripts) = !P.BACKGROUND
	subscripts = where(my_color le top_color and my_color ge 0, count)
	if count ne 0 then begin
		hdf_data_x = hdf_data_x(subscripts)
		hdf_data_y = hdf_data_y(subscripts)
		hdf_data_z = hdf_data_z(subscripts)
		my_color = my_color(subscripts)
	endif
endif 

if info.style.symbol eq 0 then plot_symbol = 3 $
   else plot_symbol = info.style.symbol

if plot_type eq 0 then begin
    if info.axis_state gt 0 then begin
	fit_flag = 0
	if with_level_flag eq 0 then begin
	    fit_data_range, info.axis_state, fit_flag, 1, 1, xrange, yrange, zrange, $
		0, hdf_data_x, hdf_data_y, hdf_data_z, 0, my_color
	endif else begin
	    fit_data_range, info.axis_state, fit_flag, 1, 1, xrange, yrange, 0, $
		0, hdf_data_x, hdf_data_y, hdf_data_z, 0, my_color
	endelse
	if fit_flag eq 1 then return
    endif
    if info.mpeg.flag eq 0 then begin
	num_x = n_elements(hdf_data_z)
	i = 0L
	!UserDone = 0
	;for i=0L,(n_elements(hdf_data_z)-1) do begin
	while(i lt num_x and !UserStop eq 1) do begin
	    if(i mod 1000 eq 0) then begin
		if !D.Name ne 'WIN' then begin
		    result = widget_event(info.widgets.stop,/Nowait, /save_hourglass)
		    result = widget_event(info.widgets.pause,/Nowait, /save_hourglass)
		endif else begin
		    ;  If put a hourglass in WIN, it will not get the signal of stop or pause widget
		    result = widget_event(info.widgets.stop,/Nowait)
		    result = widget_event(info.widgets.pause,/Nowait)
		endelse
	    endif
	    oplot,[hdf_data_x(i),hdf_data_x(i)],[hdf_data_y(i),hdf_data_y(i)], $
		MAX_VALUE = 360.0, MIN_VALUE = -360.0, color=my_color(i), $
		psym=plot_symbol, symsize = info.style.symbolsize, $
		thick = info.style.linethick
	    i = i + 1
	endwhile
	; endfor
    endif else begin
	total_frame = info.mpeg.frame
	put_frame = n_elements(hdf_data_z) / total_frame
	put_frame = long(put_frame)
	num_frame = 1
	num_x = n_elements(hdf_data_z)
	i = 0L
	!UserDone = 0
	;for i=0L,(n_elements(hdf_data_z)-1) do begin
	while(i lt num_x and !UserStop eq 1) do begin
	    if(i mod 1000 eq 0) then begin
		if !D.Name ne 'WIN' then begin
		    result = widget_event(info.widgets.stop,/Nowait, /save_hourglass)
		    result = widget_event(info.widgets.pause,/Nowait, /save_hourglass)
		endif else begin
		    ;  If put a hourglass in WIN, it will not get the signal of stop or pause widget
		    result = widget_event(info.widgets.stop,/Nowait)
		    result = widget_event(info.widgets.pause,/Nowait)
		endelse
	    endif
	    oplot,[hdf_data_x(i),hdf_data_x(i)],[hdf_data_y(i),hdf_data_y(i)], $
		MAX_VALUE = 360.0, MIN_VALUE = -360.0, color=my_color(i), $
		psym=plot_symbol, symsize = info.style.symbolsize, $
		thick = info.style.linethick
	    check_put = i mod put_frame
	    if check_put eq 0 then begin
		mpeg_put, info.mpeg.id, /order, window=info.mpeg.winid, frame=num_frame
		;image2d = get_image()
		;mpeg_put, info.mpeg.id, /order, image=image2d, frame=num_frame
		num_frame = num_frame + 1
		;print,'num_frame = ',num_frame,' id = ',info.mpeg.winid
	    endif
	    i = i + 1
	endwhile
	; endfor
    endelse
endif else begin
    if info.axis_state eq 1 or info.axis_state eq 4 or info.axis_state eq 5 then begin
      if cross_green eq 0 then begin
	lon_max = max(hdf_data_x, min=lon_min)
	;if(lon_min lt 0.0 and lon_min gt -180.0) then begin
	if(lon_min lt 0.0 and lon_min ge -180.0) then begin
	    neg_long = where(hdf_data_x lt 0.0, count)
	    if count ne 0 then hdf_data_x(neg_long) = 360.0 + hdf_data_x(neg_long)
	endif
	if XRange(1) eq 0.0 and XRange(0) lt 0.0 then XRange(1) = 360.0
	;if XRange(0) lt 0.0 and XRange(0) gt -180.0 then $
	if XRange(0) lt 0.0 and XRange(0) ge -180.0 then $
		XRange(0) = 360.0 + XRange(0)
	;if XRange(1) lt 0.0 and XRange(1) gt -180.0 then $
	if XRange(1) lt 0.0 and XRange(1) ge -180.0 then $
		XRange(1) = 360.0 + XRange(1)
	r_sub = where(hdf_data_x ge XRange(0) and hdf_data_x le XRange(1), count)
	if count ne 0 then begin
	    hdf_data_x = hdf_data_x(r_sub)
	    hdf_data_y = hdf_data_y(r_sub)
	    hdf_data_z = hdf_data_z(r_sub)
	endif else begin
	    result=dialog_message('All Longitude data are out of Range!',$
		title='View HDF Warning!')
	    return
	endelse
      endif else begin
	lon_max = max(hdf_data_x, min=lon_min)
	if(lon_max lt 360.0 and lon_max gt 180.0) then begin
	    neg_long = where(hdf_data_x gt 180.0, count)
	    if count ne 0 then hdf_data_x(neg_long) = hdf_data_x(neg_long) - 360.0
	endif
	r_sub = where(hdf_data_x ge XRange(0) and hdf_data_x le XRange(1), count)
	if count ne 0 then begin
	    hdf_data_x = hdf_data_x(r_sub)
	    hdf_data_y = hdf_data_y(r_sub)
	    hdf_data_z = hdf_data_z(r_sub)
	endif else begin
	    result=dialog_message('All Longitude data are out of Range!',$
		title='View HDF Warning!')
	    return
	endelse
      endelse
    endif

    if info.axis_state eq 2 or info.axis_state eq 4 or info.axis_state eq 5 then begin
	r_sub = where(hdf_data_y ge YRange(0) and hdf_data_y le YRange(1), count)	
	if count ne 0 then begin
	    hdf_data_x = hdf_data_x(r_sub)
	    hdf_data_y = hdf_data_y(r_sub)
	    hdf_data_z = hdf_data_z(r_sub)
	endif else begin
	    result=dialog_message('All Latitude data are out of Range!',$
		title='View HDF Warning!')
	    return
	endelse
    endif
    long_max = max(hdf_data_x, min=long_min)
    lat_max = max(hdf_data_y, min=lat_min)
    data_max = max(hdf_data_z, min=data_min)

;    data_interval = (z_max-z_min)/float(n_level)
;    tempa = findgen(n_level)
;    nlevel = z_min + tempa(*) * data_interval
    nlevel = vlevel
    num_level = n_elements(nlevel)
    if nlevel(0) eq nlevel(1) then begin
	if nlevel(0) gt z_min then nlevel(0) = z_min else nlevel(0) = nlevel(0) - 1000
    endif
    if nlevel(num_level-1) eq nlevel(num_level-2) then begin
	if nlevel(num_level-1) lt z_max then nlevel(num_level-1) = z_max $
	    else nlevel(num_level-1) = nlevel(num_level-1) + 1000
    endif

    if info.greenwich.contour eq 1 then begin
	max_hdf_x = max(hdf_data_x)
	if(max_hdf_x lt 360.0 and max_hdf_x gt 180.0) then begin
	    neg_hdf_x = where(hdf_data_x gt 180.0, count)
	    if count ne 0 then hdf_data_x(neg_hdf_x) = hdf_data_x(neg_hdf_x) - 360.0
	endif
    endif

    long_range = long_max - long_min + 1.0
    lat_range = lat_max - lat_min + 1.0
    if long_range ge 360.0 then begin
	if info.greenwich.contour eq 1 then begin
	    long_max = 180.0
	    long_min = -180.0
	endif else begin
	    long_max = 360.0
	    long_min = 0.0
	    min_hdf_x = min(hdf_data_x)
	    ;if(min_hdf_x lt 0.0 and min_hdf_x gt -180.0) then begin
	    if(min_hdf_x lt 0.0 and min_hdf_x ge -180.0) then begin
		neg_hdf_x = where(hdf_data_x lt 0.0, count)
		if count ne 0 then hdf_data_x(neg_hdf_x) = hdf_data_x(neg_hdf_x) + 360.0
	    endif
	endelse
    endif
    lon_space = (long_max - long_min)/info.greenwich.n_x_grid
    if lat_range ge 180.0 then begin
	lat_max = 90.0
	lat_min = -90.0
    endif
    lat_space = (lat_max - lat_min)/info.greenwich.n_y_grid
    gridspace=[lon_space, lat_space]
    gridlimit = [long_min, lat_min, long_max, lat_max]
    
    if info.greenwich.smooth gt 3 then begin
	if filldata_value gt 0 then begin
	    subscript = where(hdf_data_z lt filldata_value, count)
	endif else begin
	    subscript = where(hdf_data_z gt filldata_value, count)
	endelse
	if count ne 0 then begin
		hdf_data_z = hdf_data_z(subscript)
		hdf_data_x = hdf_data_x(subscript)
		hdf_data_y = hdf_data_y(subscript)
	endif else begin
		result=dialog_message('All Data is FILL data!',$
			title='View HDF Warning!')
		return
	endelse
	create_grid_data, hdf_data_x, hdf_data_y, hdf_data_z, gridspace, gridlimit, $
		filldata_value, gridlon, gridlat, griddata1
	if filldata_value gt 0 then begin
	    subscript = where(griddata1 lt filldata_value, count)
	endif else begin
	    subscript = where(griddata1 gt filldata_value, count)
	endelse
	if count eq 0 then begin
		result=dialog_message('All Data is out of range!',$
			title='View HDF Warning!')
                return
        endif
    endif else begin
	if long_range ge 360.0 then begin
	    min_delt = 2*lon_space
	    if info.greenwich.contour eq 0 then begin
		min_sub = where(hdf_data_x lt 360.0 and hdf_data_x gt 360.0-min_delt, count_min)
	    endif else begin
		min_sub = where(hdf_data_x lt 180.0 and hdf_data_x gt 180.0-min_delt, count_min)
	    endelse
	    if count_min ne 0 then begin
		hdf_data_x = [hdf_data_x(min_sub) - 360.0, hdf_data_x]
		hdf_data_y = [hdf_data_y(min_sub), hdf_data_y]
		hdf_data_z = [hdf_data_z(min_sub), hdf_data_z]
		gridlimit(0) = gridlimit(0)-min_delt
	    endif
	    if info.greenwich.contour eq 0 then begin
		min_sub = where(hdf_data_x gt 0.0 and hdf_data_x lt min_delt, count_min)
	    endif else begin
		min_sub = where(hdf_data_x gt -180.0 and hdf_data_x lt -180.0 + min_delt, count_min)
	    endelse
	    if count_min ne 0 then begin
		hdf_data_x = [hdf_data_x, hdf_data_x(min_sub)+360.0]
		hdf_data_y = [hdf_data_y, hdf_data_y(min_sub)]
		hdf_data_z = [hdf_data_z, hdf_data_z(min_sub)]
		gridlimit(2) = gridlimit(2)+min_delt
	    endif
	endif
	triangulate,hdf_data_x,hdf_data_y,tri,FVALUE=hdf_data_z, repeats=repeats
	if info.greenwich.smooth gt 1 then begin
	    filter_tri, hdf_data_x, hdf_data_y, tri, gridspace
	    if tri(0,0) lt 0 then begin
		result=dialog_message('All tri is out of range!',$
			title='View HDF Warning!')
		return
	    endif
	endif
	griddata1 = trigrid(hdf_data_x, hdf_data_y, hdf_data_z, tri, gridspace, gridlimit, $
	    xgrid=gridlon, ygrid=gridlat, max_value=data_max, min_value=data_min)
    endelse
    
    case info.greenwich.smooth of
	1: begin
		griddata1=smooth(griddata1, 3)
	   end
	3: begin
		if filldata_value gt 0 then begin
		    subscripts = where(griddata1 lt filldata_value, count)
		endif else begin
		    subscripts = where(griddata1 gt filldata_value, count)
		endelse
		if count ne 0 then begin
			griddata_temp = griddata1(subscripts)
			griddata_temp = smooth(griddata_temp, 3)
			griddata1(subscripts) = griddata_temp
		endif
	   end
	5: begin
		if filldata_value gt 0 then begin
		    subscripts = where(griddata1 lt filldata_value, count)
		endif else begin
		    subscripts = where(griddata1 gt filldata_value, count)
		endelse
		if count ne 0 then begin
			griddata_temp = griddata1(subscripts)
			griddata_temp = smooth(griddata_temp, 3)
			griddata1(subscripts) = griddata_temp
		endif
	   end
	else:
    endcase
    if info.greenwich.contour eq 1 then begin
	if long_range ge 360.0 then begin
	    sub_grid = where(gridlon ge -180.0 and gridlon le 180.0, count)
	    if count ne 0 then begin
		griddata1 = griddata1(sub_grid,*)
		gridlon = gridlon(sub_grid)
	    endif
	endif
	size_grid = size(griddata1)
	griddata1 = reform(griddata1, n_elements(griddata1))
	;my_color = make_array(n_elements(griddata1), /INT, value=top_color+10)
	my_color = make_array(n_elements(griddata1), /INT, value=!P.BACKGROUND)
	if info.greenwich.in_level eq 0 then begin
	    for i = 0, n_level-2 do begin
		sub_color = where(griddata1 ge vlevel(i) and griddata1 lt vlevel(i+1), count_color)
		if count_color ne 0 then my_color(sub_color) = clevel(i)
	    endfor
	    if ((info.axis_state eq 3) or (info.axis_state eq 5)) and $
	      info.greenwich.ext_level eq 0 then begin
		max_griddata1 = max(griddata1, min=min_griddata1)
		print,'max_griddata1 = ',max_griddata1,', min_griddata1 = ',min_griddata1
		print,'vlevel(1) = ',vlevel(1),', vlevel(n_level-1) = ',vlevel(n_level-1)
		sub_color = where(griddata1 gt vlevel(n_level-1), count_color)
		if count_color ne 0 then my_color(sub_color) = clevel(n_level-1)
		sub_color = where(griddata1 lt vlevel(1) and griddata1 gt 0.0, count_color)
		if count_color ne 0 then my_color(sub_color) = clevel(0)
	    endif else begin
		sub_color = where(griddata1 ge vlevel(n_level-1) and griddata1 lt vlevel(n_level), count_color)
		if count_color ne 0 then my_color(sub_color) = clevel(n_level-1)
	    endelse
	endif else begin
	    if info.greenwich.ext_level eq 0 then begin
		sub_color = where(griddata1 lt vlevel(1), count_color)
		if count_color ne 0 then my_color(sub_color) = clevel(0)
		sub_color = where(griddata1 gt vlevel(n_level-1), count_color)
		if count_color ne 0 then my_color(sub_color) = clevel(n_level-1)
	    endif else begin
		sub_color = where(griddata1 lt vlevel(1) and griddata1 ge vlevel(0), count_color)
		if count_color ne 0 then my_color(sub_color) = clevel(0)
		sub_color = where(griddata1 gt vlevel(n_level-1) and griddata1 le vlevel(n_level), count_color)
		if count_color ne 0 then my_color(sub_color) = clevel(n_level-1)
	    endelse
	    for i = 1, n_level-2 do begin
		sub_color = where(griddata1 ge vlevel(i) and griddata1 lt vlevel(i+1), count_color)
		if count_color ne 0 then my_color(sub_color) = clevel(i)
	    endfor
	    ;sub_color = where(griddata1 gt vlevel(n_level-1), count_color)
	    ;if count_color ne 0 then my_color(sub_color) = clevel(n_level-1)
	endelse

	if filldata_value gt 0 then begin
	    subscript = where(griddata1 ge filldata_value, count)
	endif else begin
	    subscript = where(griddata1 le filldata_value, count)
	endelse
	;if count ne 0 then my_color(subscript) = top_color + 10
	if count ne 0 then my_color(subscript) = !P.BACKGROUND

	my_color = reform(my_color, size_grid(1), size_grid(2))

	num_lat = n_elements(gridlat)
	num_lon = n_elements(gridlon)
	con_image = map_image(my_color, startx, starty, xsize, ysize, latmin=gridlat(0), $
	    latmax=gridlat(num_lat-1), lonmin = gridlon(0), lonmax=gridlon(num_lon-1), $
	    compress=1, /bilinear, missing=!P.BACKGROUND)
	;sub_fill = where(con_image gt top_color, fill_count)
        ;if fill_count ne 0 then con_image(sub_fill) = !P.BACKGROUND
	;tvscl, con_image, startx, starty, xsize=xsize, ysize=ysize
	tv, con_image, startx, starty, xsize=xsize, ysize=ysize
    endif else begin
	if long_range ge 360.0 then begin
	    sub_grid = where(gridlon ge 0.0 and gridlon le 360.0, count)
	    if count ne 0 then begin
		griddata1 = griddata1(sub_grid,*)
		gridlon = gridlon(sub_grid)
	    endif
	endif
	;if info.greenwich.ext_level eq 1 then clevel = [clevel, !P.background]
	;print,'data_max = ',data_max
	contour, griddata1, gridlon, gridlat, /FOLLOW, levels = nlevel, c_colors=clevel, $
	    Xstyle=1, YStyle=1, /overplot, /cell_fill, max_value=data_max
    endelse
endelse

if info.greenwich.continents eq 1 and !UserStop eq 1 then begin
    if info.greenwich.high_resol eq 1 then begin
	old_quiet = !QUIET
	!QUIET=1
	if info.greenwich.coasts eq 1 then begin
	    map_continents,/coasts, /hires, mlinethick=info.greenwich.mlinethick
	endif else begin
	    map_continents, /hires, mlinethick=info.greenwich.mlinethick
	endelse
	!QUIET = old_quiet
    endif else begin
	map_continents,/coasts, mlinethick=info.greenwich.mlinethick
    endelse
    ;map_continents,mlinethick=info.greenwich.mlinethick
endif
if info.greenwich.grid eq 1 and !UserStop eq 1 then begin
    if info.axis_state eq 0 or info.axis_state eq 3 then begin
	map_grid, LABEL=info.greenwich.label, charsize = map_charsize, londel=londel
    endif else begin
	map_grid, LABEL=info.greenwich.label, charsize = map_charsize, $
	    londel=londel, latdel = latdel
    endelse
endif

if info.greenwich.satellite eq 1 and !UserStop eq 1 then begin
; Plot the Satellite Position
   temp_error_data = get_error_data(satellite_x)
   if temp_error_data ge 0.0 then begin
	;if !D.Name eq 'PS' then satellite_color = !d.n_colors/10 $
	;	else satellite_color = !d.n_colors - map_color
	if !D.Name eq 'PS' or !D.Name eq 'PRINTER' then satellite_color = top_color/10 $
		else satellite_color = top_color - map_color
	fit_flag = 0
	if info.axis_state gt 0 then begin
	    fit_data_range, info.axis_state, fit_flag, 1, 0, xrange, yrange, 0, 0, $
		satellite_x, satellite_y, 0, 0, 0
	endif
	if fit_flag ne 1 then begin
	    if info.style.symbol eq 0 then plot_symbol = 3 $
		else plot_symbol = info.style.symbol
	    oplot, satellite_x, satellite_y, MAX_VALUE = 360.0, $
		MIN_VALUE = -360.0, color=satellite_color, psym=plot_symbol, $
		symsize = info.style.symbolsize, thick = info.style.linethick
	    if info.mpeg.flag eq 1 then begin
		mpeg_put, info.mpeg.id, /order, window=info.mpeg.winid, frame=num_frame
		;image2d = get_image()
		;mpeg_put, info.mpeg.id, /order, image=image2d, frame=num_frame
		num_frame = num_frame + 1
		;print,'num_frame = ',num_frame,' id = ',info.mpeg.winid
	    endif
	endif
   endif
endif

if info.greenwich.sun eq 1 and !UserStop eq 1 then begin
; Plot the Sun Position
   temp_error_data = get_error_data(sun_x)
   if temp_error_data ge 0.0 then begin
	if !D.Name eq 'PS' then sun_color = 0 $
		else sun_color = top_color - 20
		;else sun_color = !d.n_colors - 20
	fit_flag = 0
	if info.axis_state gt 0 then begin
	    fit_data_range, info.axis_state, fit_flag, 1, 0, xrange, yrange, 0, 0, $
		sun_x, sun_y, 0, 0, 0
	endif
	if fit_flag ne 1 then begin
	    if info.style.symbol eq 0 then plot_symbol = 3 $
		else plot_symbol = info.style.symbol
	    oplot, sun_x, sun_y, MAX_VALUE = 360.0, MIN_VALUE = -360.0, $
		color=sun_color, psym=plot_symbol, symsize = info.style.symbolsize, $
		thick = info.style.linethick
	    if info.mpeg.flag eq 1 then begin
		mpeg_put, info.mpeg.id, /order, window=info.mpeg.winid, frame=num_frame
		;image2d = get_image()
		;mpeg_put, info.mpeg.id, /order, image=image2d, frame=num_frame
		num_frame = num_frame + 1
		;print,'num_frame = ',num_frame,' id = ',info.mpeg.winid
	    endif
	endif
   endif
endif

endif else begin
	result=dialog_message('The number of data points are not matched!',$
		title='View HDF Warning!')
	return
endelse

; Reset the control
!UserStop = 1
!UserPause = 1
!UserDone = 1
widget_control, set_button=0, info.widgets.pause

;crit_location = barlocation-0.10
crit_location = barlocation + (3.0 * bar_offset) - 0.01
if info.color_bar eq 1 then begin
	  temp_name = info.subset.data(this_subset).src_unitname
	  temp_name = temp_name(0)
	  temp_length = strlen(temp_name)
	  unitlabel = ''
	  if (temp_length gt 0) then begin
	    dot=strpos(temp_name,'N/A')
	    if( dot eq -1) then unitlabel = strmid(temp_name,2,temp_length-2)
	  endif
	;x_location = !P.Position(0) + (!P.Position(2) - !P.Position(0))/2. - 0.22
	x_bar_location = 20.0 * info.greenwich.barsize
	x_location = !P.Position(0) + (!P.Position(2) - !P.Position(0))/2. - x_bar_location
	; x_location = !P.Position(0) + (!P.Position(2) - !P.Position(0))/2. - x_bar_offset
	; deltx = (x_bar_offset)/20.0
	if info.greenwich.with_level eq 1 then $
	    draw_contour_bar, clevel, z_min, z_max, barlocation, x_location, n_level, info.char.size, $
		info.char.font, unitlabel, vlevel, !P.BACKGROUND, info.greenwich.setformat, $
		info.greenwich.bformat, info.greenwich.colborder, info.greenwich.displaybad, $
		bar_offset=abs(bar_offset), deltx=info.greenwich.barsize $
		;info.char.font, unitlabel, vlevel, !P.BACKGROUND, bar_offset=abs(bar_offset), deltx=deltx $
	else draw_color_bar, top_color, z_min, z_max, barlocation, x_location, info.char.size, $
		info.char.font, unitlabel, info.greenwich.setformat, info.greenwich.bformat, $
		bar_offset=abs(bar_offset), deltx=info.greenwich.barsize
		; info.char.font, unitlabel, bar_offset=abs(bar_offset), deltx = deltx
	if strlen(unitlabel) gt 140 then crit_location = crit_location - 0.015
endif

if info.subset.data(this_subset).src_crit_flag eq 1 or $
    info.greenwich.projection eq 4 then begin
        if !D.Name eq 'PS' or !D.Name eq 'PRINTER' then charsize = 0.9*info.char.size $
        else charsize = info.char.size
	;xyouts, !X.Window(0), barlocation-0.10, crit_string, /NORMAL, font=info.char.font, $
	;xyouts, !X.Window(0), crit_location, crit_string, /NORMAL, font=info.char.font, $
	xlocation = 0.08
	xyouts, xlocation, crit_location, crit_string, /NORMAL, font=info.char.font, $
                charsize=charsize
endif

if info.addtext.key eq 1 then write_add_text, info

if info.mpeg.flag eq 1 then begin
    mpeg_put, info.mpeg.id, /order, window=info.mpeg.winid, frame=num_frame
    ;image2d = get_image()
    ;mpeg_put, info.mpeg.id, /order, image=image2d, frame=num_frame
    ;print,'num_frame = ',num_frame,' id = ',info.mpeg.winid
endif

test = !d.flags and 128
if test ne 0 then begin
    ;image = tvrd()
    image = get_image24()
    if ptr_valid(info.overlay.image) then ptr_free, info.overlay.image
	info.overlay.image = ptr_new(image, /NO_COPY)
endif

if info.overlay.flag eq 1 then do_overlay, info
 
if !D.Name ne 'PS' or !D.Name eq 'PRINTER' then !P.CHARSIZE = 0.0
; store the system variables
!P.Position = [ 0.0 , 0.0 , 0.0 , 0.0]
info.sview.map_old = !Map
info.sview.p_old = !P
info.sview.x_old = !X
info.sview.y_old = !Y

widget_control, set_uvalue=info, info.widgets.base
widget_control, set_uvalue=info, info.base
end

;--------------------------------------------------------------------------------
pro do_histogram, this_subset, print_flag, info, plot_status

pro_name = 'do_histogram'
@getinfo

data_name = info.subset.data(this_subset).subset_name
data_name = data_name(0)
dot=strpos(data_name, '[')
if( dot ne -1) then begin
	xtitle=strmid(data_name,0,dot)
endif else xtitle = data_name
if info.subset.data(this_subset).src_type_flag eq 0 then begin
        hdf_data_x = *info.subset.data(this_subset).src_data
	hdf_data_x = reform(hdf_data_x,n_elements(hdf_data_x))
endif else begin
	;hdf_data_temp = ptr_new(*info.subset.data(this_subset).src_data, /NO_COPY)
	hdf_data_temp = ptr_new(*info.subset.data(this_subset).src_data)
	hdf_data_x = reform((*hdf_data_temp).components0, n_elements((*hdf_data_temp).components0))
	ptr_free, hdf_data_temp
endelse
data_type = info.subset.data(this_subset).src_types(0)
filldata_value = get_filldata_value(data_type, info.filldata)
if filldata_value gt info.filldata then filldata_value = info.filldata
max_value = get_max_value(data_type, info.filldata)
if info.filldata gt 0 then begin
    if max_value gt info.filldata then max_value = info.filldata
endif
if filldata_value gt 0 then begin
    subscript = where(hdf_data_x lt filldata_value, count)
endif else begin
    subscript = where(hdf_data_x gt filldata_value, count)
endelse
if (count eq 0) then begin
	result=dialog_message('All data are fill data!',$
	    title='View HDF Warning!')
	plot_status = 0
	return
endif
hdf_data_x = hdf_data_x(subscript)
x_max = max(hdf_data_x, min=x_min)

if print_flag eq 0 then begin
  info.graph_style = 'Histogram'
  widget_control, set_uvalue=info, info.base
  get_hist_par, data_name, x_max, x_min, info
  widget_control, get_uvalue=info, info.base
  if info.canceloption eq 'Yes' then begin
	info.canceloption = 'No'
	widget_control, set_uvalue=info, info.base
	plot_status = 0
	return
  endif 

endif

widget_control, /hourglass
widget_control, get_uvalue=info, info.base

binsize = info.histogram.binsize
max_value = info.histogram.max
min_value = info.histogram.min

hist_result = histogram(hdf_data_x, binsize=binsize, max=max_value, min=min_value)

num_range = n_elements(hist_result)
num_bin = (max_value - min_value)/binsize

filename = info.subset.data(this_subset).src_filename

if (print_flag eq 0) then begin
	the_message = [ 'Do you want to write the result to a file?']
	result=dialog_message(the_message, /Question, title='View HDF Question!')

	if result eq 'Yes' then begin

	   count = check_directory(info.export_path, info.home_path)
	   if count eq 0 then begin
		CD, '.', CURRENT=pwd
		info.export_path = pwd
	   endif
	   export_name=dialog_pickfile(filter='*.dat', path=info.export_path, $
	   file=info.export_file, get_path=export_path,/write)
	   if export_name ne "" then begin
		export_result=STRPOS(export_name, export_path)
		if export_result eq -1 then export_name=export_path+export_name
		print,"Filename=", export_name
		info.export_path = export_path
		default_file = ''
		default_file = get_default_file(export_name)
		if default_file ne 'None' then info.export_file = default_file
		widget_control, /hourglass
		widget_control, info.widgets.current_file, get_value=this_name
		get_lun, unit
		openw, unit, export_name
		printf, unit, format='("Source Data Filename: ",A)',this_name
		data_name = info.subset.data(info.subset.selected).subset_name
		data_name = data_name(0)
		unit_name = info.subset.data(info.subset.selected).src_unitname
		unit_name = unit_name(0)
		temp_length = strlen(unit_name)
		unitlabel = ''
		if (temp_length gt 0) then $
			unitlabel = strmid(unit_name,2,temp_length-2)
		printf,unit, format='("Data Name:  ",A)', data_name
		printf,unit, format='("Unit:  ",A)', unitlabel
		data_range = ''
		data_range = get_data_range(info.subset.selected,info)
		printf,unit, format='("Data Range:  ",A)',data_range
		if info.subset.data(info.subset.selected).src_crit_flag eq 1 then begin
			this_subset = info.subset.selected
			crit_string = ''
			crit_string = get_crit_string(this_subset, info)
			temp_name = str_sep(crit_string, '!C')
			num_temp = n_elements(temp_name)
			for i = 0, num_temp-1 do begin
				temp_length = strlen(temp_name(i))
				dot=strpos(temp_name(i),';')
				if( dot ne -1) then begin
					crit1 = strtrim(strmid(temp_name(i),0,dot),2)
					crit2 = strtrim(strmid(temp_name(i),dot+1,temp_length-1),2)
					if i eq 0 then printf,unit,crit1 $
					else printf,unit,'           '+crit1
					printf,unit,'           '+crit2
				endif else begin
					crit1 = strtrim(temp_name(i),2)
					if i eq 0 then printf,unit,crit1 $
					else printf,unit,'           '+crit1
				endelse
			endfor
			printf,unit
		endif
		temp_string = 'The size of bin is '+strtrim(string(binsize),2)
		printf,unit,temp_string
		temp_string = 'The maximum value is '+strtrim(string(max_value),2)
		printf,unit,temp_string
		temp_string = 'The minimum value is '+strtrim(string(min_value),2)
		printf,unit,temp_string
		printf,unit
		temp_string = 'The result of Histogram function is:'
		printf,unit,temp_string
		printf,unit
		temp_string = '          Range                   Number  '
		printf,unit,temp_string
		for i = 0L, num_range-1 do begin
			start_value = min_value + float(i)*binsize
			end_value = min_value + float(i+1)*binsize
			temp_string = strtrim(string(start_value),2) + '-'+ $
				strtrim(string(end_value),2)
			printf,unit,format='(5x,A,10x,i10)',temp_string,hist_result(i)
		endfor
		close,unit
		free_lun, unit
		info.output_path = info.export_path
		CD, info.output_path, CURRENT=old_dir
		output_name_list=findfile(info.filter, count=count)
		if count eq 0 then output_name_list = [ 'None' ]
		widget_control, info.widgets.output, set_value=output_name_list
		widget_control, info.widgets.outputdir, set_value=info.output_path
		CD, old_dir
	   endif
	endif
endif

widget_control, /hourglass

set_axis_ranges, info, YRange, Ystyle, XRange, Xstyle, ZRange, Zstyle

data_range = ''
data_range = get_data_range(this_subset,info)
if !D.Name eq 'PS' or !D.Name eq 'PRINTER' or !D.Name eq 'WIN' or info.char.font eq 0 then begin
	the_title='Histogram of ' + xtitle + '!C Data Range: ' + data_range
endif else begin
	the_title='Histogram of ' + xtitle + '!C!C Data Range: ' + data_range
endelse

if info.subset.data(this_subset).src_crit_flag eq 1 then begin
	crit_string = ''
	crit_string = get_crit_string(this_subset, info)
	if !D.Name eq 'PS' and info.eps_out.type eq 1 then $
		!P.Position = [0.235, 0.15, 0.99, 0.92] $
		else !P.Position = [0.060, 0.120, 0.98, 0.93]
	temp_name = str_sep(crit_string, '!C')
	num_temp = n_elements(temp_name)
	!P.Position(1) = !P.Position(1) + (num_temp-1)*0.025
endif else begin
	if !D.Name eq 'PS' and info.eps_out.type eq 1 then $
		!P.Position = [0.235, 0.15, 0.99, 0.92] $
		else !P.Position = [0.060, 0.100, 0.98, 0.93]
endelse 

if info.style.symbolline eq 1 then plot_symbol = - info.style.symbol $
	else plot_symbol = info.style.symbol

temp_name = info.subset.data(this_subset).src_unitname
temp_name = temp_name(0)
dot=strpos(temp_name,'N/A')
;if( dot eq -1) then xtitle = xtitle + temp_name
if(dot eq -1) then begin
    text_string = temp_name
    length = strlen(text_string)
    if info.char.font eq -1 then begin
	max_char = 140
	com_char = 125
    endif else begin
	max_char = 125
	com_char = 110
    endelse
    if length gt max_char then begin
	text_string = strmid(text_string, 2, length-2)
	loc_comma = strpos(text_string,',',com_char)
	loc_space = strpos(text_string,' ',com_char)
	if loc_comma lt max_char then begin
		loc_sep = loc_comma
	endif else if loc_space lt max_char then begin
		loc_sep = loc_space
	endif else if loc_comma eq -1 and loc_space ne -1 then begin
		loc_sep = loc_space
	endif else if loc_comma ne -1 and loc_space eq -1 then begin
		loc_sep = loc_comma
	endif else loc_sep = max_char
	string1 = strmid(text_string,0,loc_sep)
	length2 = length - loc_sep -1
	if length2 lt 0 then string2 = '' $
	    else string2 = strmid(text_string,loc_sep+1,length2)
	if !D.Name eq 'PS' or !D.Name eq 'WIN' or info.char.font eq 0 then begin
		text_string = string1+'!C'+string2
	endif else begin
		text_string = string1+'!C!C'+string2
	endelse
	!P.Position = [0.08, 0.140, 0.98, 0.93]
	xtitle = xtitle + '!C!C' + text_string + '!C'
    endif else xtitle = xtitle + temp_name
endif

get_ticklen, info.style.grid, xticklen, yticklen 

y_max = max(hist_result, min=y_min)
info.slide.x_end = max_value
info.slide.x_start = min_value
info.slide.y_end = y_max
info.slide.y_start = y_min

if (print_flag eq 0) or (print_flag eq 3) then plot_dialogue , data_name, info

if !D.Name ne 'PRINTER' then begin
    if !D.Name ne 'WIN' and info.char.font ne 0 then begin
	xtitle='!C'+xtitle+'!C'
    endif else begin
	xtitle=xtitle+'!C'
    endelse
endif
ytitle='Number of samples'
if !D.Name eq 'PS' or !D.Name eq 'PRINTER' then begin
	old_charsize = !X.CHARSIZE
	!X.CHARSIZE = 0.9
	!Y.CHARSIZE = 0.9	
endif

if info.axis_state ne 2 and info.axis_state ne 4 then begin
	get_range, y_max, y_min, ymax, ymin
	YRange=[0, ymax]
	Ystyle = 3
endif
if info.axis_state ne 1 and info.axis_state ne 4 then begin
	get_range, max_value, min_value, xmax, xmin
	XRange = [xmin, xmax]
	Xstyle = 3
endif

if info.style.xlog gt 0 then begin
	XRange = set_log_range(XRange, XRange(0), XRange(1))
endif

if info.style.ylog gt 0 then begin
	YRange = set_log_range(YRange, YRange(0), YRange(1))
endif

plot,hdf_data_x, hist_result, /NODATA, $
	FONT=info.char.font, charsize=info.char.size, $
	xtitle=xtitle, ytitle=ytitle, title=the_title, $
	xticklen=xticklen, yticklen=yticklen, $
	subtitle="File: " + filename + "  Date:" + systime(0), $
	xrange=XRange, yrange=YRange, xstyle=Xstyle, ystyle=Ystyle, $
	xlog=info.style.xlog, ylog=info.style.ylog

start_value = min_value
for i = 0L, num_range-1 do begin
	end_value = min_value + float(i+1)*binsize
	oplot, [start_value, start_value],[YRange(0), hist_result(i)], $
		linestyle=info.style.linetype, thick = info.style.linethick, $
		color = info.style.colorindex
		;psym = plot_symbol, linestyle=info.style.linetype, $
		;symsize = info.style.symbolsize
	oplot, [start_value, end_value],[hist_result(i), hist_result(i)], $
		linestyle=info.style.linetype, thick = info.style.linethick, $
		color = info.style.colorindex
		;psym = plot_symbol, linestyle=info.style.linetype, $
		;symsize = info.style.symbolsize
	oplot, [end_value, end_value],[hist_result(i), YRange(0)], $
		linestyle=info.style.linetype, thick = info.style.linethick, $
		color = info.style.colorindex
		;psym = plot_symbol, linestyle=info.style.linetype, $
		;symsize = info.style.symbolsize
	start_value = end_value
endfor

if info.subset.data(this_subset).src_crit_flag eq 1 then begin
	if !D.Name eq 'PS' or !D.Name eq 'PRINTER' then begin
		charsize = 0.9*info.char.size
		y_location = 0.125
	endif else begin
		charsize = info.char.size
		y_location = 0.11
	endelse
	;xyouts, !P.Position(0), !P.Position(1)-y_location, crit_string, /NORMAL, $
	xyouts, 0.08, !P.Position(1)-y_location, crit_string, /NORMAL, $
		font=info.char.font, charsize=charsize
endif

if info.addtext.key eq 1 then write_add_text, info

if !D.Name eq 'PS' or !D.Name eq 'PRINTER' then begin
	!X.CHARSIZE = old_charsize
	!Y.CHARSIZE = old_charsize
endif

!P.Position = [0.0, 0.0, 0.0, 0.0]

widget_control, set_uvalue=info, info.widgets.base
widget_control, set_uvalue=info, info.base

end

;--------------------------------------------------------------------------------
pro do_regression, print_flag, this_subset, info, plot_status

pro_name = 'do_regression'
@getinfo

if info.subset.count lt 1 then begin
	the_message = ['You need at least one subset of data', $
	    'to do Regression!']
	result=dialog_message(the_message, title='View HDF Warning!')
	plot_status = 0
	return
endif

if print_flag eq 0 then begin
  info.graph_style = 'Regression'
  pick_indep_variables, this_subset, info
  widget_control, get_uvalue=info, info.base
  if info.canceloption eq 'Yes' then begin
	info.canceloption = 'No'
	widget_control, set_uvalue=info, info.base
	plot_status = 0
	return
  endif 

endif

widget_control, /hourglass

widget_control, get_uvalue=info, info.base

subscripts = where(info.out.pick eq 1, numout)
print, 'number of variables picked = ', numout
if (numout eq 0) then begin
    result=dialog_message('No independent data selected for "Regression"!',$
	title='View HDF Warning!')
    plot_status = 0
    return
endif
	
info.subset.selected = this_subset
data_name = info.subset.data(this_subset).subset_name
data_name = data_name(0)
indep_list = info.name_list_indep
num_list = n_elements(indep_list)

if info.subset.data(this_subset).src_type_flag eq 0 then begin
	hdf_data_y = *info.subset.data(this_subset).src_data
	size_hdf_data = size(hdf_data_y)
	hdf_data_y = reform(hdf_data_y, n_elements(hdf_data_y))
endif else begin
	hdf_y_temp = *info.subset.data(this_subset).src_data
	size_hdf_data = size(hdf_y_temp)
	hdf_data_y = reform(hdf_y_temp.components0, n_elements(hdf_y_temp.components0))
endelse
num_y = n_elements(hdf_data_y)
this_type = info.subset.data(this_subset).src_types
this_type = this_type(0)
filldata_value_y = get_filldata_value(this_type, info.filldata)
if filldata_value_y gt info.filldata then filldata_value_y = info.filldata
max_value_y = get_max_value(this_type, info.filldata)
if info.filldata gt 0 then begin
    if max_value_y gt info.filldata then max_value_y = info.filldata
endif
max_value = max_value_y
if filldata_value_y gt 0 then begin
    subs_data_y = where(hdf_data_y lt filldata_value_y, count)
endif else begin
    subs_data_y = where(hdf_data_y gt filldata_value_y, count)
endelse
if (count eq 0) then begin
	result=dialog_message('All dependent variable, ' + data_name + ' are fill data!',$
	    title='View HDF Warning!')
	plot_status = 0
	return
endif

for i = 0 , numout-1 do begin
  x_name = indep_list(subscripts(i))
  if subscripts(i) lt (num_list - 2) then begin
     if info.subset.data(subscripts(i)).src_type_flag eq 0 then begin
	hdf_x_temp = *info.subset.data(subscripts(i)).src_data
	hdf_x_temp = reform(hdf_x_temp, n_elements(hdf_x_temp))
     endif else begin
	hdf_x_temp = *info.subset.data(subscripts(i)).src_data
	hdf_x_temp = reform(hdf_x_temp.components0, n_elements(hdf_x_temp.components0))
     endelse
     num_x = n_elements(hdf_x_temp)
     this_type = info.subset.data(subscripts(i)).src_types
     this_type = this_type(0)
     filldata_value_x = get_filldata_value(this_type, info.filldata)
     if filldata_value_x gt info.filldata then filldata_value_x = info.filldata
  endif else begin
     if indep_list(subscripts(i)) eq 'Time' then begin
	if info.subset.data(this_subset).src_type_flag eq 0 then begin
  		this_rank = info.subset.data(this_subset).src_rank
  		start_list = info.subset.data(this_subset).src_start(0:this_rank-1)
  		end_list = info.subset.data(this_subset).src_end(0:this_rank-1)
  		increment_list = info.subset.data(this_subset).src_increment(0:this_rank-1)
  		;array_size = long((end_list-start_list)/float(increment_list) + 0.9)
		array_size = long((end_list-start_list-1)/float(increment_list) + 1.0)
  		hdf_x_temp = array_type(6, array_size)
  		if (hdf_x_temp(0) eq -1) then begin
			result=dialog_message('Unable to allocate memory for Time!',$
				title='View HDF Warning!')
			plot_status = 0
			return
		endif
	endif else begin
		hdf_x_temp = make_array(num_y, /DOUBLE)
	endelse
	get_seconds, info, this_subset, hdf_x_temp
	num_x = n_elements(hdf_x_temp)
	hdf_x_temp = reform(hdf_x_temp, num_x)
	filldata_value_x = 86401.0
	case info.time_type.new of
		0:begin
			 hdf_x_temp(subs_data_y) = hdf_x_temp(subs_data_y)/3600.0
			 filldata_value_x = 24.01
		  end
		1: begin
			hdf_x_temp(subs_data_y) = hdf_x_temp(subs_data_y)/60.0
			filldata_value_x = 1440.01
		  end
		else: 
	endcase
     endif else begin
	num_x = num_y
	hdf_x_temp = dindgen(num_x) + 1.0
	filldata_value_x = info.filldata
     endelse
  endelse

  if(num_x ne num_y) then begin
	the_message = ['Number of data points for ' + x_name, $
			'are not equal to dependend variables, '+ data_name + '.', $
			'This subset is not included.']
	result=dialog_message(the_message, title='View HDF Warning!')
	subscripts(i) = - 9999
  endif

  if subscripts(i) ge 0 then begin
	if filldata_value_x gt 0 then begin
	    subscript = where(hdf_x_temp lt filldata_value_x, count)
	endif else begin
	    subscript = where(hdf_x_temp gt filldata_value_x, count)
	endelse
	if (count eq 0) then begin
		the_message = [ x_name + ' are fill data.', $
				'This is subset is not included.']
		result=dialog_message(the_message, title='View HDF Warning!')
		subscripts(i) = -9999
	endif
	if filldata_value_x gt 0 then begin
	    subscript = where(hdf_x_temp ge filldata_value_x, count)
	endif else begin
	    subscript = where(hdf_x_temp le filldata_value_x, count)
	endelse
	hdf_x_temp = double(hdf_x_temp)
	if(count ne 0 ) then hdf_x_temp(subscript) = info.filldata
  endif

  if subscripts(i) ge 0 then begin
	size_hdf_x = size(hdf_data_x)
	if size_hdf_x(0) eq 0 then hdf_data_x = hdf_x_temp $
		else hdf_data_x = [ hdf_data_x , hdf_x_temp]
  endif
endfor

num_indep = where(subscripts ge 0, indep_count)
if indep_count eq 0 then begin
	result=dialog_message('All X fields are fill data or not same number of data!', $
	    title='View HDF Warning!')
	plot_status = 0
	return
endif

if indep_count gt 1 then begin
	hdf_data_x = reform(hdf_data_x, num_y, indep_count)
	hdf_data_x = transpose(hdf_data_x)
endif else hdf_data_x = reform(hdf_data_x, 1, num_y)

if info.filldata gt 0 then begin
    if info.filldata lt 3.0E+37 then filldata = info.filldata * 10 $
	else filldata = 3.0E+38
endif else filldata = info.filldata

y_temp = hdf_data_y
x_temp = hdf_data_x
if filldata_value_y gt 0 then begin
    subscript = where(y_temp ge filldata_value_y, count)
endif else begin
    subscript = where(y_temp le filldata_value_y, count)
endelse
if (count eq num_y) then begin
	result=dialog_message('All Dependent data are fill data!',$
	    title='View HDF Warning!')
	plot_status = 0
	return
endif
;y_temp = y_temp(subscript)
if count ne 0 then x_temp(*,subscript) = info.filldata
for i = 0 , indep_count-1 do begin
	if info.filldata gt 0 then begin
	    subscript = where(x_temp(i,*) ge info.filldata, count)
	endif else begin
	    subscript = where(x_temp(i,*) le info.filldata, count)
	endelse
	if count eq num_x then begin
		result=dialog_message('All of one independent data are fill data!',$
			title='View HDF Warning!')
		plot_status = 0
		return
	endif
	if count ne 0 then begin
		y_temp(subscript) = filldata_value_y
		x_temp(*,subscript) = info.filldata
	endif
endfor

if filldata_value_y gt 0 then begin
    subscript = where(y_temp lt filldata_value_y, count)
endif else begin
    subscript = where(y_temp gt filldata_value_y, count)
endelse
if count lt 1 then begin
	result=dialog_message('Either Dependent or independent data are fill data!',$
		title='View HDF Warning!')
	plot_status = 0
	return
endif
y_temp = y_temp(subscript)
x_temp = x_temp(*,subscript)
hdf_data_z = make_array(num_x, /DOUBLE, VALUE=filldata)
hdf_error = make_array(num_x, /DOUBLE, VALUE=filldata)

weights = replicate(1.0, count)
coeff = regress(x_temp, y_temp, weights, yfit, const, sigma, ftest, r, rmul,$
		chisq, status, /relative_weight)

if coeff(0) lt 0.0 then begin
	equat_string = 'Y = ' + strtrim(string(const),2) + ' - ' + $
		strtrim(string(abs(coeff(0))),2) + ' X1'
endif else begin
	equat_string = 'Y = ' + strtrim(string(const),2) + ' + ' + $
		strtrim(string(coeff(0)),2) + ' X1'
endelse
out_equat_string = equat_string
for i = 1 , indep_count-1 do begin
	if coeff(i) lt 0.0 then begin
		equat_string = equat_string + ' - ' + strtrim(string(abs(coeff(i))),2) + $
			' X'+strtrim(string(i+1), 2)
		out_equat_string = out_equat_string + ' - ' + strtrim(string(abs(coeff(i))),2) + $
			' X'+strtrim(string(i+1), 2)
	endif else begin
		equat_string = equat_string + ' + ' + strtrim(string(coeff(i)),2) + $
			' X'+strtrim(string(i+1), 2)
		out_equat_string = out_equat_string + ' + ' + strtrim(string(coeff(i)),2) + $
			' X'+strtrim(string(i+1), 2)
	endelse
endfor

hdf_data_z(subscript) = yfit
hdf_error(subscript) = y_temp - yfit
if filldata gt 0 then begin
    subscript = where(hdf_data_z ge filldata, count)
endif else begin
    subscript = where(hdf_data_z le filldata, count)
endelse
if (count eq num_x) then begin
	result=dialog_message('All the computed result are fill data!',$
	    title='View HDF Warning!')
	plot_status = 0
	return
endif
if count ne 0 then hdf_data_z(subscript) = filldata

if filldata gt 0 then begin
    subscript = where(hdf_data_z lt filldata, count)
endif else begin
    subscript = where(hdf_data_z gt filldata, count)
endelse
if count ne 0 then begin
	hdf_data_z_temp = hdf_data_z(subscript)
	z_max = max(hdf_data_z_temp, min=z_min)
endif else begin
	result=dialog_message('All the result are fill data!',$
	    title='View HDF Warning!')
	plot_status = 0
	return
endelse

if filldata gt 0 then begin
    subscript = where(hdf_error lt filldata, err_count)
endif else begin
    subscript = where(hdf_error gt filldata, err_count)
endelse
if err_count ne 0 then begin
	hdf_error_temp = hdf_error(subscript)
	e_max = max(hdf_error_temp, min=e_min)
endif else begin
	result=dialog_message('All the error are fill data!',$
                    title='View HDF Warning!')
endelse

if filldata_value_y gt 0 then begin
    subscript = where(hdf_data_y lt filldata_value_y, count)
endif else begin
    subscript = where(hdf_data_y gt filldata_value_y, count)
endelse
if count ne 0 then begin
	hdf_data_y_temp = hdf_data_y(subscript)
	y_max = max(hdf_data_y_temp, min=y_min)
endif else begin
	result=dialog_message('All the Y variables are fill data!',$
	    title='View HDF Warning!')
	plot_status = 0
	return
endelse

info.slide.x_end = num_y
info.slide.x_start = 0
max_range_value = [y_max, z_max]
min_range_value = [y_min, z_min]
info.slide.y_end = max(max_range_value)
info.slide.y_start = min(min_range_value)

filename = info.subset.data(this_subset).src_filename
xtitle = 'Sample'

dot=strpos(data_name,'[')
if dot ne -1 then ytitle=strmid(data_name,0,dot) $
	else ytitle = data_name

xyname = 'Regression for '+ ytitle

if (print_flag eq 0) then begin
	get_variable_name, xyname, info
	widget_control, get_uvalue=info, info.base
	if info.variablename eq 'None' then begin
	    plot_status = 0
	    return
	endif
	widget_control, /hourglass
	the_rank = info.subset.data(this_subset).src_rank
	if info.subset.data(this_subset).src_type_flag eq 0 then begin
	   case size_hdf_data(0) of
		2: begin
			hdf_data = reform(hdf_data_z, size_hdf_data(1), size_hdf_data(2))
			hdf_data_error = reform(hdf_error, size_hdf_data(1), size_hdf_data(2))
		   end
		3: begin
			hdf_data = reform(hdf_data_z, size_hdf_data(1), size_hdf_data(2), $
						 size_hdf_data(3))
			hdf_data_error = reform(hdf_error, size_hdf_data(1), size_hdf_data(2), $
						 size_hdf_data(3))
		   end
		else: begin
			hdf_data = hdf_data_z
			hdf_data_error = hdf_error
		   end
	   endcase
	endif else begin
  		the_order = info.subset.data(this_subset).src_order(0)
		blank = array_type(6, the_order)
		single_record=create_struct( 'components' + '0', blank) 
		hdf_data=replicate(single_record, size_hdf_data(1))
		hdf_data_error = replicate(single_record, size_hdf_data(1))
		jj=0L
		for i=0L, size_hdf_data(1)-1 do begin
			for j=0L, the_order-1 do begin
				hdf_data(i).components0(j) = hdf_data_z(jj)
				hdf_data_error(i).components0(j) = hdf_error(jj)
				jj = jj + 1
			endfor
		endfor
	endelse
	set_statistics_subset, info.variablename, this_subset, the_rank, info, hdf_data
	temp_name = 'Error of Regression for ' + data_name
	set_statistics_subset, temp_name, this_subset, the_rank, info, hdf_data_error

	;the_message = [ 'Do you want to write the coefficient to a file?']
	;result=dialog_message(the_message, /Question, title='View HDF Question!')

	desc = [ $
		'0, label, Regression Output Option, center, font='+info.font, $
		'0, label, "   ", center, font=' + info.font, $
		'1, base, ,column, frame', $
		'0, label, Do you want to write the coefficient to a file?, left, font='+info.font, $
		'2, button, No|Yes, EXCLUSIVE, row, set_value=0, tag=coeff', $
		'1, base, ,column, frame', $
		'0, label, Do you want to plot the curve fit result?, left, font='+info.font, $
		'2, button, No|Yes, EXCLUSIVE, row, set_value=0, tag=result', $
		'1, base, ,column, frame', $
		'0, label, Do you want to plot the error?, left, font='+info.font, $
		'2, button, No|Yes, EXCLUSIVE, row, set_value=0, tag=error', $
		'0, label, "   ", center, font='+info.font, $
		'1, base, , row, space=60, center', $
		'0, button, Done, QUIT, tag=done, font='+info.font, $
		'2, button, Cancel, QUIT, tag=cancel, font='+info.font]
	
	result = cw_form(desc, /column, title='Regression Output Option')
	if result.cancel eq 1 then begin
		result.coeff = 0
		result.result = 0
		result.error = 0
	endif

	widget_control, /hourglass

	;if result eq 'Yes' then begin
	if result.coeff eq 1 then begin
		count = check_directory(info.export_path, info.home_path)
		if count eq 0 then begin
			CD, '.', CURRENT=pwd
			info.export_path = pwd
		endif
		export_name=dialog_pickfile(filter='*.dat', path=info.export_path, $
			file=info.export_file, get_path=export_path,/write)
		if export_name ne "" then begin
			export_result=STRPOS(export_name, export_path)
			if export_result eq -1 then export_name=export_path+export_name
			print,"Filename=", export_name
			info.export_path = export_path
			default_file = ''
			default_file = get_default_file(export_name)
			if default_file ne 'None' then info.export_file = default_file
			widget_control, /hourglass
			widget_control, info.widgets.current_file, get_value=this_name
			get_lun, unit
			openw, unit, export_name
			printf, unit, format='("Source Data Filename: ",A)',this_name
			data_name = info.subset.data(info.subset.selected).subset_name
			data_name = data_name(0)
			unit_name = info.subset.data(info.subset.selected).src_unitname
			unit_name = unit_name(0)
			temp_length = strlen(unit_name)
			unitlabel = ''
			if (temp_length gt 0) then $
				unitlabel = strmid(unit_name,2,temp_length-2)
			printf,unit, format='("Data Name:  ",A)', data_name
			printf,unit, format='("Unit:  ",A)', unitlabel
			data_range = ''
			data_range = get_data_range(info.subset.selected,info)
			printf,unit, format='("Data Range:  ",A)',data_range
			if info.subset.data(info.subset.selected).src_crit_flag eq 1 then begin
				this_subset = info.subset.selected
				crit_string = ''
				crit_string = get_crit_string(this_subset, info)
				temp_name = str_sep(crit_string, '!C')
				num_temp = n_elements(temp_name)
				for i = 0, num_temp-1 do begin
				   temp_length = strlen(temp_name(i))
				   dot=strpos(temp_name(i),';')
				   if( dot ne -1) then begin
					crit1 = strtrim(strmid(temp_name(i),0,dot),2)
					crit2 = strtrim(strmid(temp_name(i),dot+1,temp_length-1),2)
					if i eq 0 then printf,unit,crit1 $
						else printf,unit,'           '+crit1
					printf,unit,'           '+crit2
				   endif else begin
					crit1 = strtrim(temp_name(i),2)
					if i eq 0 then printf,unit,crit1 $
						else printf,unit,'           '+crit1
				   endelse
				endfor
				printf,unit
			endif
			temp_string = 'The regression equation is:'
			printf,unit,temp_string
			printf,unit
			printf,unit,'    '+out_equat_string
			printf,unit
			temp_name = info.subset.data(this_subset).src_unitname
			temp_name = temp_name(0)
			dot=strpos(temp_name,'N/A')
			if( dot eq -1) then yvalue = ytitle + temp_name
			printf,unit,'    '+'Y = '+yvalue

			for i = 0 , numout-1 do begin
			    if subscripts(i) ge 0 then begin
				x_name = indep_list(subscripts(i))
				x_name = x_name(0)
				dot=strpos(x_name,'[')
				if dot ne -1 then xvalue=strmid(x_name,0,dot) $
					else xvalue = x_name
  				if xvalue eq 'Time' then begin
					case info.time_type.new of
						0: xvalue = xvalue + ', hour'
						1: xvalue = xvalue + ', minute'
						else: xvalue = xvalue + ', second'
					endcase
				endif else if xvalue ne 'Sample' then begin
					temp_name = info.subset.data(subscripts(i)).src_unitname
					temp_name = temp_name(0)
					dot=strpos(temp_name,'N/A')
					if( dot eq -1) then xvalue = xvalue + temp_name
				endif
				printf,unit,'    '+'X'+strtrim(string(i+1), 2)+' = '+xvalue
			    endif
			endfor
			printf,unit
			cor_string = 'Multiple correlation coefficient = '
			cor_string = cor_string + strtrim(string(rmul),2)
			printf,unit,cor_string
			printf,unit
			for i = 0 , numout-1 do begin
			    if subscripts(i) ge 0 then begin
				cor_string = 'Linear correlation coefficient for ' + $
					'X'+strtrim(string(i+1), 2)+ ' = ' + $
					strtrim(string(r(i)),2)
				printf,unit,cor_string
			    endif
			endfor
			close,unit
			free_lun, unit
			info.output_path = info.export_path
			CD, info.output_path, CURRENT=old_dir
			output_name_list=findfile(info.filter, count=count)
			if count eq 0 then output_name_list = [ 'None' ]
			widget_control, info.widgets.output, set_value=output_name_list
			widget_control, info.widgets.outputdir, set_value=info.output_path
			CD, old_dir
		endif
	endif

	;the_message = [ 'Do you want to plot the curve fit result?']
	;result=dialog_message(the_message, /Question, title='View HDF Question!')

	;if result eq 'No' then return
	if result.result eq 0 then begin
	    plot_status = 0
	    return
	endif

	info.plot_error = result.error
	;info.plot_error = 1
	;the_message = [ 'Do you want to plot the error?']
	;result=dialog_message(the_message, /Question, title='View HDF Question!')

	;if result eq 'No' then info.plot_error = 0
	widget_control, set_uvalue=info, info.base
endif

widget_control, /hourglass
widget_control, get_uvalue=info, info.base
if info.canceloption eq 'Yes' then begin
	info.canceloption = 'No'
	widget_control, set_uvalue=info, info.base
	plot_status = 0
	return
endif 

set_axis_ranges, info, YRange, Ystyle, XRange, Xstyle, ZRange, Zstyle

data_range = ''
data_range = get_data_range(this_subset,info)
if !D.Name eq 'PS' or !D.Name eq 'PRINTER' or !D.Name eq 'WIN' or info.char.font eq 0 then begin
	the_title='Regression for ' + ytitle + '!C Data Range: ' + data_range
endif else begin
	the_title='Regression for ' + ytitle + '!C!C Data Range: ' + data_range
endelse

if info.subset.data(this_subset).src_crit_flag eq 1 then begin
	crit_string = ''
	crit_string = get_crit_string(this_subset, info)
	if !D.Name eq 'PS' and info.eps_out.type eq 1 then $
		!P.Position = [0.235, 0.15, 0.99, 0.92] $
		else !P.Position = [0.060, 0.120, 0.98, 0.93]
	temp_name = str_sep(crit_string, '!C')
	num_temp = n_elements(temp_name)
	!P.Position(1) = !P.Position(1) + (num_temp-1)*0.025
endif else begin
	if !D.Name eq 'PS' and info.eps_out.type eq 1 then $
		!P.Position = [0.235, 0.15, 0.99, 0.92] $
		else !P.Position = [0.060, 0.100, 0.98, 0.93]
endelse 

if info.style.symbolline eq 1 then plot_symbol = - info.style.symbol $
	else plot_symbol = info.style.symbol

xtitle = 'Sample'

temp_name = info.subset.data(this_subset).src_unitname
temp_name = temp_name(0)
dot=strpos(temp_name,'N/A')
if( dot eq -1) then ytitle = ytitle + temp_name

get_ticklen, info.style.grid, xticklen, yticklen 

if (print_flag eq 0) or (print_flag eq 3) then plot_dialogue , xyname, info

if !D.Name ne 'PRINTER' then begin
    if !D.Name ne 'WIN' and info.char.font ne 0 then begin
	xtitle= '!C' + xtitle + '!C'
    endif else begin
	xtitle = xtitle + '!C'
    endelse
endif
if !D.Name eq 'PS' or !D.Name eq 'PRINTER' then begin
	old_charsize = !X.CHARSIZE
	!X.CHARSIZE = 0.9
	!Y.CHARSIZE = 0.9	
endif

max_y_range = max_value
if info.axis_state ne 2 and info.axis_state ne 4  and info.axis_state ne 7 $
    and info.axis_state ne 9 then begin
	if y_max gt z_max then temp_max = y_max $
		else temp_max = z_max
	if y_min lt z_min then temp_min = y_min $
		else temp_min = z_min
	temp_max = temp_max + (temp_max - temp_min)*(0.20 + indep_count*0.025)
endif else begin
        temp_max = YRange(1)
        temp_min = YRange(0)
	info.range.real_y_end = temp_max
	max_y_range = temp_max
	temp_max = temp_max + (temp_max - temp_min)*(0.22 + indep_count*0.025)
endelse
if info.plot_error eq 1 then begin
    if info.axis_state lt 6 then begin
	get_range, e_max, e_min, err_max, err_min
    endif else begin
	err_min = info.range.y2_start
	err_max = info.range.y2_end
    endelse
    err_max = err_max + (err_max - err_min)*(0.20 + indep_count*0.025)
    if !P.Position(2) gt 0.0 then !P.Position(2) = !P.Position(2) - 0.03
    !X.MARGIN = [10, 10]
    ystyle = ystyle + 8
endif
YRange = [temp_min, temp_max]
min_value = temp_min

if info.style.xlog gt 0 then begin
	default_max = n_elements(hdf_data_y)
	XRange = set_log_range(XRange, 1, default_max)
endif

if info.style.ylog gt 0 then begin
	YRange = set_log_range(YRange, YRange(0), YRange(1))
endif

plot, hdf_data_y, $
       	MAX_VALUE = max_value, /YNOZERO, /NODATA, FONT=info.char.font, $
	charsize=info.char.size, xtitle=xtitle, ytitle=ytitle, $
	title=the_title, xticklen=xticklen, yticklen=yticklen, $
	subtitle="File: " + filename + "  Date:" + systime(0), $
       	xrange=XRange, yrange=YRange, xstyle=Xstyle, ystyle=Ystyle, $
	xlog=info.style.xlog, ylog=info.style.ylog

if info.multiple.styleflag eq 1 then begin
    num = 0
    style_name = info.subset.data(this_subset).subset_name
    style_name = style_name(0)
    get_input_style, info, style_name, num, linetype, plot_symbol, colorindex
    if linetype lt 0 then begin
	plot_status = 0
	return
    endif
endif else begin
    linetype = info.style.linetype
    colorindex = info.style.colorindex
endelse

;oplot, hdf_data_y,MAX_VALUE = max_value, psym = plot_symbol, $
oplot, hdf_data_y,MAX_VALUE = max_y_range, min_value = min_value, $
	psym = plot_symbol, linestyle=linetype, $
	symsize = info.style.symbolsize, thick = info.style.linethick, $
	color = colorindex

legend_title = ytitle
y_leg = !Y.WINDOW(1) - 0.03
y_leg_t = y_leg - 0.005
x_leg_s = !X.WINDOW(0) + 0.03
x_leg_e = x_leg_s + 0.05
leg_start = convert_coord(x_leg_s, y_leg, /NORMAL, /TO_DATA)
leg_end   = convert_coord(x_leg_e, y_leg, /NORMAL, /TO_DATA)
oplot, [leg_start(0), leg_end(0)], [leg_start(1), leg_end(1)], $
	psym = plot_symbol, linestyle=linetype, $
	symsize = info.style.symbolsize, thick = info.style.linethick, $
	color = colorindex
xyouts, x_leg_e+0.01, y_leg_t, legend_title, /NORMAL, font=info.char.font, $
	charsize=info.char.size

linetype = info.style.linetype + 1
if linetype gt 5 then linetype = 0
if info.style.symbol gt 0 then plot_symbol = info.style.symbol + 1
if plot_symbol gt 7 then plot_symbol = 1
if info.style.symbolline eq 1 then plot_symbol = - plot_symbol
if info.axis_state ne 2 and info.axis_state ne 4  and info.axis_state ne 7 $
    and info.axis_state ne 9 then begin
	if info.filldata gt 0 then max_y_range = info.filldata $
	    else max_y_range = max_value
endif else max_y_range = info.range.real_y_end

if info.multiple.styleflag eq 1 then begin
    num = 1
    style_name = info.subset.data(this_subset).subset_name
    style_name = style_name(0)
    style_name = 'Regression of ' + style_name
    get_input_style, info, style_name, num, linetype, plot_symbol, colorindex
    if linetype lt 0 then begin
	plot_status = 0
	return
    endif
    if info.plot_error eq 0 then info.multiple.resetflag = 0
endif else begin
    colorindex = info.style.colorindex
endelse

;oplot, hdf_data_z,MAX_VALUE = info.filldata, psym = plot_symbol, $
oplot, hdf_data_z,MAX_VALUE = max_y_range, min_value = min_value, $
	psym = plot_symbol, linestyle=linetype, symsize = info.style.symbolsize, $
	thick = info.style.linethick, color=colorindex

legend_title = 'Regression of ' + ytitle
y_leg = !Y.WINDOW(1) - 0.055
y_leg_t = y_leg - 0.005
x_leg_s = !X.WINDOW(0) + 0.03
x_leg_e = x_leg_s + 0.05
leg_start = convert_coord(x_leg_s, y_leg, /NORMAL, /TO_DATA)
leg_end   = convert_coord(x_leg_e, y_leg, /NORMAL, /TO_DATA)
oplot, [leg_start(0), leg_end(0)], [leg_start(1), leg_end(1)], $
	psym = plot_symbol, linestyle=linetype, symsize = info.style.symbolsize, $
	thick = info.style.linethick, color=colorindex
xyouts, x_leg_e+0.01, y_leg_t, legend_title, /NORMAL, font=info.char.font, $
	charsize=info.char.size

if info.plot_error eq 1 then begin
	linetype = linetype + 1
	if linetype gt 5 then linetype = 0
	if info.style.symbol gt 0 then plot_symbol = plot_symbol + 1
	if plot_symbol gt 7 then plot_symbol = 1
	if info.style.symbolline eq 1 then plot_symbol = - plot_symbol

	if info.multiple.styleflag eq 1 then begin
	    num = 2
	    style_name = 'Error of regression'
	    get_input_style, info, style_name, num, linetype, plot_symbol, colorindex
	    if linetype lt 0 then begin
		plot_status = 0
		return
	    endif
	    info.multiple.resetflag = 0
	endif else begin
	    colorindex = info.style.colorindex
	endelse

	legend_title = 'Error'
	y_leg = !Y.WINDOW(1) - 0.080
	y_leg_t = y_leg - 0.005
	x_leg_s = !X.WINDOW(0) + 0.03
	x_leg_e = x_leg_s + 0.05
	leg_start = convert_coord(x_leg_s, y_leg, /NORMAL, /TO_DATA)
	leg_end   = convert_coord(x_leg_e, y_leg, /NORMAL, /TO_DATA)
	oplot, [leg_start(0), leg_end(0)], [leg_start(1), leg_end(1)], $
		psym = plot_symbol, linestyle=linetype, symsize = info.style.symbolsize, $
		thick = info.style.linethick, color = colorindex
	xyouts, x_leg_e+0.01, y_leg_t, legend_title, /NORMAL, font=info.char.font, $
		charsize=info.char.size

	if !Y.TYPE eq 1 then !Y.TYPE = 0
	Axis, YAXIS=1, ytitle = 'Error', YRANGE=[err_min, err_max], $
		FONT=info.char.font, charsize=info.char.size, ystyle=2, $
		ticklen=0.01, /SAVE

	if info.axis_state lt 6 then begin
	    if info.filldata gt 0 then max_y_range = info.filldata else max_y_range = max_value
	endif else max_y_range = info.range.y2_end
	min_value = err_min
	;oplot, hdf_error,MAX_VALUE = info.filldata, psym = plot_symbol, $
	oplot, hdf_error,MAX_VALUE = max_y_range, min_value = min_value, $
		psym = plot_symbol, linestyle=linetype, symsize = info.style.symbolsize, $
		thick = info.style.linethick, color = colorindex
endif

legend_title = '(Multiple correlation coefficient = ' + $
	strtrim(string(rmul),2)+')'
y_leg = !Y.WINDOW(1) - 0.085
x_leg = !X.WINDOW(0) + 0.15
xyouts, x_leg, y_leg, legend_title, /NORMAL, font=info.char.font, $
	charsize=info.char.size

y_leg = !Y.WINDOW(1) - 0.125
x_leg = !X.WINDOW(0) + 0.05
charsize = 1.5 * info.char.size
xyouts, x_leg, y_leg, equat_string, /NORMAL, font=info.char.font, $
charsize=charsize

for i = 0 , numout-1 do begin
	if subscripts(i) ge 0 then begin
		x_name = indep_list(subscripts(i))
		x_name = x_name(0)
		dot=strpos(x_name,'[')
		if dot ne -1 then xvalue=strmid(x_name,0,dot) $
			else xvalue = x_name
		if xvalue eq 'Time' then begin
			case info.time_type.new of
				0: xvalue = xvalue + ', hour'
				1: xvalue = xvalue + ', minute'
				else: xvalue = xvalue + ', second'
			endcase
		endif else if xvalue ne 'Sample' then begin
			temp_name = info.subset.data(subscripts(i)).src_unitname
			temp_name = temp_name(0)
			dot=strpos(temp_name,'N/A')
			if( dot eq -1) then xvalue = xvalue + temp_name
		endif
		legend_title = 'X'+strtrim(string(i+1), 2)+' = '+xvalue
		legend_title = legend_title + '   (linear cor. coef. = ' + $
			strtrim(string(r(i)), 2) + ')'
		y_leg = y_leg - 0.025
		xyouts, x_leg, y_leg, legend_title, /NORMAL, font=info.char.font, $
			charsize=info.char.size
	endif
endfor

if info.subset.data(this_subset).src_crit_flag eq 1 then begin
	if !D.Name eq 'PS' or !D.Name eq 'PRINTER' then begin
		charsize = 0.9*info.char.size
		y_location = 0.125
	endif else begin
		charsize = info.char.size
		y_location = 0.11
	endelse
	;xyouts, !P.Position(0), !P.Position(1)-y_location, crit_string, /NORMAL, $
	xyouts, 0.08, !P.Position(1)-y_location, crit_string, /NORMAL, $
		font=info.char.font, charsize=charsize
endif

if info.addtext.key eq 1 then write_add_text, info

if !D.Name eq 'PS' or !D.Name eq 'PRINTER' then begin
	!X.CHARSIZE = old_charsize
	!Y.CHARSIZE = old_charsize
endif

!P.Position = [0.0, 0.0, 0.0, 0.0]

widget_control, set_uvalue=info, info.widgets.base
widget_control, set_uvalue=info, info.base

end

;--------------------------------------------------------------------------------
pro do_statistics, info, name_of_data, this_subset, print_flag, plot_type, plot_status

pro_name = 'do_statistics'
@getinfo

;--------------------------
; If this is an SDS then
;--------------------------

hdf_data = *info.subset.data(this_subset).src_data
if info.subset.data(this_subset).src_type_flag eq 1 then $
	hdf_data = hdf_data.components0

if plot_type eq 1 then hdf_data = reform(hdf_data, n_elements(hdf_data))

size_hdf = size(hdf_data)
if ((size_hdf(0) lt 1) or (size_hdf(0) gt 2)) then begin
	result=dialog_message('Do not support the data with rank of '+ $
		strcompress(string(size_hdf(0)), /REMOVE_ALL) + $
		' for Statistics function!',$
	title='View HDF Warning!')
	plot_status = 0
	return
endif

if print_flag eq 0 then begin

	count = check_directory(info.stats_path, info.home_path)
	if count eq 0 then begin
		CD, '.', CURRENT=pwd
		info.stats_path = pwd
	endif
	stats_filename=dialog_pickfile(filter='*.dat', path=info.stats_path, $
		file=info.stats_file, get_path=stats_path,$
		title="Statistics Output File", /write)

	print,'filename = ', stats_filename
       	if stats_filename eq "" then begin
	    plot_status = 0
	    return
	endif

	stats_result=STRPOS(stats_filename, stats_path)

	if stats_result eq -1 then $
		stats_filename=stats_path+stats_filename

	info.stats_path = stats_path

	default_file = ''
	default_file = get_default_file(stats_filename)
	if default_file ne 'None' then info.stats_file = default_file

	get_lun, unit
        openw,unit,stats_filename

	this_name = info.subset.data(this_subset).src_filename
	this_name = this_name(0)

        printf,unit,format='("Source Data Filename: ",A)',this_name
        printf,unit,format='("Subset Name: ",A)', info.name_list_subset(info.subset.selected)
	unit_name = info.subset.data(this_subset).src_unitname
	unit_name = unit_name(0)
	temp_length = strlen(unit_name)
	unitlabel = ''
	if (temp_length gt 0) then $
	unitlabel = strmid(unit_name,2,temp_length-2)

	printf,unit, format='("Unit:  ",A)', unitlabel
	data_range = ''
	data_range = get_data_range(this_subset,info)
	printf,unit, format='("Data Range:  ",A)',data_range

endif

if info.subset.data(this_subset).src_crit_flag eq 1 then $
	crit_string = get_crit_string(this_subset, info) 

if print_flag eq 0 and info.subset.data(this_subset).src_crit_flag eq 1 then begin
	temp_name = str_sep(crit_string, '!C')
	num_temp = n_elements(temp_name)
	for i = 0, num_temp-1 do begin
		temp_length = strlen(temp_name(i))
		dot=strpos(temp_name(i),';')
		if( dot ne -1) then begin
               		crit1 = strtrim(strmid(temp_name(i),0,dot),2)
			crit2 = strtrim(strmid(temp_name(i),dot+1,temp_length-1),2)
			if i eq 0 then printf,unit,crit1 $
				else printf,unit,'           '+crit1
			printf,unit,'           '+crit2
       		endif else begin
			crit1 = strtrim(temp_name(i),2)
			if i eq 0 then printf,unit,crit1 $
				else printf,unit,'           '+crit1
		endelse
	endfor
endif

if size_hdf(0) eq 2 then begin
;----------------------------
; Open & Write file header
;----------------------------
	if print_flag eq 0 then begin
		printf,unit
		if info.subset.data(this_subset).src_transpose eq 1 then begin
        	  printf,unit,format='("  Record       N         StdDev           Mean        Maximum        Minimum         Median       Skewness")'
		endif else begin
        	  printf,unit,format='("  Sample       N         StdDev           Mean        Maximum        Minimum         Median       Skewness")'
		endelse
	endif

	this_type = info.subset.data(this_subset).src_types
	this_type = this_type(0)
	filldata_value = get_filldata_value(this_type, info.filldata)
	if filldata_value gt info.filldata then filldata_value = info.filldata
	max_value = get_max_value(this_type, info.filldata)
	if info.filldata gt 0 then begin
	    if max_value gt info.filldata then max_value = info.filldata
	endif
	filldata = get_filldata(this_type,info.filldata)
	;case this_type of
	;	21: filldata = 255
	;	22: filldata = 32767
	;	23: filldata = 65535
	;	24: filldata = 2147483647
	;	25: filldata = 2147483647
	;	else: begin
	;		if info.filldata LT 3.0E+37 then $
	;			filldata = info.filldata * 10 $
	;		else filldata = 3.0E+38
	;	     end
	;endcase

	y_starting=info.subset.data(this_subset).src_start(1)
       	y_ending=info.subset.data(this_subset).src_end(1)
	if info.subset.data(this_subset).src_type_flag eq 1 then y_ending = y_ending + 1
	y_increment=info.subset.data(this_subset).src_increment(1)
	
       	widget_control, /hourglass
	;num_element = (float(y_ending) - float(y_starting))/float(y_increment) + 0.9
	num_element = (float(y_ending) - float(y_starting) - 1.0)/float(y_increment) + 1.0
	num_element = long(num_element)
       	temp_mean=fltarr(num_element)
       	temp_stddev=fltarr(num_element)
       	temp_max=fltarr(num_element)
       	temp_min=fltarr(num_element)
	temp_median=fltarr(num_element)
	temp_skewness=fltarr(num_element)
	temp_num=lonarr(num_element)

       	; j is the number of columns
	
       	for j=0L,num_element-1 do begin
		hdf_data_temp = hdf_data(j,*)
		if filldata_value gt 0 then begin
		    subscripts = where(hdf_data_temp lt filldata_value, count)
		endif else begin
		    subscripts = where(hdf_data_temp gt filldata_value, count)
		endelse
		if count gt 1 then begin
			hdf_data_temp = double(hdf_data_temp(subscripts))
        		statistics=moment(hdf_data_temp,sdev=deviation)
               		temp_mean(j)=float(statistics[0])
			temp_skewness(j)=float(statistics[2])
			temp_stddev(j) = float(deviation)
			tempmax = max(hdf_data_temp, min = tempmin)
			temp_max(j) = float(tempmax)
			temp_min(j) = float(tempmin)
			temp_median(j) = median(hdf_data_temp)
		endif else if count eq 1 then begin
			temp_max(j) = float(hdf_data_temp(subscripts(0)))
			temp_min(j) = float(hdf_data_temp(subscripts(0)))
			temp_mean(j) = float(hdf_data_temp(subscripts(0)))
			temp_stddev(j) = 0.0
			temp_skewness(j) = 0.0
			temp_median(j) = float(hdf_data_temp(subscripts(0)))
		endif else begin
			deviation = filldata
			temp_mean(j) = filldata
			temp_stddev(j) = filldata
			temp_max(j) = filldata
			temp_min(j) = filldata
			temp_skewness(j) = filldata
			temp_median(j) = filldata
		endelse
		temp_num(j) = count
		if print_flag eq 0 then begin
			printf,unit,format='($,i8)',j
			if filldata_value gt 0 then begin
			    if temp_stddev(j) lt filldata_value then temp = temp_stddev(j) $
				else temp = -99999.0
			    temp_format='($,i8,'+info.precision+')'
			    printf,unit,format=temp_format,count,temp
			    ;printf,unit,format='($,i8,f15.5)',count,temp
			    if temp_mean(j) lt filldata_value then temp = temp_mean(j) $
				else temp = -99999.0
			    temp_format='($,'+info.precision+')'
			    printf,unit,format=temp_format,temp
			    ;printf,unit,format='($,f15.5)',temp
			    if temp_max(j) lt filldata_value then temp = temp_max(j) $
				else temp = -99999.0
			    printf,unit,format=temp_format,temp
			    ;printf,unit,format='($,f15.5)',temp
			    if temp_min(j) lt filldata_value then temp = temp_min(j) $
				else temp = -99999.0
			    printf,unit,format=temp_format,temp
			    ;printf,unit,format='(f15.5)',temp
			    if temp_median(j) lt filldata_value then temp = temp_median(j) $
				else temp = -99999.0
			    printf,unit,format=temp_format,temp
			    ;printf,unit,format='($,f15.5)',temp
			    if temp_skewness(j) lt filldata_value then temp = temp_skewness(j) $
				else temp = -99999.0
			    temp_format='('+info.precision+')'
			    printf,unit,format=temp_format,temp
			    ;printf,unit,format='(f15.5)',temp
			endif else begin
			    temp_format='($,i8,'+info.precision+')'
                            printf,unit,format=temp_format,count,temp_stddev(j)
			    ;printf,unit,format='($,i8,f15.5)',count,temp_stddev(j)
			    temp_format='($,'+info.precision+')'
                            printf,unit,format=temp_format,temp_mean(j)
                            printf,unit,format=temp_format,temp_max(j)
			    ;printf,unit,format='($,f15.5)',temp_mean(j)
			    ;printf,unit,format='($,f15.5)',temp_max(j)
                            printf,unit,format=temp_format,temp_min(j)
			    printf,unit,format=temp_format,temp_median(j)
			    temp_format='('+info.precision+')'
			    printf,unit,format=temp_format,temp_skewness(j)
			    ;printf,unit,format='(f15.5)',temp_min(j)
			endelse
		endif
       	endfor

	if print_flag eq 0 then begin
		temp_name = 'Number sample of ' + name_of_data
		set_statistics_subset, temp_name, this_subset, 1, info, temp_num

		temp_name = 'Mean of ' + name_of_data
		set_statistics_subset, temp_name, this_subset, 1, info, temp_mean

		temp_name = 'Standard Deviation of ' + name_of_data
		set_statistics_subset, temp_name, this_subset, 1, info, temp_stddev

		temp_name = 'Maximum of ' + name_of_data
		set_statistics_subset, temp_name, this_subset, 1, info, temp_max

		temp_name = 'Minimum of ' + name_of_data
		set_statistics_subset, temp_name, this_subset, 1, info, temp_min

		temp_name = 'Median of ' + name_of_data
		set_statistics_subset, temp_name, this_subset, 1, info, temp_median

		temp_name = 'Skewness of ' + name_of_data
		set_statistics_subset, temp_name, this_subset, 1, info, temp_skewness

		close,unit
		free_lun, unit

		case info.editor_type of
			1: command_line = "emacs " + stats_filename + " &"
			2: begin
				command_line = info.ieditor + " -geometry 757x531+75+104"
				command_line = command_line + " -title 'Display Statistics Result' "
				command_line = command_line + stats_filename + " &"
			   end
			3: command_line = 'start edit "' + stats_filename + '"'
			4: begin
				if !D.Name eq 'X' then begin
					command_line = info.editor + " " + stats_filename + " &"
				endif else begin
					command_line = 'start ' + info.editor + ' "' + stats_filename + '"'
				endelse
			   end
			5: begin
				command_line="xterm -bg \#73a1ff -fn "
				command_line=command_line+ $
					"-adobe-courier-bold-r-normal--14-100-100-100-m-90-iso8859-1"
				command_line=command_line + " -e emacs " + stats_filename + " &"
			   end
			else: begin
				command_line="xterm -bg \#73a1ff -fn "
				command_line=command_line+ $
					"-adobe-courier-bold-r-normal--14-100-100-100-m-90-iso8859-1"
				command_line=command_line + " -e vi -R " + stats_filename + " &"
			   end
		endcase

		spawn,command_line,results
		info.output_path = info.stats_path
		CD, info.output_path, CURRENT=old_dir
		output_name_list=findfile(info.filter, count=count)
		if count eq 0 then output_name_list = [ 'None' ]
 
		widget_control, info.widgets.output, set_value=output_name_list
		widget_control, info.widgets.outputdir, set_value=info.output_path
 
		CD, old_dir
 
	endif

	;-----------------
	; Plot the Mean
	;-----------------

    temp_temp_mean = reform(temp_mean, n_elements(temp_mean))
    if filldata_value gt 0 then begin
	subscript = where(temp_temp_mean lt filldata_value, count)
    endif else begin
	subscript = where(temp_temp_mean gt filldata_value, count)
    endelse
    if count eq 0 then begin
	result=dialog_message('All Mean values are FILL data!',$
		title='View HDF Warning!')
    endif else begin

	temp_temp_mean = temp_temp_mean(subscript)
	mean_max = max(temp_temp_mean, min=mean_min)
	if (print_flag eq 0) or (print_flag eq 3) then plot_dialogue , name_of_data, info
	dot=strpos(name_of_data,'[')
	if( dot ne -1) then begin
		ytitle=strmid(name_of_data,0,dot)
	endif else begin
		ytitle = name_of_data
	endelse

	data_range = ''
	data_range = get_data_range(this_subset,info)
	the_title = "Mean of " + ytitle + ' Data Range: ' + data_range

	if info.subset.data(this_subset).src_transpose eq 1 then begin
	   if !D.Name eq 'PRINTER' or !D.Name eq 'WIN' or info.char.font eq 0 then begin
		xtitle='Record Number'
	   endif else xtitle='!CRecord Number!C'
	endif else begin
	   if !D.Name eq 'PRINTER' or !D.Name eq 'WIN' or info.char.font eq 0 then begin
		xtitle='Scan Sample Number'
	   endif else xtitle='!CScan Sample Number!C'
	endelse
	if !D.Name eq 'PS' then begin
		old_charsize = !X.CHARSIZE
		!X.CHARSIZE = 0.9
		!Y.CHARSIZE = 0.9	
	endif else !P.Position = [0.060, 0.100, 0.98, 0.96]

        if info.subset.data(this_subset).src_crit_flag eq 1 then begin
		if !D.Name eq 'PS' and info.eps_out.type eq 1 then $
			!P.Position = [0.235, 0.15, 0.99, 0.95] $
			else !P.Position = [0.060, 0.120, 0.98, 0.96]
                temp_name = str_sep(crit_string, '!C')
                num_temp = n_elements(temp_name)
                !P.Position(1) = !P.Position(1) + (num_temp-1)*0.025
        endif

	if info.style.symbolline eq 1 then plot_symbol = - info.style.symbol $
		else plot_symbol = info.style.symbol

	temp_name = info.subset.data(this_subset).src_unitname
	temp_name = temp_name(0)
	dot=strpos(temp_name,'N/A')
	if( dot eq -1) then ytitle = ytitle + temp_name

	set_axis_ranges, info, YRange, Ystyle, XRange, Xstyle, ZRange, Zstyle

	old_x_margin = !X.MARGIN
	if filldata_value gt 0 then begin
	    sub_stddev = where(temp_stddev lt filldata_value, std_count)
	endif else begin
	    sub_stddev = where(temp_stddev gt filldata_value, std_count)
	endelse
	if std_count ne 0 then begin
	    if info.axis_state lt 6 then begin
		temp_std = temp_stddev(sub_stddev)
		std_max = max(temp_std, min=std_min)
		get_range, std_max, std_min, ymax, ymin
		y2style=2
	    endif else begin
		ymin = info.range.y2_start
		ymax = info.range.y2_end
		y2style=3
	    endelse
		if !P.Position(2) gt 0.0 then !P.Position(2) = !P.Position(2) - 0.03
		!X.MARGIN = [10, 10]
		ystyle = ystyle + 8
	endif

	get_ticklen, info.style.grid, xticklen, yticklen 

        plot, temp_mean, $
		MAX_VALUE = max_value, MIN_VALUE = mean_min, /YNOZERO, /NODATA, $
		FONT=info.char.font, charsize=info.char.size, $
		psym = plot_symbol, linestyle=info.style.linetype, $
		symsize = info.style.symbolsize, thick = info.style.linethick, $
		title=the_title, xtitle=xtitle, $
		ytitle= ytitle, xticklen=xticklen, yticklen=yticklen, $
		subtitle=info.subset.data(this_subset).src_filename + "  Date:" + systime(0), $
		XRange = XRange, YRange = YRange, Xstyle=Xstyle, Ystyle = Ystyle
	
	if info.multiple.styleflag eq 1 then begin
	    num = 0
	    style_name = info.subset.data(this_subset).subset_name
	    style_name = style_name(0)
	    style_name = 'Mean of ' + style_name
	    get_input_style, info, style_name, num, linetype, plot_symbol, colorindex
	    if linetype lt 0 then begin
		plot_status = 0
		return
	    endif
	    if std_count eq 0 then info.multiple.resetflag = 0
	endif else begin
	    linetype = info.style.linetype
            colorindex = info.style.colorindex
	endelse

	oplot, temp_mean, MAX_VALUE = max_value, MIN_VALUE = mean_min, $
		psym = plot_symbol, linestyle=linetype, $
		symsize = info.style.symbolsize, thick = info.style.linethick, $
		color = colorindex

	if std_count ne 0 then begin
		Axis, YAXIS=1, ytitle = 'Standard Deviation', YRANGE=[ymin, ymax], $
			FONT=info.char.font, charsize=info.char.size, ystyle=y2style, $
			ticklen=0.01, /SAVE

		linestyle = info.style.linetype+1
		if linestyle gt 5 then linestyle = 0
		if plot_symbol ne 0 then splot_symbol = plot_symbol + 1 $
			else splot_symbol = plot_symbol
		if splot_symbol gt 7 then splot_symbol = 1

		if info.multiple.styleflag eq 1 then begin
		    num = 1
		    style_name = info.subset.data(this_subset).subset_name
		    style_name = style_name(0)
		    style_name = 'Std Dev of ' + style_name
		    get_input_style, info, style_name, num, linestyle, splot_symbol, colorindex
		    if linestyle lt 0 then begin
			plot_status = 0
			return
		    endif
		    info.multiple.resetflag = 0
		endif else begin
		    colorindex = info.style.colorindex
		endelse

		oplot, temp_stddev, MAX_VALUE = max_value, MIN_VALUE = ymin, psym = splot_symbol, $
			linestyle=linestyle, symsize = info.style.symbolsize, $
			thick = info.style.linethick, color = colorindex
			;linestyle=info.style.linetype+1, symsize = info.style.symbolsize
	endif

	if info.subset.data(this_subset).src_crit_flag eq 1 then begin
		if !D.Name eq 'PS' then begin
			charsize = 0.9*info.char.size
			y_location = 0.125
		endif else begin
			charsize = info.char.size
			y_location = 0.11
		endelse
		;xyouts, !P.Position(0), !P.Position(1)-y_location, crit_string, /NORMAL, $
		xyouts, 0.08, !P.Position(1)-y_location, crit_string, /NORMAL, $
			font=info.char.font, charsize=charsize
	endif

	if info.addtext.key eq 1 then write_add_text, info

	if !D.Name eq 'PS' then begin
		!X.CHARSIZE = old_charsize
		!Y.CHARSIZE = old_charsize
	endif
		
	!X.MARGIN = old_x_margin
	!P.Position = [ 0.0 , 0.0 , 0.0 , 0.0]

    endelse

endif else begin

       	widget_control, /hourglass
	plot_status = 0
	this_type = info.subset.data(this_subset).src_types
	this_type = this_type(0)
	filldata_value = get_filldata_value(this_type, info.filldata)
	if filldata_value gt info.filldata then filldata_value = info.filldata

	;if info.subset.data(this_subset).src_type_flag eq 0 then $
	;	hdf_data_temp = hdf_data $
	;else hdf_data_temp = hdf_data(*).components0
	hdf_data_temp = hdf_data
	if filldata_value gt 0 then begin
	    subscripts = where(hdf_data_temp lt filldata_value, count)
	endif else begin
	    subscripts = where(hdf_data_temp gt filldata_value, count)
	endelse
	if count gt 0 then begin
		hdf_data_temp = double(hdf_data_temp(subscripts))
       		statistics=moment(hdf_data_temp,sdev=deviation)
		temp_max = max(hdf_data_temp, min = temp_min)
		temp_median = median(hdf_data_temp)
	endif else begin
		deviation = -99999.0
		statistics = [-99999.0 , -99999.0 , -99999.0 , -99999.0]
		temp_max = -99999.0
		temp_min = -99999.0
		temp_median = -99999.0
	endelse
	if print_flag eq 0 then begin
		printf,unit,format='(A,i12)',  "Number of samples  = ", count
		temp_format='(A,'+info.precision+')'
		printf,unit,format=temp_format,"Standard deviation = ",deviation
		printf,unit,format=temp_format,"Mean               = ",statistics[0]
		printf,unit,format=temp_format,"Maximum            = ",temp_max
		printf,unit,format=temp_format,"Minimum            = ",temp_min
		printf,unit,format=temp_format,"Median             = ",temp_median
		printf,unit,format=temp_format,"Skewness           = ",statistics[2]
		;printf,unit,format='(A,f12.5)',"Standard deviation = ",deviation
		;printf,unit,format='(A,f12.5)',"Mean               = ",statistics(0)
		;printf,unit,format='(A,f12.5)',"Maximum            = ",temp_max
		;printf,unit,format='(A,f12.5)',"Minimum            = ",temp_min
	
		close,unit
		free_lun, unit

		case info.editor_type of
			1: command_line = "emacs " + stats_filename + " &"
			2: begin
				command_line = info.ieditor + " -geometry 757x531+75+104"
				command_line = command_line + " -title 'Display Statistics Result' "
				command_line = command_line + stats_filename + " &"
			   end
			3: command_line = 'start edit ' + stats_filename + '"'
			4: begin
				if !D.Name eq 'X' then begin
					command_line = info.editor + " " + stats_filename + " &"
				endif else begin
					command_line = 'start ' + info.editor + ' "' + stats_filename + '"'
				endelse
			   end
			5: begin
				command_line="xterm -bg \#73a1ff -fn "
				command_line=command_line+ $
					"-adobe-courier-bold-r-normal--14-100-100-100-m-90-iso8859-1"
				command_line=command_line + " -e emacs " + stats_filename + " &"
			   end
			else: begin
				command_line="xterm -bg \#73a1ff -fn "
				command_line=command_line+ $
					"-adobe-courier-bold-r-normal--14-100-100-100-m-90-iso8859-1"
				command_line=command_line + " -e vi -R " + stats_filename + " &"
			   end
		endcase

		spawn,command_line,results
		info.output_path = info.stats_path
		CD, info.output_path, CURRENT=old_dir
		output_name_list=findfile(info.filter, count=count)
		if count eq 0 then output_name_list = [ 'None' ]

		widget_control, info.widgets.output, set_value=output_name_list
		widget_control, info.widgets.outputdir, set_value=info.output_path
 
		CD, old_dir

	endif

endelse

widget_control, set_uvalue=info, info.base

end

;--------------------------------------------------------------------------------
pro do_subsample, info, name_of_data, this_subset

pro_name = 'do_subsample'
@getinfo

info.graph_style = 'Subsampling'
hdf_data = *info.subset.data(this_subset).src_data
if info.subset.data(this_subset).src_type_flag eq 1 then $
	hdf_data = hdf_data.components0

size_hdf = size(hdf_data)
if size_hdf(0) eq 0 then return

rank = size_hdf(0)
dot=strpos(name_of_data,'[')
if dot ne -1 then dataname=strmid(name_of_data,0,dot) $
    else dataname = name_of_data
temp_name = 'Subsample of ' + dataname

i_value = [1, size_hdf(1), 1]
m_title = ['Dimension1']
for i = 1, rank-1 do begin
    i_value = [i_value, 1, size_hdf(i+1), 1]
    m_title = [m_title, 'Dimension'+strcompress(string(i+1), /REMOVE_ALL)]
endfor

title = 'Enter Subsample Dimensions'
the_message = ['Enter the dimension ranges to subsample the data set:', $
    name_of_data, ' ']
n_title = [temp_name, 'Starting', 'Ending', 'Increment']
para = get_mn_field_value(rank, 3, i_value, title, m_title, n_title, $
    the_message, info.base, info)
dataname = para(0)
if dataname eq 'cancel' then return

widget_control, /hourglass

para = para(1:*)
num_values = n_elements(para)
subrange = long(para)
case rank of
     1: begin
	    this_start = subrange(0)-1
	    if this_start lt 0 then this_start = 0
	    this_end = subrange(1)-1
	    if this_end ge size_hdf(1) then this_end = size_hdf(1) - 1
	    this_incr = subrange(2)
	    hdf_data = hdf_data(this_start:this_end)
	    if (this_incr gt 1) then begin
		indices = lindgen(this_end-this_start+1)
		indices = indices mod this_incr
		indices = [where(indices eq 0) ]
		hdf_data = hdf_data(indices)
	    endif
	    temp_size = size(hdf_data)
	    start_list = [0]
	    end_list = [temp_size(1)]
	    increment_list = [1]
	    the_type = convert_idltype_hdftype(temp_size(2))
	    the_rank = 1
	end
     2: begin
	    this_start = subrange(0) - 1
	    if this_start lt 0 then this_start = 0
	    this_end = subrange(1) - 1
	    if this_end ge size_hdf(1) then this_end = size_hdf(1) - 1
	    this_incr = subrange(2)
	    hdf_data = hdf_data(this_start:this_end,*)
	    if (this_incr gt 1) then begin
		indices = lindgen(this_end-this_start+1)
		indices = indices mod this_incr
		indices = [where(indices eq 0) ]
		hdf_data = hdf_data(indices,*)
	    endif
	    this_start = subrange(3) - 1
	    if this_start lt 0 then this_start = 0
	    this_end = subrange(4) - 1
	    if this_end ge size_hdf(2) then this_end = size_hdf(2) - 1
	    this_incr = subrange(5)
	    hdf_data = hdf_data(*,this_start:this_end)
	    if (this_incr gt 1) then begin
		indices = lindgen(this_end-this_start+1)
		indices = indices mod this_incr
		indices = [where(indices eq 0) ]
		hdf_data = hdf_data(*, indices)
	    endif
	    temp_size = size(hdf_data)
	    start_list = [0, 0]
	    end_list = [temp_size(2), temp_size(1)]
	    increment_list = [1, 1]
	    the_type = convert_idltype_hdftype(temp_size(3))
	    the_rank = 2
	end
     3: begin
	    this_start = subrange(0) - 1
	    if this_start lt 0 then this_start = 0
	    this_end = subrange(1) - 1
	    if this_end ge size_hdf(1) then this_end = size_hdf(1) - 1
	    this_incr = subrange(2)
	    hdf_data = hdf_data(this_start:this_end,*,*)
	    if (this_incr gt 1) then begin
		indices = lindgen(this_end-this_start+1)
		indices = indices mod this_incr
		indices = [where(indices eq 0) ]
		hdf_data = hdf_data(indices,*,*)
	    endif
	    this_start = subrange(3) - 1
	    if this_start lt 0 then this_start = 0
	    this_end = subrange(4) - 1
	    if this_end ge size_hdf(2) then this_end = size_hdf(2) - 1
	    this_incr = subrange(5)
	    hdf_data = hdf_data(*,this_start:this_end, *)
	    if (this_incr gt 1) then begin
		indices = lindgen(this_end-this_start+1)
		indices = indices mod this_incr
		indices = [where(indices eq 0) ]
		hdf_data = hdf_data(*, indices, *)
	    endif
	    this_start = subrange(6) - 1
	    if this_start lt 0 then this_start = 0
	    this_end = subrange(7) - 1
	    if this_end ge size_hdf(3) then this_end = size_hdf(3) - 1
	    this_incr = subrange(8)
	    hdf_data = hdf_data(*,*,this_start:this_end)
	    if (this_incr gt 1) then begin
		indices = lindgen(this_end-this_start+1)
		indices = indices mod this_incr
		indices = [where(indices eq 0) ]
		hdf_data = hdf_data(*, *, indices)
	    endif
	    temp_size = size(hdf_data)
	    start_list = [0, 0, 0]
	    end_list = [temp_size(3), temp_size(2), temp_size(1)]
	    increment_list = [1, 1, 1]
	    the_type = convert_idltype_hdftype(temp_size(4))
	    the_rank = 3
	end
     4: begin
	    this_start = subrange(0) - 1
	    if this_start lt 0 then this_start = 0
	    this_end = subrange(1) - 1
	    if this_end ge size_hdf(1) then this_end = size_hdf(1) - 1
	    this_incr = subrange(2)
	    hdf_data = hdf_data(this_start:this_end,*,*,*)
	    if (this_incr gt 1) then begin
		indices = lindgen(this_end-this_start+1)
		indices = indices mod this_incr
		indices = [where(indices eq 0) ]
		hdf_data = hdf_data(indices,*,*,*)
	    endif
	    this_start = subrange(3) - 1
	    if this_start lt 0 then this_start = 0
	    this_end = subrange(4) - 1
	    if this_end ge size_hdf(2) then this_end = size_hdf(2) - 1
	    this_incr = subrange(5)
	    hdf_data = hdf_data(*,this_start:this_end, *,*)
	    if (this_incr gt 1) then begin
		indices = lindgen(this_end-this_start+1)
		indices = indices mod this_incr
		indices = [where(indices eq 0) ]
		hdf_data = hdf_data(*, indices, *,*)
	    endif
	    this_start = subrange(6) - 1
	    if this_start lt 0 then this_start = 0
	    this_end = subrange(7) - 1
	    if this_end ge size_hdf(3) then this_end = size_hdf(3) - 1
	    this_incr = subrange(8)
	    hdf_data = hdf_data(*,*,this_start:this_end,*)
	    if (this_incr gt 1) then begin
		indices = lindgen(this_end-this_start+1)
		indices = indices mod this_incr
		indices = [where(indices eq 0) ]
		hdf_data = hdf_data(*, *, indices,*)
	    endif
	    this_start = subrange(9) - 1
	    if this_start lt 0 then this_start = 0
	    this_end = subrange(10) - 1
	    if this_end ge size_hdf(4) then this_end = size_hdf(4) - 1
	    this_incr = subrange(12)
	    hdf_data = hdf_data(*,*,*,this_start:this_end)
	    if (this_incr gt 1) then begin
		indices = lindgen(this_end-this_start+1)
		indices = indices mod this_incr
		indices = [where(indices eq 0) ]
		hdf_data = hdf_data(*, *, *,indices)
	    endif
	    temp_size = size(hdf_data)
	    start_list = [0, 0, 0, 0]
	    end_list = [temp_size(4), temp_size(3), temp_size(2), temp_size(1)]
	    increment_list = [1, 1, 1, 1]
	    the_type = convert_idltype_hdftype(temp_size(5))
	    the_rank = 4
	end
	else: begin
	    result=dialog_message('Do not support the rank greater than 4!',$
		title='View HDF Warning!')
	    return
	end
endcase

unitname = info.subset.data(this_subset).src_unitname
set_output_woref, dataname, -1, the_type, the_rank, $
	start_list, end_list, increment_list, unitname, info, hdf_data

end

;--------------------------------------------------------------------------------
pro do_array_average, info, name_of_data, this_subset

pro_name = 'do_array_average'
@getinfo

info.graph_style = 'Array Average'
hdf_data = *info.subset.data(this_subset).src_data
if info.subset.data(this_subset).src_type_flag eq 1 then $
	hdf_data = hdf_data.components0

size_hdf = size(hdf_data)
if size_hdf[0] eq 0 then return

rank = size_hdf[0]
dot=strpos(name_of_data,'[')
if dot ne -1 then dataname=strmid(name_of_data,0,dot) $
    else dataname = name_of_data
temp_name = 'Array_average of ' + dataname

i_value = [1, size_hdf(1), 1]
m_title = ['Dimension1']
for i = 1, rank-1 do begin
    i_value = [i_value, 1, size_hdf(i+1), 1]
    m_title = [m_title, 'Dimension'+strcompress(string(i+1), /REMOVE_ALL)]
endfor

title = 'Enter Average Value for each Dimensions'
the_message = ['Enter the average value to do averaging the data set:', $
    name_of_data, ' ']
n_title = [temp_name, 'Starting', 'Ending', 'Average Value']
para = get_mn_field_value(rank, 3, i_value, title, m_title, n_title, $
    the_message, info.base, info)
dataname = para(0)
if dataname eq 'cancel' then return

widget_control, /hourglass

this_type = info.subset.data(this_subset).src_types
this_type = this_type(0)
filldata_value = get_filldata_value(this_type, info.filldata)
if filldata_value gt info.filldata then filldata_value = info.filldata

para = para(1:*)
num_values = n_elements(para)
subrange = long(para)
case rank of
     1: begin
	    this_start = subrange(0)-1
	    if this_start lt 0 then this_start = 0
	    this_end = subrange(1)-1
	    if this_end ge size_hdf(1) then this_end = size_hdf(1) - 1
	    this_incr = subrange(2)
	    hdf_data = hdf_data(this_start:this_end)
	    if (this_incr gt 1) then begin
		num_data = n_elements(hdf_data)
		num_new = long(num_data/this_incr)
		if num_data gt 1 and num_new lt 1 then num_new = 1
		if num_new gt 0 then begin
		    ;  Allocate the memeory
		    temp_data = dblarr(num_new)
		    ii = 0L
		    start_rec = 0L
		    end_rec = long(this_incr - 1)
		    for i = 0L, num_new-1 do begin
			temp_hdf = hdf_data[start_rec:end_rec]
			;  Remove the fill data
			if filldata_value gt 0 then begin
			    subscript = where(temp_hdf lt filldata_value, count)
			endif else begin
			    subscript = where(temp_hdf gt filldata_value, count)
			endelse
			if count ne 0 then begin
			    if count eq 1 then begin
				temp_data(ii) = temp_hdf(subscript(0))
			    endif else begin
				temp_hdf = temp_hdf(subscript)
				temp_data(ii) = mean(temp_hdf)
			    endelse
			endif else temp_data(ii) = filldata_value
			ii = ii + 1
			start_rec = start_rec + this_incr
			end_rec = start_rec + this_incr - 1
			if end_rec ge num_data then end_rec = num_data - 1
		    endfor

		    if ii gt 0 then begin
			hdf_data = temp_data(0:ii-1)
			undefine, temp_data
		    endif else begin
			undefine, temp_data
			undefine, hdf_data
			result=dialog_message('Problem to do averaging for this array!',$
			    title='View HDF Warning!')
			return
		    endelse
		endif
	    endif
	    temp_size = size(hdf_data)
	    start_list = [0]
	    end_list = [temp_size(1)]
	    increment_list = [1]
	    the_type = convert_idltype_hdftype(temp_size(2))
	    the_rank = 1
	end
     2: begin
	    ;  First dimension
	    i_start = subrange(0) - 1
	    if i_start lt 0 then i_start = 0
	    i_end = subrange(1) - 1
	    if i_end ge size_hdf(1) then i_end = size_hdf(1) - 1
	    i_incr = subrange(2)
	    hdf_data = hdf_data(i_start:i_end,*)

	    ;  Second dimension
	    j_start = subrange(3) - 1
	    if j_start lt 0 then j_start = 0
	    j_end = subrange(4) - 1
	    if j_end ge size_hdf(2) then j_end = size_hdf(2) - 1
	    j_incr = subrange(5)
	    hdf_data = hdf_data(*,j_start:j_end)

	    ;  If i_incr and j_incr are gt than one then do the average
	    this_incr = i_incr + j_incr
	    if this_incr gt 2 then begin
		size_hdf = size(hdf_data)
		num_i = long(size_hdf[1]/i_incr)
		num_j = long(size_hdf[2]/j_incr)
		temp_data = dblarr(num_i, num_j)
		ii = 0L
		i_start_rec = 0L
		i_end_rec = long(i_incr - 1)
		for i = 0L, num_i-1 do begin
		    ij = 0L
		    j_start_rec = 0L
		    j_end_rec = long(j_incr - 1)
		    for j = 0L, num_j-1 do begin
			temp_hdf = hdf_data[i_start_rec:i_end_rec, j_start_rec:j_end_rec]
			temp_hdf = reform(temp_hdf, n_elements(temp_hdf))
			;  Remove the fill data
			if filldata_value gt 0 then begin
			    subscript = where(temp_hdf lt filldata_value, count)
			endif else begin
			    subscript = where(temp_hdf gt filldata_value, count)
			endelse
			if count ne 0 then begin
			    if count eq 1 then begin
				temp_data[ii,ij] = temp_hdf[subscript[0]]
			    endif else begin
				temp_hdf = temp_hdf[subscript]
				temp_data[ii,ij] = mean(temp_hdf)
			    endelse
			endif else temp_data[ii,ij] = filldata_value
			ij = ij + 1
			j_start_rec = j_start_rec + j_incr
			j_end_rec = j_start_rec + j_incr - 1
			if j_end_rec ge size_hdf[2] then j_end_rec = size_hdf[2] - 1
		    endfor
		    ii = ii + 1
		    i_start_rec = i_start_rec + i_incr
		    i_end_rec = i_start_rec + i_incr - 1
		    if i_end_rec ge size_hdf[1] then i_end_rec = size_hdf[1] - 1
		endfor

		if ii gt 0 and ij gt 0 then begin
		    hdf_data = temp_data(0:ii-1,0:ij-1)
		    undefine, temp_data
		endif else begin
		    undefine, temp_data
		    undefine, hdf_data
		    result=dialog_message('Problem to do averaging for this array!',$
			title='View HDF Warning!')
			return
		endelse
	    endif
		
	    temp_size = size(hdf_data)
	    start_list = [0, 0]
	    end_list = [temp_size[2], temp_size[1]]
	    increment_list = [1, 1]
	    the_type = convert_idltype_hdftype(temp_size[3])
	    the_rank = 2
	end
     3: begin
	    ;  First Dimension
	    i_start = subrange(0) - 1
	    if i_start lt 0 then i_start = 0
	    i_end = subrange(1) - 1
	    if i_end ge size_hdf(1) then i_end = size_hdf(1) - 1
	    i_incr = subrange(2)
	    hdf_data = hdf_data(i_start:i_end,*,*)

	    ;  Second Dimension
	    j_start = subrange(3) - 1
	    if j_start lt 0 then j_start = 0
	    j_end = subrange(4) - 1
	    if j_end ge size_hdf(2) then j_end = size_hdf(2) - 1
	    j_incr = subrange(5)
	    hdf_data = hdf_data(*,j_start:j_end, *)

	    ;  Third Dimension
	    k_start = subrange(6) - 1
	    if k_start lt 0 then k_start = 0
	    k_end = subrange(7) - 1
	    if k_end ge size_hdf(3) then k_end = size_hdf(3) - 1
	    k_incr = subrange(8)
	    hdf_data = hdf_data(*,*,k_start:k_end)

	    ;  If any incr is greater than 1, do the averaging
	    this_incr = i_incr + j_incr + k_incr
	    if this_incr gt 3 then begin
		size_hdf = size(hdf_data)
		num_i = long(size_hdf[1]/i_incr)
		num_j = long(size_hdf[2]/j_incr)
		num_k = long(size_hdf[3]/k_incr)
		temp_data = dblarr(num_i, num_j, num_k)
		ii = 0L
		i_start_rec = 0L
		i_end_rec = long(i_incr - 1)
		for i = 0L, num_i-1 do begin
		    ij = 0L
		    j_start_rec = 0L
		    j_end_rec = long(j_incr - 1)
		    for j = 0L, num_j-1 do begin
			ik = 0L
			k_start_rec = 0L
			k_end_rec = long(k_incr - 1)
			for k = 0L, num_k-1 do begin
			    temp_hdf = hdf_data[i_start_rec:i_end_rec, j_start_rec:j_end_rec, $
				k_start_rec:k_end_rec]
			    temp_hdf = reform(temp_hdf, n_elements(temp_hdf))
			    ;  Remove the fill data
			    if filldata_value gt 0 then begin
				subscript = where(temp_hdf lt filldata_value, count)
			    endif else begin
				subscript = where(temp_hdf gt filldata_value, count)
			    endelse
			    if count ne 0 then begin
				if count eq 1 then begin
				    temp_data[ii,ij,ik] = temp_hdf[subscript[0]]
				endif else begin
				    temp_hdf = temp_hdf[subscript]
				    temp_data[ii,ij,ik] = mean(temp_hdf)
				endelse
			    endif else temp_data[ii,ij,ik] = filldata_value
			    ik = ik + 1
			    k_start_rec = k_start_rec + k_incr
			    k_end_rec = k_start_rec + k_incr - 1
			    if k_end_rec ge size_hdf[3] then k_end_rec = size_hdf[3] - 1
			endfor
			ij = ij + 1
			j_start_rec = j_start_rec + j_incr
			j_end_rec = j_start_rec + j_incr - 1
			if j_end_rec ge size_hdf[2] then j_end_rec = size_hdf[2] - 1
		    endfor
		    ii = ii + 1
		    i_start_rec = i_start_rec + i_incr
		    i_end_rec = i_start_rec + i_incr - 1
		    if i_end_rec ge size_hdf[1] then i_end_rec = size_hdf[1] - 1
		endfor

		if ii gt 0 and ij gt 0 and ik gt 0 then begin
		    hdf_data = temp_data(0:ii-1,0:ij-1,0:ik-1)
		    undefine, temp_data
		endif else begin
		    undefine, temp_data
		    undefine, hdf_data
		    result=dialog_message('Problem to do averaging for this array!',$
			title='View HDF Warning!')
			return
		endelse
	    endif

	    temp_size = size(hdf_data)
	    start_list = [0, 0, 0]
	    end_list = [temp_size(3), temp_size(2), temp_size(1)]
	    increment_list = [1, 1, 1]
	    the_type = convert_idltype_hdftype(temp_size(4))
	    the_rank = 3
	end
     4: begin
	    ;  First Dimension
	    i_start = subrange(0) - 1
	    if i_start lt 0 then i_start = 0
	    i_end = subrange(1) - 1
	    if i_end ge size_hdf(1) then i_end = size_hdf(1) - 1
	    i_incr = subrange(2)
	    hdf_data = hdf_data(i_start:i_end,*,*,*)

	    ;  Second Dimension
	    j_start = subrange(3) - 1
	    if j_start lt 0 then j_start = 0
	    j_end = subrange(4) - 1
	    if j_end ge size_hdf(2) then j_end = size_hdf(2) - 1
	    j_incr = subrange(5)
	    hdf_data = hdf_data(*,j_start:j_end, *,*)

	    ;  Third Dimension
	    k_start = subrange(6) - 1
	    if k_start lt 0 then k_start = 0
	    k_end = subrange(7) - 1
	    if k_end ge size_hdf(3) then k_end = size_hdf(3) - 1
	    k_incr = subrange(8)
	    hdf_data = hdf_data(*,*,k_start:k_end,*)

	    ;  Fourth Dimension
	    l_start = subrange(9) - 1
	    if l_start lt 0 then l_start = 0
	    l_end = subrange(10) - 1
	    if l_end ge size_hdf(4) then l_end = size_hdf(4) - 1
	    l_incr = subrange(12)
	    hdf_data = hdf_data(*,*,*,l_start:l_end)

	    ;  If any incr is greater than 1, do the averaging
	    this_incr = i_incr + j_incr + k_incr + l_incr
	    if this_incr gt 4 then begin
		size_hdf = size(hdf_data)
		num_i = long(size_hdf[1]/i_incr)
		num_j = long(size_hdf[2]/j_incr)
		num_k = long(size_hdf[3]/k_incr)
		num_l = long(size_hdf[4]/l_incr)
		temp_data = dblarr(num_i, num_j, num_k, num_l)
		ii = 0L
		i_start_rec = 0L
		i_end_rec = long(i_incr - 1)
		for i = 0L, num_i-1 do begin
		    ij = 0L
		    j_start_rec = 0L
		    j_end_rec = long(j_incr - 1)
		    for j = 0L, num_j-1 do begin
			ik = 0L
			k_start_rec = 0L
			k_end_rec = long(k_incr - 1)
			for k = 0L, num_k-1 do begin
			    il = 0L
			    l_start_rec = 0L
			    l_end_rec = long(l_incr - 1)
			    for l = 0L, num_l-1 do begin
				temp_hdf = hdf_data[i_start_rec:i_end_rec, j_start_rec:j_end_rec, $
				    k_start_rec:k_end_rec, l_start_rec:l_end_rec]
				temp_hdf = reform(temp_hdf, n_elements(temp_hdf))
				;  Remove the fill data
				if filldata_value gt 0 then begin
				    subscript = where(temp_hdf lt filldata_value, count)
				endif else begin
				    subscript = where(temp_hdf gt filldata_value, count)
				endelse
				if count ne 0 then begin
				    if count eq 1 then begin
					temp_data[ii,ij,ik,il] = temp_hdf[subscript[0]]
				    endif else begin
					temp_hdf = temp_hdf[subscript]
					temp_data[ii,ij,ik,il] = mean(temp_hdf)
				    endelse
				endif else temp_data[ii,ij,ik,il] = filldata_value
				il = il + 1
				l_start_rec = l_start_rec + l_incr
				l_end_rec = l_start_rec + l_incr - 1
				if l_end_rec ge size_hdf[4] then l_end_rec = size_hdf[4] - 1
			    endfor
			    ik = ik + 1
			    k_start_rec = k_start_rec + k_incr
			    k_end_rec = k_start_rec + k_incr - 1
			    if k_end_rec ge size_hdf[3] then k_end_rec = size_hdf[3] - 1
			endfor
			ij = ij + 1
			j_start_rec = j_start_rec + j_incr
			j_end_rec = j_start_rec + j_incr - 1
			if j_end_rec ge size_hdf[2] then j_end_rec = size_hdf[2] - 1
		    endfor
		    ii = ii + 1
		    i_start_rec = i_start_rec + i_incr
		    i_end_rec = i_start_rec + i_incr - 1
		    if i_end_rec ge size_hdf[1] then i_end_rec = size_hdf[1] - 1
		endfor

		if ii gt 0 and ij gt 0 and ik gt 0 and il gt 0 then begin
		    hdf_data = temp_data(0:ii-1,0:ij-1,0:ik-1,0:il-1)
		    undefine, temp_data
		endif else begin
		    undefine, temp_data
		    undefine, hdf_data
		    result=dialog_message('Problem to do averaging for this array!',$
			title='View HDF Warning!')
			return
		endelse
	    endif

	    temp_size = size(hdf_data)
	    start_list = [0, 0, 0, 0]
	    end_list = [temp_size(4), temp_size(3), temp_size(2), temp_size(1)]
	    increment_list = [1, 1, 1, 1]
	    the_type = convert_idltype_hdftype(temp_size(5))
	    the_rank = 4
	end
	else: begin
	    result=dialog_message('Do not support the rank greater than 4!',$
		title='View HDF Warning!')
	    return
	end
endcase

unitname = info.subset.data(this_subset).src_unitname
set_output_woref, dataname, -1, the_type, the_rank, $
	start_list, end_list, increment_list, unitname, info, hdf_data

result=dialog_message('Array Average Completed!', title='Notice!')

end

;--------------------------------------------------------------------------------
pro averagesetting_event, event

pro_name = 'averagesetting_event'
@getinfo

widget_control, get_value=v, event.id
widget_control, get_uvalue=fieldid, event.id

if v.cancel eq 1 then begin
    widget_control, get_uvalue=info, event.top
    widget_control, get_uvalue=info, info.base
    info.canceloption='Yes'
    widget_control, set_uvalue=info, info.base
    widget_control, /destroy, event.top
    return
endif

if event.tag eq 'ROW_FLAG' then begin
    if event.value eq 0 then $
	widget_control, fieldid(4), sensitive = 0 $
        else widget_control, fieldid(4), sensitive = 1
endif

if event.tag eq 'COL_FLAG' then begin
    if event.value eq 0 then $
	widget_control, fieldid(8), sensitive = 0 $
	else widget_control, fieldid(8), sensitive = 1
endif

if event.tag eq 'ROW_FIRST' then begin
    if event.value eq 0 then $
	widget_control, fieldid[10], set_droplist_select = 1 $
	else widget_control, fieldid[10], set_droplist_select = 0
endif

if event.tag eq 'COL_FIRST' then begin
     if event.value eq 0 then $
	widget_control, fieldid[6], set_droplist_select = '1' $
	else widget_control, fieldid[6], set_droplist_select = '0'
endif

if v.done eq 1 then begin
    widget_control, get_uvalue=info, event.top
    info.average.row_flag = v.row_flag
    info.average.row_value = v.row_value
    info.average.row_first = v.row_first
    info.average.col_flag = v.col_flag
    info.average.col_value = v.col_value
    info.average.col_first = v.col_first
    info.average.contain_fill = v.contain_fill

    ;  Turn off the first when not select
    if info.average.row_flag eq 0 then info.average.row_first = 0
    if info.average.col_flag eq 0 then info.average.col_first = 0
    
    if(widget_info(info.widgets.base, /VALID_ID)) then $
        widget_control, set_uvalue=info, info.widgets.base
    widget_control, set_uvalue=info, info.base

    widget_control, event.top, /destroy

endif

end

;--------------------------------------------------------------------------------
pro average_setting, data_name, rank, info

pro_name = 'average_setting'
@getinfo

widget_control, /hourglass

row_flag = strcompress(string(info.average.row_flag), /REMOVE_ALL)
row_value = strcompress(string(info.average.row_value), /REMOVE_ALL)
row_first = strcompress(string(info.average.row_first), /REMOVE_ALL)
col_flag = strcompress(string(info.average.col_flag), /REMOVE_ALL)
col_value = strcompress(string(info.average.col_value), /REMOVE_ALL)
col_first = strcompress(string(info.average.col_first), /REMOVE_ALL)
contain_fill = strcompress(string(info.average.contain_fill), /REMOVE_ALL)

;  If only one-dimensional, use the row only
if rank eq 1 then begin
    col_flag = '0'
    col_first = '0'
endif

if row_flag eq 1 and col_flag eq 1 and row_first eq 1 then col_first = 0
length = strlen(data_name)
if length gt 50 then begin
    temp_name = strmid(data_name, 0, 50) + '...'
endif else temp_name = data_name

desc = [ $
	'0, label, Select Array Average - 2D Setting For, center, font='+info.font, $
	'0, label, '+temp_name+', center, font='+info.font, $
	'0, label, "   ", center, font=' + info.font, $
	'0, droplist, No|Yes, label_left=Average Row:, set_value='+row_flag+', tag=row_flag, ' $
	    + 'font='+info.font+', labelfont='+info.font, $
	'1, base, , column, frame', $
	'0, integer,'+row_value+', title=Average Row Value:, width=12, tag=row_value, font='+info.font $
	    +', fieldfont='+info.font+ ', labelfont='+info.font, $
	'2, droplist, No|Yes, label_left=Average Row First:, set_value='+row_first $
	    + ', tag=row_first, font='+info.font+', labelfont='+info.font, $
	'0, droplist, No|Yes, label_left=Average Column:, set_value='+col_flag $
	    + ', tag=col_flag, font='+info.font+', labelfont='+info.font, $
	'1, base, , column, frame', $
	'0, integer,'+col_value+', title=Average Column Value:, width=12, tag=col_value, font='+info.font $
	    +', fieldfont='+info.font+ ', labelfont='+info.font, $
	'2, droplist, No|Yes, label_left=Average Column First:, set_value='+col_first $
	    + ', tag=col_first, font='+info.font+', labelfont='+info.font, $
	'1, base, , column, frame', $
	'0, label, If some values are fill data, left, font='+info.font, $
	'2, droplist, Use non fill values|Fill value, label_left=set the result to:, set_value='+contain_fill $
	    + ', tag=contain_fill, font='+info.font+', labelfont='+info.font, $
	'0, label, "   ", center, font='+info.font, $
	'1, base, , row, space=60, center', $
	'0, button, Done, QUIT, tag=done, font='+info.font, $
	'2, button, Cancel, QUIT, tag=cancel, font='+info.font]
	
base_loc = widget_info(info.base, /geometry)
xoffset = base_loc.xoffset + 100
yoffset = base_loc.yoffset + 100
base=widget_base(group_leader=info.base, /modal, column=1, map=1, xoffset=xoffset, $
    yoffset=yoffset, TITLE='Select Array Average - 2D Setting')
formid = cw_form(base, desc, /column, ids=fieldid)

widget_control, base, /realize
widget_control, set_uvalue=info, base
widget_control, set_uvalue=fieldid, formid

if row_flag eq 0 then begin
    widget_control, fieldid(4), sensitive = 0
endif else begin
    widget_control, fieldid(4), sensitive = 1
endelse

if col_flag eq 0 then begin
    widget_control, fieldid(8), sensitive = 0
endif else begin
    widget_control, fieldid(8), sensitive = 1
endelse

if rank eq 1 then begin
    widget_control, fieldid[7], sensitive = 0
endif else begin
    widget_control, fieldid[7], sensitive = 1
endelse

xmanager, 'averagesetting', base

end

;--------------------------------------------------------------------------------
pro do_2d_array_average, info, this_subset

pro_name = 'do_2d_array_average'
@getinfo

;  for one or two dimensional array only

;  Get the data
hdf_data = *info.subset.data(this_subset).src_data 
if info.subset.data(this_subset).src_type_flag eq 1 then $
    hdf_data = hdf_data.components0

;  Test the data, it has to be an array with one-dimensional or two-dimenstional
size_hdf = size(hdf_data)
num_data = n_elements(hdf_data)
if(size_hdf[0] lt 1 or size_hdf[0] gt 2 or num_data lt 2) then begin
    the_message = [ 'Data set is not an one-dimensional or two-dimensional array', $
	'the 1(2) dimensional array average is not valid!']
    result= dialog_message(the_message, title='View HDF Message!')
    return
endif

data_name = info.subset.data(this_subset).subset_name
data_name = data_name[0]

info.graph_style = 'Array Average - 2D'
average_setting, data_name, size_hdf[0], info
widget_control, get_uvalue=info, info.base
if info.canceloption eq 'Yes' then begin
    info.canceloption = 'No'
    widget_control, set_uvalue=info, info.base
    return
endif

temp_name = "Array_Average_"+data_name
get_variable_name, temp_name, info
widget_control, get_uvalue=info, info.base
if info.variablename eq 'None' then begin
    return
endif

output_name = info.variablename

widget_control, /hourglass

widget_control, get_uvalue=info, info.base

;  Get the settings
row_flag = info.average.row_flag
row_value = info.average.row_value
row_first = info.average.row_first
col_flag = info.average.col_flag
col_value = info.average.col_value
col_first = info.average.col_first
contain_fill = info.average.contain_fill

;  Test the row_value and col_value, have to be greater than 1
if row_value lt 2 then row_flag = 0
if col_value lt 2 then col_flag = 0

if row_flag eq 0 and col_flag eq 0 then begin
    the_message = [ 'Both average value are less than 2', $
        'No averaging is neede!']
    result= dialog_message(the_message, title='View HDF Message!')
    return
endif

if size_hdf[0] eq 1 then begin
    hdf_data = reform(hdf_data, 1, size_hdf[1], /overwrite)
    row_first = 1
    num_row = size_hdf[1]
    num_col = 1
endif else begin
    num_row = size_hdf[2]
    num_col = size_hdf[1]
endelse

if row_flag eq 1 then begin
    num_row_value = long(num_row/row_value)
endif else num_row_value = -1

if col_flag eq 1 then begin
    num_col_value = long(num_col/col_value)
endif else num_col_value = -1

;  Test both values, should not be zero or negative
if num_row_value lt 1 and num_col_value lt 1 then begin
     the_message = [ 'Both average result dimension are less than 1', $
	'No averaging is neede!']
    result= dialog_message(the_message, title='View HDF Message!')
    return
endif

do_row = 0
do_col = 0
;  Do the average, check which one go first
if row_flag eq 1 then begin
    if col_flag eq 1 then begin
	if col_first eq 1 then do_col = 1 else do_row = 1
    endif else do_row = 1
endif else do_col = 1

if do_row eq 1 then begin
    if size_hdf[0] eq 2 then begin
	array_size = [num_row_value, size_hdf[1]]
    endif else begin
	array_size = [num_row_value, 1]
    endelse
endif else begin
    array_size = [size_hdf[2], num_col_value]
endelse

;  Allocate the memeory
temp_data = array_type(6,array_size)
if(temp_data[0] eq -1) then begin
    result=dialog_message('Unable to allocate memory for temporary data!',$
	title='View HDF Warning!')
    return
endif

this_type = info.subset.data(this_subset).src_types
this_type = this_type(0)
filldata_value = get_filldata_value(this_type, info.filldata)
if filldata_value gt info.filldata then filldata_value = info.filldata

start_rec = 0L
if do_row eq 1 then begin
    end_rec = long(row_value - 1)
    num_x = num_row_value
    num_y = num_col
    num_inc = row_value
endif else begin
    end_rec = long(col_value - 1)
    num_x = num_col_value
    num_y = num_row
    num_inc = col_value
endelse

ii = 0L
check_inc = num_inc
if do_row eq 1 then begin
    for i = 0L, num_x-1 do begin
	for j = 0, num_y-1 do begin
	    temp_hdf = hdf_data[j,start_rec:end_rec]

	    ;  Remove the fill data
	    if filldata_value gt 0 then begin
		subscript = where(temp_hdf lt filldata_value, count)
	    endif else begin
		subscript = where(temp_hdf gt filldata_value, count)
	    endelse

	    ;  if contain_fill eq 1, contain any fill set to fill
	    if contain_fill eq 1 and count ne check_inc then begin
		temp_data[j, ii] = filldata_value
	    endif else begin
		if count ne 0 then begin
		    if count eq 1 then begin
			temp_data(j,ii) = temp_hdf(subscript(0))
		    endif else begin	
			temp_hdf = temp_hdf(subscript)
			temp_data(j,ii) = mean(temp_hdf)
		    endelse
		endif else temp_data(j,ii) = filldata_value
	    endelse
	endfor
	ii = ii + 1
	start_rec = start_rec + num_inc
	end_rec = start_rec + num_inc - 1
	if end_rec ge num_row then begin
	    end_rec = num_row - 1
	    check_inc = end_rec - start_rec + 1
	endif
    endfor

    if ii gt 0 then begin
	hdf_data = temp_data(*,0:ii-1)
	undefine, temp_data
	if filldata_value gt 0 then begin
	    subscript = where(hdf_data lt filldata_value, count)
	endif else begin
	    subscript = where(hdf_data gt filldata_value, count)
	endelse
	if(count eq 0) then begin
	    undefine, hdf_data
	    result=dialog_message('All the average data are fill data!',$
		title='View HDF Warning!')
	    return
	endif
    endif

    ;  If col_flag eq to 1, then average the col
    if col_flag eq 1 then begin
	;  Allocate the memeory
	array_size = [ii, num_col_value]
	temp_data = array_type(6,array_size)
	if(temp_data[0] eq -1) then begin
	    undefine, hdf_data
	    result=dialog_message('Unable to allocate memory for temporary data!',$
		title='View HDF Warning!')
	    return
	endif

	start_rec = 0L
	end_rec = long(col_value - 1)
	num_x = num_col_value
	num_y = ii
	num_inc = col_value

	ii = 0L
	check_inc = num_inc
	for i = 0L, num_x-1 do begin
	    for j = 0, num_y-1 do begin
		temp_hdf = hdf_data[start_rec:end_rec, j]

		;  Remove the fill data
		if filldata_value gt 0 then begin
		    subscript = where(temp_hdf lt filldata_value, count)
		endif else begin
		    subscript = where(temp_hdf gt filldata_value, count)
		endelse

		;  if contain_fill eq 1, contain any fill set to fill
		if contain_fill eq 1 and count ne check_inc then begin
		    temp_data[ii, j] = filldata_value
		endif else begin
		    if count ne 0 then begin
			if count eq 1 then begin
			    temp_data(ii, j) = temp_hdf(subscript(0))
			endif else begin	
			    temp_hdf = temp_hdf(subscript)
			    temp_data(ii, j) = mean(temp_hdf)
			endelse
		    endif else temp_data(ii, j) = filldata_value
		endelse
	    endfor
	    ii = ii + 1
	    start_rec = start_rec + num_inc
	    end_rec = start_rec + num_inc - 1
	    if end_rec ge num_col then begin
		end_rec = num_col - 1
		check_inc = end_rec - start_rec + 1
	    endif
	endfor

	if ii gt 0 then begin
	    hdf_data = temp_data(0:ii-1, *)
	    undefine, temp_data
	    if filldata_value gt 0 then begin
		subscript = where(hdf_data lt filldata_value, count)
	    endif else begin
		subscript = where(hdf_data gt filldata_value, count)
	    endelse

	    if(count eq 0) then begin
		undefine, hdf_data
		result=dialog_message('All the average data are fill data!',$
		    title='View HDF Warning!')
		return
	    endif
	endif
    endif
endif else begin
    for i = 0L, num_x-1 do begin
	for j = 0, num_y-1 do begin
	    temp_hdf = hdf_data[start_rec:end_rec, j]

	    ;  Remove the fill data
	    if filldata_value gt 0 then begin
		subscript = where(temp_hdf lt filldata_value, count)
	    endif else begin
		subscript = where(temp_hdf gt filldata_value, count)
	    endelse

	    ;  if contain_fill eq 1, contain any fill set to fill
	    if contain_fill eq 1 and count ne check_inc then begin
		temp_data[ii, j] = filldata_value
	    endif else begin
		if count ne 0 then begin
		    if count eq 1 then begin
			temp_data(ii, j) = temp_hdf(subscript(0))
		    endif else begin	
			temp_hdf = temp_hdf(subscript)
			temp_data(ii, j) = mean(temp_hdf)
		    endelse
		endif else temp_data(ii, j) = filldata_value
	    endelse
	endfor
	ii = ii + 1
	start_rec = start_rec + num_inc
	end_rec = start_rec + num_inc - 1
	if end_rec ge num_col then begin
	    end_rec = num_col - 1
	    check_inc = end_rec - start_rec + 1
	endif
    endfor

    if ii gt 0 then begin
	hdf_data = temp_data(0:ii-1, *)
	undefine, temp_data
	if filldata_value gt 0 then begin
	    subscript = where(hdf_data lt filldata_value, count)
	endif else begin
	    subscript = where(hdf_data gt filldata_value, count)
	endelse
	if(count eq 0) then begin
	    undefine, hdf_data
	    result=dialog_message('All the average data are fill data!',$
		title='View HDF Warning!')
	    return
	endif
    endif

     ;  If row_flag eq to 1, then average the row
    if row_flag eq 1 then begin
	;  Allocate the memeory
	array_size = [num_row_value, ii]
	temp_data = array_type(6,array_size)
	if(temp_data[0] eq -1) then begin
	    undefine, hdf_data
	    result=dialog_message('Unable to allocate memory for temporary data!',$
		title='View HDF Warning!')
	    return
	endif

	start_rec = 0L
	end_rec = long(row_value - 1)
	num_x = num_row_value
	num_y = ii
	num_inc = row_value

	ii = 0L
	check_inc = num_inc
	for i = 0L, num_x-1 do begin
	    for j = 0, num_y-1 do begin
		temp_hdf = hdf_data[j,start_rec:end_rec]

		;  Remove the fill data
		if filldata_value gt 0 then begin
		    subscript = where(temp_hdf lt filldata_value, count)
		endif else begin
		    subscript = where(temp_hdf gt filldata_value, count)
		endelse

		;  if contain_fill eq 1, contain any fill set to fill
		if contain_fill eq 1 and count ne check_inc then begin
		    temp_data[j, ii] = filldata_value
		endif else begin
		    if count ne 0 then begin
			if count eq 1 then begin
			    temp_data(j,ii) = temp_hdf(subscript(0))
			endif else begin	
			    temp_hdf = temp_hdf(subscript)
			    temp_data(j,ii) = mean(temp_hdf)
			endelse
		    endif else temp_data(j,ii) = filldata_value
		endelse
	    endfor

	    ii = ii + 1
	    start_rec = start_rec + num_inc
	    end_rec = start_rec + num_inc - 1
	    if end_rec ge num_row then begin
		end_rec = num_row - 1
		check_inc = end_rec - start_rec + 1
	    endif
	endfor

	if ii gt 0 then begin
	    hdf_data = temp_data(*,0:ii-1)
	    undefine, temp_data
	    if filldata_value gt 0 then begin
		subscript = where(hdf_data lt filldata_value, count)
	    endif else begin
		subscript = where(hdf_data gt filldata_value, count)
	    endelse
	    if(count eq 0) then begin
		undefine, hdf_data
		result=dialog_message('All the average data are fill data!',$
		    title='View HDF Warning!')
		return
	    endif
	endif
    endif
endelse

;  Save the result
if size_hdf[0] eq 1 then begin
    hdf_data = reform(hdf_data, n_elements(hdf_data), /overwrite)
endif
size_hdf = size(hdf_data)
the_rank = size_hdf[0]
start_list=lonarr(the_rank)
end_list=lonarr(the_rank)
increment_list=lonarr(the_rank)
for i = 0, the_rank-1 do begin
    start_list[i] = 0
    end_list[i] = size_hdf[i+1]
    increment_list[i] = 1
endfor
the_type = convert_idltype_hdftype(size_hdf[the_rank+1])
unitname = info.subset.data(this_subset).src_unitname
set_output_woref, output_name, this_subset, the_type, the_rank, $
        start_list, end_list, increment_list, unitname, info, hdf_data

result=dialog_message('Array Average - 2D Completed!', title='Notice!')

end

;--------------------------------------------------------------------------------
pro do_matrix_vector_compute, info

pro_name = 'do_matrix_vector_compute'
@getinfo

if info.subset.count lt 2 then begin
    the_message = ['You need at least two subset of data', $
	'to do Matrices Multiplication!']
    result=dialog_message(the_message, title='View HDF Warning!')
    return
endif

info.graph_style = 'Matrices Multiplication'
plot_setup, info, 'Matrices Multiplication', 1, 1, 0
widget_control, get_uvalue=info, info.base
if info.canceloption eq 'Yes' then begin
    info.canceloption = 'No'
    widget_control, set_uvalue=info, info.base
    return
endif 

widget_control, /hourglass

get_data, y_index, x_index, z_index, info
x_index = x_index[0]
y_index = y_index[0]

;  If any index is -1 (constant), return
if x_index eq -1 or y_index eq -1 then begin
    result=dialog_message('Any operand for this select cannot be constant!', $
	title='View HDF Warning!')
    return
endif

hdf_data_x = *info.subset.data(x_index).src_data
size_hdf_x = size(hdf_data_x)

hdf_data_y = *info.subset.data(y_index).src_data
size_hdf_y = size(hdf_data_y)

;  Now check the dimensions of these two arrays, they have to be one or two dimensional
if(size_hdf_x[0] lt 1 or size_hdf_x[0] gt 2) or (size_hdf_y[0] lt 1 or $
    size_hdf_y[0] gt 2) then begin
	the_message = ['The arrays have to be either one or two dimensional', $
	    'to do Matrices Multiplication!']
	result=dialog_message(the_message, title='View HDF Warning!')
	undefine, hdf_data_x
	undefine, hdf_data_y
	return
endif

;  Now check the dimensions for doing the matrix and vector multiplication
;  If it is a vector, reform it as a matrix
if size_hdf_x[0] eq 1 then begin
    if size_hdf_y[0] eq 1 then begin
	hdf_data_x = reform(hdf_data_x, 1, size_hdf_x[1])
    endif else begin
	if size_hdf_x[1] eq size_hdf_y[2] then begin
	    hdf_data_x = reform(hdf_data_x, size_hdf_x[1], 1)
	endif else begin
	    hdf_data_x = reform(hdf_data_x, 1, size_hdf_x[1])
	endelse
    endelse
endif

if size_hdf_y[0] eq 1 then begin
    if size_hdf_x[0] eq 1 then begin
	hdf_data_y = reform(hdf_data_y, size_hdf_y[1], 1)
    endif else begin
	if size_hdf_x[1] eq size_hdf_y[1] then begin
	    hdf_data_y = reform(hdf_data_y, 1, size_hdf_y[1])
	endif else begin
	    hdf_data_y = reform(hdf_data_y, size_hdf_y[1], 1)
	endelse
    endelse
endif

;  reset the size_hdf_x and size_hdf_y
size_hdf_x = size(hdf_data_x)
size_hdf_y = size(hdf_data_y)

;  The column (size_hdf_x[1] of first matrix must equal to
;  the row (size_hdf_y[2] of the second matrix.
if size_hdf_x[1] ne size_hdf_y[2] then begin
    the_message = ['The number of columns of first array do not match', $
	'the number of rows of the second array!', $
	'Cannot do Matrices Multiplication!']
    result=dialog_message(the_message, title='View HDF Warning!')
    return
endif

;  Get the fill data value
this_type = info.subset.data(y_index).src_types
this_type = this_type(0)
filldata_value_y = get_filldata_value(this_type, info.filldata)
if filldata_value_y gt info.filldata then filldata_value_y = info.filldata

this_type = info.subset.data(x_index).src_types
this_type = this_type(0)
filldata_value_x = get_filldata_value(this_type, info.filldata)
if filldata_value_x gt info.filldata then filldata_value_x = info.filldata

if info.filldata gt 0 then begin
    if info.filldata lt 3.0E+37 then filldata = info.filldata * 10 $
	else filldata = 3.0E+38
endif else filldata = info.filldata

;  Create the output array, it is equal to number of columns of hdf_data_y and
;  number of rows of hdf_data_x
hdf_data_z = make_array(size_hdf_y[1], size_hdf_x[2], /DOUBLE, VALUE=filldata)

;  Set the fill data to zero
if filldata_value_x gt 0 then begin
    subscript = where(hdf_data_x ge filldata_value_x, count)
endif else begin
    subscript = where(hdf_data_x le filldata_value_x, count)
endelse
if count ne 0 then begin
    hdf_data_x[subscript] = 0.0
endif

if filldata_value_y gt 0 then begin
    subscript = where(hdf_data_y ge filldata_value_y, count)
endif else begin
    subscript = where(hdf_data_y le filldata_value_y, count)
endelse

if count ne 0 then begin
    hdf_data_y[subscript] = 0.0
endif

;  The multiplication of two arrays is multiplying the rows of the first array
;  by the columns of the second array
for i = 0L, size_hdf_x[2]-1 do begin
    for j = 0L, size_hdf_y[1]-1 do begin
	sum = 0.0D
	for k = 0L, size_hdf_x[1]-1 do begin
	    sum = sum + hdf_data_x[k, i] * hdf_data_y[j, k]
	endfor
	hdf_data_z[j, i] = sum
    endfor
endfor

; get the new variable name
dot=strpos(info.field_name.x,'[')
    if dot ne -1 then xtitle=strmid(info.field_name.x,0,dot) $
	else xtitle = info.field_name.x

dot=strpos(info.field_name.y,'[')
    if dot ne -1 then ytitle=strmid(info.field_name.y,0,dot) $
	else ytitle = info.field_name.y

xyname = ' '
    xyname = xtitle + info.y1y2.operator + ytitle
temp_name = 'Matrices Multiplication_'+xtitle+'_'+ytitle
get_variable_name, temp_name, info
widget_control, get_uvalue=info, info.base
if info.variablename eq 'None' then begin
    return
endif

hdf_data_z = reform(hdf_data_z)
size_hdf = size(hdf_data_z)
the_rank = size_hdf[0]
the_type = convert_idltype_hdftype(size_hdf[the_rank+1])
start_list = [0L]
end_list = [long(size_hdf[the_rank])]
increment_list = [1L]

for i = 1, the_rank-1 do begin
    start_list = [start_list, 0L]
    end_list = [end_list, long(size_hdf[the_rank-i])]
    increment_list = [increment_list, 1L]
endfor

unitname = info.subset.data(x_index).src_unitname
set_output_woref, info.variablename, -1, the_type, the_rank, $
        start_list, end_list, increment_list, unitname, info, hdf_data_z

undefine, hdf_data_x
undefine, hdf_data_y

result=dialog_message('Martix and Vector Compute Completed!', title='Notice!')

end

;--------------------------------------------------------------------------------
pro do_transpose, info, name_of_data, this_subset

pro_name = 'do_transpose'
@getinfo

;--------------------------
;  If this is an SDS then
;--------------------------

hdf_data = *info.subset.data(this_subset).src_data
if info.subset.data(this_subset).src_type_flag eq 1 then $
	hdf_data = hdf_data.components0
size_hdf = size(hdf_data)

if(size_hdf(0) eq 2) then begin
	info.graph_style = 'Transpose'
	dot=strpos(name_of_data,'[')
	if dot ne -1 then dataname=strmid(name_of_data,0,dot) $
	else dataname = name_of_data
	temp_name = 'Transpose of ' + dataname
	get_variable_name, temp_name, info
	widget_control, get_uvalue=info, info.base
	if info.variablename eq 'None' then return
	hdf_data_temp = transpose(hdf_data)
	size_temp = size(hdf_data_temp)
	if info.subset.data(this_subset).src_type_flag eq 0 then begin
	    set_statistics_subset, info.variablename, this_subset, size_temp(0), $
		info, hdf_data_temp
	endif else begin
	    the_type = info.subset.data(this_subset).src_types(0)
	    the_rank = 2
	    start_list = [0,0]
	    end_list = [size_temp(2), size_temp(1)]
	    increment_list = [1, 1]
	    unitname = info.subset.data(this_subset).src_unitname
	    set_output_woref, info.variablename, this_subset, the_type, the_rank, $
		start_list, end_list, increment_list, unitname, info, hdf_data_temp
	endelse
endif else begin

	the_message = [ 'Data record is not a 2 dimensional array', $
                'Transpose is not valid']
 
	result= dialog_message(the_message, $
		title='View HDF Message!')
 
endelse

end

;--------------------------------------------------------------------------------
pro do_xy_graph, info, name_of_data, this_subset, print_flag, plot_status

pro_name = 'do_xy_graph'
@getinfo

if ((print_flag lt 1) or (print_flag gt 3)) then begin
  info.field_name.y = info.subset.data(this_subset).subset_name
  info.graph_style = 'XY Graph'
  if(info.multiple.key ne 1) then begin
      plot_setup, info, 'XY Graph', 1, 0, 0
      widget_control, get_uvalue=info, info.base
      if info.canceloption eq 'Yes' then begin
	if info.multiple.key ne 1 then begin
		info.canceloption = 'No'
		widget_control, set_uvalue=info, info.base
		plot_status = 0
	endif
	return
      endif
  endif 
endif

widget_control, /hourglass

if (print_flag ne 1) or (info.multiple.key eq 1) then begin 
widget_control, get_uvalue=info, info.base
if info.subset.data(this_subset).src_type_flag eq 0 then begin
  hdf_data_y = *info.subset.data(this_subset).src_data
  this_rank = info.subset.data(this_subset).src_rank
  start_list = lonarr(this_rank)
  end_list = lonarr(this_rank)
  increment_list = lonarr(this_rank)
  array_size = lonarr(this_rank)

  start_list = info.subset.data(this_subset).src_start(0:this_rank-1)
  end_list = info.subset.data(this_subset).src_end(0:this_rank-1)
  increment_list = info.subset.data(this_subset).src_increment(0:this_rank-1)
  hdf_size_y = size(hdf_data_y)

  ;array_size = long((end_list-start_list)/float(increment_list) + 0.9)
  array_size = long((end_list-start_list-1)/float(increment_list) + 1.0)

  hdf_data_x = array_type(6, array_size)
  if (hdf_data_x(0) eq -1) then begin
	result=dialog_message('Unable to allocate memory for X field data!',$
			title='View HDF Warning!')
	plot_status = 0
	return
  endif
endif else begin
  hdf_y_temp = *info.subset.data(this_subset).src_data
  hdf_data_y = reform(hdf_y_temp.components0, n_elements(hdf_y_temp.components0))
  hdf_data_x = make_array(n_elements(hdf_data_y), /DOUBLE)
endelse

get_x_data, info, this_subset, print_flag, hdf_data_x

if info.canceloption eq 'Yes' then begin
	if info.multiple.key eq 1 then return
	info.canceloption = 'No'
	widget_control, set_uvalue=info, info.base
	plot_status = 0
	return
endif

temp_error_data = get_error_data(hdf_data_x)
if temp_error_data lt -9999999.0 then begin
    plot_status = 0
    return
endif

if ptr_valid(info.xyvalue.x_index) then $
	ptr_free, info.xyvalue.x_index
info.xyvalue.x_index=ptr_new(hdf_data_x)
 
endif else begin

widget_control, get_uvalue=info, info.base

if info.subset.data(this_subset).src_type_flag eq 0 then begin
  hdf_data_y = *info.subset.data(this_subset).src_data
endif else begin
  hdf_y_temp = *info.subset.data(this_subset).src_data
  hdf_data_y = reform(hdf_y_temp.components0, n_elements(hdf_y_temp.components0))
endelse
hdf_data_x = *info.xyvalue.x_index

endelse

set_axis_ranges, info, YRange, Ystyle, XRange, Xstyle, ZRange, Zstyle

change_scale = 0

this_type = info.subset.data(this_subset).src_types
this_type = this_type(0)
filldata_value = get_filldata_value(this_type, info.filldata)
if filldata_value gt info.filldata then filldata_value = info.filldata
max_value = get_max_value(this_type, info.filldata)
if info.filldata gt 0 then begin
    if max_value gt info.filldata then max_value = info.filldata
endif

if filldata_value gt 0 then begin
    subscript = where(hdf_data_y lt filldata_value, count)
endif else begin
    subscript = where(hdf_data_y gt filldata_value, count)
endelse
if(count ne 0) then begin
   hdf_data_x = hdf_data_x(subscript)
   hdf_data_y = hdf_data_y(subscript)
endif else begin
	result=dialog_message('All the Y field data are fill data!',$
	    title='View HDF Warning!')
	plot_status = 0
	return
endelse

if info.field_name.x eq 'Time' then $
	subscript = where(hdf_data_x lt 86400.0, count) $
else begin
    if info.filldata gt 0 then begin
	subscript = where(hdf_data_x lt info.filldata, count)
    endif else begin
	subscript = where(hdf_data_x gt info.filldata, count)
    endelse
endelse
if(count ne 0) then begin
   hdf_data_x = hdf_data_x(subscript)
   hdf_data_y = hdf_data_y(subscript)
endif else begin
	result=dialog_message('All the X field data are fill data!',$
	    title='View HDF Warning!')
	plot_status = 0
	return
endelse

x_max = max(hdf_data_x, min=x_min)
if x_max eq x_min then begin
    plot_status = 0
    return
endif
y_max = max(hdf_data_y, min=y_min)
info.slide.x_end = x_max
info.slide.x_start = x_min
info.slide.y_end = y_max
info.slide.y_start = y_min

filename = info.subset.data(this_subset).src_filename

dot=strpos(info.field_name.x,'[')
if( dot ne -1) then begin
  xtitle=strmid(info.field_name.x,0,dot)
endif else begin
  xtitle = info.field_name.x
endelse

if xtitle eq 'Select Variable' then begin
	x_index = info.out.x_index
	temp_name = info.subset.data(x_index).subset_name
	dot=strpos(temp_name,'[')
	if dot ne -1 then xtitle=strmid(temp_name,0,dot) $
		else xtitle = temp_name
	temp_name = info.subset.data(x_index).src_unitname
	temp_name = temp_name(0)
	dot=strpos(temp_name,'N/A')
	if( dot eq -1) then xtitle = xtitle + temp_name
endif

if xtitle eq 'Time' then begin
   case info.time_type.new of
     0: begin
	hdf_data_x(*) = hdf_data_x(*)/3600.0
	info.slide.x_end = x_max/3600.0
	info.slide.x_start = x_min/3600.0
	xtitle = 'Time of day, hours'
	end
     1: begin
	hdf_data_x(*) = hdf_data_x(*)/60.0
	info.slide.x_end = x_max/60.0
	info.slide.x_start = x_min/60.0
	xtitle = 'Time of day, minutes'
	end
     else: xtitle = 'Time of day, seconds'
  endcase
endif

if(widget_info(info.widgets.startfield, /VALID_ID)) then begin
  if info.time_type.old ne info.time_type.new then begin
    widget_control, info.widgets.startfield, get_value=x_start
    widget_control, info.widgets.rangefield, get_value=x_range
    case info.time_type.old of
       0: begin
	   x_start = x_start * 3600.0
	   x_range = x_range * 3600.0
	end
       1: begin
	   x_start = x_start * 60.0
	   x_range = x_range * 60.0
	end
       else:
    endcase

    case info.time_type.new of
       0: begin
  	   x_start = x_start / 3600.0
	   x_range = x_range / 3600.0
	   if x_range le 1 then x_range = 1
	end
       1: begin
	   x_start = x_start / 60.0
	   x_range = x_range / 60.0
	   if x_range le 1 then x_range = 1
	end
       else:
    endcase
    x_max = max(hdf_data_x, min=x_min)
    x_int_max = long(x_max)
    x_int_min = long(x_min)
    if x_int_max eq x_int_min then x_max = x_min + x_range
    info.range.x_start = x_start
    info.range.x_end = x_start + x_range
    info.save.x_start = x_min
    info.save.x_end = x_max
    widget_control, info.widgets.rangefield, set_value=x_range
    widget_control, info.widgets.startslide, set_slider_min=x_min
    widget_control, info.widgets.startslide, set_slider_max=x_max
    widget_control, info.widgets.startslide, set_slider_min=x_min
    widget_control, info.widgets.startslide, set_value=x_start
    widget_control, info.widgets.startfield, set_value=x_start
    info.time_type.old = info.time_type.new
    set_axis_ranges, info, YRange, Ystyle, XRange, Xstyle, ZRange, Zstyle
  endif
endif else info.time_type.old = info.time_type.new

field_name = info.subset.data(this_subset).subset_name
dot=strpos(field_name,'[')
if( dot ne -1) then begin
  ytitle=strmid(field_name,0,dot)
endif else begin
  ytitle=field_name
endelse

if info.multiple.key eq 1 then begin
	the_title = 'Multiple Y Variables vs. ' + xtitle
	if info.multiple.y1y2 ne 1 then ytitle = ''
	field_name = info.subset.data(this_subset).subset_name
	dot=strpos(field_name,'[')
	if( dot ne -1) then begin
  		legend_title=strmid(field_name,0,dot)
	endif else begin
  		legend_title=field_name
	endelse
endif else the_title = ytitle + ' vs. '+ xtitle

if ((print_flag eq 0) or (print_flag eq 3) or (print_flag eq 4)) then $
	plot_dialogue , name_of_data, info

data_range = ''
data_range = get_data_range(this_subset,info)
if !D.Name eq 'PS' or !D.Name eq 'PRINTER' or !D.Name eq 'WIN' or info.char.font eq 0 then begin
	the_title=the_title + '!C Data Range: ' + data_range
endif else begin
	the_title=the_title + '!C!C Data Range: ' + data_range
endelse


if info.style.symbolline eq 1 then plot_symbol = - info.style.symbol $
	else plot_symbol = info.style.symbol

if info.multiple.flag ne 1 then begin

   if info.multiple.key ne 1 then begin
	temp_name = info.subset.data(this_subset).src_unitname
	temp_name = temp_name(0)
	dot=strpos(temp_name,'N/A')
	if( dot eq -1) then ytitle = ytitle + temp_name
   endif

   if info.subset.data(this_subset).src_crit_flag eq 1 then begin
	crit_string = ''
	crit_string = get_crit_string(this_subset, info)
	if !D.Name eq 'PS' and info.eps_out.type eq 1 then $
		!P.Position = [0.235, 0.15, 0.99, 0.92] $
		else !P.Position = [0.060, 0.120, 0.98, 0.93]
	temp_name = str_sep(crit_string, '!C')
	num_temp = n_elements(temp_name)
	!P.Position(1) = !P.Position(1) + (num_temp-1)*0.025
   endif else begin
	if !D.Name eq 'PS' and info.eps_out.type eq 1 then $
		!P.Position = [0.235, 0.15, 0.99, 0.92] $
		else !P.Position = [0.060, 0.100, 0.98, 0.93]
   endelse

   if info.style.xlog gt 0 then begin
	check_max = max(hdf_data_x, min=check_min)
	XRange = set_log_range(XRange, check_min, check_max)
   endif

   if info.style.ylog gt 0 then begin
	YRange = set_log_range(YRange, y_min, y_max)
   endif

   if (info.multiple.key eq 1 and info.multiple.y1y2 eq 1) then begin
	temp_name = info.subset.data(this_subset).src_unitname
	temp_name = temp_name(0)
	dot=strpos(temp_name,'N/A')
	if( dot eq -1) then ytitle = ytitle + temp_name
	old_x_margin = !X.MARGIN
        if !P.Position(2) gt 0.0 then !P.Position(2) = !P.Position(2) - 0.03
        !X.MARGIN = [10, 10]
	ystyle = ystyle + 8
   endif
 
   get_ticklen, info.style.grid, xticklen, yticklen 

   if !D.Name ne 'PRINTER' then begin
	if !D.Name ne 'WIN' and info.char.font ne 0 then begin
	    xtitle='!C' + xtitle + '!C'
	endif else begin
	    xtitle = xtitle + '!C'
	endelse
   endif
   if !D.Name eq 'PS' or !D.Name eq 'PRINTER' then begin
	old_charsize = !X.CHARSIZE
	!X.CHARSIZE = 0.9
	!Y.CHARSIZE = 0.9	
   endif 

   plot,hdf_data_x,hdf_data_y, $
        MAX_VALUE = max_value, /YNOZERO, /NODATA, $
	FONT=info.char.font, $
	charsize=info.char.size, $
        xtitle=xtitle, $
        ytitle=ytitle, $
	title=the_title, $
        xticklen=xticklen, yticklen=yticklen, $
	subtitle="File: " + filename + "  Date:" + systime(0), $
        xrange=XRange, yrange=YRange, xstyle=Xstyle, ystyle=Ystyle, $
	xlog=info.style.xlog, ylog=info.style.ylog

   if info.subset.data(this_subset).src_crit_flag eq 1 then begin
	if !D.Name eq 'PS' or !D.Name eq 'PRINTER' then begin
		charsize = 0.9*info.char.size
		y_location = 0.125
	endif else begin
		charsize = info.char.size
		y_location = 0.11
	endelse
	;xyouts, !P.Position(0), !P.Position(1)-y_location, crit_string, /NORMAL, $
	xyouts, 0.08, !P.Position(1)-y_location, crit_string, /NORMAL, $
		font=info.char.font, charsize=charsize
   endif

   if info.addtext.key eq 1 then write_add_text, info

   if !D.Name eq 'PS' or !D.Name eq 'PRINTER' then begin
	!X.CHARSIZE = old_charsize
	!Y.CHARSIZE = old_charsize
   endif
 
endif

if ((info.multiple.key eq 1 and info.multiple.y1y2 eq 1) and $
     info.multiple.number eq 1) then begin
	temp_name = info.subset.data(this_subset).src_unitname
	temp_name = temp_name(0)
	dot=strpos(temp_name,'N/A')
	if( dot eq -1) then ytitle = ytitle + temp_name
	if filldata_value gt 0 then begin
	    subscripts = where(hdf_data_y lt filldata_value, count)
	endif else begin
	    subscripts = where(hdf_data_y gt filldata_value, count)
	endelse
	if count ne 0 then begin
	    if info.axis_state lt 6 then begin
		hdf_temp_data = hdf_data_y(subscripts)
		hdf_max = max(hdf_temp_data, min=hdf_min)
		if hdf_max le !y.crange(1) and hdf_min ge !y.crange(0) then begin
			toler=(info.range.y_end - info.range.y_start)/5
			max_diff = info.range.y_end - hdf_max
			min_diff = hdf_min - info.range.y_start
			if abs(max_diff) le toler and abs(min_diff) le toler then begin
				ymax=info.range.y_end
				ymin=info.range.y_start
			endif else begin
				get_range, hdf_max, hdf_min, ymax, ymin
				ymax = ymax + (ymax - ymin)*0.15
			endelse
		endif else begin
			get_range, hdf_max, hdf_min, ymax, ymin
			ymax = ymax + (ymax - ymin)*0.15
		endelse
	    endif else begin
		ymin = info.range.y2_start
		ymax = info.range.y2_end
		ymax = ymax + (ymax - ymin)*0.15
	    endelse
		old_x = !X
		old_y = !Y
		change_scale = 1
		 if info.style.y2log gt 0 then begin
			y2range = [ymin, ymax]
			y2range = set_log_range(y2range, ymin, ymax)
			ymin = y2range(0)
			ymax = y2range(1)
		endif else if !Y.TYPE eq 1 then !Y.TYPE = 0
		Axis, YAXIS=1, ytitle = ytitle, YRANGE=[ymin, ymax], $
			FONT=info.char.font, charsize=info.char.size, ystyle=3, $
			ticklen=0.01, ylog=info.style.y2log, /SAVE
		if info.axis_state gt 0 then begin
		    y22range = [info.range.y2_start, info.range.y2_end]
		    fit_flag = 0
		    fit_data_range, info.axis_state, fit_flag, 0, 1, xrange, 0, 0, y22range, $
			hdf_data_x, 0, 0, hdf_data_y, 0
		    if fit_flag eq 1 then return
		endif
	endif else begin
		Axis, YAXIS=1, ytitle = ytitle, FONT=info.char.font, $
			charsize=info.char.size, ystyle=2, ticklen=0.01, $
			ylog=info.style.ylog, /SAVE
	endelse
endif else if info.axis_state gt 0 then begin
	fit_flag = 0
	if info.multiple.key eq 1 then y1range = [info.range.y_start, info.range.real_y_end] $
		else y1range = yrange
	fit_data_range, info.axis_state, fit_flag, 0, 1, xrange, y1range, 0, 0, hdf_data_x, $
		hdf_data_y, 0, 0, 0
	if fit_flag eq 1 then return
endif
 
oplot, hdf_data_x,hdf_data_y, MAX_VALUE = max_value, $
	psym = plot_symbol, linestyle=info.style.linetype, $
	symsize = info.style.symbolsize, thick = info.style.linethick, $
	color = info.style.colorindex

if info.multiple.key eq 1 then begin
	temp_name = info.subset.data(this_subset).src_unitname
	temp_name = temp_name(0)
	dot=strpos(temp_name,'N/A')
	if( dot eq -1) then legend_title = legend_title + temp_name
 
	y_leg = !Y.WINDOW(1) - 0.03 - 0.025 * info.multiple.number
	y_leg_t = y_leg - 0.005
	x_leg_s = !X.WINDOW(0) + 0.03
	x_leg_e = x_leg_s + 0.05
	leg_start = convert_coord(x_leg_s, y_leg, /NORMAL, /TO_DATA)
	leg_end   = convert_coord(x_leg_e, y_leg, /NORMAL, /TO_DATA)
	oplot, [leg_start(0), leg_end(0)], [leg_start(1), leg_end(1)], $
		psym = plot_symbol, linestyle=info.style.linetype, $
		symsize = info.style.symbolsize, thick = info.style.linethick, $
		color = info.style.colorindex

	xyouts, x_leg_e+0.01, y_leg_t, legend_title, /NORMAL, font=info.char.font, $
		charsize=info.char.size
endif
 
if change_scale eq 1 then begin
	!X = old_x
	!Y = old_y
endif

if info.subset.data(this_subset).src_crit_flag eq 1 then $
	!P.Position = [0.0, 0.0, 0.0, 0.0]

check_x_margin = size(old_x_margin)
if check_x_margin(0) ne 0 then !X.MARGIN=old_x_margin

widget_control, set_uvalue=info, info.widgets.base
widget_control, set_uvalue=info, info.base
end

;--------------------------------------------------------------------------------
pro do_xyz_graph, info, name_of_data, this_subset, print_flag, plot_status

pro_name = 'do_xyz_graph'
@getinfo

if info.subset.count lt 3 then begin
	result=dialog_message('You need at least three subsets of data to do XYZ Graph!',$
	    title='View HDF Warning!')
	plot_status = 0
	return
endif

if print_flag ne 1 and print_flag ne 3 then begin
  info.field_name.z = info.subset.data(this_subset).subset_name
  info.graph_style = 'XYZ Graph'
  plot_setup, info, 'XYZ Graph', 1, 1, 0
  widget_control, get_uvalue=info, info.base
  if info.canceloption eq 'Yes' then begin
	info.canceloption = 'No'
	widget_control, set_uvalue=info, info.base
	plot_status = 0
	return
  endif 
  info.overlay.flag = 0
  info.overlay.offflag = 0
endif

;  If put a hourglass in WIN, it will not get the signal of stop or pause widget
if !D.Name ne 'WIN' then widget_control, /hourglass

widget_control, get_uvalue=info, info.base
get_data, y_index, x_index, z_index, info

set_axis_ranges, info, YRange, Ystyle, XRange, Xstyle, ZRange, Zstyle

if info.subset.data(x_index).src_type_flag eq 0 then begin
  hdf_data_x = *info.subset.data(x_index).src_data
endif else begin
  hdf_x_temp = *info.subset.data(x_index).src_data
  hdf_data_x = reform(hdf_x_temp.components0, n_elements(hdf_x_temp.components0))
endelse

if info.subset.data(y_index).src_type_flag eq 0 then begin
  hdf_data_y = *info.subset.data(y_index).src_data
endif else begin
  hdf_x_temp = *info.subset.data(y_index).src_data
  hdf_data_y = reform(hdf_x_temp.components0, n_elements(hdf_x_temp.components0))
endelse

if info.subset.data(z_index).src_type_flag eq 0 then begin
  hdf_data_z = *info.subset.data(z_index).src_data
endif else begin
  hdf_x_temp = *info.subset.data(z_index).src_data
  hdf_data_z = reform(hdf_x_temp.components0, n_elements(hdf_x_temp.components0))
endelse

num_x = n_elements(hdf_data_x)
num_y = n_elements(hdf_data_y)
num_z = n_elements(hdf_data_z)

if(num_x eq num_y) and (num_x eq num_z) then begin
 
this_type = info.subset.data(x_index).src_types
this_type = this_type(0)
filldata_value = get_filldata_value(this_type, info.filldata)
if filldata_value gt info.filldata then filldata_value = info.filldata

if filldata_value gt 0 then begin
    subscript = where(hdf_data_x lt filldata_value, count)
endif else begin
    subscript = where(hdf_data_x gt filldata_value, count)
endelse
if(count ne 0) then begin
   hdf_data_x = hdf_data_x(subscript)
   hdf_data_y = hdf_data_y(subscript)
   hdf_data_z = hdf_data_z(subscript)
endif else begin
	result=dialog_message('All the X field data are fill data!',$
	    title='View HDF Warning!')
	plot_status = 0
	return
endelse
 
this_type = info.subset.data(y_index).src_types
this_type = this_type(0)
filldata_value = get_filldata_value(this_type, info.filldata)
if filldata_value gt info.filldata then filldata_value = info.filldata

if filldata_value gt 0 then begin
    subscript = where(hdf_data_y lt filldata_value, count)
endif else begin
    subscript = where(hdf_data_y gt filldata_value, count)
endelse
if(count ne 0) then begin
   hdf_data_x = hdf_data_x(subscript)
   hdf_data_y = hdf_data_y(subscript)
   hdf_data_z = hdf_data_z(subscript)
endif else begin
	result=dialog_message('All the Y field data are fill data!',$
	    title='View HDF Warning!')
	plot_status = 0
	return
endelse
 
this_type = info.subset.data(this_subset).src_types
this_type = this_type(0)
filldata_value = get_filldata_value(this_type, info.filldata)
if filldata_value gt info.filldata then filldata_value = info.filldata

if filldata_value gt 0 then begin
    subscript = where(hdf_data_z lt filldata_value, count)
endif else begin
    subscript = where(hdf_data_z gt filldata_value, count)
endelse
if(count ne 0) then begin
   hdf_data_x = hdf_data_x(subscript)
   hdf_data_y = hdf_data_y(subscript)
   hdf_data_z = hdf_data_z(subscript)
endif else begin
	result=dialog_message('All the Z field data are fill data!',$
	    title='View HDF Warning!')
	plot_status = 0
	return
endelse
 
x_max = max(hdf_data_x, min=x_min)
y_max = max(hdf_data_y, min=y_min)
info.slide.x_end = x_max
info.slide.x_start = x_min
info.slide.y_end = y_max
info.slide.y_start = y_min

xyzname = ''
xyzname = info.field_name.x + ' : ' + info.field_name.y + ' : ' + $
          info.field_name.z
if (print_flag eq 0) or (print_flag eq 3) then plot_dialogue , xyzname, info
 
filename = info.subset.data(y_index).src_filename
 
dot=strpos(info.field_name.x,'[')
if dot ne -1 then xtitle=strmid(info.field_name.x,0,dot)  $
	else xtitle = info.field_name.x
dot=strpos(info.field_name.y,'[')
if dot ne -1 then ytitle=strmid(info.field_name.y,0,dot) $
	else ytitle = info.field_name.y
dot=strpos(info.field_name.z,'[')
if dot ne -1 then ztitle=strmid(info.field_name.z,0,dot) $
	else ztitle = info.field_name.z
 
if (info.axis_state eq 3) or (info.axis_state eq 5) then begin
        z_max = info.range.z_end
        z_min = info.range.z_start
endif else begin
        z_max = max(hdf_data_z, min = z_min)
        z_max_temp = long(z_max + 0.99999)
        z_min_temp = long(z_min - 0.99999)
        z_max = float(z_max_temp)
        z_min = float(z_min_temp)
endelse
 
info.overlay.zmax = z_max
info.overlay.zmin = z_min

data_range = ''
data_range = get_data_range(this_subset,info)
if !D.Name eq 'PS' or !D.Name eq 'PRINTER' or !D.Name eq 'WIN' or info.char.font eq 0 then begin
	the_title=ytitle + ' vs. ' + xtitle + '!Ccolored by ' + ztitle $
		 + ' with Data Range: ' + data_range
endif else begin
	the_title=ytitle + ' vs. ' + xtitle + '!C!Ccolored by ' + ztitle $
		 + ' with Data Range: ' + data_range
endelse

	top_color = !d.n_colors - 2
	if top_color gt 254 then top_color = 254
	if((!D.Name ne 'PS' and !D.Name ne 'PRINTER') and top_color gt info.top_color) then $
		top_color = info.top_color

if info.greenwich.with_level ge 1 then begin
	if info.greenwich.with_level eq 2 then begin
	    info.greenwich.in_level = 0
	    if z_max lt 1.0 then info.greenwich.with_level = 1 $
	    else begin
		if z_min lt 1.0 then z_min = 1.0
	    endelse
	endif
	n_level = info.greenwich.n_level
	if info.greenwich.in_level eq 1 then begin
	    temp_range = str_sep(info.greenwich.range, ';')
	    num_range = n_elements(temp_range)
	    if info.greenwich.ext_level eq 0 then begin
		n_level = num_range + 1
		vlevel = double(temp_range)
		vlevel = [vlevel(0), vlevel, vlevel(num_range-1)]
	    endif else begin
		n_level = num_range - 1
		vlevel = double(temp_range)
	    endelse
	    if z_min gt vlevel(0) then z_min = vlevel(0)
	    if z_max lt vlevel(n_level) then z_max = vlevel(n_level)
	    data_interval = vlevel(n_level-1)-vlevel(n_level-2)
	    tempa=findgen(n_level)
	endif else begin
	  tempa=findgen(n_level)
	  if info.greenwich.with_level eq 2 then begin
	    if ((info.axis_state eq 3) or (info.axis_state eq 5)) and $
	      info.greenwich.ext_level eq 0 then begin
		;data_interval = (alog10(z_max) - alog10(z_min))/float(n_level-1)
		;vlevel = [0, tempa+1]
		data_interval = (alog10(z_max) - alog10(z_min))/float(n_level-2)
		vlevel = [0, tempa]
		vlevel(n_level) = vlevel(n_level-1)
	    endif else begin
		data_interval = (alog10(z_max) - alog10(z_min))/float(n_level)
		vlevel = [0, tempa+1]
	    endelse
	    vlevel = alog10(z_min) + vlevel * data_interval
	    vlevel = 10 ^ vlevel
	  endif else begin
	    if ((info.axis_state eq 3) or (info.axis_state eq 5)) and $
	      info.greenwich.ext_level eq 0 then begin
		;data_interval = (z_max - z_min)/float(n_level-1)
		;vlevel = [0, tempa+1]
		data_interval = (z_max - z_min)/float(n_level-2)
		vlevel = [0, tempa]
                vlevel(n_level) = vlevel(n_level-1)
	    endif else begin
		data_interval = (z_max - z_min)/float(n_level)
		vlevel = [0, tempa+1]
	    endelse
	    vlevel = z_min + vlevel * data_interval
	  endelse
	endelse

	color_interval = top_color/float(n_level)
	;tempa=findgen(n_level)
	clevel = fix(color_interval * (tempa(*) + 1))

	;sub_max = where(hdf_data_z gt z_max , count_max)
	;sub_min = where(hdf_data_z lt z_min, count_min)
	;if count_min ne 0 then hdf_data_z(sub_min) = z_max + 10 * data_interval
	my_color = make_array(n_elements(hdf_data_z), /INT, VALUE=!P.BACKGROUND)
	if info.greenwich.in_level eq 0 then begin
	  ;if abs(data_interval) ge 1.0 then begin
	  ;  if info.greenwich.with_level eq 2 then begin
	;	my_color(*) = fix(fix((alog10(hdf_data_z(*)) - alog10(z_min))/data_interval + 1.0) * $
	;		color_interval)
	;    endif else begin
	;	my_color(*) = fix(fix((hdf_data_z(*) - z_min)/data_interval + 1.0) * $
	;		color_interval)
	;    endelse
	;  endif else begin
	;    if info.greenwich.with_level eq 2 then begin
	;	my_color(*) = fix(fix((alog10(hdf_data_z(*)) - alog10(z_min))/data_interval + 0.99999) * $
	;		color_interval)
	;    endif else begin
	;	my_color(*) = fix(fix((hdf_data_z(*) - z_min)/data_interval + 0.99999) * $
	;		color_interval)
	;    endelse
	;  endelse
	  for i = 0, n_level-2 do begin
	    sub_color = where(hdf_data_z ge vlevel(i) and hdf_data_z lt vlevel(i+1), count_color)
	    if count_color ne 0 then my_color(sub_color) = clevel(i)
	  endfor
	  if ((info.axis_state eq 3) or (info.axis_state eq 5)) and $
	    info.greenwich.ext_level eq 0 then begin
		sub_color = where(hdf_data_z gt vlevel(n_level-1), count_color)
		if count_color ne 0 then my_color(sub_color) = clevel(n_level-1)
		sub_color = where(hdf_data_z lt vlevel(1), count_color)
		if count_color ne 0 then my_color(sub_color) = clevel(0)
	  endif else begin
		sub_color = where(hdf_data_z ge vlevel(n_level-1) and hdf_data_z lt vlevel(n_level), count_color)
		if count_color ne 0 then my_color(sub_color) = clevel(n_level-1)
	  endelse
	endif else begin
	  if info.greenwich.ext_level eq 0 then begin
	    sub_color = where(hdf_data_z lt vlevel(1), count_color)
	    if count_color ne 0 then my_color(sub_color) = clevel(0)
	    sub_color = where(hdf_data_z gt vlevel(n_level-1), count_color)
	    if count_color ne 0 then my_color(sub_color) = clevel(n_level-1)
	  endif else begin
	    sub_color = where(hdf_data_z lt vlevel(1) and hdf_data_z ge vlevel(0), count_color)
            if count_color ne 0 then my_color(sub_color) = clevel(0)
            sub_color = where(hdf_data_z gt vlevel(n_level-1) and hdf_data_z le vlevel(n_level), count_color)
            if count_color ne 0 then my_color(sub_color) = clevel(n_level-1)
	  endelse
	  for i = 1, n_level-2 do begin
	    sub_color = where(hdf_data_z ge vlevel(i) and hdf_data_z lt vlevel(i+1), count_color)
	    if count_color ne 0 then my_color(sub_color) = clevel(i)
	  endfor
	    ;sub_color = where(hdf_data_z gt vlevel(n_level-1), count_color)
	    ;if count_color ne 0 then my_color(sub_color) = clevel(n_level-1)
	endelse
	if ((info.axis_state ne 3) and (info.axis_state ne 5)) or $
	    info.greenwich.ext_level eq 1 then begin
		sub_max = where(hdf_data_z gt z_max , count_max)
		sub_min = where(hdf_data_z lt z_min, count_min)
		if count_max ne 0 then begin
		    my_color(sub_max) = !P.BACKGROUND
		    hdf_data_z(sub_max) = filldata_value
		endif
		if count_min ne 0 then begin
		    my_color(sub_min) = !P.BACKGROUND
		    hdf_data_z(sub_min) = filldata_value
		endif
	endif
endif else my_color=bytscl(hdf_data_z, max=z_max, min=z_min, top=top_color)

	if info.color_table ne 0 and info.pick_color_table eq 0 then $
		check_bw = check_color_table(top_color) $
		else check_bw = 0
	if check_bw eq 1 then begin
		color_table_file=info.home_path+"/"+"view_hdf_color.tbl"
		test_file = findfile(color_table_file, count=count)
		if count eq 0 then color_table_file = 'view_hdf_color.tbl'
		loadct, info.color_table, file=color_table_file
	endif
 
	if info.subset.data(this_subset).src_crit_flag eq 1 then begin
		crit_string = ''
		crit_string = get_crit_string(this_subset, info)
		if !D.Name eq 'PS' and info.eps_out.type eq 1 then $
			!P.Position = [0.235, 0.15, 0.99, 0.92] $
			else !P.Position = [0.060, 0.120, 0.98, 0.92]
		temp_name = str_sep(crit_string, '!C')
		num_temp = n_elements(temp_name)
		!P.Position(1) = !P.Position(1) + (num_temp-1)*0.025
	endif else begin
		if !D.Name eq 'PS' and info.eps_out.type eq 1 then $
			!P.Position = [0.235, 0.15, 0.99, 0.92] $
			else !P.Position = [0.060, 0.100, 0.98, 0.92]
	endelse

temp_name = info.subset.data(x_index).src_unitname
temp_name = temp_name(0)
dot=strpos(temp_name,'N/A')
if( dot eq -1) then xtitle = xtitle + temp_name

temp_name = info.subset.data(y_index).src_unitname
temp_name = temp_name(0)
dot=strpos(temp_name,'N/A')
if( dot eq -1) then ytitle = ytitle + temp_name

if info.color_bar eq 1 then begin
	if (info.axis_state eq 2) or (info.axis_state eq 4) or $
	   (info.axis_state eq 5) then begin
		yrange1=yrange
		yrange1(0) = yrange1(0) - (yrange1(1) - yrange(0)) * 0.15
	endif else begin
		get_range, y_max, y_min, ymax, ymin
		ymin = ymin - (ymax - ymin)*0.15
		yrange1 = [ymin, ymax]
		ystyle = 3
	endelse
endif else yrange1 = yrange

if info.style.xlog gt 0 then begin
     XRange = set_log_range(XRange, x_min, x_max)
endif

if info.style.ylog gt 0 then begin
    YRange1 = set_log_range(YRange1, y_min, y_max)
endif

get_ticklen, info.style.grid, xticklen, yticklen 

if !D.Name ne 'PRINTER' then begin
    if !D.Name ne 'WIN' and info.char.font ne 0 then begin
	xtitle= '!C' + xtitle + '!C'
    endif else begin
	xtitle = xtitle + '!C'
    endelse
endif
if !D.Name eq 'PS' or !D.Name eq 'PRINTER' then begin
	old_charsize = !X.CHARSIZE
	!X.CHARSIZE = 0.9
	!Y.CHARSIZE = 0.9	
endif

plot,hdf_data_x, hdf_data_y, /NODATA, /YNOZERO, $
	FONT=info.char.font, $
	charsize=info.char.size, $
        xtitle=xtitle, $
        ytitle=ytitle, $
	title=the_title, $
        color= !P.COLOR, $
        xticklen=xticklen, yticklen=yticklen, $
	subtitle="File: " + filename + "  Date:" + systime(0), $
        xrange=XRange, yrange=YRange1, xstyle=Xstyle, ystyle=Ystyle, $
	xlog=info.style.xlog, ylog=info.style.ylog
 
if info.style.symbolline eq 1 then plot_symbol = - info.style.symbol $
	else plot_symbol = info.style.symbol

if info.axis_state gt 0 then begin
    fit_flag = 0
    if info.greenwich.with_level ge 1 and info.greenwich.ext_level eq 0 then begin
	fit_data_range, info.axis_state, fit_flag, 2, 1, xrange, yrange, 0, $
	    0, hdf_data_x, hdf_data_y, hdf_data_z, 0, my_color
    endif else begin
	fit_data_range, info.axis_state, fit_flag, 2, 1, xrange, yrange, zrange, $
	    0, hdf_data_x, hdf_data_y, hdf_data_z, 0, my_color
    endelse
    if fit_flag eq 1 then return
endif

if info.filldata gt 0 then max_value = info.filldata else max_value = 3.0E+38
num_x = n_elements(hdf_data_x)
i = 0L
!UserDone = 0
;for i=0L,(n_elements(hdf_data_x)-1) do begin
while(i lt num_x and !UserStop eq 1) do begin
	if(i mod 1000 eq 0) then begin
	    if !D.Name ne 'WIN' then begin
		result = widget_event(info.widgets.stop,/Nowait, /save_hourglass)
		result = widget_event(info.widgets.pause,/Nowait, /save_hourglass)
	    endif else begin
		;  If put a hourglass in WIN, it will not get the signal of stop or pause widget
		result = widget_event(info.widgets.stop,/Nowait)
		result = widget_event(info.widgets.pause,/Nowait)
	    endelse
	endif
        oplot,[hdf_data_x(i), hdf_data_x(i)],[hdf_data_y(i), hdf_data_y(i)], $
	  MAX_VALUE = max_value, psym = plot_symbol, linestyle=info.style.linetype, $
	  symsize=info.style.symbolsize, color=my_color(i), $
	  thick = info.style.linethick
	i = i + 1
endwhile
;endfor
!UserStop = 1
!UserPause = 1
!UserDone = 1
widget_control, set_button=0, info.widgets.pause
 
if info.color_bar eq 1 then begin
   temp_name = info.subset.data(this_subset).src_unitname
   temp_name = temp_name(0)
   temp_length = strlen(temp_name)
   unitlabel = ''
   if (temp_length gt 0) then begin
      dot=strpos(temp_name,'N/A')
      if( dot eq -1) then unitlabel = strmid(temp_name,2,temp_length-2)
   endif
   ; x_location = !P.Position(0) + (!P.Position(2) - !P.Position(0))/2. - 0.22
   x_bar_location = 20.0 * info.greenwich.barsize
   x_location = !P.Position(0) + (!P.Position(2) - !P.Position(0))/2. - x_bar_location
   y_location = !y.window(0) + 0.08
   if info.greenwich.with_level ge 1 then $
	draw_contour_bar, clevel, z_min, z_max, y_location, x_location, n_level, $
	    info.char.size, info.char.font, unitlabel, vlevel, !P.background, $
	    info.greenwich.setformat, info.greenwich.bformat, info.greenwich.colborder, $
	    info.greenwich.displaybad, deltx=info.greenwich.barsize $
   else draw_color_bar, top_color, z_min, z_max, y_location, x_location, $
	info.char.size, info.char.font, unitlabel, info.greenwich.setformat, $
	info.greenwich.bformat, deltx=info.greenwich.barsize
endif
 
if info.subset.data(this_subset).src_crit_flag eq 1 then begin
	if !D.Name eq 'PS' or !D.Name eq 'PRINTER' then begin
		charsize = 0.9*info.char.size
		y_location = 0.125
	endif else begin
		charsize = info.char.size
		y_location = 0.11
	endelse
	;xyouts, !P.Position(0), !P.Position(1)-y_location, crit_string, /NORMAL, $
	xyouts, 0.08, !P.Position(1)-y_location, crit_string, /NORMAL, $
		font=info.char.font, charsize=charsize
endif

if info.addtext.key eq 1 then write_add_text, info

test = !d.flags and 128
if test ne 0 then begin
    ;image = tvrd()
    image = get_image24()
    if ptr_valid(info.overlay.image) then ptr_free, info.overlay.image
	info.overlay.image = ptr_new(image, /NO_COPY)
endif

if info.overlay.flag eq 1 then do_overlay, info

if !D.Name eq 'PS' or !D.Name eq 'PRINTER' then begin
	!X.CHARSIZE = old_charsize
	!Y.CHARSIZE = old_charsize
endif

!P.Position = [ 0.0 , 0.0 , 0.0 , 0.0]

endif else begin
	result=dialog_message('Number of data points for three subsets are not equal!',$
	    title='View HDF Warning!')
	plot_status = 0
	return
endelse

widget_control, set_uvalue=info, info.widgets.base
widget_control, set_uvalue=info, info.base

end

;--------------------------------------------------------------------------------
pro do_y1y2_compute, print_flag, info, plot_status

pro_name = 'do_y1y2_compute'
@getinfo

if info.subset.count lt 1 then begin
	the_message = ['You need at least one subset of data', $
	    'to do Y1 Y2 Compute!']
	result=dialog_message(the_message, title='View HDF Warning!')
	plot_status = 0
	return
endif

if print_flag eq 0 then begin
  info.graph_style = 'Y1Y2 Compute'
  plot_setup, info, 'Y1Y2 Compute', 1, 1, 0
  widget_control, get_uvalue=info, info.base
  if info.canceloption eq 'Yes' then begin
	info.canceloption = 'No'
	widget_control, set_uvalue=info, info.base
	plot_status = 0
	return
  endif 

endif

widget_control, /hourglass

widget_control, get_uvalue=info, info.base
get_data, y_index, x_index, z_index, info
x_index = x_index(0)
y_index = y_index(0)

if x_index eq -1 and y_index eq -1 then begin
	result=dialog_message('Both operands are constant!', title='View HDF Warning!')
	plot_status = 0
	return
endif
	
if x_index ne -1 then this_subset = x_index else this_subset = y_index
info.subset.selected = this_subset

if x_index ne -1 then begin
  if info.subset.data(x_index).src_type_flag eq 0 then begin
	hdf_data_x = *info.subset.data(x_index).src_data
	size_hdf_data = size(hdf_data_x)
	size_hdf_x = size(hdf_data_x)
	hdf_data_x = reform(hdf_data_x, n_elements(hdf_data_x))
  endif else begin
	; hdf_x_temp = *info.subset.data(x_index).src_data
	hdf_data_x = *info.subset.data(x_index).src_data
	size_hdf_data =  size(hdf_data_x)
	size_hdf_x = size(hdf_data_x)
	hdf_data_x = reform(hdf_data_x.components0, n_elements(hdf_data_x.components0))
	; hdf_data_x = reform(hdf_x_temp.components0, n_elements(hdf_x_temp.components0))
	; undefine, hdf_x_temp
  endelse
  num_x = n_elements(hdf_data_x)
endif

if y_index ne -1 then begin
  if info.subset.data(y_index).src_type_flag eq 0 then begin
	hdf_data_y = *info.subset.data(y_index).src_data
	if x_index eq -1 then size_hdf_data = size(hdf_data_y)
	size_hdf_y = size(hdf_data_y)
	hdf_data_y = reform(hdf_data_y, n_elements(hdf_data_y))
  endif else begin
	; hdf_y_temp = *info.subset.data(y_index).src_data
	hdf_data_y = *info.subset.data(y_index).src_data
	if x_index eq -1 then size_hdf_data = size(hdf_data_y)
	size_hdf_y = size(hdf_data_y)
	; hdf_data_y = reform(hdf_y_temp.components0, n_elements(hdf_y_temp.components0))
	hdf_data_y = reform(hdf_data_y.components0, n_elements(hdf_data_y.components0))
  endelse
  num_y = n_elements(hdf_data_y)
endif

if x_index eq -1 then begin
	num_x = num_y
	;hdf_data_x = make_array(num_x, /FLOAT, VALUE=info.y1y2.cons_value1)
	hdf_data_x = info.y1y2.cons_value1
endif
if y_index eq -1 then begin
	num_y = num_x
	;hdf_data_y = make_array(num_y, /FLOAT, VALUE=info.y1y2.cons_value2)
	hdf_data_y = info.y1y2.cons_value2
endif

;  if both do not have the same number of data, check one is vector and one is matrix
if(num_x ne num_y) then begin
	check_expand = 0
	; If one is one-dimensional and the other is two-dimension, may be expanded
	if(abs(size_hdf_x[0] - size_hdf_y[0]) eq 1) then begin
	    ; if x is matrix and y is vector
	    if(size_hdf_x[0] eq 2 and size_hdf_y[0] eq 1) then begin
		;  check which dimension is matched with y
		if size_hdf_y[1] eq size_hdf_x[1] or $
		   size_hdf_y[1] eq size_hdf_x[2] then begin
		    idltype = size(hdf_data_y, /type)
		    hdftype = convert_idltype_hdftype(idltype)
		    array_size = [size_hdf_x[2], size_hdf_x[1]]
		    hdf_y_temp = array_type(hdftype, array_size)
		    if(hdf_y_temp[0] eq -1) then begin
			result=dialog_message('Unable to allocate memory for temporary y data!',$
			    title='View HDF Warning!')
			plot_status = 0
			return
		    endif
		    if size_hdf_y[1] eq size_hdf_x[1] then begin
			for i = 0L, size_hdf_y[1]-1 do begin
			    hdf_y_temp[i,*] = hdf_data_y[i]
			endfor
		    endif else begin
			for i = 0L, size_hdf_y[1]-1 do begin
			    hdf_y_temp[*,i] = hdf_data_y[i]
			endfor
		    endelse
		    check_expand = 1
		    hdf_data_y = temporary(hdf_y_temp)
		    num_y = n_elements(hdf_data_y)
		endif
	    endif else if (size_hdf_x[0] eq 1 and size_hdf_y[0] eq 2) then begin
		;  if X is a vector and y is a matrix
		;  check which dimension is matched with X
		if size_hdf_x[1] eq size_hdf_y[1] or $
		   size_hdf_x[1] eq size_hdf_y[2] then begin
		    idltype = size(hdf_data_x, /type)
		    hdftype = convert_idltype_hdftype(idltype)
		    array_size = [size_hdf_y[2], size_hdf_y[1]]
		    hdf_x_temp = array_type(hdftype, array_size)
		    if(hdf_x_temp[0] eq -1) then begin
			result=dialog_message('Unable to allocate memory for temporary X data!',$
			    title='View HDF Warning!')
			plot_status = 0
			return
		    endif
		    if size_hdf_x[1] eq size_hdf_y[1] then begin
			for i = 0L, size_hdf_x[1]-1 do begin
			    hdf_x_temp[i,*] = hdf_data_x[i]
			endfor
		    endif else begin
			for i = 0L, size_hdf_x[1]-1 do begin
			    hdf_x_temp[*,i] = hdf_data_x[i]
			endfor
		    endelse
		    check_expand = 1
		    hdf_data_x = temporary(hdf_x_temp)
		    num_x = n_elements(hdf_data_x)
		    ;  set this_subset to y when y is a matrix
		    size_hdf_data = size_hdf_y
		    this_subset = y_index 
		    info.subset.selected = this_subset
		endif
	    endif
	endif

	;  if check_expand eq 0 then the two are really not matched, so exit
	if(check_expand eq 0) then begin
	    result=dialog_message('Number of data points for two subsets are not equal!',$
		title='View HDF Warning!')
	    plot_status = 0
	    return
	endif
endif

if y_index ne -1 then begin
	this_type = info.subset.data(y_index).src_types
	this_type = this_type(0)
	filldata_value_y = get_filldata_value(this_type, info.filldata)
	if filldata_value_y gt info.filldata then filldata_value_y = info.filldata
	max_value_y = get_max_value(this_type, info.filldata)
	if info.filldata gt 0 then begin
	    if max_value_y gt info.filldata then max_value_y = info.filldata
	endif
endif else begin
	filldata_value_y = info.filldata
	if info.filldata gt 0 then max_value_y = info.filldata else max_value_y = 3.0E+38
endelse

if x_index ne -1 then begin
	this_type = info.subset.data(x_index).src_types
	this_type = this_type(0)
	filldata_value_x = get_filldata_value(this_type, info.filldata)
	if filldata_value_x gt info.filldata then filldata_value_x = info.filldata
	max_value_x = get_max_value(this_type, info.filldata)
	if info.filldata gt 0 then begin
	    if max_value_x gt info.filldata then max_value_x = info.filldata
	endif
endif else begin
	filldata_value_x = info.filldata
	if info.filldata gt 0 then max_value_x = info.filldata else max_value_x = 3.0E+38
endelse

if max_value_y gt max_value_x then max_value = max_value_y $
	else max_value = max_value_x

;filldata = get_filldata(this_type,info.filldata)
if info.filldata gt 0 then begin
    if info.filldata lt 3.0E+37 then filldata = info.filldata * 10 $
	else filldata = 3.0E+38
endif else filldata = info.filldata
;case this_type of
;        21: filldata = 255
;        22: filldata = 32767
;        23: filldata = 65535
;        24: filldata = 2147483647
;        25: filldata = 2147483647
;        else: begin
;		if info.filldata lt 3.0E+37 then $
;			filldata = info.filldata * 10 $
;		else filldata = 3.0E+38
;	      end
;endcase

if info.y1y2.operator eq ' ** ' then begin
    int_const = 0
    ;if y_index eq -1 and info.y1y2.cons_value2 gt 0.0 then begin
    if y_index eq -1 then begin
	y_frac = info.y1y2.cons_value2 - floor(info.y1y2.cons_value2)
	if abs(y_frac) lt 0.0000001 then begin 
	    ;hdf_data_y = fix(hdf_data_y)
	    hdf_data_y = fix(info.y1y2.cons_value2)
	    int_const = 1
	endif
    endif

    if int_const eq 0 then begin
	neg_subs = where(hdf_data_x lt 0.0, count)
	if count gt 0 then begin
	    hdf_data_x(neg_subs) = filldata_value_x
	endif
    endif
endif

if info.y1y2.tri_flag gt 0 then hdf_data_y = fix(info.y1y2.cons_value2)

if x_index ne -1 and y_index ne -1 then begin
    if filldata_value_x gt 0 then begin
	subscript = where(hdf_data_x lt filldata_value_x and hdf_data_y lt filldata_value_y, count)
    endif else begin
	subscript = where(hdf_data_x gt filldata_value_x and hdf_data_y gt filldata_value_y, count)
    endelse
    if (count eq 0) then begin
	result=dialog_message('Either X field or Y field data are fill data for whole array!',$
	    title='View HDF Warning!')
	plot_status = 0
	return
    endif
    hdf_data_x = hdf_data_x(subscript)
    hdf_data_y = hdf_data_y(subscript)
endif else if x_index ne -1 and y_index eq -1 then begin
    if filldata_value_x gt 0 then begin
	subscript = where(hdf_data_x lt filldata_value_x, count)
    endif else begin
	subscript = where(hdf_data_x gt filldata_value_x, count)
    endelse
    if (count eq 0) then begin
	result=dialog_message('The whole Y1 data array are fill data!',$
	    title='View HDF Warning!')
	plot_status = 0
	return
    endif
    hdf_data_x = hdf_data_x(subscript)
endif else if x_index eq -1 and y_index ne -1 then begin
    if filldata_value_y gt 0 then begin
	subscript = where(hdf_data_y lt filldata_value_y, count)
    endif else begin
	subscript = where(hdf_data_y gt filldata_value_y, count)
    endelse
    if (count eq 0) then begin
	result=dialog_message('The whole Y2 data array are fill data!',$
	    title='View HDF Warning!')
	plot_status = 0
	return
    endif
    hdf_data_y = hdf_data_y(subscript)
endif

if info.y1y2.tri_flag eq 1 and hdf_data_y(0) eq 0 then $
	hdf_data_x = hdf_data_x/!RADEG

hdf_data_z = make_array(num_x, /DOUBLE, VALUE=filldata)
;print,'info.y1y2.operator = ', info.y1y2.operator
case info.y1y2.operator of
	;' + ': hdf_data_z(subscript) = hdf_data_x(subscript) + hdf_data_y(subscript)
	;' - ': hdf_data_z(subscript) = hdf_data_x(subscript) - hdf_data_y(subscript)
	;' * ': hdf_data_z(subscript) = hdf_data_x(subscript) * hdf_data_y(subscript)
	;' / ': hdf_data_z(subscript) = hdf_data_x(subscript) / hdf_data_y(subscript)
	;' ** ': hdf_data_z(subscript) = hdf_data_x(subscript) ^ hdf_data_y(subscript)
	' + ': hdf_data_z(subscript) = hdf_data_x + hdf_data_y
	' - ': hdf_data_z(subscript) = hdf_data_x - hdf_data_y
	' * ': hdf_data_z(subscript) = hdf_data_x * hdf_data_y
	' / ': hdf_data_z(subscript) = hdf_data_x / hdf_data_y
	' ** ': hdf_data_z(subscript) = hdf_data_x ^ hdf_data_y
	' cos ': hdf_data_z(subscript) = cos(hdf_data_x)
	' sin ': hdf_data_z(subscript) = sin(hdf_data_x)
	' tan ': hdf_data_z(subscript) = tan(hdf_data_x)
	' acos ': hdf_data_z(subscript) = acos(hdf_data_x)
	' asin ': hdf_data_z(subscript) = asin(hdf_data_x)
	' atan ': hdf_data_z(subscript) = atan(hdf_data_x)
endcase

if info.y1y2.tri_flag eq 2 and hdf_data_y(0) eq 0 then $
	hdf_data_z(subscript) = hdf_data_z(subscript) * !RADEG

if filldata gt 0 then begin
    subscript = where(hdf_data_z ge filldata, count)
endif else begin
    subscript = where(hdf_data_z le filldata, count)
endelse
if (count eq num_x) then begin
	result=dialog_message('All the computed result are fill data!',$
	    title='View HDF Warning!')
	plot_status = 0
	return
endif
if count ne 0 then hdf_data_z(subscript) = filldata

hdf_data_z_temp = hdf_data_z
if filldata gt 0 then begin
    subscript = where(hdf_data_z lt filldata, count)
endif else begin
    subscript = where(hdf_data_z gt filldata, count)
endelse
if count ne 0 then begin
	hdf_data_z_temp = hdf_data_z_temp(subscript)
	z_max = max(hdf_data_z_temp, min=z_min)
endif else begin
	result=dialog_message('All the result are fill data!',$
	    title='View HDF Warning!')
	plot_status = 0
	return
endelse

info.slide.x_end = num_x - 1
info.slide.x_start = 0
info.slide.y_end = z_max
info.slide.y_start = z_min

xyname = ' '
;if x_index eq -1 then begin
;	xname = strcompress(string(info.y1y2.cons_value1),/REMOVE_ALL)
;endif else xname = info.field_name.x
;
;if y_index eq -1 then begin
;	yname = strcompress(string(info.y1y2.cons_value2),/REMOVE_ALL)
;endif else yname = info.field_name.y
;
;if info.y1y2.tri_flag eq 0 then begin
;    xyname = xname + info.y1y2.operator + yname
;endif else begin
;    case info.y1y2.operator of
;	' cos ': xyname = 'cos('+xname+')'
;	' sin ': xyname = 'sin('+xname+')'
;	' tan ': xyname = 'tan('+xname+')'
;	' acos ': xyname = 'arccos('+xname+')'
;	' asin ': xyname = 'arcsin('+xname+')'
;	' atan ': xyname = 'arctan('+xname+')'
;	else: xyname = xname
;    endcase
;endelse
;if (print_flag eq 0) then plot_dialogue , xyname, info

filename = info.subset.data(this_subset).src_filename

if x_index ne -1 then begin
	dot=strpos(info.field_name.x,'[')
	if dot ne -1 then xtitle=strmid(info.field_name.x,0,dot) $
		else xtitle = info.field_name.x
endif else xtitle = strcompress(string(info.y1y2.cons_value1),/REMOVE_ALL)

if y_index ne -1 then begin
	dot=strpos(info.field_name.y,'[')
	if dot ne -1 then ytitle=strmid(info.field_name.y,0,dot) $
		else ytitle = info.field_name.y
endif else ytitle = strcompress(string(info.y1y2.cons_value2),/REMOVE_ALL)

xyname = ' '
if info.y1y2.tri_flag eq 0 then begin
    xyname = xtitle + info.y1y2.operator + ytitle
endif else begin
    case info.y1y2.operator of
	' cos ': xyname = 'cos('+xtitle+')'
	' sin ': xyname = 'sin('+xtitle+')'
	' tan ': xyname = 'tan('+xtitle+')'
	' acos ': xyname = 'arccos('+xtitle+')'
	' asin ': xyname = 'arcsin('+xtitle+')'
	' atan ': xyname = 'arctan('+xtitle+')'
	else: xyname = xtitle
    endcase
endelse

if (print_flag eq 0) then begin
	;temp_name = xtitle + info.y1y2.operator + ytitle
	temp_name = xyname
	get_variable_name, temp_name, info
	widget_control, get_uvalue=info, info.base
	if info.variablename eq 'None' then begin
	    plot_status = 0
	    return
	endif
	the_rank = info.subset.data(this_subset).src_rank
	if info.subset.data(this_subset).src_type_flag eq 0 then begin
	   case size_hdf_data(0) of
		2: hdf_data = reform(hdf_data_z, size_hdf_data(1), size_hdf_data(2))
		3: hdf_data = reform(hdf_data_z, size_hdf_data(1), size_hdf_data(2), $
						 size_hdf_data(3))
		else: hdf_data = hdf_data_z
	   endcase
	endif else begin
  		the_order = info.subset.data(this_subset).src_order(0)
		blank = array_type(6, the_order)
		single_record=create_struct( 'components' + '0', blank) 
		hdf_data=replicate(single_record, size_hdf_data(1))
		jj=0L
		for i=0L, size_hdf_data(1)-1 do begin
			for j=0L, the_order-1 do begin
				hdf_data(i).components0(j) = hdf_data_z(jj)
				jj = jj + 1
			endfor
		endfor
	endelse
	set_statistics_subset, info.variablename, this_subset, the_rank, info, hdf_data

	if info.y1y2.out_flag eq 1 then begin
	    the_message = [ 'Do you want to plot the result?']
	    result=dialog_message(the_message, /Question, title='View HDF Question!')

	    if result eq 'No' then begin
		plot_status = 0
		return
	    endif
	endif else begin
	    plot_status = 0
	    return
	endelse

	base=widget_base( GROUP_LEADER=info.base, /MODAL, COLUMN=1, MAP=1, $
		TITLE='Select a Graph Style', XSIZE=240, uvalue=info)

	group1=widget_base(base, column=1, map=1, xoffset=80)

	desc= [ 'Sample' ,	$
		'Time'	]

	info.multiple.xy_diff = 'Sample'
	info = initial_info(info)
	widget_control, set_uvalue=info, base
	widget_control, set_uvalue=info, info.base

	the_style = CW_BGROUP(group1, desc, /return_name, $
		set_value=0, FONT=info.font, $
		event_func='diff_graph', /exclusive)

	group2=widget_base(base, row=1,map=1, space=40, /align_center)

	button1=widget_button(group2, FONT=info.font, EVENT_PRO='doneCB', VALUE="Done",$
		/ALIGN_CENTER)

	button2=widget_button(group2, FONT=info.font, EVENT_PRO='canceloptionCB', $
		VALUE="Cancel", /ALIGN_CENTER)

	;button1=widget_button(base, FONT=info.font, $
	;	EVENT_PRO='doneCB', VALUE="Done", $
	;	/ALIGN_CENTER)

	widget_control, /realize, base 
	widget_control, DEFAULT_BUTTON=button1, CANCEL_BUTTON=button2, base
	xmanager, 'main_widget', base

endif

widget_control, /hourglass
widget_control, get_uvalue=info, info.base
if info.canceloption eq 'Yes' then begin
	info.canceloption = 'No'
	widget_control, set_uvalue=info, info.base
	plot_status = 0
	return
endif 

set_axis_ranges, info, YRange, Ystyle, XRange, Xstyle, ZRange, Zstyle

data_range = ''
data_range = get_data_range(this_subset,info)
if !D.Name eq 'PS' or !D.Name eq 'PRINTER' or !D.Name eq 'WIN' or info.char.font eq 0 then begin
	;the_title=xtitle + info.y1y2.operator + ytitle + '!C Data Range: ' + data_range
	the_title=xyname + '!C Data Range: ' + data_range
endif else begin
	;the_title=xtitle + info.y1y2.operator + ytitle + '!C!C Data Range: ' + data_range
	the_title=xyname + '!C!C Data Range: ' + data_range
endelse

if info.subset.data(this_subset).src_crit_flag eq 1 then begin
	crit_string = ''
	crit_string = get_crit_string(this_subset, info)
	if !D.Name eq 'PS' and info.eps_out.type eq 1 then $
		!P.Position = [0.235, 0.15, 0.99, 0.92] $
		else !P.Position = [0.060, 0.120, 0.98, 0.93]
	temp_name = str_sep(crit_string, '!C')
	num_temp = n_elements(temp_name)
	!P.Position(1) = !P.Position(1) + (num_temp-1)*0.025
endif else begin
	if !D.Name eq 'PS' and info.eps_out.type eq 1 then $
		!P.Position = [0.235, 0.15, 0.99, 0.92] $
		else !P.Position = [0.060, 0.100, 0.98, 0.93]
endelse 

if info.style.symbolline eq 1 then plot_symbol = - info.style.symbol $
	else plot_symbol = info.style.symbol

if x_index ne -1 then begin
	temp_name = info.subset.data(x_index).src_unitname
	temp_name = temp_name(0)
	temp_length = strlen(temp_name)
	temp_name_x = ''
	if (temp_length gt 0) then begin
		dot=strpos(temp_name,'N/A')
		if( dot eq -1) then $
			temp_name_x = strmid(temp_name,2,temp_length-2)
	endif
endif else temp_name_x = ''

if y_index ne -1 then begin
	temp_name = info.subset.data(y_index).src_unitname
	temp_name = temp_name(0)
	temp_length = strlen(temp_name)
	temp_name_y = ''
	if (temp_length gt 0) then begin
		dot=strpos(temp_name,'N/A')
		if( dot eq -1) then $
			temp_name_y = strmid(temp_name,2,temp_length-2)
	endif
endif else temp_name_y = ''

temp_length = strlen(temp_name_x)
if temp_length gt 0 then begin
	temp_length = strlen(temp_name_y)
	if temp_length gt 0 then begin
		if temp_name_x eq temp_name_y then $
			ytitle = temp_name_x $
		else ytitle = temp_name_x + ' - ' + temp_name_y
	endif else ytitle = temp_name_x
endif else begin
	temp_length = strlen(temp_name_y)
        if temp_length gt 0 then $
		ytitle = temp_name_y $
	else ytitle = ''
endelse

get_ticklen, info.style.grid, xticklen, yticklen 

if info.axis_state eq 2 or info.axis_state eq 4 then min_value = YRange(0) $
    else min_value = z_min

if info.multiple.xy_diff eq 'Time' then begin
	if info.subset.data(this_subset).src_type_flag eq 0 then begin
  		this_rank = info.subset.data(this_subset).src_rank
  		start_list = info.subset.data(this_subset).src_start(0:this_rank-1)
  		end_list = info.subset.data(this_subset).src_end(0:this_rank-1)
  		increment_list = info.subset.data(this_subset).src_increment(0:this_rank-1)

  		;array_size = long((end_list-start_list)/float(increment_list) + 0.9)
		array_size = long((end_list-start_list-1)/float(increment_list) + 1.0)

  		hdf_data_time = array_type(6, array_size)
  		if (hdf_data_time(0) eq -1) then begin
			result=dialog_message('Unable to allocate memory for Time!',$
				title='View HDF Warning!')
			plot_status = 0
			return
		endif
	endif else begin
		hdf_data_time = make_array(num_x, /DOUBLE)
	endelse

	get_seconds, info, this_subset, hdf_data_time
	subscript = where(hdf_data_time lt 86400.0, count)
	if(count ne 0) then begin
   		hdf_data_time = hdf_data_time(subscript)
		hdf_data_z = hdf_data_z(subscript)
	endif else begin
		result=dialog_message('All the Time field data are fill data!',$
			title='View HDF Warning!')
		plot_status = 0
		return
	endelse
	time_max = max(hdf_data_time, min=time_min)
	info.slide.x_end = time_max
	info.slide.x_start = time_min
	case info.time_type.new of
		0: begin
			hdf_data_time(*) = hdf_data_time(*)/3600.0
			info.slide.x_end = time_max/3600.0
			info.slide.x_start = time_min/3600.0
			xtitle = 'Time of day, hours'
		   end
		1: begin
			hdf_data_time(*) = hdf_data_time(*)/60.0
			info.slide.x_end = time_max/60.0
			info.slide.x_start = time_min/60.0
			xtitle = 'Time of day, minutes'
		   end
		else: xtitle = 'Time of day, seconds'
	endcase

	if(widget_info(info.widgets.startfield, /VALID_ID)) then begin
	  if info.time_type.old ne info.time_type.new then begin
	    widget_control, info.widgets.startfield, get_value=x_start
	    widget_control, info.widgets.rangefield, get_value=x_range
	    case info.time_type.old of
	       0: begin
		   x_start = x_start * 3600.0
		   x_range = x_range * 3600.0
		end
	       1: begin
		   x_start = x_start * 60.0
		   x_range = x_range * 60.0
		end
	       else:
	    endcase

	    case info.time_type.new of
	       0: begin
	  	   x_start = x_start / 3600.0
		   x_range = x_range / 3600.0
		   if x_range le 1 then x_range = 1
		end
	       1: begin
		   x_start = x_start / 60.0
		   x_range = x_range / 60.0
		   if x_range le 1 then x_range = 1
		end
	       else:
	    endcase
	    x_max = max(hdf_data_time, min=x_min)
	    x_int_max = long(x_max)
	    x_int_min = long(x_min)
	    if x_int_max eq x_int_min then x_max = x_min + x_range
	    info.range.x_start = x_start
	    info.range.x_end = x_start + x_range
	    info.save.x_start = x_min
	    info.save.x_end = x_max
	    widget_control, info.widgets.rangefield, set_value=x_range
	    widget_control, info.widgets.startslide, set_slider_min=x_min
	    widget_control, info.widgets.startslide, set_slider_max=x_max
	    widget_control, info.widgets.startslide, set_slider_min=x_min
	    widget_control, info.widgets.startslide, set_value=x_start
	    widget_control, info.widgets.startfield, set_value=x_start
	    info.time_type.old = info.time_type.new
	    set_axis_ranges, info, YRange, Ystyle, XRange, Xstyle, ZRange, Zstyle
	  endif
	endif else info.time_type.old = info.time_type.new

	if (print_flag eq 0) or (print_flag eq 3) then plot_dialogue , xyname, info

	if !D.Name ne 'PRINTER' then begin
	    if !D.Name ne 'WIN' and info.char.font ne 0 then begin
		xtitle = '!C' + xtitle + '!C'
	    endif else begin
		xtitle = xtitle + '!C'
	    endelse
	endif
	if !D.Name eq 'PS' then begin
		old_charsize = !X.CHARSIZE
		!X.CHARSIZE = 0.9
		!Y.CHARSIZE = 0.9	
	endif

	if info.style.xlog gt 0 then begin
		check_max = max(hdf_data_time, min=check_min)
		XRange = set_log_range(XRange, check_min, dcheck_max)
        endif

        if info.style.ylog gt 0 then begin
		YRange = set_log_range(YRange, z_min, z_max)
        endif

	plot,hdf_data_time, hdf_data_z, $
        	MAX_VALUE = max_value, MIN_VALUE = min_value, /YNOZERO, /NODATA, $
		FONT=info.char.font, $
		charsize=info.char.size, $
        	xtitle=xtitle, $
        	ytitle=ytitle, $
		title=the_title, $
        	xticklen=xticklen, yticklen=yticklen, $
		subtitle="File: " + filename + "  Date:" + systime(0), $
        	xrange=XRange, yrange=YRange, xstyle=Xstyle, ystyle=Ystyle, $
		xlog=info.style.xlog, ylog=info.style.ylog

	if info.axis_state gt 0 then begin
		fit_flag = 0
		fit_data_range, info.axis_state, fit_flag, 0, 1, xrange, yrange, 0, $
			0, hdf_data_time, hdf_data_z, 0, 0, 0
		if fit_flag eq 1 then return
        endif

	oplot, hdf_data_time, hdf_data_z,MAX_VALUE = max_value, MIN_VALUE = min_value, $
		psym = plot_symbol, linestyle=info.style.linetype, $
		symsize = info.style.symbolsize, thick = info.style.linethick, $
		color = info.style.colorindex

endif else begin

	if (print_flag eq 0) or (print_flag eq 3) then plot_dialogue , xyname, info

	if !D.Name eq 'PRINTER' or !D.Name eq 'WIN' or info.char.font eq 0 then xtitle='Sample' $
		else xtitle='!CSample!C'
	if !D.Name eq 'PS' or !D.Name eq 'PRINTER' then begin
		old_charsize = !X.CHARSIZE
		!X.CHARSIZE = 0.9
		!Y.CHARSIZE = 0.9	
	endif

	if info.style.xlog gt 0 then begin
		default_max = n_elements(hdf_data_Z)
		XRange = set_log_range(XRange, 1, default_max)
        endif

        if info.style.ylog gt 0 then begin
		YRange = set_log_range(YRange, z_min, z_max)
        endif

	plot,hdf_data_z, $
        	MAX_VALUE = max_value, MIN_VALUE = min_value, /YNOZERO, /NODATA, $
		FONT=info.char.font, $
		charsize=info.char.size, $
        	xtitle=xtitle, $
        	ytitle=ytitle, $
		title=the_title, $
        	xticklen=xticklen, yticklen=yticklen, $
		subtitle="File: " + filename + "  Date:" + systime(0), $
        	xrange=XRange, yrange=YRange, xstyle=Xstyle, ystyle=Ystyle, $
		xlog=info.style.xlog, ylog=info.style.ylog

	if info.axis_state ne 2 or info.axis_state ne 4 then $
	    max_y_range = max_value $
	else max_y_range = yrange(1)
	;oplot, hdf_data_z,MAX_VALUE = max_value, $
	oplot, hdf_data_z,MAX_VALUE = max_y_range, MIN_VALUE = min_value, $
		psym = plot_symbol, linestyle=info.style.linetype, $
		symsize = info.style.symbolsize, thick = info.style.linethick, $
		color = info.style.colorindex

endelse

if info.subset.data(this_subset).src_crit_flag eq 1 then begin
	if !D.Name eq 'PS' or !D.Name eq 'PRINTER' then begin
		charsize = 0.9*info.char.size
		y_location = 0.125
	endif else begin
		charsize = info.char.size
		y_location = 0.11
	endelse
	;xyouts, !P.Position(0), !P.Position(1)-y_location, crit_string, /NORMAL, $
	xyouts, 0.08, !P.Position(1)-y_location, crit_string, /NORMAL, $
		font=info.char.font, charsize=charsize
endif

if info.addtext.key eq 1 then write_add_text, info

if !D.Name eq 'PS' or !D.Name eq 'PRINTER' then begin
	!X.CHARSIZE = old_charsize
	!Y.CHARSIZE = old_charsize
endif

!P.Position = [0.0, 0.0, 0.0, 0.0]

widget_control, set_uvalue=info, info.widgets.base
widget_control, set_uvalue=info, info.base

end

;--------------------------------------------------------------------------------
pro do_y1_compute, print_flag, info, plot_status

pro_name = 'do_y1_compute'
@getinfo

if info.subset.count lt 1 then begin
	the_message = ['You need at least one subset of data', $
	    'to do Y1 Compute!']
	result=dialog_message(the_message, title='View HDF Warning!')
	plot_status = 0
	return
endif

if print_flag eq 0 then begin
  info.graph_style = 'Y1 Compute'
  plot_setup, info, 'Y1 Compute', 1, 0, 0
  widget_control, get_uvalue=info, info.base
  if info.canceloption eq 'Yes' then begin
	info.canceloption = 'No'
	widget_control, set_uvalue=info, info.base
	plot_status = 0
	return
  endif 

endif

widget_control, /hourglass

widget_control, get_uvalue=info, info.base
if info.field_name.x ne 'Constant' then begin
        x_index=name_to_index(info.field_name.x, info.name_list_subset)
endif else x_index = -1
x_index = x_index(0)

if x_index eq -1 then begin
	the_message='Constant operand is not allowed for this operation!'
	result=dialog_message(the_message, title='View HDF Warning!')
	plot_status = 0
	return
endif
	
this_subset = x_index
info.subset.selected = this_subset

if info.subset.data(x_index).src_type_flag eq 0 then begin
	hdf_data_x = *info.subset.data(x_index).src_data
	size_hdf_data = size(hdf_data_x)
	hdf_data_x = reform(hdf_data_x, n_elements(hdf_data_x))
endif else begin
	hdf_x_temp = *info.subset.data(x_index).src_data
	size_hdf_data =  size(hdf_x_temp)
	hdf_data_x = reform(hdf_x_temp.components0, n_elements(hdf_x_temp.components0))
endelse
num_x = n_elements(hdf_data_x)

this_type = info.subset.data(x_index).src_types
this_type = this_type(0)
filldata_value_x = get_filldata_value(this_type, info.filldata)
if filldata_value_x gt info.filldata then filldata_value_x = info.filldata
max_value = get_max_value(this_type, info.filldata)
if info.filldata gt 0 then begin
    if max_value gt info.filldata then max_value = info.filldata
    if info.filldata lt 3.0E+37 then filldata = info.filldata * 10 $
	else filldata = 3.0E+38
endif else filldata = info.filldata

if info.y1y2.operator eq ' alog ' or info.y1y2.operator eq ' alog10 ' then begin
	neg_subs = where(hdf_data_x le 0.0, count)
	if count gt 0 then begin
		hdf_data_x(neg_subs) = filldata_value_x
	endif
endif

if filldata_value_x gt 0 then begin
    subscript = where(hdf_data_x lt filldata_value_x, count)
endif else begin
    subscript = where(hdf_data_x gt filldata_value_x, count)
endelse
if (count eq 0) then begin
	result=dialog_message('The whole data array are fill data!',$
		title='View HDF Warning!')
	plot_status = 0
	return
endif
hdf_data_x = hdf_data_x(subscript)

hdf_data_z = make_array(num_x, /DOUBLE, VALUE=filldata)
;print,'info.y1y2.operator = ', info.y1y2.operator
case info.y1y2.operator of
	' alog ': hdf_data_z(subscript) = alog(hdf_data_x)
	' alog10 ': hdf_data_z(subscript) = alog10(hdf_data_x)
	' exp ': hdf_data_z(subscript) = exp(hdf_data_x)
	' abs ': hdf_data_z(subscript) = abs(hdf_data_x)
endcase

if filldata gt 0 then begin
    subscript = where(hdf_data_z ge filldata, count)
endif else begin
    subscript = where(hdf_data_z le filldata, count)
endelse
if (count eq num_x) then begin
	result=dialog_message('All the computed result are fill data!',$
	    title='View HDF Warning!')
	plot_status = 0
	return
endif
if count ne 0 then hdf_data_z(subscript) = filldata

hdf_data_z_temp = hdf_data_z
if filldata gt 0 then begin
    subscript = where(hdf_data_z lt filldata, count)
endif else begin
    subscript = where(hdf_data_z gt filldata, count)
endelse
if count ne 0 then begin
	hdf_data_z_temp = hdf_data_z_temp(subscript)
	z_max = max(hdf_data_z_temp, min=z_min)
endif else begin
	result=dialog_message('All the result are fill data!',$
	    title='View HDF Warning!')
	plot_status = 0
	return
endelse

info.slide.x_end = num_x - 1
info.slide.x_start = 0
info.slide.y_end = z_max
info.slide.y_start = z_min

filename = info.subset.data(this_subset).src_filename

dot=strpos(info.field_name.x,'[')
if dot ne -1 then xtitle=strmid(info.field_name.x,0,dot) $
	else xtitle = info.field_name.x

xyname = ' '
case info.y1y2.operator of
' alog ': xyname = 'log('+xtitle+')'
' alog10 ': xyname = 'log10('+xtitle+')'
' exp ': xyname = 'exp('+xtitle+')'
' abs ': xyname = 'abs('+xtitle+')'
else: xyname = xtitle
endcase

if (print_flag eq 0) then begin
	temp_name = xyname
	get_variable_name, temp_name, info
	widget_control, get_uvalue=info, info.base
	if info.variablename eq 'None' then begin
	    plot_status = 0
	    return
	endif
	the_rank = info.subset.data(this_subset).src_rank
	if info.subset.data(this_subset).src_type_flag eq 0 then begin
	   case size_hdf_data(0) of
		2: hdf_data = reform(hdf_data_z, size_hdf_data(1), size_hdf_data(2))
		3: hdf_data = reform(hdf_data_z, size_hdf_data(1), size_hdf_data(2), $
						 size_hdf_data(3))
		else: hdf_data = hdf_data_z
	   endcase
	endif else begin
  		the_order = info.subset.data(this_subset).src_order(0)
		blank = array_type(6, the_order)
		single_record=create_struct( 'components' + '0', blank) 
		hdf_data=replicate(single_record, size_hdf_data(1))
		jj=0L
		for i=0L, size_hdf_data(1)-1 do begin
			for j=0L, the_order-1 do begin
				hdf_data(i).components0(j) = hdf_data_z(jj)
				jj = jj + 1
			endfor
		endfor
	endelse
	set_statistics_subset, info.variablename, this_subset, the_rank, info, hdf_data

	if info.y1y2.out_flag eq 1 then begin
	    the_message = [ 'Do you want to plot the result?']
	    result=dialog_message(the_message, /Question, title='View HDF Question!')

	    if result eq 'No' then begin
		plot_status = 0
		return
	    endif
	endif else begin
	    plot_status = 0
	    return
	endelse

	base=widget_base( GROUP_LEADER=info.base, /MODAL, COLUMN=1, MAP=1, $
		TITLE='Select a Graph Style', XSIZE=240, uvalue=info)

	group1=widget_base(base, column=1, map=1, xoffset=80)

	desc= [ 'Sample' ,	$
		'Time'	]

	info.multiple.xy_diff = 'Sample'
	info = initial_info(info)
	widget_control, set_uvalue=info, base
	widget_control, set_uvalue=info, info.base

	the_style = CW_BGROUP(group1, desc, /return_name, $
		set_value=0, FONT=info.font, $
		event_func='diff_graph', /exclusive)

	group2=widget_base(base, row=1,map=1, space=40, /align_center)

	button1=widget_button(group2, FONT=info.font, EVENT_PRO='doneCB', VALUE="Done",$
		/ALIGN_CENTER)

	button2=widget_button(group2, FONT=info.font, EVENT_PRO='canceloptionCB', $
		VALUE="Cancel", /ALIGN_CENTER)

	widget_control, /realize, base 
	widget_control, DEFAULT_BUTTON=button1, CANCEL_BUTTON=button2, base
	xmanager, 'main_widget', base

endif

widget_control, /hourglass
widget_control, get_uvalue=info, info.base
if info.canceloption eq 'Yes' then begin
	info.canceloption = 'No'
	widget_control, set_uvalue=info, info.base
	plot_status = 0
	return
endif 

set_axis_ranges, info, YRange, Ystyle, XRange, Xstyle, ZRange, Zstyle

data_range = ''
data_range = get_data_range(this_subset,info)
if !D.Name eq 'PS' or !D.Name eq 'WIN' or info.char.font eq 0 then begin
	the_title=xyname + '!C Data Range: ' + data_range
endif else begin
	the_title=xyname + '!C!C Data Range: ' + data_range
endelse

if info.subset.data(this_subset).src_crit_flag eq 1 then begin
	crit_string = ''
	crit_string = get_crit_string(this_subset, info)
	if !D.Name eq 'PS' and info.eps_out.type eq 1 then $
		!P.Position = [0.235, 0.15, 0.99, 0.92] $
		else !P.Position = [0.060, 0.120, 0.98, 0.93]
	temp_name = str_sep(crit_string, '!C')
	num_temp = n_elements(temp_name)
	!P.Position(1) = !P.Position(1) + (num_temp-1)*0.025
endif else begin
	if !D.Name eq 'PS' and info.eps_out.type eq 1 then $
		!P.Position = [0.235, 0.15, 0.99, 0.92] $
		else !P.Position = [0.060, 0.100, 0.98, 0.93]
endelse 

if info.style.symbolline eq 1 then plot_symbol = - info.style.symbol $
	else plot_symbol = info.style.symbol

temp_name = info.subset.data(x_index).src_unitname
temp_name = temp_name(0)
temp_length = strlen(temp_name)
if (temp_length gt 0) then begin
	dot=strpos(temp_name,'N/A')
	if( dot eq -1) then ytitle = strmid(temp_name,2,temp_length-2) $
		else ytitle = ''
endif else ytitle = ''

get_ticklen, info.style.grid, xticklen, yticklen 

if info.axis_state eq 2 or info.axis_state eq 4 then min_value = YRange(0) $
    else min_value = z_min

if info.multiple.xy_diff eq 'Time' then begin
	if info.subset.data(this_subset).src_type_flag eq 0 then begin
  		this_rank = info.subset.data(this_subset).src_rank
  		start_list = info.subset.data(this_subset).src_start(0:this_rank-1)
  		end_list = info.subset.data(this_subset).src_end(0:this_rank-1)
  		increment_list = info.subset.data(this_subset).src_increment(0:this_rank-1)

  		;array_size = long((end_list-start_list)/float(increment_list) + 0.9)
		array_size = long((end_list-start_list-1)/float(increment_list) + 1.0)

  		hdf_data_time = array_type(6, array_size)
  		if (hdf_data_time(0) eq -1) then begin
			result=dialog_message('Unable to allocate memory for Time!',$
				title='View HDF Warning!')
			plot_status = 0
			return
		endif
	endif else begin
		hdf_data_time = make_array(num_x, /DOUBLE)
	endelse

	get_seconds, info, this_subset, hdf_data_time
	subscript = where(hdf_data_time lt 86400.0, count)
	if(count ne 0) then begin
   		hdf_data_time = hdf_data_time(subscript)
		hdf_data_z = hdf_data_z(subscript)
	endif else begin
		result=dialog_message('All the Time field data are fill data!',$
			title='View HDF Warning!')
		plot_status = 0
		return
	endelse
	time_max = max(hdf_data_time, min=time_min)
	info.slide.x_end = time_max
	info.slide.x_start = time_min
	case info.time_type.new of
		0: begin
			hdf_data_time(*) = hdf_data_time(*)/3600.0
			info.slide.x_end = time_max/3600.0
			info.slide.x_start = time_min/3600.0
			xtitle = 'Time of day, hours'
		   end
		1: begin
			hdf_data_time(*) = hdf_data_time(*)/60.0
			info.slide.x_end = time_max/60.0
			info.slide.x_start = time_min/60.0
			xtitle = 'Time of day, minutes'
		   end
		else: xtitle = 'Time of day, seconds'
	endcase

	if(widget_info(info.widgets.startfield, /VALID_ID)) then begin
	  if info.time_type.old ne info.time_type.new then begin
	    widget_control, info.widgets.startfield, get_value=x_start
	    widget_control, info.widgets.rangefield, get_value=x_range
	    case info.time_type.old of
	       0: begin
		   x_start = x_start * 3600.0
		   x_range = x_range * 3600.0
		end
	       1: begin
		   x_start = x_start * 60.0
		   x_range = x_range * 60.0
		end
	       else:
	    endcase

	    case info.time_type.new of
	       0: begin
	  	   x_start = x_start / 3600.0
		   x_range = x_range / 3600.0
		   if x_range le 1 then x_range = 1
		end
	       1: begin
		   x_start = x_start / 60.0
		   x_range = x_range / 60.0
		   if x_range le 1 then x_range = 1
		end
	       else:
	    endcase
	    x_max = max(hdf_data_time, min=x_min)
	    x_int_max = long(x_max)
	    x_int_min = long(x_min)
	    if x_int_max eq x_int_min then x_max = x_min + x_range
	    info.range.x_start = x_start
	    info.range.x_end = x_start + x_range
	    info.save.x_start = x_min
	    info.save.x_end = x_max
	    widget_control, info.widgets.rangefield, set_value=x_range
	    widget_control, info.widgets.startslide, set_slider_min=x_min
	    widget_control, info.widgets.startslide, set_slider_max=x_max
	    widget_control, info.widgets.startslide, set_slider_min=x_min
	    widget_control, info.widgets.startslide, set_value=x_start
	    widget_control, info.widgets.startfield, set_value=x_start
	    info.time_type.old = info.time_type.new
	    set_axis_ranges, info, YRange, Ystyle, XRange, Xstyle, ZRange, Zstyle
	  endif
	endif else info.time_type.old = info.time_type.new

	if (print_flag eq 0) or (print_flag eq 3) then plot_dialogue , xyname, info

	if !D.Name ne 'WIN' and info.char.font ne 0 then begin
	    xtitle= '!C' + xtitle + '!C'
	endif else begin
	    xtitle = xtitle + '!C'
	endelse
	if !D.Name eq 'PS' then begin
		old_charsize = !X.CHARSIZE
		!X.CHARSIZE = 0.9
		!Y.CHARSIZE = 0.9	
	endif

	if info.style.xlog gt 0 then begin
		check_max = max(hdf_data_time, min=check_min)
		XRange = set_log_range(XRange, check_min, check_max)
        endif

        if info.style.ylog gt 0 then begin
		YRange = set_log_range(YRange, z_min, z_max)
        endif

	plot,hdf_data_time, hdf_data_z, $
        	MAX_VALUE = max_value, MIN_VALUE = min_value, /YNOZERO, /NODATA, $
		FONT=info.char.font, $
		charsize=info.char.size, $
        	xtitle=xtitle, $
        	ytitle=ytitle, $
		title=the_title, $
        	xticklen=xticklen, yticklen=yticklen, $
		subtitle="File: " + filename + "  Date:" + systime(0), $
        	xrange=XRange, yrange=YRange, xstyle=Xstyle, ystyle=Ystyle, $
		xlog=info.style.xlog, ylog=info.style.ylog

	if info.axis_state gt 0 then begin
		fit_flag = 0
		fit_data_range, info.axis_state, fit_flag, 0, 1, xrange, yrange, 0, $
			0, hdf_data_time, hdf_data_z, 0, 0, 0
		if fit_flag eq 1 then return
	endif

	oplot, hdf_data_time, hdf_data_z,MAX_VALUE = max_value, MIN_VALUE = min_value, $
		psym = plot_symbol, linestyle=info.style.linetype, $
		symsize = info.style.symbolsize, thick = info.style.linethick, $
		color = info.style.colorindex

endif else begin

	if (print_flag eq 0) or (print_flag eq 3) then plot_dialogue , xyname, info

	if !D.Name eq 'PRINTER' or !D.Name eq 'WIN' or info.char.font eq 0 then begin
	    xtitle='Sample'
	endif else xtitle='!CSample!C'
	if !D.Name eq 'PS' then begin
		old_charsize = !X.CHARSIZE
		!X.CHARSIZE = 0.9
		!Y.CHARSIZE = 0.9	
	endif

	if info.style.xlog gt 0 then begin
		default_max = n_elements(hdf_data_z)
		XRange = set_log_range(XRange, 1, default_max)
        endif

        if info.style.ylog gt 0 then begin
		YRange = set_log_range(YRange, z_min, z_max)
        endif

	plot,hdf_data_z, $
        	MAX_VALUE = max_value, MIN_VALUE = min_value, /YNOZERO, /NODATA, $
		FONT=info.char.font, $
		charsize=info.char.size, $
        	xtitle=xtitle, $
        	ytitle=ytitle, $
		title=the_title, $
        	xticklen=xticklen, yticklen=yticklen, $
		subtitle="File: " + filename + "  Date:" + systime(0), $
        	xrange=XRange, yrange=YRange, xstyle=Xstyle, ystyle=Ystyle, $
		xlog=info.style.xlog, ylog=info.style.ylog

	if info.axis_state ne 2 or info.axis_state ne 4 then $
		max_y_range = max_value $
	else max_y_range = yrange(1)
	oplot, hdf_data_z,MAX_VALUE = max_value, MIN_VALUE = min_value, $
		psym = plot_symbol, linestyle=info.style.linetype, $
		symsize = info.style.symbolsize, thick = info.style.linethick, $
		color = info.style.colorindex

endelse

if info.subset.data(this_subset).src_crit_flag eq 1 then begin
	if !D.Name eq 'PS' then begin
		charsize = 0.9*info.char.size
		y_location = 0.125
	endif else begin
		charsize = info.char.size
		y_location = 0.11
	endelse
	;xyouts, !P.Position(0), !P.Position(1)-y_location, crit_string, /NORMAL, $
	xyouts, 0.08, !P.Position(1)-y_location, crit_string, /NORMAL, $
		font=info.char.font, charsize=charsize
endif

if info.addtext.key eq 1 then write_add_text, info

if !D.Name eq 'PS' then begin
	!X.CHARSIZE = old_charsize
	!Y.CHARSIZE = old_charsize
endif

!P.Position = [0.0, 0.0, 0.0, 0.0]

widget_control, set_uvalue=info, info.widgets.base
widget_control, set_uvalue=info, info.base

end

;--------------------------------------------------------------------------------
pro do_xy_plot, print_flag, info, plot_status

pro_name = 'do_xy_plot'
@getinfo

if info.subset.count lt 2 then begin
	result=dialog_message('You need at least two subsets of data!',$
	    title='View HDF Warning!')
	plot_status = 0
	return
endif

if print_flag eq 0 and info.multiple.key ne 2 then begin
  info.graph_style = 'XY Plot'
  plot_setup, info, 'XY Plot', 1, 1, 0
  widget_control, get_uvalue=info, info.base
  if info.canceloption eq 'Yes' then begin
	info.canceloption = 'No'
	widget_control, set_uvalue=info, info.base
	plot_status = 0
	return
  endif 
endif

widget_control, /hourglass

widget_control, get_uvalue=info, info.base
get_data, y_index, x_index, z_index, info

this_subset = y_index(0)
info.subset.selected = this_subset

set_axis_ranges, info, YRange, Ystyle, XRange, Xstyle, ZRange, Zstyle

if info.subset.data(x_index).src_type_flag eq 0 then begin
  hdf_data_x = *info.subset.data(x_index).src_data
endif else begin
  hdf_x_temp = *info.subset.data(x_index).src_data
  hdf_data_x = reform(hdf_x_temp.components0, n_elements(hdf_x_temp.components0))
endelse

if info.subset.data(y_index).src_type_flag eq 0 then begin
  hdf_data_y = *info.subset.data(y_index).src_data
endif else begin
  hdf_y_temp = *info.subset.data(y_index).src_data
  hdf_data_y = reform(hdf_y_temp.components0, n_elements(hdf_y_temp.components0))
endelse

size_hdf_x = size(hdf_data_x)
size_hdf_y = size(hdf_data_y)

n_size_hdf_x = n_elements(size_hdf_x)
n_size_hdf_y = n_elements(size_hdf_y)

if(size_hdf_x(n_size_hdf_x-1) ne size_hdf_y(n_size_hdf_y-1)) then begin
	result=dialog_message('Number of data points for two subsets are not equal!',$
	    title='View HDF Warning!')
	plot_status = 0
	return
endif

this_type = info.subset.data(x_index).src_types
this_type = this_type(0)
filldata_value_x = get_filldata_value(this_type, info.filldata)
if filldata_value_x gt info.filldata then filldata_value_x = info.filldata
max_value_x = get_max_value(this_type, info.filldata)
if info.filldata gt 0 then begin
    if max_value_x gt info.filldata then max_value_x = info.filldata
endif

if filldata_value_x gt 0 then begin
    subscript = where(hdf_data_x lt filldata_value_x, count)
endif else begin
    subscript = where(hdf_data_x gt filldata_value_x, count)
endelse
if(count ne 0) then begin
   hdf_data_x = hdf_data_x(subscript)
   hdf_data_y = hdf_data_y(subscript)
endif else begin
	result=dialog_message('All the X field data are fill data!',$
	    title='View HDF Warning!')
	plot_status = 0
	return
endelse

this_type = info.subset.data(y_index).src_types
this_type = this_type(0)
filldata_value_y = get_filldata_value(this_type, info.filldata)
if filldata_value_y gt info.filldata then filldata_value_y = info.filldata
max_value_y = get_max_value(this_type, info.filldata)
if info.filldata gt 0 then begin
    if max_value_y gt info.filldata then max_value_y = info.filldata
endif

if filldata_value_y gt 0 then begin
    subscript = where(hdf_data_y lt filldata_value_y, count)
endif else begin
    subscript = where(hdf_data_y gt filldata_value_y, count)
endelse
if(count ne 0) then begin
   hdf_data_x = hdf_data_x(subscript)
   hdf_data_y = hdf_data_y(subscript)
endif else begin
	result=dialog_message('All the Y field data are fill data!',$
	    title='View HDF Warning!')
	plot_status = 0
	return
endelse

if max_value_y gt max_value_x then max_value = max_value_y $
	else max_value = max_value_x

x_max = max(hdf_data_x, min=x_min)
y_max = max(hdf_data_y, min=y_min)
info.slide.x_end = x_max
info.slide.x_start = x_min
info.slide.y_end = y_max
info.slide.y_start = y_min

min_value = y_min
if info.axis_state eq 2 or info.axis_state eq 4 then begin
    if YRange(0) le YRange(1) then min_value = YRange(0)
endif

dot=strpos(info.field_name.x,'[')
if dot ne -1 then xtitle=strmid(info.field_name.x,0,dot) $
	else xtitle = info.field_name.x
if info.multiple.key eq 2 then legend_title = xtitle

if info.style.symbolline eq 1 then plot_symbol = - info.style.symbol $
    else plot_symbol = info.style.symbol

if info.multiple.flag ne 1 then begin
    dot=strpos(info.field_name.y,'[')
    if dot ne -1 then ytitle=strmid(info.field_name.y,0,dot) $
	else ytitle = info.field_name.y

    xyname = ' '
    if info.multiple.key eq 2 then $
	xyname = info.field_name.y + ' vs multiple x variables' $
	else xyname = info.field_name.x + ' : ' + info.field_name.y
    if (print_flag eq 0) or (print_flag eq 3) or (print_flag eq 4) then $
	plot_dialogue , xyname, info

    filename = info.subset.data(y_index).src_filename

    data_range = ''
    data_range = get_data_range(this_subset,info)
    xdata_range = ''
    xdata_range = get_data_range(x_index, info)
    if data_range ne xdata_range then $
	data_range = 'Y: '+data_range + ' X: '+xdata_range

    if info.multiple.key eq 2 then begin
	the_title = ytitle + ' vs. Multiple X Variables' 
	xtitle = ''
    endif else the_title = ytitle + ' vs. ' + xtitle

    if !D.Name eq 'PS' or !D.Name eq 'WIN' or info.char.font eq 0 then begin
	the_title=the_title + '!C Data Range: ' + data_range
    endif else begin
	the_title=the_title + '!C!C Data Range: ' + data_range
    endelse

    if info.subset.data(this_subset).src_crit_flag eq 1 then begin
	crit_string = ''
	crit_string = get_crit_string(this_subset, info)
	if !D.Name eq 'PS' and info.eps_out.type eq 1 then $
		!P.Position = [0.235, 0.15, 0.99, 0.92] $
		else !P.Position = [0.060, 0.120, 0.98, 0.93]
	temp_name = str_sep(crit_string, '!C')
	num_temp = n_elements(temp_name)
	!P.Position(1) = !P.Position(1) + (num_temp-1)*0.025
    endif else begin
	if !D.Name eq 'PS' and info.eps_out.type eq 1 then $
		!P.Position = [0.235, 0.15, 0.99, 0.92] $
		else !P.Position = [0.060, 0.100, 0.98, 0.93]
    endelse 

    if info.multiple.key ne 2 then begin
	temp_name = info.subset.data(x_index).src_unitname
	temp_name = temp_name(0)
	dot=strpos(temp_name,'N/A')
	if( dot eq -1) then xtitle = xtitle + temp_name
    endif

    temp_name = info.subset.data(y_index).src_unitname
    temp_name = temp_name(0)
    dot=strpos(temp_name,'N/A')
    if( dot eq -1) then ytitle = ytitle + temp_name

    get_ticklen, info.style.grid, xticklen, yticklen 

    if !D.Name ne 'WIN' and info.char.font ne 0 then begin
	xtitle= '!C' + xtitle + '!C'
    endif else begin
	xtitle = xtitle + '!C'
    endelse
    if !D.Name eq 'PS' then begin
	old_charsize = !X.CHARSIZE
	!X.CHARSIZE = 0.9
	!Y.CHARSIZE = 0.9	
    endif

    if info.style.xlog gt 0 then begin
	XRange = set_log_range(XRange, x_min, x_max)
    endif

    if info.style.ylog gt 0 then begin
	YRange = set_log_range(YRange, y_min, y_max)
    endif

    plot,hdf_data_x,hdf_data_y, $
        MAX_VALUE = max_value, MIN_VALUE = min_value, /YNOZERO, /NODATA, $
	FONT=info.char.font, $
	charsize=info.char.size, $
        xtitle=xtitle, $
        ytitle=ytitle, $
	title=the_title, $
        xticklen=xticklen, yticklen=yticklen, $
	subtitle="File: " + filename + "  Date:" + systime(0), $
        xrange=XRange, yrange=YRange, xstyle=Xstyle, ystyle=Ystyle, $
	xlog=info.style.xlog, ylog=info.style.ylog

    if info.subset.data(this_subset).src_crit_flag eq 1 then begin
	if !D.Name eq 'PS' then begin
		charsize = 0.9*info.char.size
		y_location = 0.125
	endif else begin
		charsize = info.char.size
		y_location = 0.11
	endelse
	;xyouts, !P.Position(0), !P.Position(1)-y_location, crit_string, /NORMAL, $
	xyouts, 0.08, !P.Position(1)-y_location, crit_string, /NORMAL, $
		font=info.char.font, charsize=charsize
    endif

    if info.addtext.key eq 1 then write_add_text, info

    if !D.Name eq 'PS' then begin
	!X.CHARSIZE = old_charsize
	!Y.CHARSIZE = old_charsize
    endif
endif
 
if info.axis_state gt 0 then begin
	fit_flag = 0
	fit_data_range, info.axis_state, fit_flag, 0, 1, xrange, yrange, 0, $
		0, hdf_data_x, hdf_data_y, 0, 0, 0
	if fit_flag eq 1 then return
endif

oplot, hdf_data_x,hdf_data_y, MAX_VALUE = max_value, MIN_VALUE = min_value, $
	psym = plot_symbol, linestyle=info.style.linetype, $
	symsize = info.style.symbolsize, thick = info.style.linethick, $
	color = info.style.colorindex

if info.multiple.key eq 2 then begin
	temp_name = info.subset.data(x_index).src_unitname
        temp_name = temp_name(0)
        dot=strpos(temp_name,'N/A')
        if( dot eq -1) then legend_title = legend_title + temp_name
	y_leg = !Y.WINDOW(1) - 0.03 - 0.025 * info.multiple.number
	y_leg_t = y_leg - 0.005
	x_leg_s = !X.WINDOW(0) + 0.03
	x_leg_e = x_leg_s + 0.05
	leg_start = convert_coord(x_leg_s, y_leg, /NORMAL, /TO_DATA)
	leg_end   = convert_coord(x_leg_e, y_leg, /NORMAL, /TO_DATA)
	oplot, [leg_start(0), leg_end(0)], [leg_start(1), leg_end(1)], $
		psym = plot_symbol, linestyle=info.style.linetype, $
		symsize = info.style.symbolsize, thick = info.style.linethick, $
		color = info.style.colorindex
	xyouts, x_leg_e+0.01, y_leg_t, legend_title, /NORMAL, font=info.char.font, $
		charsize=info.char.size
endif

info.view.p_old = !P
info.view.d_old = !D
info.view.x_old = !X
info.view.y_old = !Y

if info.subset.data(this_subset).src_crit_flag eq 1 then $
	!P.Position = [0.0, 0.0, 0.0, 0.0]

widget_control, set_uvalue=info, info.widgets.base
widget_control, set_uvalue=info, info.base

end

;------------------------------------------------------------------
pro draw_color_bar, top_color, y_min, y_max, y_position, x_location, charsize, $
	charfont, unitlabel, setformat, bformat, bar_offset=bar_offset, $
	deltx=deltx, delty=delty

pro_name = 'draw_color_bar'
@getinfo

if keyword_set(bar_offset) then yoffset = bar_offset else yoffset = 0.03
if keyword_set(deltx) then xoffset = deltx else xoffset = 0.011
if keyword_set(delty) then ydelta = delty else ydelta = 0.011

;  Make sure the yoffset is larger than ydelta
; if(yoffset < ydelta + 0.018) then yoffset = ydelta + 0.019

;bar_size = CONVERT_COORD(0.011, 0.5, /NORMAL, /TO_DEVICE)
;bar_size = CONVERT_COORD(xoffset, 0.5, /NORMAL, /TO_DEVICE)

;color_size = fix(bar_size(0) + 0.9999)

color_interval = top_color/40.0

char_size = charsize

; set up a color bar
for j = 0 , 39 do begin
  color = fix(color_interval * (j + 1))
  ;TV, Replicate(color, color_size, color_size), 0.011*j+x_location, y_position, $
;	xsize=0.011, ysize=0.011, /normal
  ;x1 = 0.011*j + x_location
  ;x2 = x1 + 0.011
  x1 = xoffset*j + x_location
  x2 = x1 + xoffset
  y1 = y_position
  ; y2 = y1 + 0.011
  y2 = y1 + ydelta
  x = [x1, x1, x2, x2]
  y = [y1, y2, y2, y1]
  polyfill, x, y, color = color , /NOCLIP, /NORMAL
endfor

y_delta = (y_max - y_min)/10.0
; num_decimal = 6
; if abs(y_delta) lt 1.0 then begin
; 	y_del_temp = abs(y_delta)
; 	if y_del_temp mod 0.1 lt 0.00001 then begin
; 		if y_delta gt 0.0 then num_decimal = 3 $
; 			else num_decimal = 4
; 	endif else if y_del_temp mod 0.01 lt 0.00001 then begin
; 		if y_delta gt 0.0 then num_decimal = 4 $
; 			else num_decimal = 5
; 	endif else begin
; 		if y_delta gt 0.0 then num_decimal = 5 $
; 			else num_decimal = 6
; 	endelse
; endif
; print,'y_delta = ',y_delta,', num_decimal = ',num_decimal

;if abs(y_delta) ge 10000.0 then char_size = 0.8 * char_size

for j = 0 , 10 do begin
;  text_size = char_size
;  if abs(y_delta) lt 1.0 then begin
;	y_value = y_min + y_delta * j 
;	y_string = strmid(strtrim(string(y_value), 2), 0, num_decimal)
;  endif else begin
;	if abs(y_delta) lt 10000.0 then begin
;	    if j eq 0 then y_value = long(y_min + y_delta * j) $
;		else y_value = long(y_min + y_delta * j + 0.5)
;	    y_string = strtrim(string(y_value), 2)
;	endif else begin
;	    if j eq 0 then y_value = y_min + y_delta * j $
;		else y_value = y_min + y_delta * j + 0.5
;	    y_string = strtrim(string(y_value,format='(e10.1)'), 2)
;	endelse
;  endelse
;  print,'y_value = ',y_value,', y_string = ',y_string
;  if (abs(y_value) lt 0.001 and y_value ne 0.0) $
;    or abs(y_value) gt 10000.0 then begin
;	y_string = strtrim(string(y_value, format='(e10.1)'), 2)
;	text_size = 0.8*char_size
;  endif
  y_value = y_min + y_delta * j
  ; num_decimal = get_num_decimal(y_value)
  num_decimal = get_num_decimal(y_delta)
  label = get_label_string(y_value, setformat, bformat, num_decimal, y_delta)
  ; print,'initial y_value = ',y_value,', final y_value = ',label,', num_decimal = ',num_decimal
  y_string = strtrim(label, 2)
  ; print,'final y_string = ',y_string
  ;xyouts, 0.044*j+x_location, y_position-0.03, string(y_string), /NORMAL, $
  xyouts, 4*xoffset*j+x_location, y_position-yoffset, string(y_string), /NORMAL, $
    FONT=charfont, SIZE = text_size, ALIGNMENT=0.5
endfor

text_string = unitlabel
length = strlen(text_string)
if charfont eq -1 then begin
    max_char = 140
    com_char = 125
endif else begin
    max_char = 125
    com_char = 110
endelse
if length gt max_char then begin
	loc_comma = strpos(text_string,',',com_char)
	loc_space = strpos(text_string,' ',com_char)
	if loc_comma lt max_char then begin
	loc_sep = loc_comma
	endif else if loc_space lt max_char then begin
		loc_sep = loc_space
	endif else if loc_comma eq -1 and loc_space ne -1 then begin
		loc_sep = loc_space
	endif else if loc_comma ne -1 and loc_space eq -1 then begin
		loc_sep = loc_comma
	endif else loc_sep = max_char
	string1 = strmid(text_string,0,loc_sep)
	length2 = length - loc_sep -1
	if length2 lt 0 then string2 = '' $
	    else string2 = strmid(text_string,loc_sep+1,length2)
	if !D.Name eq 'PS' or !D.Name eq 'WIN' or charfont eq 0 then begin
		text_string = string1+'!C'+string2
	endif else begin
		text_string = string1+'!C!C'+string2
	endelse
endif

;xyouts, x_location+0.22, y_position-0.06, string(unitlabel), /NORMAL, $
;xyouts, x_location+0.22, y_position-0.06, string(text_string), /NORMAL, $
xyouts, x_location+20*xoffset, y_position-2.0*yoffset, string(text_string), /NORMAL, $
  FONT=charfont, SIZE = charsize, ALIGNMENT=0.5

end

;------------------------------------------------------------------
pro draw_contour_bar, clevel, y_min, y_max, y_position, x_location, n_level, $
	charsize, charfont, unitlabel, vlevel, badcolor, setformat, bformat, $
	colborder, displaybad, bar_offset = bar_offset, deltx = deltx, $
	centre_label = centre_label

pro_name = 'draw_contour_bar'
@getinfo

if keyword_set(bar_offset) then yoffset = bar_offset else yoffset = 0.03
if keyword_set(deltx) then xoffset = deltx else xoffset = 0.011
if keyword_set(centre_label) then centrelabel = centre_label else centrelabel = 0

;bar_size = CONVERT_COORD(0.044, 0.5, /NORMAL, /TO_DEVICE)
if n_level le 15 then begin
;	bar_size = CONVERT_COORD(0.044, 0.5, /NORMAL, /TO_DEVICE)
;	x_size = 0.044
	xsize = 4*xoffset
	bar_size = CONVERT_COORD(xsize, 0.5, /NORMAL, /TO_DEVICE)
	x_size = xsize
	bar_incr = 1
endif else if n_level gt 15 and n_level lt 31 then begin
;	bar_size = CONVERT_COORD(0.022, 0.5, /NORMAL, /TO_DEVICE)
;	x_size = 0.022
	xsize = 2*xoffset
	bar_size = CONVERT_COORD(xsize, 0.5, /NORMAL, /TO_DEVICE)
	x_size = xsize
	bar_incr = 2
endif else begin
;	bar_size = CONVERT_COORD(0.011, 0.5, /NORMAL, /TO_DEVICE)
;	x_size = 0.011
	xsize = xoffset
	bar_size = CONVERT_COORD(xsize, 0.5, /NORMAL, /TO_DEVICE)
	x_size = xsize
	bar_incr = 4
endelse

char_size = charsize
color_size = fix(bar_size(0) + 0.9999)
case bar_incr of
	1: y_color_size = color_size/4.0
	2: y_color_size = color_size/2.0
	else: y_color_size = color_size
endcase

c_location = !P.Position(0) + (!P.Position(2) - !P.Position(0))/2.
x_location = c_location - (x_size * float(n_level))/2.0
if x_location lt 0.07 then x_location = 0.07

; set up a color bar
;color = !P.BACKGROUND
color = badcolor

;  Set the bad data color
bad_color_size = 4.0 * xoffset
if bad_color_size gt 0.044 then bad_color_size = 0.044
bad_color_start = 1.5 * bad_color_size
;x1 = x_location-0.066
;x2 = x_location-0.066+0.044
; x1 = x_location-6*xoffset
; x2 = x1+4*xoffset
x1 = x_location-bad_color_start
x2 = x1+bad_color_size
y1 = y_position
y2 = y_position + 0.011
x = [x1, x1, x2 , x2]
y = [y1, y2, y2, y1]
if displaybad eq 1 then begin
    polyfill, x, y, color = color , /NOCLIP, /NORMAL
    if colborder eq 1 then begin
	x = [x, x1]
	y = [y, y1]
	plots,x,y,color=!P.COLOR, /NOCLIP, /NORMAL
    endif
endif

;TV, Replicate(color, color_size, y_color_size), x_location-0.066, y_position, $
;	xsize=0.044, ysize=0.011, /normal

for j = 0 , n_level-1 do begin
  color=clevel(j)
  ;bararray = make_array(color_size, y_color_size, /BYTE, value=color)
  ;TV, bararray, x_size*j+x_location, y_position, xsize=x_size, ysize=0.011, /normal
  x1 = x_size*j + x_location
  x2 = x1 + x_size
  y1 = y_position
  y2 = y1 + 0.011
  x = [x1, x1, x2, x2]
  y = [y1, y2, y2, y1]
  polyfill, x, y, color = color , /NOCLIP, /NORMAL
  if colborder eq 1 then begin
    x = [x, x1]
    y = [y, y1]
    plots,x,y,color=!P.COLOR, /NOCLIP, /NORMAL
  endif
endfor

if displaybad eq 1 then begin
   ;xyouts, x_location-0.044, y_position-0.03, "No!CData", /NORMAL, $
   ; xyouts, x_location-4*xoffset, y_position-yoffset, "No!CData", /NORMAL, $
   xyouts, x_location-bad_color_size, y_position-yoffset, "No!CData", /NORMAL, $
	FONT=charfont, SIZE = charsize, ALIGNMENT=0.5
endif

num_level = n_elements(vlevel)
if num_level eq n_level+1 then set_scale = 1 else set_scale = 0

if set_scale eq 0 then begin
    y_delta = (y_max - y_min)/float(n_level)
endif else begin
    y_delta = vlevel(n_level-1) - vlevel(n_level-2)
endelse

num_decimal = 6
; if abs(y_delta) lt 1.0 then begin
; 	y_del_temp = abs(y_delta)
; 	if y_del_temp mod 0.1 lt 0.00001 then begin
; 		if y_delta gt 0.0 then num_decimal = 3 $
; 			else num_decimal = 4
; 	endif else if y_del_temp mod 0.01 lt 0.00001 then begin
; 		if y_delta gt 0.0 then num_decimal = 4 $
; 			else num_decimal = 5
; 	endif else begin
; 		if y_delta gt 0.0 then num_decimal = 5 $
; 			else num_decimal = 6
; 	endelse
; endif

; print,'y_delta = ',y_delta,', num_decimal = ',num_decimal

;if abs(y_delta) ge 10000.0 then char_size = 0.8 * char_size

if centrelabel eq 1 then nlevel = n_level - 1 else nlevel = n_level

;for j = 0 , n_level, bar_incr do begin
for j = 0 , nlevel, bar_incr do begin
    text_size = char_size
    if set_scale eq 0 then begin
	;if abs(y_delta) lt 1.0 then begin
	;    y_value = y_min + y_delta * j 
	;    y_string = strmid(strtrim(string(y_value), 2), 0, num_decimal)
	;endif else begin
	;    if abs(y_delta) lt 10000.0 then begin
	;	if j eq 0 then y_value = long(y_min + y_delta * j) $
	;	    else y_value = long(y_min + y_delta * j + 0.5)
	;	y_string = strtrim(string(y_value), 2)
	;    endif else begin
	;	if j eq 0 then y_value = y_min + y_delta * j $
	;	    else y_value = y_min + y_delta * j + 0.5
	;	y_string = strtrim(string(y_value, format='(e10.1)'), 2)
	;    endelse
	;endelse
	;if (abs(y_value) lt 0.001 and y_value ne 0.0) $
	;  or abs(y_value) gt 10000.0 then begin
	;    y_string = strtrim(string(y_value, format='(e10.1)'), 2)
	;    text_size = 0.8 * char_size
	;endif
	y_value = y_min + y_delta * j
	; num_decimal = get_num_decimal(y_value)
	num_decimal = get_num_decimal(y_delta)
	label = get_label_string(y_value, setformat, bformat, num_decimal, y_delta)
	; print,'initial y_value = ',y_value,', final y_value = ',label,', num_decimal = ',num_decimal
	y_string = strtrim(label, 2)
    endif else begin
	if j gt n_level-2 then y_delta = vlevel(n_level-1) - vlevel(n_level-2) $
	    else y_delta = vlevel(j+1) - vlevel(j)
	;if abs(y_delta) lt 1.0 then begin
	;    y_del_temp = abs(y_delta)
	;    if y_del_temp mod 0.1 lt 0.00001 then begin
	;	if y_delta gt 0.0 then num_decimal = 3 $
	;	    else num_decimal = 4
	;    endif else if y_del_temp mod 0.01 lt 0.00001 then begin
	;	if y_delta gt 0.0 then num_decimal = 4 $
	;	    else num_decimal = 5
	;    endif else begin
	;	if y_delta gt 0.0 then num_decimal = 5 $
	;	    else num_decimal = 6
	;    endelse
	;endif
	;print,'y_delta = ',y_delta,', num_decimal = ',num_decimal
	;if abs(y_delta) lt 1.0 then begin
	;    y_string = strmid(strtrim(string(vlevel(j)), 2), 0, num_decimal)
	;    print,'y_string = ',y_string,' for vlevel(j) = ',vlevel(j)
	;endif else begin
	;    if abs(y_delta) lt 10000.0 then begin
	;	y_string = strtrim(string(long(vlevel(j))), 2)
	;    endif else begin
	;	y_string = strtrim(string(vlevel(j), format='(e10.1)'), 2)
	;    endelse
	;endelse
	;if (abs(vlevel(j)) lt 0.001 and vlevel(j) ne 0.0) $
	;  or abs(vlevel(j)) gt 10000.0 then begin
	;    print,'y_delta = ',y_delta,', vlevel(j) = ',vlevel(j)
        ;    y_string = strtrim(string(vlevel(j), format='(e10.1)'), 2)
	;    text_size = 0.8 * char_size
	;    print,'y_string = ',y_string,' for vlevel(j) = ',vlevel(j)
	;endif
	; num_decimal = get_num_decimal(vlevel[j])
	num_decimal = get_num_decimal(y_delta)
	label = get_label_string(vlevel[j], setformat, bformat, num_decimal, y_delta)
	y_string = strtrim(label, 2)
	; print,'initial y_value = ',vlevel[j],', final y_value = ',label,', num_decimal = ',num_decimal
	if j eq 0 then begin
	    if vlevel(0) eq vlevel(1) then begin
		y_string = '<--'
		;text_size = char_size
	    endif
	endif
	if j eq n_level then begin
	    if vlevel(j) eq vlevel(j-1) then begin
		y_string = '-->'
		text_size = char_size
	    endif
	endif
    endelse

    ; print,'final y_string = ',y_string
    ;xyouts, x_size*j+x_location, y_position-0.03, string(y_string), /NORMAL, $
    if centrelabel eq 1 then begin
	xyouts, x_size*(j+0.5)+x_location, y_position-yoffset, string(y_string), /NORMAL, $
	    FONT=charfont, SIZE = text_size, ALIGNMENT=0.5
    endif else begin
	xyouts, x_size*j+x_location, y_position-yoffset, string(y_string), /NORMAL, $
	    FONT=charfont, SIZE = text_size, ALIGNMENT=0.5
    endelse
endfor

text_string = unitlabel
length = strlen(text_string)
if charfont eq -1 then begin
    max_char = 140
    com_char = 125
endif else begin
    max_char = 125
    com_char = 110
endelse
; if length gt 140 then begin
; 	loc_comma = strpos(text_string,',',125)
; 	loc_space = strpos(text_string,' ',125)
if length gt max_char then begin
	loc_comma = strpos(text_string,',',com_char)
	loc_space = strpos(text_string,' ',com_char)
	if loc_comma lt max_char then begin
	loc_sep = loc_comma
	endif else if loc_space lt max_char then begin
		loc_sep = loc_space
	endif else if loc_comma eq -1 and loc_space ne -1 then begin
		loc_sep = loc_space
	endif else if loc_comma ne -1 and loc_space eq -1 then begin
		loc_sep = loc_comma
	endif else loc_sep = max_char
	string1 = strmid(text_string,0,loc_sep)
	length2 = length - loc_sep -1
	if length2 lt 0 then string2 = '' $
	    else string2 = strmid(text_string,loc_sep+1,length2)
	if !D.Name eq 'PS' or !D.Name eq 'WIN' or charfont eq 0 then begin
		text_string = string1+'!C'+string2
	endif else begin
		text_string = string1+'!C!C'+string2
	endelse
endif
;xyouts, c_location, y_position-0.06, string(text_string), /NORMAL, $
;xyouts, c_location, y_position-0.06, string(unitlabel), /NORMAL, $
xyouts, c_location, y_position-2.0*yoffset, string(text_string), /NORMAL, $
  FONT=charfont, SIZE = charsize, ALIGNMENT=0.5

end

;--------------------------------------------------------------------------------
pro do_xyz_plot, print_flag, info, plot_status

pro_name = 'do_xyz_plot'
@getinfo

if info.subset.count lt 3 then begin
	result=dialog_message('You need at least three subsets of data!',$
	    title='View HDF Warning!')
	plot_status = 0
	return
endif

if print_flag eq 0 then begin
  info.graph_style = 'XYZ Plot'
  plot_setup, info, 'XYZ Plot', 1, 1, 1
  widget_control, get_uvalue=info, info.base
  if info.canceloption eq 'Yes' then begin
	info.canceloption = 'No'
	widget_control, set_uvalue=info, info.base
	plot_status = 0
	return
  endif 
  info.overlay.flag = 0
  info.overlay.offflag = 0
endif

;  If put a hourglass in WIN, it will not get the signal of stop or pause widget
if !D.Name ne 'WIN' then widget_control, /hourglass

widget_control, get_uvalue=info, info.base

get_data, y_index, x_index, z_index, info

this_subset = z_index(0)
info.subset.selected = this_subset

set_axis_ranges, info, YRange, Ystyle, XRange, Xstyle, ZRange, Zstyle

if info.subset.data(x_index).src_type_flag eq 0 then begin
   hdf_data_x = *info.subset.data(x_index).src_data
endif else begin
  hdf_x_temp = *info.subset.data(x_index).src_data
  hdf_data_x = reform(hdf_x_temp.components0, n_elements(hdf_x_temp.components0))
endelse

if info.subset.data(y_index).src_type_flag eq 0 then begin
  hdf_data_y = *info.subset.data(y_index).src_data
endif else begin
  hdf_y_temp = *info.subset.data(y_index).src_data
  hdf_data_y = reform(hdf_y_temp.components0, n_elements(hdf_y_temp.components0))
endelse

if info.subset.data(z_index).src_type_flag eq 0 then begin
  hdf_data_z = *info.subset.data(z_index).src_data
endif else begin
  hdf_z_temp = *info.subset.data(z_index).src_data
  hdf_data_z = reform(hdf_z_temp.components0, n_elements(hdf_z_temp.components0))
endelse

num_x = n_elements(hdf_data_x)
num_y = n_elements(hdf_data_y)
num_z = n_elements(hdf_data_z)

if(num_x eq num_y) and (num_x eq num_z) then begin

this_type = info.subset.data(x_index).src_types
this_type = this_type(0)
filldata_value_x = get_filldata_value(this_type, info.filldata)
if filldata_value_x gt info.filldata then filldata_value_x = info.filldata
max_value_x = get_max_value(this_type, info.filldata)
if info.filldata gt 0 then begin
    if max_value_x gt info.filldata then max_value_x = info.filldata
endif

if filldata_value_x gt 0 then begin
    subscript = where(hdf_data_x lt filldata_value_x, count)
endif else begin
    subscript = where(hdf_data_x gt filldata_value_x, count)
endelse
if(count ne 0) then begin
   hdf_data_x = hdf_data_x(subscript)
   hdf_data_y = hdf_data_y(subscript)
   hdf_data_z = hdf_data_z(subscript)
endif else begin
	result=dialog_message('All the X field data are fill data!',$
	    title='View HDF Warning!')
	plot_status = 0
	return
endelse

this_type = info.subset.data(y_index).src_types
this_type = this_type(0)
filldata_value_y = get_filldata_value(this_type, info.filldata)
if filldata_value_y gt info.filldata then filldata_value_y = info.filldata
max_value_y = get_max_value(this_type, info.filldata)
if info.filldata gt 0 then begin
    if max_value_y gt info.filldata then max_value_y = info.filldata
endif

if filldata_value_y gt 0 then begin
    subscript = where(hdf_data_y lt filldata_value_y, count)
endif else begin
    subscript = where(hdf_data_y gt filldata_value_y, count)
endelse
if(count ne 0) then begin
   hdf_data_x = hdf_data_x(subscript)
   hdf_data_y = hdf_data_y(subscript)
   hdf_data_z = hdf_data_z(subscript)
endif else begin
	result=dialog_message('All the Y field data are fill data!',$
	    title='View HDF Warning!')
	plot_status = 0
	return
endelse

this_type = info.subset.data(this_subset).src_types
this_type = this_type(0)
filldata_value_z = get_filldata_value(this_type, info.filldata)
if filldata_value_z gt info.filldata then filldata_value_z = info.filldata

if filldata_value_z gt 0 then begin
    subscript = where(hdf_data_z lt filldata_value_z, count)
endif else begin
    subscript = where(hdf_data_z gt filldata_value_z, count)
endelse
if(count ne 0) then begin
   hdf_data_x = hdf_data_x(subscript)
   hdf_data_y = hdf_data_y(subscript)
   hdf_data_z = hdf_data_z(subscript)
endif else begin
	result=dialog_message('All the Z field data are fill data!',$
	    title='View HDF Warning!')
	plot_status = 0
	return
endelse

if max_value_y gt max_value_x then max_value = max_value_y $
	else max_value = max_value_x

x_max = max(hdf_data_x, min=x_min)
y_max = max(hdf_data_y, min=y_min)
info.slide.x_end = x_max
info.slide.x_start = x_min
info.slide.y_end = y_max
info.slide.y_start = y_min

xyzname = ''
xyzname = info.field_name.x + ' : ' + info.field_name.y + ' : ' + $
          info.field_name.z
if (print_flag eq 0) or (print_flag eq 3) then plot_dialogue , xyzname, info

filename = info.subset.data(y_index).src_filename

dot=strpos(info.field_name.x,'[')
if dot ne -1 then xtitle=strmid(info.field_name.x,0,dot) $
	else xtitle = info.field_name.x
dot=strpos(info.field_name.y,'[')
if dot ne -1 then ytitle=strmid(info.field_name.y,0,dot) $
	else ytitle = info.field_name.y
dot=strpos(info.field_name.z,'[')
if dot ne -1 then ztitle=strmid(info.field_name.z,0,dot) $
	else ztitle = info.field_name.z

if (info.axis_state eq 3) or (info.axis_state eq 5) then begin
	z_max = info.range.z_end
	z_min = info.range.z_start
endif else begin
        z_max = max(hdf_data_z, min = z_min)
	z_max_temp = long(z_max + 0.99999)
	z_min_temp = long(z_min - 0.99999)
        z_max = float(z_max_temp)
	z_min = float(z_min_temp)
endelse

info.overlay.zmax = z_max
info.overlay.zmin = z_min

data_range = ''
data_range = get_data_range(this_subset,info)
if !D.Name eq 'PS' or !D.Name eq 'PRINTER' or !D.Name eq 'WIN' or info.char.font eq 0 then begin
	the_title=ytitle + ' vs. ' + xtitle + '!Ccolored by '+ ztitle
	the_title=the_title + ' with Data Range: ' + data_range
endif else begin
	the_title=ytitle + ' vs. ' + xtitle + '!C!Ccolored by '+ ztitle
	the_title=the_title + ' with Data Range: ' + data_range
endelse

top_color = !d.n_colors - 2
if top_color gt 254 then top_color = 254
if((!D.Name ne 'PS' and !D.Name ne 'PRINTER') and top_color gt info.top_color) then $
	top_color = info.top_color

if info.greenwich.with_level ge 1 then begin
	if info.greenwich.with_level eq 2 then begin
	    info.greenwich.in_level = 0
	    if z_max lt 1.0 then info.greenwich.with_level = 1 $
	    else begin
		if z_min lt 1.0 then z_min = 1.0
	    endelse
	endif
	n_level = info.greenwich.n_level
	if info.greenwich.in_level eq 1 then begin
	    temp_range = str_sep(info.greenwich.range, ';')
	    num_range = n_elements(temp_range)
	    if info.greenwich.ext_level eq 0 then begin
		n_level = num_range + 1
		vlevel = double(temp_range)
		vlevel = [vlevel(0), vlevel, vlevel(num_range-1)]
	    endif else begin
		n_level = num_range - 1
		vlevel = double(temp_range)
	    endelse
	    if z_min gt vlevel(0) then z_min = vlevel(0)
	    if z_max lt vlevel(n_level) then z_max = vlevel(n_level)
	    data_interval = vlevel(n_level-1)-vlevel(n_level-2)
	    tempa=findgen(n_level)
	endif else begin
	  tempa=findgen(n_level)
	  if info.greenwich.with_level eq 2 then begin
	    if ((info.axis_state eq 3) or (info.axis_state eq 5)) and $
	      info.greenwich.ext_level eq 0 then begin
		;data_interval = (alog10(z_max) - alog10(z_min))/float(n_level-1)
		;vlevel = [0, tempa+1]
		data_interval = (alog10(z_max) - alog10(z_min))/float(n_level-2)
		vlevel = [0, tempa]
		vlevel(n_level) = vlevel(n_level-1)
	    endif else begin
		data_interval = (alog10(z_max) - alog10(z_min))/float(n_level)
		vlevel = [0, tempa+1]
	    endelse
	    vlevel = alog10(z_min) + vlevel * data_interval
	    vlevel = 10 ^ vlevel
	  endif else begin
	    if ((info.axis_state eq 3) or (info.axis_state eq 5)) and $
	      info.greenwich.ext_level eq 0 then begin
		;data_interval = (z_max - z_min)/float(n_level-1)
		;vlevel = [0, tempa+1]
		data_interval = (z_max - z_min)/float(n_level-2)
		vlevel = [0, tempa]
                vlevel(n_level) = vlevel(n_level-1)
	    endif else begin
		data_interval = (z_max - z_min)/float(n_level)
		vlevel = [0, tempa+1]
	    endelse
	    vlevel = z_min + vlevel * data_interval
	  endelse
	endelse

	color_interval = top_color/float(n_level)
	;tempa=findgen(n_level)
	clevel = fix(color_interval * (tempa(*) + 1))

	;sub_max = where(hdf_data_z gt z_max , count_max)
	;sub_min = where(hdf_data_z lt z_min, count_min)
	;if count_min ne 0 then hdf_data_z(sub_min) = z_max + 10 * data_interval
	my_color = make_array(n_elements(hdf_data_z), /INT, VALUE=!P.BACKGROUND)
	if info.greenwich.in_level eq 0 then begin
	  ;if abs(data_interval) ge 1.0 then begin
	  ;  if info.greenwich.with_level eq 2 then begin
	;	my_color(*) = fix(fix((alog10(hdf_data_z(*)) - alog10(z_min))/data_interval + 1.0) * $
	;		color_interval)
	;    endif else begin
	;	my_color(*) = fix(fix((hdf_data_z(*) - z_min)/data_interval + 1.0) * $
	;		color_interval)
	;    endelse
	;  endif else begin
	;    if info.greenwich.with_level eq 2 then begin
	;	my_color(*) = fix(fix((alog10(hdf_data_z(*)) - alog10(z_min))/data_interval + 0.99999) * $
	;		color_interval)
	;    endif else begin
	;	my_color(*) = fix(fix((hdf_data_z(*) - z_min)/data_interval + 0.99999) * $
	;		color_interval)
	;    endelse
	;  endelse
	  for i = 0, n_level-2 do begin
	    sub_color = where(hdf_data_z ge vlevel(i) and hdf_data_z lt vlevel(i+1), count_color)
	    if count_color ne 0 then my_color(sub_color) = clevel(i)
	  endfor
	  if ((info.axis_state eq 3) or (info.axis_state eq 5)) and $
	    info.greenwich.ext_level eq 0 then begin
		sub_color = where(hdf_data_z gt vlevel(n_level-1), count_color)
		if count_color ne 0 then my_color(sub_color) = clevel(n_level-1)
		sub_color = where(hdf_data_z lt vlevel(1), count_color)
		if count_color ne 0 then my_color(sub_color) = clevel(0)
	  endif else begin
		sub_color = where(hdf_data_z ge vlevel(n_level-1) and hdf_data_z lt vlevel(n_level), count_color)
		if count_color ne 0 then my_color(sub_color) = clevel(n_level-1)
	  endelse
	endif else begin
	  if info.greenwich.ext_level eq 0 then begin
	    sub_color = where(hdf_data_z lt vlevel(1), count_color)
	    if count_color ne 0 then my_color(sub_color) = clevel(0)
	    sub_color = where(hdf_data_z gt vlevel(n_level-1), count_color)
            if count_color ne 0 then my_color(sub_color) = clevel(n_level-1)
	  endif else begin
	    sub_color = where(hdf_data_z lt vlevel(1) and hdf_data_z ge vlevel(0), count_color)
            if count_color ne 0 then my_color(sub_color) = clevel(0)
            sub_color = where(hdf_data_z gt vlevel(n_level-1) and hdf_data_z le vlevel(n_level), count_color)
            if count_color ne 0 then my_color(sub_color) = clevel(n_level-1)
	  endelse
	  for i = 1, n_level-2 do begin
	    sub_color = where(hdf_data_z ge vlevel(i) and hdf_data_z lt vlevel(i+1), count_color)
	    if count_color ne 0 then my_color(sub_color) = clevel(i)
	  endfor
	    ;sub_color = where(hdf_data_z gt vlevel(n_level-1), count_color)
	    ;if count_color ne 0 then my_color(sub_color) = clevel(n_level-1)
	endelse
	if ((info.axis_state ne 3) and (info.axis_state ne 5)) or $
	    info.greenwich.ext_level eq 1 then begin
	    sub_max = where(hdf_data_z gt z_max , count_max)
	    sub_min = where(hdf_data_z lt z_min, count_min)
	    if count_max ne 0 then begin
		my_color(sub_max) = !P.BACKGROUND
		hdf_data_z(sub_max) = filldata_value_z
	    endif
	    if count_min ne 0 then begin
		my_color(sub_min) = !P.BACKGROUND
		hdf_data_z(sub_min) = filldata_value_z
	    endif
	endif
endif else my_color=bytscl(hdf_data_z, max=z_max, min=z_min, top=top_color)

if info.color_table ne 0 and info.pick_color_table eq 0 then $
	check_bw = check_color_table(top_color) $
	else check_bw = 0
if check_bw eq 1 then begin
	color_table_file=info.home_path+"/"+"view_hdf_color.tbl"
	test_file = findfile(color_table_file, count=count)
	if count eq 0 then color_table_file = 'view_hdf_color.tbl'
	loadct, info.color_table, file=color_table_file
endif

temp_name = info.subset.data(x_index).src_unitname
temp_name = temp_name(0)
dot=strpos(temp_name,'N/A')
if( dot eq -1) then xtitle = xtitle + temp_name

temp_name = info.subset.data(y_index).src_unitname
temp_name = temp_name(0)
dot=strpos(temp_name,'N/A')
if( dot eq -1) then ytitle = ytitle + temp_name

if info.subset.data(this_subset).src_crit_flag eq 1 then begin
	crit_string = ''
	crit_string = get_crit_string(this_subset, info)
	if !D.Name eq 'PS' and info.eps_out.type eq 1 then $
		!P.Position = [0.235, 0.15, 0.99, 0.92] $
		else !P.Position = [0.060, 0.120, 0.98, 0.92]
	temp_name = str_sep(crit_string, '!C')
	num_temp = n_elements(temp_name)
	!P.Position(1) = !P.Position(1) + (num_temp-1)*0.025
endif else begin
	if !D.Name eq 'PS' and info.eps_out.type eq 1 then $
		!P.Position = [0.235, 0.15, 0.99, 0.92] $
		else !P.Position = [0.060, 0.10, 0.98, 0.92]
endelse
 
if info.color_bar eq 1 then begin
	if (info.axis_state eq 2) or (info.axis_state eq 4) or $
	   (info.axis_state eq 5) then begin
		yrange1=yrange
		yrange1(0) = yrange1(0) - (yrange1(1) - yrange(0)) * 0.15
	endif else begin
		get_range, y_max, y_min, ymax, ymin
		ymin = ymin - (ymax - ymin)*0.15
		yrange1 = [ymin, ymax]
		ystyle = 3
	endelse
endif else yrange1 = yrange

get_ticklen, info.style.grid, xticklen, yticklen 

if !D.Name ne 'PRINTER' then begin
    if !D.Name ne 'WIN' and info.char.font ne 0 then begin
	xtitle= '!C' + xtitle + '!C'
    endif else begin
	xtitle = xtitle + '!C'
    endelse
endif
if !D.Name eq 'PS' or !D.Name eq 'PRINTER' then begin
	old_charsize = !X.CHARSIZE
	!X.CHARSIZE = 0.9
	!Y.CHARSIZE = 0.9	
endif

if info.style.xlog gt 0 then begin
    XRange = set_log_range(XRange, x_min, x_max)
endif

if info.style.ylog gt 0 then begin
    YRange1 = set_log_range(YRange1, y_min, y_max)
endif

plot,hdf_data_x, hdf_data_y, /NODATA, /YNOZERO, $
	FONT=info.char.font, $
	charsize=info.char.size, $
        xtitle=xtitle, $
        ytitle=ytitle, $
	title=the_title, $
        xticklen=xticklen, yticklen=yticklen, $
	subtitle="File: " + filename + "  Date:" + systime(0), $
        xrange=XRange, yrange=YRange1, xstyle=Xstyle, ystyle=Ystyle, $
	xlog=info.style.xlog, ylog=info.style.ylog

if info.style.symbolline eq 1 then plot_symbol = - info.style.symbol $
	else plot_symbol = info.style.symbol

if info.axis_state gt 0 then begin
    fit_flag = 0
    if info.greenwich.with_level ge 1 and info.greenwich.ext_level eq 0 then begin
	fit_data_range, info.axis_state, fit_flag, 2, 1, xrange, yrange, 0, $
	    0, hdf_data_x, hdf_data_y, hdf_data_z, 0, my_color
    endif else begin
	fit_data_range, info.axis_state, fit_flag, 2, 1, xrange, yrange, zrange, $
	    0, hdf_data_x, hdf_data_y, hdf_data_z, 0, my_color
    endelse
    if fit_flag eq 1 then return
endif

if info.filldata gt 0 then max_value = info.filldata else max_value = 3.0E+38
num_x = n_elements(hdf_data_x)
i = 0L
!UserDone = 0
;for i=0L,(n_elements(hdf_data_x)-1) do begin
while(i lt num_x and !UserStop eq 1) do begin
	if(i mod 1000 eq 0) then begin
	    if !D.Name ne 'WIN' then begin
		result = widget_event(info.widgets.stop,/Nowait, /save_hourglass)
		result = widget_event(info.widgets.pause,/Nowait, /save_hourglass)
	    endif else begin
		;  If put a hourglass in WIN, it will not get the signal of stop or pause widget
		result = widget_event(info.widgets.stop,/Nowait)
		result = widget_event(info.widgets.pause,/Nowait)
	    endelse
	endif
        oplot,[hdf_data_x(i), hdf_data_x(i)],[hdf_data_y(i), hdf_data_y(i)], $
	MAX_VALUE = max_value, psym = plot_symbol, linestyle=info.style.linetype, $
	symsize = info.style.symbolsize, color=my_color(i), thick = info.style.linethick
	i = i + 1
endwhile
;endfor
!UserStop = 1
!UserPause = 1
!UserDone = 1
widget_control, set_button=0, info.widgets.pause

if info.color_bar eq 1 then begin
   temp_name = info.subset.data(this_subset).src_unitname
   temp_name = temp_name(0)
   temp_length = strlen(temp_name)
   unitlabel = ''
   if (temp_length gt 0) then begin
	dot=strpos(temp_name,'N/A')
	if( dot eq -1) then unitlabel = strmid(temp_name,2,temp_length-2)
   endif
   ; x_location = !P.Position(0) + (!P.Position(2) - !P.Position(0))/2. - 0.22
   x_bar_location = 20.0 * info.greenwich.barsize
   x_location = !P.Position(0) + (!P.Position(2) - !P.Position(0))/2. - x_bar_location
   y_location = !y.window(0) + 0.08
   if info.greenwich.with_level ge 1 then $
	draw_contour_bar, clevel, z_min, z_max, y_location, x_location, n_level, $
	    info.char.size, info.char.font, unitlabel, vlevel, !P.background, $
	    info.greenwich.setformat, info.greenwich.bformat, info.greenwich.colborder, $
	    info.greenwich.displaybad, deltx=info.greenwich.barsize $
   else draw_color_bar, top_color, z_min, z_max, y_location, x_location, $
	info.char.size, info.char.font, unitlabel, info.greenwich.setformat, $
	info.greenwich.bformat, deltx=info.greenwich.barsize
endif

if info.subset.data(this_subset).src_crit_flag eq 1 then begin
	if !D.Name eq 'PS' or !D.Name eq 'PRINTER' then begin
		charsize = 0.9*info.char.size
		y_location = 0.125
	endif else begin
		charsize = info.char.size
		y_location = 0.11
	endelse
	;xyouts, !P.Position(0), !P.Position(1)-y_location, crit_string, /NORMAL, $
	xyouts, 0.08, !P.Position(1)-y_location, crit_string, /NORMAL, $
		font=info.char.font, charsize=charsize
endif

if info.addtext.key eq 1 then write_add_text, info

test = !d.flags and 128
if test ne 0 then begin
    ;image = tvrd()
    image = get_image24()
    if ptr_valid(info.overlay.image) then ptr_free, info.overlay.image
	info.overlay.image = ptr_new(image, /NO_COPY)
endif

if info.overlay.flag eq 1 then do_overlay, info

if !D.Name eq 'PS' or !D.Name eq 'PRINTER' then begin
	!X.CHARSIZE = old_charsize
	!Y.CHARSIZE = old_charsize
endif

info.view.p_old = !P
info.view.d_old = !D
info.view.x_old = !X
info.view.y_old = !Y
 
!P.Position = [ 0.0 , 0.0 , 0.0 , 0.0]

endif else begin
	result=dialog_message('Number of date points for three subsets are not equal!',$
	    title='View HDF Warning!')
	plot_status = 0
	return
endelse

widget_control, set_uvalue=info, info.widgets.base
widget_control, set_uvalue=info, info.base

end

;--------------------------------------------------------------------------------
pro do_scatter_contour, print_flag, info, plot_status

pro_name = 'do_scatter_contour'
@getinfo

if info.subset.count lt 3 then begin
	result=dialog_message('You need at least three subsets of data!',$
	    title='View HDF Warning!')
	plot_status = 0
	return
endif

if print_flag eq 0 then begin
  info.graph_style = 'Scatter Contour Plot'
  plot_setup, info, 'Scatter Contour Plot', 1, 1, 1
  widget_control, get_uvalue=info, info.base
  if info.canceloption eq 'Yes' then begin
	info.canceloption = 'No'
	widget_control, set_uvalue=info, info.base
	plot_status = 0
	return
  endif 
  info.overlay.flag = 0
  info.overlay.offflag = 0
endif

widget_control, /hourglass

widget_control, get_uvalue=info, info.base
get_data, y_index, x_index, z_index, info

this_subset = z_index(0)
info.subset.selected = this_subset

set_axis_ranges, info, YRange, Ystyle, XRange, Xstyle, ZRange, Zstyle

if info.subset.data(x_index).src_type_flag eq 0 then begin
  hdf_data_x = *info.subset.data(x_index).src_data
endif else begin
  hdf_x_temp = *info.subset.data(x_index).src_data
  hdf_data_x = reform(hdf_x_temp.components0, n_elements(hdf_x_temp.components0))
endelse

if info.subset.data(y_index).src_type_flag eq 0 then begin
  hdf_data_y = *info.subset.data(y_index).src_data
endif else begin
  hdf_y_temp = *info.subset.data(y_index).src_data
  hdf_data_y = reform(hdf_y_temp.components0, n_elements(hdf_y_temp.components0))
endelse

if info.subset.data(z_index).src_type_flag eq 0 then begin
  hdf_data_z = *info.subset.data(z_index).src_data
endif else begin
  hdf_z_temp = *info.subset.data(z_index).src_data
  hdf_data_z = reform(hdf_z_temp.components0, n_elements(hdf_z_temp.components0))
endelse

num_x = n_elements(hdf_data_x)
num_y = n_elements(hdf_data_y)
num_z = n_elements(hdf_data_z)

if(num_x eq num_y) and (num_x eq num_z) then begin

this_type = info.subset.data(x_index).src_types
this_type = this_type(0)
filldata_value_x = get_filldata_value(this_type, info.filldata)
if filldata_value_x gt info.filldata then filldata_value_x = info.filldata

if filldata_value_x gt 0 then begin
    subscript = where(hdf_data_x lt filldata_value_x, count)
endif else begin
    subscript = where(hdf_data_x gt filldata_value_x, count)
endelse
if(count ne 0) then begin
   hdf_data_x = hdf_data_x(subscript)
   hdf_data_y = hdf_data_y(subscript)
   hdf_data_z = hdf_data_z(subscript)
endif else begin
	result=dialog_message('All the X field data are fill data!',$
	    title='View HDF Warning!')
	plot_status = 0
	return
endelse

this_type = info.subset.data(y_index).src_types
this_type = this_type(0)
filldata_value_y = get_filldata_value(this_type, info.filldata)
if filldata_value_y gt info.filldata then filldata_value_y = info.filldata

if filldata_value_y gt 0 then begin
    subscript = where(hdf_data_y lt filldata_value_y, count)
endif else begin
    subscript = where(hdf_data_y gt filldata_value_y, count)
endelse
if(count ne 0) then begin
   hdf_data_x = hdf_data_x(subscript)
   hdf_data_y = hdf_data_y(subscript)
   hdf_data_z = hdf_data_z(subscript)
endif else begin
	result=dialog_message('All the Y field data are fill data!',$
	    title='View HDF Warning!')
	plot_status = 0
	return
endelse

this_type = info.subset.data(this_subset).src_types
this_type = this_type(0)
filldata_value_z = get_filldata_value(this_type, info.filldata)
if filldata_value_z gt info.filldata then filldata_value_z = info.filldata

if filldata_value_z gt 0 then begin
    subscript = where(hdf_data_z lt filldata_value_z, count)
endif else begin
    subscript = where(hdf_data_z gt filldata_value_z, count)
endelse
if(count ne 0) then begin
   hdf_data_x = hdf_data_x(subscript)
   hdf_data_y = hdf_data_y(subscript)
   hdf_data_z = hdf_data_z(subscript)
endif else begin
	result=dialog_message('All the Z field data are fill data!',$
	    title='View HDF Warning!')
	plot_status = 0
	return
endelse

xyzname = ''
xyzname = info.field_name.x + ' : ' + info.field_name.y + ' : ' + $
          info.field_name.z
if (print_flag eq 0) or (print_flag eq 3) then plot_dialogue , xyzname, info

filename = info.subset.data(y_index).src_filename

dot=strpos(info.field_name.x,'[')
if dot ne -1 then xtitle=strmid(info.field_name.x,0,dot) $
	else xtitle = info.field_name.x
dot=strpos(info.field_name.y,'[')
if dot ne -1 then ytitle=strmid(info.field_name.y,0,dot) $
	else ytitle = info.field_name.y
dot=strpos(info.field_name.z,'[')
if dot ne -1 then ztitle=strmid(info.field_name.z,0,dot) $
	else ztitle = info.field_name.z

top_color = !d.n_colors - 2
if top_color gt 254 then top_color = 254
if(!D.Name ne 'PS' and top_color gt info.top_color) then top_color = info.top_color

if (info.axis_state eq 3) or (info.axis_state eq 5) then begin
	z_max = info.range.z_end
	z_min = info.range.z_start
endif else begin
	z_max = max(hdf_data_z, min = z_min)
	hdf_range = (z_max - z_min) * 0.05
	z_max = z_max + hdf_range
	z_min = z_min - hdf_range
	z_max_temp = long(z_max + 0.99999)
	z_min_temp = long(z_min - 0.99999)
	z_max = float(z_max_temp)
	z_min = float(z_min_temp)
endelse
;z_max_temp = long(z_max + 0.99999)
;z_min_temp = long(z_min - 0.99999)
;z_max = float(z_max_temp)
;z_min = float(z_min_temp)

info.overlay.zmax = z_max
info.overlay.zmin = z_min

if info.greenwich.with_level eq 2 then begin
    info.greenwich.in_level = 0
    if z_max lt 1.0 then info.greenwich.with_level = 1 $
    else begin
	if z_min lt 1.0 then z_min = 1.0
    endelse
endif

n_level = info.greenwich.n_level

if info.greenwich.in_level eq 1 then begin
    temp_range = str_sep(info.greenwich.range, ';')
    num_range = n_elements(temp_range)
    if info.greenwich.ext_level eq 0 then begin
	n_level = num_range + 1
	vlevel = double(temp_range)
	vlevel = [vlevel(0), vlevel, vlevel(num_range-1)]
    endif else begin
	n_level = num_range - 1
	vlevel = double(temp_range)
    endelse
    if z_min gt vlevel(0) then z_min = vlevel(0)
    if z_max lt vlevel(n_level) then z_max = vlevel(n_level)
    data_interval = vlevel(n_level-1)-vlevel(n_level-2)
    tempa = findgen(n_level)
endif else begin
    tempa = findgen(n_level)
    if info.greenwich.with_level eq 2 then begin
	if ((info.axis_state eq 3) or (info.axis_state eq 5)) and $
	  info.greenwich.ext_level eq 0 then begin
	    ;data_interval = (alog10(z_max) - alog10(z_min))/float(n_level-1)
	    ;vlevel = [0, tempa+1]
	    data_interval = (alog10(z_max) - alog10(z_min))/float(n_level-2)
	    vlevel = [0, tempa]
	    vlevel(n_level) = vlevel(n_level-1)
	endif else begin
	    data_interval = (alog10(z_max) - alog10(z_min))/float(n_level)
	    vlevel = [0, tempa+1]
	endelse
	vlevel = alog10(z_min) + vlevel * data_interval
	vlevel = 10 ^ vlevel
    endif else begin
	if ((info.axis_state eq 3) or (info.axis_state eq 5)) and $
	  info.greenwich.ext_level eq 0 then begin
	    ;data_interval = (z_max - z_min)/float(n_level-1)
	    ;vlevel = [0, tempa+1]
	    data_interval = (z_max - z_min)/float(n_level-2)
	    vlevel = [0, tempa]
	    vlevel(n_level) = vlevel(n_level-1)
	endif else begin
	    data_interval = (z_max - z_min)/float(n_level)
	    vlevel = [0, tempa+1]
	endelse
	vlevel = z_min + vlevel * data_interval
    endelse
endelse

color_interval = top_color/float(n_level)
clevel = fix(color_interval * (tempa(*) + 1))

nlevel = vlevel
num_level = n_elements(nlevel)
if nlevel(0) eq nlevel(1) then begin
    if nlevel(0) gt z_min then nlevel(0) = z_min else nlevel(0) = nlevel(0) - 1000
endif
if nlevel(num_level-1) eq nlevel(num_level-2) then begin
    if nlevel(num_level-1) lt z_max then nlevel(num_level-1) = z_max $
	else nlevel(num_level-1) = nlevel(num_level-1) + 1000
endif

if info.axis_state gt 0 then begin
    fit_flag = 0
    if info.greenwich.ext_level eq 0 then begin
	fit_data_range, info.axis_state, fit_flag, 2, 1, xrange, yrange, 0, $
	    0, hdf_data_x, hdf_data_y, hdf_data_z, 0, 0
    endif else begin
	fit_data_range, info.axis_state, fit_flag, 2, 1, xrange, yrange, zrange, $
	    0, hdf_data_x, hdf_data_y, hdf_data_z, 0, 0
    endelse
    if fit_flag eq 1 then return
endif

data_range = ''
data_range = get_data_range(this_subset,info)
if !D.Name eq 'PS' or !D.Name eq 'WIN' or info.char.font eq 0 then begin
	the_title='Contour plot for '+ ztitle
	the_title=the_title + '!C with Data Range: ' + data_range
endif else begin
	the_title='Contour plot for '+ ztitle
	the_title=the_title + '!C!C with Data Range: ' + data_range
endelse

temp_name = info.subset.data(x_index).src_unitname
temp_name = temp_name(0)
dot=strpos(temp_name,'N/A')
if( dot eq -1) then xtitle = xtitle + temp_name

temp_name = info.subset.data(y_index).src_unitname
temp_name = temp_name(0)
dot=strpos(temp_name,'N/A')
if( dot eq -1) then ytitle = ytitle + temp_name

if info.subset.data(this_subset).src_crit_flag eq 1 then begin
	crit_string = ''
	crit_string = get_crit_string(this_subset, info)
	if !D.Name eq 'PS' and info.eps_out.type eq 1 then $
		!P.Position = [0.235, 0.15, 0.99, 0.92] $
		else !P.Position = [0.060, 0.120, 0.98, 0.92]
	temp_name = str_sep(crit_string, '!C')
	num_temp = n_elements(temp_name)
	!P.Position(1) = !P.Position(1) + (num_temp-1)*0.025
endif else begin
	if !D.Name eq 'PS' and info.eps_out.type eq 1 then $
		!P.Position = [0.235, 0.15, 0.99, 0.92] $
		else !P.Position = [0.060, 0.10, 0.98, 0.92]
endelse
 
if info.axis_state eq 1 or info.axis_state eq 4 or info.axis_state eq 5 then begin
    x_max = xrange(1)
    x_min = xrange(0)
endif else x_max = max(hdf_data_x, min=x_min)

if info.axis_state eq 2 or info.axis_state eq 4 or info.axis_state eq 5 then begin
    y_max = yrange(1)
    y_min = yrange(0)
endif else y_max = max(hdf_data_y, min=y_min)

info.slide.x_end = x_max
info.slide.x_start = x_min
info.slide.y_end = y_max
info.slide.y_start = y_min

if info.color_bar eq 1 then begin
	if (info.axis_state eq 2) or (info.axis_state eq 4) or $
	   (info.axis_state eq 5) then begin
		yrange1=yrange
		yrange1(0) = yrange1(0) - (yrange1(1) - yrange(0)) * 0.15
	endif else begin
		get_range, y_max, y_min, ymax, ymin
		ymin = ymin - (ymax - ymin)*0.15
		yrange1 = [ymin, ymax]
		ystyle = 3
	endelse
endif else yrange1 = yrange

if !D.Name ne 'WIN' and info.char.font ne 0 then begin
    xtitle= '!C' + xtitle + '!C'
endif else begin
    xtitle = xtitle + '!C'
endelse
if !D.Name eq 'PS' then begin
	old_charsize = !X.CHARSIZE
	!X.CHARSIZE = 0.9
	!Y.CHARSIZE = 0.9	
endif

if info.style.xlog gt 0 then begin
    XRange = set_log_range(XRange, x_min, x_max)
endif

if info.style.ylog gt 0 then begin
    YRange1 = set_log_range(YRange1, y_min, y_max)
endif

x_space = (x_max - x_min)/(info.greenwich.n_x_grid-1)
y_space = (y_max - y_min)/(info.greenwich.n_y_grid-1)

gridspace=[x_space, y_space]
gridlimit = [x_min, y_min, x_max, y_max]

if info.greenwich.smooth gt 3 then begin
    create_grid_data, hdf_data_x, hdf_data_y, hdf_data_z, gridspace, gridlimit, $
	filldata_value_z, gridx, gridy, griddata1
    if filldata_value_z gt 0 then begin
	subscript = where(griddata1 lt filldata_value_z, count)
    endif else begin
	subscript = where(griddata1 gt filldata_value_z, count)
    endelse
    if count eq 0 then begin
	result=dialog_message('All Data is out of range!',$
	    title='View HDF Warning!')
	return
    endif
endif else begin
    triangulate,hdf_data_x,hdf_data_y,tri,FVALUE=hdf_data_z, repeats=repeats
    if info.greenwich.smooth gt 1 then begin
	filter_tri, hdf_data_x, hdf_data_y, tri, gridspace
	if tri(0,0) lt 0 then begin
	    result=dialog_message('All tri is out of range!',$
		title='View HDF Warning!')
	    return
	endif
    endif
    if info.greenwich.ext_level eq 0 then begin
	z_max_temp = max(hdf_data_z)
	z_min_temp = min(hdf_data_z)
    endif else begin
	z_max_temp = z_max
	z_min_temp = z_min
    endelse
    griddata1 = trigrid(hdf_data_x, hdf_data_y, hdf_data_z, tri, gridspace, gridlimit, $
	xgrid=gridx, ygrid=gridy, max_value=z_max_temp, min_value=z_min_temp)
endelse

case info.greenwich.smooth of
    1: begin
	griddata1=smooth(griddata1, 3)
       end
    3: begin
	if filldata_value_z gt 0 then begin
	    subscripts = where(griddata1 lt filldata_value_z, count)
	endif else begin
	    subscripts = where(griddata1 gt filldata_value_z, count)
	endelse
	if count ne 0 then begin
	    griddata_temp = griddata1(subscripts)
	    griddata_temp = smooth(griddata_temp, 3)
	    griddata1(subscripts) = griddata_temp
	endif
     end
    5: begin
	if filldata_value_z gt 0 then begin
	    subscripts = where(griddata1 lt filldata_value_z, count)
	endif else begin
	    subscripts = where(griddata1 gt filldata_value_z, count)
	endelse
	if count ne 0 then begin
	    griddata_temp = griddata1(subscripts)
	    griddata_temp = smooth(griddata_temp, 3)
	    griddata1(subscripts) = griddata_temp
	endif
     end
    else:
endcase

get_ticklen, info.style.grid, xticklen, yticklen

z_max_temp = max(griddata1)
z_min_temp = min(griddata1) + 1
contour, griddata1, gridx, gridy, MAX_VALUE = z_max_temp, MIN_VALUE = z_min_temp, $
    FONT=info.char.font, charsize=info.char.size, $
    /FOLLOW, levels = nlevel, c_colors=clevel, /cell_fill, $
    title=the_title, xtitle=xtitle, ytitle=ytitle, $
    subtitle=info.subset.data(this_subset).src_filename + "  Date:" + systime(0), $
    xrange=XRange, yrange=YRange1, xstyle=Xstyle, ystyle=Ystyle, $
    xticklen = xticklen, yticklen=yticklen

crit_location = 0.0
if info.color_bar eq 1 then begin
    temp_name = info.subset.data(this_subset).src_unitname
    temp_name = temp_name(0)
    temp_length = strlen(temp_name)
    unitlabel = ''
    if (temp_length gt 0) then begin
	dot=strpos(temp_name,'N/A')
	if( dot eq -1) then unitlabel = strmid(temp_name,2,temp_length-2)
    endif
    ; x_location = !P.Position(0) + (!P.Position(2) - !P.Position(0))/2. - 0.22
    x_bar_location = 20.0 * info.greenwich.barsize
    x_location = !P.Position(0) + (!P.Position(2) - !P.Position(0))/2. - x_bar_location
    y_location = !y.window(0) + 0.08
    if strlen(unitlabel) gt 140 then y_location = y_location + 0.015
    draw_contour_bar, clevel, z_min, z_max, y_location, x_location, n_level, info.char.size, $
	info.char.font, unitlabel, vlevel, !P.background, info.greenwich.setformat, $
	info.greenwich.bformat, info.greenwich.colborder, info.greenwich.displaybad, $
	deltx=info.greenwich.barsize
endif

if info.subset.data(this_subset).src_crit_flag eq 1 then begin
	if !D.Name eq 'PS' then begin
		charsize = 0.9*info.char.size
		y_location = 0.125
	endif else begin
		charsize = info.char.size
		y_location = 0.11
	endelse
	;xyouts, !P.Position(0), !P.Position(1)-y_location, crit_string, /NORMAL, $
	xyouts, 0.08, !P.Position(1)-y_location, crit_string, /NORMAL, $
		font=info.char.font, charsize=charsize
endif

if info.addtext.key eq 1 then write_add_text, info

test = !d.flags and 128
if test ne 0 then begin
    ;image = tvrd()
    image = get_image24()
    if ptr_valid(info.overlay.image) then ptr_free, info.overlay.image
	info.overlay.image = ptr_new(image, /NO_COPY)
endif

if info.overlay.flag eq 1 then do_overlay, info

if !D.Name eq 'PS' then begin
	!X.CHARSIZE = old_charsize
	!Y.CHARSIZE = old_charsize
endif


info.view.p_old = !P
info.view.d_old = !D
info.view.x_old = !X
info.view.y_old = !Y
 
!P.Position = [ 0.0 , 0.0 , 0.0 , 0.0]

endif else begin
	result=dialog_message('Number of date points for three subsets are not equal!',$
	    title='View HDF Warning!')
	plot_status = 0
	return
endelse

widget_control, set_uvalue=info, info.widgets.base
widget_control, set_uvalue=info, info.base

end

;--------------------------------------------------------------------------------
pro plot_3d_mesh, print_flag, info, plot_status

pro_name = 'plot_3d_mesh'
@getinfo

if info.subset.count lt 3 then begin
    result=dialog_message('You need at least three subsets of data!',$
	title='View HDF Warning!')
    plot_status = 0
    return
endif

if print_flag eq 0 then begin
    info.graph_style = '3D Mesh Plot'
    plot_setup, info, '3D Mesh Plot', 1, 1, 1
    widget_control, get_uvalue=info, info.base
    if info.canceloption eq 'Yes' then begin
	info.canceloption = 'No'
	widget_control, set_uvalue=info, info.base
	plot_status = 0
	return
    endif

    info.overlay.flag = 0
    info.overlay.offflag = 0
endif

widget_control, /hourglass

widget_control, get_uvalue=info, info.base
get_data, y_index, x_index, z_index, info

this_subset = z_index(0)
info.subset.selected = this_subset

;--------------------------
;  If this is an SDS then
;--------------------------

this_type = info.subset.data(this_subset).src_types
this_type = this_type(0)
filldata_value = get_filldata_value(this_type, info.filldata)
if filldata_value gt info.filldata then filldata_value = info.filldata
max_value = get_max_value(this_type, info.filldata)
if info.filldata gt 0 then begin
    if max_value gt info.filldata then max_value = info.filldata
endif

hdf_data_z = *info.subset.data(this_subset).src_data
size_hdf = size(hdf_data_z)

if(size_hdf(0) eq 2) then begin

    hdf_data_x = *info.subset.data(x_index).src_data
    hdf_data_y = *info.subset.data(y_index).src_data

    hdf_temp_data = reform(hdf_data_z, n_elements(hdf_data_z))
    if filldata_value gt 0 then begin
	subscript = where(hdf_temp_data lt filldata_value, count)
    endif else begin
	subscript = where(hdf_temp_data gt filldata_value, count)
    endelse
    if count eq 0 then begin
	result=dialog_message('All Data is FILL data!',$
	    title='View HDF Warning!')
	plot_status = 0
	return
    endif

    dot=strpos(info.field_name.x,'[')
    if dot ne -1 then xtitle=strmid(info.field_name.x,0,dot) $
	else xtitle = info.field_name.x
    dot=strpos(info.field_name.y,'[')
    if dot ne -1 then ytitle=strmid(info.field_name.y,0,dot) $
	else ytitle = info.field_name.y
    dot=strpos(info.field_name.z,'[')
    if dot ne -1 then ztitle=strmid(info.field_name.z,0,dot) $
	else ztitle = info.field_name.z

    name_of_data = ztitle

    hdf_temp_data = hdf_temp_data(subscript)
    hdf_max = max(hdf_temp_data, min=hdf_min)
    hdf_range = (hdf_max - hdf_min) * 0.05
    hdf_max = hdf_max + hdf_range
    hdf_min = hdf_min - hdf_range

    starting=info.subset.data(this_subset).src_start(0)
    ending=info.subset.data(this_subset).src_end(0)

    info.slide.x_start = info.subset.data(this_subset).src_start(1)
    info.slide.x_end = info.subset.data(this_subset).src_end(1)
    info.slide.y_start = info.subset.data(this_subset).src_start(0)
    info.slide.y_end = info.subset.data(this_subset).src_end(0)

    set_axis_ranges, info, YRange, Ystyle, XRange, Xstyle, ZRange, Zstyle

    rstart = starting
    rend = ending - 1

    hdf_size = size(hdf_data_z)

    if (info.axis_state eq 3) or (info.axis_state eq 5) then begin
	if info.filldata gt 0 then begin
	    if ZRange(1) gt info.filldata then hdf_max = info.filldata $
		else hdf_max = ZRange(1)
	endif
	hdf_min = ZRange(0)
    endif

    if (print_flag eq 0) then plot_dialogue , name_of_data, info

    data_range = ''
    data_range = get_data_range(this_subset,info)
    the_title = ztitle + ' Data Range: ' + data_range

    temp_name = info.subset.data(this_subset).src_unitname
    temp_name = temp_name(0)
    dot=strpos(temp_name,'N/A')
    if( dot eq -1) then ztitle = ztitle + temp_name

    if info.subset.data(this_subset).src_crit_flag eq 1 then begin
	crit_string = ''
	crit_string = get_crit_string(this_subset, info)
	the_title = the_title + '!C' + crit_string
    endif

    surface, hdf_data_z, hdf_data_x, hdf_data_y, MAX_VALUE = hdf_max, $
	MIN_VALUE = hdf_min, charsize=info.char.size, $
	linestyle=info.style.linetype, ax=info.rotate.ax, az=info.rotate.az, $
	title=the_title, xtitle=xtitle, ytitle=ytitle, $
	ztitle=ztitle,ticklen=-0.01, $
	subtitle=info.subset.data(this_subset).src_filename + "  Date:" + systime(0), $
	xrange=XRange, yrange=YRange, xstyle=Xstyle, ystyle=Ystyle

	if info.addtext.key eq 1 then write_add_text, info

endif else begin

    the_message = [ 'Data record is not a 2 dimensional array', $
    '3D Mesh plot is not valid']
 
    result= dialog_message(the_message, $
	title='View HDF Message!')
    plot_status = 0
    return
 
endelse

widget_control, set_uvalue = info, info.widgets.base
widget_control, set_uvalue = info, info.base

end

;--------------------------------------------------------------------------------
pro plot_3d_color_mesh, info, name_of_data, this_subset, print_flag, plot_status

pro_name = 'plot_3d_color_mesh'
@getinfo

if info.subset.count lt 3 then begin
    result=dialog_message('You need at least three subsets of data!',$
	title='View HDF Warning!')
    plot_status = 0
    return
endif

if print_flag eq 0 then begin
    info.field_name.z = info.subset.data(this_subset).subset_name
    info.graph_style = '3D Color Mesh Graph'
    plot_setup, info, '3D Color Mesh Graph', 1, 1, 1
    widget_control, get_uvalue=info, info.base
    if info.canceloption eq 'Yes' then begin
	info.canceloption = 'No'
	widget_control, set_uvalue=info, info.base
	plot_status = 0
	return
    endif

    info.overlay.flag = 0
    info.overlay.offflag = 0
endif

widget_control, /hourglass

widget_control, get_uvalue=info, info.base
get_data, y_index, x_index, z_index, info

;--------------------------
;  If this is an SDS then
;--------------------------

this_type = info.subset.data(this_subset).src_types
this_type = this_type(0)
filldata_value = get_filldata_value(this_type, info.filldata)
if filldata_value gt info.filldata then filldata_value = info.filldata

hdf_data = *info.subset.data(this_subset).src_data
size_hdf = size(hdf_data)

if(size_hdf(0) eq 2) then begin

    hdf_data_x = *info.subset.data(x_index).src_data
    hdf_data_y = *info.subset.data(y_index).src_data
    hdf_data_z = *info.subset.data(z_index).src_data

    hdf_temp_data = reform(hdf_data, n_elements(hdf_data))
    if filldata_value gt 0 then begin
	subscript = where(hdf_temp_data lt filldata_value, count)
    endif else begin
	subscript = where(hdf_temp_data gt filldata_value, count)
    endelse
    if count eq 0 then begin
	result=dialog_message('All Data is FILL data!',$
	    title='View HDF Warning!')
	plot_status = 0
	return
    endif

    dot=strpos(info.field_name.x,'[')
    if dot ne -1 then xtitle=strmid(info.field_name.x,0,dot) $
	else xtitle = info.field_name.x
    dot=strpos(info.field_name.y,'[')
    if dot ne -1 then ytitle=strmid(info.field_name.y,0,dot) $
	else ytitle = info.field_name.y
    dot=strpos(info.field_name.z,'[')
    if dot ne -1 then ztitle=strmid(info.field_name.z,0,dot) $
	else ztitle = info.field_name.z

    hdf_temp_data = hdf_temp_data(subscript)
    hdf_max = max(hdf_temp_data, min=hdf_min)
    hdf_range = (hdf_max - hdf_min) * 0.05
    hdf_max = hdf_max + hdf_range
    hdf_min = hdf_min - hdf_range

    z_type = info.subset.data(z_index).src_types
    z_type = z_type(0)
    z_filldata_value = get_filldata_value(z_type, info.filldata)
    if z_filldata_value gt info.filldata then z_filldata_value = info.filldata
    hdf_temp_data = reform(hdf_data_z, n_elements(hdf_data_z))
    if z_filldata_value gt 0 then begin
	subscript = where(hdf_temp_data lt z_filldata_value, count)
    endif else begin
	subscript = where(hdf_temp_data gt z_filldata_value, count)
    endelse
    if count eq 0 then begin
	result=dialog_message('All Z Data is FILL data!',$
	    title='View HDF Warning!')
	plot_status = 0
	return
    endif

    hdf_temp_data = hdf_temp_data(subscript)
    z_max = max(hdf_temp_data, min=z_min)

    starting=info.subset.data(this_subset).src_start(0)
    ending=info.subset.data(this_subset).src_end(0)

    info.slide.x_start = info.subset.data(this_subset).src_start(1)
    info.slide.x_end = info.subset.data(this_subset).src_end(1)
    info.slide.y_start = info.subset.data(this_subset).src_start(0)
    info.slide.y_end = info.subset.data(this_subset).src_end(0)

    set_axis_ranges, info, YRange, Ystyle, XRange, Xstyle, ZRange, Zstyle

    rstart = starting
    rend = ending - 1

    hdf_size = size(hdf_data)

    if (info.axis_state eq 3) or (info.axis_state eq 5) then begin
	if info.filldata gt 0 then begin
	    if ZRange(1) gt info.filldata then z_max = info.filldata $
		else z_max = ZRange(1)
	endif
	z_min = ZRange(0)
    endif

    if (print_flag eq 0) then plot_dialogue , name_of_data, info

    data_range = ''
    data_range = get_data_range(this_subset,info)
    the_title = name_of_data + ' Data Range: ' + data_range

    temp_name = info.subset.data(x_index).src_unitname
    temp_name = temp_name(0)
    dot=strpos(temp_name,'N/A')
    if( dot eq -1) then xtitle = xtitle + temp_name

    temp_name = info.subset.data(y_index).src_unitname
    temp_name = temp_name(0)
    dot=strpos(temp_name,'N/A')
    if( dot eq -1) then ytitle = ytitle + temp_name

    temp_name = info.subset.data(z_index).src_unitname
    temp_name = temp_name(0)
    dot=strpos(temp_name,'N/A')
    if( dot eq -1) then ztitle = ztitle + temp_name

    if info.subset.data(this_subset).src_crit_flag eq 1 then begin
	crit_string = ''
	crit_string = get_crit_string(this_subset, info)
	the_title = the_title + '!C' + crit_string
    endif

    top_color = !d.n_colors - 2
    if(!D.Name ne 'PS' and top_color gt info.top_color) then top_color = info.top_color
    my_color=bytscl(hdf_data, max=hdf_max, min=hdf_min, top=top_color)

    surface, hdf_data_z, hdf_data_x, hdf_data_y, MAX_VALUE = z_max, $
	MIN_VALUE = z_min, charsize=info.char.size, shades=my_color, $
	linestyle=info.style.linetype, ax=info.rotate.ax, az=info.rotate.az, $
	title=the_title, xtitle=xtitle, ytitle=ytitle, $
	ztitle=ztitle,ticklen=-0.01, $
	subtitle=info.subset.data(this_subset).src_filename + "  Date:" + systime(0), $
	xrange=XRange, yrange=YRange, xstyle=Xstyle, ystyle=Ystyle

	if info.addtext.key eq 1 then write_add_text, info

endif else begin

    the_message = [ 'Data record is not a 2 dimensional array', $
    '3D Color Mesh Graph plot is not valid']
 
    result= dialog_message(the_message, $
	title='View HDF Message!')
    plot_status = 0
    return
 
endelse

widget_control, set_uvalue = info, info.widgets.base
widget_control, set_uvalue = info, info.base

end

;--------------------------------------------------------------------------------
pro sort_array, hdf_data_x, hdf_data_z, hdf_data_y, my_color

pro_name = 'sort_array'
@getinfo

;  The array is two-dimension and have same number of data
size_in = size(hdf_data_x)

for i = 0, size_in[2]-1 do begin
    temp = hdf_data_x[*,i]
    index = sort(temp)
    temp = hdf_data_x[index, i]
    hdf_data_x[*, i] = temp
    temp = hdf_data_z[index, i]
    hdf_data_z[*, i] = temp
    temp = hdf_data_y[index, i]
    hdf_data_y[*, i] = temp
    temp = my_color[index, i]
    my_color[*, i] = temp
endfor

end

;--------------------------------------------------------------------------------
pro plot_3d_surface, info, name_of_data, this_subset, print_flag, plot_status

pro_name = 'plot_3d_surface'
@getinfo

if info.subset.count lt 3 then begin
    result=dialog_message('You need at least three subsets of data!',$
	title='View HDF Warning!')
    plot_status = 0
    return
endif

if print_flag eq 0 then begin
    info.field_name.z = info.subset.data(this_subset).subset_name
    info.graph_style = '3D Mesh Surface'
    plot_setup, info, '3D Mesh Surface', 1, 1, 1
    widget_control, get_uvalue=info, info.base
    if info.canceloption eq 'Yes' then begin
	info.canceloption = 'No'
	widget_control, set_uvalue=info, info.base
	plot_status = 0
	return
    endif

    info.overlay.flag = 0
    info.overlay.offflag = 0
endif

widget_control, /hourglass

widget_control, get_uvalue=info, info.base
get_data, y_index, x_index, z_index, info

;--------------------------
;  If this is an SDS then
;--------------------------

this_type = info.subset.data(this_subset).src_types
this_type = this_type(0)
filldata_value = get_filldata_value(this_type, info.filldata)
if filldata_value gt info.filldata then filldata_value = info.filldata

hdf_data = *info.subset.data(this_subset).src_data
size_hdf = size(hdf_data)

if(size_hdf(0) eq 2) then begin

    hdf_data_x = *info.subset.data(x_index).src_data
    hdf_data_y = *info.subset.data(y_index).src_data
    hdf_data_z = *info.subset.data(z_index).src_data

    hdf_temp_data = reform(hdf_data, n_elements(hdf_data))
    if filldata_value gt 0 then begin
	subscript = where(hdf_temp_data lt filldata_value, count)
    endif else begin
	subscript = where(hdf_temp_data gt filldata_value, count)
    endelse
    if count eq 0 then begin
	result=dialog_message('All Data is FILL data!',$
	    title='View HDF Warning!')
	plot_status = 0
	return
    endif

    dot=strpos(info.field_name.x,'[')
    if dot ne -1 then xtitle=strmid(info.field_name.x,0,dot) $
	else xtitle = info.field_name.x
    dot=strpos(info.field_name.y,'[')
    if dot ne -1 then ytitle=strmid(info.field_name.y,0,dot) $
	else ytitle = info.field_name.y
    dot=strpos(info.field_name.z,'[')
    if dot ne -1 then ztitle=strmid(info.field_name.z,0,dot) $
	else ztitle = info.field_name.z

    hdf_temp_data = hdf_temp_data(subscript)
    hdf_max = max(hdf_temp_data, min=hdf_min)
    hdf_range = (hdf_max - hdf_min) * 0.05
    hdf_max = hdf_max + hdf_range
    hdf_min = hdf_min - hdf_range

    z_type = info.subset.data(z_index).src_types
    z_type = z_type(0)
    z_filldata_value = get_filldata_value(z_type, info.filldata)
    if z_filldata_value gt info.filldata then z_filldata_value = info.filldata
    hdf_temp_data = reform(hdf_data_z, n_elements(hdf_data_z))
    if z_filldata_value gt 0 then begin
	subscript = where(hdf_temp_data lt z_filldata_value, count)
    endif else begin
	subscript = where(hdf_temp_data gt z_filldata_value, count)
    endelse
    if count eq 0 then begin
	result=dialog_message('All Z Data is FILL data!',$
	    title='View HDF Warning!')
	plot_status = 0
	return
    endif

    hdf_temp_data = hdf_temp_data(subscript)
    z_max = max(hdf_temp_data, min=z_min)

    starting=info.subset.data(this_subset).src_start(0)
    ending=info.subset.data(this_subset).src_end(0)

    info.slide.x_start = info.subset.data(this_subset).src_start(1)
    info.slide.x_end = info.subset.data(this_subset).src_end(1)
    info.slide.y_start = info.subset.data(this_subset).src_start(0)
    info.slide.y_end = info.subset.data(this_subset).src_end(0)

    set_axis_ranges, info, YRange, Ystyle, XRange, Xstyle, ZRange, Zstyle

    rstart = starting
    rend = ending - 1

    hdf_size = size(hdf_data)

    if (info.axis_state eq 3) or (info.axis_state eq 5) then begin
	if info.filldata gt 0 then begin
	    if ZRange(1) gt info.filldata then z_max = info.filldata $
		else z_max = ZRange(1)
	endif
	z_min = ZRange(0)
    endif

    if (print_flag eq 0) then plot_dialogue , name_of_data, info

    data_range = ''
    data_range = get_data_range(this_subset,info)
    the_title = name_of_data + ' Data Range: ' + data_range

    temp_name = info.subset.data(x_index).src_unitname
    temp_name = temp_name(0)
    dot=strpos(temp_name,'N/A')
    if( dot eq -1) then xtitle = xtitle + temp_name

    temp_name = info.subset.data(y_index).src_unitname
    temp_name = temp_name(0)
    dot=strpos(temp_name,'N/A')
    if( dot eq -1) then ytitle = ytitle + temp_name

    temp_name = info.subset.data(z_index).src_unitname
    temp_name = temp_name(0)
    dot=strpos(temp_name,'N/A')
    if( dot eq -1) then ztitle = ztitle + temp_name

    if info.subset.data(this_subset).src_crit_flag eq 1 then begin
	crit_string = ''
	crit_string = get_crit_string(this_subset, info)
	the_title = the_title + '!C' + crit_string
    endif

    top_color = !d.n_colors - 2
    if(!D.Name ne 'PS' and top_color gt info.top_color) then top_color = info.top_color
    my_color=bytscl(hdf_data, max=hdf_max, min=hdf_min, top=top_color)

    subfill = where(hdf_data_z gt z_max or hdf_data_z lt z_min, countfill)
    if(countfill gt 0) then begin
	hdf_data_z[subfill] = 0;
	my_color[subfill] = !P.BACKGROUND
    endif

    ;  Sort the array if info.array_sort eq to 1
    if(info.array_sort eq 1) then begin
	sort_array, hdf_data_x, hdf_data_z, hdf_data_y, my_color
    endif

    shade_surf, hdf_data_z, hdf_data_x, hdf_data_y, MAX_VALUE = z_max, $
	MIN_VALUE = z_min, charsize=info.char.size, shades=my_color, $
	ax=info.rotate.ax, az=info.rotate.az, $
	title=the_title, xtitle=xtitle, ytitle=ytitle, $
	ztitle=ztitle,ticklen=-0.01, $
	subtitle=info.subset.data(this_subset).src_filename + "  Date:" + systime(0), $
	xrange=XRange, yrange=YRange, xstyle=Xstyle, ystyle=Ystyle
    ; shade_surf, hdf_data_z, hdf_data_x, hdf_data_y, MAX_VALUE = z_max, $
; 	MIN_VALUE = z_min, charsize=info.char.size, shades=my_color, $
; 	linestyle=info.style.linetype, ax=info.rotate.ax, az=info.rotate.az, $
; 	title=the_title, xtitle=xtitle, ytitle=ytitle, $
; 	ztitle=ztitle,ticklen=-0.01, $
; 	subtitle=info.subset.data(this_subset).src_filename + "  Date:" + systime(0), $
; 	xrange=XRange, yrange=YRange, xstyle=Xstyle, ystyle=Ystyle

	if info.addtext.key eq 1 then write_add_text, info

endif else begin

    the_message = [ 'Data record is not a 2 dimensional array', $
    '3D Mesh Surface plot is not valid']
 
    result= dialog_message(the_message, $
	title='View HDF Message!')
    plot_status = 0
    return
 
endelse

widget_control, set_uvalue = info, info.widgets.base
widget_control, set_uvalue = info, info.base

end

;--------------------------------------------------------------------------------
function set_browse_image_colortable,flag

pro_name = 'set_browse_image_colortable'
@getinfo1

if flag eq 0 then begin
    ;  Set the color index
    hdf_data_x = [  0,   0,   0,   0,  64,  64, 255, 255, 255, 255, 208, 255, 255, 255, 255, 255]
    hdf_data_y = [  0,   0,   0, 192, 255, 255, 255, 192, 128,   0,   0,   0,   0, 192, 255, 255]
    hdf_data_z = [  0,   0, 255, 255, 192,   0,   0,   0,   0,   0,  64, 128, 255, 255, 255, 255]
endif else if flag eq 1 then begin
;    hdf_data_x = [  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 255, 255, 255, 255,   $
;		  255, 255, 255, 255, 255, 255,  70, 100, 130, 155, 180, 200, 225, 235, 240, 242, $
;		  245, 249, 253, 255, 255]
;    hdf_data_y = [  0,  42,  42, 127, 170, 170, 170, 170, 170, 127, 170, 255, 255, 212, 170, $
;		  127,  85,   0,  42,  85, 127,  70, 100, 130, 155, 180, 200, 225, 235, 240, 242, $
;		  245, 249, 253, 255, 255]
;    hdf_data_z = [  0, 127, 170, 255, 255, 255, 255, 255, 255, 127,  85,   0,   0,   0,   0,  $
;		  0,   0,   0,  85, 127, 170,  70, 100, 130, 155, 180, 200, 225, 235, 240, 242, $
;		  245, 249, 253, 255, 255]
;  From the gen_images_v1_night_launch
    hdf_data_x = [  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 255, 255, 255, 255, $
		  255, 255, 255, 255, 255, 255,  70, 100, 130, 155, 180, 200, 225, 235, 240, 242, $
		  245, 249, 253, 255, 255]
    hdf_data_y = [  0,  42,  42,  42, 127, 127, 127, 127, 127, 255, 127, 170, 255, 255, 212, 170, $
		  127,  85,   0,  42,  85, 127,  70, 100, 130, 155, 180, 200, 225, 235, 240, 242, $
		  245, 249, 253, 255, 255]
    hdf_data_z = [  0, 127, 170, 170, 255, 255, 255, 255, 255, 170, 127,  85,   0,   0,   0,   0, $
		    0,   0,   0,  85, 127, 170,  70, 100, 130, 155, 180, 200, 225, 235, 240, 242, $
		  245, 249, 253, 255, 255]
endif else begin
    hdf_data_x = [  0,   0,   0,   0,   0,   0,   0,   0,   0,   0,   0, 255, 255, 255, 255,   $
	          255, 255, 255, 255, 255, 255,  70, 100, 130, 155, 180, 200, 225, 235, 240, 242, $
	          245, 249, 253, 255, 255]
    hdf_data_y = [  0,  42,  42, 127, 170, 212, 255, 255, 255, 127, 170, 255, 255, 212, 170, $
	          127,  85,   0,  42,  85, 127,  70, 100, 130, 155, 180, 200, 225, 235, 240, 242, $
	          245, 249, 253, 255, 255]
    hdf_data_z = [  0, 127, 170, 255, 255, 255, 255, 212, 170, 127,  85,   0,   0,   0,   0,  $
	            0,   0,   0,  85, 127, 170,  70, 100, 130, 155, 180, 200, 225, 235, 240, 242, $
	          245, 249, 253, 255, 255]
endelse

num_r = n_elements(hdf_data_x)
num_g = n_elements(hdf_data_y)
num_b = n_elements(hdf_data_z)

if(num_r le 256) and (num_r eq num_g) and (num_g eq num_b) and (num_r eq num_b) then begin
    top_color = !d.n_colors
    if top_color gt 256 then top_color = 256

    if num_r gt top_color then begin
	the_message = [ 'The number of input color is exceeded the', $
			'maximum color allowed!']
	result=dialog_message(the_message, title='View HDF Warning!')
	return, -1
    endif

    r1 = make_array(top_color, /byte, VALUE = 0)
    g1 = make_array(top_color, /byte, VALUE = 0)
    b1 = make_array(top_color, /byte, VALUE = 0)

    ;if num_r lt 20 then begin
    if num_r lt 40 then begin
	n_level = num_r-2
	num_color = top_color-2
	data_interval = double(num_color)/float(n_level)
	half_interval = fix(data_interval/2)

	tempa = findgen(n_level)
	clevel = fix(data_interval * (tempa(*) + 1))

	;  The first color is background or foreground (black)
	r1[0:half_interval-1] = hdf_data_x[0]
	g1[0:half_interval-1] = hdf_data_y[0]
	b1[0:half_interval-1] = hdf_data_z[0]

	;  assign the color table
	start_pos = fix(half_interval)
	for i = 1, num_r-3 do begin
	    end_pos = fix(clevel[i-1] + half_interval)
	    r1[start_pos:end_pos] = hdf_data_x[i]
	    g1[start_pos:end_pos] = hdf_data_y[i]
	    b1[start_pos:end_pos] = hdf_data_z[i]
	    start_pos = end_pos + 1
	endfor

	end_pos = num_color

	r1[start_pos:end_pos] = hdf_data_x[num_r-2]
	g1[start_pos:end_pos] = hdf_data_y[num_r-2]
	b1[start_pos:end_pos] = hdf_data_z[num_r-2]

	;  The last color is foreground or background, white
	start_pos = end_pos + 1
	if(start_pos gt num_color+1) then start_pos = num_color+1

	r1[start_pos:num_color+1] = hdf_data_x[num_r-1]
	g1[start_pos:num_color+1] = hdf_data_y[num_r-1]
	b1[start_pos:num_color+1] = hdf_data_z[num_r-1]
    endif else begin
	r1 = congrid(hdf_data_x, top_color, /minus_one)
	g1 = congrid(hdf_data_y, top_color, /minus_one)
	b1 = congrid(hdf_data_z, top_color, /minus_one)
    endelse

    tvlct, r1, g1, b1
endif else begin
    the_message = ['Number of date points for three subsets are not equal,', $
		   'or they are more than 256 values!']
    result=dialog_message(the_message, title='View HDF Warning!')
    return, -1
endelse

return, 0

end

;--------------------------------------------------------------------------------
pro do_browse_image, print_flag, this_subset, plot_type, info, plot_status

pro_name = 'do_browse_image'
@getinfo

;if info.subset.count lt 3 then begin
;	result=dialog_message('You need at least three subsets of data!',$
;	    title='View HDF Warning!')
;	return
;endif

if print_flag eq 0 then begin
  info.field_name.z = info.subset.data(this_subset).subset_name
  if plot_type eq 0 then begin
	info.graph_style = 'Browse Image'
	plot_setup, info, 'Browse Image', 1, 1, 0
  endif else begin
	info.graph_style = 'Browse Image With Average'
	plot_setup, info, 'Browse Image With Average', 1, 1, 0
  endelse
  widget_control, get_uvalue=info, info.base
  if info.canceloption eq 'Yes' then begin
	info.canceloption = 'No'
	widget_control, set_uvalue=info, info.base
	plot_status = 0
	return
  endif 
  if plot_type eq 1 then begin
	i_value = info.browse_image.npvalue
	title = 'Enter Number of Profiles'
	f_title = 'Number of profiles:'
	the_message = 'Enter number of profiles to average'
	num_profile = get_field_value(i_value, 10, title, f_title, $
		the_message, info)
	num_profile = num_profile(0)
	if num_profile eq 'cancel' then begin
	    plot_status = 0
	    return
	endif
	num_profile = long(num_profile)
	info.browse_image.npvalue = num_profile
	widget_control, set_uvalue=info, info.base
  endif

  info.overlay.flag = 0
  info.overlay.offflag = 0
endif

;  If put a hourglass in WIN, it will not get the signal of stop or pause widget
if !D.Name ne 'WIN' or info.browse_image.type eq 0 then widget_control, /hourglass

widget_control, get_uvalue=info, info.base
get_data, y_index, x_index, z_index, info
x_index = x_index(0)
y_index = y_index(0)

if info.browse_image.useprofile eq 1 then begin
    xtitle_index = x_index
    x_index = -1
endif else xtitle_index = -1

this_subset = z_index(0)
info.subset.selected = this_subset

hdf_data_z = *info.subset.data(z_index).src_data
if info.subset.data(z_index).src_type_flag eq 1 then $
	hdf_data_z = hdf_z_temp.components0

size_hdf_z = size(hdf_data_z)
if(size_hdf_z(0) ne 2) then begin
	the_message = [ 'Data set is not a 2 dimensional array', $
		'Browse Image option is not valid']
	result= dialog_message(the_message, title='View HDF Message!')
	plot_status = 0
	return
endif

set_axis_ranges, info, YRange, Ystyle, XRange, Xstyle, ZRange, Zstyle

temp_name = strlowcase(info.field_name.z)
loc = strpos(temp_name,'km')
if loc eq -1 then begin
    rloc = rstrpos(temp_name,'_')
    if rloc eq - 1 then begin
	info.browse_image.scale = 1.0
	dot = strpos(temp_name, '[')
	if( dot ne -1) then begin
	    info.browse_image.rootname = strmid(temp_name,0,dot)
	endif else begin
	    info.browse_image.rootname = temp_name
	endelse
    endif else begin
	length = strpos(temp_name,'[')
	if length eq -1 then length = strlen(temp_name)
	if rloc eq length - 2 then begin
	    resol = strcompress(strmid(temp_name, length - 1, 1), /REMOVE_ALL)
	    case resol of
		'1':  info.browse_image.scale = 1.0
		'2':  info.browse_image.scale = 1.0 * info.browse_image.shotscale
		'3':  info.browse_image.scale = 5.0 * info.browse_image.shotscale
		'4':  info.browse_image.scale = 20.0 * info.browse_image.shotscale
		'5':  info.browse_image.scale = 80 * info.browse_image.shotscale
		else: info.browse_image.scale = 1.0
	    endcase
	    info.browse_image.profile = resol
	    info.browse_image.rootname = strmid(temp_name,0,rloc)
	endif else begin
	    info.browse_image.scale = 1.0
	    dot = strpos(temp_name, '[')
	    if( dot ne -1) then begin
		info.browse_image.rootname = strmid(temp_name,0,dot)
	    endif else begin
		info.browse_image.rootname = temp_name
	    endelse
	endelse
    endelse
endif else begin
    rloc = rstrpos(temp_name,'_',loc)
    length = loc - rloc - 1
    temp = strmid(temp_name,rloc+1,length)
    info.browse_image.scale = float(temp) * info.browse_image.shotscale
    if temp eq 0.0 then info.browse_image.scale = 1.0
    info.browse_image.rootname = strmid(temp_name,0,rloc)
    info.browse_image.profile = strmid(info.field_name.z,rloc+1,loc - rloc + 1)
endelse
info.browse_image.xindex = x_index

if x_index ne -1 then begin
    if info.subset.data(x_index).src_type_flag eq 0 then begin
	hdf_data_x = *info.subset.data(x_index).src_data
	hdf_data_x = reform(hdf_data_x, n_elements(hdf_data_x))
    endif else begin
	hdf_x_temp = *info.subset.data(x_index).src_data
	hdf_data_x = reform(hdf_x_temp.components0, n_elements(hdf_x_temp.components0))
    endelse
endif else hdf_data_x = lindgen(size_hdf_z(2)) + 1

if y_index ne -1 then begin
    if info.subset.data(y_index).src_type_flag eq 0 then begin
	hdf_data_y = *info.subset.data(y_index).src_data
	hdf_data_y = reform(hdf_data_y, n_elements(hdf_data_y))
    endif else begin
	hdf_y_temp = *info.subset.data(y_index).src_data
	hdf_data_y = reform(hdf_y_temp.components0, n_elements(hdf_y_temp.components0))
    endelse
endif else hdf_data_y = lindgen(size_hdf_z(1)) + 1

size_hdf_x = size(hdf_data_x)
size_hdf_y = size(hdf_data_y)

n_size_hdf_x = n_elements(size_hdf_x)
n_size_hdf_y = n_elements(size_hdf_y)
n_size_hdf_z = n_elements(size_hdf_z)

if((size_hdf_x(n_size_hdf_x-1) ne size_hdf_z(2)) or $
	(size_hdf_y(n_size_hdf_y-1) ne size_hdf_z(1))) then begin
	the_message = [ 'The numbers of data points are not matched with X and Y.', $
		'Check the number of data points.']
	result= dialog_message(the_message, title='View HDF Message!')
	plot_status = 0
	return
endif

; save the orginal array for add feature
if ptr_valid(info.browse_image.xarray) then ptr_free, info.browse_image.xarray
info.browse_image.xarray = ptr_new(hdf_data_x)

if ptr_valid(info.browse_image.yarray) then ptr_free, info.browse_image.yarray
info.browse_image.yarray = ptr_new(hdf_data_y)

; save the current resolution feature arrary
set_feature_profile, this_subset, info.browse_image.profile, info

if x_index ne -1 then begin
    this_type = info.subset.data(x_index).src_types
    this_type = this_type(0)
endif else this_type = 24
x_type = this_type
filldata_value_x = get_filldata_value(this_type, info.filldata)
if filldata_value_x gt info.filldata then filldata_value_x = info.filldata
max_value_x = get_max_value(this_type, info.filldata)
if info.filldata gt 0 then begin
    if max_value_x gt info.filldata then max_value_x = info.filldata
endif

if y_index ne -1 then begin
    this_type = info.subset.data(y_index).src_types
    this_type = this_type(0)
endif else this_type = 24
y_type = this_type
filldata_value_y = get_filldata_value(this_type, info.filldata)
if filldata_value_y gt info.filldata then filldata_value_y = info.filldata
max_value_y = get_max_value(this_type, info.filldata)
if info.filldata gt 0 then begin
    if max_value_y gt info.filldata then max_value_y = info.filldata
endif

if filldata_value_y gt 0 then begin
    subscript = where(hdf_data_y lt filldata_value_y, count)
endif else begin
    subscript = where(hdf_data_y gt filldata_value_y, count)
endelse
if(count ne 0) then begin
	hdf_data_y = hdf_data_y(subscript)
	hdf_data_z = hdf_data_z(subscript, *)
endif else begin
	result=dialog_message('All the Y field data are fill data!',$
		title='View HDF Warning!')
	plot_status = 0
	return
endelse

this_type = info.subset.data(this_subset).src_types
this_type = this_type(0)
filldata_value_z = get_filldata_value(this_type, info.filldata)
if filldata_value_z gt info.filldata then filldata_value_z = info.filldata

if plot_type eq 0 then begin
    if filldata_value_x gt 0 then begin
	subscript = where(hdf_data_x lt filldata_value_x, count)
    endif else begin
	subscript = where(hdf_data_x gt filldata_value_x, count)
    endelse
    if(count ne 0) then begin
	hdf_data_x = hdf_data_x(subscript)
	hdf_data_z = hdf_data_z(*,subscript)
    endif else begin
	result=dialog_message('All the X field data are fill data!',$
		title='View HDF Warning!')
	plot_status = 0
	return
    endelse

    if filldata_value_z gt 0 then begin
	subscript = where(hdf_data_z lt filldata_value_z, count)
    endif else begin
	subscript = where(hdf_data_z gt filldata_value_z, count)
    endelse
    if(count ne 0) then begin
	hdf_temp = hdf_data_z(subscript)
	if info.browse_image.btype eq 0 and info.browse_image.utype eq 1 then $
	    hdf_temp = hdf_temp * 1000.0
	z_max = max(hdf_temp, min=z_min)
    endif else begin
	result=dialog_message('All the Z field data are fill data!',$
		title='View HDF Warning!')
	plot_status = 0
	return
    endelse
endif else begin
    num_profile = info.browse_image.npvalue
    num_x = n_elements(hdf_data_x)
    num_y = n_elements(hdf_data_y)
    num_value = long(num_x/num_profile)
    array_size = [num_value, num_y]
    z_temp_data = array_type(5,array_size)
    if (z_temp_data(0) eq -1) then begin
	result=dialog_message('Unable to allocate memory for temporary z data!',$
	    title='View HDF Warning!')
	plot_status = 0
	return
    endif
    array_size = [num_value]
    x_temp_data = array_type(5,array_size)
    if (x_temp_data(0) eq -1) then begin
	result=dialog_message('Unable to allocate memory for temporary x data!',$
	    title='View HDF Warning!')
	plot_status = 0
	return
    endif
    start_rec = 0L
    end_rec = long(num_profile - 1)
    ii = 0L
    for i = 0, num_value-1 do begin
	temp_x = hdf_data_x(start_rec:end_rec)
	if filldata_value_x gt 0 then begin
	    subscript = where(temp_x lt filldata_value_x, count)
	endif else begin
	    subscript = where(temp_x gt filldata_value_x, count)
	endelse
	if count ne 0 then begin
	    if x_index eq -1 then x_temp_data(ii) = i + 1 $
            else begin
		mid = long(count/2)
		x_temp_data(ii) = temp_x(subscript(mid))
	    endelse
;	    x_temp_data(ii) = hdf_data_x(start_rec)
;	    x_temp_data(ii+1) = hdf_data_x(end_rec)
;	    if count eq 1 then x_temp_data(ii) = temp_x(subsript(0)) $
;		else begin
;		    temp_x = temp_x(subscript)
;		    x_temp_data(ii) = mean(temp_x)
;	    endelse
	    for j = 0, num_y-1 do begin
		temp_z = hdf_data_z(j,start_rec:end_rec)
		if filldata_value_z gt 0 then begin
		    subscript = where(temp_z lt filldata_value_z, count)
		endif else begin
		    subscript = where(temp_z gt filldata_value_z, count)
		endelse
		if count ne 0 then begin
		    if count eq 1 then begin
			z_temp_data(j,ii) = temp_z(subscript(0))
		    endif else begin	
			temp_z = temp_z(subscript)
			z_temp_data(j,ii) = mean(temp_z)
		    endelse
		endif else z_temp_data(j,ii) = filldata_value_z
	    endfor
	    ii = ii + 1
	endif
	start_rec = start_rec + num_profile
	end_rec = start_rec + num_profile - 1
	if end_rec ge num_x then end_rec = num_x - 1
    endfor
    if ii gt 0 then begin
	hdf_data_x = x_temp_data(0:ii-1)
	hdf_data_z = z_temp_data(*,0:ii-1)
	if filldata_value_z gt 0 then begin
	    subscript = where(hdf_data_z lt filldata_value_z, count)
	endif else begin
	    subscript = where(hdf_data_z gt filldata_value_z, count)
	endelse
	if(count ne 0) then begin
	    z_temp_data = hdf_data_z(subscript)
	    if info.browse_image.btype eq 0 and info.browse_image.utype eq 1 then $
		z_temp_data = z_temp_data * 1000.0
	    z_max = max(z_temp_data, min=z_min)
	endif else begin
	    result=dialog_message('All the Z field data are fill data!',$
		title='View HDF Warning!')
	    plot_status = 0
	    return
	endelse
    endif else begin
	result=dialog_message('All the X field data are fill data!',$
		title='View HDF Warning!')
	plot_status = 0
	return
    endelse
    info.browse_image.scale = info.browse_image.npvalue
endelse

;  Save the hdf_data_z for profile
if plot_type eq 1 then begin
    if ptr_valid(info.browse_image.aarray) then ptr_free, info.browse_image.aarray
	info.browse_image.aarray = ptr_new(hdf_data_z)
endif

x_max = max(hdf_data_x, min=x_min)
if x_index eq -1 then begin
    x_max = x_max * info.browse_image.scale
    x_min = (x_min - 1 ) * info.browse_image.scale
endif
y_max = max(hdf_data_y, min=y_min)
info.slide.x_end = x_max
info.slide.x_start = x_min
info.slide.y_end = y_max
info.slide.y_start = y_min

filename = info.subset.data(this_subset).src_filename

dot=strpos(info.field_name.x,'[')
if dot ne -1 then xtitle=strmid(info.field_name.x,0,dot) $
	else xtitle = info.field_name.x
dot=strpos(info.field_name.y,'[')
if dot ne -1 then ytitle=strmid(info.field_name.y,0,dot) $
	else ytitle = info.field_name.y
dot=strpos(info.field_name.z,'[')
if dot ne -1 then ztitle=strmid(info.field_name.z,0,dot) $
	else ztitle = info.field_name.z

xyzname = ''
if plot_type eq 0 then begin
    xyzname = 'Browse Image of ' + ztitle
endif else begin
    xyzname = 'Browse Image with average every ' + $
	strcompress(string(num_profile), /REMOVE_ALL) + ' profiles of '+ztitle
endelse

if (print_flag eq 0) or (print_flag eq 3) then plot_dialogue , xyzname, info

if (info.axis_state eq 3) or (info.axis_state eq 5) then begin
	z_max = info.range.z_end
	z_min = info.range.z_start
endif

if abs(z_max) lt 2147483645L and abs(z_max) gt 1.0 then begin
    z_max_temp = long(z_max + 0.99999)
    z_min_temp = long(z_min - 0.99999)
    z_max = float(z_max_temp)
    z_min = float(z_min_temp)
endif

data_range = ''
data_range = get_data_range(this_subset,info)
the_title = xyzname
if !D.Name eq 'PS' or !D.Name eq 'WIN' or info.char.font eq 0 then begin
	;the_title='Browse Image of ' + ztitle
	the_title=the_title + '!CData Range: ' + data_range
endif else begin
	;the_title='Browse Image of ' + ztitle
	the_title=the_title + '!C!CData Range: ' + data_range
endelse

top_color = !d.n_colors - 2
if top_color gt 254 then top_color = 254

; save the info.greenwich.in_level and info.greenwich.with_level
save_with_level = info.greenwich.with_level
save_in_level   = info.greenwich.in_level
save_axis_state = info.axis_state

if((!D.Name ne 'PS' and !D.Name ne 'PRINTER') and top_color gt info.top_color) then $
        top_color = info.top_color

if info.browse_image.btype eq 0 then begin
    result = set_browse_image_colortable(info.browse_image.rtype)
    if(result eq -1) then begin
	the_message = [ 'Problem to set default color table for Browse Image.']
	result= dialog_message(the_message, title='View HDF Message!')
	return
    endif
    info.greenwich.with_level = 1
    info.greenwich.in_level = 1
    n_level = info.greenwich.n_level
    if info.browse_image.rtype eq 0 then begin
	;  Check the data_name, if it is perpendicular, use different scale
	l_data_name = strlowcase(ztitle)
	loc = strpos(l_data_name, 'perpendicular')
	if loc eq -1 then begin
	    temp_range = [0.0, 0.0002, 0.0006, 0.0013, 0.0027, 0.0052, 0.0098, $
		0.0187, 0.0340, 0.0630, 0.1168, 0.2162, 0.4]
	endif else begin
	    temp_range = [0.0, 0.0002, 0.0006, 0.0013, 0.0025, 0.0045, 0.0078, $
		0.0136, 0.0234, 0.0401, 0.0686, 0.1172, 0.2]
	endelse
    endif else begin
	temp_range = [0.0001, 0.0002, 0.0003, 0.0004, 0.0005, 0.0006, 0.0007, 0.0008, $
	    0.0009, 0.001, 0.0015, 0.002, 0.0025, 0.003, 0.0035, 0.004, 0.0045, 0.005, $
	    0.0055, 0.006, 0.0065, 0.007, 0.0075, 0.008, 0.01, 0.02, 0.03, 0.04, 0.05, $
	    0.06, 0.07, 0.08, 0.09, 0.1]
    endelse
    num_range = n_elements(temp_range)
    if info.greenwich.ext_level eq 0 then begin
	n_level = num_range + 1
	vlevel = double(temp_range)
	vlevel = [vlevel(0), vlevel, vlevel(num_range-1)]
    endif else begin
	n_level = num_range - 1
	vlevel = double(temp_range)
    endelse
    if z_min gt vlevel(0) then z_min = vlevel(0)
    if z_max lt vlevel(n_level) then z_max = vlevel(n_level)
    data_interval = vlevel(n_level-1)-vlevel(n_level-2)
    tempa=findgen(n_level)
    if info.browse_image.utype eq 1 then hdf_data_z = hdf_data_z * 1000.0
    if info.browse_image.ytype eq 0 then begin
	info.range.y_start = -2.0
	info.range.y_end = 30.0
	YRange=[info.range.y_start, info.range.y_end]
	Ystyle=3
	if info.axis_state eq 0 then begin
	    info.axis_state = 2
	endif else if info.axis_state eq 1 then begin
	    info.axis_state = 4
	endif
	y_max = 30.0
	y_min = -2.0
	info.slide.y_end = y_max
	info.slide.y_start = y_min
    endif
endif else begin
    if info.color_table ne 0 and info.pick_color_table eq 0 then $
	check_bw = check_color_table(top_color) $
	else check_bw = 0
    if check_bw eq 1 then begin
	if info.device eq 'X' then begin
	    color_table_file=info.home_path+"/"+"view_hdf_color.tbl"
	endif else begin
	    color_table_file=info.home_path+"\"+"view_hdf_color.tbl"
	endelse
	test_file = findfile(color_table_file, count=count)
	if count eq 0 then color_table_file = 'view_hdf_color.tbl'
	loadct, info.color_table, file=color_table_file
    endif
endelse

if info.greenwich.with_level ge 1 then begin
;	if info.device eq 'X' then begin
;	    color_table_file=info.home_path+"/"+"view_hdf_color.tbl"
;	endif else begin
;	    color_table_file=info.home_path+"\"+"view_hdf_color.tbl"
;	endelse
;	test_file = findfile(color_table_file, count=count)
;	if count eq 0 then color_table_file = 'view_hdf_color.tbl'
;	loadct,44, file=color_table_file, /silent
;	info.greenwich.n_level = 14
    if info.browse_image.btype ne 0 then begin
	if info.greenwich.with_level eq 2 then begin
	    info.greenwich.in_level = 0
	    if z_max lt 1.0 then info.greenwich.with_level = 1 $
	    else begin
		if z_min lt 1.0 then z_min = 1.0
	    endelse
	endif
	n_level = info.greenwich.n_level
	if info.greenwich.in_level eq 1 then begin
	    temp_range = str_sep(info.greenwich.range, ';')
	    num_range = n_elements(temp_range)
	    if info.greenwich.ext_level eq 0 then begin
		n_level = num_range + 1
		vlevel = double(temp_range)
		vlevel = [vlevel(0), vlevel, vlevel(num_range-1)]
	    endif else begin
		n_level = num_range - 1
		vlevel = double(temp_range)
	    endelse
	    if z_min gt vlevel(0) then z_min = vlevel(0)
	    if z_max lt vlevel(n_level) then z_max = vlevel(n_level)
	    data_interval = vlevel(n_level-1)-vlevel(n_level-2)
	    tempa=findgen(n_level)
	endif else begin
	  tempa=findgen(n_level)
	  if info.greenwich.with_level eq 2 then begin
	    if ((info.axis_state eq 3) or (info.axis_state eq 5)) and $
	      info.greenwich.ext_level eq 0 then begin
		;data_interval = (alog10(z_max) - alog10(z_min))/float(n_level-1)
		;vlevel = [0, tempa+1]
		data_interval = (alog10(z_max) - alog10(z_min))/float(n_level-2)
		vlevel = [0, tempa]
		vlevel(n_level) = vlevel(n_level-1)
	    endif else begin
		data_interval = (alog10(z_max) - alog10(z_min))/float(n_level)
		vlevel = [0, tempa+1]
	    endelse
	    vlevel = alog10(z_min) + vlevel * data_interval
	    vlevel = 10 ^ vlevel
	  endif else begin
	    if ((info.axis_state eq 3) or (info.axis_state eq 5)) and $
	      info.greenwich.ext_level eq 0 then begin
		;data_interval = (z_max - z_min)/float(n_level-1)
		;vlevel = [0, tempa+1]
		data_interval = (z_max - z_min)/float(n_level-2)
		vlevel = [0, tempa]
                vlevel(n_level) = vlevel(n_level-1)
	    endif else begin
		data_interval = (z_max - z_min)/float(n_level)
		vlevel = [0, tempa+1]
	    endelse
	    vlevel = z_min + vlevel * data_interval
	  endelse
	endelse
    endif

	color_interval = top_color/float(n_level)
	;tempa=findgen(n_level)
	clevel = fix(color_interval * (tempa(*) + 1))
	; print,'clevel = ',clevel

	info.browse_image.colorint = fix(color_interval)

	;sub_max = where(hdf_data_z gt z_max , count_max)
	;sub_min = where(hdf_data_z lt z_min, count_min)
	;if count_min ne 0 then hdf_data_z(sub_min) = z_max + 10 * data_interval
	my_color = make_array(n_elements(hdf_data_z), /INT, VALUE=info.greenwich.baddata)
	if info.greenwich.in_level eq 0 then begin
	  ;if abs(data_interval) ge 1.0 then begin
	  ;  if info.greenwich.with_level eq 2 then begin
	;	my_color(*) = fix(fix((alog10(hdf_data_z(*)) - alog10(z_min))/data_interval + 1.0) * $
	;		color_interval)
	;    endif else begin
	;	my_color(*) = fix(fix((hdf_data_z(*) - z_min)/data_interval + 1.0) * $
	;		color_interval)
	;    endelse
	;  endif else begin
	;    if info.greenwich.with_level eq 2 then begin
	;	my_color(*) = fix(fix((alog10(hdf_data_z(*)) - alog10(z_min))/data_interval + 0.99999) * $
	;		color_interval)
	;    endif else begin
	;	my_color(*) = fix(fix((hdf_data_z(*) - z_min)/data_interval + 0.99999) * $
	;		color_interval)
	;    endelse
	;  endelse
	  for i = 0, n_level-2 do begin
	    sub_color = where(hdf_data_z ge vlevel(i) and hdf_data_z lt vlevel(i+1), count_color)
	    if count_color ne 0 then my_color(sub_color) = clevel(i)
	  endfor
	  if ((info.axis_state eq 3) or (info.axis_state eq 5)) and $
	    info.greenwich.ext_level eq 0 then begin
		sub_color = where(hdf_data_z gt vlevel(n_level-1), count_color)
		if count_color ne 0 then my_color(sub_color) = clevel(n_level-1)
		sub_color = where(hdf_data_z lt vlevel(1), count_color)
		if count_color ne 0 then my_color(sub_color) = clevel(0)
	  endif else begin
		sub_color = where(hdf_data_z ge vlevel(n_level-1) and hdf_data_z lt vlevel(n_level), count_color)
		if count_color ne 0 then my_color(sub_color) = clevel(n_level-1)
	  endelse
	endif else begin
	  tvlct,r1,g1,b1,/get
	  if info.greenwich.ext_level eq 0 then begin
	    sub_color = where(hdf_data_z le vlevel(1), count_color)
	    if count_color ne 0 then my_color(sub_color) = clevel(0)
	    sub_color = where(hdf_data_z gt vlevel(n_level-1), count_color)
            if count_color ne 0 then my_color(sub_color) = clevel(n_level-1)
	  endif else begin
	    sub_color = where(hdf_data_z lt vlevel(1) and hdf_data_z ge vlevel(0), count_color)
            if count_color ne 0 then my_color(sub_color) = clevel(0)
            sub_color = where(hdf_data_z gt vlevel(n_level-1) and hdf_data_z le vlevel(n_level), count_color)
            if count_color ne 0 then my_color(sub_color) = clevel(n_level-1)
	  endelse
	  for i = 1, n_level-2 do begin
	    sub_color = where(hdf_data_z gt vlevel(i) and hdf_data_z le vlevel(i+1), count_color)
	    if count_color ne 0 then my_color(sub_color) = clevel(i)
	  endfor
	    ;sub_color = where(hdf_data_z gt vlevel(n_level-1), count_color)
	    ;if count_color ne 0 then my_color(sub_color) = clevel(n_level-1)
	endelse
	if ((info.axis_state ne 3) and (info.axis_state ne 5)) or $
	    info.greenwich.ext_level eq 1 then begin
	    sub_max = where(hdf_data_z gt z_max , count_max)
	    sub_min = where(hdf_data_z lt z_min, count_min)
	    if count_max ne 0 then begin
		my_color(sub_max) = info.greenwich.baddata
		hdf_data_z(sub_max) = filldata_value_z
	    endif
	    if count_min ne 0 then begin
		my_color(sub_min) = info.greenwich.baddata
		hdf_data_z(sub_min) = filldata_value_z
	    endif
	endif
endif else begin
    my_color=bytscl(hdf_data_z, max=z_max, min=z_min, top=top_color)
    info.browse_image.colorint = 0
endelse

info.overlay.zmax = z_max
info.overlay.zmin = z_min

if filldata_value_z gt 0 then begin
    subscript = where(hdf_data_z gt filldata_value_z, count)
endif else begin
    subscript = where(hdf_data_z lt filldata_value_z, count)
endelse
;if(count ne 0) then my_color(subscript) = !P.BACKGROUND
if(count ne 0) then my_color(subscript) = info.greenwich.baddata

if x_index ne -1 then begin
    temp_name = info.subset.data(x_index).src_unitname
    temp_name = temp_name(0)
    dot=strpos(temp_name,'N/A')
    if( dot eq -1) then xtitle = xtitle + temp_name
endif

if xtitle_index ne -1 then begin
    xtitle = info.subset.data(xtitle_index).subset_name
    xtitle = xtitle(0)
    dot=strpos(xtitle,'[')
    if dot ne -1 then xtitle=strmid(xtitle,0,dot)

    temp_name = info.subset.data(xtitle_index).src_unitname
    temp_name = temp_name(0)
    dot=strpos(temp_name,'N/A')
    if( dot eq -1) then xtitle = xtitle + temp_name
endif

if y_index ne -1 then begin
    temp_name = info.subset.data(y_index).src_unitname
    temp_name = temp_name(0)
    dot=strpos(temp_name,'N/A')
    if( dot eq -1) then ytitle = ytitle + temp_name
endif

if info.subset.data(this_subset).src_crit_flag eq 1 then begin
	crit_string = ''
	crit_string = get_crit_string(this_subset, info)
	if !D.Name eq 'PS' and info.eps_out.type eq 1 then $
		!P.Position = [0.235, 0.15, 0.99, 0.92] $
		else !P.Position = [0.060, 0.120, 0.98, 0.92]
	temp_name = str_sep(crit_string, '!C')
	num_temp = n_elements(temp_name)
	!P.Position(1) = !P.Position(1) + (num_temp-1)*0.025
endif else begin
	if !D.Name eq 'PS' and info.eps_out.type eq 1 then $
		!P.Position = [0.235, 0.15, 0.99, 0.92] $
		else !P.Position = [0.060, 0.10, 0.98, 0.92]
endelse
 
if info.color_bar eq 1 then begin
	if (info.axis_state eq 2) or (info.axis_state eq 4) or $
	   (info.axis_state eq 5) then begin
		yrange1=yrange
		yrange1(0) = yrange1(0) - (yrange1(1) - yrange(0)) * 0.15
	endif else begin
		get_range, y_max, y_min, ymax, ymin
		ymin = ymin - (ymax - ymin)*0.15
		yrange1 = [ymin, ymax]
		ystyle = 3
	endelse
endif else yrange1 = yrange

get_ticklen, info.style.grid, xticklen, yticklen 

if !D.Name ne 'WIN' and info.char.font ne 0 then begin
    xtitle= '!C' + xtitle + '!C'
endif else begin
    xtitle = xtitle + '!C'
endelse
if !D.Name eq 'PS' or !D.Name eq 'PRINTER' then begin
	old_charsize = !X.CHARSIZE
	!X.CHARSIZE = 0.9
	!Y.CHARSIZE = 0.9	
endif

if info.style.xlog gt 0 then begin
    XRange = set_log_range(XRange, x_min, x_max)
endif

if info.style.ylog gt 0 then begin
    YRange1 = set_log_range(YRange1, y_min, y_max)
endif

if x_index eq -1 then begin
    num_x = n_elements(hdf_data_x)
    x_array = hdf_data_x - 1
    x_array = [x_array, hdf_data_x(num_x - 1)]
    x_array = x_array  * info.browse_image.scale
endif else x_array = hdf_data_x

if xtitle_index eq -1 then begin
    ;plot,hdf_data_x, hdf_data_y, /NODATA, /YNOZERO, $
    titlesize = 1.2 * info.char.size
    plot,x_array, hdf_data_y, /NODATA, /YNOZERO, $
	FONT=info.char.font, $
	charsize=info.char.size, $
	xcharsize=titlesize, $
	ycharsize=titlesize, $
        xtitle=xtitle, $
        ytitle=ytitle, $
	title=the_title, $
        xticklen=xticklen, yticklen=yticklen, $
	subtitle="File: " + filename + "  Date:" + systime(0), $
        xrange=XRange, yrange=YRange1, xstyle=Xstyle, ystyle=Ystyle, $
	xlog=info.style.xlog, ylog=info.style.ylog
endif else begin
    if(XRange[0] eq XRange[1]) then begin
	XRange = [min(x_array), max(x_array)]
	Xstyle = 3
	num_x = n_elements(x_array)
	x_start_index = 0
    endif else begin
	range_sub = where(x_array ge XRange[0] and x_array le XRange[1], num_x)
	if(num_x eq 0) then begin
	    the_message = [ 'All the x_array are out of range.']
	    result= dialog_message(the_message, title='View HDF Message!')
	    return
	endif
	x_start_index = range_sub[0]
	undefine, range_sub
    endelse
    ; num_x = n_elements(x_array)
    x_incs = num_x/10
    x_tick = num_x/x_incs
    xtick = replicate(' ',x_tick+1)
    ;if !D.Name ne 'WIN' then xtitle = '!C'+xtitle $
    ;else begin
;	if info.char.font eq 0 then xtitle = xtitle + '!C'
;    endelse
    titlesize = 1.2 * info.char.size
    plot,x_array, hdf_data_y, /NODATA, /YNOZERO, $
	FONT=info.char.font, $
	charsize=info.char.size, $
	xcharsize=titlesize, $
	ycharsize=titlesize, $
	xtitle=xtitle, $
	ytitle=ytitle, $
	title=the_title, $
	; xticks=x_tick, $
	xticks=x_tick, xtickn=xtick, $
	xticklen=xticklen, yticklen=yticklen, $
	subtitle="File: " + filename + "  Date:" + systime(0), $
	xrange=XRange, yrange=YRange1, xstyle=Xstyle, ystyle=Ystyle, $
	xlog=info.style.xlog, ylog=info.style.ylog

    if info.subset.data(xtitle_index).src_type_flag eq 0 then begin
	temp_x = *info.subset.data(xtitle_index).src_data
	temp_x = reform(temp_x, n_elements(temp_x))
    endif else begin
	temp_x_1 = *info.subset.data(xtitle_index).src_data
	temp_x = reform(temp_x_1.components0, n_elements(temp_x_1.components0))
	undefine, temp_x_1
    endelse

    num_x = n_elements(temp_x)

    ; readabley = 1./36*(max(hdf_data_y) - min(hdf_data_y))
    readabley = info.browse_image.xlocat * info.char.size

    num_index_x = n_elements(x_array)
    for i = 0, x_tick do begin
	current_index = i * x_incs + x_start_index
	if current_index lt num_index_x then begin
	    x_loc = x_array[current_index]
	    label_loc = x_loc
	    ;  check x_loc is within the number of x value
	    if(label_loc le num_x) then begin
		if label_loc eq num_x then label_loc = num_x - 1
		;x_value = string(temp_x[label_loc], format='(f8.1)')
		xformat = '('+info.browse_image.xformat+')'
		x_value = string(temp_x[label_loc], format=xformat)
		x_value = strcompress(x_value, /REMOVE_ALL)
		normal_coord = convert_coord(x_loc, !Y.crange[0], /to_normal)
		; xyouts, x_loc, !Y.crange[0] - readabley, x_value, alignment=0.5, $
		xyouts, normal_coord[0], normal_coord[1] - readabley, x_value, alignment=0.5, $
		    FONT=info.char.font, charsize = info.char.size, /normal
	    endif
	endif
    endfor

    undefine, temp_x
endelse

if info.style.symbolline eq 1 then plot_symbol = - info.style.symbol $
	else plot_symbol = info.style.symbol

num_x = n_elements(hdf_data_x)
num_y = n_elements(hdf_data_y)
my_color = reform(my_color, num_y, num_x)

if info.axis_state gt 0 then begin
	fit_flag = 0
	if plot_type eq 1 and x_index eq -1 then begin
	    xrange1 = xrange / info.browse_image.npvalue
	endif else xrange1 = xrange
	fit_data_range, info.axis_state, fit_flag, 3, 1, xrange1, yrange, zrange, $
		0, hdf_data_x, hdf_data_y, hdf_data_z, 0, my_color
	if fit_flag eq 1 then begin
	    ; reset the info.greenwich.in_level and info.greenwich.with_level
	    info.greenwich.with_level = save_with_level
	    info.greenwich.in_level   = save_in_level
	    info.axis_state = save_axis_state
	    return
	endif
	num_x = n_elements(hdf_data_x)
	num_y = n_elements(hdf_data_y)
endif

if info.browse_image.type eq 0 then begin
    ; build the image
    temp_z = transpose(my_color)

    temp_x_max = max(hdf_data_x, min=temp_x_min)
    if x_index eq -1 and info.browse_image.scale gt 1 then begin
	temp_x_max = temp_x_max * info.browse_image.scale
	temp_x_min = (temp_x_min - 1) * info.browse_image.scale + 1
    endif
    temp_y_max = max(hdf_data_y, min=temp_y_min)

    px = !X.window * !D.x_vsize
    py = !Y.window * !D.y_vsize
    sx = px(1) - px(0) + 1
    sy = py(1) - py(0) + 1
    axrange = abs(!X.crange(1) - !X.crange(0))
    ayrange = abs(!Y.crange(1) - !Y.crange(0))
    dxrange = temp_x_max - temp_x_min
    dyrange = temp_y_max - temp_y_min
    xratio = dxrange / axrange
    yratio = dyrange / ayrange
    if xratio gt 1.0 then xratio = 1.0
    if yratio gt 1.0 then yratio = 1.0
    x_nump = sx * xratio
    y_nump = sy * yratio
    if(XRange[0] gt XRange[1]) then begin
	x_orgin = px(0) + abs(temp_x_max-!X.crange(0)) * sx/(axrange)
    endif else begin
	x_orgin = px(0) + (temp_x_min-!X.crange(0)) * sx/(axrange)
    endelse
    if(YRange[0] gt YRange[1]) then begin
	y_orgin = py(0) + abs(temp_y_max-!Y.crange(0)) * sy/(ayrange)
    endif else begin
	y_orgin = py(0) + (temp_y_min-!Y.crange(0)) * sy/(ayrange)
    endelse
    if x_index eq -1 and y_index eq -1 then begin
	if !D.NAME ne 'PS' then griddata1 = congrid(temp_z, x_nump, y_nump) $
	    else griddata1 = temp_z
    endif else if x_index eq -1 then begin
	y_space = dyrange / 599.0
	t_array = temp_y_min + findgen(600) * y_space
	x_array = hdf_data_y
	subscripts = sort(x_array)
	x_array = x_array(subscripts)
	array_size = [600, num_x]
	temp_array = array_type(22, array_size)
	if temp_array(0) eq -1 then begin
	    ; reset the info.greenwich.in_level and info.greenwich.with_level
	    info.greenwich.with_level = save_with_level
	    info.greenwich.in_level   = save_in_level
	    info.axis_state = save_axis_state
	    return
	endif
	for i = 0L, num_x-1 do begin
	    y_array = temp_z(i, *)
	    y_array = y_array(subscripts)
	    ;z_array = spline(x_array, y_array, t_array)
	    z_array = interpol(y_array, x_array, t_array)
	    temp_array(i,*) = z_array
	endfor
	if !D.NAME ne 'PS' then begin
	    if info.browse_image.saveimage eq 1 then begin
		temp_name = 'BrowseImage' + ztitle
		set_statistics_subset, temp_name, this_subset, 2, info, temp_array
	    endif
	    griddata1 = congrid(temp_array, x_nump, y_nump)
	endif else griddata1 = temp_array
    endif else if y_index eq -1 then begin
	x_space = dxrange / 1199.0
	t_array = temp_x_min + findgen(1200) * x_space
	x_array = hdf_data_x
	subscripts = sort(x_array)
	x_array = x_array(subscripts)
	array_size = [num_y, 1200]
	temp_array = array_type(22, array_size)
	if temp_array(0) eq -1 then begin
	    ; reset the info.greenwich.in_level and info.greenwich.with_level
	    info.greenwich.with_level = save_with_level
	    info.greenwich.in_level   = save_in_level
	    info.axis_state = save_axis_state
	    return
	endif
	for i = 0L, num_y-1 do begin
	    y_array = temp_z(*, i)
	    y_array = y_array(subscripts)
	    ;z_array = spline(x_array, y_array, t_array)
	    z_array = interpol(y_array, x_array, t_array)
	    temp_array(*,i) = z_array
	endfor

	if !D.NAME ne 'PS' then begin
	    if info.browse_image.saveimage eq 1 then begin
		temp_name = 'BrowseImage' + ztitle
		set_statistics_subset, temp_name, this_subset, 2, info, temp_array
	    endif
	    griddata1 = congrid(temp_array, x_nump, y_nump)
	endif else griddata1 = temp_array
    endif else if x_index ne -1 and y_index ne -1 then begin
	y_space = dyrange / 599.0
	t_array = temp_y_min + findgen(600) * y_space
	x_array = hdf_data_y
	subscripts = sort(x_array)
	x_array = x_array(subscripts)
	array_size = [600, num_x]
	temp_array = array_type(22, array_size)
	if temp_array(0) eq -1 then begin
	    ; reset the info.greenwich.in_level and info.greenwich.with_level
	    info.greenwich.with_level = save_with_level
	    info.greenwich.in_level   = save_in_level
	    info.axis_state = save_axis_state
	    return
	endif
	for i = 0L, num_x-1 do begin
	    y_array = temp_z(i, *)
	    y_array = y_array(subscripts)
	    ;z_array = spline(x_array, y_array, t_array)
	    z_array = interpol(y_array, x_array, t_array)
	    temp_array(i,*) = z_array
	endfor
	temp_z = temp_array
	x_space = dxrange / 1199.0
	t_array = temp_x_min + findgen(1200) * x_space
	x_array = hdf_data_x
	subscripts = sort(x_array)
	x_array = x_array(subscripts)
	array_size = [600, 1200]
	temp_array = array_type(22, array_size)
	if temp_array(0) eq -1 then begin
	    ; reset the info.greenwich.in_level and info.greenwich.with_level
	    info.greenwich.with_level = save_with_level
	    info.greenwich.in_level   = save_in_level
	    info.axis_state = save_axis_state
	    return
	endif
	for i = 0L, 599 do begin
	    y_array = temp_z(*, i)
	    y_array = y_array(subscripts)
	    ;z_array = spline(x_array, y_array, t_array)
	    z_array = interpol(y_array, x_array, t_array)
	    temp_array(*,i) = z_array
	endfor
	if !D.NAME ne 'PS' then begin
	    if info.browse_image.saveimage eq 1 then begin
		temp_name = 'BrowseImage' + ztitle
		set_statistics_subset, temp_name, this_subset, 2, info, temp_array
	    endif
	    griddata1 = congrid(temp_array, x_nump, y_nump)
	endif else griddata1 = temp_array
    endif else begin
	array_size = [num_y, num_x]
	temp_x = array_type(x_type, array_size)
	temp_y = array_type(y_type, array_size)
	for i = 0L, num_x-1 do begin
	    for j = 0L, num_y-1 do begin
		temp_x(i,j) = hdf_data_x(i)
		temp_y(i,j) = hdf_data_y(j)
	    endfor
	endfor
	if !D.NAME ne 'PS' then begin
	    x_space = dxrange / (x_nump-1)
	    y_space = dyrange / (y_nump-1)
	endif else begin
	    x_space = dxrange / (1000.0-1)
	    y_space = dyrange / (600.0-1)
	endelse
	triangulate,temp_x,temp_y,tri,FVALUE=temp_z, repeats=repeats
	gridspace=[x_space, y_space]
	gridlimit = [temp_x_min, temp_y_min, temp_x_max, temp_y_max]
	griddata1 = trigrid(temp_x, temp_y, temp_z, tri, gridspace, gridlimit, $
	    xgrid=gridlon, ygrid=gridlat, max_value=top_color, min_value=0)
	if !D.NAME ne 'PS' then begin
	    if info.browse_image.saveimage eq 1 then begin
		temp_name = 'BrowseImage' + ztitle
		set_statistics_subset, temp_name, this_subset, 2, info, griddata1
	    endif
	endif
    endelse

    if(XRange[0] gt XRange[1]) then griddata1 = reverse(temporary(griddata1))

    if !D.NAME eq 'PS' then tv,griddata1,xsize=x_nump, ysize=y_nump, x_orgin, y_orgin $
	else tv,griddata1,x_orgin,y_orgin

endif else if info.browse_image.type eq 1 then begin

;  use polyfill function
    temp_x = hdf_data_x
    temp_y = hdf_data_y
    if x_index eq -1 and info.browse_image.scale gt 1 then $
	temp_x = (temp_x - 1) * info.browse_image.scale
;  sort the array
    subscripts = sort(temp_x)
    temp_x = temp_x(subscripts)
    for i = 0L, num_y-1 do begin
	temp_color = my_color(i,subscripts)
	my_color(i,*) = temp_color
    endfor
    subscripts = sort(temp_y)
    temp_y = temp_y(subscripts)
    for i = 0L, num_x - 1 do begin
	temp_color = my_color(subscripts, i)
	my_color(*,i) = temp_color
    endfor

    deltx = temp_x(1) - temp_x(0)
    for i = 1L, num_x-2 do begin
	deltx = [deltx, temp_x(i+1)-temp_x(i)]
    endfor
    deltx = [deltx, deltx(num_x-2)]

    delty = temp_y(1) - temp_y(0)
    for i = 1L, num_y-2 do begin
	delty = [delty, temp_y(i+1)-temp_y(i)]
    endfor

    i = 0L
    !UserDone = 0
    while(i lt num_x and !UserStop eq 1) do begin
    ; for i = 0L, num_x-1 do begin
	;if i eq 0 then begin
	;    mdeltx = 0.0
	;    pdeltx = deltx(0)/2.0
	;    if x_index eq -1 and info.browse_image.scale gt 1 then $
	;	mdeltx = pdeltx
	;endif else if i eq num_x-1 then begin
	;    mdeltx = deltx(num_x-2)/2.0
	;    pdeltx = 0.0
	;    if x_index eq -1 and info.browse_image.scale gt 1 then $
	;	pdeltx = mdeltx
	;endif else begin
	;    mdeltx = deltx(i-1)/2.0
	;    pdeltx = deltx(i)/2.0
	;endelse
	mdeltx = 0.0
	pdeltx = deltx(i)
	if !D.Name ne 'WIN' then begin
	    result = widget_event(info.widgets.stop,/Nowait, /save_hourglass)
	    result = widget_event(info.widgets.pause,/Nowait, /save_hourglass)
	endif else begin
	    ;  If put a hourglass in WIN, it will not get the signal of stop or pause widget
	    result = widget_event(info.widgets.stop,/Nowait)
	    result = widget_event(info.widgets.pause,/Nowait)
	endelse
	for j = 0L, num_y-1 do begin
	    if j eq 0 then begin
		mdelty = 0.0
		pdelty = delty(0)/2.0
	    endif else if j eq num_y-1 then begin
		mdelty = delty(num_y-2)/2.0
		pdelty = 0.0
	    endif else begin
		mdelty = delty(j-1)/2.0
		pdelty = delty(j)/2.0
	    endelse
	    vert1 = convert_coord(temp_x(i)-mdeltx, temp_y(j)-mdelty, /to_device)
	    vert2 = convert_coord(temp_x(i)-mdeltx, temp_y(j)+pdelty, /to_device)
	    vert3 = convert_coord(temp_x(i)+pdeltx, temp_y(j)+pdelty, /to_device)
	    vert4 = convert_coord(temp_x(i)+pdeltx, temp_y(j)-mdelty, /to_device)
	    x = [vert1(0), vert2(0), vert3(0), vert4(0)]
	    y = [vert1(1), vert2(1), vert3(1), vert4(1)]
	    the_color = my_color(j,i)
	    polyfill, x, y, color=the_color, /DEVICE
	endfor
	i = i + 1
    ; endfor
    endwhile
    !UserStop = 1
    !UserPause = 1
    !UserDone = 1
    widget_control, set_button=0, info.widgets.pause

endif else begin
    if x_index eq -1 and info.browse_image.scale gt 1 then $
	hdf_data_x = hdf_data_x * info.browse_image.scale
    ; for i=0L,num_x-1 do begin
    i = 0L
    !UserDone = 0
    while(i lt num_x and !UserStop eq 1) do begin
	if !D.Name ne 'WIN' then begin
	    result = widget_event(info.widgets.stop,/Nowait, /save_hourglass)
	    result = widget_event(info.widgets.pause,/Nowait, /save_hourglass)
	endif else begin
	    ;  If put a hourglass in WIN, it will not get the signal of stop or pause widget
	    result = widget_event(info.widgets.stop,/Nowait)
	    result = widget_event(info.widgets.pause,/Nowai)
	endelse
	for j=0L, num_y-1 do begin
	    oplot,[hdf_data_x(i), hdf_data_x(i)],[hdf_data_y(j), hdf_data_y(j)], $
		MAX_VALUE = info.filldata, psym = plot_symbol, $
		linestyle=info.style.linetype, thick = info.style.linethick, $
		symsize = info.style.symbolsize, color=my_color(j,i)
	endfor
	i = i + 1
    endwhile
    !UserStop = 1
    !UserPause = 1
    !UserDone = 1
    widget_control, set_button=0, info.widgets.pause
    ;endfor
endelse

if info.color_bar eq 1 then begin
   temp_name = info.subset.data(this_subset).src_unitname
   temp_name = temp_name(0)
   temp_length = strlen(temp_name)
   unitlabel = ''
   if (temp_length gt 0) then begin
	dot=strpos(temp_name,'N/A')
	if( dot eq -1) then unitlabel = strmid(temp_name,2,temp_length-2)
   endif
   ; x_location = !P.Position(0) + (!P.Position(2) - !P.Position(0))/2. - 0.22
   x_bar_location = 20.0 * info.greenwich.barsize
   x_location = !P.Position(0) + (!P.Position(2) - !P.Position(0))/2. - x_bar_location
   y_location = !y.window(0) + 0.08
   if info.greenwich.with_level eq 1 then $
	draw_contour_bar, clevel, z_min, z_max, y_location, x_location, n_level, info.char.size, $
	    info.char.font, unitlabel, vlevel, info.greenwich.baddata, info.greenwich.setformat, $
	    info.greenwich.bformat, info.greenwich.colborder, info.greenwich.displaybad, $
	    deltx=info.greenwich.barsize $
   else draw_color_bar, top_color, z_min, z_max, y_location, x_location, info.char.size, $
	info.char.font, unitlabel, info.greenwich.setformat, info.greenwich.bformat, $
	deltx=info.greenwich.barsize
;   draw_color_bar, top_color, z_min, z_max, y_location, x_location, $
;	info.char.size, info.char.font, unitlabel, info.greenwich.setformat, $
;	info.greenwich.bformat, deltx=info.greenwich.barsize
endif

if info.subset.data(this_subset).src_crit_flag eq 1 then begin
	if !D.Name eq 'PS' or !D.Name eq 'PRINTER' then begin
		charsize = 0.9*info.char.size
		y_location = 0.125
	endif else begin
		charsize = info.char.size
		y_location = 0.11
	endelse
	;xyouts, !P.Position(0), !P.Position(1)-y_location, crit_string, /NORMAL, $
	xyouts, 0.08, !P.Position(1)-y_location, crit_string, /NORMAL, $
		font=info.char.font, charsize=charsize
endif

if info.addtext.key eq 1 then write_add_text, info

test = !d.flags and 128
if test ne 0 then begin
    ;image = tvrd()
    image = get_image24()
    if ptr_valid(info.overlay.image) then ptr_free, info.overlay.image
	info.overlay.image = ptr_new(image, /NO_COPY)
endif

;  Save the hdf_data_z for profile
;if plot_type eq 1 then begin
;    if ptr_valid(info.browse_image.aarray) then ptr_free, info.browse_image.aarray
;	info.browse_image.aarray = ptr_new(hdf_data_z, /no_copy)
;endif

if info.overlay.flag eq 1 then do_overlay, info

if !D.Name eq 'PS' or !D.Name eq 'PRINTER' then begin
	!X.CHARSIZE = old_charsize
	!Y.CHARSIZE = old_charsize
endif
 
!P.Position = [ 0.0 , 0.0 , 0.0 , 0.0]

;  save the image for do not display feature
test = !d.flags and 128
;if !D.Name ne 'PS' and !D.NAME ne 'PRINTER' then begin
if test ne 0 then begin
    ;image = tvrd()
    image = get_image24()
    if ptr_valid(info.browse_image.image) then ptr_free, info.browse_image.image
	info.browse_image.image = ptr_new(image, /NO_COPY)
endif

temp_list = strlowcase(info.name_list_sds)
check_top = strpos(temp_list, 'top')
sub_check = where(check_top ne -1, count)
if count eq 0 then top_list = 'None' $
    else top_list = ['All Descend', 'All Ascend', 'Default', info.name_list_sds(sub_check)]

base_valid = widget_info(info.browse_image.base, /VALID_ID)
if (print_flag eq 0 or base_valid eq 0) and (!d.name ne 'PS' and !d.name ne 'PRINTER') then begin
    info.subset_locate = 1
    WIDGET_CONTROL, info.widgets.location, SENSITIVE = info.subset_locate
    info.view.p_old = !P
    info.view.d_old = !D
    info.view.x_old = !X
    info.view.y_old = !Y
;    name_of_data = 'Show Individual profile for '+ztitle
;    plot_profile_window, name_of_data, info
endif

; reset the info.greenwich.in_level and info.greenwich.with_level
info.greenwich.with_level = save_with_level
info.greenwich.in_level   = save_in_level
info.axis_state = save_axis_state

;widget_control, set_uvalue=info, info.widgets.base
widget_control, set_uvalue=info, info.base
if (widget_info(info.browse_image.base, /VALID_ID)) then $
    widget_control, set_uvalue=info, info.browse_image.base

if info.browse_image.feature eq 1 then redisplay_feature, this_subset, top_list, info

end

;--------------------------------------------------------------------------------
pro plot_profile_window, name_of_data, info

pro_name = 'plot_profile_window'
@getinfo

;-----------------------------------------------------
; Create a new plot window - allow multiple windows
;-----------------------------------------------------
; put a menubar on this window if possible
;

window_id_old = !d.window
base=widget_base( COLUMN=1, MAP=1, $
    TITLE=name_of_data, MBAR=this_menubar)

if info.version lt 5.3 then begin 
  if info.gif_out.gif_flag eq 1 and info.gif_out.png_flag eq 0 then begin
    the_menu_items= [ $
	{ CW_PDMENU_S,       1, 'File' }, $
	{ CW_PDMENU_S,       0, 'Save Postscript...' }, $
	{ CW_PDMENU_S,       0, 'Save EPS Portrait' }, $
	{ CW_PDMENU_S,       0, 'Save EPS Landscape' }, $
	{ CW_PDMENU_S,       0, 'Save GIF' }, $
	{ CW_PDMENU_S,       0, 'Print...' }, $
	{ CW_PDMENU_S,       0, 'Print Viewgraph...' }, $
	{ CW_PDMENU_S,       0, 'Display Profile Data' }, $
	{ CW_PDMENU_S,       0, 'Export Profile Data' }, $
	{ CW_PDMENU_S,	     0, 'Change Preferences' }, $
	{ CW_PDMENU_S,       2, 'Close' } $
	]
  endif else if info.gif_out.gif_flag eq 0 and info.gif_out.png_flag eq 1 then begin
    the_menu_items= [ $
	{ CW_PDMENU_S,       1, 'File' }, $
	{ CW_PDMENU_S,       0, 'Save Postscript...' }, $
	{ CW_PDMENU_S,       0, 'Save EPS Portrait' }, $
	{ CW_PDMENU_S,       0, 'Save EPS Landscape' }, $
	{ CW_PDMENU_S,       0, 'Save PNG' }, $
	{ CW_PDMENU_S,       0, 'Print...' }, $
	{ CW_PDMENU_S,       0, 'Print Viewgraph...' }, $
	{ CW_PDMENU_S,       0, 'Display Profile Data' }, $
	{ CW_PDMENU_S,       0, 'Export Profile Data' }, $
	{ CW_PDMENU_S,       0, 'Change Preferences' }, $
	{ CW_PDMENU_S,       2, 'Close' } $
	]
  endif else if info.gif_out.gif_flag eq 1 and info.gif_out.png_flag eq 1 then begin
    the_menu_items= [ $
	{ CW_PDMENU_S,       1, 'File' }, $
	{ CW_PDMENU_S,       0, 'Save Postscript...' }, $
	{ CW_PDMENU_S,       0, 'Save EPS Portrait' }, $
	{ CW_PDMENU_S,       0, 'Save EPS Landscape' }, $
	{ CW_PDMENU_S,       0, 'Save GIF' }, $
	{ CW_PDMENU_S,       0, 'Save PNG' }, $
	{ CW_PDMENU_S,       0, 'Print...' }, $
	{ CW_PDMENU_S,       0, 'Print Viewgraph...' }, $
	{ CW_PDMENU_S,       0, 'Display Profile Data' }, $
	{ CW_PDMENU_S,       0, 'Export Profile Data' }, $
	{ CW_PDMENU_S,       0, 'Change Preferences' }, $
	{ CW_PDMENU_S,       2, 'Close' } $
	]
  endif else begin
    the_menu_items= [ $
	{ CW_PDMENU_S,       1, 'File' }, $
	{ CW_PDMENU_S,       0, 'Save Postscript...' }, $
	{ CW_PDMENU_S,       0, 'Save EPS Portrait' }, $
	{ CW_PDMENU_S,       0, 'Save EPS Landscape' }, $
;	{ CW_PDMENU_S,       0, 'Save GIF' }, $
;	{ CW_PDMENU_S,       0, 'Save PNG' }, $
	{ CW_PDMENU_S,       0, 'Print...' }, $
	{ CW_PDMENU_S,       0, 'Print Viewgraph...' }, $
	{ CW_PDMENU_S,       0, 'Display Profile Data' }, $
	{ CW_PDMENU_S,       0, 'Export Profile Data' }, $
	{ CW_PDMENU_S,       0, 'Change Preferences' }, $
	{ CW_PDMENU_S,       2, 'Close' } $
	]
  endelse
endif else begin
    the_menu_items= [ $
	{ CW_PDMENU_S,       1, 'File' }, $
	{ CW_PDMENU_S,       0, 'Save Postscript...' }, $
	{ CW_PDMENU_S,       0, 'Save EPS Portrait' }, $
	{ CW_PDMENU_S,       0, 'Save EPS Landscape' }, $
	{ CW_PDMENU_S,       0, 'Save Image' }, $
	{ CW_PDMENU_S,       0, 'Print...' }, $
	{ CW_PDMENU_S,       0, 'Print Viewgraph...' }, $
	{ CW_PDMENU_S,       0, 'Display Profile Data' }, $
	{ CW_PDMENU_S,       0, 'Export Profile Data' }, $
	{ CW_PDMENU_S,       0, 'Change Preferences' }, $
	{ CW_PDMENU_S,       2, 'Close' } $
	]
endelse

the_menu=cw_pdmenu(this_menubar, the_menu_items, /return_full_name, $
	FONT=info.font, uvalue='PROFILE', /mbar)

helpmenu = widget_button(this_menubar, FONT=info.font, value='Help', /MENU, /HELP)

user_guide = widget_button(helpmenu, FONT=info.font, value='User Guide', $
	uvalue='userguide')

user_guide = widget_button(helpmenu, FONT=info.font, value='Release Note', $
	uvalue='releasenote')

idlhelpbut = widget_button(helpmenu, FONT=info.font, value='IDL Online Help', $
	uvalue='IDLhelp')

about_viewhdf = widget_button(helpmenu, value='About View_HDF...', FONT=info.font, $
	uvalue='aboutviewhdf')

top_color = info.top_color
screen_xsize = 480
screen_ysize = 640

profile_base = widget_base(base, row=1, map=1, space=5)

control_base=widget_base(profile_base, column=1, MAP=1, EVENT_PRO = 'show_profile')

temp_list = strlowcase(info.name_list_sds)
check_top = strpos(temp_list, 'top')
sub_check = where(check_top ne -1, count)
if count eq 0 then top_list = 'None' $
    else top_list = ['All Descend', 'All Ascend', 'Default', info.name_list_sds(sub_check)]
    ;else top_list = ['Default', info.name_list_sds(sub_check)]

;check_res = strpos(temp_list, 'resolution')
check_res = strpos(temp_list, info.browse_image.rootname)
sub_check = where(check_res ne -1, count)
if count eq 0 then resolution_list = 'Default' $
    else resolution_list = info.name_list_sds(sub_check)
;  Get rid of threshold
temp_list = strlowcase(resolution_list)
check_res = strpos(temp_list, 'threshold')
sub_check = where(check_res eq -1, count)
if count eq 0 then resolution_list = 'Default' $
    else resolution_list = resolution_list(sub_check)

num_resolution = n_elements(resolution_list)
res_list = 'full'
root_length = strlen(info.browse_image.rootname)
for i = 0, num_resolution-1 do begin
    temp_name = resolution_list(i)
    ltemp_name = strlowcase(temp_name)
    loc = strpos(ltemp_name,'km')
    if loc ne -1 then begin
	rloc = rstrpos(ltemp_name,'_',loc)
	if rloc ne -1 then begin
	    length = loc - rloc + 1
	    temp_res = strmid(temp_name,rloc+1,length)
	    res_list = [res_list, temp_res]
	endif
    endif else begin
	rloc = rstrpos(ltemp_name,'_')
	if rloc ne - 1 then begin
	    length = strpos(ltemp_name,'[')
	    if length eq -1 then length = strlen(ltemp_name)
	    if rloc eq length - 2 and length eq root_length + 2 then begin
		temp_res = strcompress(strmid(temp_name, length - 1, 1), /REMOVE_ALL)
		res_list = [res_list, temp_res]
	    endif
	endif
    endelse
endfor

profile_widget = widget_droplist(control_base, VALUE=res_list, $
    TITLE='Profile Resolution:', uvalue=res_list, $
    EVENT_PRO='select_profile', FONT=info.font, /ALIGN_CENTER)

info.browse_image.xwidget = CW_FIELD(control_base, $
    /FLOATING, /ROW, XSIZE = 10, YSIZE=1, TITLE = 'Location: ', $
    UVALUE = 'location', VALUE = info.browse_image.xvalue, $
    FONT = info.font, FIELDFONT = info.font, /RETURN_EVENTS)

group3=widget_base(control_base, row=1,map=1, space=5, /align_center)

info.browse_image.pwidget = CW_FIELD(group3, $
    /LONG, /ROW, XSIZE = 10, YSIZE=1, TITLE = 'Profile #: ', $
    UVALUE = 'number', VALUE = info.browse_image.pvalue, $
    FONT = info.font, FIELDFONT = info.font, /RETURN_EVENTS)

button1=widget_button(group3, FONT=info.font, EVENT_PRO='down_profile', VALUE="  <<  ",$
    /ALIGN_CENTER)

button2=widget_button(group3, FONT=info.font, EVENT_PRO='up_profile', VALUE="  >>  ",$
    /ALIGN_CENTER)

range_base = widget_base(control_base, column=1,map=1, space=5, frame=2, /align_center)

range_list = [ 'Auto', 'Manual']
range_widget = widget_droplist(range_base, VALUE=range_list, TITLE='Range Set:', $
    EVENT_PRO='range_profile', FONT=info.font, /ALIGN_CENTER)

if info.browse_image.xstart eq info.browse_image.xend then begin
    info.browse_image.xstart = info.range.x_start
    info.browse_image.xend = info.range.x_end
endif

if info.browse_image.ystart eq info.browse_image.yend then begin
    info.browse_image.ystart = info.range.y_start
    info.browse_image.yend = info.range.y_end
endif

info.browse_image.rwidget = widget_base(range_base, row=1,map=1, $
    /align_center)

column1 = widget_base(info.browse_image.rwidget, column=1,map=1, $
    /align_center)

first_field = widget_label(column1, /ALIGN_CENTER, FONT=info.font, $
    value='   Start')

info.browse_image.xswidget = CW_FIELD(column1, /FLOAT, /ROW, XSIZE = 10, $
    YSIZE=1, TITLE = 'X:', VALUE = info.browse_image.xstart, $
    FONT = info.font, FIELDFONT = info.font)

info.browse_image.yswidget = CW_FIELD(column1, /FLOAT, /ROW, XSIZE = 10, $
    YSIZE=1, TITLE = 'Y:', VALUE = info.browse_image.ystart, $
    FONT = info.font, FIELDFONT = info.font)

column2 = widget_base(info.browse_image.rwidget, column=1,map=1, $
    /align_center)

first_field = widget_label(column2, /ALIGN_CENTER, FONT=info.font, $
    value='End')

info.browse_image.xewidget = CW_FIELD(column2, /FLOAT, /ROW, XSIZE = 10, $
    YSIZE=1, TITLE = ' ', VALUE = info.browse_image.xend, $
    FONT = info.font, FIELDFONT = info.font)

info.browse_image.yewidget = CW_FIELD(column2, /FLOAT, /ROW, XSIZE = 10, $
    YSIZE=1, TITLE = ' ', VALUE = info.browse_image.yend, $
    FONT = info.font, FIELDFONT = info.font)

feature_base = widget_base(control_base, column=1,map=1, space=10, frame=2, /align_center)

feature_list = [ 'Do Not Display Boundaries', 'Display Boundaries']
feat_widget = widget_droplist(feature_base, VALUE=feature_list, $
    EVENT_PRO='display_feature', uvalue=top_list, FONT=info.font, /ALIGN_CENTER)

info.browse_image.twidget = widget_base(feature_base, column=1,map=1, $
    space=10, /align_center)

name_widget = widget_droplist(info.browse_image.twidget, VALUE=top_list, $
    EVENT_PRO='set_feature', FONT=info.font, /ALIGN_CENTER)

group1=widget_base(info.browse_image.twidget, row=1,map=1, space=20, /align_center)

button1=widget_button(group1, FONT=info.font, EVENT_PRO='add_feature', VALUE="Add",$
    uvalue=top_list, /ALIGN_CENTER)

button2=widget_button(group1, FONT=info.font, EVENT_PRO='remove_feature', VALUE="Remove",$
    uvalue=top_list, /ALIGN_CENTER)

fcol_list = ['Do not use predefined color','Use predefined color']
fcol_widget = widget_droplist(info.browse_image.twidget, VALUE=fcol_list, $
    EVENT_PRO='set_feature_color', FONT=info.font, /ALIGN_CENTER)

thre_list = ['Do Not Display Threshold', ' Display Threshold']
thre_widget = widget_droplist(control_base, VALUE=thre_list, $
    EVENT_PRO='display_threshold', FONT=info.font, /ALIGN_CENTER)

group3=widget_base(control_base, row=1,map=1, /align_center)
line_list = ['Do Not Add Line', 'Add Line']
line_widget = widget_droplist(group3, VALUE=line_list, $
    EVENT_PRO='display_line', FONT=info.font, /ALIGN_CENTER)

info.browse_image.linewidget = CW_FIELD(group3, /FLOAT, /ROW, XSIZE = 5, $
    YSIZE=1, TITLE = ' ', VALUE = info.browse_image.line, $
    FONT = info.font, FIELDFONT = info.font)

group2=widget_base(control_base, row=1,map=1, space=20, /align_center)

button1=widget_button(group2, FONT=info.font, EVENT_PRO='show_profile', VALUE="Plot",$
    /ALIGN_CENTER, uvalue='plot')

button2=widget_button(group2, FONT=info.font, EVENT_PRO='doneCB', VALUE="Close",$
    /ALIGN_CENTER)

button3=widget_button(group2, FONT=info.font, EVENT_PRO='unset_location', VALUE="End",$
    /ALIGN_CENTER)

draw_base=widget_base(profile_base, column=1, MAP=1)

draw_id=widget_draw(draw_base, retain=2, xsize=screen_xsize,ysize=screen_ysize, $
    colors=top_color)

widget_control, /realize, base

widget_control, draw_id, GET_VALUE=window_id
info.browse_image.base = base
info.browse_image.window_id = window_id

wset,window_id_old

subscript = where (res_list eq info.browse_image.profile, count)
if count eq 0 then temp = 0 else temp = subscript(0)
widget_control, set_droplist_select=temp, profile_widget
widget_control, set_droplist_select=info.browse_image.feature, feat_widget
widget_control, set_droplist_select=info.browse_image.range, range_widget
num_feature = n_elements(top_list)
if info.browse_image.findex gt num_feature or info.browse_image.findex lt 0 then $
    info.browse_image.findex = 0
widget_control, set_droplist_select=info.browse_image.findex, name_widget
widget_control, set_droplist_select=info.browse_image.setfcolor, fcol_widget
widget_control, info.browse_image.twidget, sensitive = info.browse_image.feature
widget_control, info.browse_image.rwidget, sensitive = info.browse_image.range
widget_control, set_droplist_select=info.browse_image.threflag, thre_widget
widget_control, set_droplist_select=info.browse_image.lineflag, line_widget

widget_control, set_uvalue=info, info.browse_image.base
widget_control, set_uvalue=info, info.base
widget_control, set_uvalue=info, base

xmanager, 'main_widget', base

end

;--------------------------------------------------------------------------------
pro range_profile, event

pro_name = 'range_profile'
@getinfo

widget_control, get_uvalue=info, event.top

info.browse_image.range = event.index

widget_control, info.browse_image.rwidget, sensitive = info.browse_image.range

widget_control, set_uvalue=info, event.top
if(widget_info(info.widgets.base, /VALID_ID)) then $
    widget_control, set_uvalue=info, info.widgets.base
widget_control, set_uvalue=info, info.base

end

;--------------------------------------------------------------------------------
pro draw_profile, x_location, p_number, flag, info 

pro_name = 'draw_profile'
@getinfo

; x_location is location in the plot
; p_number is profile number in the current set profile

if not ptr_valid(info.browse_image.z) then return

hdf_data_x = *info.browse_image.x
if info.graph_style eq 'Browse Image With Average' then begin
    hdf_data_z = *info.browse_image.aarray
endif else begin
    hdf_data_z = *info.browse_image.z
endelse
num_x = n_elements(hdf_data_x)
proscale = info.browse_image.proscale
if proscale eq 0 then proscale = 1

xarray = *info.browse_image.xarray
yarray = *info.browse_image.yarray
xindex = info.browse_image.xindex
scale_ratio = info.browse_image.scale/proscale

if xindex eq -1 then begin
    numx = n_elements(xarray)
    x_array = xarray - 1
    x_array = [x_array, xarray(numx - 1)]
    xarray = x_array  * info.browse_image.scale
endif

x_diff = abs(x_location - info.browse_image.xvalue)
if flag eq 2 then begin
	if (x_diff gt 0.0001) and $
	    (p_number eq info.browse_image.pvalue) then begin
		flag = 0
	endif else if (x_diff le 0.0001) and $
	    (p_number ne info.browse_image.pvalue) then begin
		flag = 1
	endif else if (x_diff gt 0.0001) and $
            (p_number ne info.browse_image.pvalue) then begin
		flag = 0
	endif else flag = 1
endif

if flag eq 0 then begin
	max_range = max(xarray, min=min_range)
	if x_location lt min_range then x_location = min_range
	if x_location gt max_range then x_location = max_range
	if info.browse_image.scale eq 1 then begin
	    hdf_diff = abs(xarray - x_location)
	endif else begin
	    hdf_diff = xarray - x_location
	    subscript = where(hdf_diff gt 0.0, count)
	    if count ne 0 then hdf_diff(subscript) = 5*info.browse_image.scale
	    hdf_diff = abs(hdf_diff)
	endelse
	min_x = min(hdf_diff)
	subscript = where(hdf_diff eq min_x, count)
	if count eq 0 then return
	profile_location = xarray(subscript(0))
	profile_number = long(subscript(0) * scale_ratio) + 1
	deltx = x_location - xarray(subscript(0))
	num_array = n_elements(xarray)
	if subscript(0) ge num_array-1 then $
	    delta = xarray(subscript(0)) - xarray(subscript(0)-1) $
	    else delta = xarray(subscript(0)+1) - xarray(subscript(0))
        add_prof = (deltx/delta) * scale_ratio
	profile_number = profile_number + long(add_prof)
	swift_ratio = info.browse_image.swift
	swift_portion = subscript(0) * scale_ratio
	swift_portion = swift_portion - long(swift_portion)
	if swift_portion ge (1.0 - swift_ratio) then profile_number = profile_number + 1
	if profile_number gt num_x then profile_number = num_x
endif else if flag eq 1 then begin
	num_xarray = n_elements(xarray)
	if p_number lt 1 then p_number = 1
	if p_number gt num_x then p_number = num_x
	loc_index = fix((p_number-1) /scale_ratio + 0.5)
	if loc_index ge num_xarray then loc_index = num_xarray-1
	profile_location = xarray(loc_index)
	profile_number = p_number
endif else return

info.browse_image.xvalue = profile_location
info.browse_image.pvalue = profile_number

if(widget_info(info.browse_image.base, /VALID_ID)) then begin
    widget_control, set_value=profile_location, info.browse_image.xwidget
    widget_control, set_value=profile_number, info.browse_image.pwidget
endif

if info.graph_style eq 'Browse Image With Average' then begin
    cur_pro_num = long((profile_number-1) / info.browse_image.npvalue)
    temp_x = hdf_data_z(*,cur_pro_num)
endif else begin
    temp_x = hdf_data_z(*,profile_number-1)
endelse
;  Store the profile data for export or display
if ptr_valid(info.browse_image.parray) then ptr_free, info.browse_image.parray
    info.browse_image.parray = ptr_new(temp_x)
info.browse_image.pindex = profile_number
temp_y = yarray
size_x = size(temp_x)
size_y = size(temp_y)
n_size_x = n_elements(size_x)
n_size_y = n_elements(size_y)
idltype = size_x(n_size_x - 2)
this_type = convert_idltype_hdftype(idltype)
filldata_value_x = get_filldata_value(this_type, info.filldata)
if filldata_value_x gt info.filldata then filldata_value_x = info.filldata
max_value_x = get_max_value(this_type, info.filldata)
if info.filldata gt 0 then begin
    if max_value_x gt info.filldata then max_value_x = info.filldata
endif

if filldata_value_x gt 0 then begin
    subscript = where(temp_x lt filldata_value_x, count)
endif else begin
    subscript = where(temp_x gt filldata_value_x, count)
endelse
if(count ne 0) then begin
	temp_x = temp_x(subscript)
	temp_y = temp_y(subscript)
endif else return

idltype = size_y(n_size_y - 2)
this_type = convert_idltype_hdftype(idltype)
filldata_value_y = get_filldata_value(this_type, info.filldata)
if filldata_value_y gt info.filldata then filldata_value_y = info.filldata
max_value_y = get_max_value(this_type, info.filldata)
if info.filldata gt 0 then begin
    if max_value_y gt info.filldata then max_value_y = info.filldata
endif

if filldata_value_y gt 0 then begin
    subscript = where(temp_y lt filldata_value_y, count)
endif else begin
    subscript = where(temp_y gt filldata_value_y, count)
endelse
if(count ne 0) then begin
	temp_x = temp_x(subscript)
	temp_y = temp_y(subscript)
endif else return

if max_value_y gt max_value_x then max_value = max_value_y $
	else max_value = max_value_x

set_axis_ranges, info, YRange, Ystyle, XRange, Xstyle, ZRange, Zstyle

if info.browse_image.range eq 1 then begin
    widget_control, info.browse_image.xswidget, get_value=xstart
    widget_control, info.browse_image.xewidget, get_value=xend
    widget_control, info.browse_image.yswidget, get_value=ystart
    widget_control, info.browse_image.yewidget, get_value=yend
    info.browse_image.xstart = xstart
    info.browse_image.xend = xend
    info.browse_image.ystart = ystart
    info.browse_image.yend = yend
    ZRange = [xstart, xend]
    YRange = [ystart, yend]
    Zstyle = 3
    Ystyle = 3
endif

get_data, y_index, x_index, z_index, info
y_index = y_index(0)
x_index = x_index(0)
z_index = z_index(0)

dot=strpos(info.field_name.x,'[')
if dot ne -1 then xtitle=strmid(info.field_name.x,0,dot) $
	else xtitle = info.field_name.x
	dot=strpos(info.field_name.y,'[')
if dot ne -1 then ytitle=strmid(info.field_name.y,0,dot) $
	else ytitle = info.field_name.y
dot=strpos(info.field_name.z,'[')
if dot ne -1 then ztitle=strmid(info.field_name.z,0,dot) $
	else ztitle = info.field_name.z

if y_index ne -1 then begin
    temp_name = info.subset.data(y_index).src_unitname
    temp_name = temp_name(0)
    dot=strpos(temp_name,'N/A')
    if( dot eq -1) then ytitle = ytitle + temp_name
endif

temp_name = info.subset.data(z_index).src_unitname
temp_name = temp_name(0)
dot=strpos(temp_name,'N/A')
if( dot eq -1) then ztitle = ztitle + temp_name

;top_title = 'Profile ' + strcompress(string(profile_number), /REMOVE_ALL) + $
top_title = 'Profile ' + strcompress(string(long(profile_number)), /REMOVE_ALL) + $
	' at ' + xtitle + ' = ' + $
	strcompress(string(profile_location), /REMOVE_ALL)
if x_index ne -1 then begin
    temp_name = info.subset.data(x_index).src_unitname
    temp_name = temp_name(0)
    dot=strpos(temp_name,'N/A')
    if( dot eq -1) then top_title = top_title + temp_name
endif 
the_title = 'Show LIDAR ' + top_title

;window, 5, xsize=640, ysize=480, title=the_title, retain=2
if !D.Name ne 'PS' and !D.Name ne 'PRINTER' then begin
    window_id_old = !d.window
    wset, info.browse_image.window_id
    wshow, !d.window
endif
if info.style.symbolline eq 1 then plot_symbol = - info.style.symbol $
	else plot_symbol = info.style.symbol
get_ticklen, info.style.grid, xticklen, yticklen 

if info.style.xlog gt 0 then begin
    if info.browse_image.range eq 0 then begin
	z_max = max(temp_x, min=z_min)
    endif else begin
	z_max = xend
	z_min = xstart
    endelse
	ZRange = set_log_range(ZRange, z_min, z_max)
endif

if info.style.ylog gt 0 then begin
    if info.browse_image.range eq 0 then begin
	y_max = max(temp_y, min=y_min)
    endif else begin
	y_max = yend
	y_min = ystart
    endelse
	YRange = set_log_range(YRange, y_min, y_max)
endif

top_color = !d.n_colors - 2
if top_color gt 254 then top_color = 254
n_level = info.greenwich.n_level
color_interval = top_color/float(n_level)
tempa=findgen(n_level)
clevel = fix(color_interval * (tempa(*) + 1))

middle_color = fix(n_level/2)

start_color = fix((clevel(middle_color) + clevel(middle_color+1))/2)
r = [160]
tvlct, r, r, r, start_color

if info.browse_image.feature eq 1 then top_color = start_color $
     else top_color = clevel(middle_color)

linethick = 2.0

axis_state = 0
if((zrange[0] ne zrange[1]) and (yrange[0] ne yrange[1])) then begin
    axis_state = 4
endif else if(zrange[0] ne zrange[1]) then begin
    axis_state = 1
endif else if(yrange[0] ne yrange[1]) then begin
    axis_state = 2
endif

if axis_state gt 0 then begin
    fit_flag = 0
    fit_data_range, axis_state, fit_flag, 0, 1, zrange, yrange, 0, 0, temp_x, $
	temp_y, 0, 0, 0
    if fit_flag eq 1 then return
endif

if !D.Name ne 'WIN' and info.char.font ne 0 then begin
    ztitle= '!C' + ztitle + '!C'
endif else begin
    ztitle = ztitle + '!C'
endelse
plot, temp_x, temp_y, /YNOZERO, /NODATA, font=info.char.font, $
	position = [0.10, 0.10, 0.95, 0.95], $
	charsize=info.char.size, xtitle=ztitle, ytitle=ytitle, title=top_title, $
	psym = plot_symbol, linestyle=info.style.linetype, $
	symsize=info.style.symbolsize, xrange=ZRange, yrange=YRange, $
	xstyle=Zstyle, ystyle=Ystyle, xticklen=xticklen, yticklen=yticklen, $
	subtitle=info.subset.data(info.subset.selected).src_filename, $
	MAX_VALUE = max_value

;print,'color for profile = ',top_color
oplot,temp_x, temp_y, psym = plot_symbol, linestyle=info.style.linetype, $
    symsize=info.style.symbolsize, color=top_color, thick=linethick, $
    MAX_VALUE = max_value

if info.browse_image.lineflag eq 1 then begin
    widget_control, info.browse_image.linewidget, get_value=line_value
    info.browse_image.line = line_value
    temp_x(*) = line_value
    oplot,temp_x,temp_y, thick = info.style.linethick
endif

if info.browse_image.threflag eq 1 then begin
    if ptr_valid(info.browse_image.y) then begin
	temp_y = yarray
	hdf_data_y = *info.browse_image.y
	thr_array = reform(hdf_data_y(*,profile_number-1))

	if axis_state gt 0 then begin
	    fit_flag = 0
	    fit_data_range, axis_state, fit_flag, 0, 1, zrange, yrange, 0, 0, thr_array, $
		temp_y, 0, 0, 0
	    if fit_flag eq 1 then return
	endif
	; oplot,thr_array, temp_y, color=!P.COLOR, thick=linethick
	;print,'color for threshold = ',clevel[fix(n_level/3)]
	oplot,thr_array, temp_y, color=clevel[fix(n_level/3)], thick=linethick
    endif
endif
	
if info.browse_image.feature eq 1 then begin
    if info.graph_style eq 'Browse Image With Average' then begin
	cur_pro_num = long((profile_number-1) / info.browse_image.npvalue)
	temp_x = reform(hdf_data_z(*,cur_pro_num))
    endif else begin
	temp_x = reform(hdf_data_z(*,profile_number-1))
    endelse
    temp_y = yarray
    max_yarray = max(temp_y,min=min_yarray)
    if max_yarray gt 40.0 then top_flag = 1 else top_flag = 0
    if ptr_valid(info.browse_image.tarray) then begin
	t_array = *info.browse_image.tarray
	b_array = *info.browse_image.barray
	top_array = reform(t_array(*,profile_number-1))
	base_array = reform(b_array(*,profile_number-1))
	num_top = n_elements(top_array)
	num_temp_x = n_elements(temp_x)
	for i = 0, num_top-1 do begin
	    if top_array(i) ne 0 and base_array(i) ne 0 then begin
		;start_feature = top_array(i)-1
		;end_feature = base_array(i)-1
		if top_flag eq 1 then begin
		    start_feature = top_array(i) - 1
		    if start_feature lt 0 then start_feature = 0
		    end_feature = base_array(i)
		endif else begin
		    subscript = where(temp_y le top_array(i), count)
		    if count gt 0 then start_feature = subscript(0) - 1 $
			else start_feature = 0
		    if start_feature lt 0 then start_feature = 0
		    subscript = where(temp_y le base_array(i), count)
		    if count gt 0 then end_feature = subscript(0) $
			else end_feature = -1
		endelse
		if end_feature gt 0 then begin
		    x_array = temp_x(start_feature:end_feature)
		    y_array = temp_y(start_feature:end_feature)
		    if((axis_state eq 1) or (axis_state eq 4)) then begin
			if(zrange[0] lt zrange[1]) then begin
			    sub_x = where(x_array ge zrange[0] and x_array le zrange[1], count)
			endif else begin
			    sub_x = where(x_array le zrange[0] and x_array ge zrange[1], count)
			endelse
			if count ne 0 then begin
			    x_array = x_array[sub_x]
			    y_array = y_array[sub_x]
			endif
		    endif

		    if((axis_state eq 2) or (axis_state eq 4)) then begin
			if(yrange[0] lt yrange[1]) then begin
			    sub_y = where(y_array ge yrange[0] and y_array le yrange[1], count)
			endif else begin
			    sub_y = where(y_array le yrange[0] and y_array ge yrange[1], count)
			endelse
			if count ne 0 then begin
			    x_array = x_array[sub_y]
			    y_array = y_array[sub_y]
			endif
		    endif

		    ;print,'color for feature = ',clevel(middle_color)
		    oplot, x_array, y_array, color=clevel(middle_color), thick=linethick
		endif
	    endif
	endfor
    endif
; final threshold is using clevel(11)
endif

if !D.Name ne 'PS' and !D.Name ne 'PRINTER' then wset,window_id_old

if(widget_info(info.widgets.base, /VALID_ID)) then $
	widget_control, set_uvalue=info, info.widgets.base
if(widget_info(info.browse_image.base, /VALID_ID)) then $
	widget_control, set_uvalue=info, info.browse_image.base

end

;--------------------------------------------------------------------------------
function set_vfm_image_colortable, vfm_type, feature_type

pro_name = 'set_vfm_image_colortable'
@getinfo1

;  Set the color index
; for vertical feature mask
if vfm_type eq 1 then begin
    hdf_data_x  = [  0,   0, 192,   0,   0, 255]
    hdf_data_y =  [  0,   0, 192, 220,   0, 255]
    hdf_data_z =  [  0, 255, 192, 255,   0, 255]
endif else if vfm_type eq 2 then begin
    hdf_data_x  = [  0,   0, 255,   0, 250, 192,   0, 255]
    hdf_data_y =  [  0,   0,   0, 255, 255, 192,   0, 255]
    hdf_data_z =  [  0, 255,   0,   0,   0, 192,   0, 255]
endif else begin
    if feature_type eq 3 then begin
	hdf_data_x  = [  0,   0,   0, 250, 255, 192, 176,   0,   0, 255]
	hdf_data_y =  [  0,   0, 255, 255,   0, 192,  80,   0, 220, 255]
	hdf_data_z =  [  0, 255,   0,   0,   0, 192,   0,   0, 255, 255]
    endif else if(feature_type eq 2 or feature_type eq 4) then begin
	hdf_data_x  = [  0,   0, 255,   0, 255, 250,   0, 192,   0, 255]
	hdf_data_y =  [  0,   0,   0, 220, 160, 255, 255, 192,   0, 255]
	hdf_data_z =  [  0, 255,   0, 255,   0,   0, 110, 192,   0, 255]
    endif else begin
	hdf_data_x  = [  0, 255,   0,   0, 255, 250,   0, 192,   0, 255]
	hdf_data_y =  [  0,   0,   0, 220, 160, 255, 255, 192,   0, 255]
	hdf_data_z =  [  0,   0, 255, 255,   0,   0, 110, 192,   0, 255]
    endelse
endelse

num_r = n_elements(hdf_data_x)
num_g = n_elements(hdf_data_y)
num_b = n_elements(hdf_data_z)

if(num_r le 256) and (num_r eq num_g) and (num_g eq num_b) and (num_r eq num_b) then begin
    top_color = !d.n_colors
    if top_color gt 256 then top_color = 256

    if num_r gt top_color then begin
	the_message = [ 'The number of input color is exceeded the', $
			'maximum color allowed!']
	result=dialog_message(the_message, title='View HDF Warning!')
	return, -1
    endif

    r1 = make_array(top_color, /byte, VALUE = 0)
    g1 = make_array(top_color, /byte, VALUE = 0)
    b1 = make_array(top_color, /byte, VALUE = 0)

    if num_r lt 20 then begin
	n_level = num_r-2
	num_color = top_color-2
	data_interval = double(num_color)/float(n_level)
	half_interval = fix(data_interval/2)

	tempa = findgen(n_level)
	clevel = fix(data_interval * (tempa(*) + 1))

	;  The first color is background or foreground (black)
	r1[0:half_interval-1] = hdf_data_x[0]
	g1[0:half_interval-1] = hdf_data_y[0]
	b1[0:half_interval-1] = hdf_data_z[0]

	;  assign the color table
	start_pos = fix(half_interval)
	for i = 1, num_r-3 do begin
	    end_pos = fix(clevel[i-1] + half_interval)
	    r1[start_pos:end_pos] = hdf_data_x[i]
	    g1[start_pos:end_pos] = hdf_data_y[i]
	    b1[start_pos:end_pos] = hdf_data_z[i]
	    start_pos = end_pos + 1
	endfor

	end_pos = num_color

	r1[start_pos:end_pos] = hdf_data_x[num_r-2]
	g1[start_pos:end_pos] = hdf_data_y[num_r-2]
	b1[start_pos:end_pos] = hdf_data_z[num_r-2]

	;  The last color is foreground or background, white
	start_pos = end_pos + 1
	if(start_pos gt num_color+1) then start_pos = num_color+1

	r1[start_pos:num_color+1] = hdf_data_x[num_r-1]
	g1[start_pos:num_color+1] = hdf_data_y[num_r-1]
	b1[start_pos:num_color+1] = hdf_data_z[num_r-1]
    endif else begin
	r1 = congrid(hdf_data_x, top_color, /minus_one)
	g1 = congrid(hdf_data_y, top_color, /minus_one)
	b1 = congrid(hdf_data_z, top_color, /minus_one)
    endelse

    tvlct, r1, g1, b1
endif else begin
    the_message = ['Number of date points for three subsets are not equal,', $
		   'or they are more than 256 values!']
    result=dialog_message(the_message, title='View HDF Warning!')
    return, -1
endelse

return, 0

end

;--------------------------------------------------------------------------------
function set_vfm_data, this_subset, info

pro_name = 'set_vfm_data'
@getinfo1

hdf_data = *info.subset.data(this_subset).src_data
if info.subset.data(this_subset).src_type_flag eq 1 then $
        hdf_data = hdf_data.components0

size_hdf_data = size(hdf_data)
if(size_hdf_data(0) eq 0 or size_hdf_data(0) gt 2) then begin
    the_message = [ 'Data set is not either 1 or 2 dimensional array', $
	'Vertical Feature Mask option is not valid']
    result= dialog_message(the_message, title='View HDF Message!')
    return, -1
endif

if(size_hdf_data(1) ne 5515) then begin
    the_message = [ 'The 2nd dimension of the data set is not equal to 5515', $
	'Vertical Feature Mask option is not valid']
    result= dialog_message(the_message, title='View HDF Message!')
    return, -1
endif

num_data = n_elements(hdf_data)
num_size_data = n_elements(size_hdf_data)

data_type = info.subset.data(this_subset).src_types(0)
if(data_type eq 25 and size_hdf_data(num_size_data-2) eq 5) then $
	hdf_data = long(hdf_data)
if data_type lt 19 then begin
	the_message = ['The data type of '+data_name+' is not integer.', $
		 'Do you want to change it to integer?', $
                'Press Cancel to cancel this action.']
        result=dialog_message(the_message, /Question, /Cancel, title='View HDF Question!')

        if result eq 'Yes' then begin
		if info.version lt 5.19 then begin
			hdf_data_temp = long(hdf_data)
		endif else begin
			hdf_data_temp = ulong(hdf_data)
		endelse
		hdf_data = hdf_data_temp
	endif else if result eq 'Cancel' then begin
		return, -1
	endif else begin
		result = dialog_message('The data type must be integer type!', $
		  title='View HDF Warning!')
		return, -1
	endelse
endif

filldata_value = get_filldata_value(data_type, info.filldata)
if filldata_value gt info.filldata then filldata_value = info.filldata
if info.version lt 5.19 then begin
    filldata = get_filldata_value(24, info.filldata)
endif else begin
    filldata = get_filldata_value(25, info.filldata)
endelse

if filldata_value gt 0 then begin
    subscript = where(hdf_data lt filldata_value, count)
endif else begin
    subscript = where(hdf_data gt filldata_value, count)
endelse
if (count eq 0) then begin
	result=dialog_message('All data are fill data!',$
	    title='View HDF Warning!')
	return, -1
endif

vfm_type = info.vfm.type
feature_type = info.vfm.feature

if vfm_type lt 0 or vfm_type gt 2 then begin
    the_message = ['The select Vertical Feature Mask type is wrong.', $
	'Please select again and do it again.']
    result=dialog_message(the_message, title='View HDF Error!')
    return, -1
endif

case vfm_type of
    1: begin
	start_bit = 5
	num_bit = 2
       end
    2: begin
	start_bit = 13
	num_bit = 3
       end
    else: begin
	start_bit = 0
	num_bit = 3
    end
endcase

hdf_data_z = get_bit_values(num_data,start_bit,num_bit,hdf_data,info.version)

hdf_data_temp = hdf_data_z(subscript)
z_max = max(hdf_data_temp,min=z_min)

if filldata_value gt 0 then begin
    subscript = where(hdf_data ge filldata_value, count)
endif else begin
    subscript = where(hdf_data le filldata_value, count)
endelse
if count ne 0 then hdf_data_z(subscript) = filldata

if vfm_type eq 0 then begin
    if feature_type gt 1 and feature_type lt 5 then begin
	subscript = where(hdf_data_z eq feature_type, count)
	if count eq 0 then begin
	    the_message = ['The selected Feature type is not found in the array.']
	    result=dialog_message(the_message, title='View HDF Warning!')
	    return, -1
	endif

	;notsub = where(hdf_data_z ne feature_type, notcount)
	;if notcount ne 0 then hdf_data_z(notsub) = filldata
	;if notcount ne 0 then hdf_data_z(notsub) = 0
	hdf_data_z[*, *] = 0
	start_bit = 9
	num_bit = 3
	hdf_data_x = get_bit_values(num_data,start_bit,num_bit,hdf_data,info.version)
	hdf_data_z(subscript) = hdf_data_x(subscript)
    endif
endif

return, hdf_data_z

end

;--------------------------------------------------------------------------------
function set_old_vfm_data, this_subset, info

pro_name = 'set_old_vfm_data'
@getinfo1

hdf_data = *info.subset.data(this_subset).src_data
if info.subset.data(this_subset).src_type_flag eq 1 then $
        hdf_data = hdf_data.components0

size_hdf_data = size(hdf_data)
if(size_hdf_data(0) eq 0 or size_hdf_data(0) gt 2) then begin
    the_message = [ 'Data set is not either 1 or 2 dimensional array', $
	'Vertical Feature Mask option is not valid']
    result= dialog_message(the_message, title='View HDF Message!')
    return, -1
endif

if(size_hdf_data(1) ne 5515) then begin
    the_message = [ 'The 2nd dimension of the data set is not equal to 5515', $
	'Vertical Feature Mask option is not valid']
    result= dialog_message(the_message, title='View HDF Message!')
    return, -1
endif

num_data = n_elements(hdf_data)
num_size_data = n_elements(size_hdf_data)

data_type = info.subset.data(this_subset).src_types(0)
if(data_type eq 25 and size_hdf_data(num_size_data-2) eq 5) then $
	hdf_data = long(hdf_data)
if data_type lt 19 then begin
	the_message = ['The data type of '+data_name+' is not integer.', $
		 'Do you want to change it to integer?', $
                'Press Cancel to cancel this action.']
        result=dialog_message(the_message, /Question, /Cancel, title='View HDF Question!')

        if result eq 'Yes' then begin
		if info.version lt 5.19 then begin
			hdf_data_temp = long(hdf_data)
		endif else begin
			hdf_data_temp = ulong(hdf_data)
		endelse
		hdf_data = hdf_data_temp
	endif else if result eq 'Cancel' then begin
		return, -1
	endif else begin
		result = dialog_message('The data type must be integer type!', $
		  title='View HDF Warning!')
		return, -1
	endelse
endif

filldata_value = get_filldata_value(data_type, info.filldata)
if filldata_value gt info.filldata then filldata_value = info.filldata
if info.version lt 5.19 then begin
    filldata = get_filldata_value(24, info.filldata)
endif else begin
    filldata = get_filldata_value(25, info.filldata)
endelse

if filldata_value gt 0 then begin
    subscript = where(hdf_data lt filldata_value, count)
endif else begin
    subscript = where(hdf_data gt filldata_value, count)
endelse
if (count eq 0) then begin
	result=dialog_message('All data are fill data!',$
	    title='View HDF Warning!')
	return, -1
endif

vfm_type = info.vfm.type
feature_type = info.vfm.feature

if vfm_type lt 0 or vfm_type gt 2 then begin
    the_message = ['The select Vertical Feature Mask type is wrong.', $
	'Please select again and do it again.']
    result=dialog_message(the_message, title='View HDF Error!')
    return, -1
endif

case vfm_type of
    1: begin
	start_bit = 5
	num_bit = 2
       end
    2: begin
	start_bit = 14
	num_bit = 3
       end
    else: begin
	start_bit = 0
	num_bit = 3
    end
endcase

hdf_data_z = get_bit_values(num_data,start_bit,num_bit,hdf_data,info.version)

hdf_data_temp = hdf_data_z(subscript)
z_max = max(hdf_data_temp,min=z_min)

if filldata_value gt 0 then begin
    subscript = where(hdf_data ge filldata_value, count)
endif else begin
    subscript = where(hdf_data le filldata_value, count)
endelse
if count ne 0 then hdf_data_z(subscript) = filldata

if vfm_type eq 0 then begin
    if feature_type gt 1 and feature_type lt 5 then begin
	subscript = where(hdf_data_z eq feature_type, count)
	if count eq 0 then begin
	    the_message = ['The selected Feature type is not found in the array.']
	    result=dialog_message(the_message, title='View HDF Warning!')
	    return, -1
	endif

	;notsub = where(hdf_data_z ne feature_type, notcount)
	;if notcount ne 0 then hdf_data_z(notsub) = filldata
	;if notcount ne 0 then hdf_data_z(notsub) = 0
	hdf_data_z[*, *] = 0
	start_bit = 9
	num_bit = 3
	hdf_data_x = get_bit_values(num_data,start_bit,num_bit,hdf_data,info.version)
	hdf_data_z(subscript) = hdf_data_x(subscript)
    endif
endif

return, hdf_data_z

end

;--------------------------------------------------------------------------------
pro vfmsetting_event, event

pro_name = 'vfmsetting_event'
@getinfo

widget_control, get_value=v, event.id
widget_control, get_uvalue=fieldid, event.id

if v.cancel eq 1 then begin
    widget_control, get_uvalue=info, event.top
    widget_control, get_uvalue=info, info.base
    info.canceloption='Yes'
    widget_control, set_uvalue=info, info.base
    widget_control, /destroy, event.top
    return
endif

if event.tag eq 'TYPE' then begin
    if event.value eq 0 then $
	widget_control, fieldid(3), sensitive = 1 $
        else widget_control, fieldid(3), sensitive = 0
endif

if event.tag eq 'AUTO' then begin
    if event.value eq 1 then begin
	widget_control, fieldid(6), sensitive = 1
	widget_control, fieldid(8), sensitive = 0
    endif else begin
	widget_control, fieldid(6), sensitive = 0
	widget_control, fieldid(8), sensitive = 1
    endelse
endif

if v.done eq 1 then begin
    widget_control, get_uvalue=info, event.top
    info.vfm.type = v.type
    info.vfm.feature = v.feature
    info.vfm.major = v.major
    info.vfm.auto = v.auto
    info.vfm.fmax = v.fmax
    info.vfm.fmin = v.fmin
    info.vfm.usesubset = v.usub
    info.vfm.xlocat = v.xlocat
    info.vfm.xformat = v.xformat
    
    if(widget_info(info.widgets.base, /VALID_ID)) then $
        widget_control, set_uvalue=info, info.widgets.base
    widget_control, set_uvalue=info, info.base

    widget_control, event.top, /destroy

endif

end

;--------------------------------------------------------------------------------
pro vfm_setting, top_base, info

pro_name = 'vfm_setting'
@getinfo

widget_control, /hourglass

vfm_type = strcompress(string(info.vfm.type), /REMOVE_ALL)
feature = strcompress(string(info.vfm.feature), /REMOVE_ALL)
major = strcompress(string(info.vfm.major), /REMOVE_ALL)
auto = strcompress(string(info.vfm.auto), /REMOVE_ALL)
fmax = strcompress(string(info.vfm.fmax), /REMOVE_ALL)
fmin = strcompress(string(info.vfm.fmin), /REMOVE_ALL)
usub = strcompress(string(info.vfm.usesubset), /REMOVE_ALL)
xlocat = strcompress(string(info.vfm.xlocat), /REMOVE_ALL)
xformat = strcompress(info.vfm.xformat, /REMOVE_ALL)

print,'feature = ',feature

desc = [ $
	'0, label, Select Veritcal Feature Mask Setting, center, font='+info.font, $
	'0, label, "   ", center, font=' + info.font, $
	'0, droplist, Feature Type|Ice/Water Phase|Horizontal Averaging, ' $
	    + 'label_left=Feature Classification:, set_value='+vfm_type+', tag=type, ' $
	    + 'font='+info.font+', labelfont='+info.font, $
	'1, base, , column, frame', $
	'2, droplist, invalid|clear air|cloud|aerosol|stratospheric feature|surface|subsurface|no signal|all, '$
	    + 'label_left=Feature Sub-type:, set_value='+feature $
	    + ', tag=feature, font='+info.font+', labelfont='+info.font, $
	'0, droplist, Auto|Manual, label_left=Select Major Value:, set_value='+auto $
	    + ', tag=auto, font='+info.font+', labelfont='+info.font, $
	'1, base, , column, frame', $
	'2, integer,'+major+', title=Mayor Value:, width=12, tag=major, font='+info.font $
	    +', fieldfont='+info.font+ ', labelfont='+info.font, $
	'1, base, , column, frame', $
	'0, integer,'+fmin+', title=Minimum Value:, width=12, tag=fmin, font='+info.font $
	    +', fieldfont='+info.font+ ', labelfont='+info.font, $
	'2, integer,'+fmax+', title=Maximum Value:, width=12, tag=fmax, font='+info.font $
	    +', fieldfont='+info.font+ ', labelfont='+info.font, $
	'0, droplist, No|Yes, label_left=Select X title variable:, set_value='+usub $
	    + ', tag=usub, font='+info.font+', labelfont='+info.font, $
	'0, float, '+xlocat+', title=X Title Location (Normal):, width=10, tag=xlocat, ' $
	    + 'font='+info.font+', fieldfont='+info.font+', labelfont='+info.font, $
	'0, text, '+xformat+', label_left=X Title Format:, width=10, tag=xformat, ' $
	    + 'font='+info.font+', fieldfont='+info.font+', labelfont='+info.font, $
	'0, label, "   ", center, font='+info.font, $
	'1, base, , row, space=60, center', $
	'0, button, Done, QUIT, tag=done, font='+info.font, $
	'2, button, Cancel, QUIT, tag=cancel, font='+info.font]
	
base_loc = widget_info(top_base, /geometry)
xoffset = base_loc.xoffset + 100
yoffset = base_loc.yoffset + 100
base=widget_base(group_leader=top_base, /modal, column=1, map=1, xoffset=xoffset, $
    yoffset=yoffset, TITLE='Select Vertical Feature Mask Setting')
formid = cw_form(base, desc, /column, ids=fieldid)

widget_control, base, /realize
widget_control, set_uvalue=info, base
widget_control, set_uvalue=fieldid, formid

if vfm_type eq 0 then begin
    widget_control, fieldid(3), sensitive = 1
endif else begin
    widget_control, fieldid(3), sensitive = 0
endelse

if info.vfm.auto eq 0 then begin
    widget_control, fieldid(6), sensitive = 0
    widget_control, fieldid(8), sensitive = 1
endif else begin
    widget_control, fieldid(6), sensitive = 1
    widget_control, fieldid(8), sensitive = 0
endelse

xmanager, 'vfmsetting', base

end

;--------------------------------------------------------------------------------
pro do_vertical_feature_mask, print_flag, this_subset, info, plot_status

pro_name = 'do_vertical_feature_mask'
@getinfo

if print_flag eq 0 then begin
    info.overlay.flag = 0
    info.overlay.offflag = 0
    info.graph_style = 'Vertical Feature Mask'
    vfm_setting, info.base, info
    widget_control, get_uvalue=info, info.base
    if info.canceloption eq 'Yes' then begin
	info.canceloption = 'No'
	widget_control, set_uvalue=info, info.base
	plot_status = 0
	return
    endif
    hdf_data = set_vfm_data(this_subset, info)
    if hdf_data(0) eq -1 then begin
	plot_status = 0
	return
    endif else begin
	if ptr_valid(info.vfm.data) then ptr_free, info.vfm.data
        info.vfm.data = ptr_new(hdf_data, /NO_COPY)
	widget_control, set_uvalue=info, info.base
    endelse

    if info.vfm.usesubset eq 1 then begin
try_again:
	info.vfm.xtitle = -1
	num_list = n_elements(info.name_list_subset)
	if num_list gt 1 then begin
	    the_list = info.name_list_subset
	    the_list = [the_list, 'Cancel']
	    num_list = n_elements(the_list)
	    title = 'Select X Axis Variable'
	    the_message = ['Select one of the following variables as', $
		'X axis title:']
	    default_option = 0
	    sel_option = get_option(default_option,the_list,title,the_message,info)
	    if sel_option eq num_list-1 then begin
		info.vfm.usesubset = 0
	    endif else begin
		if sel_option eq this_subset then begin
		    the_message = ['X axis title cannot be equal to VFM, use km instead.', $
				   'Continue?']
		    result= dialog_message(the_message, title='View HDF Message!', /Question, /Cancel)
		    if result eq 'No' then goto, try_again
		    if result eq 'Cancel' then begin
			plot_status = 0
			return
		    endif
		    info.vfm.usesubset = 0
		endif else info.vfm.xtitle = sel_option
	    endelse
	endif else info.vfm.usesubset = 0

	widget_control, set_uvalue=info, info.base
    endif
endif

;  If put a hourglass in WIN, it will not get the signal of stop or pause widget
if !D.Name ne 'WIN' then widget_control, /hourglass

widget_control, get_uvalue=info, info.base

info.subset.selected = this_subset

if ptr_valid(info.vfm.data) then hdf_data = *info.vfm.data $
else begin
    the_message = ['Problem with the data set.', $
	'Please check the data and do it again.']
    result= dialog_message(the_message, title='View HDF Message!')
    plot_status = 0
    return
endelse

set_axis_ranges, info, YRange, Ystyle, XRange, Xstyle, ZRange, Zstyle

size_data = size(hdf_data)
if size_data(0) eq 1 then begin
    hdf_data = reform(hdf_data, n_elements(hdf_data), 1)
    size_data = size(hdf_data)
endif

x_size = 5.0 * size_data(2)
y_size = 3.6

x_min = 0
x_max = x_size
y_min = - 0.5
y_max = 30.1

if (info.axis_state eq 1) or (info.axis_state eq 4) or $
    (info.axis_state eq 5) then begin
	xrange = xrange
endif else begin
	xrange = [x_min, x_max]
	xstyle = 3
endelse

if (info.axis_state eq 2) or (info.axis_state eq 4) or $
    (info.axis_state eq 5) then begin
	yrange=yrange
endif else begin
	yrange = [y_min, y_max]
	ystyle = 3
endelse

info.slide.x_end = x_max
info.slide.x_start = x_min
info.slide.y_end = y_max
info.slide.y_start = y_min

filename = info.subset.data(this_subset).src_filename

xtitle = 'Km'
;ytitle = 'Km'
ytitle = 'Altitude, km'

if info.vfm.usesubset eq 1 and info.vfm.xtitle ne -1 then begin
    xtitle_index = info.vfm.xtitle
    xtitle = info.subset.data(xtitle_index).subset_name
    xtitle = xtitle(0)
    dot=strpos(xtitle,'[')
    if dot ne -1 then xtitle=strmid(xtitle,0,dot)

    temp_name = info.subset.data(xtitle_index).src_unitname
    temp_name = temp_name(0)
    dot=strpos(temp_name,'N/A')
    if( dot eq -1) then xtitle = xtitle + temp_name
endif

data_name = info.subset.data(this_subset).subset_name
data_name = data_name(0)

dot=strpos(data_name,'[')
if dot ne -1 then ztitle=strmid(data_name,0,dot) $
    else ztitle = data_name

xyzname = ''
xyzname = 'Vertical Feature Mask of ' + ztitle

if (print_flag eq 0) or (print_flag eq 3) then plot_dialogue , xyzname, info

if (info.axis_state eq 3) or (info.axis_state eq 5) then begin
	z_max = info.range.z_end
	z_min = info.range.z_start
endif

data_range = ''
data_range = get_data_range(this_subset,info)
the_title = xyzname
if !D.Name eq 'PS' or !D.Name eq 'WIN' or info.char.font eq 0 then begin
	the_title=the_title + '!CData Range: ' + data_range
endif else begin
	the_title=the_title + '!C!CData Range: ' + data_range
endelse

vfm_type = info.vfm.type
feature_type = info.vfm.feature

top_color = !d.n_colors - 2
if top_color gt 254 then top_color = 254

if((!D.Name ne 'PS' and !D.Name ne 'PRINTER') and top_color gt info.top_color) then $
        top_color = info.top_color

if info.browse_image.btype eq 0 then begin
    ; result = set_vfm_image_colortable()
    result = set_vfm_image_colortable(vfm_type, feature_type)
    if(result eq -1) then begin
	the_message = [ 'Problem to set default color table for VFM Image.']
	result= dialog_message(the_message, title='View HDF Message!')
	return
    endif
endif else begin
    if info.color_table ne 0 and info.pick_color_table eq 0 then $
	check_bw = check_color_table(top_color) $
	else check_bw = 0
    if check_bw eq 1 then begin
	if info.device eq 'X' then begin
	    color_table_file=info.home_path+"/"+"view_hdf_color.tbl"
	endif else begin
	    color_table_file=info.home_path+"\"+"view_hdf_color.tbl"
	endelse
	test_file = findfile(color_table_file, count=count)
	if count eq 0 then color_table_file = 'view_hdf_color.tbl'
	loadct, info.color_table, file=color_table_file
    endif
endelse

case vfm_type of
    1:  begin
	    n_level = 4
	    z_max = 3
	    z_min = 0
	end
    2:  begin
	    n_level = 6
	    z_max = 5
	    z_min = 0
	end
    else: begin
	    n_level = 8
	    z_max = 7
	    z_min = 0
	end
endcase
      
vlevel = findgen(n_level)
color_interval = top_color/float(n_level)
clevel = fix(color_interval * (vlevel(*) + 1))
;clevel = [!P.BACKGROUND, clevel]
clevel = [info.greenwich.baddata, clevel]
vlevel = [vlevel, n_level]

info.overlay.zmax = z_max
info.overlay.zmin = z_min
	   
if info.subset.data(this_subset).src_crit_flag eq 1 then begin
	crit_string = ''
	crit_string = get_crit_string(this_subset, info)
	if !D.Name eq 'PS' and info.eps_out.type eq 1 then $
		!P.Position = [0.235, 0.15, 0.99, 0.92] $
		else !P.Position = [0.060, 0.120, 0.98, 0.92]
	temp_name = str_sep(crit_string, '!C')
	num_temp = n_elements(temp_name)
	!P.Position(1) = !P.Position(1) + (num_temp-1)*0.025
endif else begin
	if !D.Name eq 'PS' and info.eps_out.type eq 1 then $
		!P.Position = [0.235, 0.15, 0.99, 0.92] $
		else !P.Position = [0.060, 0.10, 0.98, 0.92]
endelse
 
if info.color_bar eq 1 then begin
    yrange1=yrange
    yrange1(0) = yrange1(0) - (yrange1(1) - yrange(0)) * 0.15
endif else yrange1 = yrange

get_ticklen, info.style.grid, xticklen, yticklen 

if !D.Name ne 'WIN' and info.char.font ne 0 then begin
    xtitle= '!C' + xtitle + '!C'
endif else begin
    xtitle = xtitle + '!C'
endelse
if !D.Name eq 'PS' or !D.Name eq 'PRINTER' then begin
	old_charsize = !X.CHARSIZE
	!X.CHARSIZE = 0.9
	!Y.CHARSIZE = 0.9	
endif

if info.style.xlog gt 0 then begin
    XRange = set_log_range(XRange, x_min, x_max)
endif

if info.style.ylog gt 0 then begin
    YRange1 = set_log_range(YRange1, y_min, y_max)
endif

x_array = [x_min, x_max]
y_array = [y_min, y_max]

if info.vfm.usesubset eq 0 or info.vfm.xtitle eq -1 then begin
    titlesize = 1.2 * info.char.size
    plot,x_array, y_array, /NODATA, /YNOZERO, $
	FONT=info.char.font, $
	charsize=info.char.size, $
	xcharsize=titlesize, $
	ycharsize=titlesize, $
        xtitle=xtitle, $
        ytitle=ytitle, $
	title=the_title, $
        xticklen=xticklen, yticklen=yticklen, $
	subtitle="File: " + filename + "  Date:" + systime(0), $
        xrange=XRange, yrange=YRange1, xstyle=Xstyle, ystyle=Ystyle, $
	xlog=info.style.xlog, ylog=info.style.ylog
endif else begin
    xtitle_index = info.vfm.xtitle
    num_x = long((XRange[1] - XRange[0])/5.0 + 0.5)
    x_incs = num_x/10
    x_tick = num_x/x_incs
    xtick = replicate(' ',x_tick+1)
    ; if !D.NAME ne 'WIN' then xtitle = '!C'+xtitle $
    ; else begin
; 	if info.char.font eq 0 then xtitle = xtitle + '!C'
    ; endelse

    titlesize = 1.2 * info.char.size
    plot,x_array, y_array, /NODATA, /YNOZERO, $
	FONT=info.char.font, $
	charsize=info.char.size, $
	xcharsize=titlesize, $
	ycharsize=titlesize, $
	xtitle=xtitle, $
	ytitle=ytitle, $
	title=the_title, $
	xticks=x_tick, xtickn=xtick, $
	xticklen=xticklen, yticklen=yticklen, $
	subtitle="File: " + filename + "  Date:" + systime(0), $
	xrange=XRange, yrange=YRange1, xstyle=Xstyle, ystyle=Ystyle, $
	xlog=info.style.xlog, ylog=info.style.ylog

    if info.subset.data(xtitle_index).src_type_flag eq 0 then begin
	temp_x = *info.subset.data(xtitle_index).src_data
	temp_x = reform(temp_x, n_elements(temp_x))
    endif else begin
	temp_x_1 = *info.subset.data(xtitle_index).src_data
	temp_x = reform(temp_x_1.components0, n_elements(temp_x_1.components0))
	undefine, temp_x_1
    endelse

    num_x = n_elements(temp_x)

    ; readabley = 1./24*(y_max - y_min)
    readabley = info.vfm.xlocat * info.char.size

    for i = 0, x_tick do begin
	x_loc = i * x_incs * 5.0 + Xrange[0]
	label_loc = i * x_incs + fix(Xrange[0]/5.0 + 0.5)
	;  check x_loc is within the number of x value
	if(label_loc le num_x) then begin
	    if label_loc eq num_x then label_loc = num_x - 1
	    xformat = '('+info.vfm.xformat+')'
	    ;x_value = string(temp_x[label_loc], format='(f8.1)')
	    x_value = string(temp_x[label_loc], format=xformat)
	    x_value = strcompress(x_value, /REMOVE_ALL)
	    normal_coord = convert_coord(x_loc, !Y.crange[0], /to_normal)
	    ; xyouts, x_loc, !Y.crange[0] - readabley, x_value, alignment=0.5, $
	    xyouts, normal_coord[0], normal_coord[1] - readabley, x_value, alignment=0.5, $
		FONT=info.char.font, charsize = info.char.size, /normal
	endif
    endfor

    undefine, temp_x
endelse

if info.vfm.auto eq 0 then begin
    ;  Check the major_color
    his_result = histogram(hdf_data, binsize=1, min=info.vfm.fmin, max=info.vfm.fmax)
    max_data = max(his_result, major_color)
    ;print,'number of data = ',max_data,' equal to major_color = ',major_color
endif else begin
    major_color = info.vfm.major
endelse

;print,'major_color = ',major_color

; fill up the whole image with the major color
if major_color lt -1 or major_color gt z_max then major_color = 0
;if vfm_type gt 0 and feature_type eq 8 then major_color = 0 else major_color = 1
;  The y_min is -0.5, so set this is limit
if yrange[0] lt -0.5 then ymin = -0.5 else ymin = yrange[0]
if yrange[1] gt 30.1 then ymax = 31.1 else ymax = yrange[1]
if xrange[0] lt 0 then xmin = 0 else xmin = xrange[0]
if xrange[1] gt x_size then xmax = x_size else xmax = xrange[1]
vert1 = convert_coord(xmin, ymin, /to_device)
vert2 = convert_coord(xmax, ymin, /to_device)
vert3 = convert_coord(xmax, ymax, /to_device)
vert4 = convert_coord(xmin, ymax, /to_device)
;vert1 = convert_coord(xrange[0], yrange[0], /to_device)
;vert2 = convert_coord(xrange[1], yrange[0], /to_device)
;vert3 = convert_coord(xrange[1], yrange[1], /to_device)
;vert4 = convert_coord(xrange[0], yrange[1], /to_device)
x = [vert1[0], vert2[0], vert3[0], vert4[0]]
y = [vert1[1], vert2[1], vert3[1], vert4[1]]
sub_x = where(finite(x) eq 0, count_x)
sub_y = where(finite(y) eq 0, count_y)
if(count_x eq 0 and count_y eq 0) then begin
    the_color = clevel(major_color+1)
    polyfill, x, y, color=the_color, /DEVICE
endif

;  use polyfill function to display the vertical feature mask
;  for every 5 km chunk.  The order of the values are veritcal first and 
;  then horizontal.

layer1 = 55
layer2 = 200
layer3 = 290
profile1 = 3
profile2 = 5
profile3 = 15
max1 = 30.1
max2 = 20.2
max3 = 8.2

x_old = 0.0
i = 0
!UserDone = 0
continue_plot = 1
;for i = 0, size_data(2)-1 do begin
; while(i lt size_data(2) and continue_plot eq 1) do begin
while(i lt size_data(2) and continue_plot eq 1 and !UserStop eq 1) do begin
  x_start = i * 5.0D
  x_end = (i+1) * 5.0D
  if !D.Name ne 'WIN' then begin
    result = widget_event(info.widgets.stop,/Nowait, /save_hourglass)
    result = widget_event(info.widgets.pause,/Nowait, /save_hourglass)
  endif else begin
    ;  If put a hourglass in WIN, it will not get the signal of stop or pause widget
    result = widget_event(info.widgets.stop,/Nowait)
    result = widget_event(info.widgets.pause,/Nowait)
  endelse
  if(x_start ge xrange[0] and x_end le xrange[1]) then begin

    ;  Check is there any value greater than 0
    current_data_array = hdf_data[*,i]
    sub_nonzero = where(current_data_array ne major_color, count_non_zero)
    if count_non_zero gt 0 then begin
	;  The First layer, 20.2 - 30.1
	deltx = 5.0D/3.0D
	deltx2 = deltx/2.0D
	delty = 0.18D
	delty2 = delty/2.0D
	y_index = -1
	for k = 0, profile1-1 do begin
	    temp_x = x_start + k * deltx + deltx2
	    for j = 0, layer1-1 do begin
		y_index = y_index + 1
		data_value = current_data_array[y_index]
                if(data_value ne major_color) then begin
		    temp_y = max1 - j * delty - delty2
		    if(temp_y-delty2 ge yrange[0] and temp_y+delty2 le yrange[1]) then begin
			vert1 = convert_coord(temp_x-deltx2, temp_y-delty2, /to_device)
			vert2 = convert_coord(temp_x-deltx2, temp_y+delty2, /to_device)
			vert3 = convert_coord(temp_x+deltx2, temp_y+delty2, /to_device)
			vert4 = convert_coord(temp_x+deltx2, temp_y-delty2, /to_device)
			x = [vert1(0), vert2(0), vert3(0), vert4(0)]
			y = [vert1(1), vert2(1), vert3(1), vert4(1)]
			sub_x = where(finite(x) eq 0, count_x)
			sub_y = where(finite(y) eq 0, count_y)
			if(count_x eq 0 and count_y eq 0) then begin
			    ;data_value = hdf_data(y_index,i)
			    if data_value lt z_min or data_value gt z_max then data_value = -1
			    the_color = clevel(data_value+1)
			    polyfill, x, y, color=the_color, /DEVICE
			endif
		    endif
		endif
	    endfor
	endfor

	;  The Second layer, 8.2 - 20.2
	deltx = 1.0
	deltx2 = deltx/2.0
	delty = 0.06
	delty2 = delty/2.0
	for k = 0, profile2-1 do begin
	    temp_x = x_start + k * deltx + deltx2
	    for j = 0, layer2-1 do begin
		y_index = y_index + 1
		data_value = current_data_array[y_index]
		if(data_value ne major_color) then begin
		    temp_y = max2 - j * delty - delty2
		    if(temp_y-delty2 ge yrange[0] and temp_y+delty2 le yrange[1]) then begin
			vert1 = convert_coord(temp_x-deltx2, temp_y-delty2, /to_device)
			vert2 = convert_coord(temp_x-deltx2, temp_y+delty2, /to_device)
			vert3 = convert_coord(temp_x+deltx2, temp_y+delty2, /to_device)
			vert4 = convert_coord(temp_x+deltx2, temp_y-delty2, /to_device)
			x = [vert1(0), vert2(0), vert3(0), vert4(0)]
			y = [vert1(1), vert2(1), vert3(1), vert4(1)]
			sub_x = where(finite(x) eq 0, count_x)
			sub_y = where(finite(y) eq 0, count_y)
			if(count_x eq 0 and count_y eq 0) then begin
			    ;data_value = hdf_data(y_index,i)
			    if data_value lt z_min or data_value gt z_max then data_value = -1
			    the_color = clevel(data_value+1)
			    polyfill, x, y, color=the_color, /DEVICE
			endif
		    endif
		endif
	    endfor
	endfor

	;  The Third layer, -0.5 - 8.2
	deltx = 5.0/15.0
	deltx2 = deltx/2.0
	delty = 0.03
	delty2 = delty/2.0
	for k = 0, profile3-1 do begin
	    temp_x = x_start + k * deltx + deltx2
	    for j = 0, layer3-1 do begin
		y_index = y_index + 1
		data_value = current_data_array[y_index]
		if(data_value ne major_color) then begin
		    temp_y = max3 - j * delty - delty2
		    if(temp_y-delty2 ge yrange[0] and temp_y+delty2 le yrange[1]) then begin
			vert1 = convert_coord(temp_x-deltx2, temp_y-delty2, /to_device)
			vert2 = convert_coord(temp_x-deltx2, temp_y+delty2, /to_device)
			vert3 = convert_coord(temp_x+deltx2, temp_y+delty2, /to_device)
			vert4 = convert_coord(temp_x+deltx2, temp_y-delty2, /to_device)
			x = [vert1(0), vert2(0), vert3(0), vert4(0)]
			y = [vert1(1), vert2(1), vert3(1), vert4(1)]
			sub_x = where(finite(x) eq 0, count_x)
			sub_y = where(finite(y) eq 0, count_y)
			if(count_x eq 0 and count_y eq 0) then begin
			    ;data_value = hdf_data(y_index,i)
			    if data_value lt z_min or data_value gt z_max then data_value = -1
			    the_color = clevel(data_value+1)
			    polyfill, x, y, color=the_color, /DEVICE
			endif
		    endif
		endif
	    endfor
	endfor
    endif
  endif else begin
    if(x_end ge xrange[1]) then continue_plot = 0
  endelse
  i = i + 1
endwhile
;endfor

!UserStop = 1
!UserPause = 1
!UserDone = 1
widget_control, set_button=0, info.widgets.pause

if info.color_bar eq 1 then begin
    case vfm_type of
	1: unitlabel = 'ice/Water Phase: 0 = unknow/not determined, 1 = ice, 2 = water, 3 = mixed phase'
	2: unitlabel = 'Horizontial Averaging: 0 = not applicable, 1 = 1/3 km, 2 = 1 km, 3 = 5 km, 4 = 20 km, 5 = 80 km'
	else: begin
	    case feature_type of
		2: begin
		    unitlabel = 'cloud: 0 = not determined, 1 = thin low overcast, '
		    unitlabel = unitlabel + '2 = thick low overcast, 3 = low, broken, '
		    unitlabel = unitlabel + '4 = altocumuls, 5 = transparent cirrus, '
		    unitlabel = unitlabel + '6 = altostratus, nimbostratus, or cumulonimbus, 7 = other'
		   end
		3: begin
		    unitlabel = 'aerosol: 0 = not determined, 1 = clean marine, 2 = dust, '
		    unitlabel = unitlabel + '3 = polluted continental, 4 = clean continental, '
		    unitlabel = unitlabel + '5 = polluted dust, 6 = smoke, 7 = other'
		   end
		4: begin
		    unitlabel = 'stratospheric feature: 0 = not determined, '
		    unitlabel = unitlabel + '1 = non-depolarizing PSC, '
		    unitlabel = unitlabel + '2 = depolarizing PSC, '
		    unitlabel = unitlabel + '3 = non-depolarizing aerosol, '
		    unitlabel = unitlabel + '4 = depolarizing aerosol, '
		    unitlabel = unitlabel + '5 = spare, 6 = spare, 7 = other'
		   end
		else: begin
		    unitlabel = 'Feature Type: 0 = invalid (bad or missing data), 1 = clear air, 2 = cloud, '
		    unitlabel = unitlabel + '3 = aerosol, 4 = stratospheric feature, 5 = surface, '
		    unitlabel = unitlabel + '6 = subsurface, 7 = no signal (total attenuated)'
		   end
	    endcase
	end
    endcase

    clevel = clevel[1:n_elements(clevel)-1]
    ; x_location = !P.Position(0) + (!P.Position(2) - !P.Position(0))/2. - 0.22
    x_bar_location = 20.0 * info.greenwich.barsize
    x_location = !P.Position(0) + (!P.Position(2) - !P.Position(0))/2. - x_bar_location
    y_location = !y.window(0) + 0.09
    draw_contour_bar, clevel, z_min, z_max, y_location, x_location, n_level, info.char.size, $
	info.char.font, unitlabel, vlevel, info.greenwich.baddata, 0, info.greenwich.bformat, $
	info.greenwich.colborder, info.greenwich.displaybad, centre_label=1, $
	deltx=info.greenwich.barsize
endif

if info.subset.data(this_subset).src_crit_flag eq 1 then begin
	if !D.Name eq 'PS' or !D.Name eq 'PRINTER' then begin
		charsize = 0.9*info.char.size
		y_location = 0.125
	endif else begin
		charsize = info.char.size
		y_location = 0.11
	endelse
	;xyouts, !P.Position(0), !P.Position(1)-y_location, crit_string, /NORMAL, $
	xyouts, 0.08, !P.Position(1)-y_location, crit_string, /NORMAL, $
		font=info.char.font, charsize=charsize
endif

if info.addtext.key eq 1 then write_add_text, info

test = !d.flags and 128
if test ne 0 then begin
    ;image = tvrd()
    image = get_image24()
    if ptr_valid(info.overlay.image) then ptr_free, info.overlay.image
	info.overlay.image = ptr_new(image, /NO_COPY)
endif

if info.overlay.flag eq 1 then do_overlay, info

if !D.Name eq 'PS' or !D.Name eq 'PRINTER' then begin
	!X.CHARSIZE = old_charsize
	!Y.CHARSIZE = old_charsize
endif
 
!P.Position = [ 0.0 , 0.0 , 0.0 , 0.0]

widget_control, set_uvalue=info, info.base
if (widget_info(info.browse_image.base, /VALID_ID)) then $
    widget_control, set_uvalue=info, info.browse_image.base

end

;--------------------------------------------------------------------------------
pro do_old_vertical_feature_mask, print_flag, this_subset, info, plot_status

pro_name = 'do_old_vertical_feature_mask'
@getinfo

if print_flag eq 0 then begin
    info.graph_style = 'Old Vertical Feature Mask'
    vfm_setting, info.base, info
    widget_control, get_uvalue=info, info.base
    if info.canceloption eq 'Yes' then begin
	info.canceloption = 'No'
	widget_control, set_uvalue=info, info.base
	plot_status = 0
	return
    endif
    hdf_data = set_old_vfm_data(this_subset, info)
    if hdf_data(0) eq -1 then begin
	plot_status = 0
	return
    endif else begin
	if ptr_valid(info.vfm.data) then ptr_free, info.vfm.data
        info.vfm.data = ptr_new(hdf_data, /NO_COPY)
	widget_control, set_uvalue=info, info.base
    endelse

    info.overlay.flag = 0
    info.overlay.offflag = 0
endif

;  If put a hourglass in WIN, it will not get the signal of stop or pause widget
if !D.Name ne 'WIN' then widget_control, /hourglass

widget_control, get_uvalue=info, info.base

info.subset.selected = this_subset

if ptr_valid(info.vfm.data) then hdf_data = *info.vfm.data $
else begin
    the_message = ['Problem with the data set.', $
	'Please check the data and do it again.']
    result= dialog_message(the_message, title='View HDF Message!')
    plot_status = 0
    return
endelse

set_axis_ranges, info, YRange, Ystyle, XRange, Xstyle, ZRange, Zstyle

size_data = size(hdf_data)
if size_data(0) eq 1 then begin
    hdf_data = reform(hdf_data, n_elements(hdf_data), 1)
    size_data = size(hdf_data)
endif

x_size = 5.0 * size_data(2)
y_size = 3.6

x_min = 0
x_max = x_size
y_min = - 0.5
y_max = 30.1

if (info.axis_state eq 1) or (info.axis_state eq 4) or $
    (info.axis_state eq 5) then begin
	xrange = xrange
endif else begin
	xrange = [x_min, x_max]
	xstyle = 3
endelse

if (info.axis_state eq 2) or (info.axis_state eq 4) or $
    (info.axis_state eq 5) then begin
	yrange=yrange
endif else begin
	yrange = [y_min, y_max]
	ystyle = 3
endelse

info.slide.x_end = x_max
info.slide.x_start = x_min
info.slide.y_end = y_max
info.slide.y_start = y_min

filename = info.subset.data(this_subset).src_filename

xtitle = 'Km'
ytitle = 'Km'

data_name = info.subset.data(this_subset).subset_name
data_name = data_name(0)

dot=strpos(data_name,'[')
if dot ne -1 then ztitle=strmid(data_name,0,dot) $
    else ztitle = data_name

xyzname = ''
xyzname = 'Vertical Feature Mask of ' + ztitle

if (print_flag eq 0) or (print_flag eq 3) then plot_dialogue , xyzname, info

if (info.axis_state eq 3) or (info.axis_state eq 5) then begin
	z_max = info.range.z_end
	z_min = info.range.z_start
endif

data_range = ''
data_range = get_data_range(this_subset,info)
the_title = xyzname
if !D.Name eq 'PS' or !D.Name eq 'WIN' or info.char.font eq 0 then begin
	the_title=the_title + '!CData Range: ' + data_range
endif else begin
	the_title=the_title + '!C!CData Range: ' + data_range
endelse

vfm_type = info.vfm.type
feature_type = info.vfm.feature

top_color = !d.n_colors - 2
if top_color gt 254 then top_color = 254

if((!D.Name ne 'PS' and !D.Name ne 'PRINTER') and top_color gt info.top_color) then $
        top_color = info.top_color

if info.color_table ne 0 and info.pick_color_table eq 0 then $
    check_bw = check_color_table(top_color) $
    else check_bw = 0
if check_bw eq 1 then begin
    if info.device eq 'X' then begin
	color_table_file=info.home_path+"/"+"view_hdf_color.tbl"
    endif else begin
	color_table_file=info.home_path+"\"+"view_hdf_color.tbl"
    endelse
    test_file = findfile(color_table_file, count=count)
    if count eq 0 then color_table_file = 'view_hdf_color.tbl'
    loadct, info.color_table, file=color_table_file
endif

case vfm_type of
    1:  begin
	    n_level = 4
	    z_max = 3
	    z_min = 0
	end
    2:  begin
	    n_level = 6
	    z_max = 5
	    z_min = 0
	end
    else: begin
	    n_level = 8
	    z_max = 7
	    z_min = 0
	end
endcase
      
vlevel = findgen(n_level)
color_interval = top_color/float(n_level)
clevel = fix(color_interval * (vlevel(*) + 1))
;clevel = [!P.BACKGROUND, clevel]
clevel = [info.greenwich.baddata, clevel]
vlevel = [vlevel, n_level]

info.overlay.zmax = z_max
info.overlay.zmin = z_min
	   
if info.subset.data(this_subset).src_crit_flag eq 1 then begin
	crit_string = ''
	crit_string = get_crit_string(this_subset, info)
	if !D.Name eq 'PS' and info.eps_out.type eq 1 then $
		!P.Position = [0.235, 0.15, 0.99, 0.92] $
		else !P.Position = [0.060, 0.120, 0.98, 0.92]
	temp_name = str_sep(crit_string, '!C')
	num_temp = n_elements(temp_name)
	!P.Position(1) = !P.Position(1) + (num_temp-1)*0.025
endif else begin
	if !D.Name eq 'PS' and info.eps_out.type eq 1 then $
		!P.Position = [0.235, 0.15, 0.99, 0.92] $
		else !P.Position = [0.060, 0.10, 0.98, 0.92]
endelse
 
if info.color_bar eq 1 then begin
    yrange1=yrange
    yrange1(0) = yrange1(0) - (yrange1(1) - yrange(0)) * 0.15
endif else yrange1 = yrange

get_ticklen, info.style.grid, xticklen, yticklen 

if !D.Name ne 'WIN' and info.char.font ne 0 then begin
    xtitle= '!C' + xtitle + '!C'
endif else begin
    xtitle = xtitle + '!C'
endelse
if !D.Name eq 'PS' or !D.Name eq 'PRINTER' then begin
	old_charsize = !X.CHARSIZE
	!X.CHARSIZE = 0.9
	!Y.CHARSIZE = 0.9	
endif

if info.style.xlog gt 0 then begin
    XRange = set_log_range(XRange, x_min, x_max)
endif

if info.style.ylog gt 0 then begin
    YRange1 = set_log_range(YRange1, y_min, y_max)
endif

x_array = [x_min, x_max]
y_array = [y_min, y_max]

plot,x_array, y_array, /NODATA, /YNOZERO, $
	FONT=info.char.font, $
	charsize=info.char.size, $
        xtitle=xtitle, $
        ytitle=ytitle, $
	title=the_title, $
        xticklen=xticklen, yticklen=yticklen, $
	subtitle="File: " + filename + "  Date:" + systime(0), $
        xrange=XRange, yrange=YRange1, xstyle=Xstyle, ystyle=Ystyle, $
	xlog=info.style.xlog, ylog=info.style.ylog

if info.vfm.auto eq 0 then begin
    ;  Check the major_color
    his_result = histogram(hdf_data, binsize=1, min=info.vfm.fmin, max=info.vfm.fmax)
    max_data = max(his_result, major_color)
    ;print,'number of data = ',max_data,' equal to major_color = ',major_color
endif else begin
    major_color = info.vfm.major
endelse

;print,'major_color = ',major_color

; fill up the whole image with the major color
if major_color lt -1 or major_color gt z_max then major_color = 0
;if vfm_type gt 0 and feature_type eq 8 then major_color = 0 else major_color = 1
;  The y_min is -0.5, so set this is limit
if yrange[0] lt -0.5 then ymin = -0.5 else ymin = yrange[0]
if yrange[1] gt 30.1 then ymax = 31.1 else ymax = yrange[1]
if xrange[0] lt 0 then xmin = 0 else xmin = xrange[0]
if xrange[1] gt x_size then xmax = x_size else xmax = xrange[1]
vert1 = convert_coord(xmin, ymin, /to_device)
vert2 = convert_coord(xmax, ymin, /to_device)
vert3 = convert_coord(xmax, ymax, /to_device)
vert4 = convert_coord(xmin, ymax, /to_device)
;vert1 = convert_coord(xrange[0], yrange[0], /to_device)
;vert2 = convert_coord(xrange[1], yrange[0], /to_device)
;vert3 = convert_coord(xrange[1], yrange[1], /to_device)
;vert4 = convert_coord(xrange[0], yrange[1], /to_device)
x = [vert1[0], vert2[0], vert3[0], vert4[0]]
y = [vert1[1], vert2[1], vert3[1], vert4[1]]
sub_x = where(finite(x) eq 0, count_x)
sub_y = where(finite(y) eq 0, count_y)
if(count_x eq 0 and count_y eq 0) then begin
    the_color = clevel(major_color+1)
    polyfill, x, y, color=the_color, /DEVICE
endif

;  use polyfill function to display the vertical feature mask
;  for every 5 km chunk.  The order of the values are veritcal first and 
;  then horizontal.

layer1 = 55
layer2 = 200
layer3 = 290
profile1 = 3
profile2 = 5
profile3 = 15
max1 = 30.1
max2 = 20.2
max3 = 8.2

x_old = 0.0
i = 0
!UserDone = 0
continue_plot = 1
;for i = 0, size_data(2)-1 do begin
; while(i lt size_data(2) and continue_plot eq 1) do begin
while(i lt size_data(2) and continue_plot eq 1 and !UserStop eq 1) do begin
  x_start = i * 5.0D
  x_end = (i+1) * 5.0D
  if !D.Name ne 'WIN' then begin
    result = widget_event(info.widgets.stop,/Nowait, /save_hourglass)
    result = widget_event(info.widgets.pause,/Nowait, /save_hourglass)
  endif else begin
    ;  If put a hourglass in WIN, it will not get the signal of stop or pause widget
    result = widget_event(info.widgets.stop,/Nowait)
    result = widget_event(info.widgets.pause,/Nowait)
  endelse
  if(x_start ge xrange[0] and x_end le xrange[1]) then begin

    ;  Check is there any value greater than 0
    current_data_array = hdf_data[*,i]
    sub_nonzero = where(current_data_array ne major_color, count_non_zero)
    if count_non_zero gt 0 then begin
	;  The First layer, 20.2 - 30.1
	deltx = 5.0D/3.0D
	deltx2 = deltx/2.0D
	delty = 0.18D
	delty2 = delty/2.0D
	y_index = -1
	for k = 0, profile1-1 do begin
	    temp_x = x_start + k * deltx + deltx2
	    for j = 0, layer1-1 do begin
		y_index = y_index + 1
		data_value = current_data_array[y_index]
                if(data_value ne major_color) then begin
		    temp_y = max1 - j * delty - delty2
		    if(temp_y-delty2 ge yrange[0] and temp_y+delty2 le yrange[1]) then begin
			vert1 = convert_coord(temp_x-deltx2, temp_y-delty2, /to_device)
			vert2 = convert_coord(temp_x-deltx2, temp_y+delty2, /to_device)
			vert3 = convert_coord(temp_x+deltx2, temp_y+delty2, /to_device)
			vert4 = convert_coord(temp_x+deltx2, temp_y-delty2, /to_device)
			x = [vert1(0), vert2(0), vert3(0), vert4(0)]
			y = [vert1(1), vert2(1), vert3(1), vert4(1)]
			sub_x = where(finite(x) eq 0, count_x)
			sub_y = where(finite(y) eq 0, count_y)
			if(count_x eq 0 and count_y eq 0) then begin
			    ;data_value = hdf_data(y_index,i)
			    if data_value lt z_min or data_value gt z_max then data_value = -1
			    the_color = clevel(data_value+1)
			    polyfill, x, y, color=the_color, /DEVICE
			endif
		    endif
		endif
	    endfor
	endfor

	;  The Second layer, 8.2 - 20.2
	deltx = 1.0
	deltx2 = deltx/2.0
	delty = 0.06
	delty2 = delty/2.0
	for k = 0, profile2-1 do begin
	    temp_x = x_start + k * deltx + deltx2
	    for j = 0, layer2-1 do begin
		y_index = y_index + 1
		data_value = current_data_array[y_index]
		if(data_value ne major_color) then begin
		    temp_y = max2 - j * delty - delty2
		    if(temp_y-delty2 ge yrange[0] and temp_y+delty2 le yrange[1]) then begin
			vert1 = convert_coord(temp_x-deltx2, temp_y-delty2, /to_device)
			vert2 = convert_coord(temp_x-deltx2, temp_y+delty2, /to_device)
			vert3 = convert_coord(temp_x+deltx2, temp_y+delty2, /to_device)
			vert4 = convert_coord(temp_x+deltx2, temp_y-delty2, /to_device)
			x = [vert1(0), vert2(0), vert3(0), vert4(0)]
			y = [vert1(1), vert2(1), vert3(1), vert4(1)]
			sub_x = where(finite(x) eq 0, count_x)
			sub_y = where(finite(y) eq 0, count_y)
			if(count_x eq 0 and count_y eq 0) then begin
			    ;data_value = hdf_data(y_index,i)
			    if data_value lt z_min or data_value gt z_max then data_value = -1
			    the_color = clevel(data_value+1)
			    polyfill, x, y, color=the_color, /DEVICE
			endif
		    endif
		endif
	    endfor
	endfor

	;  The Third layer, -0.5 - 8.2
	deltx = 5.0/15.0
	deltx2 = deltx/2.0
	delty = 0.03
	delty2 = delty/2.0
	for k = 0, profile3-1 do begin
	    temp_x = x_start + k * deltx + deltx2
	    for j = 0, layer3-1 do begin
		y_index = y_index + 1
		data_value = current_data_array[y_index]
		if(data_value ne major_color) then begin
		    temp_y = max3 - j * delty - delty2
		    if(temp_y-delty2 ge yrange[0] and temp_y+delty2 le yrange[1]) then begin
			vert1 = convert_coord(temp_x-deltx2, temp_y-delty2, /to_device)
			vert2 = convert_coord(temp_x-deltx2, temp_y+delty2, /to_device)
			vert3 = convert_coord(temp_x+deltx2, temp_y+delty2, /to_device)
			vert4 = convert_coord(temp_x+deltx2, temp_y-delty2, /to_device)
			x = [vert1(0), vert2(0), vert3(0), vert4(0)]
			y = [vert1(1), vert2(1), vert3(1), vert4(1)]
			sub_x = where(finite(x) eq 0, count_x)
			sub_y = where(finite(y) eq 0, count_y)
			if(count_x eq 0 and count_y eq 0) then begin
			    ;data_value = hdf_data(y_index,i)
			    if data_value lt z_min or data_value gt z_max then data_value = -1
			    the_color = clevel(data_value+1)
			    polyfill, x, y, color=the_color, /DEVICE
			endif
		    endif
		endif
	    endfor
	endfor
    endif
  endif else begin
    if(x_end ge xrange[1]) then continue_plot = 0
  endelse
  i = i + 1
endwhile
;endfor

!UserStop = 1
!UserPause = 1
!UserDone = 1
widget_control, set_button=0, info.widgets.pause

if info.color_bar eq 1 then begin
    case vfm_type of
	1: unitlabel = 'ice/Water Phase: 0 = unknow/not determined, 1 = ice, 2 = water, 3 = mixed phase'
	2: unitlabel = 'Horizontial Averaging: 0 = not applicable, 1 = 1/3 km, 2 = 1 km, 3 = 5 km, 4 = 20 km, 5 = 80 km'
	else: begin
	    case feature_type of
		2: begin
		    unitlabel = 'cloud: 0 = not determined, 1 = Stratus, 2 = Cumulus, '
		    unitlabel = unitlabel + '3 = Altostratus, 4 = Altocumuls, 5 = Cirrus, '
		    unitlabel = unitlabel + '6 = deep convection/frontal cloud, 7 = other'
		   end
		3: begin
		    unitlabel = 'aeroso: 0 = not determined, 1 = clean marine, 2 = dust, '
		    unitlabel = unitlabel + '3 = polluted continental, 4 = clean continental, '
		    unitlabel = unitlabel + '5 = polluted marine, 6 = smoke, 7 = other'
		   end
		4: begin
		    unitlabel = 'stratospheric feature: 0 = not determined, '
		    unitlabel = unitlabel + '1 = non-depolarizing, large particules, '
		    unitlabel = unitlabel + '2 = depolarizing, large particules, '
		    unitlabel = unitlabel + '3 = non-depolarizing, small particles, '
		    unitlabel = unitlabel + '4 = depolarizing, small particles, '
		    unitlabel = unitlabel + '5 = (...), 6 = (...), 7 = other'
		   end
		else: begin
		    unitlabel = 'Feature Type: 0 = invalid (bad or missing data), 1 = clear air, 2 = cloud, '
		    unitlabel = unitlabel + '3 = aerosol, 4 = stratospheric feature, 5 = surface, '
		    unitlabel = unitlabel + '6 = subsurface, 7 = no signal (total attenuated)'
		   end
	    endcase
	end
    endcase

    clevel = clevel[1:n_elements(clevel)-1]
    ; x_location = !P.Position(0) + (!P.Position(2) - !P.Position(0))/2. - 0.22
    x_bar_location = 20.0 * info.greenwich.barsize
    x_location = !P.Position(0) + (!P.Position(2) - !P.Position(0))/2. - x_bar_location
    y_location = !y.window(0) + 0.09
    draw_contour_bar, clevel, z_min, z_max, y_location, x_location, n_level, info.char.size, $
	info.char.font, unitlabel, vlevel, info.greenwich.baddata, info.greenwich.setformat, $
	info.greenwich.bformat, info.greenwich.colborder, info.greenwich.displaybad, $
	centre_label=1, deltx=info.greenwich.barsize
endif

if info.subset.data(this_subset).src_crit_flag eq 1 then begin
	if !D.Name eq 'PS' or !D.Name eq 'PRINTER' then begin
		charsize = 0.9*info.char.size
		y_location = 0.125
	endif else begin
		charsize = info.char.size
		y_location = 0.11
	endelse
	;xyouts, !P.Position(0), !P.Position(1)-y_location, crit_string, /NORMAL, $
	xyouts, 0.08, !P.Position(1)-y_location, crit_string, /NORMAL, $
		font=info.char.font, charsize=charsize
endif

if info.addtext.key eq 1 then write_add_text, info

test = !d.flags and 128
if test ne 0 then begin
    ;image = tvrd()
    image = get_image24()
    if ptr_valid(info.overlay.image) then ptr_free, info.overlay.image
	info.overlay.image = ptr_new(image, /NO_COPY)
endif

if info.overlay.flag eq 1 then do_overlay, info

if !D.Name eq 'PS' or !D.Name eq 'PRINTER' then begin
	!X.CHARSIZE = old_charsize
	!Y.CHARSIZE = old_charsize
endif
 
!P.Position = [ 0.0 , 0.0 , 0.0 , 0.0]

widget_control, set_uvalue=info, info.base
if (widget_info(info.browse_image.base, /VALID_ID)) then $
    widget_control, set_uvalue=info, info.browse_image.base

end

;--------------------------------------------------------------------------------
pro do_curve_fit, print_flag, type_flag, info, plot_status

pro_name = 'do_curve_fit'
@getinfo

if info.subset.count lt 1 then begin
	the_message = ['You need at least one subset of data', $
	    'to do Curve Fit!']
	result=dialog_message(the_message, title='View HDF Warning!')
	plot_status = 0
	return
endif

if print_flag eq 0 then begin
  info.graph_style = 'Curve Fit'
  if type_flag eq 0 or type_flag eq 4 then begin
	curve_fit_setup, info, 'Curve Fit', 1, 1, 1
  endif else begin
	curve_fit_setup, info, 'Curve Fit', 1, 1, 0
  endelse
  widget_control, get_uvalue=info, info.base
  if info.canceloption eq 'Yes' then begin
	info.canceloption = 'No'
	widget_control, set_uvalue=info, info.base
	plot_status = 0
	return
  endif 

endif

widget_control, /hourglass

widget_control, get_uvalue=info, info.base
get_data, y_index, x_index, z_index, info
x_index = x_index(0)
y_index = y_index(0)

if y_index eq -1 then begin
	result=dialog_message(info.field_name.y + ' not Found!', $
	    title='View HDF Warning!')
	plot_status = 0
	return
endif
	
this_subset = y_index
info.subset.selected = this_subset

if info.subset.data(y_index).src_type_flag eq 0 then begin
	hdf_data_y = *info.subset.data(y_index).src_data
	size_hdf_data = size(hdf_data_y)
	hdf_data_y = reform(hdf_data_y, n_elements(hdf_data_y))
endif else begin
	hdf_y_temp = *info.subset.data(y_index).src_data
	size_hdf_data = size(hdf_y_temp)
	hdf_data_y = reform(hdf_y_temp.components0, n_elements(hdf_y_temp.components0))
endelse
num_y = n_elements(hdf_data_y)

if x_index ne -1 then begin
  if info.subset.data(x_index).src_type_flag eq 0 then begin
	hdf_data_x = *info.subset.data(x_index).src_data
	hdf_data_x = reform(hdf_data_x, n_elements(hdf_data_x))
  endif else begin
	hdf_x_temp = *info.subset.data(x_index).src_data
	hdf_data_x = reform(hdf_x_temp.components0, n_elements(hdf_x_temp.components0))
  endelse
  num_x = n_elements(hdf_data_x)
endif else begin
  if info.field_name.x eq 'Time' then begin
	if info.subset.data(this_subset).src_type_flag eq 0 then begin
  		this_rank = info.subset.data(this_subset).src_rank
  		start_list = info.subset.data(this_subset).src_start(0:this_rank-1)
  		end_list = info.subset.data(this_subset).src_end(0:this_rank-1)
  		increment_list = info.subset.data(this_subset).src_increment(0:this_rank-1)
  		;array_size = long((end_list-start_list)/float(increment_list) + 0.9)
		array_size = long((end_list-start_list-1)/float(increment_list) + 1.0)
  		hdf_data_x = array_type(6, array_size)
  		if (hdf_data_x(0) eq -1) then begin
			result=dialog_message('Unable to allocate memory for Time!',$
				title='View HDF Warning!')
			plot_status = 0
			return
		endif
	endif else begin
		hdf_data_x = make_array(num_y, /DOUBLE)
	endelse
	get_seconds, info, this_subset, hdf_data_x
	num_x = n_elements(hdf_data_x)
	hdf_data_x = reform(hdf_data_x, num_x)
	subscript = where(hdf_data_x lt 86400.0, count)
	if(count eq 0) then begin
		result=dialog_message('All the Time field data are fill data!',$
			title='View HDF Warning!')
		plot_status = 0
		return
	endif
	case info.time_type.new of
		0: hdf_data_x(subscript) = hdf_data_x(subscript)/3600.0
		1: hdf_data_x(subscript) = hdf_data_x(subscript)/60.0
		else: 
	endcase
  endif else begin
	num_x = num_y
	hdf_data_x = dindgen(num_x) + 1.0
  endelse
endelse

if(num_x ne num_y) then begin
	result=dialog_message('Number of data points for two subsets are not equal!',$
	    title='View HDF Warning!')
	plot_status = 0
	return
endif

if x_index ne -1 then begin
	this_type = info.subset.data(x_index).src_types
	this_type = this_type(0)
	filldata_value_x = get_filldata_value(this_type, info.filldata)
	if filldata_value_x gt info.filldata then filldata_value_x = info.filldata
	max_value_x = get_max_value(this_type, info.filldata)
	if info.filldata gt 0 then begin
	    if max_value_x gt info.filldata then max_value_x = info.filldata
	endif
endif else begin
	filldata_value_x = info.filldata
	if info.filldata gt 0 then max_value_x = info.filldata else max_value_x = 3.0E+38
endelse

this_type = info.subset.data(y_index).src_types
this_type = this_type(0)
filldata_value_y = get_filldata_value(this_type, info.filldata)
if filldata_value_y gt info.filldata then filldata_value_y = info.filldata
max_value_y = get_max_value(this_type, info.filldata)
if info.filldata gt 0 then begin
    if max_value_y gt info.filldata then max_value_y = info.filldata
    if info.filldata lt 3.0E+37 then filldata = info.filldata * 10 $
	else filldata = 3.0E+38
endif else filldata = info.filldata    

max_value = max_value_y

if filldata_value_x gt 0 then begin
    subscript = where(hdf_data_x lt filldata_value_x and hdf_data_y lt filldata_value_y, count)
endif else begin
    subscript = where(hdf_data_x gt filldata_value_x and hdf_data_y gt filldata_value_y, count)
endelse
if (count eq 0) then begin
	result=dialog_message('Either X field or Y field data are fill data for whole array!',$
	    title='View HDF Warning!')
	plot_status = 0
	return
endif

hdf_data_z = make_array(num_x, /DOUBLE, VALUE=filldata)
hdf_error = make_array(num_x, /DOUBLE, VALUE=filldata)
y_temp = double(hdf_data_y(subscript))
x_temp = double(hdf_data_x(subscript))

correl = correlate(x_temp, y_temp)

A = [1.5, 1.5, 1.5] ; initial guess for comfit
case type_flag of
	0: begin    ; least-square polynomial fit: y = a0 + a1*x + a2*x^2 + ...
		ndegree = fix(info.field_name.z)
		if ndegree eq 0 then ndegree = 1
		coeff = poly_fit(x_temp, y_temp, ndegree, yfit, /double)
		if coeff(1) lt 0.0 then begin
			equat_string = 'Y = ' + strtrim(string(coeff(0)),2) + ' - ' + $
				strtrim(string(abs(coeff(1))),2) + ' X'
		endif else begin
			equat_string = 'Y = ' + strtrim(string(coeff(0)),2) + ' + ' + $
				strtrim(string(coeff(1)),2) + ' X'
		endelse
		out_equat_string = equat_string
		for i = 2 , ndegree do begin
		   if coeff(i) lt 0.0 then begin
			equat_string = equat_string + ' - ' + strtrim(string(abs(coeff(i))),2) + $
				' X!E'+strtrim(string(i), 2)+'!N'
			out_equat_string = out_equat_string + ' - ' + strtrim(string(abs(coeff(i))),2) + $
				' X^'+strtrim(string(i), 2)
		   endif else begin
			equat_string = equat_string + ' + ' + strtrim(string(coeff(i)),2) + $
				' X!E'+strtrim(string(i), 2)+'!N'
			out_equat_string = out_equat_string + ' + ' + strtrim(string(coeff(i)),2) + $
				' X^'+strtrim(string(i), 2)
		   endelse
		endfor
	end
	1: begin    ; Exponential : y = a0*a1^x + a2
		coeff = comfit(x_temp, y_temp, a, /EXPONENTIAL, yfit=yfit)
		if coeff(2) lt 0.0 then begin
		    equat_string = 'Y = ' + strtrim(string(coeff(0)),2) + '*' + $
			strtrim(string(coeff(1)),2) + '!EX!N - ' + strtrim(string(abs(coeff(2))),2)
		    out_equat_string = 'Y = ' + strtrim(string(coeff(0)),2) + '*' + $
			strtrim(string(coeff(1)),2) + '^X - ' + strtrim(string(abs(coeff(2))),2)
		endif else begin
		    equat_string = 'Y = ' + strtrim(string(coeff(0)),2) + '*' + $
			strtrim(string(coeff(1)),2) + '!EX!N + ' + strtrim(string(coeff(2)),2)
		    out_equat_string = 'Y = ' + strtrim(string(coeff(0)),2) + '*' + $
			strtrim(string(coeff(1)),2) + '^X + ' + strtrim(string(coeff(2)),2)
		endelse
	end
	2: begin    ; Geometric : y = a0*x^a1 + a2
		coeff = comfit(x_temp, y_temp, a, /GEOMETRIC, yfit=yfit)
		if coeff(2) lt 0.0 then begin
		    equat_string = 'Y = ' + strtrim(string(coeff(0)),2) + '*X!E' + $
			strtrim(string(coeff(1)),2) + '!N - ' + strtrim(string(abs(coeff(2))),2)
		    out_equat_string = 'Y = ' + strtrim(string(coeff(0)),2) + '*X^' + $
			strtrim(string(coeff(1)),2) + ' - ' + strtrim(string(abs(coeff(2))),2)
		endif else begin
		    equat_string = 'Y = ' + strtrim(string(coeff(0)),2) + '*X!E' + $
			strtrim(string(coeff(1)),2) + '!N + ' + strtrim(string(coeff(2)),2)
		    out_equat_string = 'Y = ' + strtrim(string(coeff(0)),2) + '*X^' + $
			strtrim(string(coeff(1)),2) + ' + ' + strtrim(string(coeff(2)),2)
		endelse
	end
	3: begin    ; Logsquare : y = a0 + a1*log10(x) + a2*log10(x)^2
		coeff = comfit(x_temp, y_temp, a, /LOGSQUARE, yfit=yfit)
		if coeff(1) lt 0.0 then begin
		    equat_string = 'Y = ' + strtrim(string(coeff(0)),2) + ' - ' + $
			strtrim(string(abs(coeff(1))),2) + '*alog10(X)'
		    out_equat_string = 'Y = ' + strtrim(string(coeff(0)),2) + ' - ' + $
			strtrim(string(abs(coeff(1))),2) + '*alog10(X)'
		endif else begin
		    equat_string = 'Y = ' + strtrim(string(coeff(0)),2) + ' + ' + $
			strtrim(string(coeff(1)),2) + '*alog10(X)'
		    out_equat_string = 'Y = ' + strtrim(string(coeff(0)),2) + ' + ' + $
			strtrim(string(coeff(1)),2) + '*alog10(X)'
		endelse
		if coeff(2) lt 0.0 then begin
		    equat_string = equat_string + ' - ' + $
			strtrim(string(abs(coeff(2))),2) + '*alog10(X)!E2!N'
		    out_equat_string = out_equat_string + ' - ' + $
			strtrim(string(abs(coeff(2))),2) + '*alog10(X)^2'
		endif else begin
		    equat_string = equat_string + ' + ' + $
			strtrim(string(coeff(2)),2) + '*alog10(X)!E2!N'
		    out_equat_string = out_equat_string + ' + ' + $
			strtrim(string(coeff(2)),2) + '*alog(X)^2'
		endelse
	end
	else: begin    ; linear fit with fix intercept: y = a0 + a1*x
		b_value = double(info.field_name.z)
		x_temp = double(x_temp)
		y_temp = double(y_temp)
		xy_temp = x_temp * y_temp
		xx_temp = x_temp * x_temp
		sum_xy = total(xy_temp)
		sum_x = total(x_temp)
		sum_x2 = total(xx_temp)
		m_value = (sum_xy - b_value*sum_x)/sum_x2
		coeff = [b_value, m_value]
		yfit = m_value * x_temp + b_value
		if coeff(1) lt 0.0 then begin
		    if coeff(0) eq 0.0 then begin
			equat_string = 'Y = ' + ' - ' + strtrim(string(abs(coeff(1))),2) + ' X'
		    endif else begin
			equat_string = 'Y = ' + strtrim(string(coeff(0)),2) + ' - ' + $
				strtrim(string(abs(coeff(1))),2) + ' X'
		    endelse
		endif else begin
		    if coeff(0) eq 0.0 then begin
			equat_string = 'Y = ' + strtrim(string(coeff(1)),2) + ' X'
		    endif else begin
			equat_string = 'Y = ' + strtrim(string(coeff(0)),2) + ' + ' + $
				strtrim(string(coeff(1)),2) + ' X'
		    endelse
		endelse
		out_equat_string = equat_string
	end
endcase

hdf_data_z(subscript) = yfit
hdf_error(subscript) = y_temp - yfit
if filldata gt 0 then begin
    subscript = where(hdf_data_z ge filldata, count)
endif else begin
    subscript = where(hdf_data_z le filldata, count)
endelse
if (count eq num_x) then begin
	result=dialog_message('All the computed result are fill data!',$
	    title='View HDF Warning!')
	plot_status = 0
	return
endif
if count ne 0 then hdf_data_z(subscript) = filldata

if filldata gt 0 then begin
    subscript = where(hdf_data_z lt filldata, count)
endif else begin
    subscript = where(hdf_data_z gt filldata, count)
endelse
if count ne 0 then begin
	hdf_data_z_temp = hdf_data_z(subscript)
	z_max = max(hdf_data_z_temp, min=z_min)
endif else begin
	result=dialog_message('All the result are fill data!',$
	    title='View HDF Warning!')
	plot_status = 0
	return
endelse

if filldata gt 0 then begin
    subscript = where(hdf_error lt filldata, err_count)
endif else begin
    subscript = where(hdf_error gt filldata, err_count)
endelse
if err_count ne 0 then begin
	hdf_error_temp = hdf_error(subscript)
	e_max = max(hdf_error_temp, min=e_min)
endif else begin
	result=dialog_message('All the error are fill data!',$
                    title='View HDF Warning!')
endelse

if filldata_value_y gt 0 then begin
    subscript = where(hdf_data_y lt filldata_value_y, count)
endif else begin
    subscript = where(hdf_data_y gt filldata_value_y, count)
endelse
if count ne 0 then begin
	hdf_data_y_temp = hdf_data_y(subscript)
	y_max = max(hdf_data_y_temp, min=y_min)
endif else begin
	result=dialog_message('All the Y variables are fill data!',$
	    title='View HDF Warning!')
	plot_status = 0
	return
endelse

if filldata_value_x gt 0 then begin
    subscript = where(hdf_data_x lt filldata_value_x, count)
endif else begin
    subscript = where(hdf_data_x gt filldata_value_x, count)
endelse
if count ne 0 then begin
	hdf_data_x_temp = hdf_data_x(subscript)
	x_max = max(hdf_data_x_temp, min=x_min)
endif else begin
	result=dialog_message('All the X variables are fill data!',$
	    title='View HDF Warning!')
	plot_status = 0
	return
endelse

info.slide.x_end = x_max
info.slide.x_start = x_min
max_range_value = [y_max, z_max]
min_range_value = [y_min, z_min]
info.slide.y_end = max(max_range_value)
info.slide.y_start = min(min_range_value)

filename = info.subset.data(this_subset).src_filename

dot=strpos(info.field_name.x,'[')
if dot ne -1 then xtitle=strmid(info.field_name.x,0,dot) $
	else xtitle = info.field_name.x

if xtitle eq 'Time' then begin
	case info.time_type.new of
		0: xtitle = xtitle + ', hour'
		1: xtitle = xtitle + ', minute'
		else: xtitle = xtitle + ', second'
	endcase
endif

dot=strpos(info.field_name.y,'[')
if dot ne -1 then ytitle=strmid(info.field_name.y,0,dot) $
	else ytitle = info.field_name.y

xyname = 'Curve fit for '+ ytitle+ ' wrt ' + xtitle

if (print_flag eq 0) then begin
	temp_name = 'Curve fit for ' + ytitle + ' wrt ' + xtitle
	get_variable_name, temp_name, info
	widget_control, get_uvalue=info, info.base
	if info.variablename eq 'None' then begin
	    plot_status = 0
	    return
	endif

	widget_control, /hourglass

	the_rank = info.subset.data(this_subset).src_rank
	if info.subset.data(this_subset).src_type_flag eq 0 then begin
	   case size_hdf_data(0) of
		2: begin
			hdf_data = reform(hdf_data_z, size_hdf_data(1), size_hdf_data(2))
			hdf_data_error = reform(hdf_error, size_hdf_data(1), size_hdf_data(2))
		   end
		3: begin
			hdf_data = reform(hdf_data_z, size_hdf_data(1), size_hdf_data(2), $
						 size_hdf_data(3))
			hdf_data_error = reform(hdf_error, size_hdf_data(1), size_hdf_data(2), $
						 size_hdf_data(3))
		   end
		else: begin
			hdf_data = hdf_data_z
			hdf_data_error = hdf_error
		   end
	   endcase
	endif else begin
  		the_order = info.subset.data(this_subset).src_order(0)
		blank = array_type(6, the_order)
		single_record=create_struct( 'components' + '0', blank) 
		hdf_data=replicate(single_record, size_hdf_data(1))
		hdf_data_error = replicate(single_record, size_hdf_data(1))
		jj=0L
		for i=0L, size_hdf_data(1)-1 do begin
			for j=0L, the_order-1 do begin
				hdf_data(i).components0(j) = hdf_data_z(jj)
				hdf_data_error(i).components0(j) = hdf_error(jj)
				jj = jj + 1
			endfor
		endfor
	endelse
	set_statistics_subset, info.variablename, this_subset, the_rank, info, hdf_data
	temp_name = 'Error of Curve fit for ' + ytitle + ' wrt ' + xtitle
	set_statistics_subset, temp_name, this_subset, the_rank, info, hdf_data_error

	;the_message = [ 'Do you want to write the coefficient to a file?']
	;result=dialog_message(the_message, /Question, title='View HDF Question!')
	org_coeff   = strcompress(string(info.curvefit.coeff), /REMOVE_ALL)
	org_result  = strcompress(string(info.curvefit.result), /REMOVE_ALL)
	org_data    = strcompress(string(info.curvefit.data), /REMOVE_ALL)
	org_error   = strcompress(string(info.curvefit.error), /REMOVE_ALL)
	org_display = strcompress(string(info.curvefit.display), /REMOVE_ALL)
	org_points  = strcompress(string(info.curvefit.points), /REMOVE_ALL)

	desc = [ $
		'0, label, Curve Fit Output Option, center, font='+info.font, $
		'0, label, "   ", center, font=' + info.font, $
		'1, base, ,column, frame', $
		'0, label, Do you want to write the coefficient to a file?, left, font='+info.font, $
		'2, button, No|Yes, EXCLUSIVE, row, set_value='+org_coeff+', tag=coeff', $
		'1, base, ,column, frame', $
		'0, label, Do you want to plot the data?, left, font='+info.font, $
		'2, button, No|Yes, EXCLUSIVE, row, set_value='+org_data+', tag=data', $
		'1, base, ,column, frame', $
		'0, label, Do you want to plot the curve fit result?, left, font='+info.font, $
		'0, button, No|Yes, EXCLUSIVE, row, set_value='+org_result+', tag=result', $
		'0, droplist, Yes|No, label_left=Display all data points:, set_value='+org_display  $
		   + ', tag=display, font='+info.font+', labelfont='+info.font, $
		'2, integer,'+org_points+', title=Number of points:, width=12, tag=points, font='+info.font $
		   +', fieldfont='+info.font+ ', labelfont='+info.font, $
		'1, base, ,column, frame', $
		'0, label, Do you want to plot the error?, left, font='+info.font, $
		'2, button, No|Yes, EXCLUSIVE, row, set_value='+org_error+', tag=error', $
		'0, label, "   ", center, font='+info.font, $
		'1, base, , row, space=60, center', $
		'0, button, Done, QUIT, tag=done, font='+info.font, $
		'2, button, Cancel, QUIT, tag=cancel, font='+info.font]
	
	result = cw_form(desc, /column, title='Curve Fit Output Option')
	if result.cancel eq 1 then begin
		plot_status = 0
		return
	endif

	info.curvefit.coeff = result.coeff
	info.curvefit.result = result.result
	info.curvefit.error = result.error
	info.curvefit.data = result.data
	info.curvefit.display = result.display
	info.curvefit.points = result.points

	if (info.curvefit.coeff eq 0 and info.curvefit.result eq 0 and $
	    info.curvefit.data eq 0 and info.curvefit.error eq 0 ) then begin
	    plot_status = 0
	    return
	endif

	widget_control, /hourglass

	;if result eq 'Yes' then begin
	if info.curvefit.coeff eq 1 then begin
		count = check_directory(info.export_path, info.home_path)
		if count eq 0 then begin
			CD, '.', CURRENT=pwd
			info.export_path = pwd
		endif
		export_name=dialog_pickfile(filter='*.dat', path=info.export_path, $
			file=info.export_file, get_path=export_path,/write)
		if export_name ne "" then begin
			export_result=STRPOS(export_name, export_path)
			if export_result eq -1 then export_name=export_path+export_name
			print,"Filename=", export_name
			info.export_path = export_path
			default_file = ''
			default_file = get_default_file(export_name)
			if default_file ne 'None' then info.export_file = default_file
			widget_control, /hourglass
			widget_control, info.widgets.current_file, get_value=this_name
			get_lun, unit
			openw, unit, export_name
			printf, unit, format='("Source Data Filename: ",A)',this_name
			data_name = info.subset.data(info.subset.selected).subset_name
			data_name = data_name(0)
			unit_name = info.subset.data(info.subset.selected).src_unitname
			unit_name = unit_name(0)
			temp_length = strlen(unit_name)
			unitlabel = ''
			if (temp_length gt 0) then $
				unitlabel = strmid(unit_name,2,temp_length-2)
			printf,unit, format='("Data Name:  ",A)', data_name
			printf,unit, format='("Unit:  ",A)', unitlabel
			data_range = ''
			data_range = get_data_range(info.subset.selected,info)
			printf,unit, format='("Data Range:  ",A)',data_range
			if info.subset.data(info.subset.selected).src_crit_flag eq 1 then begin
				this_subset = info.subset.selected
				crit_string = ''
				crit_string = get_crit_string(this_subset, info)
				temp_name = str_sep(crit_string, '!C')
				num_temp = n_elements(temp_name)
				for i = 0, num_temp-1 do begin
				   temp_length = strlen(temp_name(i))
				   dot=strpos(temp_name(i),';')
				   if( dot ne -1) then begin
					crit1 = strtrim(strmid(temp_name(i),0,dot),2)
					crit2 = strtrim(strmid(temp_name(i),dot+1,temp_length-1),2)
					if i eq 0 then printf,unit,crit1 $
						else printf,unit,'           '+crit1
					printf,unit,'           '+crit2
				   endif else begin
					crit1 = strtrim(temp_name(i),2)
					if i eq 0 then printf,unit,crit1 $
						else printf,unit,'           '+crit1
				   endelse
				endfor
				printf,unit
			endif
			case info.curvefit.type of
				0: temp_string = 'The curve fit equation with polynomial is:'
				1: temp_string = 'The curve fit equation with Exponential is:' 
				2: temp_string = 'The curve fit equation with Geometric is:'
				else: temp_string = 'The curve fit equation with Logsquare is:'
			endcase
			printf,unit,temp_string
			printf,unit
			printf,unit,'    '+out_equat_string
			printf,unit
			if x_index ne -1 then begin
				temp_name = info.subset.data(x_index).src_unitname
				temp_name = temp_name(0)
				dot=strpos(temp_name,'N/A')
					if( dot eq -1) then xvalue = xtitle + temp_name
			endif else xvalue = xtitle

			temp_name = info.subset.data(y_index).src_unitname
			temp_name = temp_name(0)
			dot=strpos(temp_name,'N/A')
			if( dot eq -1) then yvalue = ytitle + temp_name

			printf,unit,'    '+'Y = '+yvalue
			printf,unit,'    '+'X = '+xvalue
			printf,unit
			cor_string = 'Linear Pearson correlation coefficient = '
			cor_string = cor_string + strtrim(string(correl),2)
			printf,unit,cor_string
			close,unit
			free_lun, unit
			info.output_path = info.export_path
			CD, info.output_path, CURRENT=old_dir
			output_name_list=findfile(info.filter, count=count)
			if count eq 0 then output_name_list = [ 'None' ]
			widget_control, info.widgets.output, set_value=output_name_list
			widget_control, info.widgets.outputdir, set_value=info.output_path
			CD, old_dir
		endif
	endif

	;the_message = [ 'Do you want to plot the curve fit result?']
	;result=dialog_message(the_message, /Question, title='View HDF Question!')

	;if result eq 'No' then return
	if info.curvefit.result eq 0 and info.curvefit.data eq 0 and $
            info.curvefit.error eq 0 then begin
	    plot_status = 0
	    return
	endif

	info.plot_error = info.curvefit.error
	;info.plot_error = 1
	;the_message = [ 'Do you want to plot the error?']
	;result=dialog_message(the_message, /Question, title='View HDF Question!')

	;if result eq 'No' then info.plot_error = 0
	widget_control, set_uvalue=info, info.base
endif

widget_control, /hourglass
widget_control, get_uvalue=info, info.base
if info.canceloption eq 'Yes' then begin
	info.canceloption = 'No'
	widget_control, set_uvalue=info, info.base
	plot_status = 0
	return
endif 

set_axis_ranges, info, YRange, Ystyle, XRange, Xstyle, ZRange, Zstyle

data_range = ''
data_range = get_data_range(this_subset,info)
if !D.Name eq 'PS' or !D.Name eq 'PRINTER' or !D.Name eq 'WIN' or info.char.font eq 0 then begin
	the_title='Curve Fit for ' + ytitle + ' wrt ' + xtitle + '!C Data Range: ' + data_range
endif else begin
	the_title='Curve Fit for ' + ytitle + ' wrt ' + xtitle + '!C!C Data Range: ' + data_range
endelse

if info.subset.data(this_subset).src_crit_flag eq 1 then begin
	crit_string = ''
	crit_string = get_crit_string(this_subset, info)
	if !D.Name eq 'PS' and info.eps_out.type eq 1 then $
		!P.Position = [0.235, 0.15, 0.99, 0.92] $
		else !P.Position = [0.060, 0.120, 0.98, 0.93]
	temp_name = str_sep(crit_string, '!C')
	num_temp = n_elements(temp_name)
	!P.Position(1) = !P.Position(1) + (num_temp-1)*0.025
endif else begin
	if !D.Name eq 'PS' and info.eps_out.type eq 1 then $
		!P.Position = [0.235, 0.15, 0.99, 0.92] $
		else !P.Position = [0.060, 0.100, 0.98, 0.93]
endelse 

if info.style.symbolline eq 1 then plot_symbol = - info.style.symbol $
	else plot_symbol = info.style.symbol

if x_index ne -1 then begin
	temp_name = info.subset.data(x_index).src_unitname
	temp_name = temp_name(0)
	dot=strpos(temp_name,'N/A')
	if( dot eq -1) then xtitle = xtitle + temp_name
endif

temp_name = info.subset.data(y_index).src_unitname
temp_name = temp_name(0)
dot=strpos(temp_name,'N/A')
if( dot eq -1) then ytitle = ytitle + temp_name

get_ticklen, info.style.grid, xticklen, yticklen 

if (print_flag eq 0) or (print_flag eq 3) then plot_dialogue , xyname, info

if !D.Name ne 'PRINTER' then begin
    if !D.Name ne 'WIN' and info.char.font ne 0 then begin
	xtitle= '!C' + xtitle + '!C'
    endif else begin
	xtitle = xtitle + '!C'
    endelse
endif
if !D.Name eq 'PS' or !D.Name eq 'PRINTER' then begin
	old_charsize = !X.CHARSIZE
	!X.CHARSIZE = 0.9
	!Y.CHARSIZE = 0.9	
endif

if info.axis_state ne 2 and info.axis_state ne 4 and info.axis_state ne 7 $
    and info.axis_state ne 9 then begin
	if y_max gt z_max then temp_max = y_max $
		else temp_max = z_max
	if y_min lt z_min then temp_min = y_min $
		else temp_min = z_min
	y1range = [temp_min,temp_max]
	temp_max = temp_max + (temp_max - temp_min)*0.25
endif else begin
        temp_max = YRange(1)
        temp_min = YRange(0)
	y1range = [temp_min,temp_max]
        temp_max = temp_max + (temp_max - temp_min)*0.25
endelse

if filldata_value_x gt 0 then begin
    subscript = where(hdf_data_x lt filldata_value_x, count)
endif else begin
    subscript = where(hdf_data_x gt filldata_value_x, count)
endelse
if count ne 0 then begin
        hdf_data_x = hdf_data_x(subscript)
	hdf_data_y = hdf_data_y(subscript)
	hdf_data_z = hdf_data_z(subscript)
	hdf_error = hdf_error(subscript)
endif

if info.plot_error eq 1 then begin
    if info.axis_state lt 6 then begin
        get_range, e_max, e_min, err_max, err_min
    endif else begin
        err_min = info.range.y2_start
        err_max = info.range.y2_end
    endelse
    err_max = err_max + (err_max - err_min)*0.25
    if info.curvefit.data eq 1 or info.curvefit.result eq 1 then begin
	if !P.Position(2) gt 0.0 then !P.Position(2) = !P.Position(2) - 0.03
	!X.MARGIN = [10, 10]
	ystyle = ystyle + 8
    endif
endif

if info.curvefit.data eq 1 or info.curvefit.result eq 1 then begin
    YRange = [temp_min, temp_max]

    if info.style.xlog gt 0 then begin
	check_max = max(hdf_data_x, min=check_min)
	XRange = set_log_range(XRange, check_min, check_max)
    endif

    if info.style.ylog gt 0 then begin
	YRange = set_log_range(YRange, YRange(0), YRange(1))
    endif

    plot,hdf_data_x, hdf_data_y, MIN_VALUE = temp_min, $
       	MAX_VALUE = max_value, /YNOZERO, /NODATA, FONT=info.char.font, $
	charsize=info.char.size, xtitle=xtitle, ytitle=ytitle, $
	title=the_title, xticklen=xticklen, yticklen=yticklen, $
	subtitle="File: " + filename + "  Date:" + systime(0), $
       	xrange=XRange, yrange=YRange, xstyle=Xstyle, ystyle=Ystyle, $
	xlog=info.style.xlog, ylog=info.style.ylog
endif else begin
    YRange = [err_min, err_max]
    ytitle = 'Error of Curve Fit data'

    plot,hdf_data_x, hdf_error, MIN_VALUE = err_min, $
	MAX_VALUE = max_value, /YNOZERO, /NODATA, FONT=info.char.font, $
	charsize=info.char.size, xtitle=xtitle, ytitle=ytitle, $
	title=the_title, xticklen=xticklen, yticklen=yticklen, $
	subtitle="File: " + filename + "  Date:" + systime(0), $
	xrange=XRange, yrange=YRange, xstyle=Xstyle, ystyle=Ystyle
endelse

if info.axis_state gt 0 then begin
	fit_flag = 0
	fit_data_range, info.axis_state, fit_flag, 2, 1, xrange, y1range, 0, $
		0, hdf_data_x, hdf_data_y, hdf_data_z, 0, hdf_error
	if fit_flag eq 1 then begin
	    plot_status = 0
	    return
	endif
endif

if info.curvefit.data eq 1 then begin
    if info.multiple.styleflag eq 1 then begin
	num = 0
	style_name = info.subset.data(this_subset).subset_name
	style_name = style_name(0)
	get_input_style, info, style_name, num, linetype, plot_symbol, colorindex
	if linetype lt 0 then begin
	    plot_status = 0
	    return
	endif
    endif else begin
	linetype = info.style.linetype
	colorindex = info.style.colorindex
    endelse

    oplot, hdf_data_x, hdf_data_y,MAX_VALUE = max_value, MIN_VALUE = temp_min, $
	psym = plot_symbol, linestyle=linetype, $
	symsize = info.style.symbolsize, thick = info.style.linethick, $
	color = colorindex

    legend_title = ytitle
    y_leg = !Y.WINDOW(1) - 0.03
    y_leg_t = y_leg - 0.005
    x_leg_s = !X.WINDOW(0) + 0.03
    x_leg_e = x_leg_s + 0.05
    leg_start = convert_coord(x_leg_s, y_leg, /NORMAL, /TO_DATA)
    leg_end   = convert_coord(x_leg_e, y_leg, /NORMAL, /TO_DATA)
    oplot, [leg_start(0), leg_end(0)], [leg_start(1), leg_end(1)], $
	psym = plot_symbol, linestyle=linetype, $
	symsize = info.style.symbolsize, thick = info.style.linethick, $
	color = colorindex
    xyouts, x_leg_e+0.01, y_leg_t, legend_title, /NORMAL, font=info.char.font, $
	charsize=info.char.size
endif

if info.curvefit.result eq 1 then begin
    if info.curvefit.data eq 1 then begin
	incre = 1
	y_leg_decre = 0.055
    endif else begin
	incre = 0
	y_leg_decre = 0.03
    endelse
    linetype = info.style.linetype + incre
    if linetype gt 5 then linetype = 0
    if info.style.symbol gt 0 then plot_symbol = info.style.symbol + incre
    if plot_symbol gt 7 then plot_symbol = 1
    if info.style.symbolline eq 1 then plot_symbol = - plot_symbol

    if info.multiple.styleflag eq 1 then begin
	num = 1
	style_name = info.subset.data(this_subset).subset_name
	style_name = style_name(0)
	style_name = 'Curve Fit of ' + style_name
	get_input_style, info, style_name, num, linetype, plot_symbol, colorindex
	if linetype lt 0 then begin
	    plot_status = 0
	    return
	endif
	if info.plot_error eq 0 then info.multiple.resetflag = 0
    endif else begin
	colorindex = info.style.colorindex
    endelse

    if info.curvefit.display eq 0 then begin
	oplot, hdf_data_x, hdf_data_z,MAX_VALUE = max_value, MIN_VALUE = temp_min, $
	    psym = plot_symbol, linestyle=linetype, $
	    symsize = info.style.symbolsize, thick = info.style.linethick, $
	    color = colorindex
    endif else begin
	num_points = info.curvefit.points
	max_x = max(hdf_data_x, min=min_x)
	x_interval = (max_x - min_x)/(num_points - 1.0)
	hdf_x_temp = findgen(num_points)*x_interval + min_x
	case type_flag of
	    0: begin    ; least-square polynomial fit: y = a0 + a1*x + a2*x^2 + ...
		hdf_z_temp = poly(hdf_x_temp, coeff)
	    end
	    1: begin    ; Exponential : y = a0*a1^x + a2
		hdf_z_temp = coeff(0)*(coeff(1)^hdf_x_temp) + coeff(2)
	    end
	    2: begin    ; Geometric : y = a0*x^a1 + a2
		hdf_z_temp = coeff(0)*(hdf_x_temp^coeff(1)) + coeff(2)
	    end
	    3: begin    ; Logsquare : y = a0 + a1*log(x) + a2*log(x)^2
	        hdf_z_temp = coeff(0) + coeff(1)*alog10(hdf_x_temp) + $
			     coeff(2)*(alog10(hdf_x_temp))^2
	    end
	    else: begin ; linear fit with fix intercept: y = a0 + a1*x
		hdf_z_temp = poly(hdf_x_temp, coeff)
	    end
	endcase

	oplot, hdf_x_temp, hdf_z_temp,MAX_VALUE = max_value, MIN_VALUE = temp_min, $
	    psym = plot_symbol, linestyle=linetype, $
	    symsize = info.style.symbolsize, thick = info.style.linethick, $
	    color = colorindex
     endelse

    legend_title = 'Curve Fit of ' + ytitle
    y_leg = !Y.WINDOW(1) - y_leg_decre
    y_leg_t = y_leg - 0.005
    x_leg_s = !X.WINDOW(0) + 0.03
    x_leg_e = x_leg_s + 0.05
    leg_start = convert_coord(x_leg_s, y_leg, /NORMAL, /TO_DATA)
    leg_end   = convert_coord(x_leg_e, y_leg, /NORMAL, /TO_DATA)
    oplot, [leg_start(0), leg_end(0)], [leg_start(1), leg_end(1)], $
	psym = plot_symbol, linestyle=linetype, symsize = info.style.symbolsize, $
	thick = info.style.linethick, color = colorindex
    xyouts, x_leg_e+0.01, y_leg_t, legend_title, /NORMAL, font=info.char.font, $
	charsize=info.char.size
endif

if info.plot_error eq 1 then begin
	if info.curvefit.data eq 1 then begin
	    incre = 1
	    y_leg_decre = 0.055
	endif else begin
	    incre = 0
	    y_leg_decre = 0.03
	endelse
	if info.curvefit.result eq 1 then begin
	    incre = incre + 1
	    y_leg_decre = y_leg_decre + 0.025
	endif
	linetype = info.style.linetype + incre
	if linetype gt 5 then linetype = 0
	if info.style.symbol gt 0 then plot_symbol = plot_symbol + incre
	if plot_symbol gt 7 then plot_symbol = 1
	if info.style.symbolline eq 1 then plot_symbol = - plot_symbol

	if info.multiple.styleflag eq 1 then begin
	    num = 2
	    style_name = 'Error of curve fit'
	    get_input_style, info, style_name, num, linetype, plot_symbol, colorindex
	    if linetype lt 0 then begin
		plot_status = 0
		return
	    endif
	    info.multiple.resetflag = 0
	endif else begin
	    colorindex = info.style.colorindex
	endelse

	legend_title = 'Error'
	y_leg = !Y.WINDOW(1) - y_leg_decre
	y_leg_t = y_leg - 0.005
	x_leg_s = !X.WINDOW(0) + 0.03
	x_leg_e = x_leg_s + 0.05
	leg_start = convert_coord(x_leg_s, y_leg, /NORMAL, /TO_DATA)
	leg_end   = convert_coord(x_leg_e, y_leg, /NORMAL, /TO_DATA)
	oplot, [leg_start(0), leg_end(0)], [leg_start(1), leg_end(1)], $
		psym = plot_symbol, linestyle=linetype, symsize = info.style.symbolsize, $
		thick = info.style.linethick, color = colorindex
	xyouts, x_leg_e+0.01, y_leg_t, legend_title, /NORMAL, font=info.char.font, $
		charsize=info.char.size

	if !Y.TYPE eq 1 then !Y.TYPE = 0
	if info.curvefit.data eq 1 or info.curvefit.result eq 1 then begin
	    Axis, YAXIS=1, ytitle = 'Error', YRANGE=[err_min, err_max], $
		FONT=info.char.font, charsize=info.char.size, ystyle=2, $
		ticklen=0.01, /SAVE
	endif

	if info.axis_state lt 6 then begin
	    if info.filldata gt 0 then max_y_range = info.filldata else max_y_range = 3.0E+38
	endif else max_y_range = info.range.y2_end
	;oplot, hdf_data_x, hdf_error,MAX_VALUE = info.filldata, $
	oplot, hdf_data_x, hdf_error,MAX_VALUE = max_y_range, MIN_VALUE = err_min, $
		psym = plot_symbol, linestyle=linetype, $
		symsize = info.style.symbolsize, thick = info.style.linethick, $
		color = colorindex
endif

legend_title = '(Linear Pearson correlation coefficient = ' + $
	strtrim(string(correl),2)+')'
y_leg = !Y.WINDOW(1) - 0.085
x_leg = !X.WINDOW(0) + 0.15
xyouts, x_leg, y_leg, legend_title, /NORMAL, font=info.char.font, $
	charsize=info.char.size

y_leg = !Y.WINDOW(1) - 0.125
x_leg = !X.WINDOW(0) + 0.05
charsize = 1.5 * info.char.size
xyouts, x_leg, y_leg, equat_string, /NORMAL, font=info.char.font, $
	charsize=charsize

if info.subset.data(this_subset).src_crit_flag eq 1 then begin
	if !D.Name eq 'PS' or !D.Name eq 'PRINTER' then begin
		charsize = 0.9*info.char.size
		y_location = 0.125
	endif else begin
		charsize = info.char.size
		y_location = 0.11
	endelse
	;xyouts, !P.Position(0), !P.Position(1)-y_location, crit_string, /NORMAL, $
	xyouts, 0.08, !P.Position(1)-y_location, crit_string, /NORMAL, $
		font=info.char.font, charsize=charsize
endif

if info.addtext.key eq 1 then write_add_text, info

if !D.Name eq 'PS' or !D.Name eq 'PRINTER' then begin
	!X.CHARSIZE = old_charsize
	!Y.CHARSIZE = old_charsize
endif

!P.Position = [0.0, 0.0, 0.0, 0.0]

widget_control, set_uvalue=info, info.widgets.base
widget_control, set_uvalue=info, info.base

end

;------------------------------------------------------------------
pro curve_fit_setup, info, value, xflag, yflag, zflag

pro_name = 'curve_fit_setup'
@getinfo

base_loc = widget_info(info.base, /geometry)
xoffset = base_loc.xoffset + 100
case info.curvefit.type of
	0: base_title = "Select Polynomial Curve Fit Fields"
	1: base_title = "Select Exponential Curve Fit Fields"
	2: base_title = "Select Geometric Curve Fit Fields"
	3: base_title = "Select Logsquare Curve Fit Fields"
	else: base_title = "Select Linear Curve Fit Fields"
endcase

base=widget_base( GROUP_LEADER=info.base, /MODAL, COLUMN=1, MAP=1, $
	TITLE=base_title, uvalue=info, XOFFSET=xoffset)

case info.curvefit.type of
	0: title = "Y = a0 + a1*X + a2*X^2 + ..."
	1: title = "Y = a0*a1^X + a2"
	2: title = "Y = a0*X^a1 + a2"
	3: title = "Y = a0 + a1*log10(X) + a2*log10(X)^2"
	else: title = "Y = a0 + a1*X"
endcase

curve_text=widget_label(base, $ FONT=info.font, /align_center, $
	value=title)

x_group=widget_base(base, row=1,map=1)
y_group=widget_base(base, row=1, map=1)
z_group=widget_base(base, row=1, map=1)

create_curve_fields, x_field, y_field, z_field, x_group, y_group, $
	z_group, xflag, yflag, zflag, info.curvefit.type, info

x_list = [info.name_list_subset, 'Time', 'Sample']
get_curve_parameter_names, x_field, y_field, xflag, yflag, x_list, $
	info.name_list_subset

make_curve_buttons, x_field, y_field, z_field, x_group, y_group, z_group,$
        base, xflag, yflag, zflag

widget_control, set_uvalue=info, base  
widget_control,/realize, base

XMANAGER, 'set_curvefields', base

END

;--------------------------------------------------------------------------------
pro curve_doneCB, event

pro_name = 'curve_doneCB'
@getinfo

widget_control, get_uvalue=info, event.top
widget_control, get_uvalue=info, info.base

if(widget_info(info.widgets.zfield, /VALID_ID)) then begin
	widget_control, info.widgets.zfield, get_value=zvalue
	zvalue = zvalue(0)
	info.field_name.z = zvalue
endif

widget_control, event.top, /destroy

widget_control, set_uvalue=info, info.base

end

;--------------------------------------------------------------------------------
pro cancel_criterion, event

pro_name = 'cancel_criterion'
@getinfo

widget_control, get_uvalue=info, event.id
widget_control, get_uvalue=info, info.base

widget_control, event.top, /destroy

info.criterion.flag = 0
;WIDGET_CONTROL, info.widgets.criterion, SENSITIVE = info.criterion.flag

if(widget_info(info.widgets.base, /VALID_ID)) then $
	widget_control, set_uvalue=info, info.widgets.base
widget_control, set_uvalue=info, info.base

end

;--------------------------------------------------------------------------------
pro doneCB, event

pro_name = 'doneCB'
@getinfo

widget_control, event.top, /destroy

end

;------------------------------------------------------------------
;       donepick
;------------------------------------------------------------------
pro donepick,event
 
widget_control, get_uvalue=info, event.top
widget_control, get_uvalue=top_base, event.id
top_base = long(top_base)
widget_control, event.top, /destroy
if(widget_info(top_base, /VALID_ID)) then $
	widget_control, top_base, /destroy
widget_control, set_uvalue=info, info.base
 
end
 
;--------------------------------------------------------------------------------
function error_check_pickfile, file

pro_name = 'error_check_pickfile'
@getinfoa

result=''

if file eq "" then result=dialog_message('You must choose a filename!',$
                        title='View HDF Warning!')

return, result

end

;--------------------------------------------------------------------------------
pro edit_color_doneCB, event

pro_name = 'edit_color_doneCB'
@getinfo

widget_control, event.top, get_uvalue=current_id
widget_control, event.top, /destroy

if current_id ne -1 then wset, current_id

end

;--------------------------------------------------------------------------------
pro export_list, info, export_type, print_flag

pro_name = 'export_list'
@getinfo

if info.name_list_subset(0) eq "None" then begin
         result=dialog_message('No data read in Subset list yet!',$
                    title='View HDF Warning!')
         return
end

count = check_directory(info.list_path, info.home_path)
if count eq 0 then begin
	CD, '.', CURRENT=pwd
	info.list_path = pwd
endif
export_name = dialog_pickfile(filter='*.dat', path=info.list_path, $
			file=info.export_file, get_path=export_path, /write)

if export_name eq "" then return

export_result=STRPOS(export_name, export_path)

if export_result eq -1 then export_name=export_path+export_name
print,"Filename=", export_name

widget_control, /hourglass

pick_export_variables, info

widget_control, get_uvalue=info, info.base

info.list_path = export_path
default_file = ''
default_file = get_default_file(export_name)
if default_file ne 'None' then info.export_file = default_file

widget_control, /hourglass


subscripts = where(info.out.pick eq 1, numout)

print, 'number of variables picked = ', numout

if (numout eq 0) then begin
  result=dialog_message('No data selected to export!',$
                    title='View HDF Warning!')
  return
end

get_lun, unit
openw, unit, export_name

check_sds=where(info.subset.data(subscripts).src_type_flag eq 0, count)

case count of
   numout: export_sds_list, info, export_type, unit, print_flag
   0: export_vdata_list, info, export_type, unit, print_flag
   else : begin
          result=dialog_message('Not all the exported data are SDS or Vdata!', $
                 title='View HDF Warning!')
          close, unit
	  free_lun, unit
          return
   end
 endcase

close,unit
free_lun, unit

info.output_path = info.list_path
CD, info.output_path, CURRENT=old_dir
output_name_list=findfile(info.filter, count=count)
if count eq 0 then output_name_list = [ 'None' ]
 
widget_control, info.widgets.output, set_value=output_name_list
widget_control, info.widgets.outputdir, set_value=info.output_path
 
CD, old_dir
 
result=dialog_message('Exporting List Completed!',$
                title='Notice!')

end

;--------------------------------------------------------------------------------
pro export_sds, info , unit, print_flag

pro_name = 'export_sds'
@getinfo

data_name = info.subset.data(info.subset.selected).subset_name
data_name = data_name(0)
unit_name = info.subset.data(info.subset.selected).src_unitname
unit_name = unit_name(0)
temp_length = strlen(unit_name)
unitlabel = ''
if (temp_length gt 0) then $
	unitlabel = strmid(unit_name,2,temp_length-2)

printf,unit, format='("SDS Name:  ",A)', data_name
printf,unit, format='("Unit:  ",A)', unitlabel
data_range = ''
data_range = get_data_range(info.subset.selected,info)
printf,unit, format='("Data Range:  ",A)',data_range

if info.subset.data(info.subset.selected).src_crit_flag eq 1 then begin
	this_subset = info.subset.selected
	crit_string = ''
	crit_string = get_crit_string(this_subset, info)
	temp_name = str_sep(crit_string, '!C')
	num_temp = n_elements(temp_name)
	for i = 0, num_temp-1 do begin
		temp_length = strlen(temp_name(i))
		dot=strpos(temp_name(i),';')
		if( dot ne -1) then begin
			crit1 = strtrim(strmid(temp_name(i),0,dot),2)
			crit2 = strtrim(strmid(temp_name(i),dot+1,temp_length-1),2)
			if i eq 0 then printf,unit,crit1 $
				else printf,unit,'           '+crit1
				printf,unit,'           '+crit2
		endif else begin
			crit1 = strtrim(temp_name(i),2)
			if i eq 0 then printf,unit,crit1 $
				else printf,unit,'           '+crit1
		endelse
	endfor
	printf,unit
endif

hdf_data = *info.subset.data(info.subset.selected).src_data

; NOTE: This currently assumes a 2D SDS.
;       Could check the rank.
;       This also assumes float not integer data
;
; The data array returned from the C code does not
; have the same indices as what the user put in.

if print_flag eq 1 then begin
    this_type = info.subset.data(info.subset.selected).src_types
    this_type = this_type(0)
    filldata_value = get_filldata_value(this_type, info.filldata)
    if filldata_value gt 0 then begin
	subscript = where(hdf_data lt filldata_value, count)
    endif else begin
	subscript = where(hdf_data gt filldata_value, count)
    endelse
    if count ne 0 then hdf_data = hdf_data(subscript) $
	else hdf_data = 0
endif

temp='('+info.precision+')'
temp=temp(0)
printf, unit, format=temp, hdf_data

;size_hdf = size(hdf_data)

;case size_hdf(0) of
;1: begin
;	col_start=0L
;	col_end = size_hdf(1)
;
;	temp='('+info.precision+')'
;	temp=temp(0)
;
;	for j=col_start,(col_end-1) do begin
;	    printf, unit, format=temp, hdf_data(j)
;        endfor
;   end
;2: begin
;	col_start=0L
;	col_end = size_hdf(2)
;	row_start=0L
;	row_end = size_hdf(1)
;
;	temp='('+info.precision+')'
;	temp=temp(0)
;
;	for j=col_start,(col_end-1) do begin
;		for i=row_start,(row_end-1) do begin
;	            printf, unit, format=temp, hdf_data(i,j)
;		endfor
;	endfor
;    end
;3: begin
;	k_start=0L
;	k_end = size_hdf(3)
;	col_start=0L
;	col_end = size_hdf(2)
;	row_start=0L
;	row_end = size_hdf(1)
;
;	temp='('+info.precision+')'
;	temp=temp(0)
;
;	for k=k_start, (k_end-1) do begin
;		for j=col_start,(col_end-1) do begin
;			for i=row_start,(row_end-1) do begin
;			    printf, unit, format=temp, hdf_data(i,j)
;			endfor
;		endfor
;	endfor
;    end
;else: begin
;	result=dialog_message('Only support SDS rank 1 to 3!',$
;		title='View HDF Warning!')
;	return
;    end
;endcase

end

;--------------------------------------------------------------------------------
pro export_sds_list, info, export_type, unit, print_flag

pro_name = 'export_sds_list'
@getinfo

subscripts = where(info.out.pick eq 1, numout)

for i = 1 , numout-1 do begin

	if(info.subset.data(subscripts(i)).src_rank ne info.subset.data(subscripts(i-1)).src_rank) $
        then begin
                result=dialog_message('Not all SDS data have same rank!',$
                        title='View HDF Warning!')
                return
        endif

        rank = info.subset.data(subscripts(i)).src_rank

        for j = 0 , rank do begin
        	if(info.subset.data(subscripts(i)).src_start(j) ne $
		info.subset.data(subscripts(i-1)).src_start(j)) then begin

                	result=dialog_message('Not all SDS data have same start!',$
                        title='View HDF Warning!')
                	return
          	endif

          	if(info.subset.data(subscripts(i)).src_end(j) ne $
		info.subset.data(subscripts(i-1)).src_end(j)) then begin
                	result=dialog_message('Not all SDS data have same end!',$
                        title='View HDF Warning!')
                	return
          	endif

          	if(info.subset.data(subscripts(i)).src_increment(j) ne $
		info.subset.data(subscripts(i-1)).src_increment(j)) then begin
                	result=dialog_message('Not all SDS data have same increment!',$
                        title='View HDF Warning!')
                	return
          	endif
        endfor

endfor

  hdf_data = *info.subset.data(subscripts(0)).src_data
        check_size = size(hdf_data)

  if export_type eq 0 then begin
        case check_size(0) of
           1: out_name = [ "Record Number" ]
           2: out_name = [ "Record Number" , "Sample Number" ]
           3: out_name = [ "Record Number" , "i" , "j" ]
           else : begin
                  result=dialog_message('Only support SDS rank 1 to 3 for Export List!',$
                        title='View HDF Warning!')
                  return
                  end
        endcase
	unit_name = out_name
  endif else begin
	get_time_flag = 1
	if info.rangetype.get_time eq 1 then begin
	  this_rank = info.subset.data(subscripts(0)).src_rank
	  start_list = lonarr(this_rank)
	  end_list = lonarr(this_rank)
	  increment_list = lonarr(this_rank)
	  array_size = lonarr(this_rank)
	  start_list = info.subset.data(subscripts(0)).src_start(0:this_rank-1)
	  end_list = info.subset.data(subscripts(0)).src_end(0:this_rank-1)
	  increment_list = info.subset.data(subscripts(0)).src_increment(0:this_rank-1)
	  ;array_size = long((end_list-start_list)/float(increment_list) + 0.9)
	  array_size = long((end_list-start_list-1)/float(increment_list) + 1.0)

	  hdf_data_x = array_type(6, array_size)
	  if (hdf_data_x(0) eq -1) then begin
		result=dialog_message('Unable to allocate memory for Time array!',$
		title='View HDF Warning!')
		get_time_flag = 0
		out_name = ["N"]
	  endif else begin
		get_seconds, info, subscripts(0), hdf_data_x
		temp_error_data = get_error_data(hdf_data_x)
		if temp_error_data lt -9999999.0 then begin
			get_time_flag = 0
			out_name = [ "N" ]
		endif else begin
			out_name = [ "Time" ]
		endelse
	  endelse
	endif else begin
	  get_time_flag = 0
	  out_name = [ "N" ]
	endelse
  endelse

        for i = 0 , numout-1 do begin
          temp_name = info.subset.data(subscripts(i)).subset_name
          end_loc = strpos(temp_name, '[')
          ;if end_loc eq -1 then begin
          ;      result=dialog_message('The name format of export SDS data:' + temp_name + ' is wrong!',$
          ;              title='View HDF Warning!')
          ;      return
          ;endif
	  if export_type eq 0 then begin
	    temp_unit_name = info.subset.data(subscripts(i)).src_unitname
	    temp_unit_name = temp_unit_name(0)
	    temp_length = strlen(temp_unit_name)
            unitlabel = ''
            if (temp_length gt 0) then $
            	unitlabel = strmid(temp_unit_name,2,temp_length-2)

	    if end_loc ne -1 then temp_name = strmid(temp_name, 0, end_loc)
            ;out_name = [ out_name , strmid(temp_name, 0, end_loc) ] 
	    out_name = [ out_name , temp_name ]
	    unit_name = [ unit_name, strcompress(unitlabel) ]
	  endif else begin
            if end_loc ne -1 then $
                temp_name = strcompress(strmid(temp_name, 0, end_loc), /REMOVE_ALL)
            ;out_name = [ out_name, strcompress(strmid(temp_name, 0, end_loc), /REMOVE_ALL) ]
            out_name = [ out_name , temp_name ]
          endelse
        endfor


        widget_control,info.widgets.current_file,get_value=this_name
	data_range = ''
	data_range = get_data_range(subscripts(0),info)

	;--------------------------
        ; Write file header
        ;--------------------------
	if export_type eq 0 then begin
          printf,unit,format='("Source Data Filename: ",A)',this_name
	  printf,unit,format='("Data Range: ",A)',data_range

          numvar = numout + check_size(0)
          out_format = '(' + strcompress(string(numvar), /REMOVE_ALL) + '(A, :, "	"))'
          printf,unit, format=out_format, out_name
          printf,unit, format=out_format, unit_name
	endif else begin
	  printf,unit,format='("#Source Data Filename: ",A)',this_name
	  printf,unit,format='("#Data Range: ",A)',data_range
	  numvar = numout + 1
          out_format = '( "Variables = ", ' + strcompress(string(numvar), /REMOVE_ALL) + '(A, :, " , "))'
          printf,unit, format=out_format, out_name
	endelse

        case check_size(0) of
          1: total_number = check_size(3) * numout
          2: total_number = check_size(4) * numout
          3: total_number = check_size(5) * numout
          else : begin
                  result=dialog_message('Only support SDS rank 1 to 3 for Export List!',$
                        title='View HDF Warning!')
                  return
                  end
        endcase

        hdf_data = dblarr(total_number)

        case check_size(0) of
           1: hdf_data = reform(hdf_data, check_size(1), numout)
           2: hdf_data = reform(hdf_data, check_size(1), check_size(2), numout)
           3: hdf_data = reform(hdf_data, check_size(1), check_size(2), check_size(3), numout)
        else: begin
                result=dialog_message('Do not support SDS rank greater than 3 for EXport List Yet!',$
                        title='View HDF Warning!')
                return
                end
        endcase


  for i = 0, numout-1 do begin
           temp_data = *info.subset.data(subscripts(i)).src_data
          case check_size(0) of
             1: hdf_data(*,i) = double(temp_data)
             2: hdf_data(*,*,i) = double(temp_data)
             3: hdf_data(*,*,*,i) = double(temp_data)
          else: begin
                  result=dialog_message('Do not support SDS rank greater than 3 for Export data Yet!',$
                        title='View HDF Warning!')
                  return
                  end
          endcase
        endfor

        precision = info.precision(0)
	if export_type eq 0 then begin
          case check_size(0) of
             1: temp1 = '(I6, "	", '
             2: temp1 = '(I6, "	", I4, "	", '
             3: temp1 = '(I6, "	", I4, "	", I4, "	", '
          else: begin
                result=dialog_message('Do not support SDS rank greater than 3 for Export data Yet!',$
                        title='View HDF Warning!')
                return
                end
          endcase
	endif else begin
	  if get_time_flag eq 1 then temp1 = '(' + precision + ',"	", ' $
		else temp1 = '(I10,"	",'
	endelse

        temp='('+precision+', :, "	"))'
        out_format = temp1 + strcompress(string(numout), /REMOVE_ALL) + temp

	if print_flag eq 2 then begin
	    the_list = info.name_list_subset(subscripts)
	    the_list = [the_list, 'Cancel']
	    num_list = n_elements(the_list)
	    title = 'Select Reference File'
	    the_message = ['Select one of the following files for', $
		'reference to remove fill values:']
	    default_option = 0
	    sel_option = get_option(default_option,the_list,title,the_message,info)
	    if sel_option eq num_list-1 then return
	    ref_data = *info.subset.data(subscripts(sel_option)).src_data
	    this_type = info.subset.data(sel_option).src_types
	    this_type = this_type(0)
	    filldata_value = get_filldata_value(this_type, info.filldata)
	    widget_control, /hourglass
	endif

        case check_size(0) of
           1: begin
		start_rec = info.subset.data(subscripts(0)).src_start(0)+1
		end_rec = info.subset.data(subscripts(0)).src_end(0)
		incr_rec = info.subset.data(subscripts(0)).src_increment(0)
		if start_rec eq end_rec then begin
			start_rec = 1
			incr_rec = 1
		endif
		ijk = 1L
		for i=0L, check_size(1)-1 do begin
		    if info.filldata gt 0 then begin
			check_fill = where(hdf_data(i,*) gt info.filldata, count)
		    endif else begin
			check_fill = where(hdf_data(i,*) le info.filldata, count)
		    endelse
		    out_flag = 1
		    if print_flag eq 1 then begin
			if count eq numout then out_flag = 0
		    endif
		    if print_flag eq 2 then begin
			;if ref_data(i) ge info.filldata then out_flag = 0
			if filldata_value gt 0 then begin
			    if ref_data(i) ge filldata_value then out_flag = 0
			endif else begin
			    if ref_data(i) le filldata_value then out_flag = 0
			endelse
		    endif
		    if out_flag eq 1 then begin
			if export_type eq 0 then begin
			    if count ne 0 then hdf_data(i, check_fill) = -9999.0
			    printf,unit,format=out_format, start_rec, hdf_data(i,*)
			endif else begin
			    if count ne 0 then hdf_data(i, check_fill) = 0.0
			    if get_time_flag eq 1 then begin
				printf,unit,format=out_format, hdf_data_x(i), hdf_data(i,*)
			    endif else begin
				printf,unit,format=out_format, ijk, hdf_data(i,*)
				ijk = ijk + 1
			    endelse
			endelse
		    endif
		    start_rec = start_rec + incr_rec
		endfor
              end
           2: begin
		start_rec = info.subset.data(subscripts(0)).src_start(0)+1
		incr_rec = info.subset.data(subscripts(0)).src_increment(0)
		ijk = 1L
		for i=0L, check_size(2)-1 do begin
		    start_sample = info.subset.data(subscripts(0)).src_start(1)+1
		    incr_sample = info.subset.data(subscripts(0)).src_increment(1)
		    for j=0L, check_size(1)-1 do begin
			if info.filldata gt 0 then begin
			    check_fill = where(hdf_data(j,i,*) gt info.filldata, count)
			endif else begin
			    check_fill = where(hdf_data(j,i,*) le info.filldata, count)
			endelse
			out_flag = 1
			if print_flag eq 1 then begin
			    if count eq numout then out_flag = 0
			endif
			if print_flag eq 2 then begin
			    ;if ref_data(j,i) ge info.filldata then out_flag = 0
			    if filldata_value gt 0 then begin
				if ref_data(j,i) ge filldata_value then out_flag = 0
			    endif else begin
				if ref_data(j,i) le filldata_value then out_flag = 0
			    endelse
			endif
			if out_flag eq 1 then begin
			    if export_type eq 0 then begin
				if count ne 0 then hdf_data(j, i, check_fill) = -9999.0
				printf,unit,format=out_format, start_rec, start_sample, hdf_data(j,i,*)
			    endif else begin
				if count ne 0 then hdf_data(j, i, check_fill) = 0.0
				if get_time_flag eq 1 then begin
				    printf,unit,format=out_format, hdf_data_x(j,i), hdf_data(j,i,*)
				endif else begin
				    printf,unit,format=out_format, ijk, hdf_data(j,i,*)
				    ijk = ijk + 1
				endelse
			    endelse
			endif
			start_sample = start_sample + incr_sample
		    endfor
		    start_rec = start_rec + incr_rec
		endfor
              end
	   3: begin
		start_rec = info.subset.data(subscripts(0)).src_start(0)+1
		incr_rec = info.subset.data(subscripts(0)).src_increment(0)
		ijk = 1L
		for i=0L, check_size(3)-1 do begin
		    start_sample = info.subset.data(subscripts(0)).src_start(1)+1
		    incr_sample = info.subset.data(subscripts(0)).src_increment(1)
		    for j=0L, check_size(2)-1 do begin
			start_k = info.subset.data(subscripts(0)).src_start(2)+1
			incr_k = info.subset.data(subscripts(0)).src_increment(2)
			for k=0L, check_size(1)-1 do begin
			    if info.filldata gt 0 then begin
				check_fill = where(hdf_data(k,j,i,*) gt info.filldata, count)
			    endif else begin
				check_fill = where(hdf_data(k,j,i,*) le info.filldata, count)
			    endelse
			    out_flag = 1
			    if print_flag eq 1 then begin
				if count eq numout then out_flag = 0
			    endif
			    if print_flag eq 2 then begin
				;if ref_data(k,j,i) ge info.filldata then out_flag = 0
				if filldata_value gt 0 then begin
				    if ref_data(k,j,i) ge filldata_value then out_flag = 0
				endif else begin
				    if ref_data(k,j,i) le filldata_value then out_flag = 0
				endelse
			    endif
			    if out_flag eq 1 then begin
				if export_type eq 0 then begin
				    if count ne 0 then hdf_data(k,j,i, check_fill) = -9999.0
				    printf,unit,format=out_format, start_rec, start_sample, start_k, hdf_data(k,j,i,*)
				endif else begin
				    if count ne 0 then hdf_data(k,j,i, check_fill) = 0.0
				    if get_time_flag eq 1 then begin
					printf,unit,format=out_format, hdf_data_x(k,j,i), hdf_data(k,j,i,*)
				    endif else begin
					printf,unit,format=out_format, ijk, hdf_data(k,j,i,*)
					ijk = ijk + 1
				    endelse
				endelse
			    endif
			    start_k = start_k + incr_k
			endfor
			start_sample = start_sample + incr_sample
		    endfor
		    start_rec = start_rec + incr_rec
		endfor
	    end
           else: begin
                  result=dialog_message('Do not support SDS rank greater than 3 for Export data Yet!',$
                        title='View HDF Warning!')
                  return
                  end
          ENDCASE

end

;--------------------------------------------------------------------------------
pro export_vdata, info , unit, print_flag

pro_name = 'export_vdata'
@getinfo

;--------------------------
; Print Column Labels
;--------------------------

;  Get the vdata name
filename = info.subset.data(info.subset.selected).src_filename
current_vref = info.subset.data(info.subset.selected).src_ref

vdata_name = 'Unknown'

if current_vref gt -1 then begin
    filename = filename(0)
    file_id = HDF_OPEN(filename, /READ)
    if file_id ne -1 then begin
	vdata_id = HDF_VD_ATTACH(file_id, current_vref, /READ)
	if vdata_id gt 0 then begin
	    HDF_VD_GET,vdata_id,NAME=vdata_name
	    HDF_VD_DETACH,vdata_id
	    HDF_CLOSE,file_id
	endif
    endif
endif

data_name = info.subset.data(info.subset.selected).subset_name
data_name = data_name(0)

;printf,unit, format='("Vdata Name:  ", A)', info.vdata.name_sel
;printf,unit, format='("Field Name:  ", A)', info.vfield.name_sel
printf,unit, format='("Vdata Name:  ", A)', vdata_name
printf,unit, format='("Field Name:  ", A)', data_name
unit_name = info.subset.data(info.subset.selected).src_unitname
unit_name = unit_name(0)
temp_length = strlen(unit_name)
unitlabel = ''
if (temp_length gt 0) then $
	unitlabel = strmid(unit_name,2,temp_length-2)

printf,unit, format='("Unit:  ", A)', unitlabel
data_range = ''
data_range = get_data_range(info.subset.selected,info)
printf,unit, format='("Data Range:  ",A)',data_range

if info.subset.data(info.subset.selected).src_crit_flag eq 1 then begin
	crit_string = ''
	crit_string = get_crit_string(info.subset.selected, info)
	temp_name = str_sep(crit_string, '!C')
	num_temp = n_elements(temp_name)
	for i = 0, num_temp-1 do begin
		temp_length = strlen(temp_name(i))
		dot=strpos(temp_name(i),';')
		if( dot ne -1) then begin
			crit1 = strtrim(strmid(temp_name(i),0,dot),2)
			crit2 = strtrim(strmid(temp_name(i),dot+1,temp_length-1),2)
			if i eq 0 then printf,unit,crit1 $
				else printf,unit,'           '+crit1
				printf,unit,'           '+crit2
		endif else begin
			crit1 = strtrim(temp_name(i),2)
			if i eq 0 then printf,unit,crit1 $
				else printf,unit,'           '+crit1
		endelse
	endfor
endif

;--------------------------
; Print Data Values
;--------------------------
if info.subset.data(info.subset.selected).src_types(0) eq 4 or $
    info.subset.data(info.subset.selected).src_types(0) eq 3 then begin
	hdf_data = *info.subset.data(info.subset.selected).src_data
	printf, unit, hdf_data(*).components0
	return
endif

hdf_data_temp = *info.subset.data(info.subset.selected).src_data
hdf_data = reform(hdf_data_temp.components0, n_elements(hdf_data_temp.components0))
if print_flag eq 1 then begin
    this_type = info.subset.data(info.subset.selected).src_types
    this_type = this_type(0)
    filldata_value = get_filldata_value(this_type, info.filldata)
    if filldata_value gt 0 then begin
	subscript = where(hdf_data lt filldata_value, count)
    endif else begin
	subscript = where(hdf_data gt filldata_value, count)
    endelse
    if count ne 0 then hdf_data = hdf_data(subscript) $
	else hdf_data = 0
endif
printf, unit, format='('+info.precision+')', hdf_data

;-----------------------------------------------------------
; At this point the data is one column by N rows in size.
; This is so since we only allow the selection of a
; single field from the Vdata. Do for all components.
; Components are the columns while j is the row
; The number of components if the src_order.
;-----------------------------------------------------------
;
; Fixed for subsets that do NOT start at zero
; Also need to fix it for the maximum value
;

;col_start = 0L
;col_end = info.subset.data(info.subset.selected).src_end(0) - $
;                             info.subset.data(info.subset.selected).src_start(0)

;for j = col_start,col_end do begin
;
;	for i = 0,info.subset.data(info.subset.selected).src_order(0)-1 do begin
;                         printf, unit, format='('+info.precision+')', hdf_data(j).components0(i)
;        end
;end
 
end

;--------------------------------------------------------------------------------
pro export_vdata_list, info, export_type, unit, print_flag

pro_name = 'export_vdata_list'
@getinfo

subscripts = where(info.out.pick eq 1, numout)

if info.subset.data(subscripts(0)).src_types(0) eq 4 then begin
   for i = 0, numout-1 do begin
	if info.subset.data(subscripts(i)).src_types(0) ne 4 then begin
		return
	endif
	filename = info.subset.data(subscripts(i)).src_filename
	printf,unit,format='("Source Data Filename: ",A)', filename

	hdf_data = *info.subset.data(subscripts(i)).src_data
	printf, unit, hdf_data(*).components0
   endfor
   return
endif

for i = 1, numout-1 do begin

	if (info.subset.data(subscripts(i)).src_start(0) ne $
	info.subset.data(subscripts(i-1)).src_start(0)) then begin

		result=dialog_message('Not all Vdata have same start!',$
		title='View HDF Warning!')
        	return
	endif

	if (info.subset.data(subscripts(i)).src_end(0) ne $
	info.subset.data(subscripts(i-1)).src_end(0)) then begin
		result=dialog_message('Not all Vdata have same end!',$
        	title='View HDF Warning!')
        	return
	endif

	if (info.subset.data(subscripts(i)).src_increment(0) ne $
	info.subset.data(subscripts(i-1)).src_increment(0)) $
	then begin
        	result=dialog_message('Not all Vdata have same increment!',$
        	title='View HDF Warning!')
        	return
	endif

	if (info.subset.data(subscripts(i)).src_order(0) ne $
	info.subset.data(subscripts(i-1)).src_order(0)) $
	then begin
		result=dialog_message('Not all Vdata have same order!',$
        	title='View HDF Warning!')
	        	return
	endif
endfor

if export_type eq 0 then begin
	out_name = ["Record Number", "Order Number" ]
	unit_name = out_name
endif else begin
	get_time_flag = 1
	if info.rangetype.get_time eq 1 then begin
	  hdf_y_temp = *info.subset.data(subscripts(0)).src_data
	  hdf_data_y = reform(hdf_y_temp.components0, n_elements(hdf_y_temp.components0))
	  hdf_data_x = make_array(n_elements(hdf_data_y), /DOUBLE)
	  get_seconds, info, subscripts(0), hdf_data_x
	  size_x = size(hdf_data_x)
	  case size_x(0) of 
		1: temp_data = hdf_data_x(0)
		2: temp_data = hdf_data_x(0,0)
		3: temp_data = hdf_data_x(0,0,0)
		else: temp_data = hdf_data_x
	  endcase
	  if temp_data lt -9999999.0 then begin
		get_time_flag = 0
		out_name = [ "N" ]
	  endif else out_name = [ "Time" ]
	endif else begin
	  get_time_flag = 0
	  out_name = [ "N" ]
	endelse
endelse

for i = 0 , numout-1 do begin

	temp_name = info.subset.data(subscripts(i)).subset_name
        end_loc = strpos(temp_name, '[')

        ;if end_loc eq -1 then begin
        ;	result=dialog_message('The name format of export Vdata: ' + $
	;		temp_name + ' is wrong!', title='View HDF Warning!')
        ;        return
        ;endif

	if export_type eq 0 then begin
	  unit_temp_name = info.subset.data(subscripts(i)).src_unitname
	  unit_temp_name = unit_temp_name(0)
	  temp_length = strlen(unit_temp_name)
	  unitlabel = ''
	  if (temp_length gt 0) then $
	  	unitlabel = strmid(unit_temp_name,2,temp_length-2)

	  if end_loc ne -1 then $
                temp_name = strmid(temp_name, 0, end_loc)
          ;out_name = [ out_name , strmid(temp_name, 0, end_loc) ]
          out_name = [ out_name , temp_name ]
	  unit_name = [unit_name, strcompress(unitlabel) ]
	endif else begin
          if end_loc ne -1 then $
                temp_name = strcompress(strmid(temp_name, 0, end_loc), /REMOVE_ALL)
          ;out_name = [ out_name , strcompress(strmid(temp_name, 0, end_loc), /REMOVE_ALL) ]
          out_name = [ out_name , temp_name ]
        endelse
endfor


;--------------------------
; Write file header
;--------------------------
widget_control,info.widgets.current_file, get_value=filename
data_range = ''
data_range = get_data_range(subscripts(0),info)
if export_type eq 0 then begin
  printf,unit,format='("Source Data Filename: ",A)', filename
  printf,unit,format='("Data Range:  ",A)',data_range

  numvar = numout + 2
  out_format = '(' + string(numvar) + '(A, :, "	"))'

endif else begin

  printf,unit,format='("#Source Data Filename: ",A)', filename
  printf,unit,format='("#Data Range:  ",A)',data_range
  numvar = numout + 1
  out_format = '( "Variables = "' + string(numvar) + '(A, :, " , "))'

endelse

printf,unit, format=out_format, out_name
if export_type eq 0 then printf, unit, format=out_format, unit_name

hdf_data = *info.subset.data(subscripts(0)).src_data

check_size = size(hdf_data)

total_number = check_size(3) * info.subset.data(subscripts(0)).src_order(0)

hdf_data = dblarr(total_number * numout)

hdf_data = reform(hdf_data, total_number , numout)

for i = 0, numout-1 do begin

           temp_data = *info.subset.data(subscripts(i)).src_data
           hdf_data(*,i) = double(temp_data.components0)
endfor

precision = info.precision(0)
if export_type eq 0 then begin
  temp1 = '(I6, "	", I4, "	", '
  temp='('+precision+', :, "	"))'
endif else begin
  if get_time_flag eq 1 then temp1 = '('+precision+',"	",' $
	else temp1 = '(I10,"	",'
  temp='('+precision+', :, "	"))'
endelse

out_format = temp1 + string(numout) + temp

incr_order = info.subset.data(subscripts(0)).src_order(0)
hdf_data = reform(hdf_data, incr_order, check_size(3), numout)

start_rec = info.subset.data(subscripts(0)).src_start(0)+1
incr_rec = info.subset.data(subscripts(0)).src_increment(0)

if print_flag eq 2 then begin
    the_list = info.name_list_subset(subscripts)
    the_list = [the_list, 'Cancel']
    num_list = n_elements(the_list)
    title = 'Select Reference File'
    the_message = ['Select one of the following files for', $
        'reference to remove fill values:']
    default_option = 0
    sel_option = get_option(default_option,the_list,title,the_message,info)
    if sel_option eq num_list-1 then return
    ref_data = *info.subset.data(subscripts(sel_option)).src_data
    ref_data = reform(ref_data.components0, n_elements(ref_data.components0))
    ref_data = reform(ref_data, incr_order, check_size(3))
    this_type = info.subset.data(sel_option).src_types
    this_type = this_type(0)
    filldata_value = get_filldata_value(this_type, info.filldata)
    widget_control, /hourglass
endif

k = 0L
ijk = 1L
for i=0L, check_size(3)-1 do begin
    for j=0L, incr_order-1 do begin
	if info.filldata gt 0 then begin
	    check_fill = where(hdf_data(j,i,*) gt info.filldata, count)
	endif else begin
	    check_fill = where(hdf_data(j,i,*) le info.filldata, count)
	endelse
	out_flag = 1
	if print_flag eq 1 then begin
	    if count eq numout then out_flag = 0
	endif
	if print_flag eq 2 then begin
	    ;if ref_data(j,i) ge info.filldata then out_flag = 0
	    if filldata_value gt 0 then begin
		if ref_data(j,i) ge filldata_value then out_flag = 0
	    endif else begin
		if ref_data(j,i) le filldata_value then out_flag = 0
	    endelse
	endif
	if out_flag eq 1 then begin
	    if export_type eq 0 then begin
		if count ne 0 then hdf_data(j,i, check_fill) = -9999.0
		printf,unit,format=out_format, start_rec, j+1, hdf_data(j,i,*)
	    endif else begin
		if count ne 0 then hdf_data(j,i, check_fill) = 0.0
		if get_time_flag eq 1 then begin
		    printf,unit,format=out_format, hdf_data_x(k), hdf_data(j,i,*)
		endif else begin
		    printf,unit,format=out_format, ijk, hdf_data(j,i,*)
		    ijk = ijk + 1
		endelse
	    endelse
	endif
	k = k + 1
    endfor
    start_rec = start_rec + incr_rec
endfor

end

;--------------------------------------------------------------------------------
function extract_printcap, info

pro_name = 'extract_printcap'
@getinfoa

;-----------------------------------------------------------
;setup to print from thunder to saic printers
;-----------------------------------------------------------

;-----------------------------------------------------------
; Extract the printer names from .printcap
; Note: You must setup this file initially from
;       /etc/printcap.
;-----------------------------------------------------------

CD, '.', CURRENT = PWD

;print_file=info.home_path+"/"+info.printname+"_printer_name"
;print_file = pwd+'/'+info.printname + '_printer_name'
;check_file=findfile(print_file, count=count)
;if count eq 0 then begin
	;command_line="lpstat -a | grep accepting | sort -u | awk '{print $1}' >! "
	;command_line=command_line+pwd+"/printer_name"
	;command_line="lpstat -a | grep accepting | sort -u | awk '{print $1}' > "
	;command_line='lpstat -a | grep -v "not accepting" | '
	;command_line = command_line+"grep accepting | sort -u | awk '{print $1}' > "
	;command_line=command_line+print_file
	command_line='lpstat -a | grep -v "not accepting" | '
	command_line = command_line+"grep accepting | sort -u | awk '{print $1}'"
	print,command_line
	spawn, command_line, results
	;print,'results = ',results
;endif

;print,'print_file = ',print_file
;check_file=findfile(print_file, count=count)
;if count eq 0 then begin
;	print_file = pwd+'/printer_name'
;endif
;
;the_result = CALL_EXTERNAL(PWD+'/' + info.library,  $
;                                'get_printer_name',        $
;				print_file,	$
;                                /s_value)

;if the_result eq "BAD" then begin
;        result = dialog_message('Problem reading printer name!',  $
;            title = 'VIEW_HDF_WARNING!')
;endif
if n_elements(results) eq 0 then the_result = ["BAD"] $
	else the_result = results

return, the_result

end

;------------------------------------------------------------------
function field_struct,  text, name_list

pro_name = 'field_struct'
@getinfoa

fields = { CW_PDMENU_S,       1, text } 
fields = replicate(fields, n_elements(name_list)+1)

if n_elements(name_list) gt 1 then begin
   for i = 0,n_elements(name_list)-2 do begin
	 fields(i+1).flags = 0
	 fields(i+1).name = name_list(i) 
   endfor
endif else i = 0

fields(i+1).flags = 2
fields(i+1).name = name_list(i)

return, fields

end

;--------------------------------------------------------------------------------
pro file_export, info, print_flag

pro_name = 'file_export'
@getinfo

count = check_directory(info.export_path, info.home_path)
if count eq 0 then begin
	CD, '.', CURRENT=pwd
	info.export_path = pwd
endif
export_name=dialog_pickfile(filter='*.dat', path=info.export_path, $
		file=info.export_file, get_path=export_path,/write)

if export_name eq "" then return

export_result=STRPOS(export_name, export_path)

if export_result eq -1 then export_name=export_path+export_name

print,"Filename=", export_name

info.export_path = export_path
default_file = ''
default_file = get_default_file(export_name)
if default_file ne 'None' then info.export_file = default_file

widget_control, /hourglass

widget_control, info.widgets.current_file, get_value=this_name

get_lun, unit
openw, unit, export_name

;--------------------------
; Write file header
;--------------------------

printf, unit, format='("Source Data Filename: ",A)',this_name

if info.subset.data(info.subset.selected).src_type_flag eq 0 then  $
	export_sds, info, unit, print_flag $ 
	else export_vdata, info , unit, print_flag

close,unit
free_lun, unit

;-----------------------------------------------------
; This piece of code removes all the spaces
; from the exported data files so that
; spreadsheets can read them easily.
;-----------------------------------------------------

info.output_path = info.export_path
CD, info.output_path, CURRENT=old_dir
output_name_list=findfile(info.filter, count=count)
if count eq 0 then output_name_list = [ 'None' ]
 
widget_control, info.widgets.output, set_value=output_name_list
widget_control, info.widgets.outputdir, set_value=info.output_path
widget_control, set_uvalue=info, info.base
 
CD, old_dir
 
result=dialog_message('Exporting Completed!', title='Notice!')
return

end

;--------------------------------------------------------------------------------
pro read_ascii_data, index, filename,info

pro_name = 'read_ascii_data'
@getinfo

widget_control, /hourglass

openr,unit,filename,/get_lun

skip_line = info.ascii_file.skip_line + info.ascii_file.num_heading + $
     info.ascii_file.skip_ahead
if skip_line gt 0 then begin
    for i = 0, skip_line-1 do begin
	temp = ''
	readf,unit,temp
    endfor
endif

output_data = 0.0D
num_data = 0L
sep_char = info.ascii_file.sep_char
if sep_char eq 'tab' then sep_char = '	'
if sep_char eq 'space' then sep_char = ' '

while not EOF(unit) do begin
    temp = ''
    readf,unit,temp
    if sep_char eq ' ' then begin
	temp = strtrim(temp, 2)
	temp = strcompress(temp)
    endif
    pararray = str_sep(temp, sep_char)
    num_para = n_elements(pararray)
    if index gt num_para then begin
	the_message = ['The index is greater than the number of column.', $
	    'Please, check the index or file and do it again.']
	result=dialog_message(the_message, title='View HDF Warning!')
	close, unit
	free_lun, unit
	return
    endif
    temp_data = pararray(index)
    temp_data =strtrim(temp_data, 2)
    if strlen(temp_data) gt 0 then begin
	temp_data = double(temp_data)
	;temp_data = float(temp_data)
	output_data = [output_data, temp_data]
	num_data = num_data + 1
    endif
endwhile

close,unit
free_lun, unit

if num_data gt 0 then begin
    output_data = output_data(1:num_data)
endif else begin
    the_message = ['No data has been read.', $
	'Please, check the data file and do it again.']
    result=dialog_message(the_message, title='View HDF Warning!')
    return
endelse

filldata = info.filldata
if filldata gt 0 then begin
    subscripts = where(output_data lt filldata, count)
endif else begin
    subscripts = where(output_data gt filldata, count)
endelse
if count ne 0 then begin
    data_max = max(output_data(subscripts), min=data_min)
endif else begin
    data_max = max(output_data, min=data_min)
endelse
max_value = strcompress(string(data_max), /REMOVE_ALL)
min_value = strcompress(string(data_min), /REMOVE_ALL)
fillvalue = strcompress(string(filldata), /REMOVE_ALL)
name_of_data = info.name_list_sds(index)
name_of_data = name_of_data(0)
rank = '1'
dimsize = strcompress(string(num_data), /REMOVE_ALL)
unitname = ''
i_value = [name_of_data, rank, dimsize, unitname, fillvalue]
title = 'Get Name, Rank, Dimension Size, Unit and Fill Value'
f_title = ['Name:', 'Rank:', 'Dimension Size:', 'Unit', 'Fill Value']
xsize = [40, 10, 30, 30, 30]
the_message = ['Input the name, rank, dimension size, and unit dimension to store data', $
	'The MAX and MIN values of data are '+max_value+' and '+min_value, $
	'NOTE:', $
	'If rank is greater than 1, use "," to separate each dimension value.', $
	'If number of records is unknown, do not enter the first dimension value.', ' ']
para = get_n_field_value(5, i_value, xsize, title, f_title, the_message, info.base, info)
name_of_data = para(0)
if name_of_data eq 'cancel' then return

widget_control, /hourglass

rank = fix(para(1))
unitname = para(3)
filldata = float(para(4))
if filldata ne 0 and filldata lt 3.4028235E+38 then begin
    info.filldata = filldata
    count = info.open_file.count
    the_list = info.open_file.file(0:count-1)
    subscript = where(the_list eq filename, count)
    if count ne 0 then info.open_file.fill_data(subscript(0)) = info.filldata
endif
unitname = strtrim(unitname,2)
if strlen(unitname) lt 1 then unitname = '' else $
    unitname = ', ' + unitname

temp_dim = str_sep(para(2),',')
temp_dim = strtrim(temp_dim, 2)
subscript = where(strlen(temp_dim) eq 0, count)
if count gt 0 then temp_dim(subscript) = '0'

dimsize = long(temp_dim)
num_dim = n_elements(dimsize)
subscript = where(dimsize le 0, count)
if num_dim eq rank then begin
    if count gt 1 then begin
	the_message = ['You have more than one unknown dimension sizes.', $
	    'Please, check the dimension sizes and do it again.']
	result=dialog_message(the_message, title='View HDF Warning!')
	return
    endif else if count eq 1 then begin
	if rank eq 1 then begin
	    dimsize = [num_data]
	endif else begin
	    total1 = 1
	    for i = 0, rank-1 do begin
		if i ne subscript(0) then total1 = total1 * dimsize(i)
	    endfor
	    if total1 gt 0 then begin
		temp_dim1 = long(num_data/total1)
		dimsize(subscript(0)) = temp_dim1
	    endif else begin
		temp_dim1 = strcompress(string(dimsize), /REMOVE_ALL)
		dim_char = temp_dim1(0)
		for i = 1, rank-1 do begin
		    dim_char = dim_char + ' , ' + temp_dim1(i)
		endfor
		the_message = ['The dimension sizes is wrong: '+dim_char, $
		    'Please, check the dimension sizes and do it again.']
		result=dialog_message(the_message, title='View HDF Warning!')
		return
	    endelse
	endelse
    endif
endif else if rank-num_dim eq 1 then begin
    if count gt 0 then begin
	the_message = ['You have more than one unknown dimension sizes.', $
	    'Please, check the dimension sizes and do it again.']
	result=dialog_message(the_message, title='View HDF Warning!')
	return
    endif else begin
	if rank eq 1 then begin
	    dimsize = [num_data]
	endif else begin
	    total1 = 1
	    for i = 0, num_dim-1 do begin
		total1 = total1 * dimsize(i)
	    endfor
	    if total1 gt 0 then begin
		temp_dim1 = long(num_data/total1)
		dimsize = [temp_dim1, dimsize]
	    endif else begin
		temp_dim1 = strcompress(string(dimsize), /REMOVE_ALL)
		dim_char = temp_dim1(0)
		for i = 1, rank-1 do begin
		    dim_char = dim_char + ' , ' + temp_dim1(i)
		endfor
		the_message = ['The dimension sizes is wrong: '+dim_char, $
		    'Please, check the dimension sizes and do it again.']
		result=dialog_message(the_message, title='View HDF Warning!')
		return
	    endelse
	endelse
    endelse
endif else begin
    the_message = ['The rank and number of dimension is not matched.', $
	'Please, check the input and do it again.']
    result=dialog_message(the_message, title='View HDF Warning!')
    return
endelse

total_num = 1
for i = 0, rank-1 do begin
    total_num = total_num * dimsize(i)
endfor

if total_num gt num_data then begin
    the_message = ['The total elements of the dimension sizes set is not', $
	'matched with the number of data in the file.', $
	'Please, check the dimension sizes and do it again.']
    result=dialog_message(the_message, title='View HDF Warning!')
    return
endif

if num_data ne total_num then begin
    if rank eq 1 then begin
	dimsize = [num_data]
    endif else begin
	total1 = 1
	for i = 1, rank-1 do begin
	    total1 = total1 * dimsize(i)
	endfor
	dimsize(0) = long(num_data/total1)
	total1 = total1 * dimsize(0)
	output_data = output_data(0:total1-1)
    endelse
endif

output_data = reform(output_data, reverse(dimsize))
the_type = size(output_data, /tname)
hdf_type = convert_idltypename_hdftype(the_type)
if ptr_valid(info.ascii_file.output) then $
    ptr_free, info.ascii_file.output
info.ascii_file.output=ptr_new(output_data, /NO_COPY)
info.ascii_file.unitname = unitname

info.sds.index = index
info.sds.rank = rank
info.sds.type = hdf_type
for i = 0 , rank-1 do begin
    info.sds.dims(i) = dimsize(i)
    info.rangetype.dim_name(i) = 'Dimension'+strcompress(string(i+1), /REMOVE_ALL)
endfor

record_range_buttons, name_of_data, info.sds.rank-1, 'set_ascii_dataCB', info

end

;--------------------------------------------------------------------------------
pro set_ascii_dataCB, event

pro_name = 'set_ascii_dataCB'
@getinfo

widget_control, get_uvalue=info, event.id
widget_control, /hourglass

rank = info.sds.rank
hdf_type = info.sds.type
start_list=lonarr(rank)
end_list=lonarr(rank)
increment_list=lonarr(rank)

for i=0,(rank-1) do begin
    widget_control, info.widgets.starting_field(i), get_value=this_start
    widget_control, info.widgets.ending_field(i), get_value=this_end
    widget_control, info.widgets.increment_field(i), get_value=this_increment

    start_list(i)=this_start-1
    if start_list(i) lt 0 then start_list(i) = 0L
    end_list(i)=this_end
    increment_list(i)=this_increment
endfor

info.rangetype.old_start(0:rank-1) = start_list(0:rank-1) + 1
info.rangetype.old_end(0:rank-1) = end_list(0:rank-1)
info.rangetype.old_increment(0:rank-1) = increment_list(0:rank-1)
info.rangetype.old_dim(0:rank-1) = info.sds.dims(0:rank-1)

widget_control, info.widgets.subset_name, get_value=name_of_data
name_of_data=name_of_data(0)
widget_control, event.top, /destroy

output_data = *info.ascii_file.output
size_of_data = size(output_data)
if size_of_data(0) ne rank then begin
    the_message = ['The rank of the data is not matched.', $
	'Please check the data and do it again.']
    result=dialog_message(the_message, title='View HDF Warning!')
    return
endif

array_size = long((end_list-start_list-1)/float(increment_list) + 1.0)
j = size_of_data(0)
check_dim = 0
for i = 0,rank-1 do begin
    if array_size(i) ne size_of_data(j) then check_dim = 1
    j = j - 1
endfor
   
if check_dim eq 1 then begin
    case rank of 
	1: begin
	    this_start = start_list(0)
	    this_end = end_list(0) - 1
	    output_data = output_data(this_start:this_end)
	    this_increment = increment_list(0)
	    if (this_increment gt 1) then begin
		indices = lindgen(this_end-this_start+1)
	        indices = indices mod this_increment
	        indices = [where(indices eq 0) ]
	        output_data = output_data(indices)
	    endif
	end
	2: begin
	    this_start = start_list(0)
	    this_end = end_list(0) - 1
	    output_data = output_data(*,this_start:this_end)
	    this_increment = increment_list(0)
	    if (this_increment gt 1) then begin
		indices = lindgen(this_end-this_start+1)
		indices = indices mod this_increment
		indices = [where(indices eq 0) ]
		output_data = output_data(*,indices)
	    endif
	    this_start = start_list(1)
	    this_end = end_list(1) - 1
	    output_data = output_data(this_start:this_end,*)
	    this_increment = increment_list(1)
	    if (this_increment gt 1) then begin
		indices = lindgen(this_end-this_start+1)
		indices = indices mod this_increment
		indices = [where(indices eq 0) ]
		output_data = output_data(indices,*)
	    endif
	end
	3: begin
	    this_start = start_list(0)
	    this_end = end_list(0) - 1
	    output_data = output_data(*,*,this_start:this_end)
	    this_increment = increment_list(0)
	    if (this_increment gt 1) then begin
		indices = lindgen(this_end-this_start+1)
		indices = indices mod this_increment
		indices = [where(indices eq 0) ]
		output_data = output_data(*,*,indices)
	    endif
	    this_start = start_list(1)
	    this_end = end_list(1) - 1
	    output_data = output_data(*,this_start:this_end,*)
	    this_increment = increment_list(1)
	    if (this_increment gt 1) then begin
		indices = lindgen(this_end-this_start+1)
		indices = indices mod this_increment
		indices = [where(indices eq 0) ]
		output_data = output_data(*,indices,*)
	    endif
	    this_start = start_list(2)
	    this_end = end_list(2) - 1
	    output_data = output_data(this_start:this_end,*,*)
	    this_increment = increment_list(2)
	    if (this_increment gt 1) then begin
		indices = lindgen(this_end-this_start+1)
		indices = indices mod this_increment
		indices = [where(indices eq 0) ]
		output_data = output_data(indices,*,*)
	    endif
	end
	4: begin
	    this_start = start_list(0)
	    this_end = end_list(0) - 1
	    output_data = output_data(*,*,*,this_start:this_end)
	    this_increment = increment_list(0)
	    if (this_increment gt 1) then begin
		indices = lindgen(this_end-this_start+1)
		indices = indices mod this_increment
		indices = [where(indices eq 0) ]
		output_data = output_data(*,*,*,indices)
	    endif
	    this_start = start_list(1)
	    this_end = end_list(1) - 1
	    output_data = output_data(*,*,this_start:this_end,*)
	    this_increment = increment_list(1)
	    if (this_increment gt 1) then begin
		indices = lindgen(this_end-this_start+1)
		indices = indices mod this_increment
		indices = [where(indices eq 0) ]
		output_data = output_data(*,*,indices,*)
	    endif
	    this_start = start_list(2)
	    this_end = end_list(2) - 1
	    output_data = output_data(*,this_start:this_end,*,*)
	    this_increment = increment_list(2)
	    if (this_increment gt 1) then begin
		indices = lindgen(this_end-this_start+1)
		indices = indices mod this_increment
		indices = [where(indices eq 0) ]
		output_data = output_data(*,indices,*,*)
	    endif
	    this_start = start_list(3)
	    this_end = end_list(3) - 1
	    output_data = output_data(this_start:this_end,*,*,*)
	    this_increment = increment_list(3)
	    if (this_increment gt 1) then begin
		indices = lindgen(this_end-this_start+1)
		indices = indices mod this_increment
		indices = [where(indices eq 0) ]
		output_data = output_data(indices,*,*,*)
	    endif
	end
	else: begin
	    result=dialog_message('Do not support the rank greater than 4!',$
		title='View HDF Warning!')
	    return
	end
    endcase
endif

unitname = info.ascii_file.unitname

set_output_woref, name_of_data, -1, hdf_type, rank, start_list, end_list, $
    increment_list, unitname, info, output_data

end

;--------------------------------------------------------------------------------
pro list_field, flag, filename, info

pro_name = 'list_field'
@getinfo

skip_line = strcompress(string(info.ascii_file.skip_line), /REMOVE_ALL)
num_heading = strcompress(string(info.ascii_file.num_heading), /REMOVE_ALL)
skip_ahead = strcompress(string(info.ascii_file.skip_ahead), /REMOVE_ALL)
i_value = [skip_line, num_heading, skip_ahead, info.ascii_file.sep_char]

title = 'Get Parameters for Open an ASCII File'
f_title = ['Skip lines from beginnig of file:', 'Number of heading lines:', $
    'Skip lines after heading', 'Variables separated by:']
the_message = ['Input the parameters for open an ASCII file', $
	'NOTE:', $
	'If tab is used as delimited character, enter the word tab in the field.', $
	'If space is used as delimited character, enter the word space in the field.', $
	'If space is used as delimited character,', $
	'     there cannot be any missing data in any column.', ' ' ]
para = get_list_field(4, i_value, 10, title, f_title, the_message, filename, info.base, info)
skip_line = para(0)
if skip_line eq 'cancel' then return

widget_control, /hourglass

skip_line = fix(para(0))
num_heading = fix(para(1))
skip_ahead = fix(para(2))
sep_char = para(3)
info.ascii_file.skip_line = skip_line
info.ascii_file.num_heading = num_heading
info.ascii_file.skip_ahead = skip_ahead
info.ascii_file.sep_char = sep_char

openr, unit, filename, /get_lun

if skip_line gt 0 then begin
    for i = 0, skip_line-1 do begin
	temp = ''
	readf, unit, temp
    endfor
endif

if sep_char eq 'tab' then sep_char = '	'
if sep_char eq 'space' then sep_char = ' '
temp = ''
readf, unit, temp
if sep_char eq ' ' then begin
    temp = strtrim(temp, 2)
    temp = strcompress(temp)
endif
pararray = str_sep(temp, sep_char)
pararray = strtrim(pararray, 2)
subscript = where(strlen(pararray) eq 0, count)
if count gt 0 then begin
    the_message = ['Some variable names are blank.', $
	'The separated character "'+sep_char+'" may not be right', $
	'Still want to continue?']
    result=dialog_message(the_message, /Question, title='View HDF Question!')
    if result eq 'No' then begin
	close,unit
	free_lun,unit
	return
    endif
endif

the_list = ''
num_para = n_elements(pararray)
for i = 0, num_para-1 do begin
    if num_heading gt 0 then begin
	the_list = [the_list, pararray(i)]
    endif else begin
	temp_name = 'Variable_'+strcompress(string(i+1), /REMOVE_ALL)
	the_list = [the_list, temp_name]
    endelse
endfor

num_field = num_para

if num_heading gt 1 then begin
    for i = 1, num_heading-1 do begin
	temp = ''
	readf, unit, temp
	if sep_char eq ' ' then begin
	    temp = strtrim(temp, 2)
	    temp = strcompress(temp)
	endif
	pararray = str_sep(temp, sep_char)
	pararray = strtrim(pararray, 2)
	subscript = where(strlen(pararray) eq 0, count)
	if count gt 0 then begin
	    the_message = ['Some variable names are blank.', $
	        'The separated character "'+sep_char+'" may not be right', $
	        'Still want to continue?']
	    result=dialog_message(the_message, /Question, title='View HDF Question!')
	    if result eq 'No' then begin
		close,unit
		free_lun,unit
		return
	    endif
	endif

	num_para = n_elements(pararray)
	for j = 0, num_para-1 do begin
	    the_list = [the_list, pararray(i)]
	endfor
	num_field = num_field + num_para
    endfor
endif

if num_field gt 0 then begin
    the_list = the_list(1:num_field)
    widget_control, info.widgets.sds, set_value=the_list
    info = redefine_info(info, the_list, 2)
    flag = 1
endif else begin
    result=dialog_message('Problem reading ASCII file heading!',$
	title='View HDF Warning!')
endelse

close, unit
free_lun, unit

end

;--------------------------------------------------------------------------------
pro file_open_ascii, info, filename

pro_name = 'file_open_ascii'
@getinfo

file_len = strlen(filename)
if strlen(filename) gt 0 then begin
    if info.device eq 'X' then begin
	path_divide = '/'
    endif else begin
	path_divide = '\'
    endelse
    loc = rstrpos(filename,path_divide)
    if loc eq -1 then begin
	CD, '.', CURRENT=pwd
	open_path = pwd
    endif else begin
	open_path = strmid(filename,0,loc+1)
    endelse
endif else begin
    count = check_exist_dir(info.ascii_file.open_path)
    if count eq 0 then begin
	CD, '.', CURRENT=pwd
	info.ascii_file.open_path = pwd
    endif
    filename=dialog_pickfile(/read, get_path=open_path, path= info.ascii_file.open_path, $
	filter = info.filter)

    if filename eq "" then return
    check_hdf = HDF_ISHDF(filename)
    if check_hdf eq 1 then begin
	file_open, info, 2, filename
	return
    endif
    if info.hdf5.exist eq 1 then begin
	check_hdf5 = H5F_IS_HDF5(filename)
	if check_hdf5 eq 1 then begin
	    file_open_hdf5, info, 2, filename
	    return
	endif
    endif
    openr, unit, filename, error=err, /get_lun
    if err ne 0 then begin
	result=dialog_message(filename+" is not found!", title='View HDF Warning!')
	return
    endif else begin
	close, unit
	free_lun, unit
    endelse
endelse

widget_control, /hourglass

info.ascii_file.open_path = open_path

info = initial_open_file(info)

info = initial_vgroup(info)
info = initial_hdf5(info)

widget_control, info.widgets.current_file, set_value=filename
widget_control, info.widgets.sds, set_value="None"
widget_control, info.widgets.vdata, set_value="None"

temp_name_list = ['None']
info = redefine_info(info, temp_name_list, 5)

flag = 0

list_field,flag,filename,info

info.ssf.file = 0
info.ssf.key = 0
info.ssf.select = 0
info.ssf.layer = 0
info.bds_file = 0

info.flags.data_read = flag
info.filldata = 1.0E+35

if flag eq 1 then begin
	info.ascii_file.flag = 1
	info.current_file = filename
	info = store_previous_file(info)
	info = store_open_file(info)
	widget_control, set_uvalue=info, info.base
endif

end

;--------------------------------------------------------------------------------
pro file_open, info, attr_flag, filename

pro_name = 'file_open'
@getinfo

file_len = strlen(filename)
if strlen(filename) gt 0 then begin
    if info.device eq 'X' then begin
	path_divide = '/'
    endif else begin
	path_divide = '\'
    endelse
    loc = rstrpos(filename,path_divide)
    if loc eq -1 then begin
	CD, '.', CURRENT=pwd
	open_path = pwd
    endif else begin
	open_path = strmid(filename,0,loc+1)
    endelse
endif else begin
    ;count = check_directory(info.open_path, info.home_path)
    count = check_exist_dir(info.open_path)
    if count eq 0 then begin
	CD, '.', CURRENT=pwd
	info.open_path = pwd
    endif
    filename=dialog_pickfile(/read, get_path=open_path, path= info.open_path, $
	filter = info.open_filter)

    if filename eq "" then return
    check_hdf = HDF_ISHDF(filename)
    if check_hdf eq 0 then begin
	if info.hdf5.exist eq 1 then begin
	    check_hdf5 = H5F_IS_HDF5(filename)
	    if check_hdf5 eq 1 then begin
		file_open_hdf5, info, attr_flag, filename
		return
	    endif
	endif
	openr, unit, filename, error=err, /get_lun
	if err ne 0 then begin
	    result=dialog_message(filename+" is not found!", title='View HDF Warning!')
	    return
	endif else begin
	    close, unit
	    free_lun, unit
	    file_open_ascii, info, filename
	    return
	endelse
    endif
endelse

widget_control, /hourglass

info.open_path = open_path

info = initial_open_file(info)
;info.rangetype.get_time = 0
;info.rangetype.old_start(*) = 0
;info.rangetype.old_end(*) = 0
;info.rangetype.old_increment(*) = 0
;info.rangetype.old_dim(*) = 0
;info.geolocated.flag = 0
;info.geolocated.selected = 0

info = initial_vgroup(info)
info = initial_hdf5(info)

widget_control, info.widgets.current_file, set_value=filename
widget_control, info.widgets.sds, set_value="None"
widget_control, info.widgets.vdata, set_value="None"

temp_name_list = ['None']
info = redefine_info(info, temp_name_list, 5)

flag = 0
if attr_flag gt 1 then begin
   get_vgroup_list,flag, filename, info
   if flag eq 0 then attr_flag = 0
endif 
if flag eq 0 then begin
   get_parameters, 'list_sds', info.widgets.sds, flag, filename, info
   if attr_flag eq 0 then $
      get_parameters, 'list_vdata', info.widgets.vdata, flag, filename, info $
   else get_parameters, 'list_vdata_attr', info.widgets.vdata, flag, filename, info
endif

get_time, info, 0

info.ssf.file = 0
info.ssf.key = 0
info.ssf.select = 0
info.ssf.layer = 0
info.bds_file = 0

check_file, info

info.flags.data_read = flag

if flag eq 1 then begin
	info.current_file = filename
	info = store_previous_file(info)
	info = store_open_file(info)
	widget_control, set_uvalue=info, info.base
endif

end

;--------------------------------------------------------------------------------
pro file_open_hdf5, info, attr_flag, filename

pro_name = 'file_open_hdf5'
@getinfo

;  if hdf5 is not support, return
if info.hdf5.exist eq 0 then return

file_len = strlen(filename)
if strlen(filename) gt 0 then begin
    path_divide = '/'
    loc = rstrpos(filename,path_divide)
    if loc eq -1 then begin
        CD, '.', CURRENT=pwd
        open_path = pwd
    endif else begin
        open_path = strmid(filename,0,loc+1)
    endelse
endif else begin
    count = check_exist_dir(info.open_path)
    if count eq 0 then begin
        CD, '.', CURRENT=pwd
        info.open_path = pwd
    endif
    filename=dialog_pickfile(/read, get_path=open_path, path= info.open_path, $
        filter = info.open_filter)

    if filename eq "" then return

    check_hdf5 = H5F_IS_HDF5(filename)
    if check_hdf5 eq 0 then begin
	check_hdf = HDF_ISHDF(filename)
	if check_hdf eq 1 then begin
	    file_open, info, attr_flag, filename
	    return
	endif else begin
	    openr, unit, filename, error=err, /get_lun
	    if err ne 0 then begin
		result=dialog_message(filename+" is not found!", title='View HDF Warning!')
		return
	    endif else begin
		close, unit
		free_lun, unit
		file_open_ascii, info, filename
		return
	    endelse
	endelse
    endif
endelse

widget_control, /hourglass

info.open_path = open_path

info = initial_open_file(info)

info = initial_vgroup(info)
info = initial_hdf5(info)

widget_control, info.widgets.current_file, set_value=filename
widget_control, info.widgets.sds, set_value="None"
widget_control, info.widgets.vdata, set_value="None"

temp_name_list = ['None']
info = redefine_info(info, temp_name_list, 5)

flag = 0
if attr_flag gt 1 then begin
    get_hdf5_group_list,flag, filename, info
    if flag eq 0 then attr_flag = 0
endif 
if flag eq 0 then begin
    result=dialog_message("Problem to open HDF5 file!", title='View HDF Warning!')
    return
endif

info.ssf.file = 0
info.ssf.key = 0
info.ssf.select = 0
info.ssf.layer = 0
info.bds_file = 0

info.filldata = 1.0E+35

info.flags.data_read = flag

if flag eq 1 then begin
	info.hdf5.flag = 1
	info.current_file = filename
	info = store_previous_file(info)
	info = store_open_file(info)
	widget_control, set_uvalue=info, info.base
endif

end

;--------------------------------------------------------------------------------
pro open_file, event

pro_name = 'open_file'
@getinfo

widget_control, /hourglass

widget_control, get_uvalue=info, event.id
widget_control,get_uvalue=info,info.base
widget_control, info.widgets.current_file, get_value=filename
filename = filename(0)
filename = strcompress(filename,/REMOVE_ALL)
file_len = strlen(filename)

if filename eq info.current_file then return

if file_len eq 0 or filename eq "None" then begin
	widget_control, set_value=info.current_file, info.widgets.current_file
	return
endif

check_file = findfile(filename,count=count)
if count eq 0 then begin
	the_message = [filename+" is not found!", $
		"Or no file exists in the directory!", $
		"If you are not sure the filename,", $
		"use widecard character '*' or", $
		"use 'File'--'Open' option to select the file."]
	result=dialog_message(the_message, title='View HDF Warning!')
	widget_control, set_value=info.current_file, info.widgets.current_file
	return
endif

if info.device eq 'X' then begin
	path_divide = '/'
endif else begin
	path_divide = '\'
endelse
if count eq 1 and filename ne check_file(0) then begin
	check_loc = rstrpos(check_file(0),path_divide)
	if check_loc ne -1 then filename = check_file(0) $
	else begin
		check_dir = check_exist_dir(filename)
		if check_dir eq 1 then begin
			if check_path(filename) eq 1 then begin
				filename = filename + check_file(0)
			endif else begin
				filename = filename + path_divide + check_file(0)
			endelse
		endif else begin
			loc = rstrpos(filename,path_divide)
			if loc eq -1 then begin
				filename = check_file(0)
			endif else begin
				temp_file = strmid(filename,0,loc+1)
				filename = temp_file + check_file(0)
			endelse
		endelse
	endelse
file_len = strlen(filename)
endif

check_dir = check_exist_dir(filename)
if check_dir eq 1 then begin
	filename = filename + path_divide
	file_len = strlen(filename)
endif

loc = rstrpos(filename,path_divide)
direct = 0
if loc eq file_len-1 then begin
	current_filename = '*'
	open_path = filename
	direct = 1
endif else if loc eq -1 then begin
	current_filename = filename
	open_path = ''
endif else begin
	current_filename = strmid(filename,loc+1,file_len-loc-1)
	open_path = strmid(filename,0,loc+1)
endelse

if count gt 1 or direct eq 1 then begin
	filename=dialog_pickfile(/read, get_path=open_path, path= open_path, $
		filter = current_filename)

	if filename eq "" then begin
		widget_control, set_value=info.current_file, info.widgets.current_file
		return
	endif
	check_hdf = HDF_ISHDF(filename)
	if check_hdf eq 0 then begin
	    if info.hdf5.exist eq 1 then begin
		check_hdf5 = H5F_IS_HDF5(filename)
	    endif else check_hdf5 = 0
	    if check_hdf5 eq 0 then begin
		openr, unit, filename, error=err, /get_lun
		if err ne 0 then begin
		    result=dialog_message(filename+" is not found!", title='View HDF Warning!')
		    widget_control, set_value=info.current_file, info.widgets.current_file
		    return
		endif else begin
		    close, unit
		    free_lun, unit
		endelse
	    endif
	endif
endif

widget_control, /hourglass

check_hdf = HDF_ISHDF(filename)
if info.hdf5.exist eq 1 then check_hdf5 = H5F_IS_HDF5(filename) else check_hdf5 = 0
if check_hdf eq 0 and check_hdf5 eq 0 then ascii_flag = 1 else ascii_flag = 0

if ascii_flag eq 0 then info.open_path = open_path $
    else info.ascii_file.open_path = open_path

info = initial_open_file(info)
;info.rangetype.get_time = 0
;info.rangetype.old_start(*) = 0
;info.rangetype.old_end(*) = 0
;info.rangetype.old_increment(*) = 0
;info.rangetype.old_dim(*) = 0
;info.geolocated.flag = 0
;info.geolocated.selected = 0

info = initial_vgroup(info)
info = initial_hdf5(info)

widget_control, info.widgets.current_file, set_value=filename
widget_control, info.widgets.sds, set_value="None"
widget_control, info.widgets.vdata, set_value="None"

temp_name_list = ['None']
info = redefine_info(info, temp_name_list, 5)

flag = 0

if ascii_flag eq 0 then begin
    if check_hdf eq 1 then begin
	get_vgroup_list,flag, filename, info

	if flag eq 0 then begin
	    get_parameters, 'list_sds', info.widgets.sds, flag, filename, info
	    get_parameters, 'list_vdata', info.widgets.vdata, flag, filename, info
	endif

	get_time, info, 0
    endif else get_hdf5_group_list,flag, filename, info
endif else begin
    list_field,flag,filename,info
endelse

info.ssf.file = 0
info.ssf.key = 0
info.ssf.select = 0
info.ssf.layer = 0
info.bds_file = 0

if ascii_flag eq 0 and check_hdf eq 1 then check_file, info else info.filldata = 1.0E+35

info.flags.data_read = flag

if flag eq 1 then begin
	if ascii_flag eq 1 then info.ascii_file.flag = 1
	info.current_file = filename
	info = store_previous_file(info)
	info = store_open_file(info)
	widget_control, set_uvalue=info, info.base
endif

end

;--------------------------------------------------------------------------------
pro open_previous_fileCB, event

pro_name = 'open_previous_fileCB'
@getinfo

widget_control, /hourglass

widget_control, get_uvalue=info, event.top

widget_control, event.top, /destroy

filename = info.previous_file.current
filename = filename(0)

if info.device eq 'X' then begin
    filename = strcompress(filename,/REMOVE_ALL)
endif

;if filename eq info.current_file then return

check_file = findfile(filename,count=count)
if count eq 0 then begin
	the_message = [filename+" is not found!", $
		"use 'File'--'Open' option to select the file."]
	result=dialog_message(the_message, title='View HDF Warning!')
	return
endif

check_hdf = HDF_ISHDF(filename)
if info.hdf5.exist eq 1 then check_hdf5 = H5F_IS_HDF5(filename) else check_hdf5 = 0
if check_hdf eq 0 and check_hdf5 eq 0 then ascii_flag = 1 else ascii_flag = 0

if info.device eq 'X' then begin
        path_divide = '/'
endif else begin
        path_divide = '\'
endelse
loc = rstrpos(filename,path_divide)
if loc eq -1 then begin
        open_path = ''
endif else begin
        open_path = strmid(filename,0,loc+1)
endelse

if ascii_flag eq 0 then info.open_path = open_path $
    else info.ascii_file.open_path = open_path

info = initial_open_file(info)
;info.rangetype.get_time = 0
;info.rangetype.old_start(*) = 0
;info.rangetype.old_end(*) = 0
;info.rangetype.old_increment(*) = 0
;info.rangetype.old_dim(*) = 0
;info.geolocated.flag = 0
;info.geolocated.selected = 0

info = initial_vgroup(info)
info = initial_hdf5(info)

widget_control, info.widgets.current_file, set_value=filename
widget_control, info.widgets.sds, set_value="None"
widget_control, info.widgets.vdata, set_value="None"

temp_name_list = ['None']
info = redefine_info(info, temp_name_list, 5)

flag = 0

if ascii_flag eq 0 then begin
    if check_hdf eq 1 then begin
	get_vgroup_list,flag, filename, info

	if flag eq 0 then begin
	    get_parameters, 'list_sds', info.widgets.sds, flag, filename, info
	    get_parameters, 'list_vdata', info.widgets.vdata, flag, filename, info
	endif

	get_time, info, 0
    endif else get_hdf5_group_list,flag, filename, info
endif else begin
    list_field,flag,filename,info
endelse

info.ssf.file = 0
info.ssf.key = 0
info.ssf.select = 0
info.ssf.layer = 0
info.bds_file = 0

if ascii_flag eq 0 and check_hdf eq 1 then check_file, info else info.filldata = 1.0E+35

info.flags.data_read = flag

if flag eq 1 then begin
	if ascii_flag eq 1 then info.ascii_file.flag = 1
	info.current_file = filename
	info = store_previous_file(info)
	info = store_open_file(info)
	widget_control, set_uvalue=info, info.base
endif

end

;--------------------------------------------------------------------------------
pro open_previous_file, info

pro_name = 'open_previous_file'
@getinfo

base_loc = widget_info(info.base, /geometry)
xoffset = base_loc.xoffset
yoffset = base_loc.yoffset + 100

list_file = info.previous_file.store
num_file = n_elements(list_file)
if num_file gt 0 then begin
    file_len = strlen(list_file)
    sub_file = where(file_len gt 80, count)
    if count gt 0 then begin
	extract_name = strmid(list_file[sub_file], 0, 80) + '...'
	list_file[sub_file] = extract_name
    endif
endif

base=widget_base(group_leader=info.base, /modal, column=1, map=1, $
    xoffset=xoffset, yoffset=yoffset, TITLE='Select a File', uvalue=info)
;base = widget_base( COLUMN=1, MAP=1, TITLE='Select a File', uvalue=info)

;button_group=cw_bgroup(base, info.previous_file.store, column=1, $
button_group=cw_bgroup(base, list_file, column=1, $
                        set_value=0,  event_funct="set_previous_file", /exclusive)

group2=widget_base(base, row=1,map=1, space=100, /align_center)

button1=widget_button(group2, FONT=info.font, EVENT_PRO='open_previous_fileCB', VALUE="Done",$
	/ALIGN_CENTER)

button2=widget_button(group2, FONT=info.font, EVENT_PRO='doneCB', VALUE="Cancel",$
	 /ALIGN_CENTER)

info.previous_file.current = info.previous_file.store(0)
widget_control, set_uvalue=info, base
widget_control, /realize, base 

widget_control, base, set_list_select=-1

end

;--------------------------------------------------------------------------------
pro switch_open_file, event

pro_name = 'switch_file'
@getinfo

widget_control, /hourglass

widget_control, get_uvalue=info, event.id
widget_control,get_uvalue=info,info.base

if info.open_file.count eq 0 then begin
	result=dialog_message('No file has been opened yet!', $
		title='View HDF Warning!')
	return
endif

widget_control,info.widgets.current_file,get_value=filename
filename = filename(0)

count = info.open_file.count
the_list = info.open_file.file(0:count-1)
the_list = [the_list, 'Cancel']
num_list = n_elements(the_list)
title = 'Switch Open File'
the_message = ['Select the current file:']
default_option = num_list-1
sel_option = get_option(default_option,the_list,title,the_message,info)
if sel_option eq num_list-1 then return

current_filename = the_list(sel_option)
vgroup_flag = info.open_file.flag(sel_option)
ascii_flag = info.open_file.ascii_flag(sel_option)
hdf5_flag = info.open_file.hdf5_flag(sel_option)
if (vgroup_flag eq 0 and hdf5_flag eq 0) and current_filename eq filename then return

if info.device eq 'X' then begin
	path_divide = '/'
endif else begin
	path_divide = '\'
endelse
loc = rstrpos(current_filename,path_divide)
if loc eq -1 then begin
        open_path = ''
endif else begin
        open_path = strmid(current_filename,0,loc+1)
endelse

if ascii_flag eq 0 then info.open_path = open_path $
    else info.ascii_file.open_path = open_path

info = initial_open_file(info)
;info.rangetype.get_time = 0
;info.rangetype.old_start(*) = 0
;info.rangetype.old_end(*) = 0
;info.rangetype.old_increment(*) = 0
;info.rangetype.old_dim(*) = 0
;info.geolocated.flag = 0
;info.geolocated.selected = 0

info = initial_vgroup(info)
info = initial_hdf5(info)

widget_control, info.widgets.current_file, set_value=current_filename
widget_control, info.widgets.sds, set_value="None"
widget_control, info.widgets.vdata, set_value="None"

temp_name_list = ['None']
info = redefine_info(info, temp_name_list, 5)

widget_control, /hourglass
if vgroup_flag eq 0 and hdf5_flag eq 0 then begin
	sds_list = str_sep(info.open_file.sds_list(sel_option), '|')
	vdata_list = str_sep(info.open_file.vdata_list(sel_option), '|')
	info = redefine_info(info, sds_list,2 )
	info = redefine_info(info, vdata_list,0 )
	widget_control, info.widgets.sds, set_value=sds_list
	widget_control, info.widgets.vdata, set_value=vdata_list
endif else if vgroup_flag eq 1 then begin
        info.vgroup.flag = 1
        info.vgroup.nlayer = 1
        info.vgroup.ref(0) = 1
        info.vgroup.id(0) = 1
	vg_name_list = info.open_file.vg_name(sel_option)
	vg_id_list = info.open_file.vg_id(sel_option)
	vref = info.open_file.vref(sel_option)
	info.vgroup.vref = vref
        info.vgroup.vg_name(0) = vg_name_list
        info.vgroup.vg_id(0) = vg_id_list
	vg_list = str_sep(vg_name_list, '|')
	vg_id = str_sep(vg_id_list, '|')
	info = redefine_info(info, vg_list, 9)
	length = strlen(info.vgroup.vref)
        if length gt 0 then begin
		vdata_list = str_sep(info.open_file.vdata_list(sel_option), '|')
                info = redefine_info(info, vdata_list, 0 )
		widget_control, info.widgets.vdata, set_value  = vdata_list
	endif
endif else begin
	info.hdf5.flag = 1
	info.hdf5.nlayer = 1
	info.hdf5.ref(0) = 1
	info.hdf5.id(0) = 1
	info.hdf5.name_string(0) = '/'
	g_name_list = info.open_file.hdf5_g_name(sel_option)
	info.hdf5.g_name(0) = g_name_list
	g_list = str_sep(g_name_list, '|')
	info = redefine_info(info, g_list, 9)
	sdn_name_list = info.open_file.hdf5_sdn_name(sel_option)
	info.hdf5.sdn_name(0) = sdn_name_list
	length = strlen(sdn_name_list)
	if length gt 0 then begin
		sdn_name = str_sep(sdn_name_list, '|')
		info = redefine_info(info, sdn_name, 2 )
		widget_control, info.widgets.sds, set_value  = sdn_name
	endif
	cdn_name_list = info.open_file.hdf5_cdn_name(sel_option)
	info.hdf5.cdn_name(0) = cdn_name_list
	length = strlen(cdn_name_list)
	if length gt 0 then begin
		cdn_name = str_sep(cdn_name_list, '|')
		info = redefine_info(info, cdn_name, 0 )
		widget_control, info.widgets.vdata, set_value  = cdn_name
	endif
endelse

if ascii_flag eq 0 and hdf5_flag eq 0 then get_time, info, 0

info.ssf.file = info.open_file.ssf_file(sel_option)
info.ssf.key = 0
info.ssf.select = 0
info.ssf.layer = 0
info.bds_file = info.open_file.bds_file(sel_option)
info.ascii_file.flag = ascii_flag
info.ascii_file.skip_line = info.open_file.ascii_skip(sel_option)
info.ascii_file.num_heading = info.open_file.ascii_heading(sel_option)
info.ascii_file.skip_ahead = info.open_file.ascii_skiphead(sel_option)
info.ascii_file.sep_char = info.open_file.ascii_sep(sel_option)
info.filldata = info.open_file.fill_data(sel_option)

info.flags.data_read = 1

info.current_file = current_filename
widget_control, set_uvalue=info, info.base

if info.vgroup.flag eq 1 then select_vgroup,'VGROUP', info, vg_list, vg_id, 0

if info.hdf5.flag eq 1 then select_hdf5_group, '/', info, g_list, 0

end

;--------------------------------------------------------------------------------
function do_subset_data, flag, name_of_data, rank, start_list, end_list, $
    increment_list, hdf_data, info

pro_name = 'do_subset_data'
@getinfo1

size_hdf = size(hdf_data)
if size_hdf(0) eq 0 then return, -1

if flag eq 1 then begin
    if info.multifile.skip_data(0) gt end_list(0) then $
	increment = 1 else increment = info.multifile.skip_data(0)
    i_value = [1, end_list(0), increment]
    m_title = ['Dimension1']
    for i = 1, rank-1 do begin
	if info.multifile.skip_data(i) gt end_list(i) then $
	    increment = 1 else increment = info.multifile.skip_data(i)
	i_value = [i_value, 1, end_list(i), increment]
	m_title = [m_title, 'Dimension'+strcompress(string(i+1), /REMOVE_ALL)]
    endfor

    title = 'Subset Data'
    the_message = ['Enter the ranges of data set to import:', $
	name_of_data, ' ']
    n_title = [name_of_data, 'Starting', 'Ending', 'Increment']
    para = get_mn_field_value(rank, 3, i_value, title, m_title, n_title, $
	the_message, info.base, info)
    dataname = para(0)
    if dataname eq 'cancel' then return, -1
    para = para(1:*)
    num_values = n_elements(para)
    subrange = long(para)
endif else begin
    num_values = 3 * rank
    subrange = lonarr(num_values)
    m = 0
    for i = 0, rank-1 do begin
	subrange(m) = start_list(i) + 1
	subrange(m+1) = end_list(i)
	subrange(m+2) = increment_list(i)
	m = m + 3
    endfor
endelse

widget_control, /hourglass

case rank of
    1: begin
	this_start = subrange(0)-1
	if this_start lt 0 then this_start = 0
	this_end = subrange(1)-1
	if this_end ge size_hdf(1) then this_end = size_hdf(1) - 1
	this_incr = subrange(2)
	hdf_data = hdf_data(this_start:this_end)
	if (this_incr gt 1) then begin
	    indices = lindgen(this_end-this_start+1)
	    indices = indices mod this_incr
	    indices = [where(indices eq 0) ]
	    hdf_data = hdf_data(indices)
	endif
	if flag eq 1 then begin
	    start_list = [subrange(0)-1]
	    end_list = [subrange(1)]
	    increment_list = [subrange(2)]
	endif
    end
    2: begin
	this_start = subrange(0) - 1
	if this_start lt 0 then this_start = 0
	this_end = subrange(1) - 1
	if this_end ge size_hdf(2) then this_end = size_hdf(2) - 1
	this_incr = subrange(2)
	hdf_data = hdf_data(*,this_start:this_end)
	if (this_incr gt 1) then begin
	    indices = lindgen(this_end-this_start+1)
	    indices = indices mod this_incr
	    indices = [where(indices eq 0) ]
	    hdf_data = hdf_data(*,indices)
	endif
	if flag eq 1 then begin
	    start_list = [subrange(0) - 1]
	    end_list = [subrange(1)]
	    increment_list = [subrange(2)]
	endif

	this_start = subrange(3) - 1
	if this_start lt 0 then this_start = 0
	this_end = subrange(4) - 1
	if this_end ge size_hdf(1) then this_end = size_hdf(1) - 1
	this_incr = subrange(5)
	hdf_data = hdf_data(this_start:this_end, *)
	if (this_incr gt 1) then begin
	    indices = lindgen(this_end-this_start+1)
	    indices = indices mod this_incr
	    indices = [where(indices eq 0) ]
	    hdf_data = hdf_data(indices, *)
	endif
	if flag eq 1 then begin
	    start_list = [start_list, subrange(3) - 1]
	    end_list = [end_list, subrange(4)]
	    increment_list = [increment_list, subrange(5)]
	endif
    end
    3: begin
	this_start = subrange(0) - 1
	if this_start lt 0 then this_start = 0
	this_end = subrange(1) - 1
	if this_end ge size_hdf(1) then this_end = size_hdf(1) - 1
	this_incr = subrange(2)
	hdf_data = hdf_data(*,*,this_start:this_end)
	if (this_incr gt 1) then begin
	    indices = lindgen(this_end-this_start+1)
	    indices = indices mod this_incr
	    indices = [where(indices eq 0) ]
	    hdf_data = hdf_data(*,*,indices)
	endif
	if flag eq 1 then begin
	    start_list = [subrange(0) - 1]
	    end_list = [subrange(1)]
	    increment_list = [subrange(2)]
	endif

	this_start = subrange(3) - 1
	if this_start lt 0 then this_start = 0
	this_end = subrange(4) - 1
	if this_end ge size_hdf(2) then this_end = size_hdf(2) - 1
	this_incr = subrange(5)
	hdf_data = hdf_data(*,this_start:this_end, *)
	if (this_incr gt 1) then begin
	    indices = lindgen(this_end-this_start+1)
	    indices = indices mod this_incr
	    indices = [where(indices eq 0) ]
	    hdf_data = hdf_data(*, indices, *)
	endif
	if flag eq 1 then begin
	    start_list = [start_list, subrange(3) - 1]
	    end_list = [end_list, subrange(4)]
	    increment_list = [increment_list, subrange(5)]
	endif

	this_start = subrange(6) - 1
	if this_start lt 0 then this_start = 0
	this_end = subrange(7) - 1
	if this_end ge size_hdf(3) then this_end = size_hdf(3) - 1
	this_incr = subrange(8)
	hdf_data = hdf_data(this_start:this_end,*,*)
	if (this_incr gt 1) then begin
	    indices = lindgen(this_end-this_start+1)
	    indices = indices mod this_incr
	    indices = [where(indices eq 0) ]
	    hdf_data = hdf_data(indices,*,*)
	endif
	if flag eq 1 then begin
	    start_list = [start_list, subrange(6) - 1]
	    end_list = [end_list, subrange(7)]
	    increment_list = [increment_list, subrange(8)]
	endif
    end
    4: begin
	this_start = subrange(0) - 1
	if this_start lt 0 then this_start = 0
	this_end = subrange(1) - 1
	if this_end ge size_hdf(1) then this_end = size_hdf(1) - 1
	this_incr = subrange(2)
	hdf_data = hdf_data(*,*,*,this_start:this_end)
	if (this_incr gt 1) then begin
	    indices = lindgen(this_end-this_start+1)
	    indices = indices mod this_incr
	    indices = [where(indices eq 0) ]
	    hdf_data = hdf_data(*,*,*,indices)
	endif
	if flag eq 1 then begin
	    start_list = [subrange(0) - 1]
	    end_list = [subrange(1)]
	    increment_list = [subrange(2)]
	endif

	this_start = subrange(3) - 1
	if this_start lt 0 then this_start = 0
	this_end = subrange(4) - 1
	if this_end ge size_hdf(2) then this_end = size_hdf(2) - 1
	this_incr = subrange(5)
	hdf_data = hdf_data(*,*,this_start:this_end,*)
	if (this_incr gt 1) then begin
	    indices = lindgen(this_end-this_start+1)
	    indices = indices mod this_incr
	    indices = [where(indices eq 0) ]
	    hdf_data = hdf_data(*,*,indices,*)
	endif
	if flag eq 1 then begin
	    start_list = [start_list, subrange(3) - 1]
	    end_list = [end_list, subrange(4)]
	    increment_list = [increment_list, subrange(5)]
	endif

	this_start = subrange(6) - 1
	if this_start lt 0 then this_start = 0
	this_end = subrange(7) - 1
	if this_end ge size_hdf(3) then this_end = size_hdf(3) - 1
	this_incr = subrange(8)
	hdf_data = hdf_data(*,this_start:this_end,*,*)
	if (this_incr gt 1) then begin
	    indices = lindgen(this_end-this_start+1)
	    indices = indices mod this_incr
	    indices = [where(indices eq 0) ]
	    hdf_data = hdf_data(*,indices,*,*)
	endif
	if flag eq 1 then begin
	    start_list = [start_list, subrange(6) - 1]
	    end_list = [end_list, subrange(7)]
	    increment_list = [increment_list, subrange(8)]
	endif

	this_start = subrange(9) - 1
	if this_start lt 0 then this_start = 0
	this_end = subrange(10) - 1
	if this_end ge size_hdf(4) then this_end = size_hdf(4) - 1
	this_incr = subrange(12)
	hdf_data = hdf_data(this_start:this_end,*,*,*)
	if (this_incr gt 1) then begin
	    indices = lindgen(this_end-this_start+1)
	    indices = indices mod this_incr
	    indices = [where(indices eq 0) ]
	    hdf_data = hdf_data(indices,*,*,*)
	endif
	temp_size = size(hdf_data)
	if flag eq 1 then begin
	    start_list = [start_list, subrange(9) - 1]
	    end_list = [end_list, subrange(10)]
	    increment_list = [increment_list, subrange(11)]
	endif
    end
	else: begin
	    result=dialog_message('Do not support the rank greater than 4!',$
		title='View HDF Warning!')
	    return, -1
	end
endcase
info.multifile.skip_data(0:rank-1) = increment_list

return, 0

end

;------------------------------------------------------------------
pro read_sds_multiple_files, filename, data_name, sds_ref, info

pro_name = 'read_sds_multiple_files'
@getinfo

str_num_digit = strcompress(string(info.multifile.num_digit), /REMOVE_ALL)
str_start_num = strcompress(string(info.multifile.start_num), /REMOVE_ALL)
str_last_num  = strcompress(string(info.multifile.last_num), /REMOVE_ALL)
str_skip_num  = strcompress(string(info.multifile.skip_num), /REMOVE_ALL)
if info.multifile.has_time eq 1 then str_has_time = 'Yes' else str_has_time = 'No'
if info.multifile.with_geo eq 1 then str_with_geo = 'Yes' else str_with_geo = 'No'
if info.multifile.with_time eq 1 then str_with_time = 'Yes' else str_with_time = 'No'

desc = [ $
    '0, label, Read SDS From Multiple Files, center, font='+info.font, $
    '0, label, "   ", center, font=' + info.font, $
    '0, label, You are requesting to read the SDS:, left, font='+info.font, $
    '0, label, '+data_name+', left, font='+info.font, $
    '0, label, from multiple files.  The settings are:, left, font='+info.font, $
    '0, label, "   ", center, font='+info.font, $
    '0, label, Increase by the last '+str_num_digit+' digits, left, font='+info.font, $
    '0, label, Start with the number: '+str_start_num+', left, font='+info.font, $
    '0, label, End with the number: '+str_last_num+', left, font='+info.font, $
    '0, label, Skip number of files: '+str_skip_num+', left, font='+info.font, $
    '0, label, With time information: '+str_has_time+', left, font='+info.font, $
    '0, label, Import the geolocation parameters: '+str_with_geo+', left, font='+info.font, $
    '0, label, Import the time parameter: '+str_with_time+', left, font='+info.font, $
    '0, label, "   ", center, font='+info.font, $
    '0, label, Press OK to continue if the settings are corrected., left, font='+info.font, $
    '0, label, Press Cancel to quit if the settings are incorrected., left, font='+info.font, $
    '0, label, "   ", center, font='+info.font, $
    '1, base, , row, space=60, center', $
    '0, button, OK, QUIT, tag=done, font='+info.font, $
    '2, button, Cancel, QUIT, tag=cancel, font='+info.font]

result = cw_form(desc, /column, title='Read SDS From Multiple Files')
if result.cancel eq 1 then return

widget_control, /hourglass

num_digit = info.multifile.num_digit
start_num = info.multifile.start_num
last_num = info.multifile.last_num
skip_num = info.multifile.skip_num
with_geo = info.multifile.with_geo
with_time = info.multifile.with_time
has_time = info.multifile.has_time

length_filename = strlen(filename)
if length_filename le num_digit then begin
    the_message = ['The length of the filename is less than or equal to', $
	'the number of digits to be increased.', $
	'Please check the setting and do it again.']
    result=dialog_message(the_message, title='View HDF Warning!')
    return
endif

root_filename = strmid(filename, 0, length_filename-num_digit)

;  Get the indese for geolocation parameters if with_geo = 1
if with_geo eq 1 then begin
    long_name = ['Longitude of CERES FOV at surface', $
	'Longitude of CERES FOV at Surface', 'Longitude of CERES FOV at TOA', $
	'Longitude', 'longitude']
    num_name = n_elements(long_name)
    long_index = -1
    i = 0
    while (long_index eq -1 and i lt num_name) do begin
        temp_name = long_name(i)
        long_index = check_sds_index(filename, temp_name)
        i = i + 1
    endwhile
    if long_index eq -1 then begin
	info.multifile.with_geo = 0
	with_geo = 0
    endif

    if with_geo eq 1 then begin
	colat_name = ['Colatitude of CERES FOV at surface', $
	    'Colatitude of CERES FOV at Surface', 'Colatitude of CERES FOV at TOA', $
	    'Latitude', 'latitude']
	num_name = n_elements(colat_name)
	colat_index = -1
	i = 0
	while (colat_index eq -1 and i lt num_name) do begin
	    temp_name = colat_name(i)
	    colat_index = check_sds_index(filename, temp_name)
	    i = i + 1
	endwhile
	if colat_index eq -1 then begin
	    info.multifile.with_geo = 0
	    with_geo = 0
	endif
    endif
endif

;  Get the index for time parameters if has_time eq 1 or with_time eq 1
if has_time eq 1 or with_time eq 1 then begin
    time_name = ['Julian Date and Time', 'Time of observation', 'Jultime_Radius', $
	'Julian_Time', 'Julian date and time']
    num_name = n_elements(time_name)
    time_index = -1
    i = 0
    while (time_index eq -1 and i lt num_name) do begin
	temp_name = time_name(i)
	time_index = check_sds_index(filename, temp_name)
	i = i + 1
    endwhile
    if time_index eq -1 then begin
	info.multifile.with_time = 0
	with_time = 0
	info.multifile.has_time = 0
	has_time = 0
    endif else name_id = i - 1
endif

for i = start_num, last_num, skip_num do begin
    current_num = strcompress(string(i), /REMOVE_ALL)
    if(strlen(current_num) lt num_digit) then begin
	num_zero = num_digit - strlen(current_num)
	for j = 1, num_zero do begin
	    current_num = '0'+current_num
	endfor
    endif

    current_filename = root_filename + current_num
    ;print,'current_filename = ',current_filename

    check_hdf = HDF_ISHDF(current_filename)
    if(check_hdf eq 1) then begin

      sd_id = HDF_SD_START(current_filename, /READ)
      if sd_id ne -1 then begin

	sds_id = HDF_SD_SELECT(sd_id, sds_ref)
	if sds_id ne -1 then begin

	    HDF_SD_GETINFO,sds_id, NAME=sds_name, DIMS=sds_dims, NDIMS=sds_rank, $
		HDF_TYPE=type, /NOREVERSE

	    start_list=lonarr(sds_rank)
	    end_list=lonarr(sds_rank)
	    increment_list=lonarr(sds_rank)
	    array_size=lonarr(sds_rank)
	    org_dims=lonarr(sds_rank)

	    for j = 0, sds_rank-1 do begin
		start_list(j) = 0
		end_list(j) = sds_dims(j)
		increment_list(j) = 1
	    endfor

	    array_size = end_list
	    org_dims = end_list

	    sds_type = convert_hdftypename_hdftype(type)
	    unsign_type = 0
	    if info.version lt 5.19 and info.library_status eq 1 then begin
		if sds_type gt 20 then unsign_type = sds_type mod 2
	    endif

	    if info.hdf421 eq 1 then unsign_type = 1

	    if unsign_type eq 0 then begin
		start_list = reverse(start_list)
		array_size = reverse(array_size)
		HDF_SD_GETDATA, sds_id, sds_data, START=start_list, COUNT=array_size
		HDF_SD_ENDACCESS,sds_id
		HDF_SD_END, sd_id
		the_result = 0
	    endif else begin
		HDF_SD_ENDACCESS,sds_id
		HDF_SD_END, sd_id
		sds_data = array_type(sds_type, array_size)
		if (sds_data(0) ne -1) then begin
		    CD, '.', CURRENT = PWD
		    ;the_result = CALL_EXTERNAL(PWD+'/' + info.library,   $
		    the_result = CALL_EXTERNAL(info.library, $
			'read_sds_eos',$
			current_filename,$
			sds_name,$
			sds_ref,$
			sds_rank,$
			sds_type,$
			sds_dims,$
			start_list,$
			end_list,$
			increment_list,$
			array_size,$
			sds_data)
		endif else begin
		    result=dialog_message('Unable to allocate memory for SDS data!',$
			title='View HDF Warning!')
		    the_result = -1
		endelse
	    endelse
	    
	    if (the_result eq -1) then begin
		result=dialog_message('Unable to read '+sds_name+' SDS data!',$
		    title='View HDF Warning!')
	    endif else begin
                ;if i eq start_num then begin
		sds_data = reform(sds_data, n_elements(sds_data))
		check_output = size(output_data)
                if check_output(0) eq 0 then begin
		    output_data = sds_data
		    org_dims=sds_dims
		endif else begin
		    output_data = [output_data, sds_data]
		endelse
	    endelse

;   get the geolocation parameters if with_geo eq 1
	    if with_geo eq 1 then begin
		sd_id = HDF_SD_START(current_filename, /READ)
		sds_id = HDF_SD_SELECT(sd_id, long_index)
		if sds_id ne -1 then begin

		    HDF_SD_GETINFO,sds_id, NAME=long_sds_name, DIMS=sds_dims, NDIMS=sds_rank, $
			HDF_TYPE=type, /NOREVERSE

		    start_list=lonarr(sds_rank)
		    end_list=lonarr(sds_rank)
		    increment_list=lonarr(sds_rank)
		    array_size=lonarr(sds_rank)

		    for j = 0, sds_rank-1 do begin
			start_list(j) = 0
			end_list(j) = sds_dims(j)
			increment_list(j) = 1
		    endfor

		    array_size = end_list

		    long_sds_type = convert_hdftypename_hdftype(type)

		    start_list = reverse(start_list)
		    array_size = reverse(array_size)
		    HDF_SD_GETDATA, sds_id, sds_data, START=start_list, COUNT=array_size
		    HDF_SD_ENDACCESS,sds_id
		    HDF_SD_END, sd_id

		    ;if i eq start_num then begin
		    sds_data = reform(sds_data, n_elements(sds_data))
		    check_output = size(long_output_data)
		    if check_output(0) eq 0 then begin
			long_output_data = sds_data
			long_org_dims = sds_dims
		    endif else begin
			long_output_data = [long_output_data, sds_data]
		    endelse
		endif else begin
		    HDF_SD_END, sd_id
		    info.multifile.with_geo = 0
		    with_geo = 0
		endelse
	    endif

	    if with_geo eq 1 then begin
		sd_id = HDF_SD_START(current_filename, /READ)
		sds_id = HDF_SD_SELECT(sd_id, colat_index)
		if sds_id ne -1 then begin

		    HDF_SD_GETINFO,sds_id, NAME=colat_sds_name, DIMS=sds_dims, NDIMS=sds_rank, $
			HDF_TYPE=type, /NOREVERSE

		    start_list=lonarr(sds_rank)
		    end_list=lonarr(sds_rank)
		    increment_list=lonarr(sds_rank)
		    array_size=lonarr(sds_rank)

		    for j = 0, sds_rank-1 do begin
			start_list(j) = 0
			end_list(j) = sds_dims(j)
			increment_list(j) = 1
		    endfor

		    array_size = end_list

		    colat_sds_type = convert_hdftypename_hdftype(type)

		    start_list = reverse(start_list)
		    array_size = reverse(array_size)
		    HDF_SD_GETDATA, sds_id, sds_data, START=start_list, COUNT=array_size
		    HDF_SD_ENDACCESS,sds_id
		    HDF_SD_END, sd_id

		    ;if i eq start_num then begin
		    check_output = size(colat_output_data)
		    sds_data = reform(sds_data, n_elements(sds_data))
		    if check_output(0) eq 0 then begin
			colat_output_data = sds_data
			colat_org_dims = sds_dims
		    endif else begin
			colat_output_data = [colat_output_data, sds_data]
		    endelse
		endif else begin
		    HDF_SD_END, sd_id
		    info.multifile.with_geo = 0
		    with_geo = 0
		endelse
	    endif
		
	    if has_time eq 1 or with_time eq 1 then begin
		sd_id = HDF_SD_START(current_filename, /READ)
		sds_id = HDF_SD_SELECT(sd_id, time_index)
		if sds_id ne -1 then begin

		    HDF_SD_GETINFO,sds_id, NAME=time_sds_name, DIMS=sds_dims, NDIMS=sds_rank, $
			HDF_TYPE=type, /NOREVERSE

		    start_list=lonarr(sds_rank)
		    end_list=lonarr(sds_rank)
		    increment_list=lonarr(sds_rank)
		    array_size=lonarr(sds_rank)

		    for j = 0, sds_rank-1 do begin
			start_list(j) = 0
			end_list(j) = sds_dims(j)
			increment_list(j) = 1
		    endfor

		    array_size = end_list

		    time_sds_type = convert_hdftypename_hdftype(type)

		    start_list = reverse(start_list)
		    array_size = reverse(array_size)
		    HDF_SD_GETDATA, sds_id, sds_data, START=start_list, COUNT=array_size
		    HDF_SD_ENDACCESS,sds_id
		    HDF_SD_END, sd_id

		    ;if i eq start_num then begin
		    check_output = size(time_output_data)
		    sds_data = reform(sds_data, n_elements(sds_data))
		    if check_output(0) eq 0 then begin
			time_output_data = sds_data
			time_org_dims = sds_dims
		    endif else begin
			time_output_data = [time_output_data, sds_data]
		    endelse
		endif else begin
		    HDF_SD_END, sd_id
		    info.multifile.with_time = 0
		    with_time = 0
		    info.multifile.has_time = 0
		    has_time = 0
		endelse
	    endif
		
	endif else begin
	    result=dialog_message('Unable to select '+data_name+' SDS data!',$
		title='View HDF Warning!')
	    HDF_SD_END,sd_id
	endelse
      endif else begin
	result=dialog_message('Unable to open '+current_filename+'!',$
 	    title='View HDF Warning!')
      endelse
    endif
endfor

size_data = size(output_data)
if size_data(0) ne 0 then begin
    ;If time is available, convert julian date to seconds of the day
    if(has_time eq 1) or (with_time eq 1) then begin
	size_time_data = size(time_output_data)
	if size_time_data(0) ne 0 then begin
	    if name_id eq 4 then time_record = make_array(size_time_data(1), size_time_data(2), /DOUBLE) $
		else time_record = make_array(size_time_data(size_time_data(0)), /DOUBLE)
	    if name_id eq 0 then begin
		for i=0L, size_time_data(2)-1 do begin
		    if(time_output_data(1, i) gt 0.5) then begin
			time_record(i) = (time_output_data(1,i) - 0.5) * 86400.0
		    endif else begin
			time_record(i) = (time_output_data(1,i) + 0.5) * 86400.0
		    endelse 
		endfor
	    endif else if name_id eq 1 then begin
		for i=0L, size_time_data(1)-1 do begin
		    if time_output_data(i) gt 1.0 then $
			time_output_data(i) = time_output_data(i) - long(time_output_data(i))
		    if(time_output_data(i) gt 0.5) then begin
			time_record(i) = (time_output_data(i) - 0.5) * 86400.0
		    endif else begin
			time_record(i) = (time_output_data(i) + 0.5) * 86400.0
		    endelse 
		endfor
	    endif else if name_id eq 2 or name_id eq 3 then begin
		for i=0L, size_time_data(2)-1 do begin
		    if time_output_data(0, i) gt 1.0 then $
			time_output_data(0, i) = time_output_data(0, i) - long(time_output_data(0, i))
		    if(time_output_data(0, i) gt 0.5) then begin
			time_record(i) = (time_output_data(0,i) - 0.5) * 86400.0
		    endif else begin
			time_record(i) = (time_output_data(0,i) + 0.5) * 86400.0
		    endelse 
		endfor
	    endif else if name_id eq 4 then begin
		for j=0L, size_time_data(2)-1 do begin
		    for i=0L, size_time_data(3)-1 do begin
			time_record(j,i) = time_output_data(1,j,i) * 86400.0
		    endfor
		endfor
	    endif else begin
		time_record = -9999.0
		info.multifile.with_time = 0
		with_time = 0
		info.multifile.has_time = 0
		has_time = 0
	    endelse
	endif else begin
	    time_record = -9999.0
	    info.multifile.with_time = 0
	    with_time = 0
	    info.multifile.has_time = 0
	    has_time = 0
	endelse
    endif
	   
    if info.vgroup.flag eq 1 then $
	data_name = get_vgroup_name(data_name,info)

    num_output_data = n_elements(output_data)
    rank = n_elements(org_dims)
    if rank eq 2 then begin
	num_rec = long(num_output_data/org_dims(1) + 0.5)
	output_data = reform(output_data, org_dims(1), num_rec)
    endif else if rank eq 3 then begin
	num_rec = long(num_output_data/(org_dims(1)*org_dims(2)) + 0.5)
	output_data = reform(output_data, org_dims(2), org_dims(1), num_rec)
    endif else if rank eq 4 then begin
	num_rec = long(num_output_data/(org_dims(1)*org_dims(2)*org_dims(3)) + 0.5)
	output_data = reform(output_data, org_dims(3), org_dims(2), org_dims(1), num_rec)
    endif
    size_data = size(output_data)
	    
    num_output_data = n_elements(output_data)
    org_output_data = num_output_data
    sds_rank = size_data(0)
    org_sds_rank = sds_rank
    start_list=lonarr(size_data(0))
    end_list=lonarr(size_data(0))
    increment_list=lonarr(size_data(0))

    for j = 0, sds_rank-1 do begin
	start_list(j) = 0
	end_list(j) = size_data(j+1)
	increment_list(j) = 1
    endfor
    end_list = reverse(end_list)

    the_result = do_subset_data(1,data_name,sds_rank,start_list,end_list, $
	increment_list, output_data, info)
    if the_result eq -1 then return

    org_start_list = start_list
    org_end_list = end_list
    org_increment_list = increment_list

    num_output_data = n_elements(output_data)

    info.subset.count=info.subset.count+1
    info.subset.data(info.subset.count-1).subset_name = string(data_name)
    info.subset.data(info.subset.count-1).src_filename = filename
    info.subset.data(info.subset.count-1).src_unitname = info.unitname
    info.subset.data(info.subset.count-1).src_type_flag = 0
    info.subset.data(info.subset.count-1).src_crit_flag = 0
    info.subset.data(info.subset.count-1).src_crit_name = ''
    info.subset.data(info.subset.count-1).src_crit_min = ''
    info.subset.data(info.subset.count-1).src_crit_max = ''
    info.subset.data(info.subset.count-1).src_crit_type = ''
    info.subset.data(info.subset.count-1).src_num = num_output_data
    info.subset.data(info.subset.count-1).src_ref = sds_ref
    info.subset.data(info.subset.count-1).src_rank = sds_rank
    info.subset.data(info.subset.count-1).src_start = start_list
    info.subset.data(info.subset.count-1).src_end = end_list
    info.subset.data(info.subset.count-1).src_increment = increment_list
    info.subset.data(info.subset.count-1).src_org_rank = sds_rank
    info.subset.data(info.subset.count-1).src_org_start = start_list
    info.subset.data(info.subset.count-1).src_org_end = end_list
    info.subset.data(info.subset.count-1).src_org_increment = increment_list
    info.subset.data(info.subset.count-1).src_types(0) = sds_type
    info.subset.data(info.subset.count-1).src_start(info.sds.rank) = start_list(0)
    info.subset.data(info.subset.count-1).src_end(info.sds.rank) = end_list(0)

    if ptr_valid(info.subset.data(info.subset.count-1).src_data) then begin
	*info.subset.data(info.subset.count-1).src_data = output_data
    endif else begin
	info.subset.data(info.subset.count-1).src_data = ptr_new(output_data)
    endelse

;   assign the time to the variable
    if has_time eq 1 then begin
	if ptr_valid(info.subset.data(info.subset.count-1).src_time) then begin
	    *info.subset.data(info.subset.count-1).src_time = time_record
	endif else begin
	    info.subset.data(info.subset.count-1).src_time = ptr_new(time_record)
	endelse
    endif

    info.greenwich.default = 0
    info.rangetype.flag = 0
    info.multifile.with_geo = 0
    info.multifile.with_time = 0

    info = redefine_info(info, data_name, 3)
    widget_control, info.widgets.subset_list, set_value=info.name_list_subset

    widget_control, info.widgets.sds, set_list_select=-1
    widget_control, set_uvalue=info, info.base

    save_list = redefine_save_list(info)
    widget_control, set_uvalue=save_list, info.list_base
endif else begin
    the_message = ['Either the data files are empty or',$
        'there is an error to open the files.', $
        'Please check the setting and do it again.']
    result=dialog_message(the_message, title='View HDF Warning!')
    return
endelse

;assign the geolocation parameters if with_geo = 1
if(with_geo eq 1) then begin
    if (info.subset.count lt info.subset.maximum-1) then begin
	size_data = size(long_output_data)
	if size_data(0) ne 0 then begin
	    ;if info.vgroup.flag eq 1 then $
	;	long_sds_name = get_vgroup_name(long_sds_name,info)

	    num_output_data = n_elements(long_output_data)
	    rank = n_elements(long_org_dims)
	    if rank eq 2 then begin
		num_rec = long(num_output_data/long_org_dims(1) + 0.5)
		long_output_data = reform(long_output_data, long_org_dims(1), num_rec)
	    endif else if rank eq 3 then begin
		num_rec = long(num_output_data/(long_org_dims(1)*long_org_dims(2)) + 0.5)
		long_output_data = reform(long_output_data, long_org_dims(2), $
		    long_org_dims(1), num_rec)
	    endif else if rank eq 4 then begin
		num_rec = long(num_output_data/(long_org_dims(1)*long_org_dims(2)* $
		    long_org_dims(3)) + 0.5)
		long_output_data = reform(long_output_data, long_org_dims(3), long_org_dims(2), $
		    long_org_dims(1), num_rec)
	    endif
	    size_data = size(long_output_data)

	    num_output_data = n_elements(long_output_data)
	    sds_rank = size_data(0)
	    start_list=lonarr(size_data(0))
	    end_list=lonarr(size_data(0))
	    increment_list=lonarr(size_data(0))

	    if org_output_data eq num_output_data and org_sds_rank eq sds_rank then begin
		sub_flag = 0
		start_list = org_start_list
		end_list = org_end_list
		increment_list = org_increment_list
	    endif else begin
		sub_flag = 1
		for j = 0, sds_rank-1 do begin
		    start_list(j) = 0
		    end_list(j) = size_data(j+1)
		    increment_list(j) = 1
		endfor
		end_list = reverse(end_list)
	    endelse

	    the_result = do_subset_data(sub_flag, long_sds_name, sds_rank, start_list, $
		 end_list, increment_list, long_output_data, info)

	    if the_result ne -1 then begin

		num_output_data = n_elements(long_output_data)

		info.subset.count=info.subset.count+1
		info.subset.data(info.subset.count-1).subset_name = string(long_sds_name)
		info.subset.data(info.subset.count-1).src_filename = filename
		info.subset.data(info.subset.count-1).src_unitname = 'Degrees'
		info.subset.data(info.subset.count-1).src_type_flag = 0
		info.subset.data(info.subset.count-1).src_crit_flag = 0
		info.subset.data(info.subset.count-1).src_crit_name = ''
		info.subset.data(info.subset.count-1).src_crit_min = ''
		info.subset.data(info.subset.count-1).src_crit_max = ''
		info.subset.data(info.subset.count-1).src_crit_type = ''
		info.subset.data(info.subset.count-1).src_num = num_output_data
		info.subset.data(info.subset.count-1).src_ref = long_index
		info.subset.data(info.subset.count-1).src_rank = sds_rank
		info.subset.data(info.subset.count-1).src_start = start_list
		info.subset.data(info.subset.count-1).src_end = end_list
		info.subset.data(info.subset.count-1).src_increment = increment_list
		info.subset.data(info.subset.count-1).src_org_rank = sds_rank
		info.subset.data(info.subset.count-1).src_org_start = start_list
		info.subset.data(info.subset.count-1).src_org_end = end_list
		info.subset.data(info.subset.count-1).src_org_increment = increment_list
		info.subset.data(info.subset.count-1).src_types(0) = long_sds_type
		info.subset.data(info.subset.count-1).src_start(info.sds.rank) = start_list(0)
		info.subset.data(info.subset.count-1).src_end(info.sds.rank) = end_list(0)

		if ptr_valid(info.subset.data(info.subset.count-1).src_data) then begin
		    *info.subset.data(info.subset.count-1).src_data = long_output_data
		endif else begin
		    info.subset.data(info.subset.count-1).src_data = ptr_new(long_output_data)
		endelse

		info = redefine_info(info, long_sds_name, 3)
		widget_control, info.widgets.subset_list, set_value=info.name_list_subset

		widget_control, info.widgets.sds, set_list_select=-1
		widget_control, set_uvalue=info, info.base

		save_list = redefine_save_list(info)
		widget_control, set_uvalue=save_list, info.list_base
	    endif
	endif

	size_data = size(colat_output_data)
	if size_data(0) ne 0 then begin
	    ;if info.vgroup.flag eq 1 then $
	;	colat_sds_name = get_vgroup_name(colat_sds_name,info)

	    num_output_data = n_elements(colat_output_data)
	    rank = n_elements(colat_org_dims)
	    if rank eq 2 then begin
		num_rec = long(num_output_data/colat_org_dims(1) + 0.5)
		colat_output_data = reform(colat_output_data, colat_org_dims(1), num_rec)
	    endif else if rank eq 3 then begin
		num_rec = long(num_output_data/(colat_org_dims(1)*colat_org_dims(2)) + 0.5)
		colat_output_data = reform(colat_output_data, colat_org_dims(2), $
		    colat_org_dims(1), num_rec)
	    endif else if rank eq 4 then begin
		num_rec = long(num_output_data/(colat_org_dims(1)*colat_org_dims(2)* $
		    colat_org_dims(3)) + 0.5)
		colat_output_data = reform(colat_output_data, colat_org_dims(3), colat_org_dims(2), $
		    colat_org_dims(1), num_rec)
	    endif
	    size_data = size(colat_output_data)

	    num_output_data = n_elements(colat_output_data)
	    sds_rank = size_data(0)
	    start_list=lonarr(size_data(0))
	    end_list=lonarr(size_data(0))
	    increment_list=lonarr(size_data(0))

	    if org_output_data eq num_output_data and org_sds_rank eq sds_rank then begin
		sub_flag = 0
		start_list = org_start_list
		end_list = org_end_list
		increment_list = org_increment_list
	    endif else begin
		sub_flag = 1
		for j = 0, sds_rank-1 do begin
		    start_list(j) = 0
		    end_list(j) = size_data(j+1)
		    increment_list(j) = 1
		endfor
		end_list = reverse(end_list)
	    endelse

	    the_result = do_subset_data(sub_flag, colat_sds_name, sds_rank, start_list, $
		end_list, increment_list, colat_output_data, info)

	    if the_result ne -1 then begin

		num_output_data = n_elements(colat_output_data)

		info.subset.count=info.subset.count+1
		info.subset.data(info.subset.count-1).subset_name = string(colat_sds_name)
		info.subset.data(info.subset.count-1).src_filename = filename
		info.subset.data(info.subset.count-1).src_unitname = 'Degrees'
		info.subset.data(info.subset.count-1).src_type_flag = 0
		info.subset.data(info.subset.count-1).src_crit_flag = 0
		info.subset.data(info.subset.count-1).src_crit_name = ''
		info.subset.data(info.subset.count-1).src_crit_min = ''
		info.subset.data(info.subset.count-1).src_crit_max = ''
		info.subset.data(info.subset.count-1).src_crit_type = ''
		info.subset.data(info.subset.count-1).src_num = num_output_data
		info.subset.data(info.subset.count-1).src_ref = colat_index
		info.subset.data(info.subset.count-1).src_rank = sds_rank
		info.subset.data(info.subset.count-1).src_start = start_list
		info.subset.data(info.subset.count-1).src_end = end_list
		info.subset.data(info.subset.count-1).src_increment = increment_list
		info.subset.data(info.subset.count-1).src_org_rank = sds_rank
		info.subset.data(info.subset.count-1).src_org_start = start_list
		info.subset.data(info.subset.count-1).src_org_end = end_list
		info.subset.data(info.subset.count-1).src_org_increment = increment_list
		info.subset.data(info.subset.count-1).src_types(0) = colat_sds_type
		info.subset.data(info.subset.count-1).src_start(info.sds.rank) = start_list(0)
		info.subset.data(info.subset.count-1).src_end(info.sds.rank) = end_list(0)

		if ptr_valid(info.subset.data(info.subset.count-1).src_data) then begin
		    *info.subset.data(info.subset.count-1).src_data = colat_output_data
		endif else begin
		    info.subset.data(info.subset.count-1).src_data = ptr_new(colat_output_data)
		endelse

		info = redefine_info(info, colat_sds_name, 3)
		widget_control, info.widgets.subset_list, set_value=info.name_list_subset

		widget_control, info.widgets.sds, set_list_select=-1
		widget_control, set_uvalue=info, info.base

		save_list = redefine_save_list(info)
		widget_control, set_uvalue=save_list, info.list_base
	    endif
	endif
    endif
endif

;assign the time parameters if with_time = 1
if(with_time eq 1) then begin
    if (info.subset.count lt info.subset.maximum) then begin
	size_data = size(time_record)
	if size_data(0) ne 0 then begin
	    ;if info.vgroup.flag eq 1 then $
	;	time_sds_name = get_vgroup_name(time_sds_name,info)

	    num_output_data = n_elements(time_output_data)
	    rank = n_elements(time_org_dims)
	    if rank eq 2 then begin
		num_rec = long(num_output_data/time_org_dims(1) + 0.5)
		time_record = reform(time_record, time_org_dims(1), num_rec)
	    endif else if rank eq 3 then begin
		num_rec = long(num_output_data/(time_org_dims(1)*time_org_dims(2)) + 0.5)
		time_record = reform(time_record, time_org_dims(2), $
		    time_org_dims(1), num_rec)
	    endif else if rank eq 4 then begin
		num_rec = long(num_output_data/(time_org_dims(1)*time_org_dims(2)* $
		    time_org_dims(3)) + 0.5)
		time_record = reform(time_record, time_org_dims(3), time_org_dims(2), $
		    time_org_dims(1), num_rec)
	    endif
	    size_data = size(time_record)

	    num_output_data = n_elements(time_record)
	    sds_rank = size_data(0)
	    start_list=lonarr(size_data(0))
	    end_list=lonarr(size_data(0))
	    increment_list=lonarr(size_data(0))

	    if org_output_data eq num_output_data and org_sds_rank eq sds_rank then begin
		sub_flag = 0
		start_list = org_start_list
		end_list = org_end_list
		increment_list = org_increment_list
	    endif else begin
		sub_flag = 1
		for j = 0, sds_rank-1 do begin
		    start_list(j) = 0
		    end_list(j) = size_data(j+1)
		    increment_list(j) = 1
		endfor
		end_list = reverse(end_list)
	    endelse

	    the_result = do_subset_data(sub_flag, time_sds_name, sds_rank, start_list, $
		end_list, increment_list, time_output_data, info)

	    if the_result ne -1 then begin
		num_output_data = n_elements(time_output_data)

		info.subset.count=info.subset.count+1
		info.subset.data(info.subset.count-1).subset_name = string(time_sds_name)
		info.subset.data(info.subset.count-1).src_filename = filename
		info.subset.data(info.subset.count-1).src_unitname = 'Seconds'
		info.subset.data(info.subset.count-1).src_type_flag = 0
		info.subset.data(info.subset.count-1).src_crit_flag = 0
		info.subset.data(info.subset.count-1).src_crit_name = ''
		info.subset.data(info.subset.count-1).src_crit_min = ''
		info.subset.data(info.subset.count-1).src_crit_max = ''
		info.subset.data(info.subset.count-1).src_crit_type = ''
		info.subset.data(info.subset.count-1).src_num = num_output_data
		info.subset.data(info.subset.count-1).src_ref = time_index
		info.subset.data(info.subset.count-1).src_rank = sds_rank
		info.subset.data(info.subset.count-1).src_start = start_list
		info.subset.data(info.subset.count-1).src_end = end_list
		info.subset.data(info.subset.count-1).src_increment = increment_list
		info.subset.data(info.subset.count-1).src_org_rank = sds_rank
		info.subset.data(info.subset.count-1).src_org_start = start_list
		info.subset.data(info.subset.count-1).src_org_end = end_list
		info.subset.data(info.subset.count-1).src_org_increment = increment_list
		info.subset.data(info.subset.count-1).src_types(0) = time_sds_type
		info.subset.data(info.subset.count-1).src_start(info.sds.rank) = start_list(0)
		info.subset.data(info.subset.count-1).src_end(info.sds.rank) = end_list(0)

		if ptr_valid(info.subset.data(info.subset.count-1).src_data) then begin
		    *info.subset.data(info.subset.count-1).src_data = time_record
		endif else begin
		    info.subset.data(info.subset.count-1).src_data = ptr_new(time_record)
		endelse

		info = redefine_info(info, time_sds_name, 3)
		widget_control, info.widgets.subset_list, set_value=info.name_list_subset

		widget_control, info.widgets.sds, set_list_select=-1
		widget_control, set_uvalue=info, info.base

		save_list = redefine_save_list(info)
		widget_control, set_uvalue=save_list, info.list_base
	    endif
	endif
    endif
endif

end
;------------------------------------------------------------------
pro read_vdata_multiple_files, filename, vdata_name, vdata_ref, $
    fieldname, fieldindex, the_order, the_types, unitname, info

pro_name = 'read_vdata_multiple_files'
@getinfo

str_num_digit = strcompress(string(info.multifile.num_digit), /REMOVE_ALL)
str_start_num = strcompress(string(info.multifile.start_num), /REMOVE_ALL)
str_last_num  = strcompress(string(info.multifile.last_num), /REMOVE_ALL)
str_skip_num  = strcompress(string(info.multifile.skip_num), /REMOVE_ALL)
if info.multifile.has_time eq 1 then str_has_time = 'Yes' else str_has_time = 'No'
if info.multifile.with_geo eq 1 then str_with_geo = 'Yes' else str_with_geo = 'No'
if info.multifile.with_time eq 1 then str_with_time = 'Yes' else str_with_time = 'No'

desc = [ $
    '0, label, Read Vdata From Multiple Files, center, font='+info.font, $
    '0, label, "   ", center, font=' + info.font, $
    '0, label, You are requesting to read the field:, left, font='+info.font, $
    '0, label, '+fieldname+', left, font='+info.font, $
    '0, label, in the Vdata:, left, font='+info.font, $
    '0, label, '+vdata_name+', left, font='+info.font, $
    '0, label, from multiple files.  The settings are:, left, font='+info.font, $
    '0, label, "   ", center, font='+info.font, $
    '0, label, Increase by the last '+str_num_digit+' digits, left, font='+info.font, $
    '0, label, Start with the number: '+str_start_num+', left, font='+info.font, $
    '0, label, End with the number: '+str_last_num+', left, font='+info.font, $
    '0, label, Skip number of files: '+str_skip_num+', left, font='+info.font, $
    '0, label, With time information: '+str_has_time+', left, font='+info.font, $
    '0, label, Import the geolocation parameters: '+str_with_geo+', left, font='+info.font, $
    '0, label, Import the time parameter: '+str_with_time+', left, font='+info.font, $
    '0, label, "   ", center, font='+info.font, $
    '0, label, Press OK to continue if the settings are corrected., left, font='+info.font, $
    '0, label, Press Cancel to quit if the settings are incorrected., left, font='+info.font, $
    '0, label, "   ", center, font='+info.font, $
    '1, base, , row, space=60, center', $
    '0, button, OK, QUIT, tag=done, font='+info.font, $
    '2, button, Cancel, QUIT, tag=cancel, font='+info.font]

result = cw_form(desc, /column, title='Read Vdata From Multiple Files')
if result.cancel eq 1 then return

widget_control, /hourglass

num_digit = info.multifile.num_digit
start_num = info.multifile.start_num
last_num = info.multifile.last_num
skip_num = info.multifile.skip_num
with_geo = info.multifile.with_geo
with_time = info.multifile.with_time
has_time = info.multifile.has_time

filename = filename(0)
the_types = the_types(0)
the_order = the_order(0)
unitname = unitname(0)
if unitname eq "BAD" then unitname = '' else unitname = ', '+unitname

length_filename = strlen(filename)
if length_filename le num_digit then begin
    the_message = ['The length of the filename is less than or equal to', $
	'the number of digits to be increased.', $
	'Please check the setting and do it again.']
    result=dialog_message(the_message, title='View HDF Warning!')
    return
endif

root_filename = strmid(filename, 0, length_filename-num_digit)

;  Get the indese for geolocation parameters if with_geo = 1
;  Assume the parameters are in the same vdata set
if with_geo eq 1 then begin
    vdata_id = open_vdata(filename,vdata_name,file_id)
    if vdata_id ne 0 then begin
	field_name = ['Longitude of CERES FOV at Surface']
	num_field = n_elements(field_name)
	field_check = -1
	i = 0
	while (field_check eq -1 and i lt num_field) do begin
	    long_fieldname = field_name(i)
	    field_check = HDF_VD_FEXIST(vdata_id,long_fieldname)
	    i = i + 1
	endwhile
	if field_check eq -1 then begin
	    info.multifile.with_geo = 0
	    with_geo = 0
	endif else begin
	    HDF_VD_GETINFO, vdata_id, long_fieldname, ORDER=long_order, TYPE=type
	    long_type = convert_idltypename_hdftype(type)
	endelse
	HDF_VD_DETACH, vdata_id
	HDF_CLOSE,file_id
    endif else begin
	info.multifile.with_geo = 0
	with_geo = 0
	HDF_CLOSE,file_id
    endelse

    if with_geo eq 1 then begin
	vdata_id = open_vdata(filename,vdata_name,file_id)
	if vdata_id ne 0 then begin
	    field_name = ['Colatitude of CERES FOV at Surface']
	    num_field = n_elements(field_name)
	    field_check = -1
	    i = 0
	    while (field_check eq -1 and i lt num_field) do begin
		colat_fieldname = field_name(i)
		field_check = HDF_VD_FEXIST(vdata_id,colat_fieldname)
		i = i + 1
	    endwhile
	    if field_check eq -1 then begin
		info.multifile.with_geo = 0
		with_geo = 0
	    endif else begin
		HDF_VD_GETINFO, vdata_id, colat_fieldname, ORDER=colat_order, TYPE=type
		colat_type = convert_idltypename_hdftype(type)
	    endelse
	    HDF_VD_DETACH, vdata_id
	    HDF_CLOSE,file_id
	endif else begin
	    info.multifile.with_geo = 0
	    with_geo = 0
	    HDF_CLOSE,file_id
	endelse
    endif
endif

;  Get the index for time parameters if has_time eq 1 or with_time eq 1
if has_time eq 1 or with_time eq 1 then begin
    vdata_id = open_vdata(filename,vdata_name,file_id)
    if vdata_id ne 0 then begin
	field_name = ['Time of Observation']
	num_field = n_elements(field_name)
	field_check = -1
	i = 0
	while (field_check eq -1 and i lt num_field) do begin
	    time_fieldname = field_name(i)
	    field_check = HDF_VD_FEXIST(vdata_id,time_fieldname)
	    i = i + 1
	endwhile
	if field_check eq -1 then begin
	    info.multifile.with_time = 0
	    with_time = 0
	    info.multifile.has_time = 0
	    has_time = 0
	endif else begin
	    HDF_VD_GETINFO, vdata_id, time_fieldname, ORDER=time_order, TYPE=type
	    time_type = convert_idltypename_hdftype(type)
	endelse
	HDF_VD_DETACH, vdata_id
	HDF_CLOSE,file_id
    endif else begin
	info.multifile.with_time = 0
	with_time = 0
	info.multifile.has_time = 0
	has_time = 0
	HDF_CLOSE,file_id
    endelse
endif

for i = start_num, last_num, skip_num do begin
    current_num = strcompress(string(i), /REMOVE_ALL)
    if(strlen(current_num) lt num_digit) then begin
	num_zero = num_digit - strlen(current_num)
	for j = 1, num_zero do begin
	    current_num = '0'+current_num
	endfor
    endif

    current_filename = root_filename + current_num
    ;print,'current_filename = ',current_filename

    check_hdf = HDF_ISHDF(current_filename)
    if(check_hdf eq 1) then begin

      file_id = HDF_OPEN(current_filename, /READ)
      if file_id ne -1 then begin

	vdata_id = HDF_VD_ATTACH(file_id, vdata_ref, /READ)
	;if vdata_id ne 0 then begin
	if vdata_id gt 0 then begin

	    HDF_VD_GET,vdata_id, COUNT=n_records
	    ;HDF_VD_GETINFO, vdata_id, fieldindex, NAME=field_name, ORDER=field_order, $
	;	TYPE=type
	;    output_type = convert_idltypename_hdftype(type)

	    unsign_type = 0
	    if info.version lt 5.19 and info.library_status eq 1 then begin
		if the_types gt 20 then unsign_type = sds_type mod 2
	    endif

;  Close the vdata_id and file_id before to read data
	    HDF_VD_DETACH, vdata_id
	    HDF_CLOSE, file_id

	    if unsign_type eq 0 then begin
		the_result = read_vdata(current_filename, vdata_name, vdata_ref, $
		    n_records-1, the_order, the_types, fieldname, vdata_data)
	    endif else begin
		if the_types eq 4 then begin
		    blank = array_type(20L, the_order+1)
		endif else if the_types eq 21 and n_records eq 1 then begin
		    blank = array_type(the_types, the_order+1)
		endif else begin
		    blank = array_type(the_types, the_order)
		endelse

		single_record=create_struct( 'components' + '0', blank)

		vdata_data=replicate(single_record, (info.vdata.nrec))

		CD, '.', CURRENT = PWD

		this_start = 0L
		this_increment = 1
		;the_result = CALL_EXTERNAL(PWD+'/' + info.library,   $
		the_result = CALL_EXTERNAL(info.library, $
		    'read_vdata_eos',	$
		    current_filename,	$
		    vdata_name,		$
		    vdata_ref,		$
		    long(1),		$
		    this_start,		$
		    n_records-1,	$
		    this_increment,	$
		    fieldname,		$
		    the_types,		$
		    the_order,		$
		    vdata_data)
	    endelse
	    
	    if (the_result eq -1) then begin
		the_message = ['Unable to read '+fieldname, $
		    'from '+vdata_name+' Vdata!']
		result=dialog_message(the_message, title='View HDF Warning!')
	    endif else begin
		vdata_data = reform(vdata_data.components0, n_elements(vdata_data.components0))
		;if i eq start_num then begin
		check_output = size(output_data)
		if check_output(0) eq 0 then begin
		    output_data = vdata_data
		endif else begin
		    output_data = [output_data, vdata_data]
		endelse
	    endelse

;   get the geolocation parameters if with_geo eq 1
	    if with_geo eq 1 then begin
		file_id = HDF_OPEN(current_filename, /READ)
		vdata_id = HDF_VD_ATTACH(file_id, vdata_ref, /READ)
		;if vdata_id ne 0 then begin
		if vdata_id gt 0 then begin
		    nread = HDF_VD_READ(vdata_id, vdata_data, FIELDS=long_fieldname)
		    if n_records eq nread then begin
			check_output = size(long_output_data)
			if check_output(0) eq 0 then begin
			    long_output_data = vdata_data
			endif else begin
			    long_output_data = [long_output_data, vdata_data]
			endelse
		    endif
		    HDF_VD_DETACH, vdata_id
		    HDF_CLOSE, file_id
		endif else begin
		    HDF_CLOSE, file_id
		    info.multifile.with_geo = 0
		    with_geo = 0
		endelse
	    endif

	    if with_geo eq 1 then begin
		file_id = HDF_OPEN(current_filename, /READ)
		vdata_id = HDF_VD_ATTACH(file_id, vdata_ref, /READ)
		;if vdata_id ne 0 then begin
		if vdata_id gt 0 then begin
		    nread = HDF_VD_READ(vdata_id, vdata_data, FIELDS=colat_fieldname)
		    if n_records eq nread then begin
			check_output = size(colat_output_data)
			if check_output(0) eq 0 then begin
			    colat_output_data = vdata_data
			endif else begin
			    colat_output_data = [colat_output_data, vdata_data]
			endelse
		    endif
		    HDF_VD_DETACH, vdata_id
		    HDF_CLOSE, file_id
		endif else begin
		    HDF_CLOSE, file_id
		    info.multifile.with_geo = 0
		    with_geo = 0
		endelse
	    endif
		
	    if has_time eq 1 or with_time eq 1 then begin
		file_id = HDF_OPEN(current_filename, /READ)
                vdata_id = HDF_VD_ATTACH(file_id, vdata_ref, /READ)
                ;if vdata_id ne 0 then begin
		if vdata_id gt 0 then begin
                    nread = HDF_VD_READ(vdata_id, vdata_data, FIELDS=time_fieldname)
		    if n_records eq nread then begin
			check_output = size(time_output_data)
			if check_output(0) eq 0 then begin
			    time_output_data = vdata_data
			endif else begin
			    time_output_data = [time_output_data, vdata_data]
			endelse
		    endif
		    HDF_VD_DETACH, vdata_id
		    HDF_CLOSE, file_id
		endif else begin
		    HDF_CLOSE, file_id
		    info.multifile.with_time = 0
		    with_time = 0
		    info.multifile.has_time = 0
		    has_time = 0
		endelse
	    endif
		
	endif else begin
	    result=dialog_message('Unable to select '+vdata_name+' vdata!',$
		title='View HDF Warning!')
	    HDF_CLOSE, file_id
	endelse
      endif else begin
	result=dialog_message('Unable to open '+current_filename+'!',$
 	    title='View HDF Warning!')
      endelse
    endif
endfor

size_data = size(output_data)
if size_data(0) ne 0 then begin
    num_data = n_elements(output_data)
    num_rec = long(num_data/the_order+0.5)
    output_data = reform(output_data, the_order, num_rec)
    rank = 2
    org_output_data = num_data
    org_order = the_order
    org_rank  = rank

    start_list=lonarr(rank)
    end_list=lonarr(rank)
    increment_list=lonarr(rank)
    start_list(0) = 0
    end_list(0) = num_rec
    increment_list(0) = 1
    start_list(1) = 0
    end_list(1) = the_order
    increment_list(1) = 1

    the_result = do_subset_data(1,fieldname,rank,start_list,end_list, $
	increment_list, output_data, info)
    if the_result eq -1 then return

    org_start_list = start_list
    org_end_list = end_list
    org_increment_list = increment_list

    size_data = size(output_data)
    num_rec = size_data(2)
    the_order = size_data(1)

    blank = array_type(the_types, the_order)
    single_record=create_struct( 'components' + '0', blank)
    vdata_data=replicate(single_record, num_rec)

    m = 0L
    for i = 0L, num_rec-1 do begin
	for j = 0L, the_order-1 do begin
	    vdata_data(i).components0(j) = output_data(m)
	    m = m + 1
	endfor
    endfor

    output_data = vdata_data
    size_data = size(output_data)

    n_records = size_data(size_data(0))
    this_start = start_list(0)
    this_end = end_list(0) - 1
    this_increment = increment_list(0)
;  if the field is Radiance and mode flags, get the particular flag
    if info.vfield.name_sel eq "Radiance and mode flags" then begin
	get_quality_bits, info.quality.indices_sel, start_bit, num_bit
	data_type = the_types
	num_data = n_elements(output_data.components0)
	output_data = reform(output_data.components0, n_elements(output_data.components0))
	output_data = long(output_data)
	output_data_1 = get_bit_values(num_data,start_bit,num_bit,output_data,info.version)
	blank = array_type(24L, the_order)
	single_record=create_struct( 'components' + '0', blank)
	output_data=replicate(single_record, n_records)
	jj = 0L
	for i=0L, n_records-1 do begin
	    for j=0, the_order-1 do begin
		output_data(i).components0(j) = output_data_1(jj)
		jj = jj + 1
	    endfor
	endfor
    endif

    ;If time is available, convert julian date to seconds of the day
    if(has_time eq 1) or (with_time eq 1) then begin
	size_time_data = size(time_output_data)
	if size_time_data(0) ne 0 then begin
	    time_output_data = reform(time_output_data, n_elements(time_output_data))
	    the_nrec = n_elements(time_output_data)
	    time_record = make_array(the_nrec, /DOUBLE)
	    for i = 0L, the_nrec-1 do begin
		if time_output_data(i) gt 1.0 then $
		    time_output_data(i) = time_output_data(i) - long(time_output_data(i))
		if(time_output_data(i) gt 0.5) then $
		    time_record(i) = (time_output_data(i) - 0.5) * 86400.0 $
		    else time_record(i) = (time_output_data(i) + 0.5) * 86400.0
	    endfor
	endif else begin
	    time_record = -9999.0
	    info.multifile.with_time = 0
	    with_time = 0
	    info.multifile.has_time = 0
	    has_time = 0
	endelse
    endif
	   
    info = redefine_info(info, fieldname, 3)

    widget_control, info.widgets.subset_list, set_value=info.name_list_subset

    num_output_data = n_elements(output_data.components0)

    ;-------------------------------------------
    ; Stuff the data into info.subset.data
    ;-------------------------------------------
    info.subset.count=info.subset.count+1
    info.subset.data(info.subset.count-1).subset_name = string(fieldname)
    info.subset.data(info.subset.count-1).src_filename = filename
    info.subset.data(info.subset.count-1).src_unitname = unitname
    info.subset.data(info.subset.count-1).src_type_flag = 1
    info.subset.data(info.subset.count-1).src_crit_flag = 0
    info.subset.data(info.subset.count-1).src_crit_name = ''
    info.subset.data(info.subset.count-1).src_crit_min = ''
    info.subset.data(info.subset.count-1).src_crit_max = ''
    info.subset.data(info.subset.count-1).src_crit_type = ''
    info.subset.data(info.subset.count-1).src_num = num_output_data
    info.subset.data(info.subset.count-1).src_ref = vdata_ref
    info.subset.data(info.subset.count-1).src_rank = rank
    info.subset.data(info.subset.count-1).src_start(0) = this_start
    info.subset.data(info.subset.count-1).src_end(0) = this_end
    info.subset.data(info.subset.count-1).src_increment(0) = this_increment
    info.subset.data(info.subset.count-1).src_org_rank = org_rank
    info.subset.data(info.subset.count-1).src_org_start(0) = org_start_list(0)
    info.subset.data(info.subset.count-1).src_org_end(0) = org_end_list(0) - 1
    info.subset.data(info.subset.count-1).src_org_increment(0) = org_increment_list(0)
    info.subset.data(info.subset.count-1).src_org_start(1) = org_start_list(1)
    info.subset.data(info.subset.count-1).src_org_end(1) = org_end_list(1) - 1
    info.subset.data(info.subset.count-1).src_org_increment(1) = org_increment_list(1)
    info.subset.data(info.subset.count-1).src_start(1) = start_list(1) + 1
    info.subset.data(info.subset.count-1).src_end(1) = end_list(1)
    info.subset.data(info.subset.count-1).src_increment(1) = increment_list(1)
    info.subset.data(info.subset.count-1).src_fnames = fieldname
    info.subset.data(info.subset.count-1).src_order = the_order
    info.subset.data(info.subset.count-1).src_order(1) = org_order
    info.subset.data(info.subset.count-1).src_types = the_types

    if ptr_valid(info.subset.data(info.subset.count-1).src_data) then begin
	*info.subset.data(info.subset.count-1).src_data = output_data
    endif else begin
	info.subset.data(info.subset.count-1).src_data = ptr_new(output_data)
    endelse

;   assign the time to the variable
    if has_time eq 1 then begin
	if ptr_valid(info.subset.data(info.subset.count-1).src_time) then begin
	    *info.subset.data(info.subset.count-1).src_time = time_record
	endif else begin
	    info.subset.data(info.subset.count-1).src_time = ptr_new(time_record)
	endelse
    endif

    info.greenwich.default = 0
    info.rangetype.flag = 0
    info.multifile.with_geo = 0
    info.multifile.with_time = 0
    widget_control, info.widgets.vdata, set_list_select=-1
    widget_control, set_uvalue=info, info.base

    save_list = redefine_save_list(info)
    widget_control, set_uvalue=save_list, info.list_base
endif else begin
    the_message = ['Either the data files are empty or',$
        'there is an error to open the files.', $
        'Please check the setting and do it again.']
    result=dialog_message(the_message, title='View HDF Warning!')
    return
endelse

;assign the geolocation parameters if with_geo = 1
if(with_geo eq 1) then begin
    if (info.subset.count lt info.subset.maximum-1) then begin
	size_data = size(long_output_data)
	if size_data(0) ne 0 then begin
	    long_output_data = reform(long_output_data, n_elements(long_output_data))
	    num_data = n_elements(long_output_data)
	    num_rec = long(num_data/long_order+0.5)
	    long_output_data = reform(long_output_data, long_order, num_rec)
	    rank = 2
	    start_list=lonarr(2)
	    end_list=lonarr(2)
	    increment_list=lonarr(2)

	    if org_output_data eq num_data and org_order eq long_order then begin
		sub_flag = 0
		start_list = org_start_list
		end_list = org_end_list
		increment_list = org_increment_list
	    endif else begin
		sub_flag = 1
		start_list(0) = 0
		end_list(0) = num_rec
		increment_list(0) = 1
		start_list(1) = 0
		end_list(1) = long_order
		increment_list(1) = 1
	    endelse
	    the_result = do_subset_data(sub_flag, long_fieldname, rank, start_list, $
		end_list, increment_list, long_output_data, info)

	    if the_result ne -1 then begin

		size_data = size(long_output_data)
		num_rec = size_data(2)
		the_order = size_data(1)

		blank = array_type(long_type, long_order)
		single_record=create_struct( 'components' + '0', blank)
		vdata_data=replicate(single_record, num_rec)

		m = 0L
		for i = 0L, num_rec-1 do begin
		    for j = 0L, the_order-1 do begin
			vdata_data(i).components0(j) = long_output_data(m)
			m = m + 1
		    endfor
		endfor

		long_output_data = vdata_data
		size_data = size(long_output_data)

		n_records = size_data(size_data(0))
		this_start = start_list(0)
		this_end = end_list(0) - 1
		this_increment = increment_list(0)

		info = redefine_info(info, long_fieldname, 3)
		widget_control, info.widgets.subset_list, set_value=info.name_list_subset
		num_output_data = n_elements(long_output_data.components0)

		;-------------------------------------------
		; Stuff the data into info.subset.data
		;-------------------------------------------
		info.subset.count=info.subset.count+1
		info.subset.data(info.subset.count-1).subset_name = string(long_fieldname)
		info.subset.data(info.subset.count-1).src_filename = filename
		info.subset.data(info.subset.count-1).src_unitname = 'Degrees'
		info.subset.data(info.subset.count-1).src_type_flag = 1
		info.subset.data(info.subset.count-1).src_crit_flag = 0
		info.subset.data(info.subset.count-1).src_crit_name = ''
		info.subset.data(info.subset.count-1).src_crit_min = ''
		info.subset.data(info.subset.count-1).src_crit_max = ''
		info.subset.data(info.subset.count-1).src_crit_type = ''
		info.subset.data(info.subset.count-1).src_num = num_output_data
		info.subset.data(info.subset.count-1).src_ref = vdata_ref
		info.subset.data(info.subset.count-1).src_rank = 2
		info.subset.data(info.subset.count-1).src_start(0) = this_start
		info.subset.data(info.subset.count-1).src_end(0) = this_end
		info.subset.data(info.subset.count-1).src_increment(0) = this_increment
		info.subset.data(info.subset.count-1).src_org_rank = 2
		info.subset.data(info.subset.count-1).src_org_start(0) = this_start
		info.subset.data(info.subset.count-1).src_org_end(0) = this_end
		info.subset.data(info.subset.count-1).src_org_increment(0) = this_increment
		info.subset.data(info.subset.count-1).src_org_start(1) = start_list(1)
		info.subset.data(info.subset.count-1).src_org_end(1) = end_list(1) - 1
		info.subset.data(info.subset.count-1).src_org_increment(1) = increment_list(1)
		info.subset.data(info.subset.count-1).src_start(1) = start_list(1) + 1
		info.subset.data(info.subset.count-1).src_end(1) = end_list(1)
		info.subset.data(info.subset.count-1).src_increment(1) = increment_list(1)
		info.subset.data(info.subset.count-1).src_fnames = long_fieldname
		info.subset.data(info.subset.count-1).src_order = the_order
		info.subset.data(info.subset.count-1).src_order(1) = long_order
		info.subset.data(info.subset.count-1).src_types = the_types

		if ptr_valid(info.subset.data(info.subset.count-1).src_data) then begin
		    *info.subset.data(info.subset.count-1).src_data = long_output_data
		endif else begin
		    info.subset.data(info.subset.count-1).src_data = ptr_new(long_output_data)
		endelse

		widget_control, info.widgets.vdata, set_list_select=-1
		widget_control, set_uvalue=info, info.base

		save_list = redefine_save_list(info)
		widget_control, set_uvalue=save_list, info.list_base
	    endif
	endif

	size_data = size(colat_output_data)
	if size_data(0) ne 0 then begin
	    colat_output_data = reform(colat_output_data, n_elements(colat_output_data))
	    num_data = n_elements(colat_output_data)
	    num_rec = long(num_data/colat_order+0.5)
	    colat_output_data = reform(colat_output_data, colat_order, num_rec)
	    rank = 2
	    start_list=lonarr(2)
	    end_list=lonarr(2)
	    increment_list=lonarr(2)

	    if org_output_data eq num_data and org_order eq colat_order then begin
		sub_flag = 0
		start_list = org_start_list
		end_list = org_end_list
		increment_list = org_increment_list
	    endif else begin
		sub_flag = 1
		start_list(0) = 0
		end_list(0) = num_rec
		increment_list(0) = 1
		start_list(1) = 0
		end_list(1) = colat_order
		increment_list(1) = 1
	    endelse
	    the_result = do_subset_data(sub_flag, colat_fieldname, rank, start_list, $
		end_list, increment_list, colat_output_data, info)

	    if the_result ne -1 then begin

		size_data = size(colat_output_data)
		num_rec = size_data(2)
		the_order = size_data(1)

		blank = array_type(colat_type, colat_order)
		single_record=create_struct( 'components' + '0', blank)
		vdata_data=replicate(single_record, num_rec)

		m = 0L
		for i = 0L, num_rec-1 do begin
		    for j = 0L, the_order-1 do begin
			vdata_data(i).components0(j) = colat_output_data(m)
			m = m + 1
		    endfor
		endfor

		colat_output_data = vdata_data
		size_data = size(colat_output_data)

		n_records = size_data(size_data(0))
		this_start = start_list(0)
		this_end = end_list(0) - 1
		this_increment = increment_list(0)

		info = redefine_info(info, colat_fieldname, 3)
		widget_control, info.widgets.subset_list, set_value=info.name_list_subset
		num_output_data = n_elements(colat_output_data.components0)

		;-------------------------------------------
		; Stuff the data into info.subset.data
		;-------------------------------------------
		info.subset.count=info.subset.count+1
		info.subset.data(info.subset.count-1).subset_name = string(colat_fieldname)
		info.subset.data(info.subset.count-1).src_filename = filename
		info.subset.data(info.subset.count-1).src_unitname = 'Degrees'
		info.subset.data(info.subset.count-1).src_type_flag = 1
		info.subset.data(info.subset.count-1).src_crit_flag = 0
		info.subset.data(info.subset.count-1).src_crit_name = ''
		info.subset.data(info.subset.count-1).src_crit_min = ''
		info.subset.data(info.subset.count-1).src_crit_max = ''
		info.subset.data(info.subset.count-1).src_crit_type = ''
		info.subset.data(info.subset.count-1).src_num = num_output_data
		info.subset.data(info.subset.count-1).src_ref = vdata_ref
		info.subset.data(info.subset.count-1).src_rank = 2
		info.subset.data(info.subset.count-1).src_start(0) = this_start
		info.subset.data(info.subset.count-1).src_end(0) = this_end
		info.subset.data(info.subset.count-1).src_increment(0) = this_increment
		info.subset.data(info.subset.count-1).src_org_rank = 2
		info.subset.data(info.subset.count-1).src_org_start(0) = this_start
		info.subset.data(info.subset.count-1).src_org_end(0) = this_end
		info.subset.data(info.subset.count-1).src_org_increment(0) = this_increment
		info.subset.data(info.subset.count-1).src_org_start(1) = start_list(1)
		info.subset.data(info.subset.count-1).src_org_end(1) = end_list(1) - 1
		info.subset.data(info.subset.count-1).src_org_increment(1) = increment_list(1)
		info.subset.data(info.subset.count-1).src_start(1) = start_list(1) + 1
		info.subset.data(info.subset.count-1).src_end(1) = end_list(1)
		info.subset.data(info.subset.count-1).src_increment(1) = increment_list(1)
		info.subset.data(info.subset.count-1).src_fnames = colat_fieldname
		info.subset.data(info.subset.count-1).src_order = the_order
		info.subset.data(info.subset.count-1).src_order(1) = colat_order
		info.subset.data(info.subset.count-1).src_types = the_types

		if ptr_valid(info.subset.data(info.subset.count-1).src_data) then begin
		    *info.subset.data(info.subset.count-1).src_data = colat_output_data
		endif else begin
		    info.subset.data(info.subset.count-1).src_data = ptr_new(colat_output_data)
		endelse

		widget_control, info.widgets.vdata, set_list_select=-1
		widget_control, set_uvalue=info, info.base

		save_list = redefine_save_list(info)
		widget_control, set_uvalue=save_list, info.list_base
	    endif
	endif
    endif
endif

;assign the time parameters if with_time = 1
if(with_time eq 1) then begin
    if (info.subset.count lt info.subset.maximum) then begin
	size_data = size(time_record)
	if size_data(0) ne 0 then begin
	    num_data = n_elements(time_record)
	    num_rec = long(num_data/time_order+0.5)
	    time_record = reform(time_record, time_order, num_rec)
	    rank = 2
	    start_list=lonarr(2)
	    end_list=lonarr(2)
	    increment_list=lonarr(2)

	    if org_output_data eq num_data and org_order eq time_order then begin
		sub_flag = 0
		start_list = org_start_list
		end_list = org_end_list
		increment_list = org_increment_list
	    endif else begin
		sub_flag = 1
		start_list(0) = 0
		end_list(0) = num_rec
		increment_list(0) = 1
		start_list(1) = 0
		end_list(1) = time_order
		increment_list(1) = 1
	    endelse
	    the_result = do_subset_data(sub_flag, time_fieldname, rank, start_list, $
		end_list, increment_list, time_record, info)

	    if the_result ne -1 then begin

		size_data = size(time_record)
		num_rec = size_data(2)
		the_order = size_data(1)

		blank = array_type(time_type, time_order)
		single_record=create_struct( 'components' + '0', blank)
		vdata_data=replicate(single_record, num_rec)

		m = 0L
		for i = 0L, num_rec-1 do begin
		    for j = 0L, the_order-1 do begin
			vdata_data(i).components0(j) = time_record(m)
			m = m + 1
		    endfor
		endfor

		time_record = vdata_data
		size_data = size(time_record)

		n_records = size_data(size_data(0))
		this_start = start_list(0)
		this_end = end_list(0) - 1
		this_increment = increment_list(0)

		info = redefine_info(info, time_fieldname, 3)
		widget_control, info.widgets.subset_list, set_value=info.name_list_subset
		num_output_data = n_elements(time_record.components0)

		;-------------------------------------------
		; Stuff the data into info.subset.data
		;-------------------------------------------
		info.subset.count=info.subset.count+1
		info.subset.data(info.subset.count-1).subset_name = string(time_fieldname)
		info.subset.data(info.subset.count-1).src_filename = filename
		info.subset.data(info.subset.count-1).src_unitname = 'Seconds'
		info.subset.data(info.subset.count-1).src_type_flag = 1
		info.subset.data(info.subset.count-1).src_crit_flag = 0
		info.subset.data(info.subset.count-1).src_crit_name = ''
		info.subset.data(info.subset.count-1).src_crit_min = ''
		info.subset.data(info.subset.count-1).src_crit_max = ''
		info.subset.data(info.subset.count-1).src_crit_type = ''
		info.subset.data(info.subset.count-1).src_num = num_output_data
		info.subset.data(info.subset.count-1).src_ref = vdata_ref
		info.subset.data(info.subset.count-1).src_rank = 2
		info.subset.data(info.subset.count-1).src_start(0) = this_start
		info.subset.data(info.subset.count-1).src_end(0) = this_end
		info.subset.data(info.subset.count-1).src_increment(0) = this_increment
		info.subset.data(info.subset.count-1).src_org_rank = 2
		info.subset.data(info.subset.count-1).src_org_start(0) = this_start
		info.subset.data(info.subset.count-1).src_org_end(0) = this_end
		info.subset.data(info.subset.count-1).src_org_increment(0) = this_increment
		info.subset.data(info.subset.count-1).src_org_start(1) = start_list(1)
		info.subset.data(info.subset.count-1).src_org_end(1) = end_list(1) - 1
		info.subset.data(info.subset.count-1).src_org_increment(1) = increment_list(1)
		info.subset.data(info.subset.count-1).src_start(1) = start_list(1) + 1
		info.subset.data(info.subset.count-1).src_end(1) = end_list(1)
		info.subset.data(info.subset.count-1).src_increment(1) = increment_list(1)
		info.subset.data(info.subset.count-1).src_fnames = time_fieldname
		info.subset.data(info.subset.count-1).src_order = the_order
		info.subset.data(info.subset.count-1).src_order(1) = time_order
		info.subset.data(info.subset.count-1).src_types = the_types

		if ptr_valid(info.subset.data(info.subset.count-1).src_data) then begin
		    *info.subset.data(info.subset.count-1).src_data = time_record
		endif else begin
		    info.subset.data(info.subset.count-1).src_data = ptr_new(time_record)
		endelse

		widget_control, info.widgets.vdata, set_list_select=-1
		widget_control, set_uvalue=info, info.base

		save_list = redefine_save_list(info)
		widget_control, set_uvalue=save_list, info.list_base
	    endif
	endif
    endif
endif

end

;--------------------------------------------------------------------------------
pro file_print, info, print_type, pro_check

pro_name = 'file_print'
@getinfo

if info.device eq 'X' then begin
   file_save_ps, 1, info, pro_check

   if print_type eq 0 then begin
	;the_list = extract_printcap(info)
	;printer_list = extract_printcap(info)

	command_line='lpstat -a | grep -v "not accepting" | '
	command_line = command_line+"grep accepting | sort -u | awk '{print $1}'"
	;print,command_line
	spawn, command_line, printer_list, /sh
	;print,'printer_list = ',printer_list
	;help,printer_list

	if n_elements(printer_list) eq 0 then begin
		result=dialog_message('Unable to get printer list', $
			title='View HDF Warning!')
		return
	endif

	;if printer_list(0) eq "BAD" then return
	;if the_list eq "BAD" then return

	;printer_list = str_sep(the_list, ',')
	;printer_list = str_sep(the_list, ' ')
	;print,'printer_list = ',printer_list

   endif else printer_list = [ 'phaser550', 'sai550', 'Other' ]

   select_printer, printer_list, info, print_type
endif else begin
   print_plot, info, pro_check
endelse

end

;--------------------------------------------------------------------------------
pro print_plot, info, pro_check

pro_name = 'print_plot'
@getinfo

TVLCT, R, G, B, /GET
result = dialog_printersetup()
if result ne 0 then begin
    if pro_check eq 1 then begin
	info.sview.p_old = !P
	info.sview.x_old = !X
	info.sview.y_old = !Y
	window_id_old = !d.window
   endif 

   old_foreground = !P.Color
   old_background = !P.BACKGROUND

   set_plot,"PRINTER", /copy
   device, /landscape, /index_color

   check_color = 0
   if info.style.colorindex eq 255 then begin
	check_color = 1
	info.style.colorindex = !P.Color
   endif

   charsize_old = info.char.size
   info.char.size = 1.2
   ;info.char.font = 5
   info.char.font = 1
   change_sym = 0
   check_sym = 0
   if info.graph_style eq 'Geolocated' then check_sym = 1
   if info.graph_style eq 'Browse Image' and info.browse_image.type eq 2 $
	then check_sym = 1
   if info.graph_style eq 'Browse Image With Average' and $
	info.browse_image.type eq 2 then check_sym = 1
   ;if info.graph_style eq 'Geolocated' then begin
   if check_sym eq 1 then begin
	if info.style.symbol eq 0 then begin
	    if !d.x_px_cm gt 80.0 then begin
		change_sym = 1
		old_symbol = info.style.symbol
		old_usersym = info.style.usersym
		old_symsize = info.style.symbolsize
		info.style.symbol = 8
		info.style.usersym = 5
		info.style.symbolsize = 0.1
		set_user_symbol, info.style.usersym
	    endif
	endif
   endif

   widget_control, set_uvalue=info, info.base
   if pro_check eq 0 then begin
     if info.multiple.key eq 1 then begin
	do_more_variables, 2, info
     endif else begin
	case info.graph_style of
	  'XY Plot': do_xy_plot, 1, info 
	  'XYZ Plot': do_xyz_plot, 1, info
	  'Scatter Contour Plot': do_scatter_contour, 1, info
	  'Y1Y2 Compute': do_y1y2_compute, 1, info 
	  'Curve Fit': do_curve_fit, 1, info.curvefit_type, info 
	  'Extract Bits': do_extract_bits, info.subset.selected, 1, info 
	  else: plot_graph, 1, info.subset.selected, info
	endcase
     endelse
   endif else begin
	widget_control, info.browse_image.xwidget, get_value=x_location
	widget_control, info.browse_image.pwidget, get_value=p_number
	draw_profile, x_location, p_number, 1, info
   endelse

   device,/close_document
   result=dialog_message('Print Job Submitted!', title='Notice!')

   if check_color eq 1 then info.style.colorindex = 255

   info.char.size = charsize_old
   info.char.font = -1
   if change_sym eq 1 then begin
	info.style.symbol = old_symbol
	info.style.usersym = old_usersym
	info.style.symbolsize = old_symsize
	set_user_symbol, info.style.usersym
   endif
   set_plot,info.device
   TVLCT, R, G, B
   if !P.BACKGROUND ne 0 then set_plot, info.device
   if pro_check eq 1 then begin
	!P = info.sview.p_old
	!X = info.sview.x_old
	!Y = info.sview.y_old
	wset, window_id_old
   endif 

   !P.Color = old_foreground
   !P.BACKGROUND = old_background

endif else return

end

;--------------------------------------------------------------------------------
PRO plot_graph, print_flag, this_subset, info

pro_name = 'plot_graph'
@getinfo

widget_control, /hourglass

font1=0

if info.graph_style eq 'Remove' then begin
 remove_some_subset, info, this_subset
 return
endif

if info.graph_style eq 'Change Name' then begin
 change_subset_name, info, this_subset
 return
endif

if info.graph_style eq 'Change Data Type' then begin
 change_data_type, this_subset, info
 return
endif

if info.graph_style eq 'Replace Data Value' then begin
 replace_data_value, this_subset, info
 return
endif

if info.graph_style eq 'Scale Data Value' then begin
 scale_data_value, this_subset, info
 return
endif

if info.graph_style eq 'Create Subset' then begin
 create_subset, info, this_subset
 return
endif

if info.graph_style eq 'Display Data' then begin
 display_value, info, this_subset
 return
endif

if info.graph_style eq 'Display Attribute' then begin
 filename=info.subset.data(this_subset).src_filename
 this_name=info.subset.data(this_subset).subset_name
 dot=strpos(this_name,'[')
 if( dot ne -1) then begin
   data_name=strmid(this_name,0,dot)
 endif else begin
   data_name = this_name
 endelse
 data_ref=info.subset.data(this_subset).src_ref
 if info.hdf5.exist eq 1 then check_hdf5 = H5F_IS_HDF5(filename) $
    else check_hdf5 = 0
 if check_hdf5 eq 0 then begin
    if info.subset.data(this_subset).src_type_flag eq 0 then begin
	get_data_attr, filename,data_name,data_ref,0,info 
    endif else begin
	get_data_attr, filename,data_name,data_ref,1,info
    endelse
 endif else begin
    if info.subset.data(this_subset).src_type_flag eq 0 then begin
	member_index = -1
    endif else begin
	member_index = info.subset.data(this_subset).src_findex(0)
    endelse
    get_data_attr, filename,data_name,member_index,2,info
 endelse
 return
endif

if info.graph_style eq 'Export Data' then begin
 file_export, info, 0
 return
endif

if info.graph_style eq 'Export Data Without Filldata' then begin
 file_export, info, 1
 return
endif

if info.graph_style eq 'Transpose' then begin
  name_of_data = info.subset.data(this_subset).subset_name
  do_transpose, info, name_of_data, this_subset
  return
endif

if info.graph_style eq 'Subsampling' then begin
  name_of_data = info.subset.data(this_subset).subset_name
  do_subsample, info, name_of_data, this_subset
  return
endif

if info.graph_style eq 'Array Average - 2D' then begin
  do_2d_array_average, info, this_subset
  return
endif

if info.graph_style eq 'Array Average' then begin
  name_of_data = info.subset.data(this_subset).subset_name
  do_array_average, info, name_of_data, this_subset
  return
endif

name_of_data = info.subset.data(this_subset).subset_name
	
;widget_control, /hourglass

plot_status = 1
CASE info.graph_style of

	'2D Graph': do_2d_graph, info, name_of_data, this_subset, print_flag, plot_status
	
	'2D Image': do_2d_image, info , name_of_data, this_subset, print_flag, 0, plot_status

	'2D Image With Scale': do_2d_image, info , name_of_data, this_subset, print_flag, 1, plot_status
	
	'3D Graph': do_3d_graph, info , name_of_data, this_subset, print_flag, plot_status

	'3D Surface': do_3d_graph, info, name_of_data, this_subset, print_flag, plot_status

	'Contour': do_3d_graph, info , name_of_data, this_subset, print_flag, plot_status

	'Grid Contour': do_grid_contour, info, name_of_data, this_subset, print_flag, 0, plot_status

	'Grid Contour - Region': do_grid_contour, info, name_of_data, this_subset, print_flag, 1, plot_status

	'Grid Cell': do_grid_contour, info, name_of_data, this_subset, print_flag, 2, plot_status

	'Grid Cell - Region': do_grid_contour, info, name_of_data, this_subset, print_flag, 3, plot_status

	'XY Graph': do_xy_graph, info, name_of_data, this_subset, print_flag, plot_status
 
	'XYZ Graph': do_xyz_graph, info, name_of_data, this_subset, print_flag, plot_status

	'3D Mesh Surface': plot_3d_surface, info, name_of_data, this_subset, print_flag, plot_status

	'3D Color Mesh Graph': plot_3d_color_mesh, info, name_of_data, this_subset, print_flag, plot_status

	'Browse Image': do_browse_image, print_flag, this_subset, 0, info, plot_status

	'Browse Image With Average': do_browse_image, print_flag, this_subset, 1, info, plot_status
 
	'Vertical Feature Mask': do_vertical_feature_mask, print_flag, this_subset, info, plot_status
 
	'Old Vertical Feature Mask': do_old_vertical_feature_mask, print_flag, this_subset, info, plot_status
 
	'XY Plot': do_xy_plot, 1, info, plot_status
 
	'XYZ Plot': do_xyz_plot, 1, info, plot_status

	'3D Mesh Plot': plot_3d_mesh, 1, info, plot_status

	'Scatter Contour Plot': do_scatter_contour, 1, info, plot_status
 
	'Y1Y2 Compute': do_y1y2_compute, 1, info, plot_status

	'Y1 Compute': do_y1_compute, 1, info, plot_status
 
	'Curve Fit': do_curve_fit, 1, info.curvefit.type, info, plot_status
 
	'Regression': do_regression, print_flag, this_subset, info, plot_status
 
	'Extract Bits': do_extract_bits, this_subset, print_flag, info, plot_status
 
	'Geolocated': do_geolocated, info, name_of_data, this_subset, print_flag, 0, plot_status
	
	'Contour Geolocated': do_geolocated, info, name_of_data, this_subset, print_flag, 1, plot_status
 
	'Statistics': do_statistics, info, name_of_data, this_subset, print_flag, 0, plot_status

	'Statistics For Whole Subset': do_statistics, info, name_of_data, this_subset, print_flag, 1, plot_status

	'Histogram': do_histogram, this_subset, print_flag, info, plot_status

	else: begin
		result=dialog_message('The graph type, '+info.graph_style+', is not valid!',$
			title='View HDF Warning!')
		return
	end

ENDCASE

	info.view.p_old = !P
	info.view.d_old = !D
	info.view.x_old = !X
	info.view.y_old = !Y
	if plot_status eq 1 then begin
	    if(widget_info(info.widgets.base, /VALID_ID)) then $
		widget_control, set_uvalue=info, info.widgets.base
	endif

if info.subset.data(this_subset).src_crit_flag eq 1 then $
	!P.Position = [ 0.0 , 0.0 , 0.0 , 0.0]

END

;--------------------------------------------------------------------------------
pro replot_screen, this_subset, info

pro_name = 'replot_screen'
@getinfo

font1=0

name_of_data = info.subset.data(this_subset).subset_name
	
widget_control, /hourglass

plot_status = 1
CASE info.graph_style of

	'2D Graph': do_2d_graph, info, name_of_data, this_subset, 0, plot_status
	
	'2D Image': do_2d_image, info , name_of_data, this_subset, 0, 0, plot_status

	'2D Image With Scale': do_2d_image, info , name_of_data, this_subset, 0, 1, plot_status
	
	'3D Graph': do_3d_graph, info , name_of_data, this_subset, 0, plot_status

	'3D Surface': do_3d_graph, info, name_of_data, this_subset, 0, plot_status

	'Contour': do_3d_graph, info , name_of_data, this_subset, 0, plot_status

	'Grid Contour': do_grid_contour, info, name_of_data, this_subset, 0, 0, plot_status

	'Grid Contour - Region': do_grid_contour, info, name_of_data, this_subset, 0, 1, plot_status

	'Grid Cell': do_grid_contour, info, name_of_data, this_subset, 0, 2, plot_status

	'Grid Cell - Region': do_grid_contour, info, name_of_data, this_subset, 0, 3, plot_status

	'XY Graph': do_xy_graph, info, name_of_data, this_subset, 3, plot_status
 
	'XYZ Graph': do_xyz_graph, info, name_of_data, this_subset, 3, plot_status

	'3D Mesh Surface': plot_3d_surface, info, name_of_data, this_subset, 3, plot_status

	'3D Color Mesh Graph': plot_3d_color_mesh, info, name_of_data, this_subset, 3, plot_status

	'Browse Image': do_browse_image, 3, this_subset, 0, info, plot_status

	'Browse Image With Average': do_browse_image, 3, this_subset, 1, info, plot_status
 
	'Vertical Feature Mask': do_vertical_feature_mask, 3, this_subset, info, plot_status
 
	'Old Vertical Feature Mask': do_old_vertical_feature_mask, 3, this_subset, info, plot_status
 
	'XY Plot': do_xy_plot, 3, info, plot_status
 
	'XYZ Plot': do_xyz_plot, 3, info, plot_status

	'3D Mesh Plot': plot_3d_mesh, 3, info, plot_status

	'Scatter Contour Plot': do_scatter_contour, 3, info, plot_status
 
	'Y1Y2 Compute': do_y1y2_compute, 3, info, plot_status

	'Y1 Compute': do_y1_compute, 3, info, plot_status
 
	'Curve Fit': do_curve_fit, 3, info.curvefit.type, info, plot_status
 
	'Regression': do_regression, 3, this_subset, info, plot_status
 
	'Extract Bits': do_extract_bits, this_subset, 3, info, plot_status
 
	'Geolocated': do_geolocated, info, name_of_data, this_subset, 3, 0, plot_status

	'Contour Geolocated': do_geolocated, info, name_of_data, this_subset, 3, 1, plot_status
 
	'Statistics': do_statistics, info, name_of_data, this_subset, 3, 0, plot_status

	'Statistics For Whole Subset': do_statistics, info, name_of_data, this_subset, 3, 1, plot_status

	'Histogram': do_histogram, this_subset, 3, info, plot_status

	else: begin
		result=dialog_message('The graph type, '+info.graph_style+', is not valid!',$
			title='View HDF Warning!')
		return
	end

ENDCASE

	info.view.p_old = !P
	info.view.d_old = !D
	info.view.x_old = !X
	info.view.y_old = !Y
	if plot_status eq 1 then begin
	    if(widget_info(info.widgets.base, /VALID_ID)) then $
		widget_control, set_uvalue=info, info.widgets.base
	endif

if info.subset.data(this_subset).src_crit_flag eq 1 then $
	!P.Position = [ 0.0 , 0.0 , 0.0 , 0.0]

END

;--------------------------------------------------------------------------------
pro do_more_variables, more_flag, info

pro_name = 'do_more_variables'
@getinfo

if more_flag eq 0 then begin
   if info.name_list_subset(0) eq "None" then begin
         result=dialog_message('No data read in Subset list yet!',$
                    title='View HDF Warning!')
         return
   end

   pick_export_variables, info

   widget_control, get_uvalue=info, info.base

   subscripts = where(info.out.pick eq 1, numout)

   print, 'number of variables picked = ', numout

   if (numout eq 0) then begin
     result=dialog_message('No data selected for "Multi Y Variables"!',$
	title='View HDF Warning!')
     info.multiple.y1y2 = 0
     return
   endif

   if info.multiple.y1y2 eq 1 then begin
	if numout ne 2 then begin
		result=dialog_message('You can only pick TWO variables for "Y1-Y2 Plot"!',$
                    title='View HDF Warning!')
		info.multiple.y1y2 = 0
     		return
	endif
   endif

   base=widget_base( GROUP_LEADER=info.base, /MODAL, COLUMN=1, MAP=1, $
	TITLE='Select a Graph Style', XSIZE=240, uvalue=info)

   group1=widget_base(base, column=1, map=1, xoffset=80)

   desc= [ '2D Graph' ,	$
   	   'XY Graph'	]

   info.graph_style = '2D Graph'
   info = initial_info(info)
   widget_control, set_uvalue=info, base
   widget_control, set_uvalue=info, info.base

   the_style = CW_BGROUP(group1, desc, /return_name, $
		set_value=0, FONT=info.font, $
		event_func='graph_item', /exclusive)

  group2=widget_base(base, row=1,map=1, space=40, /align_center)

  button1=widget_button(group2, FONT=info.font, EVENT_PRO='doneCB', VALUE="Done",$
	/ALIGN_CENTER)

  button2=widget_button(group2, FONT=info.font, EVENT_PRO='canceloptionCB', $
	VALUE="Cancel", /ALIGN_CENTER)

  ; button1=widget_button(base, FONT=info.font, $
;		EVENT_PRO='doneCB', VALUE="Done", $
;		/ALIGN_CENTER)

   widget_control, /realize, base 
   widget_control, DEFAULT_BUTTON=button1, CANCEL_BUTTON=button2, base
   xmanager, 'main_widget', base

endif else begin

   subscripts = where(info.out.pick eq 1, numout)

endelse

if more_flag eq 0 then begin
	widget_control, get_uvalue=info, info.base
	if info.canceloption eq 'Yes' then begin
		info.canceloption = 'No'
		widget_control, set_uvalue=info, info.base
		return
	endif 
endif
info.multiple.flag = more_flag
info.multiple.key = 1
info.multiple.number = 0
save_linetype = info.style.linetype
save_symbol = info.style.symbol
save_usersym = info.style.usersym
save_symbolline = info.style.symbolline
save_colorindex = info.style.colorindex
if info.style.symbol ne 8 then info.style.usersym = 0
;info.style.linetype = 0
;if info.style.symbol ne 0 then info.style.symbol = 1

save_axis_state = info.axis_state
if info.axis_state ne 2 and info.axis_state ne 4 and info.axis_state ne 5 and $
	info.axis_state ne 7 and info.axis_state ne 9 then begin
	temp_max = -999999.0
	;temp_min = 999999.0
	temp_min = 3.14E+35
	if info.multiple.y1y2 eq 0 then begin
	    for i=0, numout-1 do begin
		this_subset = subscripts(i)
		if info.subset.data(this_subset).src_type_flag eq 0 then begin
			hdf_data = *info.subset.data(this_subset).src_data
		endif else begin
			hdf_data_temp = *info.subset.data(this_subset).src_data
			hdf_data = reform(hdf_data_temp.components0, n_elements(hdf_data_temp.components0))
		endelse
		this_type = info.subset.data(this_subset).src_types
		this_type = this_type(0)
		filldata_value = get_filldata_value(this_type, info.filldata)
		if filldata_value gt info.filldata then filldata_value = info.filldata
		if filldata_value gt 0 then test_subs = where(hdf_data lt filldata_value, count) $
		    else test_subs = where(hdf_data gt filldata_value, count)
		if count ne 0 then begin
			hdf_data = hdf_data(test_subs)
			max_hdf = max(hdf_data, min=min_hdf)
			if (max_hdf gt temp_max) then temp_max = max_hdf
			if (min_hdf lt temp_min) then temp_min = min_hdf
		endif
	    endfor
	endif else begin
		this_subset = subscripts(0)
                if info.subset.data(this_subset).src_type_flag eq 0 then begin
                        hdf_data = *info.subset.data(this_subset).src_data
                endif else begin
                        hdf_data_temp = *info.subset.data(this_subset).src_data
                        hdf_data = reform(hdf_data_temp.components0, n_elements(hdf_data_temp.components0))
                endelse
                this_type = info.subset.data(this_subset).src_types
                this_type = this_type(0)
		filldata_value = get_filldata_value(this_type, info.filldata)
		if filldata_value gt info.filldata then filldata_value = info.filldata
                if filldata_value gt 0 then test_subs = where(hdf_data lt filldata_value, count) $
		    else test_subs = where(hdf_data gt filldata_value, count)
                if count ne 0 then begin
                        hdf_data = hdf_data(test_subs)
                        max_hdf = max(hdf_data, min=min_hdf)
                        if (max_hdf gt temp_max) then temp_max = max_hdf
                        if (min_hdf lt temp_min) then temp_min = min_hdf
                endif
	endelse

	case save_axis_state of
		1: info.axis_state = 4 
		6: info.axis_state = 7
		8: info.axis_state = 9
		else: info.axis_state = 2
	endcase

	temp_max = temp_max + (temp_max - temp_min)*(numout+1)*.05
	info.range.y_start = temp_min
	info.range.y_end = temp_max
	info.range.real_y_end = info.range.y_end
endif else begin
	save_y_end = info.range.y_end
	info.range.real_y_end = info.range.y_end
	temp_max = info.range.y_end
	temp_min = info.range.y_start
        temp_max = temp_max + (temp_max - temp_min)*(numout+1)*.05
        info.range.y_end = temp_max
endelse

if (info.graph_style eq '2D Graph') and (info.axis_state ne 1 and $
	info.axis_state ne 4 and info.axis_state ne 5 and info.axis_state ne 8 $
	and info.axis_state ne 9) then begin
	temp_max = -999999.0
	for i=0, numout-1 do begin
		this_subset = subscripts(i)
		if info.subset.data(this_subset).src_type_flag eq 0 then begin
			hdf_data = *info.subset.data(this_subset).src_data
		endif else begin
			hdf_data_temp = *info.subset.data(this_subset).src_data
			hdf_data = reform(hdf_data_temp.components0, n_elements(hdf_data_temp.components0))
		endelse
		max_num_hdf = n_elements(hdf_data)
		if (max_num_hdf gt temp_max) then temp_max = max_num_hdf
	endfor
	if save_axis_state eq 2 or info.axis_state eq 2 then begin
		info.axis_state = 4 
	endif else if save_axis_state eq 7 or info.axis_state eq 7 then begin
		info.axis_state = 9
	endif else info.axis_state = 1
	info.range.x_start = 0
	info.range.x_end = temp_max
endif

;if (info.graph_style eq 'XY Graph') and (info.axis_state ne 1 and $
;	info.axis_state ne 4 and info.axis_state ne 5 and info.axis_state ne 8 $
;	and info.axis_state ne 9) then begin
if (info.graph_style eq 'XY Graph') then begin
    if (more_flag lt 1) or (more_flag gt 3)  then begin    
	plot_setup, info, 'XY Graph', 1, 0, 0
	widget_control, get_uvalue=info, info.base
	if info.canceloption eq 'Yes' then begin
	    info.canceloption = 'No'
	    widget_control, set_uvalue=info, info.base
	    return
	endif
    endif
    if(info.axis_state ne 1 and info.axis_state ne 4 and info.axis_state ne 5 and $
	info.axis_state ne 8 and info.axis_state ne 9) then begin
	temp_max = -999999.0
	temp_min = 3.14E+37
	for i=0, numout-1 do begin
		this_subset = subscripts(i)
		if i eq 0 then print_flag = more_flag else print_flag = 1
		if info.subset.data(this_subset).src_type_flag eq 0 then begin
		    this_rank = info.subset.data(this_subset).src_rank
		    start_list = lonarr(this_rank)
		    end_list = lonarr(this_rank)
		    increment_list = lonarr(this_rank)
		    array_size = lonarr(this_rank)
		    start_list = info.subset.data(this_subset).src_start(0:this_rank-1)
		    end_list = info.subset.data(this_subset).src_end(0:this_rank-1)
		    increment_list = info.subset.data(this_subset).src_increment(0:this_rank-1)
		    array_size = long((end_list-start_list-1)/float(increment_list) + 1.0)
		    hdf_data_x = array_type(6, array_size)
		    if (hdf_data_x(0) eq -1) then begin
			result=dialog_message('Unable to allocate memory for X field data!',$
			    title='View HDF Warning!')
			return
		    endif
		endif else begin
		    hdf_y_temp = *info.subset.data(this_subset).src_data
		    hdf_data_y = reform(hdf_y_temp.components0, n_elements(hdf_y_temp.components0))
		    hdf_data_x = make_array(n_elements(hdf_data_y), /DOUBLE)
		endelse
		get_x_data, info, this_subset, print_flag, hdf_data_x
		if info.canceloption eq 'Yes' then begin
		    info.canceloption = 'No'
		    widget_control, set_uvalue=info, info.base
		    return
		endif
		temp_error_data = get_error_data(hdf_data_x)
		if temp_error_data lt -9999999.0 then return
		if info.field_name.x eq 'Time' then $
		    subscript = where(hdf_data_x lt 86400.0, count) $
		else begin
		    if info.filldata gt 0 then begin
			subscript = where(hdf_data_x lt info.filldata, count)
		    endif else begin
			subscript = where(hdf_data_x gt info.filldata, count)
		    endelse
		endelse
		if(count ne 0) then begin
		    hdf_data_x = hdf_data_x(subscript)
		    if info.field_name.x eq 'Time' then begin
			case info.time_type.new of
			    0: hdf_data_x(*) = hdf_data_x(*)/3600.0
			    1: hdf_data_x(*) = hdf_data_x(*)/60.0
			    else: 
			endcase
		    endif
		    max_value = max(hdf_data_x, min=min_value)
		    if (max_value gt temp_max) then temp_max = max_value
		    if (min_value lt temp_min) then temp_min = min_value
		endif
	endfor
	if more_flag eq 0 then info.multiple.flag = 3
	if save_axis_state eq 2 or info.axis_state eq 2 then begin
		info.axis_state = 4 
	endif else if save_axis_state eq 7 or info.axis_state eq 7 then begin
		info.axis_state = 9
	endif else info.axis_state = 1
	info.range.x_start = temp_min
	info.range.x_end = temp_max
    endif
endif

start_linetype = save_linetype
start_symbol = save_symbol
if start_symbol gt 7 then start_symbol = save_symbol + save_usersym - 1
for i=0, numout-1 do begin
	;widget_control, set_uvalue=info, info.base
	print_flag = info.multiple.flag
	this_selected = subscripts(i)
	if info.multiple.styleflag eq 0 then begin
	    info.multiple.linearray(i) = (start_linetype + i) mod 6
	    ;if info.multiple.linearray(i) gt 5 then begin
	;	info.multiple.linearray(i) = 0
	;	start_linetype = 0
	;    endif
	    if start_symbol ne 0 then begin
		symbol_type = start_symbol + i
		if symbol_type gt 13 then symbol_type = symbol_type + 1
		;info.multiple.symarray(i) = start_symbol + i
		info.multiple.symarray(i) = symbol_type mod 14
		;if info.multiple.symarray(i) gt 13 then begin
		;    info.multiple.symarray(i) = 1
		;    start_symbol = 1
		;endif
	    endif else info.multiple.symarray(i) = 0
	    info.multiple.symlinearray(i) = info.style.symbolline
	    info.multiple.colorarray(i) = !P.COLOR
	endif else begin
	    if info.multiple.resetflag eq 1 then begin
		old_window_id = !d.window
		num = i
		temp_name = info.name_list_subset(this_selected)
		temp_name = temp_name(0)
		style_value = more_style_set(info, num, temp_name)
		if style_value(0) lt -999 then begin
		    wset, old_window_id
		    return
		endif
		info.multiple.linearray(i) = style_value(0)
		info.multiple.symarray(i) = style_value(1)
		info.multiple.symlinearray(i) = style_value(2)
		info.multiple.colorarray(i) = style_value(3)
		wset, old_window_id
	    endif
	    start_symbol = info.multiple.symarray(i)
	endelse
	info.style.linetype = info.multiple.linearray(i)
	if start_symbol ne 0 then begin
	    if info.multiple.symarray(i) gt 7 then begin
		usersym = info.multiple.symarray(i) - 7
		info.style.symbol = 8
		info.style.usersym = usersym
		set_user_symbol, info.style.usersym
	    endif else begin
		info.style.symbol = info.multiple.symarray(i)
		info.style.usersym = 0
	    endelse
	endif else info.style.symbol = 0
	info.style.symbolline = info.multiple.symlinearray(i)
	info.style.colorindex = info.multiple.colorarray(i)
	widget_control, set_uvalue=info, info.base
	plot_graph, print_flag, this_selected, info
	if info.canceloption eq 'Yes' then begin
		info.canceloption = 'NO'
		widget_control, set_uvalue=info, info.base
		return
	endif
	info.multiple.flag = 1
	info.multiple.number=info.multiple.number + 1
	;info.style.linetype = info.style.linetype + 1
	;if info.style.linetype gt 5 then info.style.linetype = 0
	;if info.style.symbol ne 0 then begin
	;	if info.style.symbol lt 8 then $
	;		info.style.symbol = info.style.symbol + 1
	;	;if info.style.symbol gt 7 then info.style.symbol = 1
	;	if info.style.symbol eq 8 then begin
	;		info.style.usersym = info.style.usersym + 1
	;		if info.style.usersym gt 6 then begin
	;			info.style.symbol = 1
	;			info.style.usersym = 0
	;		endif else set_user_symbol, info.style.usersym
	;	endif
	;endif
endfor
info.multiple.resetflag = 0

if save_axis_state eq 2 or save_axis_state eq 4 or save_axis_state eq 5 or $
	save_axis_state eq 7 or save_axis_state eq 9 then begin
	info.range.y_end = save_y_end
endif
info.axis_state = save_axis_state
info.style.linetype = save_linetype
info.style.symbol = save_symbol
info.style.usersym = save_usersym
if info.style.symbol eq 8 then begin
	if info.style.usersym eq 0 then info.style.usersym = 4
	set_user_symbol, info.style.usersym
endif
info.style.symbolline = save_symbolline
info.style.colorindex = save_colorindex
info.subset.selected = subscripts(0)

widget_control, set_uvalue=info, info.base
if(widget_info(info.widgets.base, /VALID_ID)) then $
        widget_control, set_uvalue=info, info.widgets.base

end

;--------------------------------------------------------------------------------
pro do_more_x_variables, more_flag, info

pro_name = 'do_more_x_variables'
@getinfo

if more_flag eq 0 then begin
   if info.name_list_subset(0) eq "None" then begin
         result=dialog_message('No data read in Subset list yet!',$
                    title='View HDF Warning!')
         return
   end

   pick_export_variables, info

   widget_control, get_uvalue=info, info.base

   subscripts = where(info.out.pick eq 1, numout)

   print, 'number of variables picked = ', numout

   if (numout eq 0) then begin
     result=dialog_message('No data selected for "Multi X Variables"!',$
                    title='View HDF Warning!')
     return
   endif

  info.graph_style = 'XY Plot'
  plot_setup, info, 'XY Plot', 0, 1, 0
  widget_control, get_uvalue=info, info.base
  if info.canceloption eq 'Yes' then begin
        info.canceloption = 'No'
        widget_control, set_uvalue=info, info.base
        return
  endif

endif else begin

   subscripts = where(info.out.pick eq 1, numout)

endelse

info.multiple.flag = more_flag
info.multiple.key = 2
info.multiple.number = 0
save_linetype = info.style.linetype
save_symbol = info.style.symbol
save_usersym = info.style.usersym
save_symbolline = info.style.symbolline
save_colorindex = info.style.colorindex
if info.style.symbol ne 8 then info.style.usersym = 0

info.field_name.x = info.name_list_subset(subscripts(0))
get_data, y_index, x_index, z_index, info
save_axis_state = info.axis_state
if info.axis_state ne 2 and info.axis_state ne 4 and info.axis_state ne 5 and $
	info.axis_state ne 7 and info.axis_state ne 9 then begin
	this_subset = y_index
	if info.subset.data(this_subset).src_type_flag eq 0 then begin
		hdf_data = *info.subset.data(this_subset).src_data
	endif else begin
		hdf_data_temp = *info.subset.data(this_subset).src_data
		hdf_data = reform(hdf_data_temp.components0, n_elements(hdf_data_temp.components0))
	endelse
	this_type = info.subset.data(this_subset).src_types
	this_type = this_type(0)
	filldata_value = get_filldata_value(this_type, info.filldata)
	if filldata_value gt info.filldata then filldata_value = info.filldata
	if filldata_value gt 0 then test_subs = where(hdf_data lt filldata_value, count) $
	    else test_subs = where(hdf_data gt filldata_value, count)
	if count ne 0 then begin
		hdf_data = hdf_data(test_subs)
		temp_max = max(hdf_data, min=temp_min)
	endif

	case save_axis_state of
		1: info.axis_state = 4 
		6: info.axis_state = 7
		8: info.axis_state = 9
		else: info.axis_state = 2
	endcase

	temp_max = temp_max + (temp_max - temp_min)*(numout+1)*.05
	info.range.y_start = temp_min
	info.range.y_end = temp_max
	info.range.real_y_end = info.range.y_end
endif else begin
	save_y_end = info.range.y_end
	info.range.real_y_end = info.range.y_end
	temp_max = info.range.y_end
	temp_min = info.range.y_start
        temp_max = temp_max + (temp_max - temp_min)*(numout+1)*.05
        info.range.y_end = temp_max
endelse

if info.axis_state ne 1 and info.axis_state ne 4 and info.axis_state ne 5 and $
    info.axis_state ne 8 and info.axis_state ne 9 then begin
	temp_min = 999999.0
	temp_max = -999999.0
	for i=0, numout-1 do begin
		this_subset = subscripts(i)
		if info.subset.data(this_subset).src_type_flag eq 0 then begin
			hdf_data = *info.subset.data(this_subset).src_data
		endif else begin
			hdf_data_temp = *info.subset.data(this_subset).src_data
			hdf_data = reform(hdf_data_temp.components0, n_elements(hdf_data_temp.components0))
		endelse
		this_type = info.subset.data(this_subset).src_types
		this_type = this_type(0)
		filldata_value = get_filldata_value(this_type, info.filldata)
		if filldata_value gt info.filldata then filldata_value = info.filldata
		if filldata_value gt 0 then test_subs = where(hdf_data lt filldata_value, count) $
		    else test_subs = where(hdf_data gt filldata_value, count)
		if count ne 0 then begin
			hdf_data = hdf_data(test_subs)
			max_hdf = max(hdf_data, min=min_hdf)
			if (max_hdf gt temp_max) then temp_max = max_hdf
			if (min_hdf lt temp_min) then temp_min = min_hdf
		endif
	endfor
	if save_axis_state eq 2 or info.axis_state eq 2 then begin
		info.axis_state = 4 
	endif else if save_axis_state eq 7 or info.axis_state eq 7 then begin
		info.axis_state = 9
	endif else info.axis_state = 1
	info.range.x_start = temp_min
	info.range.x_end = temp_max
endif

start_linetype = save_linetype
start_symbol = save_symbol
if start_symbol gt 7 then start_symbol = save_symbol + save_usersym - 1
for i=0, numout-1 do begin
	plot_status = 1
	print_flag = info.multiple.flag
	info.field_name.x = info.name_list_subset(subscripts(i))
	;widget_control, set_uvalue=info, info.base
	this_selected = subscripts(i)
	if info.multiple.styleflag eq 0 then begin
	    info.multiple.linearray(i) = (start_linetype + i) mod 6
	    ;if info.multiple.linearray(i) gt 5 then begin
	;	info.multiple.linearray(i) = 0
	;	start_linetype = 0
	;    endif
	    if start_symbol ne 0 then begin
		symbol_type = start_symbol + i
                if symbol_type gt 13 then symbol_type = symbol_type + 1
		info.multiple.symarray(i) = symbol_type mod 14
		;info.multiple.symarray(i) = start_symbol + i
		;if info.multiple.symarray(i) gt 13 then begin
		;    info.multiple.symarray(i) = 1
		;    start_symbol = 1
		;endif
	    endif else info.multiple.symarray(i) = 0
	    info.multiple.symlinearray(i) = info.style.symbolline
	    info.multiple.colorarray(i) = !P.COLOR
	endif else begin
	    if info.multiple.resetflag eq 1 then begin
		old_window_id = !d.window
		num = i
		temp_name = info.name_list_subset(this_selected)
		temp_name = temp_name(0)
		style_value = more_style_set(info, num, temp_name)
		if style_value(0) lt -999 then begin
		    wset, old_window_id
		    return
		endif
		info.multiple.linearray(i) = style_value(0)
		info.multiple.symarray(i) = style_value(1)
		info.multiple.symlinearray(i) = style_value(2)
		info.multiple.colorarray(i) = style_value(3)
		wset, old_window_id
	    endif
	    start_symbol = info.multiple.symarray(i)
	endelse
	info.style.linetype = info.multiple.linearray(i)
	if start_symbol ne 0 then begin
	    if info.multiple.symarray(i) gt 7 then begin
		usersym = info.multiple.symarray(i) - 7
		info.style.symbol = 8
		info.style.usersym = usersym
		set_user_symbol, info.style.usersym
	    endif else begin
		info.style.symbol = info.multiple.symarray(i)
		info.style.usersym = 0
	    endelse
	endif else info.style.symbol = 0
	info.style.symbolline = info.multiple.symlinearray(i)
	info.style.colorindex = info.multiple.colorarray(i)
	widget_control, set_uvalue=info, info.base
	do_xy_plot,print_flag,info, plot_status
	if info.canceloption eq 'Yes' then begin
		info.canceloption = 'NO'
		widget_control, set_uvalue=info, info.base
		return
	endif
	info.multiple.flag = 1
	info.multiple.number=info.multiple.number + 1
	;info.style.linetype = info.style.linetype + 1
	;if info.style.linetype gt 5 then info.style.linetype = 0
	;if info.style.symbol ne 0 then begin
	;	if info.style.symbol lt 8 then $
	;		info.style.symbol = info.style.symbol + 1
	;	;if info.style.symbol gt 7 then info.style.symbol = 1
	;	if info.style.symbol eq 8 then begin
	;		info.style.usersym = info.style.usersym + 1
	;		if info.style.usersym gt 6 then begin
	;			info.style.symbol = 1
	;			info.style.usersym = 0
	;		endif else set_user_symbol, info.style.usersym
	;	endif
	;endif
endfor
info.multiple.resetflag = 0

if save_axis_state eq 2 or save_axis_state eq 4 or save_axis_state eq 5 or $
	save_axis_state eq 7 or save_axis_state eq 9 then begin
	info.range.y_end = save_y_end
endif
info.axis_state = save_axis_state
info.style.linetype = save_linetype
info.style.symbol = save_symbol
info.style.usersym = save_usersym
if info.style.symbol eq 8 then begin
	if info.style.usersym eq 0 then info.style.usersym = 4
	set_user_symbol, info.style.usersym
endif
info.style.symbolline = save_symbolline
info.style.colorindex = save_colorindex
info.subset.selected = subscripts(0)

widget_control, set_uvalue=info, info.base
if(widget_info(info.widgets.base, /VALID_ID)) then $
	widget_control, set_uvalue=info, info.widgets.base

end

;--------------------------------------------------------------------------------
pro do_extract_bits, this_subset, print_flag, info, plot_status

pro_name = 'do_extract_bits'
@getinfo

if info.subset.count lt 1 then begin
	the_message = ['You need at least one subset of data', $
	    'to do Extract Bits!']
	result=dialog_message(the_message, title='View HDF Warning!')
	plot_status = 0
	return
endif

if print_flag eq 0 then begin
  info.graph_style = 'Extract Bits'
  widget_control, set_uvalue=info, info.base
  get_bits, this_subset, info
  widget_control, get_uvalue=info, info.base
  if info.canceloption eq 'Yes' then begin
	info.canceloption = 'No'
	widget_control, set_uvalue=info, info.base
	plot_status = 0
	return
  endif 

endif

widget_control, /hourglass

widget_control, get_uvalue=info, info.base
this_subset = info.bit.index
info.subset.selected = this_subset
data_name = info.subset.data(this_subset).subset_name
data_name = data_name(0)
if info.subset.data(this_subset).src_type_flag eq 0 then begin
        hdf_data_x = *info.subset.data(this_subset).src_data
	size_hdf_data = size(hdf_data_x)
	hdf_data_x = reform(hdf_data_x,n_elements(hdf_data_x))
endif else begin
        hdf_data_temp = *info.subset.data(this_subset).src_data
	size_hdf_data = size(hdf_data_temp)
        hdf_data_x = reform(hdf_data_temp.components0, n_elements(hdf_data_temp.components0))
endelse

num_data = n_elements(hdf_data_x)
num_size_data = n_elements(size_hdf_data)

data_type = info.subset.data(this_subset).src_types(0)
if(data_type eq 25 and size_hdf_data(num_size_data-2) eq 5) then $
	hdf_data_x = long(hdf_data_x)
if data_type lt 19 then begin
	the_message = ['The data type of '+data_name+' is not integer.', $
		 'Do you want to change it to integer?', $
                'Press Cancel to cancel this action.']
        result=dialog_message(the_message, /Question, /Cancel, title='View HDF Question!')

        if result eq 'Yes' then begin
		hdf_data_temp = long(hdf_data_x)
		hdf_data_x = hdf_data_temp
	endif else if result eq 'Cancel' then begin
		plot_status = 0
		return
	endif else begin
		result = dialog_message('The data type must be integer type!', $
		  title='View HDF Warning!')
		plot_status = 0
		return
	endelse
endif

filldata_value = get_filldata_value(data_type, info.filldata)
if filldata_value gt info.filldata then filldata_value = info.filldata
max_value = get_max_value(data_type, info.filldata)
if info.filldata gt 0 then begin
    if max_value gt info.filldata then max_value = info.filldata
endif

filldata = get_filldata_value(24, info.filldata)

if filldata_value gt 0 then begin
    subscript = where(hdf_data_x lt filldata_value, count)
endif else begin
    subscript = where(hdf_data_x gt filldata_value, count)
endelse
if (count eq 0) then begin
	result=dialog_message('All data are fill data!',$
	    title='View HDF Warning!')
	plot_status = 0
	return
endif

start_bit = info.bit.start_bit
num_bit = info.bit.num_bit
end_bit = start_bit + num_bit - 1

hdf_data_z = get_bit_values(num_data,start_bit,num_bit,hdf_data_x,info.version)

hdf_data_temp = hdf_data_z(subscript)
z_max = max(hdf_data_temp,min=z_min)

if filldata_value gt 0 then begin
    subscript = where(hdf_data_x ge filldata_value, count)
endif else begin
    subscript = where(hdf_data_x le filldata_value, count)
endelse
if count ne 0 then hdf_data_z(subscript) = filldata

filename = info.subset.data(this_subset).src_filename

if (print_flag eq 0) then begin
	dot=strpos(data_name,'[')
	if dot ne -1 then dataname=strmid(data_name,0,dot) $
		else dataname = data_name
	temp_name = 'Bits '+strcompress(string(start_bit),/REMOVE_ALL)+':'+ $
		strcompress(string(end_bit),/REMOVE_ALL)+' of '+dataname
	get_variable_name, temp_name, info
	widget_control, get_uvalue=info, info.base
	if info.variablename eq 'None' then begin
	    plot_status = 0
	    return
	endif
	the_rank = info.subset.data(this_subset).src_rank
	if info.subset.data(this_subset).src_type_flag eq 0 then begin
	   case size_hdf_data(0) of
		2: hdf_data = reform(hdf_data_z, size_hdf_data(1), size_hdf_data(2))
		3: hdf_data = reform(hdf_data_z, size_hdf_data(1), size_hdf_data(2), $
						 size_hdf_data(3))
		else: hdf_data = hdf_data_z
	   endcase
	endif else begin
  		the_order = info.subset.data(this_subset).src_order(0)
		blank = array_type(24, the_order)
		single_record=create_struct( 'components' + '0', blank) 
		hdf_data=replicate(single_record, size_hdf_data(1))
		jj=0L
		for i=0L, size_hdf_data(1)-1 do begin
			for j=0L, the_order-1 do begin
				hdf_data(i).components0(j) = hdf_data_z(jj)
				jj = jj + 1
			endfor
		endfor
	endelse
	set_statistics_subset, info.variablename, this_subset, the_rank, info, hdf_data

	if info.y1y2.out_flag eq 1 then begin
	    the_message = [ 'Do you want to plot the result?']
	    result=dialog_message(the_message, /Question, title='View HDF Question!')

	    if result eq 'No' then begin
		plot_status = 0
		return
	    endif
	endif else begin
	    plot_status = 0
	    return
	endelse

	base=widget_base( GROUP_LEADER=info.base, /MODAL, COLUMN=1, MAP=1, $
		TITLE='Select a Graph Style', XSIZE=240, uvalue=info)

	group1=widget_base(base, column=1, map=1, xoffset=80)

	desc= [ 'Sample' ,	$
		'Time'	]

	info.multiple.xy_diff = 'Sample'
	info = initial_info(info)
	widget_control, set_uvalue=info, base
	widget_control, set_uvalue=info, info.base

	the_style = CW_BGROUP(group1, desc, /return_name, $
		set_value=0, FONT=info.font, $
		event_func='diff_graph', /exclusive)

	group2=widget_base(base, row=1,map=1, space=40, /align_center)

	button1=widget_button(group2, FONT=info.font, EVENT_PRO='doneCB', VALUE="Done",$
		/ALIGN_CENTER)

	button2=widget_button(group2, FONT=info.font, EVENT_PRO='canceloptionCB', $
		VALUE="Cancel", /ALIGN_CENTER)

	;button1=widget_button(base, FONT=info.font, $
	;	EVENT_PRO='doneCB', VALUE="Done", $
	;	/ALIGN_CENTER)

	widget_control, /realize, base 
	widget_control, DEFAULT_BUTTON=button1, CANCEL_BUTTON=button2, base
	xmanager, 'main_widget', base

endif

widget_control, /hourglass
widget_control, get_uvalue=info, info.base
if info.canceloption eq 'Yes' then begin
	info.canceloption = 'No'
	widget_control, set_uvalue=info, info.base
	plot_status = 0
	return
endif 

set_axis_ranges, info, YRange, Ystyle, XRange, Xstyle, ZRange, Zstyle

data_range = ''
data_range = get_data_range(this_subset,info)
if !D.Name eq 'PS' or !D.Name eq 'PRINTER' or !D.Name eq 'WIN' or info.char.font eq 0 then begin
	the_title=info.variablename + '!C Data Range: ' + data_range
endif else begin
	the_title=info.variablename + '!C!C Data Range: ' + data_range
endelse

if info.subset.data(this_subset).src_crit_flag eq 1 then begin
	crit_string = ''
	crit_string = get_crit_string(this_subset, info)
	if !D.Name eq 'PS' and info.eps_out.type eq 1 then $
		!P.Position = [0.235, 0.15, 0.99, 0.92] $
		else !P.Position = [0.060, 0.120, 0.98, 0.93]
	temp_name = str_sep(crit_string, '!C')
	num_temp = n_elements(temp_name)
	!P.Position(1) = !P.Position(1) + (num_temp-1)*0.025
endif else begin
	if !D.Name eq 'PS' and info.eps_out.type eq 1 then $
		!P.Position = [0.235, 0.15, 0.99, 0.92] $
		else !P.Position = [0.060, 0.100, 0.98, 0.93]
endelse 

if info.style.symbolline eq 1 then plot_symbol = - info.style.symbol $
	else plot_symbol = info.style.symbol

ytitle = info.variablename
temp_name = info.subset.data(this_subset).src_unitname
temp_name = temp_name(0)
dot=strpos(temp_name,'N/A')
if( dot eq -1) then ytitle = ytitle + temp_name

get_ticklen, info.style.grid, xticklen, yticklen 

info.slide.x_end = num_data-1
info.slide.x_start = 0
info.slide.y_end = z_max
info.slide.y_start = z_min

if info.axis_state eq 2 or info.axis_state eq 4 then min_value = YRange(0) $
    else min_value = z_min

if info.multiple.xy_diff eq 'Time' then begin
	if info.subset.data(this_subset).src_type_flag eq 0 then begin
  		this_rank = info.subset.data(this_subset).src_rank
  		start_list = info.subset.data(this_subset).src_start(0:this_rank-1)
  		end_list = info.subset.data(this_subset).src_end(0:this_rank-1)
  		increment_list = info.subset.data(this_subset).src_increment(0:this_rank-1)

  		;array_size = long((end_list-start_list)/float(increment_list) + 0.9)
		array_size = long((end_list-start_list-1)/float(increment_list) + 1.0)

  		hdf_data_time = array_type(6, array_size)
  		if (hdf_data_x(0) eq -1) then begin
			result=dialog_message('Unable to allocate memory for Time!',$
				title='View HDF Warning!')
			plot_status = 0
			return
		endif
	endif else begin
		hdf_data_time = make_array(num_data, /DOUBLE)
	endelse

	get_seconds, info, this_subset, hdf_data_time
	subscript = where(hdf_data_time lt 86400.0, count)
	if(count ne 0) then begin
   		hdf_data_time = hdf_data_time(subscript)
		hdf_data_z = hdf_data_z(subscript)
	endif else begin
		result=dialog_message('All the Time field data are fill data!',$
			title='View HDF Warning!')
		plot_status = 0
		return
	endelse
	time_max = max(hdf_data_time, min=time_min)
	info.slide.x_end = time_max
	info.slide.x_start = time_min
	case info.time_type.new of
		0: begin
			hdf_data_time(*) = hdf_data_time(*)/3600.0
			info.slide.x_end = time_max/3600.0
			info.slide.x_start = time_min/3600.0
			xtitle = 'Time of day, hours'
		   end
		1: begin
			hdf_data_time(*) = hdf_data_time(*)/60.0
			info.slide.x_end = time_max/60.0
			info.slide.x_start = time_min/60.0
			xtitle = 'Time of day, minutes'
		   end
		else: xtitle = 'Time of day, seconds'
	endcase

	if(widget_info(info.widgets.startfield, /VALID_ID)) then begin
	  if info.time_type.old ne info.time_type.new then begin
	    widget_control, info.widgets.startfield, get_value=x_start
	    widget_control, info.widgets.rangefield, get_value=x_range
	    case info.time_type.old of
	       0: begin
		   x_start = x_start * 3600.0
		   x_range = x_range * 3600.0
		end
	       1: begin
		   x_start = x_start * 60.0
		   x_range = x_range * 60.0
		end
	       else:
	    endcase

	    case info.time_type.new of
	       0: begin
	  	   x_start = x_start / 3600.0
		   x_range = x_range / 3600.0
		   if x_range le 1 then x_range = 1
		end
	       1: begin
		   x_start = x_start / 60.0
		   x_range = x_range / 60.0
		   if x_range le 1 then x_range = 1
		end
	       else:
	    endcase
	    x_max = max(hdf_data_time, min=x_min)
	    x_int_max = long(x_max)
	    x_int_min = long(x_min)
	    if x_int_max eq x_int_min then x_max = x_min + x_range
	    info.range.x_start = x_start
	    info.range.x_end = x_start + x_range
	    info.save.x_start = x_min
	    info.save.x_end = x_max
	    widget_control, info.widgets.rangefield, set_value=x_range
	    widget_control, info.widgets.startslide, set_slider_min=x_min
	    widget_control, info.widgets.startslide, set_slider_max=x_max
	    widget_control, info.widgets.startslide, set_slider_min=x_min
	    widget_control, info.widgets.startslide, set_value=x_start
	    widget_control, info.widgets.startfield, set_value=x_start
	    info.time_type.old = info.time_type.new
	    set_axis_ranges, info, YRange, Ystyle, XRange, Xstyle, ZRange, Zstyle
	  endif
	endif else info.time_type.old = info.time_type.new

	if (print_flag eq 0) or (print_flag eq 3) then plot_dialogue , info.variablename, info

	if !D.Name ne 'PRINTER' then begin
	    if !D.Name ne 'WIN' and info.char.font ne 0 then begin
		xtitle= '!C' + xtitle + '!C'
	    endif else begin
		xtitle = xtitle + '!C'
	    endelse
	endif
	if !D.Name eq 'PS' or !D.Name eq 'PRINTER' then begin
		old_charsize = !X.CHARSIZE
		!X.CHARSIZE = 0.9
		!Y.CHARSIZE = 0.9	
	endif

	plot,hdf_data_time, hdf_data_z, $
        	MAX_VALUE = max_value, MIN_VALUE = min_value, /YNOZERO, /NODATA, $
		FONT=info.char.font, $
		charsize=info.char.size, $
        	xtitle=xtitle, $
        	ytitle=ytitle, $
		title=the_title, $
        	xticklen=xticklen, yticklen=yticklen, $
		subtitle="File: " + filename + "  Date:" + systime(0), $
        	xrange=XRange, yrange=YRange, xstyle=Xstyle, ystyle=Ystyle

	if info.axis_state gt 0 then begin
		fit_flag = 0
		fit_data_range, info.axis_state, fit_flag, 0, 1, xrange, yrange, 0, $
			0, hdf_data_time, hdf_data_z, 0, 0, 0
		if fit_flag eq 1 then return
	endif

	oplot, hdf_data_time, hdf_data_z,MAX_VALUE = max_value, MIN_VALUE = min_value, $
		psym = plot_symbol, linestyle=info.style.linetype, $
		symsize = info.style.symbolsize, thick = info.style.linethick, $
		color = info.style.colorindex

endif else begin

	if (print_flag eq 0) or (print_flag eq 3) then plot_dialogue , info.variablename, info

	if !D.Name eq 'PRINTER' or !D.Name eq 'WIN' or info.char.font eq 0 then xtitle='Sample' $
		else xtitle='!CSample!C'
	if !D.Name eq 'PS' or !D.Name eq 'PRINTER' then begin
		old_charsize = !X.CHARSIZE
		!X.CHARSIZE = 0.9
		!Y.CHARSIZE = 0.9	
	endif

	plot,hdf_data_z, $
        	MAX_VALUE = max_value, MIN_VALUE = min_value, /YNOZERO, /NODATA, $
		FONT=info.char.font, $
		charsize=info.char.size, $
        	xtitle=xtitle, $
        	ytitle=ytitle, $
		title=the_title, $
        	xticklen=xticklen, yticklen=yticklen, $
		subtitle="File: " + filename + "  Date:" + systime(0), $
        	xrange=XRange, yrange=YRange, xstyle=Xstyle, ystyle=Ystyle

	if info.axis_state ne 2 or info.axis_state ne 4 then $
                max_y_range = max_value $
                else max_y_range = yrange(1)
        ;oplot, hdf_data_z,MAX_VALUE = max_value, $
        oplot, hdf_data_z,MAX_VALUE = max_y_range, MIN_VALUE = min_value, $
		psym = plot_symbol, linestyle=info.style.linetype, $
		symsize = info.style.symbolsize, thick = info.style.linethick, $
		color = info.style.colorindex

endelse

if info.subset.data(this_subset).src_crit_flag eq 1 then begin
	if !D.Name eq 'PS' or !D.Name eq 'PRINTER' then begin
		charsize = 0.9*info.char.size
		y_location = 0.125
	endif else begin
		charsize = info.char.size
		y_location = 0.11
	endelse
	;xyouts, !P.Position(0), !P.Position(1)-y_location, crit_string, /NORMAL, $
	xyouts, 0.08, !P.Position(1)-y_location, crit_string, /NORMAL, $
		font=info.char.font, charsize=charsize
endif

if info.addtext.key eq 1 then write_add_text, info

if !D.Name eq 'PS' or !D.Name eq 'PRINTER' then begin
	!X.CHARSIZE = old_charsize
	!Y.CHARSIZE = old_charsize
endif

!P.Position = [0.0, 0.0, 0.0, 0.0]

widget_control, set_uvalue=info, info.widgets.base
widget_control, set_uvalue=info, info.base

end

;--------------------------------------------------------------------------------
function setpshardfont, info

pro_name = 'setpshardfont'
@getinfo1

;  Verify the set_plot set to ps
if !D.Name ne 'PS' then return, 0

;  initialize the command to device
psfont = 'device'

;  convert the fontname to uppercase
temp_name = strupcase(info.char.fontname)

;  First check the font type
the_list = ['COURIER', 'HELVETICA', 'AVANTGARDE', 'BKMAN', 'ZAPFCHANCERY', $
    'SCHOOLBOOK', 'PALATINO', 'TIMES', 'SYMBOL', 'ZAPFDINGBATS']
num_list = n_elements(the_list)

;  Only one font can be selected
the_index = -1
i = 0
while (the_index eq -1 and i lt num_list) do begin
    check_name = the_list[i]
    the_index = strpos(temp_name, check_name)
    i = i + 1
endwhile

;  if one font is found, then set the font
if the_index ne -1 then begin
    psfont = psfont + ', /'+strtrim(the_list[i-1], 2)
endif else begin
    ;  If cannont find the font, cannot change the font
    return, 0
endelse

;  Next check the other settings
the_list = ['BOLD', 'OBLIQUE', 'NARROW', 'BOOK', 'DEMI', 'ITALIC', 'LIGHT', $
    'MEDIUM']
num_list = n_elements(the_list)

; loop through these keywords and set when included
i = 0
while (i lt num_list) do begin
    check_name = the_list[i]
    the_index = strpos(temp_name, check_name)
    if the_index ne -1 then begin
	psfont = psfont + ', /'+strtrim(the_list[i], 2)
    endif
    i = i + 1
endwhile

print,'psfont = ',psfont

;  Set the device use execute command
result = execute(psfont)

if result eq 1 then begin
    ;  if it is successful, set the !P.FONT to 0
    !P.FONT = 0
    status = 1
endif else begin
    ;  If it is not successful to set the font return, 0
    status = 0
endelse

return, status

end

;--------------------------------------------------------------------------------
pro file_save_eps, info, eps_type, pro_check

pro_name = 'file_save_eps'
@getinfo

count = check_directory(info.eps_out.path, info.home_path)
if count eq 0 then begin
	CD, '.', CURRENT=pwd
	info.eps_out.path = pwd
endif
filename = dialog_pickfile(title='Encapsulated Postscript Output File',/write, $
		path=info.eps_out.path, file=info.eps_out.file, $
		get_path=this_path, filter='*.eps')

if filename eq "" then return

print_result=STRPOS(filename, this_path)

if print_result eq -1 then filename=this_path+filename
print, 'Encapsulated Postscript save to = ', filename

info.eps_out.path = this_path
default_file = ''
default_file = get_default_file(filename)
if default_file ne 'None' then info.eps_out.file = default_file

if pro_check eq 1 then begin
    info.sview.p_old = !P
    info.sview.x_old = !X
    info.sview.y_old = !Y
    window_id_old = !d.window
endif

old_foreground = !P.Color
old_background = !P.BACKGROUND

TVLCT, R, G, B, /GET
set_plot,"PS", /INTERPOLATE

i_p_old = 0
epspreview = info.eps_out.preview
if info.version lt 5.3 and epspreview gt 1 then epspreview = 1
if eps_type eq 0 then begin
    if info.eps_out.newsize eq 0 then begin
	xsize=info.eps_out.p_xsize
	ysize=info.eps_out.p_ysize
    endif else begin
	xsize=7.0
	ysize=5.40
    endelse
    device, filename=filename, /color, /PORTRAIT, /encapsulated, $
	/inches, xsize=xsize, ysize=ysize, bits_per_pixel=8, PREVIEW=epspreview
;	/inches, xsize=7.0, ysize=5.40, bits_per_pixel=8, preview=1
endif else begin
    if info.eps_out.newsize eq 0 then begin
	xsize=info.eps_out.l_xsize
	ysize=info.eps_out.l_ysize
    endif else begin
	xsize=9.0
	ysize=6.95
    endelse
    yoffset = xsize + xsize * 1.25 / 9.0
    if info.graph_style eq 'Geolocated' then begin
	device, filename=filename, /color, /LANDSCAPE, /encapsulated, $
	    /inches, xsize=xsize, ysize=ysize, yoffset=yoffset, bits_per_pixel=8, $
            PREVIEW=epspreview
	   ; /inches, xsize=9.0, ysize=6.95, bits_per_pixel=8, preview=1
    endif else begin
	p_old = !P.Position
	!P.Position = [0.235, 0.15, 0.99, 0.95] 
	device, filename=filename, /color, /LANDSCAPE, /encapsulated, $
	    /inches, xsize=xsize, ysize=ysize, yoffset=yoffset, bits_per_pixel=8, $
	    PREVIEW=epspreview
	   ; /inches, xsize=9.0, ysize=6.95, bits_per_pixel=8, preview=1
	i_p_old = 1
    endelse
endelse

check_color = 0
if info.style.colorindex eq 255 then begin
    check_color = 1
    info.style.colorindex = !P.Color
endif

;  If hardware font or true_type outline font is used, set the font
old_font = info.char.font
setpsfont = 0
if info.char.font gt -1 then begin
    setpsfont = setpshardfont(info)
endif

info.eps_out.type = eps_type
info.eps_out.flag = 1
charsize_old = info.char.size
; info.char.size = 0.70
if info.char.font eq -1 or setpsfont eq 0 then begin
    info.char.font = 5
    info.char.size = 0.70
endif
widget_control, set_uvalue=info, info.base

if pro_check eq 0 then begin
    if info.multiple.key eq 1 then begin
	do_more_variables, 2, info
    endif else if info.multiple.key eq 2 then begin
	do_more_x_variables, 2, info
    endif else begin
      plot_status = 1
      case info.graph_style of
	'XY Plot': do_xy_plot, 1, info, plot_status
	'XYZ Plot': do_xyz_plot, 1, info, plot_status
	'3D Mesh Plot': plot_3d_mesh, 1, info, plot_status
	'Scatter Contour Plot': do_scatter_contour, 1, info, plot_status
	'Y1Y2 Compute': do_y1y2_compute, 1, info , plot_status
	'Y1 Compute': do_y1_compute, 1, info, plot_status
	'Curve Fit': do_curve_fit, 1, info.curvefit.type, info , plot_status
	'Extract Bits': do_extract_bits, info.subset.selected, 1, info , plot_status
	else: plot_graph, 1, info.subset.selected, info
      endcase
    endelse
endif else begin
	widget_control, info.browse_image.xwidget, get_value=x_location
	widget_control, info.browse_image.pwidget, get_value=p_number
	draw_profile, x_location, p_number, 1, info
endelse

device,/close

if i_p_old eq 1 then begin
   !P.Position = p_old
   i_p_old = 0
endif

if info.eps_out.check eq 0 and info.eps_out.preview lt 2 then begin
    if info.device eq 'X' then begin
	command = 'grep -i showpage '+ filename
	spawn, command, result
	result = result(0)
	if result ne 'showpage' then begin
	    tempname=info.temp_dir+'/.'+info.tempname+'_tmp'
	    command = "awk '{print ; if($1 == " + '"%%PageTrailer") { print"showpage" } }'+"'"
	    command = command + ' ' + filename + ' > ' + tempname
	    spawn, command, result
	    command = 'mv -f ' + tempname + ' ' + filename
	    spawn, command, result
	endif
    endif
endif

if check_color eq 1 then info.style.colorindex = 255

info.char.size = charsize_old
; info.char.font = -1
info.char.font = old_font
info.eps_out.type = 0
info.eps_out.flag = 0
;set_plot,"X"
set_plot,info.device
TVLCT, R, G, B
;if !P.BACKGROUND ne 0 then set_plot, "X"
if !P.BACKGROUND ne 0 then set_plot, info.device

if pro_check eq 1 then begin
    !P = info.sview.p_old
    !X = info.sview.x_old
    !Y = info.sview.y_old
    wset, window_id_old
endif

!P.Color = old_foreground
!P.BACKGROUND = old_background

result=dialog_message('Save EPS Completed!', title='Notice!')

end

;--------------------------------------------------------------------------------
pro file_save_ps, flag, info, pro_check

pro_name = 'file_save_ps'
@getinfo

; Note: Need to Change the Printer fonts

if (flag eq 0) then begin

	count = check_directory(info.ps_path, info.home_path)
	if count eq 0 then begin
		CD, '.', CURRENT=pwd
		info.ps_path = pwd
	endif
	filename = dialog_pickfile(title='Postscript Output File',/write, $
			path=info.ps_path, file=info.ps_file, $
                        get_path=this_path, filter='*.ps')

	if filename eq "" then return

	print_result=STRPOS(filename, this_path)
	if print_result eq -1 then filename=this_path+filename
	print, 'Postscript save to = ', filename

	info.ps_path = this_path
	default_file = ''
	default_file = get_default_file(filename)
	if default_file ne 'None' then info.ps_file = default_file

endif else begin
	if info.device eq 'X' then begin
		filename=info.temp_dir+'/.'+info.tempname+'_ps'
	endif else begin
		filename=info.temp_dir+'\.'+info.tempname+'_ps'
	endelse
endelse

if pro_check eq 1 then begin
    info.sview.p_old = !P
    info.sview.x_old = !X
    info.sview.y_old = !Y
    window_id_old = !d.window
endif

; Save the background and foreground colors
old_foreground = !P.Color
old_background = !P.BACKGROUND

TVLCT, R, G, B, /GET
set_plot,"PS", /INTERPOLATE

if pro_check eq 0 then begin
   device, filename=filename, /color, /landscape, encapsulated=0, $
	bits_per_pixel=8, PREVIEW=0
endif else begin
   device, filename=filename, /color, /portrait, encapsulated=0, $
	bits_per_pixel=8, /inches, yoffset=1.0, ysize=9, xsize=7.0, $
	PREVIEW=0
endelse

check_color = 0
if info.style.colorindex eq 255 then begin
    check_color = 1
    info.style.colorindex = !P.Color
endif

old_font = info.char.font
setpsfont = 0
;  If hardware font or true_type outline font is used, set the font
if info.char.font gt -1 then begin
    setpsfont = setpshardfont(info)
endif

info.eps_out.type = 0
charsize_old = info.char.size
; info.char.size = 0.8
if info.char.font eq -1 or setpsfont eq 0 then begin
    info.char.font = 5
    info.char.size = 0.8
endif
widget_control, set_uvalue=info, info.base
if pro_check eq 0 then begin
    if info.multiple.key eq 1 then begin
	do_more_variables, 2, info
    endif else if info.multiple.key eq 2 then begin
	do_more_x_variables, 2, info
    endif else begin
	plot_status = 1
	case info.graph_style of
	  'XY Plot': do_xy_plot, 1, info, plot_status
	  'XYZ Plot': do_xyz_plot, 1, info, plot_status
	  '3D Mesh Plot': plot_3d_mesh, 1, info, plot_status
	  'Scatter Contour Plot': do_scatter_contour, 1, info, plot_status
	  'Y1Y2 Compute': do_y1y2_compute, 1, info , plot_status
	  'Y1 Compute': do_y1_compute, 1, info, plot_status
	  'Curve Fit': do_curve_fit, 1, info.curvefit.type, info, plot_status
	  'Extract Bits': do_extract_bits, info.subset.selected, 1, info, plot_status 
	  else: plot_graph, 1, info.subset.selected, info
	endcase
    endelse
endif else begin
	widget_control, info.browse_image.xwidget, get_value=x_location
	widget_control, info.browse_image.pwidget, get_value=p_number
	draw_profile, x_location, p_number, 1, info
endelse

device,/close

;command = 'grep -i showpage '+ filename
;spawn, command, result
;result = result(0)
;if result ne 'showpage' then begin
;  tempname='/CERES/scratch/idltemp/.'+info.tempname+'_tmp'
  ;command = 'echo "showpage" >> ' + filename
  ;command = 'showpage.csh ' + filename
;  command = "awk '{print ; if($1 == " + '"%%PageTrailer") { print"showpage" } }'+"'"
;  command = command + ' ' + filename + ' > ' + tempname
  ;print, 'in file_save_ps, command = ', command
;  spawn, command, result
;  command = 'mv -f ' + tempname + ' ' + filename
;  spawn, command, result
;endif

if check_color eq 1 then info.style.colorindex = 255

info.char.size = charsize_old
; info.char.font = -1
info.char.font = old_font
;set_plot,"X"
set_plot,info.device
TVLCT, R, G, B
;if !P.BACKGROUND ne 0 then set_plot, "X"
if !P.BACKGROUND ne 0 then set_plot, info.device

if pro_check eq 1 then begin
    !P = info.sview.p_old
    !X = info.sview.x_old
    !Y = info.sview.y_old
    wset, window_id_old
endif

!P.Color = old_foreground
!P.BACKGROUND = old_background

if (flag eq 0) then $
    result=dialog_message('Save Postscript Completed!', title='Notice!')

end

;--------------------------------------------------------------------------------
pro file_save_gif, info, print_type, pro_check

pro_name = 'file_save_gif'
@getinfo

widget_control, /hourglass
;if print_type eq 0 and info.version ge 5.4 then begin
;    the_message = ['GIF is no longer supported in this version of IDL.', $
;	'Do you want to save in PNG format instead?']
;    result=dialog_message(the_message, /Question, title='View HDF Question!')
;
;    if result eq 'Yes' then print_type = 1 else return
;endif else if print_type eq 1 and info.version lt 5.3 then begin
;    the_message = ['PNG is not supported in this version of IDL.', $
;	'Do you want to save in GIF format instead?']
;    result=dialog_message(the_message, /Question, title='View HDF Question!')
;
;    if result eq 'Yes' then print_type = 0 else return
;endif

if print_type eq 0 then begin
    count = check_directory(info.gif_path, info.home_path)
    if count eq 0 then begin
	CD, '.', CURRENT=pwd
	info.gif_path = pwd
    endif
    filename = dialog_pickfile(title='GIF Output File',/write, $
	path=info.gif_path, file=info.gif_file, $
	get_path=this_path, filter='*.gif')
    if filename eq "" then return
    print_result=STRPOS(filename, this_path)
    if print_result eq -1 then filename=this_path+filename
    print, 'GIF file save to = ', filename 
    info.gif_path = this_path
    default_file = ''
    default_file = get_default_file(filename)
    if default_file ne 'None' then info.gif_file = default_file
endif else begin
    count = check_directory(info.png_path, info.home_path)
    if count eq 0 then begin
	CD, '.', CURRENT=pwd
	info.png_path = pwd
    endif
    filename = dialog_pickfile(title='PNG Output File',/write, $
	path=info.png_path, file=info.png_file, $
	get_path=this_path, filter='*.png')
    if filename eq "" then return
    print_result=STRPOS(filename, this_path)
    if print_result eq -1 then filename=this_path+filename
    print, 'PNG file save to = ', filename
    info.png_path = this_path
    default_file = ''
    default_file = get_default_file(filename)
    if default_file ne 'None' then info.png_file = default_file
endelse

widget_control, /hourglass

if pro_check eq 1 then begin
    window_id_old = !d.window
    wset, info.browse_image.window_id
endif

if info.version lt 5.19 then begin
    device,get_visual_depth = thisDepth
    thisState = 0
endif else begin
    device, get_visual_depth=thisDepth, get_decomposed=thisState
    print,'in file_save_gif: thisDepth = ',thisDepth,' and thisState = ',thisState
endelse
if thisDepth gt 8 then begin
    if print_type eq 0 then begin
	image2d = convert_image24_image8()
    endif else begin
	device, decomposed=1
	; snapshot = TVRD(True=1)
	image2d = TVRD(True=1)
	device, decomposed=thisState
    endelse
    ; image2d = color_quan(snapshot, 1, r1,g1,b1,colors=256, /Dither)
    tvlct,r1,g1,b1,/get
endif else begin
    tvlct,r1,g1,b1,/get
    image2d = TVRD()
endelse

if print_type eq 0 then begin
    write_gif, filename, image2d, r1,g1,b1
    result=dialog_message('Save Gif Completed!', title='Notice!')
endif else begin
    if info.version lt 5.4 then image2d = reverse(temporary(image2d), 2)
    write_png, filename, image2d, r1,g1,b1
    result=dialog_message('Save PNG Completed!', title='Notice!')
endelse

if pro_check eq 1 then wset, window_id_old

widget_control, set_uvalue=info, info.base

end

;--------------------------------------------------------------------------------
pro file_save_image, info, pro_check, base_leader

pro_name = 'file_save_image'
@getinfo

widget_control, /hourglass

;  Note:  write_image is only good with IDL 5.3 and up
if info.version lt 5.3 then begin
    the_message = ['The WRITE_IMAGE function is only valid for', $
	'IDL version 5.3 and later.', $
	'Please use other function to save the plot.']
    result=dialog_message(the_message, title='View HDF Error!')
    return
endif

;  Select the output type
the_list = ' '

;  Check the gif and/or png are valid
if info.gif_out.gif_flag eq 1 then the_list = [the_list, 'GIF']
if info.gif_out.png_flag eq 1 then the_list = [the_list, 'PNG']

;  append the other type of graphs at the end
the_list = [the_list, 'BMP', 'JPEG', 'PPM', 'SRF', 'TIFF']
num_type = n_elements(the_list)
the_list = the_list[1:num_type-1]

the_list = the_list(sort(the_list))
the_list = [the_list, 'Cancel']

num_type = n_elements(the_list)

title = 'Select Output Image Type'
the_message = [ 'Please select one of the following output type:']
default_option = 0
sel_option = get_option(default_option,the_list,title,the_message,info, $
    base_leader = base_leader)

;  If cancel is selected, return
if sel_option eq num_type-1 then return

image_type = the_list[sel_option]

;  set the extension
case image_type of
    'GIF':  image_ext = 'gif'
    'PNG':  image_ext = 'png'
    'BMP':  image_ext = 'bmp'
    'JPEG': image_ext = 'jpg'
    'PPM':  image_ext = 'ppm'
    'SRF':  image_ext = 'srf'
    'TIFF': image_ext = 'tif'
    else:   image_ext = 'jpg'
endcase

;  If it is an JPEG, ask for the quality
if image_type eq 'JPEG' then begin
    q_value=info.gif_out.jpg_quality
    title = 'Set the Quality of the JPEG output'
    f_title = 'Output Quality:'
    the_message = 'Set the Quality of the JPEG output'
    jpeg_quality = get_field_value(q_value, 10, title, f_title, the_message, info, $
	base_leader = base_leader)
    jpeg_quality = jpeg_quality(0)
    if jpeg_quality eq 'cancel' then return
    jpeg_quality = fix(jpeg_quality)
    ;  Make sure the quality within the range
    if jpeg_quality lt 0 then jpeg_quality = 75
    if jpeg_quality gt 100 then jpeg_quality = 100
    print,'Write a JPEG with ',jpeg_quality,' quality'
endif

image_filter = '*.'+image_ext

count = check_directory(info.gif_path, info.home_path)
if count eq 0 then begin
    CD, '.', CURRENT=pwd
    info.gif_path = pwd
endif

filename = dialog_pickfile(title='Enter Image Output File', /write, $
    path=info.gif_path, file=info.gif_file, $
    get_path=this_path, filter=image_filter)

if filename eq "" then return
print_result=STRPOS(filename, this_path)
if print_result eq -1 then filename=this_path+filename
print, 'Image file save to = ', filename 
info.gif_path = this_path
default_file = ''
default_file = get_default_file(filename)
if default_file ne 'None' then info.gif_file = default_file

widget_control, /hourglass

if pro_check eq 1 then begin
    window_id_old = !d.window
    wset, info.browse_image.window_id
endif

if info.version lt 5.19 then begin
    device,get_visual_depth = thisDepth
    thisState = 0
endif else begin
    device, get_visual_depth=thisDepth, get_decomposed=thisState
    print,'in file_save_image: thisDepth = ',thisDepth,' and thisState = ',thisState
endelse
if thisDepth gt 8 then begin
    ; device, decomposed=1
    ; snapshot = TVRD(True=1)
    ; device, decomposed=thisState
    ; image2d = color_quan(snapshot, 1, r1,g1,b1,colors=256, /Dither)
    ;  only gif is 8-bit image
    if image_type eq 'GIF' then begin
	image2d = convert_image24_image8()
	; print,'max image2d = ',max(image2d)
    endif else begin
	image2d = get_image24()
    endelse
    tvlct,r1,g1,b1,/get
    ; print,'max r1 = ',max(r1),', max g1 = ',max(g1),', max b1 = ',max(b1)
endif else begin
    tvlct,r1,g1,b1,/get
    image2d = TVRD()
endelse

;  Write image to file
if((image_type eq 'PPM') or (image_type eq 'SRF') or (image_type eq 'TIFF')) then begin
   ; print,'This is ',image_type,' plot, need to reverse the image'
   rev_id = size(image2d, /N_DIMENSIONS)
   ; print,'the rev_id = ',rev_id
   image2d = reverse(temporary(image2d), rev_id)
endif

if image_type eq 'JPEG' then begin
    ;  For JPEG, the image has to be a true color, otherwise it only show gray scale
    image_dim = size(image2d, /N_DIMENSIONS)
    if image_dim eq 2 then begin
	;  Convert it to true color image
	new_image = image2d
	size_image = size(new_image)
	image2d = bytarr(3, size_image[1], size_image[2])
	; tvlct, r1, g1, b1, /get
	image2d[0, *, *] = r1[new_image]
	image2d[1, *, *] = g1[new_image]
	image2d[2, *, *] = b1[new_image]
    endif

    ;  Set the true=1 to show the color
    write_jpeg, filename, image2d, quality=jpeg_quality, true=1
endif else begin
    write_image, filename, image_type, image2d, r1, g1, b1
endelse

result=dialog_message('Save Image Completed!', title='Notice!')

if pro_check eq 1 then wset, window_id_old

widget_control, set_uvalue=info, info.base

end

;--------------------------------------------------------------------------------
; $Id: mpeg_put.pro,v 1.6.2.1 1998/06/23 17:40:25 scottm Exp $
;
; Copyright (c) 1998, Research Systems, Inc.  All rights reserved.
;	Unauthorized reproduction prohibited.
;+
; NAME:
;	MPEG_PUT
;
; PURPOSE:
;       Stores the given image at the given frame index.
;
; CATEGORY:
;       Input/Output
;
; CALLING SEQUENCE:
;       MPEG_PUT, mpegID
;
; INPUTS:
;       mpegID: The object reference returned from an MPEG_OPEN call.
;
; KEYWORD PARAMETERS:
;	COLOR: Set to write 24 bit MPEG from 8 bit pseudo color direct
;		graphics windows.
;       FRAME: Set this keyword to the frame at which the image is to
;              be loaded.  If the frame number matches a previously
;              put frame, the previous frame is overwritten.  The 
;              default is 0.
;       IMAGE: Set this keyword to an mxn or 3xmxn array representing
;              the image to be loaded at the given frame.  Mutually
;              exclusive of the WINDOW keyword.
;       ORDER: Set this keyword to a non-zero value to indicate that
;              the rows of the image should be drawn from top to bottom.
;              By default, the rows are drawn from bottom to top.
;       WINDOW: Set this keyword to the index of a Direct Graphics
;              Window (or to an object reference to an IDLgrWindow or
;              IDLgrBuffer object) to indicate that the image to be
;              loaded is to be read from the given window or buffer.
;
; EXAMPLE:
;       MPEG_PUT, mpegID, FRAME=2, IMAGE=DIST(100)
;
; MODIFICATION HISTORY:
; 	Written by:	Scott J. Lasica, December, 1997
;-

pro MPEG_PUT, mpegID, FRAME = frame, IMAGE = image, ORDER = order, $
              WINDOW = window, COLOR=color

common colors, r_orig, g_orig, b_orig, r_curr, g_curr, b_curr

    ;; Check all the input parameters
    if (not OBJ_ISA(mpegID, 'IDLgrMPEG')) then $
      MESSAGE,'Argument must be an IDLgrMPEG object reference.'

    if (N_ELEMENTS(frame) eq 0) then $
      frameFlag = 0 $
    else $
      frameFlag = frame
    if (frameFlag lt 0) then $
      MESSAGE,'FRAME values must be non-negative.'
    
    imageFlag = N_ELEMENTS(image) gt 0
    windowFlag = N_ELEMENTS(window) gt 0
    bOrder = keyword_set(order) ;Set if ORDER is set
    
    if ((imageFlag + windowFlag) eq 0) then $
      MESSAGE,'Image is undefined.' $
    else if (imageFlag gt 0) and (windowFlag gt 0) then $
      MESSAGE,'IMAGE and WINDOW are mutually exclusive keywords.'
    
    if (imageFlag gt 0) then begin     ;Must be an image
        nDims = size(image, /N_DIMENSIONS)
        if ((nDims ne 2) and (nDims ne 3)) then $

          MESSAGE,'Image dimensions must be 2D or 3D.'
        if (bOrder) then $
          mpegID->Put, REVERSE(Image, nDims), frameFlag $
        else $
          mpegID->Put, Image, frameFlag
    endif else begin            ;Must be a window    
        if (OBJ_VALID(window)) then begin ;a GR2 window?
            if (OBJ_ISA(window, 'IDLgrWindow') or $
                OBJ_ISA(window, 'IDLgrBuffer')) then begin
                myImage = window->Read() ;(m,n) or (3,m,n)
            endif
        endif else begin        ;Must be a GR1 window
            oldWin = !D.WINDOW
            WSET, window
            if (!d.n_colors le 256) then $
              myImage = TVRD(ORDER=bOrder) $
            else $
              myImage = TVRD(TRUE=1, ORDER=bOrder)
            WSET, oldWin
            bOrder = 0          ;Now its not reversed
                                ; Convert to 24 bit color from 8 bit?
            if (KEYWORD_SET(color) and (!d.n_colors le 256)) then begin
; Apply color tables and create an (!d.x_size, 3 * !d.y_size) array:
                myImage = [[r_curr[myImage]], [g_curr[myImage]], $
                           [b_curr[myImage]]]
; Reform to (!D.x_size * !D.y_size, 3) and then transpose to
; interleave color as first dimension.
                myImage = TRANSPOSE(REFORM(myImage,!d.x_size * !d.y_size, 3,$ 
                                           /OVERWRITE))
; Now back to (3, !d.x_size, !d.y_size)
                myImage = REFORM(myImage, 3, !d.x_size, !d.y_size, /OVERWRITE)
            endif               ;Colorize
        endelse                 ;Gr1 window
                                ;Write to MPEG stream
        if (bOrder) then $
          mpegID->Put, $
          REVERSE(MyImage, size(myImage, /N_DIMENSIONS)), frameFlag $
        else mpegID->Put, MyImage, frameFlag
    endelse                     ;A window
end

;--------------------------------------------------------------------------------
pro file_save_mpeg, info

pro_name = 'file_save_mpeg'
@getinfo

if info.graph_style ne 'Geolocated' then begin
    the_message='"Save MPEG" option is only good for "Geolocated" plot!'
    result=dialog_message(the_message, title='View HDF Warning!')
    return
endif

count = check_directory(info.mpeg.path, info.home_path)
if count eq 0 then begin
    CD, '.', CURRENT=pwd
    info.mpeg.path = pwd
endif

info.mpeg.flag = 0
filename = dialog_pickfile(title='MPEG Output File',/write, $
    path=info.mpeg.path, file=info.mpeg.file, $
    get_path=this_path, filter='*.mpeg')

if filename eq "" then return

mpeg_result=STRPOS(filename, this_path)
if mpeg_result eq -1 then filename=this_path+filename
print, 'MPEG save to = ', filename

info.ps_path = this_path
default_file = ''
default_file = get_default_file(filename)
if default_file ne 'None' then info.mpeg.file = default_file

old_xscreen = info.screen.xsize
old_yscreen = info.screen.ysize
old_window_id = !d.window

xscreen = info.screen.xsize
yscreen = info.screen.ysize

temp = fix(xscreen/16) * 16
xscreen = temp
temp = fix(yscreen/16) * 16
yscreen = temp
info.screen.xsize = xscreen
info.screen.ysize = yscreen
dimension = [xscreen, yscreen]
;print,'start to open mpeg file'
mpeg_id = MPEG_OPEN(dimension)
info.mpeg.id = mpeg_id

num_frame = info.mpeg.frame
i_value = [num_frame]
title = 'Get number of frames'
f_title = ['Number Of Frames:']
xsize = [20]
the_message = ['Enter the number of frames in the mpeg file']
para = get_n_field_value(1, i_value, xsize, title, f_title, the_message, $
    info.widgets.base, info)
num_frame = para(0)
if num_frame eq 'cancel' then return
info.mpeg.frame = num_frame

window, /free, /pixmap, xsize=xscreen, ysize=yscreen
info.mpeg.winid = !d.window
info.mpeg.flag = 1

widget_control, set_uvalue=info, info.base

if info.multiple.key eq 1 then begin
	do_more_variables, 2, info
endif else if info.multiple.key eq 2 then begin
	do_more_x_variables, 2, info
endif else begin
	plot_status = 1
	case info.graph_style of
	  'XY Plot': do_xy_plot, 1, info, plot_status
	  'XYZ Plot': do_xyz_plot, 1, info, plot_status
	  '3D Mesh Plot': plot_3d_mesh, 1, info, plot_status
	  'Scatter Contour Plot': do_scatter_contour, 1, info, plot_status
	  'Y1Y2 Compute': do_y1y2_compute, 1, info , plot_status
	  'Y1 Compute': do_y1_compute, 1, info , plot_status
	  'Curve Fit': do_curve_fit, 1, info.curvefit.type, info , plot_status
	  'Extract Bits': do_extract_bits, info.subset.selected, 1, info , plot_status
	  else: plot_graph, 1, info.subset.selected, info
	endcase
endelse

mpeg_save, info.mpeg.id, filename=filename
mpeg_close, info.mpeg.id

info.mpeg.flag = 0
if obj_valid(info.mpeg.id) then obj_destroy, info.mpeg.id

wdelete, info.mpeg.winid
wset, old_window_id

info.screen.xsize = old_xscreen
info.screen.ysize = old_yscreen

widget_control, set_uvalue=info, info.base

result=dialog_message('Save MPEG Completed!', title='Notice!')

end

;--------------------------------------------------------------------------------
pro filter_tri, hdf_data_x, hdf_data_y, tri, gridspace

pro_name = 'filter_tri'
@getinfo

toler = sqrt(gridspace(0)*gridspace(0) + gridspace(1)*gridspace(1)) * 5

xdiff = hdf_data_x(tri(1,*)) - hdf_data_x(tri(0,*))
ydiff = hdf_data_y(tri(1,*)) - hdf_data_y(tri(0,*))
distance = sqrt(xdiff*xdiff + ydiff*ydiff)
subscripts = where(distance lt toler, count)
if count ne 0 then tri = tri(*,subscripts) $
else begin
	tri(0,0) = -999
	return
endelse

xdiff = hdf_data_x(tri(2,*)) - hdf_data_x(tri(1,*))
ydiff = hdf_data_y(tri(2,*)) - hdf_data_y(tri(1,*))
distance = sqrt(xdiff*xdiff + ydiff*ydiff)
subscripts = where(distance lt toler, count)
if count ne 0 then tri = tri(*,subscripts) $
else begin
	tri(0,0) = -999
	return
endelse

xdiff = hdf_data_x(tri(0,*)) - hdf_data_x(tri(2,*))
ydiff = hdf_data_y(tri(0,*)) - hdf_data_y(tri(2,*))
distance = sqrt(xdiff*xdiff + ydiff*ydiff)
subscripts = where(distance lt toler, count)
if count ne 0 then tri = tri(*,subscripts) $
else begin
	tri(0,0) = -999
	return
endelse

end 

;--------------------------------------------------------------------------------
pro load_user_colortable, info

pro_name = 'load_user_colortable'
@getinfo

if info.subset.count lt 1 then begin
	result=dialog_message('You need at least one or three subsets of data!',$
	    title='View HDF Warning!')
	return
endif

widget_control, get_uvalue=info, info.base

;  Save the old graph_style and field names
old_graph_style = info.graph_style
old_x_fieldname = info.field_name.x
old_y_fieldname = info.field_name.y
old_z_fieldname = info.field_name.z

info.graph_style = 'Load User Color Table'
plot_setup, info, 'Load User Color Table', 1, 1, 1
widget_control, get_uvalue=info, info.base
if info.canceloption eq 'Yes' then begin
    info.canceloption = 'No'
    info.graph_style = old_graph_style
    info.field_name.x = old_x_fieldname
    info.field_name.y = old_y_fieldname
    info.field_name.z = old_z_fieldname
    widget_control, set_uvalue=info, info.base
    return
endif 

widget_control, /hourglass

widget_control, get_uvalue=info, info.base
get_data, y_index, x_index, z_index, info

if x_index eq -1 then begin
    result=dialog_message('The selected variables are wrong!',$
	title='View HDF Warning!')
    return
endif

if info.subset.data(x_index).src_type_flag eq 0 then begin
    hdf_data_x = *info.subset.data(x_index).src_data
    size_hdf_data_x = size(hdf_data_x)
    if size_hdf_data_x(0) eq 2 then begin
	if size_hdf_data_x(1) eq 3 then begin
	    hdf_data_y = hdf_data_x[1,*]
	    hdf_data_z = hdf_data_x[2,*]
	    hdf_data_x = hdf_data_x[0,*]
	    hdf_data_x = reform(hdf_data_x)
	    hdf_data_y = reform(hdf_data_y)
	    hdf_data_z = reform(hdf_data_z)
	    y_index = -1
	    z_index = -1
	endif else if size_hdf_data_x(2) eq 3 then begin
	    hdf_data_y = hdf_data_x[*,1]
	    hdf_data_z = hdf_data_x[*,2]
	    hdf_data_x = hdf_data_x[*,0]
	    hdf_data_x = reform(hdf_data_x)
	    hdf_data_y = reform(hdf_data_y)
	    hdf_data_z = reform(hdf_data_z)
	    y_index = -1
	    z_index = -1
	endif
    endif
    hdf_data_x = reform(hdf_data_x, n_elements(hdf_data_x))
endif else begin
    hdf_x_temp = *info.subset.data(x_index).src_data
    hdf_data_x = reform(hdf_x_temp.components0, n_elements(hdf_x_temp.components0))
endelse

if y_index ne -1 then begin
    if info.subset.data(y_index).src_type_flag eq 0 then begin
	hdf_data_y = *info.subset.data(y_index).src_data
	hdf_data_y = reform(hdf_data_y, n_elements(hdf_data_y))
    endif else begin
	hdf_y_temp = *info.subset.data(y_index).src_data
	hdf_data_y = reform(hdf_y_temp.components0, n_elements(hdf_y_temp.components0))
    endelse
endif

if z_index ne -1 then begin
    if info.subset.data(z_index).src_type_flag eq 0 then begin
	hdf_data_z = *info.subset.data(z_index).src_data
	hdf_data_z = reform(hdf_data_z, n_elements(hdf_data_z))
    endif else begin
	hdf_z_temp = *info.subset.data(z_index).src_data
	hdf_data_z = reform(hdf_z_temp.components0, n_elements(hdf_z_temp.components0))
    endelse
endif

num_x = n_elements(hdf_data_x)
num_y = n_elements(hdf_data_y)
num_z = n_elements(hdf_data_z)

if(num_x le 256) and (num_x eq num_y) and (num_x eq num_z) then begin
    tvlct, hdf_data_x, hdf_data_y, hdf_data_z
endif else begin
    the_message = ['Number of date points for three subsets are not equal,', $
		   'or they are more than 256 values!']
    result=dialog_message(the_message, title='View HDF Warning!')
endelse

; reset the fields
info.graph_style = old_graph_style
info.field_name.x = old_x_fieldname
info.field_name.y = old_y_fieldname
info.field_name.z = old_z_fieldname

widget_control, set_uvalue=info, info.base

result=dialog_message('Load User Color Table Completed!', title='Notice!')

end

;--------------------------------------------------------------------------------
pro load_discrete_colortable, info

pro_name = 'load_discrete_colortable'
@getinfo

if info.subset.count lt 1 then begin
    result=dialog_message('You need at least one or three subsets of data!',$
	title='View HDF Warning!')
    return
endif

widget_control, get_uvalue=info, info.base

;  Save the old graph_style and field names
old_graph_style = info.graph_style
old_x_fieldname = info.field_name.x
old_y_fieldname = info.field_name.y
old_z_fieldname = info.field_name.z

info.graph_style = 'Load Discrete Color Table'
plot_setup, info, 'Load Discrete Color Table', 1, 1, 1
widget_control, get_uvalue=info, info.base
if info.canceloption eq 'Yes' then begin
    info.canceloption = 'No'
    info.graph_style = old_graph_style
    info.field_name.x = old_x_fieldname
    info.field_name.y = old_y_fieldname
    info.field_name.z = old_z_fieldname
    widget_control, set_uvalue=info, info.base
    return
endif 

widget_control, /hourglass

widget_control, get_uvalue=info, info.base
get_data, y_index, x_index, z_index, info

if x_index eq -1 then begin
    result=dialog_message('The selected variables are wrong!',$
	title='View HDF Warning!')
    return
endif

if info.subset.data(x_index).src_type_flag eq 0 then begin
    hdf_data_x = *info.subset.data(x_index).src_data
    size_hdf_data_x = size(hdf_data_x)
    if size_hdf_data_x(0) eq 2 then begin
	if size_hdf_data_x(1) eq 3 then begin
	    hdf_data_y = hdf_data_x[1,*]
	    hdf_data_z = hdf_data_x[2,*]
	    hdf_data_x = hdf_data_x[0,*]
	    hdf_data_x = reform(hdf_data_x)
	    hdf_data_y = reform(hdf_data_y)
	    hdf_data_z = reform(hdf_data_z)
	    y_index = -1
	    z_index = -1
	endif else if size_hdf_data_x(2) eq 3 then begin
	    hdf_data_y = hdf_data_x[*,1]
	    hdf_data_z = hdf_data_x[*,2]
	    hdf_data_x = hdf_data_x[*,0]
	    hdf_data_x = reform(hdf_data_x)
	    hdf_data_y = reform(hdf_data_y)
	    hdf_data_z = reform(hdf_data_z)
	    y_index = -1
	    z_index = -1
	endif
    endif
    hdf_data_x = reform(hdf_data_x, n_elements(hdf_data_x))
endif else begin
    hdf_x_temp = *info.subset.data(x_index).src_data
    hdf_data_x = reform(hdf_x_temp.components0, n_elements(hdf_x_temp.components0))
endelse

if y_index ne -1 then begin
    if info.subset.data(y_index).src_type_flag eq 0 then begin
	hdf_data_y = *info.subset.data(y_index).src_data
	hdf_data_y = reform(hdf_data_y, n_elements(hdf_data_y))
    endif else begin
	hdf_y_temp = *info.subset.data(y_index).src_data
	hdf_data_y = reform(hdf_y_temp.components0, n_elements(hdf_y_temp.components0))
    endelse
endif

if z_index ne -1 then begin
    if info.subset.data(z_index).src_type_flag eq 0 then begin
	hdf_data_z = *info.subset.data(z_index).src_data
	hdf_data_z = reform(hdf_data_z, n_elements(hdf_data_z))
    endif else begin
	hdf_z_temp = *info.subset.data(z_index).src_data
	hdf_data_z = reform(hdf_z_temp.components0, n_elements(hdf_z_temp.components0))
    endelse
endif

num_r = n_elements(hdf_data_x)
num_g = n_elements(hdf_data_y)
num_b = n_elements(hdf_data_z)

if(num_r le 256) and (num_r eq num_g) and (num_g eq num_b) and (num_r eq num_b) then begin
    top_color = !d.n_colors
    if top_color gt 256 then top_color = 256

    if num_r gt top_color then begin
	the_message = [ 'The number of input color is exceeded the', $
			'maximum color allowed!', $
			'Reduce the number of input color and do it again!']
	result=dialog_message(the_message, title='View HDF Warning!')
	return
    endif

    r1 = make_array(top_color, /byte, VALUE = 0)
    g1 = make_array(top_color, /byte, VALUE = 0)
    b1 = make_array(top_color, /byte, VALUE = 0)

    if num_r lt 20 then begin
	n_level = num_r-3
	num_color = top_color-2
	data_interval = double(num_color)/float(n_level)
	half_interval = fix(data_interval/2)
	half_half_interval = fix(half_interval/2)
	;print,'data_interval = ',data_interval,', half_interval = ', half_interval, $
	;    ', half_half_interval = ',half_half_interval

	tempa = findgen(n_level)
	clevel = fix(data_interval * (tempa(*) + 1))
	;print,'clevel = ',clevel

	;  The first color is background or foreground (black)
	r1[0:half_half_interval-1] = hdf_data_x[0]
	g1[0:half_half_interval-1] = hdf_data_y[0]
	b1[0:half_half_interval-1] = hdf_data_z[0]

	;  The second color is bad data
	r1[half_half_interval:half_interval-1] = hdf_data_x[1]
	g1[half_half_interval:half_interval-1] = hdf_data_y[1]
	b1[half_half_interval:half_interval-1] = hdf_data_z[1]

	;  assign the color table
	start_pos = fix(half_interval)
	for i = 2, num_r-3 do begin
	    end_pos = fix(clevel[i-2] + half_interval)
	    ;print,'i = ',i,': start_pos = ',start_pos,', end_pos = ',end_pos
	    r1[start_pos:end_pos] = hdf_data_x[i]
	    g1[start_pos:end_pos] = hdf_data_y[i]
	    b1[start_pos:end_pos] = hdf_data_z[i]
	    start_pos = end_pos + 1
	endfor

	end_pos = num_color

	;print,'i = ',num_r-2,': start_pos = ',start_pos,', end_pos = ',end_pos
	r1[start_pos:end_pos] = hdf_data_x[num_r-2]
	g1[start_pos:end_pos] = hdf_data_y[num_r-2]
	b1[start_pos:end_pos] = hdf_data_z[num_r-2]

	;  The last color is foreground or background, white
	start_pos = end_pos + 1
	;print,'last start_pos = ',start_pos
	if(start_pos gt num_color+1) then start_pos = num_color+1

	r1[start_pos:num_color+1] = hdf_data_x[num_r-1]
	g1[start_pos:num_color+1] = hdf_data_y[num_r-1]
	b1[start_pos:num_color+1] = hdf_data_z[num_r-1]
    endif else begin
	r1 = congrid(hdf_data_x, top_color, /minus_one)
	g1 = congrid(hdf_data_y, top_color, /minus_one)
	b1 = congrid(hdf_data_z, top_color, /minus_one)
    endelse

    tvlct, r1, g1, b1
endif else begin
    the_message = ['Number of date points for three subsets are not equal,', $
		   'or they are more than 256 values!']
    result=dialog_message(the_message, title='View HDF Warning!')
endelse

; reset the fields
info.graph_style = old_graph_style
info.field_name.x = old_x_fieldname
info.field_name.y = old_y_fieldname
info.field_name.z = old_z_fieldname

widget_control, set_uvalue=info, info.base

result=dialog_message('Load Discrete Color Table Completed!', title='Notice!')

end

;--------------------------------------------------------------------------------
pro backgroundCB, event

pro_name = 'backgroundCB'
@getinfo

widget_control, get_uvalue=info, event.top

widget_control, info.widgets.background, get_value=background

if background lt 0 then background = 0
;if background gt !D.N_COLORS - 1 then background = !D.N_COLORS - 1
if background gt info.top_color - 1 then background = info.top_color - 1
!P.BACKGROUND = background
if(widget_info(info.widgets.base, /VALID_ID)) then begin
	info.view.p_old.BACKGROUND = background
	widget_control, set_uvalue=info, info.widgets.base
endif

if info.style.colorindex eq background then begin
    if !P.COLOR ne background then begin
	info.style.colorindex = !P.COLOR
	widget_control, set_uvalue=info, info.base
	if(widget_info(info.widgets.base, /VALID_ID)) then $
	    widget_control, set_uvalue=info, info.widgets.base
    endif
endif

print,'Background color =',background
if !P.BACKGROUND eq !P.COLOR then begin
	message=['The background color is set to same as foreground color', $
		 'you need to change the foreground color to distinguish the data!']
        result=dialog_message(message, title='View HDF Warning!')
endif

widget_control, event.top, /destroy

end

;--------------------------------------------------------------------------------
pro change_background, info

pro_name = 'change_background'
@getinfo

base = widget_base(COLUMN=1, MAP=1, TITLE='Define Background Color')

b_group=widget_base(base, row=1,map=1)

info.widgets.background = CW_FIELD(b_group, VALUE=!P.BACKGROUND, $
		ROW=1, FLOATING=1, FIELDFONT=info.font, $
		FONT=info.font, TITLE='Background Color:', XSIZE=10)

group2=widget_base(base, row=1,map=1, space=40, /align_center)

button1=widget_button(group2, FONT=info.font, EVENT_PRO='backgroundCB', VALUE="Done",$
	/ALIGN_CENTER)

button2=widget_button(group2, FONT=info.font, EVENT_PRO='doneCB', VALUE="Cancel",$
	 /ALIGN_CENTER)

widget_control, /realize, base

widget_control, set_uvalue=info, base

end


;--------------------------------------------------------------------------------
pro foregroundCB, event

pro_name = 'foregroundCB'
@getinfo

widget_control, get_uvalue=info, event.top

widget_control, info.widgets.foreground, get_value=foreground

change_index = 0
if foreground lt 0 then foreground = 0
;if foreground gt !D.N_COLORS - 1 then foreground = !D.N_COLORS - 1
if foreground gt info.top_color - 1 then begin
    foreground = info.top_color - 1
    if info.style.colorindex eq !P.COLOR then begin
	info.style.colorindex = 255
	change_index = 1
    endif
endif else begin
    if info.style.colorindex eq !P.COLOR then begin
	info.style.colorindex = foreground
	change_index = 1
    endif
    if info.style.colorindex eq 255 then begin
	info.style.colorindex = foreground
	change_index = 1
    endif
endelse
!P.COLOR = foreground

if change_index eq 1 then widget_control, set_uvalue=info, info.base

if(widget_info(info.widgets.base, /VALID_ID)) then begin
	info.view.p_old.COLOR = foreground
	widget_control, set_uvalue=info, info.widgets.base
endif

if info.style.colorindex eq !P.BACKGROUND then begin
    if foreground ne !P.BACKGROUND then begin
	info.style.colorindex = foreground
	widget_control, set_uvalue=info, info.base
	if(widget_info(info.widgets.base, /VALID_ID)) then $
	    widget_control, set_uvalue=info, info.widgets.base
    endif
endif

print,'Foreground color =',foreground
if !P.COLOR eq !P.BACKGROUND then begin
	message=['The foreground color is set to same as background color', $
		 'you need to change the background color to distinguish the data!']
        result=dialog_message(message, title='View HDF Warning!')
endif

widget_control, event.top, /destroy

end

;--------------------------------------------------------------------------------
pro change_foreground, info

pro_name = 'change_foreground'
@getinfo

base = widget_base(COLUMN=1, MAP=1, TITLE='Define Forekground Color')

f_group=widget_base(base, row=1,map=1)

info.widgets.foreground = CW_FIELD(f_group, VALUE=!P.COLOR, $
		ROW=1, FLOATING=1, FIELDFONT=info.font, $
		FONT=info.font, TITLE='Foreground Color:', XSIZE=10)

group2=widget_base(base, row=1,map=1, space=40, /align_center)

button1=widget_button(group2, FONT=info.font, EVENT_PRO='foregroundCB', VALUE="Done",$
	/ALIGN_CENTER)

button2=widget_button(group2, FONT=info.font, EVENT_PRO='doneCB', VALUE="Cancel",$
	 /ALIGN_CENTER)

widget_control, /realize, base

widget_control, set_uvalue=info, base

end

;--------------------------------------------------------------------------------
pro change_data_type, this_subset, info

pro_name = 'change_data_type'
@getinfo

data_name = info.subset.data(this_subset).subset_name
data_name = data_name(0)
dot=strpos(data_name, '[')
if( dot ne -1) then begin
	xtitle=strmid(data_name,0,dot)
endif else xtitle = data_name
data_type = info.subset.data(this_subset).src_types(0)
if info.subset.data(this_subset).src_type_flag eq 0 then begin
	hdf_data_x = *info.subset.data(this_subset).src_data
	if data_type eq 4 or data_type eq 3 then begin
	    hdf_data_x = byte(hdf_data_x)
	endif
	size_hdf_data = size(hdf_data_x)
	hdf_data_x = reform(hdf_data_x,n_elements(hdf_data_x))
endif else begin
	hdf_data_temp = *info.subset.data(this_subset).src_data
	hdf_data_x = hdf_data_temp.components0
	if data_type eq 4 or data_type eq 3 then begin
	    hdf_data_x = byte(hdf_data_x)
	endif
	size_hdf_data = size(hdf_data_x)
	hdf_data_x = reform(hdf_data_x,n_elements(hdf_data_x))
endelse
;data_type = info.subset.data(this_subset).src_types(0)
filldata_value = get_filldata_value(data_type, info.filldata)
if filldata_value gt info.filldata then filldata_value = info.filldata

idltypename = size(hdf_data_x, /TNAME)
if data_type eq 4 or data_type eq 3 then idltypename = 'STRING'
hdftypename = convert_idltypename_hdftypename(idltypename)

the_list = ['DFNT_FLOAT32', 'DFNT_FLOAT64', 'DFNT_UINT8', 'DFNT_INT16', $
		'DFNT_INT32', 'DFNT_CHAR']
if info.version gt 5.2 then the_list = [the_list, 'DFNT_UINT16', 'DFNT_UINT32', $
	'DFNT_INT64', 'DFNT_UINT64']
the_list = [the_list, 'Cancel']
num_list = n_elements(the_list)
title = 'Change Data Type'
the_message = ['The original data type of', xtitle, 'is '+hdftypename, ' ', $
	'Change to one of the following types:']
default_option = num_list-1
sel_option = get_option(default_option,the_list,title,the_message,info)
if sel_option eq num_list-1 then return

changetypename = the_list(sel_option)
if changetypename eq hdftypename then return

changehdftype = convert_hdftypename_hdftype(changetypename)
changeidltype = convert_hdftype_idltype(changehdftype)

change_filldata = get_filldata(changehdftype, info.filldata)

if filldata_value gt 0 then begin
    subscript = where(hdf_data_x ge filldata_value, count)
endif else begin
    subscript = where(hdf_data_x le filldata_value, count)
endelse
case changeidltype of
	1: hdf_data_x = byte(hdf_data_x)
	2: hdf_data_x = fix(hdf_data_x)
	3: hdf_data_x = long(hdf_data_x)
	4: hdf_data_x = float(hdf_data_x)
	5: hdf_data_x = double(hdf_data_x)
	7: hdf_data_x = byte(hdf_data_x)
	12: hdf_data_x = uint(hdf_data_x)
	13: hdf_data_x = ulong(hdf_data_x)
	14: hdf_data_x = long64(hdf_data_x)
	15: hdf_data_x = ulong64(hdf_data_x)
	else:
endcase

if count ne 0 then hdf_data_x(subscript) = change_filldata

if info.subset.data(this_subset).src_type_flag eq 0 then begin
	case size_hdf_data(0) of
		2: hdf_data = reform(hdf_data_x, size_hdf_data(1), size_hdf_data(2))
		3: hdf_data = reform(hdf_data_x, size_hdf_data(1), size_hdf_data(2), $
			size_hdf_data(3))
		else: hdf_data = hdf_data_x
	endcase
endif else begin
	if size_hdf_data(0) eq 1 then begin
		the_order = 1
		num_rec = size_hdf_data(1)
	endif else begin
		the_order = size_hdf_data(1)
		num_rec = size_hdf_data(2)
	endelse
	blank = array_type(changehdftype, the_order)
	single_record=create_struct( 'components' + '0', blank)
	hdf_data=replicate(single_record, num_rec)
	jj=0L
	for i=0L, num_rec-1 do begin
		for j=0L, the_order-1 do begin
			hdf_data(i).components0(j) = hdf_data_x(jj)
			jj = jj + 1
		endfor
	endfor
endelse

info.subset.data(this_subset).src_types(0) = long(changehdftype)
ptr_free, info.subset.data(this_subset).src_data
info.subset.data(this_subset).src_data = ptr_new(hdf_data)

;if(widget_info(info.widgets.base, /VALID_ID)) then $
;	widget_control, set_uvalue=info, info.widgets.base
widget_control, set_uvalue=info, info.base
save_list = redefine_save_list(info)
widget_control, set_uvalue=save_list, info.list_base

result=dialog_message('Change Data Type Completed!', title='Notice!')

end

;--------------------------------------------------------------------------------
pro check_file, info

pro_name = 'check_file'
@getinfo

    if info.library_status eq 0 then return

    widget_control,info.widgets.current_file,get_value=filename
    filename = filename(0)

    result = where(info.name_list_vdata eq 'CERES_metadata', count)
    if count eq 0 then return

    the_vdata_name = ''
    the_vdata_name = info.name_list_vdata(result)

    number_of_fields=0L

    CD, '.', CURRENT = PWD

    ;the_result = CALL_EXTERNAL(PWD+'/' + info.library,   $
;    the_result = CALL_EXTERNAL(info.library, 		$
;			'get_vdata_fields',  		$
;                	filename,			$
;			the_vdata_name,			$
;			number_of_fields,		$
;			/s_value)

    num_vdata = 1
    the_result = get_vdata_fields(filename,the_vdata_name,number_of_fields,num_vdata,$
	vdata_ref, the_nrec)

    if the_result eq "BAD" then return
    
    	the_vfield_list = str_sep(the_result, ',')

	;the_nrec=1L

    result = where(the_vfield_list eq 'LOCALGRANULEID', count)
    if count eq 0 then return

	the_name = ''
	the_index = result
	the_name = the_vfield_list(the_index)
	the_types=long(1)
	the_order=long(1)

	this_start = 0L
	this_end = the_nrec
	this_increment = 1L

	CD, '.', CURRENT = PWD

	;the_result = CALL_EXTERNAL(PWD+'/' + info.library,   $
;	the_result = CALL_EXTERNAL(info.library, 		$
;		'get_vfield_types',  	$
;        	filename, 		$
;		the_vdata_name,		$ 
;		the_index,		$
;		long(1),		$
;		the_types,		$
;		the_order,		$
;		/s_value)

	if info.version lt 5.19 and info.library_status eq 1 then begin
		the_result = CALL_EXTERNAL(info.library,   $
			'get_vfield_types_eos',	$
			filename,		$
			the_vdata_name,		$
			vdata_ref,		$
			the_index,		$
			long(1),		$
			the_types,		$
			the_order,		$
			/s_value)

		if the_types(0) ne 4 then return
		blank = array_type(20L, the_order+1)
		single_record=create_struct( 'components' + '0', blank)
		output_data=replicate(single_record, (the_nrec))

;-------------------------------------------
; Now read in the vdata from the HDF file
;-------------------------------------------

;	CD, '.', CURRENT = PWD

	;the_result = CALL_EXTERNAL(PWD+'/' + info.library,   $
;	the_result = CALL_EXTERNAL(info.library, 		$
;		'read_vdata',  			$
;        	filename, 			$
;		the_vdata_name,			$
;		long(1), 			$
;		this_start,            	 	$
;		the_nrec-1,			$
;		this_increment,			$
;		the_name, 			$
;		the_types,			$
;		the_order,			$
;		output_data)

		the_result = CALL_EXTERNAL(info.library,   $
			'read_vdata_eos',	$
			filename,		$
			the_vdata_name,		$
			vdata_ref,		$
			long(1),		$
			this_start,		$
			the_nrec-1,		$
			this_increment,		$
			the_name,		$
			the_types,		$
			the_order,		$
			output_data)
	endif else begin
		the_result = get_vfield_type(filename,the_vdata_name,vdata_ref, $
			the_index,the_types,the_order,info.version, $
			info.library, info.library_status, 0)
		if the_types(0) ne 4 then return
		the_result = read_vdata(filename, the_vdata_name, vdata_ref, $
			the_nrec-1, the_order, the_types, the_name, output_data)
	endelse

	if the_result eq -1 then return 

	  num_rec = 1
	  single_record=create_struct( 'components' + '0', '')
	  output_data_1=replicate(single_record, num_rec)
 
	  output_data_1(0).components0 = ''
	  j=0L
	  while((output_data.components0(j) ne 0) and (j lt the_order)) do begin
	    output_data_1(0).components0 = output_data_1(0).components0 + string(output_data.components0(j))
	    j=j+1
	    if j eq the_order then output_data.components0(j) = 0
	  endwhile
	  output_data = output_data_1 

	test_filename=STRPOS(output_data.components0, 'CER_ES8')
	if test_filename eq -1 then info.filldata = 1.0E+35 $
		else info.filldata = 32700 

	test_filename=STRPOS(output_data.components0, 'CER_SSF')
	if test_filename ne -1 then info.ssf.file = 1

	test_filename=STRPOS(output_data.components0, 'CER_CRS')
	if test_filename ne -1 then info.ssf.file = 1

	test_filename=STRPOS(output_data.components0, 'CER_BDS')
	if test_filename ne -1 then info.bds_file = 1

end

;--------------------------------------------------------------------------------
pro create_subset, info, this_subset

pro_name = 'create_subset'
@getinfo

get_criterion, info, 1

widget_control, /hourglass

widget_control, get_uvalue=info, info.base
if info.criterion.flag eq 0 then return

x_starting=info.subset.data(this_subset).src_start(0)
x_ending=info.subset.data(this_subset).src_end(0)
if info.subset.data(this_subset).src_type_flag eq 1 then x_ending = x_ending + 1
x_increment=info.subset.data(this_subset).src_increment(0)

c_starting=info.subset.data(info.criterion.index).src_start(0)
c_ending=info.subset.data(info.criterion.index).src_end(0)
c_increment=info.subset.data(info.criterion.index).src_increment(0)
if info.subset.data(info.criterion.index).src_type_flag eq 1 then c_ending = c_ending + 1
if(c_starting gt x_starting or c_ending lt x_ending) then begin
	the_message = ['The range of criterion data is less than selected data!',$
			'Increase the range of criterion data and do it again!!!']
	result=dialog_message(the_message, title='View HDF Warning!')
	info.criterion.flag = 0
	;WIDGET_CONTROL, info.widgets.criterion, SENSITIVE = info.criterion.flag
	return
endif

if(c_increment ne 1 and c_increment ne x_increment) then begin
	the_message = ['The increment of criterion data is not equal selected data,',$
			'or the increment of criterion data is not equal to ONE!', $
			'Change the increment of criterion data and do it again!!!']
	result=dialog_message(the_message, title='View HDF Warning!')
	info.criterion.flag = 0
	;WIDGET_CONTROL, info.widgets.criterion, SENSITIVE = info.criterion.flag
	return
endif

criterion_data = *info.subset.data(info.criterion.index).src_data
size_c_data = size(criterion_data)
c_begin = x_starting - c_starting
c_end = x_ending - c_starting - 1

case size_c_data(0) of
	1: begin
		if x_increment eq 1 and c_increment eq 1 then begin
			criterion_data = criterion_data(c_begin:c_end)
		endif else if x_increment eq c_increment then begin
			check_mod = c_begin mod x_increment
			if check_mod ne 0 then begin
				the_message = ['The location of criterion data is not matched selected data,',$
					'Change the location of criterion data and do it again!!!']
				result=dialog_message(the_message, title='View HDF Warning!')
				info.criterion.flag = 0
				;WIDGET_CONTROL, info.widgets.criterion, SENSITIVE = info.criterion.flag
				return
			endif
			real_start = c_begin/x_increment
			;real_end = long((c_end+1.0)/x_increment + 0.9) - 1
			real_end = long(c_end/x_increment + 1.0) - 1
			criterion_data = criterion_data(real_start:real_end)
		endif else begin
			;array_size = long((x_ending-x_starting)/float(x_increment) + 0.9)
			array_size = long((x_ending-x_starting-1)/float(x_increment) + 1.0)
			the_type = info.subset.data(info.criterion.index).src_types
			the_type = the_type(0)
			if info.subset.data(info.criterion.index).src_type_flag eq 0 then begin
				criterion_temp_data = array_type(the_type, array_size)
				if (criterion_temp_data(0) eq -1) then begin
				   result=dialog_message('Unable to allocate memory for temporary criterion data!',$
				   title='View HDF Warning!')
				   info.criterion.flag = 0
				   ;WIDGET_CONTROL, info.widgets.criterion, SENSITIVE = info.criterion.flag
        			   return
				endif
				jj = 0L
				for j = c_begin, c_end, x_increment do begin
					criterion_temp_data(jj)= criterion_data(j)
					jj = jj + 1
				endfor
			endif else begin
				the_order = info.subset.data(info.criterion.index).src_order(0)
				the_order = the_order(0)
				blank = array_type(the_type, the_order)
				if (blank(0) eq -1) then begin
				   result=dialog_message('Unable to allocate memory for temporary criterion data!',$
				   title='View HDF Warning!')
				   info.criterion.flag = 0
				   ;WIDGET_CONTROL, info.widgets.criterion, SENSITIVE = info.criterion.flag
        			   return
				endif
				single_record=create_struct( 'components' + '0', blank) 
				criterion_temp_data=replicate(single_record, array_size)
				jj = 0L
				for j = c_begin, c_end, x_increment do begin
					criterion_temp_data(jj).components0 = criterion_data(j).components0
					jj = jj + 1
				endfor
			endelse
			criterion_data = criterion_temp_data
		endelse
	   end 
	2: begin
		if x_increment eq 1 and c_increment eq 1 then begin
			criterion_data = criterion_data(*,c_begin:c_end)
		endif else if x_increment eq c_increment then begin
			check_mod = c_begin mod x_increment
			if check_mod ne 0 then begin
				the_message = ['The location of criterion data is not matched selected data,',$
					'Change the location of criterion data and do it again!!!']
				result=dialog_message(the_message, title='View HDF Warning!')
				info.criterion.flag = 0
				;WIDGET_CONTROL, info.widgets.criterion, SENSITIVE = info.criterion.flag
				return
			endif
			real_start = c_begin/x_increment
			;real_end = long((c_end+1.0)/x_increment + 0.9) - 1
			real_end = long(c_end/x_increment + 1.0) - 1
			criterion_data = criterion_data(*,real_start:real_end)
		endif else begin
			start_list = info.subset.data(info.criterion.index).src_start(0:1)
			end_list = info.subset.data(info.criterion.index).src_end(0:1)
			increment_list = info.subset.data(info.criterion.index).src_increment(0:1)
			start_list(0) = x_starting
			end_list(0) = x_ending
			increment_list(0) = x_increment
			;array_size = long((end_list-start_list)/float(increment_list) + 0.9)
			array_size = long((end_list-start_list-1)/float(increment_list) + 1.0)
			the_type = info.subset.data(info.criterion.index).src_types
			the_type = the_type(0)
			criterion_temp_data = array_type(the_type, array_size)
			if (criterion_temp_data(0) eq -1) then begin
				result=dialog_message('Unable to allocate memory for temporary criterion data!',$
					title='View HDF Warning!')
				info.criterion.flag = 0
				;;WIDGET_CONTROL, info.widgets.criterion, SENSITIVE = info.criterion.flag
				return
			endif
			jj = 0L
			for j = c_begin, c_end, x_increment do begin
				criterion_temp_data(*, jj) = criterion_data(*, j)
				jj = jj + 1
			endfor
			criterion_data = criterion_temp_data
		endelse
	   end 
	else: begin
		the_message = ['The rank of criterion data is not supported!',$
				'Check the criterion data and do it again!!!']
		result=dialog_message(the_message, title='View HDF Warning!')
		info.criterion.flag = 0
		;WIDGET_CONTROL, info.widgets.criterion, SENSITIVE = info.criterion.flag
		return
	      end
endcase

this_type = info.subset.data(this_subset).src_types
this_type = this_type(0)
filldata = get_filldata(this_type, info.filldata)
;case this_type of
;	21: filldata = 255
;	22: filldata = 32767
;	23: filldata = 65535
;	24: filldata = 2147483647
;	25: filldata = 2147483647
;	else: begin
;		if info.filldata lt 3.0E+37 then filldata = info.filldata * 10  $
;			else filldata = 3.0E+38
;	     end
;endcase

crite_name = strlowcase(info.criterion.name)
check_longitude = strpos(crite_name, 'longitude')
if check_longitude ne -1 then crite_long = 1 $
        else crite_long = 0
if crite_long eq 1 then begin
    cross_green = 0
    if info.criterion.min lt 0.0 and info.criterion.max ge 0.0 then begin
	if info.criterion.min ge -180.0 and info.criterion.max le 180.0 then $
	    cross_green = 1
    endif
    if info.criterion.min gt info.criterion.max then begin
	if info.criterion.min lt 360.0 and info.criterion.max ge 0.0 then begin
	    info.criterion.min = info.criterion.min - 360.0
	    cross_green = 1
	endif
    endif
    crite_type = info.subset.data(info.criterion.index).src_types
    crite_type = crite_type(0)
    crite_filldata = get_filldata(crite_type, info.filldata)
    crite_temp_data = criterion_data
    if crite_filldata gt 0 then begin
	neg_long = where(crite_temp_data lt crite_filldata, count)
    endif else begin
        neg_long = where(crite_temp_data gt crite_filldata, count)
    endelse
    if count ne 0 then crite_temp_data = crite_temp_data(neg_long) $
    else begin
	the_message = ['All the criterion data are filled data!']
	result=dialog_message(the_message, title='View HDF Warning!')
	info.criterion.flag = 0
	;WIDGET_CONTROL, info.widgets.criterion, SENSITIVE = info.criterion.flag
	return
    endelse
    crite_max = max(crite_temp_data, min=crite_min)
    if cross_green eq 0 then begin
	;if (crite_min lt 0.0 and crite_min gt -180.0) then begin
	if (crite_min lt 0.0 and crite_min ge -180.0) then begin
	    if crite_filldata gt 0 then begin
		neg_long = where(criterion_data lt 0.0 and criterion_data lt crite_filldata, count)
	    endif else begin
		neg_long = where(criterion_data lt 0.0 and criterion_data gt crite_filldata, count)
	    endelse
	    if count ne 0 then criterion_data(neg_long) = 360.0 + criterion_data(neg_long)
	endif
	if info.criterion.max eq 0.0 and info.criterion.min lt 0.0 then $
	    info.criterion.max = 360.0
	;if info.criterion.min lt 0.0 and info.criterion.min gt -180.0 then $
	if info.criterion.min lt 0.0 and info.criterion.min ge -180.0 then $
	    info.criterion.min = 360.0 + info.criterion.min
	;if info.criterion.max lt 0.0 and info.criterion.max gt -180.0 then $
	if info.criterion.max lt 0.0 and info.criterion.max ge -180.0 then $
	    info.criterion.max = 360.0 + info.criterion.max
    endif else begin
	if (crite_max lt 360.0 and crite_max gt 180.0) then begin
	    if crite_filldata gt 0 then begin
		neg_long = where(criterion_data gt 180.0 and criterion_data lt crite_filldata, count)
	    endif else begin
		neg_long = where(criterion_data gt 180.0, count)
	    endelse
	    if count ne 0 then criterion_data(neg_long) = criterion_data(neg_long) - 360.0
	endif
    endelse
endif

hdf_data = *info.subset.data(this_subset).src_data
size_hdf_data = size(hdf_data)
case size_hdf_data(0) of
	1: begin
		if info.subset.data(this_subset).src_type_flag eq 0 then begin
			crite_temp_data = criterion_data 
			size_c_data = size(crite_temp_data)
			if(size_c_data(0) gt 1) then begin
				temp = 168
				if size_c_data(1) lt 168 then temp = fix(size_c_data(1)/2)
				crite_temp_data = crite_temp_data(temp,*)
			endif else if info.subset.data(info.criterion.index).src_type_flag eq 1 then begin
				crite_temp = crite_temp_data(*).components0(0)
				crite_temp_data = crite_temp
			endif
			if info.criterion.type eq 1 then begin
			    subscripts = where(crite_temp_data ge info.criterion.min and $
				crite_temp_data le info.criterion.max, count)
			endif else begin
			    subscripts = where(crite_temp_data lt info.criterion.min or $
				crite_temp_data gt info.criterion.max, count)
			endelse
			if count gt 0 then hdf_data(subscripts) = filldata
		endif else begin
			if info.subset.data(info.criterion.index).src_type_flag eq 0 then begin
				crite_temp_data = criterion_data
				size_c_data = size(crite_temp_data)
				if(size_c_data(0) gt 1) then begin
					temp = 168
					if size_c_data(1) lt 168 then temp = fix(size_c_data(1)/2)
					crite_temp_data = crite_temp_data(temp,*)
				endif 
				if info.criterion.type eq 1 then begin
				    subscripts = where(crite_temp_data ge info.criterion.min and $
					crite_temp_data le info.criterion.max, count)
				endif else begin
				    subscripts = where(crite_temp_data lt info.criterion.min or $
					crite_temp_data gt info.criterion.max, count)
				endelse
				if count gt 0 then hdf_data(subscripts).components0(*) = filldata
			endif else begin
				the_order = info.subset.data(this_subset).src_order(0)
				crite_order = info.subset.data(info.criterion.index).src_order(0)
				if crite_order eq the_order then begin
					for j=0L,size_hdf_data(1)-1 do begin
						crite_temp_data = criterion_data(j).components0
						if info.criterion.type eq 1 then begin
						    subscripts = where(crite_temp_data ge info.criterion.min and $
							crite_temp_data le info.criterion.max, count)
						endif else begin
						    subscripts = where(crite_temp_data lt info.criterion.min or $
                                        		crite_temp_data gt info.criterion.max, count)
						endelse
                                		if count gt 0 then $
							hdf_data(j).components0(subscripts) = filldata
					endfor
				endif else begin
					crite_temp_data = criterion_data(*).components0(0)
					if info.criterion.type eq 1 then begin
					    subscripts = where(crite_temp_data ge info.criterion.min and $
						crite_temp_data le info.criterion.max, count)
					endif else begin
                        		    subscripts = where(crite_temp_data lt info.criterion.min or $
                                		crite_temp_data gt info.criterion.max, count)
					endelse
                        		if count gt 0 then hdf_data(subscripts).components0(*) = filldata	
				endelse
			endelse
		endelse
	  end
	2: begin
		crite_temp_data = criterion_data 
		size_c_data = size(crite_temp_data)
		if(size_c_data(0) eq 1) then begin
			if info.subset.data(info.criterion.index).src_type_flag eq 1 then begin
				crite_temp = crite_temp_data(*).components0(0)
				crite_temp_data = crite_temp
			endif
			if info.criterion.type eq 1 then begin
			    subscripts = where(crite_temp_data ge info.criterion.min and $
				crite_temp_data le info.criterion.max, count)
			endif else begin
			    subscripts = where(crite_temp_data lt info.criterion.min or $
				crite_temp_data gt info.criterion.max, count)
			endelse
			if count gt 0 then hdf_data(*,subscripts) = filldata
		endif else begin
			y_starting=info.subset.data(this_subset).src_start(1)
			y_ending=info.subset.data(this_subset).src_end(1)
			y_increment=info.subset.data(this_subset).src_increment(1)
			cy_starting=info.subset.data(info.criterion.index).src_start(1)
			cy_ending=info.subset.data(info.criterion.index).src_end(1)
			cy_increment=info.subset.data(info.criterion.index).src_increment(1)
			if(cy_starting gt y_starting or cy_ending lt y_ending) then begin
				the_message = ['The range of criterion data is less than selected data!',$
					'Increase the range of criterion data and do it again!!!']
				result=dialog_message(the_message, title='View HDF Warning!')
				info.criterion.flag = 0
				;WIDGET_CONTROL, info.widgets.criterion, SENSITIVE = info.criterion.flag
				return
			endif
			if(cy_increment ne 1 and cy_increment ne y_increment) then begin
				the_message = ['The increment of criterion data is not equal selected data,',$
					'or the increment of criterion data is not equal to ONE!', $
				'Change the increment of criterion data and do it again!!!']
				result=dialog_message(the_message, title='View HDF Warning!')
				info.criterion.flag = 0
				;WIDGET_CONTROL, info.widgets.criterion, SENSITIVE = info.criterion.flag
				return
			endif
			cy_begin = y_starting - cy_starting
			cy_end = y_ending - cy_starting - 1
			if y_increment eq 1 and cy_increment eq 1 then begin
				;if (size_c_data(1) lt size_hdf_data(1)) or (cy_begin lt 0) or $
				 ;  (cy_end gt size_c_data(1)) then begin
					;the_message = ['The range of criterion data is less than subset data!',$
                                        	;'Increase the range of criterion data and do it again!!!']
                			;result=dialog_message(the_message, title='View HDF Warning!')
					;info.criterion.flag = 0
					;WIDGET_CONTROL, info.widgets.criterion, SENSITIVE = info.criterion.flag
                			;return
              			;endif
				jj = 0
				for j=cy_begin, cy_end do begin
					crite_temp_data = criterion_data(j,*)
					if info.criterion.type eq 1 then begin
					    subscripts = where(crite_temp_data ge info.criterion.min and $
						crite_temp_data le info.criterion.max, count)
					endif else begin
					    subscripts = where(crite_temp_data lt info.criterion.min or $
						crite_temp_data gt info.criterion.max, count)
					endelse
					if count gt 0 then hdf_data(jj,subscripts) = filldata
					jj = jj + 1
				endfor
			endif else if cy_increment eq y_increment then begin
				check_mod = cy_begin mod y_increment
				if check_mod ne 0 then begin
				  the_message = ['The location of criterion data is not matched selected data,',$
					'Change the location of criterion data and do it again!!!']
				  result=dialog_message(the_message, title='View HDF Warning!')
				  info.criterion.flag = 0
				  ;WIDGET_CONTROL, info.widgets.criterion, SENSITIVE = info.criterion.flag
				  return
				endif
				real_start = cy_begin/y_increment
				;real_end = long((cy_end+1.0)/y_increment + 0.9) - 1
				real_end = long(cy_end/y_increment + 1.0) - 1
				jj = 0
				for j=real_start, real_end do begin
					crite_temp_data = criterion_data(j,*)
					if info.criterion.type eq 1 then begin
					    subscripts = where(crite_temp_data ge info.criterion.min and $
						crite_temp_data le info.criterion.max, count)
					endif else begin
					    subscripts = where(crite_temp_data lt info.criterion.min or $
						crite_temp_data gt info.criterion.max, count)
					endelse
					if count gt 0 then hdf_data(jj,subscripts) = filldata
					jj = jj + 1
				endfor
			endif else begin
				jj = 0
				for j = cy_begin, cy_end, y_increment do begin
					crite_temp_data = criterion_data(j,*)
					if info.criterion.type eq 1 then begin
					    subscripts = where(crite_temp_data ge info.criterion.min and $
						crite_temp_data le info.criterion.max, count)
					endif else begin
                                            subscripts = where(crite_temp_data lt info.criterion.min or $
                                                crite_temp_data gt info.criterion.max, count)
					endelse
                                        if count gt 0 then hdf_data(jj,subscripts) = filldata
					jj = jj + 1
                                endfor
			endelse
		endelse
	   end
	else: begin
		the_message = ['The rank of criterion data is not supported!',$
					'Check the criterion data and do it again!!!']
		result=dialog_message(the_message, title='View HDF Warning!')
		info.criterion.flag = 0
		;WIDGET_CONTROL, info.widgets.criterion, SENSITIVE = info.criterion.flag
		return
	   end
endcase

name_of_data = info.subset.data(this_subset).subset_name
name_of_data = name_of_data(0)
search_result = strpos(name_of_data, 'Subset of')
if search_result eq -1 then temp_name = 'Subset of ' + name_of_data $
	else temp_name = name_of_data
get_variable_name, temp_name, info
widget_control, get_uvalue=info, info.base
if info.variablename eq 'None' then return
the_rank = info.subset.data(this_subset).src_rank
set_statistics_subset, info.variablename, this_subset, the_rank, info, hdf_data
info.criterion.flag = 0
;WIDGET_CONTROL, info.widgets.criterion, SENSITIVE = info.criterion.flag

end

;--------------------------------------------------------------------------------
pro filldataCB, event

pro_name = 'filldataCB'
@getinfo

widget_control, get_uvalue=info, event.top

widget_control, info.widgets.filldata, get_value=filldata

info.filldata=filldata

widget_control,info.widgets.current_file,get_value=filename
filename = filename(0)
if info.open_file.count gt 0 then begin
    count = info.open_file.count
    the_list = info.open_file.file(0:count-1)
    subscript = where(the_list eq filename, count)
    if count ne 0 then info.open_file.fill_data(subscript(0)) = info.filldata
endif
print,'Fill data=',info.filldata

if(widget_info(info.widgets.base, /VALID_ID)) then $
	widget_control, set_uvalue=info, info.widgets.base
widget_control, set_uvalue=info, info.base

widget_control, event.top, /destroy

end

;--------------------------------------------------------------------------------
pro filldata_dialogueCB, event

pro_name = 'filldata_dialogueCB'
@getinfo

widget_control, get_uvalue=info, event.top

base = widget_base(COLUMN=1, MAP=1, TITLE='Define Fill Data')

f_group=widget_base(base, row=1,map=1)

info.widgets.filldata = CW_FIELD(f_group, VALUE=info.filldata, $
		ROW=1, FLOATING=1, FIELDFONT=info.font, $
		FONT=info.font, TITLE='Fill Data:', XSIZE=40)

group2=widget_base(base, row=1,map=1, space=40, /align_center)

button1=widget_button(group2, FONT=info.font, EVENT_PRO='filldataCB', VALUE="Done",$
	/ALIGN_CENTER)

button2=widget_button(group2, FONT=info.font, EVENT_PRO='doneCB', VALUE="Cancel",$
	 /ALIGN_CENTER)

widget_control, /realize, base

widget_control, set_uvalue=info, base
widget_control, set_uvalue=info, info.base

end

;--------------------------------------------------------------------------------
pro filldata_dialogue, top_base, info

pro_name = 'filldata_dialogue'
@getinfo

base_loc = widget_info(top_base, /geometry)
xoffset = base_loc.xoffset + 100
yoffset = base_loc.yoffset + 100

base=widget_base(group_leader=top_base, /modal, column=1, xoffset=xoffset, $
	yoffset=yoffset, TITLE='Define Fill Data')

f_group=widget_base(base, row=1,map=1)

info.widgets.filldata = CW_FIELD(f_group, VALUE=info.filldata, $
		ROW=1, FLOATING=1, FIELDFONT=info.font, $
		FONT=info.font, TITLE='Fill Data:', XSIZE=40)

group2=widget_base(base, row=1,map=1, space=40, /align_center)

button1=widget_button(group2, FONT=info.font, EVENT_PRO='filldataCB', VALUE="Done",$
	/ALIGN_CENTER)

button2=widget_button(group2, FONT=info.font, EVENT_PRO='doneCB', VALUE="Cancel",$
	 /ALIGN_CENTER)

widget_control, /realize, base

widget_control, set_uvalue=info, base
widget_control, set_uvalue=info, info.base

end

;--------------------------------------------------------------------------------
pro charsizeCB, event

pro_name = 'charsizeCB'
@getinfo

widget_control, get_uvalue=info, event.top

widget_control, info.widgets.charsize, get_value=charsize

info.char.size=charsize

print,'plot character size=',info.char.size

if(widget_info(info.widgets.base, /VALID_ID)) then $
	widget_control, set_uvalue=info, info.widgets.base
widget_control, set_uvalue=info, info.base

widget_control, event.top, /destroy

end

;--------------------------------------------------------------------------------
pro charsize_dialogue, top_base, info

pro_name = 'charsize_dialogue'
@getinfo

base_loc = widget_info(top_base, /geometry)
xoffset = base_loc.xoffset + 100
yoffset = base_loc.yoffset + 100

base=widget_base(group_leader=top_base, /modal, column=1, xoffset=xoffset, $
	yoffset=yoffset, TITLE='Set the Plot Character Size')

c_group=widget_base(base, row=1,map=1)

info.widgets.charsize = CW_FIELD(c_group, VALUE=info.char.size, $
		ROW=1, FLOATING=1, FIELDFONT=info.font, $
		FONT=info.font, TITLE='Plot Character Size:', XSIZE=10)

group2=widget_base(base, row=1,map=1, space=40, /align_center)

button1=widget_button(group2, FONT=info.font, EVENT_PRO='charsizeCB', VALUE="Done",$
	/ALIGN_CENTER)

button2=widget_button(group2, FONT=info.font, EVENT_PRO='doneCB', VALUE="Cancel",$
	 /ALIGN_CENTER)

widget_control, /realize, base

widget_control, set_uvalue=info, base
widget_control, set_uvalue=info, info.base

end

;--------------------------------------------------------------------------------
pro fit_data_range, axis_state, flag, plot_type, out_error, xrange, yrange, $
	zrange, y2range, hdf_data_x, hdf_data_y, hdf_data_z, hdf_data_y2, my_color

pro_name = 'fit_data_range'
@getinfo

flag = 0
size_of_x = size(hdf_data_x)
size_of_y = size(hdf_data_y)
size_of_z = size(hdf_data_z)
size_of_y2 = size(hdf_data_y2)
size_of_xrange = size(xrange)
size_of_yrange = size(yrange)
size_of_zrange = size(zrange)
size_of_y2range = size(y2range)

if size_of_xrange(0) gt 0 then begin
    if (axis_state eq 1) or (axis_state eq 4) or (axis_state eq 5) or (axis_state eq 8) $
	or (axis_state eq 9) then begin
	    xmin = xrange(0)
	    xmax = xrange(1)
	    if plot_type eq 1 then begin
		cross_green = 0
		If xmin lt 0.0 and xmax ge 0.0 then begin
		    If xmin ge -180.0 and xmax le 180.0 then cross_green = 1 $
		    else begin
			if out_error eq 1 then begin
			    the_message = ['The ranges of longitude is not right!', $
				'Check the ranges and do it again!']
			    result=dialog_message(the_message, title='View HDF Warning!')
			endif
			    flag = 1
			    return
		    endelse
		endif

		if xmin gt xmax then begin
		    if xmin lt 360.0 and xmax ge 0.0 then begin
			xmin = xmin - 360.0
			cross_green = 1
		    endif else begin
			if out_error eq 1 then begin
			    the_message = ['The ranges of longitude is not right!', $
				'Check the ranges and do it again!']
			    result=dialog_message(the_message, title='View HDF Warning!')
			endif
			flag = 1
			return
		    endelse
		endif

		if cross_green eq 0 then begin
		    lon_max = max(hdf_data_x, min=lon_min)
		    ;if(lon_min lt 0.0 and lon_min gt -180.0) then begin
		    if(lon_min lt 0.0 and lon_min ge -180.0) then begin
			neg_long = where(hdf_data_x lt 0.0, count)
			if count ne 0 then hdf_data_x(neg_long) = 360.0 + hdf_data_x(neg_long)
		    endif
		    if xmax eq 0.0 and xmin lt 0.0 then xmax = 360.0
		    ;if xmin lt 0.0 and xmin gt -180.0 then $
		    if xmin lt 0.0 and xmin ge -180.0 then $
			xmin = 360.0 + xmin
		    ;if xmax lt 0.0 and xmax gt -180.0 then $
		    if xmax lt 0.0 and xmax ge -180.0 then $
			xmax = 360.0 + xmax
		endif else begin
		    lon_max = max(hdf_data_x, min=lon_min)
		    if(lon_max lt 360.0 and lon_max gt 180.0) then begin
			neg_long = where(hdf_data_x gt 180.0, count)
			if count ne 0 then hdf_data_x(neg_long) = hdf_data_x(neg_long) - 360.0
		    endif
		endelse
	    endif
	    if xmin le xmax then begin
		subscript = where(hdf_data_x ge xmin and hdf_data_x le xmax, count)
	    endif else begin
		subscript = where(hdf_data_x le xmin and hdf_data_x ge xmax, count)
	    endelse
	    ;subscript = where(hdf_data_x ge xrange(0) and hdf_data_x le xrange(1), count)
	    if count ne 0 then begin
		hdf_data_x = hdf_data_x(subscript)
		if plot_type eq 3 then begin
		    if size_of_z(0) gt 0 then hdf_data_z = hdf_data_z(*,subscript)
		    my_color = my_color(*,subscript)
		endif else begin
		    if size_of_y(0) gt 0 then hdf_data_y = hdf_data_y(subscript)
		    if size_of_z(0) gt 0 then hdf_data_z = hdf_data_z(subscript)
		    if size_of_y2(0) gt 0 then hdf_data_y2 = hdf_data_y2(subscript)
		    if plot_type gt 0 then my_color = my_color(subscript)
		endelse
	    endif else begin
		if out_error eq 1 then begin
		    result=dialog_message( "All the X data are out of range!", $
			title='View HDF Warning!')
		endif
		flag = 1
		return
	    endelse
    endif
endif

if size_of_yrange(0) gt 0 then begin
    if (axis_state eq 2) or (axis_state eq 4) or (axis_state eq 5) or (axis_state eq 7) $
	or (axis_state eq 9) then begin
	    if yrange(0) le yrange(1) then begin
		subscript = where(hdf_data_y ge yrange(0) and hdf_data_y le yrange(1), count)
	    endif else begin
		subscript = where(hdf_data_y le yrange(0) and hdf_data_y ge yrange(1), count)
	    endelse
	    if count ne 0 then begin
		hdf_data_y = hdf_data_y(subscript)
		if plot_type eq 3 then begin
		    if size_of_z(0) gt 0 then hdf_data_z = hdf_data_z(subscript,*)
		    my_color = my_color(subscript,*)
		endif else begin
		    if size_of_x(0) gt 0 then hdf_data_x = hdf_data_x(subscript)
		    if size_of_z(0) gt 0 then hdf_data_z = hdf_data_z(subscript)
		    if size_of_y2(0) gt 0 then hdf_data_y2 = hdf_data_y2(subscript)
		    if plot_type gt 0 then my_color = my_color(subscript)
		endelse
	    endif else begin
		if out_error eq 1 then begin
		    result=dialog_message( "All the Y data are out of range!", $
			title='View HDF Warning!')
		endif
		flag = 1
		return
	    endelse
    endif
endif

if plot_type eq 3 then return

if size_of_zrange(0) gt 0 then begin
    if (axis_state eq 3) or (axis_state eq 5) then begin
	if zrange(0) le zrange(1) then begin
	    subscript = where(hdf_data_z ge zrange(0) and hdf_data_z le zrange(1), count)
	endif else begin
	    subscript = where(hdf_data_z le zrange(0) and hdf_data_z ge zrange(1), count)
	endelse
	if count ne 0 then begin
	    hdf_data_z = hdf_data_z(subscript)
	    if size_of_x(0) gt 0 then hdf_data_x = hdf_data_x(subscript)
	    if size_of_y(0) gt 0 then hdf_data_y = hdf_data_y(subscript)
	    if plot_type gt 0 then my_color = my_color(subscript)
	endif else begin
	    if out_error eq 1 then begin
		result=dialog_message( "All the Z data are out of range!", $
		    title='View HDF Warning!')
	    endif
	    flag = 1
	    return
	endelse
    endif
endif

if size_of_y2range(0) gt 0 then begin
    if (axis_state gt 5) then begin
	if y2range(0) le y2range(1) then begin
	    subscript = where(hdf_data_y2 ge y2range(0) and hdf_data_y2 le y2range(1), count)
	endif else begin
	    subscript = where(hdf_data_y2 le y2range(0) and hdf_data_y2 ge y2range(1), count)
	endelse
	if count ne 0 then begin
	    hdf_data_y2 = hdf_data_y2(subscript)
	    if size_of_x(0) gt 0 then hdf_data_x = hdf_data_x(subscript)
	    if size_of_y(0) gt 0 then hdf_data_y = hdf_data_y(subscript)
	endif else begin
	    if out_error eq 1 then begin
		result=dialog_message( "All the Y2 data are out of range!", $
		    title='View HDF Warning!')
	    endif
	    flag = 1
	    return
	endelse
    endif
endif

end

;--------------------------------------------------------------------------------
pro rotationCB, event

pro_name = 'rotationCB'
@getinfo

widget_control, get_uvalue=info, event.top

widget_control, info.widgets.rotateax, get_value=rotateax

widget_control, info.widgets.rotateaz, get_value=rotateaz

info.rotate.ax = rotateax
info.rotate.az = rotateaz

print,'Rotation angles = ', info.rotate.ax, ' and ', info.rotate.az

if(widget_info(info.widgets.base, /VALID_ID)) then $
	widget_control, set_uvalue=info, info.widgets.base
widget_control, set_uvalue=info, info.base

widget_control, event.top, /destroy
plot_graph, 1, info.subset.selected, info

end

;--------------------------------------------------------------------------------
pro rotation_dialogueCB, event

pro_name = 'rotation_dialogueCB'
@getinfo

widget_control, get_uvalue=info, event.top

base = widget_base(COLUMN=1, MAP=1, TITLE='Define Rotation Angles')

r_group=widget_base(base, row=1,map=1)

info.widgets.rotateax = CW_FIELD(r_group, VALUE=info.rotate.ax, $
		ROW=1, FLOATING=1, FIELDFONT=info.font, $
		FONT=info.font, TITLE='Rotation AX:', XSIZE=10)

info.widgets.rotateaz = CW_FIELD(r_group, VALUE=info.rotate.az, $
		ROW=1, FLOATING=1, FIELDFONT=info.font, $
		FONT=info.font, TITLE='Rotation AZ:', XSIZE=10)

group2=widget_base(base, row=1,map=1, space=100, /align_center)

button1=widget_button(group2, FONT=info.font, EVENT_PRO='rotationCB', VALUE="Done",$
	/ALIGN_CENTER)

button2=widget_button(group2, FONT=info.font, EVENT_PRO='doneCB', VALUE="Cancel",$
	 /ALIGN_CENTER)

widget_control, /realize, base

widget_control, set_uvalue=info, base
widget_control, set_uvalue=info, info.base

end

;--------------------------------------------------------------------------------
pro clear_plot_dia, id

pro_name = 'clear_plot_dia'
@getinfo

    widget_control, get_uvalue=info, id
    widget_control, get_uvalue=info, info.base

    if info.multiple.key gt 0 then begin
	info.multiple.flag = 0
	info.multiple.key = 0
	info.multiple.y1y2 = 0
	info.style.linetype = info.multiple.linetype
	info.style.symbol = info.multiple.symbol
	info.style.symbolsize = info.multiple.symbolsize
	info.style.symbolline = info.multiple.symbolline
	info.style.colorindex = info.multiple.colorindex
    endif

    if info.addtext.key eq 1 then begin
	info = initial_addtext(info)
    endif

    if (info.graph_style eq 'Geolocated' or $
	info.graph_style eq 'Contour Geolocated') then begin
	    if ptr_valid(info.geolocated.hdf_z) then ptr_free, $
		info.geolocated.hdf_z
	    if ptr_valid(info.geolocated.long) then ptr_free, $
		info.geolocated.long
	    if ptr_valid(info.geolocated.colat) then ptr_free, $
		info.geolocated.colat
	    if ptr_valid(info.geolocated.sate_long) then ptr_free, $
		info.geolocated.sate_long
	    if ptr_valid(info.geolocated.sate_colat) then ptr_free, $
		info.geolocated.sate_colat
	    if ptr_valid(info.geolocated.sun_long) then ptr_free, $
		info.geolocated.sun_long
	    if ptr_valid(info.geolocated.sun_colat) then ptr_free, $
		info.geolocated.sun_colat
    endif

    if (info.graph_style eq 'Browse Image' or $
	info.graph_style eq 'Browse Image With Average') then begin
	    if ptr_valid(info.browse_image.z) then ptr_free, $
		info.browse_image.z
	    if ptr_valid(info.browse_image.x) then ptr_free, $
		info.browse_image.x
	    if ptr_valid(info.browse_image.y) then ptr_free, $
		info.browse_image.y
	    if ptr_valid(info.browse_image.image) then ptr_free, $
		info.browse_image.image
	    if ptr_valid(info.browse_image.xarray) then ptr_free, $
		info.browse_image.xarray
	    if ptr_valid(info.browse_image.yarray) then ptr_free, $
		info.browse_image.yarray
	    if ptr_valid(info.browse_image.tarray) then ptr_free, $
		info.browse_image.tarray
	    if ptr_valid(info.browse_image.barray) then ptr_free, $
		info.browse_image.barray
	    if ptr_valid(info.browse_image.aarray) then ptr_free, $
		info.browse_image.aarray
	    if ptr_valid(info.browse_image.parray) then ptr_free, $
		info.browse_image.parray
	    info.browse_image.farray(*) = -1
	    info.browse_image.number = 0
	    info.browse_image.findex = -1
	    info.browse_image.feature = 0
	    info.browse_image.rootname = ''
	    info.browse_image.profile = 'full'

	    if(widget_info(info.browse_image.base, /VALID_ID)) then $
		widget_control, info.browse_image.base, /destroy
    endif

    if info.graph_style eq 'Vertical Feature Mask' or $
	info.graph_style eq 'Old Vertical Feature Mask' then begin
	    if ptr_valid(info.vfm.data) then ptr_free, info.vfm.data
    endif

    if info.overlay.flag eq 1 then begin
	info.overlay.flag = 0
	info.overlay.offflag = 0
	if ptr_valid(info.overlay.image) then ptr_free, $
	    info.overlay.image
    endif

    if(widget_info(info.widgets.subset_base, /VALID_ID)) then begin
	widget_control, info.widgets.subset_base, /destroy
    endif

    ;wdelete, 5
    delete_window, 5

    widget_control, id, /destroy

end

;--------------------------------------------------------------------------------
pro check_pause, id

pro_name = 'check_pause'
@getinfo

; print,'call the check_pause'

if !UserPause eq 0 then begin
    !UserPause = 1
    !UserDone = 1
endif; else begin
    clear_plot_dia, id
;endelse

end

;--------------------------------------------------------------------------------
pro stop_dialogueCB, event

pro_name = 'stop_dialogueCB'
@getinfo

; print,'stop_dialogueCB: !UserDone = ',!UserDone
if !UserDone eq 1 then return

!UserStop = 0

end

;--------------------------------------------------------------------------------
pro pause_dialogueCB, event

pro_name = 'pause_dialogueCB'
@getinfo

widget_control, get_uvalue=info, event.top

if !UserDone eq 1 then begin
    if event.select eq 1 then begin
	widget_control, set_button=0, info.widgets.pause
    endif
    return
endif

if event.select eq 0 then begin
    !UserPause = 1
    return
endif

if event.select eq 1 then begin
    !UserPause = 0
    while(!UserPause eq 0) do begin
	if !D.Name ne 'WIN' then begin
	    result = widget_event(info.widgets.pause,/Nowait, /save_hourglass)
	    result = widget_event(info.widgets.stop,/Nowait, /save_hourglass)
	endif else begin
	    ;  If put a hourglass in WIN, it will not get the signal of stop or pause widget
	    result = widget_event(info.widgets.pause,/Nowait)
	    result = widget_event(info.widgets.stop,/Nowait)
	endelse
	if(!UserStop eq 0) then begin
	    !UserPause = 1
	    widget_control, set_button=0, info.widgets.pause
	endif
    endwhile
endif

end

;--------------------------------------------------------------------------------
pro do_overlay, info

pro_name = 'do_overlay'
@getinfo

if info.overlay.flag eq 0 then return

widget_control, /hourglass

x_index_1 = info.overlay.xindex
;  x_index_1 = 0 is for index of the array
if x_index_1 gt 0 then x_index = x_index_1 - 1 else x_index = -9
y_index = info.overlay.yindex
z_index = info.overlay.zindex

if(x_index ge 0) then begin
    if info.subset.data(x_index).src_type_flag eq 0 then begin
	hdf_data_x = *info.subset.data(x_index).src_data
    endif else begin
	hdf_x_temp = *info.subset.data(x_index).src_data
	hdf_data_x = reform(hdf_x_temp.components0, n_elements(hdf_x_temp.components0))
    endelse
endif

if info.subset.data(y_index).src_type_flag eq 0 then begin
    hdf_data_y = *info.subset.data(y_index).src_data
endif else begin
    hdf_x_temp = *info.subset.data(y_index).src_data
    hdf_data_y = reform(hdf_x_temp.components0, n_elements(hdf_x_temp.components0))
endelse

if info.subset.data(z_index).src_type_flag eq 0 then begin
    hdf_data_z = *info.subset.data(z_index).src_data
endif else begin
    hdf_x_temp = *info.subset.data(z_index).src_data
    hdf_data_z = reform(hdf_x_temp.components0, n_elements(hdf_x_temp.components0))
endelse

if x_index lt 0 then hdf_data_x = lindgen(n_elements(hdf_data_z))
 
num_x = n_elements(hdf_data_x)
num_y = n_elements(hdf_data_y)
num_z = n_elements(hdf_data_z)

if(num_x eq num_y) and (num_x eq num_z) then begin
 
    if x_index ge 0 then begin
	this_type = info.subset.data(x_index).src_types
	this_type = this_type(0)
    endif else this_type = 3
    filldata_value = get_filldata_value(this_type, info.filldata)
    if filldata_value gt info.filldata then filldata_value = info.filldata

    if filldata_value gt 0 then begin
	subscript = where(hdf_data_x lt filldata_value, count)
    endif else begin
	subscript = where(hdf_data_x gt filldata_value, count)
    endelse
    if(count ne 0) then begin
	hdf_data_x = hdf_data_x(subscript)
	hdf_data_y = hdf_data_y(subscript)
	hdf_data_z = hdf_data_z(subscript)
    endif else begin
	result=dialog_message('All the X field data are fill data!',$
	    title='View HDF Warning!')
	return
    endelse
 
    this_type = info.subset.data(y_index).src_types
    this_type = this_type(0)
    filldata_value = get_filldata_value(this_type, info.filldata)
    if filldata_value gt info.filldata then filldata_value = info.filldata

    if filldata_value gt 0 then begin
	subscript = where(hdf_data_y lt filldata_value, count)
    endif else begin
	subscript = where(hdf_data_y gt filldata_value, count)
    endelse
    if(count ne 0) then begin
	hdf_data_x = hdf_data_x(subscript)
	hdf_data_y = hdf_data_y(subscript)
	hdf_data_z = hdf_data_z(subscript)
    endif else begin
	result=dialog_message('All the Y field data are fill data!',$
	    title='View HDF Warning!')
	return
    endelse
 
    this_type = info.subset.data(z_index).src_types
    this_type = this_type(0)
    filldata_value = get_filldata_value(this_type, info.filldata)
    if filldata_value gt info.filldata then filldata_value = info.filldata

    if filldata_value gt 0 then begin
	subscript = where(hdf_data_z lt filldata_value, count)
    endif else begin
	subscript = where(hdf_data_z gt filldata_value, count)
    endelse
    if(count ne 0) then begin
	hdf_data_x = hdf_data_x(subscript)
	hdf_data_y = hdf_data_y(subscript)
	hdf_data_z = hdf_data_z(subscript)
    endif else begin
	result=dialog_message('All the Z field data are fill data!',$
	    title='View HDF Warning!')
	return
    endelse

    if info.overlay.range eq 0 then begin
	z_max = info.overlay.zmax
	z_min = info.overlay.zmin
    endif else begin
	z_max = max(hdf_data_z, min = z_min)
    endelse
 
    if info.overlay.numcolor eq 1 then begin
      top_color = !d.n_colors - 2
      if top_color gt 254 then top_color = 254
      if(!D.Name ne 'PS' and top_color gt info.top_color) then top_color = info.top_color
      if info.greenwich.with_level ge 1 then begin
	if info.greenwich.with_level eq 2 then begin
	    info.greenwich.in_level = 0
	    if z_max lt 1.0 then info.greenwich.with_level = 1 $
	    else begin
		if z_min lt 1.0 then z_min = 1.0
	    endelse
	endif
	n_level = info.greenwich.n_level
	if info.greenwich.in_level eq 1 then begin
	    temp_range = str_sep(info.greenwich.range, ';')
	    num_range = n_elements(temp_range)
	    if info.greenwich.ext_level eq 0 then begin
		n_level = num_range + 1
		vlevel = double(temp_range)
		vlevel = [vlevel(0), vlevel, vlevel(num_range-1)]
	    endif else begin
		n_level = num_range - 1
		vlevel = double(temp_range)
	    endelse
	    if z_min gt vlevel(0) then z_min = vlevel(0)
	    if z_max lt vlevel(n_level) then z_max = vlevel(n_level)
	    data_interval = vlevel(n_level-1)-vlevel(n_level-2)
	    tempa=findgen(n_level)
	endif else begin
	  tempa=findgen(n_level)
	  if info.greenwich.with_level eq 2 then begin
	    if ((info.axis_state eq 3) or (info.axis_state eq 5)) and $
	      info.greenwich.ext_level eq 0 then begin
		;data_interval = (alog10(z_max) - alog10(z_min))/float(n_level-1)
		;vlevel = [0, tempa+1]
		data_interval = (alog10(z_max) - alog10(z_min))/float(n_level-2)
		vlevel = [0, tempa]
		vlevel(n_level) = vlevel(n_level-1)
	    endif else begin
		data_interval = (alog10(z_max) - alog10(z_min))/float(n_level)
		vlevel = [0, tempa+1]
	    endelse
	    vlevel = alog10(z_min) + vlevel * data_interval
	    vlevel = 10 ^ vlevel
	  endif else begin
	    if ((info.axis_state eq 3) or (info.axis_state eq 5)) and $
	      info.greenwich.ext_level eq 0 then begin
		;data_interval = (z_max - z_min)/float(n_level-1)
		;vlevel = [0, tempa+1]
		data_interval = (z_max - z_min)/float(n_level-2)
		vlevel = [0, tempa]
		vlevel(n_level) = vlevel(n_level-1)
	    endif else begin
		data_interval = (z_max - z_min)/float(n_level)
		vlevel = [0, tempa+1]
	    endelse
	    vlevel = z_min + vlevel * data_interval
	  endelse
	endelse

	color_interval = top_color/float(n_level)
	;tempa=findgen(n_level)
	clevel = fix(color_interval * (tempa(*) + 1))

	;sub_max = where(hdf_data_z gt z_max , count_max)
	;sub_min = where(hdf_data_z lt z_min, count_min)
	;if count_min ne 0 then hdf_data_z(sub_min) = z_max + 10 * data_interval
	my_color = make_array(n_elements(hdf_data_z), /INT, VALUE=!P.BACKGROUND)
	if info.greenwich.in_level eq 0 then begin
	  ;if abs(data_interval) ge 1.0 then begin
	  ;  if info.greenwich.with_level eq 2 then begin
	;	my_color(*) = fix(fix((alog10(hdf_data_z(*)) - alog10(z_min))/data_interval + 1.0) * $
	;		color_interval)
	;    endif else begin
	;	my_color(*) = fix(fix((hdf_data_z(*) - z_min)/data_interval + 1.0) * $
	;		color_interval)
	;    endelse
	;  endif else begin
	;    if info.greenwich.with_level eq 2 then begin
	;	my_color(*) = fix(fix((alog10(hdf_data_z(*)) - alog10(z_min))/data_interval + 0.99999) * $
	;		color_interval)
	;    endif else begin
	;	my_color(*) = fix(fix((hdf_data_z(*) - z_min)/data_interval + 0.99999) * $
	;		color_interval)
	;    endelse
	;  endelse
;
	  for i = 0, n_level-2 do begin
	    sub_color = where(hdf_data_z ge vlevel(i) and hdf_data_z lt vlevel(i+1), count_color)
	    if count_color ne 0 then my_color(sub_color) = clevel(i)
	  endfor
	  if ((info.axis_state eq 3) or (info.axis_state eq 5)) and $
	    info.greenwich.ext_level eq 0 then begin
		sub_color = where(hdf_data_z gt vlevel(n_level-1), count_color)
		if count_color ne 0 then my_color(sub_color) = clevel(n_level-1)
		sub_color = where(hdf_data_z lt vlevel(1), count_color)
		if count_color ne 0 then my_color(sub_color) = clevel(0)
	  endif else begin
		sub_color = where(hdf_data_z ge vlevel(n_level-1) and hdf_data_z lt vlevel(n_level), count_color)
		if count_color ne 0 then my_color(sub_color) = clevel(n_level-1)
	  endelse
;
	endif else begin
	  if info.greenwich.ext_level eq 0 then begin
	    sub_color = where(hdf_data_z lt vlevel(1), count_color)
	    if count_color ne 0 then my_color(sub_color) = clevel(0)
	    sub_color = where(hdf_data_z gt vlevel(n_level-1), count_color)
	    if count_color ne 0 then my_color(sub_color) = clevel(n_level-1)
	  endif else begin
	    sub_color = where(hdf_data_z lt vlevel(1) and hdf_data_z ge vlevel(0), count_color)
	    if count_color ne 0 then my_color(sub_color) = clevel(0)
	    sub_color = where(hdf_data_z gt vlevel(n_level-1) and hdf_data_z le vlevel(n_level), count_color)
	    if count_color ne 0 then my_color(sub_color) = clevel(n_level-1)
	  endelse
	  for i = 1, n_level-2 do begin
	    sub_color = where(hdf_data_z ge vlevel(i) and hdf_data_z lt vlevel(i+1), count_color)
	    if count_color ne 0 then my_color(sub_color) = clevel(i)
	  endfor
	    ;sub_color = where(hdf_data_z gt vlevel(n_level-1), count_color)
	    ;if count_color ne 0 then my_color(sub_color) = clevel(n_level-1)
	endelse
	if ((info.axis_state ne 3) and (info.axis_state ne 5)) or $
	    info.greenwich.ext_level eq 1 then begin
	    sub_max = where(hdf_data_z gt z_max , count_max)
	    sub_min = where(hdf_data_z lt z_min, count_min)
	    if count_max ne 0 then begin
		my_color(sub_max) = !P.BACKGROUND
		hdf_data_z(sub_max) = filldata_value
	    endif
	    if count_min ne 0 then begin
		my_color(sub_min) = !P.BACKGROUND
		hdf_data_z(sub_min) = filldata_value
	    endif
	endif
      endif else begin
	my_color=bytscl(hdf_data_z, max=z_max, min=z_min, top=top_color)
	sub_max = where(hdf_data_z gt z_max , count_max)
        sub_min = where(hdf_data_z lt z_min, count_min)
	if count_max ne 0 then my_color(sub_max) = !P.BACKGROUND
	if count_min ne 0 then my_color(sub_min) = !P.BACKGROUND
      endelse
    endif else my_color = info.overlay.colorindex

    temp_name = info.subset.data(z_index).subset_name
    dot=strpos(temp_name,'[')
    if dot ne -1 then ztitle=strmid(temp_name,0,dot) $
	else ztitle = temp_name
    temp_name = info.subset.data(z_index).src_unitname
    temp_name = temp_name(0)
    dot=strpos(temp_name,'N/A')
    if( dot eq -1) then ztitle = ztitle + temp_name

    if info.overlay.numcolor eq 1 then begin
	if info.overlay.symbol eq 0 then plot_symbol = 3 $
	    else plot_symbol = info.overlay.symbol
	if info.overlay.symbolline eq 1 then plot_symbol = - plot_symbol
    endif else begin
	if info.overlay.symbolline eq 1 then plot_symbol = - info.overlay.symbol $
	    else plot_symbol = info.overlay.symbol
    endelse

    if info.overlay.offflag eq 1 then begin
	hdf_data_x = hdf_data_x + info.overlay.long_offset
	hdf_data_y = hdf_data_y + info.overlay.lat_offset
    endif

    if info.axis_state gt 0 then begin
	fit_flag = 0
	if info.overlay.numcolor eq 1 then plot_type = 2 else plot_type = 0
	fit_data_range, info.axis_state, fit_flag, plot_type, 1, xrange, yrange, $
	    zrange, 0, hdf_data_x, hdf_data_y, hdf_data_z, 0, my_color
	if fit_flag eq 1 then return
    endif

    if info.filldata gt 0 then max_value = info.filldata else max_value = 3.0E+38

    if !D.Name ne 'PS' and !D.Name ne 'PRINTER' then wset, info.sview.window_id
    if info.overlay.numcolor eq 1 then begin
	for i=0L,(n_elements(hdf_data_x)-1) do begin
	    oplot,[hdf_data_x(i), hdf_data_x(i)],[hdf_data_y(i), hdf_data_y(i)], $
		MAX_VALUE = max_value, psym = plot_symbol, linestyle=info.overlay.linetype, $
		symsize=info.overlay.symbolsize, color=my_color(i), $
		thick = info.overlay.linethick
	endfor
    endif else begin
	oplot, hdf_data_x, hdf_data_y, MAX_VALUE = max_value, psym = plot_symbol, $
	    linestyle=info.overlay.linetype, symsize=info.overlay.symbolsize, $
	    color=my_color, thick = info.overlay.linethick
    endelse
 
endif else begin
    result=dialog_message('Number of data points for three subsets are not equal!',$
	title='View HDF Warning!')
    return
endelse

end

;--------------------------------------------------------------------------------
pro offsetoverlay_event, event

pro_name = 'offsetoverlay_event'
@getinfo

widget_control, get_value=v, event.id
widget_control, get_uvalue=fieldid, event.id

if v.close eq 1 then begin
    widget_control, get_uvalue=info, event.top
    info.overlay.long_offset = v.longoff
    info.overlay.lat_offset = v.latoff
    info.overlay.long_delt = v.longdelt
    info.overlay.lat_delt = v.latdelt
    if(widget_info(info.widgets.base, /VALID_ID)) then begin
        if !D.Name ne 'PS' and !D.Name ne 'PRINTER' then wset, info.sview.window_id
	widget_control, set_uvalue=info, info.widgets.base
    endif
    widget_control, set_uvalue=info, info.base
    widget_control, /destroy, event.top
    return
endif

button_array = [v.upleft, v.left, v.downleft, v.up, v.reset, v.down, $
    v.upright, v.right, v.downright]

sub_button = where(button_array eq 1, count)
if count gt 0 then begin
    button_motion = sub_button(0)
    widget_control, get_uvalue=info, event.top
    if(widget_info(info.widgets.base, /VALID_ID)) then begin
	if !D.Name ne 'PS' and !D.Name ne 'PRINTER' then wset, info.sview.window_id
	long_offset = v.longoff
	lat_offset = v.latoff
	long_delt = v.longdelt
	lat_delt = v.latdelt
	case button_motion of
	    0: begin   ; up left
		info.overlay.long_offset = long_offset - long_delt
		info.overlay.lat_offset = lat_offset + lat_delt
		widget_control, event.id, set_value={longoff:info.overlay.long_offset, $
		    latoff:info.overlay.lat_offset, upleft:0}
	      end
	    1: begin   ; left
		info.overlay.long_offset = long_offset - long_delt
		info.overlay.lat_offset = lat_offset
		widget_control, event.id, set_value={longoff:info.overlay.long_offset, $
		    latoff:info.overlay.lat_offset, left:0}
	      end
	    2: begin   ; down left
		info.overlay.long_offset = long_offset - long_delt
		info.overlay.lat_offset = lat_offset - lat_delt
		widget_control, event.id, set_value={longoff:info.overlay.long_offset, $
		    latoff:info.overlay.lat_offset, downleft:0}
	      end
	    3: begin   ; up
		info.overlay.long_offset = long_offset
		info.overlay.lat_offset = lat_offset + lat_delt
		widget_control, event.id, set_value={longoff:info.overlay.long_offset, $
		    latoff:info.overlay.lat_offset, up:0}
	      end
	    4: begin   ; reset
		info.overlay.long_offset = 0.0
		info.overlay.lat_offset = 0.0
		widget_control, event.id, set_value={longoff:info.overlay.long_offset, $
		    latoff:info.overlay.lat_offset, reset:0}
	      end
	    5: begin   ; down
		info.overlay.long_offset = long_offset
		info.overlay.lat_offset = lat_offset - lat_delt
		widget_control, event.id, set_value={longoff:info.overlay.long_offset, $
		    latoff:info.overlay.lat_offset, down:0}
	      end
	    6: begin   ; up right
		info.overlay.long_offset = long_offset + long_delt
		info.overlay.lat_offset = lat_offset + lat_delt
		widget_control, event.id, set_value={longoff:info.overlay.long_offset, $
		    latoff:info.overlay.lat_offset, upright:0}
	      end
	    7: begin   ; right
		info.overlay.long_offset = long_offset + long_delt
		info.overlay.lat_offset = lat_offset
		widget_control, event.id, set_value={longoff:info.overlay.long_offset, $
		    latoff:info.overlay.lat_offset, right:0}
	      end
	    8: begin   ; down right
		info.overlay.long_offset = long_offset + long_delt
		info.overlay.lat_offset = lat_offset - lat_delt
		widget_control, event.id, set_value={longoff:info.overlay.long_offset, $
		    latoff:info.overlay.lat_offset, downright:0}
	      end
	    else:
	endcase
	widget_control, fieldid(3), set_value=info.overlay.long_offset
	widget_control, fieldid(4), set_value=info.overlay.lat_offset
	image = *info.overlay.image
        tvscl24, image
	do_overlay, info
    endif
endif

end

;--------------------------------------------------------------------------------
pro do_offset_overlay, info

pro_name = 'do_offset_overlay'
@getinfo

; if info.widgets.base is not valid, it is no sense to pop up this window
if(not widget_info(info.widgets.base, /VALID_ID)) then return

latoff = strcompress(string(info.overlay.lat_offset), /REMOVE_ALL)
longoff = strcompress(string(info.overlay.long_offset), /REMOVE_ALL)
latdelt = strcompress(string(info.overlay.lat_delt), /REMOVE_ALL)
longdelt = strcompress(string(info.overlay.long_delt), /REMOVE_ALL)

desc = [ $
	'0, label, Adjust X And Y Fields Setting, center, font='+info.font, $
	'0, label, "   ", center, font=' + info.font, $
	'1, base, , row, space=30, center', $
	'0, float, '+longoff+', title=X Offset: , width=10, tag=longoff, '$
	    + 'font='+info.font+', fieldfont='+info.font+', labelfont='+info.font, $ 
	'2, float, '+latoff+', title=Y Offset: , width=10, tag=latoff, ' $
	    + 'font='+info.font+', fieldfont='+info.font+', labelfont='+info.font, $
	'1, base, , row, space=30, center', $
	'0, float, '+longdelt+', title=X Increment: , width=10, tag=longdelt, '$
	    + 'font='+info.font+', fieldfont='+info.font+', labelfont='+info.font, $
	'2, float, '+latdelt+', title=Y Increment: , width=10, tag=latdelt, ' $
	    + 'font='+info.font+', fieldfont='+info.font+', labelfont='+info.font, $
	'0, label, "   ", center, font='+info.font, $
	'1, base, , row, space=20, frame, center', $
	'1, base, , column, space=20, center', $
	'0, button, Up Left, tag=upleft, font='+info.font, $
	'0, button, Left, tag=left, font='+info.font, $
	'2, button, Down Left, tag=downleft, font='+info.font, $
	'1, base, , column, space=20, center', $
	'0, button, Up, tag=up, font='+info.font, $
	'0, button, Reset, tag=reset, font='+info.font, $
	'2, button, Down, tag=down, font='+info.font, $
	'1, base, , column, space=20, center', $
	'0, button, Up Right, tag=upright, font='+info.font, $
	'0, button, Right, tag=right, font='+info.font, $
	'2, button, Down Right, tag=downright, font='+info.font, $
	'2, label, "   ", center, font='+info.font, $
	'1, base, , row, space=30, center', $
	'2, button, Close, QUIT, tag=close, font='+info.font]
	
base_loc = widget_info(info.widgets.base, /geometry)
xoffset = base_loc.xoffset + 100
yoffset = base_loc.yoffset + 50
base=widget_base(group_leader=info.widgets.base, /modal, column=1, map=1, xoffset=xoffset, $
    yoffset=yoffset, TITLE='Adjust X And Y Fields Setting')
formid = cw_form(base, desc, /column, ids=fieldid)

widget_control, base, /realize
widget_control, set_uvalue=info, base
widget_control, set_uvalue=fieldid, formid

info.overlay.offbase = base

xmanager, 'offsetoverlay', base

end

;--------------------------------------------------------------------------------
pro overlaydone_event, event

pro_name = 'overlaydone_event'
@getinfo

if TAG_NAMES(event,/structure_name) eq 'CW_COLOR_INDEX' then begin
    widget_control, get_uvalue=info, event.top
    info.overlay.colorindex=event.value
    widget_control, set_uvalue=info, event.top
    return    
end

widget_control, get_value=v, event.id
widget_control, get_uvalue=fieldid, event.id

if v.cancel eq 1 or v.close eq 1 then begin
    widget_control, get_uvalue=info, event.top
    if(widget_info(info.widgets.base, /VALID_ID)) then begin
	if !D.Name ne 'PS' and !D.Name ne 'PRINTER' then wset, info.sview.window_id
    endif
    widget_control, /destroy, event.top
    return
endif

if v.remove eq 1 then begin
    widget_control, get_uvalue=info, event.top
    info.overlay.flag = 0
    
    if(widget_info(info.widgets.base, /VALID_ID)) then begin
	if !D.Name ne 'PS' and !D.Name ne 'PRINTER' then wset, info.sview.window_id
	image = *info.overlay.image
        tvscl24, image
	widget_control, set_uvalue=info, info.widgets.base
    endif
    widget_control, set_uvalue=info, info.base

    widget_control, event.id, set_value={remove:0}
;    widget_control, event.top, /destroy
    return
endif

if event.tag eq 'SYMBOL' then begin
    if event.value gt 0 then begin
	widget_control, fieldid(10), sensitive = 1
	if v.with gt 0 then $
	    widget_control, fieldid(6), sensitive = 1 $
	    else widget_control, fieldid(6), sensitive = 0
    endif else begin
	widget_control, fieldid(6), sensitive = 1
	widget_control, fieldid(10), sensitive = 0
    endelse
endif

if event.tag eq 'WITH' then begin
    if event.value gt 0 then $
	widget_control, fieldid(6), sensitive = 1 $
        else widget_control, fieldid(6), sensitive = 0
endif

if v.done eq 1 then begin
    widget_control, get_uvalue=info, event.top
    info.overlay.flag = 1
    info.overlay.xindex = v.xindex
    info.overlay.yindex = v.yindex
    info.overlay.zindex = v.zindex
    info.overlay.linetype = v.line
    info.overlay.linethick = v.thick
    info.overlay.symbol = v.symbol
    info.overlay.symbolline = v.with
    info.overlay.symbolsize = v.size
    info.overlay.numcolor = v.numcolor
    info.overlay.range = v.range
    info.overlay.offflag = v.offflag
    info.overlay.offreset = v.offreset

    if v.offflag eq 1 and v.offreset eq 1 then begin
	info.overlay.long_offset = 0.0
	info.overlay.lat_offset = 0.0
	if(widget_info(info.widgets.base, /VALID_ID)) then begin
	    if !D.Name ne 'PS' and !D.Name ne 'PRINTER' then wset, info.sview.window_id
	    image = *info.overlay.image
	    tvscl24, image
	endif
    endif

    if info.overlay.symbol gt 7 then begin
	info.overlay.symbol = 8
	info.overlay.usersym = v.symbol - 7
	set_user_symbol, info.overlay.usersym
    endif
    
    if(widget_info(info.widgets.base, /VALID_ID)) then $
        widget_control, set_uvalue=info, info.widgets.base
    widget_control, set_uvalue=info, info.base

    widget_control, event.top, /destroy

    do_overlay, info
    if info.overlay.offflag eq 1 then begin
	if(not widget_info(info.overlay.offbase, /VALID_ID)) then $
	    do_offset_overlay, info
    endif

endif

end

;--------------------------------------------------------------------------------
pro overlay_dialogueCB, event

pro_name = 'overlay_dialogueCB'
@getinfo

widget_control, get_uvalue=info, event.top

widget_control, /hourglass

info.overlay.flag = 0

name_list = info.name_list_subset[0]
for i = 1, info.subset.count-1 do begin
    name_list = name_list + '|' + info.name_list_subset[i]
endfor

name_list_x = 'Index|'+name_list

x_index = strcompress(string(info.overlay.xindex), /REMOVE_ALL)
y_index = strcompress(string(info.overlay.yindex), /REMOVE_ALL)
z_index = strcompress(string(info.overlay.zindex), /REMOVE_ALL)

line_type = strcompress(string(info.overlay.linetype), /REMOVE_ALL)
if info.overlay.symbol gt 7 then begin
   symbol_num = info.overlay.symbol + info.overlay.usersym - 1
endif else symbol_num = info.overlay.symbol
sym_type = strcompress(string(symbol_num), /REMOVE_ALL)
with_line = strcompress(string(info.overlay.symbolline), /REMOVE_ALL)
sym_size = strcompress(string(info.overlay.symbolsize), /REMOVE_ALL)
thickness = strcompress(string(info.overlay.linethick), /REMOVE_ALL)
numcolor = strcompress(string(info.overlay.numcolor), /REMOVE_ALL)
datarange = strcompress(string(info.overlay.range), /REMOVE_ALL)
offflag = strcompress(string(info.overlay.offflag), /REMOVE_ALL)
offreset = strcompress(string(info.overlay.offreset), /REMOVE_ALL)

desc = [ $
	'0, label, Overlay Variables Setting, center, font='+info.font, $
	'0, label, "   ", center, font=' + info.font, $
	'0, droplist,'+name_list_x+', '$
	    + 'label_left=X Field:, set_value='+x_index+', tag=xindex, ' $
	    + 'font='+info.font+', labelfont='+info.font, $
	'0, droplist,'+name_list+', '$
	    + 'label_left=Y Field:, set_value='+y_index+', tag=yindex, ' $
	    + 'font='+info.font+', labelfont='+info.font, $
	'0, droplist,'+name_list+', '$
	    + 'label_left=Z Field:, set_value='+z_index+', tag=zindex, ' $
	    + 'font='+info.font+', labelfont='+info.font, $
	'0, droplist, Same|Different, ' $
	    + 'label_left=Data Rqange:, set_value='+datarange+', tag=range, ' $
	    + 'font='+info.font+', labelfont='+info.font, $
	'1, base, , column', $
	'0, droplist, Solid|Dotted|Dashed|Dashed Dot|Dashed Dot Dot Dot|Long Dashes, ' $
	    + 'label_left=Line Type:, set_value='+line_type+', tag=line, ' $
	    + 'font='+info.font+', labelfont='+info.font, $
	'2, float, '+thickness+', title=Line Thickness:, width=10, tag=thick, ' $
	    + 'font='+info.font+', fieldfont='+info.font+', labelfont='+info.font, $
	'0, droplist, No Symbol|Plus sign|Asterisk|Period|Diamond|Triangle|' $
	    + 'Square|X|Circle|FOV|Filled Triangle|Filled Square|Filled Circle|' $
	    + 'Filled FOV, label_left=Symbol Type:, set_value='+sym_type $
	    + ', tag=symbol, font='+info.font+', labelfont='+info.font, $
	'1, base, , column, frame', $
	'0, droplist, No|Yes, label_left=Symbol With Line:, set_value='+with_line $
	    + ', tag=with, font='+info.font+', labelfont='+info.font, $
	'2, float, '+sym_size+', title=Symbol Size:, width=10, tag=size, ' $
	    + 'font='+info.font+', fieldfont='+info.font+', labelfont='+info.font, $
	'0, droplist, Single|Multiple, ' $
	    + 'label_left=Number of Colors:, set_value='+numcolor+', tag=numcolor, ' $
	    + 'font='+info.font+', labelfont='+info.font, $
	'1, base, , row, space=30, center', $
	'0, droplist, No|Yes, ' $
	    + 'label_left=Adjust X and/or Y data:, set_value='+offflag+', tag=offflag, ' $
	    + 'font='+info.font+', labelfont='+info.font, $
	'2, droplist, No|Yes, ' $
	    + 'label_left=Reset the offset:, set_value='+offreset+', tag=offreset, ' $
	    + 'font='+info.font+', labelfont='+info.font, $
	'0, label, "   ", center, font='+info.font, $
	'1, base, , row, space=60, center', $
	'0, button, Done, QUIT, tag=done, font='+info.font, $
	'0, button, Remove, QUIT, tag=remove, font='+info.font, $
	'0, button, Close, QUIT, tag=close, font='+info.font, $
	'2, button, Cancel, QUIT, tag=cancel, font='+info.font]
	
base_loc = widget_info(event.top, /geometry)
xoffset = base_loc.xoffset + 100
yoffset = base_loc.yoffset + 50
base=widget_base(group_leader=event.top, /modal, column=1, map=1, xoffset=xoffset, $
    yoffset=yoffset, TITLE='Select Overlay Setting')
formid = cw_form(base, desc, /column, ids=fieldid)

if !d.n_colors gt 192 then bar_size = !d.n_colors else bar_size = 192
if !d.n_colors gt 256 then begin
    bar_size = 256
    color_values =indgen(bar_size)
    if info.overlay.colorindex gt 255 then info.overlay.colorindex = 255
endif else color_values =indgen(!d.n_colors)
if info.version lt 5.39 then begin
    clr_index = cw_clr_index(base, color_values=color_values, label='Color: ', $
	xsize=bar_size, uvalue='overlay')
endif else begin
    clr_index = cw_clr_index(base, color_values=color_values, label='Color: ', $
	xsize=bar_size, value=info.overlay.colorindex, uvalue='overlay')
endelse

widget_control, base, /realize
widget_control, set_uvalue=info, base
widget_control, set_uvalue=fieldid, formid

if info.version lt 5.39 then initial_cw_clr_index, clr_index, info.overlay.colorindex

editable_cw_clr_index, clr_index

if symbol_num gt 0 then begin
	widget_control, fieldid(10), sensitive = 1
	if info.overlay.symbolline gt 0 then $
	    widget_control, fieldid(6), sensitive = 1 $
	    else widget_control, fieldid(6), sensitive = 0
endif else begin
	widget_control, fieldid(10), sensitive = 0
endelse

xmanager, 'overlaydone', base

end

;--------------------------------------------------------------------------------
pro changeopathCB, event

pro_name = 'changeopathCB'
@getinfo

widget_control, get_uvalue=info, event.top

changeopath = ''
widget_control, info.widgets.changeopath, get_value=changeopath

changeopath=changeopath(0)
info.output_path=changeopath
print,'Output Path=',info.output_path

;count = check_directory(info.output_path, info.home_path)
count = check_exist_dir(info.output_path)
if count eq 0 then begin
	message = [ "Your output path is invali!d", info.output_path , $
		"It is set to current directory.", $
		"Use Change Output Path to change the output path."] 
	result=dialog_message( message, title='View HDF Warning!')
	CD, '.', CURRENT=pwd
	info.output_path = pwd
endif
CD, info.output_path, CURRENT=old_dir
output_name_list=findfile(info.filter, count=count)
if count eq 0 then output_name_list = [ 'None' ]
 
widget_control, info.widgets.output, set_value=output_name_list
widget_control, info.widgets.outputdir, set_value=info.output_path
 
CD, old_dir
 
widget_control, set_uvalue=info, info.base

widget_control, event.top, /destroy

end

;--------------------------------------------------------------------------------
pro change_opath, info

pro_name = 'change_opath'
@getinfo

base = widget_base(COLUMN=1, MAP=1, TITLE='Set Outpath Path')

o_group=widget_base(base, row=1,map=1)

info.widgets.changeopath = CW_FIELD(o_group, VALUE=info.output_path, $
		ROW=1, string=1, FIELDFONT=info.font, $
		FONT=info.font, TITLE='Output Path:', XSIZE=40)

group2=widget_base(base, row=1,map=1, space=100, /align_center)

button1=widget_button(group2, FONT=info.font, EVENT_PRO='changeopathCB', VALUE="Done",$
	/ALIGN_CENTER)

button2=widget_button(group2, FONT=info.font, EVENT_PRO='doneCB', VALUE="Cancel",$
	 /ALIGN_CENTER)

widget_control, /realize, base

widget_control, set_uvalue=info, base
widget_control, set_uvalue=info, info.base

end

;--------------------------------------------------------------------------------
pro changeopenCB, event

pro_name = 'changeopenCB'
@getinfo

widget_control, get_uvalue=info, event.top

changeopen = ''
widget_control, info.widgets.changeopen, get_value=changeopen

changeopen=changeopen(0)
info.open_path=changeopen
print,'Open File Path=',info.open_path

widget_control, set_uvalue=info, info.base

widget_control, event.top, /destroy

end

;--------------------------------------------------------------------------------
pro change_open_path, info

pro_name = 'change_open_path'
@getinfo

base = widget_base(COLUMN=1, MAP=1, TITLE='Set Open File Path')

o_group=widget_base(base, row=1,map=1)

info.widgets.changeopen = CW_FIELD(o_group, VALUE=info.open_path, $
	ROW=1, string=1, FIELDFONT=info.font, $
	FONT=info.font, TITLE='Open File Path:', XSIZE=60)

group2=widget_base(base, row=1,map=1, space=100, /align_center)

button1=widget_button(group2, FONT=info.font, EVENT_PRO='changeopenCB', VALUE="Done",$
	/ALIGN_CENTER)

button2=widget_button(group2, FONT=info.font, EVENT_PRO='doneCB', VALUE="Cancel",$
	/ALIGN_CENTER)

widget_control, /realize, base

widget_control, set_uvalue=info, base
widget_control, set_uvalue=info, info.base

end

;--------------------------------------------------------------------------------
function get_color_table, current_table, top_color, home_path

pro_name = 'get_color_table'
@getinfo1

get_lun, unit
if !D.Name eq 'X' then begin
    color_table_file=home_path+"/"+"view_hdf_color.tbl"
endif else begin
    color_table_file=home_path+"\"+"view_hdf_color.tbl"
endelse
test_file = findfile(color_table_file, count=count)
if count eq 0 then color_table_file = 'view_hdf_color.tbl'
openr, unit, color_table_file
result = fstat(unit)
close, unit
free_lun, unit

num_table = result.size/800
if num_table le 1 then return, current_table

TVLCT, R_CUR, G_CUR, B_CUR, /GET
num_r_cur = n_elements(r_cur)
for i = 0, num_table-1 do begin
	LOADCT, i, FILE=color_table_file, ncolors=top_color, /SILENT 
	TVLCT, R, G, B, /GET
	diff = r_cur - r
	subscripts = where(diff ne 0, count)
	if count eq 0 then begin
		diff = g_cur - g
		subscripts = where(diff ne 0, count)	
		if count eq 0 then begin
			diff = b_cur - b
			subscripts = where(diff ne 0, count)
			if count eq 0 then return, i
		endif
	endif
endfor

return, current_table

end 

;--------------------------------------------------------------------------------
pro get_quality_bits, index, start_bit, num_bit

pro_name = 'get_quality_bits'
@getinfo

;get the bits for any flag in Radiance and mode quality flags

case index of
	0: begin
	 	start_bit = 0
		num_bit = 2
	   end
	1: begin
	 	start_bit = 2
		num_bit = 2
	   end
	2: begin
		start_bit = 4
		num_bit = 2
	   end
	3: begin
		start_bit = 6
		num_bit = 2
	   end
	4: begin
		start_bit = 8
		num_bit = 2
	   end
	5: begin
		start_bit = 10
		num_bit = 4
	   end
	6: begin
		start_bit = 14
		num_bit = 1
	   end
	7: begin
		start_bit = 15
		num_bit = 2
	   end
	8: begin
		start_bit = 17
		num_bit = 1
	   end
	9: begin
		start_bit = 18
		num_bit = 1
	   end
	else: begin
		start_bit = 0
		num_bit = 32
	   end
endcase

end

;--------------------------------------------------------------------------------
pro get_range, max_value, min_value, ymax, ymin

pro_name = 'get_range'
@getinfo

;***  calculate the range of values 
if abs(max_value - min_value) lt 0.1 then begin
	if abs(max_value) gt 1 then begin
		ymax = max_value + 0.5
		ymin = min_value - 0.5
	endif else begin
		ymax = max_value + 0.05
		ymin = min_value - 0.05
	endelse
	return
endif

if max_value - min_value lt 5.0 then begin
        ymax = max_value
        ymin = min_value
        return
endif

if (abs(max_value) gt 2147483647) or (abs(min_value) gt 2147483647) then begin
    ymax = max_value
    ymin = min_value
    return
endif
 
if min_value lt 0 then ymin = long(min_value - 1) $
	else ymin = long(min_value) 
if max_value lt 0 then ymax = long(max_value) $
	else ymax = long(max_value + 1)

ytic = ymax - ymin
if ytic gt 10 then begin
	if(ymin ne 0) then begin
		junk1 = abs(ymin)
		temp = string(junk1)
		if(strlen(strtrim(temp,2)) gt 1) then begin
			temp = strmid(temp, 0, strlen(temp)-1)
			junk = long(temp)
			if(ymin eq junk1) then  ymin =  junk * 10  $
						else  ymin = -10* ( junk + 1 ) 
		endif else begin
			if(ymin eq junk1) then ymin = 0  $
				else  ymin = -10
		endelse
	endif

	if(ymax ne 0) then begin
		junk1 = abs(ymax)
		temp = string(junk1)
		if(strlen(strtrim(temp,2)) gt 1) then begin
			temp = strmid(temp, 0, strlen(temp)-1)
			junk = long(temp)
			if(ymax eq junk1) then ymax = ( junk + 1 ) * 10  $
				else  ymax = -10*  junk 
		endif else begin
			if(ymax eq junk1) then ymax = 10  $
				else  ymax = 0
		endelse
	endif

	junk1 = 0L
	ytic = (ymax - ymin)/5
	while ( ytic gt 10 ) do begin
		junk1 = junk1 + 1
		ytic = (ymax - ymin)/(junk1 * 10)
	endwhile

	temp1 = (float(ymax) - float(ymin))/float(ytic)
	if(temp1 ge 0) then junk = long(temp1 + 0.999) $
		else junk = long(temp1 - 0.999)
	yinc = junk
	temp = strtrim(string(junk) , 2)
	junk1 = strlen(temp)
	temp4 = strmid(temp, junk1-1, 1)
	junk2 = long(temp4)
	if(junk2 gt 0) and (junk2 le 5) then begin
		temp = strmid(temp, 0 , junk1-1) + '5'
		temp = strtrim(temp , 2)
		yinc = long(temp)
	endif
	if(junk2 gt 5) and (junk2 le 9) then begin
		temp = strmid(temp , 0 , junk1-1) + '0'
		temp = strtrim(temp , 2)
		if(temp1 ge 0) then yinc = long(temp) + 10 $
			else yinc = long(temp) - 10
	endif
	junk = long(ymin/yinc)
	if(ymin lt 0) then ymin = (junk - 1) *yinc $
		else ymin = junk * yinc
	ymin_temp = ymin + yinc
	while(ymin_temp lt min_value) do begin
		ymin = ymin_temp
		ytic = ytic - 1
		ymin_temp = ymin + yinc
	endwhile
	ymax = ymin + (yinc * ytic)
	while(ymax lt max_value) do begin
		ytic = ytic + 1
		ymax = ymin + yinc * ytic 
	endwhile
endif 

end

;--------------------------------------------------------------------------------
pro get_max_min, z_max, z_min

pro_name = 'get_max_min'
@getinfo

diff_z = abs(z_max - z_min)
if diff_z ge 10.0 then begin
	if z_max lt 0.0 then z_max_temp = long(z_max) $
		else z_max_temp = long(z_max + 0.99999)
	if z_min lt 0.0 then z_min_temp = long(z_min - 0.99999) $
		else z_min_temp = long(z_min)
	if z_min gt 0.0 and z_min_temp lt 0.0 then z_min_temp = 0.0
	z_max = float(z_max_temp)
	z_min = float(z_min_temp)
endif else if diff_z lt 10.0 and diff_z ge 1.0 then begin
	if z_max lt 0.0 then z_max_temp = long(z_max * 10) $
		else z_max_temp = long(z_max * 10 + 0.99999)
	if z_min lt 0.0 then z_min_temp = long(z_min * 10 - 0.99999) $
		else z_min_temp = long(z_min * 10)
	if z_min gt 0.0 and z_min_temp lt 0.0 then z_min_temp = 0.0
	z_max = float(z_max_temp/10.0)
	z_min = float(z_min_temp/10.0)
endif else if diff_z lt 1.0 and diff_z ge 0.1 then begin
	if z_max lt 0.0 then z_max_temp = long(z_max * 100) $
		else z_max_temp = long(z_max * 100 + 0.99999)
	if z_min lt 0.0 then z_min_temp = long(z_min * 100 - 0.99999) $
		else z_min_temp = long(z_min * 100)
	if z_min gt 0.0 and z_min_temp lt 0.0 then z_min_temp = 0.0
	z_max = float(z_max_temp)/100.0
	z_min = float(z_min_temp)/100.0
endif else if diff_z lt 0.1 and diff_z ge 0.01 then begin
	if z_max lt 0.0 then z_max_temp = long(z_max * 1000) $
		else z_max_temp = long(z_max * 1000 + 0.99999)
	if z_min lt 0.0 then z_min_temp = long(z_min * 1000 - 0.99999) $
		else z_min_temp = long(z_min * 1000)
	if z_min gt 0.0 and z_min_temp lt 0.0 then z_min_temp = 0.0
	z_max = float(z_max_temp)/1000.0
	z_min = float(z_min_temp)/1000.0
endif

end

;--------------------------------------------------------------------------------
pro get_home_directory, info

pro_name = 'get_home_directory'
@getinfo

i_value=info.home_path
title = 'Get Home Directory'
f_title = 'Home Directory:'
the_message = 'Change the Home Directory'
home_directory = get_field_value(i_value, 60, title, f_title, the_message, info)
home_directory = home_directory(0)
if home_directory eq 'cancel' then return

count = check_exist_dir(home_directory)
if count eq 0 then begin
        message = [ "Your new home directory is invalid!", home_directory, $
                "The new home directory is not set."]
        result=dialog_message( message, title='View HDF Warning!')
        return
endif

info.home_path = home_directory
print,'Home directory = ',info.home_path

widget_control, set_uvalue=info, info.base

end

;--------------------------------------------------------------------------------
pro gettempdirCB, event

pro_name = 'gettempdirCB'
@getinfo

widget_control, get_uvalue=info, event.top

tempdir = ''
widget_control, info.widgets.gettempdir, get_value=tempdir

tempdir=tempdir(0)
info.temp_dir=tempdir
print,'Temporary directory=',info.temp_dir

count = check_directory(info.temp_dir, info.home_path)
if count eq 0 then begin
	message = [ "You don't have permmision to write in", info.temp_dir , $
		    "You need to choose the other valid directory" ]
	result=dialog_message( message, title='View HDF Warning!')
endif else begin
if info.device eq 'X' then begin
  command_line="\rm -f "+ info.temp_dir+"/temp_file.pro"
endif else begin
  command_line='del "'+ info.temp_dir+'\temp_file.pro"'
endelse
spawn,command_line,results
endelse
 
widget_control, set_uvalue=info, info.base

widget_control, event.top, /destroy

end

;--------------------------------------------------------------------------------
pro get_temp_directory, info

pro_name = 'get_temp_directory'
@getinfo

if info.device eq 'X' then begin
  test_file = findfile(info.temp_dir+"/."+info.tempname+"_*", count=count)
  rm_command = '\rm -f '
  dir_sige = '/.'
endif else begin
  test_file = findfile(info.temp_dir+"\."+info.tempname+"_*", count=count)
  rm_command = 'del '
  dir_sige = '\.'
endelse
if count ne 0 then begin
	if info.device eq 'X' then begin
	    command_line=rm_command+info.temp_dir+dir_sige+info.tempname+"_*"
	endif else begin
	    command_line=rm_command+'"'+info.temp_dir+dir_sige+info.tempname+'_*"'
	endelse
	spawn,command_line,results
endif

base = widget_base(COLUMN=1, MAP=1, TITLE='Get Temporary Directory')

g_group=widget_base(base, row=1,map=1)

info.widgets.gettempdir = CW_FIELD(g_group, VALUE=info.temp_dir, $
		ROW=1, string=1, FIELDFONT=info.font, $
		FONT=info.font, TITLE='Temporary Directory:', XSIZE=40)

group2=widget_base(base, row=1,map=1, space=100, /align_center)

button1=widget_button(group2, FONT=info.font, EVENT_PRO='gettempdirCB', VALUE="Done",$
	/ALIGN_CENTER)

button2=widget_button(group2, FONT=info.font, EVENT_PRO='doneCB', VALUE="Cancel",$
	 /ALIGN_CENTER)

widget_control, /realize, base

widget_control, set_uvalue=info, base
widget_control, set_uvalue=info, info.base

end

;--------------------------------------------------------------------------------
pro getcolortableCB, event

pro_name = 'getcolortableCB'
@getinfo

widget_control, get_uvalue=colortable, event.top
widget_control, get_uvalue=info, event.id

color_table = ''
widget_control, info.widgets.colortable, get_value=color_table

color_table=color_table(0)
color_table = strtrim(color_table, 2)
color_table = strcompress(color_table)
length = strlen(color_table)
if length gt 32 then color_table = strmid(color_table, 0 , 32)

TVLCT, R, G, B, /GET
;R = make_array(200, /BYTE, VALUE = 0)
;G = make_array(200, /BYTE, VALUE = 0)
;B = make_array(200, /BYTE, VALUE = 0)

;R(4:17) = 0
;G(4:17) = 42
;B(4:17) = 170
;R(18:31) = 0
;G(18:31) = 127
;B(18:31) = 255
;R(32:45) = 0
;G(32:45) = 212
;B(32:45) = 255
;R(46:59) = 0
;G(46:59) = 255
;B(46:59) = 255
;R(60:73) = 0
;G(60:73) = 127
;B(60:73) = 127
;R(74:87) = 0
;G(74:87) = 255
;B(74:87) = 0
;R(88:101) = 255
;G(88:101) = 255
;B(88:101) = 212
;R(102:115) = 255
;G(102:115) = 255
;B(102:115) = 0
;R(116:129) = 255
;G(116:129) = 170
;B(116:129) = 0
;R(130:143) = 212
;G(130:143) = 0
;B(130:143) = 85
;R(144:157) = 255
;G(144:157) = 0
;B(144:157) = 0
;R(158:171) = 255
;G(158:171) = 0
;B(158:171) = 255
;R(172:185) = 255
;G(172:185) = 170
;B(172:185) = 255
;R(186:199) = 255
;G(186:199) = 255
;B(186:199) = 255

R = congrid(R, 256)
G = congrid(G, 256)
B = congrid(B, 256)

if info.device eq 'X' then begin
    color_table_file=info.home_path+"/"+"view_hdf_color.tbl"
endif else begin
    color_table_file=info.home_path+"\"+"view_hdf_color.tbl"
endelse
test_file = findfile(color_table_file, count=count)
if count eq 0 then begin
    if info.device eq 'X' then begin
	command_line="\cp -f view_hdf_color.tbl "+info.home_path
    endif else begin
	command_line='copy view_hdf_color.tbl "'+info.home_path+'"'
    endelse
    spawn,command_line,results
endif
Modifyct, 255, color_table, R, G, B, File=color_table_file
widget_control, event.top, /destroy

end

;--------------------------------------------------------------------------------
pro save_edit_color, event

pro_name = 'save_edit_color'
@getinfo

widget_control, event.id, get_uvalue=info
widget_control, event.top, get_uvalue=current_id
widget_control, event.top, /destroy

if current_id ne -1 then wset, current_id

base = widget_base(COLUMN=1, MAP=1, TITLE='Get New Color Table Name')

c_group=widget_base(base, row=1,map=1)

info.widgets.colortable = CW_FIELD(c_group, VALUE='None', $
		ROW=1, string=1, FIELDFONT=info.font, $
		FONT=info.font, TITLE='Color Table Name:', XSIZE=32)

group2=widget_base(base, row=1,map=1, space=100, /align_center)

button1=widget_button(group2, FONT=info.font, EVENT_PRO='getcolortableCB', VALUE="Done",$
	/ALIGN_CENTER, uvalue=info)

button2=widget_button(group2, FONT=info.font, EVENT_PRO='doneCB', VALUE="Cancel",$
	 /ALIGN_CENTER)

widget_control, /realize, base

end

;--------------------------------------------------------------------------------
pro browse_file, event

pro_name = 'browse_file'
@getinfo

widget_control, get_uvalue=field_id, event.id

temp_text = ''
widget_control, field_id, get_value=temp_text
temp_text=temp_text(0)

count = check_exist_dir(temp_text)
if count eq 0 then begin
	CD, '.', CURRENT=pwd
	temp_text = pwd
endif
filename = dialog_pickfile(title='Get Directory Path',/directory, $
		path=temp_text, get_path=this_path)

if filename eq "" then return

;print, 'the path = ', this_path

widget_control, field_id, set_value=this_path

end

;--------------------------------------------------------------------------------
pro set_editor, event

pro_name = 'set_editor'
@getinfo

widget_control, get_uvalue=field_id, event.top
widget_control, get_uvalue=base, event.id

field_id(5) = event.index

widget_control, set_uvalue=field_id, event.top

if field_id(5) eq 4 then begin
    widget_control, get_uvalue=info, base
    get_editor_name, info, event.top
endif

end

;--------------------------------------------------------------------------------
pro set_menu_order, event

pro_name = 'set_menu_order'
@getinfo

widget_control, get_uvalue=field_id, event.top
widget_control, get_uvalue=base, event.id

field_id(15) = event.index

widget_control, set_uvalue=field_id, event.top

if field_id(15) eq 2 then begin
    widget_control, get_uvalue=info, base
    get_menu_order, info, event.top
endif

end

;--------------------------------------------------------------------------------
pro set_screen, event

pro_name = 'set_screen'
@getinfo

widget_control, get_uvalue=field_id, event.top
widget_control, get_uvalue=base, event.id

field_id(11) = event.index

widget_control, set_uvalue=field_id, event.top

if field_id(11) eq 2 then begin
    widget_control, field_id(13), sensitive = 1
    widget_control, field_id(14), sensitive = 1
endif else begin
    widget_control, field_id(13), sensitive = 0
    widget_control, field_id(14), sensitive = 0
endelse
;    widget_control, get_uvalue=info, base
;    get_screen_size, info, event.top
;endif

end

;--------------------------------------------------------------------------------
pro set_color_table, event

pro_name = 'set_color_table'
@getinfo

widget_control, get_uvalue=field_id, event.top

field_id(7) = event.index

widget_control, set_uvalue=field_id, event.top

end

;--------------------------------------------------------------------------------
pro setpreferCB, event

pro_name = 'setpreferCB'
@getinfo

widget_control, get_uvalue=field_id, event.top
widget_control, get_uvalue=info, event.id
widget_control, get_uvalue=info, info.base

temp_text = ''
widget_control, field_id(0), get_value=temp_text
temp_text=temp_text(0)
info.open_path=temp_text

temp_text = ''
widget_control, field_id(1), get_value=temp_text
temp_text=temp_text(0)
info.open_filter=temp_text

temp_text = ''
widget_control, field_id(2), get_value=temp_text
temp_text=temp_text(0)
info.output_path=temp_text

temp_text = ''
widget_control, field_id(3), get_value=temp_text
temp_text=temp_text(0)
info.precision=temp_text

temp_text = ''
widget_control, field_id(4), get_value=temp_text
temp_text=temp_text(0)
info.export_path=temp_text

;if field_id(5) eq 3 then info.editor_type = 4 $
;    else if field_id(5) eq 4 then info.editor_type = 3 $
;    else info.editor_type = field_id(5)
info.editor_type = field_id(5)

info.menu_order.flag = field_id(15)

widget_control, field_id(17), get_value=charsize
info.char.size = charsize

temp_text = ''
widget_control, field_id(6), get_value=temp_text
temp_text=temp_text(0)
info.ps_path=temp_text

temp_color_table = info.color_table
info.color_table = field_id(7)
if temp_color_table ne info.color_table then begin
    color_table_file=info.home_path+"/"+"view_hdf_color.tbl"
    test_file = findfile(color_table_file, count=count)
    if count eq 0 then color_table_file = 'view_hdf_color.tbl'
    loadct, info.color_table, file=color_table_file, /silent
endif

temp_text = ''
widget_control, field_id(8), get_value=temp_text
temp_text=temp_text(0)
info.temp_dir=temp_text

temp_text = ''
widget_control, field_id(9), get_value=temp_text
temp_text=temp_text(0)
info.home_path=temp_text

temp_text = ''
widget_control, field_id(10), get_value=temp_text
temp_text=temp_text(0)
info.stats_path=temp_text

old_xsize = info.screen.xsize
old_ysize = info.screen.ysize

info.screen.pick = field_id(11)
if info.screen.pick eq 0 then begin
	info.screen.xsize = 1024
	info.screen.ysize = 600
endif else if info.screen.pick eq 1 then begin
	info.screen.xsize = 1152
	info.screen.ysize = 614
endif else begin
        widget_control, field_id(13), get_value=xsize
        widget_control, field_id(14), get_value=ysize
        info.screen.xsize = xsize(0)
        info.screen.ysize = ysize(0)
endelse

;widget_control, info.widgets.screen, set_droplist_select=info.screen.pick

temp_text = ''
widget_control, field_id(12), get_value=temp_text
temp_text=temp_text(0)
info.userdefine.old_path=temp_text

temp_text = ''
widget_control, field_id(16), get_value=temp_text
temp_text=temp_text(0)
if info.version lt 5.4 then info.gif_path=temp_text else info.png_path=temp_text

if(widget_info(info.widgets.base, /VALID_ID)) then $
	widget_control, set_uvalue=info, info.widgets.base
widget_control, set_uvalue=info, info.base

widget_control, event.top, /destroy

if old_xsize ne info.screen.xsize or old_ysize ne info.screen.ysize then begin
    if(widget_info(info.widgets.base, /VALID_ID)) then begin
	widget_control, info.widgets.base, /destroy
	if info.multiple.key eq 1 then begin
	    do_more_variables, 3, info
	endif else if info.multiple.key eq 2 then begin
	    do_more_x_variables, 3, info
	endif else begin
	    replot_screen, info.subset.selected, info
	endelse
    endif
endif

end

;--------------------------------------------------------------------------------
pro set_preferences, top_base, info

pro_name = 'set_preferences'
@getinfo

widget_control, /hourglass

field_id = lonarr(18)

base_loc = widget_info(top_base, /geometry)
xoffset = base_loc.xoffset + 100
yoffset = base_loc.yoffset + 100

base = widget_base(group_leader=top_base, /modal, column=1, xoffset=xoffset, $
    yoffset=yoffset, TITLE='Set Preferences')

temp_text = ''
junk = widget_label(base,value=temp_text,/ALIGN_LEFT, font=info.font)
temp_text = 'Change the default setting'
junk = widget_label(base,value=temp_text,/ALIGN_CENTER, font=info.font)
temp_text = ''
junk = widget_label(base,value=temp_text,/ALIGN_LEFT, font=info.font)

row_base = widget_base(base, row=1,map=1, space=10, /align_left)

col_base = widget_base(row_base, column=1, map=1, space=10, /align_left)

group_1=widget_base(col_base, row=1,map=1, space=10, /align_left)

field_id(0) = CW_FIELD(group_1, VALUE=info.open_path, $
	ROW=1, string=1, FIELDFONT=info.font, $
	FONT=info.font, TITLE='Open File Directory:', XSIZE=41)

browse_button=widget_button(group_1, FONT=info.font, event_pro='browse_file', $
	VALUE="Browse",/ALIGN_CENTER, uvalue=field_id(0))

group_2=widget_base(col_base, row=1,map=1, space=10, /align_left)

field_id(2) = CW_FIELD(group_2, VALUE=info.output_path, $
	ROW=1, string=1, FIELDFONT=info.font, $
	FONT=info.font, TITLE='Output Directory:', XSIZE=43)

browse_button=widget_button(group_2, FONT=info.font, event_pro='browse_file', $
        VALUE="Browse",/ALIGN_CENTER, uvalue=field_id(2))

group_3=widget_base(col_base, row=1,map=1, space=10, /align_left)

field_id(4) = CW_FIELD(group_3, VALUE=info.export_path, $
	ROW=1, string=1, FIELDFONT=info.font, $
	FONT=info.font, TITLE='Export Directory:', XSIZE=43)

browse_button=widget_button(group_3, FONT=info.font, event_pro='browse_file', $
        VALUE="Browse",/ALIGN_CENTER, uvalue=field_id(4))

group_4=widget_base(col_base, row=1,map=1, space=10, /align_left)

field_id(6) = CW_FIELD(group_4, VALUE=info.ps_path, $
	ROW=1, string=1, FIELDFONT=info.font, $
	FONT=info.font, TITLE='Postscript File Directory:', XSIZE=37)

browse_button=widget_button(group_4, FONT=info.font, event_pro='browse_file', $
        VALUE="Browse",/ALIGN_CENTER, uvalue=field_id(6))

group_9=widget_base(col_base, row=1,map=1, space=10, /align_left)

if info.version lt 5.4 then graph_path = info.gif_path else graph_path = info.png_path
field_id(16) = CW_FIELD(group_9, VALUE=graph_path, $
	ROW=1, string=1, FIELDFONT=info.font, $
	FONT=info.font, TITLE='Graphic File Directory:', XSIZE=39)

browse_button=widget_button(group_9, FONT=info.font, event_pro='browse_file', $
	VALUE="Browse",/ALIGN_CENTER, uvalue=field_id(16))

group_5=widget_base(col_base, row=1,map=1, space=10, /align_left)

field_id(8) = CW_FIELD(group_5, VALUE=info.temp_dir, $
	ROW=1, string=1, FIELDFONT=info.font, $
	FONT=info.font, TITLE='Temporary Directory:', XSIZE=40)

browse_button=widget_button(group_5, FONT=info.font, event_pro='browse_file', $
        VALUE="Browse",/ALIGN_CENTER, uvalue=field_id(8))

group_6=widget_base(col_base, row=1,map=1, space=10, /align_left)

field_id(9) = CW_FIELD(group_6, VALUE=info.home_path, $
	ROW=1, string=1, FIELDFONT=info.font, $
	FONT=info.font, TITLE='Home Directory:', XSIZE=44)

browse_button=widget_button(group_6, FONT=info.font, event_pro='browse_file', $
        VALUE="Browse",/ALIGN_CENTER, uvalue=field_id(9))

group_7=widget_base(col_base, row=1,map=1, space=10, /align_left)

field_id(10) = CW_FIELD(group_7, VALUE=info.stats_path, $
	ROW=1, string=1, FIELDFONT=info.font, $
	FONT=info.font, TITLE='Statistics Output Directory:', XSIZE=35)

browse_button=widget_button(group_7, FONT=info.font, event_pro='browse_file', $
        VALUE="Browse",/ALIGN_CENTER, uvalue=field_id(10))

group_8=widget_base(col_base, row=1,map=1, space=10, /align_left)

field_id(12) = CW_FIELD(group_8, VALUE=info.userdefine.old_path, $
	ROW=1, string=1, FIELDFONT=info.font, $
	FONT=info.font, TITLE='User Defined Procedure Directory:', XSIZE=30)

browse_button=widget_button(group_8, FONT=info.font, event_pro='browse_file', $
        VALUE="Browse",/ALIGN_CENTER, uvalue=field_id(12))

;col2_base = widget_base(row_base, column=1, map=1, space=15, /align_left)
col2_base = widget_base(row_base, column=1, map=1, space=10, /align_left)

field_id(1) = CW_FIELD(col2_base, VALUE=info.open_filter, $
	ROW=1, string=1, FIELDFONT=info.font, $
	FONT=info.font, TITLE='Open File Filter:', XSIZE=10)

field_id(3) = CW_FIELD(col2_base, VALUE=info.precision, $
	ROW=1, string=1, FIELDFONT=info.font, $
	FONT=info.font, TITLE='Output Format:', XSIZE=10)

field_id(5) = info.editor_type
editor_list = ['VI', 'Emacs', 'Ieditor', 'Edit (PC)', 'Other', 'Emacs with Xterm']
editor = widget_droplist(col2_base, VALUE=editor_list, $
	FONT=info.font, TITLE='Editor:', EVENT_PRO='set_editor', $
	uvalue=top_base, /align_left)

field_id(15) = info.menu_order.flag
menu_order_list = ['Auto', 'Alphabetic', 'Favorite']
menu_order = widget_droplist(col2_base, VALUE=menu_order_list, $
	FONT=info.font, TITLE='Menu Order:', EVENT_PRO='set_menu_order', $
	uvalue=top_base, /align_left)

field_id(17) = CW_FIELD(col2_base, VALUE=info.char.size, $
	ROW=1, floating=1, FIELDFONT=info.font, $
	FONT=info.font, TITLE='Character Size:', XSIZE=10)

field_id(7) = info.color_table
color_table_file=info.home_path+"/"+"view_hdf_color.tbl"
test_file = findfile(color_table_file, count=count)
if count eq 0 then color_table_file = 'view_hdf_color.tbl'
color_table_names = ''
loadct, get_names=color_table_names, file=color_table_file

c_table=widget_base(col2_base,column=1,map=1)
junk=widget_label(c_table, FONT=info.font, /align_left, value="Color table:")
color_table=widget_list(c_table,value=color_table_names, FONT=info.font,  $
	event_pro="set_color_table", ysize=4 )

field_id(11) = info.screen.pick
screen_list = ['1024x600', '1152x614', 'Other']

s_table=widget_base(col2_base,column=1,map=1,frame=1)
screen = widget_droplist(s_table, VALUE=screen_list, $
	FONT=info.font, TITLE='Screen Size:', EVENT_PRO='set_screen', $
	uvalue=top_base, /ALIGN_LEFT)

field_id(13) = CW_FIELD(s_table, VALUE=info.screen.xsize, $
        ROW=1, integer=1, FIELDFONT=info.font, $
        FONT=info.font, TITLE='Horizontal:', XSIZE=10)

field_id(14) = CW_FIELD(s_table, VALUE=info.screen.ysize, $
        ROW=1, integer=1, FIELDFONT=info.font, $
        FONT=info.font, TITLE='Vertical:', XSIZE=10)

group2=widget_base(base, row=1,map=1, space=100, /align_center)

button1=widget_button(group2, FONT=info.font, EVENT_PRO='setpreferCB', VALUE="Done",$
	/ALIGN_CENTER, uvalue=info)

button2=widget_button(group2, FONT=info.font, EVENT_PRO='doneCB', VALUE="Cancel",$
	/ALIGN_CENTER)

widget_control, /realize, base

widget_control, set_uvalue=field_id, base
widget_control, set_uvalue=info, button1
widget_control, set_list_select=info.color_table, color_table
;if info.editor_type eq 3 then editortype = 4 $
;    else if info.editor_type eq 4 then editortype = 3 $
;    else editortype = info.editor_type
editortype = info.editor_type
widget_control, set_droplist_select=editortype, editor
widget_control, set_droplist_select=info.menu_order.flag, menu_order
widget_control, set_droplist_select=info.screen.pick, screen
if info.screen.pick eq 2 then begin
    widget_control, field_id(13), sensitive = 1 
    widget_control, field_id(14), sensitive = 1
endif else begin
    widget_control, field_id(13), sensitive = 0
    widget_control, field_id(14), sensitive = 0
endelse

end

;--------------------------------------------------------------------------------
pro set_user_symbol, symbol_flag

pro_name = 'set_user_symbol'
@getinfo

case symbol_flag of
    1: begin
	A = FINDGEN(16) * (!PI*2/16.)
	USERSYM, COS(A), SIN(A)
    end
    2: begin
	x = [0.0, -1.0, -1.0, 0.0, 1.0, 1.0, 0.0]
	y = [-2.0, -1.0, 1.0, 2.0, 1.0, -1.0, -2.0]
	USERSYM, x, y
    end
    3: begin
	x = [-1.0, 0.0, 1.0, -1.0]
	y = [-1.0, 1.0, -1.0, -1.0]
	USERSYM, x, y, /FILL
    end
    4: begin
	x = [-1.0, -1.0, 1.0, 1.0, -1.0]
	y = [-1.0, 1.0, 1.0, -1.0, -1.0]
	USERSYM, x, y, /FILL
    end
    5: begin
	A = FINDGEN(16) * (!PI*2/16.)
	USERSYM, COS(A), SIN(A), /FILL
    end
    6: begin
	x = [0.0, -1.0, -1.0, 0.0, 1.0, 1.0, 0.0]
	y = [-2.0, -1.0, 1.0, 2.0, 1.0, -1.0, -2.0]
	USERSYM, x, y, /FILL
    end
    else:
endcase

end

;--------------------------------------------------------------------------------
pro set_attr, event

pro_name = 'set_attr'
@getinfo

widget_control, get_uvalue=info, event.top
widget_control, get_uvalue=info, info.base

info.show_attr = event.index

widget_control, set_uvalue=info, info.base

end

;--------------------------------------------------------------------------------
pro set_error_data, hdf_data_x
 
pro_name = 'set_error_data'
@getinfo
 
	size_x = size(hdf_data_x)
	case size_x(0) of
		1: hdf_data_x(0) = -9999999.9
		2: hdf_data_x(0,0) = -9999999.9
		3: hdf_data_x(0,0,0) = -9999999.9
		else: hdf_data_x = -9999999.9
	endcase
end

;--------------------------------------------------------------------------------
pro set_criterion, event
 
pro_name = 'set_criterion'
@getinfo
 
widget_control, get_uvalue=info, event.top
 
widget_control, info.widgets.c_min, get_value=c_min
widget_control, info.widgets.c_max, get_value=c_max
criterion_index = info.criterion.index
criterion_type = info.criterion.type

widget_control, get_uvalue=info, info.base
widget_control, event.top, /destroy

info.criterion.min = c_min
info.criterion.max = c_max
info.criterion.index = criterion_index
info.criterion.type = criterion_type
info.criterion.name = info.name_list_subset(info.criterion.index)
print,'info.criterion.index = ', info.criterion.index
print,'info.criterion.name = ', info.criterion.name
print,'info.criterion.min = ', info.criterion.min
print,'info.criterion.max = ', info.criterion.max
print,'info.criterion.type = ', info.criterion.type
 
widget_control, set_uvalue=info, info.base
;if(widget_info(info.widgets.base, /VALID_ID)) then $
;	widget_control, set_uvalue=info, info.widgets.base
 
end
 
;--------------------------------------------------------------------------------
pro set_criterion_name, event
 
pro_name = 'set_criterion_name'
@getinfo
 
widget_control, get_uvalue=info, event.top
 
info.criterion.index = event.index
 
widget_control, set_uvalue=info, event.top
 
end
 
;------------------------------------------------------------------
pro get_criterion, info, type_flag

pro_name = 'get_criterion'
@getinfo

if info.criterion.index ge info.subset.count then info.criterion.index = 0

if type_flag eq 1 then begin
	base_loc = widget_info(info.base, /geometry)
	xoffset = base_loc.xoffset + 100
	base=widget_base( GROUP_LEADER=info.base, /MODAL, COLUMN=1, MAP=1, $
		TITLE='Pick Additional Criterion', uvalue=info, xoffset=xoffset)
endif else begin
	base=widget_base( COLUMN=1, MAP=1, TITLE='Pick Additional Criterion', uvalue=info)
endelse

c_field = widget_droplist(base, $
		TITLE='Parameter:', VALUE=info.name_list_subset, UVALUE = info, $
                EVENT_PRO='set_criterion_name', FONT=info.font, $
                /ALIGN_CENTER)

group1=widget_base(base, row=1,map=1)
info.widgets.c_min = CW_FIELD(group1,VALUE=info.criterion.min, $
	ROW=1, /floating, FIELDFONT=info.font, FONT=info.font, $
	TITLE='Minimum Value: ', XSIZE=10)

info.widgets.c_max = CW_FIELD(group1,VALUE=info.criterion.max, $
	ROW=1, /floating, FIELDFONT=info.font, FONT=info.font, $
	TITLE='Maximum Value: ', XSIZE=10)
 
group3=widget_base(base, row=1, map=1, /align_center)
desc= [ 'Inside the range' , 'Outside the range'  ]
the_range = CW_BGROUP(group3, desc, set_value=info.criterion.type, FONT=info.font, $
        event_func='set_criterion_type', column=2, xoffset=280, /exclusive)

group2=widget_base(base, row=1,map=1, space=100, /align_center)

button1=widget_button(group2, FONT=info.font, EVENT_PRO='set_criterion', VALUE="Done",$
	/ALIGN_CENTER, uvalue=info)

button2=widget_button(group2, FONT=info.font, EVENT_PRO='cancel_criterion', VALUE="Cancel",$
	 /ALIGN_CENTER, uvalue=info)

widget_control,/realize, base
widget_control, DEFAULT_BUTTON=button1, CANCEL_BUTTON=button2, base

widget_control, c_field, set_droplist_select=info.criterion.index
info.criterion.name = info.name_list_subset(info.criterion.index)
widget_control, set_uvalue=info, base

xmanager, 'main_widget', base

END

;--------------------------------------------------------------------------------
pro unset_criterion, event

pro_name = 'unset_criterion'
@getinfo

widget_control, get_uvalue=info, event.top

info.criterion.flag = 0
WIDGET_CONTROL, info.widgets.criterion, SENSITIVE = info.criterion.flag

if(widget_info(info.widgets.base, /VALID_ID)) then $
	widget_control, set_uvalue=info, info.widgets.base
widget_control, set_uvalue=info, info.base

end

;--------------------------------------------------------------------------------
pro unset_location, event

pro_name = 'unset_location'
@getinfo

widget_control, get_uvalue=info, event.top

info.subset_locate = 0
WIDGET_CONTROL, info.widgets.location, SENSITIVE = info.subset_locate
if info.graph_style eq 'Browse Image' or $
    info.graph_style eq 'Browse Image With Average' then begin
	;wdelete, 5
	delete_window, 5
	wset, info.sview.window_id
	if(widget_info(info.browse_image.base, /VALID_ID)) then $
		widget_control, info.browse_image.base, /destroy
endif

if(widget_info(info.widgets.base, /VALID_ID)) then $
	widget_control, set_uvalue=info, info.widgets.base
;widget_control, set_uvalue=info, info.base

end

;--------------------------------------------------------------------------------
function set_replace_type, event

pro_name = 'set_replace_type'
@getinfo1

widget_control, get_uvalue=info, event.top

info.replace.type=event.value

widget_control, set_uvalue=info, event.top

end

;--------------------------------------------------------------------------------
pro set_replace_value, event
 
pro_name = 'set_replace_value'
@getinfo
 
widget_control, get_uvalue=info, event.top
 
widget_control, info.replace.w_min, get_value=c_min
widget_control, info.replace.w_max, get_value=c_max
replace_type = info.replace.type
widget_control, info.replace.w_val, get_value=c_val

widget_control, get_uvalue=info, info.base
widget_control, event.top, /destroy

info.replace.min = c_min
info.replace.max = c_max
info.replace.type = replace_type
info.replace.val = c_val
print,'info.replace.min = ', info.replace.min
print,'info.replace.max = ', info.replace.max
print,'info.replace.type = ', info.replace.type
print,'info.replace.val = ', info.replace.val
 
widget_control, set_uvalue=info, info.base
;if(widget_info(info.widgets.base, /VALID_ID)) then $
;	widget_control, set_uvalue=info, info.widgets.base
 
end
 
;------------------------------------------------------------------
pro get_replace_value, this_subset, max_value, info

pro_name = 'get_replace_value'
@getinfo

if info.replace.val gt max_value then replace_val = max_value $
	else replace_val = info.replace.val

base_loc = widget_info(info.base, /geometry)
xoffset = base_loc.xoffset + 100
base=widget_base( GROUP_LEADER=info.base, /MODAL, COLUMN=1, MAP=1, $
	TITLE='Pick Replcement Value', uvalue=info, xoffset=xoffset)

temp_name = info.name_list_subset(this_subset)
temp_name = temp_name(0)

length = strlen(temp_name)
if length gt 65 then begin
    data_name = strmid(temp_name, 0, 60) + '...'
endif else data_name = temp_name
temp_text = 'Variable: '+data_name
junk = widget_label(base,value=temp_text,/ALIGN_LEFT, font=info.font)
;temp_text = ' '
;junk = widget_label(base,value=temp_text,/ALIGN_LEFT, font=info.font)

group1=widget_base(base, row=1,map=1)
info.replace.w_min = CW_FIELD(group1,VALUE=info.replace.min, $
	ROW=1, /floating, FIELDFONT=info.font, FONT=info.font, $
	TITLE='Minimum Value: ', XSIZE=10)

info.replace.w_max = CW_FIELD(group1,VALUE=info.replace.max, $
	ROW=1, /floating, FIELDFONT=info.font, FONT=info.font, $
	TITLE='Maximum Value: ', XSIZE=10)
 
group3=widget_base(base, row=1, map=1, /align_center)
desc= [ 'Inside the range' , 'Outside the range', 'Equal to Minimum'  ]
the_range = CW_BGROUP(group3, desc, set_value=info.replace.type, FONT=info.font, $
	event_func='set_replace_type', column=3, xoffset=200, /exclusive)

;temp_text = ' '
;junk = widget_label(base,value=temp_text,/ALIGN_LEFT, font=info.font)

info.replace.w_val = CW_FIELD(base,VALUE=replace_val, $
	ROW=1, /floating, FIELDFONT=info.font, FONT=info.font, $
	TITLE='Replace Value: ', XSIZE=10)

;temp_text = ' '
;junk = widget_label(base,value=temp_text,/ALIGN_LEFT, font=info.font)

group2=widget_base(base, row=1,map=1, space=100, /align_center)

button1=widget_button(group2, FONT=info.font, EVENT_PRO='set_replace_value', VALUE="Done",$
	/ALIGN_CENTER, uvalue=info)

button2=widget_button(group2, FONT=info.font, EVENT_PRO='canceloptionCB', VALUE="Cancel",$
	 /ALIGN_CENTER, uvalue=info)

widget_control,/realize, base
widget_control, DEFAULT_BUTTON=button1, CANCEL_BUTTON=button2, base

widget_control, set_uvalue=info, base

xmanager, 'main_widget', base

END

;--------------------------------------------------------------------------------
pro canceloptionCB, event

pro_name = 'canceloptionCB'
@getinfo

widget_control, get_uvalue=info, event.top

info.canceloption='Yes'

widget_control, set_uvalue=info, info.base

widget_control, event.top, /destroy

end

;--------------------------------------------------------------------------------
pro replace_data_value, this_subset, info

pro_name = 'replace_data_value'
@getinfo

this_type = info.subset.data(this_subset).src_types
this_type = this_type(0)
filldata = get_filldata(this_type, info.filldata)

get_replace_value, this_subset, filldata, info

widget_control, /hourglass

widget_control, get_uvalue=info, info.base

if info.canceloption eq 'Yes' then begin
	info.canceloption = 'No'
	widget_control, set_uvalue=info, info.base
	return
endif

hdf_data = *info.subset.data(this_subset).src_data
if info.subset.data(this_subset).src_type_flag eq 1 then begin
	hdf_data_temp = hdf_data
	size_of_data = size(hdf_data.components0)
	if size_of_data(0) eq 1 then begin
		the_order = 1
		num_record = size_of_data(3)
	endif else begin
		the_order = size_of_data(1)
		num_record = size_of_data(2)
	endelse
        hdf_data = reform(hdf_data.components0, n_elements(hdf_data.components0))
endif

case info.replace.type of
	1: subscripts = where(hdf_data lt info.replace.min or $
			hdf_data gt info.replace.max, count)
	2: subscripts = where(hdf_data eq info.replace.min, count)
	else: subscripts = where(hdf_data ge info.replace.min and $
			hdf_data le info.replace.max, count)
endcase

if count gt 0 then begin
    hdf_data(subscripts) = info.replace.val
    if info.subset.data(this_subset).src_type_flag eq 1 then begin
	for i=0L,num_record-1 do begin
		start1 = i * the_order
		end1 = start1 + the_order - 1
		temp = hdf_data(start1:end1)
		hdf_data_temp(i).components0 = temp
	endfor
	hdf_data = hdf_data_temp
    endif

    if ptr_valid(info.subset.data(this_subset).src_data) then $
	ptr_free, info.subset.data(this_subset).src_data
    info.subset.data(this_subset).src_data=ptr_new(hdf_data, /NO_COPY)

    ;if(widget_info(info.widgets.base, /VALID_ID)) then $
    ;    widget_control, set_uvalue=info, info.widgets.base
    widget_control, set_uvalue=info, info.base
    save_list = redefine_save_list(info)
    widget_control, set_uvalue=save_list, info.list_base
endif

result=dialog_message('Replace data value Completed!', title='Notice!')

end

;------------------------------------------------------------------
pro get_data_attr_factor, this_subset, filename, data_name, data_ref, flag, $
	info, attr_name, attr_value

pro_name = 'get_data_attr_factor'
@getinfo
 
CD, '.', CURRENT = PWD
check_name = get_data_name(data_name)
if flag eq 2 then begin
    if info.subset.data(this_subset).src_type_flag eq 0 then begin
        member_index = -1
    endif else begin
        member_index = info.subset.data(this_subset).src_findex(0)
    endelse
    the_result = get_hdf5_data_attr( filename, check_name, member_index)
endif else if flag eq 0 then begin
    the_result = get_sds_attr(filename, check_name, data_ref)
    title="SDS Attributes"
endif else begin
    if info.version lt 5.5 then begin
	if info.library_status eq 1 then begin
	    the_result = CALL_EXTERNAL(PWD+'/' + info.library,   $
		'get_vfield_attr',  	$
		filename, $
		check_name, $
		data_ref, $
		/s_value)
	    title="Vfield Attributes"
	endif else the_result = 'BAD'
    endif else begin
	the_result = get_vfield_attr(filename, check_name, data_ref)
    endelse
endelse

if the_result eq "BAD" then begin
    attr_name = 'BAD'
    return
endif

attri_value = str_sep(the_result, '|')
num = n_elements(attri_value)
attr_name = ''
attr_value = ''

for i = 0, num-1 do begin
    temp = attri_value(i)
    temp1 = str_sep(temp, ':')
    temp1 = strtrim(temp1, 2)
    if n_elements(temp1) ge 2 then begin
	attr_name = [attr_name, temp1(0)]
	attr_value = [attr_value, temp1(1)]
    endif
endfor

num = n_elements(attr_name)
attr_name = attr_name(1:num-1)
attr_value = attr_value(1:num-1)

end

;------------------------------------------------------------------
pro get_factor_from_input, this_subset, info, scale, offset

pro_name = 'get_factor_from_input'
@getinfo
 
this_name=info.subset.data(this_subset).subset_name
dot=strpos(this_name,'[')
if( dot ne -1) then begin
    data_name=strmid(this_name,0,dot)
endif else begin
    data_name = this_name
endelse

if info.scaledata.auto eq 1 then begin
    i_value = [info.scaledata.vscale, info.scaledata.voffset]
endif else begin
    i_value = [1,0]
endelse
title = 'Get Scale Factor and Offset Parameters'
f_title = ['Scale factor:', 'Offset:']
the_message = ['Input the values of scale factor and offset for', data_name]
para = get_n_field_value(2, i_value, 20, title, f_title, the_message, info.base, info)
scale = para(0)
if scale eq 'cancel' then begin
    scale = -9999
    return
endif

scale = double(para(0))
offset = double(para(1))
info.scaledata.type = 3

end

;------------------------------------------------------------------
pro get_factor_from_attr, this_subset, info, scale, offset

pro_name = 'get_factor_from_attr'
@getinfo
 
filename=info.subset.data(this_subset).src_filename
this_name=info.subset.data(this_subset).subset_name
dot=strpos(this_name,'[')
if( dot ne -1) then begin
    data_name=strmid(this_name,0,dot)
endif else begin
    data_name = this_name
endelse
data_ref=info.subset.data(this_subset).src_ref
if info.hdf5.exist eq 1 then check_hdf5 = H5F_IS_HDF5(filename) $
    else check_hdf5 = 0
if check_hdf5 eq 0 then begin
  if info.subset.data(this_subset).src_type_flag eq 0 then begin
    get_data_attr_factor, this_subset, filename, data_name, data_ref, 0, info, $
	attr_name, attr_value
  endif else begin
    get_data_attr_factor, this_subset, filename, data_name, data_ref, 1, info, $
	attr_name, attr_value
  endelse
endif else begin
  get_data_attr_factor, this_subset, filename, data_name, data_ref, 2, info, $
	attr_name, attr_value
endelse

if attr_name(0) eq 'BAD' then begin
    the_message = ['Problem to find attributes or there is no attribute.', $
	'Do you want to input scale factor and offset?']
    result=dialog_message(the_message, /Question, title='View HDF Question!')

    if result eq 'Yes' then begin
	get_factor_from_input, this_subset, info, scale, offset
    endif else scale = -9999
    return
endif

the_list = [attr_name, 'None', 'Cancel']
num_list = n_elements(the_list)
if info.scaledata.auto eq 1 and info.scaledata.flag eq 1 then begin
    nscale = info.scaledata.nscale
    nscale = nscale(0)
    subscript = where(the_list eq nscale, count)
    if count gt 0 then sel_option = subscript(0) $
	else begin
	    title = 'Select Scale Factor Parameter'
	    the_message = ['The '+nscale+' attribute is not found', $
		'Please select the scale factor from the list:']
	    default_option = 0
	    sel_option = get_option(default_option,the_list,title,the_message,info)
	    if sel_option eq num_list-1 then begin
		scale = -9999
		return
	    endif
    endelse
endif else begin
    title = 'Select Scale Factor Parameter'
    the_message = 'Select the scale factor from the list:'
    default_option = 0
    sel_option = get_option(default_option,the_list,title,the_message,info)
    if sel_option eq num_list-1 then begin
	scale = -9999
	return
    endif
    info.scaledata.nscale = the_list(sel_option)
endelse

if sel_option eq num_list-2 then scale = 1.0D $
;    else scale = double(attr_value(sel_option))
else begin
    scale_value = attr_value(sel_option)
    scale_list = str_sep(scale_value, ';')
    num_scale = n_elements(scale_list)
    if num_scale gt 1 then begin
	org_rank = info.subset.data(this_subset).src_org_rank
        org_start = info.subset.data(this_subset).src_org_start
        org_end = info.subset.data(this_subset).src_org_end
	org_increment = info.subset.data(this_subset).src_org_increment
	real_org_dims = get_real_sds_dims(info, this_subset, real_org_rank)
	if real_org_dims(0) gt 0 then begin
	    ;  check which dimension match the num_scale
	    match_dim = -9
	    num_match = 0
	    for icheck = 0, real_org_rank-1 do begin
		if real_org_dims[icheck] eq num_scale then begin
		    match_dim = [match_dim, icheck]
		    num_match = num_match + 1
		endif
	    endfor
	    if num_match gt 0 then begin
		match_dim = match_dim[1:num_match]
		if num_match eq 1 then begin
		    scale = double(scale_list[org_start[match_dim[0]]])
		endif else begin
		    ;  check number of data equal to 1
		    icheck = 0
		    check_match = 0
		    while (icheck lt num_match) and (check_match eq 0) do begin
			num_data = (org_end[match_dim[icheck]] - $
				    org_start[match_dim[icheck]]) / $
				    org_increment[match_dim[icheck]]
			if num_data eq 1 then begin
			    scale = double(scale_list[org_start[match_dim[icheck]]])
			    check_match  = 1
			endif
			icheck = icheck + 1
		    endwhile
		    ;  If no match, use the first one
		    if check_match eq 0 then begin
			scale = double(scale_list[org_start[match_dim[0]]])
		    endif
		endelse
	    endif else begin
		if org_rank eq 3 and org_end[0] - org_start[0] eq 1 then begin
		    if org_start[0] lt num_scale then scale = double(scale_list[org_start[0]]) $
			else scale = double(scale_list[0])
		endif else scale = double(scale_list[0])
	    endelse
	endif else begin
	    if org_rank eq 3 and org_end[0] - org_start[0] eq 1 then begin
		if org_start[0] lt num_scale then scale = double(scale_list[org_start[0]]) $
		    else scale = double(scale_list[0])
	    endif else scale = double(scale_list[0])
	endelse
    endif else scale = double(scale_list[0])
		
	;org_rank = info.subset.data(this_subset).src_org_rank
	;org_start = info.subset.data(this_subset).src_org_start(0)
	;org_end = info.subset.data(this_subset).src_org_end(0)
	;if org_rank eq 3 and org_end - org_start eq 1 then begin
	;   if org_start lt num_scale then scale = double(scale_list(org_start)) $
	;	else scale = double(scale_list(0))
	;endif else scale = double(scale_list(0))
    ;endif else scale = double(scale_list(0))
endelse

if info.scaledata.auto eq 1 and info.scaledata.flag eq 1 then begin
    noffset = info.scaledata.noffset
    noffset = noffset(0)
    subscript = where(the_list eq noffset, count)
    if count gt 0 then sel_option = subscript(0) $
	else begin
	    title = 'Select Offset Parameter'
	    the_message = ['The '+noffset+' attribute is not found', $
		'Please select the offset from the list:']
	    default_option = 0
	    sel_option = get_option(default_option,the_list,title,the_message,info)
	    if sel_option eq num_list-1 then begin
		scale = -9999
		return
	    endif
    endelse
endif else begin
    title = 'Select Offset Parameter'
    the_message = 'Select the offset from the list:'
    default_option = 0
    sel_option = get_option(default_option,the_list,title,the_message,info)
    if sel_option eq num_list-1 then begin
	scale = -9999
	return
    endif
    info.scaledata.noffset = the_list(sel_option)
endelse

if sel_option eq num_list-2 then offset = 0.0D $
;    else offset = double(attr_value(sel_option))
else begin
    scale_value = attr_value(sel_option)
    scale_list = str_sep(scale_value, ';')
    num_scale = n_elements(scale_list)
    if num_scale gt 1 then begin
	org_rank = info.subset.data(this_subset).src_org_rank
        org_start = info.subset.data(this_subset).src_org_start
        org_end = info.subset.data(this_subset).src_org_end
	org_increment = info.subset.data(this_subset).src_org_increment
	real_org_dims = get_real_sds_dims(info, this_subset, real_org_rank)
	if real_org_dims(0) gt 0 then begin
	    ;  check which dimension match the num_scale
	    match_dim = -9
	    num_match = 0
	    for icheck = 0, real_org_rank-1 do begin
		if real_org_dims[icheck] eq num_scale then begin
		    match_dim = [match_dim, icheck]
		    num_match = num_match + 1
		endif
	    endfor
	    if num_match gt 0 then begin
		match_dim = match_dim[1:num_match]
		if num_match eq 1 then begin
		    offset = double(scale_list[org_start[match_dim[0]]])
		endif else begin
		    ;  check number of data equal to 1
		    icheck = 0
		    check_match = 0
		    while (icheck lt num_match) and (check_match eq 0) do begin
			num_data = (org_end[match_dim[icheck]] - $
				    org_start[match_dim[icheck]]) / $
				    org_increment[match_dim[icheck]]
			if num_data eq 1 then begin
			    offset = double(scale_list[org_start[match_dim[icheck]]])
			    check_match  = 1
			endif
			icheck = icheck + 1
		    endwhile
		    ;  If no match, use the first one
		    if check_match eq 0 then begin
			offset = double(scale_list[org_start[match_dim[0]]])
		    endif
		endelse
	    endif else begin
		if org_rank eq 3 and org_end[0] - org_start[0] eq 1 then begin
		    if org_start[0] lt num_scale then offset = double(scale_list[org_start[0]]) $
			else offset = double(scale_list[0])
		endif else offset = double(scale_list[0])
	    endelse
	endif else begin
	    if org_rank eq 3 and org_end[0] - org_start[0] eq 1 then begin
		if org_start[0] lt num_scale then offset = double(scale_list[org_start[0]]) $
		    else offset = double(scale_list[0])
	    endif else offset = double(scale_list[0])
	endelse
    endif else offset = double(scale_list[0])
	;org_rank = info.subset.data(this_subset).src_org_rank
	;org_start = info.subset.data(this_subset).src_org_start(0)
	;org_end = info.subset.data(this_subset).src_org_end(0)
	;if org_rank eq 3 and org_end - org_start eq 1 then begin
	;    if org_start lt num_scale then offset = double(scale_list(org_start)) $
	;	else offset = double(scale_list(0))
	;endif else offset = double(scale_list(0))
    ;endif else offset = double(scale_list(0))
endelse

print,'scale = ',scale,' offset = ',offset
info.scaledata.type = 2

end

;------------------------------------------------------------------
pro get_factor_from_caldata, this_subset, info, scale, offset

pro_name = 'get_factor_from_caldata'
@getinfo
 
if info.subset.data(this_subset).src_type_flag eq 0 then begin
    filename=info.subset.data(this_subset).src_filename
    sd_id = HDF_SD_START(filename, /READ)
    if sd_id ne -1 then begin
	data_ref=info.subset.data(this_subset).src_ref
	sds_id = HDF_SD_SELECT(sd_id, data_ref)
	if sds_id ne -1 then begin
	    old_quiet = !QUIET
	    !QUIET=1
	    HDF_SD_GETINFO, sds_id, CALDATA=caldata
	    !QUIET=old_quiet
	    HDF_SD_ENDACCESS,sds_id
	    HDF_SD_END,sd_id
	    if caldata.cal ne 0.0 then begin
		scale = caldata.cal
		offset = caldata.offset
		info.scaledata.nscale = 'caldata'
		info.scaledata.type = 1
		return
	    endif
	endif else HDF_SD_END,sd_id
    endif
endif

this_name=info.subset.data(this_subset).subset_name
dot=strpos(this_name,'[')
if( dot ne -1) then begin
    data_name=strmid(this_name,0,dot)
endif else begin
    data_name = this_name
endelse

the_list = ['From attributes', 'From input', 'Cancel']
num_list = n_elements(the_list)
title = 'Select Location of Scale and Offset'
the_message = ['The CALDATA attribute is not found.', $
	'Please select scale and offset from the other source:']
default_option = 0
sel_option = get_option(default_option,the_list,title,the_message,info)
if sel_option eq num_list-1 then begin
    scale = -9999
    return
endif

case sel_option of
    0: get_factor_from_attr, this_subset, info, scale, offset
    1: get_factor_from_input, this_subset, info, scale, offset
    else: scale = -9999
endcase

end

;--------------------------------------------------------------------------------
pro scale_data_value, this_subset, info

pro_name = 'scale_data_value'
@getinfo

the_list = ['scale * data + offset', 'scale * data - offset', $
	'data / scale + offset', 'data / scale - offset', $
	'scale * (data - offset)', 'scale * (data + offset)', $
	'(data - offset) / scale', ' (data + offset) / scale', 'Cancel']
num_list = n_elements(the_list)
if info.scaledata.auto eq 1 and info.scaledata.flag eq 1 then begin
    sel_option = info.scaledata.eq_num
    sel_from = info.scaledata.type
    case sel_from of
	1: get_factor_from_caldata, this_subset, info, scale, offset
	2: get_factor_from_attr, this_subset, info, scale, offset
	3: get_factor_from_input, this_subset, info, scale, offset
	else: begin
	    the_message = 'Error to select location of scale and offset!'
	    result=dialog_message(the_message, title='View HDF Error!')
	    return
	end
    endcase
endif else begin
    title = 'Select Scale Equation'
    the_message = ['Select one of the following equation','for scaling the data set:']
    default_option = 0
    sel_option = get_option(default_option, the_list, title, the_message, info)
    if sel_option eq num_list-1 then return
    info.scaledata.eq_num = sel_option

    the_list = ['From attributes', 'From input', 'Cancel']
    if sel_option eq 4 then the_list = ['From caldata attribute', the_list]
    num_list = n_elements(the_list)
    title = 'Select Location of Scale and Offset'
    the_message = 'How to get scale and offset:'
    default_option = 0
    sel_from = get_option(default_option, the_list, title, the_message, info)
    if sel_from eq num_list-1 then return

    if sel_option eq 4 then begin
	case sel_from of
	    0: get_factor_from_caldata, this_subset, info, scale, offset
	    1: get_factor_from_attr, this_subset, info, scale, offset
	    2: get_factor_from_input, this_subset, info, scale, offset
	    else: begin
		the_message = 'Error to select location of scale and offset!'
		result=dialog_message(the_message, title='View HDF Error!')
		return
	    end
	endcase
    endif else begin
	case sel_from of
	    0: get_factor_from_attr, this_subset, info, scale, offset
	    1: get_factor_from_input, this_subset, info, scale, offset
	    else: begin
		the_message = 'Error to select location of scale and offset!'
		result=dialog_message(the_message, title='View HDF Error!')
		return
	    end
	endcase
    endelse
endelse

if scale lt -9990 then return

widget_control, /hourglass

info.scaledata.vscale = scale
info.scaledata.voffset = offset

hdf_data = *info.subset.data(this_subset).src_data
if info.subset.data(this_subset).src_type_flag eq 1 then begin
	size_of_data = size(hdf_data.components0)
	if size_of_data(0) eq 1 then begin
		the_order = 1
		num_record = size_of_data(3)
	endif else begin
		the_order = size_of_data(1)
		num_record = size_of_data(2)
	endelse
        hdf_data = reform(hdf_data.components0, n_elements(hdf_data.components0))
endif

this_type = info.subset.data(this_subset).src_types
this_type = this_type(0)
filldata= get_filldata_value(this_type, info.filldata)
if filldata gt info.filldata then filldata = info.filldata

if filldata gt 0 then subscript = where(hdf_data lt filldata, count) $
    else subscript = where(hdf_data gt filldata, count)

if count eq 0 then begin
	result=dialog_message('All the data are fill value!',$
		title='View HDF Warning!')
	return
endif

if filldata gt 0 then sub_fill = where(hdf_data ge filldata, count_fill) $
    else sub_fill = where(hdf_data le filldata, count_fill)

hdf_data = double(hdf_data)
if count_fill ne 0 then hdf_data(sub_fill) = info.filldata

case sel_option of
    0: hdf_data(subscript) = scale * hdf_data(subscript) + offset
    1: hdf_data(subscript) = scale * hdf_data(subscript) - offset
    2: hdf_data(subscript) = hdf_data(subscript) / scale + offset
    3: hdf_data(subscript) = hdf_data(subscript) / scale - offset
    4: hdf_data(subscript) = scale * (hdf_data(subscript) - offset)
    5: hdf_data(subscript) = scale * (hdf_data(subscript) + offset)
    6: hdf_data(subscript) = (hdf_data(subscript) - offset) / scale
    7: hdf_data(subscript) = (hdf_data(subscript) + offset) / scale
    else: begin
	the_message = 'Error to select scale equation!'
	result=dialog_message(the_message, title='View HDF Error!')
	return
      end
endcase

if info.subset.data(this_subset).src_type_flag eq 1 then begin
    blank = array_type(6, the_order)
    single_record = create_struct('components' + '0', blank)
    hdf_data_temp=replicate(single_record, num_record)
    jj = 0L
    for i=0L,num_record-1 do begin
	for j=0L, the_order-1 do begin
	    hdf_data_temp(i).components0(j) = hdf_data(jj)
	    jj = jj + 1
	endfor
    endfor
    hdf_data = hdf_data_temp
endif

info.subset.data(this_subset).src_types = 6
info.scaledata.flag = 1

if ptr_valid(info.subset.data(this_subset).src_data) then $
    ptr_free, info.subset.data(this_subset).src_data
info.subset.data(this_subset).src_data=ptr_new(hdf_data, /NO_COPY)

;if(widget_info(info.widgets.base, /VALID_ID)) then $
;    widget_control, set_uvalue=info, info.widgets.base
widget_control, set_uvalue=info, info.base

save_list = redefine_save_list(info)
widget_control, set_uvalue=save_list, info.list_base

result=dialog_message('Scale data value Completed!', title='Notice!')

end

;--------------------------------------------------------------------------------
pro set_bits, event
 
pro_name = 'set_bits'
@getinfo
 
widget_control, get_uvalue=info, event.top
 
widget_control, info.widgets.start_bit, get_value=start_bit
widget_control, info.widgets.num_bit, get_value=num_bit
bit_index = info.bit.index

widget_control, get_uvalue=info, info.base
widget_control, event.top, /destroy

info.bit.start_bit = start_bit
info.bit.num_bit = num_bit
info.bit.index = bit_index
info.bit.name = info.name_list_subset(info.bit.index)
print,'info.bit.index = ', info.bit.index
print,'info.bit.name = ', info.bit.name
print,'info.bit.start_bit = ', info.bit.start_bit
print,'info.bit.num_bit = ', info.bit.num_bit
 
widget_control, set_uvalue=info, info.base
if(widget_info(info.widgets.base, /VALID_ID)) then $
	widget_control, set_uvalue=info, info.widgets.base
 
end
 
;--------------------------------------------------------------------------------
pro set_bit_name, event
 
pro_name = 'set_bit_name'
@getinfo
 
widget_control, get_uvalue=info, event.top
 
info.bit.index = event.index
 
widget_control, set_uvalue=info, event.top
 
end
 
;------------------------------------------------------------------
pro get_bits, this_subset, info

pro_name = 'get_bits'
@getinfo

if this_subset gt 0 then info.bit.index = this_subset
if info.bit.index ge info.subset.count then info.bit.index = 0

base_loc = widget_info(info.base, /geometry)
xoffset = base_loc.xoffset + 300
;xoffset = base_loc.xoffset + 100
base=widget_base( GROUP_LEADER=info.base, /MODAL, COLUMN=1, MAP=1, $
	TITLE='Extract Bits', uvalue=info, xoffset=xoffset)

b_field = widget_droplist(base, $
	TITLE='Variable:', VALUE=info.name_list_subset, UVALUE = info, $
	EVENT_PRO='set_bit_name', FONT=info.font, /ALIGN_CENTER)

info.widgets.start_bit = CW_FIELD(base,VALUE=info.bit.start_bit, $
	ROW=1, /integer, FIELDFONT=info.font, FONT=info.font, $
	TITLE='Start Bit: ', XSIZE=10)

info.widgets.num_bit = CW_FIELD(base,VALUE=info.bit.num_bit, $
	ROW=1, /integer, FIELDFONT=info.font, FONT=info.font, $
	TITLE='Number of Bits: ', XSIZE=10)
 
group2=widget_base(base, row=1,map=1, space=100, /align_center)

button1=widget_button(group2, FONT=info.font, EVENT_PRO='set_bits', $
	VALUE="Done", /ALIGN_CENTER, uvalue=info)

button2=widget_button(group2, FONT=info.font, EVENT_PRO='canceloptionCB', $
	VALUE="Cancel", /ALIGN_CENTER, uvalue=info)

widget_control,/realize, base
widget_control, DEFAULT_BUTTON=button1, CANCEL_BUTTON=button2, base

widget_control, b_field, set_droplist_select=info.bit.index
info.bit.name = info.name_list_subset(info.bit.index)
widget_control, set_uvalue=info, base

xmanager, 'main_widget', base

end

;--------------------------------------------------------------------------------
pro set_region, event
 
pro_name = 'set_region'
@getinfo
 
widget_control, get_uvalue=info, event.top
widget_control, get_uvalue=this_subset, event.id
 
widget_control, info.region.sizewidget, get_value=region_size
region_index = info.region.index

widget_control, get_uvalue=info, info.base
widget_control, event.top, /destroy

info.region.size = region_size
info.region.index = region_index
 
hdf_data = *info.subset.data(this_subset).src_data
if info.subset.data(this_subset).src_type_flag eq 1 then $
	hdf_data = reform(hdf_data.components0, n_elements(hdf_data.components0))
hdf_region = *info.subset.data(region_index).src_data
if info.subset.data(region_index).src_type_flag eq 1 then $
	hdf_region = reform(hdf_region.components0, n_elements(hdf_region.components0))
hdf_data_size = size(hdf_data)
hdf_region_size = size(hdf_region)

if hdf_region_size(0) ne 1 then begin
	the_message = "The region number must be one dimensional array!"
	result=dialog_message(the_message, title='View HDF Warning!')
	info.canceloption = 'Yes'
	widget_control, set_uvalue=info, info.base
	return
endif
region_index = 0
for i = 1, hdf_data_size(0) do begin 
	if hdf_data_size(i) eq hdf_region_size(1) then $
		region_index = i
endfor
if region_index eq 0 then begin
	the_message = 'Number of data is not equal to number of region!'
	result = dialog_message(the_message, title='View HDF Warning!')
	info.canceloption = 'Yes'
	widget_control, set_uvalue=info, info.base
	return
endif
hdf_region = hdf_region - 1
lat_num = long(180.0/region_size + 0.999)
lon_num = long(360.0/region_size + 0.999)
tot_num = long(lat_num*lon_num)
if info.filldata gt 0 then begin
    if info.filldata lt 3.0E+37 then filldata = info.filldata * 10 $
	else filldata = 3.0E+38
endif else filldata = info.filldata
case hdf_data_size(0) of
    1: begin
	hdf_data_array = make_array(tot_num, /DOUBLE, VALUE=filldata)
	hdf_data_array(hdf_region) = hdf_data
	hdf_data_array = reform(hdf_data_array, lon_num, lat_num)
       end
    2: begin
	if region_index eq 1 then begin
	    hdf_data_array = make_array(tot_num, hdf_data_size(2), /DOUBLE, VALUE=filldata)
	    hdf_data_array(hdf_region,*) = hdf_data(*,*)
	    hdf_data_array = reform(hdf_data_array, lon_num,lat_num, hdf_data_size(2))
	endif else begin
	    hdf_data_array = make_array(hdf_data_size(1), tot_num, /DOUBLE, VALUE=filldata)
	    hdf_data_array(*, hdf_region) = hdf_data(*,*)
	    hdf_data_array = reform(hdf_data_array, hdf_data_size(1), lon_num,lat_num)
	endelse
       end
    else: begin
	the_message = 'Not support the dimension greater than 2!'
        result = dialog_message(the_message, title='View HDF Warning!')
        info.canceloption = 'Yes'
        widget_control, set_uvalue=info, info.base
        return
       end
endcase

if ptr_valid(info.xyvalue.x_index) then $
	ptr_free, info.xyvalue.x_index
info.xyvalue.x_index=ptr_new(hdf_data_array)

widget_control, set_uvalue=info, info.base
if(widget_info(info.widgets.base, /VALID_ID)) then $
	widget_control, set_uvalue=info, info.widgets.base
 
end
 
;--------------------------------------------------------------------------------
pro set_region_name, event
 
pro_name = 'set_region_name'
@getinfo
 
widget_control, get_uvalue=info, event.top
 
info.region.index = event.index
 
widget_control, set_uvalue=info, event.top
 
end
 
;------------------------------------------------------------------
pro get_region_number, this_subset, info

pro_name = 'get_region_number'
@getinfo

data_name = info.subset.data(this_subset).subset_name
data_name = data_name(0)
base_loc = widget_info(info.base, /geometry)
xoffset = base_loc.xoffset + 300
;xoffset = base_loc.xoffset + 100
base=widget_base( GROUP_LEADER=info.base, /MODAL, COLUMN=1, MAP=1, $
	TITLE='Get Region Number Variable', uvalue=info, xoffset=xoffset)

length = strlen(data_name)
if length gt 65 then begin
    temp_name = strmid(data_name, 0, 60) + '...'
endif else temp_name = data_name
grid_variable = "Variable: " + temp_name
text1 = widget_label(base, /ALIGN_LEFT, value=grid_variable, $
	FONT=info.font)

text3 = widget_label(base, /ALIGN_RIGHT, value="   ", $
	FONT=info.font)

b_field = widget_droplist(base, $
	TITLE='Variable:', VALUE=info.name_list_subset, UVALUE = info, $
	EVENT_PRO='set_region_name', FONT=info.font, /ALIGN_CENTER)

info.region.sizewidget = CW_FIELD(base,VALUE=info.region.size, $
	ROW=1, /float, FIELDFONT=info.font, FONT=info.font, $
	TITLE='Region size: ', XSIZE=10)

group2=widget_base(base, row=1,map=1, space=100, /align_center)

button1=widget_button(group2, FONT=info.font, EVENT_PRO='set_region', $
	VALUE="Done", /ALIGN_CENTER, uvalue=this_subset)

button2=widget_button(group2, FONT=info.font, EVENT_PRO='canceloptionCB', $
	VALUE="Cancel", /ALIGN_CENTER, uvalue=info)

widget_control,/realize, base
widget_control, DEFAULT_BUTTON=button1, CANCEL_BUTTON=button2, base

widget_control, set_uvalue=info, base

xmanager, 'main_widget', base

end

;--------------------------------------------------------------------------------
pro set_constant, info, cons_id

pro_name = 'set_constant'
@getinfo

if cons_id eq 1 then begin
	widget_control, info.widgets.xfield, get_value=cons_value
	info.y1y2.cons_value1 = double(cons_value)
	;print,'info.y1y2.cons_value1 = ',info.y1y2.cons_value1
endif else begin
	widget_control, info.widgets.yfield, get_value=cons_value
	info.y1y2.cons_value2 = double(cons_value)
	;print,'info.y1y2.cons_value2 = ',info.y1y2.cons_value2
endelse

widget_control, set_uvalue=info, info.base

end

;--------------------------------------------------------------------------------
pro getconstantCB, event

pro_name = 'getconstantCB'
@getinfo

widget_control, get_uvalue=info, event.top
widget_control, get_uvalue=cons_id, event.id

widget_control, info.widgets.cons_value, get_value=cons_value

if cons_id eq 1 then info.y1y2.cons_value1=cons_value $
	else info.y1y2.cons_value2 = cons_value

widget_control, set_uvalue=info, info.base

widget_control, event.top, /destroy

end

;--------------------------------------------------------------------------------
pro get_constant_value, info, cons_id

pro_name = 'get_constant_value'
@getinfo

if cons_id eq 1 then begin
	title='Get Y1 Constant Value'
	cons_value = info.y1y2.cons_value1
endif else begin
	title = 'Get Y2 Constant Value'
	cons_value = info.y1y2.cons_value2
endelse
base_loc = widget_info(info.base, /geometry)
xoffset = base_loc.xoffset + 100
base = widget_base(GROUP_LEADER=info.base, /MODAL, COLUMN=1, MAP=1, $
	TITLE='Get Constant Value', xoffset=xoffset)

c_group=widget_base(base, row=1,map=1)

info.widgets.cons_value = CW_FIELD(c_group, VALUE=cons_value, $
		ROW=1, /float, FIELDFONT=info.font, $
		FONT=info.font, TITLE='Constant:', XSIZE=20)

group2=widget_base(base, row=1,map=1, space=40, /align_center)

button1=widget_button(group2, FONT=info.font, EVENT_PRO='getconstantCB', VALUE="Done",$
	/ALIGN_CENTER, uvalue=cons_id)

button2=widget_button(group2, FONT=info.font, EVENT_PRO='canceloptionCB', VALUE="Cancel",$
	 /ALIGN_CENTER)

widget_control, /realize, base
widget_control, DEFAULT_BUTTON=button1, CANCEL_BUTTON=button2, base

widget_control, set_uvalue=info, base
widget_control, set_uvalue=info, info.base

xmanager, 'main_widget', base

end

;--------------------------------------------------------------------------------
pro editornameCB, event

pro_name = 'editornameCB'
@getinfo

widget_control, get_uvalue=info, event.top
widget_control, get_uvalue=editorid, event.id

editorname = ''
widget_control, editorid, get_value=editorname

editorname=editorname(0)
if info.device eq 'X' then begin
   loc = check_command(editorname)
   if loc ne -1 then begin
	the_message = ["The editor "+editorname+" is not available in this system.", $
			"Please enter another editor!"]
	result=dialog_message(the_message, title='View HDF Warning!')
	return
   endif
endif
	
info.editor=editorname
info.editor_type = 4

if(widget_info(info.widgets.base, /VALID_ID)) then $
	widget_control, set_uvalue=info, info.widgets.base
widget_control, set_uvalue=info, info.base

widget_control, event.top, /destroy

end

;--------------------------------------------------------------------------------
pro get_editor_name, info, group_base

pro_name = 'get_editor_name'
@getinfo

id = 0
base_loc = widget_info(group_base, /geometry)
xoffset = base_loc.xoffset + 200
yoffset = base_loc.yoffset + 300
base = widget_base(GROUP_LEADER=group_base, /modal, COLUMN=1, MAP=1, $
	TITLE='Get Editor Name', xoffset=xoffset, yoffset=yoffset)

p_group=widget_base(base, row=1,map=1)

editorid = CW_FIELD(p_group, VALUE=info.editor, ROW=1, string=1, $
	FIELDFONT=info.font, FONT=info.font, TITLE='Editor:', XSIZE=60)

group2=widget_base(base, row=1,map=1, space=100, /align_center)

button1=widget_button(group2, FONT=info.font, EVENT_PRO='editornameCB', VALUE="Done",$
	/ALIGN_CENTER, uvalue=id)

button2=widget_button(group2, FONT=info.font, EVENT_PRO='doneCB', VALUE="Cancel",$
	 /ALIGN_CENTER)

widget_control, /realize, base

widget_control, set_uvalue=editorid, button1
widget_control, set_uvalue=info, base
widget_control, set_uvalue=info, info.base

xmanager, 'main_widget', base

end

;--------------------------------------------------------------------------------
FUNCTION get_favorite_list, type, graph_list, info

pro_name = 'get_favorite_list'
@getinfo1

temp_name = info.menu_order.select
favorite_list = str_sep(temp_name,',')
num_favorite = n_elements(favorite_list)
if num_favorite gt 0 then begin
    sub_favorite = 0
    for i = 0, num_favorite-1 do begin
	sub_temp = where(graph_list eq favorite_list(i), count)
	if count ne 0 then sub_favorite = [sub_favorite, sub_temp(0)]
    endfor
    num_sub = n_elements(sub_favorite)
    if num_sub gt 1 then begin
	sub_favorite = sub_favorite(1:num_sub-1)
	if type eq 1 then return, sub_favorite
	num_list = n_elements(graph_list)
	for i = 0, num_list-1 do begin
	    sub_temp = where(sub_favorite eq i, count)
	    if count eq 0 then sub_favorite = [sub_favorite, i]
	endfor
	;print,'num_favorite = ',n_elements(sub_favorite),', num_list = ',num_list
	graph_list = graph_list(sub_favorite)
    endif
endif

if type eq 0 then return, graph_list else return, -1

END

;--------------------------------------------------------------------------------
FUNCTION favorite_selected, Event

pro_name = 'favorite_selected'
@getinfo1

widget_control, get_uvalue=info, event.top

picks = info.menu_order.pick
picks(event.value) = event.select
info.menu_order.pick = picks

widget_control, set_uvalue=info, event.top

END

;--------------------------------------------------------------------------------
pro reset_menu_order, Event

pro_name = 'reset_menu_order'
@getinfo

widget_control, get_uvalue=info, event.top
widget_control, get_uvalue=the_pick, event.id

info.menu_order.pick = 0
widget_control, set_value=info.menu_order.pick, the_pick

widget_control, set_uvalue=info, event.top

END

;--------------------------------------------------------------------------------
pro getmenuorderCB, event

pro_name = 'getmenuorderCB'
@getinfo

widget_control, get_uvalue=info, event.top

picks = info.menu_order.pick
graph_list = info.menu_order.name

subs_pick = where(info.menu_order.pick eq 1, num_pick)
print, 'number of graphic options are picked = ', num_pick
if num_pick gt 0 then begin
    info.menu_order.select = graph_list(subs_pick(0))
    for i = 1, num_pick-1 do begin
	info.menu_order.select = info.menu_order.select+','+graph_list(subs_pick(i))
    endfor
    ;print,'info.menu_order.select = ',info.menu_order.select
endif

if(widget_info(info.widgets.base, /VALID_ID)) then $
	widget_control, set_uvalue=info, info.widgets.base
widget_control, set_uvalue=info, info.base

widget_control, event.top, /destroy

end

;--------------------------------------------------------------------------------
pro get_menu_order, info, group_base

pro_name = 'get_menu_order'
@getinfo

info.menu_order.pick(*) = 0
temp_name = info.menu_order.select
favorite_list = str_sep(temp_name,',')
num_favorite = n_elements(favorite_list)
if num_favorite gt 0 then begin
    graph_list = info.menu_order.name
    select_list = get_favorite_list( 1, graph_list, info)
    if select_list(0) ne -1 then info.menu_order.pick(select_list) = 1
endif

base_loc = widget_info(group_base, /geometry)
xoffset = base_loc.xoffset + 100
yoffset = base_loc.yoffset + 100
base = widget_base(GROUP_LEADER=group_base, /modal, row=1, MAP=1, $
	TITLE='Get Favorite Menu Option', xoffset=xoffset, yoffset=yoffset)

;the_pick=CW_BGROUP(base, info.menu_order.name, set_value=0, $
the_pick=CW_BGROUP(base, info.menu_order.name, set_value=info.menu_order.pick, $
	FONT=info.font, EVENT_FUNCT='favorite_selected', uvalue=info,$
        /SCROLL,Y_SCROLL_SIZE=600,X_SCROLL_SIZE=300, /NONEXCLUSIVE)
   
group2=widget_base(base, column=1,map=1, space=40, /align_center)

button1=widget_button(group2, FONT=info.font, EVENT_PRO='getmenuorderCB', $
	VALUE="Done", /ALIGN_CENTER)

button3=widget_button(group2, FONT=info.font, EVENT_PRO='reset_menu_order', $
	VALUE="Reset", /ALIGN_CENTER)

button2=widget_button(group2, FONT=info.font, EVENT_PRO='doneCB', VALUE="Cancel",$
	 /ALIGN_CENTER)

widget_control,/realize, base
widget_control, DEFAULT_BUTTON=button1, CANCEL_BUTTON=button2, base
widget_control, set_uvalue=the_pick, button3
widget_control, set_uvalue=info, base
xmanager, 'main_widget', base

end

;--------------------------------------------------------------------------------
pro printcommandCB, event

pro_name = 'printcommandCB'
@getinfo

widget_control, get_uvalue=info, event.top

printcommand = ''
widget_control, info.widgets.printcommand, get_value=printcommand

printcommand=printcommand(0)
info.printcommand=printcommand

widget_control, set_uvalue=info, info.base

widget_control, event.top, /destroy

end

;--------------------------------------------------------------------------------
pro get_print_command, info

pro_name = 'get_print_command'
@getinfo

base_loc = widget_info(info.widgets.base, /geometry)
xoffset = base_loc.xoffset + 100
base = widget_base(GROUP_LEADER=info.widgets.base, /MODAL, COLUMN=1, MAP=1, $
	TITLE='Get Print Viewgraph Command', xoffset=xoffset)

p_group=widget_base(base, row=1,map=1)

info.widgets.printcommand = CW_FIELD(p_group, VALUE=info.printcommand, $
		ROW=1, string=1, FIELDFONT=info.font, $
		FONT=info.font, TITLE='Command:', XSIZE=60)

group2=widget_base(base, row=1,map=1, space=100, /align_center)

button1=widget_button(group2, FONT=info.font, EVENT_PRO='printcommandCB', VALUE="Done",$
	/ALIGN_CENTER, uvalue=info)

button2=widget_button(group2, FONT=info.font, EVENT_PRO='canceloptionCB', VALUE="Cancel",$
	 /ALIGN_CENTER)

widget_control, /realize, base
widget_control, DEFAULT_BUTTON=button1, CANCEL_BUTTON=button2, base

widget_control, set_uvalue=info, base
widget_control, set_uvalue=info, info.base

xmanager, 'main_widget', base

end

;--------------------------------------------------------------------------------
PRO cancel_variablename, Event

pro_name = 'cancel_variablename'
@getinfo

widget_control, get_uvalue=info, event.top
info.variablename = 'None'

widget_control, set_uvalue=info, info.base
 
widget_control, event.top, /destroy

END

;--------------------------------------------------------------------------------
pro clear_variablename, event

pro_name = 'clear_variablename'
@getinfo

widget_control, get_uvalue=info, event.top

variablename = ''
widget_control, info.widgets.variablename, set_value=variablename

end

;--------------------------------------------------------------------------------
pro variablenameCB, event

pro_name = 'variablenameCB'
@getinfo

widget_control, get_uvalue=info, event.top

variablename = ''
widget_control, info.widgets.variablename, get_value=variablename

variablename=variablename(0)
info.variablename=variablename

widget_control, set_uvalue=info, info.base

widget_control, event.top, /destroy

end

;--------------------------------------------------------------------------------
pro get_variable_name, temp_name, info

pro_name = 'get_variable_name'
@getinfo

base_loc = widget_info(info.base, /geometry)
xoffset = base_loc.xoffset + 100
base = widget_base(GROUP_LEADER=info.base, /MODAL, COLUMN=1, MAP=1, $
	TITLE='Get Variable Name', xoffset=xoffset)

v_group=widget_base(base, row=1,map=1)

info.widgets.variablename = CW_FIELD(v_group, VALUE=temp_name, $
		ROW=1, string=1, FIELDFONT=info.font, $
		FONT=info.font, TITLE='Command:', XSIZE=70)

group2=widget_base(base, row=1,map=1, space=100, /align_center)

button1=widget_button(group2, FONT=info.font, EVENT_PRO='variablenameCB', VALUE="Done",$
	/ALIGN_CENTER, uvalue=info)

button3=widget_button(group2, FONT=info.font, EVENT_PRO='clear_variablename', VALUE="Clear",$
	/ALIGN_CENTER)

button2=widget_button(group2, FONT=info.font, EVENT_PRO='cancel_variablename', VALUE="Cancel",$
	 /ALIGN_CENTER)

widget_control, /realize, base
widget_control, DEFAULT_BUTTON=button1, CANCEL_BUTTON=button2, base

widget_control, set_uvalue=info, base
widget_control, set_uvalue=info, info.base
widget_control, button1, /input_focus

xmanager, 'main_widget', base

end

;------------------------------------------------------------------
pro get_ticklen, grid_flag, xticklen, yticklen

pro_name = 'get_ticklen'
@getinfo
 
case grid_flag of
	1: begin
		xticklen = 1.0
		yticklen = 1.0
	end
	2: begin
		xticklen = 1.0
		yticklen = -0.01
	end
	3:  begin
		xticklen = -0.01
		yticklen = 1.0
	end 
	else: begin
		xticklen = -0.01
		yticklen = -0.01
	end
endcase

end

;------------------------------------------------------------------
pro get_data, y_index, x_index, z_index, info

pro_name = 'get_data'
@getinfo
 
if info.field_name.x ne 'Constant' and info.field_name.x ne 'None' then begin
	x_index=name_to_index(info.field_name.x, info.name_list_subset)
endif else x_index = -1
if info.field_name.y ne 'Constant' and info.field_name.y ne 'None' then begin
	y_index=name_to_index(info.field_name.y, info.name_list_subset)
endif else y_index = -1
if info.field_name.z ne 'Constant' and info.field_name.z ne 'None' then begin
	z_index=name_to_index(info.field_name.z, info.name_list_subset)
endif else z_index = -1

end

;------------------------------------------------------------------
pro get_data_attr, filename, data_name, data_ref, flag, info

pro_name = 'get_data_attr'
@getinfo
 
CD, '.', CURRENT = PWD
check_name = get_data_name(data_name)
if flag eq 2 then begin
    the_result = get_hdf5_data_attr( filename, check_name, data_ref)
    title = "HDF5 Dataset Attributes"
endif else if flag eq 0 then begin
  the_result = get_sds_attr(filename, check_name, data_ref)
  ;the_result = CALL_EXTERNAL(PWD+'/' + info.library,   $
  ;the_result = CALL_EXTERNAL(info.library, 		$
;	'get_sds_attr',  	$
;	filename, $
;	check_name, $
;	data_ref, $
;	/s_value)
  title="SDS Attributes"
endif else begin
  if info.version lt 5.5 then begin
    if info.library_status eq 1 then begin
      ;the_result = CALL_EXTERNAL(PWD+'/' + info.library,   $
      the_result = CALL_EXTERNAL(info.library, 		$
	'get_vfield_attr',  	$
	filename, $
	check_name, $
	data_ref, $
	/s_value)
      title="Vfield Attributes"
    endif else the_result = 'BAD'
  endif else begin
    the_result = get_vfield_attr(filename, check_name, data_ref)
    title = "Vfield Attributes"
  endelse
endelse

;print,'The attributes = ',the_result

if the_result eq "BAD" then begin
	the_message = "Problem getting attribute for "+data_name
	result=dialog_message(the_message, title='View HDF Warning!')
endif else if the_result eq "No Data" then begin
	the_message = "No attribute for "+data_name
	result=dialog_message(the_message, title=title)
endif else begin
	if info.device eq 'X' then begin
	   check=check_path(info.temp_dir)
	   if check eq 1 then begin
		attr_filename=info.temp_dir+"."+info.tempname+"_attr_value"
	   endif else begin
		attr_filename=info.temp_dir+"/."+info.tempname+"_attr_value"
	   endelse
	endif else begin
		attr_filename=info.temp_dir+"\."+info.tempname+"_attr_value"
	endelse
	get_lun, unit
	openw, unit, attr_filename
	widget_control,info.widgets.current_file, get_value=filename
	filename=filename(0)
	printf, unit, format='("Source Data Filename: ",A)', filename
	printf, unit, format='("Data Name: ",A)', data_name
	printf, unit
	attri_value=str_sep(the_result,"|")
	temp = "The attributes for "+data_name
	printf, unit, temp
;	max_column = 80
 	num = n_elements(attri_value)
 	for i = 0 , num-1 do begin
;	   length = strlen(attri_value(i))
;	   if length gt max_column then begin
;		j=0L
;		while j lt length do begin
;		   temp = strmid(attri_value(i),j,max_column)
;		   printf, unit, temp
;		   j = j + max_column
;		endwhile
;	   endif else begin
		printf, unit, attri_value(i)
;	   endelse
	endfor
	close,unit
	free_lun, unit
	case info.editor_type of
	   1: command_line = "emacs " + attr_filename + " &"
           2: begin
                command_line = info.ieditor + " -geometry 757x531+75+104"
                command_line = command_line + " -title 'Display Data' "
                command_line = command_line + attr_filename + " &"
	      end
	   3: command_line = 'start edit "' + attr_filename + '"'
	   4: begin
		if !D.Name eq 'X' then begin
		    command_line = info.editor + " " + attr_filename + " &"
		endif else begin
		    command_line = 'start ' + info.editor + ' "' + attr_filename + '"'
		endelse
	      end
           5: begin
		command_line="xterm -bg \#73a1ff -fn "
		command_line=command_line+ $
		    "-adobe-courier-bold-r-normal--14-100-100-100-m-90-iso8859-1"
		command_line=command_line + " -e emacs " + attr_filename + " &"
	      end
           else: begin
                command_line="xterm -bg \#73a1ff -fn "
                command_line=command_line+ $
                        "-adobe-courier-bold-r-normal--14-100-100-100-m-90-iso8859-1"
                command_line=command_line + " -e vi -R " + attr_filename + " &"
              end
	endcase
	spawn, command_line,results
endelse

end

;------------------------------------------------------------------
pro display_global_attr, base_type, info

pro_name = 'display_global_attr'
@getinfo
 
if base_type eq 0 then begin
    widget_control,info.widgets.current_file,get_value=filename
    filename = filename(0)
endif else begin
    this_subset = info.subset.selected
    filename = info.subset.data(this_subset).src_filename
    filename=filename(0)
endelse

the_result = get_global_attr(filename)
title="Global Attributes"

if the_result eq "BAD" then begin
    the_message = ["Problem getting global attribute for: ", filename]
    result=dialog_message(the_message, title='View HDF Warning!')
endif else if the_result eq "No Data" then begin
    the_message = ["No global attribute for: ", filename]
    result=dialog_message(the_message, title=title)
endif else begin
    if info.device eq 'X' then begin
	check=check_path(info.temp_dir)
	if check eq 1 then begin
	    attr_filename=info.temp_dir+"."+info.tempname+"_attr_value"
	endif else begin
	    attr_filename=info.temp_dir+"/."+info.tempname+"_attr_value"
	endelse
    endif else begin
	attr_filename=info.temp_dir+"\."+info.tempname+"_attr_value"
    endelse
    get_lun, unit
    openw, unit, attr_filename
    printf, unit, format='("Source Data Filename: ",A)', filename
    printf, unit
    attri_value=str_sep(the_result,"|")
    temp = "The Global attributes"
    printf, unit, temp
    num = n_elements(attri_value)
    for i = 0 , num-1 do begin
	printf, unit, attri_value(i)
    endfor
    close,unit
    free_lun, unit
    case info.editor_type of
	1: command_line = "emacs " + attr_filename + " &"
	2: begin
	    command_line = info.ieditor + " -geometry 757x531+75+104"
	    command_line = command_line + " -title 'Display Data' "
	    command_line = command_line + attr_filename + " &"
	   end
	3: command_line = 'start edit "' + attr_filename + '"'
	4: begin
	    if !D.Name eq 'X' then begin
		command_line = info.editor + " " + attr_filename + " &"
	    endif else begin
		command_line = 'start ' + info.editor + ' "' + attr_filename + '"'
	    endelse
	   end
	5: begin
	    command_line="xterm -bg \#73a1ff -fn "
	    command_line=command_line+ $
		"-adobe-courier-bold-r-normal--14-100-100-100-m-90-iso8859-1"
	    command_line=command_line + " -e emacs " + attr_filename + " &"
	   end
	else: begin
	    command_line="xterm -bg \#73a1ff -fn "
	    command_line=command_line+ $
		"-adobe-courier-bold-r-normal--14-100-100-100-m-90-iso8859-1"
	    command_line=command_line + " -e vi -R " + attr_filename + " &"
	   end
    endcase
    spawn, command_line,results
endelse

end

;--------------------------------------------------------------------------------
pro display_metadata, base_type, info

pro_name = 'display_metadata'
@getinfo

    if(info.name_list_vdata[0] eq 'None') then begin
	message = 'There is no vdata in the file.'
	result=dialog_message(message, title='View HDF Warning!')
	return
    endif

    if base_type eq 0 then begin
	widget_control,info.widgets.current_file,get_value=filename
	filename = filename(0)
    endif else begin
	this_subset = info.subset.selected
	filename = info.subset.data(this_subset).src_filename
	filename=filename(0)
    endelse

    temp_vdata_name = strlowcase(info.name_list_vdata)
    metadata_loc = strpos(temp_vdata_name, 'metadata')

    sub_meta = where(metadata_loc ne -1, count)
    if count eq 0 then begin
	message = 'There is no metadata in the file.'
	result=dialog_message(message, title='View HDF Warning!')
	return
    endif else if count gt 1 then begin
	the_list = info.name_list_vdata(sub_meta)
	the_list = [the_list, 'Cancel']
	num_list = n_elements(the_list)
	title = 'Select Metadata File'
	the_message = ['There are more than one files with "metadata",', $
	    'Select one of the following files for displaying:']
	default_option = 0
	sel_option = get_option(default_option,the_list,title,the_message,info)
	if sel_option eq num_list-1 then return
	the_vdata_name = ''
	the_vdata_name = info.name_list_vdata(sel_option)
    endif else begin
	the_vdata_name = ''
	the_vdata_name = info.name_list_vdata(sub_meta)
    endelse

    widget_control, /hourglass

    number_of_fields=0L

    CD, '.', CURRENT = PWD

    num_vdata = 1
    the_result = get_vdata_fields(filename,the_vdata_name,number_of_fields,num_vdata,$
	vdata_ref, the_nrec)

    if the_result eq "BAD" then return

    the_vfield_list = strsplit(the_result,',',/EXTRACT)
    num_vfield = n_elements(the_vfield_list)
    if(num_vfield ne number_of_fields) then begin
	message = ['There is something wrong with number of vfields', $
	    'the number_of_fields = '+strcompress(string(number_of_fields), /REMOVE_ALL), $
	    'the num_vfield       = '+strcompress(string(num_vfield), /REMOVE_ALL), $
	    'The least will be picked.']
	result=dialog_message(message, title='View HDF Warning!')
	if num_vfield lt number_of_fields then number_of_fields = num_vfield
    endif

    ;  Open the HDF file
    file_id = HDF_OPEN(filename, /READ)
    if file_id eq -1 then begin
	message = ['Unable to open '+filename, $
	    'for displaying the metadata.']
	result=dialog_message(message, title='View HDF Warning!')
	return
    endif

    ;  Attach the vdata
    the_vdata_name = the_vdata_name[0]
    vdata_ref = HDF_VD_FIND(file_id, the_vdata_name)
    if vdata_ref eq 0 then begin
	result=dialog_message('Unable to find '+the_vdata_name+'!',$
	title='View HDF Warning!')
	HDF_CLOSE,file_id
	return
    endif

    vdata_id = HDF_VD_ATTACH(file_id, vdata_ref, /READ)
    if vdata_id le 0 then begin
	result=dialog_message('Unable to attach '+the_vdata_name+'!',$
	    title='View HDF Warning!')
	HDF_CLOSE,file_id
	return
    endif

    ;  Create the temporary file
    if info.device eq 'X' then begin
	check=check_path(info.temp_dir)
	if check eq 1 then begin
	    meta_filename=info.temp_dir+"."+info.tempname+"_meta_value"
	endif else begin
	    meta_filename=info.temp_dir+"/."+info.tempname+"_meta_value"
	endelse
    endif else begin
	meta_filename=info.temp_dir+"\."+info.tempname+"_meta_value"
    endelse

    get_lun, unit
    openw, unit, meta_filename

    printf, unit, format='("Source Data Filename: ",A)', filename
    printf, unit, format='("Metadata Name: ",A)', the_vdata_name
    printf, unit

    for i = 0L , number_of_fields-1 do begin
	vfield_name = the_vfield_list[i]
	vfield_name = vfield_name[0]
	HDF_VD_GETINFO,vdata_id,vfield_name,TYPE=the_types,ORDER=the_order, NAME=the_name
	if the_name ne vfield_name then begin
	    the_message = ['Input fieldname, '+vfield_name,'is not equal to',$
		'fieldname, '+the_name]
	    result=dialog_message(the_message, title='View HDF Warning!')
	endif

	CASE the_types of
	    'BYTE': begin
			if the_order ge 5 then data_type = 4 else data_type = 20
		    end
	    'INT': data_type = 22
	    'LONG': data_type = 24
	    'FLOAT': data_type = 5
	    'DOUBLE': data_type = 6
	    else: data_type = 5
	ENDCASE

	nread = HDF_VD_READ(vdata_id,output_data,FIELDS=vfield_name)
	if nread eq the_nrec then begin
	    if(data_type gt 4) and (the_order gt 1) then temp_format='(A," = ")' $
		else temp_format='($,A," = ")'
	    printf, unit, format=temp_format, vfield_name
	    if data_type eq 4 then output_data = string(output_data)
	    printf, unit, output_data
	endif
    endfor

    ;  Close the HDF file after reading all the fields
    HDF_VD_DETACH, vdata_id
    HDF_CLOSE,file_id

    ;  Close the temporary file
    close,unit
    free_lun, unit

    ;Display the temporary file
    case info.editor_type of
	1: command_line = "emacs " + meta_filename + " &"
	2:  begin
		command_line = info.ieditor + " -geometry 757x531+75+104"
		command_line = command_line + " -title 'Display Data' "
		command_line = command_line + meta_filename + " &"
	    end
	3: command_line = 'start edit "' + meta_filename + '"'
	4:  begin
		if !D.Name eq 'X' then begin
		    command_line = info.editor + " " + meta_filename + " &"
		endif else begin
		    command_line = 'start ' + info.editor + ' "' + meta_filename + '"'
		endelse
	    end
	5: begin
		command_line="xterm -bg \#73a1ff -fn "
		command_line=command_line+ $
		    "-adobe-courier-bold-r-normal--14-100-100-100-m-90-iso8859-1"
		command_line=command_line + " -e emacs " + meta_filename + " &"
	    end
	else:  begin
		command_line="xterm -bg \#73a1ff -fn "
		command_line=command_line+ $
		    "-adobe-courier-bold-r-normal--14-100-100-100-m-90-iso8859-1"
		command_line=command_line + " -e vi -R " + meta_filename + " &"
	    end
    endcase

    spawn, command_line,results

end

;------------------------------------------------------------------
function read_sds_data, this_subset, sds_name, info, sds_data

pro_name = 'read_sds_data'
@getinfo1

;widget_control,info.widgets.current_file,get_value=filename
filename = info.subset.data(this_subset).src_filename
filename = filename(0)

sd_id = HDF_SD_START(filename, /READ)
if sd_id eq -1 then begin
	result=dialog_message('Unable to open '+filename+'!',$
		title='View HDF Warning!')
	return, -1
endif

sds_index = check_sds_index(filename,sds_name)
if sds_index eq -1 then begin
	result=dialog_message('Unable to get index for '+sds_name+'!',$
		title='View HDF Warning!')
	HDF_SD_END,sd_id
	return, -1
endif

sds_id = HDF_SD_SELECT(sd_id, sds_index)
if sds_id eq -1 then begin
	result=dialog_message('Unable to select '+temp_name+' SDS data!',$
		title='View HDF Warning!')
	HDF_SD_END,sd_id
	return, -1
endif

HDF_SD_GETINFO,sds_id, DIMS=sds_dims, NDIMS=sds_rank, HDF_TYPE=type, /NOREVERSE
 
start_list=lonarr(sds_rank)
end_list=lonarr(sds_rank)
increment_list=lonarr(sds_rank)
array_size=lonarr(sds_rank)

for i = 0, sds_rank-1 do begin
	start_list(i) = 0
	end_list(i) = sds_dims(i)
	increment_list(i) = 1
endfor

start_list(0) = info.subset.data(this_subset).src_start(0)
end_list(0) = info.subset.data(this_subset).src_end(0)
if info.subset.data(this_subset).src_type_flag eq 0 then begin
	the_rank = info.subset.data(this_subset).src_rank
	if the_rank eq 1 then begin
		true_start = info.subset.data(this_subset).src_start(the_rank)
		true_end = info.subset.data(this_subset).src_end(the_rank)
		if true_start ne start_list(0) or true_end ne end_list(0) then begin
			start_list(0) = true_start
			end_list(0) = true_end
		endif
	endif
endif else end_list(0) = end_list(0) + 1

org_rank = info.subset.data(this_subset).src_org_rank
if end_list(0) gt sds_dims(0) or org_rank gt sds_rank then begin
    start_list(0) = 0
    end_list(0) = sds_dims(0)
endif

array_size = end_list
array_size(0) = end_list(0) - start_list(0)

sds_type = convert_hdftypename_hdftype(type)
unsign_type = 0
if info.version lt 5.19 and info.library_status eq 1 then begin
        if sds_type gt 20 then unsign_type = sds_type mod 2
endif

if info.hdf421 eq 1 then unsign_type = 1

if unsign_type eq 0 then begin
	start_list = reverse(start_list)
	array_size = reverse(array_size)
	HDF_SD_GETDATA, sds_id, sds_data, START=start_list, COUNT=array_size
	HDF_SD_ENDACCESS,sds_id
	HDF_SD_END, sd_id
endif else begin
	HDF_SD_ENDACCESS,sds_id
	HDF_SD_END, sd_id
	CD, '.', CURRENT = PWD
	;the_result = CALL_EXTERNAL(PWD+'/' + info.library,   $
	the_result = CALL_EXTERNAL(info.library,   $
		'read_sds_eos',$
		filename,$
		sds_name,$
		sds_index,$
		sds_rank,$
		sds_type,$
		sds_dims,$
		start_list,$
		end_list,$
		increment_list,$
		array_size,$
		sds_data)
	if (the_result eq -1) then begin
		result=dialog_message('Unable to read '+sds_name+' SDS data!',$
			title='View HDF Warning!')
		return, -1
	endif
endelse
 
return, 0

end 

;------------------------------------------------------------------
function read_vdata_data, this_subset, the_nrec, vdata_name, vfield_name,  $
	info, vdata_data

pro_name = 'read_vdata_data'
@getinfo1

;widget_control,info.widgets.current_file,get_value=filename
filename = info.subset.data(this_subset).src_filename
filename = filename(0)

file_id = HDF_OPEN(filename, /READ)
if file_id eq -1 then begin
	result=dialog_message('Unable to open '+filename+'!',$
		title='View HDF Warning!')
	return, -1
endif

vdata_name = vdata_name[0]
vdata_ref = HDF_VD_FIND(file_id, vdata_name)
if vdata_ref eq 0 then begin
	result=dialog_message('Unable to find '+vdata_name+'!',$
		title='View HDF Warning!')
	HDF_CLOSE,file_id
	return, -1
endif

vdata_id = HDF_VD_ATTACH(file_id, vdata_ref, /READ)
;if vdata_id eq 0 then begin
if vdata_id le 0 then begin
	result=dialog_message('Unable to attach '+vdata_name+'!',$
		title='View HDF Warning!')
	HDF_CLOSE,file_id
	return, -1
endif

vfield_name = vfield_name(0)
HDF_VD_GETINFO,vdata_id,vfield_name,TYPE=the_types,ORDER=the_order, $
	NAME=the_name
if the_name ne vfield_name then begin
	the_message = ['Input fieldname, '+vfield_name,'is not equal to',$
			'fieldname, '+the_name]
	result=dialog_message(the_message, title='View HDF Warning!')
	return, -1
endif

CASE the_types of
	'BYTE': data_type = 20
	'INT': data_type = 22
	'LONG': data_type = 24
	'FLOAT': data_type = 5
	'DOUBLE': data_type = 6
	else: data_type = 5
ENDCASE

blank = array_type(data_type, the_order)
single_record=create_struct( 'components' + '0', blank) 
vdata_data=replicate(single_record, (the_nrec))

nread = HDF_VD_READ(vdata_id,output_data,FIELDS=vfield_name)

HDF_VD_DETACH, vdata_id
HDF_CLOSE,file_id

k = 0L
for i = 0L, the_nrec-1 do begin
	for j = 0L, the_order-1 do begin
		vdata_data(i).components0(j) = output_data(k)
		k = k + 1L
	endfor
endfor

this_start = info.subset.data(this_subset).src_start(0)
this_end = info.subset.data(this_subset).src_end(0)
if info.subset.data(this_subset).src_type_flag eq 0 then begin
	the_rank = info.subset.data(this_subset).src_rank
	if the_rank eq 1 then begin
		true_start = info.subset.data(this_subset).src_start(the_rank)
		true_end = info.subset.data(this_subset).src_end(the_rank)
		if true_start ne this_start or true_end ne this_end then begin
			this_start = true_start
			this_end = true_end
		endif
	endif
	this_end = this_end - 1
endif
if this_end le the_nrec then $
    vdata_data = vdata_data(this_start:this_end)
return, 0

end

;--------------------------------------------------------------------------------
pro cancelCB, event

pro_name = 'cancelCB'
@getinfo

widget_control, get_uvalue=info, event.top
widget_control, get_uvalue=info, info.base 

widget_control, event.top, /destroy

this_subset = info.subset.selected

set_error_data, hdf_data_x
assign_geolocated_data, this_subset, info, hdf_data_x, hdf_data_y, satellite_x, $
	satellite_y, sun_x, sun_y

end

;--------------------------------------------------------------------------------
pro clear_geo_field, event

pro_name = 'clear_geo_field'
@getinfo

widget_control, get_uvalue=info, event.top
widget_control, get_uvalue=info, info.base 

field_name = 'None'

info.geo_name.long = field_name
widget_control, info.geo_widgets.long_field, set_value=field_name

info.geo_name.colat = field_name
widget_control, info.geo_widgets.col_field, set_value=field_name

info.geo_name.lat = field_name
widget_control, info.geo_widgets.lat_field, set_value=field_name

info.geo_name.satelong = field_name
widget_control, info.geo_widgets.satelong_field, set_value=field_name

info.geo_name.satecol = field_name
widget_control, info.geo_widgets.satecol_field, set_value=field_name

info.geo_name.satelat = field_name
widget_control, info.geo_widgets.satelat_field, set_value=field_name

info.geo_name.sunlong = field_name
widget_control, info.geo_widgets.sunlong_field, set_value=field_name

info.geo_name.suncol = field_name
widget_control, info.geo_widgets.suncol_field, set_value=field_name

info.geo_name.sunlat = field_name
widget_control, info.geo_widgets.sunlat_field, set_value=field_name

widget_control, set_uvalue=info, info.base

end

;--------------------------------------------------------------------------------
pro get_geo_doneCB, event

pro_name = 'get_geo_doneCB'
@getinfo

widget_control, get_uvalue=info, event.top
widget_control, get_uvalue=info, info.base 

widget_control, event.top, /destroy

this_subset = info.subset.selected

if info.geo_name.long ne 'None' then begin
	long_index=name_to_index(info.geo_name.long, info.name_list_subset)
	long_index = long_index(0)
	if long_index lt 0 or long_index ge info.subset.count then begin
		set_error_data, hdf_data_x
		assign_geolocated_data, this_subset, info, hdf_data_x, hdf_data_y, satellite_x, $
			satellite_y, sun_x, sun_y
		return
	endif
endif else begin
	set_error_data, hdf_data_x
	assign_geolocated_data, this_subset, info, hdf_data_x, hdf_data_y, satellite_x, $
		satellite_y, sun_x, sun_y
	return
endelse

if info.geo_name.colat eq 'None' and info.geo_name.lat eq 'None' then begin
        set_error_data, hdf_data_x
        assign_geolocated_data, this_subset, info, hdf_data_x, hdf_data_y, satellite_x, $
                satellite_y, sun_x, sun_y
        return
endif 

if info.geo_name.colat ne 'None' then begin
	colat_index=name_to_index(info.geo_name.colat, info.name_list_subset)
	colat_index = colat_index(0)
	if colat_index lt 0 or colat_index ge info.subset.count then begin
		set_error_data, hdf_data_x
		assign_geolocated_data, this_subset, info, hdf_data_x, hdf_data_y, satellite_x, $
			satellite_y, sun_x, sun_y
		return
	endif
endif

if info.geo_name.lat ne 'None' then begin
	lat_index=name_to_index(info.geo_name.lat, info.name_list_subset)
	lat_index = lat_index(0)
	if lat_index lt 0 or lat_index ge info.subset.count then begin
		set_error_data, hdf_data_x
		assign_geolocated_data, this_subset, info, hdf_data_x, hdf_data_y, satellite_x, $
			satellite_y, sun_x, sun_y
		return
	endif
endif

if info.geo_name.satelong ne 'None' then begin
	satelong_index=name_to_index(info.geo_name.satelong, info.name_list_subset)
	satelong_index = satelong_index(0)
	if satelong_index lt 0 or satelong_index ge info.subset.count then begin
		set_error_data, satellite_x
		assign_geolocated_data, this_subset, info, hdf_data_x, hdf_data_y, satellite_x, $
			satellite_y, sun_x, sun_y
		info.greenwich.satellite = 0
	endif else info.greenwich.satellite = 1
endif else info.greenwich.satellite = 0

if info.geo_name.satecol eq 'None' and info.geo_name.satelat eq 'None' then $
	info.greenwich.satellite = 0

if info.geo_name.satecol ne 'None' then begin
	satecol_index=name_to_index(info.geo_name.satecol, info.name_list_subset)
	satecol_index = satecol_index(0)
	if satecol_index lt 0 or satecol_index ge info.subset.count then begin
		set_error_data, satellite_x
		assign_geolocated_data, this_subset, info, hdf_data_x, hdf_data_y, satellite_x, $
			satellite_y, sun_x, sun_y
		info.greenwich.satellite = 0
	endif
endif

if info.geo_name.satelat ne 'None' then begin
	satelat_index=name_to_index(info.geo_name.satelat, info.name_list_subset)
	satelat_index = satelat_index(0)
	if satelat_index lt 0 or satelat_index ge info.subset.count then begin
		set_error_data, satellite_x
		assign_geolocated_data, this_subset, info, hdf_data_x, hdf_data_y, satellite_x, $
			satellite_y, sun_x, sun_y
		info.greenwich.satellite = 0
	endif
endif

if info.geo_name.sunlong ne 'None' then begin
	sunlong_index=name_to_index(info.geo_name.sunlong, info.name_list_subset)
	sunlong_index = sunlong_index(0)
	if sunlong_index lt 0 or sunlong_index ge info.subset.count then begin
		set_error_data, sun_x
		assign_geolocated_data, this_subset, info, hdf_data_x, hdf_data_y, satellite_x, $
			satellite_y, sun_x, sun_y
		info.greenwich.sun = 0
	endif else info.greenwich.sun = 1
endif else info.greenwich.sun = 0

if info.geo_name.suncol eq 'None' and info.geo_name.sunlat eq 'None' then $
	info.greenwich.sun = 0

if info.geo_name.suncol ne 'None' then begin
	suncol_index=name_to_index(info.geo_name.suncol, info.name_list_subset)
	suncol_index = suncol_index(0)
	if suncol_index lt 0 or suncol_index ge info.subset.count then begin
		set_error_data, sun_x
		assign_geolocated_data, this_subset, info, hdf_data_x, hdf_data_y, satellite_x, $
			satellite_y, sun_x, sun_y
		info.greenwich.sun = 0
	endif
endif 

if info.geo_name.sunlat ne 'None' then begin
	sunlat_index=name_to_index(info.geo_name.sunlat, info.name_list_subset)
	sunlat_index = sunlat_index(0)
	if sunlat_index lt 0 or sunlat_index ge info.subset.count then begin
		set_error_data, sun_x
		assign_geolocated_data, this_subset, info, hdf_data_x, hdf_data_y, satellite_x, $
			satellite_y, sun_x, sun_y
		info.greenwich.sun = 0
	endif
endif 

starting=info.subset.data(this_subset).src_start(0)
ending=info.subset.data(this_subset).src_end(0)
if info.subset.data(this_subset).src_type_flag eq 1 then ending = ending + 1
increment=info.subset.data(this_subset).src_increment(0)
num_z = info.subset.data(this_subset).src_num

long_start = info.subset.data(long_index).src_start(0)
long_end = info.subset.data(long_index).src_end(0)
if info.subset.data(long_index).src_type_flag eq 1 then long_end = long_end + 1
long_increment = info.subset.data(long_index).src_increment(0)
num_x = info.subset.data(long_index).src_num

check_expand = 0
if info.greenwich.expand eq 1 then begin
   hdf_data_z = *info.subset.data(this_subset).src_data
   size_z = size(hdf_data_z)
   x_rank = info.subset.data(long_index).src_rank
   long_diff = long_end - long_start
   ;if info.subset.data(long_index).src_type_flag eq 1 then long_diff = long_diff + 1
   if size_z(0) eq 2 and x_rank eq 1 then begin
	if info.geo_name.colat ne 'None' then begin
		colat_start = info.subset.data(colat_index).src_start(0)
		colat_end = info.subset.data(colat_index).src_end(0)
		if info.subset.data(colat_index).src_type_flag eq 1 then colat_end = colat_end + 1
		y_rank = info.subset.data(long_index).src_rank
		y_index = colat_index
	endif else begin
		colat_start = info.subset.data(lat_index).src_start(0)
		colat_end = info.subset.data(lat_index).src_end(0)
		if info.subset.data(lat_index).src_type_flag eq 1 then colat_end = colat_end + 1
		y_rank = info.subset.data(long_index).src_rank
		y_index = lat_index
	endelse
	if y_rank eq 1 then begin
		check_expand = 1
		colat_diff = colat_end - colat_start
		;if info.subset.data(y_index).src_type_flag eq 1 then colat_diff = colatlong_diff + 1
		long_start = colat_start
		long_end = colat_end
	endif
   endif
endif

if num_z eq num_x then begin
    if info.subset.data(long_index).src_type_flag eq 0 then begin
	hdf_data_x = *info.subset.data(long_index).src_data
    endif else begin
	hdf_x_temp = *info.subset.data(long_index).src_data
	hdf_data_x = reform(hdf_x_temp.components0, n_elements(hdf_x_temp.components0))
    endelse
endif else begin
    if (increment eq long_increment) or (long_increment eq 1) then incre_ok = 1 $
        else incre_ok = 0
    if (starting ge long_start and ending le long_end) and (incre_ok eq 1) then begin
	if info.subset.data(long_index).src_type_flag eq 0 then begin
  		hdf_data_x = *info.subset.data(long_index).src_data
		if check_expand eq 1 then begin
			size_x = size(hdf_data_x)
			if size_x(0) eq 1 then begin
				array_size = [long(colat_diff), long(long_diff)]
				the_type = info.subset.data(long_index).src_types
				the_type = the_type(0)
				hdf_data_x_temp = array_type(the_type, array_size)
				if (hdf_data_x_temp(0) eq -1) then begin
					result=dialog_message('Unable to allocate memory for temporary longitudex data!',$
						title='View HDF Warning!')
					set_error_data, hdf_data_x
					assign_geolocated_data, this_subset, info, hdf_data_x, hdf_data_y, satellite_x, $
						satellite_y, sun_x, sun_y
					return
				endif
				for j = 0, long_diff-1 do begin
					hdf_data_x_temp(j,*) = hdf_data_x(j)
				endfor
				hdf_data_x = hdf_data_x_temp
			endif
		endif
	endif else begin
  		hdf_x_temp = *info.subset.data(long_index).src_data
  		hdf_data_x = reform(hdf_x_temp.components0, n_elements(hdf_x_temp.components0))
	endelse
    endif else begin
	the_message = ['The range of longitude data is less than selected data!',$
			'Increase the range of longitude data and do it again!!!']
	result=dialog_message(the_message, title='View HDF Warning!')
	set_error_data, hdf_data_x
	assign_geolocated_data, this_subset, info, hdf_data_x, hdf_data_y, satellite_x, $
		satellite_y, sun_x, sun_y
	return
    endelse
endelse

if info.geo_name.colat ne 'None' then begin
	colat_start = info.subset.data(colat_index).src_start(0)
	colat_end = info.subset.data(colat_index).src_end(0)
	if info.subset.data(colat_index).src_type_flag eq 1 then colat_end = colat_end + 1
	colat_increment = info.subset.data(colat_index).src_increment(0)
	y_index = colat_index
	num_y = info.subset.data(colat_index).src_num
endif else begin
        colat_start = info.subset.data(lat_index).src_start(0)
        colat_end = info.subset.data(lat_index).src_end(0)
	if info.subset.data(lat_index).src_type_flag eq 1 then colat_end = colat_end + 1
	colat_increment = info.subset.data(lat_index).src_increment(0)
	y_index = lat_index
	num_y = info.subset.data(lat_index).src_num
endelse

if num_z eq num_y then begin
    if info.subset.data(y_index).src_type_flag eq 0 then begin
	hdf_data_y = *info.subset.data(y_index).src_data
    endif else begin
	hdf_y_temp = *info.subset.data(y_index).src_data
	hdf_data_y = reform(hdf_y_temp.components0, n_elements(hdf_y_temp.components0))
    endelse
    if info.geo_name.colat ne 'None' then hdf_data_y = 90.0 - hdf_data_y
endif else begin
    if (increment eq colat_increment) or (colat_increment eq 1) then incre_ok = 1 $
	else incre_ok = 0
    if (starting ge colat_start and ending le colat_end) and (incre_ok eq 1) then begin
	if info.subset.data(y_index).src_type_flag eq 0 then begin
		hdf_data_y = *info.subset.data(y_index).src_data
		if check_expand eq 1 then begin
			size_y = size(hdf_data_y)
			if size_y(0) eq 1 then begin
				array_size = [long(colat_diff), long(long_diff)]
				the_type = info.subset.data(y_index).src_types
				the_type = the_type(0)
				hdf_data_y_temp = array_type(the_type, array_size)
				if (hdf_data_y_temp(0) eq -1) then begin
					result=dialog_message('Unable to allocate memory for temporary colatitude data!',$
						title='View HDF Warning!')
					set_error_data, hdf_data_x
					assign_geolocated_data, this_subset, info, hdf_data_x, hdf_data_y, satellite_x, $
						satellite_y, sun_x, sun_y
					return
				endif
				for j = 0, colat_diff-1 do begin
					hdf_data_y_temp(*,j) = hdf_data_y(j)
				endfor
				hdf_data_y = hdf_data_y_temp
			endif
		endif
		if info.geo_name.colat ne 'None' then begin
			size_hdf_y = size(hdf_data_y)
			case size_hdf_y(0) of
				1: hdf_data_y = 90.0 - hdf_data_y(*)
				2: hdf_data_y = 90.0 - hdf_data_y(*,*)
				3: hdf_data_y = 90.0 - hdf_data_y(*,*,*)
				else:
			endcase
		endif
        endif else begin
                hdf_y_temp = *info.subset.data(y_index).src_data
                hdf_data_y = reform(hdf_y_temp.components0, n_elements(hdf_y_temp.components0))
		if info.geo_name.colat ne 'None' then $
			hdf_data_y = 90.0 - hdf_data_y(*)
        endelse
    endif else begin
        the_message = ['The range of Colatitude or Latitude data is ', 'less than selected data!',$
                        'Increase the range of Colatitude or Latitude', 'data and do it again!!!']
        result=dialog_message(the_message, title='View HDF Warning!')
        set_error_data, hdf_data_x
	assign_geolocated_data, this_subset, info, hdf_data_x, hdf_data_y, satellite_x, $
		satellite_y, sun_x, sun_y
	return
    endelse
endelse

info.geolocated.selected = 1
info.geolocated.long_index = long_index

if info.greenwich.satellite ne 0 then begin
	long_start = info.subset.data(satelong_index).src_start(0)
	long_end = info.subset.data(satelong_index).src_end(0)
	if info.subset.data(satelong_index).src_type_flag eq 1 then long_end = long_end + 1
	num_x = info.subset.data(satelong_index).src_num

	if num_z eq num_x then begin
	    if info.subset.data(satelong_index).src_type_flag eq 0 then begin
		satellite_x = *info.subset.data(satelong_index).src_data
	    endif else begin
		hdf_x_temp = *info.subset.data(satelong_index).src_data
		satellite_x = reform(hdf_x_temp.components0, n_elements(hdf_x_temp.components0))
	    endelse
	endif else begin
	    if(starting ge long_start and ending le long_end) or $
		(info.greenwich.default eq 0) then begin
		if info.subset.data(satelong_index).src_type_flag eq 0 then begin
  			satellite_x = *info.subset.data(satelong_index).src_data
		endif else begin
  			hdf_x_temp = *info.subset.data(satelong_index).src_data
  			satellite_x = reform(hdf_x_temp.components0, n_elements(hdf_x_temp.components0))
		endelse
	    endif else begin
		the_message = ['The range of satellite longitude data is','less than selected data!',$
			'Increase the range of satellite longitude data ', 'and do it again!!!']
		result=dialog_message(the_message, title='View HDF Warning!')
		set_error_data, satellite_x
		assign_geolocated_data, this_subset, info, hdf_data_x, hdf_data_y, satellite_x, $
			satellite_y, sun_x, sun_y
		info.greenwich.satellite = 0
		return
	    endelse
	endelse

	if info.geo_name.satecol ne 'None' then begin
		colat_start = info.subset.data(satecol_index).src_start(0)
		colat_end = info.subset.data(satecol_index).src_end(0)
		if info.subset.data(satecol_index).src_type_flag eq 1 then colat_end = colat_end + 1
		y_index = satecol_index
		num_y = info.subset.data(satecol_index).src_num
	endif else begin
		colat_start = info.subset.data(satelat_index).src_start(0)
        	colat_end = info.subset.data(satelat_index).src_end(0)
		if info.subset.data(satelat_index).src_type_flag eq 1 then colat_end = colat_end + 1
		y_index = satelat_index
		num_y = info.subset.data(satelat_index).src_num
	endelse

	if num_z eq num_y then begin
	    if info.subset.data(y_index).src_type_flag eq 0 then begin
		satellite_y = *info.subset.data(y_index).src_data
	    endif else begin
		hdf_y_temp = *info.subset.data(y_index).src_data
		satellite_y = reform(hdf_y_temp.components0, n_elements(hdf_y_temp.components0))
	    endelse
	    if info.geo_name.satecol ne 'None' then satellite_y = 90.0 - satellite_y
        endif else begin
	    if(starting ge colat_start and ending le colat_end) or $
		(info.greenwich.default eq 0) then begin
		if info.subset.data(y_index).src_type_flag eq 0 then begin
			satellite_y = *info.subset.data(y_index).src_data
			if info.geo_name.satecol ne 'None' then begin
				size_hdf_y = size(satellite_y)
				case size_hdf_y(0) of
					1: satellite_y = 90.0 - satellite_y(*)
					2: satellite_y = 90.0 - satellite_y(*,*)
					3: satellite_y = 90.0 - satellite_y(*,*,*)
					else:
				endcase
			endif
        	endif else begin
                	hdf_y_temp = *info.subset.data(y_index).src_data
                	satellite_y = reform(hdf_y_temp.components0, n_elements(hdf_y_temp.components0))
			if info.geo_name.satecol ne 'None' then $
				satellite_y = 90.0 - satellite_y(*)
        	endelse
	    endif else begin
       		the_message = ['The range of Satellite Colatitude or Latitude data','is less than selected data!',$
                        'Increase the range of Satellite Colatitude or Latitude','data and do it again!!!']
        	result=dialog_message(the_message, title='View HDF Warning!')
        	set_error_data, satellite_x
        	assign_geolocated_data, this_subset, info, hdf_data_x, hdf_data_y, satellite_x, $
			satellite_y, sun_x, sun_y
		info.greenwich.satellite = 0
        	return
	    endelse
	endelse
endif

if info.greenwich.sun ne 0 then begin
	long_start = info.subset.data(sunlong_index).src_start(0)
	long_end = info.subset.data(sunlong_index).src_end(0)
	if info.subset.data(sunlong_index).src_type_flag eq 1 then long_end = long_end + 1
	num_x = info.subset.data(sunlong_index).src_num

	if num_z eq num_x then begin
	    if info.subset.data(sunlong_index).src_type_flag eq 0 then begin
		sun_x = *info.subset.data(sunlong_index).src_data
	    endif else begin
		hdf_x_temp = *info.subset.data(sunlong_index).src_data
		sun_x = reform(hdf_x_temp.components0, n_elements(hdf_x_temp.components0))
	    endelse
	endif else begin
	    if(starting ge long_start and ending le long_end) or $
		(info.greenwich.default eq 0) then begin
		if info.subset.data(sunlong_index).src_type_flag eq 0 then begin
  			sun_x = *info.subset.data(sunlong_index).src_data
		endif else begin
  			hdf_x_temp = *info.subset.data(sunlong_index).src_data
  			sun_x = reform(hdf_x_temp.components0, n_elements(hdf_x_temp.components0))
		endelse
	    endif else begin
		the_message = ['The range of Sun longitude data is','less than selected data!',$
			'Increase the range of Sun longitude data ', 'and do it again!!!']
		result=dialog_message(the_message, title='View HDF Warning!')
		set_error_data, sun_x
		assign_geolocated_data, this_subset, info, hdf_data_x, hdf_data_y, satellite_x, $
			satellite_y, sun_x, sun_y
		info.greenwich.sun = 0
		return
	    endelse
	endelse

	if info.geo_name.suncol ne 'None' then begin
		colat_start = info.subset.data(suncol_index).src_start(0)
		colat_end = info.subset.data(suncol_index).src_end(0)
		if info.subset.data(suncol_index).src_type_flag eq 1 then colat_end = colat_end + 1
		y_index = suncol_index
		num_y = info.subset.data(suncol_index).src_num
	endif else begin
		colat_start = info.subset.data(sunlat_index).src_start(0)
        	colat_end = info.subset.data(sunlat_index).src_end(0)
		if info.subset.data(sunlat_index).src_type_flag eq 1 then colat_end = colat_end + 1
		y_index = sunlat_index
		num_y = info.subset.data(sunlat_index).src_num
	endelse

	if num_z eq num_y then begin
	    if info.subset.data(y_index).src_type_flag eq 0 then begin
		sun_y = *info.subset.data(y_index).src_data
	    endif else begin
		hdf_y_temp = *info.subset.data(y_index).src_data
		sun_y = reform(hdf_y_temp.components0, n_elements(hdf_y_temp.components0))
	    endelse
	    if info.geo_name.satecol ne 'None' then sun_y = 90.0 - sun_y
	endif else begin
	    if(starting ge colat_start and ending le colat_end) or $
		(info.greenwich.default eq 0) then begin
		if info.subset.data(y_index).src_type_flag eq 0 then begin
			sun_y = *info.subset.data(y_index).src_data
			if info.geo_name.satecol ne 'None' then begin
				size_hdf_y = size(sun_y)
				case size_hdf_y(0) of
					1: sun_y = 90.0 - sun_y(*)
					2: sun_y = 90.0 - sun_y(*,*)
					3: sun_y = 90.0 - sun_y(*,*,*)
					else:
				endcase
			endif
        	endif else begin
                	hdf_y_temp = *info.subset.data(y_index).src_data
                	sun_y = reform(hdf_y_temp.components0, n_elements(hdf_y_temp.components0))
			if info.geo_name.satecol ne 'None' then $
				sun_y = 90.0 - sun_y(*)
        	endelse
	    endif else begin
       		the_message = ['The range of Sun Colatitude or Latitude data','is less than selected data!',$
                        'Increase the range of Sun Colatitude or Latitude','data and do it again!!!']
        	result=dialog_message(the_message, title='View HDF Warning!')
        	set_error_data, sun_x
        	assign_geolocated_data, this_subset, info, hdf_data_x, hdf_data_y, satellite_x, $
			satellite_y, sun_x, sun_y
		info.greenwich.sun = 0
        	return
	    endelse
	endelse
endif

assign_geolocated_data, this_subset, info, hdf_data_x, hdf_data_y, satellite_x, $
	satellite_y, sun_x, sun_y

end

;------------------------------------------------------------------
pro set_geofields_event, event

pro_name = 'set_geofields_event'
@getinfo

if TAG_NAMES(event,/structure_name) eq 'WIDGET_TRACKING' then return
widget_control, get_uvalue=info, event.top
widget_control, get_uvalue=info, info.base 

heading = str_sep(event.value, '.')
if n_elements(heading) gt 2 then begin
	length = strlen(event.value)
	dot=strpos(event.value,'.')
	if( dot ne -1) then begin
		field_name = strmid(event.value,dot+1,length-dot-1)
	endif else begin
		field_name = event.value
	endelse
endif else field_name = heading(1)

CASE heading(0) of

	'Longitude Field Selection' : begin
		info.geo_name.long = field_name
       		widget_control, info.geo_widgets.long_field, set_value=field_name
	end

	'Colatitude Field Selection' : begin
		info.geo_name.colat = field_name
       		widget_control, info.geo_widgets.col_field, set_value=field_name
		lat_name = ' '
		widget_control, info.geo_widgets.lat_field, get_value=lat_name
		lat_name = lat_name(0)
		if lat_name ne 'None' then begin
			lat_name = 'None'
			info.geo_name.lat = lat_name
			widget_control, info.geo_widgets.lat_field, set_value=lat_name
		endif
	end

	'Latitude Field Selection' : begin
		info.geo_name.lat = field_name
       		widget_control, info.geo_widgets.lat_field, set_value=field_name
		colat_name = ' '
                widget_control, info.geo_widgets.col_field, get_value=colat_name
		colat_name = colat_name(0)
                if colat_name ne 'None' then begin
			colat_name = 'None'
			info.geo_name.colat = colat_name
                        widget_control, info.geo_widgets.col_field, set_value=colat_name
		endif
	end

	'Satellite Longitude Field Selection' : begin
		info.geo_name.satelong = field_name
       		widget_control, info.geo_widgets.satelong_field, set_value=field_name
	end

	'Satellite Colatitude Field Selection' : begin
		info.geo_name.satecol = field_name
       		widget_control, info.geo_widgets.satecol_field, set_value=field_name
		lat_name = ' '
		widget_control, info.geo_widgets.satelat_field, get_value=lat_name
		lat_name = lat_name(0)
		if lat_name ne 'None' then begin
			lat_name = 'None'
			widget_control, info.geo_widgets.satelat_field, set_value=lat_name
		endif
	end

	'Satellite Latitude Field Selection' : begin
		info.geo_name.satelat = field_name
       		widget_control, info.geo_widgets.satelat_field, set_value=field_name
		colat_name = ' '
                widget_control, info.geo_widgets.satecol_field, get_value=colat_name
		colat_name = colat_name(0)
                if colat_name ne 'None' then begin
			colat_name = 'None'
                        widget_control, info.geo_widgets.satecol_field, set_value=colat_name
		endif
	end

	'Sun Longitude Field Selection' : begin
		info.geo_name.sunlong = field_name
       		widget_control, info.geo_widgets.sunlong_field, set_value=field_name
	end

	'Sun Colatitude Field Selection' : begin
		info.geo_name.suncol = field_name
       		widget_control, info.geo_widgets.suncol_field, set_value=field_name
		lat_name = ' '
		widget_control, info.geo_widgets.sunlat_field, get_value=lat_name
		lat_name = lat_name(0)
		if lat_name ne 'None' then begin
			lat_name = 'None'
			widget_control, info.geo_widgets.sunlat_field, set_value=lat_name
		endif
	end

	'Sun Latitude Field Selection' : begin
		info.geo_name.sunlat = field_name
       		widget_control, info.geo_widgets.sunlat_field, set_value=field_name
		colat_name = ' '
                widget_control, info.geo_widgets.suncol_field, get_value=colat_name
		colat_name = colat_name(0)
                if colat_name ne 'None' then begin
			colat_name = 'None'
                        widget_control, info.geo_widgets.suncol_field, set_value=colat_name
		endif
	end

	else:

ENDCASE

widget_control, set_uvalue=info, info.base

end

;------------------------------------------------------------------
pro create_geo_fields, long_field, col_field, lat_field, satelong_field, $
	satecol_field, satelat_field, sunlong_field, suncol_field, sunlat_field, $
	long_group, colat_group, lat_group, satelong_group, satecol_group, $
	satelat_group, sunlong_group, suncol_group, sunlat_group, info

pro_name = 'create_geo_fields'
@getinfo
 
font1=info.font

long_field= CW_FIELD( long_group, VALUE=info.geo_name.long, $
ROW=1, STRING=1, FIELDFONT= font1, FONT= font1, $
TITLE='Longitude Field:           ', XSIZE=40)
	
info.geo_widgets.long_field= long_field

col_field= CW_FIELD( colat_group, VALUE=info.geo_name.colat, $
ROW=1, STRING=1, FIELDFONT= font1, FONT= font1, $
TITLE='*Colatitude Field:          ', XSIZE=40)

info.geo_widgets.col_field = col_field

lat_field= CW_FIELD( lat_group, VALUE=info.geo_name.lat, $
ROW=1, STRING=1, FIELDFONT= font1, FONT= font1, $
TITLE='*Latitude Field:            ', XSIZE=40) 

info.geo_widgets.lat_field =lat_field

satelong_field= CW_FIELD( satelong_group, VALUE=info.geo_name.satelong, $
ROW=1, STRING=1, FIELDFONT= font1, FONT= font1, $
TITLE='Satellite Longitude Field: ', XSIZE=40)
	
info.geo_widgets.satelong_field= satelong_field

satecol_field= CW_FIELD( satecol_group, VALUE=info.geo_name.satecol, $
ROW=1, STRING=1, FIELDFONT= font1, FONT= font1, $
TITLE='*Satellite Colatitude Field:', XSIZE=40)

info.geo_widgets.satecol_field = satecol_field

satelat_field= CW_FIELD( satelat_group, VALUE=info.geo_name.satelat, $
ROW=1, STRING=1, FIELDFONT= font1, FONT= font1, $
TITLE='*Satellite Latitude Field:  ', XSIZE=40) 

info.geo_widgets.satelat_field =satelat_field

sunlong_field= CW_FIELD( sunlong_group, VALUE=info.geo_name.sunlong, $
ROW=1, STRING=1, FIELDFONT= font1, FONT= font1, $
TITLE='Sun Longitude Field:       ', XSIZE=40)
	
info.geo_widgets.sunlong_field= sunlong_field

suncol_field= CW_FIELD( suncol_group, VALUE=info.geo_name.suncol, $
ROW=1, STRING=1, FIELDFONT= font1, FONT= font1, $
TITLE='*Sun Colatitude Field:      ', XSIZE=40)

info.geo_widgets.suncol_field = suncol_field

sunlat_field= CW_FIELD( sunlat_group, VALUE=info.geo_name.sunlat, $
ROW=1, STRING=1, FIELDFONT= font1, FONT= font1, $
TITLE='*Sun Latitude Field:        ', XSIZE=40) 

info.geo_widgets.sunlat_field =sunlat_field

widget_control, set_uvalue=info, info.base

end

;------------------------------------------------------------------
pro get_geo_parameter_names, long_field, col_field, lat_field, satelong_field, $
	satecol_field, satelat_field, sunlong_field, suncol_field, sunlat_field, $
	name_list

pro_name = 'get_geo_parameter_names'
@getinfo
 
long_field = field_struct('Longitude Field Selection', name_list)
col_field = field_struct('Colatitude Field Selection', name_list)
lat_field = field_struct('Latitude Field Selection', name_list)
satelong_field = field_struct('Satellite Longitude Field Selection', name_list)
satecol_field = field_struct('Satellite Colatitude Field Selection', name_list)
satelat_field = field_struct('Satellite Latitude Field Selection', name_list)
sunlong_field = field_struct('Sun Longitude Field Selection', name_list)
suncol_field = field_struct('Sun Colatitude Field Selection', name_list)
sunlat_field = field_struct('Sun Latitude Field Selection', name_list)

end

;------------------------------------------------------------------
pro make_geo_buttons, long_field, col_field, lat_field, satelong_field, satecol_field, $
        satelat_field, sunlong_field, suncol_field, sunlat_field, long_group, $
        colat_group, lat_group, satelong_group, satecol_group, satelat_group, $
        sunlong_group, suncol_group, sunlat_group, base

pro_name = 'make_geo_buttons'
@getinfo
 
if !D.Name eq 'X' then begin
   font1='-adobe-helvetica-bold-o-normal--14-140-75-75-p-82-iso8859-1'
endif else begin
   font1 = 'Times New Roman*Bold*18'
endelse

button1=cw_pdmenu(long_group, long_field, /RETURN_FULL_NAME, FONT= font1)

button2=cw_pdmenu(colat_group, col_field, /RETURN_FULL_NAME, FONT= font1 )

button3=cw_pdmenu(lat_group, lat_field, /RETURN_FULL_NAME, FONT= font1)

button4=cw_pdmenu(satelong_group, satelong_field, /RETURN_FULL_NAME, FONT= font1)

button5=cw_pdmenu(satecol_group, satecol_field, /RETURN_FULL_NAME, FONT= font1 )

button6=cw_pdmenu(satelat_group, satelat_field, /RETURN_FULL_NAME, FONT= font1)

button7=cw_pdmenu(sunlong_group, sunlong_field, /RETURN_FULL_NAME, FONT= font1)

button8=cw_pdmenu(suncol_group, suncol_field, /RETURN_FULL_NAME, FONT= font1 )

button9=cw_pdmenu(sunlat_group, sunlat_field, /RETURN_FULL_NAME, FONT= font1)

group2=widget_base(base, row=1,map=1, space=40, /align_center)

done_button=widget_button(group2, $
        FONT= font1, VALUE="Done", EVENT_PRO='get_geo_doneCB', /ALIGN_CENTER)

clear_button=widget_button(group2, $
	FONT= font1, VALUE="Clear", EVENT_PRO='clear_geo_field', /ALIGN_CENTER)

cancel_button=widget_button(group2, $
        FONT= font1, VALUE="Cancel", EVENT_PRO='cancelCB', /ALIGN_CENTER)

text2id = widget_label(base, value = " ", /ALIGN_CENTER, FONT=font1)
text2 = '* Select either Colatitude or Latitude.'
text2id=widget_label(base, value = text2, /ALIGN_LEFT, FONT=font1)

widget_control, DEFAULT_BUTTON=done_button, CANCEL_BUTTON=cancel_button, base

end

;------------------------------------------------------------------
pro get_geolocated_name, info

pro_name = 'get_geolocated_name'
@getinfo

font2 =info.font

base_loc = widget_info(info.base, /geometry)
xoffset = base_loc.xoffset + 100
yoffset = base_loc.yoffset + 100
base=widget_base( GROUP_LEADER=info.base, /MODAL, COLUMN=1, MAP=1, $
	TITLE='Select Geolocated Fields', uvalue=info, $
	xoffset=xoffset, yoffset=yoffset)

text2 = 'REQUIRED FIELDS'
text2id=widget_label(base, value = text2, /ALIGN_CENTER, FONT=font2)

long_group=widget_base(base, row=1,map=1)
colat_group=widget_base(base, row=1, map=1)
lat_group=widget_base(base, row=1, map=1)

text2 = 'OPTIONAL FIELDS'
text2id=widget_label(base, value = text2, /ALIGN_CENTER, FONT=font2)

satelong_group=widget_base(base, row=1, map=1)
satecol_group=widget_base(base, row=1, map=1)
satelat_group=widget_base(base, row=1, map=1)

text2id=widget_label(base, value = " ", /ALIGN_CENTER, FONT=font2)

sunlong_group=widget_base(base, row=1, map=1)
suncol_group=widget_base(base, row=1, map=1)
sunlat_group=widget_base(base, row=1, map=1)

create_geo_fields, long_field, col_field, lat_field, satelong_field, satecol_field, $
	satelat_field, sunlong_field, suncol_field, sunlat_field, long_group, $
	colat_group, lat_group, satelong_group, satecol_group, satelat_group, $
	sunlong_group, suncol_group, sunlat_group, info

name_list_geo = [info.name_list_subset, 'None']
get_geo_parameter_names, long_field, col_field, lat_field, satelong_field, $
	satecol_field, satelat_field, sunlong_field, suncol_field, sunlat_field, $
	name_list_geo
	;info.name_list_subset

make_geo_buttons, long_field, col_field, lat_field, satelong_field, satecol_field, $
        satelat_field, sunlong_field, suncol_field, sunlat_field, long_group, $
        colat_group, lat_group, satelong_group, satecol_group, satelat_group, $
        sunlong_group, suncol_group, sunlat_group, base

widget_control, set_uvalue=info, base  
widget_control,/realize, base

XMANAGER, 'set_geofields', base

END

;------------------------------------------------------------------
pro get_geolocated_data, info, this_subset

pro_name = 'get_geolocated_data'
@getinfo
 
    if info.greenwich.default eq 0 then begin
	info.geolocated.selected = 0
	get_geolocated_name, info
	return
    endif

    ;widget_control,info.widgets.current_file,get_value=filename
    filename = info.subset.data(this_subset).src_filename
    filename = filename(0)

    check_hdf = HDF_ISHDF(filename)
    if check_hdf eq 0 then begin
	info.greenwich.default = 0
	info.geolocated.selected = 0
	get_geolocated_name, info
	return
    endif

;   ***For longitude of FOV***
    sds_name = ['Longitude of CERES FOV at surface', $
	'Longitude of CERES FOV at Surface', 'Longitude of CERES FOV at TOA', $
	'Colat_Long', 'Colat_Longitude', 'Longitude', 'longitude']
    num_name = n_elements(sds_name)
    sds_index = -1
    i = 0
    while (sds_index eq -1 and i lt num_name) do begin
	temp_name = sds_name(i)
	sds_index = check_sds_index(filename, temp_name)
	i = i + 1
    endwhile
    if sds_index ne -1 then begin

	the_result = read_sds_data( this_subset, temp_name, info, hdf_data_x)
	if (the_result eq -1) then begin
		result=dialog_message('Unable to read ' + temp_name + ' SDS data!',$
			title='View HDF Warning!')
		set_error_data,hdf_data_x
		assign_geolocated_data, this_subset, info, hdf_data_x, hdf_data_y, $
			satellite_x, satellite_y, sun_x, sun_y
		return
	endif

	if temp_name eq 'Colat_Long' or temp_name eq 'Colat_Longitude' then begin
		temp_x = hdf_data_x(7,*)
		hdf_data_y = 90.0 - hdf_data_x(6,*)
		satellite_x = hdf_data_x(1,*)
		satellite_y = 90.0 - hdf_data_x(0,*)
		sun_x = hdf_data_x(3,*)
		sun_y = 90.0 - hdf_data_x(2,*)
		hdf_data_x = temp_x

		assign_geolocated_data, this_subset, info, hdf_data_x, hdf_data_y, $
			satellite_x, satellite_y, sun_x, sun_y

		return
	endif

    endif else begin
	vdata_name = ['IES Hour']
	num_name = n_elements(vdata_name)
	count = 0
	i = 0
	while(count eq 0 and i lt num_name) do begin
		temp_name = vdata_name(i)
		search_result = strpos(info.name_list_vdata, temp_name)
		result = where(search_result ne -1, count)
		i = i + 1
	endwhile
	if count ne 0 then begin

	   the_vdata_name = ''
	   the_vdata_name = info.name_list_vdata(result)
	   vdata_id = open_vdata(filename,the_vdata_name,file_id)
	   if vdata_id eq 0 then begin
		result=dialog_message('Unable to attach '+the_vdata_name+'!',$
			title='View HDF Warning!')
		set_error_data,hdf_data_x
		assign_geolocated_data, this_subset, info, hdf_data_x, hdf_data_y, $
			satellite_x, satellite_y, sun_x, sun_y
		return
	   endif
	   field_name = ['Longitude of CERES FOV at Surface']
	   num_field = n_elements(field_name)
	   field_check = -1
	   i = 0
	   while (field_check eq -1 and i lt num_field) do begin
		fieldname = field_name(i)
		field_check = HDF_VD_FEXIST(vdata_id,fieldname)
		i = i + 1
	   endwhile
	   if field_check eq -1 then begin
		result=dialog_message('Unable to find Longitude of FOV field!', $
			title='View HDF Warning!')
		HDF_VD_DETACH, vdata_id
		HDF_CLOSE,file_id
		set_error_data,hdf_data_x
		assign_geolocated_data, this_subset, info, hdf_data_x, hdf_data_y, $
			satellite_x, satellite_y, sun_x, sun_y
		return
	   endif
	   HDF_VD_GET,vdata_id,COUNT=the_nrec

	   HDF_VD_DETACH, vdata_id
	   HDF_CLOSE,file_id

	   the_result = read_vdata_data(this_subset, the_nrec, the_vdata_name, $
		fieldname, info, hdf_data_x)
	   if (the_result eq -1) then begin
		result=dialog_message('Unable to read ' + fieldname + ' Vdata data!',$
			title='View HDF Warning!')
		set_error_data, hdf_data_x
		assign_geolocated_data, this_subset, info, hdf_data_x, hdf_data_y, $
			satellite_x, satellite_y, sun_x, sun_y
		return
	   endif

	   hdf_data_x = reform(hdf_data_x.components0, n_elements(hdf_data_x.components0))

	endif else begin

	   if info.subset.count lt 3 then begin
		result=dialog_message('The Geolocated fields are not found!',$
                    title='View HDF Warning!')
		set_error_data, hdf_data_x
		assign_geolocated_data, this_subset, info, hdf_data_x, hdf_data_y, satellite_x, $
                	satellite_y, sun_x, sun_y
		return
	   endif

	   the_message = ['The Geolocated fields are not found!', $
		'Do you want to get them from Current Subset list?']
	   result=dialog_message(the_message, /Question, title='View HDF Question!')

	   if result eq 'Yes' then begin
		info.geolocated.selected = 0
		get_geolocated_name, info
		return
	   endif else begin
		set_error_data, hdf_data_x
		assign_geolocated_data, this_subset, info, hdf_data_x, hdf_data_y, $
			satellite_x, satellite_y, sun_x, sun_y
		return
	   endelse

	endelse
    endelse

;   ***For colatitude of FOV***
    sds_name = ['Colatitude of CERES FOV at surface', $
	'Colatitude of CERES FOV at Surface', 'Colatitude of CERES FOV at TOA', $
	'Latitude', 'latitude']
    num_name = n_elements(sds_name)
    sds_index = -1
    i = 0
    while (sds_index eq -1 and i lt num_name) do begin
	temp_name = sds_name(i)
	sds_index = check_sds_index(filename, temp_name)
	i = i + 1
    endwhile
    if sds_index ne -1 then begin

	the_result = read_sds_data( this_subset, temp_name, info, hdf_data_y)
	if (the_result eq -1) then begin
		result=dialog_message('Unable to read ' + temp_name + ' SDS data!',$
			title='View HDF Warning!')
		set_error_data,hdf_data_x
		assign_geolocated_data, this_subset, info, hdf_data_x, hdf_data_y, $
			satellite_x, satellite_y, sun_x, sun_y
		return
	endif

	if temp_name ne 'Latitude' and temp_name ne 'latitude' then $
		hdf_data_y = 90.0 - hdf_data_y

    endif else begin

	vdata_name = ['IES Hour']
	num_name = n_elements(vdata_name)
	count = 0
	i = 0
	while(count eq 0 and i lt num_name) do begin
		temp_name = vdata_name(i)
		search_result = strpos(info.name_list_vdata, temp_name)
		result = where(search_result ne -1, count)
		i = i + 1
	endwhile
	if count ne 0 then begin

	   the_vdata_name = ''
	   the_vdata_name = info.name_list_vdata(result)
	   vdata_id = open_vdata(filename,the_vdata_name,file_id)
	   if vdata_id eq 0 then begin
		result=dialog_message('Unable to attach '+the_vdata_name+'!',$
			title='View HDF Warning!')
		set_error_data,hdf_data_x
		assign_geolocated_data, this_subset, info, hdf_data_x, hdf_data_y, $
			satellite_x, satellite_y, sun_x, sun_y
		return
	   endif
	   field_name = ['Colatitude of CERES FOV at Surface']
	   num_field = n_elements(field_name)
	   field_check = -1
	   i = 0
	   while (field_check eq -1 and i lt num_field) do begin
		fieldname = field_name(i)
		field_check = HDF_VD_FEXIST(vdata_id,fieldname)
		i = i + 1
	   endwhile
	   if field_check eq -1 then begin
		result=dialog_message('Unable to find Colatitude of FOV field!', $
			title='View HDF Warning!')
		HDF_VD_DETACH, vdata_id
		HDF_CLOSE,file_id
		set_error_data,hdf_data_x
		assign_geolocated_data, this_subset, info, hdf_data_x, hdf_data_y, $
			satellite_x, satellite_y, sun_x, sun_y
		return
	   endif
	   HDF_VD_GET,vdata_id,COUNT=the_nrec

	   HDF_VD_DETACH, vdata_id
	   HDF_CLOSE,file_id

	   the_result = read_vdata_data(this_subset, the_nrec, the_vdata_name, $
		fieldname, info, hdf_data_y)
	   if (the_result eq -1) then begin
		result=dialog_message('Unable to read ' + fieldname + ' Vdata data!',$
			title='View HDF Warning!')
		set_error_data, hdf_data_x
		assign_geolocated_data, this_subset, info, hdf_data_x, hdf_data_y, $
			satellite_x, satellite_y, sun_x, sun_y
		return
	   endif

		hdf_data_y = reform(hdf_data_y.components0, n_elements(hdf_data_y.components0))
		hdf_data_y = 90.0 - hdf_data_y

	endif else begin

	   if info.subset.count lt 3 then begin
		result=dialog_message('The Geolocated fields are not found!',$
                    title='View HDF Warning!')
		set_error_data, hdf_data_x
		assign_geolocated_data, this_subset, info, hdf_data_x, hdf_data_y, satellite_x, $
                	satellite_y, sun_x, sun_y
		return
	   endif

	   the_message = ['The Geolocated fields are not found!', $
		'Do you want to get them from Current Subset list?']
	   result=dialog_message(the_message, /Question, title='View HDF Question!')

	   if result eq 'Yes' then begin
		info.geolocated.selected = 0
		get_geolocated_name, info
		return
	   endif else begin
		set_error_data, hdf_data_x
		assign_geolocated_data, this_subset, info, hdf_data_x, hdf_data_y, $
			satellite_x, satellite_y, sun_x, sun_y
		return
	   endelse

	endelse
    endelse

;   ***For longitude of satellite***
    sds_name = ['Longitude of subsatellite point at surface at observation']
    num_name = n_elements(sds_name)
    sds_index = -1
    i = 0
    while (sds_index eq -1 and i lt num_name) do begin
	temp_name = sds_name(i)
	sds_index = check_sds_index(filename, temp_name)
	i = i + 1
    endwhile
    if sds_index ne -1 then begin

	the_result = read_sds_data( this_subset, temp_name, info, satellite_x)
	if (the_result eq -1) then begin
		result=dialog_message('Unable to read ' + temp_name + ' SDS data!',$
			title='View HDF Warning!')
		set_error_data,satellite_x
		assign_geolocated_data, this_subset, info, hdf_data_x, hdf_data_y, $
			satellite_x, satellite_y, sun_x, sun_y
		return
	endif

    endif else begin

	vdata_name = ['IES Hour','Satellite-Celestial Data', $
		'Longitude of satellite nadir at record start']
	num_name = n_elements(vdata_name)
	count = 0
	i = 0
	while(count eq 0 and i lt num_name) do begin
		temp_name = vdata_name(i)
		search_result = strpos(info.name_list_vdata, temp_name)
		result = where(search_result ne -1, count)
		i = i + 1
	endwhile
	if count ne 0 then begin
	   the_vdata_name = ''
	   the_vdata_name = info.name_list_vdata(result)
	   vdata_id = open_vdata(filename,the_vdata_name,file_id)
	   if vdata_id eq 0 then begin
		result=dialog_message('Unable to attach '+the_vdata_name+'!',$
			title='View HDF Warning!')
		set_error_data,satellite_x
		assign_geolocated_data, this_subset, info, hdf_data_x, hdf_data_y, $
			satellite_x, satellite_y, sun_x, sun_y
		return
	   endif
	   field_name = ['Longitude of Satellite at Observation', $
		'Longitude of Subsatellite Point at Surface at Observation', $
		'Longitude of Satellite at record start', $
		'Longitude of satellite nadir at record start']
	   num_field = n_elements(field_name)
	   field_check = -1
	   i = 0
	   while (field_check eq -1 and i lt num_field) do begin
		fieldname = field_name(i)
		field_check = HDF_VD_FEXIST(vdata_id,fieldname)
		i = i + 1
	   endwhile
	   if field_check eq -1 then begin
		result=dialog_message('Unable to find Longitude of satellite field!', $
			title='View HDF Warning!')
		HDF_VD_DETACH, vdata_id
		HDF_CLOSE,file_id
		set_error_data,satellite_x
		assign_geolocated_data, this_subset, info, hdf_data_x, hdf_data_y, $
			satellite_x, satellite_y, sun_x, sun_y
		return
	   endif
	   HDF_VD_GET,vdata_id,COUNT=the_nrec

	   HDF_VD_DETACH, vdata_id
	   HDF_CLOSE,file_id

	   the_result = read_vdata_data(this_subset, the_nrec, the_vdata_name, $
		fieldname, info, satellite_x)
	   if (the_result eq -1) then begin
		result=dialog_message('Unable to read ' + fieldname + ' Vdata data!',$
			title='View HDF Warning!')
		set_error_data, satellite_x
		assign_geolocated_data, this_subset, info, hdf_data_x, hdf_data_y, $
			satellite_x, satellite_y, sun_x, sun_y
		return
	   endif

	   if n_elements(satellite_x) eq 1 then $
		satellite_x = [satellite_x.components0] else $
		satellite_x = reform(satellite_x.components0, n_elements(satellite_x.components0))

	endif else begin

		set_error_data, satellite_x
		assign_geolocated_data, this_subset, info, hdf_data_x, hdf_data_y, $
			satellite_x, satellite_y, sun_x, sun_y
		return

	endelse
    endelse

;   ***For colatitude of satellite***
    sds_name = ['Colatitude of subsatellite point at surface at observation']
    num_name = n_elements(sds_name)
    sds_index = -1
    i = 0
    while (sds_index eq -1 and i lt num_name) do begin
	temp_name = sds_name(i)
	sds_index = check_sds_index(filename, temp_name)
	i = i + 1
    endwhile
    if sds_index ne -1 then begin

	the_result = read_sds_data( this_subset, temp_name, info, satellite_y)
	if (the_result eq -1) then begin
		result=dialog_message('Unable to read ' + temp_name + ' SDS data!',$
			title='View HDF Warning!')
		set_error_data,satellite_x
		assign_geolocated_data, this_subset, info, hdf_data_x, hdf_data_y, $
			satellite_x, satellite_y, sun_x, sun_y
		return
	endif

	satellite_y = 90.0 - satellite_y

    endif else begin

	vdata_name = ['IES Hour','Satellite-Celestial Data', $
		'Colatitude of satellite nadir at record start']
	num_name = n_elements(vdata_name)
	count = 0
	i = 0
	while(count eq 0 and i lt num_name) do begin
		temp_name = vdata_name(i)
		search_result = strpos(info.name_list_vdata, temp_name)
		result = where(search_result ne -1, count)
		i = i + 1
	endwhile
	if count ne 0 then begin

	   the_vdata_name = ''
	   the_vdata_name = info.name_list_vdata(result)
	   vdata_id = open_vdata(filename,the_vdata_name,file_id)
	   if vdata_id eq 0 then begin
		result=dialog_message('Unable to attach '+the_vdata_name+'!',$
			title='View HDF Warning!')
		set_error_data,satellite_x
		assign_geolocated_data, this_subset, info, hdf_data_x, hdf_data_y, $
			satellite_x, satellite_y, sun_x, sun_y
		return
	   endif
	   field_name = ['Colatitude of Satellite at Observation', $
		'Colatitude of Subsatellite Point at Surface at Observation', $
		'Colatitude of Satellite at record start', $
		'Colatitude of satellite nadir at record start']
	   num_field = n_elements(field_name)
	   field_check = -1
	   i = 0
	   while (field_check eq -1 and i lt num_field) do begin
		fieldname = field_name(i)
		field_check = HDF_VD_FEXIST(vdata_id,fieldname)
		i = i + 1
	   endwhile
	   if field_check eq -1 then begin
		result=dialog_message('Unable to find Colatitude of satellite field!', $
			title='View HDF Warning!')
		HDF_VD_DETACH, vdata_id
		HDF_CLOSE,file_id
		set_error_data,satellite_x
		assign_geolocated_data, this_subset, info, hdf_data_x, hdf_data_y, $
			satellite_x, satellite_y, sun_x, sun_y
		return
	   endif
	   HDF_VD_GET,vdata_id,COUNT=the_nrec

	   HDF_VD_DETACH, vdata_id
	   HDF_CLOSE,file_id

	   the_result = read_vdata_data(this_subset, the_nrec, the_vdata_name, $
		fieldname, info, satellite_y)
	   if (the_result eq -1) then begin
		result=dialog_message('Unable to read ' + fieldname + ' Vdata data!',$
			title='View HDF Warning!')
		set_error_data, satellite_x
		assign_geolocated_data, this_subset, info, hdf_data_x, hdf_data_y, $
			satellite_x, satellite_y, sun_x, sun_y
		return
	   endif

	   if n_elements(satellite_y) eq 1 then $
		satellite_y = [satellite_y.components0] else $
		satellite_y = reform(satellite_y.components0, n_elements(satellite_y.components0))
	   satellite_y(*) = 90.0 - satellite_y(*)

	endif else begin

		set_error_data, satellite_x
		assign_geolocated_data, this_subset, info, hdf_data_x, hdf_data_y, $
			satellite_x, satellite_y, sun_x, sun_y
		return

	endelse
    endelse

;   ***For longitude of sun***
    sds_name = ['Longitude of subsolar point at surface at observation']
    num_name = n_elements(sds_name)
    sds_index = -1
    i = 0
    while (sds_index eq -1 and i lt num_name) do begin
	temp_name = sds_name(i)
	sds_index = check_sds_index(filename, temp_name)
	i = i + 1
    endwhile
    if sds_index ne -1 then begin

	the_result = read_sds_data( this_subset, temp_name, info, sun_x)
	if (the_result eq -1) then begin
		result=dialog_message('Unable to read ' + temp_name + ' SDS data!',$
			title='View HDF Warning!')
		set_error_data,satellite_x
		assign_geolocated_data, this_subset, info, hdf_data_x, hdf_data_y, $
			satellite_x, satellite_y, sun_x, sun_y
		return
	endif

    endif else begin

	vdata_name = ['IES Hour','Satellite-Celestial Data', $
		'Longitude of Sun at observation']
	num_name = n_elements(vdata_name)
	count = 0
	i = 0
	while(count eq 0 and i lt num_name) do begin
		temp_name = vdata_name(i)
		search_result = strpos(info.name_list_vdata, temp_name)
		result = where(search_result ne -1, count)
		i = i + 1
	endwhile
	if count ne 0 then begin

	   the_vdata_name = ''
	   the_vdata_name = info.name_list_vdata(result)
	   vdata_id = open_vdata(filename,the_vdata_name,file_id)
	   if vdata_id eq 0 then begin
		result=dialog_message('Unable to attach '+the_vdata_name+'!',$
			title='View HDF Warning!')
		set_error_data,sun_x
		assign_geolocated_data, this_subset, info, hdf_data_x, hdf_data_y, $
			satellite_x, satellite_y, sun_x, sun_y
		return
	   endif
	   field_name = ['Longitude of Sun at Observation', $
		'Longitude of Subsolar Point at Surface at Observation' , $
		'Longitude of Sun at Observation', $
		'Longitude of Sun at observation']
	   num_field = n_elements(field_name)
	   field_check = -1
	   i = 0
	   while (field_check eq -1 and i lt num_field) do begin
		fieldname = field_name(i)
		field_check = HDF_VD_FEXIST(vdata_id,fieldname)
		i = i + 1
	   endwhile
	   if field_check eq -1 then begin
		result=dialog_message('Unable to find Longitude of sun field!', $
			title='View HDF Warning!')
		HDF_VD_DETACH, vdata_id
		HDF_CLOSE,file_id
		set_error_data,sun_x
		assign_geolocated_data, this_subset, info, hdf_data_x, hdf_data_y, $
			satellite_x, satellite_y, sun_x, sun_y
		return
	   endif
	   HDF_VD_GET,vdata_id,COUNT=the_nrec

	   HDF_VD_DETACH, vdata_id
	   HDF_CLOSE,file_id

	   the_result = read_vdata_data(this_subset, the_nrec, the_vdata_name, $
		fieldname, info, sun_x)
	   if (the_result eq -1) then begin
		result=dialog_message('Unable to read ' + fieldname + ' Vdata data!',$
			title='View HDF Warning!')
		set_error_data, sun_x
		assign_geolocated_data, this_subset, info, hdf_data_x, hdf_data_y, $
			satellite_x, satellite_y, sun_x, sun_y
		return
	   endif

	   if n_elements(sun_x) eq 1 then $
		sun_x = [sun_x.components0] else $
		sun_x= reform(sun_x.components0, n_elements(sun_x.components0))

	endif else begin

		set_error_data, sun_x
		assign_geolocated_data, this_subset, info, hdf_data_x, hdf_data_y, $
			satellite_x, satellite_y, sun_x, sun_y
		return

	endelse
    endelse

;   ***For colatitude of sun***
    sds_name = ['Colatitude of subsolar point at surface at observation']
    num_name = n_elements(sds_name)
    sds_index = -1
    i = 0
    while (sds_index eq -1 and i lt num_name) do begin
	temp_name = sds_name(i)
	sds_index = check_sds_index(filename, temp_name)
	i = i + 1
    endwhile
    if sds_index ne -1 then begin

	the_result = read_sds_data( this_subset, temp_name, info, sun_y)
	if (the_result eq -1) then begin
		result=dialog_message('Unable to read ' + temp_name + ' SDS data!',$
			title='View HDF Warning!')
		set_error_data,sun_y
		assign_geolocated_data, this_subset, info, hdf_data_x, hdf_data_y, $
			satellite_x, satellite_y, sun_x, sun_y
		return
	endif

	sun_y = 90.0 - sun_y

    endif else begin

	vdata_name = ['IES Hour','Satellite-Celestial Data', $
		'Colatitude of Sun at observation']
	num_name = n_elements(vdata_name)
	count = 0
	i = 0
	while(count eq 0 and i lt num_name) do begin
		temp_name = vdata_name(i)
		search_result = strpos(info.name_list_vdata, temp_name)
		result = where(search_result ne -1, count)
		i = i + 1
	endwhile
	if count ne 0 then begin

	   the_vdata_name = ''
	   the_vdata_name = info.name_list_vdata(result)
	   vdata_id = open_vdata(filename,the_vdata_name,file_id)
	   if vdata_id eq 0 then begin
		result=dialog_message('Unable to attach '+the_vdata_name+'!',$
			title='View HDF Warning!')
		set_error_data,sun_x
		assign_geolocated_data, this_subset, info, hdf_data_x, hdf_data_y, $
			satellite_x, satellite_y, sun_x, sun_y
		return
	   endif
	   field_name = ['Colatitude of Sun at Observation', $
		'Colatitude of Subsolar Point at Surface at Observation', $
		'Colatitude of Sun at Observation', $
		'Colatitude of Sun at observation']
	   num_field = n_elements(field_name)
	   field_check = -1
	   i = 0
	   while (field_check eq -1 and i lt num_field) do begin
		fieldname = field_name(i)
		field_check = HDF_VD_FEXIST(vdata_id,fieldname)
		i = i + 1
	   endwhile
	   if field_check eq -1 then begin
		result=dialog_message('Unable to find Colatitude of sun field!', $
			title='View HDF Warning!')
		HDF_VD_DETACH, vdata_id
		HDF_CLOSE,file_id
		set_error_data,sun_x
		assign_geolocated_data, this_subset, info, hdf_data_x, hdf_data_y, $
			satellite_x, satellite_y, sun_x, sun_y
		return
	   endif
	   HDF_VD_GET,vdata_id,COUNT=the_nrec

	   HDF_VD_DETACH, vdata_id
	   HDF_CLOSE,file_id

	   the_result = read_vdata_data(this_subset, the_nrec, the_vdata_name, $
		fieldname, info, sun_y)
	   if (the_result eq -1) then begin
		result=dialog_message('Unable to read ' + fieldname + ' Vdata data!',$
			title='View HDF Warning!')
		set_error_data, sun_x
		assign_geolocated_data, this_subset, info, hdf_data_x, hdf_data_y, $
			satellite_x, satellite_y, sun_x, sun_y
		return
	   endif

	   if n_elements(sun_y) eq 1 then $
		sun_y = [sun_y.components0] else $
		sun_y = reform(sun_y.components0, n_elements(sun_y.components0))
		sun_y = 90.0 - sun_y

	endif else begin

		set_error_data, sun_x
		assign_geolocated_data, this_subset, info, hdf_data_x, hdf_data_y, $
			satellite_x, satellite_y, sun_x, sun_y
		return

	endelse
    endelse

    assign_geolocated_data, this_subset, info, hdf_data_x, hdf_data_y, satellite_x, $
	satellite_y, sun_x, sun_y


end 

;--------------------------------------------------------------------------------
pro set_histogram, event
 
pro_name = 'set_histogram'
@getinfo
 
widget_control, get_uvalue=info, event.top
 
widget_control, info.histogram.binwidget, get_value=binsize
widget_control, info.histogram.maxwidget, get_value=max_value
widget_control, info.histogram.minwidget, get_value=min_value

widget_control, get_uvalue=info, info.base
widget_control, event.top, /destroy

info.histogram.binsize = binsize
info.histogram.max = max_value
info.histogram.min = min_value
print,'info.histogram.binsize = ', info.histogram.binsize
print,'info.histogram.max = ', info.histogram.max
print,'info.histogram.min = ', info.histogram.min
 
widget_control, set_uvalue=info, info.base
;if(widget_info(info.widgets.base, /VALID_ID)) then $
;	widget_control, set_uvalue=info, info.widgets.base
 
end
 
;------------------------------------------------------------------
pro get_hist_par, data_name, max, min, info

pro_name = 'get_hist_par'
@getinfo

;  Byte type does not show on the widget
if(size(max, /type) eq 1) then max = float(max)
if(size(min, /type) eq 1) then min = float(min)

base_loc = widget_info(info.base, /geometry)
xoffset = base_loc.xoffset + 300
yoffset = base_loc.yoffset + 300

base=widget_base( GROUP_LEADER=info.base, /MODAL, COLUMN=1, MAP=1, $
	TITLE='Histogram Parameters', uvalue=info, xoffset=xoffset, $
	yoffset=yoffset)

length = strlen(data_name)
if length gt 65 then begin
    temp_name = strmid(data_name, 0, 60) + '...'
endif else temp_name = data_name
dep_variable = "Variable: " + temp_name
text1 = widget_label(base, /ALIGN_LEFT, value=dep_variable, $
        FONT=info.font)

text3 = widget_label(base, /ALIGN_RIGHT, value="   ", $
        FONT=info.font)

info.histogram.binwidget = CW_FIELD(base,VALUE=info.histogram.binsize, $
	ROW=1, /float, FIELDFONT=info.font, FONT=info.font, $
	TITLE='Bin Size: ', XSIZE=10)

info.histogram.maxwidget = CW_FIELD(base,VALUE=max, $
	ROW=1, /float, FIELDFONT=info.font, FONT=info.font, $
	TITLE='Max Value: ', XSIZE=15)
 
info.histogram.minwidget = CW_FIELD(base,VALUE=min, $
	ROW=1, /float, FIELDFONT=info.font, FONT=info.font, $
	TITLE='Min Value: ', XSIZE=15)
 
group2=widget_base(base, row=1,map=1, space=100, /align_center)

button1=widget_button(group2, FONT=info.font, EVENT_PRO='set_histogram', $
	VALUE="Done", /ALIGN_CENTER, uvalue=info)

button2=widget_button(group2, FONT=info.font, EVENT_PRO='canceloptionCB', $
	VALUE="Cancel", /ALIGN_CENTER, uvalue=info)

widget_control,/realize, base
widget_control, DEFAULT_BUTTON=button1, CANCEL_BUTTON=button2, base

widget_control, set_uvalue=info, base

xmanager, 'main_widget', base

end

;--------------------------------------------------------------------------------
pro setnumbergridCB, event

pro_name = 'setnumbergridCB'
@getinfo

widget_control, get_uvalue=info, event.top
widget_control, get_uvalue=widget_id, event.id

widget_control, widget_id(0), get_value=n_x_grid
info.greenwich.n_x_grid=n_x_grid
print,'Number of X Grids =',info.greenwich.n_x_grid

widget_control, widget_id(1), get_value=n_y_grid
info.greenwich.n_y_grid=n_y_grid
print,'Number of Y Grids =',info.greenwich.n_y_grid

if(widget_info(info.widgets.base, /VALID_ID)) then $
	widget_control, set_uvalue=info, info.widgets.base
widget_control, set_uvalue=info, info.base

widget_control, event.top, /destroy

end

;--------------------------------------------------------------------------------
pro set_number_grid, info

pro_name = 'set_number_grid'
@getinfo

base = widget_base(COLUMN=1, MAP=1, TITLE='Set Number of Grids')

s_group=widget_base(base, column=1,map=1)

n_x_grid = CW_FIELD(s_group, VALUE=info.greenwich.n_x_grid, $
		ROW=1, INTEGER=1, FIELDFONT=info.font, $
		FONT=info.font, TITLE='Number of X Grids:', XSIZE=10)

n_y_grid = CW_FIELD(s_group, VALUE=info.greenwich.n_y_grid, $
		ROW=1, INTEGER=1, FIELDFONT=info.font, $
		FONT=info.font, TITLE='Number of Y Grids:', XSIZE=10)

group2=widget_base(base, row=1,map=1, space=40, /align_center)

button1=widget_button(group2, FONT=info.font, EVENT_PRO='setnumbergridCB', VALUE="Done",$
	/ALIGN_CENTER)

button2=widget_button(group2, FONT=info.font, EVENT_PRO='doneCB', VALUE="Cancel",$
	 /ALIGN_CENTER)

widget_control, /realize, base

widget_id = [n_x_grid, n_y_grid]
widget_control, set_uvalue=info, base
if(widget_info(info.widgets.base, /VALID_ID)) then $
	widget_control, set_uvalue=info, info.widgets.base
widget_control, set_uvalue=info, info.base
widget_control, set_uvalue=widget_id, button1

end

;--------------------------------------------------------------------------------
pro openfilterCB, event

pro_name = 'openfilterCB'
@getinfo

widget_control, get_uvalue=info, event.top

widget_control, info.widgets.openfilter, get_value=open_filter
open_filter = open_filter(0)

info.open_filter=open_filter

widget_control, set_uvalue=info, info.base

widget_control, event.top, /destroy

end

;--------------------------------------------------------------------------------
pro get_open_filter, info

pro_name = 'get_open_filter'
@getinfo

base = widget_base(COLUMN=1, MAP=1, TITLE='Open File Filter')

o_group=widget_base(base, row=1,map=1)

info.widgets.openfilter = CW_FIELD(o_group, VALUE=info.open_filter, $
		ROW=1, STRING=1, FIELDFONT=info.font, $
		FONT=info.font, TITLE='Filter:', XSIZE=20)

group2=widget_base(base, row=1,map=1, space=40, /align_center)

button1=widget_button(group2, FONT=info.font, EVENT_PRO='openfilterCB', VALUE="Done",$
	/ALIGN_CENTER)

button2=widget_button(group2, FONT=info.font, EVENT_PRO='doneCB', VALUE="Cancel",$
	 /ALIGN_CENTER)

widget_control, /realize, base

widget_control, set_uvalue=info, base
widget_control, set_uvalue=info, info.base

end

;--------------------------------------------------------------------------------
pro numlevelCB, event

pro_name = 'numlevelCB'
@getinfo

widget_control, get_uvalue=info, event.top

widget_control, info.widgets.numlevel, get_value=n_level

info.greenwich.n_level=n_level

if(widget_info(info.widgets.base, /VALID_ID)) then $
	widget_control, set_uvalue=info, info.widgets.base
widget_control, set_uvalue=info, info.base

widget_control, event.top, /destroy

end

;--------------------------------------------------------------------------------
pro get_n_level, info

pro_name = 'get_n_level'
@getinfo

base = widget_base(COLUMN=1, MAP=1, TITLE='Set Number of Discrete Intervals')

c_group=widget_base(base, row=1,map=1)

info.widgets.numlevel = CW_FIELD(c_group, VALUE=info.greenwich.n_level, $
		ROW=1, FLOATING=1, FIELDFONT=info.font, $
		FONT=info.font, TITLE='Number of Discrete Intervals:', XSIZE=10)

group2=widget_base(base, row=1,map=1, space=40, /align_center)

button1=widget_button(group2, FONT=info.font, EVENT_PRO='numlevelCB', VALUE="Done",$
	/ALIGN_CENTER)

button2=widget_button(group2, FONT=info.font, EVENT_PRO='doneCB', VALUE="Cancel",$
	 /ALIGN_CENTER)

widget_control, /realize, base

widget_control, set_uvalue=info, base
if(widget_info(info.widgets.base, /VALID_ID)) then $
	widget_control, set_uvalue=info, info.widgets.base
widget_control, set_uvalue=info, info.base

end

;--------------------------------------------------------------------------------
function list_sds, filename, num_field

pro_name = 'list_sds'
@getinfoa

result=''
num_field = 0

sd_id = HDF_SD_START(filename, /READ)
if sd_id eq -1 then return, 'BAD'

HDF_SD_FILEINFO, sd_id, num_dataset, nglobal_attr
if num_dataset eq 0 then begin
	HDF_SD_END,sd_id
	return, result
endif

for i = 0, num_dataset-1 do begin
    default_name = 0
    sds_id = HDF_SD_SELECT(sd_id, i)
    if sds_id eq -1 then begin
	the_result=dialog_message('Problem to select SDS data!',$
		title='View HDF Warning!')
	HDF_SD_END,sd_id
	return, result
    endif

    HDF_SD_GETINFO, sds_id, NAME=sds_name, NATTS=nattrs

    dot=strpos(sds_name,'fakeDim')
    if( dot ne -1) then default_name = 1 $
	else begin
	    dot=strpos(sds_name, 'Data-Set')
	    if (dot ne -1) then default_name = 1
	endelse

    if default_name eq 1 then begin
	j = 0
	j_continue = 1
	while j_continue eq 1 and j lt nattrs do begin
	    HDF_SD_ATTRINFO, sds_id, j, NAME=attr_name, DATA=attr_value
	    if attr_name eq 'long_name' then begin
		attr_value = strcompress(strtrim(attr_value,2))
		length = strlen(attr_value)
		if length gt 80 then temp_name = strmid(attr_value,0,80) $
			else temp_name = attr_value
		sds_name = sds_name + ":" + temp_name
		j_continue = 0
	   endif
	   j = j + 1
	endwhile
    endif

    if i eq 0 then result = sds_name $
    else result = result + '|' + sds_name
    num_field = num_field + 1

    HDF_SD_ENDACCESS,sds_id

endfor

HDF_SD_END,sd_id

return, result

end

;--------------------------------------------------------------------------------
function list_vdata, filename, num_field

pro_name = 'list_vdata'
@getinfoa

result=''
num_field = 0

file_id = HDF_OPEN(filename, /READ)
if file_id eq -1 then return, 'BAD'

continue_flag = 1
previous_vref = -1
while continue_flag eq 1 do begin
    current_vref = HDF_VD_GETID(file_id, previous_vref)
    if current_vref ne -1 then begin
	vdata_id = HDF_VD_ATTACH(file_id, current_vref, /READ)
	;if vdata_id eq 0 then begin
	if vdata_id le 0 then begin
	    the_result=dialog_message('Unable to attach '+current_vref+'!',$
		title='View HDF Warning!')
	    HDF_CLOSE,file_id
	    return, result
	endif

	previous_vref = current_vref
	HDF_VD_GET,vdata_id,NAME=vdata_name, CLASS=class_name
	dot=strpos(vdata_name,'fake')
	if dot eq -1 then begin
	    check_meta = 0
	    temp_name = strlowcase(vdata_name)
	    loc = strpos(temp_name, 'coremetadata')
	    loc1 = strpos(temp_name, 'archivemetadata')
	    if loc ne -1 or loc1 ne -1 then check_meta = 1
	    check_class = 0
	    temp_name = strlowcase(class_name)
	    loc = strpos(temp_name, 'attr')
	    loc1 = strpos(temp_name, 'dimval')
	    if loc ne -1 or loc1 ne -1 then check_class = 1

	    if check_meta eq 1 or check_class ne 1 then begin
		if num_field eq 0 then result = vdata_name $
			else result = result + '|' + vdata_name

		num_field = num_field + 1
	    endif
	endif
	
	HDF_VD_DETACH, vdata_id
    endif else continue_flag = 0
endwhile

HDF_CLOSE, file_id

return, result

end

;--------------------------------------------------------------------------------
function list_vdata_attr, filename, num_field

pro_name = 'list_vdata'
@getinfoa

result=''
num_field = 0

file_id = HDF_OPEN(filename, /READ)
if file_id eq -1 then return, 'BAD'

continue_flag = 1
previous_vref = -1
while continue_flag eq 1 do begin
    current_vref = HDF_VD_GETID(file_id, previous_vref)
    if current_vref ne -1 then begin
	vdata_id = HDF_VD_ATTACH(file_id, current_vref, /READ)
	;if vdata_id eq 0 then begin
	if vdata_id le 0 then begin
	    the_result=dialog_message('Unable to attach '+the_vdata_name+'!',$
		title='View HDF Warning!')
	    HDF_CLOSE,file_id
	    return, result
	endif

	previous_vref = current_vref
	HDF_VD_GET,vdata_id,NAME=vdata_name, CLASS=class_name
	dot=strpos(vdata_name,'fake')
	if dot eq -1 then begin
	    check_meta = 0
	    temp_name = strlowcase(vdata_name)
	    loc = strpos(temp_name, 'coremetadata')
	    loc1 = strpos(temp_name, 'archivemetadata')
	    if loc ne -1 or loc1 ne -1 then check_meta = 1
	    check_class = 0
	    temp_name = strlowcase(class_name)
	    loc = strpos(temp_name, 'dimval')
	    if loc ne -1 then check_class = 1

	    if check_meta eq 1 or check_class ne 1 then begin
		if num_field eq 0 then result = vdata_name $
			else result = result + '|' + vdata_name

		num_field = num_field + 1
	    endif
	endif
	
	HDF_VD_DETACH, vdata_id
    endif else continue_flag = 0
endwhile

HDF_CLOSE, file_id

return, result

end

;--------------------------------------------------------------------------------
pro get_parameters, string_call, widget, flag, filename, info

pro_name = 'get_parameters'
@getinfo

number_of_fields=long(0)

CD, '.', CURRENT = PWD

;the_result = CALL_EXTERNAL(PWD+'/' + info.library,   $
;the_result = CALL_EXTERNAL(info.library, $
;                string_call,     $
;                filename, $
;                number_of_fields,/s_value)

case string_call of
	'list_sds': the_result = list_sds(filename,number_of_fields)
	'list_vdata': the_result = list_vdata(filename,number_of_fields)
	else: the_result = list_vdata_attr(filename,number_of_fields)
endcase

if the_result ne "BAD" then begin

	if number_of_fields gt 0 then begin

         	widget_control, widget, set_value  = str_sep(the_result, '|')
		
		type = str_sep(string_call, '_')

		CASE type(1) of

		'vdata': info = redefine_info(info, str_sep(the_result, '|'),0 ) 
		'vfield': info = redefine_info(info, str_sep(the_result, ','),1 )
		'sds': info = redefine_info(info, str_sep(the_result, '|'),2 )
	
		ENDCASE

		flag = 1

        endif

endif else begin

       result=dialog_message('Problem reading HDF information!',$
                        title='View HDF Warning!')
       return
endelse        

end

;--------------------------------------------------------------------------------
FUNCTION x_selected, Event

pro_name = 'x_selected'
@getinfo1

widget_control, get_uvalue=info, event.top

info.out.x_index = event.value

widget_control, set_uvalue=info, event.top

END

;--------------------------------------------------------------------------------
pro get_select_variable, info, this_subset, print_flag, hdf_data_x

pro_name = 'get_select_variable'
@getinfo

if ((print_flag lt 1) or (print_flag gt 3)) then begin

	base_loc = widget_info(info.base, /geometry)
	xoffset = base_loc.xoffset + 100
	yoffset = base_loc.yoffset + 100
	base=widget_base(group_leader=info.base, /modal, ROW=1, xoffset=xoffset, $
		yoffset=yoffset, TITLE='Select X Variable')
	widget_control, set_uvalue=info, base

	the_pick=CW_BGROUP(base, info.name_list_subset, set_value=0, $
		FONT=info.font, EVENT_FUNCT='x_selected', $
		/SCROLL,Y_SCROLL_SIZE=600,X_SCROLL_SIZE=300, /EXCLUSIVE)
   
	group2=widget_base(base, column=1,map=1, space=40, /align_center)

	button1=widget_button(group2, FONT=info.font, EVENT_PRO='donepick', UVALUE=base, $
		VALUE="Done", /ALIGN_CENTER)

	button2=widget_button(group2, FONT=info.font, EVENT_PRO='canceloptionCB', $
		VALUE="Cancel", /ALIGN_CENTER)

	widget_control,/realize, base
	widget_control, DEFAULT_BUTTON=button1, CANCEL_BUTTON=button2, base
	xmanager, 'main_widget', base

	widget_control, get_uvalue=info, info.base
endif

if info.canceloption eq 'Yes' then return

x_index = info.out.x_index

if info.subset.data(x_index).src_type_flag eq 0 then begin
  hdf_data_x = *info.subset.data(x_index).src_data
endif else begin
  hdf_x_temp = *info.subset.data(x_index).src_data
  hdf_data_x = reform(hdf_x_temp.components0, n_elements(hdf_x_temp.components0))
endelse


END

;--------------------------------------------------------------------------------
pro get_vgroup_list, flag, filename, info

pro_name = 'get_vgroup_list'
@getinfo

fileid = HDF_OPEN(filename)
if fileid eq -1 then begin
	result=dialog_message('Problem open HDF file!',$
		title='View HDF Warning!')
	return
	flag = 0
endif

loneid = HDF_VG_LONE(fileid)
check_loneid = loneid(0)
if check_loneid eq -1 then begin
	;result=dialog_message('There is no Vgroup defined!',$
	;	title='View HDF Warning!')
	flag = 0
	return
endif
old_vgid = -1
new_vgid = 0
i = 0
while new_vgid ne -1 do begin
	new_vgid = HDF_VG_GETID(fileid, old_vgid)
	if new_vgid ne -1 then begin
	   check = where(loneid eq new_vgid, count)
	   if count ne 0 then begin
	      vg_handle = HDF_VG_ATTACH(fileid, new_vgid)
	      if vg_handle ne 0 then begin
		HDF_VG_GETINFO, vg_handle, CLASS=class, NAME=name, NENTRIES=num
		name_check = strpos(name, 'fakeDim')
		class_check = strpos(class, 'Var')
		class1_check = strpos(class, 'CDF')
		if name_check eq -1 and class_check eq -1 and class1_check eq -1 then begin
			if i eq 0 then begin
				vg_list = name
				vg_id = new_vgid
				vg_name_list = strtrim(name,2)
				vg_id_list = strtrim(string(new_vgid),2)
			endif else begin
				vg_list = [vg_list, name]
				vg_id = [vg_id, new_vgid]
				vg_name_list = vg_name_list + '|'
				vg_name_list = vg_name_list + strtrim(name,2)
				vg_id_list = vg_id_list + '|'
				vg_id_list = vg_id_list + strtrim(string(new_vgid),2)
			endelse
			i = i + 1
			HDF_VG_GETTRS, vg_handle, tags, refs
		endif
		HDF_VG_DETACH, vg_handle
	      endif
	   endif
	   old_vgid = new_vgid
	endif
endwhile

num_vg = n_elements(vg_list)
if num_vg gt 1 then begin
	info = initial_vgroup(info)
	metaname = ['SSF_Header', 'CRS_Header', 'CERES_metadata', 'coremetadata', $
	    'archivemetadata', 'CoreMetadata.0', 'ArchiveMetadata.0']
	num_meta = n_elements(metaname)
	num_vd = 0
	vdata_list = ''
        vref = ''
	for imeta = 0, num_meta-1 do begin
	    mname = metaname(imeta)
	    mname = mname(0)
	    vmetaref = HDF_VD_FIND(fileid, mname)
	    if vmetaref ne 0 then begin
		vd_id = HDF_VD_ATTACH(fileid, vmetaref, /read)
		;if vd_id ne 0 then begin
		if vd_id gt 0 then begin
		    HDF_VD_GET, vd_id, name=temp, class=class
		    if num_vd gt 0 then $
			vdata_list = [vdata_list, temp] $
		    else vdata_list = temp
		    HDF_VD_DETACH, vd_id
		    if num_vd gt 0 then begin
			vref = vref + '|'
			vref = vref + strtrim(string(vmetaref),2)
		    endif else vref = strtrim(string(vmetaref),2)
		    num_vd = num_vd + 1
		endif
	    endif
	endfor
	if num_vd gt 0 then begin
		widget_control, info.widgets.vdata, set_value  = vdata_list
		info.vgroup.vref = vref
		info = redefine_info(info, vdata_list, 0 )
		widget_control, set_uvalue=info, info.base
	endif

	flag = 1 
	info = redefine_info(info, vg_list, 9)
	info.vgroup.flag = 1
	info.vgroup.nlayer = 1
	info.vgroup.ref(0) = 1
	info.vgroup.id(0) = 1
	info.vgroup.vg_name(0) = vg_name_list
	info.vgroup.vg_id(0) = vg_id_list
	info.flags.data_read = flag
	select_vgroup,'VGROUP', info, vg_list, vg_id, 0
endif else begin
	;result=dialog_message('There is no Vgroup defined!',$
	;	title='View HDF Warning!')
	flag = 0
endelse

HDF_CLOSE, fileid

end

;--------------------------------------------------------------------------------
pro get_vgroup, event

pro_name = 'get_vgroup'
@getinfo

if event.clicks eq 2 then return
widget_control, /hourglass
widget_control, get_uvalue=info, event.top
widget_control, get_uvalue=info, info.base
widget_control, get_uvalue=vg_id, event.id
vgid = vg_id(event.index)
; check which level of the vgroup
subscript = where(info.vgroup.ref gt 0 , count)
if count gt 1 then begin
	i = 0
	icheck = 0
	while icheck eq 0 do begin
		vg_id_list = info.vgroup.vg_id(i)
		vg_list = str_sep(vg_id_list, '|')
		vg_list = long(vg_list)
		check = where(vg_list eq vgid, check_count)
		if check_count ne 0 then icheck = 1
		i = i + 1
		if i eq count then icheck = 1
	endwhile
	if i lt count then begin
		for j = i, count-1 do begin
		    if(widget_info(info.vgroup.base(j), /VALID_ID)) then $
			widget_control, info.vgroup.base(j), /destroy
		endfor
		info.vgroup.base(i:*) = 0L
		info.vgroup.ref(i:*) = 0L
		info.vgroup.id(i:*) = 0L
		info.vgroup.name_string(i:*) = ''
		info.vgroup.vg_id(i:*) = ''
		info.vgroup.vg_name(i:*) = ''
	endif
endif else i = 1
if i eq 8 then begin
	result = dialog_message("You have maximum level of Vgroup", $
		title='View HDF Warning!')
	return
endif
nlayer = i
vg_name_list = info.vgroup.vg_name(i-1)
name_list = str_sep(vg_name_list, '|')
name_vg = name_list(event.index)
info.vgroup.name_string(i) = name_vg
info.vgroup.ref(i) = vgid
info.vgroup.id(i) = event.id

widget_control,info.widgets.current_file,get_value=filename
filename = filename(0)
fileid = HDF_OPEN(filename)
if fileid eq -1 then begin
	result=dialog_message('Problem open HDF file!',$
		title='View HDF Warning!')
	return
endif
vg_handle = HDF_VG_ATTACH(fileid, vgid)
if vg_handle eq 0 then begin
	result = dialog_message('Problem attach the vgroup!.', $
		title='View HDF Warning!')
	return
	HDF_CLOSE, fileid
endif

HDF_VG_GETINFO, vg_handle, CLASS=class, NAME=name, NENTRIES=num
HDF_VG_GETTRS, vg_handle, tags, refs
num_ref = n_elements(refs)
vdata_list = ''
sds_list = ''
vref = ''
sref = ''
vgroup = ''
temp=''
vg_list = ''
num_vd = 0
num_sd = 0
num_vg = 0
for i = 0L, num_ref-1 do begin
   type = 2
   check_vg = HDF_VG_ISVD(vg_handle, refs(i))
   if check_vg eq 1 then type = 0
   check_vg = HDF_VG_ISVG(vg_handle, refs(i))
   if check_vg eq 1 then type = 1
   case type of
	0: begin
	   vd_id = HDF_VD_ATTACH(fileid, refs(i), /read)
	   ;if vd_id ne 0 then begin
	   if vd_id gt 0 then begin
		HDF_VD_GET, vd_id, name=temp, class=class
		if num_vd gt 0 then $
		   vdata_list = [vdata_list, temp] $
		else vdata_list = temp
		HDF_VD_DETACH, vd_id
		if num_vd gt 0 then begin
		   vref = vref + '|'
		   vref = vref + strtrim(string(refs(i)),2)
		endif else vref = strtrim(string(refs(i)),2)
		num_vd = num_vd + 1
	   endif
	end
	1: begin
	   new_vgid = refs(i)
	   vg_handle1 = HDF_VG_ATTACH(fileid, new_vgid)
	   if vg_handle1 ne 0 then begin
		HDF_VG_GETINFO, vg_handle1, CLASS=class, NAME=name, NENTRIES=num
		name_check = strpos(name, 'fakeDim')
		class_check = strpos(class, 'Var')
		class1_check = strpos(class, 'CDF')
		if name_check eq -1 and class_check eq -1 and class1_check eq -1 then begin
		   if num_vg gt 0 then begin
			vg_list = [vg_list, name]
			vg_id = [vg_id, new_vgid]
			vg_name_list = vg_name_list + '|'
			vg_name_list = vg_name_list + strtrim(name,2)
			vg_id_list = vg_id_list + '|'
			vg_id_list = vg_id_list + strtrim(string(new_vgid),2)
		   endif else begin
			vg_list = name
			vg_id = new_vgid
			vg_name_list = strtrim(name,2)
			vg_id_list = strtrim(string(new_vgid),2)
		   endelse
		   HDF_VG_GETTRS, vg_handle1, tag1s, ref1s
		endif
		HDF_VG_DETACH, vg_handle1
		num_vg = num_vg + 1
	   endif
	end
	else: begin
	   sd_id = HDF_SD_START(filename)
	   if sd_id ne -1 then begin
		sds_index = HDF_SD_REFTOINDEX(sd_id, refs(i))
		if sds_index ne -1 then begin
		   sds_id = HDF_SD_SELECT(sd_id, sds_index)
		   if sds_id ne -1 then begin
			HDF_SD_GETINFO, sds_id, name=temp
			if num_sd gt 0 then $
			   sds_list = [sds_list, temp] $
			else sds_list = temp
			HDF_SD_ENDACCESS, sds_id
			if num_sd gt 0 then begin
			   sref = sref + '|'
			   sref = sref + strtrim(string(sds_index),2)
			endif else sref = strtrim(string(sds_index),2)
			num_sd = num_sd + 1
		   endif
		endif
		HDF_SD_END, sd_id			
	   endif
	end
   endcase
endfor

metaname = ['SSF_Header', 'CRS_Header', 'CERES_metadata', 'coremetadata', $
	'archivemetadata', 'CoreMetadata.0', 'ArchiveMetadata.0']
num_meta = n_elements(metaname)
for imeta = 0, num_meta-1 do begin
	mname = metaname(imeta)
	mname = mname(0)
	vmetaref = HDF_VD_FIND(fileid, mname)
	if vmetaref ne 0 then begin
		vd_id = HDF_VD_ATTACH(fileid, vmetaref, /read)
		;if vd_id ne 0 then begin
		if vd_id gt 0 then begin
			HDF_VD_GET, vd_id, name=temp, class=class
			if num_vd gt 0 then $
				vdata_list = [vdata_list, temp] $
			else vdata_list = temp
			HDF_VD_DETACH, vd_id
			if num_vd gt 0 then begin
				vref = vref + '|'
				vref = vref + strtrim(string(vmetaref),2)
			endif else vref = strtrim(string(vmetaref),2)
			num_vd = num_vd + 1
		endif
	endif
endfor
if num_vd gt 0 then begin
	widget_control, info.widgets.vdata, set_value  = vdata_list
	info.vgroup.vref = vref
	info = redefine_info(info, vdata_list, 0 )
endif else begin
	temp_name = 'None'
	widget_control, info.widgets.vdata, set_value = temp_name
	info.vgroup.vref = ''
	info = redefine_info(info, temp_name, 0)
endelse

if num_sd gt 0 then begin
	widget_control, info.widgets.sds, set_value  = sds_list
	info.vgroup.sref = sref
	info = redefine_info(info, sds_list,2 )
endif else begin
	temp_name = 'None'
	widget_control, info.widgets.sds, set_value = temp_name
	info.vgroup.sref = ''
	info = redefine_info(info, temp_name, 2)
endelse

widget_control, set_uvalue=info, info.base

if num_vg gt 0 then begin
	info = redefine_info(info, vg_list, 10)
	info.vgroup.vg_name(nlayer) = vg_name_list
	info.vgroup.vg_id(nlayer) = vg_id_list
	info.vgroup.nlayer = nlayer + 1
	widget_control, set_uvalue=info, info.base
	select_vgroup, name_vg, info, vg_list, vg_id, nlayer
endif

end

;--------------------------------------------------------------------------------
pro get_hdf5_group_list, flag, filename, info

pro_name = 'get_hdf5_group_list'
@getinfo

check_hdf5 = H5F_IS_HDF5(filename)
if check_hdf5 eq 0 then begin
    result=dialog_message(filename + ' is not HDF5 file!',$
	title='View HDF Warning!')
    flag = 0
    return
endif

fileid = open_hdf5_file(filename)
if fileid eq -1 then begin
    result=dialog_message('Problem open HDF5 file!',$
	title='View HDF Warning!')
    flag = 0
    return
endif

;  check how many group under root
root_name = "/"
num_group = H5G_GET_NMEMBERS(fileid, root_name)
if num_group eq 0 then begin
    flag = 0
    return
endif else begin
; open the root group
    root_id = H5G_OPEN(fileid, root_name)
endelse

number_group = 0
number_dataset = 0
simple_dataset = 0
compound_dataset = 0
group_name = ''
dataset_name = ''

for i = 0L, num_group-1 do begin
    groupname = H5G_GET_MEMBER_NAME(fileid, root_name, i)
    objinfo = get_hdf5_objinfo(root_id, groupname)
    if objinfo.TYPE eq "GROUP" then begin
	group_name = [group_name, groupname]
	number_group = number_group + 1
    endif else if objinfo.TYPE eq "DATASET" then begin
	dataset_name = [dataset_name, groupname]
	number_dataset = number_dataset + 1
    endif
endfor

if number_group gt 0 then begin
    group_name = group_name[1:number_group]
    group_name_list = strtrim(group_name[0], 2)
endif

if number_dataset gt 0 then begin
    dataset_name = dataset_name[1:number_dataset]
    simple_dataset_name = ''
    compound_dataset_name = ''
    for i = 0L, number_dataset-1 do begin
	dataset_id = H5D_OPEN(root_id, dataset_name[i])
	;datatype_id = H5D_GET_TYPE(dataset_id)
	;if H5T_GET_CLASS(datatype_id) ne "H5T_COMPOUND" then begin
	dataspace_id = H5D_GET_SPACE(dataset_id)
	if H5S_IS_SIMPLE(dataspace_id) eq 1 then begin
	    simple_dataset_name = [simple_dataset_name, dataset_name[i]]
	    simple_dataset = simple_dataset + 1
	endif else begin
	    compound_dataset_name = [compound_dataset_name, dataset_name[i] ]
	    compound_dataset = compound_dataset + 1
	endelse
	;H5T_CLOSE, datatype_id
	close_hdf5_dataspace, dataspace_id
	H5D_CLOSE, dataset_id
    endfor
    if simple_dataset gt 0 then begin
	simple_dataset_name = simple_dataset_name[1:simple_dataset]
	simple_dataset_name_list = strtrim(simple_dataset_name[0], 2)
    endif
    if compound_dataset gt 0 then begin
	compound_dataset_name = compound_dataset_name[1:compound_dataset]
	compound_dataset_name_list = strtrim(compound_dataset_name[0], 2)
    endif
endif

H5G_CLOSE, root_id
H5F_CLOSE, fileid

if number_group + simple_dataset + compound_dataset eq 0 then begin
    flag = 0
    return
endif

;  initialize the hdf5
info = initial_hdf5(info)

for i = 1L, number_group-1 do begin
    group_name_list = group_name_list + '|'
    group_name_list = group_name_list + strtrim(group_name[i],2)
endfor

for i = 1L, simple_dataset-1 do begin
    simple_dataset_name_list = simple_dataset_name_list + '|'
    simple_dataset_name_list = simple_dataset_name_list + strtrim(simple_dataset_name[i],2)
endfor

for i = 1L, compound_dataset-1 do begin
    compound_dataset_name_list = compound_dataset_name_list + '|'
    compound_dataset_name_list = compound_dataset_name_list + strtrim(compound_dataset_name[i],2)
endfor

if simple_dataset gt 0 then begin
    info.hdf5.sdn_name(0) = simple_dataset_name_list
    widget_control, info.widgets.sds, set_value  = simple_dataset_name
    info = redefine_info(info, simple_dataset_name, 2 )
endif

if compound_dataset gt 0 then begin
    info.hdf5.cdn_name(0) = compound_dataset_name_list
    widget_control, info.widgets.vdata, set_value  = compound_dataset_name
    info = redefine_info(info, compound_dataset_name, 0 )
endif

info.hdf5.flag = 1
info.hdf5.nlayer = 0

widget_control, set_uvalue=info, info.base

if number_group gt 0 then begin
    info = redefine_info(info, group_name, 9)
    info.hdf5.flag = 1
    info.hdf5.nlayer = 1
    info.hdf5.g_name(0) = group_name_list
    info.hdf5.ref(0) = 1
    info.hdf5.id(0) = 1
    info.hdf5.name_string(0) = root_name
    select_hdf5_group, root_name, info, group_name, 0
endif

flag = 1
info.flags.data_read = flag

end

;--------------------------------------------------------------------------------
pro get_hdf5_group, event

pro_name = 'get_hdf5_group'
@getinfo

if event.clicks eq 2 then return
widget_control, /hourglass
widget_control, get_uvalue=info, event.top
widget_control, get_uvalue=info, info.base
widget_control, get_uvalue=level, event.id

; check which level of the group
subscript = where(info.hdf5.ref gt 0 , count)
i = level + 1
if i lt count then begin
    for j = i, count-1 do begin
	if(widget_info(info.hdf5.base(j), /VALID_ID)) then $
	    widget_control, info.hdf5.base(j), /destroy
    endfor

    info.hdf5.base(i:*) = 0L
    info.hdf5.ref(i:*) = 0L
    info.hdf5.id(i:*) = 0L
    info.hdf5.name_string(i:*) = ''
    info.hdf5.sdn_name(i:*) = ''
    info.hdf5.cdn_name(i:*) = ''
    info.hdf5.g_name(i:*) = ''
endif

if i eq 8 then begin
    result = dialog_message("You have maximum level of group", $
	title='View HDF Warning!')
    return
endif

nlayer = i
g_name_list = info.hdf5.g_name(nlayer-1)
name_list = str_sep(g_name_list, '|')
name_g = name_list(event.index)
info.hdf5.name_string(i) = name_g
info.hdf5.ref(nlayer) = 1
info.hdf5.id(nlayer) = event.id

widget_control,info.widgets.current_file,get_value=filename
filename = filename(0)
fileid = open_hdf5_file(filename)
if fileid eq -1 then begin
    result=dialog_message('Problem open HDF5 file!',$
	title='View HDF Warning!')
    return
endif

current_group_name = ''
for j = 1, nlayer do begin
    current_group_name = current_group_name + '/' + info.hdf5.name_string[j]
endfor

;  check how many group under group_name
num_group = H5G_GET_NMEMBERS(fileid, current_group_name)
if num_group eq 0 then begin
    result = dialog_message("The "+current_group_name+" group are empty", $
        title='View HDF Warning!')
    return
endif else begin
; open the current group
    group_id = H5G_OPEN(fileid, current_group_name)
endelse

number_group = 0
number_dataset = 0
simple_dataset = 0
compound_dataset = 0
group_name = ''
dataset_name = ''

for j = 0L, num_group-1 do begin
    groupname = H5G_GET_MEMBER_NAME(fileid, current_group_name, j)
    objinfo = get_hdf5_objinfo(group_id, groupname)
    if objinfo.TYPE eq "GROUP" then begin
	group_name = [group_name, groupname]
	number_group = number_group + 1
    endif else if objinfo.TYPE eq "DATASET" then begin
	dataset_name = [dataset_name, groupname]
	number_dataset = number_dataset + 1
    endif
endfor

if number_group gt 0 then begin
    group_name = group_name[1:number_group]
    group_name_list = strtrim(group_name[0], 2)
endif

if number_dataset gt 0 then begin
    dataset_name = dataset_name[1:number_dataset]
    simple_dataset_name = ''
    compound_dataset_name = ''
    for j = 0L, number_dataset-1 do begin
	dataset_id = H5D_OPEN(group_id, dataset_name[j])
	;datatype_id = H5D_GET_TYPE(dataset_id)
	;if H5T_GET_CLASS(datatype_id) ne "H5T_COMPOUND" then begin
	dataspace_id = H5D_GET_SPACE(dataset_id)
	;print,'Space = ',H5S_IS_SIMPLE(dataspace_id)
        if H5S_IS_SIMPLE(dataspace_id) eq 1 then begin
	    datatype_id = H5D_GET_TYPE(dataset_id)
	    if H5T_GET_CLASS(datatype_id) ne "H5T_COMPOUND" then begin
		simple_dataset_name = [simple_dataset_name, dataset_name[j]]
		simple_dataset = simple_dataset + 1
	    endif else begin
		compound_dataset_name = [compound_dataset_name, dataset_name[j] ]
		compound_dataset = compound_dataset + 1
	    endelse
	    H5T_CLOSE, datatype_id
	endif
	close_hdf5_dataspace, dataspace_id
	H5D_CLOSE, dataset_id
    endfor
    if simple_dataset gt 0 then begin
	simple_dataset_name = simple_dataset_name[1:simple_dataset]
	simple_dataset_name_list = strtrim(simple_dataset_name[0], 2)
    endif
    if compound_dataset gt 0 then begin
	compound_dataset_name = compound_dataset_name[1:compound_dataset]
	compound_dataset_name_list = strtrim(compound_dataset_name[0], 2)
    endif
endif

H5G_CLOSE, group_id
H5F_CLOSE, fileid

if number_group + simple_dataset + compound_dataset eq 0 then begin
    temp_name = 'None'
    widget_control, info.widgets.sds, set_value = temp_name
    info = redefine_info(info, temp_name, 2 )

    temp_name = 'None'
    widget_control, info.widgets.vdata, set_value = temp_name
    info = redefine_info(info, temp_name, 0 )

    return
endif

for j = 1L, number_group-1 do begin
    group_name_list = group_name_list + '|'
    group_name_list = group_name_list + strtrim(group_name[j],2)
endfor

for j = 1L, simple_dataset-1 do begin
    simple_dataset_name_list = simple_dataset_name_list + '|'
    simple_dataset_name_list = simple_dataset_name_list + strtrim(simple_dataset_name[j],2)
endfor

for j = 1L, compound_dataset-1 do begin
    compound_dataset_name_list = compound_dataset_name_list + '|'
    compound_dataset_name_list = compound_dataset_name_list + strtrim(compound_dataset_name[j],2)
endfor

if simple_dataset gt 0 then begin
    info.hdf5.sdn_name(nlayer) = simple_dataset_name_list
    widget_control, info.widgets.sds, set_value  = simple_dataset_name
    info = redefine_info(info, simple_dataset_name, 2 )
endif else begin
    temp_name = 'None'
    widget_control, info.widgets.sds, set_value = temp_name
    info = redefine_info(info, temp_name, 2 )
endelse

if compound_dataset gt 0 then begin
    info.hdf5.cdn_name(nlayer) = compound_dataset_name_list
    widget_control, info.widgets.vdata, set_value  = compound_dataset_name
    info = redefine_info(info, compound_dataset_name, 0 )
endif else begin
    temp_name = 'None'
    widget_control, info.widgets.vdata, set_value = temp_name
    info = redefine_info(info, temp_name, 0)
endelse

info.hdf5.nlayer = nlayer

widget_control, set_uvalue=info, info.base

if number_group gt 0 then begin
    info = redefine_info(info, group_name, 10)
    info.hdf5.g_name(nlayer) = group_name_list
    info.hdf5.nlayer = nlayer + 1
    widget_control, set_uvalue=info, info.base
    select_hdf5_group, name_g, info, group_name, nlayer
endif

widget_control, set_uvalue=info, info.base

end

;--------------------------------------------------------------------------------
pro select_hdf5_group, name, info, g_list, index

pro_name = 'select_hdf5_group'
@getinfo

num_list = n_elements(g_list)
ysize = fix(1.5 * num_list)
title = 'Select '+name+' Group'

info.hdf5.base(index)=widget_base( COLUMN=1, MAP=1, TITLE=title, $
    XSIZE=300, uvalue=info)

g_list_widget=widget_list(info.hdf5.base(index), value=g_list, $
    FONT=info.font, event_pro='get_hdf5_group', uvalue=index, $
    xsize=60, ysize=ysize)

button1=widget_button(info.hdf5.base(index), FONT=info.font, EVENT_PRO='doneCB', $
    VALUE="Close", /ALIGN_CENTER)

widget_control, /realize, info.hdf5.base(index) 
widget_control, set_uvalue=info, info.hdf5.base(index)
widget_control, set_uvalue=info, info.base

if index gt 0 then begin
    if widget_info(info.hdf5.base(index-1),/valid_id) eq 1 then begin
	DEVICE, GET_SCREEN_SIZE=scr
	base_loc = widget_info(info.hdf5.base(index-1), /geometry)
	base_loc1 = widget_info(info.hdf5.base(index), /geometry)
	xoffset = base_loc.xoffset
	yoffset = base_loc.yoffset + base_loc.scr_ysize
	if yoffset + base_loc1.scr_ysize gt scr(1) then begin
	    base_loc2 = widget_info(info.hdf5.base(0), /geometry)
	    yoffset = base_loc2.yoffset
	    if base_loc2.xoffset lt scr(0)/2 then begin
		xoffset = xoffset + base_loc.scr_xsize
	    endif else begin
		xoffset = xoffset - base_loc.scr_xsize
	    endelse
	endif 
	widget_control, info.hdf5.base(index), xoffset=xoffset, yoffset=yoffset
    endif
endif 

end

;--------------------------------------------------------------------------------
pro hdf5_sdn_range_dialogue, info

pro_name = 'hdf5_sdn_range_dialogue'
@getinfo

subset_name = info.name_list_sds(info.sds.index) + '[' + strcompress(string(info.subset.count)) +']'

if info.rangetype.type eq 1 then begin
  info.rangetype.flag = 0
  get_time_range, subset_name, info.sds.rank-1, info
  widget_control, get_uvalue=info, info.base
  if info.canceloption eq 'Yes' then begin
	info.canceloption = 'No'
	widget_control, set_uvalue=info, info.base
	return
  endif 
  if info.rangetype.flag eq 0 then begin
	info.rangetype.type = 0
	widget_control, info.rangetype.widget, set_droplist_select=info.rangetype.type
  endif
endif

if info.rangetype.type eq 0 or info.rangetype.flag eq 1 then $
  record_range_buttons, subset_name, info.sds.rank-1, 'read_hdf5_sdn_dataCB', info $
else return

widget_control, set_uvalue=info, info.base


end

;--------------------------------------------------------------------------------
pro read_hdf5_sdn_dataCB, event

pro_name = 'read_hdf5_sdn_dataCB'
@getinfo

widget_control, get_uvalue=info, event.id
widget_control, /hourglass

start_list=lonarr(info.sds.rank)
end_list=lonarr(info.sds.rank)
increment_list=lonarr(info.sds.rank)

for i=0,(info.sds.rank-1) do begin

    widget_control, info.widgets.starting_field(i), get_value=this_start
    widget_control, info.widgets.ending_field(i), get_value=this_end
    widget_control, info.widgets.increment_field(i), get_value=this_increment

    start_list(i)=this_start-1
    if start_list(i) lt 0 then start_list(i) = 0L
    end_list(i)=this_end
    increment_list(i)=this_increment
endfor

info.rangetype.old_start(0:info.sds.rank-1) = start_list(0:info.sds.rank-1) + 1
info.rangetype.old_end(0:info.sds.rank-1) = end_list(0:info.sds.rank-1)
info.rangetype.old_increment(0:info.sds.rank-1) = increment_list(0:info.sds.rank-1)
info.rangetype.old_dim(0:info.sds.rank-1) = info.sds.dims(0:info.sds.rank-1)

widget_control, info.widgets.current_file, get_value=filename
filename=filename(0)

CD, '.', CURRENT = PWD

data_name = info.name_list_sds(info.sds.index)
data_name = data_name(0)

nlayer = info.hdf5.nlayer

current_data_name = ''
for j = 1, nlayer do begin
    if strlen(info.hdf5.name_string[j]) gt 0 then begin
	current_data_name = current_data_name + '/' + info.hdf5.name_string[j]
    endif
endfor
current_data_name = current_data_name + '/' + data_name

;  Open a HDF5 file
fileid = open_hdf5_file(filename)
if fileid eq -1 then begin
    result=dialog_message('Problem open HDF5 file!',$
        title='View HDF Error!')
    return
endif

;  Open the dataset
dataset_id = H5D_OPEN(fileid, current_data_name)

array_size = long((end_list-start_list-1)/float(increment_list) + 1.0)
the_result=read_sdn_data(dataset_id, start_list, array_size, increment_list, output_data)

H5D_CLOSE, dataset_id
H5F_CLOSE, fileid

if the_result eq -1 then begin
    result=dialog_message('Problem to read '+current_data_name+'!',$
	title='View HDF Error!')
    return
endif

org_rank = info.sds.rank
org_start = start_list
org_end = end_list
org_increment = increment_list
true_start = start_list(0)
true_end = end_list(0)
num_start_list = n_elements(start_list)
output_data = reform(output_data)
sizedata_new = size(output_data)
if num_start_list ne sizedata_new(0) then begin
    start_list_old = start_list
    end_list_old = end_list
    increment_list_old = increment_list
    j = 0
    for i=0, num_start_list-1 do begin
	num_elem = end_list_old(i) - start_list_old(i)
	if(num_elem ne 1) then begin
	    start_list(j) = start_list_old(i)
	    end_list(j) = end_list_old(i)
	    increment_list(j) = increment_list_old(i)
	    j = j + 1
	endif
    endfor
    if j eq 0 then j = 1
    info.sds.rank = j
    start_list = start_list(0:j-1)
    end_list = end_list(0:j-1)
    increment_list = increment_list(0:j-1)
endif

sizedata_old = size(output_data)
if sizedata_old(0) lt info.sds.rank then begin
    start_list_old = start_list
    end_list_old = end_list
    increment_list_old = increment_list
    j = 0
    for i=0, info.sds.rank-1 do begin
	if(end_list_old(i) - start_list_old(i) ne 1) then begin
	    start_list(j) = start_list_old(i)
	    end_list(j) = end_list_old(i)
	    increment_list(j) = increment_list_old(i)
	    j = j + 1
	endif
    endfor
    if j eq 0 then j = 1
    info.sds.rank = j
    start_list = start_list(0:j-1)
    end_list = end_list(0:j-1)
    increment_list = increment_list(0:j-1)
endif

temp_name = current_data_name + '[' + strcompress(string(info.subset.count)) +']'
info = redefine_info(info, temp_name, 3)

widget_control, info.widgets.subset_list, set_value=info.name_list_subset
widget_control, event.top, /destroy

num_output_data = n_elements(output_data)

info.subset.count=info.subset.count+1
info.subset.data(info.subset.count-1).subset_name = string(temp_name)
info.subset.data(info.subset.count-1).src_filename = filename
info.subset.data(info.subset.count-1).src_unitname = info.unitname
info.subset.data(info.subset.count-1).src_type_flag = 0			
info.subset.data(info.subset.count-1).src_crit_flag = 0
info.subset.data(info.subset.count-1).src_crit_name = ''
info.subset.data(info.subset.count-1).src_crit_min = ''
info.subset.data(info.subset.count-1).src_crit_max = ''
info.subset.data(info.subset.count-1).src_crit_type = ''
info.subset.data(info.subset.count-1).src_num = num_output_data
info.subset.data(info.subset.count-1).src_ref = info.sds.ref
info.subset.data(info.subset.count-1).src_rank = info.sds.rank
info.subset.data(info.subset.count-1).src_start = start_list
info.subset.data(info.subset.count-1).src_end = end_list
info.subset.data(info.subset.count-1).src_increment = increment_list
info.subset.data(info.subset.count-1).src_org_rank = org_rank
info.subset.data(info.subset.count-1).src_org_start = org_start
info.subset.data(info.subset.count-1).src_org_end = org_end
info.subset.data(info.subset.count-1).src_org_increment = org_increment
info.subset.data(info.subset.count-1).src_types(0) = info.sds.type
info.subset.data(info.subset.count-1).src_start(info.sds.rank) = true_start
info.subset.data(info.subset.count-1).src_end(info.sds.rank) = true_end

if ptr_valid(info.subset.data(info.subset.count-1).src_data) then begin
    *info.subset.data(info.subset.count-1).src_data = output_data
endif else begin
    info.subset.data(info.subset.count-1).src_data = ptr_new(output_data)
endelse

if ptr_valid(info.rangetype.time) then begin
    if ptr_valid(info.subset.data(info.subset.count-1).src_time) then begin
	*info.subset.data(info.subset.count-1).src_time=*info.rangetype.time
    endif else begin
	info.subset.data(info.subset.count-1).src_time = $
	    ptr_new(*info.rangetype.time)
    endelse
endif

info.greenwich.default = 0
info.rangetype.flag = 0
widget_control, info.widgets.sds, set_list_select=-1
widget_control, set_uvalue=info, info.base

save_list = redefine_save_list(info)
widget_control, set_uvalue=save_list, info.list_base

end

;--------------------------------------------------------------------------------
pro read_hdf5_cdn_data, index, filename,info

pro_name = 'read_hdf5_cdn_data'
@getinfo

info.vfield.name_sel=""

nlayer = info.hdf5.nlayer
info.vdata.name_sel = info.name_list_vdata(index)
data_name = info.name_list_vdata(index)
data_name = data_name(0)

current_data_name = ''
for j = 1, nlayer do begin
    if strlen(info.hdf5.name_string[j]) gt 0 then begin
	current_data_name = current_data_name + '/' + info.hdf5.name_string[j]
    endif
endfor
current_data_name = current_data_name + '/' + data_name

;  Open a HDF5 file
fileid = open_hdf5_file(filename)
if fileid eq -1 then begin
    result=dialog_message('Problem open HDF5 file!',$
	title='View HDF Warning!')
    return
endif

;  Open the dataset
dataset_id = H5D_OPEN(fileid, current_data_name)
info.vdata.ref = dataset_id

the_vfield_list = get_hdf5_cdn_fields(dataset_id,number_of_fields)

H5D_CLOSE, dataset_id
H5F_CLOSE, fileid

if the_vfield_list[0] ne "BAD" then begin

    info = redefine_info( info, the_vfield_list, 1)

    num_vfield = n_elements(the_vfield_list)
    if num_vfield eq 1 then begin
	info.vfield.name_sel = the_vfield_list(0)
	info.vfield.indices_sel= [ long(0) ]
	cdn_field_range_dialogue, info
    endif else cdn_field_dialogue, info

endif else begin
	result=dialog_message('Problem reading Compound Fields!',$
			title='View HDF Warning!')
endelse 

widget_control, set_uvalue=info, info.base

end

;--------------------------------------------------------------------------------
pro cdn_field_dialogue, info

pro_name = 'vdata_dialogue'
@getinfo

base = widget_base( COLUMN=1, MAP=1, TITLE='Select HDF5 Compound Fields', uvalue=info)

button_group=cw_bgroup(base, info.name_list_vfield, column=1, $
                        event_funct="add_vfieldCB", $
                        /scroll, y_scroll_size=450, x_scroll_size=350, /exclusive)

group2=widget_base(base, row=1,map=1, space=100, /align_center)

button1=widget_button(group2, FONT=info.font, EVENT_PRO='cdn_field_doneCB', VALUE="Done",$
	/ALIGN_CENTER)

button2=widget_button(group2, FONT=info.font, EVENT_PRO='doneCB', VALUE="Cancel",$
	 /ALIGN_CENTER)

widget_control, set_uvalue=info, base
widget_control, /realize, base 

widget_control, base, set_list_select=-1

end

;--------------------------------------------------------------------------------
PRO cdn_field_doneCB, event

pro_name = 'cdn_field_doneCB'
@getinfo

widget_control, get_uvalue=info, event.top

widget_control, event.top, /destroy

if (info.subset.count lt info.subset.maximum) then cdn_field_range_dialogue, info $
    else print,'Maximum number of subsets = ', info.subset.maximum

END

;--------------------------------------------------------------------------------
pro read_hdf5_cdn_dataCB, Event

pro_name = 'read_hdf5_cdn_dataCB'
@getinfo

widget_control, /hourglass
widget_control, get_uvalue=info, event.id

start_list=lonarr(info.sds.rank)
end_list=lonarr(info.sds.rank)
increment_list=lonarr(info.sds.rank)

for i=0,(info.sds.rank-1) do begin

    widget_control, info.widgets.starting_field(i), get_value=this_start
    widget_control, info.widgets.ending_field(i), get_value=this_end
    widget_control, info.widgets.increment_field(i), get_value=this_increment

    start_list(i)=this_start-1
    if start_list(i) lt 0 then start_list(i) = 0L
    end_list(i)=this_end
    increment_list(i)=this_increment
endfor

info.rangetype.old_start(0:info.sds.rank-1) = start_list(0:info.sds.rank-1) + 1
info.rangetype.old_end(0:info.sds.rank-1) = end_list(0:info.sds.rank-1)
info.rangetype.old_increment(0:info.sds.rank-1) = increment_list(0:info.sds.rank-1)
info.rangetype.old_dim(0:info.sds.rank-1) = info.sds.dims(0:info.sds.rank-1)

widget_control, info.widgets.current_file, get_value=filename
filename=filename(0)

;  Open a HDF5 file
fileid = open_hdf5_file(filename)
if fileid eq -1 then begin
    result=dialog_message('Problem open HDF5 file!',$
        title='View HDF Warning!')
    return
endif

nlayer = info.hdf5.nlayer
data_name = info.vdata.name_sel
current_data_name = ''
for j = 1, nlayer do begin
    if strlen(info.hdf5.name_string[j]) gt 0 then begin
	current_data_name = current_data_name + '/' + info.hdf5.name_string[j]
    endif
endfor
current_data_name = current_data_name + '/' + data_name

;  Open the dataset
dataset_id = H5D_OPEN(fileid, current_data_name)

the_index = info.vfield.indices_sel

widget_control, event.top, /destroy

the_result = read_cdn_data(dataset_id, the_index, output_data)

if the_result eq -1 then begin
    result=dialog_message('Problem to read '+current_data_name+'!',$
        title='View HDF Error!')
    return
endif

H5D_CLOSE, dataset_id
H5F_CLOSE, fileid

output_data = subset_output_data(info.sds.rank, start_list, end_list, $
    increment_list, output_data)

org_rank = info.sds.rank
org_start = start_list
org_end = end_list
org_increment = increment_list
true_start = start_list(0)
true_end = end_list(0)
num_start_list = n_elements(start_list)
output_data = reform(output_data)
sizedata_new = size(output_data)
if num_start_list ne sizedata_new(0) then begin
    start_list_old = start_list
    end_list_old = end_list
    increment_list_old = increment_list
    j = 0
    for i=0, num_start_list-1 do begin
	num_elem = end_list_old(i) - start_list_old(i)
	if(num_elem ne 1) then begin
	    start_list(j) = start_list_old(i)
	    end_list(j) = end_list_old(i)
	    increment_list(j) = increment_list_old(i)
	    j = j + 1
	endif
    endfor
    if j eq 0 then j = 1
    info.sds.rank = j
    start_list = start_list(0:j-1)
    end_list = end_list(0:j-1)
    increment_list = increment_list(0:j-1)
endif

sizedata_old = size(output_data)
if sizedata_old(0) lt info.sds.rank then begin
    start_list_old = start_list
    end_list_old = end_list
    increment_list_old = increment_list
    j = 0
    for i=0, info.sds.rank-1 do begin
	if(end_list_old(i) - start_list_old(i) ne 1) then begin
	    start_list(j) = start_list_old(i)
	    end_list(j) = end_list_old(i)
	    increment_list(j) = increment_list_old(i)
	    j = j + 1
	endif
    endfor
    if j eq 0 then j = 1
    info.sds.rank = j
    start_list = start_list(0:j-1)
    end_list = end_list(0:j-1)
    increment_list = increment_list(0:j-1)
endif

temp_name = info.vfield.name_sel+'('+current_data_name+')[' + $
    strcompress(string(info.subset.count)) +']'

num_output_data = n_elements(output_data)

;-------------------------------------------
; Stuff the data into info.subset.data 
;-------------------------------------------
info.subset.count=info.subset.count+1
info.subset.data(info.subset.count-1).subset_name = string(temp_name)
info.subset.data(info.subset.count-1).src_filename = filename
info.subset.data(info.subset.count-1).src_unitname = info.unitname
info.subset.data(info.subset.count-1).src_type_flag = 0
info.subset.data(info.subset.count-1).src_crit_flag = 0
info.subset.data(info.subset.count-1).src_crit_name = ''
info.subset.data(info.subset.count-1).src_crit_min = ''
info.subset.data(info.subset.count-1).src_crit_max = ''
info.subset.data(info.subset.count-1).src_crit_type = ''
info.subset.data(info.subset.count-1).src_num = num_output_data
info.subset.data(info.subset.count-1).src_ref = info.vdata.ref
info.subset.data(info.subset.count-1).src_rank = info.sds.rank
info.subset.data(info.subset.count-1).src_start = start_list
info.subset.data(info.subset.count-1).src_end = end_list
info.subset.data(info.subset.count-1).src_increment = increment_list
info.subset.data(info.subset.count-1).src_org_rank = org_rank
info.subset.data(info.subset.count-1).src_org_start = org_start
info.subset.data(info.subset.count-1).src_org_end = org_end
info.subset.data(info.subset.count-1).src_org_increment = org_increment
info.subset.data(info.subset.count-1).src_fnames = info.vfield.name_sel
info.subset.data(info.subset.count-1).src_findex = info.vfield.indices_sel
info.subset.data(info.subset.count-1).src_types = info.sds.type
info.subset.data(info.subset.count-1).src_start(info.sds.rank) = true_start
info.subset.data(info.subset.count-1).src_end(info.sds.rank) = true_end

if ptr_valid(info.subset.data(info.subset.count-1).src_data) then begin
    *info.subset.data(info.subset.count-1).src_data = output_data
endif else begin
    info.subset.data(info.subset.count-1).src_data = ptr_new(output_data)
endelse

if ptr_valid(info.rangetype.time) then begin
    if ptr_valid(info.subset.data(info.subset.count-1).src_time) then begin
	*info.subset.data(info.subset.count-1).src_time=*info.rangetype.time
    endif else begin
	info.subset.data(info.subset.count-1).src_time = $
	    ptr_new(*info.rangetype.time)
    endelse
endif

;-------------------------------------------
; Add to the subset list
;-------------------------------------------

info = redefine_info(info, temp_name, 3 )
	
widget_control, info.widgets.subset_list, set_value=info.name_list_subset

info.greenwich.default = 0
info.rangetype.flag = 0

save_list = redefine_save_list(info)
widget_control, set_uvalue=save_list, info.list_base

widget_control, set_uvalue=info, info.base

end

;------------------------------------------------------------------
pro get_curve_parameter_names, x_field, y_field, xflag, yflag, $
x_list, y_list

pro_name = 'get_curve_parameter_names'
@getinfo
 
if (xflag gt 0) then x_field = field_struct('X Field Selection', x_list)
if (yflag gt 0) then y_field = field_struct('Y Field Selection', y_list)

end

;------------------------------------------------------------------
pro get_parameter_names, x_fields, y_fields, z_fields,$
xflag, yflag, zflag, name_list

pro_name = 'get_parameter_names'
@getinfo
 
if (xflag gt 0) then x_fields = field_struct('X Field Selection', name_list)
if (yflag gt 0) then y_fields = field_struct('Y Field Selection', name_list)
if (zflag gt 0) then z_fields = field_struct('Z Field Selection', name_list)

end

;------------------------------------------------------------------
pro get_rgb_parameter_names, x_fields, y_fields, z_fields,$
xflag, yflag, zflag, name_list

pro_name = 'get_rgb_parameter_names'
@getinfo
 
if (xflag gt 0) then x_fields = field_struct('X Field Selection', name_list)
if (yflag gt 0) then y_fields = field_struct('Y Field Selection', name_list)
if (zflag gt 0) then z_fields = field_struct('Z Field Selection', name_list)

end

;------------------------------------------------------------------
pro get_y1y2_parameter_names, x_fields, y_fields, xflag, yflag, name_list

pro_name = 'get_y1y2_parameter_names'
@getinfo
 
if (xflag gt 0) then x_fields = field_struct('Y1 Field Selection', name_list)
if (yflag gt 0) then y_fields = field_struct('Y2 Field Selection', name_list)

end

;------------------------------------------------------------------
pro get_browse_parameter_names, x_fields, y_fields, xflag, yflag, name_list

pro_name = 'get_browse_parameter_names'
@getinfo

x_list = [name_list, 'Profile Number']
y_list = [name_list, 'Slab Number']
if (xflag gt 0) then x_fields = field_struct('X Field Selection', x_list)
if (yflag gt 0) then y_fields = field_struct('Y Field Selection', y_list)

end

;------------------------------------------------------------------
pro get_packet_number_absolute, info, this_subset, hdf_data_x, flag

pro_name = 'get_packet_number_absolute'
@getinfo
 
    widget_control,info.widgets.current_file,get_value=filename
    filename = filename(0)
    subset_filename = info.subset.data(this_subset).src_filename
    subset_filename=subset_filename(0)
    if subset_filename ne filename then begin
	the_message=['The subset file is not equal to current file,', $
		     'Unable to make plot vs. absolute packet number.', $
		     'Please open the subset file:', subset_filename]
	result=dialog_message(the_message, title='View HDF Warning!')
	set_error_data, hdf_data_x
	return
    endif

    result = where(info.name_list_vdata eq 'Converted Digital Data' or $
	info.name_list_vdata eq 'Converted Instrument Status Data', count)
    if count ne 0 then begin

    the_vdata_name = ''
    the_vdata_name = info.name_list_vdata(result)

    number_of_fields=0L

    CD, '.', CURRENT = PWD

    ;the_result = CALL_EXTERNAL(PWD+'/' + info.library,   $
;    the_result = CALL_EXTERNAL(info.library,   $
;	'get_vdata_fields',  		$
;	filename,			$
;	the_vdata_name,			$
;	number_of_fields,		$
;	/s_value)

    num_vdata = 1
    the_result = get_vdata_fields(filename,the_vdata_name,number_of_fields,num_vdata,$
	vdata_ref, the_nrec)

    if the_result ne "BAD" then begin
    
    	the_vfield_list = str_sep(the_result, ',')

;	CD, '.', CURRENT = PWD

	;the_result = CALL_EXTERNAL(PWD+'/' + info.library,   $
;	the_result = CALL_EXTERNAL(info.library,   $
;		'get_vdata_n_rec',  		$
;		filename,			$
;		the_vdata_name)

;	the_nrec=the_result

    endif else begin
	result=dialog_message('Problem reading Vdata Fields!',$
			title='View HDF Warning!')
	set_error_data, hdf_data_x
	return
    endelse 

    if flag eq 0 then fieldname = 'Packet Counter - Absolute' $
	else fieldname = 'Packet Counter - Relative'
    ;result = where(the_vfield_list eq 'Packet Counter - Absolute', count)
    result = where(the_vfield_list eq fieldname, count)
    if count ne 0 then begin

	the_name = ''
	the_index = result
	the_name = the_vfield_list(the_index)
	the_types=long(1)
	the_order=long(1)

	this_start = 0L
	this_end = the_nrec
	this_increment = 1L

	CD, '.', CURRENT = PWD

	;the_result = CALL_EXTERNAL(PWD+'/' + info.library,   $
;	the_result = CALL_EXTERNAL(info.library,   $
;		'get_vfield_types',  	$
;		filename, 		$
;		the_vdata_name,		$ 
;		the_index,		$
;		long(1),		$
;		the_types,		$
;		the_order,		$
;		/s_value)

	if info.version lt 5.19 and info.library_status eq 1 then begin
		;the_result = CALL_EXTERNAL(PWD+'/' + info.library,   $
		the_result = CALL_EXTERNAL(info.library,   $
			'get_vfield_types_eos', $
			filename,		$
			the_vdata_name,		$
			vdata_ref,		$
			the_index,		$
			long(1),		$
			the_types,		$
			the_order,		$
			/s_value)

		blank = array_type(the_types(0), the_order)

		single_record=create_struct( 'components' + '0', blank) 

		output_data=replicate(single_record, (the_nrec))

;-------------------------------------------
; Now read in the vdata from the HDF file
;-------------------------------------------

		CD, '.', CURRENT = PWD

	;the_result = CALL_EXTERNAL(PWD+'/' + info.library,   $
;	the_result = CALL_EXTERNAL(info.library,   $
;		'read_vdata',	$
;		filename,	$
;		the_vdata_name,	$
;		long(1),	$
;		this_start,	$
;		the_nrec-1,	$
;		this_increment,	$
;		the_name,	$
;		the_types,	$
;		the_order,	$
;		output_data)

		;the_result = CALL_EXTERNAL(PWD+'/' + info.library,   $
		the_result = CALL_EXTERNAL(info.library,   $
			'read_vdata_eos',       $
			filename,               $
			the_vdata_name,         $
			vdata_ref,              $
			long(1),                $
			this_start,             $
			the_nrec-1,             $
			this_increment,         $
			the_name,               $
			the_types,              $
			the_order,              $
			output_data)

	endif else begin
		the_result = get_vfield_type(filename,the_vdata_name,vdata_ref, $
			the_index,the_types,the_order,info.version, $
			info.library, info.library_status, 0)
		the_result = read_vdata(filename, the_vdata_name, vdata_ref, $
			the_nrec-1, the_order, the_types, the_name, output_data)
	endelse

	output_data = reform(output_data.components0, n_elements(output_data.components0))

	if info.subset.data(this_subset).src_type_flag eq 0 then begin
  	hdf_data = *info.subset.data(this_subset).src_data
  	size_hdf = size(hdf_data)

  	case size_hdf(0) of
	1: begin
		this_start = info.subset.data(this_subset).src_start(0)
		this_end = info.subset.data(this_subset).src_end(0)
		this_increment = info.subset.data(this_subset).src_increment(0)
		true_start = info.subset.data(this_subset).src_start(1)
		true_end = info.subset.data(this_subset).src_end(1)
		if true_start ne this_start or true_end ne this_end then begin
			message = strarr(3)
			message(0) = 'Only ONE packet is selected.'
			message(1) = 'Plotting against packet number is meaningless.'
			message(2) = 'Plotting against sample number is better!'
			result=dialog_message(message, title='View HDF Warning!')
			return
		endif
		ii = 0L
		for i = this_start, this_end-1, this_increment do begin
		  hdf_data_x(ii) = output_data(i)
		  ii = ii + 1
		endfor
  	   end
	2: begin
		i_start = info.subset.data(this_subset).src_start(0)
		i_end = info.subset.data(this_subset).src_end(0)
		i_increment = info.subset.data(this_subset).src_increment(0)
		this_start = info.subset.data(this_subset).src_start(1)
		this_end = info.subset.data(this_subset).src_end(1)
		this_increment = info.subset.data(this_subset).src_increment(1)
		ii = 0L
		for i = i_start, i_end-1, i_increment do begin
			jj = 0
        		for j = this_start, this_end-1, this_increment do begin
	    			hdf_data_x(jj,ii) = output_data(i)
				jj = jj + 1
        		endfor
			ii = ii + 1
    		endfor
	  end
	else: begin
		result=dialog_message('Do not support SDS rank greater than 2!',$
			title='View HDF Warning!')
		set_error_data, hdf_data_x
		return
	  end

	endcase

	endif else begin
  	this_order = info.subset.data(this_subset).src_order(0)
	this_end = info.subset.data(this_subset).src_end(0)
	this_start = info.subset.data(this_subset).src_start(0)
	this_increment = info.subset.data(this_subset).src_increment(0)
	k = 0L
	for i = this_start, this_end, this_increment do begin
        	for j = 0, this_order-1 do begin
	  		hdf_data_x(k) = output_data(i)
          		k = k + 1
        	endfor
    	endfor
	endelse

   endif else begin
	result=dialog_message('"'+fieldname+'" field is not found!',$
		title='View HDF Warning!')
	set_error_data, hdf_data_x
    endelse

return

endif

	if flag eq 0 then fieldname = 'Absolute Packet Number' $
		else fieldname = 'Packet Number'
	;result = where(info.name_list_vfield eq 'Absolute Packet Number', count)
	result = where(info.name_list_vfield eq fieldname, count)
	if count ne 0 then begin

	this_start = info.subset.data(this_subset).src_start(0)
	this_end = info.subset.data(this_subset).src_end(0)
	this_increment = info.subset.data(this_subset).src_increment(0)

	the_name = ''
	the_index = result
	the_name = info.name_list_vfield(the_index)
	the_types=long(1)
	the_order=long(1)

	CD, '.', CURRENT = PWD

	;the_result = CALL_EXTERNAL(PWD+'/' + info.library,   $
;	the_result = CALL_EXTERNAL(info.library,   $
;		'get_vfield_types',  	$
;		filename, 		$
;		info.vdata.name_sel,	$ 
;		the_index,		$
;		long(1),		$
;		the_types,		$
;		the_order,		$
;		/s_value)

	if info.version lt 5.19 and info.library_status eq 1 then begin
		;the_result = CALL_EXTERNAL(PWD+'/' + info.library,   $
		the_result = CALL_EXTERNAL(info.library,   $
			'get_vfield_types_eos', $
			filename,		$
			info.vdata.name_sel,	$
			info.vdata.ref,		$
			the_index,		$
			long(1),		$
			the_types,		$
			the_order,		$
			/s_value)

		blank = array_type(the_types(0), the_order)

		single_record=create_struct( 'components' + '0', blank) 

		output_data=replicate(single_record, (info.vdata.nrec))

;-------------------------------------------
; Now read in the vdata from the HDF file
;-------------------------------------------

	CD, '.', CURRENT = PWD

	;the_result = CALL_EXTERNAL(PWD+'/' + info.library,   $
	;the_result = CALL_EXTERNAL(info.library,   $
;		'read_vdata',		$
;		filename, 		$
;		info.vdata.name_sel,	$
;		long(1), 		$
;		this_start,		$
;		info.vdata.nrec-1,	$
;		this_increment,		$
;		the_name, 		$
;		the_types,		$
;		the_order,		$
;		output_data)

		;the_result = CALL_EXTERNAL(PWD+'/' + info.library,   $
		the_result = CALL_EXTERNAL(info.library,   $
			'read_vdata_eos',	$
			filename,		$
			info.vdata.name_sel,	$
			info.vdata.ref,		$
			long(1),		$
			this_start,		$
			info.vdata.nrec-1,	$
			this_increment,		$
			the_name,		$
			the_types,		$
			the_order,		$
			output_data)

	endif else begin
		the_result = get_vfield_type(filename,info.vdata.name_sel, $
			info.vdata.ref, the_index,the_types,the_order,info.version, $
			info.library, info.library_status, 0)

		the_result = read_vdata(filename, info.vdata.name_sel, info.vdata.ref, $
			info.vdata.nrec-1, the_order, the_types, the_name, output_data)
	endelse

	output_data = output_data(this_start:this_end)
	this_increment = this_increment(0)

	if (this_increment gt 1) then begin
		indices = lindgen(this_end-this_start+1)
	 	ndices = indices mod this_increment
	 	ndices = [where(indices eq 0) ]
		utput_data = output_data(indices)
	endif

	hdf_data = *info.subset.data(this_subset).src_data
	hdf_size = size(hdf_data)
	hdf_x_size = size(output_data)
	n_hdf_data = n_elements(hdf_size)
	n_hdf_x_data = n_elements(hdf_x_size)
 
	if(n_hdf_data ne n_hdf_x_data) then begin
		;result=dialog_message('The rank of Absolute Packet Number is not matched!',$
		result=dialog_message('The rank of "' + fieldname + '" is not matched!',$
			title='View HDF Warning!')
		set_error_data, hdf_data_x
		return
	endif

	if(hdf_size(n_hdf_data-1) ne hdf_x_size(n_hdf_x_data-1)) then begin
		;result=dialog_message('The number of data for Absolute Packet Number is not matched!',$
		result=dialog_message('The number of data for "' + fieldname + '" is not matched!',$
			title='View HDF Warning!')
		set_error_data, hdf_data_x
		return
	endif

	output_data = reform(output_data.components0, n_elements(output_data.components0))
  	for i = 0L, hdf_size(n_hdf_data-1)-1 do begin
     		hdf_data_x(i) = output_data(i)
  	endfor

	return

	endif

if flag eq 1 then begin
	result=dialog_message('The Relative Packet Number field is not found!',$
		title='View HDF Warning!')
	set_error_data, hdf_data_x
	return
endif

;result = where(info.name_list_sds eq 'Packet number', count)
;if count ne 0 then begin
sds_name = ['Packet number', 'Sample_Packet', 'Scan_Index']
num_name = n_elements(sds_name)
sds_index = -1
i = 0
while (sds_index eq -1 and i lt num_name) do begin
    temp_name = sds_name(i)
    sds_index = check_sds_index(filename, temp_name)
    i = i + 1
endwhile
if sds_index ne -1 then begin

; Get the dimensions for Sample_Packet
; Initial the variable type
 
    sds_dims = info.sds.dims
    sds_rank = info.sds.rank
    sds_type = info.sds.type
    num_sds = 1

    ;temp_name = info.name_list_sds(result)
    ;temp_name = temp_name(0)

    CD, '.', CURRENT = PWD
 
    the_result = get_sds_dims(filename,temp_name,num_sds,sds_index,sds_rank,$
	sds_dims,sds_type)
    ;the_result = CALL_EXTERNAL(PWD+'/' + info.library,   $
    ;the_result = CALL_EXTERNAL(info.library,   $
    ;            'get_sds_dims',         $
    ;            filename, $
    ;            temp_name, $
    ;            sds_rank, $
    ;            sds_dims, $
    ;            sds_type)
 
    if temp_name eq 'Packet number' then begin
	start_list = info.subset.data(this_subset).src_start(0:sds_rank-1)
	end_list = info.subset.data(this_subset).src_end(0:sds_rank-1)
	increment_list = info.subset.data(this_subset).src_increment(0:sds_rank-1)
    endif else begin
	start_list=lonarr(sds_rank)
	end_list=lonarr(sds_rank)
	increment_list=lonarr(sds_rank)
	array_size=lonarr(sds_rank)
	start_list(0) = info.subset.data(this_subset).src_start(0)
	end_list(0) = info.subset.data(this_subset).src_end(0)
	increment_list(0) = info.subset.data(this_subset).src_increment(0)
	start_list(1) = 0
	end_list(1) = sds_dims(1)
	increment_list(1) = 1
    endelse
 
    if info.subset.data(this_subset).src_type_flag eq 1 then begin
	end_list(0) = end_list(0) + 1 
    endif

    ;array_size = long((end_list-start_list)/float(increment_list) + 0.9)
    array_size = long((end_list-start_list-1)/float(increment_list) + 1.0)
 
    output_x = array_type(sds_type, array_size)

    if (output_x(0) eq -1) then begin
        result=dialog_message('Unable to allocate memory for Sample_Packet array!',$
                 title='View HDF Warning!')
	set_error_data, hdf_data_x
        return
    endif
 
    CD, '.', CURRENT = PWD
 
    unsign_type = 0
    if info.version lt 5.19 and info.library_status eq 1 then begin
	if sds_type gt 20 then unsign_type = sds_type mod 2
    endif

    if info.hdf421 eq 1 then unsign_type = 1

    if unsign_type eq 0 then begin
	the_result=read_sds(filename, temp_name, sds_index, start_list, array_size, $
		increment_list, output_x)
    endif else begin
	;the_result = CALL_EXTERNAL(PWD+'/' + info.library,   $
	the_result = CALL_EXTERNAL(info.library,   $
		'read_sds_eos',	$
		filename,	$
		temp_name,	$
		sds_index,	$
		sds_rank,	$
		sds_type,	$
		sds_dims,	$
		start_list,	$
		end_list,	$
		increment_list,	$
		array_size,	$
		output_x)
    endelse
    ;the_result = CALL_EXTERNAL(PWD+'/' + info.library,   $
    ;the_result = CALL_EXTERNAL(info.library,   $
    ;             'read_sds',      $
    ;             filename,        $
    ;             temp_name,       $
    ;             sds_rank,        $
    ;             sds_type,        $
    ;             sds_dims,        $
    ;             start_list,      $
    ;             end_list,        $
    ;             increment_list,  $
    ;             array_size,      $
    ;             output_x)
 
    if (the_result eq -1) then begin
          result=dialog_message('Unable to read Sample_Packet SDS data!',$
                      title='View HDF Warning!')
	  set_error_data, hdf_data_x
          return
    endif

  if temp_name eq 'Sample_Packet' or temp_name eq 'Scan_Index' then begin
	output_x = output_x(1,*)
	output_x = reform(output_x)
  endif
  ; Assign the Packet Number
  if info.subset.data(this_subset).src_type_flag eq 0 then begin
  hdf_data = *info.subset.data(this_subset).src_data
  size_hdf = size(hdf_data)

  case size_hdf(0) of
  1: begin
    for i=0L, size_hdf(1)-1 do begin
	  hdf_data_x(i) = output_x(i)
    endfor
  end
  2: begin
    this_start = info.subset.data(this_subset).src_start(1)
    this_end = info.subset.data(this_subset).src_end(1)
    this_increment = info.subset.data(this_subset).src_increment(1)
    for i = 0L, size_hdf(2)-1 do begin
        for j = this_start, this_end-1, this_increment do begin
	    hdf_data_x(j,i) = output_x(i)
        endfor
    endfor
  end
  else: begin
	result=dialog_message('Do not support SDS rank greater 2!',$
			title='View HDF Warning!')
	set_error_data, hdf_data_x
	return
  end

endcase

endif else begin
  this_order = info.subset.data(this_subset).src_order(0)
  this_range = (info.subset.data(this_subset).src_end(0) - $
                info.subset.data(this_subset).src_start(0)) / $
                info.subset.data(this_subset).src_increment(0)
  this_range = this_range+1
  k = 0L
  for i = 0L, this_range-1 do begin
	for j = 0, this_order-1 do begin
	  hdf_data_x(k) = output_x(i)
          k = k + 1
        endfor
  endfor
endelse
return
endif

result=dialog_message('The Absolute Packet Number field is not found!',$
	title='View HDF Warning!')
set_error_data,hdf_data_x

end 

;------------------------------------------------------------------
pro get_packet_number_relative, info, this_subset, hdf_data_x

pro_name = 'get_packet_number_relative'
@getinfo
 
    widget_control,info.widgets.current_file,get_value=filename
    filename = filename(0)
    subset_filename = info.subset.data(this_subset).src_filename
    subset_filename=subset_filename(0)
    if subset_filename ne filename then begin
	the_message=['The subset file is not equal to current file,', $
		     'Unable to make plot vs. relative packet number.', $
		     'Please open the subset file:', subset_filename]
	result=dialog_message(the_message, title='View HDF Warning!')
	set_error_data,hdf_data_x
	return
    endif

    result = where(info.name_list_vdata eq 'Converted Digital Data' or $
	   info.name_list_vdata eq 'Converted Instrument Status Data', count)
    if count ne 0 then begin

    the_vdata_name = ''
    the_vdata_name = info.name_list_vdata(result)

    number_of_fields=0L

    CD, '.', CURRENT = PWD

    ;the_result = CALL_EXTERNAL(PWD+'/' + info.library,   $
;    the_result = CALL_EXTERNAL(info.library,   $
;		'get_vdata_fields',  		$
;		filename,			$
;		the_vdata_name,			$
;		number_of_fields,		$
;		/s_value)

    num_vdata = 1
    the_result = get_vdata_fields(filename,the_vdata_name,number_of_fields,num_vdata,$
	vdata_ref, the_nrec)

    if the_result ne "BAD" then begin
    
    	the_vfield_list = str_sep(the_result, ',')

;	CD, '.', CURRENT = PWD

	;the_result = CALL_EXTERNAL(PWD+'/' + info.library,   $
;	the_result = CALL_EXTERNAL(info.library,   $
;		'get_vdata_n_rec',  		$
;		filename,			$
;		the_vdata_name)

;	the_nrec=the_result

    endif else begin
	result=dialog_message('Problem reading Vdata Fields!',$
			title='View HDF Warning!')
	set_error_data, hdf_data_x
	return
    endelse 

    result = where(the_vfield_list eq 'Packet Counter - Relative', count)
    if count ne 0 then begin

	the_name = ''
	the_index = result
	the_name = the_vfield_list(the_index)
	the_types=long(1)
	the_order=long(1)

	this_start = 0L
	this_end = the_nrec
	this_increment = 1L

	CD, '.', CURRENT = PWD

	;the_result = CALL_EXTERNAL(PWD+'/' + info.library,   $
;	the_result = CALL_EXTERNAL(info.library,   $
;		'get_vfield_types',  	$
;		filename, 		$
;		the_vdata_name,		$ 
;		the_index,		$
;		long(1),		$
;		the_types,		$
;		the_order,		$
;		/s_value)

	if info.version lt 5.19 and info.library_status eq 1 then begin
		;the_result = CALL_EXTERNAL(PWD+'/' + info.library,   $
		the_result = CALL_EXTERNAL(info.library,   $
			'get_vfield_types_eos', $
			filename,		$
			the_vdata_name,		$
			vdata_ref,		$
			the_index,		$
			long(1),		$
			the_types,		$
			the_order,		$
			/s_value)

		blank = array_type(the_types(0), the_order)

		single_record=create_struct( 'components' + '0', blank) 

		output_data=replicate(single_record, (the_nrec))

;-------------------------------------------
; Now read in the vdata from the HDF file
;-------------------------------------------

	CD, '.', CURRENT = PWD

	;the_result = CALL_EXTERNAL(PWD+'/' + info.library,   $
;	the_result = CALL_EXTERNAL(info.library,   $
;		'read_vdata',  		$
;		filename, 		$
;		the_vdata_name,		$
;		long(1), 		$
;		this_start,		$
;		the_nrec-1,		$
;		this_increment,		$
;		the_name, 		$
;		the_types,		$
;		the_order,		$
;		output_data)

		;the_result = CALL_EXTERNAL(PWD+'/' + info.library,   $
		the_result = CALL_EXTERNAL(info.library,   $
			'read_vdata_eos',       $
			filename,               $
			the_vdata_name,         $
			vdata_ref,              $
			long(1),                $
			this_start,             $
			the_nrec-1,             $
			this_increment,         $
			the_name,               $
			the_types,              $
			the_order,              $
			output_data)
	endif else begin
		the_result = get_vfield_type(filename,the_vdata_name,vdata_ref, $
			the_index,the_types,the_order,info.version, $
			info.library, info.library_status, 0)
		the_result = read_vdata(filename, the_vdata_name, vdata_ref, $
			the_nrec-1, the_order, the_types, the_name, output_data)
	endelse

	output_data = reform(output_data.components0, n_elements(output_data.components0))

	if info.subset.data(this_subset).src_type_flag eq 0 then begin
  	hdf_data = *info.subset.data(this_subset).src_data
  	size_hdf = size(hdf_data)

  	case size_hdf(0) of
	1: begin
		this_start = info.subset.data(this_subset).src_start(0)
		this_end = info.subset.data(this_subset).src_end(0)
		this_increment = info.subset.data(this_subset).src_increment(0)
		true_start = info.subset.data(this_subset).src_start(1)
		true_end = info.subset.data(this_subset).src_end(1)
		if true_start ne this_start or true_end ne this_end then begin
			message = strarr(3)
			message(0) = 'Only ONE packet is selected.'
			message(1) = 'Plotting against packet number is meaningless.'
			message(2) = 'Plotting against sample number is better!'
			result=dialog_message(message, title='View HDF Warning!')
			return
		endif
		ii = 0L
		for i = this_start, this_end-1, this_increment do begin
		  hdf_data_x(ii) = output_data(i)
		  ii = ii + 1
		endfor
  	   end
	2: begin
		i_start = info.subset.data(this_subset).src_start(0)
		i_end = info.subset.data(this_subset).src_end(0)
		i_increment = info.subset.data(this_subset).src_increment(0)
		this_start = info.subset.data(this_subset).src_start(1)
		this_end = info.subset.data(this_subset).src_end(1)
		this_increment = info.subset.data(this_subset).src_increment(1)
		ii = 0L
		for i = i_start, i_end-1, i_increment do begin
			jj = 0
        		for j = this_start, this_end-1, this_increment do begin
	    			hdf_data_x(jj,ii) = output_data(i)
				jj = jj + 1
        		endfor
			ii = ii + 1
    		endfor
	  end
	else: begin
		result=dialog_message('Do not support SDS rank greater than 2!',$
			title='View HDF Warning!')
		set_error_data, hdf_data_x
		return
	  end

	endcase

	endif else begin
  	this_order = info.subset.data(this_subset).src_order(0)
	this_end = info.subset.data(this_subset).src_end(0)
	this_start = info.subset.data(this_subset).src_start(0)
	this_increment = info.subset.data(this_subset).src_increment(0)
	k = 0L
	for i = this_start, this_end, this_increment do begin
        	for j = 0, this_order-1 do begin
	  		hdf_data_x(k) = output_data(i)
          		k = k + 1
        	endfor
    	endfor
	endelse

   endif

return

endif

	result = where(info.name_list_vfield eq 'Packet Number', count)
	if count ne 0 then begin

	this_start = info.subset.data(this_subset).src_start(0)
	this_end = info.subset.data(this_subset).src_end(0)
	this_increment = info.subset.data(this_subset).src_increment(0)

	the_name = ''
	the_index = result
	the_name = info.name_list_vfield(the_index)
	the_types=long(1)
	the_order=long(1)

	CD, '.', CURRENT = PWD

	;the_result = CALL_EXTERNAL(PWD+'/' + info.library,   $
;	the_result = CALL_EXTERNAL(info.library,   $
;		'get_vfield_types',  	$
;		filename, 		$
;		info.vdata.name_sel,	$ 
;		the_index,		$
;		long(1),		$
;		the_types,		$
;		the_order,		$
;		/s_value)

	if info.version lt 5.19 and info.library_status eq 1 then begin
		;the_result = CALL_EXTERNAL(PWD+'/' + info.library,   $
		the_result = CALL_EXTERNAL(info.library,   $
			'get_vfield_types_eos', $
			filename,		$
			info.vdata.name_sel,	$
			info.vdata.ref,		$
			the_index,		$
			long(1),		$
			the_types,		$
			the_order,		$
			/s_value)

		blank = array_type(the_types(0), the_order)

		single_record=create_struct( 'components' + '0', blank) 

		output_data=replicate(single_record, (info.vdata.nrec))

;-------------------------------------------
; Now read in the vdata from the HDF file
;-------------------------------------------

	CD, '.', CURRENT = PWD

	;the_result = CALL_EXTERNAL(PWD+'/' + info.library,   $
;	the_result = CALL_EXTERNAL(info.library,   $
;		'read_vdata',  		$
;		filename, 		$
;		info.vdata.name_sel,	$
;		long(1), 		$
;		this_start,            	$
;		info.vdata.nrec-1,	$
;		this_increment,		$
;		the_name, 		$
;		the_types,		$
;		the_order,		$
;		output_data)

		;the_result = CALL_EXTERNAL(PWD+'/' + info.library,   $
		the_result = CALL_EXTERNAL(info.library,   $
			'read_vdata_eos',       $
			filename,               $
			info.vdata.name_sel,    $
			info.vdata.ref,         $
			long(1),                $
			this_start,             $
			info.vdata.nrec-1,      $
			this_increment,         $
			the_name,               $
			the_types,              $
			the_order,              $
			output_data)
	endif else begin
		the_result = get_vfield_type(filename,info.vdata.name_sel, $
			info.vdata.ref, the_index,the_types,the_order,info.version, $
			info.library, info.library_status, 0)
		the_result = read_vdata(filename, info.vdata.name_sel, info.vdata.ref, $
			info.vdata.nrec-1, the_order, the_types, the_name, output_data)
	endelse

	output_data = output_data(this_start:this_end)
	this_increment = this_increment(0)

	if (this_increment gt 1) then begin
		indices = lindgen(this_end-this_start+1)
	 	ndices = indices mod this_increment
	 	ndices = [where(indices eq 0) ]
		utput_data = output_data(indices)
	endif

	hdf_data = *info.subset.data(this_subset).src_data
	hdf_size = size(hdf_data)
	hdf_x_size = size(output_data)
	n_hdf_data = n_elements(hdf_size)
	n_hdf_x_data = n_elements(hdf_x_size)
 
	if(n_hdf_data ne n_hdf_x_data) then begin
		result=dialog_message('The rank of Relative Packet Number is not matched!',$
			title='View HDF Warning!')
		set_error_data, hdf_data_x
		return
	endif

	if(hdf_size(n_hdf_data-1) ne hdf_x_size(n_hdf_x_data-1)) then begin
		result=dialog_message('The number of data for Relative Packet Number is not matched!',$
			title='View HDF Warning!')
		set_error_data, hdf_data_x
		return
	endif

	output_data = reform(output_data.components0, n_elements(output_data.components0))
  	for i = 0L, hdf_size(n_hdf_data-1)-1 do begin
     		hdf_data_x(i) = output_data(i)
  	endfor

	return

	endif

result=dialog_message('The Relative Packet Number field is not found!',$
	title='View HDF Warning!')
set_error_data, hdf_data_x

end 

;------------------------------------------------------------------
pro get_record_number, info, this_subset, hdf_data_x

pro_name = 'get_record_number'
@getinfo
 
if info.subset.data(this_subset).src_type_flag eq 0 then begin
  hdf_data = *info.subset.data(this_subset).src_data
  size_hdf = size(hdf_data)

  case size_hdf(0) of
  1: begin
     this_start = info.subset.data(this_subset).src_start(0)
     this_end = info.subset.data(this_subset).src_end(0)
     this_increment = info.subset.data(this_subset).src_increment(0)
     true_start = info.subset.data(this_subset).src_start(1)
     true_end = info.subset.data(this_subset).src_end(1)
     if true_start ne this_start or true_end ne this_end then begin
	message = strarr(3)
	message(0) = 'Only ONE record is selected.'
	message(1) = 'Plotting against record number is meaningless.'
	message(2) = 'Plotting against sample number is better!'
	result=dialog_message(message, title='View HDF Warning!')
	return
     endif
     ii = 0L
     for i = this_start, this_end-1, this_increment do begin
	    hdf_data_x(ii) = i + 1
	    ii = ii + 1
     endfor
  end
  2: begin
    i_start = info.subset.data(this_subset).src_start(0)
    i_end = info.subset.data(this_subset).src_end(0)
    i_increment = info.subset.data(this_subset).src_increment(0)
    this_start = info.subset.data(this_subset).src_start(1)
    this_end = info.subset.data(this_subset).src_end(1)
    this_increment = info.subset.data(this_subset).src_increment(1)
    ii = 0L
    for i = i_start, i_end-1, i_increment do begin
        jj = 0
        for j = this_start, this_end-1, this_increment do begin
	    hdf_data_x(jj,ii) = i + 1
	    jj = jj + 1
        endfor
	ii = ii+1
    endfor
  end
  else: begin
	result=dialog_message('Do not support SDS rank greater than 2!',$
			title='View HDF Warning!')
	set_error_data,hdf_data_x
	return
  end

  endcase

endif else begin
  this_order = info.subset.data(this_subset).src_order(0)
  this_end = info.subset.data(this_subset).src_end(0)
  this_start = info.subset.data(this_subset).src_start(0)
  this_increment = info.subset.data(this_subset).src_increment(0)
    k = 0L
    for i = this_start, this_end, this_increment do begin
        for j = 0, this_order-1 do begin
	  hdf_data_x(k) = i + 1
          k = k + 1
        endfor
    endfor
endelse

end 

;------------------------------------------------------------------
pro get_sample_number, info, this_subset, hdf_data_x

pro_name = 'get_sample_number'
@getinfo
 
widget_control,info.widgets.current_file,get_value=filename
filename = filename(0)

result = where(info.name_list_vfield eq 'Scan Sample Number', count)
if count ne 0 then begin

this_start = info.subset.data(this_subset).src_start(0)
this_end = info.subset.data(this_subset).src_end(0)
this_increment = info.subset.data(this_subset).src_increment(0)

the_name = ''
the_index = result
the_name = info.name_list_vfield(the_index)
the_types=long(1)
the_order=long(1)

CD, '.', CURRENT = PWD

;the_result = CALL_EXTERNAL(PWD+'/' + info.library,   $
;the_result = CALL_EXTERNAL(info.library,   $
;	'get_vfield_types',  	$
;	filename, 		$
;	info.vdata.name_sel,	$ 
;	the_index,		$
;	long(1),		$
;	the_types,		$
;	the_order,		$
;	/s_value)

if info.version lt 5.19 and info.library_status eq 1 then begin
	;the_result = CALL_EXTERNAL(PWD+'/' + info.library,   $
	the_result = CALL_EXTERNAL(info.library,   $
		'get_vfield_types_eos', $
		filename,		$
		info.vdata.name_sel,	$
		info.vdata.ref,		$
		the_index,		$
		long(1),		$
		the_types,		$
		the_order,		$
		/s_value)

	blank = array_type(the_types(0), the_order)

	single_record=create_struct( 'components' + '0', blank) 

	output_data=replicate(single_record, (info.vdata.nrec))

;-------------------------------------------
; Now read in the vdata from the HDF file
;-------------------------------------------

CD, '.', CURRENT = PWD

;the_result = CALL_EXTERNAL(PWD+'/' + info.library,   $
;the_result = CALL_EXTERNAL(info.library,   $
;	'read_vdata',  		$
;	filename, 		$
;	info.vdata.name_sel,	$
;	long(1), 		$
;	this_start,            	$
;	info.vdata.nrec-1,	$
;	this_increment,		$
;	the_name, 		$
;	the_types,		$
;	the_order,		$
;	output_data)

	the_result = CALL_EXTERNAL(PWD+'/' + info.library,   $
		'read_vdata_eos',	$
		filename,		$
		info.vdata.name_sel,	$
		info.vdata.ref,		$
		long(1),		$
		this_start,		$
		info.vdata.nrec-1,	$
		this_increment,		$
		the_name,		$
		the_types,		$
		the_order,		$
		output_data)
endif else begin
	the_result = get_vfield_type(filename,info.vdata.name_sel, $
		info.vdata.ref, the_index,the_types,the_order,info.version, $
		info.library, info.library_status, 0)
	the_result = read_vdata(filename, info.vdata.name_sel, info.vdata.ref, $
		info.vdata.nrec-1, the_order, the_types, the_name, output_data)
endelse

output_data = output_data(this_start:this_end)
this_increment = this_increment(0)

if (this_increment gt 1) then begin
	indices = lindgen(this_end-this_start+1)
	indices = indices mod this_increment
	indices = [where(indices eq 0) ]
	output_data = output_data(indices)
endif

hdf_data = *info.subset.data(this_subset).src_data
hdf_size = size(hdf_data)
hdf_x_size = size(output_data)
n_hdf_data = n_elements(hdf_size)
n_hdf_x_data = n_elements(hdf_x_size)
 
if(n_hdf_data ne n_hdf_x_data) then begin
	result=dialog_message('The rank of Scan Sample Number is not matched!',$
			title='View HDF Warning!')
	set_error_data,hdf_data_x
	return
endif

if(hdf_size(n_hdf_data-1) ne hdf_x_size(n_hdf_x_data-1)) then begin
	result=dialog_message('The number of data for Scan Sample Number is not matched!',$
			title='View HDF Warning!')
	set_error_data,hdf_data_x
	return
endif

hdf_data_x = reform(output_data.components0, n_elements(output_data.components0))

return

endif

;result = where(info.name_list_sds eq 'Scan sample number', count)
;if count ne 0 then begin
sds_name = ['Scan sample number', 'Sample_Packet', 'Scan_Index']
num_name = n_elements(sds_name)
sds_index = -1
i = 0
while (sds_index eq -1 and i lt num_name) do begin
    temp_name = sds_name(i)
    sds_index = check_sds_index(filename, temp_name)
    i = i + 1
endwhile
if sds_index ne -1 then begin

; Get the dimensions for Sample_Packet
; Initial the variable type
 
    sds_dims = info.sds.dims
    sds_rank = info.sds.rank
    sds_type = info.sds.type

    ;temp_name = info.name_list_sds(result)
    ;temp_name = temp_name(0)

    CD, '.', CURRENT = PWD
 
    the_result = get_sds_dims(filename,temp_name,num_sds,sds_index,sds_rank,$
	sds_dims,sds_type)
;    the_result = CALL_EXTERNAL(PWD+'/' + info.library,   $
;    the_result = CALL_EXTERNAL(info.library,   $
;	'get_sds_dims',         $
;	filename, $
;	temp_name, $
;	sds_rank, $
;	sds_dims, $
;	sds_type)

    if temp_name eq 'Scan sample number' then begin
	start_list = info.subset.data(this_subset).src_start(0:sds_rank-1)
	end_list = info.subset.data(this_subset).src_end(0:sds_rank-1)
	increment_list = info.subset.data(this_subset).src_increment(0:sds_rank-1)
    endif else begin
	start_list=lonarr(sds_rank)
	end_list=lonarr(sds_rank)
	increment_list=lonarr(sds_rank)
	array_size=lonarr(sds_rank)
	start_list(0) = info.subset.data(this_subset).src_start(0)
	end_list(0) = info.subset.data(this_subset).src_end(0)
	increment_list(0) = info.subset.data(this_subset).src_increment(0)
	start_list(1) = 0
	end_list(1) = sds_dims(1)
	increment_list(1) = 1
    endelse

    if info.subset.data(this_subset).src_type_flag eq 1 then begin
	end_list(0) = end_list(0) + 1 
    endif

    ;array_size = long((end_list-start_list)/float(increment_list) + 0.9)
    array_size = long((end_list-start_list-1)/float(increment_list) + 1.0)
 
    output_x = array_type(sds_type, array_size)

    if (output_x(0) eq -1) then begin
        result=dialog_message('Unable to allocate memory for Scan sample number array!',$
                 title='View HDF Warning!')
	set_error_data,hdf_data_x
        return
    endif
 
    CD, '.', CURRENT = PWD

    unsign_type = 0
    if info.version lt 5.19 and info.library_status eq 1 then begin
	if sds_type gt 20 then unsign_type = sds_type mod 2
    endif

    if info.hdf421 eq 1 then unsign_type = 1

    if unsign_type eq 0 then begin
	the_result=read_sds(filename, temp_name, sds_index, start_list, array_size, $
		increment_list, output_x)
    endif else begin
	;the_result = CALL_EXTERNAL(PWD+'/' + info.library,   $
	the_result = CALL_EXTERNAL(info.library,   $
		'read_sds_eos',	$
		filename,	$
		temp_name,	$
		sds_index,	$
		sds_rank,	$
		sds_type,	$
		sds_dims,	$
		start_list,	$
		end_list,	$
		increment_list,	$
		array_size,	$
		output_x)
    endelse
 
;    the_result = CALL_EXTERNAL(PWD+'/' + info.library,   $
;    the_result = CALL_EXTERNAL(info.library,   $
;	'read_sds',$
;	filename,$
;	temp_name,$
;	sds_rank,$
;	sds_type,$
;	sds_dims,$
;	start_list,$
;	end_list,$
;	increment_list,$
;	array_size,$
;	output_x)
 
    if (the_result eq -1) then begin
	result=dialog_message('Unable to read Scan sample number SDS data!',$
		title='View HDF Warning!')
	set_error_data,hdf_data_x
	return
    endif

  if temp_name eq 'Sample_Packet' or temp_name eq 'Scan_Index' then begin
	output_x = output_x(0,*)
	output_x = reform(output_x)
  endif

  ; Assign the Sample Number
  if info.subset.data(this_subset).src_type_flag eq 0 then begin
  hdf_data = *info.subset.data(this_subset).src_data
  size_hdf = size(hdf_data)

  case size_hdf(0) of
  1: begin
    for i=0L, size_hdf(1)-1 do begin
	hdf_data_x(i) = output_x(i)
    endfor
  end
  2: begin
    this_start = info.subset.data(this_subset).src_start(1)
    this_end = info.subset.data(this_subset).src_end(1)
    this_increment = info.subset.data(this_subset).src_increment(1)
    for i = 0L, size_hdf(2)-1 do begin
	for j = this_start, this_end-1, this_increment do begin
	    hdf_data_x(j,i) = output_x(i)
        endfor
    endfor
  end
  else: begin
	result=dialog_message('Do not support SDS rank greater than 2!',$
		title='View HDF Warning!')
	set_error_data,hdf_data_x
	return
  end

endcase

endif else begin
  this_order = info.subset.data(this_subset).src_order(0)
  this_range = (info.subset.data(this_subset).src_end(0) - $
	info.subset.data(this_subset).src_start(0)) / $
	info.subset.data(this_subset).src_increment(0)
  this_range = this_range+1
  k = 0L
  for i = 0L, this_range-1 do begin
	for j = 0, this_order-1 do begin
	   hdf_data_x(k) = output_x(i)
	   k = k + 1
	endfor
  endfor
endelse
return
endif

if info.subset.data(this_subset).src_type_flag eq 0 then begin
  hdf_data = *info.subset.data(this_subset).src_data
  size_hdf = size(hdf_data)

  case size_hdf(0) of
  1: begin
	this_start = info.subset.data(this_subset).src_start(0)
	this_end = info.subset.data(this_subset).src_end(0)
	true_start = info.subset.data(this_subset).src_start(1)
	true_end = info.subset.data(this_subset).src_end(1)
	if true_start eq this_start and true_end eq this_end then begin
		message = strarr(3)
		message(0) = 'Only ONE sample is selected.'
		message(1) = 'Plotting against sample number is meaningless.'
		message(2) = 'Plotting against record number is better!'
		result=dialog_message(message, title='View HDF Warning!')
		return
	endif
	this_increment = info.subset.data(this_subset).src_increment(0)
	jj = 0
	for j = this_start, this_end-1, this_increment do begin
		hdf_data_x(jj) = j + 1
		jj = jj + 1
	endfor	
  end
  2: begin
    this_start = info.subset.data(this_subset).src_start(1)
    this_end = info.subset.data(this_subset).src_end(1)
    this_increment = info.subset.data(this_subset).src_increment(1)
    for i = 0L, size_hdf(2)-1 do begin
	jj = 0
        for j = this_start, this_end-1, this_increment do begin
	    hdf_data_x(jj,i) = j + 1
	    jj = jj + 1
        endfor
    endfor
  end
  else: begin
	result=dialog_message('Do not support SDS rank greater than 2!',$
			title='View HDF Warning!')
	set_error_data,hdf_data_x
	return
  end

  endcase

endif else begin
  this_order = info.subset.data(this_subset).src_order(0)
  if this_order eq 1 then begin
	message = strarr(3)
	message(0) = 'The order of data is one.'
	message(1) = 'Plotting against sample number is meaningless.'
	message(2) = 'Plotting against record number is better!'
	result=dialog_message(message, title='View HDF Warning!')
	set_error_data,hdf_data_x
	return
  endif else begin
    this_true_order = info.subset.data(this_subset).src_order(1)
    start_order = info.subset.data(this_subset).src_start(1)
    end_order = info.subset.data(this_subset).src_end(1)
    increment_order = info.subset.data(this_subset).src_increment(1)

    sample_location = make_array(this_true_order, /LONG)
    if info.bds_file eq 1 then begin
	temp_name = info.subset.data(this_subset).subset_name
	temp_name = temp_name(0)
	dot=strpos(temp_name,'[')
	if( dot ne -1) then begin
	    fieldname=strmid(temp_name,0,dot)
	endif else begin
	    fieldname = temp_name
	endelse
	CD, '.', CURRENT = PWD
	;the_result = CALL_EXTERNAL(PWD+'/' + info.library,   $
	the_result = CALL_EXTERNAL(info.library,   $
		'get_analog_location',         $
		fieldname, $
		this_true_order, $
		sample_location)
    endif else the_result = -1

    if the_result eq -1 then begin
        this_interval = long(660/this_true_order)
        for i = 0, this_true_order-1 do begin
            sample_location(i) = i * this_interval + 1
        endfor
    endif

    this_range = (info.subset.data(this_subset).src_end(0) - $
	info.subset.data(this_subset).src_start(0)) / $
	info.subset.data(this_subset).src_increment(0)
    this_range = this_range+1
    ;this_interval = 660/this_order
    k = 0L
    for i = 0L, this_range-1 do begin
	;for j = 0, this_order-1 do begin
	;    hdf_data_x(k) = j * this_interval
	for j = start_order-1, end_order-1, increment_order do begin
	    hdf_data_x(k) = sample_location(j)
	    k = k + 1
	endfor
    endfor
  endelse
endelse

end 

;--------------------------------------------------------------------------------
pro cancel_screensizeCB, event

pro_name = 'cancel_screensizeCB'
@getinfo

widget_control, get_uvalue=info, event.top

info.screen.new = 0

if(widget_info(info.widgets.base, /VALID_ID)) then $
	widget_control, set_uvalue=info, info.widgets.base
widget_control, set_uvalue=info, info.base

widget_control, event.top, /destroy

end

;--------------------------------------------------------------------------------
pro screensizeCB, event

pro_name = 'screensizeCB'
@getinfo

widget_control, get_uvalue=info, event.top

widget_control, info.widgets.sxsize, get_value=screen_xsize
widget_control, info.widgets.sysize, get_value=screen_ysize

info.screen.xsize=screen_xsize
info.screen.ysize=screen_ysize

info.screen.new = 1

if(widget_info(info.widgets.base, /VALID_ID)) then $
	widget_control, set_uvalue=info, info.widgets.base
widget_control, set_uvalue=info, info.base

widget_control, event.top, /destroy

end

;--------------------------------------------------------------------------------
pro get_screen_size, info, current_top

pro_name = 'get_screen_size'
@getinfo

base = widget_base(GROUP_LEADER=current_top, /MODAL, COLUMN=1, MAP=1, $
	TITLE='Define Screen Size')

scr_group=widget_base(base, row=1,map=1)

info.widgets.sxsize = CW_FIELD(scr_group, VALUE=info.screen.xsize, $
		ROW=1, integer=1, FIELDFONT=info.font, $
		FONT=info.font, TITLE='Screen XSize:', XSIZE=10)

info.widgets.sysize = CW_FIELD(scr_group, VALUE=info.screen.ysize, $
		ROW=1, integer=1, FIELDFONT=info.font, $
		FONT=info.font, TITLE='Screen YSize:', XSIZE=10)

group2=widget_base(base, row=1,map=1, space=100, /align_center)

button1=widget_button(group2, FONT=info.font, EVENT_PRO='screensizeCB', VALUE="Done",$
	/ALIGN_CENTER)

button2=widget_button(group2, FONT=info.font, EVENT_PRO='cancel_screensizeCB', $
	VALUE="Cancel", /ALIGN_CENTER)

widget_control, /realize, base
widget_control, DEFAULT_BUTTON=button1, CANCEL_BUTTON=button2, base
widget_control, set_uvalue=info, base
xmanager, 'main_widget', base

end

;------------------------------------------------------------------
pro get_seconds, info, this_subset, hdf_data_x

pro_name = 'get_seconds'
@getinfo
 
if ptr_valid(info.subset.data(this_subset).src_time) eq 0 then begin
        result=dialog_message('Unable to get time!',$
                 title='View HDF Warning!')
	set_error_data, hdf_data_x
        return
endif

  time_record = *info.subset.data(this_subset).src_time
  time_dimen = size(time_record, /N_DIMENSIONS)
  ; Convert to the seconds of the day
  if info.subset.data(this_subset).src_type_flag eq 0 then begin
  the_rank = info.subset.data(this_subset).src_rank 
  i_start = info.subset.data(this_subset).src_start(0)
  i_end = info.subset.data(this_subset).src_end(0)-1
  i_increment = info.subset.data(this_subset).src_increment(0)

  case the_rank of
  1: begin
    if time_dimen eq 2 then begin
	true_start = info.subset.data(this_subset).src_start(the_rank)
	true_end = info.subset.data(this_subset).src_end(the_rank)-1
	if true_start eq i_start and true_end eq i_end then begin
	    org_rank = info.subset.data(this_subset).src_org_rank
	    if org_rank gt 1 then begin
		ijk = info.subset.data(this_subset).src_org_start(1)
	    endif else ijk = 0
	    k = 0L
	    for i=i_start, i_end, i_increment do begin
		hdf_data_x(k) = time_record(ijk,i)
		k = k + 1
	    endfor
	endif else begin
	    if info.subset.data(this_subset).src_transpose eq 0 then begin
		k = 0L
		for i=i_start, i_end, i_increment do begin
		    hdf_data_x(k) = time_record(i,true_start)
		    k = k + 1
		endfor
	    endif else begin
		k = 0L
		for i=i_start, i_end, i_increment do begin
		    hdf_data_x(k) = time_record(0,i)
		    k = k + 1
		endfor
	    endelse
	endelse
    endif else begin
	true_start = info.subset.data(this_subset).src_start(the_rank)
	true_end = info.subset.data(this_subset).src_end(the_rank)-1
	if true_start eq i_start and true_end eq i_end then begin
	    org_rank = info.subset.data(this_subset).src_org_rank
	    if org_rank gt 1 then begin
		ijk = info.subset.data(this_subset).src_org_start(1)
	    endif else ijk = 0
	    k = 0L
	    for i=i_start, i_end, i_increment do begin
		hdf_data_x(k) = time_record(i) + ijk * 0.01
		k = k + 1
	    endfor
	endif else begin
	    if info.subset.data(this_subset).src_transpose eq 0 then begin
		k = 0L
		for i=i_start, i_end, i_increment do begin
		    hdf_data_x(k) = time_record(true_start) + i * 0.01
		    k = k + 1
		endfor
	    endif else begin
		k = 0L
		for i=i_start, i_end, i_increment do begin
		    hdf_data_x(k) = time_record(i)
		    k = k + 1
		endfor
	    endelse
	endelse
    endelse
  end
  2: begin
    this_start = info.subset.data(this_subset).src_start(1)
    this_end = info.subset.data(this_subset).src_end(1)-1
    this_increment = info.subset.data(this_subset).src_increment(1)
    if time_dimen eq 2 then begin
	if info.subset.data(this_subset).src_transpose eq 0 then begin
	    ii = 0L
	    for i = i_start, i_end, i_increment do begin
		jj = 0
		for j = this_start, this_end, this_increment do begin
		    hdf_data_x(jj,ii) = time_record(j,i)
		    jj = jj + 1
		endfor
		ii = ii + 1
	    endfor
	endif else begin
	    hdf_data_x = transpose(hdf_data_x)
	    ii = 0L
	    for i = this_start, this_end, this_increment do begin
		jj = 0
		for j = i_start, i_end, i_increment do begin
		    hdf_data_x(jj,ii) = time_record(j,i)
		    jj = jj + 1
		endfor
		ii = ii + 1
	    endfor
	    hdf_data_x = transpose(hdf_data_x)
	endelse
    endif else begin
	if info.subset.data(this_subset).src_transpose eq 0 then begin
	    ii = 0L
	    for i = i_start, i_end, i_increment do begin
		jj = 0
		for j = this_start, this_end, this_increment do begin
		    hdf_data_x(jj,ii) = time_record(i) + 0.01 * j
		    jj = jj + 1
		endfor
		ii = ii + 1
	    endfor
	endif else begin
	    hdf_data_x = transpose(hdf_data_x)
	    ii = 0L
	    for i = this_start, this_end, this_increment do begin
		jj = 0
		for j = i_start, i_end, i_increment do begin
		     hdf_data_x(jj,ii) = time_record(i) + 0.01 * j
		     jj = jj + 1
		endfor
		ii = ii + 1
	    endfor
	   hdf_data_x = transpose(hdf_data_x)
	endelse
    endelse
  end
  else: begin
	result=dialog_message('Do not support SDS rank greater than 2!',$
			title='View HDF Warning!')
	return
  end

endcase

endif else begin

  this_true_order = info.subset.data(this_subset).src_order(1)
  this_start = info.subset.data(this_subset).src_start(0)
  this_end = info.subset.data(this_subset).src_end(0)
  this_increment = info.subset.data(this_subset).src_increment(0)

  if this_true_order gt 1 then begin
	time_location = make_array(this_true_order, /LONG)
	if info.bds_file eq 1 then begin
	   temp_name = info.subset.data(this_subset).subset_name
	   temp_name = temp_name(0)

	   dot=strpos(temp_name,'[')
	   if( dot ne -1) then begin
		fieldname=strmid(temp_name,0,dot)
	   endif else begin
		fieldname = temp_name
	   endelse

	   CD, '.', CURRENT = PWD
 
	   if info.library_status eq 1 then begin
		;the_result = CALL_EXTERNAL(PWD+'/' + info.library,   $
		the_result = CALL_EXTERNAL(info.library,   $
		    'get_analog_location',         $
		    fieldname, $
		    this_true_order, $
		    time_location)
	   endif else the_result = -1
	endif else the_result = -1
 
	if the_result eq -1 then begin
		this_interval = long(660/this_true_order)
		for i = 0, this_true_order-1 do begin
			time_location(i) = i * this_interval
		endfor
	endif
	order_start = info.subset.data(this_subset).src_start(1) - 1
	order_end = info.subset.data(this_subset).src_end(1) - 1
	order_increment = info.subset.data(this_subset).src_increment(1)
	k = 0L
	for i = this_start, this_end, this_increment do begin
		for j = order_start, order_end, order_increment do begin
			hdf_data_x(k) = time_record(i) + 0.01 * time_location(j)
			k = k + 1
		endfor
	endfor

  endif else begin
	k = 0L
        for i = this_start, this_end, this_increment do begin
		hdf_data_x(k) = time_record(i)
		k = k + 1
        endfor
  endelse


endelse

end 

;--------------------------------------------------------------------------------
pro get_line_thickness, info, base

pro_name = 'get_line_thickness'
@getinfo

widget_control, /hourglass
thickness = strcompress(string(info.style.linethick), /REMOVE_ALL)
i_value = [thickness]
title = 'Get Line Thickness'
f_title = ['Line Thickness:']
xsize = [10]
the_message = ['Enter the line thickness for plotting']
para = get_n_field_value(1, i_value, xsize, title, f_title, the_message, base, info)
thickness = para(0)
if thickness eq 'cancel' then return

info.style.linethick = float(thickness)

if(widget_info(info.widgets.base, /VALID_ID)) then $
	widget_control, set_uvalue=info, info.widgets.base
widget_control, set_uvalue=info, info.base

end

;--------------------------------------------------------------------------------
pro getsymbolsizeCB, event

pro_name = 'getsymbolsizeCB'
@getinfo

widget_control, get_uvalue=info, event.top

widget_control, info.widgets.symbolsize, get_value=symbolsize

info.style.symbolsize=symbolsize
print,'symbol size =',info.style.symbolsize

if(widget_info(info.widgets.base, /VALID_ID)) then $
	widget_control, set_uvalue=info, info.widgets.base
widget_control, set_uvalue=info, info.base

widget_control, event.top, /destroy

end

;--------------------------------------------------------------------------------
pro get_symbol_size, info, top_base

pro_name = 'get_symobl_size'
@getinfo

base_loc = widget_info(top_base, /geometry)
xoffset = base_loc.xoffset + 100
yoffset = base_loc.yoffset + 100

base=widget_base(group_leader=top_base, /modal, column=1, xoffset=xoffset, $
	yoffset=yoffset, MAP=1, TITLE='Symbol Size')

ss_group=widget_base(base, row=1,map=1)

info.widgets.symbolsize = CW_FIELD(ss_group, VALUE=info.style.symbolsize, $
		ROW=1, FLOATING=1, FIELDFONT=info.font, $
		FONT=info.font, TITLE='Symbol Size:', XSIZE=10)

group2=widget_base(base, row=1,map=1, space=40, /align_center)

button1=widget_button(group2, FONT=info.font, EVENT_PRO='getsymbolsizeCB', VALUE="Done",$
	/ALIGN_CENTER)

button2=widget_button(group2, FONT=info.font, EVENT_PRO='doneCB', VALUE="Cancel",$
	 /ALIGN_CENTER)

widget_control, /realize, base

widget_control, set_uvalue=info, base
if(widget_info(info.widgets.base, /VALID_ID)) then $
	widget_control, set_uvalue=info, info.widgets.base
widget_control, set_uvalue=info, info.base

end

;--------------------------------------------------------------------------------
pro getdatacolor_event, event

pro_name = 'getdatacolorCB_event'
@getinfo

widget_control, get_uvalue=type, event.id
widget_control, get_uvalue=info, event.top

case type of
    'color': begin
	info.style.colorindex=event.value
	widget_control, set_uvalue=info, event.top
	end
    'done': begin
	widget_control, set_uvalue=info, info.base
	widget_control, event.top, /destroy
	end
    'cancel': widget_control, event.top, /destroy
    else:
endcase

end

;--------------------------------------------------------------------------------
pro get_data_color, info, top_base

pro_name = 'get_data_color'
@getinfo

old_window_id = !d.window

base_loc = widget_info(top_base, /geometry)
xoffset = base_loc.xoffset + 100
yoffset = base_loc.yoffset + 100

base=widget_base(group_leader=top_base, /modal, column=1, xoffset=xoffset, $
	yoffset=yoffset, MAP=1, TITLE='Data Color')

text1 = widget_label(base, /ALIGN_CENTER, value='Select Data Color Show on the Plot', $
        FONT=info.font)

ss_group=widget_base(base, row=1,map=1)

if !d.n_colors gt 192 then bar_size = !d.n_colors else bar_size = 192
if !d.n_colors gt 256 then begin
    bar_size = 256
    color_values =indgen(bar_size)
    if info.style.colorindex gt 255 then info.style.colorindex = 255
endif else color_values =indgen(!d.n_colors)
if info.version lt 5.39 then begin
    clr_index = cw_clr_index(base, color_values=color_values, label='Data Color: ', $
	uvalue='color', xsize=bar_size)
endif else begin
    clr_index = cw_clr_index(base, color_values=color_values, label='Data Color: ', $
	xsize=bar_size, value=info.style.colorindex, uvalue='color')
endelse

group2=widget_base(base, row=1,map=1, space=40, /align_center)

button1=widget_button(group2, FONT=info.font, VALUE="Done",$
	/ALIGN_CENTER, uvalue='done')

button2=widget_button(group2, FONT=info.font, VALUE="Cancel",$
	/ALIGN_CENTER, uvalue='cancel')

widget_control, /realize, base
widget_control, set_uvalue=info, base

if info.version lt 5.39 then initial_cw_clr_index, clr_index, info.style.colorindex

editable_cw_clr_index, clr_index

xmanager, 'getdatacolor', base

widget_control, get_uvalue=info, info.base
if(widget_info(info.widgets.base, /VALID_ID)) then $
        widget_control, set_uvalue=info, info.widgets.base
widget_control, set_uvalue=info, info.base

wset, old_window_id

end

;------------------------------------------------------------------
pro get_x_data, info, this_subset, print_flag, hdf_data_x

pro_name = 'get_x_data'
@getinfo
 
CASE info.field_name.x of

	'Time': get_seconds, info, this_subset, hdf_data_x
	
	'Sample Number': get_sample_number, info , this_subset, hdf_data_x
	
	'Record Number': get_record_number, info , this_subset, hdf_data_x

	;'Packet Number - Relative': get_packet_number_relative, info, $
	;				this_subset, hdf_data_x
	'Packet Number - Relative': get_packet_number_absolute, info, $
					this_subset, hdf_data_x, 1

	'Packet Number - Absolute': get_packet_number_absolute, info, $
					this_subset, hdf_data_x, 0

	'Select Variable': get_select_variable, info, this_subset, print_flag, $
				hdf_data_x

	else: begin
		result=dialog_message('This X field is not valid!',$
			title='View HDF Warning!')
		set_error_data, hdf_data_x
		return
	end

ENDCASE

end

;------------------------------------------------------------------
pro get_time, info, call_flag

pro_name = 'get_time'
@getinfo
 
widget_control,info.widgets.current_file,get_value=filename
filename = filename(0)

sds_time_name = ['Julian Date and Time', 'Time of observation', 'Jultime_Radius', $
	'Julian_Time', 'Julian date and time', 'Profile_UTC_Time', 'Lidar_Shot_UTC_Time']
num_name = n_elements(sds_time_name)
sds_index = -1
i = 0
while (sds_index eq -1 and i lt num_name) do begin
	temp_name = sds_time_name(i)
	sds_index = check_sds_index(filename, temp_name)
	i = i + 1
endwhile
if sds_index ne -1 then begin

    name_id = i - 1
    sd_id = HDF_SD_START(filename, /READ)
    if sd_id eq -1 then begin
	result=dialog_message('Unable to open '+filename+'!',$
		title='View HDF Warning!')
	return
    endif

    sds_id = HDF_SD_SELECT(sd_id, sds_index)
    if sds_id eq -1 then begin
	result=dialog_message('Unable to select '+temp_name+' SDS data!',$
		title='View HDF Warning!')
	HDF_SD_END,sd_id
	return
    endif

    HDF_SD_GETINFO,sds_id, dims=sds_dims, /NOREVERSE
    HDF_SD_GETDATA, sds_id, output_data

    HDF_SD_ENDACCESS,sds_id
    HDF_SD_END, sd_id

    if name_id eq 4 then time_record = make_array(sds_dims(1), sds_dims(0), /DOUBLE) $
	else time_record = make_array(sds_dims(0), /DOUBLE)

  ; Convert to the seconds of the day

    if name_id eq 0 then begin
	info.rangetype.jul_start = output_data(0,0) + output_data(1,0)
	info.rangetype.jul_end = output_data(0,sds_dims(0)-1) + output_data(1,sds_dims(0)-1)
	info.rangetype.julian = output_data(0,0)
	temp = output_data(1,0)
	if temp gt 0.5 then info.rangetype.julian = info.rangetype.julian + 0.5 $
	    else info.rangetype.julian = info.rangetype.julian - 0.5
	for i=0L, sds_dims(0)-1 do begin
	   if(output_data(1, i) gt 0.5) then begin
		time_record(i) = (output_data(1,i) - 0.5) * 86400.0
	   endif else begin
		time_record(i) = (output_data(1,i) + 0.5) * 86400.0
	   endelse 
	endfor
    endif else if name_id eq 1 then begin
	info.rangetype.jul_start = output_data(0)
	info.rangetype.jul_end = output_data(sds_dims(0)-1)
	info.rangetype.julian = double(long(output_data(0)))
	temp = output_data(0) - long(output_data(0))
	if temp gt 0.5 then info.rangetype.julian = info.rangetype.julian + 0.5 $
	    else info.rangetype.julian = info.rangetype.julian - 0.5
	for i=0L, sds_dims(0)-1 do begin
	   if output_data(i) gt 1.0 then $
		output_data(i) = output_data(i) - long(output_data(i))
	   if(output_data(i) gt 0.5) then begin
		time_record(i) = (output_data(i) - 0.5) * 86400.0
	   endif else begin
		time_record(i) = (output_data(i) + 0.5) * 86400.0
	   endelse 
	endfor
    endif else if name_id eq 2 or name_id eq 3 then begin
	info.rangetype.jul_start = output_data(0,0)
	info.rangetype.jul_end = output_data(0,sds_dims(0)-1)
	info.rangetype.julian = double(long(output_data(0,0)))
	temp = output_data(0,0) - long(output_data(0,0))
	if temp gt 0.5 then info.rangetype.julian = info.rangetype.julian + 0.5 $
	    else info.rangetype.julian = info.rangetype.julian - 0.5
 	for i=0L, sds_dims(0)-1 do begin
 	   if output_data(0, i) gt 1.0 then $
 		output_data(0, i) = output_data(0, i) - long(output_data(0, i))
 	   if(output_data(0, i) gt 0.5) then begin
 		time_record(i) = (output_data(0,i) - 0.5) * 86400.0
 	   endif else begin
 		time_record(i) = (output_data(0,i) + 0.5) * 86400.0
 	   endelse 
 	endfor
    endif else if name_id eq 4 then begin
	info.rangetype.jul_start = output_data(0,0,0) + output_data(1,0,0)
	info.rangetype.jul_end = output_data(0,sds_dims(1)-1,sds_dims(0)-1) $
	    + output_data(1,sds_dims(1)-1,sds_dims(0)-1)
	info.rangetype.julian = output_data(0,0,0)
	for j=0L, sds_dims(1)-1 do begin
	    for i=0L, sds_dims(0)-1 do begin
		time_record(j,i) = output_data(1,j,i) * 86400.0
	    endfor
	endfor
    endif else if name_id eq 5 or name_id eq 6 then begin
	info.rangetype.jul_start = output_data(0)
	info.rangetype.jul_end = output_data(sds_dims(0)-1)
	info.rangetype.julian = double(long(output_data(0)))
	for i=0L, sds_dims(0)-1 do begin
	    temp = output_data(i) - long(output_data(i))
	    time_record(i) = temp * 86400.0
	endfor
    endif else begin
		result=dialog_message('The '+temp_name+' is not valid!',$
			title='View HDF Warning!')
		return
   endelse

   undefine, temp
   undefine, output_data

  if ptr_valid(info.rangetype.time) then ptr_free, info.rangetype.time
  info.rangetype.time=ptr_new(time_record)
  info.rangetype.get_time = 1
 
  widget_control, set_uvalue=info, info.base

  return

endif

vdata_time_name = ['IES Hour', 'Time of observation', 'Time and Position Data']
num_name = n_elements(vdata_time_name)
count = 0
i = 0
while(count eq 0 and i lt num_name) do begin
	temp_name = vdata_time_name(i)
	search_result = strpos(info.name_list_vdata, temp_name)
	result = where(search_result ne -1, count)
	i = i + 1
endwhile

if count ne 0 then begin

    name_id = i - 1
    the_vdata_name = ''
    the_vdata_name = info.name_list_vdata(result)

    file_id = HDF_OPEN(filename, /READ)
    if file_id eq -1 then begin
	result=dialog_message('Unable to open '+filename+'!',$
		title='View HDF Warning!')
	return
    endif

    the_vdata_name = the_vdata_name[0]
    vdata_ref = HDF_VD_FIND(file_id, the_vdata_name)
    if vdata_ref eq 0 then begin
	result=dialog_message('Unable to find '+the_vdata_name+'!',$
		title='View HDF Warning!')
	HDF_CLOSE,file_id
	return
    endif
    
    vdata_id = HDF_VD_ATTACH(file_id, vdata_ref, /READ)
    ;if vdata_id eq 0 then begin
    if vdata_id le 0 then begin
	result=dialog_message('Unable to attach '+the_vdata_name+'!',$
		title='View HDF Warning!')
	HDF_CLOSE,file_id
	return
    endif

    field_time_name = ['Time of Observation', 'Time of observation', $
	'Julian Time']
    fieldname = field_time_name(name_id)
    fieldname = fieldname[0]
    result = HDF_VD_FEXIST(vdata_id, fieldname)
    if result eq -1 then begin
	result=dialog_message('Unable to find '+fieldname+'!', $
		title='View HDF Warning!')
	HDF_VD_DETACH, vdata_id
	HDF_CLOSE,file_id
	return
    endif

    HDF_VD_GET,vdata_id, COUNT=the_nrec
    nread = HDF_VD_READ(vdata_id,output_data,FIELDS=fieldname)
    HDF_VD_DETACH, vdata_id
    HDF_CLOSE,file_id
  
    info.rangetype.jul_start = output_data(0)
    info.rangetype.jul_end = output_data(the_nrec-1)
    info.rangetype.julian = double(long(output_data(0)))
	temp = output_data(0) - long(output_data(0))
    if temp gt 0.5 then info.rangetype.julian = info.rangetype.julian + 0.5 $
	else info.rangetype.julian = info.rangetype.julian - 0.5
    time_record = make_array(the_nrec, /DOUBLE)
    for i = 0L, the_nrec-1 do begin
	if output_data(i) gt 1.0 then $
		output_data(i) = output_data(i) - long(output_data(i))
	if(output_data(i) gt 0.5) then $
		time_record(i) = (output_data(i) - 0.5) * 86400.0 $
	else time_record(i) = (output_data(i) + 0.5) * 86400.0
    endfor

    if ptr_valid(info.rangetype.time) then ptr_free, info.rangetype.time
    info.rangetype.time=ptr_new(time_record)
    info.rangetype.get_time = 1
 
    widget_control, set_uvalue=info, info.base

return

endif

if ptr_valid(info.rangetype.time) then ptr_free, info.rangetype.time
if call_flag eq 1 then begin
	result=dialog_message('The Time field is not found!',$
		title='View HDF Warning!')
endif

end 

;------------------------------------------------------------------
pro set_output_wref, name_of_data, this_subset, the_type, the_rank, $
	start_list, end_list, increment_list, unitname, info, subset_data

pro_name = 'set_output_wref'
@getinfo

if (info.subset.count lt info.subset.maximum) then begin
   subset_name=name_of_data + '[' + strcompress(string(info.subset.count)) +']'
   info = redefine_info(info, subset_name, 3)
   widget_control, info.widgets.subset_list, set_value=info.name_list_subset
   info.subset.count=info.subset.count+1
   info.subset.data(info.subset.count-1).subset_name = string(subset_name)
   info.subset.data(info.subset.count-1).src_filename = info.subset.data(this_subset).src_filename
   info.subset.data(info.subset.count-1).src_unitname = unitname
   info.subset.data(info.subset.count-1).src_type_flag = info.subset.data(this_subset).src_type_flag
   info.subset.data(info.subset.count-1).src_crit_flag = info.subset.data(this_subset).src_crit_flag
   info.subset.data(info.subset.count-1).src_crit_name = info.subset.data(this_subset).src_crit_name
   info.subset.data(info.subset.count-1).src_crit_min = info.subset.data(this_subset).src_crit_min
   info.subset.data(info.subset.count-1).src_crit_max = info.subset.data(this_subset).src_crit_max
   info.subset.data(info.subset.count-1).src_crit_type = info.subset.data(this_subset).src_crit_type

   info.subset.data(info.subset.count-1).src_ref = info.subset.data(this_subset).src_ref
   info.subset.data(info.subset.count-1).src_org_rank = info.subset.data(this_subset).src_org_rank
   info.subset.data(info.subset.count-1).src_org_start = info.subset.data(this_subset).src_org_start
   info.subset.data(info.subset.count-1).src_org_end = info.subset.data(this_subset).src_org_end
   info.subset.data(info.subset.count-1).src_transpose = info.subset.data(this_subset).src_transpose
   info.subset.data(info.subset.count-1).src_org_increment = info.subset.data(this_subset).src_org_increment
   info.subset.data(info.subset.count-1).src_fnames = info.subset.data(this_subset).src_fnames
   info.subset.data(info.subset.count-1).src_types(0) = the_type
   info.subset.data(info.subset.count-1).src_order = info.subset.data(this_subset).src_order

   ref_rank = info.subset.data(this_subset).src_rank
   ref_start = info.subset.data(this_subset).src_start(0:ref_rank-1)
   ref_end = info.subset.data(this_subset).src_end(0:ref_rank-1)
   if info.subset.data(this_subset).src_type_flag eq 1 then ref_end = ref_end + 1
   ref_increment = info.subset.data(this_subset).src_increment(0:ref_rank-1)
   ;ref_array_size = long((ref_end-ref_start)/float(ref_increment) + 0.9)
   ;array_size = long((end_list-start_list)/float(increment_list) + 0.9)
   ref_array_size = long((ref_end-ref_start-1)/float(ref_increment) + 1.0)
   array_size = long((end_list-start_list-1)/float(increment_list) + 1.0)
   if info.subset.data(this_subset).src_type_flag eq 0 then begin
      ;true_rank = info.subset.data(this_subset).src_rank
      ;info.subset.data(info.subset.count-1).src_rank = the_rank
      ;if the_rank eq 1 and true_rank eq 2 then begin
;	if array_size(0) eq ref_array_size(1) then begin
;	   info.subset.data(info.subset.count-1).src_start(0) = info.subset.data(this_subset).src_start(1)
;           info.subset.data(info.subset.count-1).src_end(0) = info.subset.data(this_subset).src_end(1)
;           info.subset.data(info.subset.count-1).src_increment(0) = info.subset.data(this_subset).src_increment(1)
;	endif else begin
;	   info.subset.data(info.subset.count-1).src_start(0) = start_list(0)
;	   info.subset.data(info.subset.count-1).src_end(0) = end_list(0)
;	   info.subset.data(info.subset.count-1).src_increment(0) = increment_list(0)
;	endelse
;	   info.subset.data(info.subset.count-1).src_start(1) = info.subset.data(this_subset).src_start(0)
;	   info.subset.data(info.subset.count-1).src_end(1) = info.subset.data(this_subset).src_end(0)
;	   info.subset.data(info.subset.count-1).src_increment(1) = info.subset.data(this_subset).src_increment(0)
;      endif else begin
;	check_same = 1
;	for i=0,the_rank-1 do begin
;	   if array_size(i) ne ref_array_size(i) then check_same = 0
;	endfor
	num_ref_element = ref_array_size(0)
	for i = 1 , ref_rank-1 do num_ref_element = num_ref_element * ref_array_size(i)
	num_element = array_size(0)
	for i = 1 , the_rank-1 do num_element = num_element * array_size(i)
;	if check_same eq 1 then begin
	if num_element eq num_ref_element then begin
 	   info.subset.data(info.subset.count-1).src_start = info.subset.data(this_subset).src_start
           info.subset.data(info.subset.count-1).src_end = info.subset.data(this_subset).src_end
           info.subset.data(info.subset.count-1).src_increment = info.subset.data(this_subset).src_increment
	   info.subset.data(info.subset.count-1).src_rank = info.subset.data(this_subset).src_rank
	   ref_array_size = reverse(ref_array_size)
	   subset_data = reform(subset_data, ref_array_size)
	endif else begin
 	   info.subset.data(info.subset.count-1).src_start = start_list
 	   info.subset.data(info.subset.count-1).src_end = end_list
 	   info.subset.data(info.subset.count-1).src_increment = increment_list
	   info.subset.data(info.subset.count-1).src_rank = the_rank
	endelse
;      endelse
	num_output_data = n_elements(subset_data)
   endif else begin
      num_ref_element = ref_array_size(0) * ref_array_size(1)
      num_element = array_size(0)
      for i = 1 , the_rank-1 do num_element = num_element * array_size(i)
      check_order = 0
      if num_ref_element eq num_element then begin
	the_order = ref_array_size(1)
	num_record = ref_array_size(0)
        check_order = 1
      endif else begin
	the_order = 1
	num_record = num_element
      endelse
      blank = array_type(the_type, the_order)
      single_record = create_struct('components'+'0', blank)  
      output_data = replicate(single_record, num_record)
      jj = 0L
      for i = 0L, num_record-1 do begin
	for j = 0L, the_order-1 do begin
	   output_data(i).components0(j) = subset_data(jj)
	   jj = jj + 1
	endfor
      endfor
      subset_data = output_data
      num_output_data = n_elements(subset_data.components0)
      info.subset.data(info.subset.count-1).src_rank = 2
      if check_order eq 1 then begin
	info.subset.data(info.subset.count-1).src_start = info.subset.data(this_subset).src_start
	info.subset.data(info.subset.count-1).src_end = info.subset.data(this_subset).src_end
	info.subset.data(info.subset.count-1).src_increment = info.subset.data(this_subset).src_increment
      endif else begin
	info.subset.data(info.subset.count-1).src_start(0) = 0
	info.subset.data(info.subset.count-1).src_end(0) = num_record-1
	info.subset.data(info.subset.count-1).src_increment(0) = 1
	info.subset.data(info.subset.count-1).src_start(1) = 1
	info.subset.data(info.subset.count-1).src_end(1) = 1
	info.subset.data(info.subset.count-1).src_increment(1) = 1
	info.subset.data(info.subset.count-1).src_order = 1
      endelse    
   endelse

   info.subset.data(info.subset.count-1).src_num = num_output_data

   if ptr_valid(info.subset.data(info.subset.count-1).src_data) then begin
	*info.subset.data(info.subset.count-1).src_data = subset_data
   endif else begin
	info.subset.data(info.subset.count-1).src_data = ptr_new(subset_data)
   endelse

   if ptr_valid(info.subset.data(this_subset).src_time) then begin
	if ptr_valid(info.subset.data(info.subset.count-1).src_time) then begin
	    *info.subset.data(info.subset.count-1).src_time = $
		*info.subset.data(this_subset).src_time
	endif else begin
	    info.subset.data(info.subset.count-1).src_time = $
		ptr_new(*info.subset.data(this_subset).src_time)
	endelse
   endif
   widget_control, set_uvalue=info, info.base

   save_list = redefine_save_list(info)
   widget_control, set_uvalue=save_list, info.list_base
endif else begin
   the_message = ["You have maximum sets of data", "Please remove at least one set of data."]
       result=dialog_message(the_message, title='View HDF Warning!')
   return
endelse
	
end

;------------------------------------------------------------------
pro set_output_woref, name_of_data, this_subset, the_type, the_rank, $
	start_list, end_list, increment_list, unitname, info, subset_data

pro_name = 'set_output_woref'
@getinfo

if (info.subset.count lt info.subset.maximum) then begin
   if this_subset ge info.subset.count then this_subset = -1
   widget_control, info.widgets.current_file, get_value=current_filename
   current_filename = current_filename(0)
   subset_name=name_of_data + '[' + strcompress(string(info.subset.count)) +']'
   info = redefine_info(info, subset_name, 3)
   widget_control, info.widgets.subset_list, set_value=info.name_list_subset
   info.subset.count=info.subset.count+1
   info.subset.data(info.subset.count-1).subset_name = string(subset_name)
   info.subset.data(info.subset.count-1).src_unitname = unitname
   info.subset.data(info.subset.count-1).src_type_flag = 0
   if this_subset lt 0 then begin
	info.subset.data(info.subset.count-1).src_filename = current_filename
	info.subset.data(info.subset.count-1).src_crit_flag = 0
	info.subset.data(info.subset.count-1).src_crit_name = ''
	info.subset.data(info.subset.count-1).src_crit_min = ''
	info.subset.data(info.subset.count-1).src_crit_max = ''
	info.subset.data(info.subset.count-1).src_crit_type = ''
	info.subset.data(info.subset.count-1).src_org_rank = the_rank
	info.subset.data(info.subset.count-1).src_org_start = start_list
	info.subset.data(info.subset.count-1).src_org_end = end_list
	info.subset.data(info.subset.count-1).src_org_increment = increment_list
   endif else begin
	info.subset.data(info.subset.count-1).src_filename = info.subset.data(this_subset).src_filename
	info.subset.data(info.subset.count-1).src_crit_flag = info.subset.data(this_subset).src_crit_flag
	info.subset.data(info.subset.count-1).src_crit_name = info.subset.data(this_subset).src_crit_name
	info.subset.data(info.subset.count-1).src_crit_min = info.subset.data(this_subset).src_crit_min
	info.subset.data(info.subset.count-1).src_crit_max = info.subset.data(this_subset).src_crit_max
	info.subset.data(info.subset.count-1).src_crit_type = info.subset.data(this_subset).src_crit_type
	info.subset.data(info.subset.count-1).src_org_rank = info.subset.data(this_subset).src_org_rank
	info.subset.data(info.subset.count-1).src_org_start = info.subset.data(this_subset).src_org_start
	info.subset.data(info.subset.count-1).src_org_end = info.subset.data(this_subset).src_org_end
	info.subset.data(info.subset.count-1).src_org_increment = info.subset.data(this_subset).src_org_increment
	if info.graph_style eq 'Transpose' then begin
	    if info.subset.data(this_subset).src_transpose eq 0 then begin
		info.subset.data(info.subset.count-1).src_transpose = 1
	    endif else info.subset.data(info.subset.count-1).src_transpose = 0
	endif
   endelse

   num_output_data = n_elements(subset_data)
   info.subset.data(info.subset.count-1).src_num = num_output_data

   info.subset.data(info.subset.count-1).src_ref = 0
   info.subset.data(info.subset.count-1).src_rank = the_rank
   info.subset.data(info.subset.count-1).src_start = start_list
   info.subset.data(info.subset.count-1).src_end = end_list
   info.subset.data(info.subset.count-1).src_increment = increment_list
   info.subset.data(info.subset.count-1).src_types(0) = the_type
   info.subset.data(info.subset.count-1).src_start(the_rank) = start_list(0)
   info.subset.data(info.subset.count-1).src_end(the_rank) = end_list(0)
   if ptr_valid(info.subset.data(info.subset.count-1).src_data) then begin
	*info.subset.data(info.subset.count-1).src_data = subset_data
   endif else begin
	info.subset.data(info.subset.count-1).src_data = ptr_new(subset_data)
   endelse
   if this_subset ge 0 then begin
	if ptr_valid(info.subset.data(this_subset).src_time) then begin
	    if ptr_valid(info.subset.data(info.subset.count-1).src_time) then begin
		*info.subset.data(info.subset.count-1).src_time = $
		    *info.subset.data(this_subset).src_time
	    endif else begin
		info.subset.data(info.subset.count-1).src_time = $
		    ptr_new(*info.subset.data(this_subset).src_time)
	    endelse
	endif
   endif
   widget_control, set_uvalue=info, info.base

   save_list = redefine_save_list(info)
   widget_control, set_uvalue=save_list, info.list_base
endif else begin
   the_message = ["You have maximum sets of data", "Please remove at least one set of data."]
       result=dialog_message(the_message, title='View HDF Warning!')
   return
endelse
	
end

;--------------------------------------------------------------------------------
pro get_user_define_module, info

pro_name = 'get_user_define_module'
@getinfo

;if (info.userdefine.count ge info.userdefine.max) then begin
;	the_message = ["You have maximun sets of user defined modules.",$
;		"Please remove at least one set of module and do it again."]
;	result=dialog_message(the_message, title='View HDF Warning!')
;	return
;endif

count = check_directory(info.userdefine.old_path, info.home_path)
if count eq 0 then begin
	CD, '.', CURRENT=pwd
	info.userdefine.old_path = pwd
endif
filename = dialog_pickfile(title='Get User Defined Module',/read, $
		path=info.userdefine.old_path, $
		get_path=this_path, filter='*.pro')

if filename eq "" then return

user_result=STRPOS(filename, this_path)
if user_result eq -1 then filename=this_path+filename
print, 'User Defined Module = ', filename

info.userdefine.old_path = this_path

openr,unit,filename,/get_lun
loc = 0
temp=''
while(loc ne -1) do begin
    temp1 = ''
    readf,unit,temp1
    temp1 = strtrim(temp1,2)
    comment_check = strmid(temp1,0,1)
    if comment_check ne ';' then begin
	temp = temp + temp1
	loc = strpos(temp , '$')
	if loc ne -1 then temp = strmid(temp, 0 , loc)
    endif
endwhile
close,unit
free_lun, unit

temp = strcompress(temp,/REMOVE_ALL)
pararray = str_sep(temp,',')
num_para = n_elements(pararray) - 1
if num_para lt 0 then begin
	result=dialog_message('Error to get module name!', title='View HDF Warning!')
	return
endif

length = strlen(pararray(0))
if length lt 4 then begin
	result=dialog_message('The first line of the module must be pro ...!', $
		title='View HDF Warning!')
	return
endif

test_pro = strmid(pararray(0), 0, 3)
if strlowcase(test_pro) ne 'pro' then begin
	result=dialog_message('The first line of the module must be pro ...!', $
		title='View HDF Warning!')
	return
endif

prog_name = strmid(pararray(0), 3, length-3)

check_prog = 0
subscript = where(info.name_list_userdefine eq prog_name, count)
if count ne 0 then begin
    i = 0
    while check_prog eq 0 and i lt count do begin
	if info.userdefine.path(subscript(i)) eq this_path then begin
		if info.userdefine.num_para(subscript(i)) eq num_para then begin
			check_prog = 1
			check_index = subscript(i)
		endif
	endif
	i = i + 1
    endwhile
endif

if check_prog eq 0 then begin
	info.userdefine.path(1:info.userdefine.max-1) = info.userdefine.path(0:info.userdefine.max-2)
	info.userdefine.name(1:info.userdefine.max-1) = info.userdefine.name(0:info.userdefine.max-2)
	info.userdefine.num_para(1:info.userdefine.max-1) = info.userdefine.num_para(0:info.userdefine.max-2)
	info.userdefine.path(0) = this_path
	info.userdefine.name(0) = prog_name
	info.userdefine.num_para(0) = num_para
	if info.userdefine.count lt info.userdefine.max then $
		info.userdefine.count = info.userdefine.count + 1
endif else begin
    if check_index ne 0 then begin
	info.userdefine.path(1:check_index) = info.userdefine.path(0:check_index-1)
	info.userdefine.name(1:check_index) = info.userdefine.name(0:check_index-1)
	info.userdefine.num_para(1:check_index) = info.userdefine.num_para(0:check_index-1)
	info.userdefine.path(0) = this_path
	info.userdefine.name(0) = prog_name
	info.userdefine.num_para(0) = num_para
    endif
endelse

name_list_userdefine = info.userdefine.name(0)
for i = 1, info.userdefine.count-1 do begin
	name_list_userdefine = [name_list_userdefine , info.userdefine.name(i)]
endfor
info = redefine_info(info, name_list_userdefine, 12)

if(widget_info(info.widgets.base, /VALID_ID)) then $
	widget_control, set_uvalue=info, info.widgets.base
widget_control, set_uvalue=info, info.base

loc = strpos(!PATH, this_path)
if loc eq -1 then begin
	if info.device eq 'X' then !PATH = this_path+':'+!PATH $
		else !PATH = this_path+';'+!PATH
endif

end

;--------------------------------------------------------------------------------
pro remove_user_define_module, info

pro_name = 'remove_userdefine_module'
@getinfo

if (info.userdefine.count lt 1) then begin
	the_message = 'The list of user defined module is empty!'
	result=dialog_message(the_message, title='View HDF Warning!')
	return
endif

the_list = [info.name_list_userdefine, 'Cancel']
num_option = n_elements(the_list)
title = 'Remove User Defined Module'
the_message = 'Select the user defined module to remove'
default_option = num_option - 1
sel_option = get_option(default_option, the_list, title, the_message, info)
if sel_option eq num_option-1 then return

if (sel_option eq 0) and (info.userdefine.count eq 1) then begin
	info.userdefine.count = 0
	info.userdefine.num_para(0) = 0
	info.userdefine.path(0) = ''
	info.userdefine.name(0) = ''
	userdefine_name_list=[ 'None' ]
endif else if sel_option eq info.userdefine.count-1 then begin
	info.userdefine.count = info.userdefine.count - 1
	info.userdefine.num_para(info.userdefine.count) = 0
	info.userdefine.path(info.userdefine.count) = ''
	info.userdefine.name(info.userdefine.count) = ''
	userdefine_name_list = info.name_list_userdefine(0 : info.userdefine.count-1)
endif else if sel_option eq 0 then begin
	info.userdefine.count = info.userdefine.count - 1
	info.userdefine.num_para(0:info.userdefine.count-1) = $
		info.userdefine.num_para(1:info.userdefine.count)
	info.userdefine.path(0:info.userdefine.count-1) = $
		info.userdefine.path(1:info.userdefine.count)
	info.userdefine.name(0:info.userdefine.count-1) = $
		info.userdefine.name(1:info.userdefine.count)
	info.userdefine.num_para(info.userdefine.count) = 0
	info.userdefine.path(info.userdefine.count) = ''
	info.userdefine.name(info.userdefine.count) = ''
	userdefine_name_list = info.name_list_userdefine(1 : info.userdefine.count)
endif else begin
	userdefine_name_temp = info.name_list_userdefine
	userdefine_name_list = userdefine_name_temp(0 : sel_option-1)
	userdefine_name_list = [userdefine_name_list, userdefine_name_temp(sel_option+1 : *)]
	info.userdefine.count = info.userdefine.count - 1
	info.userdefine.num_para(sel_option:info.userdefine.count-1) = $
		info.userdefine.num_para(sel_option+1:info.userdefine.count)
	info.userdefine.path(sel_option:info.userdefine.count-1) = $
		info.userdefine.path(sel_option+1:info.userdefine.count)
	info.userdefine.name(sel_option:info.userdefine.count-1) = $
		info.userdefine.name(sel_option+1:info.userdefine.count)
	info.userdefine.num_para(info.userdefine.count) = 0
	info.userdefine.path(info.userdefine.count) = ''
	info.userdefine.name(info.userdefine.count) = ''
endelse

info = redefine_info(info, userdefine_name_list, 12)
widget_control, set_uvalue=info, info.base

return

end

;--------------------------------------------------------------------------------
pro run_user_define_module, info

pro_name = 'run_user_define_module'
@getinfo

count = check_exist_dir(info.userdefine.old_path)
if count eq 0 then begin
    CD, '.', CURRENT=pwd
    info.userdefine.old_path = pwd
endif

print,'old_path = ',info.userdefine.old_path
if strlen(info.userdefine.file) gt 0 then user_file = info.userdefine.file $
    else user_file = ''
filename = dialog_pickfile(title='Select User Defined Module',/read, $
    path=info.userdefine.old_path, file = user_file, $
    get_path=this_path, filter='*.pro')

if filename eq "" then return

user_result=STRPOS(filename, this_path)
if user_result eq -1 then filename=this_path+filename
print, 'User Defined Module = ', filename

info.userdefine.old_path = this_path
loc = strpos(!PATH, this_path)
if loc eq -1 then !PATH = this_path+':'+!PATH

openr,unit,filename,/get_lun
loc = 0
temp=''
while(loc ne -1) do begin
    temp1 = ''
    readf,unit,temp1
    temp1 = strtrim(temp1,2)
    comment_check = strmid(temp1,0,1)
    if comment_check ne ';' then begin
	temp = temp + temp1
	loc = strpos(temp , '$')
	if loc ne -1 then temp = strmid(temp, 0 , loc)
    endif
endwhile
close,unit
free_lun, unit

temp = strcompress(temp,/REMOVE_ALL)
pararray = str_sep(temp,',')
num_para = n_elements(pararray) - 1

if num_para lt 0 then begin
    result=dialog_message('Error to get module name!', title='View HDF Warning!')
    return
endif

length = strlen(pararray(0))
if length lt 4 then begin
    result=dialog_message('The first line of the module must be pro ...!', $
	title='View HDF Warning!')
    return
endif

test_pro = strmid(pararray(0), 0, 3)
if strlowcase(test_pro) ne 'pro' then begin
    result=dialog_message('The first line of the module must be pro ...!', $
	title='View HDF Warning!')
    return
endif

prog_name = strmid(pararray(0), 3, length-3)
info.userdefine.file = prog_name + '.pro'

num_output = 0
if num_para gt 0 then begin
    check_out = 0
    while check_out eq 0 do begin
	i_value = 1
	title = 'Get Number Of Output Parameters'
	f_title = 'Number of output parameters:'
	the_message = ['The procedure '+prog_name+' has '+ strcompress(string(num_para), /REMOVE_ALL) + $
	' parameters.', 'How many of them are output parameters?']
	num_output = get_field_value(i_value, 10, title, f_title, the_message, info)
	num_output = num_output(0)
	if num_output eq 'cancel' then return
	num_output = fix(num_output)
	if num_output le num_para then check_out = 1 $
	    else begin
		error_message = ['The number of output parameters is greater than number of parameters.', $
		   'Please enter the number of output parameters again.']
		result=dialog_message(error_message, title='View HDF Warning!')
	endelse
    endwhile

    if num_output gt 0 then begin
	num_input_para = num_para - num_output
	output_name_array = 'none'
	output_unit_array = 'none'

	for i = 0, num_output-1 do begin      
	    i_value=pararray(num_input_para + i + 1)
	    title = 'Get Output Variable Name'
	    f_title = 'Name:'
	    num_variable = strcompress(string(i + 1), /REMOVE_ALL)
	    the_message = 'Enter the Output Variable ' + num_variable + ' Name'
	    output_name = get_field_value(i_value, 60, title, f_title, the_message, info)
	    output_name = output_name(0)
	    if output_name eq 'cancel' then return
	    output_name_array = [output_name_array, output_name]

	    i_value = ''
	    title = 'Set Unit Value'
	    f_title = 'Unit Value:'
	    the_message = 'Enter the unit value for "'+output_name+'"'
	    unitname = get_field_value(i_value, 60, title, f_title, the_message, info)
	    unitname = unitname(0)
	    if unitname eq 'cancel' then unitname=''
	    if strlen(unitname) gt 0 then unitname = ', '+unitname else unitname = ' '
	    output_unit_array = [output_unit_array, unitname]
	endfor
	output_name_array = output_name_array(1:num_output)
	output_unit_array = output_unit_array(1:num_output)		
    endif else num_input_para = num_para

    para = ptrarr(num_para, /ALLOCATE_HEAP)
    if num_input_para gt 0 then begin
	if info.name_list_subset(0) eq 'None' then begin
	    the_list = [ 'Constant', 'String', 'Cancel']
	endif else begin
	    the_list = [info.name_list_subset, 'Constant', 'String', 'Cancel']
	endelse
	num_option = n_elements(the_list)
	para_title = 'Select Parameter'
	for i = 0, num_input_para-1 do begin
	    para_message = 'Select parameter "'+pararray(i+1)+'"'
	    default_option = num_option-1
	    sel_option = get_option(default_option, the_list, para_title, para_message, info)
	    if sel_option eq num_option-1 then begin
		ptr_free, para
		return
	    endif
	    if sel_option eq num_option-3 then begin
		i_value = 0.0
		title = 'Enter Constant Value'
		f_title = 'Constant Value:'
		the_message = 'Enter constant value for "'+pararray(i+1)+'"'
		const = get_field_value(i_value, 20, title, f_title, the_message, info)
		const = const(0)
		if const eq 'cancel' then begin
		    ptr_free, para
		    return
		endif
		const = strcompress(const,/REMOVE_ALL)
		const_array = str_sep(const,',')
		if n_elements(const_array) gt 1 then *para(i) = float(const_array) $
		    else *para(i) = float(const)
	    endif else if sel_option eq num_option-2 then begin
		i_value = ''
		title = 'Enter String Value'
		f_title = 'String Value:'
		the_message = 'Enter string value for "'+pararray(i+1)+'"'
		const = get_field_value(i_value, 20, title, f_title, the_message, info)
		const = const(0)
		if const eq 'cancel' then begin
		    ptr_free, para
		    return
		endif
		*para(i) = string(const)
	    endif else begin
		if info.subset.data(sel_option).src_type_flag eq 0 then begin
		    hdf_data = *info.subset.data(sel_option).src_data
		endif else begin
		    hdf_data_temp = *info.subset.data(sel_option).src_data
		    check_dim = size(hdf_data_temp.components0, /N_DIMENSIONS)
		    if check_dim eq 0 then hdf_data = hdf_data_temp.components0  else $
		    hdf_data = reform(hdf_data_temp.components0, n_elements(hdf_data_temp.components0))
		endelse
		*para(i) = hdf_data
	    endelse
	endfor
    endif
endif

widget_control, /hourglass

;resolve_routine, prog_name
resolve_status = check_compile_status(prog_name)
;  if cannot compile the prog, try restore
if(resolve_status eq -1) then begin
    restore_status = check_restore_status(prog_name+'.sav')
    if(restore_status eq -1) then begin
	if num_para gt 0 then ptr_free, para
	the_message = ['Cannot compile and/or restore the routine: ', prog_name]
	result=dialog_message(the_message, title='View HDF Error!')
	return
    endif
endif

case num_para of
	0: call_procedure, prog_name
	1: call_procedure, prog_name, *para(0)
	2: call_procedure, prog_name, *para(0), *para(1)
	3: call_procedure, prog_name, *para(0), *para(1), *para(2)
	4: call_procedure, prog_name, *para(0), *para(1), *para(2), *para(3)
	5: call_procedure, prog_name, *para(0), *para(1), *para(2), *para(3), *para(4)
	6: call_procedure, prog_name, *para(0), *para(1), *para(2), *para(3), *para(4), *para(5)
	7: call_procedure, prog_name, *para(0), *para(1), *para(2), *para(3), *para(4), *para(5), $
		*para(6)
	8: call_procedure, prog_name, *para(0), *para(1), *para(2), *para(3), *para(4), *para(5), $
		*para(6), *para(7)
	9: call_procedure, prog_name, *para(0), *para(1), *para(2), *para(3), *para(4), *para(5), $
		*para(6), *para(7), *para(8)
	10: call_procedure, prog_name, *para(0), *para(1), *para(2), *para(3), *para(4), *para(5), $
		*para(6), *para(7), *para(8), *para(9)
	11: call_procedure, prog_name, *para(0), *para(1), *para(2), *para(3), *para(4), *para(5), $
		*para(6), *para(7), *para(8), *para(9), *para(10)
	12: call_procedure, prog_name, *para(0), *para(1), *para(2), *para(3), *para(4), *para(5), $
		*para(6), *para(7), *para(8), *para(9), *para(10), *para(11)
	13: call_procedure, prog_name, *para(0), *para(1), *para(2), *para(3), *para(4), *para(5), $
		*para(6), *para(7), *para(8), *para(9), *para(10), *para(11), *para(12)
	14: call_procedure, prog_name, *para(0), *para(1), *para(2), *para(3), *para(4), *para(5), $
		*para(6), *para(7), *para(8), *para(9), *para(10), *para(11), *para(12), *para(13)
	15: call_procedure, prog_name, *para(0), *para(1), *para(2), *para(3), *para(4), *para(5), $
		*para(6), *para(7), *para(8), *para(9), *para(10), *para(11), *para(12), *para(13), $
		*para(14)
	16: call_procedure, prog_name, *para(0), *para(1), *para(2), *para(3), *para(4), *para(5), $
		*para(6), *para(7), *para(8), *para(9), *para(10), *para(11), *para(12), *para(13), $
		*para(14), *para(15)
	17: call_procedure, prog_name, *para(0), *para(1), *para(2), *para(3), *para(4), *para(5), $
		*para(6), *para(7), *para(8), *para(9), *para(10), *para(11), *para(12), *para(13), $
		*para(14), *para(15), *para(16)
	18: call_procedure, prog_name, *para(0), *para(1), *para(2), *para(3), *para(4), *para(5), $
		*para(6), *para(7), *para(8), *para(9), *para(10), *para(11), *para(12), *para(13), $
		*para(14), *para(15), *para(16), *para(17)
	19: call_procedure, prog_name, *para(0), *para(1), *para(2), *para(3), *para(4), *para(5), $
		*para(6), *para(7), *para(8), *para(9), *para(10), *para(11), *para(12), *para(13), $
		*para(14), *para(15), *para(16), *para(17), *para(18)
	20: call_procedure, prog_name, *para(0), *para(1), *para(2), *para(3), *para(4), *para(5), $
		*para(6), *para(7), *para(8), *para(9), *para(10), *para(11), *para(12), *para(13), $
		*para(14), *para(15), *para(16), *para(17), *para(18), *para(19)
	21: call_procedure, prog_name, *para(0), *para(1), *para(2), *para(3), *para(4), *para(5), $
		*para(6), *para(7), *para(8), *para(9), *para(10), *para(11), *para(12), *para(13), $
		*para(14), *para(15), *para(16), *para(17), *para(18), *para(19), *para(20)
	22: call_procedure, prog_name, *para(0), *para(1), *para(2), *para(3), *para(4), *para(5), $
		*para(6), *para(7), *para(8), *para(9), *para(10), *para(11), *para(12), *para(13), $
		*para(14), *para(15), *para(16), *para(17), *para(18), *para(19), *para(20), *para(21)
	else: begin
		the_message = ['Your module exceeds the maximum number of parameters!!', $
			 	'The maximum number of parameters is 22.']
		result=dialog_message(the_message, title='View HDF Warning!')
		ptr_free, para
		return
	      end
endcase

if num_output gt 0 then begin
    for i = 0, num_output-1 do begin
	output_data = *para(num_input_para+i)
	size_data = size(output_data)
	if size_data(0) gt 0 then begin

	    if (info.subset.count ge info.subset.maximum) then begin
		the_message = ["You have maximum sets of data in Current Subset List", $
		    "Output data cannot be written in the Current Subset List"]
		result=dialog_message(the_message, title='View HDF Warning!')
		ptr_free, para
		return
	    endif

	    rank = size_data(0)
	    start_list = lonarr(rank)
	    end_list = lonarr(rank)
	    increment_list = lonarr(rank)
	    for j = 0, rank-1 do begin
		start_list(j) = 0
		end_list(j) = size_data(j+1)
		increment_list(j) = 1
	    endfor
	    end_list = reverse(end_list)
	    type = size(output_data, /tname)
	    hdf_type = convert_idltypename_hdftype(type)

	    output_name = output_name_array(i)
	    unitname = output_unit_array(i)
	    the_list = info.name_list_subset
	    the_list = [the_list, 'No Reference', 'Cancel']
	    num_option = n_elements(the_list)
	    title = 'Select Reference Data Set'
	    the_message = ['Select one of the following data set for', $
		'reference to store the ' , output_name+':']
	    default_option = 0
	    sel_option = get_option(default_option,the_list,title,the_message,info)
	    if unitname eq ' ' then unitname = ''
	    if sel_option lt num_option-2 then begin
		set_output_wref, output_name, sel_option, hdf_type, rank, $
		    start_list, end_list, increment_list, unitname, info, output_data
	    endif else if sel_option eq num_option-2 then begin
		set_output_woref, output_name, -1, hdf_type, rank, $
		    start_list, end_list, increment_list, unitname, info, output_data
	    endif
	endif else begin
	    the_message = 'Error to obtain output from "'+prog_name+'"!!!'
	    result=dialog_message(the_message, title='View HDF Warning!')
	endelse
    endfor
endif

if num_para gt 0 then ptr_free, para

result=dialog_message('Run User Defined Module Completed!', title='Notice!')

end

;--------------------------------------------------------------------------------
function graph_item, event

pro_name = 'graph_item'
@getinfo1

widget_control, get_uvalue=info, event.top

info.graph_style=event.value
if info.graph_style eq 'Create Subset' then info.criterion.flag = 1

widget_control, set_uvalue=info, info.base
widget_control, set_uvalue=info, event.top

end

;--------------------------------------------------------------------------------
pro graph_selected, event

pro_name = 'graph_selected'
@getinfo

widget_control, get_uvalue=info, event.top

widget_control, event.top, /destroy

plot_graph, 0, info.subset.selected, info

widget_control, set_uvalue=info, info.base

end

;--------------------------------------------------------------------------------
pro greenlocationCB, event

pro_name = 'greenlocationCB'
@getinfo

widget_control, get_uvalue=info, event.top

widget_control, info.widgets.greenlocation, get_value=greenlocation

info.greenwich.greenloca=greenlocation
print,'Global Center Location=',info.greenwich.greenloca

if(widget_info(info.widgets.base, /VALID_ID)) then $
	widget_control, set_uvalue=info, info.widgets.base
widget_control, set_uvalue=info, info.base

widget_control, event.top, /destroy

end

;--------------------------------------------------------------------------------
pro green_location, info

pro_name = 'green_location'
@getinfo

base = widget_base(COLUMN=1, MAP=1, TITLE='Global Center Location')

g_group=widget_base(base, row=1,map=1)

info.widgets.greenlocation = CW_FIELD(g_group, VALUE=info.greenwich.greenloca, $
		ROW=1, FLOATING=1, FIELDFONT=info.font, $
		FONT=info.font, TITLE='Global Center Location:', XSIZE=10)

group2=widget_base(base, row=1,map=1, space=40, /align_center)

button1=widget_button(group2, FONT=info.font, EVENT_PRO='greenlocationCB', VALUE="Done",$
	/ALIGN_CENTER)

button2=widget_button(group2, FONT=info.font, EVENT_PRO='doneCB', VALUE="Cancel",$
	 /ALIGN_CENTER)

widget_control, /realize, base

widget_control, set_uvalue=info, base
if(widget_info(info.widgets.base, /VALID_ID)) then $
	widget_control, set_uvalue=info, info.widgets.base
widget_control, set_uvalue=info, info.base

end

;--------------------------------------------------------------------------------
pro center_location, base, info

pro_name = 'center_location'
@getinfo

widget_control, /hourglass
lat_loc = strcompress(string(info.greenwich.lat_loc), /REMOVE_ALL)
lon_loc = strcompress(string(info.greenwich.greenloca), /REMOVE_ALL)
i_value = [lat_loc, lon_loc]
title = 'Get Map Center Location'
f_title = ['Latitude:', 'Longitude:']
xsize = [20, 20]
the_message = ['Enter the map center location of the plot']
para = get_n_field_value(2, i_value, xsize, title, f_title, the_message, base, info)
lat_loc = para(0)
if lat_loc eq 'cancel' then return

info.greenwich.lat_loc = float(lat_loc)
lon_loc = float(para(1))
if lon_loc lt 0.0 then lon_loc = lon_loc + 360.0
info.greenwich.greenloca = lon_loc

if(widget_info(info.widgets.base, /VALID_ID)) then $
        widget_control, set_uvalue=info, info.widgets.base
widget_control, set_uvalue=info, info.base

end

;--------------------------------------------------------------------------------
pro continent_thick, base, info

pro_name = 'continent_thick'
@getinfo

linethick = strcompress(string(info.greenwich.mlinethick), /REMOVE_ALL)
i_value = [linethick]
title = 'Get the thickness of the continents'
f_title = ['Thickness:']
xsize = [10]
the_message = ['Enter the new thickness of the boundary of continent', $
        'The default thickness is 1']
para = get_n_field_value(1, i_value, xsize, title, f_title, the_message, base, info)
linethick = para(0)
if linethick eq 'cancel' then return

info.greenwich.mlinethick = float(linethick)

if(widget_info(info.widgets.base, /VALID_ID)) then $
	widget_control, set_uvalue=info, info.widgets.base
widget_control, set_uvalue=info, info.base

end

;--------------------------------------------------------------------------------
; $Id: cw_form.pro,v 1.11 1998/01/15 18:41:37 scottm Exp $
;
; Copyright (c) 1995-1998, Research Systems, Inc.  All rights reserved.
;	Unauthorized reproduction prohibited.
;+
; NAME:
;	CW_FORM
;
; PURPOSE:
;	CW_FORM is a compound widget that simplifies creating
;	small forms which contain text, numeric fields, buttons, 
;	lists and droplists.  Event handling is also simplified.
;
; CATEGORY:
;	Compound widgets.
;
; CALLING SEQUENCE:
;	widget = CW_FORM([Parent,] Desc)
;
; INPUTS:
;       Parent:	The ID of the parent widget.  Omitted for a top level 
;		modal widget.

; Desc: A string array describing the form.  Each element of the
;	string array contains two or more comma-delimited fields.  The
;	character '\' may be used to escape commas that appear within fields.
;	To include the backslash character, escape it with a second
;	backslash.  Field names are case insensitive.
;
;	The fields are defined as follows:
;
; Field 1: Depth: the digit 0, 1, 2, or 3.  0 continues the current
;	level, 1 begins a new level, 2 denotes the last element of the
;	current level, and 3 both begins a new level and is the last entry of
;	the current level.  Nesting is used primarily with row or column 
;	bases for layout.  See the example below.
; Field 2: Item type: BASE, BUTTON, DROPLIST, FLOAT, INTEGER, LABEL, LIST,
;		or TEXT.
;	The items return the following value types:
;	BUTTON - For single buttons, 0 if clear, 1 if set.
;		For multiple buttons, also called button groups, that are
;		exclusive, the index of the currently set button is returned.
;		For non-exclusive button groups, the value is an array
;		with an element for each button, containing 1
;		if the button is set, 0 otherwise.
;	DROPLIST, LIST - a 0 based index indicating which item is selected.
;	FLOAT, INTEGER, TEXT - return their respective data type.
;
; Field 3: Initial value.  Omitted for bases.
;	For BUTTON and DROPLIST items, the value field contains one
;		or more item names, delimited by the | character.
;	For FLOAT, INTEGER, LABEL, and TEXT items the value field contains the
;		initial value of the field.
;
; Fields 4 and following: Keywords or Keyword=value pairs that specify
;	optional attributes or options.  Keywords are case insensitive
;	and an optional leading '/' character is discarded.
;	Possibilities include:
;
;	COLUMN	If present, specifies column layout for bases or multiple
;		buttons.
;	EXCLUSIVE  If present makes an exclusive set of buttons.  The
;		default is nonexclusive.
;	EVENT=<name> specifies the name of a user-written event function that
;		is called whenever the element is changed.  The function
;		is called with one parameter, the event structure.  It may
;		return an event structure or zero to indicate that no
;		further event processing is desired.
;	FONT=<font name>  If present, the font for the item is specified.
;	FRAME:	If present, a frame is drawn around the item.  May be used
;		with all items.
;	LABEL_LEFT=<label>  annotate a button or button group with a label
;		placed to the left of the buttons.  Valid with BUTTON,
;		DROPLIST, FLOAT, INTEGER, LIST and TEXT items.
;	LABEL_TOP=<label> annotate a button or button group with a label
;		placed at the top of the buttons.  Valid with BUTTON,
;		DROPLIST, FLOAT, INTEGER, LIST and TEXT items.
;	LEFT, CENTER, or RIGHT   Specifies alignment of label items.
;	QUIT	If present, when the user activiates this entry when it
;		is activated as a modal widget, the form is destroyed
;		and its value returned as the result of CW_FORM.  For non-
;		modal form widgets, events generated by changing this item
;		have their QUIT field set to 1.
;	ROW	If present, specifies row layout for bases or multiple
;		buttons.
;	SET_VALUE  Sets the initial value of button groups or droplists.
;	TAG=<name>   the tag name  of this element.  The widget's value
;		is a structure corresponding to the form.  Each form item
;		has a corresponding tag-value pair in the widget's value.
;		Default = TAGnnn, where nnn is the index of the item
;		in the Desc array.
;	WIDTH=n Specifies the width, in characters, of a TEXT, INTEGER,
;		or FLOAT item.
;	
; KEYWORD PARAMETERS:
;	COLUMN:		  If set the main orientation is vertical, otherwise
;			  horizontal.
;	IDS:		  A named variable into which the widget id of
;				each widget corresponding to an element
;				in desc is stored.
;	TITLE:		  The title of the top level base.  Not used
;			  if a parent widget is supplied.
;	UVALUE:		  The user value to be associated with the widget.
;
; OUTPUTS:
;       If Parent is supplied, the result is the ID of the base containing
;	the form.  If Parent is omitted, the form is realized as a modal
;	top level widget. The function result is then a structure containing
;	the value of each field in the form when the user finishes.
;
;	This widget has a value that is a structure with a tag/value pair
;	for each field in the form.  WIDGET_CONTROL, id, GET_VALUE=v may
;	be used to read the current value of the form.  WIDGET_CONTROL, id,
;	SET_VALUE={ Tagname: value, ..., Tagname: value} sets the values
;	of one or more tags.
;
; SIDE EFFECTS:
;	Widgets are created.
;
; RESTRICTIONS:
;	
; EXAMPLES:

;	**** Define a form, with a label, followed by two vertical button
;	groups one non-exclusive and the other exclusive, followed by a text
;	field, and an integer field, followed lastly by OK and Done buttons.
;	If either the OK or Done buttons are pressed, the form is exited.
;	
;
;		; String array describing the form
;	desc = [ $
;	    '0, LABEL, Centered Label, CENTER', $
;		; Define a row base on a new depth.  All elements until a depth
;		; of two are included in the row.
; 	    '1, BASE,, ROW, FRAME', $
; 	    '0, BUTTON, B1|B2|B3, LABEL_TOP=Nonexclusive:, COLUMN, TAG=bg1', $
;		; This element terminates the row.
; 	    '2, BUTTON, E1|E2|E2, EXCLUSIVE,LABEL_TOP=Exclusive,COLUMN,TAG=bg2', $
; 	    '0, TEXT, , LABEL_LEFT=Enter File name:, WIDTH=12, TAG=fname', $
;	    '0, INTEGER, 0, LABEL_LEFT=File size:, WIDTH=6, TAG=fsize', $
;	    '1, BASE,, ROW', $
;	    '0, BUTTON, OK, QUIT,FONT=*helvetica-medium-r-*-180-*,TAG=OK', $
;	    '2, BUTTON, Cancel, QUIT']
;
;    To use the form in a modal manner:
;	  a = CW_FORM(desc, /COLUMN)
;	  help, /st,a
;    When the form is exited, (when the user presses the OK or Cancel buttons), 
;	the following structure is returned as the function's value:
;		BG1             INT       Array(3)  (Set buttons = 1, else 0)
;		BG2             INT              1  (Exclusive: a single index)
;		FNAME           STRING    'test.dat' (text field)
;		FSIZE           LONG               120 (integer field)
;		OK              LONG                 1 (this button was pressed)
;		TAG8            LONG                 0 (this button wasn't)
;	Note that if the Cancel button is pressed, the widget is exited with
;	the OK field set to 0.
;
;  *****************
;
;    To use CW_FORM inside another widget:
;	    a = widget_base(title='Testing')
;	    b = cw_form(a, desc, /COLUMN)
;	    WIDGET_CONTROL, a, /real
;	    xmanager, 'Test', a
;	In this example, an event is generated each time the value of
;	the form is changed.  The event has the following structure:
;	   ID              LONG                <id of CW_FORM widget>
;	   TOP             LONG                <id of top-level widget>
;	   HANDLER         LONG                <internal use>
;	   TAG             STRING    'xxx'	; name of field that changed
;	   VALUE           INT       xxx	; new value of changed field
;	   QUIT            INT              0	; quit flag
;    The event handling procedure (in this example, called TEST_EVENT), may use
;	the TAG field of the event structure to determine which field
;	changed and perform any data validation or special actions required.
;	It can also get and set the value of the widget by calling
;	WIDGET_CONTROL.
;    A simple event procedure might be written to monitor the QUIT field
;	of events from the forms widget, and if set, read and save the
;	widget's value, and finally destroy the widget.
;
;    To set or change a field within the form from a program, use a the
;	WIDGET_CONTROL procedure:
;	   	WIDGET_CONTROL, b, SET_VALUE={FNAME: 'junk.dat'}
;	This statement sets the file name field of this example.
;
; MODIFICATION HISTORY:
;	January, 1995.  DMS, Written.
;       June, 1996.     MLR, allowed SET_VALUE to be specified in the
;                       description string for DROPLIST widgets.
;-
;


function CW_FORM_PARSE, Extra, Name, Value, Index=Index
; Given the extra fields in the string array Extra,
;	determine if one field starts with Name.
; If so, return TRUE, otherwise FALSE.
; If the field contains the character '=' after Name, return the contents
; of the field following the equal sign in Value.
; Return the index of the found element in Index.
;

found = where(strpos(extra, name) eq 0, count)
if count eq 0 then return, 0
if count gt 1 then message,'Ambiguous field name: '+name, /CONTINUE

index = found[0]
item = extra[index]
nlen = strlen(name)
value = ''			;Assume no value
equal = strpos(item,'=',nlen) ;Find = character
if equal ge 0 then value = strmid(item, equal+1, 1000) ;Extract following
extra[index]=''			;clean it out...
return, 1
end


pro CW_FORM_APPEND, extra, e, keyword, USE_VALUE=use_value, ACTUAL_KEYWORD=akw
if CW_FORM_PARSE(e, keyword, value) then begin
    if n_elements(akw) le 0 then akw = keyword
    if KEYWORD_SET(use_value) eq 0 then value = 1
    if n_elements(extra) eq 0 then extra = create_struct(akw, value) $
    else extra = create_struct(extra, akw, value)
endif
end



pro CW_FORM_LABEL, parent, nparent, e, frame
;Put LABEL_LEFT and/or LABEL_RIGHT on a base.

nparent = parent
if CW_FORM_PARSE(e, 'LABEL_LEFT', value) then begin
	nparent = WIDGET_BASE(nparent, /ROW, FRAME=frame)
	frame = 0
	if CW_FORM_PARSE(e, 'LABELFONT', font) then begin
		junk1 = WIDGET_LABEL(nparent, VALUE=value, FONT=font)
	endif else begin
		junk1 = WIDGET_LABEL(nparent, VALUE=value)
	endelse
	endif
if CW_FORM_PARSE(e, 'LABEL_TOP', value) then begin
	nparent = WIDGET_BASE(nparent, /COLUMN, FRAME=frame)
	frame = 0
	if CW_FORM_PARSE(e, 'LABELFONT', font) then begin
		junk1 = WIDGET_LABEL(nparent, VALUE=value, FONT=font)
	endif else begin
		junk1 = WIDGET_LABEL(nparent, VALUE=value)
	endelse
	endif
end



pro CW_FORM_BUILD, parent, desc, cur, ids, lasttag
; Recursive routine that builds the form hierarchy described in DESC.
; Returns the ID of each button in ids.

; Format of a field descriptor:
; Field 0,  Flags: 
; Field 1, Type of item.  BASE, LABEL, INTEGER, FLOAT, DROPLIST,
;	EXCLUSIVE_BUTTONS, TEXT
; Field 2, Value of item...
; Fields >= 3, optional flags
;
;
; Type id = 0 for bgroup, 1 for droplist, 2 for button,
;	3 for integer, 4 for float, 5 for text, 6 for list.
;
  n = n_elements(desc)

  while cur lt n do begin
    a = str_sep(desc[cur], ',', /TRIM, ESC='\')
    if n_elements(a) lt 2 then $
	message,'Form element '+strtrim(cur,2)+'is missing a field separator'
    extra=0			;Clear extra keywords by making it undefined
    junk = temporary(extra)	;Clear common param list
    type = -1			;Assume type == no events.
    quit = 0
    frame = 0
    if n_elements(a) gt 3 then begin	;Addt'l common params?
	e = a[3:*]		;Remove leading/trailing blanks
	for i=0, n_elements(e)-1 do begin  ;Up case it
	    s = e[i]
	    if strmid(s,0,1) eq '/' then s = strmid(s,1,1000)  ;Disc. leading /
	    equal = strpos(s, '=')
	    if equal gt 0 then $
		e[i] = strupcase(strmid(s,0,equal)) + strmid(s,equal, 1000) $
	    else e[i] = strupcase(s)
	    endfor 
	quit = CW_FORM_PARSE(e, 'QUIT')
	frame = CW_FORM_PARSE(e, 'FRAME')
	efn = CW_FORM_PARSE(e, 'EVENT', event_fun)
	CW_FORM_APPEND, extra, e, 'FONT', /USE_VALUE
	CW_FORM_APPEND, extra, e, 'FIELDFONT', /USE_VALUE
	CW_FORM_APPEND, extra, e, 'SPACE', /USE_VALUE
	CW_FORM_APPEND, extra, e, 'TITLE', /USE_VALUE
	CW_FORM_APPEND, extra, e, 'COLUMN'
	CW_FORM_APPEND, extra, e, 'ROW'
	CW_FORM_APPEND, extra, e, 'LEFT', ACTUAL='ALIGN_LEFT'
	CW_FORM_APPEND, extra, e, 'CENTER', ACTUAL='ALIGN_CENTER'
	CW_FORM_APPEND, extra, e, 'RIGHT', ACTUAL='ALIGN_RIGHT'
    endif else e = ''

    case STRUPCASE(a[1]) of		;Which widget type?
'BASE': BEGIN
    new = WIDGET_BASE(parent, FRAME=frame, _EXTRA=extra)
    ENDCASE
'BUTTON': BEGIN
    CW_FORM_APPEND, extra, e, 'LABEL_LEFT', /USE_VALUE
    CW_FORM_APPEND, extra, e, 'LABEL_TOP', /USE_VALUE
    CW_FORM_APPEND, extra, e, 'SET_VALUE', /USE_VALUE
    exclusive = CW_FORM_PARSE(e,'EXCLUSIVE')
    no_release = CW_FORM_PARSE(e,'NO_RELEASE')
    values = str_sep(a[2],'|', ESC='\')
    if n_elements(values) ge 2 then begin
        type = 0
        new = CW_BGROUP(parent, str_sep(a[2],'|'),  $
		        EXCLUSIVE = exclusive, NONEXCLUSIVE = 1-exclusive, $
		        FRAME=frame, NO_RELEASE = no_release, _EXTRA=extra)
        WIDGET_CONTROL, new, GET_VALUE=value
    endif else begin
        type = 2
	new = WIDGET_BUTTON(parent, value=values[0], FRAME=frame, _EXTRA=extra)
	value = 0L
    endelse
    uextra = { value: value }
    ENDCASE
'DROPLIST': BEGIN
    CW_FORM_LABEL, parent, nparent, e, frame
    new = WIDGET_DROPLIST(nparent, VALUE = str_sep(a[2], '|'), $
		FRAME=frame, UVALUE=ids[n], _EXTRA=extra)
    if CW_FORM_PARSE(e, 'SET_VALUE', value) then begin
	WIDGET_CONTROL, new, SET_DROPLIST_SELECT = value 
	value = long(value)
    endif else value = 0L
    uextra = { VALUE: value }
    ;uextra = { VALUE: 0L }
    type = 1
    ENDCASE
'INTEGER': BEGIN
    type = 3
    value = 0L
;process_integer:
    uextra = { VALUE: value }    
    CW_FORM_LABEL, parent, nparent, e, frame
    if CW_FORM_PARSE(e, 'WIDTH', temp) then width = fix(temp) else width=6
    new = CW_FIELD(nparent, /ALL_EVENTS, /LONG, YSIZE=1, $
		XSIZE=width, UVALUE=ids[n], _EXTRA=extra)
    if n_elements(a) ge 3 then BEGIN		;Save value
	WIDGET_CONTROL, new, SET_VALUE=a[2]
	uextra.value = a[2]
	endif
   ENDCASE
'FLOAT': BEGIN
    type = 4
    value = 0.0
    ;goto, process_integer
    uextra = { VALUE: value }
    CW_FORM_LABEL, parent, nparent, e, frame
    if CW_FORM_PARSE(e, 'WIDTH', temp) then width = fix(temp) else width=6
    new = CW_FIELD(nparent, /ALL_EVENTS, /FLOATING, YSIZE=1, $
		XSIZE=width, UVALUE=ids[n], _EXTRA=extra)
    if n_elements(a) ge 3 then BEGIN            ;Save value
	WIDGET_CONTROL, new, SET_VALUE=a[2]
	uextra.value = a[2]
	endif
    ENDCASE
'LABEL': BEGIN
    text_label = a[2]
    first_pos = strpos(text_label, '"')
    if first_pos eq 0 then begin
	last_pos = rstrpos(text_label, '"')
	length = strlen(text_label)
	if last_pos eq length-1 then $
	    text_label = strmid(text_label, 1, length-2)
    endif
    new = WIDGET_LABEL(parent, value=text_label, FRAME=frame, _EXTRA=extra)
    ;new = WIDGET_LABEL(parent, value=a[2], FRAME=frame, _EXTRA=extra)
    ENDCASE
'LIST': BEGIN
    CW_FORM_LABEL, parent, nparent, e, frame
    v = str_sep(a[2], '|')
    if CW_FORM_PARSE(e, 'HEIGHT', temp) eq 0 then temp = n_elements(v)
    new = WIDGET_LIST(nparent, VALUE = v, YSIZE=temp, $
		FRAME=frame, UVALUE=ids[n], _EXTRA=extra)
    v = 0
    uextra = { VALUE: 0L }
    type = 6
    ENDCASE
'TEXT': BEGIN
    type=5
    value = ''
    ;goto, process_integer
    uextra = { VALUE: value }
    CW_FORM_LABEL, parent, nparent, e, frame
    if CW_FORM_PARSE(e, 'WIDTH', temp) then width = fix(temp) else width=6
    new = WIDGET_TEXT(nparent, /ALL_EVENTS, /EDITABLE, YSIZE=1, $
		XSIZE=width, UVALUE=ids[n], _EXTRA=extra)
    if n_elements(a) ge 3 then BEGIN            ;Save value
	WIDGET_CONTROL, new, SET_VALUE=a[2]
	uextra.value = a[2]
	endif
    ENDCASE
else: BEGIN
	MESSAGE,'Illegal form element type: ' + a[1], /CONTINUE
	new = WIDGET_BASE(parent)
    ENDCASE
ENDCASE

    ids[cur] = new
    if type ge 0 then begin
	if CW_FORM_PARSE(e, 'TAG', value) then value = STRUPCASE(value) $
	else value='TAG'+strtrim(cur,2)	  ;default name = TAGnnn.
        u = CREATE_STRUCT( $
		{ type: type, base: ids[n+1], tag:value, next: 0L, quit:quit}, $
		uextra)
	widget_control, new, SET_UVALUE= u
		;First tag?  If so, set child uvalue -> important widget ids.
	if lasttag eq 0 then begin
	    WIDGET_CONTROL, ids[n], GET_UVALUE=tmp, /NO_COPY
	    tmp.head = new
	    WIDGET_CONTROL, ids[n], SET_UVALUE=tmp, /NO_COPY
	endif else begin		;Otherwise, update chain.
	    WIDGET_CONTROL, lasttag, GET_UVALUE=u, /NO_COPY
	    u.next = new
	    WIDGET_CONTROL, lasttag, SET_UVALUE=u, /NO_COPY
	    endelse
	lasttag = new
	if (N_ELEMENTS(efn) NE 0) AND (N_ELEMENTS(event_fun) NE 0) then $
           WIDGET_CONTROL, new, EVENT_FUNC = event_fun
	junk = CW_FORM_PARSE(e, 'LABELFONT', junkfont)  ; get rid of labelfont field
	endif			;Type

    i = where(strlen(e) gt 0, count)
    if count gt 0 then begin	;Unrecognized fields?
	Message, /CONTINUE, 'Descriptor: '+ desc[cur]
	for j=0, count-1 do message, /CONTINUE, 'Unrecognized field: '+ e[i[j]]
	endif

    cur = cur + 1
    dflags = fix(a[0])		;Level flags
    if dflags and 1 then CW_FORM_BUILD, new, desc, cur, ids, lasttag  ;Begin new
    if (dflags and 2) ne 0 then return	;End current
  endwhile
end				;CW_FORM_BUILD



Function CW_FORM_EVENT, ev		;Event handler for CW_FORM
widget_control,   ev.id, GET_UVALUE=u, /NO_COPY  ;What kind of widget?

if (u.type eq 1) or (u.type eq 6) then begin	;Droplist?  (can't get value)
    v = ev.index
    u.value = v
endif else if u.type eq 2 then begin
    v = ev.select
    u.value=v
endif else begin		;Other types of widgets
    WIDGET_CONTROL, ev.id, GET_VALUE=v
    if u.type ge 3 then begin  ;Toss selection events from text widgets
	v = v[0]
        ret = 0
	;if ev.type eq 3 then goto, toss
	endif
    on_ioerror, invalid
    u.value = v			;Does an implicit conversion
    v = u.value
    goto, back_in

; We come here if we get an invalid number.  
invalid: WIDGET_CONTROL, ev.id, SET_VALUE=''  ;Blank it out
    v = ''
    u.value = ''
endelse			;u.type

back_in: ret= { id: u.base, top: ev.top, handler: 0L, $
		tag: u.tag, value: v, quit: u.quit} ;Our value
toss: widget_control, ev.id, SET_UVALUE=u, /NO_COPY	;Save new value...
return, ret
end			;CW_FORM_EVENT


Pro CW_FORM_SETV, id, value	;In this case, value = { Tagname : value, ... }
x = WIDGET_INFO(id, /CHILD)	;Get head of list
WIDGET_CONTROL, x, GET_UVALUE=u
head = u.head
tags = tag_names(value)
n = n_elements(tags)

while head ne 0 do begin
    WIDGET_CONTROL, head, GET_UVALUE=u, /NO_COPY
    w = where(u.tag eq tags, count)
    if count ne 0 then begin
	u.value = value.(w[0])	;Set the value
	if u.type eq 6 then $
          WIDGET_CONTROL, head, SET_LIST_SELECT=value.(w[0]) $
        else if u.type eq 1 then $
          WIDGET_CONTROL, head, SET_DROPLIST_SELECT = value.(w[0]) $
	else if u.type ne 2 then $
          WIDGET_CONTROL, head, SET_VALUE=value.(w[0]) ;Change the widget
	n = n - 1
	endif
    next = u.next
    WIDGET_CONTROL, head, SET_UVALUE=u, /NO_COPY
    if n le 0 then return		;Done...
    head = next
endwhile
end


Function CW_FORM_GETV, id	;Return value of a CW_FORM widget.

x = WIDGET_INFO(id, /CHILD)	;Get head of list
WIDGET_CONTROL, x, GET_UVALUE=u
head = u.head

while head ne 0 do begin
    WIDGET_CONTROL, head, GET_UVALUE=u, /NO_COPY
    if n_elements(ret) le 0 then ret = CREATE_STRUCT(u.tag, u.value) $
    else ret = CREATE_STRUCT(ret, u.tag, u.value)
    next = u.next
    WIDGET_CONTROL, head, SET_UVALUE=u, /NO_COPY
    head = next
endwhile
return, ret
end


pro cw_form_modal_event, ev
if ev.quit ne 0 then begin
    child = WIDGET_INFO(ev.id, /CHILD)
    WIDGET_CONTROL, child, GET_UVALUE=u  ;Get handle
    WIDGET_CONTROL, ev.id, GET_VALUE=v  ;The widget's value
    WIDGET_CONTROL, ev.top, /DESTROY
    *u.handle = v
    endif
end

FUNCTION CW_FORM, parent, desc, $
	COLUMN = column, IDS=ids, TITLE=title, UVALUE=uvalue

;  ON_ERROR, 2						;return to caller
  ; Set default values for the keywords
  If KEYWORD_SET(column) then row = 0 else begin row = 1 & column = 0 & end

  p = parent
  handle = 0L
  if n_params() eq 1 then begin
	desc = parent
	if n_elements(title) le 0 then title='FORM Widget'
        temp = WIDGET_BASE()
	p = WIDGET_BASE(TITLE=title, Column = column, row=row, $
                        GROUP_LEADER=temp, /MODAL)
	handle = PTR_NEW(/ALLOCATE_HEAP)
  endif
  Base = WIDGET_BASE(p, Column = column, row=Row)

  if n_elements(uvalue) gt 0 then WIDGET_CONTROL, base, SET_UVALUE=uvalue
  n = n_elements(desc)
  ids = lonarr(n+2)		;Element n is ^ to child, n+1 ^ to base
  child = WIDGET_BASE(base)	;Widget to contain info...
  ids[n] = child
  ids[n+1] = base
  lasttag = 0
  WIDGET_CONTROL, child, SET_UVALUE={ head: 0L, base: base, handle: handle}

  CW_FORM_BUILD, base, desc, 0, ids, lasttag
  widget_control, base, EVENT_FUNC='CW_FORM_EVENT', $
	FUNC_GET_VALUE='CW_FORM_GETV', PRO_SET_VALUE='CW_FORM_SETV'

  if n_params() eq 1 then begin		;Modal?
	WIDGET_CONTROL, p, /realize
	XMANAGER, 'CW_FORM', p, EVENT_HANDLER='CW_FORM_MODAL_EVENT'
        v = TEMPORARY(*handle)
	PTR_FREE, handle
        WIDGET_CONTROL, temp, /DESTROY
	return, v
	endif
  return, base
END

;--------------------------------------------------------------------------------
pro mapsetting_event, event

pro_name = 'mapsetting_event'
@getinfo

widget_control, get_value=v, event.id

if v.cancel eq 1 then begin
    widget_control, /destroy, event.top
    return
endif

if v.done eq 1 then begin
    widget_control, get_uvalue=info, event.top
    info.greenwich.lat_loc = v.lat
    info.greenwich.greenloca = v.long
    info.greenwich.projection = v.proj
    if v.latlong ne info.greenwich.default then begin
	info.geolocated.flag = 0
	info.geolocated.selected = 0
    endif
    info.greenwich.default = v.latlong
    info.greenwich.label = v.label
    info.greenwich.whole = v.whole
    info.greenwich.expand = v.expand
    info.greenwich.satellite = v.sate
    info.greenwich.sun = v.sun
    info.greenwich.continents = v.continent
    info.greenwich.mlinethick = v.thick
    info.greenwich.high_resol = v.hires
    info.greenwich.coasts = v.coasts
    info.greenwich.grid = v.grid
    info.greenwich.glinethick = v.gthick
    info.greenwich.smooth = v.contour
    info.greenwich.n_x_grid = v.xgrid
    info.greenwich.n_y_grid = v.ygrid
    info.greenwich.noborder = v.noborder
    info.greenwich.contour = v.contype
    info.greenwich.altitude = v.altitude/6371.0 + 1.0
    info.greenwich.rotation = v.rotation
    info.greenwich.tilt = v.tilt
    if v.read eq 1 then begin
	info.geolocated.flag = 0
	info.geolocated.selected = 0
    endif
    
    if(widget_info(info.widgets.base, /VALID_ID)) then $
        widget_control, set_uvalue=info, info.widgets.base
    widget_control, set_uvalue=info, info.base

    widget_control, event.top, /destroy

endif

end

;--------------------------------------------------------------------------------
pro map_setting, top_base, info

pro_name = 'map_setting'
@getinfo

widget_control, /hourglass

lat_loc = strcompress(string(info.greenwich.lat_loc), /REMOVE_ALL)
lon_loc = strcompress(string(info.greenwich.greenloca), /REMOVE_ALL)
which_proj = strcompress(string(info.greenwich.projection), /REMOVE_ALL)
def_latlong = strcompress(string(info.greenwich.default), /REMOVE_ALL)
with_label = strcompress(string(info.greenwich.label), /REMOVE_ALL)
whole_map = strcompress(string(info.greenwich.whole), /REMOVE_ALL)
with_expand = strcompress(string(info.greenwich.expand), /REMOVE_ALL)
show_sate = strcompress(string(info.greenwich.satellite), /REMOVE_ALL)
show_sun = strcompress(string(info.greenwich.sun), /REMOVE_ALL)
redraw_cont = strcompress(string(info.greenwich.continents), /REMOVE_ALL)
thickness = strcompress(string(info.greenwich.mlinethick), /REMOVE_ALL)
highresol = strcompress(string(info.greenwich.high_resol), /REMOVE_ALL)
withcoasts = strcompress(string(info.greenwich.coasts), /REMOVE_ALL)
display_grid = strcompress(string(info.greenwich.grid), /REMOVE_ALL)
gthickness = strcompress(string(info.greenwich.glinethick), /REMOVE_ALL)
cont_smooth = strcompress(string(info.greenwich.smooth), /REMOVE_ALL)
x_grid = strcompress(string(info.greenwich.n_x_grid), /REMOVE_ALL)
y_grid = strcompress(string(info.greenwich.n_y_grid), /REMOVE_ALL)
noborder = strcompress(string(info.greenwich.noborder), /REMOVE_ALL)
contour = strcompress(string(info.greenwich.contour), /REMOVE_ALL)
altitude = strcompress(string((info.greenwich.altitude-1.0)*6371.0), /REMOVE_ALL)
rotation = strcompress(string(info.greenwich.rotation), /REMOVE_ALL)
tilt = strcompress(string(info.greenwich.tilt), /REMOVE_ALL)

desc = [ $
	'0, label, Map Setting, center, font='+info.font, $
	'0, label, "   ", center, font=' + info.font, $
	'1, base, , column, frame', $
	'0, label, Map Center Location And Projection, center, font='+info.font, $
	'1, base, , row, space=20', $
	'0, float, '+lat_loc+', title=Latitude:, width=12, tag=lat, ' $
	    + 'font='+info.font+', fieldfont='+info.font+', labelfont='+info.font, $
	'0, float, ' + lon_loc+', title=Longitude:, width=12, tag=long, ' $
	    + 'font='+info.font+', fieldfont='+info.font+', labelfont='+info.font, $
	'2, droplist, Cylindrical|Orthographic|Stereographic|Hammer-Aitoff|Satellite, ' $
	    + 'label_left=Projection:, set_value='+which_proj+', tag=proj, ' $
	    + 'font='+info.font+', labelfont='+info.font, $
	'2, label,   , center, font='+info.font, $
	'1, base, , row, space=30', $
	'0, droplist, Manual|Auto, label_left=Lat-Longitude Select:, set_value='+def_latlong $
	    + ', tag=latlong, font='+info.font+', labelfont='+info.font, $
	'2, droplist, No|Yes, label_left=Expand Lat-Long Array:, ' $
	    + 'set_value='+with_expand+', tag=expand, font='+info.font+', labelfont='+info.font, $
	'1, base, , row, space=30', $
	'0, droplist, No|Yes, label_left=Label Meridians:, set_value='+with_label $
	    + ', tag=label, font='+info.font+', labelfont='+info.font, $
	'0, droplist, No|Yes, label_left=Reread Geolocated Data:, tag=read, font='+info.font $
	    + ', labelfont='+info.font, $
	'2, droplist, No|Yes, label_left=Draw Whole Map:, set_value='+whole_map $
	    + ', tag=whole, font='+info.font + ', labelfont='+info.font, $
	'1, base, , row, space=30', $
	'0, droplist, No|Yes, label_left=Show Satellite:, set_value='+show_sate $
	    + ', tag=sate, font='+info.font+', labelfont='+info.font, $
	'0, droplist, No|Yes, label_left=Show Sun:, set_value='+show_sun+', tag=sun, ' $
	    + 'font='+info.font+', labelfont='+info.font, $
	'2, droplist, Yes|No, label_left=Show Border:, set_value='+noborder+', tag=noborder, ' $
	    + 'font='+info.font+', labelfont='+info.font, $
	'1, base, , row, space=30', $
	'0, droplist, No|Yes, label_left=Redraw Continents:, set_value='+redraw_cont $
	    + ', tag=continent, font='+info.font+', labelfont='+info.font, $
	'2, float, '+thickness+', title=Continents Thickness:, width=10, tag=thick, ' $
	    + 'font='+info.font+', fieldfont='+info.font+', labelfont='+info.font, $
	'1, base, , row, space=30', $
	'0, droplist, No|Yes, label_left=Use High Resolution Map:, set_value='+highresol $
	    + ', tag=hires, font='+info.font+', labelfont='+info.font, $
	'2, droplist, No|Yes, label_left=Draw Islands:, set_value='+withcoasts $
	    + ', tag=coasts, font='+info.font+', labelfont='+info.font, $
	'1, base, , row, space=30', $
	'0, droplist, No|Yes, label_left=Display Grid lines:, set_value='+display_grid $
	    + ', tag=grid, font='+info.font+', labelfont='+info.font, $
	'0, float, '+gthickness+', title=Grid Thickness:, width=10, tag=gthick, ' $
	    + 'font='+info.font+', fieldfont='+info.font+', labelfont='+info.font, $
	'2, droplist, Contour|Image, label_left=Contour Type:, set_value='+contour $
	    + ', tag=contype, font='+info.font+', labelfont='+info.font, $
	'1, base, , column, frame', $
	'0, label, Parameters For Satellite Projection, center, font='+info.font, $
	'1, base, , row, space=20', $
	'0, float, '+altitude+', title=Altitude(km):, width=12, tag=altitude, ' $
            + 'font='+info.font+', fieldfont='+info.font+', labelfont='+info.font, $
	'0, float, '+rotation+', title=Rotation:, width=12, tag=rotation, font='+info.font $
	    +', fieldfont='+info.font+ ', labelfont='+info.font, $
	'2, float, '+tilt+', title=Downward Tilt:, width=12, tag=tilt, font='+info.font $
	    +', fieldfont='+info.font+ ', labelfont='+info.font, $
	'2, label,   , center, font='+info.font, $
	'1, base, , column, frame', $
	'0, label, Number of Grids for Contour Geolocated, center, font='+info.font, $
	'1, base, , row, space=20', $
	'0, integer, '+x_grid+', title=X Grids:, width=12, tag=xgrid, font='+info.font $
	    +', fieldfont='+info.font+ ', labelfont='+info.font, $
	'0, integer, '+y_grid+', title=Y Grids:, width=12, tag=ygrid, font='+info.font $
	    +', fieldfont='+info.font+ ', labelfont='+info.font, $
	'2, droplist, Without Smoothing|With Smoothing|Filter Without Smoothing|' $
	    + 'Filter With Smoothing|Average Without Smoothing|Average With Smoothing,' $
	    + ' label_left=Smoothing:, set_value='+cont_smooth+', tag=contour, ' $
	    + 'font='+info.font+', labelfont='+info.font, $
	'2, label,   , center, font='+info.font, $
	'0, label, "   ", center, font='+info.font, $
	'1, base, , row, space=60, center', $
	'0, button, Done, QUIT, tag=done, font='+info.font, $
	'2, button, Cancel, QUIT, tag=cancel, font='+info.font]
	
base_loc = widget_info(top_base, /geometry)
xoffset = base_loc.xoffset + 100
yoffset = base_loc.yoffset + 50
base=widget_base(group_leader=top_base, /modal, row=1, map=1, xoffset=xoffset, $
    yoffset=yoffset, TITLE='Change Map Setting')
formid = cw_form(base, desc, /column)
widget_control, base, /realize
widget_control, set_uvalue=info, base

xmanager, 'mapsetting', base

end

;--------------------------------------------------------------------------------
pro stylesetting_event, event

pro_name = 'stylesetting_event'
@getinfo

if TAG_NAMES(event,/structure_name) eq 'CW_COLOR_INDEX' then begin
    widget_control, get_uvalue=info, event.top
    info.style.colorindex=event.value
    widget_control, set_uvalue=info, event.top
    return
end

widget_control, get_value=v, event.id
widget_control, get_uvalue=fieldid, event.id

if v.cancel eq 1 then begin
    widget_control, /destroy, event.top
    return
endif

if event.tag eq 'SYMBOL' then begin
    if event.value gt 0 then begin
	widget_control, fieldid(6), sensitive = 1
	if v.with gt 0 then $
	    widget_control, fieldid(2), sensitive = 1 $
	    else widget_control, fieldid(2), sensitive = 0
    endif else begin
	widget_control, fieldid(2), sensitive = 1
	widget_control, fieldid(6), sensitive = 0
    endelse
endif

if event.tag eq 'WITH' then begin
    if event.value gt 0 then $
	widget_control, fieldid(2), sensitive = 1 $
        else widget_control, fieldid(2), sensitive = 0
endif

if v.done eq 1 then begin
    widget_control, get_uvalue=info, event.top
    info.style.linetype = v.line
    info.style.linethick = v.thick
    info.style.symbol = v.symbol
    info.style.symbolline = v.with
    info.style.symbolsize = v.size

    if info.style.symbol gt 7 then begin
	info.style.symbol = 8
	info.style.usersym = v.symbol - 7
	set_user_symbol, info.style.usersym
    endif
    
    if(widget_info(info.widgets.base, /VALID_ID)) then $
        widget_control, set_uvalue=info, info.widgets.base
    widget_control, set_uvalue=info, info.base

    widget_control, event.top, /destroy

endif

end

;--------------------------------------------------------------------------------
pro style_setting, top_base, info

pro_name = 'style_setting'
@getinfo

widget_control, /hourglass

old_window_id = !d.window

line_type = strcompress(string(info.style.linetype), /REMOVE_ALL)
if info.style.symbol gt 7 then begin
   symbol_num = info.style.symbol + info.style.usersym - 1
endif else symbol_num = info.style.symbol
sym_type = strcompress(string(symbol_num), /REMOVE_ALL)
with_line = strcompress(string(info.style.symbolline), /REMOVE_ALL)
sym_size = strcompress(string(info.style.symbolsize), /REMOVE_ALL)
thickness = strcompress(string(info.style.linethick), /REMOVE_ALL)

desc = [ $
	'0, label, Line and Symbol Style Setting, center, font='+info.font, $
	'0, label, "   ", center, font=' + info.font, $
	'1, base, , column', $
	'0, droplist, Solid|Dotted|Dashed|Dashed Dot|Dashed Dot Dot Dot|Long Dashes, ' $
	    + 'label_left=Line Type:, set_value='+line_type+', tag=line, ' $
	    + 'font='+info.font+', labelfont='+info.font, $
	'2, float, '+thickness+', title=Line Thickness:, width=10, tag=thick, ' $
	    + 'font='+info.font+', fieldfont='+info.font+', labelfont='+info.font, $
	'0, droplist, No Symbol|Plus sign|Asterisk|Period|Diamond|Triangle|' $
	    + 'Square|X|Circle|FOV|Filled Triangle|Filled Square|Filled Circle|' $
	    + 'Filled FOV, label_left=Symbol Type:, set_value='+sym_type $
	    + ', tag=symbol, font='+info.font+', labelfont='+info.font, $
	'1, base, , column, frame', $
	'0, droplist, No|Yes, label_left=Symbol With Line:, set_value='+with_line $
	    + ', tag=with, font='+info.font+', labelfont='+info.font, $
	'2, float, '+sym_size+', title=Symbol Size:, width=10, tag=size, ' $
	    + 'font='+info.font+', fieldfont='+info.font+', labelfont='+info.font, $
	'0, label, "   ", center, font='+info.font, $
	'1, base, , row, space=60, center', $
	'0, button, Done, QUIT, tag=done, font='+info.font, $
	'2, button, Cancel, QUIT, tag=cancel, font='+info.font]
	
base_loc = widget_info(top_base, /geometry)
xoffset = base_loc.xoffset + 100
yoffset = base_loc.yoffset + 100
base=widget_base(group_leader=top_base, /modal, column=1, map=1, xoffset=xoffset, $
    yoffset=yoffset, TITLE='Change Style Setting')
formid = cw_form(base, desc, /column, ids=fieldid)

if !d.n_colors gt 192 then bar_size = !d.n_colors else bar_size = 192
if !d.n_colors gt 256 then begin
    bar_size = 256
    color_values =indgen(bar_size)
    if info.style.colorindex gt 255 then info.style.colorindex = 255
endif else color_values =indgen(!d.n_colors)
if info.version lt 5.39 then begin
    clr_index = cw_clr_index(base, color_values=color_values, label='Color: ', $
	xsize=bar_size, uvalue='color')
endif else begin
    clr_index = cw_clr_index(base, color_values=color_values, label='Color: ', $
	xsize=bar_size, value=info.style.colorindex, uvalue='color')
endelse

widget_control, base, /realize
widget_control, set_uvalue=info, base
widget_control, set_uvalue=fieldid, formid

if info.version lt 5.39 then initial_cw_clr_index, clr_index, info.style.colorindex

editable_cw_clr_index, clr_index

if symbol_num gt 0 then begin
	widget_control, fieldid(6), sensitive = 1
	if info.style.symbolline gt 0 then $
	    widget_control, fieldid(2), sensitive = 1 $
	    else widget_control, fieldid(2), sensitive = 0
endif else begin
	widget_control, fieldid(6), sensitive = 0
endelse

xmanager, 'stylesetting', base

wset, old_window_id

end

;--------------------------------------------------------------------------------
function check_font, fontname, fonttype

pro_name = 'check_font'
@getinfo1

;  If the fonttype is -1, return 1
if fonttype eq -1 then return, 1

;  Get all the font names available
;  use pixmap to avoid a window pop up
window, /pixmap
; if fonttype eq 0, get the hardware font
if fonttype eq 0 then begin
    device,get_fontnames=afont,set_font='*'
endif else begin
    ;  otherwise to get true_type font
    device,get_fontnames=afont,set_font='*',/tt_font
endelse
wdelete

if strlen(afont[0]) eq 0 then begin
    ;  If there is not font available, return 0 for false
    return, 0
endif

;  if it is 'X' and fonttype eq 0 (hardware font), check the fontname is one of available
if !D.Name eq 'X' and fonttype eq 0 then begin
    loc = where(afont eq fontname, count)
    ;print,'fontnames = ',fontnames
    ; If not found return 0 otherwise return 1
    if count eq 0 then return, 0 else return, 1
endif

;  if it is true-type outline font, check the fontname is one of available
if fonttype eq 1 then begin
    loc = where(afont eq fontname, count)
    ;print,'fontnames = ',fontnames
    ; If not found return 0 otherwise return 1
    if count eq 0 then return, 0 else return, 1
endif

;  Now check if it is 'WIN' and fonttype eq 0 (hardware font)
if !D.Name eq 'WIN' and fonttype eq 0 then begin
    ;  Set the value, the fontname is separated with "*" in WIN
    font_name = strsplit(fontname, '*' , /EXTRACT)
    num_modify = n_elements(font_name)
    if num_modify gt 0 then begin
	;  The first one is the name of the font
	loc = where(afont eq font_name[0], count)
	;  If not found return 0 otherwise return 1
	if count eq 0 then return, 0 else return, 1
    endif else return, 0
endif

end

;--------------------------------------------------------------------------------
function gethardwarefont, flag, top_base, info

pro_name = 'gethardwarefont'
@getinfoa

; define the structure that returns to calling function
fonttype = {NAME: '', SIZE: info.char.fontsize, SPACE: info.char.spacesize}

;  Get all the font names available
;  use pixmap to avoid a window pop up
window, /pixmap
; if flag eq 0, get the hardware font
if flag eq 0 then begin
    device,get_fontnames=afont,set_font='*'
endif else begin
    ;  otherwise to get true_type font
    device,get_fontnames=afont,set_font='*',/tt_font
endelse
wdelete

if strlen(afont[0]) eq 0 then begin
    if flag eq 0 then begin
	message = "There is no available hardware font."
    endif else begin
	message = "There is no available true_type font."
    endelse
    result=dialog_message( message, title='View HDF Warning!')
    return, fonttype
endif

;  Put all the fontname in a string
num_font = n_elements(afont)
fontnames = strtrim(afont[0])
for i = 1L, num_font-1 do begin
    current_font = strtrim(afont[i])
    fontnames = fontnames+'|'+current_font
endfor

;  Find the old fontname
loc = where(afont eq info.char.fontname, count)
;print,'fontnames = ',fontnames
if count eq 0 then fontloc = 0 else fontloc = loc[0]

fontloc = strcompress(string(fontloc), /REMOVE_ALL)
fontsize = strcompress(string(info.char.fontsize), /REMOVE_ALL)
spacesize = strcompress(string(info.char.spacesize), /REMOVE_ALL)

;  Display on a window let use to select the font

if info.device eq 'WIN' and flag eq 0 then begin
    ;  Initialize all the value to 0
    weightloc = 0
    qualityloc = 0
    pitchloc = 0
    angleloc = 0
    strikloc = 0
    underloc = 0
    ;  Set the value, the fontname is separated with "*" in WIN
    font_name = strsplit(info.char.fontname, '*' , /EXTRACT)
    num_modify = n_elements(font_name)
    ;  If more than one elements than start to find the modifies
    ;  If there is only one element, the name should be found from the above
    if num_modify gt 1 then begin
	;  The first one is the name of the font
	loc = where(afont eq font_name[0], count)
	;  If find the name, then continue
	if count gt 0 then begin
	    fontloc = loc[0]
	    fontloc = strcompress(string(fontloc), /REMOVE_ALL)

	    ;  convert the fontname to lowcase for searching
	    temp_name =strlowcase(info.char.fontname)
	    ;  First check the weight
	    the_list = ['thin','light','bold','heavy']
	    num_list = n_elements(the_list)
	    the_index = -1
	    i = 0
	    while (the_index eq -1 and i lt num_list) do begin
		check_name = the_list[i]
		the_index = strpos(temp_name, check_name)
		i = i + 1
	    endwhile
	    if the_index ne -1 then weightloc = i

	    ;  Check the quality
	    the_index = strpos(temp_name, 'draft')
	    if the_index ne -1 then begin
		qualityloc = 1
	    endif else begin
		the_index = strpos(temp_name, 'proof')
		if the_index ne -1 then qualityloc = 2
	    endelse

	    ;  Check the pitch
	    the_index = strpos(temp_name, 'fixed')
	    if the_index ne -1 then begin
		pitchloc = 1
	    endif else begin
		the_index = strpos(temp_name, 'variable')
		if the_index ne -1 then pitchloc = 2
	    endelse

	    ;  Check the angle
	    the_index = strpos(temp_name, 'italic')
	    if the_index ne -1 then angleloc = 1


	    ;  Check the strikout
	    the_index = strpos(temp_name, 'strikeout')
	    if the_index ne -1 then strikloc = 1

	    ;  Check the underline
	    the_index = strpos(temp_name, 'underline')
	    if the_index ne -1 then underloc = 1
	endif
    endif
    weightloc = strcompress(string(weightloc), /REMOVE_ALL)
    qualityloc = strcompress(string(qualityloc), /REMOVE_ALL)
    pitchloc = strcompress(string(pitchloc), /REMOVE_ALL)
    angleloc = strcompress(string(angleloc), /REMOVE_ALL)
    strikloc = strcompress(string(strikloc), /REMOVE_ALL)
    underloc = strcompress(string(underloc), /REMOVE_ALL)
    desc = [ $
	'0, label, Select Font Type and Size, center, font='+info.font, $
	'0, label, "   ", center, font=' + info.font, $
	'1, base, ,column, frame', $
	'0, label, Select the Font Type, left, font='+info.font, $
	'0, droplist,'+fontnames+', label_left=Font Type:, set_value='+fontloc $
	    +', tag=font, font='+info.font+', labelfont='+info.font, $
	'2, label, "   ", center, font=' + info.font, $
	'1, base, ,column, frame', $
	'0, label, Font Modifiers, center, font='+info.font, $
	'0, droplist, Default|Thin|Light|Bold|Heavy, label_left=Weight:, set_value='+weightloc $
	    +', tag=weight, font='+info.font+', labelfont='+info.font, $
	'0, droplist, Default|Draft|Proof, label_left=Quality:, set_value='+qualityloc $
	    +', tag=quality, font='+info.font+', labelfont='+info.font, $
	'0, droplist, Default|Fixed|Variable, label_left=Pitch:, set_value='+pitchloc $
	    +', tag=pitch, font='+info.font+', labelfont='+info.font, $
	'0, droplist, No|Yes, label_left=Angle:, set_value='+angleloc $
	    +', tag=angle, font='+info.font+', labelfont='+info.font, $
	'0, droplist, No|Yes, label_left=Strikeout:, set_value='+strikloc $
	    +', tag=strikeout, font='+info.font+', labelfont='+info.font, $
	'0, droplist, No|Yes, label_left=Underline:, set_value='+underloc $
	    +', tag=underline, font='+info.font+', labelfont='+info.font, $
	'2, label, "   ", center, font=' + info.font, $
	'1, base, ,column, frame', $
	'0, label, Font size in pixel, center, font='+info.font, $
        '0, integer, '+fontsize+', title=Font Size:, width=10, tag=fontsize, ' $
            + 'font='+info.font+', fieldfont='+info.font+', labelfont='+info.font, $
        '2, label, "   ", center, font=' + info.font, $
	'1, base, ,column, frame', $
	'0, label, Leading space size in pixel, center, font='+info.font, $
	'0, integer, '+spacesize+', title=Leading Space Size:, width=10, tag=spacesize, ' $
	    + 'font='+info.font+', fieldfont='+info.font+', labelfont='+info.font, $
	'2, label, "   ", center, font=' + info.font, $
	'1, base, , row, space=60, center', $
	'0, button, Done, QUIT, tag=done, font='+info.font, $
	'2, button, Cancel, QUIT, tag=cancel, font='+info.font]
endif else if info.device eq 'MAC' and flag eq 0 then begin
    ;  Initialize all the value to 0
    weightloc = 0
    angleloc = 0
    widthloc = 0
    outloc = 0
    underloc = 0
    ;  Set the value, the fontname is separated with "*" in WIN
    font_name = strsplit(info.char.fontname, '*' , /EXTRACT)
    num_modify = n_elements(font_name)
    ;  If more than one elements than start to find the modifies
    ;  If there is only one element, the name should be found from the above
    if num_modify gt 1 then begin
	;  The first one is the name of the font
	loc = where(afont eq font_name[0], count)
	;  If find the name, then continue
	if count gt 0 then begin
	    fontloc = loc[0]
	    fontloc = strcompress(string(fontloc), /REMOVE_ALL)

	    ;  convert the fontname to lowcase for searching
	    temp_name =strlowcase(info.char.fontname)
	    ;  First check the weight
	    the_index = strpos(temp_name, 'bold')
	    if the_index ne -1 then weightloc = 1

	    ;  Check the angle
	    the_index = strpos(temp_name, 'italic')
	    if the_index ne -1 then angleloc = 1

	    ;  Check the width
	    the_index = strpos(temp_name, 'condensed')
	    if the_index ne -1 then begin
		widthloc = 1
	    endif else begin
		the_index = strpos(temp_name, 'extended')
		if the_index ne -1 then widthloc = 2
	    endelse

	    ;  Check the outline
	    the_index = strpos(temp_name, 'outline')
	    if the_index ne -1 then begin
		outloc = 1
	    endif else begin
		the_index = strpos(temp_name, 'shadow')
		if the_index ne -1 then outloc = 2
	    endelse

	    ;  Check the underline
	    the_index = strpos(temp_name, 'underline')
	    if the_index ne -1 then underloc = 1
	endif
    endif
    weightloc = strcompress(string(weightloc), /REMOVE_ALL)
    angleloc = strcompress(string(angleloc), /REMOVE_ALL)
    widthloc = strcompress(string(widthloc), /REMOVE_ALL)
    outloc = strcompress(string(outloc), /REMOVE_ALL)
    underloc = strcompress(string(underloc), /REMOVE_ALL)
    desc = [ $
	'0, label, Select Font Type and Size, center, font='+info.font, $
	'0, label, "   ", center, font=' + info.font, $
	'1, base, ,column, frame', $
	'0, label, Select the Font Type, left, font='+info.font, $
	'0, droplist,'+fontnames+', label_left=Font Type:, set_value='+fontloc $
	    +', tag=font, font='+info.font+', labelfont='+info.font, $
	'2, label, "   ", center, font=' + info.font, $
	'1, base, ,column, frame', $
	'0, label, Font Modifiers, center, font='+info.font, $
	'0, droplist, No|Yes, label_left=Weight:, set_value='+weightloc $
	    +', tag=weight, font='+info.font+', labelfont='+info.font, $
	'0, droplist, No|Yes, label_left=Angle:, set_value='+angleloc $
	    +', tag=angle, font='+info.font+', labelfont='+info.font, $
	'0, droplist, Default|Condensed|Extended, label_left=Width:, set_value='+widthloc $
	    +', tag=width, font='+info.font+', labelfont='+info.font, $
	'0, droplist, Default|Outline|Shadow, label_left=Outline:, set_value='+outloc $
	    +', tag=outlined, font='+info.font+', labelfont='+info.font, $
	'0, droplist, No|Yes, label_left=Underline:, set_value='+underloc $
	    +', tag=underline, font='+info.font+', labelfont='+info.font, $
	'2, label, "   ", center, font=' + info.font, $
	'1, base, ,column, frame', $
	'0, label, Font size in pixel, center, font='+info.font, $
        '0, integer, '+fontsize+', title=Font Size:, width=10, tag=fontsize, ' $
            + 'font='+info.font+', fieldfont='+info.font+', labelfont='+info.font, $
        '2, label, "   ", center, font=' + info.font, $
	'1, base, ,column, frame', $
	'0, label, Leading space size in pixel, center, font='+info.font, $
	'0, integer, '+spacesize+', title=Leading Space Size:, width=10, tag=spacesize, ' $
	    + 'font='+info.font+', fieldfont='+info.font+', labelfont='+info.font, $
	'2, label, "   ", center, font=' + info.font, $
	'1, base, , row, space=60, center', $
	'0, button, Done, QUIT, tag=done, font='+info.font, $
	'2, button, Cancel, QUIT, tag=cancel, font='+info.font]
endif else begin
    desc = [ $
	'0, label, Select Font Type and Size, center, font='+info.font, $
	'0, label, "   ", center, font=' + info.font, $
	'1, base, ,column, frame', $
	'0, label, Select the Font Type, left, font='+info.font, $
	'0, droplist,'+fontnames+', label_left=Font Type:, set_value='+fontloc $
	    +', tag=font, font='+info.font+', labelfont='+info.font, $
	'2, label, "   ", center, font=' + info.font, $
	'1, base, ,column, frame', $
	'0, label, Font size in pixel, center, font='+info.font, $
        '0, integer, '+fontsize+', title=Font Size:, width=10, tag=fontsize, ' $
            + 'font='+info.font+', fieldfont='+info.font+', labelfont='+info.font, $
        '2, label, "   ", center, font=' + info.font, $
	'1, base, ,column, frame', $
	'0, label, Leading space size in pixel, center, font='+info.font, $
	'0, integer, '+spacesize+', title=Leading Space Size:, width=10, tag=spacesize, ' $
	    + 'font='+info.font+', fieldfont='+info.font+', labelfont='+info.font, $
	'2, label, "   ", center, font=' + info.font, $
	'1, base, , row, space=60, center', $
	'0, button, Done, QUIT, tag=done, font='+info.font, $
	'2, button, Cancel, QUIT, tag=cancel, font='+info.font]
endelse

result = cw_form(desc, /column, title='Select the Hardware Font')

if result.cancel eq 1 then begin
    return, fonttype
endif

;  Set the font and add the font modifier if set
if info.device eq 'WIN' and flag eq 0 then begin
    win_font = afont[result.font]
    ;  Test the weight
    if result.weight gt 0 then begin
	case result.weight of
	    1: win_font = win_font+'*THIN'
	    2: win_font = win_font+'*LIGHT'
	    3: win_font = win_font+'*BOLD'
	    4: win_font = win_font+'*HEAVY'
	    else: 
	endcase
    endif

    ;  Test the quality
    if result.quality gt 0 then begin
	if result.quality eq 1 then begin
	    win_font = win_font+'*DRAFT'
	endif else if result.quality eq 2 then begin
	    win_font = win_font+'*PROOF'
	endif
    endif

    ;  Test the pitch
    if result.pitch gt 0 then begin
	if result.pitch eq 1 then begin
	    win_font = win_font+'*FIXED'
	endif else if result.pitch eq 2 then begin
	    win_font = win_font+'*VARIABLE'
	endif
    endif

    ;  Test the angle
    if result.angle eq 1 then begin
	win_font = win_font+'*ITALIC'
    endif

    ;  Test the strikeout
    if result.strikeout eq 1 then begin
	win_font = win_font+'*STRIKEOUT'
    endif

    ;  Test the underline
    if result.underline eq 1 then begin
	win_font = win_font+'*UNDERLINE'
    endif

    ;  Add the font size at the end
    win_font = win_font+'*'+strcompress(string(result.fontsize), /REMOVE_ALL)

    fonttype.NAME = win_font
    print,'fonttype = ',fonttype.NAME

endif else if info.device eq 'MAC' and flag eq 0 then begin
    mac_font = afont[result.font]
    ;  Test the weight
    if result.weight eq 1 then begin
	mac_font = mac_font+'*BOLD'
    endif

    ;  Test the angle
    if result.angle eq 1 then begin
	mac_font = mac_font+'*ITALIC'
    endif

    ;  Test the width
    if result.width gt 0 then begin
	if result.width eq 1 then begin
	    mac_font = mac_font+'*CONDENSED'
	endif else if result.width eq 2 then begin
	    mac_font = mac_font+'*EXTENDED'
	endif
    endif

    ;  Test the outlined
    if result.outlined gt 0 then begin
	if result.outlined eq 1 then begin
	    mac_font = mac_font+'*OUTLINE'
	endif else if result.outlined eq 2 then begin
	    mac_font = mac_font+'*SHADOW'
	endif
    endif

    ;  Test the underline
    if result.underline eq 1 then begin
	mac_font = mac_font+'*UNDERLINE'
    endif

    ;  Add the font size at the end
    mac_font = mac_font+'*'+strcompress(string(result.fontsize), /REMOVE_ALL)

    fonttype.NAME = mac_font
    print,'fonttype = ',fonttype.NAME

endif else begin
    ;  Set the fonttype
    fonttype.NAME = afont[result.font]
endelse

    fonttype.SIZE = result.fontsize
    fonttype.SPACE = result.spacesize

    ;print,'fonttype = ',fonttype.NAME,' with size ',fonttype.SIZE,' and space ',fonttype.SPACE

return, fonttype

end

;--------------------------------------------------------------------------------
pro fontsetting_event, event

pro_name = 'fontsetting_event'
@getinfo

if TAG_NAMES(event,/structure_name) eq 'CW_COLOR_INDEX' then begin
    widget_control, get_uvalue=info, event.top
    info.style.colorindex=event.value
    widget_control, set_uvalue=info, event.top
    return
end

widget_control, get_value=v, event.id
widget_control, get_uvalue=fieldid, event.id

if v.cancel eq 1 then begin
    widget_control, /destroy, event.top
    return
endif

if event.tag eq 'FONT' then begin
    widget_control, get_uvalue=info, event.top
    if event.value eq 0 then begin
	info.char.font = -1
	widget_control, set_uvalue=info, event.top
	return
    endif else if event.value eq 1 then begin
	info.char.font = 0
	if info.device eq 'X' then begin
	    fontname = xfont(/preserve_font_info)
	    info.char.fontname = fontname
	endif else begin
	    fontname = gethardwarefont(0, event.top, info)
	    if strlen(fontname.name) gt 0 then begin
		info.char.fontname = fontname.name
		info.char.fontsize = fontname.size
		info.char.spacesize = fontname.space
		; print,'new fontname = ',info.char.fontname
		; print,'new fontsize = ',info.char.fontsize
		; print,'new spacesize = ',info.char.spacesize
	    endif
	endelse
	widget_control, set_uvalue=info, event.top
	return
    endif else begin
	info.char.font = 1
	fontname = gethardwarefont(1, event.top, info)
	if strlen(fontname.name) gt 0 then begin
            info.char.fontname = fontname.name
	    info.char.fontsize = fontname.size
	    info.char.spacesize = fontname.space
            ; print,'new fontname = ',info.char.fontname
	    ; print,'new fontsize = ',info.char.fontsize
	    ; print,'new spacesize = ',info.char.spacesize
            widget_control, set_uvalue=info, event.top
        endif
        return
    endelse
endif

if v.done eq 1 then begin
    ; Done, save the setting
    widget_control, get_uvalue=info, event.top

    info.char.size = v.charsize
    
    if(widget_info(info.widgets.base, /VALID_ID)) then $
        widget_control, set_uvalue=info, info.widgets.base
    widget_control, set_uvalue=info, info.base

    ;  Set the font
    if info.device eq 'X' then begin
	print,'new fontname = ',info.char.fontname
    endif else begin
	print,'The final font: '
	print,'new fontname = ',info.char.fontname
	print,'new fontsize = ',info.char.fontsize
	print,'new spacesize = ',info.char.spacesize
    endelse

    !P.FONT = info.char.font
    if info.char.font gt -1 then begin
	;  use pixmap to avoid a window pop up
	window, /pixmap
	if info.device eq 'X' and info.char.font eq 0 then begin
	    device, set_font = info.char.fontname
	endif else begin
	    if info.char.font eq 0 then begin
		device, set_font = info.char.fontname, $
		    set_character_size = [info.char.fontsize, info.char.spacesize]
	    endif else begin
		device, set_font = info.char.fontname, $
		    set_character_size = [info.char.fontsize, info.char.spacesize], $
		    /tt_font
	    endelse
	endelse
	wdelete
    endif

    widget_control, event.top, /destroy

endif

end

;--------------------------------------------------------------------------------
pro font_setting, top_base, info

pro_name = 'font_setting'
@getinfo

widget_control, /hourglass

old_window_id = !d.window

font_type = strcompress(string(info.char.font + 1), /REMOVE_ALL)
charsize = strcompress(string(info.char.size), /REMOVE_ALL)

desc = [ $
	'0, label, Font Type and Size Setting, center, font='+info.font, $
	'0, label, "   ", center, font=' + info.font, $
	'1, base, , column, frame', $
	'0, droplist, Vector (Default)|Hardware|True-Type Outline, ' $
	    + 'label_left=Font Type:, set_value='+font_type+', tag=font, ' $
	    + 'font='+info.font+', labelfont='+info.font, $
	'2, label, "   ", center, font=' + info.font, $
	'1, base, ,column, frame', $
        '0, float, '+charsize+', title=Character Size:, width=10, tag=charsize, ' $
            + 'font='+info.font+', fieldfont='+info.font+', labelfont='+info.font, $
        '2, label, "   ", center, font=' + info.font, $
	'0, label, "   ", center, font='+info.font, $
	'1, base, , row, space=60, center', $
	'0, button, Done, QUIT, tag=done, font='+info.font, $
	'2, button, Cancel, QUIT, tag=cancel, font='+info.font]
	
base_loc = widget_info(top_base, /geometry)
xoffset = base_loc.xoffset + 100
yoffset = base_loc.yoffset + 100
base=widget_base(group_leader=top_base, /modal, column=1, map=1, xoffset=xoffset, $
    yoffset=yoffset, TITLE='Change Font Setting')
formid = cw_form(base, desc, /column, ids=fieldid)

widget_control, base, /realize
widget_control, set_uvalue=info, base
widget_control, set_uvalue=fieldid, formid

xmanager, 'fontsetting', base

wset, old_window_id

end

;--------------------------------------------------------------------------------
pro gridsetting_event, event

pro_name = 'gridsetting_event'
@getinfo

widget_control, get_value=v, event.id
widget_control, get_uvalue=fieldid, event.id

if v.cancel eq 1 then begin
    widget_control, /destroy, event.top
    return
endif

if event.tag eq 'OPTION' then begin
    if event.value eq 3 then widget_control, fieldid(3), sensitive = 1 $
	else widget_control, fieldid(3), sensitive = 0
endif

if v.done eq 1 then begin
    widget_control, get_uvalue=info, event.top

    case v.option of
	0: info.grid_start.long = 500
	1: info.grid_start.long = 0
	2: info.grid_start.long = -180
	3: info.grid_start.long = v.start
	else: info.grid_start.long = 500
    endcase
	    
    if info.grid_start.long gt 360 or info.grid_start.long lt -180 then $
	info.grid_start.long = 500

    info.grid_start.lat = v.latopt
    
    if(widget_info(info.widgets.base, /VALID_ID)) then $
        widget_control, set_uvalue=info, info.widgets.base
    widget_control, set_uvalue=info, info.base

    widget_control, event.top, /destroy

endif

end

;--------------------------------------------------------------------------------
pro grid_setting, top_base, info

pro_name = 'grid_setting'
@getinfo

widget_control, /hourglass

case info.grid_start.long of
    500: gridstart = 0
      0: gridstart = 1
   -180: gridstart = 2
   else: gridstart = 3
endcase

grid_start = strcompress(string(info.grid_start.long), /REMOVE_ALL)
gridoption = strcompress(string(gridstart), /REMOVE_ALL)
latoption = strcompress(string(info.grid_start.lat), /REMOVE_ALL)

desc = [ $
	'0, label, Grid Start Setting, center, font='+info.font, $
	'0, label, "   ", center, font=' + info.font, $
	'0, droplist, Auto|0|-180|Other, label_left=Longitude Grid Start:,' $
	     + 'set_value='+gridoption+', tag=option, font='+info.font $
	     + ', labelfont='+info.font, $
	'1, base, , column, frame', $
	'0, label, Enter grid start location, center, font='+info.font, $
	'2, integer, '+grid_start+', title=Grid Start:, width=10, tag=start, ' $
	    + 'font='+info.font+', fieldfont='+info.font+', labelfont='+info.font, $
	'0, label, "   ", center, font=' + info.font, $
	'0, droplist, North to South|South to North, label_left=Latitude Grid Start:,' $
	    + 'set_value='+latoption+', tag=latopt, font='+info.font $
	    + ', labelfont='+info.font, $
	'0, label, "   ", center, font='+info.font, $
	'1, base, , row, space=60, center', $
	'0, button, Done, QUIT, tag=done, font='+info.font, $
	'2, button, Cancel, QUIT, tag=cancel, font='+info.font]
	
base_loc = widget_info(top_base, /geometry)
xoffset = base_loc.xoffset + 100
yoffset = base_loc.yoffset + 100
base=widget_base(group_leader=top_base, /modal, row=1, map=1, xoffset=xoffset, $
    yoffset=yoffset, TITLE='Change Grid Start Setting')
formid = cw_form(base, desc, /column, ids=fieldid)
widget_control, base, /realize
widget_control, set_uvalue=info, base
widget_control, set_uvalue=fieldid, formid

if gridstart eq 3 then widget_control, fieldid(3), sensitive = 1 $
        else widget_control, fieldid(3), sensitive = 0

xmanager, 'gridsetting', base

end

;--------------------------------------------------------------------------------
pro editorsetting_event, event

pro_name = 'editorsetting_event'
@getinfo

widget_control, get_value=v, event.id
widget_control, get_uvalue=fieldid, event.id

if v.cancel eq 1 then begin
    widget_control, /destroy, event.top
    return
endif

if event.tag eq 'OPTION' then begin
    if event.value eq 4 then widget_control, fieldid(3), sensitive = 1 $
	else widget_control, fieldid(3), sensitive = 0
endif

if v.done eq 1 then begin
    widget_control, get_uvalue=info, event.top

    if v.option eq 4 then begin
	editorname = v.editor
	editorname=editorname(0)
	loc = check_command(editorname)
	if loc ne -1 then begin
	    the_message = ["The editor "+editorname+" is not available in this system.", $
		"Please enter another editor!"]
	    result=dialog_message(the_message, title='View HDF Warning!')
	    return
	endif
	info.editor=editorname
    endif
	
    ;if v.option eq 3 then info.editor_type = 4 $
;	else if v.option eq 4then info.editor_type = 3 $
;	else info.editor_type = v.option
    info.editor_type = v.option

    
    if(widget_info(info.widgets.base, /VALID_ID)) then $
        widget_control, set_uvalue=info, info.widgets.base
    widget_control, set_uvalue=info, info.base

    widget_control, event.top, /destroy

endif

end

;--------------------------------------------------------------------------------
pro editor_setting, top_base, info

pro_name = 'editor_setting'
@getinfo

widget_control, /hourglass

editorname = strcompress(info.editor, /REMOVE_ALL)
;if info.editor_type eq 3 then editortype = 4 $
;    else if info.editor_type eq 4 then editortype = 3 $
;    else editortype = info.editor_type
editortype = info.editor_type
editoroption = strcompress(string(editortype), /REMOVE_ALL)

desc = [ $
	'0, label, Editor Setting, center, font='+info.font, $
	'0, label, "   ", center, font=' + info.font, $
	'0, droplist, VI|Emacs|Ieditor|Edit (PC)|Other|Emacs with Xterm, label_left=Editor:,' $
	     + 'set_value='+editoroption+', tag=option, font='+info.font $
	     + ', labelfont='+info.font, $
	'1, base, , column, frame', $
	'0, label, Enter editor command, center, font='+info.font, $
	'2, text, '+editorname+', label_left=Editor:, width=20, tag=editor, ' $
	    + 'font='+info.font+', labelfont='+info.font, $
	'0, label, "   ", center, font='+info.font, $
	'1, base, , row, space=60, center', $
	'0, button, Done, QUIT, tag=done, font='+info.font, $
	'2, button, Cancel, QUIT, tag=cancel, font='+info.font]
	
base_loc = widget_info(top_base, /geometry)
xoffset = base_loc.xoffset + 100
yoffset = base_loc.yoffset + 100
base=widget_base(group_leader=top_base, /modal, row=1, map=1, xoffset=xoffset, $
    yoffset=yoffset, TITLE='Change Editor Setting')
formid = cw_form(base, desc, /column, ids=fieldid)
widget_control, base, /realize
widget_control, set_uvalue=info, base
widget_control, set_uvalue=fieldid, formid

if info.editor_type eq 4 then widget_control, fieldid(3), sensitive = 1 $
        else widget_control, fieldid(3), sensitive = 0

xmanager, 'editorsetting', base

end

;--------------------------------------------------------------------------------
pro barsetting_event, event

pro_name = 'barsetting_event'
@getinfo

if TAG_NAMES(event,/structure_name) eq 'CW_COLOR_INDEX' then begin
    widget_control, get_uvalue=info, event.top
    info.greenwich.baddata=event.value
    widget_control, set_uvalue=info, event.top
    return
end

widget_control, get_value=v, event.id
widget_control, get_uvalue=fieldid, event.id

if v.cancel eq 1 then begin
    widget_control, /destroy, event.top
    return
endif

if event.tag eq 'OPTION' then begin
    if event.value gt 1 then widget_control, fieldid(3), sensitive = 1 $
	else widget_control, fieldid(3), sensitive = 0

    if event.value eq 2 and v.inrange eq 1 then $
	widget_control, fieldid(10), sensitive = 1 $
	else widget_control, fieldid(10), sensitive = 0

;    if event.value ne 0 then widget_control, fieldid(6), sensitive = 1 $
;	else widget_control, fieldid(6), sensitive = 0
endif

if event.tag eq 'INRANGE' then begin
    if event.value gt 0 and v.option eq 2 then $
	widget_control, fieldid(10), sensitive = 1 $
	else widget_control, fieldid(10), sensitive = 0

;    if event.value ne 0 then widget_control, fieldid(6), sensitive = 1 $
;	else widget_control, fieldid(6), sensitive = 0
endif

if event.tag eq 'SETFORMAT' then begin
    if event.value eq 1 then widget_control, fieldid(16), sensitive = 1 $
	else widget_control, fieldid(16), sensitive = 0
endif

if v.done eq 1 then begin
    widget_control, get_uvalue=info, event.top

    case v.option of
	1: begin
		info.color_bar = 1
		info.greenwich.with_level = 0
		info.greenwich.n_level = v.level
	   end
	2: begin
		info.color_bar = 1
		info.greenwich.with_level = 1
		info.greenwich.n_level = v.level
	   end
	3: begin
		info.color_bar = 1
		info.greenwich.with_level = 2
		info.greenwich.n_level = v.level
	   end
	else: begin
		info.color_bar = 0
		info.greenwich.n_level = v.level
	   end
    endcase

    info.greenwich.ext_level = v.extlevel
    info.greenwich.in_level = v.inrange
    if info.greenwich.with_level ne 1 then info.greenwich.in_level = 0
    data_range = v.range
    while (((loc = strpos(data_range,','))) ne -1) do $
    strput, data_range, ';', loc
    range_array = str_sep(data_range, ';')
    num_range = n_elements(range_array)
    if num_range gt 3 then info.greenwich.range = data_range $
    else begin
	info.greenwich.range = ''
	info.greenwich.in_level = 0
    endelse
    ;info.barlocation = v.location
    info.greenwich.barsize = v.barsize
    info.greenwich.setformat = v.setformat
    info.greenwich.bformat = v.bformat
    info.greenwich.colborder = v.colborder
    info.greenwich.displaybad = v.displaybad

    if(widget_info(info.widgets.base, /VALID_ID)) then $
        widget_control, set_uvalue=info, info.widgets.base
    widget_control, set_uvalue=info, info.base

    widget_control, event.top, /destroy

endif

end

;--------------------------------------------------------------------------------
pro bar_setting, top_base, info

pro_name = 'bar_setting'
@getinfo

widget_control, /hourglass

old_window_id = !d.window

if info.color_bar eq 1 and info.greenwich.with_level eq 0 then begin
	baroption = 1 
endif else if info.color_bar eq 1 and info.greenwich.with_level eq 1 then begin
	baroption = 2
endif else if info.color_bar eq 1 and info.greenwich.with_level eq 2 then begin
	baroption = 3
endif else baroption = 0

ext_level = strcompress(string(info.greenwich.ext_level), /REMOVE_ALL)
n_level = strcompress(string(info.greenwich.n_level), /REMOVE_ALL)
;barlocation = strcompress(string(info.barlocation), /REMOVE_ALL)
bar_option = strcompress(string(baroption), /REMOVE_ALL)
in_option = strcompress(string(info.greenwich.in_level), /REMOVE_ALL)
level_range = info.greenwich.range
barsize = strcompress(string(info.greenwich.barsize), /REMOVE_ALL)
setformat = strcompress(string(info.greenwich.setformat), /REMOVE_ALL)
bformat = strcompress(info.greenwich.bformat, /REMOVE_ALL)
colborder = strcompress(string(info.greenwich.colborder), /REMOVE_ALL)
displaybad = strcompress(string(info.greenwich.displaybad), /REMOVE_ALL)

desc = [ $
	'0, label, Color Bar Setting, center, font='+info.font, $
	'0, label, "   ", center, font=' + info.font, $
	'0, droplist, Without|Continuous|Discrete|Log Discrete, label_left=Color Bar:,' $
	     + 'set_value='+bar_option+', tag=option, font='+info.font $
	     + ', labelfont='+info.font, $
	'1, base, , column, frame', $
	'0, label, Enter number of discrete intervals, center, font='+info.font, $
	'0, integer, '+n_level+', title=Number Of Discrete Intervals:, width=10, tag=level, ' $
	    + 'font='+info.font+', fieldfont='+info.font+', labelfont='+info.font, $
        '0, droplist, No|Yes, label_left=Display Out of Range Data as Bad Data:,' $
             + 'set_value='+ext_level+', tag=extlevel, font='+info.font $
             + ', labelfont='+info.font, $
        '0, droplist, No|Yes, label_left=Display Border on Each Color:,' $
             + 'set_value='+colborder+', tag=colborder, font='+info.font $
             + ', labelfont='+info.font, $
        '0, droplist, No|Yes, label_left=Display Bad Data Color:,' $
             + 'set_value='+displaybad+', tag=displaybad, font='+info.font $
             + ', labelfont='+info.font, $
        '2, droplist, Auto|Manual, label_left=Set Range:,' $
             + 'set_value='+in_option+', tag=inrange, font='+info.font $
             + ', labelfont='+info.font, $
        '1, base, , column, frame', $
        '0, label, Enter range separated by ";", center, font='+info.font, $
        '2, text, '+level_range+', label_left=Range:, width=50, tag=range, ' $
            + 'font='+info.font+', fieldfont='+info.font+', labelfont='+info.font, $
	'1, base, , column, frame', $
	'0, float, '+barsize+', title=Size of Each Color:, width=10, tag=barsize, ' $
	    + 'font='+info.font+', fieldfont='+info.font+', labelfont='+info.font, $
	'0, droplist, Auto|Manual, label_left=Set Label Format:,' $
	    + 'set_value='+setformat+', tag=setformat, font='+info.font $
	    + ', labelfont='+info.font, $
	'2, text, '+bformat+', label_left=Bar Label Format:,' $
            + 'width=10, tag=bformat, font='+info.font+', fieldfont='+info.font  $
            + ', labelfont='+info.font, $
;	'1, base, , column, frame', $
;	'0, label, Enter color bar location, center, font='+info.font, $
;	'2, float, '+barlocation+', title=Color Bar Location:, width=10, tag=location, ' $
;	    + 'font='+info.font+', labelfont='+info.font, $
	'0, label, "   ", center, font='+info.font, $
	'1, base, , row, space=60, center', $
	'0, button, Done, QUIT, tag=done, font='+info.font, $
	'2, button, Cancel, QUIT, tag=cancel, font='+info.font]
	
base_loc = widget_info(top_base, /geometry)
xoffset = base_loc.xoffset + 100
yoffset = base_loc.yoffset + 100
base=widget_base(group_leader=top_base, /modal, column=1, map=1, xoffset=xoffset, $
    yoffset=yoffset, TITLE='Change Color Bar Setting')
formid = cw_form(base, desc, /column, ids=fieldid)

if !d.n_colors gt 192 then bar_size = !d.n_colors else bar_size = 192
if !d.n_colors gt 256 then begin
    bar_size = 256
    color_values =indgen(bar_size)
    if info.greenwich.baddata gt 255 then info.greenwich.baddata = 255
endif else color_values =indgen(!d.n_colors)
if info.version lt 5.39 then begin
    clr_index = cw_clr_index(base, color_values=color_values, label='No Data Color: ', $
        xsize=bar_size, uvalue='bar')
endif else begin
    clr_index = cw_clr_index(base, color_values=color_values, label='No Data Color: ', $
	start_color = info.greenwich.baddata, $
        xsize=bar_size, value=info.greenwich.baddata, uvalue='bar')
endelse

widget_control, base, /realize
widget_control, set_uvalue=info, base
widget_control, set_uvalue=fieldid, formid

if info.version lt 5.39 then initial_cw_clr_index, clr_index, info.greenwich.baddata

editable_cw_clr_index, clr_index

if baroption gt 1 then widget_control, fieldid(3), sensitive = 1 $
        else widget_control, fieldid(3), sensitive = 0

if baroption eq 2 and info.greenwich.in_level eq 1 then $
	widget_control, fieldid(10), sensitive = 1 $
        else widget_control, fieldid(10), sensitive = 0

if setformat eq 1 then widget_control, fieldid(16), sensitive = 1 $
        else widget_control, fieldid(16), sensitive = 0

;if bar_option ne 0 then widget_control, fieldid(6), sensitive = 1 $
;	else widget_control, fieldid(6), sensitive = 0

xmanager, 'barsetting', base

wset, old_window_id

end

;--------------------------------------------------------------------------------
pro axissetting_event, event

pro_name = 'axissetting_event'
@getinfo

widget_control, get_value=v, event.id
widget_control, get_uvalue=fieldid, event.id

if v.cancel eq 1 then begin
    widget_control, get_uvalue=info, event.top
    info.canceloption = 'Yes'
    if(widget_info(info.widgets.base, /VALID_ID)) then $
	widget_control, set_uvalue=info, info.widgets.base
    widget_control, set_uvalue=info, info.base
    widget_control, /destroy, event.top
    return
endif

if event.tag eq 'AXIS' then begin
    if event.value eq 1 then begin
	widget_control, fieldid(6), sensitive = 1
	manual_option = v.manual
	if manual_option eq 0 or manual_option eq 3 or manual_option eq 4 or $
	    manual_option eq 7 or manual_option eq 8 then $
	    widget_control, fieldid(10), sensitive = 1 $
	    else widget_control, fieldid(10), sensitive = 0
	if manual_option eq 1 or manual_option eq 3 or manual_option eq 4 or $
            manual_option eq 6 or manual_option eq 8 then $
	    widget_control, fieldid(13), sensitive = 1 $
            else widget_control, fieldid(13), sensitive = 0
	if manual_option eq 2 or manual_option eq 4 then $
            widget_control, fieldid(16), sensitive = 1 $
            else widget_control, fieldid(16), sensitive = 0
	if manual_option gt 4 then widget_control, fieldid(19), sensitive = 1 $
	    else widget_control, fieldid(19), sensitive = 0
    endif else begin
	widget_control, fieldid(6), sensitive = 0
	widget_control, fieldid(10), sensitive = 0
	widget_control, fieldid(13), sensitive = 0
	widget_control, fieldid(16), sensitive = 0
	widget_control, fieldid(19), sensitive = 0
    endelse
endif

if event.tag eq 'MANUAL' then begin
    manual_option = event.value
    if manual_option eq 0 or manual_option eq 3 or manual_option eq 4 or $
	manual_option eq 7 or manual_option eq 8 $
	then widget_control, fieldid(10), sensitive = 1 $
	else widget_control, fieldid(10), sensitive = 0
    if manual_option eq 1 or manual_option eq 3 or manual_option eq 4 or $
        manual_option eq 6 or manual_option eq 8 then $
	widget_control, fieldid(13), sensitive = 1 $
        else widget_control, fieldid(13), sensitive = 0
    if manual_option eq 2 or manual_option eq 4 then $
        widget_control, fieldid(16), sensitive = 1 $
        else widget_control, fieldid(16), sensitive = 0
    if manual_option gt 4 then widget_control, fieldid(19), sensitive = 1 $
	else widget_control, fieldid(19), sensitive = 0
endif

if v.done eq 1 then begin
    widget_control, get_uvalue=info, event.top
    if v.axis gt 0 then info.axis_state = v.manual + 1 $
	else info.axis_state = 0

    info.range.x_start = v.x_start
    info.range.x_end = v.x_end
    info.range.y_start = v.y_start
    info.range.y_end = v.y_end
    info.range.z_start = v.z_start
    info.range.z_end = v.z_end
    info.range.y2_start = v.y2_start
    info.range.y2_end = v.y2_end

    info.style.grid = v.grid

    case v.log of
	1: begin
		info.style.xlog = 1
		info.style.ylog = 0
		info.style.y2log = 0
	   end
	2: begin
		info.style.xlog = 0
                info.style.ylog = 1
                info.style.y2log = 0
	   end
	3: begin
		info.style.xlog = 1
                info.style.ylog = 1
                info.style.y2log = 0
	   end
	4: begin
		info.style.xlog = 0
                info.style.ylog = 0
                info.style.y2log = 1
	   end
	5: begin
		info.style.xlog = 1
                info.style.ylog = 0
                info.style.y2log = 1
	   end
	6: begin
		info.style.xlog = 0
                info.style.ylog = 1
                info.style.y2log = 1
	   end
	7: begin
		info.style.xlog = 1
                info.style.ylog = 1
                info.style.y2log = 1
	   end
	else: begin
		info.style.xlog = 0
                info.style.ylog = 0
                info.style.y2log = 0
	   end
    endcase
    
    if(widget_info(info.widgets.base, /VALID_ID)) then $
        widget_control, set_uvalue=info, info.widgets.base
    widget_control, set_uvalue=info, info.base

    widget_control, event.top, /destroy

endif

end

;--------------------------------------------------------------------------------
pro axis_setting, top_base, info

pro_name = 'axis_setting'
@getinfo

widget_control, /hourglass

if info.axis_state gt 0 then axis_option = 1 else axis_option = 0
axisoption = strcompress(string(axis_option), /REMOVE_ALL)
if axis_option gt 0 then manual_option = info.axis_state - 1 $
    else manual_option = 0
manualoption = strcompress(string(manual_option), /REMOVE_ALL)
gridoption = strcompress(string(info.style.grid), /REMOVE_ALL)

if info.style.xlog eq 1 and info.style.ylog eq 0 and $
    info.style.y2log eq 0 then begin
	log_option = 1
endif else if info.style.xlog eq 0 and info.style.ylog eq 1 and $
    info.style.y2log eq 0 then begin
	log_option = 2
endif else if info.style.xlog eq 1 and info.style.ylog eq 1 and $
    info.style.y2log eq 0 then begin
	log_option = 3
endif else if info.style.xlog eq 0 and info.style.ylog eq 0 and $
    info.style.y2log eq 1 then begin
	log_option = 4
endif else if info.style.xlog eq 1 and info.style.ylog eq 0 and $
    info.style.y2log eq 1 then begin
	log_option = 5
endif else if info.style.xlog eq 0 and info.style.ylog eq 1 and $
    info.style.y2log eq 1 then begin
	log_option = 6
endif else if info.style.xlog eq 1 and info.style.ylog eq 1 and $
    info.style.y2log eq 1 then begin
	log_option = 7
endif else log_option = 0
logoption = strcompress(string(log_option), /REMOVE_ALL)

x_start = strcompress(string(info.range.x_start), /REMOVE_ALL)
x_end = strcompress(string(info.range.x_end), /REMOVE_ALL)
y_start = strcompress(string(info.range.y_start), /REMOVE_ALL)
y_end = strcompress(string(info.range.y_end), /REMOVE_ALL)
z_start = strcompress(string(info.range.z_start), /REMOVE_ALL)
z_end = strcompress(string(info.range.z_end), /REMOVE_ALL)
y2_start = strcompress(string(info.range.y2_start), /REMOVE_ALL)
y2_end = strcompress(string(info.range.y2_end), /REMOVE_ALL)

desc = [ $
	'0, label, Axis Setting, center, font='+info.font, $
	'0, label, "   ", center, font=' + info.font, $
	'1, base, , column, frame', $
	'0, label, Select Axis range type, center, font='+info.font, $
	'1, base, , row, space=30', $
	'0, droplist, Auto|Manual, label_left=Axis Range:, set_value='+axisoption $
	    + ', tag=axis, font='+info.font+', labelfont='+info.font, $
	'2, droplist, X Only|Y Only|Z Only|XY Only|XYZ|Y2 Only|YY2 Only|XY2 Only|XYY2,' $
	    + 'label_left=Manual Axis Type:, set_value='+manualoption $
	    + ', tag=manual, font='+info.font+', labelfont='+info.font, $
	'2, label,  , center, font='+info.font, $
	'1, base, , column, frame', $
	'0, label, Enter range of axis, center, font='+info.font, $
	'1, base, , row, space=30', $
	'0, float, '+x_start+', title=X  Start:, width=12, tag=x_start, ' $
	    + 'font='+info.font+', fieldfont='+info.font+', labelfont='+info.font, $
	'2, float, ' + x_end+', title=X  End:, width=12, tag=x_end, ' $
	    + 'font='+info.font+', fieldfont='+info.font+', labelfont='+info.font, $
	'1, base, , row, space=30', $
	'0, float, '+y_start+', title=Y  Start:, width=12, tag=y_start, ' $
	    + 'font='+info.font+', fieldfont='+info.font+', labelfont='+info.font, $
	'2, float, ' + y_end+', title=Y  End:, width=12, tag=y_end, ' $
	    + 'font='+info.font+', fieldfont='+info.font+', labelfont='+info.font, $
	'1, base, , row, space=30', $
	'0, float, '+z_start+', title=Z  Start:, width=12, tag=z_start, ' $
	    + 'font='+info.font+', fieldfont='+info.font+', labelfont='+info.font, $
	'2, float, ' + z_end+', title=Z  End:, width=12, tag=z_end, ' $
	    + 'font='+info.font+', fieldfont='+info.font+', labelfont='+info.font, $
	'1, base, , row, space=30', $
	'0, float, '+y2_start+', title=Y2 Start:, width=12, tag=y2_start, ' $
	    + 'font='+info.font+', fieldfont='+info.font+', labelfont='+info.font, $
	'2, float, ' + y2_end+', title=Y2 End:, width=12, tag=y2_end, ' $
	    + 'font='+info.font+', fieldfont='+info.font+', labelfont='+info.font, $
	'2, label,   , center, font='+info.font, $
	'1, base, , column, frame', $
	'1, base, , row, space=30', $
	'0, droplist, Without Grid|With XY Grid|With X Grid Only|With Y Grid Only,' $
	    + 'label_left=Grid Type:, set_value='+gridoption + ', tag=grid,' $
	    + 'font='+info.font+', labelfont='+info.font, $
	'2, droplist, Linear Axes|Logarithmic X Axis Only|Logarithmic Y Axis Only|' $
	    + 'Logarithmic XY Axes|Logarithmic Y2 Axis Only|Logarithmic XY2 Axes Only|' $
	    + 'Logarithmic YY2 Axes Only|Logarithmic XYY2 Axes,label_left=Axis Type:,' $
	    + 'set_value='+logoption + ', tag=log,font='+info.font+', labelfont='+info.font, $
	'2, label,  , center, font='+info.font, $
	'0, label, "   ", center, font='+info.font, $
	'1, base, , row, space=60, center', $
	'0, button, Done, QUIT, tag=done, font='+info.font, $
	'2, button, Cancel, QUIT, tag=cancel, font='+info.font]
	
base_loc = widget_info(top_base, /geometry)
xoffset = base_loc.xoffset + 100
yoffset = base_loc.yoffset + 100
base=widget_base(group_leader=top_base, /modal, row=1, map=1, xoffset=xoffset, $
    yoffset=yoffset, TITLE='Change Axis Setting')
formid = cw_form(base, desc, /column, ids=fieldid)
widget_control, base, /realize
widget_control, set_uvalue=info, base
widget_control, set_uvalue=fieldid, formid

if axis_option gt 0 then begin
    widget_control, fieldid(6), sensitive = 1
    if manual_option eq 0 or manual_option eq 3 or manual_option eq 4 or $
	manual_option eq 7 or manual_option eq 8 then $
	widget_control, fieldid(10), sensitive = 1 $
	else widget_control, fieldid(10), sensitive = 0
    if manual_option eq 1 or manual_option eq 3 or manual_option eq 4 or $
        manual_option eq 6 or manual_option eq 8 then $
	widget_control, fieldid(13), sensitive = 1 $
        else widget_control, fieldid(13), sensitive = 0
    if manual_option eq 2 or manual_option eq 4 then $
        widget_control, fieldid(16), sensitive = 1 $
        else widget_control, fieldid(16), sensitive = 0
    if manual_option gt 4 then widget_control, fieldid(19), sensitive = 1 $
	else widget_control, fieldid(19), sensitive = 0
endif else begin
    widget_control, fieldid(6), sensitive = 0
    widget_control, fieldid(10), sensitive = 0
    widget_control, fieldid(13), sensitive = 0
    widget_control, fieldid(16), sensitive = 0
    widget_control, fieldid(19), sensitive = 0
endelse

xmanager, 'axissetting', base

end

;--------------------------------------------------------------------------------
pro timesetting_event, event

pro_name = 'timesetting_event'
@getinfo

widget_control, get_value=v, event.id
widget_control, get_uvalue=fieldid, event.id

if v.cancel eq 1 then begin
    widget_control, /destroy, event.top
    return
endif

if v.done eq 1 then begin
    widget_control, get_uvalue=info, event.top

    info.time_type.new = v.time

    if(widget_info(info.widgets.base, /VALID_ID)) then begin
	if(info.field_name.x ne 'Time' and info.multiple.xy_diff ne 'Time') then $
	    info.time_type.old = info.time_type.new
	if(info.graph_style ne 'XY Graph' and info.graph_style ne 'Y1Y2 Compute' $
	    and info.graph_style ne 'Y12 Compute' and $
	    info.graph_style ne 'Extract Bits') then $
		info.time_type.old = info.time_type.new
    endif else info.time_type.old = info.time_type.new

    if(widget_info(info.widgets.base, /VALID_ID)) then $
        widget_control, set_uvalue=info, info.widgets.base
    widget_control, set_uvalue=info, info.base

    widget_control, event.top, /destroy

endif

end

;--------------------------------------------------------------------------------
pro time_setting, top_base, info

pro_name = 'time_setting'
@getinfo

widget_control, /hourglass

timetype = strcompress(string(info.time_type.old), /REMOVE_ALL)

desc = [ $
	'0, label, Display Time Type Setting, center, font='+info.font, $
	'0, label, "   ", center, font=' + info.font, $
	'0, droplist, Hours|Minutes|Seconds, label_left=Display Time Type:, ' $
	     + 'set_value='+timetype+', tag=time, font='+info.font $
	     + ', labelfont='+info.font, $
	'0, label, "   ", center, font='+info.font, $
	'1, base, , row, space=60, center', $
	'0, button, Done, QUIT, tag=done, font='+info.font, $
	'2, button, Cancel, QUIT, tag=cancel, font='+info.font]
	
base_loc = widget_info(top_base, /geometry)
xoffset = base_loc.xoffset + 100
yoffset = base_loc.yoffset + 100
base=widget_base(group_leader=top_base, /modal, row=1, map=1, xoffset=xoffset, $
    yoffset=yoffset, TITLE='Display Time Type Setting')
formid = cw_form(base, desc, /column, ids=fieldid)
widget_control, base, /realize
widget_control, set_uvalue=info, base
widget_control, set_uvalue=fieldid, formid

xmanager, 'timesetting', base

end

;--------------------------------------------------------------------------------
pro scalesetting_event, event

pro_name = 'scalesetting_event'
@getinfo

widget_control, get_value=v, event.id
widget_control, get_uvalue=fieldid, event.id

if v.cancel eq 1 then begin
    widget_control, /destroy, event.top
    return
endif

if v.done eq 1 then begin
    widget_control, get_uvalue=info, event.top

    info.scaledata.auto = v.auto

    if(widget_info(info.widgets.base, /VALID_ID)) then $
        widget_control, set_uvalue=info, info.widgets.base
    widget_control, set_uvalue=info, info.base

    widget_control, event.top, /destroy

endif

end

;--------------------------------------------------------------------------------
pro scale_setting, top_base, info

pro_name = 'scale_setting'
@getinfo

widget_control, /hourglass

autotype = strcompress(string(info.scaledata.auto), /REMOVE_ALL)

desc = [ $
	'0, label, Auto Select Scale Factors Setting, center, font='+info.font, $
	'0, label, "   ", center, font=' + info.font, $
	'0, droplist, No|Yes, label_left=Auto Select Scale Factors:, ' $
	     + 'set_value='+autotype+', tag=auto, font='+info.font $
	     + ', labelfont='+info.font, $
	'0, label, "   ", center, font='+info.font, $
	'1, base, , row, space=60, center', $
	'0, button, Done, QUIT, tag=done, font='+info.font, $
	'2, button, Cancel, QUIT, tag=cancel, font='+info.font]
	
base_loc = widget_info(top_base, /geometry)
xoffset = base_loc.xoffset + 100
yoffset = base_loc.yoffset + 100
base=widget_base(group_leader=top_base, /modal, row=1, map=1, xoffset=xoffset, $
    yoffset=yoffset, TITLE='Auto Select Scale Factors Setting')
formid = cw_form(base, desc, /column, ids=fieldid)
widget_control, base, /realize
widget_control, set_uvalue=info, base
widget_control, set_uvalue=fieldid, formid

xmanager, 'scalesetting', base

end

;--------------------------------------------------------------------------------
pro hdf421setting_event, event

pro_name = 'hdf421setting_event'
@getinfo

widget_control, get_value=v, event.id
widget_control, get_uvalue=fieldid, event.id

if v.cancel eq 1 then begin
    widget_control, /destroy, event.top
    return
endif

if v.done eq 1 then begin
    widget_control, get_uvalue=info, event.top

    info.hdf421 = v.hdf421

    if(widget_info(info.widgets.base, /VALID_ID)) then $
        widget_control, set_uvalue=info, info.widgets.base
    widget_control, set_uvalue=info, info.base

    widget_control, event.top, /destroy

endif

end

;--------------------------------------------------------------------------------
pro hdf421_setting, top_base, info

pro_name = 'hdf421_setting'
@getinfo

if info.library_status eq 0 then begin
    the_message = ["The shared library is not available.", $
		   "Cannot set the HDF 4.2r1 version."]
    result=dialog_message(the_message, title='View HDF Warning!')
    return
endif

widget_control, /hourglass

hdf421use = strcompress(string(info.hdf421), /REMOVE_ALL)

desc = [ $
	'0, label, Using HDF 421 Version Setting, center, font='+info.font, $
	'0, label, "   ", center, font=' + info.font, $
	'0, droplist, No|Yes, label_left=Using HDF 421 Version:, ' $
	     + 'set_value='+hdf421use+', tag=hdf421, font='+info.font $
	     + ', labelfont='+info.font, $
	'0, label, "   ", center, font='+info.font, $
	'1, base, , row, space=60, center', $
	'0, button, Done, QUIT, tag=done, font='+info.font, $
	'2, button, Cancel, QUIT, tag=cancel, font='+info.font]
	
base_loc = widget_info(top_base, /geometry)
xoffset = base_loc.xoffset + 100
yoffset = base_loc.yoffset + 100
base=widget_base(group_leader=top_base, /modal, row=1, map=1, xoffset=xoffset, $
    yoffset=yoffset, TITLE='Using HDF 421 Version Setting')
formid = cw_form(base, desc, /column, ids=fieldid)
widget_control, base, /realize
widget_control, set_uvalue=info, base
widget_control, set_uvalue=fieldid, formid

xmanager, 'hdf421setting', base

end

;--------------------------------------------------------------------------------
pro computeoutsetting_event, event

pro_name = 'computeoutsetting_event'
@getinfo

widget_control, get_value=v, event.id
widget_control, get_uvalue=fieldid, event.id

if v.cancel eq 1 then begin
    widget_control, /destroy, event.top
    return
endif

if v.done eq 1 then begin
    widget_control, get_uvalue=info, event.top

    info.y1y2.out_flag = v.outflag

    if(widget_info(info.widgets.base, /VALID_ID)) then $
        widget_control, set_uvalue=info, info.widgets.base
    widget_control, set_uvalue=info, info.base

    widget_control, event.top, /destroy

endif

end

;--------------------------------------------------------------------------------
pro compute_out_setting, top_base, info

pro_name = 'compute_out_setting'
@getinfo

widget_control, /hourglass

out_flag = strcompress(string(info.y1y2.out_flag), /REMOVE_ALL)

desc = [ $
	'0, label, Display Plot Result Question Window Setting, center, font='+info.font, $
	'0, label, "   ", center, font=' + info.font, $
	'0, droplist, No|Yes, label_left=Diplay Plot Result Quesiont Window:, ' $
	     + 'set_value='+out_flag+', tag=outflag, font='+info.font $
	     + ', labelfont='+info.font, $
	'0, label, "   ", center, font='+info.font, $
	'1, base, , row, space=60, center', $
	'0, button, Done, QUIT, tag=done, font='+info.font, $
	'2, button, Cancel, QUIT, tag=cancel, font='+info.font]
	
base_loc = widget_info(top_base, /geometry)
xoffset = base_loc.xoffset + 100
yoffset = base_loc.yoffset + 100
base=widget_base(group_leader=top_base, /modal, row=1, map=1, xoffset=xoffset, $
    yoffset=yoffset, TITLE='Display Plot Result Question Window Setting')
formid = cw_form(base, desc, /column, ids=fieldid)
widget_control, base, /realize
widget_control, set_uvalue=info, base
widget_control, set_uvalue=fieldid, formid

xmanager, 'computeoutsetting', base

end

;--------------------------------------------------------------------------------
pro morevariablesetting_event, event

pro_name = 'morevariablesetting_event'
@getinfo

widget_control, get_value=v, event.id
widget_control, get_uvalue=fieldid, event.id

if v.cancel eq 1 then begin
    widget_control, /destroy, event.top
    return
endif

if event.tag eq 'STYLE' then begin
    if event.value gt 0 then begin
        widget_control, fieldid(3), set_droplist_select = 1
	widget_control, event.id, set_value={reset:1}
    endif
endif

if v.done eq 1 then begin
    widget_control, get_uvalue=info, event.top

    info.multiple.styleflag = v.style
    info.multiple.resetflag = v.reset

    if(widget_info(info.widgets.base, /VALID_ID)) then $
        widget_control, set_uvalue=info, info.widgets.base
    widget_control, set_uvalue=info, info.base

    widget_control, event.top, /destroy

endif

end

;--------------------------------------------------------------------------------
pro more_variable_setting, top_base, info

pro_name = 'more_variable_setting'
@getinfo

widget_control, /hourglass

styletype = strcompress(string(info.multiple.styleflag), /REMOVE_ALL)

desc = [ $
	'0, label, Multiple Variables Style Setting, center, font='+info.font, $
	'0, label, "   ", center, font=' + info.font, $
	'0, droplist, Default|Manual, label_left=Style Setting:, ' $
	     + 'set_value='+styletype+', tag=style, font='+info.font $
	     + ', labelfont='+info.font, $
	'0, droplist, No|Yes, label_left=Reset Style Setting:, tag=reset, font='+info.font $
	     + ', set_value=0, labelfont='+info.font, $
	'0, label, "   ", center, font='+info.font, $
	'1, base, , row, space=60, center', $
	'0, button, Done, QUIT, tag=done, font='+info.font, $
	'2, button, Cancel, QUIT, tag=cancel, font='+info.font]
	
base_loc = widget_info(top_base, /geometry)
xoffset = base_loc.xoffset + 100
yoffset = base_loc.yoffset + 100
base=widget_base(group_leader=top_base, /modal, row=1, map=1, xoffset=xoffset, $
    yoffset=yoffset, TITLE='Multiple Variables Style Setting')
formid = cw_form(base, desc, /column, ids=fieldid)
widget_control, base, /realize
widget_control, set_uvalue=info, base
widget_control, set_uvalue=fieldid, formid

xmanager, 'morevariablesetting', base

end

;--------------------------------------------------------------------------------
pro imageordersetting_event, event

pro_name = 'imageordersetting_event'
@getinfo

widget_control, get_value=v, event.id
widget_control, get_uvalue=fieldid, event.id

if v.cancel eq 1 then begin
    widget_control, /destroy, event.top
    return
endif

if event.tag eq 'BAR' then begin
    if event.value eq 1 then widget_control, fieldid(4), sensitive = 1 $
	else widget_control, fieldid(4), sensitive = 0
endif

if v.preset eq 1 then begin
    offy = 0.15
    xdelt = 0.44
    ydelt = 0.022
    boff = 0.038
    widget_control, fieldid(6), set_value = offy
    widget_control, fieldid(7), set_value = xdelt
    widget_control, fieldid(8), set_value = ydelt
    widget_control, fieldid(9), set_value = boff
    widget_control, event.id, set_value={yoff:offy, deltx:xdelt, delty:ydelt, baroff:boff, preset:0}
endif

if v.done eq 1 then begin
    widget_control, get_uvalue=info, event.top

    info.d2_image.image_order = v.porder
    info.d2_image.colorbar = v.bar
    info.d2_image.yoffset = v.yoff
    info.d2_image.deltx = v.deltx
    info.d2_image.delty = v.delty
    info.d2_image.bar_offset = v.baroff

    if(widget_info(info.widgets.base, /VALID_ID)) then $
        widget_control, set_uvalue=info, info.widgets.base
    widget_control, set_uvalue=info, info.base

    widget_control, event.top, /destroy

endif

end

;--------------------------------------------------------------------------------
pro image_order_setting, top_base, info

pro_name = 'image_order_setting'
@getinfo

widget_control, /hourglass

plotorder = strcompress(string(info.d2_image.image_order), /REMOVE_ALL)
cbar = strcompress(string(info.d2_image.colorbar), /REMOVE_ALL)
offy = strcompress(string(info.d2_image.yoffset), /REMOVE_ALL)
xdelt = strcompress(string(info.d2_image.deltx), /REMOVE_ALL)
ydelt = strcompress(string(info.d2_image.delty), /REMOVE_ALL)
boff = strcompress(string(info.d2_image.bar_offset), /REMOVE_ALL)

desc = [ $
	'0, label, 2D Image Plot Setting, center, font='+info.font, $
	'0, label, "   ", center, font=' + info.font, $
	'0, droplist, Bottom-To-Top|Top-To-Bottom, label_left=Plot Order:, ' $
	     + 'set_value='+plotorder+', tag=porder, font='+info.font $
	     + ', labelfont='+info.font, $
	'0, droplist, No|Yes, label_left=Display Color Bar:, ' $
	     + 'set_value='+cbar+', tag=bar, font='+info.font $
	     + ', labelfont='+info.font, $
	'1, base, , column, frame', $
	'0, label, Color Bar Location (Normal Coordinate), center, font='+info.font, $
	'0, float, '+offy+', title=Y Offset:, width=12, tag=yoff, ' $
	     + 'font='+info.font+', fieldfont='+info.font+', labelfont='+info.font, $
	'0, float, '+xdelt+', title=X Size:, width=12, tag=deltx, ' $
	     + 'font='+info.font+', fieldfont='+info.font+', labelfont='+info.font, $
	'0, float, ' + ydelt+', title=Y Size:, width=12, tag=delty, ' $
	     + 'font='+info.font+', fieldfont='+info.font+', labelfont='+info.font, $
	'0, float, ' + boff+', title=Bar Offset:, width=12, tag=baroff, ' $
	     + 'font='+info.font+', fieldfont='+info.font+', labelfont='+info.font, $
	'2, button, Reset, tag=preset, font='+info.font, $
	'0, label, "   ", center, font='+info.font, $
	'1, base, , row, space=60, center', $
	'0, button, Done, QUIT, tag=done, font='+info.font, $
	'2, button, Cancel, QUIT, tag=cancel, font='+info.font]
	
base_loc = widget_info(top_base, /geometry)
xoffset = base_loc.xoffset + 100
yoffset = base_loc.yoffset + 100
base=widget_base(group_leader=top_base, /modal, row=1, map=1, xoffset=xoffset, $
    yoffset=yoffset, TITLE='2D Image Plot Setting')
formid = cw_form(base, desc, /column, ids=fieldid)
widget_control, base, /realize
widget_control, set_uvalue=info, base
widget_control, set_uvalue=fieldid, formid

if cbar eq 0 then widget_control, fieldid(4), sensitive = 0

xmanager, 'imageordersetting', base

end

;--------------------------------------------------------------------------------
pro arraysortsetting_event, event

pro_name = 'arraysortsetting_event'
@getinfo

widget_control, get_value=v, event.id
widget_control, get_uvalue=fieldid, event.id

if v.cancel eq 1 then begin
    widget_control, /destroy, event.top
    return
endif

if v.done eq 1 then begin
    widget_control, get_uvalue=info, event.top

    info.array_sort = v.asort

    if(widget_info(info.widgets.base, /VALID_ID)) then $
        widget_control, set_uvalue=info, info.widgets.base
    widget_control, set_uvalue=info, info.base

    widget_control, event.top, /destroy

endif

end

;--------------------------------------------------------------------------------
pro array_sort_setting, top_base, info

pro_name = 'array_sort_setting'
@getinfo

widget_control, /hourglass

arraysort = strcompress(string(info.array_sort), /REMOVE_ALL)

desc = [ $
	'0, label, 3D Mesh Surface Array Sort Setting, center, font='+info.font, $
	'0, label, "   ", center, font=' + info.font, $
	'0, droplist, No|Yes, label_left=Sort Array:, ' $
	     + 'set_value='+arraysort+', tag=asort, font='+info.font $
	     + ', labelfont='+info.font, $
	'0, label, "   ", center, font='+info.font, $
	'1, base, , row, space=60, center', $
	'0, button, Done, QUIT, tag=done, font='+info.font, $
	'2, button, Cancel, QUIT, tag=cancel, font='+info.font]
	
base_loc = widget_info(top_base, /geometry)
xoffset = base_loc.xoffset + 100
yoffset = base_loc.yoffset + 100
base=widget_base(group_leader=top_base, /modal, row=1, map=1, xoffset=xoffset, $
    yoffset=yoffset, TITLE='3D Mesh Surface Array Sort Setting')
formid = cw_form(base, desc, /column, ids=fieldid)
widget_control, base, /realize
widget_control, set_uvalue=info, base
widget_control, set_uvalue=fieldid, formid

xmanager, 'arraysortsetting', base

end

;--------------------------------------------------------------------------------
pro browsesetting_event, event

pro_name = 'browsesetting_event'
@getinfo

widget_control, get_value=v, event.id
widget_control, get_uvalue=fieldid, event.id

if v.cancel eq 1 then begin
    widget_control, /destroy, event.top
    return
endif

if event.tag eq 'BTYPE' then begin
    if event.value eq 0 then widget_control, fieldid(5), sensitive = 1 $
	else widget_control, fieldid(5), sensitive = 0
endif

if v.done eq 1 then begin
    widget_control, get_uvalue=info, event.top

    info.browse_image.type = v.ptype
    info.browse_image.shotscale = v.scale
    info.browse_image.btype = v.btype
    info.browse_image.rtype = v.rtype
    info.browse_image.utype = v.utype
    info.browse_image.ytype = v.ytype
    info.browse_image.saveimage = v.simage
    info.browse_image.useprofile = v.uprof
    info.browse_image.xlocat = v.xlocat
    info.browse_image.xformat = v.xformat

    if(widget_info(info.widgets.base, /VALID_ID)) then $
        widget_control, set_uvalue=info, info.widgets.base
    widget_control, set_uvalue=info, info.base

    widget_control, event.top, /destroy

endif

end

;--------------------------------------------------------------------------------
pro browse_setting, top_base, info

pro_name = 'browse_setting'
@getinfo

widget_control, /hourglass

plottype = strcompress(string(info.browse_image.type), /REMOVE_ALL)
shotscale = strcompress(string(info.browse_image.shotscale), /REMOVE_ALL)
bartype = strcompress(string(info.browse_image.btype), /REMOVE_ALL)
rangetype = strcompress(string(info.browse_image.rtype), /REMOVE_ALL)
unittype = strcompress(string(info.browse_image.utype), /REMOVE_ALL)
yrangetype = strcompress(string(info.browse_image.ytype), /REMOVE_ALL)
saveimage = strcompress(string(info.browse_image.saveimage), /REMOVE_ALL)
useprofile = strcompress(string(info.browse_image.useprofile), /REMOVE_ALL)
xlocat = strcompress(string(info.browse_image.xlocat), /REMOVE_ALL)
xformat = strcompress(info.browse_image.xformat, /REMOVE_ALL)

desc = [ $
	'0, label, Browse Image Plot Type Setting, center, font='+info.font, $
	'0, label, "   ", center, font=' + info.font, $
	'0, droplist, Plot As Image|Plot By Grid Cells|Plot By Points, label_left=Plot Type:, ' $
	     + 'set_value='+plottype+', tag=ptype, font='+info.font $
	     + ', labelfont='+info.font, $
	'0, integer, '+shotscale+', title=Number Shots per One Km:,' $
	     + 'width=10, tag=scale, font='+info.font+', fieldfont='+info.font  $
	     + ', labelfont='+info.font, $
	'0, droplist, Auto|Manual, label_left=Color Bar Setting:, ' $
	    + 'set_value='+bartype+', tag=btype, font='+info.font $
	    + ', labelfont='+info.font, $
	'1, base, , column', $
	'2, droplist, 14|new 34|34, label_left=Number of Ranges Setting:, ' $
	    + 'set_value='+rangetype+', tag=rtype, font='+info.font $
	    + ', labelfont='+info.font, $
	'0, droplist, Km|meter, label_left=Data Unit Setting:, ' $
	    + 'set_value='+unittype+', tag=utype, font='+info.font $
	    + ', labelfont='+info.font, $
	'0, droplist, Auto|Manual, label_left=Y Range Setting:, ' $
	    + 'set_value='+yrangetype+', tag=ytype, font='+info.font $
	    + ', labelfont='+info.font, $
	'0, droplist, No|Yes, label_left=Save Browse Image:, ' $
	    + 'set_value='+saveimage+', tag=simage, font='+info.font $
	    + ', labelfont='+info.font, $
	'0, droplist, No|Yes, label_left=Use Profile Number as X:, ' $
	    + 'set_value='+useprofile+', tag=uprof, font='+info.font $
	    + ', labelfont='+info.font, $
	'0, float, '+xlocat+', title=X Title Location (Normal):,' $
	    + 'width=10, tag=xlocat, font='+info.font+', fieldfont='+info.font  $
	    + ', labelfont='+info.font, $
	'0, text, '+xformat+', label_left=X Title Format:,' $
	    + 'width=10, tag=xformat, font='+info.font+', fieldfont='+info.font  $
	    + ', labelfont='+info.font, $
	'0, label, "   ", center, font='+info.font, $
	'1, base, , row, space=60, center', $
	'0, button, Done, QUIT, tag=done, font='+info.font, $
	'2, button, Cancel, QUIT, tag=cancel, font='+info.font]
	
base_loc = widget_info(top_base, /geometry)
xoffset = base_loc.xoffset + 100
yoffset = base_loc.yoffset + 100
base=widget_base(group_leader=top_base, /modal, row=1, map=1, xoffset=xoffset, $
    yoffset=yoffset, TITLE='Browse Image Plot Type Setting')
formid = cw_form(base, desc, /column, ids=fieldid)
widget_control, base, /realize
widget_control, set_uvalue=info, base
widget_control, set_uvalue=fieldid, formid

if bartype eq 1 then widget_control, fieldid(5), sensitive = 0

xmanager, 'browsesetting', base

end

;--------------------------------------------------------------------------------
pro epssetting_event, event

pro_name = 'epssetting_event'
@getinfo

widget_control, get_value=v, event.id
widget_control, get_uvalue=fieldid, event.id

if v.cancel eq 1 then begin
    widget_control, /destroy, event.top
    return
endif

if event.tag eq 'ENEWSIZE' then begin
    if event.value eq 0 then widget_control, fieldid(7), sensitive = 1 $
	else widget_control, fieldid(7), sensitive = 0
endif

if v.preset eq 1 then begin
    xsize = 7.0
    ysize = 5.4
    widget_control, fieldid(12), set_value = xsize
    widget_control, fieldid(13), set_value = ysize
    widget_control, event.id, set_value={epxsize:xsize, epysize:ysize, preset:0}
endif

if v.lreset eq 1 then begin
    xsize = 9.0
    ysize = 7.0
    widget_control, fieldid(17), set_value = xsize
    widget_control, fieldid(18), set_value = ysize
    widget_control, event.id, set_value={elxsize:xsize, elysize:ysize, lreset:0}
endif

if v.done eq 1 then begin
    widget_control, get_uvalue=info, event.top

;    info.eps_out.type = v.etype
    info.eps_out.check = v.echeck
    info.eps_out.preview = v.epreview
    info.eps_out.newsize = v.enewsize
    info.eps_out.title = v.etitle
    info.eps_out.p_xsize = v.epxsize
    info.eps_out.p_ysize = v.epysize
    info.eps_out.l_xsize = v.elxsize
    info.eps_out.l_ysize = v.elysize

    if(widget_info(info.widgets.base, /VALID_ID)) then $
        widget_control, set_uvalue=info, info.widgets.base
    widget_control, set_uvalue=info, info.base

    widget_control, event.top, /destroy

endif

end

;--------------------------------------------------------------------------------
pro eps_setting, top_base, info

pro_name = 'eps_setting'
@getinfo

widget_control, /hourglass

;epstype = strcompress(string(info.eps_out.type), /REMOVE_ALL)
epscheck = strcompress(string(info.eps_out.check), /REMOVE_ALL)
epspreview = strcompress(string(info.eps_out.preview), /REMOVE_ALL)
epsnewsize = strcompress(string(info.eps_out.newsize), /REMOVE_ALL)
epstitle = strcompress(string(info.eps_out.title), /REMOVE_ALL)
pxsize = strcompress(string(info.eps_out.p_xsize), /REMOVE_ALL)
pysize = strcompress(string(info.eps_out.p_ysize), /REMOVE_ALL)
lxsize = strcompress(string(info.eps_out.l_xsize), /REMOVE_ALL)
lysize = strcompress(string(info.eps_out.l_ysize), /REMOVE_ALL)

desc = [ $
	'0, label, Encapsulated Postscript Setting, center, font='+info.font, $
	'0, label, "   ", center, font=' + info.font, $
;	'0, droplist, Portrait|Landscape, label_left=Orientation:, ' $
;	     + 'set_value='+epstype+', tag=etype, font='+info.font $
;	     + ', labelfont='+info.font, $
	'0, droplist, Yes|No, label_left=Add Showpage Command:, ' $
	     + 'set_value='+epscheck+', tag=echeck, font='+info.font $
	     + ', labelfont='+info.font, $
	'0, droplist, No|Yes, label_left=Change Output Size:, ' $
	     + 'set_value='+epsnewsize+', tag=enewsize, font='+info.font $
	     + ', labelfont='+info.font, $
	'0, droplist, Yes|No, label_left=With title:, ' $
	     + 'set_value='+epstitle+', tag=etitle, font='+info.font $
	     + ', labelfont='+info.font, $
	'1, base, , column', $
	'2, droplist, No|EPSI|EPSF, label_left=Preview Type:, ' $
	     + 'set_value='+epspreview+', tag=epreview, font='+info.font $
	     + ', labelfont='+info.font, $
	'1, base, , column, frame', $
	'0, label, Output Size (inches), center, font='+info.font, $
	'1, base, , row, space=20, center', $
	'1, base, , column', $
	'0, label, PORTRAIT, center, font='+info.font, $
	'0, float, '+pxsize+', title=X Size:, width=12, tag=epxsize, ' $
	    + 'font='+info.font+', fieldfont='+info.font+', labelfont='+info.font, $
	'0, float, ' + pysize+', title=Y Size:, width=12, tag=epysize, ' $
	    + 'font='+info.font+', fieldfont='+info.font+', labelfont='+info.font, $
	'2, button, Reset, tag=preset, font='+info.font, $
	'1, base, , column', $
	'0, label, LANDSCAPE, center, font='+info.font, $
	'0, float, '+lxsize+', title=X Size:, width=12, tag=elxsize, ' $
	    + 'font='+info.font+', fieldfont='+info.font+', labelfont='+info.font, $
	'0, float, ' + lysize+', title=Y Size:, width=12, tag=elysize, ' $
	    + 'font='+info.font+', fieldfont='+info.font+', labelfont='+info.font, $
	'2, button, Reset, tag=lreset, font='+info.font, $
	'2, label,   , center, font='+info.font, $
	'2, label,   , center, font='+info.font, $
	'0, label, "   ", center, font='+info.font, $
	'1, base, , row, space=60, center', $
	'0, button, Done, QUIT, tag=done, font='+info.font, $
	'2, button, Cancel, QUIT, tag=cancel, font='+info.font]
	
base_loc = widget_info(top_base, /geometry)
xoffset = base_loc.xoffset + 100
yoffset = base_loc.yoffset + 100
base=widget_base(group_leader=top_base, /modal, row=1, map=1, xoffset=xoffset, $
    yoffset=yoffset, TITLE='Encapsulated Postscript Setting')
formid = cw_form(base, desc, /column, ids=fieldid)
widget_control, base, /realize
widget_control, set_uvalue=info, base
widget_control, set_uvalue=fieldid, formid

if info.version lt 5.3 then widget_control, fieldid(5), sensitive = 0
if info.eps_out.newsize eq 1 then widget_control, fieldid(7), sensitive = 0

xmanager, 'epssetting', base

end

;--------------------------------------------------------------------------------
pro multifilesetting_event, event

pro_name = 'multifilesetting_event'
@getinfo

widget_control, get_value=v, event.id
widget_control, get_uvalue=fieldid, event.id

if v.cancel eq 1 then begin
    widget_control, /destroy, event.top
    return
endif

if v.done eq 1 then begin
    widget_control, get_uvalue=info, event.top
    info.multifile.num_digit = v.digit
    info.multifile.start_num = v.start
    info.multifile.last_num = v.last
    info.multifile.skip_num = v.skipnum
    info.multifile.has_time = v.hastime
    info.multifile.with_geo = v.geo
    info.multifile.with_time = v.time

    widget_control, set_uvalue=info, info.base

    widget_control, event.top, /destroy

endif

end

;--------------------------------------------------------------------------------
pro multi_file_setting, top_base, info

pro_name = 'multi_file_setting'
@getinfo

widget_control, /hourglass

start_num = strcompress(string(info.multifile.start_num), /REMOVE_ALL)
last_num = strcompress(string(info.multifile.last_num), /REMOVE_ALL)
num_digit = strcompress(string(info.multifile.num_digit), /REMOVE_ALL)
skip_num = strcompress(string(info.multifile.skip_num), /REMOVE_ALL)
has_time = strcompress(string(info.multifile.has_time), /REMOVE_ALL)
with_geo = strcompress(string(info.multifile.with_geo), /REMOVE_ALL)
with_time = strcompress(string(info.multifile.with_time), /REMOVE_ALL)

desc = [ $
	'0, label, Multiple Files Input Setting, center, font='+info.font, $
	'0, label, "   ", center, font=' + info.font, $
	'0, integer, '+num_digit+', title=Increase By Last Number Of Digits:,' $
	    + 'width=10, tag=digit, font='+info.font+', fieldfont='+info.font  $
	    + ', labelfont='+info.font, $
	'0, integer, '+start_num+', title=Start Number:, width=10, tag=start,' $
	    + 'font='+info.font+', fieldfont='+info.font+', labelfont='+info.font, $
	'0, integer, '+last_num+', title=Last Number:, width=10, tag=last,' $
	    + 'font='+info.font+', fieldfont='+info.font+', labelfont='+info.font, $
	'0, integer, '+skip_num+', title=Skip Number of Files:, width=10, tag=skipnum,' $
	    + 'font='+info.font+', fieldfont='+info.font+', labelfont='+info.font, $
	'0, droplist, No|Yes, label_left=With Time Information:,' $
	    + 'set_value='+has_time+', tag=hastime, font='+info.font $
	    + ', labelfont='+info.font, $
	'0, droplist, No|Yes, label_left=Import With Geolocation Parameters:,' $
	    + 'set_value='+with_geo+', tag=geo, font='+info.font $
	    + ', labelfont='+info.font, $
	'0, droplist, No|Yes, label_left=Import With Time Parameter:, set_value='+with_time $
	    + ', tag=time, font='+info.font+', labelfont='+info.font, $
	'0, label, "   ", center, font='+info.font, $
	'1, base, , row, space=60, center', $
	'0, button, Done, QUIT, tag=done, font='+info.font, $
	'2, button, Cancel, QUIT, tag=cancel, font='+info.font]
	
base_loc = widget_info(top_base, /geometry)
xoffset = base_loc.xoffset + 100
yoffset = base_loc.yoffset + 100
base=widget_base(group_leader=top_base, /modal, column=1, map=1, xoffset=xoffset, $
    yoffset=yoffset, TITLE='Multiple Files Input Setting')
formid = cw_form(base, desc, /column, ids=fieldid)

widget_control, base, /realize
widget_control, set_uvalue=info, base
widget_control, set_uvalue=fieldid, formid

xmanager, 'multifilesetting', base

end

;--------------------------------------------------------------------------------
pro miscsetting_event, event

pro_name = 'miscsetting_event'
@getinfo

widget_control, get_value=v, event.id
widget_control, get_uvalue=fieldid, event.id

if v.cancel eq 1 then begin
    widget_control, /destroy, event.top
    return
endif

if event.tag eq 'SIZE' then begin
    if event.value eq 2 then widget_control, fieldid(8), sensitive = 1 $
	else widget_control, fieldid(8), sensitive = 0
endif

if v.done eq 1 then begin
    widget_control, get_uvalue=info, event.top

    old_size = info.screen.pick
    old_xsize = info.screen.xsize
    old_ysize = info.screen.ysize

    info.filldata = v.fill
    info.precision = v.format
    info.time_type.new = v.time
    info.screen.pick = v.size
    case v.size of 
	1: begin
		info.screen.xsize = 1152
		info.screen.ysize = 614
	   end
	2: begin
		info.screen.xsize = v.xsize
		info.screen.ysize = v.ysize
	   end
	else: begin
		info.screen.xsize = 1024
		info.screen.ysize = 600
	   end
    endcase

    info.screen.new = 0
    if old_xsize ne info.screen.xsize or $
	old_ysize ne info.screen.ysize then info.screen.new = 1

    if(widget_info(info.widgets.base, /VALID_ID)) then begin
	if(info.field_name.x ne 'Time' and info.multiple.xy_diff ne 'Time') then $
	    info.time_type.old = info.time_type.new
	if(info.graph_style ne 'XY Graph' and info.graph_style ne 'Y1Y2 Compute' $
	    and info.graph_style ne 'Y12 Compute' and $
	    info.graph_style ne 'Extract Bits') then $
		info.time_type.old = info.time_type.new
    endif else info.time_type.old = info.time_type.new

    if(widget_info(info.widgets.base, /VALID_ID)) then $
        widget_control, set_uvalue=info, info.widgets.base
    widget_control, set_uvalue=info, info.base

    widget_control, event.top, /destroy

endif

end

;--------------------------------------------------------------------------------
pro misc_setting, top_base, info

pro_name = 'misc_setting'
@getinfo

widget_control, /hourglass

filldata = strcompress(string(info.filldata), /REMOVE_ALL)
precision = strcompress(info.precision, /REMOVE_ALL)
timetype = strcompress(string(info.time_type.old), /REMOVE_ALL)
screensize = strcompress(string(info.screen.pick), /REMOVE_ALL)
xsize = strcompress(string(info.screen.xsize), /REMOVE_ALL)
ysize = strcompress(string(info.screen.ysize), /REMOVE_ALL)

desc = [ $
	'0, label, Miscellaneous Setting, center, font='+info.font, $
	'0, label, "   ", center, font=' + info.font, $
	'0, float, '+filldata+', title=Fill Data Value:, width=20, tag=fill, ' $
	    + 'font='+info.font+', fieldfont='+info.font+', labelfont='+info.font, $
	'0, text, '+precision+', label_left=Output Format:, width=20, tag=format, ' $
	    + 'font='+info.font+', labelfont='+info.font, $
	'0, droplist, Hours|Minutes|Seconds, label_left=Time Type:, ' $
	     + 'set_value='+timetype+', tag=time, font='+info.font $
	     + ', labelfont='+info.font, $
	'1, base, , column, frame', $
	'0, label, Select Screen Size, center, font='+info.font, $
	'0, droplist, 1024x600|1152x614|Other, label_left=Screen Size:, ' $
	    + 'set_value='+screensize+', tag=size, font='+info.font $
	    + ', labelfont='+info.font, $
	'1, base, , row', $
	'0, integer, '+xsize+', title=Screen XSize:, width=10, tag=xsize, ' $
	    + 'font='+info.font+', fieldfont='+info.font+', labelfont='+info.font, $
	'2, integer, '+ysize+', title=Screen YSize:, width=10, tag=ysize, ' $
	    + 'font='+info.font+', fieldfont='+info.font+', labelfont='+info.font, $
	'2, label,  , center, font='+info.font, $
	'0, label, "   ", center, font='+info.font, $
	'1, base, , row, space=60, center', $
	'0, button, Done, QUIT, tag=done, font='+info.font, $
	'2, button, Cancel, QUIT, tag=cancel, font='+info.font]
	
base_loc = widget_info(top_base, /geometry)
xoffset = base_loc.xoffset + 100
yoffset = base_loc.yoffset + 100
base=widget_base(group_leader=top_base, /modal, row=1, map=1, xoffset=xoffset, $
    yoffset=yoffset, TITLE='Change Miscellaneous Setting')
formid = cw_form(base, desc, /column, ids=fieldid)
widget_control, base, /realize
widget_control, set_uvalue=info, base
widget_control, set_uvalue=fieldid, formid

if info.screen.pick eq 2 then widget_control, fieldid(8), sensitive = 1 $
        else widget_control, fieldid(8), sensitive = 0

xmanager, 'miscsetting', base

end

;--------------------------------------------------------------------------------
pro gridstartlocationCB, event

pro_name = 'gridstartlocationCB'
@getinfo

widget_control, get_uvalue=info, event.top

widget_control, info.widgets.gridstart, get_value=gridstart

info.grid_start.long=gridstart
print,'Grid Start At=',info.grid_start.long

if(widget_info(info.widgets.base, /VALID_ID)) then $
	widget_control, set_uvalue=info, info.widgets.base
widget_control, set_uvalue=info, info.base

widget_control, event.top, /destroy

end

;--------------------------------------------------------------------------------
pro grid_start_location, info

pro_name = 'grid_start_location'
@getinfo

base = widget_base(COLUMN=1, MAP=1, TITLE='Grid Start Location')

g_group=widget_base(base, row=1,map=1)

info.widgets.gridstart = CW_FIELD(g_group, VALUE=info.grid_start.long, $
		ROW=1, INTEGER=1, FIELDFONT=info.font, $
		FONT=info.font, TITLE='Grid Start At:', XSIZE=10)

group2=widget_base(base, row=1,map=1, space=40, /align_center)

button1=widget_button(group2, FONT=info.font, EVENT_PRO='gridstartlocationCB', $
	VALUE="Done", /ALIGN_CENTER)

button2=widget_button(group2, FONT=info.font, EVENT_PRO='doneCB', VALUE="Cancel",$
	 /ALIGN_CENTER)

widget_control, /realize, base

widget_control, set_uvalue=info, base
if(widget_info(info.widgets.base, /VALID_ID)) then $
	widget_control, set_uvalue=info, info.widgets.base
widget_control, set_uvalue=info, info.base

end

;------------------------------------------------------------------
pro make_curve_buttons, x_fields, y_fields, z_fields, x_group, y_group, z_group,$
  base, xflag, yflag, zflag

pro_name = 'make_curve_buttons'
@getinfo
 
if !D.Name eq 'X' then begin
   font1='-adobe-helvetica-bold-o-normal--14-140-75-75-p-82-iso8859-1'
endif else begin
   font1 = 'Times New Roman*Bold*18'
endelse

if (xflag gt 0) then button1=cw_pdmenu(x_group, x_fields,$
 /RETURN_FULL_NAME, FONT= font1)

if (yflag gt 0) then button2=cw_pdmenu(y_group, y_fields,$
 /RETURN_FULL_NAME, FONT= font1 )

group2=widget_base(base, row=1,map=1, space=40, /align_center)

button1=widget_button(group2, FONT=font1, EVENT_PRO='curve_doneCB', VALUE="Done",$
	/ALIGN_CENTER)

button2=widget_button(group2, FONT=font1, EVENT_PRO='canceloptionCB', $
	VALUE="Cancel", /ALIGN_CENTER)

end

;------------------------------------------------------------------
pro make_xyz_buttons, x_fields, y_fields, z_fields, x_group, y_group, z_group,$
  base, xflag, yflag, zflag

pro_name = 'make_xyz_buttons'
@getinfo
 
if !D.Name eq 'X' then begin
   font1='-adobe-helvetica-bold-o-normal--14-140-75-75-p-82-iso8859-1'
endif else begin
   font1 = 'Times New Roman*Bold*18'
endelse

if (xflag gt 0) then button1=cw_pdmenu(x_group, x_fields,$
 /RETURN_FULL_NAME, FONT= font1)

if (yflag gt 0) then button2=cw_pdmenu(y_group, y_fields,$
 /RETURN_FULL_NAME, FONT= font1 )

if (zflag gt 0) then button3=cw_pdmenu(z_group,z_fields,$
 /RETURN_FULL_NAME, FONT= font1)

group2=widget_base(base, row=1,map=1, space=40, /align_center)

;button1=widget_button(group2, FONT=font1, EVENT_PRO='doneCB', VALUE="Done",$
button1=widget_button(group2, FONT=font1, EVENT_PRO='check_constant', VALUE="Done",$
	/ALIGN_CENTER)

button2=widget_button(group2, FONT=font1, EVENT_PRO='canceloptionCB', $
	VALUE="Cancel", /ALIGN_CENTER)

;button4=widget_button(base, $
;        FONT= font1, VALUE="Done", EVENT_PRO='doneCB', /ALIGN_CENTER)

;widget_control, DEFAULT_BUTTON=button1, CANCEL_BUTTON=button2, base

end

;--------------------------------------------------------------------------------
FUNCTION out_selected, Event

pro_name = 'out_selected'
@getinfo1

widget_control, get_uvalue=info, event.top

picks = info.out.pick
picks(event.value) = event.select
info.out.pick = picks

widget_control, set_uvalue=info, event.top

END

;------------------------------------------------------------------
pro pick_export_variables, info

pro_name = 'pick_export_variables'
@getinfo

font1=info.font

info.out.pick(*) = 0

base = widget_base( GROUP_LEADER=info.base, /MODAL, $
	COLUMN = 1, $
        MAP = 1, $
        TITLE='Select Variables')

widget_control, set_uvalue=info, base
button1=widget_button(base, $
	FONT = font1, $
	XSIZE = 170, $
        VALUE="All Variables", $
        EVENT_PRO = 'set_all_out', $
	uvalue=info, $
        /ALIGN_CENTER)

button2=widget_button(base, $
	FONT = font1, $
	XSIZE = 170, $
        VALUE="Selected Variables", $
        EVENT_PRO = 'set_some_out', $
	uvalue=base, $
        /ALIGN_CENTER)

button3=widget_button(base, $
	FONT = font1, $
	XSIZE = 170, $
        VALUE="Cancel", $
        EVENT_PRO='cancel_all_out', $
        /ALIGN_CENTER)

widget_control, /realize, base 
widget_control, CANCEL_BUTTON=button3, base
xmanager, 'main_widget', base

end

;--------------------------------------------------------------------------------
pro pick_indep_variables, this_subset, info

pro_name = 'pick_indep_variables'
@getinfo

info.out.pick(*) = 0
top_base = 0
data_name = info.subset.data(this_subset).subset_name
data_name = data_name(0)
grouplist = [info.name_list_subset, "Time", "Sample"]
info = redefine_info(info, grouplist, 8)

base_loc = widget_info(info.base, /geometry)
xoffset = base_loc.xoffset + 100
yoffset = base_loc.yoffset + 100
base=widget_base(group_leader=info.base, /modal, column=1, xoffset=xoffset, $
	yoffset=yoffset, TITLE='Select Independent Variables')
widget_control, set_uvalue=info, base

length = strlen(data_name)
if length gt 65 then begin
    temp_name = strmid(data_name, 0, 60) + '...'
endif else temp_name = data_name
dep_variable = "Dependent Variable: " + temp_name
length = strlen(dep_variable)
x_size = fix(length/10)*100
if x_size gt 500 then x_size = 570
if x_size lt 300 then x_size = 300
text1 = widget_label(base, /ALIGN_LEFT, value=dep_variable, $
	FONT=info.font)

text3 = widget_label(base, /ALIGN_RIGHT, value="   ", $
	FONT=info.font)

text4 = widget_label(base, /ALIGN_LEFT, value="Independent Variables:", $
	FONT=info.font)

the_pick=CW_BGROUP(base, grouplist, set_value=0, $
	FONT=info.font, $
        EVENT_FUNCT='out_selected', uvalue=info,$
        /SCROLL,Y_SCROLL_SIZE=300,X_SCROLL_SIZE=x_size, /NONEXCLUSIVE)
   
group2=widget_base(base, row=1,map=1, space=40, /align_center)

button1=widget_button(group2, FONT=info.font, EVENT_PRO='donepick', UVALUE=top_base, $
	VALUE="Done", /ALIGN_CENTER)

button2=widget_button(group2, FONT=info.font, EVENT_PRO='canceloptionCB', VALUE="Cancel",$
	 /ALIGN_CENTER)

widget_control,/realize, base
widget_control, DEFAULT_BUTTON=button1, CANCEL_BUTTON=button2, base
xmanager, 'main_widget', base

END

;--------------------------------------------------------------------------------
pro screen_size, event

pro_name = 'screen_size'
@getinfo

;---------------------------------------- 
; Toggle between table and graph modes
;---------------------------------------- 

widget_control, get_uvalue=info, event.top
screen_id = event.id
widget_control, get_uvalue=info, info.base

screen_xsize_old = info.screen.xsize
screen_ysize_old = info.screen.ysize

case event.index of
0: begin
	info.screen.pick = 0
	info.screen.new = 1
	info.screen.xsize = 1024
	info.screen.ysize = 600
   end
1: begin
	info.screen.pick = 1
	info.screen.new = 1
	info.screen.xsize = 1152
	info.screen.ysize = 614
   end
else: begin
	old_pick = info.screen.pick
	info.screen.pick = 2
	info.screen.new = 0
	get_screen_size, info, event.top
	widget_control, get_uvalue=info, info.base
	if info.screen.new eq 0 then begin
		info.screen.pick = old_pick
		widget_control, screen_id, set_droplist_select=info.screen.pick
	endif
      end
endcase

;if info.screen.new ne 0 then begin
if(info.screen.xsize ne screen_xsize_old or info.screen.ysize ne screen_ysize_old) then begin
	print, 'The new screen size is ', info.screen.xsize, ' x ', info.screen.ysize
	;widget_control, info.widgets.screen, set_droplist_select=info.screen.pick
endif

if event.top ne info.base then begin
	widget_control, info.widgets.screen, set_droplist_select=info.screen.pick
endif else begin
	if(widget_info(info.widgets.base, /VALID_ID)) then $
	   widget_control, info.widgets.screen_size_tool, set_droplist_select=info.screen.pick
endelse

if(widget_info(info.widgets.base, /VALID_ID)) then $
	widget_control, set_uvalue=info, info.widgets.base
widget_control, set_uvalue=info, info.base

if(widget_info(info.widgets.base, /VALID_ID)) then begin
	;if info.screen.new ne 0 then begin
	if(info.screen.xsize ne screen_xsize_old or info.screen.ysize ne screen_ysize_old) then begin
		widget_control, info.widgets.base, /destroy
		if info.multiple.key eq 1 then begin
			do_more_variables, 3, info
		endif else if info.multiple.key eq 2 then begin
			do_more_x_variables, 3, info
		endif else begin
			replot_screen, info.subset.selected, info
		endelse
	endif
endif 

if info.screen.new ne 0 then info.screen.new = 0


end

;--------------------------------------------------------------------------------
pro show_continue, event

pro_name = 'show_continue'
@getinfo

widget_control, get_uvalue = info, event.top
widget_control, get_uvalue = uval, event.id

widget_control, get_uvalue = info, info.base

case uval of
 
; user chooses to show graph with continue range

'showcontinue': begin
    if(info.slide.select eq 1) then info.slide.select = 0 $
      else info.slide.select = 1
    if(info.slide.select eq 1) then begin
	info.save.axis_state = info.axis_state
	info.save.x_start = info.range.x_start
	info.save.x_end = info.range.x_end
	info.save.y_start = info.range.y_start
	info.save.y_end = info.range.y_end
	if((info.graph_style eq '3D Graph') or $
	  (info.graph_style eq '3D Surface')) then begin
		if(info.axis_state eq 0) then info.axis_state = 2
		if(info.axis_state eq 1) then info.axis_state = 4
 	endif else begin
		if(info.axis_state eq 0) then info.axis_state = 1
		if(info.axis_state eq 2) then info.axis_state = 4
		if(info.axis_state eq 6) then info.axis_state = 8
		if(info.axis_state eq 7) then info.axis_state = 9
 	endelse
    endif else begin
	info.axis_state = info.save.axis_state
	info.range.x_start = info.save.x_start
	info.range.x_end = info.save.x_end
	info.range.y_start = info.save.y_start
	info.range.y_end = info.save.y_end
	if(widget_info(info.widgets.subset_base, /VALID_ID)) then begin
		widget_control, info.widgets.subset_base, /destroy
	endif
    endelse

    widget_control, set_uvalue=info, info.widgets.base
    widget_control, set_uvalue=info, info.base

    if info.slide.select eq 1 then show_subset,info

    if info.multiple.key eq 1 then begin
	do_more_variables, 2, info
    endif else if info.multiple.key eq 2 then begin
	do_more_x_variables, 2, info
    endif else begin
	plot_graph, 1, info.subset.selected, info
    endelse

 end

; user entered a range value for show

'rangeval': begin
    Widget_Control, info.widgets.rangefield, GET_VALUE = temp
;   if temp gt 1 then begin
;      widget_control, info.widgets.startslide, get_value = slidestart
;      widget_control, info.widgets.startfield, set_value = slidestart
;   endif else begin
       widget_control, info.widgets.startfield, get_value = slidestart
       widget_control, info.widgets.startslide, set_value = slidestart
;   endelse
    if((info.graph_style eq '3D Graph') or $
       (info.graph_style eq '3D Surface')) then begin
	info.range.y_start = slidestart
	info.range.y_end = info.range.y_start + temp
	if(info.axis_state eq 0) then info.axis_state = 2
	if(info.axis_state eq 1) then info.axis_state = 4
    endif else begin
	info.range.x_start = slidestart
	info.range.x_end = info.range.x_start + temp
	if(info.axis_state eq 0) then info.axis_state = 1
	if(info.axis_state eq 2) then info.axis_state = 4
	if(info.axis_state eq 6) then info.axis_state = 8
	if(info.axis_state eq 7) then info.axis_state = 9
    endelse

    widget_control, set_uvalue=info, info.base
    if(widget_info(info.widgets.base, /VALID_ID)) then begin
	widget_control, set_uvalue=info, info.widgets.base
	if info.multiple.key eq 1 then begin
		do_more_variables, 2, info
	endif else if info.multiple.key eq 2 then begin
		do_more_x_variables, 2, info
	endif else begin
		plot_graph, 1, info.subset.selected, info
	endelse
    endif

 end

'startval': begin
    WIDGET_CONTROL, info.widgets.startslide, get_value = slidestart
    WIDGET_CONTROL, info.widgets.rangefield, get_value = temp
    widget_control, info.widgets.startfield, set_value = slidestart
    if((info.graph_style eq '3D Graph') or $
       (info.graph_style eq '3D Surface')) then begin
	info.range.y_start = slidestart
	info.range.y_end = info.range.y_start + temp
	if(info.axis_state eq 0) then info.axis_state = 2
	if(info.axis_state eq 1) then info.axis_state = 4
    endif else begin
	info.range.x_start = slidestart
	info.range.x_end = info.range.x_start + temp
	if(info.axis_state eq 0) then info.axis_state = 1
	if(info.axis_state eq 2) then info.axis_state = 4
	if(info.axis_state eq 6) then info.axis_state = 8
	if(info.axis_state eq 7) then info.axis_state = 9
    endelse
 
    widget_control, set_uvalue=info, info.base
    if(widget_info(info.widgets.base, /VALID_ID)) then begin
	widget_control, set_uvalue=info, info.widgets.base
	if info.multiple.key eq 1 then begin
		do_more_variables, 2, info
	endif else if info.multiple.key eq 2 then begin
		do_more_x_variables, 2, info
	endif else begin
		plot_graph, 1, info.subset.selected, info
	endelse
    endif
 
 end
 
'startfield': begin
    WIDGET_CONTROL, info.widgets.startfield, get_value = slidestart
    WIDGET_CONTROL, info.widgets.rangefield, get_value = temp
    widget_control, info.widgets.startslide, set_value = slidestart
    if((info.graph_style eq '3D Graph') or $
       (info.graph_style eq '3D Surface')) then begin
	info.range.y_start = slidestart
	info.range.y_end = info.range.y_start + temp
	if(info.axis_state eq 0) then info.axis_state = 2
	if(info.axis_state eq 1) then info.axis_state = 4
    endif else begin
	info.range.x_start = slidestart
	info.range.x_end = info.range.x_start + temp
	if(info.axis_state eq 0) then info.axis_state = 1
	if(info.axis_state eq 2) then info.axis_state = 4
	if(info.axis_state eq 6) then info.axis_state = 8
	if(info.axis_state eq 7) then info.axis_state = 9
    endelse
 
    widget_control, set_uvalue=info, info.base
    if(widget_info(info.widgets.base, /VALID_ID)) then begin
	widget_control, set_uvalue=info, info.widgets.base
	if info.multiple.key eq 1 then begin
		do_more_variables, 2, info
	endif else if info.multiple.key eq 2 then begin
		do_more_x_variables, 2, info
	endif else begin
		plot_graph, 1, info.subset.selected, info
	endelse
    endif
 
 end

'close': begin
   widget_control, event.top, /destroy
   info.axis_state = info.save.axis_state
   info.range.x_start = info.save.x_start
   info.range.x_end = info.save.x_end
   info.range.y_start = info.save.y_start
   info.range.y_end = info.save.y_end
   info.slide.select = 0
  
   widget_control, set_uvalue=info, info.base
   if(widget_info(info.widgets.base, /VALID_ID)) then begin
	widget_control, set_button=0, info.widgets.show_subset
	widget_control, set_uvalue=info, info.widgets.base
	if info.multiple.key eq 1 then begin
		do_more_variables, 2, info
	endif else if info.multiple.key eq 2 then begin
		do_more_x_variables, 2, info
	endif else begin
		plot_graph, 1, info.subset.selected, info
	endelse
   endif

end

'addtext': begin
   addtext_message, info
end

;'charsize': begin
;   widget_control, info.widgets.charsize, get_value = charsize
;   info.char.size = charsize
;   widget_control, set_uvalue=info, info.widgets.base
;   widget_control, set_uvalue=info, info.base
;
;   if info.multiple.key eq 1 then begin
;	do_more_variables, 2, info
;   endif else if info.multiple.key eq 2 then begin
;	do_more_x_variables, 2, info
;   endif else begin
;	plot_graph, 1, info.subset.selected, info
;   endelse
; 
;end
 
else:

endcase

return
end

;--------------------------------------------------------------------------------
pro up_profile, event

pro_name = 'up_profile'
@getinfo

widget_control, get_uvalue = info, event.top

info.sview.p_old = !P
info.sview.x_old = !X
info.sview.y_old = !Y

widget_control, info.browse_image.xwidget, get_value=x_location
widget_control, info.browse_image.pwidget, get_value=p_number
p_number = p_number + 1
draw_profile, x_location, p_number, 1, info

if info.sview.window_id ne -1 then wset, info.sview.window_id
!P = info.sview.p_old
!X = info.sview.x_old
!Y = info.sview.y_old

end

;--------------------------------------------------------------------------------
pro down_profile, event

pro_name = 'down_profile'
@getinfo

widget_control, get_uvalue = info, event.top

info.sview.p_old = !P
info.sview.x_old = !X
info.sview.y_old = !Y

widget_control, info.browse_image.xwidget, get_value=x_location
widget_control, info.browse_image.pwidget, get_value=p_number
p_number = p_number - 1
draw_profile, x_location, p_number, 1, info

if info.sview.window_id ne -1 then wset, info.sview.window_id
!P = info.sview.p_old
!X = info.sview.x_old
!Y = info.sview.y_old

end

;--------------------------------------------------------------------------------
pro show_profile, event

pro_name = 'show_profile'
@getinfo

widget_control, get_uvalue = info, event.top
widget_control, get_uvalue = uval, event.id

info.sview.p_old = !P
info.sview.x_old = !X
info.sview.y_old = !Y

case uval of
 
   'location': begin
	widget_control, info.browse_image.xwidget, get_value=x_location
	widget_control, info.browse_image.pwidget, get_value=p_number
	draw_profile, x_location, p_number, 0, info
    end

   'number': begin
	widget_control, info.browse_image.xwidget, get_value=x_location
	widget_control, info.browse_image.pwidget, get_value=p_number
	draw_profile, x_location, p_number, 1, info
    end

    'plot': begin
	Widget_Control, info.browse_image.xwidget, get_value=x_location
	widget_control, info.browse_image.pwidget, get_value=p_number
	draw_profile, x_location, p_number, 2, info
     end

    else:

endcase

if info.sview.window_id ne -1 then wset, info.sview.window_id
!P = info.sview.p_old
!X = info.sview.x_old
!Y = info.sview.y_old

end

;--------------------------------------------------------------------------------
pro display_profile_value, info

pro_name = 'display_profile_value'
@getinfo

widget_control, get_uvalue = info, info.browse_image.base

if not ptr_valid(info.browse_image.parray) then begin
   print,'In display_profile_value the info.browse_image.parray is not valid, return...'
endif
if not ptr_valid(info.browse_image.parray) then return

widget_control, /hourglass

;  Get the variable name
dot=strpos(info.field_name.z,'[')
if dot ne -1 then ztitle=strmid(info.field_name.z,0,dot) $
    else ztitle = info.field_name.z

if info.device eq 'X' then begin
   check=check_path(info.temp_dir)
   if check eq 1 then begin
	table_filename=info.temp_dir+"."+info.tempname+"_profile"
   endif else begin
	table_filename=info.temp_dir+"/."+info.tempname+"_profile"
   endelse
endif else begin
   table_filename=info.temp_dir+"\."+info.tempname+"_profile"
endelse

get_lun, unit
openw, unit, table_filename 

;--------------------------
; Write file header
;--------------------------
printf, unit, format='("Variable Name: ",A)', ztitle
printf,unit, format='("Profile Number:  ",A)', strcompress(string(info.browse_image.pindex),/REMOVE_ALL)

;-------------------------------
; Get profile value
;-------------------------------

hdf_data = *info.browse_image.parray

;  Write the data
temp='('+info.precision+')'
temp=temp(0)
printf, unit, format=temp, hdf_data

close,unit
free_lun, unit

case info.editor_type of
	1: command_line = "emacs " + table_filename + " &"
	2: begin 
		command_line = info.ieditor + " -geometry 757x531+75+104"
		command_line = command_line + " -title 'Display Data' "
		command_line = command_line + table_filename + " &"
	   end
	3: command_line = 'start edit "' + table_filename + '"'
	4: begin
		if !D.Name eq 'X' then begin
		    command_line = info.editor + " " + table_filename + " &"
		endif else begin
		    command_line = 'start ' + info.editor + ' "' + table_filename + '"'
		endelse
	   end
	5: begin
		command_line="xterm -bg \#73a1ff -fn "
		command_line=command_line+ $
		    "-adobe-courier-bold-r-normal--14-100-100-100-m-90-iso8859-1"
		command_line=command_line + " -e emacs " + table_filename + " &"
	   end
	else: begin
		command_line="xterm -bg \#73a1ff -fn "
		command_line=command_line+ $
			"-adobe-courier-bold-r-normal--14-100-100-100-m-90-iso8859-1"
		command_line=command_line + " -e vi -R " + table_filename + " &"
	   end
endcase
spawn, command_line,results

end

;--------------------------------------------------------------------------------
pro export_profile_value, info

pro_name = 'export_profile_value'
@getinfo

widget_control, get_uvalue = info, info.browse_image.base

if not ptr_valid(info.browse_image.parray) then begin
   print,'In export_profile_value the info.browse_image.parray is not valid, return...'
endif

; if the data is invalid, then return
if not ptr_valid(info.browse_image.parray) then return

count = check_directory(info.export_path, info.home_path)
if count eq 0 then begin
	CD, '.', CURRENT=pwd
	info.export_path = pwd
endif
export_name=dialog_pickfile(filter='*.dat', path=info.export_path, $
		file=info.export_file, get_path=export_path,/write)

if export_name eq "" then return

export_result=STRPOS(export_name, export_path)

if export_result eq -1 then export_name=export_path+export_name

print,"Filename=", export_name

info.export_path = export_path
default_file = ''
default_file = get_default_file(export_name)
if default_file ne 'None' then info.export_file = default_file

widget_control, /hourglass

get_lun, unit
openw, unit, export_name

;--------------------------
; Write file header
;--------------------------
;  Get the variable name
dot=strpos(info.field_name.z,'[')
if dot ne -1 then ztitle=strmid(info.field_name.z,0,dot) $
    else ztitle = info.field_name.z
printf, unit, format='("Variable Name: ",A)', ztitle
printf,unit, format='("Profile Number:  ",A)', strcompress(string(info.browse_image.pindex),/REMOVE_ALL)

;-------------------------------
; Get profile value
;-------------------------------

hdf_data = *info.browse_image.parray

;  Write the data
temp='('+info.precision+')'
temp=temp(0)
printf, unit, format=temp, hdf_data

close,unit
free_lun, unit

info.output_path = info.export_path
CD, info.output_path, CURRENT=old_dir
output_name_list=findfile(info.filter, count=count)
if count eq 0 then output_name_list = [ 'None' ]
 
widget_control, info.widgets.output, set_value=output_name_list
widget_control, info.widgets.outputdir, set_value=info.output_path
widget_control, set_uvalue=info, info.base
 
CD, old_dir
 
result=dialog_message('Exporting Completed!', title='Notice!')
return

end

;--------------------------------------------------------------------------------
pro show_subset, info

pro_name = 'show_subset'
@getinfo

data_name = info.subset.data(info.subset.selected).subset_name
data_name = data_name(0)

if ((info.graph_style eq '3D Graph') $
	or (info.graph_style eq '3D Surface')) then begin
  slide_max = info.slide.y_end
  slide_min = info.slide.y_start
  range_value = info.slide.y_end - info.slide.y_start
  if(range_value le 1) then begin
	range_value = 1
	slide_max = slide_min + range_value
  endif
endif else begin
  slide_max = info.slide.x_end
  slide_min = info.slide.x_start
  range_value = info.slide.x_end - info.slide.x_start
  if(range_value le 1) then begin
	range_value = 1
	slide_max = slide_min + range_value
  endif
endelse

slide_max_int = long(slide_max)
slide_min_int = long(slide_min)
if slide_max_int eq slide_min_int then begin
  slide_max = slide_max + 1
  slide_min = slide_min - 1
  slide_max_int = long(slide_max)
  slide_min_int = long(slide_min)
  if slide_max_int eq slide_min_int then begin
    slide_min = 0
    slide_max = 1
    the_message = ["The value of X is larger than Long integer", $
		   "Cannot use Show Subset feature."]
    result=dialog_message(the_message, title='View HDF Warning!')
  endif
  range_value = slide_max - slide_min
endif

if ((info.graph_style eq '3D Graph') $
	or (info.graph_style eq '3D Surface')) then begin
   info.range.y_start = slide_min
   info.range.y_end = slide_max
endif else begin
   info.range.x_start = slide_min
   info.range.x_end = slide_max
endelse

title = 'Show Subset Menu for '+ data_name
info.widgets.subset_base=widget_base(ROW=1, MAP=1, EVENT_PRO = 'show_continue', $
	space=20, title=title, uvalue=info)

info.widgets.rangefield = CW_FIELD(info.widgets.subset_base, $
    /FLOATING, /ROW, XSIZE = 10, YSIZE=1, TITLE = 'Range: ', $
        UVALUE = 'rangeval', VALUE = range_value, FONT = info.font, $
	FIELDFONT = info.font, /RETURN_EVENTS)

info.widgets.startslide = widget_slider(info.widgets.subset_base, $
	minimum = slide_min, maximum = slide_max, value = slide_min, $
	xsize = 200, uvalue = 'startval', font=info.font, $
	title = 'X Start')

info.widgets.startfield = CW_FIELD(info.widgets.subset_base, $
    /FLOATING, /ROW, XSIZE = 10, YSIZE=1, TITLE = 'Start: ', $
        UVALUE = 'startfield', VALUE = slide_min, FONT = info.font, $
	FIELDFONT = info.font, /RETURN_EVENTS)

continuebutton = WIDGET_BUTTON(info.widgets.subset_base, $
    VALUE = 'Close', UVALUE = 'close', font = info.font)

widget_control, /realize, info.widgets.subset_base

widget_control, set_uvalue=info, info.widgets.base
widget_control, set_uvalue=info, info.base
widget_control, set_uvalue=info, info.widgets.subset_base

end

;--------------------------------------------------------------------------------
pro show_time, event

pro_name = 'show_time'
@getinfo

widget_control, get_uvalue=info, event.top
widget_control, get_uvalue=info, info.base

info.time_type.new = event.index

if event.top ne info.base then begin
	widget_control, info.widgets.time_type, set_droplist_select=info.time_type.new
endif else begin
	if(widget_info(info.widgets.base, /VALID_ID)) then $
	    widget_control, info.widgets.show_time_list, set_droplist_select=info.time_type.new
endelse

if(widget_info(info.widgets.base, /VALID_ID)) then begin
	if(info.field_name.x ne 'Time' and info.multiple.xy_diff ne 'Time') then $
		info.time_type.old = info.time_type.new
	if(info.graph_style ne 'XY Graph' and info.graph_style ne 'Y1Y2 Compute' $
		and info.graph_style ne 'Y12 Compute' and info.graph_style ne 'Extract Bits') then $
		info.time_type.old = info.time_type.new
	widget_control, set_uvalue=info, info.widgets.base 
endif else info.time_type.old = info.time_type.new
widget_control, set_uvalue=info, info.base

end

;--------------------------------------------------------------------------------
pro plot_dialogue, name_of_data, info

pro_name = 'plot_dialogue'
@getinfo

;-----------------------------------------------------
; Create a new plot window - allow multiple windows
;-----------------------------------------------------
; put a menubar on this window if possible
;

graph_list = ['2D Graph' , '2D Image' , '2D Image With Scale' , '3D Graph' , $
	'3D Surface' , 'Contour' , 'Grid Contour' , 'Grid Contour - Region' , $
	'Grid Cell' , 'Grid Cell - Region' , $
	'Statistics' , 'Statistics For Whole Subset' , 'Histogram' , 'XY Graph' , $
	'XYZ Graph', '3D Mesh Surface', '3D Color Mesh Graph', 'Geolocated' , $
	'Contour Geolocated' , 'Create Subset' , 'Subsampling' , 'Array Average - 2D',  $
	'Array Average' , 'Regression' , 'Extract Bits' , 'Browse Image' , $
	'Browse Image With Average' , 'Vertical Feature Mask', 'Old Vertical Feature Mask', $
	'Transpose' , 'Display Data' , 'Display Attribute']

if info.menu_order.flag gt 0 then begin
    graph_list = graph_list(sort(graph_list))
    if info.menu_order.flag eq 2 then begin
	graph_list = get_favorite_list( 0, graph_list, info)
    endif
endif

graph_field = field_struct('Graphic', graph_list)

string_length = strlen(name_of_data)
if(string_length gt 80) then begin
    temp_name=strmid(name_of_data,0,77)
    temp_name = temp_name + '...'
endif else begin
    temp_name = name_of_data
endelse

;  Reset these values to 1
!UserStop = 1
!UserPause = 1
!UserDone = 1

base=widget_base( COLUMN=1, MAP=1, $
	TITLE=info.graph_style + ' Plot for '+temp_name, $
	/TLB_KILL_REQUEST_EVENTS, $
	MBAR=this_menubar)

if info.version lt 5.3 then begin 
    if info.gif_out.gif_flag eq 1 and info.gif_out.png_flag eq 0 then begin
	the_menu_items= [ $
		{ CW_PDMENU_S,       1, 'File' }, $
		{ CW_PDMENU_S,       0, 'Save Postscript...' }, $
		{ CW_PDMENU_S,       0, 'Save EPS Portrait' }, $
		{ CW_PDMENU_S,       0, 'Save EPS Landscape' }, $
		{ CW_PDMENU_S,       0, 'Save GIF' }, $
		{ CW_PDMENU_S,       0, 'Save MPEG' }, $
		{ CW_PDMENU_S,       1, 'Export...' }, $
		{ CW_PDMENU_S,       0, 'Without Filldata' }, $
		{ CW_PDMENU_S,       2, 'With Filldata' }, $
		{ CW_PDMENU_S,       0, 'Print...' }, $
		{ CW_PDMENU_S,       0, 'Print Viewgraph...' }, $
		{ CW_PDMENU_S,       0, 'Display Global Attributes' }, $
		{ CW_PDMENU_S,       0, 'Display Metadata' }, $
;		{ CW_PDMENU_S,       0, 'Change Home Directory' }, $
;		{ CW_PDMENU_S,       0, 'Change Temporary Directory' }, $
		{ CW_PDMENU_S,	     0, 'Change Preferences' }, $
		{ CW_PDMENU_S,       2, 'Close' } $
		]
    endif else if info.gif_out.gif_flag eq 0 and info.gif_out.png_flag eq 1 then begin
	the_menu_items= [ $
		{ CW_PDMENU_S,       1, 'File' }, $
		{ CW_PDMENU_S,       0, 'Save Postscript...' }, $
		{ CW_PDMENU_S,       0, 'Save EPS Portrait' }, $
		{ CW_PDMENU_S,       0, 'Save EPS Landscape' }, $
		{ CW_PDMENU_S,       0, 'Save PNG' }, $
		{ CW_PDMENU_S,       0, 'Save MPEG' }, $
		{ CW_PDMENU_S,       1, 'Export...' }, $
		{ CW_PDMENU_S,       0, 'Without Filldata' }, $
		{ CW_PDMENU_S,       2, 'With Filldata' }, $
		{ CW_PDMENU_S,       0, 'Print...' }, $
		{ CW_PDMENU_S,       0, 'Print Viewgraph...' }, $
		{ CW_PDMENU_S,       0, 'Display Global Attributes' }, $
		{ CW_PDMENU_S,       0, 'Display Metadata' }, $
;		{ CW_PDMENU_S,       0, 'Change Home Directory' }, $
;		{ CW_PDMENU_S,       0, 'Change Temporary Directory' }, $
		{ CW_PDMENU_S,	     0, 'Change Preferences' }, $
		{ CW_PDMENU_S,       2, 'Close' } $
		]
    endif else if info.gif_out.gif_flag eq 1 and info.gif_out.png_flag eq 1 then begin
	the_menu_items= [ $
		{ CW_PDMENU_S,       1, 'File' }, $
		{ CW_PDMENU_S,       0, 'Save Postscript...' }, $
		{ CW_PDMENU_S,       0, 'Save EPS Portrait' }, $
		{ CW_PDMENU_S,       0, 'Save EPS Landscape' }, $
		{ CW_PDMENU_S,       0, 'Save GIF' }, $
		{ CW_PDMENU_S,       0, 'Save PNG' }, $
		{ CW_PDMENU_S,       0, 'Save MPEG' }, $
		{ CW_PDMENU_S,       1, 'Export...' }, $
		{ CW_PDMENU_S,       0, 'Without Filldata' }, $
		{ CW_PDMENU_S,       2, 'With Filldata' }, $
		{ CW_PDMENU_S,       0, 'Print...' }, $
		{ CW_PDMENU_S,       0, 'Print Viewgraph...' }, $
		{ CW_PDMENU_S,       0, 'Display Global Attributes' }, $
		{ CW_PDMENU_S,       0, 'Display Metadata' }, $
;		{ CW_PDMENU_S,       0, 'Change Home Directory' }, $
;		{ CW_PDMENU_S,       0, 'Change Temporary Directory' }, $
		{ CW_PDMENU_S,	     0, 'Change Preferences' }, $
		{ CW_PDMENU_S,       2, 'Close' } $
		]
    endif else begin
	the_menu_items= [ $
		{ CW_PDMENU_S,       1, 'File' }, $
		{ CW_PDMENU_S,       0, 'Save Postscript...' }, $
		{ CW_PDMENU_S,       0, 'Save EPS Portrait' }, $
		{ CW_PDMENU_S,       0, 'Save EPS Landscape' }, $
;		{ CW_PDMENU_S,       0, 'Save GIF' }, $
;		{ CW_PDMENU_S,       0, 'Save PNG' }, $
		{ CW_PDMENU_S,       0, 'Save MPEG' }, $
		{ CW_PDMENU_S,       1, 'Export...' }, $
		{ CW_PDMENU_S,       0, 'Without Filldata' }, $
		{ CW_PDMENU_S,       2, 'With Filldata' }, $
		{ CW_PDMENU_S,       0, 'Print...' }, $
		{ CW_PDMENU_S,       0, 'Print Viewgraph...' }, $
		{ CW_PDMENU_S,       0, 'Display Global Attributes' }, $
		{ CW_PDMENU_S,       0, 'Display Metadata' }, $
;		{ CW_PDMENU_S,       0, 'Change Home Directory' }, $
;		{ CW_PDMENU_S,       0, 'Change Temporary Directory' }, $
		{ CW_PDMENU_S,       0, 'Change Preferences' }, $
		{ CW_PDMENU_S,       2, 'Close' } $
		]
    endelse
endif else begin
    the_menu_items= [ $
		{ CW_PDMENU_S,       1, 'File' }, $
		{ CW_PDMENU_S,       0, 'Save Postscript...' }, $
		{ CW_PDMENU_S,       0, 'Save EPS Portrait' }, $
		{ CW_PDMENU_S,       0, 'Save EPS Landscape' }, $
		{ CW_PDMENU_S,       0, 'Save Image' }, $
		{ CW_PDMENU_S,       0, 'Save MPEG' }, $
		{ CW_PDMENU_S,       1, 'Export...' }, $
		{ CW_PDMENU_S,       0, 'Without Filldata' }, $
		{ CW_PDMENU_S,       2, 'With Filldata' }, $
		{ CW_PDMENU_S,       0, 'Print...' }, $
		{ CW_PDMENU_S,       0, 'Print Viewgraph...' }, $
		{ CW_PDMENU_S,       0, 'Display Global Attributes' }, $
		{ CW_PDMENU_S,       0, 'Display Metadata' }, $
;		{ CW_PDMENU_S,       0, 'Change Home Directory' }, $
;		{ CW_PDMENU_S,       0, 'Change Temporary Directory' }, $
		{ CW_PDMENU_S,       0, 'Change Preferences' }, $
		{ CW_PDMENU_S,       2, 'Close' } $
		]
endelse

the_menu_items= [ the_menu_items, $
;                { CW_PDMENU_S,       1, 'Graphic' }, $
;                { CW_PDMENU_S,       0, '2D Graph' }, $
;                { CW_PDMENU_S,       0, '2D Image' }, $
;		{ CW_PDMENU_S,       0, '2D Image With Scale' }, $
;                { CW_PDMENU_S,       0, '3D Graph' }, $
;                { CW_PDMENU_S,       0, '3D Surface' }, $
;                { CW_PDMENU_S,       0, 'Contour' }, $
;                { CW_PDMENU_S,       0, 'Grid Contour' }, $
;                { CW_PDMENU_S,       0, 'Grid Cell' }, $
;                { CW_PDMENU_S,       0, 'Grid Cell - Region' }, $
;                { CW_PDMENU_S,       0, 'Statistics' }, $
;		{ CW_PDMENU_S,       0, 'Statistics For Whole Subset' }, $
;                { CW_PDMENU_S,       0, 'Histogram' }, $
;                { CW_PDMENU_S,       0, 'XY Graph' }, $
;                { CW_PDMENU_S,       0, 'XYZ Graph' }, $
;                { CW_PDMENU_S,       0, 'Geolocated' }, $
;		{ CW_PDMENU_S,       0, 'Contour Geolocated' }, $
;                { CW_PDMENU_S,       0, 'Create Subset' }, $
;		{ CW_PDMENU_S,	     0, 'Subsampling' }, $
;                { CW_PDMENU_S,       0, 'Regression' }, $
;                { CW_PDMENU_S,       0, 'Extract Bits' }, $
;		{ CW_PDMENU_S,       0, 'Browse Image' }, $
;		{ CW_PDMENU_S,       0, 'Browse Image With Average' }, $
;                { CW_PDMENU_S,       0, 'Transpose' }, $
;                { CW_PDMENU_S,       0, 'Display Data' }, $
;                { CW_PDMENU_S,       2, 'Display Attribute' }, $
		graph_field, $
		{ CW_PDMENU_S,       1, 'Subset' }, $
		{ CW_PDMENU_S,       0, 'Zoom' }, $
		{ CW_PDMENU_S,       0, 'Locate' }, $
		{ CW_PDMENU_S,       0, 'End Locate' }, $
		{ CW_PDMENU_S,       2, 'Select Region' } $
		]
the_menu_items= [ the_menu_items, $
                { CW_PDMENU_S,       1, 'Colors' }, $
                { CW_PDMENU_S,       0, 'Select Colors...' }, $
                { CW_PDMENU_S,       0, 'Edit Colors...' }, $
                { CW_PDMENU_S,       0, 'Load User Color Table' }, $
                { CW_PDMENU_S,       0, 'Load Discrete Color Table' }, $
                { CW_PDMENU_S,       0, 'Background' }, $
                { CW_PDMENU_S,       2, 'Foreground' }, $
;		{ CW_PDMENU_S,       1, 'Settings' }, $
;		{ CW_PDMENU_S,       0, 'Axis' }, $
;		{ CW_PDMENU_S,       0, 'Map' }, $
;		{ CW_PDMENU_S,       0, 'Grid Start' }, $
;		{ CW_PDMENU_S,       0, 'Color Bar' }, $
;		{ CW_PDMENU_S,       0, 'Style' }, $
;		{ CW_PDMENU_S,       0, 'Editor' }, $
;		{ CW_PDMENU_S,       0, 'Fill Data Value' }, $
;		{ CW_PDMENU_S,       0, 'Display Time Type' }, $
;		{ CW_PDMENU_S,       0, 'Auto Select Scale Factors' }, $
;		{ CW_PDMENU_S,       2, 'Browse Image Plot Type' } $
;		{ CW_PDMENU_S,       2, 'Misc' } $
;		]
       		{ CW_PDMENU_S,       1, 'Axis' }, $
         	{ CW_PDMENU_S,       1, 'Manual' }, $
           	{ CW_PDMENU_S,       0, 'X Only' }, $
           	{ CW_PDMENU_S,       0, 'Y Only' }, $
           	{ CW_PDMENU_S,       0, 'Z Only' }, $
           	{ CW_PDMENU_S,       0, 'XY Only' }, $
           	{ CW_PDMENU_S,       0, 'XYZ' }, $
           	{ CW_PDMENU_S,       0, 'Y2 Only' }, $
           	{ CW_PDMENU_S,       0, 'YY2 Only' }, $
           	{ CW_PDMENU_S,       0, 'XY2 Only' }, $
           	{ CW_PDMENU_S,       2, 'XYY2 Only' }, $
         	{ CW_PDMENU_S,       0, 'Auto' }, $
         	{ CW_PDMENU_S,       1, 'Grid' }, $
         	{ CW_PDMENU_S,       0, 'With XY Grid' }, $
         	{ CW_PDMENU_S,       0, 'With X Grid Only' }, $
         	{ CW_PDMENU_S,       0, 'With Y Grid Only' }, $
         	{ CW_PDMENU_S,       2, 'Without Grid' }, $
 		{ CW_PDMENU_S,       1, 'Logarithmic Axis' }, $
 		{ CW_PDMENU_S,       0, 'With Linear Axes' }, $
 		{ CW_PDMENU_S,       0, 'With Logarithmic X Axis' }, $
 		{ CW_PDMENU_S,       0, 'With Logarithmic Y Axis' }, $
 		{ CW_PDMENU_S,       0, 'With Logarithmic XY Axes' }, $
 		{ CW_PDMENU_S,       0, 'With Logarithmic Y2 Axis' }, $
 		{ CW_PDMENU_S,       0, 'With Logarithmic XY2 Axes' }, $
 		{ CW_PDMENU_S,       0, 'With Logarithmic YY2 Axes' }, $
 		{ CW_PDMENU_S,       2, 'With Logarithmic XYY2 Axes' }, $
         	{ CW_PDMENU_S,       2, '' } $
 		]
;the_menu_items= [ the_menu_items, $
;      		{ CW_PDMENU_S,       1, 'Map' }, $ 	
;      		{ CW_PDMENU_S,       1, 'Greenwich Location' }, $ 	
;        	{ CW_PDMENU_S,       0, 'Left' }, $ 
;        	{ CW_PDMENU_S,       0, 'Center' }, $ 
;        	{ CW_PDMENU_S,       2, 'Other' }, $ 
;		{ CW_PDMENU_S,       0, 'Center Location' }, $
;      		{ CW_PDMENU_S,       1, 'Projection' }, $ 	
;        	{ CW_PDMENU_S,       0, 'Cylindrical' }, $ 
;        	{ CW_PDMENU_S,       0, 'Orthographic' }, $ 
;        	{ CW_PDMENU_S,       0, 'Stereographic' }, $ 
;        	{ CW_PDMENU_S,       2, 'Hammer-Aitoff' }, $ 
;      		{ CW_PDMENU_S,       1, 'Lat-Longitude' }, $ 	
;        	{ CW_PDMENU_S,       0, 'Default' }, $ 
;        	{ CW_PDMENU_S,       2, 'Select' }, $ 
;      		{ CW_PDMENU_S,       1, 'Label' }, $ 	
;        	{ CW_PDMENU_S,       0, 'With Label' }, $ 
;        	{ CW_PDMENU_S,       2, 'Without Label' }, $ 
;      		{ CW_PDMENU_S,       1, 'Expand' }, $ 	
;        	{ CW_PDMENU_S,       0, 'With Expand' }, $ 
;        	{ CW_PDMENU_S,       2, 'Without Expand' }, $ 
;      		{ CW_PDMENU_S,       1, 'Satellite' }, $ 	
;        	{ CW_PDMENU_S,       0, 'Show Satellite' }, $ 
;        	{ CW_PDMENU_S,       2, 'Show No Satellite' }, $ 
;      		{ CW_PDMENU_S,       1, 'Sun' }, $ 	
;        	{ CW_PDMENU_S,       0, 'Show Sun' }, $ 
;        	{ CW_PDMENU_S,       2, 'Show No Sun' }, $ 
;      		{ CW_PDMENU_S,       1, 'Continents' }, $ 	
;        	{ CW_PDMENU_S,       0, 'Redraw Continents' }, $ 
;        	{ CW_PDMENU_S,       0, 'No Redraw Continents' }, $ 
;		{ CW_PDMENU_S,       2, 'Thickness' }, $
;		{ CW_PDMENU_S,       1, 'Contour Geolocated' }, $
;		{ CW_PDMENU_S,       0, 'With Smoothing' }, $
;		{ CW_PDMENU_S,       0, 'Without Smoothing' }, $
;		{ CW_PDMENU_S,       0, 'Filter With Smoothing' }, $
;		{ CW_PDMENU_S,       0, 'Filter Without Smoothing' }, $
;		{ CW_PDMENU_S,       0, 'Average With Smoothing' }, $
;		{ CW_PDMENU_S,       0, 'Average Without Smoothing' }, $
;		{ CW_PDMENU_S,       2, 'Set Number of Grids' }, $
;        	{ CW_PDMENU_S,       2, 'Reread Geolocated Data' }, $ 
;      		{ CW_PDMENU_S,       1, 'Grid Start' }, $ 	
;      		{ CW_PDMENU_S,       0, 'Auto' }, $ 	
;        	{ CW_PDMENU_S,       0, '   0' }, $ 
;        	{ CW_PDMENU_S,       0, '-180' }, $ 
;        	{ CW_PDMENU_S,       2, 'Other' } $ 
;		]
the_menu_items= [  the_menu_items, $
;     		{ CW_PDMENU_S,       1, 'Color Bar' }, $ 	
;        	{ CW_PDMENU_S,       1, 'With Color Bar' }, $ 
;        	{ CW_PDMENU_S,       0, 'Discrete' }, $ 
;        	{ CW_PDMENU_S,       2, 'Continuous' }, $ 
;        	{ CW_PDMENU_S,       0, 'Without Color Bar' }, $
;        	{ CW_PDMENU_S,       2, 'Location' }, $
       		{ CW_PDMENU_S,       1, 'Style' }, $ 	
       		{ CW_PDMENU_S,       1, 'Line Type' }, $ 	
         	{ CW_PDMENU_S,       0, 'Solid' }, $ 
         	{ CW_PDMENU_S,       0, 'Dotted' }, $ 
         	{ CW_PDMENU_S,       0, 'Dashed' }, $ 
         	{ CW_PDMENU_S,       0, 'Dashed Dot' }, $ 
         	{ CW_PDMENU_S,       0, 'Dashed Dot Dot Dot' }, $ 
         	{ CW_PDMENU_S,       2, 'Long Dashes' }, $ 
       		{ CW_PDMENU_S,       1, 'Symbol' }, $ 	
         	{ CW_PDMENU_S,       0, 'No Symbol' }, $ 
         	{ CW_PDMENU_S,       0, 'Plus sign' }, $ 
         	{ CW_PDMENU_S,       0, 'Asterisk' }, $ 
         	{ CW_PDMENU_S,       0, 'Period' }, $ 
         	{ CW_PDMENU_S,       0, 'Diamond' }, $ 
       		{ CW_PDMENU_S,       0, 'Triangle' }, $ 	
         	{ CW_PDMENU_S,       0, 'Square' }, $ 
 		{ CW_PDMENU_S,       0, 'X' }, $
 		{ CW_PDMENU_S,       0, 'Circle' }, $
 		{ CW_PDMENU_S,       0, 'FOV' }, $
 		{ CW_PDMENU_S,       0, 'Filled Triangle' }, $
 		{ CW_PDMENU_S,       0, 'Filled Square' }, $
 		{ CW_PDMENU_S,       0, 'Filled Circle' }, $
 		{ CW_PDMENU_S,       2, 'Filled FOV' }, $
       		{ CW_PDMENU_S,       1, 'Symbol With Line' }, $ 	
         	{ CW_PDMENU_S,       0, 'Without Line' }, $ 
         	{ CW_PDMENU_S,       2, 'With Line' }, $ 
         	{ CW_PDMENU_S,       0, 'Line Thickness' }, $ 
         	{ CW_PDMENU_S,       0, 'Symbol Size' }, $ 
         	{ CW_PDMENU_S,       2, 'Data Color' }, $ 
		{ CW_PDMENU_S,       1, 'Settings' }, $
                { CW_PDMENU_S,       0, 'Axis' }, $
                { CW_PDMENU_S,       0, 'Map' }, $
                { CW_PDMENU_S,       0, 'Grid Start' }, $
                { CW_PDMENU_S,       0, 'Color Bar' }, $
                { CW_PDMENU_S,       0, 'Style' }, $
                { CW_PDMENU_S,       0, 'Select Font' }, $
;               { CW_PDMENU_S,       0, 'Editor' }, $
                { CW_PDMENU_S,       0, 'Fill Data Value' }, $
                { CW_PDMENU_S,       0, 'Plot Character Size' }, $
                { CW_PDMENU_S,       0, 'Display Time Type' }, $
                { CW_PDMENU_S,       0, 'Auto Select Scale Factors' }, $
                { CW_PDMENU_S,       0, 'Using HDF 4.2r1 Version' }, $
                { CW_PDMENU_S,       0, 'Diplay Plot Result Question' }, $
                { CW_PDMENU_S,       0, 'Multiple Variables Style' }, $
                { CW_PDMENU_S,       0, '2D Image Plot' }, $
                { CW_PDMENU_S,       0, '3D Mesh Surface Array Sort' }, $
                { CW_PDMENU_S,       0, 'Browse Image Plot Type' }, $
                { CW_PDMENU_S,       2, 'Encapsulated Postscript' } $
;               { CW_PDMENU_S,       2, 'Misc' } $
 		]
;the_menu_items= [ the_menu_items, $
;      		{ CW_PDMENU_S,       1, 'Editor' }, $ 	
;        	{ CW_PDMENU_S,       0, 'VI' }, $ 
;        	{ CW_PDMENU_S,       0, 'Emacs' }, $ 
;        	{ CW_PDMENU_S,       0, 'Emacs with Xterm' }, $ 
;        	{ CW_PDMENU_S,       0, 'Ieditor' }, $ 
;        	{ CW_PDMENU_S,       0, 'Edit (PC)' }, $ 
;        	{ CW_PDMENU_S,       2, 'Other' } $  
;		]
;        	{ CW_PDMENU_S,       2, 'Other' }, $ 
;      		{ CW_PDMENU_S,       1, 'Add Criterion' }, $ 	
;        	{ CW_PDMENU_S,       0, 'With Criterion' }, $ 
;        	{ CW_PDMENU_S,       2, 'Without Criterion' } $ 
;                ]

the_menu=cw_pdmenu(this_menubar, the_menu_items, /return_full_name, $
                        FONT=info.font, UVALUE='PLOT', /mbar)

helpmenu = widget_button(this_menubar, FONT=info.font, value='Help', /MENU, /HELP)

user_guide = widget_button(helpmenu, FONT=info.font, value='User Guide', $
	uvalue='userguide')

user_guide = widget_button(helpmenu, FONT=info.font, value='Release Note', $
	uvalue='releasenote')

idlhelpbut = widget_button(helpmenu, FONT=info.font, value='IDL Online Help', $
	uvalue='IDLhelp')

;about_viewhdf_i = widget_button(helpmenu, value='About View_HDF(for CERES)...', FONT=info.font, $
;	uvalue='aboutviewhdfi')

;about_viewhdf_o = widget_button(helpmenu, value='About View_HDF(for others)...', FONT=info.font, $
;	uvalue='aboutviewhdfo')

about_viewhdf = widget_button(helpmenu, value='About View_HDF...', FONT=info.font, $
	uvalue='aboutviewhdf')

top_color = info.top_color
screen_xsize = info.screen.xsize
screen_ysize = info.screen.ysize
;if info.graph_style eq '2D Image' then begin
;x_scroll_size = screen_xsize-50
;y_scroll_size = screen_ysize-50
;draw_id=widget_draw(base, retain=2, xsize=screen_xsize,ysize=screen_ysize, $
;   x_scroll_size=x_scroll_size, y_scroll_size=y_scroll_size, colors=top_color, $
;   /SCROLL, /BUTTON_EVENTS)
;endif else begin
draw_id=widget_draw(base, retain=2, xsize=screen_xsize,ysize=screen_ysize, $
   colors=top_color, /BUTTON_EVENTS, /TRACKING_EVENTS)
;endelse

continue_show = widget_base(base, $
   /ROW, $
   MAP=1, $
   EVENT_PRO = 'show_continue', space=15)
   ;EVENT_PRO = 'show_continue', space=20)

plot_button=widget_button(continue_show, FONT=info.font, VALUE="RePlot", $
	EVENT_PRO='replot_graph', /ALIGN_CENTER)

continuebase = WIDGET_BASE(continue_show, $
   /ROW, $
   /NONEXCLUSIVE)

info.widgets.show_subset = WIDGET_BUTTON(continuebase, $
    VALUE = 'Show Subset', UVALUE = 'showcontinue', font = info.font)

addtext_button = WIDGET_BUTTON(continue_show, $
    VALUE = 'Add Text', UVALUE = 'addtext', font = info.font)

;info.widgets.charsize = CW_FIELD(continue_show, $
;    /FLOATING, /ROW, XSIZE = 10, YSIZE=1, TITLE = 'Character Size: ', $
;        UVALUE = 'charsize', VALUE = info.char.size, FONT = info.font, $
;	FIELDFONT = info.font, /RETURN_EVENTS)

subsetview_area = widget_button(continue_show, FONT=info.font, $
	EVENT_PRO='subsetview_dialogueCB', VALUE='Subset Size', $
	/ALIGN_CENTER)

info.widgets.location = widget_button(continue_show, FONT=info.font, $
	/align_center, value="Location On", event_pro='unset_location')
info.subset_locate = 0
WIDGET_CONTROL, info.widgets.location, SENSITIVE = info.subset_locate

;base1 = widget_base(base, /ROW, MAP=1, SPACE=15)

;plot_button=widget_button(base1, FONT=info.font, VALUE="RePlot", $
;	EVENT_PRO='replot_graph', /ALIGN_CENTER)
 
;subsetview_area = widget_button(base1, FONT=info.font, $
;	EVENT_PRO='subsetview_dialogueCB', VALUE='Subset Size', $
;	/ALIGN_CENTER)

;precision_button = widget_button(base1, $
;		EVENT_PRO='precision_dialogueCB', VALUE='Format', $
;		FONT=info.font, $
;                /ALIGN_CENTER)

;filldata_button = widget_button(base1, $
;                EVENT_PRO='filldata_dialogueCB', VALUE='Fill Data', $
;		FONT=info.font, $
;                /ALIGN_CENTER)

;show_list = [ 'Hours', 'Minutes', 'Seconds' ]
;info.widgets.show_time_list = widget_droplist(base1, $
;		TITLE='Time Type:', VALUE=show_list, UVALUE = info, $
;                EVENT_PRO='show_time', FONT=info.font, $
;                /ALIGN_CENTER)

;screen_size_list = [ '1024x600', '1152x614', 'Other' ]
;info.widgets.screen_size_tool = widget_droplist(base1, $
;		TITLE='Screen Size:', VALUE=screen_size_list, UVALUE = info, $
;                EVENT_PRO='screen_size', FONT=info.font, $
;                /ALIGN_CENTER)

;rotation_button = widget_button(base1, $
rotation_button = widget_button(continue_show, $
                EVENT_PRO='rotation_dialogueCB', VALUE='3D Rotation', $
		FONT=info.font, $
                /ALIGN_CENTER)

if ((info.graph_style eq '3D Graph') or (info.graph_style eq '3D Surface') $
    or (info.graph_style eq '3D Mesh Plot')  or (info.graph_style eq '3D Color Mesh Graph') $
    or (info.graph_style eq '3D Mesh Surface')) then $
        rotate_sen = 1 $
else rotate_sen = 0
WIDGET_CONTROL, rotation_button, SENSITIVE = rotate_sen

overlay_button = widget_button(continue_show, $
    EVENT_PRO='overlay_dialogueCB', VALUE='Overlay', $
    FONT=info.font, /ALIGN_CENTER)

if ((info.graph_style eq 'Geolocated') or (info.graph_style eq 'Contour Geolocated') $
    or (info.graph_style eq 'Grid Contour') or (info.graph_style eq 'Grid Contour - Region') $
    or (info.graph_style eq 'Grid Cell') or (info.graph_style eq 'Grid Cell - Region') $
    or (info.graph_style eq 'XYZ Graph') or (info.graph_style eq 'XYZ Plot') $
    or (info.graph_style eq 'Scatter Contour Plot') or (info.graph_style eq 'Browse Image') $
    or (info.graph_style eq 'Browse Image With Average') or (info.graph_style eq 'Vertical Feature Mask')) $
    then overlay_sen = 1 else overlay_sen = 0
WIDGET_CONTROL, overlay_button, SENSITIVE = overlay_sen

info.widgets.stop = widget_button(continue_show, EVENT_PRO='stop_dialogueCB', VALUE='Stop', $
    FONT=info.font, /ALIGN_CENTER)

pausebase = WIDGET_BASE(continue_show, /ROW, /NONEXCLUSIVE)

info.widgets.pause = WIDGET_BUTTON(pausebase, EVENT_PRO='pause_dialogueCB', VALUE = 'Pause', $
    font = info.font)

if ((info.graph_style eq 'Geolocated') or (info.graph_style eq 'Grid Cell') $
    or (info.graph_style eq 'Grid Cell - Region') $
    or (info.graph_style eq 'XYZ Graph') or (info.graph_style eq 'XYZ Plot') $
    or (info.graph_style eq 'Browse Image') $
    or (info.graph_style eq 'Browse Image With Average') $
    or (info.graph_style eq 'Vertical Feature Mask')) $
    then stop_sen = 1 else stop_sen = 0
WIDGET_CONTROL, info.widgets.stop, SENSITIVE = stop_sen
WIDGET_CONTROL, info.widgets.pause, SENSITIVE = stop_sen

widget_control, /realize, base

;widget_control, info.widgets.show_time_list, set_droplist_select=info.time_type.new
;widget_control, info.widgets.screen_size_tool, set_droplist_select=info.screen.pick
widget_control, draw_id, GET_VALUE=window_id
info.widgets.base = base
info.sview.window_id = window_id

widget_control, set_uvalue=info, info.widgets.base
widget_control, set_uvalue=info, info.base
widget_control, set_uvalue=info, base

xmanager, 'main_widget', base

end

;------------------------------------------------------------------
pro set_statistics_subset, name_of_data, this_subset, the_rank, info, subset_data

pro_name = 'set_statistics_subset'
@getinfo

if (info.subset.count lt info.subset.maximum) then begin
   subset_name=name_of_data + '[' + strcompress(string(info.subset.count)) +']'
   if info.vgroup.flag eq 1 then $
	subset_name = get_vgroup_name(subset_name,info)
   info = redefine_info(info, subset_name, 3)
   widget_control, info.widgets.subset_list, set_value=info.name_list_subset
   info.subset.count=info.subset.count+1
   info.subset.data(info.subset.count-1).subset_name = string(subset_name)
   info.subset.data(info.subset.count-1).src_filename = info.subset.data(this_subset).src_filename
   dot=strpos(name_of_data, 'Number sample of')
   if( dot ne -1) then begin
	info.subset.data(info.subset.count-1).src_unitname = ''
   endif else begin
	info.subset.data(info.subset.count-1).src_unitname = info.subset.data(this_subset).src_unitname
   endelse
   if info.graph_style eq 'Statistics' then begin
        info.subset.data(info.subset.count-1).src_type_flag = 0
   endif else begin
        info.subset.data(info.subset.count-1).src_type_flag = info.subset.data(this_subset).src_type_flag
   endelse
   if info.criterion.flag eq 1 then begin
	info.subset.data(info.subset.count-1).src_crit_flag = 1			
	temp_string = info.subset.data(this_subset).src_crit_name
	string_length = strlen(temp_string)
	if string_length gt 5 then begin
		temp_string = temp_string + '|'
		temp_string = temp_string + info.criterion.name
		info.subset.data(info.subset.count-1).src_crit_name = temp_string
		temp_string = info.subset.data(this_subset).src_crit_min
		temp_string = temp_string + '|'
		temp_string = temp_string + strcompress(string(info.criterion.min), /REMOVE_ALL)
		info.subset.data(info.subset.count-1).src_crit_min = temp_string
		temp_string = info.subset.data(this_subset).src_crit_max
		temp_string = temp_string + '|'
		temp_string = temp_string + strcompress(string(info.criterion.max), /REMOVE_ALL)
		info.subset.data(info.subset.count-1).src_crit_max = temp_string
		temp_string = info.subset.data(this_subset).src_crit_type
		temp_string = temp_string + '|'
		temp_string = temp_string + strcompress(string(info.criterion.type), /REMOVE_ALL)
		info.subset.data(info.subset.count-1).src_crit_type = temp_string
	endif else begin
		info.subset.data(info.subset.count-1).src_crit_name = info.criterion.name			
		info.subset.data(info.subset.count-1).src_crit_min = strcompress(string(info.criterion.min), /REMOVE_ALL)
		info.subset.data(info.subset.count-1).src_crit_max = strcompress(string(info.criterion.max), /REMOVE_ALL)
		info.subset.data(info.subset.count-1).src_crit_type = strcompress(string(info.criterion.type), /REMOVE_ALL)
	endelse
   endif else begin
	info.subset.data(info.subset.count-1).src_crit_flag = info.subset.data(this_subset).src_crit_flag
	info.subset.data(info.subset.count-1).src_crit_name = info.subset.data(this_subset).src_crit_name
	info.subset.data(info.subset.count-1).src_crit_min = info.subset.data(this_subset).src_crit_min
	info.subset.data(info.subset.count-1).src_crit_max = info.subset.data(this_subset).src_crit_max
	info.subset.data(info.subset.count-1).src_crit_type = info.subset.data(this_subset).src_crit_type
   endelse

   if info.subset.data(info.subset.count-1).src_type_flag eq 0 then begin
	num_output_data = n_elements(subset_data)
   endif else  begin
	num_output_data = n_elements(subset_data.components0)
   endelse

   info.subset.data(info.subset.count-1).src_num = num_output_data

   info.subset.data(info.subset.count-1).src_ref = info.subset.data(this_subset).src_ref
   true_rank = info.subset.data(this_subset).src_rank
   info.subset.data(info.subset.count-1).src_rank = the_rank
   if the_rank eq 1 and true_rank eq 2 then begin
	info.subset.data(info.subset.count-1).src_start(0) = info.subset.data(this_subset).src_start(1)
	info.subset.data(info.subset.count-1).src_end(0) = info.subset.data(this_subset).src_end(1)
	info.subset.data(info.subset.count-1).src_increment(0) = info.subset.data(this_subset).src_increment(1)
	info.subset.data(info.subset.count-1).src_start(1) = info.subset.data(this_subset).src_start(0)
	info.subset.data(info.subset.count-1).src_end(1) = info.subset.data(this_subset).src_end(0)
	info.subset.data(info.subset.count-1).src_increment(1) = info.subset.data(this_subset).src_increment(0)
   endif else begin
	info.subset.data(info.subset.count-1).src_start = info.subset.data(this_subset).src_start
	info.subset.data(info.subset.count-1).src_end = info.subset.data(this_subset).src_end
	info.subset.data(info.subset.count-1).src_increment = info.subset.data(this_subset).src_increment
   endelse
   info.subset.data(info.subset.count-1).src_org_rank = info.subset.data(this_subset).src_org_rank
   info.subset.data(info.subset.count-1).src_org_start = info.subset.data(this_subset).src_org_start
   info.subset.data(info.subset.count-1).src_org_end = info.subset.data(this_subset).src_org_end
   if info.subset.data(info.subset.count-1).src_type_flag eq 0 and $
	info.subset.data(this_subset).src_type_flag eq 1 then $
		info.subset.data(info.subset.count-1).src_org_end(0) = $
			info.subset.data(info.subset.count-1).src_org_end(0) + 1
   if info.graph_style eq 'Transpose' then begin
	if info.subset.data(this_subset).src_transpose eq 0 then begin
		info.subset.data(info.subset.count-1).src_transpose = 1
	endif else info.subset.data(info.subset.count-1).src_transpose = 0
	temp1 = info.subset.data(info.subset.count-1).src_start(0)
	temp2 = info.subset.data(info.subset.count-1).src_end(0)
	temp3 = info.subset.data(info.subset.count-1).src_increment(0)
	info.subset.data(info.subset.count-1).src_start(0) = info.subset.data(info.subset.count-1).src_start(1)
	info.subset.data(info.subset.count-1).src_end(0) = info.subset.data(info.subset.count-1).src_end(1)
	info.subset.data(info.subset.count-1).src_increment(0) = info.subset.data(info.subset.count-1).src_increment(1)
	info.subset.data(info.subset.count-1).src_start(1) = temp1
	info.subset.data(info.subset.count-1).src_end(1) = temp2
	info.subset.data(info.subset.count-1).src_increment(1) = temp3
	;temp1 = info.subset.data(info.subset.count-1).src_org_start(0)
	;temp2 = info.subset.data(info.subset.count-1).src_org_end(0)
	;info.subset.data(info.subset.count-1).src_org_start(0) = info.subset.data(info.subset.count-1).src_org_start(1)
	;info.subset.data(info.subset.count-1).src_org_end(0) = info.subset.data(info.subset.count-1).src_org_end(1)
	;info.subset.data(info.subset.count-1).src_org_start(1) = temp1
	;info.subset.data(info.subset.count-1).src_org_end(1) = temp2
   endif else begin
	info.subset.data(info.subset.count-1).src_transpose = info.subset.data(this_subset).src_transpose
   endelse
   info.subset.data(info.subset.count-1).src_org_increment = info.subset.data(this_subset).src_org_increment
   info.subset.data(info.subset.count-1).src_fnames = info.subset.data(this_subset).src_fnames
   info.subset.data(info.subset.count-1).src_types(0) = info.subset.data(this_subset).src_types(0)
   if info.graph_style eq 'Y1Y2 Compute' or info.graph_style eq 'Y1 Compute'  then $
	info.subset.data(info.subset.count-1).src_types(0) = 6
   if info.graph_style eq 'Extract Bits'  then $
	info.subset.data(info.subset.count-1).src_types(0) = 24
   info.subset.data(info.subset.count-1).src_order = info.subset.data(this_subset).src_order
   if ptr_valid(info.subset.data(info.subset.count-1).src_data) then begin
	*info.subset.data(info.subset.count-1).src_data = subset_data
   endif else begin
	info.subset.data(info.subset.count-1).src_data = ptr_new(subset_data)
   endelse
   
   if ptr_valid(info.subset.data(this_subset).src_time) then begin
	if ptr_valid(info.subset.data(info.subset.count-1).src_time) then begin
	    *info.subset.data(info.subset.count-1).src_time = $
		*info.subset.data(this_subset).src_time
	endif else begin
	    info.subset.data(info.subset.count-1).src_time = $
		ptr_new(*info.subset.data(this_subset).src_time)
	endelse
   endif
   widget_control, set_uvalue=info, info.base

   save_list = redefine_save_list(info)
   widget_control, set_uvalue=save_list, info.list_base
endif else begin
   the_message = ["You have maximum sets of data", "Please remove at least one set of data."]
       result=dialog_message(the_message, title='View HDF Warning!')
   return
endelse
	
end

;------------------------------------------------------------------
pro set_curvefields_event, event

pro_name = 'set_curvefields_event'
@getinfo

widget_control, get_uvalue=info, event.top
widget_control, get_uvalue=info, info.base 

heading = str_sep(event.value, '.')
num_heading = n_elements(heading)
if num_heading gt 2 then begin
	length = strlen(event.value)
	dot=strpos(event.value,'.')
	if( dot ne -1) then begin
		field_name = strmid(event.value,dot+1,length-dot-1)
	endif else begin
		field_name = event.value
	endelse
endif else if num_heading eq 1 then begin
	field_name = heading(0)
endif else field_name = heading(1)

CASE heading(0) of

	'X Field Selection' : begin
		info.field_name.x = field_name
       		widget_control, info.widgets.xfield, set_value=field_name
	end

	'Y Field Selection' : begin
		info.field_name.y = field_name
       		widget_control, info.widgets.yfield, set_value=field_name
	end

	else: begin
		ON_IOERROR, problem
		test = float(event.value)
		info.field_name.z = event.value
		problem: ON_IOERROR,NULL
	end

ENDCASE

widget_control, set_uvalue=info, info.base

end

;------------------------------------------------------------------
pro check_constant, event

pro_name = 'check_constant'
@getinfo

widget_control, get_uvalue=info, event.top
widget_control, get_uvalue=info, info.base 

if info.field_name.x eq 'Constant' then begin
	widget_control, info.widgets.xfield, get_value=y_value
	y_value = y_value(0)
	y_value = float(y_value)
	diff = abs(info.y1y2.cons_value1 - y_value)
	if diff gt 0.0001 then info.y1y2.cons_value1 = y_value
endif

if info.field_name.y eq 'Constant' then begin
	widget_control, info.widgets.yfield, get_value=y_value
	y_value = y_value(0)
	y_value = float(y_value)
	diff = abs(info.y1y2.cons_value2 - y_value)
	if diff gt 0.0001 then info.y1y2.cons_value2 = y_value
endif

widget_control, set_uvalue=info, info.base

widget_control, event.top, /destroy

end

;------------------------------------------------------------------
pro set_xyzfields_event, event

pro_name = 'set_xyzfields_event'
@getinfo

if TAG_NAMES(event,/structure_name) eq 'WIDGET_TRACKING' then return
widget_control, get_uvalue=info, event.top
widget_control, get_uvalue=info, info.base 

heading = str_sep(event.value, '.')
num_heading = n_elements(heading)
if num_heading gt 2 then begin
	length = strlen(event.value)
	dot=strpos(event.value,'.')
	if( dot ne -1) then begin
		field_name = strmid(event.value,dot+1,length-dot-1)
	endif else begin
		field_name = event.value
	endelse
endif else if num_heading eq 1 then begin
	field_name = heading(0)
endif else field_name = heading(1)

CASE heading(0) of

	'X Field Selection' : begin
		info.field_name.x = field_name
       		widget_control, info.widgets.xfield, set_value=field_name
	end

	'Y Field Selection' : begin
		info.field_name.y = field_name
       		widget_control, info.widgets.yfield, set_value=field_name
	end

	'Z Field Selection' : begin
		info.field_name.z = field_name
       		widget_control, info.widgets.zfield, set_value=field_name
	end

	'Y1 Field Selection' : begin
		info.field_name.x = field_name
       		widget_control, info.widgets.xfield, set_value=field_name
		if field_name eq 'Constant' then begin
			info.y1y2.cons_value1 = 0
			get_constant_value, info, 1
			widget_control, get_uvalue=info, info.base
			if info.canceloption eq 'Yes' then begin
				info.canceloption = 'No'
				info.field_name.x = 'None'
				widget_control, info.widgets.xfield, set_value='None'
			endif else begin
				y_value = strcompress(string(info.y1y2.cons_value1))
				widget_control, info.widgets.xfield, set_value=y_value
			endelse
		endif
	end

	'Y2 Field Selection' : begin
		info.field_name.y = field_name
       		widget_control, info.widgets.yfield, set_value=field_name
		if field_name eq 'Constant' then begin
			info.y1y2.cons_value2 = 0
			get_constant_value, info, 2
			widget_control, get_uvalue=info, info.base
			if info.canceloption eq 'Yes' then begin
				info.canceloption = 'No'
				info.field_name.y = 'None'
				widget_control, info.widgets.yfield, set_value='None'
			endif else begin
				y_value = strcompress(string(info.y1y2.cons_value2))
				widget_control, info.widgets.yfield, set_value=y_value
			endelse
		endif
	end

	else: begin
		ON_IOERROR, problem
		test = float(event.value)
		widget_control, get_uvalue=cons_id, event.id
		set_constant,info,cons_id
		problem: ON_IOERROR,NULL
	end

ENDCASE

widget_control, set_uvalue=info, info.base

end

;------------------------------------------------------------------
pro plot_setup, info, value, xflag, yflag, zflag

pro_name = 'plot_setup'
@getinfo

base_loc = widget_info(info.base, /geometry)
xoffset = base_loc.xoffset + 100
if(info.graph_style eq 'Y1Y2 Compute') then begin
	base=widget_base( GROUP_LEADER=info.base, /MODAL, COLUMN=1, MAP=1, $
		TITLE='Select Operands', uvalue=info, XOFFSET=xoffset)
endif else if(info.graph_style eq 'Y1 Compute') then begin
	base=widget_base( GROUP_LEADER=info.base, /MODAL, COLUMN=1, MAP=1, $
		TITLE='Select Operand', uvalue=info, XOFFSET=xoffset)
endif else if(info.graph_style eq 'Load User Color Table') then begin
	base=widget_base( GROUP_LEADER=info.base, /MODAL, COLUMN=1, MAP=1, $
		TITLE='Select RGB Fields', uvalue=info, XOFFSET=xoffset)
endif else if(info.graph_style eq 'Load Discrete Color Table') then begin
	base=widget_base( GROUP_LEADER=info.base, /MODAL, COLUMN=1, MAP=1, $
		TITLE='Select RGB Fields', uvalue=info, XOFFSET=xoffset)
endif else begin
	base=widget_base( GROUP_LEADER=info.base, /MODAL, COLUMN=1, MAP=1, $
		TITLE='Select Plot Fields', uvalue=info, XOFFSET=xoffset)
endelse

x_group=widget_base(base, row=1,map=1)
if info.y1y2.tri_flag gt 0 then begin
    t1_group=widget_base(base, row=1,map=1)
    t2_group=widget_base(base, row=1,map=1)
    t3_group=widget_base(base, row=1,map=1)
endif
y_group=widget_base(base, row=1, map=1)
z_group=widget_base(base, row=1, map=1)

if(info.graph_style eq 'Y1Y2 Compute') then begin
    if info.y1y2.tri_flag eq 0 then begin
	create_y1y2_fields, x_field, y_field, x_group, y_group, $
		xflag, yflag, info
    endif else begin
	create_y1tri_fields, x_field, y_field, x_group, y_group, $
		xflag, yflag, info, t1_group, t2_group
    endelse
endif else if(info.graph_style eq 'Y1 Compute') then begin
	create_y1y2_fields, x_field, y_field, x_group, y_group, $
		xflag, yflag, info
endif else if(info.graph_style eq 'Load User Color Table') then begin
	create_rgb_fields, x_field, y_field, z_field, x_group, $
		y_group, z_group, xflag, yflag, zflag, info
endif else if(info.graph_style eq 'Load Discrete Color Table') then begin
	create_rgb_fields, x_field, y_field, z_field, x_group, $
		y_group, z_group, xflag, yflag, zflag, info
endif else begin
	create_xyz_fields, x_field, y_field, z_field, x_group, $
		y_group, z_group, xflag, yflag, zflag, info
endelse

if(info.graph_style eq 'XY Graph') then begin
  x_axis_list = [ 'Time', 'Sample Number', 'Record Number',  $
		  'Packet Number - Relative', 'Packet Number - Absolute', $
		  'Select Variable' ]
  get_parameter_names, x_fields, y_fields, z_fields, xflag, yflag, zflag,$
	x_axis_list
endif else if(info.graph_style eq 'Y1Y2 Compute') then begin
  y1y2_list = [info.name_list_subset, 'Constant']
  get_y1y2_parameter_names, x_fields, y_fields, xflag, yflag, $
	y1y2_list
endif else if(info.graph_style eq 'Y1 Compute') then begin
  y1y2_list = info.name_list_subset
  get_y1y2_parameter_names, x_fields, y_fields, xflag, yflag, $
	y1y2_list
endif else if(info.graph_style eq 'Browse Image' or $
    info.graph_style eq 'Browse Image With Average') then begin
	get_browse_parameter_names, x_fields, y_fields, xflag, yflag, $
	    info.name_list_subset
endif else if(info.graph_style eq 'Load User Color Table') then begin
    rgb_list = [info.name_list_subset, 'None']
    get_rgb_parameter_names, x_fields, y_fields, z_fields, xflag, yflag, zflag,$
	rgb_list
;	info.name_list_subset
endif else if(info.graph_style eq 'Load Discrete Color Table') then begin
    rgb_list = [info.name_list_subset, 'None']
    get_rgb_parameter_names, x_fields, y_fields, z_fields, xflag, yflag, zflag,$
	rgb_list
;	info.name_list_subset
endif else begin
  get_parameter_names, x_fields, y_fields, z_fields, xflag, yflag, zflag,$
	info.name_list_subset
endelse

make_xyz_buttons, x_fields, y_fields, z_fields, x_group, y_group, z_group,$
        base, xflag, yflag, zflag

widget_control, set_uvalue=info, base  
widget_control,/realize, base

XMANAGER, 'set_xyzfields', base

END

;--------------------------------------------------------------------------------
pro precisionCB, event

pro_name = 'precisionCB'
@getinfo

widget_control, get_uvalue=info, event.top

precision=''
widget_control, info.widgets.precision, get_value=precision

info.precision=precision(0)
print,'Format=',info.precision

if(widget_info(info.widgets.base, /VALID_ID)) then $
	widget_control, set_uvalue=info, info.widgets.base
widget_control, set_uvalue=info, info.base

widget_control, event.top, /destroy

end

;--------------------------------------------------------------------------------
pro precision_dialogueCB, event

pro_name = 'precision_dialogueCB'
@getinfo

widget_control, get_uvalue=info, event.top

base = widget_base(COLUMN=1, MAP=1, TITLE='Define Exporting Format')

p_group=widget_base(base, row=1,map=1)

info.widgets.precision = CW_FIELD(p_group, VALUE=info.precision, $
		ROW=1, STRING=1, FIELDFONT=info.font, $
		FONT=info.font, TITLE='Format:', XSIZE=40)

group2=widget_base(base, row=1,map=1, space=40, /align_center)

button1=widget_button(group2, FONT=info.font, EVENT_PRO='precisionCB', VALUE="Done",$
	/ALIGN_CENTER)

button2=widget_button(group2, FONT=info.font, EVENT_PRO='doneCB', VALUE="Cancel",$
	 /ALIGN_CENTER)

widget_control, /realize, base

widget_control, set_uvalue=info, base
widget_control, set_uvalue=info, info.base

end

;------------------------------------------------------------------
;	quality_done	
;------------------------------------------------------------------
PRO quality_done, Event

pro_name = 'quality_done'
@getinfo

	widget_control, get_uvalue=info, event.top
	widget_control,event.top,/destroy

	font1=info.font

if (info.subset.count lt info.subset.maximum) then begin

	;-----------------------------------
	; Ask the user to Subset the data
	;-----------------------------------

	subset_name=info.quality.name_sel + '[' + strcompress(string(info.subset.count)) +']'

	if info.rangetype.type eq 1 then begin
	   info.rangetype.flag=0
	   get_time_range, subset_name, info.sds.rank-1, info
	   widget_control, get_uvalue=info, info.base
	   if info.canceloption eq 'Yes' then begin
		info.canceloption = 'No'
		widget_control, set_uvalue=info, info.base
		return
	   endif 
	   if info.rangetype.flag eq 0 then begin
		info.rangetype.type = 0
		widget_control, info.rangetype.widget, set_droplist_select=info.rangetype.type
	   endif
	endif

	if info.rangetype.type eq 0 or info.rangetype.flag eq 1 then $
	  record_range_buttons, subset_name, info.sds.rank-1, 'quality_subset_done', info $
	else return

	widget_control, set_uvalue=info, info.base

endif else begin
        the_message = ["You have maximum sets of data", "Please remove at least one set of data."]
        result=dialog_message(the_message, title='View HDF Warning!')
        return
endelse

END

;------------------------------------------------------------------
;	quality_subset_done
;------------------------------------------------------------------
pro quality_subset_done, Event

pro_name = 'quality_subset_done'
@getinfo
 
	widget_control, /hourglass
	widget_control, get_uvalue=info, event.id

	start_list=lonarr(info.sds.rank)
	end_list=lonarr(info.sds.rank)
	increment_list=lonarr(info.sds.rank)

if info.rangetype.type eq 1 and info.rangetype.flag eq 0 then begin
   start_list(*) = 0
   end_list = info.sds.dims(*)
   increment_list(*) = 1
   time_record = *info.rangetype.time
   start_time = ' '
   end_time = ' '
   widget_control, info.widgets.start_time, get_value=start_time
   widget_control, info.widgets.end_time, get_value=end_time
   starttime = make_second_time(start_time) - 1
   endtime = make_second_time(end_time) + 1
   if (starttime gt endtime) then begin
	the_message=['The start time is greater than end time.', $
		'Please, check the time and input it again.']
	result=dialog_message(the_message, title='View HDF Warning!')
	return
   endif

   subscript=where((time_record ge starttime) and (time_record le endtime), count)
   if(count lt 2) then begin
	the_message=['There are no records in the time range!', $
		'Please, check the time and do it again.']
	result=dialog_message(the_message, title='View HDF Warning!')
	return
   endif

   start_list(0) = subscript(0)
   end_list(0) = subscript(count-1) + 1
   
endif else begin
	for i=0,(info.sds.rank-1) do begin
		widget_control,info.widgets.starting_field(i),get_value=this_start
		widget_control,info.widgets.ending_field(i),get_value=this_end
		widget_control,info.widgets.increment_field(i),get_value=this_increment

		start_list(i)=this_start - 1
		if start_list(i) lt 0 then start_list(i) = 0L
		end_list(i)=this_end
		increment_list(i)=this_increment
	endfor

endelse

	info.rangetype.old_start(0:info.sds.rank-1) = start_list(0:info.sds.rank-1) + 1
	info.rangetype.old_end(0:info.sds.rank-1) = end_list(0:info.sds.rank-1)
	info.rangetype.old_increment(0:info.sds.rank-1) = increment_list(0:info.sds.rank-1)
	info.rangetype.old_dim(0:info.sds.rank-1) = info.sds.dims(0:info.sds.rank-1)

	;-------------------------------
	; Get values from the widgets
	;-------------------------------
	widget_control,info.widgets.current_file,get_value=filename
	filename=filename(0)

	;the_count=long((end_list-start_list)/float(increment_list) + 0.9)
	the_count=long((end_list-start_list-1)/float(increment_list) + 1.0)
	total_number = the_count(0)
	if info.sds.rank gt 1 then begin
	   for i = 1 , (info.sds.rank - 1) do begin
		total_number = total_number * the_count(i)
	   endfor
	endif

	output_data = lonarr(total_number)

	output_data = reform(output_data, the_count(1), the_count(0))

	quality_nrec = info.sds.dims(0)
	check_name = info.name_list_sds(info.sds.index)
	check_name = check_name(0)

       	CD, '.', CURRENT = PWD

       	;the_result = CALL_EXTERNAL(PWD+'/' + info.library,   $
       	the_result = CALL_EXTERNAL(info.library,   $
       		'get_quality_flags',  		$
        	filename, 			$
		check_name(0),			$
		info.quality.indices_sel,	$
		quality_nrec,			$
              	info.sds.rank, 			$
		start_list,			$
		end_list,			$
		increment_list,			$
		the_count,			$
		output_data)

		if (the_result eq -1) then begin
			result=dialog_message('Problem reading quality flags!',$
			title='View HDF Warning!')
			return
		endif

		org_rank = info.sds.rank
		org_start = start_list
		org_end = end_list
		org_increment = increment_list
		true_start = start_list(0)
		true_end = end_list(0)
		num_start_list = n_elements(start_list)
		output_data = reform(output_data)
		sizedata_new = size(output_data)
		if num_start_list ne sizedata_new(0) then begin
		  start_list_old = start_list
		  end_list_old = end_list
		  increment_list_old = increment_list
		  j = 0
		  for i=0, num_start_list-1 do begin
			num_elem = end_list_old(i) - start_list_old(i)
			if(num_elem ne 1) then begin
			   start_list(j) = start_list_old(i)
			   end_list(j) = end_list_old(i)
			   increment_list(j) = increment_list_old(i)
			   j = j + 1
			endif
		   endfor
		   if j eq 0 then j = 1
		   info.sds.rank = j
		   start_list = start_list(0:j-1)
		   end_list = end_list(0:j-1)
		   increment_list = increment_list(0:j-1)
		endif

		sizedata_old = size(output_data)
		if sizedata_old(0) lt info.sds.rank then begin
		  start_list_old = start_list
		  end_list_old = end_list
		  increment_list_old = increment_list
		  j = 0
		  for i=0, info.sds.rank-1 do begin
			if(end_list_old(i) - start_list_old(i) ne 1) then begin
			   start_list(j) = start_list_old(i)
			   end_list(j) = end_list_old(i)
			   increment_list(j) = increment_list_old(i)
			   j = j + 1
			endif
		   endfor
		   if j eq 0 then j = 1
		   info.sds.rank = j
		   start_list = start_list(0:j-1)
		   end_list = end_list(0:j-1)
		   increment_list = increment_list(0:j-1)
		endif

	;-----------------------------------------------------------
	; You must reference the data in the dialog before you
	; blow it away!!
	;-----------------------------------------------------------
	widget_control,info.widgets.subset_name,get_value=temp_name
	temp_name=temp_name(0)
	if info.vgroup.flag eq 1 then $
		temp_name = get_vgroup_name(temp_name,info)

	info = redefine_info(info, temp_name, 3)

	widget_control,info.widgets.subset_list,set_value=info.name_list_subset
	widget_control,event.top,/destroy

	num_output_data = n_elements(output_data)

	;-----------------------------------------
	; Define the data in the structure
	;-----------------------------------------
	info.subset.count=info.subset.count+1
	info.subset.data(info.subset.count-1).subset_name=string(temp_name)
	info.subset.data(info.subset.count-1).src_filename=filename
	info.subset.data(info.subset.count-1).src_unitname=''
	info.subset.data(info.subset.count-1).src_type_flag=0			
	info.subset.data(info.subset.count-1).src_crit_flag = 0
	info.subset.data(info.subset.count-1).src_crit_name = ''
	info.subset.data(info.subset.count-1).src_crit_min = ''
	info.subset.data(info.subset.count-1).src_crit_max = ''
	info.subset.data(info.subset.count-1).src_crit_type = ''
	info.subset.data(info.subset.count-1).src_num = num_output_data
	info.subset.data(info.subset.count-1).src_ref = info.sds.ref
	info.subset.data(info.subset.count-1).src_rank=info.sds.rank
	info.subset.data(info.subset.count-1).src_start=start_list
	info.subset.data(info.subset.count-1).src_end=end_list
	info.subset.data(info.subset.count-1).src_increment=increment_list
	info.subset.data(info.subset.count-1).src_org_rank=org_rank
	info.subset.data(info.subset.count-1).src_org_start=org_start
	info.subset.data(info.subset.count-1).src_org_end=org_end
	info.subset.data(info.subset.count-1).src_org_increment=org_increment
	info.subset.data(info.subset.count-1).src_types(0)=info.sds.type
	info.subset.data(info.subset.count-1).src_start(info.sds.rank)=true_start
	info.subset.data(info.subset.count-1).src_end(info.sds.rank)=true_end

	if ptr_valid(info.subset.data(info.subset.count-1).src_data) then begin
	    *info.subset.data(info.subset.count-1).src_data=output_data
	endif else begin
	    info.subset.data(info.subset.count-1).src_data = ptr_new(output_data)
	endelse

	if ptr_valid(info.rangetype.time) then begin
	    if ptr_valid(info.subset.data(info.subset.count-1).src_time) then begin
		*info.subset.data(info.subset.count-1).src_time=*info.rangetype.time
	    endif else begin
		info.subset.data(info.subset.count-1).src_time= ptr_new(*info.rangetype.time)
	    endelse
	endif

	info.rangetype.flag = 0

	widget_control, info.widgets.sds, set_list_select=-1
	widget_control, set_uvalue=info, info.base

	save_list = redefine_save_list(info)
        widget_control, set_uvalue=save_list, info.list_base

end

;--------------------------------------------------------------------------------
pro record_range_buttons, subset_name, rank, event_pro, info

pro_name = 'record_range_buttons'
@getinfo

length = strlen(info.rangetype.dim_name)
if n_elements(length) gt 1 then begin
	max_length = max(length)
endif else max_length = length

;xsize = (max_length + 1) * 8
num_char = max_length + 1
xsize = float(fix(num_char/6) + 1.0) * 0.5
if xsize gt 3.0 then xsize = 3.0
if info.device eq 'X' then begin
	label_size = 2.3
endif else begin
	label_size = 1.9
endelse

base_loc = widget_info(info.base, /geometry)
xoffset = base_loc.xoffset
yoffset = base_loc.yoffset + 100

base=widget_base(group_leader=info.base, /modal, column=1, map=1, $
    xoffset=xoffset, yoffset=yoffset, TITLE='Subset Data', uvalue=info)

;base = widget_base( COLUMN=1, MAP=1, TITLE='Subset Data', uvalue=info)

info.widgets.subset_name=CW_FIELD(base, VALUE=subset_name, $
                ROW=1, STRING=1, FIELDFONT=info.font, FONT=info.font, $
                TITLE='Subset Name:', XSIZE=50)

label_group = widget_base(base, row=1, map=1, space=30)

name_button = widget_label(label_group, /ALIGN_CENTER, FONT=info.font, $
	value=' ', units=1, xsize=xsize)

start_button = widget_label(label_group, /ALIGN_CENTER, FONT=info.font, $
	value='Starting', units=1, xsize=label_size)

end_button = widget_label(label_group, /ALIGN_CENTER, FONT=info.font, $
	value='Ending', units=1, xsize=label_size)

increment_button = widget_label(label_group, /ALIGN_CENTER, FONT=info.font, $
	value='Increment', units=1, xsize=label_size)
	
for i=0,rank do begin

	if (info.rangetype.old_increment(i) eq 0) or $
	    (info.rangetype.old_dim(i) ne info.sds.dims(i)) then begin
		vstart = 1
		vend = info.sds.dims(i)
		vincre = 1
	endif else begin
		if info.rangetype.old_start(i) gt info.sds.dims(i) then $
			vstart = 1 $
		else vstart = info.rangetype.old_start(i)
		if info.rangetype.old_end(i) gt info.sds.dims(i) then $
			vend = info.sds.dims(i) $
		else vend = info.rangetype.old_end(i)
		if info.rangetype.old_increment(i) gt info.sds.dims(i) then $
			vincre = 1 $
		else vincre = info.rangetype.old_increment(i)
	endelse
	if info.ssf.file eq 1 then begin 
	   if info.ssf.key eq 1 then begin
		if i eq rank then begin
			vstart = info.ssf.select
			vend = info.ssf.select
		endif else if i eq rank-1 then begin
			if info.ssf.layer ne 0 then begin
				vstart = info.ssf.layer
				vend = info.ssf.layer
			endif
		endif
	   endif else if info.ssf.key eq 2 then begin
		if i eq rank and info.ssf.layer ne 0 then begin
			vstart = info.ssf.layer
			vend = info.ssf.layer
		endif
	   endif
	endif
				
	if info.rangetype.type eq 1 and info.rangetype.flag eq 1 then begin
		if i eq 0 then begin
			vstart = info.rangetype.start_rec
			if vstart gt info.sds.dims(0) then $
				vstart = 1
			vend = info.rangetype.end_rec
			if vend gt info.sds.dims(0) then $
				vend = info.sds.dims(0)
		endif
	endif

        group1=widget_base(base, row=1,map=1, space=30)

	dim_name = info.rangetype.dim_name(i) + ':'
	name_button = widget_label(group1, /ALIGN_CENTER, FONT=info.font, $
		value=dim_name, units=1, xsize=xsize)

        info.widgets.starting_field(i)= CW_FIELD(group1,VALUE=vstart, $
                        ROW=1, /long, FIELDFONT=info.font, FONT=info.font, $
                        TITLE=' ',XSIZE=20)

        info.widgets.ending_field(i)= CW_FIELD(group1,VALUE=vend, $
                        ROW=1, /long, FIELDFONT=info.font, FONT=info.font, $
                        TITLE=' ',XSIZE=20)

        info.widgets.increment_field(i)= CW_FIELD(group1,VALUE=vincre, $
                        ROW=1, /long, FIELDFONT=info.font, FONT=info.font, $
                        TITLE=' ',XSIZE=20)

endfor

        group2=widget_base(base, row=1,map=1, space=100, /align_center)

	button1=widget_button(group2, FONT=info.font, EVENT_PRO=event_pro, VALUE="Done",$
				 /ALIGN_CENTER, uvalue=info)

	button2=widget_button(group2, FONT=info.font, EVENT_PRO='reset_range', VALUE="Reset",$
				 /ALIGN_CENTER, uvalue=rank)

	button3=widget_button(group2, FONT=info.font, EVENT_PRO='doneCB', VALUE="Cancel",$
				 /ALIGN_CENTER, uvalue=info)

widget_control, /realize, base 
widget_control, set_uvalue=info, base

end

;--------------------------------------------------------------------------------
pro time_range_buttons, subset_name, event_pro, info

pro_name = 'time_range_buttons'
@getinfo

if info.rangetype.get_time eq 0 then get_time, info, 1

time_record = *info.rangetype.time
n_time_record = n_elements(time_record)

if n_time_record lt 2 then begin
	result=dialog_message('Problem assigning time variable!',$
		title='View HDF Warning!')
	return
endif

start_time = ' '
end_time = ' '

start_time= make_string_time(time_record(0),info.rangetype.julian, julian_start_time)
end_time = make_string_time(time_record(n_time_record-1), info.rangetype.julian, julian_end_time)

base = widget_base( COLUMN=1, MAP=1, TITLE='Subset Data', uvalue=info)

info.widgets.subset_name=CW_FIELD(base, VALUE=subset_name, $
                ROW=1, STRING=1, FIELDFONT=info.font, FONT=info.font, $
                TITLE='Subset Name:', XSIZE=30)

        group1=widget_base(base, row=1,map=1)

        info.widgets.start_time = CW_FIELD(group1,VALUE=start_time, $
                        ROW=1, /string, FIELDFONT=info.font, FONT=info.font, $
                        TITLE='Starting Time: ', XSIZE=10)

        info.widgets.end_time = CW_FIELD(group1,VALUE=end_time, $
                        ROW=1, /string, FIELDFONT=info.font, FONT=info.font, $
                        TITLE='Ending Time: ', XSIZE=10)

        group2=widget_base(base, row=1,map=1, space=100, /align_center)

	button1=widget_button(group2, FONT=info.font, EVENT_PRO=event_pro, VALUE="Done",$
				 /ALIGN_CENTER, uvalue=info)

	button2=widget_button(group2, FONT=info.font, EVENT_PRO='doneCB', VALUE="Cancel",$
				 /ALIGN_CENTER, uvalue=info)

widget_control, /realize, base 

end

;--------------------------------------------------------------------------------
pro set_time_range, event

pro_name = 'set_time_range'
@getinfo

widget_control, get_uvalue=info, event.top
widget_control, /hourglass

time_record = *info.rangetype.time
size_time = size(time_record)
if size_time(0) eq 2 then temp = 0 else temp = 1
start_time = ' '
end_time = ' '
if info.rangetype.time_type eq 0 then begin
    widget_control, info.widgets.start_time, get_value=start_time
    widget_control, info.widgets.end_time, get_value=end_time
    starttime = make_second_time(start_time) - temp
    endtime = make_second_time(end_time) + temp
endif else begin
    widget_control, info.widgets.julian_start, get_value=jul_start
    widget_control, info.widgets.julian_end, get_value=jul_end
    jul_start = jul_start(0)
    jul_end = jul_end(0)
    julian_start_time = double(jul_start)
    julian_end_time = double(jul_end)
;    if(julian_start_time lt info.rangetype.jul_start) or $
;	(julian_end_time gt info.rangetype.jul_end) then begin
;	    the_message=['The input time is exceeded the time range.', $
;		'Please, check the time and input it again.']
;	    result=dialog_message(the_message, title='View HDF Warning!')
;	    return
;    endif
    starttime = julian_start_time - long(julian_start_time)
    if(starttime gt 0.5) then begin
	starttime = (starttime - 0.5) * 86400.0
    endif else begin
	starttime = (starttime + 0.5) * 86400.0
    endelse
    endtime = julian_end_time - long(julian_end_time)
    if(endtime gt 0.5) then begin
	endtime = (endtime - 0.5) * 86400.0
    endif else begin
	endtime = (endtime + 0.5) * 86400.0
    endelse
    starttime = starttime - temp
    endtime = endtime + temp
endelse

if (starttime gt endtime) then begin
	the_message=['The start time is greater than end time.', $
		'Please, check the time and input it again.']
	result=dialog_message(the_message, title='View HDF Warning!')
	return
endif

if size_time(0) eq 2 then begin
	subscript=where((time_record(0,*) ge starttime) and $
		(time_record(0,*) le endtime), count)
endif else begin
	subscript=where((time_record ge starttime) and $
		(time_record le endtime), count)
endelse
if(count lt 2) then begin
	the_message=['There are no records in the time range!', $
		'Please, check the time and do it again.']
	result=dialog_message(the_message, title='View HDF Warning!')
	return
endif

info.rangetype.start_rec = subscript(0) + 1
info.rangetype.end_rec = subscript(count-1) + 1
info.rangetype.flag = 1

widget_control, set_uvalue=info, info.base
widget_control, event.top, /destroy

end
   
;--------------------------------------------------------------------------------
pro time_type_select, Event

pro_name = 'time_type_select'
@getinfo

widget_control, get_uvalue=info, event.top

type=''
widget_control, get_uvalue=type, event.id
type = type(0)

if type eq 'cal' then begin
info.rangetype.time_type = 0
	widget_control, info.widgets.julian_start, sensitive = 0
	widget_control, info.widgets.julian_end, sensitive = 0
	widget_control, info.widgets.start_time, sensitive = 1
	widget_control, info.widgets.end_time, sensitive = 1
endif else begin
	info.rangetype.time_type = 1
	widget_control, info.widgets.start_time, sensitive = 0
	widget_control, info.widgets.end_time, sensitive = 0
	widget_control, info.widgets.julian_start, sensitive = 1
	widget_control, info.widgets.julian_end, sensitive = 1
endelse

widget_control, set_uvalue=info, event.top

END

;--------------------------------------------------------------------------------
pro get_time_range, subset_name, rank, info

pro_name = 'get_time_range'
@getinfo

;if info.rangetype.get_time eq 0 then get_time, info, 1
if info.rangetype.get_time eq 0 then begin
;	message=['Time variable is not available.', 'Please use Record Number']
;	result=dialog_message(message, title='View HDF Warning!')
	widget_control, set_uvalue=info, info.base
        return
endif

time_record = *info.rangetype.time
n_time_record = n_elements(time_record)

if n_time_record lt 2 then begin
	result=dialog_message('Problem assigning time variable!',$
		title='View HDF Warning!')
	return
endif

start_time = ' '
end_time = ' '

time_dimen = size(time_record, /N_DIMENSIONS)
if (info.rangetype.old_increment(0) eq 0) or $
    (info.rangetype.old_dim(0) ne info.sds.dims(0)) then begin
	start_time= make_string_time(time_record(0), $
	    info.rangetype.julian, julian_start_time)
	end_time = make_string_time(time_record(n_time_record-1), $
	    info.rangetype.julian, julian_end_time)
endif else begin
    if time_dimen eq 2 then begin
	startsample = info.rangetype.old_start(1)-1
	endsample = info.rangetype.old_end(1)-1
	start_time= make_string_time(time_record(startsample, info.rangetype.old_start(0)-1), $
	    info.rangetype.julian, julian_start_time)
	end_time = make_string_time(time_record(endsample, info.rangetype.old_end(0)-1), $
	    info.rangetype.julian, julian_end_time)
    endif else begin
	start_time= make_string_time(time_record(info.rangetype.old_start(0)-1), $
	    info.rangetype.julian, julian_start_time)
	end_time = make_string_time(time_record(info.rangetype.old_end(0)-1), $
	    info.rangetype.julian, julian_end_time)
    endelse
endelse

jul_start_string=string(format='(f20.7)', julian_start_time)
jul_end_string=string(format='(f20.7)', julian_end_time)
jul_start_string=strcompress(jul_start_string, /REMOVE_ALL)
jul_end_string=strcompress(jul_end_string, /REMOVE_ALL)

base_loc = widget_info(info.base, /geometry)
xoffset = base_loc.xoffset + 100
yoffset = base_loc.yoffset + 200
base = widget_base( GROUP_LEADER=info.base, /MODAL, COLUMN=1, MAP=1, $
	TITLE='Subset Data', uvalue=info, XOFFSET=xoffset, YOFFSET=yoffset)

	info.widgets.subset_name=CW_FIELD(base, VALUE=subset_name, $
                ROW=1, STRING=1, FIELDFONT=info.font, FONT=info.font, $
                TITLE='Subset Name:', XSIZE=40)

	cal_table=widget_base(base,row=1,map=1,space=10)

        cal_button=widget_button(cal_table,font=info.font,value='  ',/ALIGN_CENTER, $
                uvalue='cal', event_pro='time_type_select')

        group1=widget_base(cal_table, row=1,map=1, space=140)

        info.widgets.start_time = CW_FIELD(group1,VALUE=start_time, $
		ROW=1, /string, FIELDFONT=info.font, FONT=info.font, $
		TITLE='Starting Time: ', XSIZE=10)

        info.widgets.end_time = CW_FIELD(group1,VALUE=end_time, $
		ROW=1, /string, FIELDFONT=info.font, FONT=info.font, $
		TITLE='Ending Time: ', XSIZE=10)

	jul_table=widget_base(base,row=1,map=1,space=10)

        jul_button=widget_button(jul_table,font=info.font,value='  ',/ALIGN_CENTER, $
                uvalue='jul', event_pro='time_type_select')

        group2=widget_base(jul_table, row=1,map=1)

        info.widgets.julian_start = CW_FIELD(group2,VALUE=jul_start_string, $
                ROW=1, /string, FIELDFONT=info.font, FONT=info.font, $
                TITLE='Julian Starting Time: ', XSIZE=20)

        info.widgets.julian_end = CW_FIELD(group2,VALUE=jul_end_string, $
                ROW=1, /string, FIELDFONT=info.font, FONT=info.font, $
                TITLE='Julian Ending Time: ', XSIZE=20)	
	
        group3=widget_base(base, row=1,map=1, space=100, /align_center)

	button1=widget_button(group3, FONT=info.font, EVENT_PRO='set_time_range', $
		VALUE="Done", /ALIGN_CENTER, uvalue=info)

	button2=widget_button(group3, FONT=info.font, EVENT_PRO='reset_range', $
		VALUE="Reset", /ALIGN_CENTER, uvalue=rank)

	;button3=widget_button(group3, FONT=info.font, EVENT_PRO='doneCB', $
	button3=widget_button(group3, FONT=info.font, EVENT_PRO='canceloptionCB', $
		VALUE="Cancel", /ALIGN_CENTER, uvalue=info)

widget_control, /realize, base 
widget_control, set_uvalue=info, base

if info.rangetype.time_type eq 0 then begin
    widget_control, info.widgets.julian_start, sensitive=0
    widget_control, info.widgets.julian_end, sensitive=0
endif else begin
    widget_control, info.widgets.start_time, sensitive=0
    widget_control, info.widgets.end_time, sensitive=0
endelse

widget_control, DEFAULT_BUTTON=button1, CANCEL_BUTTON=button3, base
xmanager, 'main_widget', base

end

;--------------------------------------------------------------------------------
pro range_input, event

pro_name = 'range_input'
@getinfo

;---------------------------------------- 
; Toggle between table and graph modes
;---------------------------------------- 

widget_control, get_uvalue=info, event.top
widget_control, get_uvalue=info, info.base

info.rangetype.type = event.index

widget_control, set_uvalue=info, info.base

if info.rangetype.type eq 2 then multi_file_setting, info.base, info

end

;--------------------------------------------------------------------------------
pro read_config_file, info

pro_name = 'read_config_file'
@getinfo

widget_control, /hourglass

count = check_directory(info.home_path, info.home_path)
if count eq 0 then begin
	CD, '.', CURRENT=pwd
	info.list_path = pwd
endif

config_file = dialog_pickfile(filter='*config*', path=info.home_path, $
	get_path=config_path, /read)

if config_file eq "" then return

config_result=STRPOS(config_file, config_path)

if config_result eq -1 then config_file=config_path+config_file
print,"config_filename=", config_file

widget_control, /hourglass

info.userdefine.count = 0

read_config,config_file,info

info.top_color = !d.n_colors - 1
if info.top_color gt 255 then info.top_color = 255

if info.style.symbol eq 8 and info.style.usersym eq 0 then $
        info.style.usersym = 4
set_user_symbol, info.style.usersym

if info.userdefine.count gt 0 then begin
        userdefine_name = info.userdefine.name(0)
        for i = 1 , info.userdefine.count-1 do begin
                userdefine_name = [userdefine_name, info.userdefine.name(i)]
        endfor
        info = redefine_info(info, userdefine_name, 12)
endif

end

;------------------------------------------------------------------
;	read_digital_data	
;------------------------------------------------------------------
pro read_digital_data, info

pro_name = 'read_digital_data'
@getinfo
 
if info.library_status eq 0 then begin
	sds_range_dialogue, info
	return
endif

  CD, '.', CURRENT = PWD

  instr_id = long(get_instrument_id(info))
  if instr_id lt 0 then begin
	result=dialog_message('Problem reading Instrument ID Number!',$
		title='View HDF Warning!')
	return
  endif 

  ;the_result = CALL_EXTERNAL(PWD+'/' + info.library,   $
  the_result = CALL_EXTERNAL(info.library,   $
               'get_digital_namelist',	$
		instr_id, $
		/s_value)

	if the_result ne "BAD" then begin

		digital_name_list=str_sep(the_result, ',')
		;
		; Pop up a dialog box with these digital names	
		;
		base=widget_base(resource_name='ddf',$
			COLUMN=1, MAP=1, TITLE='Select Digital Data')

		button_group=cw_bgroup(base,digital_name_list,column=1, $
			event_funct="add_digital", uvalue=digital_name_list, $
			/scroll,y_scroll_size=450,x_scroll_size=350,/exclusive)

		group2=widget_base(base, row=1,map=1, space=100, /align_center)

		button1=widget_button(group2, FONT=info.font, EVENT_PRO='digital_done', $
			VALUE="Done", /ALIGN_CENTER, uvalue=info)

		button2=widget_button(group2, FONT=info.font, EVENT_PRO='doneCB', $
			VALUE="Cancel", /ALIGN_CENTER)

		widget_control, set_uvalue=info, base
		widget_control,/realize,base

	endif else begin
		result=dialog_message('Problem reading Digital Variable!',$
			title='View HDF Warning!')
	endelse 

end

;--------------------------------------------------------------------------------
pro read_quality_flag, info, num_list

pro_name = 'read_quality_flag'
@getinfo

if info.library_status eq 0 then begin
	sds_range_dialogue, info
	return
endif

	quality_nrec = info.sds.dims(0)

   case num_list of
     1: begin
	quality_name_list= [ 'FOV Flag' , 'SW Filtered Radiance Flag' , 'WN Filtered Radiance Flag' , $
			     'TOT Filtered Radiance Flag' , 'Azimuth Scan Plane' , 'Elevation Scan Profile' , $
			     'Azimuth Motion Status' , 'Elevation Scan Rate' , 'Clock Angle Rate' , $
			     'Cone Angle Rate', 'Offset Table Index**', 'InterChannel Results**', $
			     'Used in WN SC**', 'Used In TOT SC**', 'Used In SW SC**'  ]
	end
     2: begin
	quality_name_list= [ 'Elevation Profile ID', 'MAM Cover Status' , 'Main Cover Status' , $
			     'Bias Voltage Edit Check' , 'TOT DAC Voltage Edit Check' , $
			     'SW DAC Voltage Edit Check' , 'WN DAC Voltage Edit Check' , $
			     'TOT Heatsink Temperature Edit Check' , 'SW Heatsink Temperature Edit Check' , $
			     'WN Heatsink Temperature Edit Check' , 'TOT Radiance Edit Check' , $
			     'SW Radiance Edit Check' ,'WN Radiance Edit Check' ]
	end
     3: begin
	quality_name_list= [ 'TOT 2nd Time Constant VK Status' , 'SW 2nd Time Constant VK Status Flag' , $
			     'WN 2nd Time Constant VK Status' , 'Measurement Used in Spaceclamp' , $
			     'TOT SpaceClamp Status' , 'SW SpaceClamp Status' , 'WN SpaceClamp Status' , $
			     'TOT DAC Status' , 'SW DAC Status' , 'WN DAC Status' ]
	end
     4: begin
	quality_name_list= [ 'Total DAC Status' , 'SW DAC Status' , 'WN DAC Status' , 'DAA Ground Reference' , $
			     'Elevation Profile ID' , 'MAM Cover Status' , 'Main Cover Status' , $
			     'Bias Voltage Edit' , 'Total DAC Voltage Edit' , 'SW DAC Voltage Edit' , $
			     'WN DAC Voltage Edit' , 'Total Heat Sink Temp Edit' , 'SW Heat Sink Temp Edit' , $
			     'WN Heat Sink Temp Edit' ]
	end
     5: begin
	quality_name_list= [ 'Total Space Clamp' , 'SW Space Clamp' , 'WN Space Clamp' ]
	end
     6: begin
	quality_name_list= [ 'Total 2nd TC Vk Status' , 'SW 2nd TC Vk Status' , 'WN 2nd TC Vk Status' , $
			     'Used In SC**' , 'Total Radiance Edit' , 'SW Radiance Edit' , 'WN Radiance Edit' ]
	end
     else: begin
		result=dialog_message('Do not support this quality list of '+ $
			strcompress(string(num_list), /REMOVE_ALL) + '!',$
			title='View HDF Warning!')
		return
	end
   endcase
		;
		; Pop up a dialog box with these quality flag names	
		;
		base=widget_base(resource_name='qff',$
			COLUMN=1, MAP=1, TITLE='Select Quality Flag')

		button_group=cw_bgroup(base,quality_name_list,column=1, $
			event_funct="add_quality", uvalue=quality_name_list, $
                        FONT=info.font, $
			/exclusive)

		group2=widget_base(base, row=1,map=1, space=40, /align_center)

		button1=widget_button(group2, FONT=info.font, EVENT_PRO='quality_done', $
			VALUE="Done", /ALIGN_CENTER)

		button2=widget_button(group2, FONT=info.font, EVENT_PRO='doneCB', VALUE="Cancel",$
			 /ALIGN_CENTER)

		if num_list eq 1 or num_list eq 6 then begin
		    text2id = widget_label(base, value = " ", /ALIGN_CENTER, FONT=font1)
		    if num_list eq 1 then begin
			text2 = '** For Release 4 or later'
			text3 = '    BDS files only.'
		    endif else begin
			text2 = '** For Release 3 or earlier'
			text3 = '    BDS files Only.'
		    endelse
		    text2id=widget_label(base, value = text2, /ALIGN_LEFT, FONT=font1)
		    text3id=widget_label(base, value = text3, /ALIGN_LEFT, FONT=font1)
		endif

		widget_control, set_uvalue=info, base
		widget_control,/realize,base

end

;--------------------------------------------------------------------------------
pro read_vfield_quality_flag, info

pro_name = 'read_vfield_quality_flag'
@getinfo

	quality_name_list= [ 'FOV Flag' , 'SW Filtered Radiance Flag' , 'WN Filtered Radiance Flag' , $
		'TOT Filtered Radiance Flag' , 'Azimuth Scan Plane' , 'Elevation Scan Profile' , $
		'Azimuth Motion Status' , 'Elevation Scan Rate' , 'Clock Angle Rate' , $
		'Cone Angle Rate' ]
	;
	; Pop up a dialog box with these quality flag names	
	;
	base=widget_base(GROUP_LEADER=info.base, /MODAL, $
		COLUMN=1, MAP=1, TITLE='Select Quality Flag')

	button_group=cw_bgroup(base,quality_name_list,column=1, $
		event_funct="add_vfield_quality", uvalue=quality_name_list, $
                       FONT=info,font, /exclusive)


	button2=widget_button(base, FONT=info.font, EVENT_PRO='doneCB', VALUE="Done",$
		 /ALIGN_CENTER)

	widget_control, set_uvalue=info, base
	widget_control,/realize,base
	xmanager, 'main_widget', base

end

;--------------------------------------------------------------------------------
pro read_sds_dataCB, event

pro_name = 'read_sds_dataCB'
@getinfo

widget_control, get_uvalue=info, event.id
widget_control, /hourglass

start_list=lonarr(info.sds.rank)
end_list=lonarr(info.sds.rank)
increment_list=lonarr(info.sds.rank)

if info.rangetype.type eq 1 and info.rangetype.flag eq 0 then begin
   start_list(*) = 0
   end_list = info.sds.dims(*)
   increment_list(*) = 1
   time_record = *info.rangetype.time
   start_time = ' '
   end_time = ' '
   widget_control, info.widgets.start_time, get_value=start_time
   widget_control, info.widgets.end_time, get_value=end_time
   starttime = make_second_time(start_time) - 1
   endtime = make_second_time(end_time) + 1
   if (starttime gt endtime) then begin
	the_message=['The start time is greater than end time.', $
		'Please, check the time and input it again.']
	result=dialog_message(the_message, title='View HDF Warning!')
	return
   endif

   subscript=where((time_record ge starttime) and (time_record le endtime), count)
   if(count lt 2) then begin
	the_message=['There are no records in the time range!', $
		'Please, check the time and do it again.']
	result=dialog_message(the_message, title='View HDF Warning!')
	return
   endif

   start_list(0) = subscript(0)
   end_list(0) = subscript(count-1) + 1
   
   if info.ssf.file eq 1 then begin
     if info.ssf.key eq 1 then begin
	start_list(info.sds.rank-1) = info.ssf.select - 1
	end_list(info.sds.rank-1) = info.ssf.select
	if info.ssf.layer ne 0 then begin
		start_list(info.sds.rank-2) = info.ssf.layer - 1
		end_list(info.sds.rank-2) = info.ssf.layer
	endif
     endif else if info.ssf.key eq 2 then begin
	if info.ssf.layer ne 0 then begin
		start_list(info.sds.rank-1) = info.ssf.layer - 1
		end_list(info.sds.rank-1) = info.ssf.layer
	endif
     endif
   endif

endif else begin
   for i=0,(info.sds.rank-1) do begin

	widget_control, info.widgets.starting_field(i), get_value=this_start
	widget_control, info.widgets.ending_field(i), get_value=this_end
	widget_control, info.widgets.increment_field(i), get_value=this_increment

	start_list(i)=this_start-1
	if start_list(i) lt 0 then start_list(i) = 0L
	end_list(i)=this_end
	increment_list(i)=this_increment
   end
endelse

info.rangetype.old_start(0:info.sds.rank-1) = start_list(0:info.sds.rank-1) + 1
info.rangetype.old_end(0:info.sds.rank-1) = end_list(0:info.sds.rank-1)
info.rangetype.old_increment(0:info.sds.rank-1) = increment_list(0:info.sds.rank-1)
info.rangetype.old_dim(0:info.sds.rank-1) = info.sds.dims(0:info.sds.rank-1)

widget_control, info.widgets.current_file, get_value=filename
filename=filename(0)

		unsign_type = 0
		if info.version lt 5.19 and info.library_status eq 1 then begin
		    if info.sds.type gt 20 then unsign_type = info.sds.type mod 2
		endif

		if info.hdf421 eq 1 then unsign_type = 1

		;array_size = long((end_list-start_list)/float(increment_list) + 0.9)
		array_size = long((end_list-start_list-1)/float(increment_list) + 1.0)

		if unsign_type ne 0 then begin
		    output_data = array_type(info.sds.type, array_size)
		    if (output_data(0) eq -1) then begin
			result=dialog_message('Unable to allocate memory for SDS data!',$
				title='View HDF Warning!')
			return
		    endif
		endif

		;check_name = info.name_list_sds(info.sds.index)
		;check_name = check_name(0)
		;subscripts = where(info.name_list_sds eq check_name, count)

       		CD, '.', CURRENT = PWD

		;if count gt 1 then begin
		;	index = long(info.sds.index)
			data_name = info.name_list_sds(info.sds.index)
			data_name = data_name(0)
			check_name = get_data_name(data_name)
		if unsign_type eq 0 then begin
		    the_result=read_sds(filename, check_name, info.sds.ref, start_list, $
                        array_size, increment_list, output_data)
		endif else begin
       			;the_result = CALL_EXTERNAL(PWD+'/' + info.library,   $
       			the_result = CALL_EXTERNAL(info.library,   $
       				'read_sds_eos', 		$
               			filename, 			$
				check_name,			$
				info.sds.ref,			$
               			info.sds.rank, 			$
				info.sds.type,         		$
               			info.sds.dims, 			$
				start_list,			$
				end_list,			$
				increment_list,			$
				array_size,			$
				output_data)

			case info.sds.type of
				21: info.sds.type = 22
				23: info.sds.type = 24
				25: info.sds.type = 6
				else:
			endcase
		endelse
		;endif else begin
		;	check_name=str_sep(info.name_list_sds(info.sds.index), ":")
       		;	the_result = CALL_EXTERNAL(PWD+'/' + info.library,   $
       		;	the_result = CALL_EXTERNAL(info.library,   $
       		;		'read_sds',  			$
               	;		filename, 			$
		;		check_name(0),			$
               	;		info.sds.rank, 			$
		;		info.sds.type,         		$
               	;		info.sds.dims, 			$
		;		start_list,			$
		;		end_list,			$
		;		increment_list,			$
		;		array_size,			$
		;		output_data)
		;endelse

		if (the_result eq -1) then begin
			result=dialog_message('Unable to read SDS data!',$
				title='View HDF Warning!')
			return
		endif

		org_rank = info.sds.rank
		org_start = start_list
		org_end = end_list
		org_increment = increment_list
		true_start = start_list(0)
		true_end = end_list(0)
		num_start_list = n_elements(start_list)
		sizedata = size(output_data)
		if(sizedata[0] gt 0) then output_data = reform(output_data)
		; output_data = reform(output_data)
		sizedata_new = size(output_data)
		if num_start_list ne sizedata_new(0) then begin
		  start_list_old = start_list
		  end_list_old = end_list
		  increment_list_old = increment_list
		  j = 0
		  for i=0, num_start_list-1 do begin
			num_elem = end_list_old(i) - start_list_old(i)
			if(num_elem ne 1) then begin
			   start_list(j) = start_list_old(i)
			   end_list(j) = end_list_old(i)
			   increment_list(j) = increment_list_old(i)
			   j = j + 1
			endif
		   endfor
		   if j eq 0 then j = 1
		   info.sds.rank = j
		   start_list = start_list(0:j-1)
		   end_list = end_list(0:j-1)
		   increment_list = increment_list(0:j-1)
		endif

		sizedata_old = size(output_data)
		if sizedata_old(0) lt info.sds.rank then begin
		  start_list_old = start_list
		  end_list_old = end_list
		  increment_list_old = increment_list
		  j = 0
		  for i=0, info.sds.rank-1 do begin
			if(end_list_old(i) - start_list_old(i) ne 1) then begin
			   start_list(j) = start_list_old(i)
			   end_list(j) = end_list_old(i)
			   increment_list(j) = increment_list_old(i)
			   j = j + 1
			endif
		   endfor
		   if j eq 0 then j = 1
		   info.sds.rank = j
		   start_list = start_list(0:j-1)
		   end_list = end_list(0:j-1)
		   increment_list = increment_list(0:j-1)
		endif

widget_control, info.widgets.subset_name, get_value=temp_name
temp_name=temp_name(0)
if info.vgroup.flag eq 1 then $
	temp_name = get_vgroup_name(temp_name,info)

info = redefine_info(info, temp_name, 3)

widget_control, info.widgets.subset_list, set_value=info.name_list_subset
widget_control, event.top, /destroy

num_output_data = n_elements(output_data)

info.subset.count=info.subset.count+1
info.subset.data(info.subset.count-1).subset_name = string(temp_name)
info.subset.data(info.subset.count-1).src_filename = filename
info.subset.data(info.subset.count-1).src_unitname = info.unitname
info.subset.data(info.subset.count-1).src_type_flag = 0			
info.subset.data(info.subset.count-1).src_crit_flag = 0
info.subset.data(info.subset.count-1).src_crit_name = ''
info.subset.data(info.subset.count-1).src_crit_min = ''
info.subset.data(info.subset.count-1).src_crit_max = ''
info.subset.data(info.subset.count-1).src_crit_type = ''
info.subset.data(info.subset.count-1).src_num = num_output_data
info.subset.data(info.subset.count-1).src_ref = info.sds.ref
info.subset.data(info.subset.count-1).src_rank = info.sds.rank
info.subset.data(info.subset.count-1).src_start = start_list
info.subset.data(info.subset.count-1).src_end = end_list
info.subset.data(info.subset.count-1).src_increment = increment_list
info.subset.data(info.subset.count-1).src_org_rank = org_rank
info.subset.data(info.subset.count-1).src_org_start = org_start
info.subset.data(info.subset.count-1).src_org_end = org_end
info.subset.data(info.subset.count-1).src_org_increment = org_increment
info.subset.data(info.subset.count-1).src_types(0) = info.sds.type
info.subset.data(info.subset.count-1).src_start(info.sds.rank) = true_start
info.subset.data(info.subset.count-1).src_end(info.sds.rank) = true_end

if ptr_valid(info.subset.data(info.subset.count-1).src_data) then begin
    *info.subset.data(info.subset.count-1).src_data = output_data
endif else begin
    info.subset.data(info.subset.count-1).src_data = ptr_new(output_data)
endelse

if ptr_valid(info.rangetype.time) then begin
    if ptr_valid(info.subset.data(info.subset.count-1).src_time) then begin
	*info.subset.data(info.subset.count-1).src_time=*info.rangetype.time
    endif else begin
	info.subset.data(info.subset.count-1).src_time = $
	    ptr_new(*info.rangetype.time)
    endelse
endif

info.rangetype.flag = 0
widget_control, info.widgets.sds, set_list_select=-1
widget_control, set_uvalue=info, info.base

save_list = redefine_save_list(info)
widget_control, set_uvalue=save_list, info.list_base

;check_type = size(output_data, /tname)
;print,'check_type = ',check_type,' info.sds.type = ',info.sds.type

end

;--------------------------------------------------------------------------------
pro read_vfield_dataCB, Event

pro_name = 'read_vfield_dataCB'
@getinfo

widget_control, /hourglass
widget_control, get_uvalue=info, event.id

widget_control, info.widgets.current_file, get_value=filename
filename=filename(0)

;----------------------------------------------------------
; Figure out what data types are in the vfield_names_sel
; and what the order is for each field.
;----------------------------------------------------------
; array of long integers to hold the data type number
; form HDF.

the_types=long(1)
the_order=long(1)


CD, '.', CURRENT = PWD

;the_result = CALL_EXTERNAL(PWD+'/' + info.library,   $
;the_result = CALL_EXTERNAL(info.library,   $
;      		'get_vfield_types',  	$
;              	filename, 		$
;		info.vdata.name_sel,	$ 
;              	info.vfield.indices_sel,$
;		long(1),		$
;              	the_types,		$
;		the_order,		$
;		/s_value)
 
if info.version lt 5.19 and info.library_status eq 1 then begin
    ;the_result = CALL_EXTERNAL(PWD+'/' + info.library,   $
    the_result = CALL_EXTERNAL(info.library,   $
	'get_vfield_types_eos', $
	filename, 		$
	info.vdata.name_sel,	$ 
	info.vdata.ref,		$
	info.vfield.indices_sel,$
	long(1),		$
	the_types,		$
	the_order,		$
	/s_value)
endif else begin 
    the_result = get_vfield_type(filename,info.vdata.name_sel,info.vdata.ref, $
        info.vfield.indices_sel,the_types,the_order,info.version, $
	info.library, info.library_status, 1)
endelse

;print,'in read_vfield_dataCB, the_types = ',the_types
;print,'the_order = ',the_order
;print,'unit = ',the_result

the_true_order = the_order

unitname = ''
if the_result ne "BAD" then unitname = ', '+the_result

start_order = 1
end_order = the_order
increment_order = 1

widget_control, info.widgets.subset_name, get_value=temp_name
temp_name=temp_name(0)
if info.vgroup.flag eq 1 then $
	temp_name = get_vgroup_name(temp_name,info)

if info.rangetype.type eq 1 and info.rangetype.flag eq 0 then begin
   time_record = *info.rangetype.time
   start_time = ' '
   end_time = ' '
   widget_control, info.widgets.start_time, get_value=start_time
   widget_control, info.widgets.end_time, get_value=end_time
   starttime = make_second_time(start_time) - 1
   endtime = make_second_time(end_time) + 1
   if (starttime gt endtime) then begin
	the_message=['The start time is greater than end time.', $
		'Please, check the time and input it again.']
	result=dialog_message(the_message, title='View HDF Warning!')
	return
   endif

   subscript=where((time_record ge starttime) and (time_record le endtime), count)
   if(count lt 2) then begin
	the_message=['There are no records in the time range!', $
		'Please, check the time and do it again.']
	result=dialog_message(the_message, title='View HDF Warning!')
	return
   endif

   this_start = long(subscript(0))
   this_end = long(subscript(count-1))
   this_increment = 1L
   
endif else begin

   widget_control, info.widgets.starting_field(0), get_value=this_start
   this_start=long(this_start) - 1
   if this_start lt 0 then this_start = 0L

   widget_control, info.widgets.ending_field(0), get_value=this_end
   this_end=long(this_end)-1

   widget_control, info.widgets.increment_field(0), get_value=this_increment
   this_increment=long(this_increment)

   if the_order gt 1 then begin
	widget_control, info.widgets.starting_field(1), get_value=order_start
	order_start=long(order_start) - 1
	if order_start lt 0 then order_start = 0L

	widget_control, info.widgets.ending_field(1), get_value=order_end
	order_end=long(order_end)-1

	widget_control, info.widgets.increment_field(1), get_value=order_increment
	order_increment=long(order_increment)

	start_order = order_start + 1
	end_order = order_end + 1
	increment_order = order_increment
   endif

endelse

info.rangetype.old_start(0) = this_start + 1
info.rangetype.old_end(0) = this_end + 1
info.rangetype.old_increment(0) = this_increment
info.rangetype.old_dim(0) = info.sds.dims(0)
info.rangetype.old_start(1) = start_order
info.rangetype.old_end(1) = end_order
info.rangetype.old_increment(1) = increment_order
info.rangetype.old_dim(1) = the_order

widget_control, event.top, /destroy

;----------------------------------------------------------
; Figure out what data types are in the vfield_names_sel
; and what the order is for each field.
;----------------------------------------------------------
; array of long integers to hold the data type number
; form HDF.
;---------------------------------------------
; Create a structure defined by what fields
; the user selected and their number of
; components. Then load the data 
; into that structure through src_data
;---------------------------------------------
;----------------------------------------------
;	HDF Number Types
;----------------------------------------------
;	Hdf Name	#     Size in Bytes
;	-------------   --    -------------
;	DFNT_CHAR8	 4	    1
;	DFNT_FLOAT32     5	    4
;	DFNT_FLOAT64     6	    8
;	DFNT_INT8	20	    1
;	DFNT_UINT8      21	    1
;	DFNT_INT16      22	    2
;	DFNT_UINT16     23	    2
;	DFNT_INT32      24	    4
;	DFNT_UINT32     25	    4
;	DFNT_INT64      26	    8
;	DFNT_UINT64     27	    8
;----------------------------------------------
; size = sizeof(data_type) * number_of_components * number_of_rows
; create an array of that size
;-------------------------------------------------

if info.version lt 5.19 and info.library_status eq 1 then begin
    num_rec = this_end - this_start + 1
    if the_types(0) eq 4 then begin
	blank = array_type(20L, the_order+1)
    endif else if the_types(0) eq 21 and num_rec eq 1 then begin
	blank = array_type(the_types(0), the_order+1)
    endif else begin
	blank = array_type(the_types(0), the_order)
    endelse

    single_record=create_struct( 'components' + '0', blank) 

;-------------------------------------------
; Setup the output data to be the correct 
; data type and rank.
;-------------------------------------------

    output_data=replicate(single_record, (info.vdata.nrec))

;-------------------------------------------
; Now read in the vdata from the HDF file
;-------------------------------------------

CD, '.', CURRENT = PWD

;the_result = CALL_EXTERNAL(PWD+'/' + info.library,   $
;the_result = CALL_EXTERNAL(info.library,   $
;      		'read_vdata',  			$
;              	filename, 			$
;		info.vdata.name_sel,		$
;              	long(1), 			$
;		this_start,            	 	$
;              	info.vdata.nrec-1,		$
;		this_increment,			$
;		info.vfield.name_sel, 		$
;		the_types,			$
;		the_order,			$
;		output_data)

    ;the_result = CALL_EXTERNAL(PWD+'/' + info.library,   $
    the_result = CALL_EXTERNAL(info.library,   $
		'read_vdata_eos',		$
		filename, 			$
		info.vdata.name_sel,		$
		info.vdata.ref,			$
		long(1), 			$
		this_start,            	 	$
		info.vdata.nrec-1,		$
		this_increment,			$
		info.vfield.name_sel, 		$
		the_types,			$
		the_order,			$
		output_data)
endif else begin
    the_result = read_vdata(filename, info.vdata.name_sel, info.vdata.ref, $
	info.vdata.nrec-1, the_order, the_types, info.vfield.name_sel, output_data)
endelse

if info.vfield.name_sel eq "Radiance and mode flags" then begin
	get_quality_bits, info.quality.indices_sel, start_bit, num_bit
	data_type = the_types(0)
	num_data = n_elements(output_data.components0)
	output_data = reform(output_data.components0, n_elements(output_data.components0))
	output_data = long(output_data)
	output_data_1 = get_bit_values(num_data,start_bit,num_bit,output_data,info.version)
	blank = array_type(24L, the_order)
	single_record=create_struct( 'components' + '0', blank)
	output_data=replicate(single_record, (info.vdata.nrec))
	jj = 0L
	for i=0L, info.vdata.nrec-1 do begin
		for j=0, the_order-1 do begin
			output_data(i).components0(j) = output_data_1(jj)
			jj = jj + 1
		endfor
	endfor
endif

output_data = output_data(this_start:this_end)

this_increment = this_increment(0)
if (this_increment gt 1) then begin
	indices = lindgen(this_end-this_start+1)
	indices = indices mod this_increment
	indices = [where(indices eq 0) ]
	output_data = output_data(indices)
endif

;  Convert to string
num_rec = this_end - this_start + 1
if the_types eq 21 and num_rec eq 1 then begin
	result=dialog_message('Is ' + temp_name + ' a text data?', $
		title='View HDF Question!', /QUESTION)
	if result eq 'Yes' then the_types = 4
endif

if the_types eq 4 then begin
  num_rec = this_end-this_start+1
  single_record=create_struct( 'components' + '0', '') 
  output_data_1=replicate(single_record, num_rec)

  for i=this_start, this_end, this_increment do begin
    output_data_1(i).components0 = ''
    j=0L
    while((output_data(i).components0(j) ne 0) and (j lt the_order)) do begin
	output_data_1(i).components0 = output_data_1(i).components0 + string(byte(output_data(i).components0(j)))
        j=j+1
	if j eq the_order then output_data(i).components0(j) = 0
    endwhile
  endfor


  output_data = output_data_1

endif else begin
  if the_order gt 1 then begin
	the_new_order = (order_end - order_start + 1)/order_increment
	check_order = order_start + the_new_order*order_increment
	if check_order LE order_end then the_new_order = the_new_order + 1
	if the_new_order lt the_order then begin
		blank = array_type(the_types(0), the_new_order)
		single_record=create_struct( 'components' + '0', blank) 
		the_new_record=n_elements(output_data)
		output_data1=replicate(single_record, the_new_record)
		for i=0L, the_new_record-1 do begin
			jj=0
			for j=order_start, order_end, order_increment do begin
				output_data1(i).components0(jj) = output_data(i).components0(j)
				jj = jj + 1
			endfor
		endfor
		the_order=the_new_order
		output_data = output_data1
	endif
  endif
endelse

if (the_result ne -1) then begin

	num_output_data = n_elements(output_data.components0)

	;-------------------------------------------
	; Stuff the data into info.subset.data 
	;-------------------------------------------
	info.subset.count=info.subset.count+1
 	info.subset.data(info.subset.count-1).subset_name = string(temp_name)
	info.subset.data(info.subset.count-1).src_filename = filename
	info.subset.data(info.subset.count-1).src_unitname = unitname
	info.subset.data(info.subset.count-1).src_type_flag = 1			
	info.subset.data(info.subset.count-1).src_crit_flag = 0
	info.subset.data(info.subset.count-1).src_crit_name = ''
	info.subset.data(info.subset.count-1).src_crit_min = ''
	info.subset.data(info.subset.count-1).src_crit_max = ''
	info.subset.data(info.subset.count-1).src_crit_type = ''
	info.subset.data(info.subset.count-1).src_num = num_output_data
	info.subset.data(info.subset.count-1).src_ref = info.vdata.ref
	info.subset.data(info.subset.count-1).src_rank = 2
	info.subset.data(info.subset.count-1).src_start(0) = this_start
	info.subset.data(info.subset.count-1).src_end(0) = this_end
	info.subset.data(info.subset.count-1).src_increment(0) = this_increment
	info.subset.data(info.subset.count-1).src_org_rank = 2
	info.subset.data(info.subset.count-1).src_org_start(0) = this_start
	info.subset.data(info.subset.count-1).src_org_end(0) = this_end
	info.subset.data(info.subset.count-1).src_org_increment(0) = this_increment
	info.subset.data(info.subset.count-1).src_org_start(1) = start_order - 1
	info.subset.data(info.subset.count-1).src_org_end(1) = end_order
	info.subset.data(info.subset.count-1).src_org_increment(1) = increment_order
	info.subset.data(info.subset.count-1).src_start(1) = start_order
	info.subset.data(info.subset.count-1).src_end(1) = end_order
	info.subset.data(info.subset.count-1).src_increment(1) = increment_order
	info.subset.data(info.subset.count-1).src_fnames = info.vfield.name_sel
	info.subset.data(info.subset.count-1).src_order = the_order
	info.subset.data(info.subset.count-1).src_order(1) = the_true_order
	info.subset.data(info.subset.count-1).src_types = the_types
	if ptr_valid(info.subset.data(info.subset.count-1).src_data) then begin
	    *info.subset.data(info.subset.count-1).src_data = output_data
	endif else begin
	    info.subset.data(info.subset.count-1).src_data = ptr_new(output_data)
	endelse

	if ptr_valid(info.rangetype.time) then begin
	    if ptr_valid(info.subset.data(info.subset.count-1).src_time) then begin
		*info.subset.data(info.subset.count-1).src_time=*info.rangetype.time
	    endif else begin
		info.subset.data(info.subset.count-1).src_time = $
		    ptr_new(*info.rangetype.time)
	    endelse
	endif

	;-------------------------------------------
	; Add to the subset list
	;-------------------------------------------

	info = redefine_info(info, temp_name, 3 )
	
	widget_control, info.widgets.subset_list, set_value=info.name_list_subset
	save_list = redefine_save_list(info)
        widget_control, set_uvalue=save_list, info.list_base

endif else begin
	result=dialog_message('Problem reading HDF Vdata!',$
		title='View HDF Warning!')
endelse

widget_control, set_uvalue=info, info.base

end

;--------------------------------------------------------------------------------
pro remove_all_subset, info

pro_name = 'remove_all_subset'
@getinfo

if info.subset.count lt 1 then return

for i = 0, info.subset.count-1 do begin
       ptr_free, info.subset.data(i).src_data
       if ptr_valid(info.subset.data(i).src_time) then $
	ptr_free, info.subset.data(i).src_time
	info = initial_subset_data(info,i)
endfor

info.subset.count = 0
subset_name_list=[ 'None' ]

info = redefine_info(info, subset_name_list, 4)
widget_control, set_uvalue=info, info.base

save_list = redefine_save_list(info)
widget_control, set_uvalue=save_list, info.list_base

widget_control, info.widgets.subset_list, set_value = info.name_list_subset
return

end

;--------------------------------------------------------------------------------
pro change_subset_name, info, this_subset

pro_name = 'change_subset_name'
@getinfo

if this_subset ge info.subset.count then begin

       result = dialog_message('This subset is not valid, cannot rename!', $
                                title='View_HDF Warning!')
                return
endif

data_name = info.subset.data(this_subset).subset_name
data_name = data_name(0)
dot=strpos(data_name, '[')
if( dot ne -1) then begin
	temp_name=strmid(data_name,0,dot)
endif else temp_name = data_name

get_variable_name, temp_name, info
widget_control, get_uvalue=info, info.base
if info.variablename eq 'None' then return

subset_name = info.variablename + '[' + strcompress(string(this_subset)) +']'

if (this_subset eq 0) and (info.subset.count eq 1) then begin

       subset_name_list=[ subset_name ]

endif else if this_subset eq info.subset.count-1 then begin

       subset_name_list = [info.name_list_subset(0 : info.subset.count-2), subset_name]

endif else if this_subset eq 0 then begin

       subset_name_list = [subset_name, info.name_list_subset(1 : info.subset.count-1)]

endif else begin

       subset_name_list = [info.name_list_subset(0:this_subset-1), $
		subset_name, info.name_list_subset(this_subset+1 : *)]

endelse

info.subset.data(this_subset).subset_name = subset_name
info = redefine_info(info, subset_name_list, 4)
widget_control, set_uvalue=info, info.base

save_list = redefine_save_list(info)
widget_control, set_uvalue=save_list, info.list_base

widget_control, info.widgets.subset_list, set_value = info.name_list_subset
return

end

;--------------------------------------------------------------------------------
pro remove_some_subset, info, this_subset

pro_name = 'remove_some_subset'
@getinfo

if this_subset ge info.subset.count then begin

       result = dialog_message('This subset is not valid, cannot remove!', $
                                title='View_HDF Warning!')
                return

 endif else if (this_subset eq 0) and (info.subset.count eq 1) then begin

       info.subset.count = 0
       subset_name_list=[ 'None' ]
       ptr_free, info.subset.data(this_subset).src_data
       if ptr_valid(info.subset.data(this_subset).src_time) then $
	ptr_free, info.subset.data(this_subset).src_time
	info = initial_subset_data(info,this_subset)

endif else if this_subset eq info.subset.count-1 then begin

       info.subset.count = info.subset.count - 1
       ptr_free, info.subset.data(this_subset).src_data
       if ptr_valid(info.subset.data(this_subset).src_time) then $
	ptr_free, info.subset.data(this_subset).src_time
       subset_name_list = info.name_list_subset(0 : info.subset.count-1)
       info = initial_subset_data(info,info.subset.count)

endif else if this_subset eq 0 then begin

       info.subset.count = info.subset.count - 1
       ptr_free, info.subset.data(this_subset).src_data
       if ptr_valid(info.subset.data(this_subset).src_time) then $
	ptr_free, info.subset.data(this_subset).src_time
       subset_name_list = info.name_list_subset(1 : info.subset.count)

       info.subset.data(0:info.subset.count-1) = info.subset.data(1:info.subset.count)
       info = initial_subset_data(info,info.subset.count)

endif else begin

       subset_name_temp = info.name_list_subset

       subset_name_list = subset_name_temp(0 : this_subset-1)
       subset_name_list = [subset_name_list, subset_name_temp(this_subset+1 : *)]

       info.subset.count = info.subset.count - 1

       ptr_free, info.subset.data(this_subset).src_data
       if ptr_valid(info.subset.data(this_subset).src_time) then $
	ptr_free, info.subset.data(this_subset).src_time

       info.subset.data(this_subset:info.subset.count-1) = info.subset.data(this_subset+1:info.subset.count)
       info = initial_subset_data(info,info.subset.count)

endelse

info = redefine_info(info, subset_name_list, 4)
widget_control, set_uvalue=info, info.base

save_list = redefine_save_list(info)
widget_control, set_uvalue=save_list, info.list_base

widget_control, info.widgets.subset_list, set_value = info.name_list_subset
return

end

;--------------------------------------------------------------------------------
pro remove_dataset, event

pro_name = 'remove_dataset'
@getinfo

widget_control, get_uvalue=info, event.id
widget_control, get_uvalue=info, info.base

if info.name_list_subset(0) eq "None" then begin
         result=dialog_message('No data read in Subset list yet!',$
                    title='View HDF Warning!')
         return
endif

pick_export_variables, info
widget_control, get_uvalue=info, info.base
subscripts = where(info.out.pick eq 1, numout)
print, 'number of variables picked = ', numout
if (numout eq 0) then begin
     result=dialog_message('No data selected for "Remove Variables"!',$
                    title='View HDF Warning!')
     return
endif

if numout eq info.subset.count then begin
	remove_all_subset, info
endif else begin
	for i = numout-1, 0, -1 do begin
		remove_some_subset, info, subscripts(i)
	endfor
endelse

end

;--------------------------------------------------------------------------------
pro remove_all_handle_create, info

pro_name = 'remove_all_handle_create'
@getinfo

if ptr_valid(info.rangetype.time) then $
	ptr_free, info.rangetype.time

if ptr_valid(info.xyvalue.x_index) then $
	ptr_free, info.xyvalue.x_index

if ptr_valid(info.xyvalue.y_index) then $
	ptr_free, info.xyvalue.y_index

if ptr_valid(info.geolocated.colat) then $
	ptr_free, info.geolocated.colat

if ptr_valid(info.geolocated.long) then $
	ptr_free, info.geolocated.long

if ptr_valid(info.geolocated.sate_colat) then $
	ptr_free, info.geolocated.sate_colat

if ptr_valid(info.geolocated.sate_long) then $
	ptr_free, info.geolocated.sate_long

if ptr_valid(info.geolocated.sun_colat) then $
	ptr_free, info.geolocated.sun_colat

if ptr_valid(info.geolocated.sun_long) then $
	ptr_free, info.geolocated.sun_long

end

;--------------------------------------------------------------------------------
pro redraw_graph, info

pro_name = 'redraw_graph'
@getinfo

;widget_control, info.widgets.charsize, get_value = charsize
;if charsize ne info.char.size then begin
;   info.char.size = charsize
;   widget_control, set_uvalue=info, info.widgets.base
;   widget_control, set_uvalue=info, info.base
;endif

if info.multiple.key eq 1 then begin
	do_more_variables, 2, info
endif else if info.multiple.key eq 2 then begin
	do_more_x_variables, 2, info
endif else begin
	if (info.graph_style eq 'Geolocated' or info.graph_style eq $
		'Contour Geolocated') and info.geolocated.flag eq 0 then $
		plot_graph, 2, info.subset.selected, info $
	else plot_graph, 1, info.subset.selected, info
endelse

end

;--------------------------------------------------------------------------------
pro replot_graph, event

pro_name = 'replot_graph'
@getinfo

widget_control, get_uvalue=info, event.top
widget_control, get_uvalue=info, info.base

!UserStop = 1
!UserPause = 1
!UserDone = 1
widget_control, set_button=0, info.widgets.pause

redraw_graph, info

end

;--------------------------------------------------------------------------------
pro reset_range, event

pro_name = 'reset_range'
@getinfo

widget_control, get_uvalue=info, event.top
widget_control,get_uvalue=rank, event.id

if info.rangetype.type eq 1 and info.rangetype.flag eq 0 then begin
	time_record = *info.rangetype.time
	n_time_record = n_elements(time_record)
	start_time = ' '
	end_time = ' '
	start_time= make_string_time(time_record(0), $
	    info.rangetype.julian, julian_start_time)
	end_time = make_string_time(time_record(n_time_record-1), $
	    info.rangetype.julian, julian_end_time)
	jul_start_string=string(format='(f20.7)', info.rangetype.jul_start)
	jul_end_string=string(format='(f20.7)', info.rangetype.jul_end)
	jul_start_string=strcompress(jul_start_string, /REMOVE_ALL)
	jul_end_string=strcompress(jul_end_string, /REMOVE_ALL)
        widget_control, set_value = start_time, info.widgets.start_time
        widget_control, set_value = end_time, info.widgets.end_time
	widget_control, set_value = jul_start_string, info.widgets.julian_start
        widget_control, set_value = jul_end_string, info.widgets.julian_end
endif else begin
	for i = 0, rank do begin
        	widget_control, set_value = 1, info.widgets.starting_field(i)
        	widget_control, set_value = info.sds.dims(i), info.widgets.ending_field(i)
        	widget_control, set_value = 1, info.widgets.increment_field(i)
	endfor
endelse

for i = 0, rank do begin
	info.rangetype.old_start(i) = 1
	info.rangetype.old_end(i) = info.sds.dims(i)
	info.rangetype.old_increment(i) = 1
endfor

end

;--------------------------------------------------------------------------------
pro sds_range_dialogue, info

pro_name = 'sds_range_dialogue'
@getinfo

if info.ssf.file eq 1 and info.ssf.key eq 1 then begin
   if info.ssf.layer eq 0 then begin
	subset_name = info.name_list_ssf(info.ssf.select-1) + '[' + strcompress(string(info.subset.count)) +']'
   endif else begin
	if info.ssf.layer eq 1 then begin
		subset_name = info.name_list_ssf(info.ssf.select-1) + ' (Lower)' + $
			'[' + strcompress(string(info.subset.count)) +']'
	endif else begin
		subset_name = info.name_list_ssf(info.ssf.select-1) + ' (Upper)' + $
                        '[' + strcompress(string(info.subset.count)) +']'
	endelse
   endelse
endif else if info.ssf.file eq 1 and info.ssf.key eq 2 then begin
   if info.ssf.layer eq 0 then begin
	subset_name = info.name_list_sds(info.sds.index) + '[' + strcompress(string(info.subset.count)) +']'
   endif else begin
	if info.ssf.layer eq 1 then begin
		subset_name = info.name_list_sds(info.sds.index) + ' (Lower)' + $
			'[' + strcompress(string(info.subset.count)) +']'
	endif else begin
		subset_name = info.name_list_sds(info.sds.index) + ' (Upper)' + $
			'[' + strcompress(string(info.subset.count)) +']'
	endelse
   endelse
endif else begin
   subset_name = info.name_list_sds(info.sds.index) + '[' + strcompress(string(info.subset.count)) +']'
endelse

if info.rangetype.type eq 1 then begin
  info.rangetype.flag = 0
  get_time_range, subset_name, info.sds.rank-1, info
  widget_control, get_uvalue=info, info.base
  if info.canceloption eq 'Yes' then begin
	info.canceloption = 'No'
	widget_control, set_uvalue=info, info.base
	return
  endif 
  if info.rangetype.flag eq 0 then begin
        info.rangetype.type = 0
        widget_control, info.rangetype.widget, set_droplist_select=info.rangetype.type
  endif
endif

if info.rangetype.type eq 0 or info.rangetype.flag eq 1 then $
  record_range_buttons, subset_name, info.sds.rank-1, 'read_sds_dataCB', info $
else return

widget_control, set_uvalue=info, info.base


end

;--------------------------------------------------------------------------------
pro select_output, event

pro_name = 'select_output'
@getinfo

if event.clicks eq 2 then return
widget_control, /hourglass
file_pick = event.index
widget_control, get_uvalue=info, event.top
widget_control, get_uvalue=info, info.base

base=widget_base( COLUMN=1, MAP=1, TITLE='Select Output Action', XSIZE=240, uvalue=info)

group1=widget_base(base, column=1, map=1, xoffset=80)

desc = [ 'Display Data', 'Remove' ]
info.graph_style = 'Display Data'

info = initial_info(info)
widget_control, set_uvalue=info, base

the_style = CW_BGROUP(group1, desc, /return_name, $
	set_value=0, FONT=info.font, $
	event_func='graph_item', /exclusive)

group2=widget_base(base, row=1,map=1, space=30, /align_center)

button1=widget_button(group2, FONT=info.font, EVENT_PRO='output_action', $
	VALUE="Done", UVALUE=file_pick, /ALIGN_CENTER)

button2=widget_button(group2, FONT=info.font, EVENT_PRO='doneCB', $
	VALUE="Cancel", /ALIGN_CENTER)

widget_control, /realize, base 

end

;--------------------------------------------------------------------------------
pro output_action, event

pro_name = 'output_action'
@getinfo

widget_control, /hourglass
widget_control, get_uvalue=info, event.top
widget_control, get_uvalue=file_pick, event.id

widget_control, event.top, /destroy

cd, info.output_path, current=old_dir
output_name_list=findfile(info.filter, count=count)
;output_name_list=findfile('*.dat', count=count)
if count eq 0 then begin
	output_name_list = [ 'None' ]
	return
endif

if info.device eq 'X' then begin
   check=check_path(info.output_path)
   if check eq 1 then begin
	output_file = info.output_path + output_name_list(file_pick)
   endif else begin
	output_file = info.output_path + '/' + output_name_list(file_pick)
   endelse
endif else begin
   output_file = info.output_path + '\' + output_name_list(file_pick)
endelse

;print,'output_file = ', output_file
if info.graph_style eq 'Remove' then begin
	if info.device eq 'X' then begin
	   ;command_line="\rm -f "+ output_name_list(file_pick)
	   command_line="\rm -f "+ output_file
	endif else begin
	   command_line='del "'+output_file+'"'
	endelse
	spawn,command_line,results
	output_name_list=findfile(info.filter, count=count)
	if count eq 0 then output_name_list = [ 'None' ]
	widget_control, info.widgets.output, set_value=output_name_list
	cd, old_dir
	return
endif

; 
; Invoke viewing and printing here?
;
case info.editor_type of
	;1: command_line = "emacs " + output_name_list(file_pick) + " &"
	1: command_line = "emacs " + output_file + " &"
	2: begin 
		command_line = info.ieditor + " -geometry 757x531+75+104"
		command_line = command_line + " -title 'Display Output File' "
		;command_line = command_line + output_name_list(file_pick) + " &"
		command_line = command_line + output_file + " &"
	   end
	3: command_line = 'start edit "' + output_file + '"'
	4: begin
		if !D.Name eq 'X' then begin
		    command_line = info.editor + " " + output_file + " &"
		endif else begin
		    command_line = 'start ' + info.editor + ' "' + output_file + '"'
		endelse
	   end
	5: begin
		command_line="xterm -bg \#73a1ff -fn "
		command_line=command_line+ $
		    "-adobe-courier-bold-r-normal--14-100-100-100-m-90-iso8859-1"
		command_line=command_line + " -e emacs " + output_file + " &"
	   end
	else: begin
		command_line="xterm -bg \#73a1ff -fn "
		command_line=command_line+"-adobe-courier-bold-r-normal--14-100-100-100-m-90-iso8859-1"
		command_line=command_line + " -e vi -R "+ output_file + " &"
	      end
endcase

spawn, command_line, results

cd, old_dir

end

;--------------------------------------------------------------------------------
pro select_printer, printer_list, info, print_type

pro_name = 'select_printer'
@getinfo

if print_type eq 0 then begin
	eventpro = 'spawn_printjobCB'
	yscrollsize = 450
endif else begin
	eventpro = 'spawn_viewjobCB'
	yscrollsize = 60
endelse

printer_index=0
;info.current_printer = printer_list(0)
result=where(printer_list eq info.current_printer, count)
;if count eq 0 then printer_index=0 $
;   else printer_index=result(0)
if count gt 0 then begin
  default_printer = printer_list(result(0))
  default_printer = default_printer(0)
  printer_list = [default_printer, printer_list]
endif
 
;-----------------------------------------------------------
; Ask which printer from thunder's /etc/printcap to use
;-----------------------------------------------------------
base = widget_base( COLUMN=1, MAP=1, TITLE='Select a Printer', uvalue=info)

group2=widget_base(base, column=1,map=1, xoffset=80)

;the_style=CW_BGROUP(group2, printer_list, /return_name, set_value=0, $
the_style=CW_BGROUP(group2, printer_list, /return_name, set_value=printer_index, $
                FONT= info.font,$
                event_func='select_printerCB', $
                /scroll, y_scroll_size=yscrollsize, x_scroll_size=150, /exclusive)

group2=widget_base(base, row=1,map=1, space=40, /align_center)

button1=widget_button(group2, FONT=info.font, EVENT_PRO=eventpro, VALUE="Done",$
	/ALIGN_CENTER)

button2=widget_button(group2, FONT=info.font, EVENT_PRO='doneCB', VALUE="Cancel",$
	 /ALIGN_CENTER)

widget_control, set_uvalue=info, base
widget_control, /realize, base

end

;--------------------------------------------------------------------------------
function select_printerCB, event

pro_name = 'select_printerCB'
@getinfo1

widget_control, get_uvalue=info, event.top

info.current_printer = event.value

print,"Current Printer is: ",info.current_printer

widget_control, set_uvalue=info, event.top

end

;--------------------------------------------------------------------------------
pro select_sdsCB, event

pro_name = 'select_sdsCB'
@getinfo

if event.clicks eq 2 then return
widget_control, /hourglass
widget_control, get_uvalue=info, event.top

if (info.flags.data_read eq 0) then begin
	result=dialog_message('No data read in yet!',$
			title='View HDF Warning!')
	return
end

if (info.subset.count eq info.subset.maximum) then begin
	the_message = ["You have maximum sets of data", "Please remove at least one set of data."]
	result=dialog_message(the_message, title='View HDF Warning!')
	return
endif

widget_control, info.widgets.current_file, get_value=filename		
filename=filename(0)

if info.hdf5.flag eq 1 then begin
    read_hdf5_sdn_data, event.index, filename,info
    return
endif

if info.ascii_file.flag eq 1 then begin
    if info.show_attr gt 0 then begin
	the_message = "No attribute for ASCII file"
	result=dialog_message(the_message, title="ASCII Attributed")
	return
    endif
    read_ascii_data, event.index, filename,info
    return
endif

;
; Get the dimensions for this SDS 
; Initial the variable type

sds_dims = info.sds.dims
sds_rank = info.sds.rank
sds_type = info.sds.type

info.ssf.key = 0
info.ssf.select = 0
info.ssf.layer = 0

check_name = info.name_list_sds(event.index)
check_name = check_name(0)
subscripts = where(info.name_list_sds eq check_name, count)
num_sds = 1;
if count gt 1 then begin
   match = 0
   i = 0
   while match eq 0 and i lt count do begin
	if subscripts(i) eq event.index then begin
		num_sds = i + 1
		match = 1
	endif		
	i = i + 1
   endwhile
endif
num_sds = long(num_sds)
if info.vgroup.flag eq 1 then begin
	sref = info.vgroup.sref
	sref_list = str_sep(sref, '|')
	s_ref = long(sref_list)
	sds_ref = s_ref(event.index)
endif else sds_ref = long(event.index)

CD, '.', CURRENT = PWD
;if count gt 1 then begin
;	index = long(event.index)
data_name = info.name_list_sds(event.index)
data_name = data_name(0)
check_name = get_data_name(data_name)
the_result = get_sds_dims(filename,check_name,num_sds,sds_ref,sds_rank,sds_dims,$
        sds_type)
	;the_result = CALL_EXTERNAL(PWD+'/' + info.library,   $
;	the_result = CALL_EXTERNAL(info.library,   $
;		'get_sds_dims_eos',         $
;		filename, $
;		check_name,	  $
;		num_sds,  $
;		sds_ref,  $
;		sds_rank, $
;		sds_dims, $
;		sds_type)
;endif else begin
;	check_name=str_sep(info.name_list_sds(event.index), ":")
;	the_result = CALL_EXTERNAL(PWD+'/' + info.library,   $
;	the_result = CALL_EXTERNAL(info.library,   $
;      		'get_sds_dims',  	$
;              	filename, $
;		check_name(0), $
;		sds_rank, $
;		sds_dims, $
;		sds_type)
;endelse

if (the_result eq 'BAD') then begin
        result=dialog_message('Problem to get SDS information!',$
                        title='View HDF Warning!')
        return
end

info.sds.index = event.index
info.sds.rank = sds_rank 
info.sds.dims = sds_dims 
info.sds.type = sds_type 

info.sds.ref = sds_ref
;print,'sds_ref = ',sds_ref
;print,'info.sds.index = ',info.sds.index

info.rangetype.dim_name(*) = ''
for i = 0 , sds_rank-1 do begin
        info.rangetype.dim_name(i) = 'Dimension ' + strcompress(string(i+1),/REMOVE_ALL)
endfor

sd_id = HDF_SD_START(filename)
if sd_id ne -1 then begin
	sds_index = sds_ref
	if sds_index ne -1 then begin
		sds_id = HDF_SD_SELECT(sd_id, sds_index)
		if sds_id ne -1 then begin
			j = 0
			for i = sds_rank-1, 0, -1 do begin
				dim_id = HDF_SD_DIMGETID(sds_id,i)
				HDF_SD_DIMGET, dim_id, NAME=dim_name
				;print,'dim_id = ',dim_id,'dim_name = ',dim_name
				loc=strpos(dim_name, 'fakeDim')
				if loc eq -1 then info.rangetype.dim_name(j) = dim_name
				j = j + 1
			endfor
			HDF_SD_ENDACCESS, sds_id
		endif else print,'sds_id is bad'
	endif else print,'sds_index is bad'
	HDF_SD_END, sd_id
endif else print,'sd_id is bad'

;if info.show_attr eq 1 then $
if info.show_attr gt 0 then begin
	;get_data_attr,filename,data_name, info.sds.ref, 0, info
	get_data_attr,filename,check_name, info.sds.ref, 0, info
	if info.show_attr eq 2 then return
endif

if info.name_list_sds(event.index) EQ 'BDS Raw Digital Status Measurement' or $
   info.name_list_sds(event.index) EQ 'Raw Instrument Status Data' then begin
  read_digital_data, info
endif else if (info.name_list_sds(event.index) EQ 'BDS Quality Flags') OR $
	      (info.name_list_sds(event.index) EQ 'Radiance and mode flags') then begin
  read_quality_flag, info, 1
endif else if (info.name_list_sds(event.index) EQ 'Ancillary QA Flags Set 1') then begin
  read_quality_flag, info, 2
endif else if (info.name_list_sds(event.index) EQ 'Ancillary QA Flags Set 2') then begin
  read_quality_flag, info, 3
endif else if (info.name_list_sds(event.index) EQ 'Primary Scan Level QA Flags') then begin
  read_quality_flag, info, 4
endif else if (info.name_list_sds(event.index) EQ 'Secondary Scan Level QA Flags') then begin
  read_quality_flag, info, 5
endif else if (info.name_list_sds(event.index) EQ 'Secondary Sample Level QA Flags') then begin
  read_quality_flag, info, 6
endif else begin

  CD, '.', CURRENT = PWD
  attr_type = "units"
  the_result = get_sds_attr_value(filename,check_name,info.sds.ref,attr_type)
;if count gt 1 then begin
  ;the_result = CALL_EXTERNAL(PWD+'/' + info.library,   $
  ;the_result = CALL_EXTERNAL(info.library,   $
;		'get_sds_attr_value_eos',  	$
;		filename, $
;		check_name, $
;		info.sds.ref, $
;		attr_type, $
;		/s_value)
;endif else begin
;  check_name=str_sep(info.name_list_sds(event.index), ":")
;  the_result = CALL_EXTERNAL(PWD+'/' + info.library,   $
;  the_result = CALL_EXTERNAL(info.library,   $
;      		'get_sds_attr_value',  	$
;              	filename, $
;		check_name(0), $
;		attr_type, $
;		/s_value)
;endelse

  unit_list  = str_sep(the_result, '|')
  num_elem = n_elements(unit_list)
  if the_result eq 'BAD' or the_result eq '' then begin
  ;if unit_list(0) eq '' then begin
    if info.library_status eq 1 then begin
	;the_result = CALL_EXTERNAL(PWD+'/' + info.library,   $
	the_result = CALL_EXTERNAL(info.library,   $
	'get_vdata_attr_value',  	$
	filename, $
	info.name_list_sds(event.index), $
	/s_value)
    endif else the_result = 'BAD'

	if the_result eq 'BAD' then begin
    	    unit_list = [ 'None' ]
    	    info.unitname = ''
	endif else begin
	    unit_list = [ the_result ]
	    info.unitname = ', ' + the_result
	endelse
  endif else if num_elem eq 1 then begin 
    info.unitname = ', ' + unit_list(0)
  endif
  info = redefine_info( info, unit_list, 7)

  if info.rangetype.type eq 2 then begin
    read_sds_multiple_files, filename, data_name, sds_ref, info
    return
  endif

  if info.ssf.file eq 1 then begin
	if sds_rank gt 1 and sds_dims(sds_rank-1) gt 1 then begin
		;result = where(info.name_list_sds eq "Time of observation", count)
		;if count eq 0 then begin
		sds_index = check_sds_index(filename, "Time of observation")
		if sds_index eq -1 then begin
			select_ssf, info, event.index, info.sds.ref
			widget_control, get_uvalue=info, info.base
			  if info.canceloption eq 'Yes' then begin
				info.canceloption = 'No'
				widget_control, set_uvalue=info, info.base
				return
			  endif 
		endif else info.ssf.key = 2
		if info.ssf.key eq 1 then begin
			ssf_name = info.name_list_sds(info.sds.index)
			ssf_layer = ["Cloudy_FOV_Integers", "Cloudy_FOV_Reals", $
				"Validation_Stddev"]
			result = where(ssf_layer eq ssf_name, count)
			if count ne 0 then begin
				select_layer, info
				widget_control, get_uvalue=info, info.base
			  	if info.canceloption eq 'Yes' then begin
					info.canceloption = 'No'
					widget_control, set_uvalue=info, info.base
					return
			  	endif 
			endif
		endif else if info.ssf.key eq 2 then begin
			ssf_name = info.name_list_sds(info.sds.index)
			ssf_name_test = strlowcase(ssf_name)
			dot=strpos(ssf_name_test,'cloud layer')
			if dot ne -1 then begin
			    if sds_dims(sds_rank-1) eq 2 then begin
				select_layer, info
				widget_control, get_uvalue=info, info.base
			  	if info.canceloption eq 'Yes' then begin
					info.canceloption = 'No'
					widget_control, set_uvalue=info, info.base
					return
			  	endif 
			    endif
			endif
		endif
	endif
  endif

  sds_range_dialogue, info
endelse

end

;--------------------------------------------------------------------------------
pro select_subsetCB, event

pro_name = 'select_subsetCB'
@getinfo

if event.clicks eq 2 then return
widget_control, /hourglass
widget_control, get_uvalue=info, event.top
widget_control, get_uvalue=info, info.base

if info.widgets.base ne 0 then begin
	if(widget_info(info.widgets.base, /VALID_ID)) then begin
	    info.view.p_old = !P
	    info.view.d_old = !D
	    info.view.x_old = !X
	    info.view.y_old = !Y
	    widget_control, set_uvalue=info, info.widgets.base
	endif
endif

info.multiple.key = 0
info.multiple.flag = 0
info.multiple.y1y2 = 0
info.subset.selected = event.index

if (info.flags.data_read eq 0) or (info.name_list_subset(event.index)  eq 'None' ) then begin

	result=dialog_message('No data read in yet!',$
			title='View HDF Warning!')
	return

endif else begin

	if (info.current_tool eq 'graph') then begin

        	;base=widget_base( COLUMN=1, MAP=1, TITLE='Select Function', uvalue=info, xsize=200)
        	base=widget_base( COLUMN=1, MAP=1, TITLE='Select Function', uvalue=info)

        	group2=widget_base(base, column=1, map=1, xoffset=80)

		;if info.subset.data(event.index).src_types(0) eq 4 then begin
		if info.subset.data(event.index).src_types(0) eq 4 or $
		    info.subset.data(event.index).src_types(0) eq 3 then begin
			desc = [ 'Display Data', $
				 'Export Data', $
				 'Change Name', $
				 'Change Data Type', $
				 'Remove'	 ]
			info.graph_style = 'Display Data'
			y_size = 110
		endif else begin
			desc= [ '2D Graph' ,		$
				'2D Image' ,		$
				'2D Image With Scale' , $
				'3D Graph',		$
				'3D Surface',		$
				'Contour',		$
				'Grid Contour',		$
				'Grid Contour - Region',	$
				'Grid Cell',		$
				'Grid Cell - Region',	$
				'Statistics',		$
				'Statistics For Whole Subset',	$
				'Histogram',		$
				'XY Graph',		$
				'XYZ Graph',		$
				'3D Mesh Surface',	$
				'3D Color Mesh Graph',  $
				'Geolocated',		$
				'Contour Geolocated',	$
				'Create Subset',	$
				'Subsampling',		$
				'Array Average - 2D',	$
				'Array Average',	$
				'Regression',		$
				'Extract Bits',		$
				'Browse Image',		$
				'Browse Image With Average',	$
				'Vertical Feature Mask',	$
				'Old Vertical Feature Mask',	$
				'Transpose',		$
				'Display Data',		$
				'Display Attribute',	$
				'Export Data',		$
				'Export Data Without Filldata', $
				'Change Name', $
				'Change Data Type',	$
				'Replace Data Value',	$
				'Scale Data Value',	$
				'Remove'	]
			info.graph_style = '2D Graph'
			y_size = 600
		endelse	

		;if info.menu_order.flag eq 1 then desc = desc(sort(desc))
		if info.menu_order.flag gt 0 then begin
		    desc = desc(sort(desc))
		    if info.menu_order.flag eq 2 then begin
			desc = get_favorite_list( 0, desc, info)
		    endif
		    info.graph_style = desc(0)
		endif

		info = initial_info(info)
		info = initial_addtext(info)
		widget_control, set_uvalue=info, base

		the_style = CW_BGROUP(group2, desc, /return_name, $
			set_value=0, FONT=info.font, $
			;/scroll, y_scroll_size = 600, x_scroll_size = 240, $
			/scroll, y_scroll_size = y_size, x_scroll_size = 240, $
			event_func='graph_item', /exclusive)

		group2=widget_base(base, row=1,map=1, space=30, /align_center)

		button1=widget_button(group2, FONT=info.font, EVENT_PRO='graph_selected', $
			VALUE="Done", /ALIGN_CENTER)

		button2=widget_button(group2, FONT=info.font, EVENT_PRO='doneCB', $
			VALUE="Cancel", /ALIGN_CENTER)

		widget_control, /realize, base 

	endif else begin

		;------------------------	
		; View Data as a Table 
		;------------------------	

       		widget_control, /hourglass

		if info.device eq 'X' then begin
		   check=check_path(info.temp_dir)
		   if check eq 1 then begin
			table_filename=info.temp_dir+"."+info.tempname+"_table" + $
			   strcompress(string(info.subset.count),/REMOVE_ALL)
		   endif else begin
			table_filename=info.temp_dir+"/."+info.tempname+"_table" + $
			   strcompress(string(info.subset.count),/REMOVE_ALL)
		   endelse
		endif else begin
		   table_filename=info.temp_dir+"\."+info.tempname+"_table" + $
			strcompress(string(info.subset.count),/REMOVE_ALL)
		endelse

		get_lun, unit
		openw, unit, table_filename 

		;--------------------------
		; Write file header
		;--------------------------
		widget_control, info.widgets.current_file, get_value=filename		

        	printf, unit, format='("Source Data Filename: ",A)', filename
        	printf, unit, format='("Subset Name: ",A)', info.name_list_subset(event.index)

		;-------------------------------
		; Get values from the widgets
		;-------------------------------

		hdf_data = *info.subset.data(event.index).src_data

		if info.subset.data(event.index).src_type_flag eq 0 then printf, unit,$
		 hdf_data  else begin
			if info.subset.data(event.index).src_types(0) eq 4 then begin
				printf, unit, hdf_data(*).components0
			endif else begin
				temp='('+info.precision+')'
				temp=temp(0)
				printf, unit, format=temp, hdf_data(*).components0
				;printf, unit, hdf_data(*).components0
			endelse
		endelse

		close,unit
		free_lun, unit

		case info.editor_type of
			1: command_line = "emacs " + table_filename + " &"
			2: begin 
				command_line = info.ieditor + " -geometry 757x531+75+104"
				command_line = command_line + " -title 'Display Data' "
				command_line = command_line + table_filename + " &"
	   		   end
			3: command_line = 'start edit "' + table_filename + '"'
			4: begin
				if !D.Name eq 'X' then begin
				    command_line = info.editor + " " + table_filename + " &"
				endif else begin
				    command_line = 'start ' + info.editor + ' "' + table_filename + '"'
				endelse
			   end
			5: begin
				command_line="xterm -bg \#73a1ff -fn "
				command_line=command_line+ $
				    "-adobe-courier-bold-r-normal--14-100-100-100-m-90-iso8859-1"
				command_line=command_line + " -e emacs " + table_filename + " &"
			   end
			else: begin
				command_line="xterm -bg \#73a1ff -fn "
				command_line=command_line+ $
		   		"-adobe-courier-bold-r-normal--14-100-100-100-m-90-iso8859-1"
				command_line=command_line + " -e vi -R " + table_filename + " &"
			     end
		endcase
		spawn,command_line,results
	endelse

	widget_control, info.widgets.subset_list, set_list_select=-1

endelse

widget_control, set_uvalue=info, info.base

end

;------------------------------------------------------------------
;	pick_ssfCB	
;------------------------------------------------------------------
function pick_ssfCB, event

pro_name = 'pick_ssfCB'
@getinfo1

widget_control, get_uvalue=info, event.top

info.ssf.select = long(event.value) + 1L
info.ssf.key = 1
info.unitname = ', ' + info.name_list_units(event.value)

widget_control, set_uvalue=info, info.base

END

;--------------------------------------------------------------------------------
pro select_ssf, info, this_select, sds_ref

pro_name = 'select_ssf'
@getinfo

widget_control, info.widgets.current_file, get_value=filename		
filename = filename(0)

data_name = ''
data_name = info.name_list_sds(this_select)

CD, '.', CURRENT = PWD

the_result = get_sds_attr_name(filename,data_name,sds_ref)
;the_result = CALL_EXTERNAL(PWD+'/' + info.library,   $
;the_result = CALL_EXTERNAL(info.library,   $
;      		'get_sds_attr_name',  	$
;              	filename, $
;		data_name, $
;		/s_value)

if the_result ne "BAD" then begin

ssf_list  = str_sep(the_result, '|')

info = redefine_info( info, ssf_list, 6)

base_loc = widget_info(info.base, /geometry)
xoffset = base_loc.xoffset + 100
base = widget_base( GROUP_LEADER=info.base, /MODAL, COLUMN=1, MAP=1, $
	TITLE='Select '+data_name, uvalue=info, xoffset=xoffset)

button_group=cw_bgroup(base, ssf_list, column=1, $
	FONT=info.font, event_funct="pick_ssfCB", $
	/scroll, y_scroll_size=150, x_scroll_size=450, /exclusive)

group2=widget_base(base, row=1,map=1, space=40, /align_center)

button1=widget_button(group2, FONT=info.font, EVENT_PRO='doneCB', VALUE="Done",$
	/ALIGN_CENTER)

button2=widget_button(group2, FONT=info.font, EVENT_PRO='canceloptionCB', $
	VALUE="Cancel", /ALIGN_CENTER)

;button=widget_button(base, FONT=info.font, $
;	event_pro="doneCB", VALUE="Done", /ALIGN_CENTER )

widget_control, set_uvalue=info, base
widget_control, /realize, base 
widget_control, DEFAULT_BUTTON=button1, CANCEL_BUTTON=button2, base
xmanager, 'main_widget', base

endif else begin
	result=dialog_message('Problem reading SSF Attribute!',$
			title='View HDF Warning!')
	info.ssf.key = 0
endelse 

end

;------------------------------------------------------------------
;	pick_layerCB	
;------------------------------------------------------------------
function pick_layerCB, event

pro_name = 'pick_layerCB'
@getinfo1

widget_control, get_uvalue=info, event.top

info.ssf.layer = long(event.value) + 1L

widget_control, set_uvalue=info, info.base

END

;--------------------------------------------------------------------------------
pro select_layer, info

pro_name = 'select_layer'
@getinfo

data_name = ''
if info.ssf.key eq 1 then $
	data_name = info.name_list_ssf(info.ssf.select-1) $
	else data_name = info.name_list_sds(info.sds.index)

layer_list  = ["Lower Cloud Layer", "Upper Cloud Layer"]

base_loc = widget_info(info.base, /geometry)
xoffset = base_loc.xoffset + 100
base = widget_base( GROUP_LEADER=info.base, /MODAL, COLUMN=1, MAP=1, $
	TITLE='Select Cloud Layer', uvalue=info, xoffset=xoffset)

if !D.Name eq 'X' then y_size = 40 else y_size = 70
button_group=cw_bgroup(base, layer_list, column=1, $
			FONT=info.font, event_funct="pick_layerCB", $
                        /scroll, y_scroll_size=y_size, x_scroll_size=200, /exclusive)

group2=widget_base(base, row=1,map=1, space=40, /align_center)

button1=widget_button(group2, FONT=info.font, EVENT_PRO='doneCB', VALUE="Done",$
	/ALIGN_CENTER)

button2=widget_button(group2, FONT=info.font, EVENT_PRO='canceloptionCB', $
	VALUE="Cancel", /ALIGN_CENTER)

;button=widget_button(base, FONT=info.font, $
;	event_pro="doneCB", VALUE="Done", /ALIGN_CENTER )

widget_control, set_uvalue=info, base
widget_control, /realize, base 
widget_control, DEFAULT_BUTTON=button1, CANCEL_BUTTON=button2, base
xmanager, 'main_widget', base

end

;--------------------------------------------------------------------------------
pro select_vdataCB, event

pro_name = 'select_vdataCB'
@getinfo

if event.clicks eq 2 then return
widget_control, /hourglass
widget_control, get_uvalue=info, event.top

if (info.flags.data_read eq 0) then begin
	result=dialog_message('No data read in yet!',$
			title='View HDF Warning!')
	return
endif

if (info.subset.count eq info.subset.maximum) then begin
	the_message = ["You have maximun sets of data.","Please remove at least one set of data."]
	result=dialog_message(the_message, title='View HDF Warning!')
	return
endif

widget_control, info.widgets.current_file, get_value=filename		

if info.hdf5.flag eq 1 then begin
    read_hdf5_cdn_data, event.index, filename,info
    return
endif

info.vfield.name_sel=""

number_of_fields=0L

num_vdata = 1
info.vdata.name_sel = info.name_list_vdata(event.index)
check_name = info.vdata.name_sel
check_name = check_name(0)
subscripts = where(info.name_list_vdata eq check_name, count)
if count gt 1 then begin
   match = 0
   i = 0
   while match eq 0 and i lt count do begin
	if subscripts(i) eq event.index then begin
		num_vdata = i + 1
		match = 1
	endif		
	i = i + 1
   endwhile
endif
;print,'num_vdata = ',num_vdata
num_vdata = long(num_vdata)
if info.vgroup.flag eq 1 then begin
	vref = info.vgroup.vref
	vref_list = str_sep(vref, '|')
	v_ref = long(vref_list)
	vdata_ref = v_ref(event.index)
endif else vdata_ref = long(0)

CD, '.', CURRENT = PWD

;the_result = CALL_EXTERNAL(PWD+'/' + info.library,   $
;the_result = CALL_EXTERNAL(info.library,   $
;               	'get_vdata_fields',  		$
;                	filename,			$
;			info.vdata.name_sel,		$
;			number_of_fields,		$
;			/s_value)

the_result = get_vdata_fields(filename,check_name,number_of_fields,num_vdata,$
	vdata_ref, n_records)
;the_result = CALL_EXTERNAL(PWD+'/' + info.library,   $
;the_result = CALL_EXTERNAL(info.library,   $
;			'get_vdata_fields_eos',		$
;                	filename,			$
;			info.vdata.name_sel,		$
;			number_of_fields,		$
;			num_vdata,			$
;			vdata_ref,			$
;			/s_value)

if the_result ne "BAD" then begin

	;print,'vdata_ref = ',vdata_ref
	info.vdata.ref = vdata_ref
	the_vfield_list = str_sep(the_result, ',')
	;info = redefine_info( info, str_sep(the_result, ','), 1)
	info = redefine_info( info, the_vfield_list, 1)

	CD, '.', CURRENT = PWD

	;the_result = CALL_EXTERNAL(PWD+'/' + info.library,   $
	;the_result = CALL_EXTERNAL(info.library,   $
        ;       	'get_vdata_n_rec',  		$
        ;        	filename,			$
	;		info.vdata.name_sel)

	;the_result = CALL_EXTERNAL(PWD+'/' + info.library,   $
	;the_result = CALL_EXTERNAL(info.library,   $
;		'get_vdata_n_rec_eos', 		$
;		filename,			$
;		info.vdata.name_sel,		$
;		vdata_ref)

	info.rangetype.dim_name(*) = ''
	info.rangetype.dim_name(0) = 'Record Number'
	info.rangetype.dim_name(1) = 'Order Number'
	info.vdata.nrec=n_records
        ;info.sds.dims(0) = the_result
        info.sds.dims(0) = n_records
	num_vfield = n_elements(the_vfield_list)
	if num_vfield eq 1 then begin
		info.vfield.name_sel = the_vfield_list(0)
		info.vfield.indices_sel= [ long(0) ]
		vfield_range_dialogue, info
	endif else vdata_dialogue, info

endif else begin
	result=dialog_message('Problem reading Vdata Fields!',$
			title='View HDF Warning!')
endelse 

widget_control, set_uvalue=info, info.base

end

;--------------------------------------------------------------------------------
pro select_vgroup, name, info, vg_list, vg_id, index

pro_name = 'select_vgroup'
@getinfo

num_list = n_elements(vg_list)
ysize = fix(1.5 * num_list)
title = 'Select '+name
info.vgroup.base(index)=widget_base( COLUMN=1, MAP=1, TITLE=title, $
	XSIZE=300, uvalue=info)

vg_list=widget_list(info.vgroup.base(index), value=vg_list, $
	FONT=info.font, event_pro='get_vgroup', uvalue=vg_id, $
	xsize=60, ysize=ysize)

button1=widget_button(info.vgroup.base(index), FONT=info.font, EVENT_PRO='doneCB', $
	VALUE="Close", /ALIGN_CENTER)

widget_control, /realize, info.vgroup.base(index) 
widget_control, set_uvalue=info, info.vgroup.base(index)
widget_control, set_uvalue=info, info.base

if index gt 0 then begin
	if widget_info(info.vgroup.base(index-1),/valid_id) eq 1 then begin
		DEVICE, GET_SCREEN_SIZE=scr
		base_loc = widget_info(info.vgroup.base(index-1), /geometry)
		base_loc1 = widget_info(info.vgroup.base(index), /geometry)
		xoffset = base_loc.xoffset
		yoffset = base_loc.yoffset + base_loc.scr_ysize
		if yoffset + base_loc1.scr_ysize gt scr(1) then begin
			base_loc2 = widget_info(info.vgroup.base(0), /geometry)
			yoffset = base_loc2.yoffset
			if base_loc2.xoffset lt scr(0)/2 then begin
				xoffset = xoffset + base_loc.scr_xsize
			endif else begin
				xoffset = xoffset - base_loc.scr_xsize
			endelse
		endif
		widget_control, info.vgroup.base(index), xoffset=xoffset, yoffset=yoffset
	endif
endif

end

;--------------------------------------------------------------------------------
PRO set_all_out, Event

pro_name = 'set_all_out'
@getinfo

    widget_control, get_uvalue=info, event.top
    if(info.subset.count gt 0) then begin
	info.out.pick(0:info.subset.count - 1) = 1
	n_infooutpick = n_elements(info.out.pick)
	if n_infooutpick gt info.subset.count then $
		info.out.pick(info.subset.count:*) = 0
    endif 
    widget_control, set_uvalue=info, info.base
 
    widget_control, event.top, /destroy

END

;--------------------------------------------------------------------------------
PRO cancel_all_out, Event

pro_name = 'cancel_all_out'
@getinfo

	widget_control, get_uvalue=info, event.top
	info.out.pick(*) = 0
	widget_control, set_uvalue=info, info.base
 
	widget_control, event.top, /destroy

END

;------------------------------------------------------------------
pro set_axis_ranges, info, YRange, Ystyle,  XRange, Xstyle, ZRange, Zstyle

pro_name = 'set_axis_ranges'
@getinfo
 
Xstyle=2 & Ystyle=2 & Zstyle=2
XRange=[0L,0L] & YRange=[0L,0L] & ZRange=[0L,0L]
if (info.graph_style eq 'Geolocated' or $
    info.graph_style eq 'Contour Geolocated') then begin
     xrange_min = info.greenwich.greenloca - 180
     xrange_max = info.greenwich.greenloca + 180
     XRange=[xrange_min, xrange_max]
     YRange=[-90, 90]
endif

CASE info.axis_state of

        1 : begin
                	XRange=[info.range.x_start, info.range.x_end]
                	Xstyle=3
        end
        2 : begin
                	YRange=[info.range.y_start, info.range.y_end]
                	Ystyle=3
        end
        3 : begin
			ZRange=[info.range.z_start, info.range.z_end]
			ZStyle=3
        end
        4 : begin
                	XRange=[info.range.x_start, info.range.x_end]
                	Yrange=[info.range.y_start, info.range.y_end]
                	Xstyle=3
                	Ystyle=3
        end
        5 : begin
                	XRange=[info.range.x_start, info.range.x_end]
                	YRange=[info.range.y_start, info.range.y_end]
			ZRange=[info.range.z_start, info.range.z_end]
                	Xstyle=3
                	Ystyle=3
			Zstyle=3
        end
        7 : begin
			YRange=[info.range.y_start, info.range.y_end]
			YStyle=3
        end
        8 : begin
                	XRange=[info.range.x_start, info.range.x_end]
                	Xstyle=3
        end
        9 : begin
                	XRange=[info.range.x_start, info.range.x_end]
                	YRange=[info.range.y_start, info.range.y_end]
                	Xstyle=3
                	Ystyle=3
        end
        else :
ENDCASE

end

;--------------------------------------------------------------------------------
pro set_some_out, Event

pro_name = 'set_some_out'
@getinfo

widget_control, get_uvalue=info, event.top
widget_control, get_uvalue=top_base, event.id

info.out.pick(*) = 0

base_loc = widget_info(info.base, /geometry)
xoffset = base_loc.xoffset + 100
yoffset = base_loc.yoffset + 100
base=widget_base(group_leader=event.top, /modal, ROW=1, xoffset=xoffset, $
	yoffset=yoffset, TITLE='Select Output Variables')
widget_control, set_uvalue=info, base

the_pick=CW_BGROUP(base, info.name_list_subset, set_value=0, $
	FONT=info.font, $
        EVENT_FUNCT='out_selected', $
	uvalue=info,$
        /SCROLL,Y_SCROLL_SIZE=600,X_SCROLL_SIZE=300, /NONEXCLUSIVE)
   
group2=widget_base(base, column=1,map=1, space=40, /align_center)

button1=widget_button(group2, FONT=info.font, EVENT_PRO='donepick', UVALUE=top_base, $
	VALUE="Done", /ALIGN_CENTER)

button2=widget_button(group2, FONT=info.font, EVENT_PRO='doneCB', VALUE="Cancel",$
	 /ALIGN_CENTER)

widget_control,/realize, base
widget_control, DEFAULT_BUTTON=button1, CANCEL_BUTTON=button2, base
xmanager, 'main_widget', base

END

;--------------------------------------------------------------------------------
pro spawn_printjobCB, event

pro_name = 'spawn_printjobCB'
@getinfo

widget_control, event.top, get_uvalue=info
widget_control, event.top, /destroy
widget_control, set_uvalue=info, info.base
if(widget_info(info.widgets.base, /VALID_ID)) then $
	widget_control, set_uvalue=info, info.widgets.base

;-----------------------------------------------------------
; Queue the print job
;-----------------------------------------------------------

command_line="lp -c -d " + info.current_printer + $
                " "+info.temp_dir+"/."+info.tempname+"_ps"

spawn, command_line, results

result=dialog_message('Print Job Submitted!', title='Notice!')

command_line="\rm -f "+ info.temp_dir +"/."+info.tempname+"_ps"

spawn, command_line, results
		
end

;--------------------------------------------------------------------------------
pro spawn_viewjobCB, event

pro_name = 'spawn_viewjobCB'
@getinfo

widget_control, event.top, get_uvalue=info
widget_control, event.top, /destroy
widget_control, set_uvalue=info, info.base
if(widget_info(info.widgets.base, /VALID_ID)) then $
	widget_control, set_uvalue=info, info.widgets.base

;-----------------------------------------------------------
; Queue the print job
;-----------------------------------------------------------

if info.current_printer eq 'phaser550' then begin
	command_line="/usr/slocal/bin/phaser550 -s T "+$
		info.temp_dir+"/."+info.tempname+"_ps | lp -c -d phaser550"
endif else if info.current_printer eq 'sai550' then begin
	loc = check_command("phaser550")
	if loc ne -1 then begin
		loc = check_command("tekprint")
		if loc ne -1 then begin
			the_message = ["sai550 can't print viewgraph from your machine.", $
				"Please use other printer!"]
			result=dialog_message(the_message, title='View HDF Warning!')
			return
		endif else command_name = 'tekprint'
	endif else command_name = 'phaser550'
	;if info.printname eq 'asdsun' then command_name = 'phaser550' $
	;       else command_name = 'tekprint'
	;command_line="/usr/slocal/bin/phaser550 -s T "+$
	command_line="/usr/slocal/bin/"+command_name+" -s T "+$
		info.temp_dir+"/."+info.tempname+"_ps | lp -c -d sai550"
	;rmhost = ' '
	;rmhost = getenv('REMOTEHOST')
	;rmuser = ' '
	;rmuser = getenv('REMOTEUSER')
	;command_line="cat "+info.temp_dir+"/."+info.tempname+"_ps"+" | rsh " + $
	;	rmhost + " -l " + rmuser + " /usr/slocal/bin/tekprint -d sai550 -s M -"
endif else begin
	command_line = ''
	get_print_command, info
	widget_control, get_uvalue=info, info.base
	if info.canceloption eq 'Yes' then begin
		info.canceloption = 'No'
		widget_control, set_uvalue=info, info.base
		return
	endif else begin
		command_line = info.printcommand + " "+info.temp_dir+"/."+info.tempname+"_ps"
		print,'command_line = ', command_line
	endelse
endelse

spawn, command_line, results

result=dialog_message('Print Job Submitted!', title='Notice!')

command_line="\rm -f "+info.temp_dir+"/."+info.tempname+"_ps"

spawn, command_line, results
		
end

;------------------------------------------------------------------
function read_feature_data, this_subset, sds_name, info, sds_data

pro_name = 'read_feature_data'
@getinfo1

filename = info.subset.data(this_subset).src_filename
filename = filename(0)

sd_id = HDF_SD_START(filename, /READ)
if sd_id eq -1 then begin
	result=dialog_message('Unable to open '+filename+'!',$
		title='View HDF Warning!')
	return, -1
endif

sds_index = check_sds_index(filename,sds_name)
if sds_index eq -1 then begin
	result=dialog_message('Unable to get index for '+sds_name+'!',$
		title='View HDF Warning!')
	HDF_SD_END,sd_id
	return, -1
endif

sds_id = HDF_SD_SELECT(sd_id, sds_index)
if sds_id eq -1 then begin
	result=dialog_message('Unable to select '+sds_name+' SDS data!',$
		title='View HDF Warning!')
	HDF_SD_END,sd_id
	return, -1
endif

HDF_SD_GETINFO,sds_id, DIMS=sds_dims, NDIMS=sds_rank, HDF_TYPE=type, /NOREVERSE

start_list=lonarr(sds_rank)
end_list=lonarr(sds_rank)
increment_list=lonarr(sds_rank)
array_size=lonarr(sds_rank)

for i = 0, sds_rank-1 do begin
	start_list(i) = 0
	end_list(i) = sds_dims(i)
	increment_list(i) = 1
endfor

array_size = end_list

sds_type = convert_hdftypename_hdftype(type)
unsign_type = 0
if info.version lt 5.19 and info.library_status eq 1 then begin
	if sds_type gt 20 then unsign_type = sds_type mod 2
endif

if info.hdf421 eq 1 then unsign_type = 1

if unsign_type eq 0 then begin
	start_list = reverse(start_list)
	array_size = reverse(array_size)
	HDF_SD_GETDATA, sds_id, sds_data, START=start_list, COUNT=array_size
	HDF_SD_ENDACCESS,sds_id
	HDF_SD_END, sd_id
endif else begin
	HDF_SD_ENDACCESS,sds_id
	HDF_SD_END, sd_id
	CD, '.', CURRENT = PWD
	the_result = CALL_EXTERNAL(PWD+'/' + info.library,   $
		'read_sds_eos',$
		filename,$
		sds_name,$
		sds_index,$
		sds_rank,$
		sds_type,$
		sds_dims,$
		start_list,$
		end_list,$
		increment_list,$
		array_size,$
		sds_data)
	if (the_result eq -1) then begin
		result=dialog_message('Unable to read '+sds_name+' SDS data!',$
			title='View HDF Warning!')
		return, -1
	endif
endelse

return, 0

end 

;--------------------------------------------------------------------------------
function get_color_index, resol, colorint, in_color

pro_name = 'get_color_index'
@getinfo1

;  Set the color table for the boundaries
bred =   [255,   0, 250, 192,  30]
bgreen = [  0, 255, 255, 192,  30]
bblue  = [  0,   0,   0, 192,  30]

;  set the boundary color table based on the resol
case resol of
      1.0:  begin
		current_red   = [bred[0]]
		current_green = [bgreen[0]]
		current_blue  = [bblue[0]]
		color_index = fix(1.5 * colorint)
	    end
      3.0:  begin
		current_red   = [bred[1]]
		current_green = [bgreen[1]]
		current_blue  = [bblue[1]]
		color_index = fix(2.5 * colorint)
	    end
     15.0:  begin
		current_red   = [bred[2]]
		current_green = [bgreen[2]]
		current_blue  = [bblue[2]]
		color_index = fix(3.5 * colorint)
	    end
     60.0:  begin
		current_red   = [bred[3]]
		current_green = [bgreen[3]]
		current_blue  = [bblue[3]]
		color_index = fix(4.5 * colorint)
	    end
    240.0:  begin
		current_red   = [bred[4]]
		current_green = [bgreen[4]]
		current_blue  = [bblue[4]]
		color_index = fix(5.5 * colorint)
	    end
    else: begin
		result=dialog_message('Wrong resolution: '+resol, $
		    title='View HDF Warning!')
		return, in_color
	  end
endcase

;  Set the color
tvlct, current_red, current_green, current_blue, color_index

; print,'color_index = ',color_index,' for resol = ',resol
; print,'current_red = ',current_red
; print,'current_green = ',current_green
; print,'current_blue = ',current_blue

return, color_index

end

;--------------------------------------------------------------------------------
function display_feature_done, this_subset, color_index, top_name, base_name, info

pro_name = 'display_feature_done'
@getinfo1


if !D.Name ne 'PS' and !D.Name ne 'PRINTER' then wshow, !d.window

set_axis_ranges, info, YRange, Ystyle, XRange, Xstyle, ZRange, Zstyle

the_result = read_feature_data( this_subset, top_name, info, top_array)
if (the_result eq -1) then begin
    result=dialog_message('Unable to read ' + top_name + ' SDS data!',$
	title='View HDF Warning!')
    return, -1
endif

the_result = read_feature_data( this_subset, base_name, info, base_array)
if (the_result eq -1) then begin
    result=dialog_message('Unable to read ' + base_name + ' SDS data!',$
	title='View HDF Warning!')
    return, -1
endif

top_array = reform(top_array)
base_array = reform(base_array)

top_size = size(top_array)
base_size = size(base_array)
diff_size = top_size - base_size
sub_diff = where(diff_size ne 0, count)
if count ne 0 then begin
    the_message = ['The size of '+top_name+' is not equal to '+base_name, $
	'Please the size of the two arrays.']
    result=dialog_message(the_message, title='View HDF Warning!')
    return, -1
endif

if top_size[0] eq 1 and top_size[1] eq 15 then begin
    top_array = reform(top_array, top_size[1], 1)
    base_array = reform(base_array, base_size[1], 1)
    top_size = size(top_array)
    base_size = size(base_array)
endif

; print,'in display_feature_done, top_name = ',top_name,' max = ',max(top_array),', min = ',min(top_array)
; print,'base_name = ',base_name,', max = ',max(base_array),', min = ',min(base_array)
; print,'top_size = ',top_size
; print,'base_size = ',base_size

if(widget_info(info.widgets.base, /VALID_ID)) then begin
    this_start = info.subset.data(this_subset).src_start(0)
    this_end = info.subset.data(this_subset).src_end(0)
    if info.subset.data(this_subset).src_type_flag eq 0 then begin
	the_rank = info.subset.data(this_subset).src_rank
	if the_rank eq 1 then begin
	    true_start = info.subset.data(this_subset).src_start(the_rank)
	    true_end = info.subset.data(this_subset).src_end(the_rank)
	    if true_start ne this_start or true_end ne this_end then begin
		this_start = true_start
		this_end = true_end
	    endif
	endif
    endif else this_end = this_end + 1

    feat_name = strlowcase(top_name)
    loc = strpos(feat_name,'km')
    if loc eq -1 then begin
	rloc = rstrpos(top_name,'_')
	if rloc eq - 1 then begin
	    scale = 1.0
	endif else begin
	    length = strpos(top_name,'[')
	    if length eq -1 then length = strlen(top_name)
	    if rloc eq length - 2 then begin
		resol = strcompress(strmid(top_name, length - 1, 1), /REMOVE_ALL)
		case resol of
		    '1':  scale = 1.0
		    '2':  scale = 1.0 * info.browse_image.shotscale
		    '3':  scale = 5.0 * info.browse_image.shotscale
		    '4':  scale = 20.0 * info.browse_image.shotscale
		    '5':  scale = 80.0 * info.browse_image.shotscale
		    else: scale = 1.0
		endcase
	    endif else begin
		scale = 1.0
	    endelse
	endelse
    endif else begin
	rloc = rstrpos(feat_name, '_', loc)
	length = loc - rloc + 1
	resol = strmid(feat_name, rloc+1, length)
	scale = float(resol) * info.browse_image.shotscale
    endelse    

    ; print,'scale = ',scale

    xarray = *info.browse_image.xarray
    yarray = *info.browse_image.yarray
    max_yarray = max(yarray,min=min_yarray)
;   top_flag = 1 means index, = 0 means altitude
    if max_yarray gt 40.0 then top_flag = 1 else top_flag = 0
    max_top = max(top_array, min=min_top)
    if max_top gt 40.0 then top_array_flag = 1 else top_array_flag = 0
;   if yarray is index and top_array is altitude read the altitude
    alt_flag = 0
    if top_flag eq 1 and top_array_flag eq 0 then begin
	temp_name = 'altitude'
	the_result = read_feature_data( this_subset, temp_name, info, alt_array)
	if (the_result eq -1) then begin
	    the_message = ['Unable to read altitude data.', $
		'The y variable is not matched with top array,', $
		'you may have problem to display boundaries on the image.']
	    result=dialog_message(the_message, title='View HDF Warning!')
	endif else alt_flag = 1
    endif
    x_size = size(xarray)
    y_size = size(yarray)
    xindex = info.browse_image.xindex
    data_scale = info.browse_image.scale
    scale_ratio = scale / data_scale
    iscale_ratio = fix(scale_ratio)

    if info.graph_style eq 'Browse Image With Average' then begin
	;  Don't need the scale
	feat_start = this_start / scale
	feat_end = this_end / scale
    endif else begin
	feat_start = this_start / scale_ratio
	feat_end = this_end / scale_ratio 
    endelse

    ; print,'this_start = ',this_start,', this_end = ',this_end
    ; print,'feat_start = ',feat_start,', feat_end = ',feat_end
    ; print,'scale_ratio = ',scale_ratio

    swift_portion = feat_start - long(feat_start)
    if swift_portion lt 0.001 or swift_portion gt 0.999 then begin
	if swift_portion lt 0.001 then feat_start = long(feat_start) $
	else feat_start = long(feat_start + 0.9)
	start_portion = 1.0
	swift_portion = 0.0
    endif else start_portion = 1.0 - swift_portion

    end_portion = feat_end - long(feat_end)
    if end_portion lt 0.001 or end_portion gt 0.999 then end_portion = 1.0
    if end_portion eq 0.0 then end_portion = 1.0

    feat_start = long(feat_start)
    feat_end = long(feat_end+0.9) - 1

    if xindex eq -1 then begin
	num_x = n_elements(xarray)
	x_array = xarray - 1
	x_array = [x_array, xarray(num_x - 1)]
	xarray = x_array  * info.browse_image.scale
	x_size = size(xarray)
    endif

    max_x = max(xarray, min=min_x)

    xpos = 0.0
    ypos = 0.0
    xdelta = 0.0
    ydelta = 0.0
    xoffset = 0.0
    prev_location = 0.0
    if top_size(0) eq 2 then begin
	if feat_end ge top_size(2) then feat_end = top_size(2) - 1
	if feat_start lt 0 then feat_start = 0
	if (feat_start gt feat_end) then begin
	    ; print,'feat_start = ',feat_start,', feat_end = ',feat_end
	    result=dialog_message('The range for the feature ' + top_name + ' is invalid!',$
		title='View HDF Warning!')
	    return, -1
	endif
	top_array = top_array(*,feat_start:feat_end)
	base_array = base_array(*,feat_start:feat_end)
	top_size = size(top_array)
	base_size = size(base_array)
	if top_size(0) eq 1 then begin
	    top_array = reform(top_array, top_size(1), 1)
	    base_array = reform(base_array, base_size(1), 1)
	    top_size = size(top_array)
	    base_size = size(base_array)
	endif
	for j = 0L, top_size(1)-1 do begin
	    for i = 0L, top_size(2)-1 do begin
		; if top_array(j,i) ne 0 and base_array(j,i) ne 0 then begin
		if top_array(j,i) gt -2.0 and base_array(j,i) gt -2.0 then begin
		    x_location = i * scale_ratio + 1
		    i_index = long(x_location)
		    if i_index ge x_size(1) or i_index+1 ge x_size(1) then begin
			xval = prev_location
			deltx = max_x - xval
			if abs(x_delta) gt abs(deltx) then x_delta = deltx else x_delta = 0.0
		    endif else begin
		      deltx = (x_location - i_index)*(xarray(i_index+1) - xarray(i_index))
		      xval = xarray(i_index) + deltx
		      if i eq 0 then begin
			if xindex eq -1 then begin
			    x_delta = scale * start_portion
			    if swift_portion gt 0.0 then xoffset = scale * swift_portion
			endif else begin
			    if scale_ratio gt 1.0 then begin
				if iscale_ratio ge x_size(1) then deltx = max_x - xarray(0) $
				else begin
				    deltx = scale_ratio - iscale_ratio
				    x_delta = xarray(iscale_ratio) - xarray(0)
				    if deltx * 10 gt 1.0 then begin
					if 2*iscale_ratio ge x_size(1) then x_val = x_delta $
					else x_val = xarray(2*iscale_ratio) - xarray(iscale_ratio)
					x_delta = x_delta + x_val * deltx
				    endif
				endelse
			    endif else x_delta = (xarray(1) - xarray(0)) * scale_ratio
			    if swift_portion gt 0.0 then xoffset = x_delta * swift_portion
			    x_delta = x_delta * start_portion
			endelse
		      endif else if i eq top_size(2)-1 then begin
			if xindex eq -1 then x_delta = scale * end_portion $
			else begin
			    if scale_ratio gt 1.0 then begin
				if i_index ge x_size(1) - 1 then begin
				    i_next = i_index-iscale_ratio
				    if i_next lt 0 then i_next = 0
				endif else begin
				    i_next = i_index + iscale_ratio
				    if i_next ge x_size(1) then begin
					i_next = i_index-iscale_ratio
					if i_next lt 0 then i_next = 0
				    endif
				endelse
				x_delta = max_x - xarray(i_index)
				if i_next ge 0 then deltx = abs((xarray(i_index) - xarray(i_next))) $
				else deltx = 1.0E+35
				deltx = (scale_ratio - iscale_ratio) * deltx + deltx
			    endif else begin
				if i_index ge x_size(1) - 1 then i_next = i_index-1 $
				else i_next = i_index+1
				x_delta = max_x - xval
				if i_next ge 0 then $
				    deltx = abs((xarray(i_index) - xarray(i_next))) * scale_ratio $
				else deltx = 1.0E+35
			    endelse
			    if abs(x_delta) gt abs(deltx) then x_delta = deltx
			endelse
		      endif else begin
			if xindex eq -1 then x_delta = scale $
			else begin
			    if scale_ratio gt 1.0 then begin
				if i_index + iscale_ratio ge x_size(1) then begin
				    x_delta = max_x - xarray(i_index)
				endif else begin
				    deltx = scale_ratio - iscale_ratio
				    x_delta = xarray(i_index+iscale_ratio) - xarray(i_index)
				    if deltx * 10 gt 1.0 then begin
					if 2*iscale_ratio + i_index ge x_size(1) then x_val = x_delta $
					else x_val = xarray(2*iscale_ratio+i_index) - xarray(i_index+iscale_ratio)
					x_delta = x_delta + x_val * deltx
				    endif
				endelse
			    endif else begin
				if i_index + iscale_ratio ge x_size(1) then begin
				    if i_index - iscale_ratio lt 0 then begin
					x_delta = max_x - xarray(i_index)
				    endif else begin
					x_delta = (xarray(i_index) - xarray(i_index-iscale_ratio)) * scale_ratio
				    endelse
				endif else begin
				    x_delta = (xarray(i_index+iscale_ratio) - xarray(i_index)) * scale_ratio
				endelse
			    endelse
			endelse
		      endelse
		      if swift_portion gt 0.0 then begin
			xval = xval - xoffset
			if xval lt min_x then xval = min_x
		      endif
		    endelse

		    xpos = [xpos, xval]
		    xdelta = [xdelta, x_delta]
		    if top_flag eq 1 then begin
			if alt_flag eq 1 then begin
			    top_sub = where(alt_array le top_array(j,i), top_count)
			    base_sub = where(alt_array le base_array(j,i), base_count)
			    if top_count ne 0 and base_count ne 0 then begin
				ypos = [ypos, yarray(top_sub(0))]
				y_delta = yarray(top_sub(0)) - yarray(base_sub(0))
			    endif
			endif else begin
			    ypos = [ypos, yarray(top_array(j,i))]
			    y_delta = yarray(top_array(j,i)) - yarray(base_array(j,i))
			endelse
		    endif else begin
			if top_array_flag eq 1 then begin
			    ypos = [ypos, yarray(top_array(j,i))]
			    y_delta = yarray(top_array(j,i)) - yarray(base_array(j,i))
			endif else begin
			    ypos = [ypos, top_array(j,i)]
			    y_delta = top_array(j,i) - base_array(j,i)
			endelse
		    endelse
		    ydelta = [ydelta, y_delta]
		    prev_location = xval + x_delta
		endif
	    endfor
	endfor
    endif else if top_size(0) eq 1 then begin
	if top_size(1) ne y_size(1) then begin
	    if feat_end ge top_size(1) then feat_end = top_size(1) - 1
	    if feat_start lt 0 then feat_start = 0
	    top_array = top_array(feat_start:feat_end)
	    base_array = base_array(feat_start:feat_end)
	    top_size = size(top_array)
	    base_size = size(base_array)
	    for i = 0L, top_size(1)-1 do begin
		; if top_array(i) ne 0 and base_array(i) ne 0 then begin
		if top_array(i) gt -2.0 and base_array(i) gt -2.0 then begin
		    x_location = i * scale_ratio + 1
		    i_index = long(x_location)
		    if i_index ge x_size(1) or i_index+1 ge x_size(1) then begin
			xval = prev_location
			deltx = max_x - xval
			if abs(x_delta) gt abs(deltx) then x_delta = deltx else x_delta = 0.0
		    endif else begin
		      deltx = (x_location - i_index)*(xarray(i_index+1) - xarray(i_index))
                      xval = xarray(i_index) + deltx
		      if i eq 0 then begin
			if xindex eq -1 then begin
			    x_delta = scale * start_portion
			    if swift_portion gt 0.0 then xoffset = scale * swift_portion
			endif else begin
			    if scale_ratio gt 1.0 then begin
				if iscale_ratio ge x_size(1) then deltx = max_x - xarray(0) $
				else begin
				    deltx = scale_ratio - iscale_ratio
				    x_delta = xarray(iscale_ratio) - xarray(0)
				    if deltx * 10 gt 1.0 then begin
					if 2*iscale_ratio ge x_size(1) then x_val = x_delta $
					else x_val = xarray(2*iscale_ratio) - xarray(iscale_ratio)
					x_delta = x_delta + x_val * deltx
				    endif
				endelse
			    endif else x_delta = (xarray(1) - xarray(0)) * scale_ratio
			    if swift_portion gt 0.0 then xoffset = x_delta * swift_portion
			    x_delta = x_delta * start_portion
			endelse
		      endif else if i eq top_size(1)-1 then begin
			if xindex eq -1 then x_delta = scale * end_portion $
			else begin
			    if scale_ratio gt 1.0 then begin
				if i_index ge x_size(1) - 1 then begin
				    i_next = i_index-iscale_ratio
				    if i_next lt 0 then i_next = 0
				endif else begin
				    i_next = i_index + iscale_ratio
				    if i_next ge x_size(1) then begin
					i_next = i_index-iscale_ratio
					if i_next lt 0 then i_next = 0
				    endif
				endelse
				x_delta = max_x - xarray(i_index)
				if i_next ge 0 then deltx = abs((xarray(i_index) - xarray(i_next))) $
				else deltx = 1.0E+35
				deltx = (scale_ratio - iscale_ratio) * deltx + deltx
			    endif else begin
				if i_index ge x_size(1) - 1 then i_next = i_index-1 $
				else i_next = i_index+1
				x_delta = max_x - xval
				if i_next ge 0 then $
				    deltx = abs((xarray(i_index) - xarray(i_next))) * scale_ratio $
				else deltx = 1.0E+35
			    endelse
			    if abs(x_delta) gt abs(deltx) then x_delta = deltx
			endelse
		      endif else begin
			if xindex eq -1 then x_delta = scale $
			else begin
			    if scale_ratio gt 1.0 then begin
				if i_index + iscale_ratio ge x_size(1) then begin
				    x_delta = max_x - xarray(i_index)
				endif else begin
				    deltx = scale_ratio - iscale_ratio
				    x_delta = xarray(i_index+iscale_ratio) - xarray(i_index)
				    if deltx * 10 gt 1.0 then begin
					if 2*iscale_ratio + i_index ge x_size(1) then x_val = x_delta $
					else x_val = xarray(2*iscale_ratio+i_index) - xarray(i_index+iscale_ratio)
					x_delta = x_delta + x_val * deltx
				    endif
				endelse
			    endif else begin
				if i_index + iscale_ratio ge x_size(1) then begin
				    if i_index - iscale_ratio lt 0 then begin
					x_delta = max_x - xarray(i_index)
				    endif else begin
					x_delta = (xarray(i_index) - xarray(i_index-iscale_ratio)) * scale_ratio
				    endelse
				endif else begin
				    x_delta = (xarray(i_index+iscale_ratio) - xarray(i_index)) * scale_ratio
				endelse
			    endelse
			endelse
		      endelse
		      if swift_portion gt 0.0 then begin
			xval = xval - xoffset
			if xval lt min_x then xval = min_x
		      endif
		    endelse

		    xpos = [xpos, xval]
		    xdelta = [xdelta, x_delta]
		    if top_flag eq 1 then begin
			if alt_flag eq 1 then begin
			    top_sub = where(alt_array le top_array(i), top_count)
			    base_sub = where(alt_array le base_array(i), base_count)
			    if top_count ne 0 and base_count ne 0 then begin
				ypos = [ypos, yarray(top_sub(0))]
				y_delta = yarray(top_sub(0)) - yarray(base_sub(0))
			    endif
			endif else begin
			    ypos = [ypos, yarray(top_array(i))]
			    y_delta = yarray(top_array(i)) - yarray(base_array(i))
			endelse
		    endif else begin
			if top_array_flag eq 1 then begin
			    ypos = [ypos, yarray(top_array(i))]
			    y_delta = yarray(top_array(i)) - yarray(base_array(i))
			endif else begin
			    ypos = [ypos, top_array(i)]
			    y_delta = top_array(i) - base_array(i)
			endelse
		    endelse
		    ydelta = [ydelta, y_delta]
		    prev_location = xval + x_delta
		endif
	    endfor
	endif else begin
	    the_rank = info.subset.data(this_subset).src_rank
            true_start = info.subset.data(this_subset).src_start(the_rank)
	    if true_start gt x_size(1) then true_start = fix(x_size(1)/2)
	    xpos_temp = xarray(true_start)
	    for i = 0L, top_size(1)-1 do begin
		if top_array(i) ne 0 and base_array(i) ne 0 then begin
		    xpos = [xpos, xpos_temp]
		    ypos = [ypos, yarray(top_array(i))]
		    xdelta = [xdelta, scale]
		    y_delta = yarray(top_array(i)) - yarray(base_array(i))
		    ydelta = [ydelta, y_delta]
		endif
	    endfor
	endelse
    endif
    fit_flag = 0
    num_xpos = n_elements(xpos)
    if num_xpos gt 1 then begin
	xpos = xpos(1:*)
	ypos = ypos(1:*)
	xdelta = xdelta(1:*)
	ydelta = ydelta(1:*)
	if info.axis_state gt 0 then begin
	    old_xrange = xrange
	    if info.axis_state eq 1 or info.axis_state eq 4 or info.axis_state eq 5 then begin
		if xrange(0) gt 0.0 then xrange(0) = xrange(0) - xdelta(0)
	    endif
	    fit_data_range, info.axis_state, fit_flag, 2, 1, xrange, yrange, 0, 0, xpos, $
		ypos, xdelta, 0, ydelta
	    xrange = old_xrange
	endif
    endif

    ;print,'xpos = ',xpos
    ;print,'ypos = ',ypos
    ;print,'xdelta = ',xdelta
    ;print,'ydelta = ',ydelta
    ;print,'fit_flag = ',fit_flag
    if fit_flag eq 0 then begin
	num_pos = n_elements(xpos)
	;print,'num_pos = ',num_pos
	the_color = color_index
	if info.browse_image.setfcolor eq 1 and info.browse_image.colorint gt 0 then begin
	    the_color = get_color_index(scale, info.browse_image.colorint, color_index)
	endif
	if info.axis_state eq 1 or info.axis_state eq 4 or info.axis_state eq 5 then begin
	    x_begin = xrange(0)
	    x_stop = xrange(1)
	endif else begin
	    x_begin = !x.crange(0)
	    x_stop = !x.crange(1)
	endelse
	x_min_thick = 0.07 * !D.X_PX_CM
	y_min_thick = 0.04 * !D.Y_PX_CM
	for i = 0L, num_pos-1 do begin
	    x_start = xpos(i)
	    x_end = xpos(i)+xdelta(i)
	    ;print,'x_start = ',x_start,', x_end = ',x_end
	    if x_start lt x_begin then x_start = x_begin
	    if x_end gt x_stop then x_end = x_stop
	    ;vert1 = convert_coord(xpos(i), ypos(i), /to_device)
	    ;vert2 = convert_coord(xpos(i)+xdelta(i), ypos(i), /to_device)
	    ;vert3 = convert_coord(xpos(i)+xdelta(i), ypos(i)-ydelta(i), /to_device)
	    ;vert4 = convert_coord(xpos(i), ypos(i)-ydelta(i), /to_device)
	    vert1 = convert_coord(x_start, ypos(i), /to_device)
	    vert2 = convert_coord(x_end, ypos(i), /to_device)
	    vert3 = convert_coord(x_end, ypos(i)-ydelta(i), /to_device)
	    vert4 = convert_coord(x_start, ypos(i)-ydelta(i), /to_device)
	    x = [vert1(0), vert2(0), vert3(0), vert4(0)]
	    y = [vert1(1), vert2(1), vert3(1), vert4(1)]
	    polyfill, x, y, color=the_color, /DEVICE
	    ;if(abs(vert2(0) - vert1(0)) gt 3.0*info.style.linethick) then begin
	    if(abs(vert2(0) - vert1(0)) gt x_min_thick*info.style.linethick) and $
		(abs(vert2(1) - vert3(1)) gt y_min_thick*info.style.linethick) then begin
		x = [x_start, x_end, x_end, x_start, x_start]
		y = [ypos(i), ypos(i), ypos(i)-ydelta(i), ypos(i)-ydelta(i), ypos(i)]
		oplot,x,y,color=0, thick = info.style.linethick
	    endif
	endfor
    endif
endif

if(widget_info(info.widgets.base, /VALID_ID)) then $
    widget_control, set_uvalue=info, info.widgets.base
widget_control, set_uvalue=info, info.base

return,1

end

;--------------------------------------------------------------------------------
pro redisplay_feature, this_subset, top_list, info

pro_name = 'redisplay_feature'
@getinfo

sub_add = where(info.browse_image.farray ge 0, count)
if count eq 0 then return

num_name = n_elements(top_list) - 2
color_interval = fix((!d.n_colors-5)/num_name)

for i = 0, count-1 do begin
    add_index = info.browse_image.farray(sub_add(i))
    if add_index gt 2 then begin
	fname = top_list(add_index)
	subscript = where(info.name_list_sds eq fname, count1)
	if count1 eq 0 then begin
	    result= dialog_message('Somethings Wrong!', title='View HDF Warning')
	    return
	endif
	top_name = info.name_list_sds(subscript(0))
	dot=strpos(top_name,'[')
	if( dot ne -1) then begin
	    top_name=strmid(top_name,0,dot)
	endif else begin
	    top_name = top_name
	endelse
	length = strlen(top_name)
	; check the km or not
	; dot=strpos(top_name,'km')
	; if( dot ne -1) then begin
	    ; base_name = 'Base'+strmid(top_name,3,length-3)
	; endif else begin
	    ; base_name = 'Base'+strmid(top_name,3,length-3)
	; endelse
	;  Replace the Top with Base
	loc = strpos(top_name, 'Top')
	if loc eq 0 then begin
	    base_name = 'Base'+strmid(top_name,3)
	endif else if loc ne -1 then begin
	    first_part = strmid(top_name, 0, loc)
	    last_part = strmid(top_name, loc+3)
	    base_name = first_part + 'Base' + last_part
	endif else begin
	    the_message = 'Somethings Wrong with the name: '+top_name
	    result= dialog_message(the_message, title='View HDF Warning')
	    return
	endelse
	; print,'top_name = ',top_name,', base_name = ',base_name
    endif else begin
	temp_name = info.field_name.z
	temp_name = strlowcase(temp_name)
	loc = strpos(temp_name,'km')
	if loc eq -1 then begin
	    rloc = rstrpos(temp_name,'_')
	    if rloc eq - 1 then begin
		; top_name = 'Top'
		; base_name = 'Base'
		top_name = 'zTop_1shot'
		base_name = 'zBase_1shot'
	    endif else begin
		length = strpos(temp_name,'[')
		if length eq -1 then length = strlen(temp_name)
		if rloc eq length - 2 then begin
		    resol = strcompress(strmid(temp_name, length - 1, 2), /REMOVE_ALL)
		    ; top_name = 'Top_'+resol
		    ; base_name = 'Base_'+resol
		    top_name = 'zTop_'+resol
		    base_name = 'zBase_'+resol
		endif else begin
		    ; top_name = 'Top'
		    ; base_name = 'Base'
		    top_name = 'zTop_1shot'
		    base_name = 'zBase_1shot'
		endelse
	    endelse
	endif else begin
	    rloc = rstrpos(temp_name,'_',loc)
	    length = loc - rloc + 2
	    temp = strmid(temp_name,rloc,length)
	    ; top_name = 'Top'+temp
	    ; base_name = 'Base'+temp
	    top_name = 'zTop'+temp
	    base_name = 'zBase'+temp
	endelse
    endelse

    color_index = color_interval * (add_index - 1)
    result = display_feature_done(this_subset, color_index, top_name, base_name, info)
endfor

end

;--------------------------------------------------------------------------------
pro display_feature, event

pro_name = 'display_feature'
@getinfo

widget_control, get_uvalue=info, event.top

if info.browse_image.feature eq event.index then return

widget_control, get_uvalue=top_list, event.id
info.browse_image.feature = event.index

widget_control, info.browse_image.twidget, sensitive = info.browse_image.feature

widget_control, set_uvalue=info, event.top
if(widget_info(info.widgets.base, /VALID_ID)) then begin
    if info.browse_image.feature eq 0 then begin
	image = *info.browse_image.image
	tvscl24, image
    endif else begin
	this_subset = info.subset.selected
	redisplay_feature, this_subset, top_list, info
    endelse
    widget_control, set_uvalue=info, info.widgets.base
endif
widget_control, set_uvalue=info, info.base

end

;--------------------------------------------------------------------------------
pro set_feature, event

pro_name = 'set_feature'
@getinfo

widget_control, get_uvalue=info, event.top

info.browse_image.findex = event.index

widget_control, set_uvalue=info, event.top
if(widget_info(info.widgets.base, /VALID_ID)) then $
    widget_control, set_uvalue=info, info.widgets.base

end

;--------------------------------------------------------------------------------
pro set_feature_color, event

pro_name = 'set_feature_color'
@getinfo

widget_control, get_uvalue=info, event.top

info.browse_image.setfcolor = event.index

widget_control, set_uvalue=info, event.top
if(widget_info(info.widgets.base, /VALID_ID)) then $
    widget_control, set_uvalue=info, info.widgets.base

end

;--------------------------------------------------------------------------------
pro add_feature, event

pro_name = 'add_feature'
@getinfo

widget_control, get_uvalue=top_list, event.id
if top_list(0) eq 'None' then return
widget_control, get_uvalue=info, event.top
add_index = info.browse_image.findex
if(widget_info(info.widgets.base, /VALID_ID)) then $
        widget_control, get_uvalue=info, info.widgets.base

subscript = where(info.browse_image.farray eq add_index, count)
if count ne 0 then return

if add_index gt 2 then begin
    fname = top_list(add_index)
    subscript = where(info.name_list_sds eq fname, count)
    if count eq 0 then begin
	result= dialog_message('Somethings Wrong!', title='View HDF Warning')
	return
    endif
    top_name = info.name_list_sds(subscript(0))
    dot=strpos(top_name,'[')
    if( dot ne -1) then begin
	top_name=strmid(top_name,0,dot)
    endif else begin
	top_name = top_name
    endelse
    length = strlen(top_name)
    ; check the km or not
    dot=strpos(top_name,'km')
    if( dot ne -1) then begin
	base_name = 'Base'+strmid(top_name,3,length-3)
    endif else begin
	base_name = 'Base'+strmid(top_name,3,length-3)
    endelse
    ;  Replace the Top with Base
    loc = strpos(top_name, 'Top')
    if loc eq 0 then begin
	base_name = 'Base'+strmid(top_name,3)
    endif else if loc ne -1 then begin
	first_part = strmid(top_name, 0, loc)
	last_part = strmid(top_name, loc+3)
	base_name = first_part + 'Base' + last_part
    endif else begin
	the_message = 'Somethings Wrong with the name: '+top_name
	result= dialog_message(the_message, title='View HDF Warning')
	return
    endelse
    ; print,'top_name = ',top_name,', base_name = ',base_name
endif else if add_index lt 2 then begin
    loc = strpos(top_list, 'km')
    subscript = where(loc ne -1, count)
    if count eq 0 then begin
	; check with 'top_in'
	loc = strpos(top_list, 'Top_')
	subscript = where(loc ne -1, count)
	if count eq 0 then begin
	    result = dialog_message('No feature is found!', title='View HDF Warning')
	    return
	endif
    endif else begin
	;  Remove any with TopIndex
	check_count = 0
	check_sub = [-9]
	for i = 0, count-1 do begin
	    loc = strpos(top_list[subscript[i]], 'Top_')
	    if loc ne -1 then begin
		check_sub = [check_sub, subscript[i]]
		check_count = check_count + 1
	    endif
	endfor
	if check_count gt 0 then begin
	    subscript = check_sub[1:check_count]
	    count = check_count
	    ; print,'There are ',count,' feature found'
	    ; print,'subscript = ',subscript
	endif else begin
	    result = dialog_message('No feature is found!', title='View HDF Warning')
	    return
	endelse
    endelse
    ;  Check the Top (single resolution)
    top_sub = where(top_list eq 'Top' or top_list eq 'zTop_1shot', top_count)
    if(top_count eq 1) then begin
	;put the index at the beginning
	subscript = [top_sub[0], subscript]
	count = count + 1
    endif
    if add_index eq 0 then subscript = reverse(subscript)
    ; print,'feature: subscript = ',subscript
    info.browse_image.farray(*) = -1
    info.browse_image.farray(0:count-1) = subscript
    info.browse_image.number = count
endif else begin
    temp_name = info.field_name.z
    temp_name = strlowcase(temp_name)
    loc = strpos(temp_name,'km')
    if loc eq -1 then begin
	rloc = rstrpos(temp_name,'_')
	if rloc eq - 1 then begin
	    ; top_name = 'Top'
	    ; base_name = 'Base'
	    top_name = 'zTop_1shot'
	    base_name = 'zBase_1shot'
	endif else begin
	    length = strpos(temp_name,'[')
	    if length eq -1 then length = strlen(temp_name)
	    if rloc eq length - 2 then begin
		resol = strcompress(strmid(temp_name, length - 1, 2), /REMOVE_ALL)
		; top_name = 'Top_'+resol
		; base_name = 'Base_'+resol
		top_name = 'zTop_'+resol
		base_name = 'zBase_'+resol
	    endif else begin
		; top_name = 'Top'
		; base_name = 'Base'
		top_name = 'zTop_1shot'
		base_name = 'zBase_1shot'
	    endelse
	endelse
    endif else begin
	rloc = rstrpos(temp_name,'_',loc)
	length = loc - rloc + 2
	temp = strmid(temp_name,rloc,length)
	; top_name = 'Top'+temp
	; base_name = 'Base'+temp
	top_name = 'zTop'+temp
	base_name = 'zBase'+temp
    endelse
endelse

this_subset = info.subset.selected

if add_index lt 2 then begin
    image = *info.browse_image.image
    tvscl24, image
    redisplay_feature, this_subset, top_list, info
endif else begin    
    num_name = n_elements(top_list) - 2
    color_interval = fix((!d.n_colors-5)/num_name)
    color_index = color_interval * (add_index - 1)
    result = display_feature_done(this_subset, color_index, top_name, base_name, info)
    if result eq 1 then begin
	if info.browse_image.number lt info.browse_image.max_num then begin
	    info.browse_image.farray(info.browse_image.number) = add_index
	    info.browse_image.number = info.browse_image.number + 1
	endif else begin
	    the_message=['Number of features has been reached maximum', $
		'The feature is not saved.']
	    result=dialog_message(the_message, title='View HDF Warning!')
	endelse
    endif
endelse

widget_control, set_uvalue=info, event.top
if(widget_info(info.widgets.base, /VALID_ID)) then $
    widget_control, set_uvalue=info, info.widgets.base
widget_control, set_uvalue=info, info.base

end

;--------------------------------------------------------------------------------
pro remove_feature, event

pro_name = 'remove_feature'
@getinfo

widget_control, get_uvalue=top_list, event.id
if top_list(0) eq 'None' then return
widget_control, get_uvalue=info, event.top
remove_index = info.browse_image.findex
if(widget_info(info.widgets.base, /VALID_ID)) then $
    widget_control, get_uvalue=info, info.widgets.base

if remove_index lt 2 then begin
    info.browse_image.farray(*) = -1
    info.browse_image.number = 0
endif else begin
    subscript = where(info.browse_image.farray eq remove_index, count)
    if count eq 0 then return
    info.browse_image.farray(subscript(0)) = -1
    info.browse_image.number = info.browse_image.number - 1
endelse

sub_add = where(info.browse_image.farray ge 0, count)
if count eq 0 then begin
    if(widget_info(info.widgets.base, /VALID_ID)) then begin
	image = *info.browse_image.image
	tvscl24, image
	info.browse_image.number = 0
	widget_control, set_uvalue=info, info.widgets.base
    endif
    widget_control, set_uvalue=info, event.top
    widget_control, set_uvalue=info, info.base
    return
endif else begin
    if(not widget_info(info.widgets.base, /VALID_ID)) then begin
	widget_control, set_uvalue=info, event.top
	widget_control, set_uvalue=info, info.base
	return
    endif
endelse

temp = info.browse_image.farray(sub_add)
info.browse_image.farray(*) = -1
info.browse_image.farray(0:count-1) = temp

image = *info.browse_image.image
tvscl24, image

this_subset = info.subset.selected

redisplay_feature, this_subset, top_list, info

widget_control, set_uvalue=info, event.top
if(widget_info(info.widgets.base, /VALID_ID)) then $
    widget_control, set_uvalue=info, info.widgets.base

end

;--------------------------------------------------------------------------------
pro set_feature_profile, this_subset, prof_res, info

pro_name = 'set_feature_profile'
@getinfo

if prof_res eq 'full' then begin
    top_name = 'Top'
    base_name = 'Base'
endif else begin
    loc = strpos(prof_res,'km')
    if loc ne -1 then begin
	top_name = 'Top_'+prof_res
	base_name = 'Base_'+prof_res
	subscript = where(info.name_list_sds eq top_name, count)
	if count eq 0 then begin
	    case prof_res of
		'1km':	begin
			    top_name = 'Top_2'
			    base_name = 'Base_2'
			end
		'5km':	begin
			    top_name = 'Top_3'
			    base_name = 'Base_3'
			end
		'20km':	begin
			    top_name = 'Top_4'
			    base_name = 'Base_4'
			end
		'80km':	begin
			    top_name = 'Top_5'
			    base_name = 'Base_5'
			end
		else:	begin
			    top_name = 'Top'
			    base_name = 'Base'
			end
	    endcase
	endif
    endif else begin
	top_name = 'Top_'+prof_res
	base_name = 'Base_'+prof_res
	subscript = where(info.name_list_sds eq top_name, count)
	if count eq 0 then begin
	    case prof_res of
		'2':  begin
			top_name = 'Top_1km'
			base_name = 'Base_1km'
		      end
		'3':  begin
			top_name = 'Top_5km'
			base_name = 'Base_5km'
		      end
		'4':  begin
			top_name = 'Top_20km'
			base_name = 'Base_20km'
		      end
		'5':  begin
			top_name = 'Top_80km'
			base_name = 'Base_80km'
		      end
		else: begin
			top_name = 'Top'
			base_name = 'Base'
		      end
	    endcase    
	endif
    endelse
    subscript = where(info.name_list_sds eq top_name, count)
    if count eq 0 then begin
	top_name = 'Top'
	base_name = 'Base'
	;info.browse_image.proscale = 1
    endif
endelse

if ptr_valid(info.browse_image.tarray) then ptr_free, info.browse_image.tarray
if ptr_valid(info.browse_image.barray) then ptr_free, info.browse_image.barray
if ptr_valid(info.browse_image.x) then ptr_free, info.browse_image.x
if ptr_valid(info.browse_image.y) then ptr_free, info.browse_image.y
if ptr_valid(info.browse_image.z) then ptr_free, info.browse_image.z

subscript = where(info.name_list_sds eq top_name, count)
if count eq 0 then feature_flag = 0 else feature_flag = 1
;print,'count = ',count,', feature_flag = ',feature_flag, $
;    ' top_name = ',top_name,', base_name = ',base_name

temp_name = info.field_name.z
temp_name = strlowcase(temp_name)
loc = strpos(temp_name,'km')
if loc eq -1 then begin
    if prof_res eq 'full' then begin
	data_name = info.field_name.z
	loc = strpos(temp_name, 'full')
	thre_len = loc - 1
	if thre_len lt 0 then thre_len = -1
    endif else begin
	loc = strpos(temp_name, 'full')
	if loc eq -1 then begin
	    rloc = rstrpos(temp_name,'_')
	    if rloc eq - 1 then begin
		data_name = info.field_name.z
		thre_len = -1
	    endif else begin
		length = strpos(temp_name,'[')
		if length eq -1 then length = strlen(temp_name)
		if rloc eq length - 2 then begin
		    resol = strcompress(strmid(temp_name, length - 1, 2), /REMOVE_ALL)
		    data_name = info.browse_image.rootname+'_'+prof_res
		    band_loc = strpos(temp_name, '532')
		    if band_loc ne -1 then begin
			thre_len = 532
		    endif else begin
			band_loc = strpos(temp_name, '1064')
			if band_loc ne -1 then thre_len = 1064 else thre_len = -1
		    endelse
		endif else begin
		    data_name = info.field_name.z
		    thre_len = -1
		endelse
	    endelse
	endif else begin
	    length = strlen(info.field_name.z)
	    data_name = strmid(info.field_name.z,0,loc)
	    data_name = data_name + prof_res
	    temp = length - loc - 4
	    data_name = data_name + strmid(info.field_name.z,loc+4,temp)
	    thre_len = loc - 1
	    if thre_len lt 0 then thre_len = -1
	endelse
    endelse
endif else begin
    rloc = rstrpos(temp_name,'_',loc)
    length = strlen(info.field_name.z)
    data_name = strmid(info.field_name.z,0,rloc+1)
    data_name = data_name + prof_res
    temp = length - loc - 2
    data_name = data_name + strmid(info.field_name.z,loc+2,temp)
    thre_len = rloc
endelse

dot=strpos(data_name,'[')
if( dot ne -1) then data_name=strmid(data_name,0,dot) $
    else data_name = data_name

;loc = strpos(data_name, 'full')
;if loc ne -1 then begin
;    length = strlen(data_name)
;    temp = length - loc + 1
;    thres_name = 'Threshold' + strmid(data_name, loc-1, temp)
;endif else thres_name = 'Threshold_full_resolution'

if thre_len lt 0 then begin
    thres_name = 'Threshold_full_resolution'
endif else if thre_len eq 532 then begin
    thres_name = 'threshold_532_'+prof_res
endif else if thre_len eq 1064 then begin
    thres_name = 'threshold_1064'
endif else begin
    length = strlen(data_name)
    temp = length - thre_len
    thres_name = 'Threshold' + strmid(data_name, thre_len, temp)
endelse

subscript = where(info.name_list_sds eq data_name, count)
if count eq 0 then data_flag = 0 else data_flag = 1
;print,'count = ',count,', data_flag = ',data_flag,' data_name = ',data_name

subscript = where(info.name_list_sds eq thres_name, count)
if count eq 0 then thres_flag = 0 else thres_flag = 1
;print,'count = ',count,', thres_flag = ',thres_flag,', thres_name = ',thres_name

this_start = info.subset.data(this_subset).src_start(0)
this_end = info.subset.data(this_subset).src_end(0)
if info.subset.data(this_subset).src_type_flag eq 0 then begin
    the_rank = info.subset.data(this_subset).src_rank
	if the_rank eq 1 then begin
	    true_start = info.subset.data(this_subset).src_start(the_rank)
	    true_end = info.subset.data(this_subset).src_end(the_rank)
	    if true_start ne this_start or true_end ne this_end then begin
		this_start = true_start
		this_end = true_end
	    endif
	endif
endif else this_end = this_end + 1

proscale = info.browse_image.proscale
data_scale = info.browse_image.scale
scale_ratio = proscale / data_scale

feat_start = this_start / scale_ratio
feat_end = this_end / scale_ratio

swift_portion = feat_start - long(feat_start)
if swift_portion lt 0.001 or swift_portion gt 0.999 then begin
    if swift_portion lt 0.001 then feat_start = long(feat_start) $
	else feat_start = long(feat_start + 0.9)
    swift_portion = 0.0
endif 

feat_start = long(feat_start)
feat_end = long(feat_end+0.9) - 1

info.browse_image.swift = swift_portion

if feature_flag eq 1 then begin
    the_result = read_feature_data( this_subset, top_name, info, top_array)
    if (the_result eq -1) then begin
	result=dialog_message('Unable to read ' + top_name + ' SDS data!',$
	    title='View HDF Warning!')
	return
    endif

    the_result = read_feature_data( this_subset, base_name, info, base_array)
    if (the_result eq -1) then begin
	result=dialog_message('Unable to read ' + base_name + ' SDS data!',$
	    title='View HDF Warning!')
	return
    endif

    size_top = size(top_array)
    size_base = size(base_array)
    if size_top(0) eq 2 then begin
	if size_top(2) gt feat_end then begin
	    top_array = top_array(*,feat_start:feat_end)
	    base_array = base_array(*,feat_start:feat_end)
	endif
    endif else if size_top(0) eq 1 then begin
	if size_top(1) gt feat_end then begin
	    top_array = top_array(feat_start:feat_end)
	    base_array = base_array(feat_start:feat_end)
	endif
    endif

    if ptr_valid(info.browse_image.tarray) then ptr_free, info.browse_image.tarray
    info.browse_image.tarray = ptr_new(top_array, /no_copy)

    if ptr_valid(info.browse_image.barray) then ptr_free, info.browse_image.barray
    info.browse_image.barray = ptr_new(base_array, /no_copy)
endif

if data_flag eq 1 then begin
    the_result = read_feature_data( this_subset, data_name, info, data_array)
    if (the_result eq -1) then begin
	result=dialog_message('Unable to read ' + data_name + ' SDS data!',$
	    title='View HDF Warning!')
	return
    endif

    size_hdf_z = size(data_array)
    hdf_data_x = lindgen(size_hdf_z(2)) + 1

    if size_hdf_z(0) eq 2 then begin
	if size_hdf_z(2) gt feat_end then begin
	    data_array = data_array(*,feat_start:feat_end)
	    hdf_data_x = hdf_data_x(feat_start:feat_end)
	endif
    endif else if size_hdf_z(0) eq 1 then begin
	if size_hdf_z(1) gt feat_end then begin
	    data_array = data_array(feat_start:feat_end)
	    hdf_data_x = hdf_data_x(feat_start:feat_end)
	endif
    endif

    if ptr_valid(info.browse_image.z) then ptr_free, info.browse_image.z
    info.browse_image.z = ptr_new(data_array, /no_copy)

    if ptr_valid(info.browse_image.x) then ptr_free, info.browse_image.x
    info.browse_image.x = ptr_new(hdf_data_x, /no_copy)
endif

if thres_flag eq 1 then begin
    the_result = read_feature_data( this_subset, thres_name, info, thre_array)
    if (the_result eq -1) then begin
	result=dialog_message('Unable to read ' + thres_name + ' SDS data!',$
	    title='View HDF Warning!')
	return
    endif

    size_thre = size(thre_array)
    if size_thre(0) eq 2 then begin
        if size_thre(2) gt feat_end then begin
            thre_array = thre_array(*,feat_start:feat_end)
        endif
    endif else if size_thre(0) eq 1 then begin
        if size_thre(1) gt feat_end then begin
            thre_array = thre_array(feat_start:feat_end)
        endif
    endif

    if ptr_valid(info.browse_image.y) then ptr_free, info.browse_image.y
    info.browse_image.y = ptr_new(thre_array, /no_copy)
endif

end

;--------------------------------------------------------------------------------
pro display_threshold, event

pro_name = 'display_threshold'
@getinfo

widget_control, get_uvalue=info, event.top

info.browse_image.threflag = event.index

widget_control, set_uvalue=info, event.top
if(widget_info(info.widgets.base, /VALID_ID)) then $
    widget_control, set_uvalue=info, info.widgets.base

end

;--------------------------------------------------------------------------------
pro display_line, event

pro_name = 'display_line'
@getinfo

widget_control, get_uvalue=info, event.top

info.browse_image.lineflag = event.index

widget_control, set_uvalue=info, event.top
if(widget_info(info.widgets.base, /VALID_ID)) then $
    widget_control, set_uvalue=info, info.widgets.base

end

;--------------------------------------------------------------------------------
pro select_profile, event

pro_name = 'select_profile'
@getinfo

widget_control, get_uvalue=info, event.top
widget_control, get_uvalue=res_list, event.id

num_list = n_elements(res_list)
if num_list le 1 then res_list = 'full'

index = event.index
if index lt 0 or index gt num_list-1 then index = 0
info.browse_image.profile = res_list(event.index)

old_proscale = info.browse_image.proscale

temp_name = strlowcase(info.browse_image.profile)
loc = strpos(temp_name, 'km')
if loc eq -1 then begin
    case temp_name of
	'1': scale = 0
	'2': scale = 1
	'3': scale = 5
	'4': scale = 20
	'5': scale = 80
	else: scale = 0 
    endcase
endif else scale = fix(info.browse_image.profile)
if scale eq 0 then info.browse_image.proscale = 1 $
    else info.browse_image.proscale = scale * info.browse_image.shotscale

this_subset = info.subset.selected
set_feature_profile, this_subset, info.browse_image.profile, info

widget_control, set_uvalue=info, event.top
if(widget_info(info.widgets.base, /VALID_ID)) then $
    widget_control, set_uvalue=info, info.widgets.base

if old_proscale ne info.browse_image.proscale then begin
    info.sview.p_old = !P
    info.sview.x_old = !X
    info.sview.y_old = !Y

    widget_control, info.browse_image.xwidget, get_value=x_location
    widget_control, info.browse_image.pwidget, get_value=p_number
    p_number = long(p_number * old_proscale / info.browse_image.proscale + 0.5)
    draw_profile, x_location, p_number, 1, info

    if info.sview.window_id ne -1 then wset, info.sview.window_id
    !P = info.sview.p_old
    !X = info.sview.x_old
    !Y = info.sview.y_old
endif

end

;------------------------------------------------------------------
pro subset_locate, info

pro_name = 'subset_locate'
@getinfo

if info.graph_style eq 'Browse Image' or $
    info.graph_style eq 'Browse Image With Average' then begin
	if info.subset_locate eq 1 then return
endif

if(widget_info(info.widgets.base, /VALID_ID)) then begin
	info.subset_locate = 1
	WIDGET_CONTROL, info.widgets.location, SENSITIVE = info.subset_locate
	widget_control, set_uvalue=info, info.widgets.base
endif else begin
	the_message = [ 'Problem to locate position in this draw window.',$
		'You may need to close this window and do it again.']
	result= dialog_message(the_message, title='View HDF Warning')
	return
endelse

the_message = [ 'Move the CURSOR to the location and ',$
	'PRESS LEFT MOUSE BUTTON to show position.', $
	'Use "Subet" --> "End Locate" option or', $
	'Click on "Location On" button to end this option.']
result= dialog_message(the_message, title='Select Position to Locate')

if info.graph_style eq 'Browse Image' or $
    info.graph_style eq 'Browse Image With Average' then begin
	temp_list = strlowcase(info.name_list_sds)
	check_top = strpos(temp_list, 'top')
	sub_check = where(check_top ne -1, count)
	if count eq 0 then top_list = 'None' $
	    else top_list = ['All Descend', 'All Ascend', 'Default', info.name_list_sds(sub_check)]
	dot=strpos(info.field_name.z,'[')
	if dot ne -1 then ztitle=strmid(info.field_name.z,0,dot) $
	    else ztitle = info.field_name.z
	name_of_data = 'Show Individual profile for '+ztitle
	plot_profile_window, name_of_data, info
endif

end

;------------------------------------------------------------------
pro subset_locate_end, info

pro_name = 'subset_locate_end'
@getinfo

if(widget_info(info.widgets.base, /VALID_ID)) then begin
	info.subset_locate = 0
	WIDGET_CONTROL, info.widgets.location, SENSITIVE = info.subset_locate
	if info.graph_style eq 'Browse Image' or $
	    info.graph_style eq 'Browse Image With Average' then begin
		;wdelete, 5
		delete_window, 5
		wset, info.sview.window_id
		if(widget_info(info.browse_image.base, /VALID_ID)) then $
			widget_control, info.browse_image.base, /destroy
	endif
	widget_control, set_uvalue=info, info.widgets.base
endif else begin
	the_message = [ 'Problem to end locate option in this draw window.',$
		'You may need to close this window and do it again.']
	result= dialog_message(the_message, title='View HDF Warning')
	return
endelse

end

;------------------------------------------------------------------
pro subset_select_region, info

pro_name = 'subset_select_region'
@getinfo

if info.graph_style ne 'Geolocated' then begin
	the_message=['This graph type is not "Geolocated"!',$
		'Subset-Select Region is not valid!!']
	result=dialog_message(the_message, title='View HDF Warning!')
                return
endif

the_message = [ 'Left button to mark point',$
    'Middle button to erase previous point', 'Right button to close region' ]
result= dialog_message(the_message,title='Select Region')

screen_xsize = info.screen.xsize
screen_ysize = info.screen.ysize

indices=defroi(screen_xsize,screen_ysize, xvert, yvert, /restore, /noregion)

max_xsize = max(xvert, min=min_xsize)
max_ysize = max(yvert, min=min_ysize)

xarray = [min_xsize, min_xsize, max_xsize, max_xsize]
yarray = [min_ysize, max_ysize, max_ysize, min_ysize]

;max_locat = CONVERT_COORD(max_xsize, max_ysize, /DEVICE, /TO_DATA)
;min_locat = CONVERT_COORD(min_xsize, min_ysize, /DEVICE, /TO_DATA)
locat = CONVERT_COORD(xarray, yarray, /DEVICE, /TO_DATA)
x_max_locat = max(locat(0,*), x_max_loc, /NAN)
x_min_locat = min(locat(0,*), x_min_loc, /NAN)
y_max_locat = max(locat(1,*), min=y_min_locat, /NAN)

if x_max_locat * x_min_locat lt 0.0 and x_max_loc lt x_min_loc then begin
    x_min_locat = 360.0 + x_min_locat
    max_locat = [x_min_locat, y_max_locat]
    min_locat = [x_max_locat, y_min_locat]
endif else begin
    max_locat = [x_max_locat, y_max_locat]
    min_locat = [x_min_locat, y_min_locat]
endelse

;while(finite(min_locat(0)) eq 0) do begin
;    min_xsize = min_xsize + 1
;    min_locat = CONVERT_COORD(min_xsize, min_ysize, /DEVICE, /TO_DATA)
;endwhile

;while(finite(max_locat(0)) eq 0) do begin
;    max_xsize = max_xsize - 1
;    max_locat = CONVERT_COORD(max_xsize, max_ysize, /DEVICE, /TO_DATA)
;endwhile

if max_locat(0) lt 0.0 then max_locat(0) = 360.0 + max_locat(0)
if min_locat(0) lt 0.0 then min_locat(0) = 360.0 + min_locat(0)

info.sview.xsize = max_xsize - min_xsize
info.sview.ysize = max_ysize - min_ysize

info.sview.long(0) = min_locat(0)
info.sview.long(1) = max_locat(0)
info.sview.lat(0) = min_locat(1)
info.sview.lat(1) = max_locat(1)

widget_control, set_uvalue=info, info.widgets.base
widget_control, set_uvalue=info, info.base

; Now ask the user how he wants to view this data
; then show the data in subset_view.

base=widget_base(TITLE='Subset View Region')

widget_control, set_uvalue=info, base
items=['Table','2D Plot','XYZ Plot','Geolocated Plot','Done']

list=widget_list(base, value=items, $
	FONT=info.font, xsize=10,ysize=5, event_pro='subset_viewCB', uvalue=info)

widget_control, /realize, base

end

;------------------------------------------------------------------
pro subset_viewCB, event

pro_name = 'subset_viewCB'
@getinfo

if event.clicks eq 2 then return
widget_control, /hourglass
widget_control, get_uvalue=info, event.top
widget_control, get_uvalue=info, info.base
if event.index lt 4 then begin
   view_xsize = info.sview.ratio * info.sview.xsize
   view_ysize = info.sview.ratio * info.sview.ysize
   ;barlocation = info.barlocation
   set_color_bar = info.color_bar
   widget_control, get_uvalue=info, event.top

   this_subset = info.subset.selected
   this_type = info.subset.data(this_subset).src_types
   this_type = this_type(0)
   filldata = get_filldata(this_type, info.filldata)
   hdf_data_z = *info.geolocated.hdf_z
   hdf_data_x = *info.geolocated.long
   hdf_data_y = *info.geolocated.colat
   if info.greenwich.satellite eq 1 then begin
	satellite_x = *info.geolocated.sate_long
	satellite_y = *info.geolocated.sate_colat
   endif
   if info.greenwich.sun eq 1 then begin
	sun_x = *info.geolocated.sun_long
	sun_y = *info.geolocated.sun_colat
   endif

   if info.filldata gt 0 then begin
	subscript = where(hdf_data_x lt info.filldata, count)
   endif else begin
	subscript = where(hdf_data_x gt info.filldata, count)
   endelse
   if(count ne 0) then begin
      hdf_data_x = hdf_data_x(subscript)
      hdf_data_y = hdf_data_y(subscript)
      hdf_data_z = hdf_data_z(subscript)
   endif else begin
        result=dialog_message('All the longitude data are fill data!',$
                    title='View HDF Warning!')
         return
   endelse
 
   if info.filldata gt 0 then begin
	subscript = where(hdf_data_y lt info.filldata, count)
   endif else begin
	subscript = where(hdf_data_y gt info.filldata, count)
   endelse
   if(count ne 0) then begin
      hdf_data_x = hdf_data_x(subscript)
      hdf_data_y = hdf_data_y(subscript)
      hdf_data_z = hdf_data_z(subscript)
   endif else begin
        result=dialog_message('All the colatitude data are fill data!',$
                    title='View HDF Warning!')
         return
   endelse
 
   ;subscript = where(hdf_data_z lt info.filldata, count)
   if filldata gt 0 then begin
	subscript = where(hdf_data_z lt filldata, count)
   endif else begin
	subscript = where(hdf_data_z gt filldata, count)
   endelse
   if(count ne 0) then begin
      hdf_data_x = hdf_data_x(subscript)
      hdf_data_y = hdf_data_y(subscript)
      hdf_data_z = hdf_data_z(subscript)
   endif else begin
        result=dialog_message('All the data are fill data!',$
                    title='View HDF Warning!')
         return
   endelse
 
   ;long_max = max(hdf_data_x, min = long_min)
   ;lat_max = max(hdf_data_y, min = lat_min)

   subscript = where(hdf_data_x lt 0.0 and hdf_data_x gt -180.01, count)
   if count ne 0 then begin
	hdf_data_x(subscript) = 360.0 + hdf_data_x(subscript)
	;long_max = max(hdf_data_x, min=long_min)
   endif

   if(info.sview.long(0) gt info.sview.long(1)) then begin
      subscript=where( ((hdf_data_x GE info.sview.long(0)) or $
		    (hdf_data_x LE info.sview.long(1))) and $
                    (hdf_data_y  GE info.sview.lat(0))  and $
		    (hdf_data_y  LE info.sview.lat(1)) , count)
      if info.greenwich.satellite eq 1 then begin
	sate_sub=where( ((satellite_x GE info.sview.long(0)) or $
                    (satellite_x LE info.sview.long(1))) and $
                    (satellite_y  GE info.sview.lat(0))  and $
                    (satellite_y  LE info.sview.lat(1)) , sate_count)
      endif
      if info.greenwich.sun eq 1 then begin
	sun_sub=where( ((sun_x GE info.sview.long(0)) or $
                   (sun_x LE info.sview.long(1))) and $
                   (sun_y  GE info.sview.lat(0))  and $
                   (sun_y  LE info.sview.lat(1)) , sun_count)
      endif
   endif else begin
      subscript=where( (hdf_data_x GE info.sview.long(0)) and $
		    (hdf_data_x LE info.sview.long(1)) and $
                    (hdf_data_y  GE info.sview.lat(0))  and $
		    (hdf_data_y  LE info.sview.lat(1)) , count)
      if info.greenwich.satellite eq 1 then begin
	sate_sub=where( (satellite_x GE info.sview.long(0)) and $
                    (satellite_x LE info.sview.long(1)) and $
                    (satellite_y  GE info.sview.lat(0))  and $
                    (satellite_y  LE info.sview.lat(1)) , sate_count)
      endif
      if info.greenwich.sun eq 1 then begin
	sun_sub=where( (sun_x GE info.sview.long(0)) and $
                  (sun_x LE info.sview.long(1)) and $
                  (sun_y  GE info.sview.lat(0))  and $
                  (sun_y  LE info.sview.lat(1)) , sun_count)
      endif
   endelse

   if count ne 0 then begin
	hdf_data_z = hdf_data_z(subscript)
        hdf_data_x = hdf_data_x(subscript)
        hdf_data_y = hdf_data_y(subscript)
   endif else begin
        result=dialog_message('All data is out of range!',$
        title='View HDF Warning!')
	return
   endelse

   if info.greenwich.satellite eq 1 then begin
      if sate_count ne 0 then begin
	satellite_x = satellite_x(sate_sub)
        satellite_y = satellite_y(sate_sub)
      endif
   endif 

   if info.greenwich.sun eq 1 then begin
      if sun_count ne 0 then begin
	sun_x = sun_x(sun_sub)
        sun_y = sun_y(sun_sub)
      endif
   endif 

endif

CASE event.index of

	0:begin
		print,"Values for the Selected Region are:"
		print, hdf_data_z
	end
	1:begin
		window,5,xsize=view_xsize,ysize=view_ysize, $
			title='Subset 2D Plot', retain=2
		if info.style.symbolline eq 1 then plot_symbol = - info.style.symbol $
			else plot_symbol = info.style.symbol

		get_ticklen, info.style.grid, xticklen, yticklen 

		plot, hdf_data_z, font=info.char.font, psym = plot_symbol, $
			linestyle=info.style.linetype, symsize=info.style.symbolsize, $
                        xticklen=xticklen, yticklen=yticklen, thick = info.style.linethick
	end
	2:begin

		window, 5, xsize=view_xsize,ysize=view_ysize, $
			title='Subset XYZ Plot', retain=2

		;top_color=!d.n_colors - 2
		top_color=info.top_color - 2
		if top_color gt 254 then top_color = 254
                if (info.axis_state eq 3) or (info.axis_state eq 5) then begin
		  z_max = info.range.z_end
		  z_min = info.range.z_start
                  my_color=bytscl(hdf_data_z, max=z_max, min=z_min, top=top_color)
                endif else begin
                  my_color=bytscl(hdf_data_z, top=top_color)
		  z_max = max(hdf_data_z, min = z_min)
		endelse

		get_ticklen, info.style.grid, xticklen, yticklen 

                plot,[hdf_data_x],[hdf_data_y], /nodata, $
			FONT=info.char.font, $
			charsize=info.char.size, $
                        xtitle='Longitude, deg', $
                        ytitle='Latitude, deg', $
                        xticklen=xticklen, yticklen=yticklen

		if info.style.symbolline eq 1 then plot_symbol = - info.style.symbol $
			else plot_symbol = info.style.symbol

                for i=0L,(count-1) do begin
                        oplot,[hdf_data_x(i),hdf_data_x(i)],[hdf_data_y(i),hdf_data_y(i)], $
			;MAX_VALUE = info.filldata, psym = plot_symbol, linestyle=info.style.linetype, $
			psym = plot_symbol, linestyle=info.style.linetype, $
			symsize = info.style.symbolsize, color=my_color(i), thick = info.style.linethick
                endfor

		if set_color_bar eq 1 then begin
		   temp_name = info.subset.data(this_subset).src_unitname
		   temp_name = temp_name(0)
		   temp_length = strlen(temp_name)
		   unitlabel = ''
		   if (temp_length gt 0) then begin
		      dot=strpos(temp_name,'N/A')
		      if( dot eq -1) then unitlabel = strmid(temp_name,2,temp_length-2)
		   endif
		   x_location = !x.window(0) + (!x.window(1) - !X.window(0))/2. - 0.22
   		   y_location = !y.window(0) + 0.08
		   draw_color_bar, top_color, z_min, z_max, y_location, x_location, info.char.size, $
			info.char.font, unitlabel, info.greenwich.setformat, info.greenwich.bformat
		endif
	end
	3:begin

		window,5,xsize=view_xsize,ysize=view_ysize, $
			title='Subset Geolocated Plot', retain=2

		;map_color = !d.n_colors/3
		map_color = info.top_color/3

		; Set the e_struct according the setting
		if info.greenwich.high_resol eq 1 then begin
		    if info.greenwich.coasts eq 1 then begin
			e_struct = {hires:1, coasts:1, mlinethick:info.greenwich.mlinethick}
		    endif else begin
			e_struct = {hires:1, mlinethick:info.greenwich.mlinethick}
		    endelse
		endif else begin
		    if info.greenwich.coasts eq 1 then begin
			e_struct = {coasts:1, mlinethick:info.greenwich.mlinethick}
		    endif else begin
			e_struct = {mlinethick:info.greenwich.mlinethick}
		    endelse
		endelse

		;  Turn off the !QUIET
		old_quiet = !QUIET
		!QUIET=1
		!P.FONT = info.char.font

		case info.greenwich.projection of
;                1: map_set,info.greenwich.lat_loc,info.greenwich.greenloca,/grid, /orthographic, $
;			LABEL=info.greenwich.label, /horizon, charsize=info.char.size, $
;			limit=[info.sview.lat(0), info.sview.long(0),$
;			info.sview.lat(1), info.sview.long(1)]
;		2: map_set,info.greenwich.lat_loc,info.greenwich.greenloca,/grid, /stereographic, $
;			LABEL=info.greenwich.label, /horizon, charsize=info.char.size, $
;			limit=[info.sview.lat(0), info.sview.long(0),$
;			info.sview.lat(1), info.sview.long(1)]
;		;3: map_set,0,info.greenwich.greenloca,/grid, /aitoff, LABEL=info.greenwich.label, $
;		3: map_set,info.greenwich.lat_loc,info.greenwich.greenloca,/grid, /hammer, $
;			LABEL=info.greenwich.label, /horizon, charsize=info.char.size, $
;			limit=[info.sview.lat(0), info.sview.long(0),$
;			info.sview.lat(1), info.sview.long(1)]
;		else: map_set,info.greenwich.lat_loc,info.greenwich.greenloca,/grid, /cylindrical, $
;			LABEL=info.greenwich.label, charsize=info.char.size, $
;			limit=[info.sview.lat(0), info.sview.long(0),$
;			info.sview.lat(1), info.sview.long(1)]
		1: begin
		    map_set,info.greenwich.lat_loc,info.greenwich.greenloca, /orthographic, $
			charsize=info.char.size, limit=[info.sview.lat(0), info.sview.long(0), $
			info.sview.lat(1), info.sview.long(1)], /horizon, $
			noborder=info.greenwich.noborder, e_continents=e_struct
		    if info.greenwich.grid eq 1 then $
			map_grid, LABEL=info.greenwich.label, charsize = info.char.size, $
			    glinethick = info.greenwich.glinethick
		   end
		2: begin
		    map_set,info.greenwich.lat_loc,info.greenwich.greenloca, /stereographic, $
			charsize=info.char.size, limit=[info.sview.lat(0), info.sview.long(0), $
			info.sview.lat(1), info.sview.long(1)], /horizon, $
			noborder=info.greenwich.noborder, e_continents=e_struct
		    if info.greenwich.grid eq 1 then $
			map_grid, LABEL=info.greenwich.label, charsize = info.char.size, $
			    glinethick = info.greenwich.glinethick
		   end
		3: begin
		    map_set,info.greenwich.lat_loc,info.greenwich.greenloca, /hammer, $
			charsize=info.char.size, limit=[info.sview.lat(0), info.sview.long(0), $
			info.sview.lat(1), info.sview.long(1)], /horizon, $
			noborder=info.greenwich.noborder, e_continents=e_struct
		    if info.greenwich.grid eq 1 then $
			map_grid, LABEL=info.greenwich.label, charsize = info.char.size, $
			    glinethick = info.greenwich.glinethick
		   end
		4: begin
		    map_set,info.greenwich.lat_loc,info.greenwich.greenloca, /satellite, $
			charsize=info.char.size, limit=[info.sview.lat(0), info.sview.long(0), $
			info.sview.lat(1), info.sview.long(1)], /horizon, $
			noborder=info.greenwich.noborder, e_continents=e_struct, $
			sat_p=[info.greenwich.altitude, info.greenwich.tilt, info.greenwich.rotation]
		    if info.greenwich.grid eq 1 then $
			map_grid, LABEL=info.greenwich.label, charsize = info.char.size, $
			    glinethick = info.greenwich.glinethick
		   end
		else: begin
		    map_set,info.greenwich.lat_loc,info.greenwich.greenloca, /cylindrical, $
			charsize=info.char.size, limit=[info.sview.lat(0), info.sview.long(0), $
			info.sview.lat(1), info.sview.long(1)], $
			noborder=info.greenwich.noborder, e_continents=e_struct
		    if info.greenwich.grid eq 1 then $
			map_grid, LABEL=info.greenwich.label, charsize = info.char.size, $
			    glinethick = info.greenwich.glinethick
		   end
		endcase

		;map_continents, mlinethick=info.greenwich.mlinethick
		if info.greenwich.high_resol eq 1 then begin
		    if info.greenwich.coasts eq 1 then begin
			map_continents, /coasts, /hires, mlinethick=info.greenwich.mlinethick
		    endif else begin
			map_continents, /hires, mlinethick=info.greenwich.mlinethick
		    endelse
		endif else begin
		    map_continents, /coasts, mlinethick=info.greenwich.mlinethick
		endelse
                ;map_continents, /coasts, color=map_color

		!QUIET = old_quiet

		;top_color = !d.n_colors - 2
		top_color = info.top_color - 2
		if top_color gt 254 then top_color = 254
                if (info.axis_state eq 3) or (info.axis_state eq 5) then begin
		  z_max = info.range.z_end
		  z_min = info.range.z_start
                  my_color=bytscl(hdf_data_z, max=z_max, min=z_min, top=top_color)
                endif else begin
		  z_max = max(hdf_data_z, min = z_min)
		  my_color=bytscl(hdf_data_z, max=z_max, min=z_min, top=top_color)
		endelse

		if info.style.symbol eq 0 then plot_symbol = 3 $
			else plot_symbol = info.style.symbol
                for i=0L,(count-1) do begin
                        oplot,[hdf_data_x(i),hdf_data_x(i)],[hdf_data_y(i),hdf_data_y(i)], $
			color=my_color(i), psym=plot_symbol, symsize = info.style.symbolsize
			;MAX_VALUE = info.filldata, color=my_color(i), psym=plot_symbol
		endfor

		; Plot the Satellite Position
		if info.greenwich.satellite eq 1 then begin
		  ;satellite_color = !d.n_colors - map_color
		  satellite_color = info.top_color - map_color
		  oplot, satellite_x, satellite_y, MAX_VALUE = info.filldata, color=satellite_color, $
		    thick = info.style.linethick
		endif
		; Plot the Sun Position
		if info.greenwich.sun eq 1 then begin
		  ;sun_color = !d.n_colors - 20
		  sun_color = info.top_color - 20
		  oplot, sun_x, sun_y, MAX_VALUE = info.filldata, color=sun_color, $
		    thick = info.style.linethick
		endif

		if set_color_bar eq 1 then begin
		   temp_name = info.subset.data(this_subset).src_unitname
		   temp_name = temp_name(0)
		   temp_length = strlen(temp_name)
		   unitlabel = ''
		   if (temp_length gt 0) then begin
		      dot=strpos(temp_name,'N/A')
		      if( dot eq -1) then unitlabel = strmid(temp_name,2,temp_length-2)
		   endif
   		   y_location = !y.window(0) + 0.08
		   draw_color_bar, top_color, z_min, z_max, y_location, 0.28, info.char.size, $
			info.char.font, unitlabel, info.greenwich.setformat, info.greenwich.bformat
		endif

	end
	4:begin
		;wdelete, 5
		delete_window, 5
		widget_control, get_uvalue=info, info.base
		wset, info.sview.window_id
		!Map = info.sview.map_old
                !P = info.sview.p_old
                !X = info.sview.x_old
                !Y = info.sview.y_old
		widget_control,	event.top, /destroy
		widget_control, set_uvalue=info, info.widgets.base
		widget_control, set_uvalue=info, info.base
		return
       end
ENDCASE

	 
end

;------------------------------------------------------------------
pro subset_zoom, info

pro_name = 'subset_zoom'
@getinfo

the_message =[ 'Left button to zoom', 'Middle button to display zoom menu',$
'Right button to exit' ]

result= dialog_message(the_message, title='Select Region to Zoom')

zoom

end

;--------------------------------------------------------------------------------
pro subsetviewCB, event

pro_name = 'SubsetviewCB'
@getinfo

widget_control, get_uvalue=info, event.top

widget_control, info.widgets.sview_xsize, get_value=sview_xsize
info.sview.xsize=sview_xsize
print,'Subset View XSize =',info.sview.xsize

widget_control, info.widgets.sview_ysize, get_value=sview_ysize
info.sview.ysize=sview_ysize
print,'Subset View YSize =',info.sview.ysize

widget_control, info.widgets.sview_ratio, get_value=sview_ratio
info.sview.ratio=sview_ratio
print,'Subset View Ratio =',info.sview.ratio

DEVICE, GET_SCREEN_SIZE=scr
view_xsize = info.sview.ratio * info.sview.xsize
view_ysize = info.sview.ratio * info.sview.ysize
if view_xsize gt scr(0) or view_ysize gt scr(1) then begin
	the_message=['The new size of subset view window','is greater than screen size.', $
		'Continue to set the new size of window?']
	result=dialog_message(the_message,/question,title='View HDF Question')
	if result eq 'No' then return
endif

widget_control, set_uvalue=info, info.widgets.base
widget_control, set_uvalue=info, info.base

widget_control, event.top, /destroy

end

;--------------------------------------------------------------------------------
pro subsetview_dialogueCB, event

pro_name = 'subsetview_dialogueCB'
@getinfo

widget_control, get_uvalue=info, event.top
widget_control, get_uvalue=info, info.base

base = widget_base(COLUMN=1, MAP=1, TITLE='Define Subset View Size')

s_group=widget_base(base, column=1,map=1)

info.widgets.sview_xsize = CW_FIELD(s_group, VALUE=info.sview.xsize, $
		ROW=1, INTEGER=1, FIELDFONT=info.font, $
		FONT=info.font, TITLE='Subset View XSize:', XSIZE=10)

info.widgets.sview_ysize = CW_FIELD(s_group, VALUE=info.sview.ysize, $
		ROW=1, INTEGER=1, FIELDFONT=info.font, $
		FONT=info.font, TITLE='Subset View YSize:', XSIZE=10)

info.widgets.sview_ratio = CW_FIELD(s_group, VALUE=info.sview.ratio, $
		ROW=1, INTEGER=1, FIELDFONT=info.font, $
		FONT=info.font, TITLE='Subset View Ratio:', XSIZE=10)

group2=widget_base(base, row=1,map=1, space=40, /align_center)

button1=widget_button(group2, FONT=info.font, EVENT_PRO='subsetviewCB', VALUE="Done",$
	/ALIGN_CENTER)

button2=widget_button(group2, FONT=info.font, EVENT_PRO='doneCB', VALUE="Cancel",$
	 /ALIGN_CENTER)

widget_control, /realize, base

widget_control, set_uvalue=info, base
widget_control, set_uvalue=info, info.widgets.base
widget_control, set_uvalue=info, info.base

end

;--------------------------------------------------------------------------------
pro tool_axis, event

pro_name = 'tool_axis'
@getinfo

widget_control, get_uvalue=info, event.top


if (info.axis_state eq 0) then begin

	info.axis_state=5 

	;---------------------------------
	; Set the button look to manual
	;---------------------------------
	read_x11_bitmap, 'axis_button_manual.xbm', axis_button_man, expand_to_bytes
	widget_control, info.widgets.axis_tool, set_value=axis_button_man

       	base=widget_base( COLUMN=1, MAP=1, TITLE='Define X & Y Axis', uvalue=info)

	x_group=widget_base(base, row=1,map=1)
	y_group=widget_base(base, row=1,map=1)
	z_group=widget_base(base, row=1,map=1)

	info.widgets.x_start= CW_FIELD(x_group,VALUE=info.range.x_start, ROW=1, $
		FLOATING=1, FIELDFONT=info.font, FONT=info.font, TITLE='X Start:', $
		XSIZE=20)

	info.widgets.x_end= CW_FIELD(x_group,VALUE=info.range.x_end, ROW=1, $
		FLOATING=1, FIELDFONT=info.font, FONT=info.font, TITLE='X End:', $
		XSIZE=20 )

	info.widgets.y_start= CW_FIELD(y_group,VALUE=info.range.y_start, $ ROW=1, $
		FLOATING=1, FIELDFONT=info.font, FONT=info.font, TITLE='Y Start:', $
		XSIZE=20)

	info.widgets.y_end= CW_FIELD(y_group,VALUE=info.range.y_end, ROW=1, $
		FLOATING=1, FIELDFONT=info.font, FONT=info.font, TITLE='Y End:', $
		XSIZE=20)

	info.widgets.z_start= CW_FIELD(z_group,VALUE=info.range.z_start, $ ROW=1, $
		FLOATING=1, FIELDFONT=info.font, FONT=info.font, TITLE='Z Start:', $
		XSIZE=20)

	info.widgets.z_end= CW_FIELD(z_group,VALUE=info.range.z_end, ROW=1, $
		FLOATING=1, FIELDFONT=info.font, FONT=info.font, TITLE='Z End:', $
		XSIZE=20)

	group2=widget_base(base, row=1,map=1, space=100, /align_center)

	button1=widget_button(group2, FONT=info.font, EVENT_PRO='axis_dialogueCB', $
		VALUE="Done", /ALIGN_CENTER)

	button2=widget_button(group2, FONT=info.font, EVENT_PRO='doneCB', VALUE="Cancel",$
		 /ALIGN_CENTER)

	widget_control, set_uvalue=info, base
        widget_control, /realize, base
        xmanager,'main_widget', base

endif else begin

	info.axis_state=0 
	;---------------------------------
	; Set the button to auto axis
	;---------------------------------

	read_x11_bitmap, 'axis_button.xbm', axis_button_auto, expand_to_bytes
	widget_control, info.widgets.axis_tool, set_value=axis_button_auto

endelse

widget_control, set_uvalue=info, info.base

end

;--------------------------------------------------------------------------------
pro tool_graph, event

pro_name = 'tool_graph'
@getinfo

;---------------------------------------- 
; Toggle between table and graph modes
;---------------------------------------- 

widget_control, get_uvalue=info, event.top

if info.current_tool eq 'graph' then begin

	info.current_tool='table'
	read_x11_bitmap, 'table_button.xbm', table_button, expand_to_bytes
	widget_control, info.widgets.graph_button, set_value=table_button

endif else begin

	info.current_tool='graph'
	read_x11_bitmap, 'graph_button.xbm', graph_button, expand_to_bytes
	widget_control, info.widgets.graph_button, set_value=graph_button

endelse

widget_control, set_uvalue=info, info.base

end

;--------------------------------------------------------------------------------
pro vdata_dialogue, info

pro_name = 'vdata_dialogue'
@getinfo

base = widget_base( COLUMN=1, MAP=1, TITLE='Select Vdata Fields', uvalue=info)

button_group=cw_bgroup(base, info.name_list_vfield, column=1, $
                        event_funct="add_vfieldCB", $
                        /scroll, y_scroll_size=450, x_scroll_size=350, /exclusive)

group2=widget_base(base, row=1,map=1, space=100, /align_center)

button1=widget_button(group2, FONT=info.font, EVENT_PRO='vfield_doneCB', VALUE="Done",$
	/ALIGN_CENTER)

button2=widget_button(group2, FONT=info.font, EVENT_PRO='doneCB', VALUE="Cancel",$
	 /ALIGN_CENTER)

widget_control, set_uvalue=info, base
widget_control, /realize, base 

widget_control, base, set_list_select=-1

end

;--------------------------------------------------------------------------------
PRO vfield_doneCB, event

pro_name = 'vfield_doneCB'
@getinfo

widget_control, get_uvalue=info, event.top

widget_control, event.top, /destroy

if (info.subset.count lt info.subset.maximum) then vfield_range_dialogue, info else print,$
	 'Maximum number of subsets = ', info.subset.maximum

END

;--------------------------------------------------------------------------------
pro vfield_range_dialogue, info

pro_name = 'vfield_range_dialogue'
@getinfo

widget_control, /hourglass
subset_name = info.vfield.name_sel
subset_name = subset_name(0)
if subset_name eq "Radiance and mode flags" then begin
	widget_control, set_uvalue=info, info.base
	read_vfield_quality_flag, info
	widget_control, get_uvalue=info, info.base
	subset_name = info.quality.name_sel + $
		'[' + strcompress(string(info.subset.count)) +']'
endif else begin
	subset_name=info.vfield.name_sel + $
		'[' + strcompress(string(info.subset.count)) +']'
endelse

widget_control, info.widgets.current_file, get_value=filename		
the_vdata_name=info.vdata.name_sel
vdata_ref=info.vdata.ref
the_name = info.vfield.name_sel
the_index = info.vfield.indices_sel

;if info.show_attr eq 1 then $
if info.show_attr gt 0 then begin
	get_data_attr,filename,the_name, vdata_ref, 1, info
	if info.show_attr eq 2 then return
endif

the_types=long(1)
the_order=long(1)

CD, '.', CURRENT = PWD

;the_result = CALL_EXTERNAL(PWD+'/' + info.library,   $
;the_result = CALL_EXTERNAL(info.library,   $
;	'get_vfield_types',  	$
;	filename, 		$
;	the_vdata_name,		$ 
;	the_index,		$
;	long(1),		$
;	the_types,		$
;	the_order,		$
;	/s_value)

if info.version lt 5.19 and info.library_status eq 1 then begin
    ;the_result = CALL_EXTERNAL(PWD+'/' + info.library,   $
    the_result = CALL_EXTERNAL(info.library,   $
	'get_vfield_types_eos',	$
	filename, 		$
	the_vdata_name,		$ 
	vdata_ref,		$
	the_index,		$
	long(1),		$
	the_types,		$
	the_order,		$
	/s_value)
endif else begin
    the_result = get_vfield_type(filename,info.vdata.name_sel,info.vdata.ref, $
        info.vfield.indices_sel,the_types,the_order,info.version, $
	info.library, info.library_status, 0)
endelse

;print,'in vfield_range_dialogue, the_types = ',the_types
;print,'the_order = ',the_order
;print,'unit = ',the_result

if info.rangetype.type eq 2 then begin
    read_vdata_multiple_files, filename, the_vdata_name, vdata_ref, the_name, $
	the_index, the_order, the_types, the_result, info
    return
endif

if the_order gt 1 then begin
	info.sds.dims(1) = the_order
	rank = 1
endif else rank = 0
	
if info.rangetype.type eq 1 then begin
  info.rangetype.flag = 0
  get_time_range, subset_name, rank, info
  widget_control, get_uvalue=info, info.base
  if info.canceloption eq 'Yes' then begin
	info.canceloption = 'No'
	widget_control, set_uvalue=info, info.base
	return
  endif 
  if info.rangetype.flag eq 0 then begin
	info.rangetype.type = 0
	widget_control, info.rangetype.widget, set_droplist_select=info.rangetype.type
  endif
endif

if info.rangetype.type eq 0 or info.rangetype.flag eq 1 then $
  record_range_buttons, subset_name, rank, 'read_vfield_dataCB', info $
else return

;------------------------------------------------------
; NOTE: This only handles single dimensioned vdatas.
;------------------------------------------------------

widget_control, info.widgets.vdata, set_list_select=-1

end

;--------------------------------------------------------------------------------
pro write_hdf_sds, info, write_type, this_subset, filename

pro_name = 'write_hdf_sds'
@getinfosds

hdf_data = *info.subset.data(this_subset).src_data
size_hdf_data = size(hdf_data)

org_filename = info.subset.data(this_subset).src_filename
org_filename = org_filename(0)

temp_name = info.subset.data(this_subset).subset_name
temp_name = temp_name(0)
dot=strpos(temp_name, '[')
if( dot ne -1) then data_name=strmid(temp_name,0,dot) $
else data_name=temp_name

org_sds_index = info.subset.data(this_subset).src_ref

sel_option = 0
if write_type eq 0 then begin
	sd_id = HDF_SD_START(filename, /CREATE)
	if sd_id eq -1 then begin
		result=dialog_message('Problem to create HDF file!',$
			title='View HDF Warning!')
		return
	endif
endif else begin
	sd_id = HDF_SD_START(filename, /RDWR)
	if sd_id eq -1 then begin
		result=dialog_message('Problem to open HDF file!',$
			title='View HDF Warning!')
		return
	endif
	old_quiet = !QUIET
	!QUIET=1
	sds_index = HDF_SD_NAMETOINDEX(sd_id, data_name)
	!QUIET=old_quiet
	if sds_index ne -1 then begin
		;the_message = [data_name+' already exists!', $
		;	'Create another data set with same name?']
		;result=dialog_message(the_message, title='View HDF Question!', $
		;	/QUESTION)
		;if result eq 'No' then begin
		;	HDF_SD_END,sd_id
		;	return
		;endif
		the_list = ['Create another data set with same name', $
			    'Append data to the data set', $
			    'Overwrite data to the data set', $
			    'Cancel adding this data to the HDF']
		title = 'Write HDF Question'
		the_message = [data_name+' already exists!', $
			'Please select one of the following options:']
		default_option = 3
		sel_option = get_option(default_option,the_list,title,the_message,info)
		if sel_option eq 3 then begin
			HDF_SD_END,sd_id
			return
		endif
	endif
endelse

if sel_option eq 0 then begin
   dim = [size_hdf_data(1)]
   if size_hdf_data(0) gt 1 then begin
	for i = 2, size_hdf_data(0) do begin
		dim = [dim, size_hdf_data(i)]
	endfor
   endif
   rank = info.subset.data(this_subset).src_rank
   org_rank = info.subset.data(this_subset).src_org_rank
   if rank ne org_rank then begin
	org_start = info.subset.data(this_subset).src_org_start(0)
	org_end = info.subset.data(this_subset).src_org_end(0)
	org_increment = info.subset.data(this_subset).src_org_increment(0)
	num_data = (org_end-org_start)/org_increment
	if num_data eq 1 then begin
		dim=[dim,1]
		rank = rank + 1
	endif
   endif
   num_dim = n_elements(dim)
   dim(num_dim-1) = 0
	
   the_type = info.subset.data(this_subset).src_types
   the_type = the_type(0)
   case the_type of
	 4:   sds_id = HDF_SD_CREATE(sd_id,data_name,dim,/DFNT_CHAR)
	 5:   sds_id = HDF_SD_CREATE(sd_id,data_name,dim,/DFNT_FLOAT32)
	 6:   sds_id = HDF_SD_CREATE(sd_id,data_name,dim,/DFNT_FLOAT64)
	20:   sds_id = HDF_SD_CREATE(sd_id,data_name,dim,/DFNT_INT8)
	21:   sds_id = HDF_SD_CREATE(sd_id,data_name,dim,/DFNT_UINT8)
	22:   sds_id = HDF_SD_CREATE(sd_id,data_name,dim,/DFNT_INT16)
	23:   sds_id = HDF_SD_CREATE(sd_id,data_name,dim,/DFNT_UINT16)
	24:   sds_id = HDF_SD_CREATE(sd_id,data_name,dim,/DFNT_INT32)
	25:   sds_id = HDF_SD_CREATE(sd_id,data_name,dim,/DFNT_UINT32)
	else: sds_id = HDF_SD_CREATE(sd_id,data_name,dim,/DFNT_FLOAT32)
   endcase

   if sds_id eq -1 then begin
	result=dialog_message('Problem to create HDF file!',$
		title='View HDF Warning!')
	HDF_SD_END,sd_id
	return
   endif

   HDF_SD_ADDDATA,sds_id,hdf_data

   check_hdf = HDF_ISHDF(org_filename)
   if check_hdf eq 1 then begin
     org_sd_id = HDF_SD_START(org_filename, /READ)
     if org_sd_id eq -1 then begin
	HDF_SD_ENDACCESS,sds_id
	HDF_SD_END, sd_id
	return
     endif

     org_sds_id = HDF_SD_SELECT(org_sd_id, org_sds_index)
     if org_sds_id eq -1 then begin
	HDF_SD_END,org_sd_id
        HDF_SD_ENDACCESS,sds_id
        HDF_SD_END, sd_id
        return
     endif

     HDF_SD_GETINFO,org_sds_id, NATTS=natts

     if natts gt 0 then begin
	for i = 0, natts-1 do begin
	    HDF_SD_ATTRINFO,org_sds_id,i,NAME=attr_name,DATA=attr_value, $
		TYPE=attr_type,COUNT=count
	    HDF_SD_ATTRSET,sds_id,attr_name,attr_value,count
	endfor
     endif

     ;old_quiet = !QUIET
     ;!QUIET=1
     ;HDF_SD_GETINFO,org_sds_id,FILL=fill,FORMAT=format,LABEL=label,RANGE=range,$
;	UNIT=unit,COORDSYS=coordsys,CALDATA=caldata,NATTS=natts
;     help,fill,output=check_string
;     check_string = check_string(0)
;     if strpos(check_string,"UNDEFINED") ne -1 then fill = 3.4e+38
;     !QUIET=old_quiet
;     check_range = size(range)
;     if check_range(0) eq 0 then attr_range = 0 $
;	else attr_range = 1
;
;     if natts gt 0 then begin
;	if caldata.cal ne 0.0 then begin
;	   if attr_range gt 0 then begin
;		HDF_SD_SETINFO,sds_id,FILL=fill,FORMAT=format,LABEL=label,$
;			RANGE=range,UNIT=unit,COORDSYS=coordsys,CALDATA=caldata
;	   endif else begin
;		HDF_SD_SETINFO,sds_id,FILL=fill,FORMAT=format,LABEL=label,$
;			UNIT=unit,COORDSYS=coordsys,CALDATA=caldata
;	   endelse
;	endif else begin
;	   if attr_range gt 0 then begin
;		HDF_SD_SETINFO,sds_id,FILL=fill,FORMAT=format,LABEL=label,$
;			RANGE=range,UNIT=unit,COORDSYS=coordsys
;	   endif else begin
;		HDF_SD_SETINFO,sds_id,FILL=fill,FORMAT=format,LABEL=label,$
;			UNIT=unit,COORDSYS=coordsys
;	   endelse
;	endelse
;     endif

     ;rank = info.subset.data(this_subset).src_rank
     ;org_rank = info.subset.data(this_subset).src_org_rank
     if rank eq org_rank then begin
	for i = 0, rank-1 do begin
		org_dim_id = HDF_SD_DIMGETID(org_sds_id,i)
		HDF_SD_DIMGET,org_dim_id,NAME=name
		if strpos(name,"fakeDim") eq -1 then begin
			dim_id = HDF_SD_DIMGETID(sds_id,i)
			HDF_SD_DIMSET,dim_id,NAME=name
		endif
	endfor
     endif else begin
	org_start = info.subset.data(this_subset).src_org_start
	org_end = info.subset.data(this_subset).src_org_end
	org_increment = info.subset.data(this_subset).src_org_increment
	j = rank - 1
        ij = 0
	i = org_rank - 1
	while(j ge 0 and i ge 0) do begin
		org_dim_id = HDF_SD_DIMGETID(org_sds_id,i)
		HDF_SD_DIMGET,org_dim_id,NAME=name
		num_data = (org_end(ij)-org_start(ij))/org_increment(ij)
		if num_data gt 1 or i eq org_rank - 1 then begin
			org_dim_id = HDF_SD_DIMGETID(org_sds_id,i)
			HDF_SD_DIMGET,org_dim_id,NAME=name
			if strpos(name,"fakeDim") eq -1 then begin
				dim_id = HDF_SD_DIMGETID(sds_id,j)
				HDF_SD_DIMSET,dim_id,NAME=name
			endif
			j = j - 1
		endif
		ij = ij + 1
		i = i - 1
        endwhile
     endelse

     HDF_SD_ENDACCESS,org_sds_id
     HDF_SD_END, org_sd_id
   endif

endif else begin

   sds_id = HDF_SD_SELECT(sd_id, sds_index)
   if sds_id eq -1 then begin
	result=dialog_message('Unable to select '+temp_name+' SDS data!',$
		title='View HDF Warning!')
	HDF_SD_END,sd_id
	return
   endif

   HDF_SD_GETINFO,sds_id, DIMS=sds_dims, NDIMS=sds_rank, TYPE=sds_type

   case sds_type of
	'BYTE': data_type = 1
	'INT':  data_type = 2
	'LONG': data_type = 3
	'FLOAT': data_type = 4
	'DOUBLE': data_type = 5
	'STRING': data_type = 7
	else: data_type = 12
   endcase

   if data_type ne size_hdf_data(size_hdf_data(0)+1) then begin
	the_message = ['The data types are not same', $
		'Please check the data type and do it again!']
	result=dialog_message(the_message, title='View HDF Warning!')
	HDF_SD_ENDACCESS,sds_id
	HDF_SD_END,sd_id
	return
   endif

   this_rank = size_hdf_data(0)
   start_list = lonarr(sds_rank)
   count_list = lonarr(sds_rank)
   start_list(*) = 0
   start_list(sds_rank-1) = sds_dims(sds_rank-1)

   if sel_option eq 2 then begin
	i_value = 1
	last_record = '"'+strcompress(string(sds_dims(sds_rank-1)),/REMOVE_ALL)+'"'
	title = 'Select Start Record'
	f_title = 'Start Record:'
	message = ['Enter the record number start to overwrite', $
		'The first record number is "1"', $
		'The last record number is '+last_record]
	start_record = get_field_value(i_value, 20, title, f_title, message, info)
	start_record = start_record(0)
	if start_record eq 'cancel' then begin
		HDF_SD_ENDACCESS,sds_id
		HDF_SD_END,sd_id
		return
	endif
	start_record = long(start_record) - 1
	if start_record lt 0 then start_record = 0
	if start_record gt sds_dims(sds_rank-1) then start_record = sds_dims(sds_rank-1)
	start_list(sds_rank-1) = start_record
   endif

   if this_rank eq sds_rank then begin
	for i = 0,sds_rank-1 do begin
		count_list(i) = size_hdf_data(i+1)
	endfor
   endif else if sds_rank - this_rank eq 1 then begin
	for i = 0, sds_rank-2 do begin
		if sds_dims(i) eq size_hdf_data(i+1) then begin
			count_list(i) = size_hdf_data(i+1)
		endif else begin
			the_message = ['The data ranges are not same', $
				'Please check the data range and do it again!']
			result=dialog_message(the_message, title='View HDF Warning!')
			HDF_SD_ENDACCESS,sds_id
			HDF_SD_END,sd_id
			return
		endelse
	endfor
	count_list(sds_rank-1) = 1
   endif else begin
	the_message = ['The data ranges are not same', $
		'Please check the data range and do it again!']
	result=dialog_message(the_message, title='View HDF Warning!')
	HDF_SD_ENDACCESS,sds_id
	HDF_SD_END,sd_id
	return
   endelse

   HDF_SD_ADDDATA,sds_id,hdf_data,START=start_list,COUNT=count_list
	
endelse
		
HDF_SD_ENDACCESS,sds_id
HDF_SD_END, sd_id

end

;--------------------------------------------------------------------------------
pro write_hdf_vdata, info, write_type, this_subset, filename

pro_name = 'write_hdf_vdata'
@getinfovd

hdf_data = *info.subset.data(this_subset).src_data
if info.subset.data(this_subset).src_types(0) eq 4 or $
    info.subset.data(this_subset).src_types(0) eq 3 then begin
	hdf_data_temp = hdf_data(*).components0
	hdf_data = byte(hdf_data_temp)
endif else begin
	hdf_data = reform(hdf_data.components0, n_elements(hdf_data.components0))
endelse
size_hdf_data = size(hdf_data)
num_data = n_elements(hdf_data)

temp_name = info.subset.data(this_subset).subset_name
temp_name = temp_name(0)
dot=strpos(temp_name, '[')
if( dot ne -1) then data_name=strmid(temp_name,0,dot) $
else data_name=temp_name

sel_option = 0
if write_type eq 0 then begin
	file_id = HDF_OPEN(filename, /CREATE)
	if file_id eq -1 then begin
		result=dialog_message('Problem to create HDF file!',$
			title='View HDF Warning!')
		return
	endif
	vd_id = HDF_VD_ATTACH(file_id,-1,/WRITE)
	;if vd_id eq 0 then begin
	if vd_id le 0 then begin
		result=dialog_message('Problem to create new Vdata!',$
			title='View HDF Warning!')
		HDF_CLOSE,file_id
		return
	endif
endif else begin
	file_id = HDF_OPEN(filename, /RDWR)
	if file_id eq -1 then begin
		result=dialog_message('Problem to open HDF file!',$
			title='View HDF Warning!')
		return
	endif
	vdata_index = HDF_VD_FIND(file_id, data_name)
	if vdata_index ne 0 then begin
	   vd_id = HDF_VD_ATTACH(file_id,vdata_index,/READ)
	   ;if vd_id eq 0 then begin
	    if vd_id le 0 then begin
		result=dialog_message('Problem to open '+data_name+' Vdata!',$
			title='View HDF Warning!')
		HDF_CLOSE,file_id
		return
	   endif
	   check_field = HDF_VD_FEXIST(vd_id, data_name)
	   HDF_VD_DETACH,vd_id
	   if check_field eq 1 then begin
		;the_message = [data_name+' already exists!', $
		;	'Create another data set with same name?']
		;result=dialog_message(the_message, title='View HDF Question!', $
		;	/QUESTION)
		;if result eq 'No' then begin
		;	HDF_CLOSE,file_id
		;	return
		;endif
		the_list = ['Create another data set with same name', $
			    'Append data to the data set', $
			    'Overwrite data to the data set', $
			    'Cancel adding this data to the HDF']
		title = 'Write HDF Question'
		the_message = [data_name+' already exists!', $
			'Please select one of the following options:']
		default_option = 3
		sel_option = get_option(default_option,the_list,title,the_message,info)
		if sel_option eq 3 then begin
			HDF_CLOSE,file_id
			return
		endif
	   endif else begin
		the_message = ['Field '+data_name+' does not exist', $
			'in vdata '+data_name+'.', $
			'Create another data set with same name?']
		result=dialog_message(the_message, title='View HDF Question!', $
			/QUESTION)
		if result eq 'No' then begin
			HDF_CLOSE,file_id
			return
		endif else sel_option = 0
	   endelse
        endif
	if sel_option eq 0 then begin
		vd_id = HDF_VD_ATTACH(file_id,-1,/WRITE)
		the_message = 'Problem to create new Vdata!'
	endif else begin
		vd_id = HDF_VD_ATTACH(file_id,vdata_index,/WRITE)
		the_message = 'Problem to open Vdata!'
	endelse
	;if vd_id eq 0 then begin
	if vd_id le 0 then begin
		result=dialog_message(the_message, title='View HDF Warning!')
		HDF_CLOSE,file_id
		return
	endif
endelse

start_order = info.subset.data(this_subset).src_start(1)
end_order = info.subset.data(this_subset).src_end(1)
increment_order = info.subset.data(this_subset).src_increment(1)
the_order = long((end_order - start_order)/increment_order + 1.9)
if the_order lt 0 then the_order = 1L

if sel_option eq 0 then begin
   HDF_VD_SETINFO,vd_id,NAME=data_name

   case size_hdf_data(2) of
	1: HDF_VD_FDEFINE, vd_id, data_name, /BYTE, ORDER=the_order
	2: HDF_VD_FDEFINE, vd_id, data_name, /INT, ORDER=the_order
	3: HDF_VD_FDEFINE, vd_id, data_name, /LONG, ORDER=the_order
	4: HDF_VD_FDEFINE, vd_id, data_name, /FLOAT, ORDER=the_order
	5: HDF_VD_FDEFINE, vd_id, data_name, /DOUBLE, ORDER=the_order
	else: HDF_VD_FDEFINE, vd_id, data_name, /FLOAT, ORDER=the_order
   endcase
   the_record = long(num_data/the_order + 0.9)
   if the_order gt 1 and the_record gt 1 then $
	hdf_data = reform(hdf_data,the_order,the_record)
   HDF_VD_WRITE, vd_id, data_name, hdf_data

   HDF_VD_DETACH,vd_id
   HDF_CLOSE, file_id

   org_filename=info.subset.data(this_subset).src_filename
   org_filename = org_filename(0)
   vdata_ref=info.subset.data(this_subset).src_ref

   CD, '.', CURRENT = PWD

   if info.library_status eq 1 then begin
	;the_result = CALL_EXTERNAL(PWD+'/' + info.library,   $
	the_result = CALL_EXTERNAL(info.library,   $
	    'write_vfield_attr',	$
	    org_filename,		$
	    data_name,		$
	    vdata_ref,		$
	    filename,		$
	    data_name,		$
	    0L,			$
	    /S_VALUE)
    endif

endif else begin
   HDF_VD_GET,vd_id,COUNT=the_nrec
   HDF_VD_GETINFO,vd_id,data_name,order=this_order,type=this_type
   data_type = convert_idltypename_idltype(this_type)
   
;   case this_type of
;	'BYTE': data_type = 1
;	'INT':  data_type = 2
;	'LONG': data_type = 3
;	'FLOAT': data_type = 4
;	'DOUBLE': data_type = 5
;	'STRING': data_type = 7
;	else: data_type = 12
;   endcase

   ;print,'data_type = ',data_type,' size_hdf_data = ',size_hdf_data(size_hdf_data(0)+1)
   if data_type ne size_hdf_data(size_hdf_data(0)+1) then begin
	the_message = ['The data types are not same', $
		'Please check the data type and do it again!']
	result=dialog_message(the_message, title='View HDF Warning!')
	HDF_VD_DETACH,vd_id
	HDF_CLOSE,file_id
	return
   endif

   if this_order ne the_order then begin
	the_message = ['The field order are not same', $
		'Please check the field order and do it again!']
	result=dialog_message(the_message, title='View HDF Warning!')
	HDF_VD_DETACH,vd_id
	HDF_CLOSE,file_id
	return
   endif

   if sel_option eq 2 then begin
	i_value = 1
	last_record = '"'+strcompress(string(the_nrec),/REMOVE_ALL)+'"'
	title = 'Select Start Record'
	f_title = 'Start Record:'
	message = ['Enter the record number start to overwrite', $
		'The first record number is "1"', $
		'The last record number is '+last_record]
	start_record = get_field_value(i_value, 20, title, f_title, message, info)
	start_record = start_record(0)
	if start_record eq 'cancel' then begin
		HDF_VD_DETACH,vd_id
		HDF_CLOSE,file_id
		return
	endif
	start_record = long(start_record) - 1
	if start_record lt 0 then start_record = 0
	if start_record gt the_nrec then start_record = the_nrec
   endif else start_record = the_nrec

   HDF_VD_SEEK,vd_id,start_record

   the_record = long(num_data/the_order + 0.9)
   if the_order gt 1 and the_record gt 1 then $
	hdf_data = reform(hdf_data,the_order,the_record)
   HDF_VD_WRITE, vd_id, data_name, hdf_data

   HDF_VD_DETACH,vd_id
   HDF_CLOSE, file_id

endelse

end

;--------------------------------------------------------------------------------
pro write_hdf, info, write_type

pro_name = 'write_hdf'
@getinfo

if info.name_list_subset(0) eq "None" then begin
         result=dialog_message('No data read in Subset list yet!',$
                    title='View HDF Warning!')
         return
end

count = check_directory(info.hdf_path, info.home_path)
if count eq 0 then begin
	CD, '.', CURRENT=pwd
	info.hdf_path = pwd
endif
hdf_filename = dialog_pickfile(filter='*.hdf', path=info.hdf_path, $
			file=info.hdf_filename, get_path=hdf_path, /write)

if hdf_filename eq "" then return

hdf_result=STRPOS(hdf_filename, hdf_path)

if hdf_result eq -1 then hdf_filename=hdf_path+hdf_filename
print,"Filename=", hdf_filename
hdf_name_list=findfile(hdf_filename, count=count)
if count gt 0 and write_type eq 0 then begin
	the_message=[hdf_filename+' exists','Do you want to overwrite it?']
	result=dialog_message(the_message,/question,title='View HDF Question')
	if result eq 'No' then return
endif else if count eq 0 and write_type eq 1 then begin
	the_message=[hdf_filename+' does not exist','Do you want to create it?']
	result=dialog_message(the_message,/question,title='View HDF Question')
	if result eq 'No' then return
	write_type = 0
endif

widget_control, /hourglass

if info.name_list_subset(0) eq "None" then begin
         result=dialog_message('No data read in Subset list yet!',$
                    title='View HDF Warning!')
         return
end

pick_export_variables, info

widget_control, get_uvalue=info, info.base

info.hdf_path = hdf_path
default_file = ''
default_file = get_default_file(hdf_filename)
if default_file ne 'None' then info.hdf_filename = default_file

widget_control, /hourglass


subscripts = where(info.out.pick eq 1, numout)

print, 'number of variables picked = ', numout

if (numout eq 0) then begin
  result=dialog_message('No data selected to write!',$
                    title='View HDF Warning!')
  return
end

for i = 0, numout-1 do begin
	if info.subset.data(subscripts(i)).src_type_flag eq 0 then $
		write_hdf_sds, info, write_type, subscripts(i), hdf_filename $
	else write_hdf_vdata, info, write_type, subscripts(i), hdf_filename
	write_type = 1
endfor

result=dialog_message('Writing HDF file Completed!',$
                title='Notice!')

end

;--------------------------------------------------------------------------------
pro write_config, info

pro_name = 'write_config'
@getinfo

if info.device eq 'X' then begin
   config_filename=info.home_path+"/"+info.tempname+"_view_hdf_config_file"
endif else begin
   config_filename=info.home_path+"\"+info.tempname+"_view_hdf_config_file"
endelse

get_lun, unit
openw, unit, config_filename, ERROR=err
if err ne 0 then return

;--------------------------
; Write file header
;--------------------------
printf, unit, format='("view_hdf Configuration file for: ",A)', info.tempname
printf, unit, format='("info.precision=",A)', strcompress(info.precision,/REMOVE_ALL)
printf, unit, format='("info.filldata=",A)', strcompress(info.filldata,/REMOVE_ALL)
printf, unit, format='("info.color_bar=",A)', strcompress(string(info.color_bar),/REMOVE_ALL)
; printf, unit, format='("info.barlocation=",A)', strcompress(string(info.barlocation),/REMOVE_ALL)
if info.color_table lt 0 then info.color_table = 13
printf, unit, format='("info.color_table=",A)', strcompress(string(info.color_table),/REMOVE_ALL)
printf, unit, format='("info.open_path=",A)', strcompress(info.open_path,/REMOVE_ALL)
printf, unit, format='("info.ascii_file.open_path=",A)', strcompress(info.ascii_file.open_path,/REMOVE_ALL)
printf, unit, format='("info.open_filter=",A)', strcompress(info.open_filter,/REMOVE_ALL)
printf, unit, format='("info.ps_path=",A)', strcompress(info.ps_path,/REMOVE_ALL)
printf, unit, format='("info.ps_file=",A)', strcompress(info.ps_file,/REMOVE_ALL)
printf, unit, format='("info.eps_out.path=",A)', strcompress(info.eps_out.path,/REMOVE_ALL)
printf, unit, format='("info.eps_out.file=",A)', strcompress(info.eps_out.file,/REMOVE_ALL)
printf, unit, format='("info.eps_out.check=",A)', strcompress(info.eps_out.check,/REMOVE_ALL)
printf, unit, format='("info.export_path=",A)', strcompress(info.export_path,/REMOVE_ALL)
printf, unit, format='("info.export_file=",A)', strcompress(info.export_file,/REMOVE_ALL)
printf, unit, format='("info.hdf_path=",A)', strcompress(info.hdf_path,/REMOVE_ALL)
printf, unit, format='("info.hdf_filename=",A)', strcompress(info.hdf_filename,/REMOVE_ALL)
printf, unit, format='("info.list_path=",A)', strcompress(info.list_path,/REMOVE_ALL)
printf, unit, format='("info.output_path=",A)', strcompress(info.output_path,/REMOVE_ALL)
printf, unit, format='("info.userdefine.old_path=",A)', strcompress(info.userdefine.old_path,/REMOVE_ALL)
printf, unit, format='("info.userdefine.file=",A)', strcompress(info.userdefine.file,/REMOVE_ALL)
for i = 0, info.userdefine.count-1 do begin
    printf, unit, format='("info.userdefine.path=",A)', strcompress(info.userdefine.path(i),/REMOVE_ALL)
    printf, unit, format='("info.userdefine.name=",A)', strcompress(info.userdefine.name(i),/REMOVE_ALL)
    printf, unit, format='("info.userdefine.num_para=",A)', $
	strcompress(string(info.userdefine.num_para(i)),/REMOVE_ALL)
endfor
printf, unit, format='("info.filter=",A)', strcompress(info.filter,/REMOVE_ALL)
printf, unit, format='("info.gif_path=",A)', strcompress(info.gif_path,/REMOVE_ALL)
printf, unit, format='("info.gif_file=",A)', strcompress(info.gif_file,/REMOVE_ALL)
printf, unit, format='("info.stats_path=",A)', strcompress(info.stats_path,/REMOVE_ALL)
printf, unit, format='("info.stats_file=",A)', strcompress(info.stats_file,/REMOVE_ALL)
printf, unit, format='("info.temp_dir=",A)', strcompress(info.temp_dir,/REMOVE_ALL)
printf, unit, format='("info.home_path=",A)', strcompress(info.home_path,/REMOVE_ALL)
printf, unit, format='("info.eps_out.type=",A)', strcompress(string(info.eps_out.type),/REMOVE_ALL)
printf, unit, format='("info.eps_out.newsize=",A)', strcompress(string(info.eps_out.newsize),/REMOVE_ALL)
printf, unit, format='("info.eps_out.title=",A)', strcompress(string(info.eps_out.title),/REMOVE_ALL)
printf, unit, format='("info.eps_out.preview=",A)', strcompress(string(info.eps_out.preview),/REMOVE_ALL)
printf, unit, format='("info.eps_out.p_xsize=",A)', strcompress(string(info.eps_out.p_xsize),/REMOVE_ALL)
printf, unit, format='("info.eps_out.p_ysize=",A)', strcompress(string(info.eps_out.p_ysize),/REMOVE_ALL)
printf, unit, format='("info.eps_out.l_xsize=",A)', strcompress(string(info.eps_out.l_xsize),/REMOVE_ALL)
printf, unit, format='("info.eps_out.l_ysize=",A)', strcompress(string(info.eps_out.l_ysize),/REMOVE_ALL)
printf, unit, format='("info.editor_type=",A)', strcompress(string(info.editor_type),/REMOVE_ALL)
printf, unit, format='("info.editor=",A)', strcompress(string(info.editor),/REMOVE_ALL)
printf, unit, format='("info.menu_order.flag=",A)', strcompress(string(info.menu_order.flag),/REMOVE_ALL)
printf, unit, format='("info.menu_order.select=",A)', strcompress(info.menu_order.select)
printf, unit, format='("info.printcommand=",A)', strcompress(info.printcommand)
printf, unit, format='("info.style.linetype=",A)', strcompress(string(info.style.linetype),/REMOVE_ALL)
printf, unit, format='("info.style.linethick=",A)', strcompress(string(info.style.linethick),/REMOVE_ALL)
printf, unit, format='("info.style.symbol=",A)', strcompress(string(info.style.symbol),/REMOVE_ALL)
printf, unit, format='("info.style.usersym=",A)', strcompress(string(info.style.usersym),/REMOVE_ALL)
printf, unit, format='("info.style.symbolsize=",A)', strcompress(string(info.style.symbolsize),/REMOVE_ALL)
printf, unit, format='("info.style.symbolline=",A)', strcompress(string(info.style.symbolline),/REMOVE_ALL)
printf, unit, format='("info.style.grid=",A)', strcompress(string(info.style.grid),/REMOVE_ALL)
printf, unit, format='("info.style.colorindex=",A)', strcompress(string(info.style.colorindex),/REMOVE_ALL)
printf, unit, format='("info.char.size=",A)', strcompress(string(info.char.size),/REMOVE_ALL)
printf, unit, format='("info.char.font=",A)', strcompress(string(info.char.font),/REMOVE_ALL)
printf, unit, format='("info.char.fontname=",A)', strcompress(info.char.fontname)
printf, unit, format='("info.char.fontsize=",A)', strcompress(string(info.char.fontsize),/REMOVE_ALL)
printf, unit, format='("info.char.spacesize=",A)', strcompress(string(info.char.spacesize),/REMOVE_ALL)
printf, unit, format='("info.greenwich.greenloca=",A)', strcompress(string(info.greenwich.greenloca),/REMOVE_ALL)
printf, unit, format='("info.greenwich.lat_loc=",A)', strcompress(string(info.greenwich.lat_loc),/REMOVE_ALL)
printf, unit, format='("info.greenwich.projection=",A)', strcompress(string(info.greenwich.projection),/REMOVE_ALL)
printf, unit, format='("info.greenwich.label=",A)', strcompress(string(info.greenwich.label),/REMOVE_ALL)
printf, unit, format='("info.greenwich.with_level=",A)', strcompress(string(info.greenwich.with_level),/REMOVE_ALL)
printf, unit, format='("info.greenwich.ext_level=",A)', strcompress(string(info.greenwich.ext_level),/REMOVE_ALL)
printf, unit, format='("info.greenwich.n_level=",A)', strcompress(string(info.greenwich.n_level),/REMOVE_ALL)
printf, unit, format='("info.greenwich.expand=",A)', strcompress(string(info.greenwich.expand),/REMOVE_ALL)
printf, unit, format='("info.greenwich.satellite=",A)', strcompress(string(info.greenwich.satellite),/REMOVE_ALL)
printf, unit, format='("info.greenwich.sun=",A)', strcompress(string(info.greenwich.sun),/REMOVE_ALL)
printf, unit, format='("info.greenwich.smooth=",A)', strcompress(string(info.greenwich.smooth),/REMOVE_ALL)
printf, unit, format='("info.greenwich.n_x_grid=",A)', strcompress(string(info.greenwich.n_x_grid),/REMOVE_ALL)
printf, unit, format='("info.greenwich.n_y_grid=",A)', strcompress(string(info.greenwich.n_y_grid),/REMOVE_ALL)
printf, unit, format='("info.greenwich.continents=",A)', strcompress(string(info.greenwich.continents),/REMOVE_ALL)
printf, unit, format='("info.greenwich.mlinethick=",A)', strcompress(string(info.greenwich.mlinethick),/REMOVE_ALL)
printf, unit, format='("info.greenwich.high_resol=",A)', strcompress(string(info.greenwich.high_resol),/REMOVE_ALL)
printf, unit, format='("info.greenwich.coasts=",A)', strcompress(string(info.greenwich.coasts),/REMOVE_ALL)
printf, unit, format='("info.greenwich.grid=",A)', strcompress(string(info.greenwich.grid),/REMOVE_ALL)
printf, unit, format='("info.greenwich.glinethick=",A)', strcompress(string(info.greenwich.glinethick),/REMOVE_ALL)
printf, unit, format='("info.greenwich.noborder=",A)', strcompress(string(info.greenwich.noborder),/REMOVE_ALL)
printf, unit, format='("info.greenwich.contour=",A)', strcompress(string(info.greenwich.contour),/REMOVE_ALL)
printf, unit, format='("info.greenwich.altitude=",A)', strcompress(string(info.greenwich.altitude),/REMOVE_ALL)
printf, unit, format='("info.greenwich.tilt=",A)', strcompress(string(info.greenwich.tilt),/REMOVE_ALL)
printf, unit, format='("info.greenwich.rotation=",A)', strcompress(string(info.greenwich.rotation),/REMOVE_ALL)
printf, unit, format='("info.greenwich.baddata=",A)', strcompress(string(info.greenwich.baddata),/REMOVE_ALL)
printf, unit, format='("info.greenwich.barsize=",A)', strcompress(string(info.greenwich.barsize),/REMOVE_ALL)
printf, unit, format='("info.greenwich.setformat=",A)', strcompress(string(info.greenwich.setformat),/REMOVE_ALL)
printf, unit, format='("info.greenwich.bformat=",A)', strcompress(info.greenwich.bformat,/REMOVE_ALL)
printf, unit, format='("info.greenwich.colborder=",A)', strcompress(string(info.greenwich.colborder),/REMOVE_ALL)
printf, unit, format='("info.greenwich.displaybad=",A)', strcompress(string(info.greenwich.displaybad),/REMOVE_ALL)
printf, unit, format='("info.grid_start.long=",A)', strcompress(string(info.grid_start.long),/REMOVE_ALL)
printf, unit, format='("info.browse_image.type=",A)', strcompress(string(info.browse_image.type),/REMOVE_ALL)
printf, unit, format='("info.browse_image.shotscale=",A)', strcompress(string(info.browse_image.shotscale),/REMOVE_ALL)
printf, unit, format='("info.browse_image.btype=",A)', strcompress(string(info.browse_image.btype),/REMOVE_ALL)
printf, unit, format='("info.browse_image.rtype=",A)', strcompress(string(info.browse_image.rtype),/REMOVE_ALL)
printf, unit, format='("info.browse_image.utype=",A)', strcompress(string(info.browse_image.utype),/REMOVE_ALL)
printf, unit, format='("info.browse_image.ytype=",A)', strcompress(string(info.browse_image.ytype),/REMOVE_ALL)
printf, unit, format='("info.browse_image.xlocat=",A)', strcompress(string(info.browse_image.xlocat),/REMOVE_ALL)
printf, unit, format='("info.browse_image.useprofile=",A)', strcompress(string(info.browse_image.useprofile),/REMOVE_ALL)
printf, unit, format='("info.browse_image.setfcolor=",A)', strcompress(string(info.browse_image.setfcolor),/REMOVE_ALL)
printf, unit, format='("info.vfm.usesubset=",A)', strcompress(string(info.vfm.usesubset),/REMOVE_ALL)
printf, unit, format='("info.vfm.xlocat=",A)', strcompress(string(info.vfm.xlocat),/REMOVE_ALL)
printf, unit, format='("info.d2_image.image_order=",A)', strcompress(string(info.d2_image.image_order),/REMOVE_ALL)
printf, unit, format='("info.d2_image.colorbar=",A)', strcompress(string(info.d2_image.colorbar),/REMOVE_ALL)
printf, unit, format='("info.d2_image.yoffset=",A)', strcompress(string(info.d2_image.yoffset),/REMOVE_ALL)
printf, unit, format='("info.d2_image.deltx=",A)', strcompress(string(info.d2_image.deltx),/REMOVE_ALL)
printf, unit, format='("info.d2_image.delty=",A)', strcompress(string(info.d2_image.delty),/REMOVE_ALL)
printf, unit, format='("info.d2_image.bar_offset=",A)', strcompress(string(info.d2_image.bar_offset),/REMOVE_ALL)
printf, unit, format='("info.time_type.old=",A)', strcompress(string(info.time_type.old),/REMOVE_ALL)
printf, unit, format='("info.time_type.new=",A)', strcompress(string(info.time_type.new),/REMOVE_ALL)
printf, unit, format='("info.screen.pick=",A)', strcompress(string(info.screen.pick),/REMOVE_ALL)
printf, unit, format='("info.screen.xsize=",A)', strcompress(string(info.screen.xsize),/REMOVE_ALL)
printf, unit, format='("info.screen.ysize=",A)', strcompress(string(info.screen.ysize),/REMOVE_ALL)
;printf, unit, format='("info.pdfread=",A)', strcompress(info.pdfread,/REMOVE_ALL)
printf, unit, format='("info.current_printer=",A)', strcompress(info.current_printer,/REMOVE_ALL)
printf, unit, format='("info.top_color=",A)', strcompress(string(info.top_color),/REMOVE_ALL)
printf, unit, format='("background_color=",A)', strcompress(string(!P.BACKGROUND),/REMOVE_ALL)
printf, unit, format='("foreground_color=",A)', strcompress(string(!P.COLOR),/REMOVE_ALL)
printf, unit, format='("info.previous_file.max=",A)', strcompress(string(info.previous_file.max),/REMOVE_ALL)
for i = 0, info.previous_file.max-1 do begin
	printf, unit, format='("info.previous_file.store=",A)', strcompress(info.previous_file.store(i),/REMOVE_ALL)
endfor

close, unit
free_lun, unit

if info.oldhome_path ne info.home_path then begin
	count = check_exist_dir(info.oldhome_path)
	if count eq 1 then begin
		if info.device eq 'X' then begin
		    command_line="\cp -f "+config_filename+" "+info.oldhome_path
		endif else begin
		    command_line='copy "'+config_filename+'" "'+info.oldhome_path+'"'
		endelse
		spawn,command_line,results
	endif
endif

end

;--------------------------------------------------------------------------------
pro write_config_win, info

pro_name = 'write_config_win'
@getinfo

config_filename=info.home_path+"\"+info.tempname+"_view_hdf_config_file"

get_lun, unit
openw, unit, config_filename, ERROR=err
if err ne 0 then return

;--------------------------
; Write file header
;--------------------------
printf, unit, format='("view_hdf Configuration file for: ",A)', info.tempname
printf, unit, format='("info.precision=",A)', strcompress(info.precision,/REMOVE_ALL)
printf, unit, format='("info.filldata=",A)', strcompress(info.filldata,/REMOVE_ALL)
printf, unit, format='("info.color_bar=",A)', strcompress(string(info.color_bar),/REMOVE_ALL)
; printf, unit, format='("info.barlocation=",A)', strcompress(string(info.barlocation),/REMOVE_ALL)
if info.color_table lt 0 then info.color_table = 13
printf, unit, format='("info.color_table=",A)', strcompress(string(info.color_table),/REMOVE_ALL)
printf, unit, format='("info.open_path=",A)', info.open_path
printf, unit, format='("info.ascii_file.open_path=",A)', info.ascii_file.open_path
printf, unit, format='("info.open_filter=",A)', strcompress(info.open_filter,/REMOVE_ALL)
printf, unit, format='("info.ps_path=",A)', info.ps_path
printf, unit, format='("info.ps_file=",A)', info.ps_file
printf, unit, format='("info.eps_out.path=",A)', info.eps_out.path
printf, unit, format='("info.eps_out.file=",A)', info.eps_out.file
printf, unit, format='("info.eps_out.check=",A)', strcompress(info.eps_out.check,/REMOVE_ALL)
printf, unit, format='("info.export_path=",A)', info.export_path
printf, unit, format='("info.export_file=",A)', info.export_file
printf, unit, format='("info.hdf_path=",A)', info.hdf_path
printf, unit, format='("info.hdf_filename=",A)', info.hdf_filename
printf, unit, format='("info.list_path=",A)', info.list_path
printf, unit, format='("info.output_path=",A)', info.output_path
printf, unit, format='("info.userdefine.old_path=",A)', info.userdefine.old_path
printf, unit, format='("info.userdefine.file=",A)', info.userdefine.file
for i = 0, info.userdefine.count-1 do begin
    printf, unit, format='("info.userdefine.path=",A)', info.userdefine.path(i)
    printf, unit, format='("info.userdefine.name=",A)', strcompress(info.userdefine.name(i),/REMOVE_ALL)
    printf, unit, format='("info.userdefine.num_para=",A)', $
	strcompress(string(info.userdefine.num_para(i)),/REMOVE_ALL)
endfor
printf, unit, format='("info.filter=",A)', strcompress(info.filter,/REMOVE_ALL)
printf, unit, format='("info.gif_path=",A)', info.gif_path
printf, unit, format='("info.gif_file=",A)', info.gif_file
printf, unit, format='("info.stats_path=",A)', info.stats_path
printf, unit, format='("info.stats_file=",A)', info.stats_file
printf, unit, format='("info.temp_dir=",A)', info.temp_dir
printf, unit, format='("info.home_path=",A)', info.home_path
printf, unit, format='("info.eps_out.type=",A)', strcompress(string(info.eps_out.type),/REMOVE_ALL)
printf, unit, format='("info.eps_out.newsize=",A)', strcompress(string(info.eps_out.newsize),/REMOVE_ALL)
printf, unit, format='("info.eps_out.title=",A)', strcompress(string(info.eps_out.title),/REMOVE_ALL)
printf, unit, format='("info.eps_out.preview=",A)', strcompress(string(info.eps_out.preview),/REMOVE_ALL)
printf, unit, format='("info.eps_out.p_xsize=",A)', strcompress(string(info.eps_out.p_xsize),/REMOVE_ALL)
printf, unit, format='("info.eps_out.p_ysize=",A)', strcompress(string(info.eps_out.p_ysize),/REMOVE_ALL)
printf, unit, format='("info.eps_out.l_xsize=",A)', strcompress(string(info.eps_out.l_xsize),/REMOVE_ALL)
printf, unit, format='("info.eps_out.l_ysize=",A)', strcompress(string(info.eps_out.l_ysize),/REMOVE_ALL)
printf, unit, format='("info.editor_type=",A)', strcompress(string(info.editor_type),/REMOVE_ALL)
printf, unit, format='("info.editor=",A)', strcompress(string(info.editor),/REMOVE_ALL)
printf, unit, format='("info.menu_order.flag=",A)', strcompress(string(info.menu_order.flag),/REMOVE_ALL)
printf, unit, format='("info.menu_order.select=",A)', strcompress(info.menu_order.select)
printf, unit, format='("info.printcommand=",A)', strcompress(info.printcommand)
printf, unit, format='("info.style.linetype=",A)', strcompress(string(info.style.linetype),/REMOVE_ALL)
printf, unit, format='("info.style.linethick=",A)', strcompress(string(info.style.linethick),/REMOVE_ALL)
printf, unit, format='("info.style.symbol=",A)', strcompress(string(info.style.symbol),/REMOVE_ALL)
printf, unit, format='("info.style.usersym=",A)', strcompress(string(info.style.usersym),/REMOVE_ALL)
printf, unit, format='("info.style.symbolsize=",A)', strcompress(string(info.style.symbolsize),/REMOVE_ALL)
printf, unit, format='("info.style.symbolline=",A)', strcompress(string(info.style.symbolline),/REMOVE_ALL)
printf, unit, format='("info.style.grid=",A)', strcompress(string(info.style.grid),/REMOVE_ALL)
printf, unit, format='("info.style.colorindex=",A)', strcompress(string(info.style.colorindex),/REMOVE_ALL)
printf, unit, format='("info.char.size=",A)', strcompress(string(info.char.size),/REMOVE_ALL)
printf, unit, format='("info.char.font=",A)', strcompress(string(info.char.font),/REMOVE_ALL)
printf, unit, format='("info.char.fontname=",A)', strcompress(info.char.fontname)
printf, unit, format='("info.char.fontsize=",A)', strcompress(string(info.char.fontsize),/REMOVE_ALL)
printf, unit, format='("info.char.spacesize=",A)', strcompress(string(info.char.spacesize),/REMOVE_ALL)
printf, unit, format='("info.greenwich.greenloca=",A)', strcompress(string(info.greenwich.greenloca),/REMOVE_ALL)
printf, unit, format='("info.greenwich.lat_loc=",A)', strcompress(string(info.greenwich.lat_loc),/REMOVE_ALL)
printf, unit, format='("info.greenwich.projection=",A)', strcompress(string(info.greenwich.projection),/REMOVE_ALL)
printf, unit, format='("info.greenwich.label=",A)', strcompress(string(info.greenwich.label),/REMOVE_ALL)
printf, unit, format='("info.greenwich.with_level=",A)', strcompress(string(info.greenwich.with_level),/REMOVE_ALL)
printf, unit, format='("info.greenwich.ext_level=",A)', strcompress(string(info.greenwich.ext_level),/REMOVE_ALL)
printf, unit, format='("info.greenwich.n_level=",A)', strcompress(string(info.greenwich.n_level),/REMOVE_ALL)
printf, unit, format='("info.greenwich.expand=",A)', strcompress(string(info.greenwich.expand),/REMOVE_ALL)
printf, unit, format='("info.greenwich.satellite=",A)', strcompress(string(info.greenwich.satellite),/REMOVE_ALL)
printf, unit, format='("info.greenwich.sun=",A)', strcompress(string(info.greenwich.sun),/REMOVE_ALL)
printf, unit, format='("info.greenwich.smooth=",A)', strcompress(string(info.greenwich.smooth),/REMOVE_ALL)
printf, unit, format='("info.greenwich.n_x_grid=",A)', strcompress(string(info.greenwich.n_x_grid),/REMOVE_ALL)
printf, unit, format='("info.greenwich.n_y_grid=",A)', strcompress(string(info.greenwich.n_y_grid),/REMOVE_ALL)
printf, unit, format='("info.greenwich.continents=",A)', strcompress(string(info.greenwich.continents),/REMOVE_ALL)
printf, unit, format='("info.greenwich.mlinethick=",A)', strcompress(string(info.greenwich.mlinethick),/REMOVE_ALL)
printf, unit, format='("info.greenwich.high_resol=",A)', strcompress(string(info.greenwich.high_resol),/REMOVE_ALL)
printf, unit, format='("info.greenwich.coasts=",A)', strcompress(string(info.greenwich.coasts),/REMOVE_ALL)
printf, unit, format='("info.greenwich.grid=",A)', strcompress(string(info.greenwich.grid),/REMOVE_ALL)
printf, unit, format='("info.greenwich.glinethick=",A)', strcompress(string(info.greenwich.glinethick),/REMOVE_ALL)
printf, unit, format='("info.greenwich.noborder=",A)', strcompress(string(info.greenwich.noborder),/REMOVE_ALL)
printf, unit, format='("info.greenwich.contour=",A)', strcompress(string(info.greenwich.contour),/REMOVE_ALL)
printf, unit, format='("info.greenwich.altitude=",A)', strcompress(string(info.greenwich.altitude),/REMOVE_ALL)
printf, unit, format='("info.greenwich.tilt=",A)', strcompress(string(info.greenwich.tilt),/REMOVE_ALL)
printf, unit, format='("info.greenwich.rotation=",A)', strcompress(string(info.greenwich.rotation),/REMOVE_ALL)
printf, unit, format='("info.greenwich.baddata=",A)', strcompress(string(info.greenwich.baddata),/REMOVE_ALL)
printf, unit, format='("info.greenwich.barsize=",A)', strcompress(string(info.greenwich.barsize),/REMOVE_ALL)
printf, unit, format='("info.greenwich.setformat=",A)', strcompress(string(info.greenwich.setformat),/REMOVE_ALL)
printf, unit, format='("info.greenwich.bformat=",A)', strcompress(info.greenwich.bformat,/REMOVE_ALL)
printf, unit, format='("info.greenwich.colborder=",A)', strcompress(string(info.greenwich.colborder),/REMOVE_ALL)
printf, unit, format='("info.greenwich.displaybad=",A)', strcompress(string(info.greenwich.displaybad),/REMOVE_ALL)
printf, unit, format='("info.grid_start.long=",A)', strcompress(string(info.grid_start.long),/REMOVE_ALL)
printf, unit, format='("info.browse_image.type=",A)', strcompress(string(info.browse_image.type),/REMOVE_ALL)
printf, unit, format='("info.browse_image.shotscale=",A)', strcompress(string(info.browse_image.shotscale),/REMOVE_ALL)
printf, unit, format='("info.browse_image.btype=",A)', strcompress(string(info.browse_image.btype),/REMOVE_ALL)
printf, unit, format='("info.browse_image.rtype=",A)', strcompress(string(info.browse_image.rtype),/REMOVE_ALL)
printf, unit, format='("info.browse_image.utype=",A)', strcompress(string(info.browse_image.utype),/REMOVE_ALL)
printf, unit, format='("info.browse_image.ytype=",A)', strcompress(string(info.browse_image.ytype),/REMOVE_ALL)
printf, unit, format='("info.browse_image.xlocat=",A)', strcompress(string(info.browse_image.xlocat),/REMOVE_ALL)
printf, unit, format='("info.browse_image.useprofile=",A)', strcompress(string(info.browse_image.useprofile),/REMOVE_ALL)
printf, unit, format='("info.browse_image.setfcolor=",A)', strcompress(string(info.browse_image.setfcolor),/REMOVE_ALL)
printf, unit, format='("info.vfm.usesubset=",A)', strcompress(string(info.vfm.usesubset),/REMOVE_ALL)
printf, unit, format='("info.vfm.xlocat=",A)', strcompress(string(info.vfm.xlocat),/REMOVE_ALL)
printf, unit, format='("info.d2_image.image_order=",A)', strcompress(string(info.d2_image.image_order),/REMOVE_ALL)
printf, unit, format='("info.d2_image.colorbar=",A)', strcompress(string(info.d2_image.colorbar),/REMOVE_ALL)
printf, unit, format='("info.d2_image.yoffset=",A)', strcompress(string(info.d2_image.yoffset),/REMOVE_ALL)
printf, unit, format='("info.d2_image.deltx=",A)', strcompress(string(info.d2_image.deltx),/REMOVE_ALL)
printf, unit, format='("info.d2_image.delty=",A)', strcompress(string(info.d2_image.delty),/REMOVE_ALL)
printf, unit, format='("info.d2_image.bar_offset=",A)', strcompress(string(info.d2_image.bar_offset),/REMOVE_ALL)
printf, unit, format='("info.time_type.old=",A)', strcompress(string(info.time_type.old),/REMOVE_ALL)
printf, unit, format='("info.time_type.new=",A)', strcompress(string(info.time_type.new),/REMOVE_ALL)
printf, unit, format='("info.screen.pick=",A)', strcompress(string(info.screen.pick),/REMOVE_ALL)
printf, unit, format='("info.screen.xsize=",A)', strcompress(string(info.screen.xsize),/REMOVE_ALL)
printf, unit, format='("info.screen.ysize=",A)', strcompress(string(info.screen.ysize),/REMOVE_ALL)
;printf, unit, format='("info.pdfread=",A)', strcompress(info.pdfread,/REMOVE_ALL)
printf, unit, format='("info.current_printer=",A)', strcompress(info.current_printer,/REMOVE_ALL)
printf, unit, format='("info.top_color=",A)', strcompress(string(info.top_color),/REMOVE_ALL)
printf, unit, format='("background_color=",A)', strcompress(string(!P.BACKGROUND),/REMOVE_ALL)
printf, unit, format='("foreground_color=",A)', strcompress(string(!P.COLOR),/REMOVE_ALL)
printf, unit, format='("info.previous_file.max=",A)', strcompress(string(info.previous_file.max),/REMOVE_ALL)
for i = 0, info.previous_file.max-1 do begin
	printf, unit, format='("info.previous_file.store=",A)', info.previous_file.store(i)
endfor

close, unit
free_lun, unit

if info.oldhome_path ne info.home_path then begin
	count = check_exist_dir(info.oldhome_path)
	if count eq 1 then begin
		command_line='copy "'+config_filename+'" "'+info.oldhome_path+'"'
		spawn,command_line,results
	endif
endif

end

;--------------------------------------------------------------------------------
pro read_config, config_filename, info

pro_name = 'read_config'
@getinfo

;if info.device eq 'X' then begin
;   config_filename=info.home_path+"/"+info.tempname+"_view_hdf_config_file"
;endif else begin
;   config_filename=info.home_path+"\"+info.tempname+"_view_hdf_config_file"
;endelse

get_lun, unit
openr, unit, config_filename 

;--------------------------
; Read file header
;--------------------------
temp=''
readf, unit, temp
i = 0
while not EOF(unit) do begin
   temp=''
   readf, unit, temp
   namearray = str_sep(temp, '=')
   if n_elements(namearray) eq 2 then begin
      case namearray(0) of
	'info.precision': info.precision = namearray(1)
	'info.filldata': info.filldata = namearray(1)
	'info.color_bar': info.color_bar = fix(namearray(1))
	; 'info.barlocation': info.barlocation = float(namearray(1))
	'info.color_table': begin
		info.color_table = float(namearray(1))
		if info.color_table lt 0 then info.color_table = 13
	end
	'info.open_path': info.open_path = namearray(1)
	'info.ascii_file.open_path': info.ascii_file.open_path = namearray(1)
	'info.open_filter': info.open_filter = namearray(1)
	'info.ps_path': info.ps_path = namearray(1)
	'info.ps_file': info.ps_file = namearray(1)
	'info.eps_out.path': info.eps_out.path = namearray(1)
	'info.eps_out.file': info.eps_out.file = namearray(1)
	'info.eps_out.check': info.eps_out.check = namearray(1)
	'info.export_path': info.export_path = namearray(1)
	'info.export_file': info.export_file = namearray(1)
	'info.hdf_path': info.hdf_path = namearray(1)
	'info.hdf_filename': info.hdf_filename = namearray(1)
	'info.list_path': info.list_path = namearray(1)
	'info.output_path': info.output_path = namearray(1)
	'info.userdefine.old_path': info.userdefine.old_path = namearray(1)
	'info.userdefine.file': info.userdefine.file = namearray(1)
	'info.userdefine.path': begin
		info.userdefine.path(info.userdefine.count) = namearray(1)
		loc = strpos(!PATH, namearray(1))
		if loc eq -1 then begin
			if info.device eq 'X' then !PATH = namearray(1)+':'+!PATH $
				else !PATH = namearray(1)+';'+!PATH
		endif
	 end
	'info.userdefine.name': info.userdefine.name(info.userdefine.count) = namearray(1)
	'info.userdefine.num_para': begin
		info.userdefine.num_para(info.userdefine.count) = fix(namearray(1))
		info.userdefine.count = info.userdefine.count + 1
	 end
	'info.filter': info.filter = namearray(1)
	'info.gif_path': info.gif_path = namearray(1)
	'info.gif_file': info.gif_file = namearray(1)
	'info.stats_path': info.stats_path = namearray(1)
	'info.stats_file': info.stats_file = namearray(1)
 	'info.home_path': info.home_path = namearray(1)
	'info.temp_dir': info.temp_dir = namearray(1)
	'info.eps_out.type': info.eps_out.type = fix(namearray(1))
	'info.eps_out.newsize': info.eps_out.newsize = fix(namearray(1))
	'info.eps_out.title': info.eps_out.title = fix(namearray(1))
	'info.eps_out.preview': info.eps_out.preview = fix(namearray(1))
	'info.eps_out.p_xsize': info.eps_out.p_xsize = fix(namearray(1))
	'info.eps_out.p_ysize': info.eps_out.p_ysize = fix(namearray(1))
	'info.eps_out.l_xsize': info.eps_out.l_xsize = fix(namearray(1))
	'info.eps_out.l_ysize': info.eps_out.l_ysize = fix(namearray(1))
	'info.editor_type': info.editor_type = fix(namearray(1))
	'info.editor': info.editor= namearray(1)
	'info.menu_order.flag': info.menu_order.flag = fix(namearray(1))
	'info.menu_order.select': info.menu_order.select = namearray(1)
	'info.printcommand': info.printcommand = namearray(1)
	'info.style.linetype': info.style.linetype = float(namearray(1))
	'info.style.linethick': info.style.linethick = float(namearray(1))
	'info.style.symbol': info.style.symbol = float(namearray(1))
	'info.style.usersym': info.style.usersym = float(namearray(1))
	'info.style.symbolsize': info.style.symbolsize = float(namearray(1))
	'info.style.symbolline': info.style.symbolline = float(namearray(1))
	'info.style.grid': info.style.grid = float(namearray(1))
	'info.style.colorindex': info.style.colorindex = float(namearray(1))
	'info.char.size': info.char.size = float(namearray(1))
	'info.char.font': info.char.font = fix(namearray(1))
	'info.char.fontname': info.char.fontname = namearray(1)
	'info.char.fontsize': info.char.fontsize = fix(namearray(1))
	'info.char.spacesize': info.char.spacesize = fix(namearray(1))
	'info.greenwich.greenloca': info.greenwich.greenloca = float(namearray(1))
	'info.greenwich.lat_loc': info.greenwich.lat_loc = float(namearray(1))
	'info.greenwich.projection': info.greenwich.projection = fix(namearray(1))
	'info.greenwich.label': info.greenwich.label = fix(namearray(1))
	'info.greenwich.with_level': info.greenwich.with_level = fix(namearray(1))
	'info.greenwich.ext_level': info.greenwich.ext_level = fix(namearray(1))
	'info.greenwich.n_level': info.greenwich.n_level = fix(namearray(1))
	'info.greenwich.expand': info.greenwich.expand = fix(namearray(1))
	'info.greenwich.satellite': info.greenwich.satellite = fix(namearray(1))
	'info.greenwich.sun': info.greenwich.sun = fix(namearray(1))
	'info.greenwich.smooth': info.greenwich.smooth = fix(namearray(1))
	'info.greenwich.n_x_grid': info.greenwich.n_x_grid = fix(namearray(1))
	'info.greenwich.n_y_grid': info.greenwich.n_y_grid = fix(namearray(1))
	'info.greenwich.continents': info.greenwich.continents = fix(namearray(1))
	'info.greenwich.mlinethick': info.greenwich.mlinethick = fix(namearray(1))
	'info.greenwich.high_resol': info.greenwich.high_resol = fix(namearray(1))
	'info.greenwich.coasts': info.greenwich.coasts = fix(namearray(1))
	'info.greenwich.grid': info.greenwich.grid = fix(namearray(1))
	'info.greenwich.glinethick': info.greenwich.glinethick = fix(namearray(1))
	'info.greenwich.noborder': info.greenwich.noborder = fix(namearray(1))
	'info.greenwich.contour': info.greenwich.contour = fix(namearray(1))
	'info.greenwich.altitude': info.greenwich.altitude = fix(namearray(1))
	'info.greenwich.tilt': info.greenwich.tilt = fix(namearray(1))
	'info.greenwich.rotation': info.greenwich.rotation = fix(namearray(1))
	'info.greenwich.baddata': info.greenwich.baddata = fix(namearray(1))
	'info.greenwich.barsize': info.greenwich.barsize = float(namearray(1))
	'info.greenwich.setformat': info.greenwich.setformat = fix(namearray(1))
	'info.greenwich.bformat': info.greenwich.bformat = namearray(1)
	'info.greenwich.colborder': info.greenwich.colborder = fix(namearray(1))
	'info.greenwich.displaybad': info.greenwich.displaybad = fix(namearray(1))
	'info.grid_start.long': info.grid_start.long = fix(namearray(1))
	'info.browse_image.type': info.browse_image.type = fix(namearray(1))
	'info.browse_image.shotscale': info.browse_image.shotscale = fix(namearray(1))
	'info.browse_image.btype': info.browse_image.btype = fix(namearray(1))
	'info.browse_image.rtype': info.browse_image.rtype = fix(namearray(1))
	'info.browse_image.utype': info.browse_image.utype = fix(namearray(1))
	'info.browse_image.ytype': info.browse_image.ytype = fix(namearray(1))
	'info.browse_image.xlocat': info.browse_image.xlocat = float(namearray(1))
	'info.browse_image.useprofile': info.browse_image.useprofile = fix(namearray(1))
	'info.browse_image.setfcolor': info.browse_image.setfcolor = fix(namearray(1))
	'info.vfm.usesubset': info.vfm.usesubset = float(namearray(1))
	'info.vfm.xlocat': info.vfm.xlocat = float(namearray(1))
	'info.d2_image.image_order': info.d2_image.image_order = float(namearray(1))
	'info.d2_image.colorbar': info.d2_image.colorbar = float(namearray(1))
	'info.d2_image.yoffset': info.d2_image.yoffset = float(namearray(1))
	'info.d2_image.deltx': info.d2_image.deltx = float(namearray(1))
	'info.d2_image.delty': info.d2_image.delty = float(namearray(1))
	'info.d2_image.bar_offset': info.d2_image.bar_offset = float(namearray(1))
	'info.time_type.old': info.time_type.old = fix(namearray(1))
	'info.time_type.new': info.time_type.new = fix(namearray(1))
	'info.screen.pick': info.screen.pick = fix(namearray(1))
	'info.screen.xsize': info.screen.xsize = fix(namearray(1))
	'info.screen.ysize': info.screen.ysize = fix(namearray(1))
	;'info.pdfread': info.pdfread = namearray(1)
	'info.current_printer': info.current_printer = namearray(1)
	'info.top_color': info.top_color = fix(namearray(1))
	'info.previous_file.max': info.previous_file.max = fix(namearray(1))
	'info.previous_file.store': begin
		info.previous_file.store(i) = namearray(1)
		i = i + 1
	end
	'background_color': begin
		if fix(namearray(1)) lt 0 then begin
			!P.BACKGROUND  = 0
		endif else if fix(namearray(1)) gt info.top_color then begin
			!P.BACKGROUND = info.top_color
		endif else begin
			!P.BACKGROUND = fix(namearray(1))
		endelse
	end
	'foreground_color': begin
		; print,'fix(namearray(1)) = ',fix(namearray(1))
		; print,'Orginial: !P.COLOR = ',!P.COLOR
		if fix(namearray(1)) lt 0 then begin
			!P.COLOR  = 0
		endif else if fix(namearray(1)) gt info.top_color then begin
			!P.COLOR = info.top_color
		endif else begin
			!P.COLOR = fix(namearray(1))
		endelse
		; print,'Set the !P.COLOR = ',!P.COLOR
	end
	else:
      endcase
   endif
end

close, unit
free_lun, unit

end

;--------------------------------------------------------------------------------
PRO PDMENU3_Event, Event

pro_name = 'PDMENU3_Event'
@getinfo

widget_control, get_uvalue=info, Event.top
widget_control, get_uvalue=info, info.base
widget_control, get_uvalue=wtype, Event.id

if wtype eq 'PROFILE' then pro_check = 1 else pro_check = 0

if wtype eq 'PLOT' then base_type = 1 else base_type = 0

CASE Event.Value OF 

;  'File.Open...Without Attribute': file_open, info, 0

;  'File.Open...With Attribute': file_open, info, 1 

;  'File.Open...With Vgroup': file_open, info, 2 

  'File.Open HDF Files': file_open, info, 2, ''

  'File.Open ASCII Files': file_open_ascii, info, ''

  'File.Open Previous Files': open_previous_file, info

  'File.Display Global Attributes': display_global_attr, base_type, info

  'File.Display Metadata': display_metadata, base_type, info

  'File.Open File Filter': get_open_filter, info

;  'File.Add User Defined Module': get_user_define_module, info

;  'File.Remove User Defined Module': remove_user_define_module, info

  'File.Save Postscript...': file_save_ps, 0, info, pro_check

  'File.Save EPS Portrait': file_save_eps, info, 0, pro_check

  'File.Save EPS Landscape': file_save_eps, info, 1, pro_check

  'File.Save GIF': file_save_gif, info, 0, pro_check

  'File.Save PNG': file_save_gif, info, 1, pro_check

  'File.Save Image': file_save_image, info, pro_check, Event.top

  'File.Save MPEG': file_save_mpeg, info

  'File.Print...': file_print, info , 0, pro_check

  'File.Print Viewgraph...': file_print, info , 1, pro_check

  'File.Export....Without Filldata': file_export, info, 1

  'File.Export....With Filldata': file_export, info, 0

  'File.Export List....Without Filldata.Without Reference': export_list, info, 0, 1

  'File.Export List....Without Filldata.With Reference': export_list, info, 0, 2

  'File.Export List....With Filldata': export_list, info, 0, 0

  'File.Export Tecplot....Without Filldata.Without Reference': export_list, info, 1, 1

  'File.Export Tecplot....Without Filldata.With Reference': export_list, info, 1, 2

  'File.Export Tecplot....With Filldata': export_list, info, 1, 0

  'File.Display Profile Data': display_profile_value, info

  'File.Export Profile Data': export_profile_value, info

  'File.Create an HDF File': write_hdf, info, 0

  'File.Add Data To an HDF File': write_hdf, info, 1

  'File.Change Open File Path': change_open_path, info

  'File.Change Output Path': change_opath, info

  'File.Change Home Directory': get_home_directory, info

  'File.Change Temporary Directory': get_temp_directory, info

  'File.Read Configuration File': read_config_file, info

  'File.Change Preferences': set_preferences, event.top, info

  'File.Restart': BEGIN

	widget_control, /hourglass
	remove_all_subset, info
	;remove_all_handle_create, info
	ptr_free, ptr_valid()
	widget_control,/reset
	base_list = widget_base (uvalue = "None", map=0)
	widget_control, base_list, /realize
	info.list_base = base_list
	create_gui, info, 0
	
   END

  'File.Exit': BEGIN

	widget_control, /hourglass
	remove_all_subset, info
	;remove_all_handle_create, info
	ptr_free, ptr_valid()
	obj_destroy,obj_valid()
	;if info.color_table le 0 then info.color_table = 13
	if info.color_table lt 0 then info.color_table = 13
	;if info.color_table ne 0 then check_bw = check_color_table(!d.n_colors-2) $
	;       else check_bw = 1
	;if check_bw eq 0 then $
	if info.pick_color_table eq 1 then $
		info.color_table = get_color_table(info.color_table, info.top_color, info.home_path)
	; write_config, info
	if info.device eq 'X' then begin
	   write_config, info
	   command_line="\rm -f "+info.temp_dir+"/."+info.tempname+"_*"
	   spawn,command_line,results
	   ;print_file=info.home_path+"/"+info.printname+"_printer_name"
	   ;check_file=findfile(print_file, count=count)
	   ;if count gt 0 then begin
	;	command_line="\rm -f "+print_file
	;	spawn,command_line,results
	;   endif
	endif else begin
	   write_config_win, info
	   command_line='del "'+info.temp_dir+'\.'+info.tempname+'_*"'
	   spawn,command_line,results
	   ;print_file=info.home_path+"\"+info.printname+"_printer_name"
	   ;check_file=findfile(print_file, count=count)
	   ;if count gt 0 then begin
	;	command_line='del "'+print_file+'"'
	;	spawn,command_line,results
	;   endif
	endelse

	;wdelete, 5
	delete_window, 5
	widget_control,/reset
   END

  'File.Close': BEGIN
     if pro_check eq 0 then begin
	widget_control, /hourglass
	if info.multiple.key gt 0 then begin
		info.multiple.flag = 0
		info.multiple.key = 0
		info.multiple.y1y2 = 0
		info.style.linetype = info.multiple.linetype
		info.style.symbol = info.multiple.symbol
		info.style.symbolsize = info.multiple.symbolsize
		info.style.symbolline = info.multiple.symbolline
		info.style.colorindex = info.multiple.colorindex
	endif
	if info.addtext.key eq 1 then begin
		info = initial_addtext(info)
	endif
	if (info.graph_style eq 'Geolocated' or $
	    info.graph_style eq 'Contour Geolocated') then begin
		if ptr_valid(info.geolocated.hdf_z) then ptr_free, $
			info.geolocated.hdf_z

		if ptr_valid(info.geolocated.long) then ptr_free, $
			info.geolocated.long

		if ptr_valid(info.geolocated.colat) then ptr_free, $
			info.geolocated.colat
 
		if ptr_valid(info.geolocated.sate_long) then ptr_free, $
			info.geolocated.sate_long

		if ptr_valid(info.geolocated.sate_colat) then ptr_free, $
			info.geolocated.sate_colat

		if ptr_valid(info.geolocated.sun_long) then ptr_free, $
			info.geolocated.sun_long

		if ptr_valid(info.geolocated.sun_colat) then ptr_free, $
			info.geolocated.sun_colat

	endif
	if (info.graph_style eq 'Browse Image' or $
	    info.graph_style eq 'Browse Image With Average') then begin
		if ptr_valid(info.browse_image.z) then ptr_free, $
			info.browse_image.z

		if ptr_valid(info.browse_image.x) then ptr_free, $
			info.browse_image.x

		if ptr_valid(info.browse_image.y) then ptr_free, $
			info.browse_image.y
 
		if ptr_valid(info.browse_image.image) then ptr_free, $
			info.browse_image.image

		if ptr_valid(info.browse_image.xarray) then ptr_free, $
			info.browse_image.xarray
 
		if ptr_valid(info.browse_image.yarray) then ptr_free, $
			info.browse_image.yarray

		if ptr_valid(info.browse_image.tarray) then ptr_free, $
			info.browse_image.tarray
 
		if ptr_valid(info.browse_image.barray) then ptr_free, $
			info.browse_image.barray

		if ptr_valid(info.browse_image.aarray) then ptr_free, $
			info.browse_image.aarray

		if ptr_valid(info.browse_image.parray) then ptr_free, $
			info.browse_image.parray

		info.browse_image.farray(*) = -1
		info.browse_image.number = 0
		info.browse_image.findex = -1
		info.browse_image.feature = 0
		info.browse_image.rootname = ''
		info.browse_image.profile = 'full'

		if(widget_info(info.browse_image.base, /VALID_ID)) then $
			widget_control, info.browse_image.base, /destroy
	endif

	if info.graph_style eq 'Vertical Feature Mask' or $
	    info.graph_style eq 'Old Vertical Feature Mask' then begin
		if ptr_valid(info.vfm.data) then ptr_free, info.vfm.data
	endif

	if info.overlay.flag eq 1 then begin
	    info.overlay.flag = 0
	    info.overlay.offflag = 0
	    if ptr_valid(info.overlay.image) then ptr_free, $
	        info.overlay.image
        endif

        if(widget_info(info.widgets.subset_base, /VALID_ID)) then begin
                widget_control, info.widgets.subset_base, /destroy
	endif

	;wdelete, 5
	delete_window, 5

      endif

	widget_control,	Event.top, /destroy
    END

  'Colors.Select Colors...': BEGIN
	;	Set the colors
	if info.device eq 'X' then begin
	    color_table_file=info.home_path+"/"+"view_hdf_color.tbl"
	endif else begin
	    color_table_file=info.home_path+"\"+"view_hdf_color.tbl"
	endelse
	test_file = findfile(color_table_file, count=count)
	if count eq 0 then color_table_file = 'view_hdf_color.tbl'
	thisDepth = 8
	if info.version gt 5.19 and info.device ne 'X' then begin
	    device, get_visual_depth=thisDepth, get_decomposed=thisState
	    ;print,'after: thisDepth = ',thisDepth,' and thisState = ',thisState
	endif
	if thisDepth gt 8 and event.top eq info.widgets.base then begin
	    device, get_visual_name=device_name
	    if device_name eq 'DirectColor' then begin
		image2d = tvrd(channel=1)
	    endif else if device_name eq 'TrueColor' then begin
		image2d = convert_image24_image8()
	    endif else begin
		result=dialog_message('Unknow 24 bits Color Model!', $
		    title='View HDF Error!')
		return
	    endelse
	    erase
	    tvscl24, image2d
	    xloadct24, image2d, color_table_file
	endif else xloadct, file=color_table_file, /use_current
	info.pick_color_table = 1
    END

  'Colors.Edit Colors...': BEGIN
	current_id = !d.window
        this_widget = widget_base(resource_name='sp',$
                COLUMN=1, $
                MAP=1, $
		UVALUE = current_id, $
                TITLE='Select Edit Colors')
        the_colors = cw_colorsel(this_widget)

	group2=widget_base(this_widget, row=1,map=1, space=100, /align_center)

	button1=widget_button(group2, FONT=info.font, EVENT_PRO='edit_color_doneCB', $
		VALUE="Done", /ALIGN_CENTER)

	button2=widget_button(group2, FONT=info.font, EVENT_PRO='save_edit_color', VALUE="Save",$
		 /ALIGN_CENTER, UVALUE=info)

        widget_control, /realize,this_widget
        xmanager, 'main_widget', this_widget
   END

  'Colors.Load User Color Table': load_user_colortable, info

  'Colors.Load Discrete Color Table': load_discrete_colortable, info

  'Colors.Background': change_background, info

  'Colors.Foreground': change_foreground, info

  'Graphic.Multi Y Variables': BEGIN
	info = initial_info(info)
	info = initial_addtext(info)
	info.multiple.linetype = info.style.linetype
	info.multiple.symbol = info.style.symbol
	info.multiple.symbolsize = info.style.symbolsize
	info.multiple.symbolline = info.style.symbolline
	info.multiple.colorindex = info.style.colorindex
	do_more_variables, 0, info
  END

  'Graphic.Multi X Variables': BEGIN
	info = initial_info(info)
	info = initial_addtext(info)
	info.multiple.linetype = info.style.linetype
	info.multiple.symbol = info.style.symbol
	info.multiple.symbolsize = info.style.symbolsize
	info.multiple.symbolline = info.style.symbolline
	info.multiple.colorindex = info.style.colorindex
	do_more_x_variables, 0, info
  END

  'Graphic.X-Y Plot': BEGIN
	info = initial_info(info)
	info = initial_addtext(info)
	plot_status = 1
	do_xy_plot, 0, info, plot_status
  END

  'Graphic.X-Y-Z Plot': BEGIN
	info = initial_info(info)
	info = initial_addtext(info)
	plot_status = 1
	do_xyz_plot, 0, info, plot_status
  END

  'Graphic.Scatter Contour Plot': BEGIN
	info = initial_info(info)
	info = initial_addtext(info)
	plot_status = 1
	do_scatter_contour, 0, info, plot_status
  END

  'Graphic.3D Mesh Plot': BEGIN
	info = initial_info(info)
	info = initial_addtext(info)
	plot_status = 1
	plot_3d_mesh, 0, info, plot_status
  END

  'Graphic.Y1-Y2 Plot': BEGIN
	info = initial_info(info)
	info = initial_addtext(info)
	info.multiple.linetype = info.style.linetype
	info.multiple.symbol = info.style.symbol
	info.multiple.symbolsize = info.style.symbolsize
	info.multiple.symbolline = info.style.symbolline
	info.multiple.colorindex = info.style.colorindex
	info.multiple.y1y2 = 1
	do_more_variables, 0, info
  END

  'Graphic.2D Graph': BEGIN
	info.graph_style = '2D Graph'
	info = initial_info(info)
	info = initial_addtext(info)
	widget_control, set_uvalue=info, info.base
	widget_control, event.top, /destroy
	if(widget_info(info.browse_image.base, /VALID_ID)) then $
	    widget_control, info.browse_image.base, /destroy
	if info.multiple.key eq 1 then do_more_variables, 3, info $
	else plot_graph, 0, info.subset.selected, info
  END

  'Graphic.2D Image': BEGIN
	info.graph_style = '2D Image'
	info = initial_info(info)
	info = initial_addtext(info)
	widget_control, set_uvalue=info, info.base
	widget_control, event.top, /destroy
	if(widget_info(info.browse_image.base, /VALID_ID)) then $
	    widget_control, info.browse_image.base, /destroy
	plot_graph, 0, info.subset.selected, info
  END

  'Graphic.2D Image With Scale': BEGIN
	info.graph_style = '2D Image With Scale'
	info = initial_info(info)
	info = initial_addtext(info)
	widget_control, set_uvalue=info, info.base
	widget_control, event.top, /destroy
	if(widget_info(info.browse_image.base, /VALID_ID)) then $
	    widget_control, info.browse_image.base, /destroy
	plot_graph, 0, info.subset.selected, info
  END

  'Graphic.3D Graph': BEGIN
	info.graph_style = '3D Graph'
	info = initial_info(info)
	info = initial_addtext(info)
	widget_control, set_uvalue=info, info.base
	widget_control, event.top, /destroy
	if(widget_info(info.browse_image.base, /VALID_ID)) then $
	    widget_control, info.browse_image.base, /destroy
	plot_graph, 0, info.subset.selected, info
  END

  'Graphic.3D Surface': BEGIN
	info.graph_style = '3D Surface'
	info = initial_info(info)
	info = initial_addtext(info)
	widget_control, set_uvalue=info, info.base
	widget_control, event.top, /destroy
	if(widget_info(info.browse_image.base, /VALID_ID)) then $
	    widget_control, info.browse_image.base, /destroy
	plot_graph, 0, info.subset.selected, info
  END

  'Graphic.Contour': BEGIN
	info.graph_style = 'Contour'
	info = initial_info(info)
	info = initial_addtext(info)
	widget_control, set_uvalue=info, info.base
	widget_control, event.top, /destroy
	if(widget_info(info.browse_image.base, /VALID_ID)) then $
	    widget_control, info.browse_image.base, /destroy
	plot_graph, 0, info.subset.selected, info
  END

  'Graphic.Grid Contour': BEGIN
	info.graph_style = 'Grid Contour'
	info = initial_info(info)
	info = initial_addtext(info)
	widget_control, set_uvalue=info, info.base
	widget_control, event.top, /destroy
	if(widget_info(info.browse_image.base, /VALID_ID)) then $
	    widget_control, info.browse_image.base, /destroy
	plot_graph, 0, info.subset.selected, info
  END

  'Graphic.Grid Contour - Region': BEGIN
	info.graph_style = 'Grid Contour - Region'
	info = initial_info(info)
	info = initial_addtext(info)
	widget_control, set_uvalue=info, info.base
	widget_control, event.top, /destroy
	if(widget_info(info.browse_image.base, /VALID_ID)) then $
	    widget_control, info.browse_image.base, /destroy
	plot_graph, 0, info.subset.selected, info
  END

  'Graphic.Grid Cell': BEGIN
	info.graph_style = 'Grid Cell'
	info = initial_info(info)
	info = initial_addtext(info)
	widget_control, set_uvalue=info, info.base
	widget_control, event.top, /destroy
	if(widget_info(info.browse_image.base, /VALID_ID)) then $
	    widget_control, info.browse_image.base, /destroy
	plot_graph, 0, info.subset.selected, info
  END

  'Graphic.Grid Cell - Region': BEGIN
	info.graph_style = 'Grid Cell - Region'
	info = initial_info(info)
	info = initial_addtext(info)
	widget_control, set_uvalue=info, info.base
	widget_control, event.top, /destroy
	if(widget_info(info.browse_image.base, /VALID_ID)) then $
	    widget_control, info.browse_image.base, /destroy
	plot_graph, 0, info.subset.selected, info
  END

  'Graphic.Statistics': BEGIN
	info.graph_style = 'Statistics'
	info = initial_info(info)
	info = initial_addtext(info)
	widget_control, set_uvalue=info, info.base
	widget_control, event.top, /destroy
	if(widget_info(info.browse_image.base, /VALID_ID)) then $
	    widget_control, info.browse_image.base, /destroy
	plot_graph, 0, info.subset.selected, info
  END

  'Graphic.Statistics For Whole Subset': BEGIN
	old_graph_style = info.graph_style
	info.graph_style = 'Statistics For Whole Subset'
	info = initial_info(info)
	widget_control, set_uvalue=info, info.base
	plot_graph, 0, info.subset.selected, info
	info.graph_style = old_graph_style
  END

  'Graphic.Histogram': BEGIN
	info.graph_style = 'Histogram'
	info = initial_info(info)
	info = initial_addtext(info)
	widget_control, set_uvalue=info, info.base
	widget_control, event.top, /destroy
	if(widget_info(info.browse_image.base, /VALID_ID)) then $
	    widget_control, info.browse_image.base, /destroy
	plot_graph, 0, info.subset.selected, info
  END

  'Graphic.XY Graph': BEGIN
	info.graph_style = 'XY Graph'
	info = initial_info(info)
	info = initial_addtext(info)
	widget_control, set_uvalue=info, info.base
	widget_control, event.top, /destroy
	if(widget_info(info.browse_image.base, /VALID_ID)) then $
	    widget_control, info.browse_image.base, /destroy
	if info.multiple.key eq 1 then do_more_variables, 4, info $
	else plot_graph, 0, info.subset.selected, info
  END

  'Graphic.XYZ Graph': BEGIN
	info.graph_style = 'XYZ Graph'
	info = initial_info(info)
	info = initial_addtext(info)
	widget_control, set_uvalue=info, info.base
	widget_control, event.top, /destroy
	if(widget_info(info.browse_image.base, /VALID_ID)) then $
	    widget_control, info.browse_image.base, /destroy
	plot_graph, 0, info.subset.selected, info
  END

  'Graphic.3D Mesh Surface': BEGIN
	info.graph_style = '3D Mesh Surface'
	info = initial_info(info)
	info = initial_addtext(info)
	widget_control, set_uvalue=info, info.base
	widget_control, event.top, /destroy
	if(widget_info(info.browse_image.base, /VALID_ID)) then $
	    widget_control, info.browse_image.base, /destroy
	plot_graph, 0, info.subset.selected, info
  END

  'Graphic.3D Color Mesh Graph': BEGIN
	info.graph_style = '3D Color Mesh Graph'
	info = initial_info(info)
	info = initial_addtext(info)
	widget_control, set_uvalue=info, info.base
	widget_control, event.top, /destroy
	if(widget_info(info.browse_image.base, /VALID_ID)) then $
	    widget_control, info.browse_image.base, /destroy
	plot_graph, 0, info.subset.selected, info
  END

  'Graphic.Geolocated': BEGIN
	info.graph_style = 'Geolocated'
	info = initial_info(info)
	info = initial_addtext(info)
	widget_control, set_uvalue=info, info.base
	widget_control, event.top, /destroy
	if(widget_info(info.browse_image.base, /VALID_ID)) then $
	    widget_control, info.browse_image.base, /destroy
	plot_graph, 0, info.subset.selected, info
  END

  'Graphic.Contour Geolocated': BEGIN
	info.graph_style = 'Contour Geolocated'
	info = initial_info(info)
	info = initial_addtext(info)
	widget_control, set_uvalue=info, info.base
	widget_control, event.top, /destroy
	if(widget_info(info.browse_image.base, /VALID_ID)) then $
	    widget_control, info.browse_image.base, /destroy
	plot_graph, 0, info.subset.selected, info
  END

  'Graphic.Create Subset': BEGIN
	old_graph_style = info.graph_style
	info.graph_style = 'Create Subset'
	info.criterion.flag = 1
	info = initial_info(info)
	widget_control, set_uvalue=info, info.base
	plot_graph, 0, info.subset.selected, info
	info.graph_style = old_graph_style
  END

  'Graphic.Subsampling': BEGIN
	old_graph_style = info.graph_style
	info.graph_style = 'Subsampling'
	info = initial_info(info)
	widget_control, set_uvalue=info, info.base
	plot_graph, 0, info.subset.selected, info
	info.graph_style = old_graph_style
  END

  'Graphic.Array Average - 2D': BEGIN
	old_graph_style = info.graph_style
	info.graph_style = 'Array Average - 2D'
	info = initial_info(info)
	widget_control, set_uvalue=info, info.base
	plot_graph, 0, info.subset.selected, info
	info.graph_style = old_graph_style
  END

  'Graphic.Array Average': BEGIN
	old_graph_style = info.graph_style
	info.graph_style = 'Array Average'
	info = initial_info(info)
	widget_control, set_uvalue=info, info.base
	plot_graph, 0, info.subset.selected, info
	info.graph_style = old_graph_style
  END

  'Graphic.Regression': BEGIN
	info.graph_style = 'Regression'
	info = initial_info(info)
	info = initial_addtext(info)
	widget_control, set_uvalue=info, info.base
	widget_control, event.top, /destroy
	if(widget_info(info.browse_image.base, /VALID_ID)) then $
	    widget_control, info.browse_image.base, /destroy
	plot_graph, 0, info.subset.selected, info
  END

  'Graphic.Extract Bits': BEGIN
	info.graph_style = 'Extract Bits'
	info = initial_info(info)
	info = initial_addtext(info)
	widget_control, set_uvalue=info, info.base
	widget_control, event.top, /destroy
	if(widget_info(info.browse_image.base, /VALID_ID)) then $
	    widget_control, info.browse_image.base, /destroy
	plot_graph, 0, info.subset.selected, info
  END

  'Graphic.Browse Image': BEGIN
	info.graph_style = 'Browse Image'
	info = initial_info(info)
	info = initial_addtext(info)
	widget_control, set_uvalue=info, info.base
	widget_control, event.top, /destroy
	if(widget_info(info.browse_image.base, /VALID_ID)) then $
	    widget_control, info.browse_image.base, /destroy
	plot_graph, 0, info.subset.selected, info
  END

  'Graphic.Browse Image With Average': BEGIN
	info.graph_style = 'Browse Image With Average'
	info = initial_info(info)
	info = initial_addtext(info)
	widget_control, set_uvalue=info, info.base
	widget_control, event.top, /destroy
	if(widget_info(info.browse_image.base, /VALID_ID)) then $
	    widget_control, info.browse_image.base, /destroy
	plot_graph, 0, info.subset.selected, info
  END

  'Graphic.Vertical Feature Mask': BEGIN
	info.graph_style = 'Vertical Feature Mask'
	info = initial_info(info)
	info = initial_addtext(info)
	widget_control, set_uvalue=info, info.base
	widget_control, event.top, /destroy
	if(widget_info(info.browse_image.base, /VALID_ID)) then $
	    widget_control, info.browse_image.base, /destroy
	plot_graph, 0, info.subset.selected, info
  END

  'Graphic.Old Vertical Feature Mask': BEGIN
	info.graph_style = 'Old Vertical Feature Mask'
	info = initial_info(info)
	info = initial_addtext(info)
	widget_control, set_uvalue=info, info.base
	widget_control, event.top, /destroy
	if(widget_info(info.browse_image.base, /VALID_ID)) then $
	    widget_control, info.browse_image.base, /destroy
	plot_graph, 0, info.subset.selected, info
  END

  'Graphic.Transpose': BEGIN
	old_graph_style = info.graph_style
	info.graph_style = 'Transpose'
	info = initial_info(info)
	widget_control, set_uvalue=info, info.base
	plot_graph, 0, info.subset.selected, info
	info.graph_style = old_graph_style
  END

  'Graphic.Display Data': BEGIN
	old_graph_style = info.graph_style
	info.graph_style = 'Display Data'
	info = initial_info(info)
	widget_control, set_uvalue=info, info.base
	plot_graph, 0, info.subset.selected, info
	info.graph_style = old_graph_style
  END

  'Graphic.Display Attribute': BEGIN
	old_graph_style = info.graph_style
	info.graph_style = 'Display Attribute'
	info = initial_info(info)
	widget_control, set_uvalue=info, info.base
	plot_graph, 0, info.subset.selected, info
	info.graph_style = old_graph_style
  END

  'Compute.Y1 Plus Y2, [Y1 + Y2]': BEGIN
	info = initial_info(info)
	info = initial_addtext(info)
	info.y1y2.operator = ' + '
	info.y1y2.tri_flag = 0
	plot_status = 1
	do_y1y2_compute, 0, info, plot_status
  END

  'Compute.Y1 Minus Y2, [Y1 - Y2]': BEGIN
	info = initial_info(info)
	info = initial_addtext(info)
	info.y1y2.operator = ' - '
	info.y1y2.tri_flag = 0
	plot_status = 1
	do_y1y2_compute, 0, info, plot_status
  END

  'Compute.Y1 Times Y2, [Y1 * Y2]': BEGIN
	info = initial_info(info)
	info = initial_addtext(info)
	info.y1y2.operator = ' * '
	info.y1y2.tri_flag = 0
	plot_status = 1
	do_y1y2_compute, 0, info, plot_status
  END

  'Compute.Y1 Divided By Y2, [Y1 / Y2]': BEGIN
	info = initial_info(info)
	info = initial_addtext(info)
	info.y1y2.operator = ' / '
	info.y1y2.tri_flag = 0
	plot_status = 1
	do_y1y2_compute, 0, info, plot_status
  END

  'Compute.Y1 Raised To The Y2 Power, [Y1 ** Y2]': BEGIN
	info = initial_info(info)
	info = initial_addtext(info)
	info.y1y2.operator = ' ** '
	info.y1y2.tri_flag = 0
	plot_status = 1
	do_y1y2_compute, 0, info, plot_status
  END

  'Compute.cos(Y1)': BEGIN
	info = initial_info(info)
	info = initial_addtext(info)
	info.y1y2.operator = ' cos '
	info.y1y2.tri_flag = 1
	plot_status = 1
	do_y1y2_compute, 0, info, plot_status
  END

  'Compute.sin(Y1)': BEGIN
	info = initial_info(info)
	info = initial_addtext(info)
	info.y1y2.operator = ' sin '
	info.y1y2.tri_flag = 1
	plot_status = 1
	do_y1y2_compute, 0, info, plot_status
  END

  'Compute.tan(Y1)': BEGIN
	info = initial_info(info)
	info = initial_addtext(info)
	info.y1y2.operator = ' tan '
	info.y1y2.tri_flag = 1
	plot_status = 1
	do_y1y2_compute, 0, info, plot_status
  END

  'Compute.acos(Y1)': BEGIN
	info = initial_info(info)
	info = initial_addtext(info)
	info.y1y2.operator = ' acos '
	info.y1y2.tri_flag = 2
	plot_status = 1
	do_y1y2_compute, 0, info, plot_status
  END

  'Compute.asin(Y1)': BEGIN
	info = initial_info(info)
	info = initial_addtext(info)
	info.y1y2.operator = ' asin '
	info.y1y2.tri_flag = 2
	plot_status = 1
	do_y1y2_compute, 0, info, plot_status
  END

  'Compute.atan(Y1)': BEGIN
	info = initial_info(info)
	info = initial_addtext(info)
	info.y1y2.operator = ' atan '
	info.y1y2.tri_flag = 2
	plot_status = 1
	do_y1y2_compute, 0, info, plot_status
  END

  'Compute.Extract Bits': BEGIN
	info = initial_info(info)
	info = initial_addtext(info)
	plot_status = 1
	do_extract_bits, -1, 0, info, plot_status
  END

  'Compute.log(Y1)': BEGIN
	info = initial_info(info)
	info = initial_addtext(info)
	info.y1y2.operator = ' alog '
	plot_status = 1
	do_y1_compute, 0, info, plot_status
  END

  'Compute.log10(Y1)': BEGIN
	info = initial_info(info)
	info = initial_addtext(info)
	info.y1y2.operator = ' alog10 '
	plot_status = 1
	do_y1_compute, 0, info, plot_status
  END

  'Compute.exp(Y1)': BEGIN
	info = initial_info(info)
	info = initial_addtext(info)
	info.y1y2.operator = ' exp '
	plot_status = 1
	do_y1_compute, 0, info, plot_status
  END

  'Compute.abs(Y1)': BEGIN
	info = initial_info(info)
	info = initial_addtext(info)
	info.y1y2.operator = ' abs '
	plot_status = 1
	do_y1_compute, 0, info, plot_status
  END

  'Compute.Matrices Multiplication': BEGIN
	info = initial_info(info)
	info = initial_addtext(info)
	do_matrix_vector_compute, info
  END

  'Compute.Run User Defined Module': BEGIN
	info = initial_info(info)
	info = initial_addtext(info)
	run_user_define_module, info
  END

  'Curve Fit.Polynomial Fit': BEGIN
	info = initial_info(info)
	info = initial_addtext(info)
	info.curvefit.type = 0
	plot_status = 1
	do_curve_fit, 0, info.curvefit.type, info, plot_status
  END

  'Curve Fit.Exponential': BEGIN
	info = initial_info(info)
	info = initial_addtext(info)
	info.curvefit.type = 1
	plot_status = 1
	do_curve_fit, 0, info.curvefit.type, info, plot_status
  END

  'Curve Fit.Geometric': BEGIN
	info = initial_info(info)
	info = initial_addtext(info)
	info.curvefit.type = 2
	plot_status = 1
	do_curve_fit, 0, info.curvefit.type, info, plot_status
  END

  'Curve Fit.Logsquare': BEGIN
	info = initial_info(info)
	info = initial_addtext(info)
	info.curvefit.type = 3
	plot_status = 1
	do_curve_fit, 0, info.curvefit.type, info, plot_status
  END

  'Curve Fit.Linear Fit With Fixed Intercept': BEGIN
	info = initial_info(info)
	info = initial_addtext(info)
	info.curvefit.type = 4
	plot_status = 1
	do_curve_fit, 0, info.curvefit.type, info, plot_status
  END

  'Subset.Zoom': subset_zoom, info
 
  'Subset.Locate': subset_locate, info
 
  'Subset.End Locate': subset_locate_end, info
 
  'Subset.Select Region':  subset_select_region, info

  'Settings.Axis': begin
	axis_setting, event.top, info
	widget_control, get_uvalue=info, event.top
	if info.canceloption eq 'Yes' then begin
		info.canceloption = 'No'
	endif else begin
		if event.top eq info.widgets.base then redraw_graph, info
	endelse
   end

   'Axis.Auto': BEGIN
 	info.axis_state = 0
 	info.widgets.x_start=0L
 	info.widgets.x_end=0L
 	info.widgets.y_start=0L
 	info.widgets.y_end=0L
 	info.widgets.z_start=0L
 	info.widgets.z_end=0L
 	if event.top eq info.widgets.base then begin
 		widget_control, set_uvalue=info, info.widgets.base
 		widget_control, set_uvalue=info, info.base
 		redraw_graph, info
 	endif
   END

   'Axis.Manual.X Only': BEGIN
 	old_axis_state = info.axis_state
 	info.axis_state = 1
 	axis_setup, info, Event.top, old_axis_state
   END

   'Axis.Manual.Y Only': BEGIN
 	old_axis_state = info.axis_state
 	info.axis_state = 2
 	axis_setup, info, Event.top, old_axis_state
   END

   'Axis.Manual.Z Only': BEGIN
 	old_axis_state = info.axis_state
 	info.axis_state = 3
 	axis_setup, info, Event.top, old_axis_state
   END

   'Axis.Manual.XY Only': BEGIN
 	old_axis_state = info.axis_state
 	info.axis_state = 4
 	axis_setup, info, Event.top, old_axis_state
   END

   'Axis.Manual.XYZ': BEGIN
 	old_axis_state = info.axis_state
 	info.axis_state = 5
 	axis_setup, info, Event.top, old_axis_state
   END

   'Axis.Manual.Y2 Only': BEGIN
 	old_axis_state = info.axis_state
 	info.axis_state = 6
 	axis_setup, info, Event.top, old_axis_state
   END

   'Axis.Manual.YY2 Only': BEGIN
 	old_axis_state = info.axis_state
 	info.axis_state = 7
 	axis_setup, info, Event.top, old_axis_state
   END

   'Axis.Manual.XY2 Only': BEGIN
 	old_axis_state = info.axis_state
 	info.axis_state = 8
 	axis_setup, info, Event.top, old_axis_state
   END

   'Axis.Manual.XYY2 Only': BEGIN
 	old_axis_state = info.axis_state
 	info.axis_state = 9
 	axis_setup, info, Event.top, old_axis_state
   END

   'Axis.Grid.With XY Grid': info.style.grid = 1

   'Axis.Grid.With X Grid Only': info.style.grid = 2

   'Axis.Grid.With Y Grid Only': info.style.grid = 3

   'Axis.Grid.Without Grid': info.style.grid = 0

   'Axis.Logarithmic Axis.With Linear Axes': BEGIN
 	info.style.xlog = 0
 	info.style.ylog = 0
 	info.style.y2log = 0
 	if event.top eq info.widgets.base then begin
 		widget_control, set_uvalue=info, info.widgets.base
 		widget_control, set_uvalue=info, info.base
 		redraw_graph, info
 	endif
   END

   'Axis.Logarithmic Axis.With Logarithmic X Axis': BEGIN
 	info.style.xlog = 1
 	info.style.ylog = 0
 	info.style.y2log = 0
 	if event.top eq info.widgets.base then begin
 		widget_control, set_uvalue=info, info.widgets.base
 		widget_control, set_uvalue=info, info.base
 		redraw_graph, info
 	endif
   END

   'Axis.Logarithmic Axis.With Logarithmic Y Axis': BEGIN
 	info.style.xlog = 0
 	info.style.ylog = 1
 	info.style.y2log = 0
 	if event.top eq info.widgets.base then begin
 		widget_control, set_uvalue=info, info.widgets.base
 		widget_control, set_uvalue=info, info.base
 		redraw_graph, info
 	endif
   END

   'Axis.Logarithmic Axis.With Logarithmic XY Axes': BEGIN
 	info.style.xlog = 1
 	info.style.ylog = 1
 	info.style.y2log = 0
 	if event.top eq info.widgets.base then begin
 		widget_control, set_uvalue=info, info.widgets.base
 		widget_control, set_uvalue=info, info.base
 		redraw_graph, info
 	endif
   END

   'Axis.Logarithmic Axis.With Logarithmic Y2 Axis': BEGIN
 	info.style.xlog = 0
 	info.style.ylog = 0
 	info.style.y2log = 1
 	if event.top eq info.widgets.base then begin
 		widget_control, set_uvalue=info, info.widgets.base
 		widget_control, set_uvalue=info, info.base
 		redraw_graph, info
 	endif
   END

   'Axis.Logarithmic Axis.With Logarithmic XY2 Axes': BEGIN
 	info.style.xlog = 1
 	info.style.ylog = 0
 	info.style.y2log = 1
 	if event.top eq info.widgets.base then begin
 		widget_control, set_uvalue=info, info.widgets.base
 		widget_control, set_uvalue=info, info.base
 		redraw_graph, info
 	endif
   END

   'Axis.Logarithmic Axis.With Logarithmic YY2 Axes': BEGIN
 	info.style.xlog = 0
 	info.style.ylog = 1
 	info.style.y2log = 1
 	if event.top eq info.widgets.base then begin
 		widget_control, set_uvalue=info, info.widgets.base
 		widget_control, set_uvalue=info, info.base
 		redraw_graph, info
 	endif
   END

   'Axis.Logarithmic Axis.With Logarithmic XYY2 Axes': BEGIN
 	info.style.xlog = 1
 	info.style.ylog = 1
 	info.style.y2log = 1
 	if event.top eq info.widgets.base then begin
 		widget_control, set_uvalue=info, info.widgets.base
 		widget_control, set_uvalue=info, info.base
 		redraw_graph, info
 	endif
   END

;  'Map.Greenwich Location.Left': info.greenwich.greenloca = 180.0

;  'Map.Greenwich Location.Center': info.greenwich.greenloca = 0.0

;  'Map.Greenwich Location.Other': green_location, info

;  'Map.Center Location': center_location, event.top, info

   'Settings.Map': begin
	map_setting, event.top, info
	widget_control, get_uvalue=info, event.top
   end

;  'Map.Projection.Cylindrical': info.greenwich.projection = 0

;  'Map.Projection.Orthographic': info.greenwich.projection = 1

;  'Map.Projection.Stereographic': info.greenwich.projection = 2

;  'Map.Projection.Hammer-Aitoff': info.greenwich.projection = 3

;  'Map.Lat-Longitude.Default': BEGIN
;	info.greenwich.default = 1
;	info.geolocated.flag = 0
;	info.geolocated.selected = 0
;   END

;  'Map.Lat-Longitude.Select': BEGIN
;	info.greenwich.default = 0
;	info.geolocated.flag = 0
;	info.geolocated.selected = 0
;  END

;  'Map.Label.With Label': info.greenwich.label = 1

;  'Map.Label.Without Label': info.greenwich.label = 0

;  'Map.Expand.With Expand': info.greenwich.expand = 1

;  'Map.Expand.Without Expand': info.greenwich.expand = 0

;  'Map.Satellite.Show Satellite': info.greenwich.satellite = 1

;  'Map.Satellite.Show No Satellite': info.greenwich.satellite = 0

;  'Map.Sun.Show Sun': info.greenwich.sun = 1

;  'Map.Sun.Show No Sun': info.greenwich.sun = 0

;  'Map.Continents.Redraw Continents': info.greenwich.continents = 1

;  'Map.Continents.No Redraw Continents': info.greenwich.continents = 0

;  'Map.Continents.Thickness': continent_thick, event.top, info

;  'Map.Contour Geolocated.With Smoothing': info.greenwich.smooth = 1

;  'Map.Contour Geolocated.Without Smoothing': info.greenwich.smooth = 0

;  'Map.Contour Geolocated.Filter With Smoothing': info.greenwich.smooth = 3

;  'Map.Contour Geolocated.Filter Without Smoothing': info.greenwich.smooth = 2

;  'Map.Contour Geolocated.Average With Smoothing': info.greenwich.smooth = 5

;  'Map.Contour Geolocated.Average Without Smoothing': info.greenwich.smooth = 4

;  'Map.Contour Geolocated.Set Number of Grids': set_number_grid, info

;  'Map.Reread Geolocated Data': BEGIN
;	info.geolocated.flag = 0
;	info.geolocated.selected = 0
;  END

  'Settings.Grid Start': begin
	grid_setting, event.top, info
	widget_control, get_uvalue=info, event.top
   end

;  'Grid Start.Auto': info.grid_start.long = 500

;  'Grid Start.   0': info.grid_start.long = 0

;  'Grid Start.-180': info.grid_start.long = -180

;  'Grid Start.Other': grid_start_location, info

  'Settings.Color Bar': begin
	bar_setting, event.top, info
	widget_control, get_uvalue=info, event.top
   end

;  'Color Bar.With Color Bar.Discrete': BEGIN
;	info.color_bar = 1
;	info.greenwich.with_level = 1
;	get_n_level, info
;   END

;  'Color Bar.With Color Bar.Continuous': BEGIN
;	info.color_bar = 1
;	info.greenwich.with_level = 0
;   END

;  'Color Bar.Without Color Bar': info.color_bar = 0

;  'Color Bar.Location': bar_location, info

  'Settings.Style': BEGIN
	style_setting, event.top, info
	widget_control, get_uvalue=info, event.top
  END

   'Style.Line Type.Solid': info.style.linetype = 0

   'Style.Line Type.Dotted': info.style.linetype = 1

   'Style.Line Type.Dashed': info.style.linetype = 2

   'Style.Line Type.Dashed Dot': info.style.linetype = 3

   'Style.Line Type.Dashed Dot Dot Dot': info.style.linetype = 4

   'Style.Line Type.Long Dashes': info.style.linetype = 5

   'Style.Symbol.No Symbol': info.style.symbol = 0

   'Style.Symbol.Plus sign': info.style.symbol = 1

   'Style.Symbol.Asterisk': info.style.symbol = 2

   'Style.Symbol.Period': info.style.symbol = 3

   'Style.Symbol.Diamond': info.style.symbol = 4

   'Style.Symbol.Triangle': info.style.symbol = 5

   'Style.Symbol.Square': info.style.symbol = 6

   'Style.Symbol.X': info.style.symbol = 7

   'Style.Symbol.Circle': BEGIN
 	info.style.symbol = 8
 	info.style.usersym = 1
 	set_user_symbol, info.style.usersym
    END

   'Style.Symbol.FOV': BEGIN
 	info.style.symbol = 8
 	info.style.usersym = 2
 	set_user_symbol, info.style.usersym
    END

   'Style.Symbol.Filled Triangle': BEGIN
 	info.style.symbol = 8
 	info.style.usersym = 3
 	set_user_symbol, info.style.usersym
    END

   'Style.Symbol.Filled Square': BEGIN
 	info.style.symbol = 8
 	info.style.usersym = 4
 	set_user_symbol, info.style.usersym
    END

   'Style.Symbol.Filled Circle': BEGIN
 	info.style.symbol = 8
 	info.style.usersym = 5
 	set_user_symbol, info.style.usersym
    END

   'Style.Symbol.Filled FOV': BEGIN
 	info.style.symbol = 8
 	info.style.usersym = 6
 	set_user_symbol, info.style.usersym
    END

   'Style.Symbol With Line.Without Line': info.style.symbolline = 0

   'Style.Symbol With Line.With Line': info.style.symbolline = 1

   'Style.Line Thickness': get_line_thickness, info, event.top

   'Style.Symbol Size': get_symbol_size, info, event.top

   'Style.Data Color': get_data_color, info, event.top

  'Settings.Select Font': BEGIN
	font_setting, event.top, info
	widget_control, get_uvalue=info, event.top
  END

  'Settings.Editor': begin
	editor_setting, event.top, info
	widget_control, get_uvalue=info, event.top
   end

   'Settings.Fill Data Value': filldata_dialogue, event.top, info

   'Settings.Plot Character Size': charsize_dialogue, event.top, info

   'Settings.Display Time Type': begin
	time_setting, event.top, info
	widget_control, get_uvalue=info, event.top
   END

   'Settings.Auto Select Scale Factors': begin
	scale_setting, event.top, info
	widget_control, get_uvalue=info, event.top
   END

   'Settings.Using HDF 4.2r1 Version': begin
	hdf421_setting, event.top, info
	widget_control, get_uvalue=info, event.top
   END

   'Settings.Diplay Plot Result Question': begin
	compute_out_setting, event.top, info
	widget_control, get_uvalue=info, event.top
   END

   'Settings.Multiple Variables Style': begin
	more_variable_setting, event.top, info
	widget_control, get_uvalue=info, event.top
   END

   'Settings.2D Image Plot': begin
	image_order_setting, event.top, info
	widget_control, get_uvalue=info, event.top
   END

   'Settings.3D Mesh Surface Array Sort': begin
	array_sort_setting, event.top, info
	widget_control, get_uvalue=info, event.top
   END

   'Settings.Browse Image Plot Type': begin
	browse_setting, event.top, info
	widget_control, get_uvalue=info, event.top
   END

   'Settings.Encapsulated Postscript': begin
	eps_setting, event.top, info
	widget_control, get_uvalue=info, event.top
   END

  ;   'Settings.Misc': begin
;	misc_setting, event.top, info
;	widget_control, get_uvalue=info, event.top
;	if(widget_info(info.widgets.base, /VALID_ID)) then begin
;	    if event.top eq info.widgets.base then begin
;		if info.screen.new ne 0 then begin
;		    widget_control, info.widgets.base, /destroy
;		    if info.multiple.key eq 1 then begin
;			do_more_variables, 3, info
;		    endif else if info.multiple.key eq 2 then begin
;			do_more_x_variables, 3, info
;		    endif else begin
;			replot_screen, info.subset.selected, info
;		    endelse
;		endif
;	    endif
;	endif
;	if info.screen.new ne 0 then info.screen.new = 0
;   END

;  'Editor.VI': info.editor_type = 0

;  'Editor.Emacs': info.editor_type = 1

;  'Editor.Emacs with Xterm': info.editor_type = 5

;  'Editor.Ieditor': info.editor_type = 2

;  'Editor.Edit (PC)': info.editor_type = 4

;  'Editor.Other': get_editor_name, info, event.top

;  'Add Criterion.With Criterion': BEGIN
;	info.criterion.flag = 1
;	get_criterion, info, 0
;	WIDGET_CONTROL, info.widgets.criterion, SENSITIVE = info.criterion.flag
;   END
;
;  'Add Criterion.Without Criterion': BEGIN
;	info.criterion.flag = 0
;	WIDGET_CONTROL, info.widgets.criterion, SENSITIVE = info.criterion.flag
;   END

  'IDLhelp': online_help

  'userguide': begin
	;command_line = "/usr/slocal/acrobat/bin/acroread"
	command_line = info.pdfread
	;command_line = command_line + " /CERES/instrument/analysis/view_hdf.pdf &"
	if info.device eq 'X' then begin
	   command_line = command_line + " view_hdf.pdf &"
	endif else begin
	   command_line = command_line + " view_hdf.pdf"
	endelse
	spawn,command_line,results
   end

  'releasenote': begin
	command_line = info.pdfread
	if info.device eq 'X' then begin
	   command_line = command_line + " releasenote.pdf &"
	endif else begin
	   command_line = command_line + " releasenote.pdf"
	endelse
	spawn,command_line,results
   end

;  'aboutviewhdfi': about_view_hdf,info, 0

;  'aboutviewhdfo': about_view_hdf,info, 1

   'aboutviewhdf': about_view_hdf,info, 0

ENDCASE

if(widget_info(info.base, /VALID_ID)) then begin
     if(widget_info(info.browse_image.base, /VALID_ID)) then $
	widget_control, set_uvalue=info, info.browse_image.base
     if(widget_info(info.widgets.base, /VALID_ID)) then $
	widget_control, set_uvalue=info, info.widgets.base
     widget_control, set_uvalue=info, info.base
endif

END

;------------------------------------------------------------------
;		main_widget_event
;------------------------------------------------------------------
PRO main_widget_event, Event

pro_name = 'main_widget'
@getinfo

;widget_control, Event.id, get_uvalue=user_value
widget_control, Event.top, get_uvalue=info

tvlct,r,g,b,/get

case TAG_NAMES(event,/structure_name) of


	'COLORSEL_EVENT': begin

		color_index=event.value

		base=widget_base(resource_name='cell',$
			COLUMN=1, MAP=1, $
                	TITLE='Edit Color Cell ' + strcompress(string(color_index), /remove_all), $
			xsize=250, uvalue=color_index)

		red_slider=widget_slider(base,minimum=0, value=r(color_index),$
			maximum=255,title="red",uvalue="red")
		green_slider=widget_slider(base,minimum=0, value=g(color_index),$
			maximum=255,title="green",uvalue="green")
		blue_slider=widget_slider(base,minimum=0, value=b(color_index),$
			maximum=255,title="blue",uvalue="blue")

		this_group=widget_base(base,row=1,map=1)

		done_button=widget_button(this_group, value="Done", event_pro='doneCB')

        	widget_control, /realize, base
        	xmanager, 'main_widget', base

	end

	'WIDGET_SLIDER': begin

		widget_control, get_uvalue=color_index, event.top
		widget_control, Event.id, get_uvalue=user_value	
  		CASE user_value of
			'red':   r(color_index)=event.value
			'green': g(color_index)=event.value
			'blue':  b(color_index)=event.value
		ENDCASE

		tvlct,r,g,b
  		TV, Replicate(color_index, 60, 60)
	end

	'WIDGET_DRAW': begin
	   if event.PRESS eq 1 then begin
		if info.addtext.flag eq 1 then begin
		   if !X.S(0) eq 0 and !X.S(1) eq 0 then return
		   X = event.X
		   Y = event.Y
		   ;the_locat = CONVERT_COORD(X, Y, /DEVICE, /TO_NORMAL)
		   the_locat = CONVERT_COORD(X, Y, /DEVICE, /TO_DATA)
		   ;print, 'The location is ', the_locat(0), ' and ', the_locat(1)
		   add_text, the_locat(0), the_locat(1), info
		endif
		if info.subset_locate eq 1 then begin
		   if !X.S(0) eq 0 then return
		   X = event.X
		   Y = event.Y
		   the_locat = CONVERT_COORD(X, Y, /DEVICE, /TO_DATA)
		   if info.graph_style eq 'Browse Image' or $
		      info.graph_style eq 'Browse Image With Average' then begin
			if(not widget_info(info.browse_image.base, /VALID_ID)) then begin
			    dot=strpos(info.field_name.z,'[')
			    if dot ne -1 then ztitle=strmid(info.field_name.z,0,dot) $
				else ztitle = info.field_name.z
			    name_of_data = 'Show Individual profile for '+ztitle
			    plot_profile_window, name_of_data, info
			    widget_control, set_uvalue=info, event.top
			endif
			if(widget_info(info.browse_image.xwidget, /VALID_ID)) then $
				widget_control, set_value=the_locat(0), info.browse_image.xwidget
			info.sview.p_old = !P
			info.sview.x_old = !X
			info.sview.y_old = !Y
			window_id_old = !d.window
			draw_profile, the_locat(0), info.browse_image.pvalue, 0, info
			!P = info.sview.p_old
			!X = info.sview.x_old
			!Y = info.sview.y_old
			wset, window_id_old
		   endif else begin
			;print, 'The location is ', the_locat(0), ' and ', the_locat(1)
			print, format='("The location is X = ",'+info.precision+'," and ",'+info.precision+')', $
			    the_locat(0), the_locat(1)
		   endelse
		endif
		if info.view.d_old.NAME ne "PS" and info.view.d_old.NAME ne "PRINTER" then begin
		    widget_control, event.id, GET_VALUE=window_id
		    wset, window_id
		    widget_control, get_uvalue=info, event.top
		    !P = info.view.p_old
		    !X = info.view.x_old
		    !Y = info.view.y_old
		    widget_control, set_uvalue=info, info.base
		endif
	   endif
        end

	'WIDGET_TRACKING': begin
	   if event.ENTER eq 1 then begin
		if info.view.d_old.NAME ne "PS" and info.view.d_old.NAME ne "PRINTER" then begin
		   widget_control, event.id, GET_VALUE=window_id
		   wset, window_id
		   widget_control, get_uvalue=info, event.top
		   !P = info.view.p_old
		   !X = info.view.x_old
		   !Y = info.view.y_old
		   this_subset = info.subset.selected
		   widget_control, info.list_base, get_uvalue = save_list
		   name_list_subset = save_list.name_list_subset
		   info.subset = save_list.subset
		   info.subset.selected = this_subset
		   info = redefine_info(info, name_list_subset, 4)
		   widget_control, set_uvalue=info, info.base
		   if event.top ne info.base then widget_control, set_uvalue=info, event.top
		endif
	   endif
	end

	'WIDGET_KILL_REQUEST': begin
	    if(widget_info(info.widgets.base, /valid_id)) then begin
		if(info.widgets.base eq event.top) then check_pause, event.top
	    endif
	end

	ELSE: PDMENU3_event, Event
ENDCASE

END

;--------------------------------------------------------------------------------
PRO view_hdf, max_color=max_color, macosx=macosx, hdf421=hdf421

pro_name = 'view_hdf'
@getinfo

info = create_info()

if info.device eq 'X' then begin
    spawn, "uname", result, /sh
    result = result(0)
    result = strlowcase(result)
    dot=strpos(result,'darwin')
endif else dot = -1

if keyword_set(macosx) then begin
    if macosx eq 1 then dot = 1
endif
    
if info.device eq 'X' and dot eq -1 then DEVICE, PSEUDO_COLOR = 8
;if info.device eq 'X' then DEVICE, PSEUDO_COLOR = 8
DEVICE, GET_SCREEN_SIZE=scr

!EXCEPT = 0

screen_xsize = fix(0.9*scr(0))
if screen_xsize lt 1030 then begin
   info.screen.xsize = screen_xsize
   info.screen.ysize = fix(0.6*scr(1))
   info.screen.pick = 2
endif else if screen_xsize lt 1145 then begin
   info.screen.xsize = 1024
   info.screen.ysize = 600
   info.screen.pick = 0
endif else begin
   info.screen.xsize = 1152
   info.screen.ysize = 614
   info.screen.pick = 1
   info.char.size = 0.6
   info.char.sgi = 1
endelse

!X.CHARSIZE = 0.85
!Y.CHARSIZE = 0.85

count = check_exist_dir(info.home_path)
if count eq 0 then begin
	message = [ "Your home directory is invalid!", info.home_path , $
		"Please assign a valid home directory."]
	result=dialog_message( message, title='View HDF Warning!')
	get_home_directory, info
endif

old_home_path = info.home_path

if info.device eq 'X' then begin
   config_filename=info.home_path+"/"+info.tempname+"_view_hdf_config_file"
endif else begin
   config_filename=info.home_path+"\"+info.tempname+"_view_hdf_config_file"
endelse
test_file = findfile(config_filename, count=count)
;if count eq 1 then read_config,config_filename,info
if count gt 0 then begin
    read_config,config_filename,info
    ;info.greenwich.baddata = !P.BACKGROUND
    new_flag = 0
endif else new_flag = 1

; print,'After read_config, !P.COLOR = ',!P.COLOR

count = check_exist_dir(info.home_path)
if count eq 0 then info.home_path = old_home_path

if info.version lt 5.19 then begin
    device, get_visual_depth=thisDepth
    print,'thisDepth = ',thisDepth
endif else begin
    device, get_visual_depth=thisDepth, get_decomposed=thisState
    print,'thisDepth = ',thisDepth,' and thisState = ',thisState
endelse
;if !d.n_colors gt 256 then begin
if thisDepth gt 8 then begin
	device, decomposed=0
	info.top_color = 256
	if !P.BACKGROUND gt 255 then !P.BACKGROUND = 255
	if !P.COLOR gt 255 then !P.COLOR = 255
endif

; print,'After thisDepth, !P.COLOR = ',!P.COLOR

if info.version gt 5.19 then begin
    device, get_visual_depth=thisDepth, get_decomposed=thisState
    print,'after: thisDepth = ',thisDepth,' and thisState = ',thisState
endif else print,'after: thisDepth = ',thisDepth

if keyword_set(max_color) then begin
	;if !d.n_colors - 1 lt max_color then max_color = !d.n_colors - 1
	if !d.n_colors lt max_color then max_color = !d.n_colors
	if !P.COLOR eq info.top_color-1 then begin
		!P.COLOR = max_color - 1 
	endif else begin
		!P.COLOR = fix(float(!P.COLOR)/float(info.top_color)*float(max_color))
	endelse
	if !P.BACKGROUND eq info.top_color-1 then begin
		!P.BACKGROUND = max_color - 1 
	endif else if !P.BACKGROUND gt 0 then begin
		!P.BACKGROUND = fix(float(!P.BACKGROUND)/float(info.top_color)*float(max_color))
	endif
	info.top_color = max_color
	if !P.COLOR GE info.top_color then !P.COLOR = info.top_color-1
	if !P.BACKGROUND GE info.top_color then !P.BACKGROUND = info.top_color-1
endif
;if !d.n_colors - 1 lt info.top_color then info.top_color = !d.n_colors - 1
if !d.n_colors lt info.top_color then info.top_color = !d.n_colors

; print,'After check_color, !P.COLOR = ',!P.COLOR
; print,'After check_color, !P.BACKGROUND = ',!P.BACKGROUND

;  To avoid changing the !P.COLOR, save the orginial one
old_foreground = !P.COLOR

window, colors=info.top_color, /pixmap
wdelete

if old_foreground ne !P.COLOR then !P.COLOR = old_foreground

; print,'After window, !P.COLOR = ',!P.COLOR
; print,'After window, !P.BACKGROUND = ',!P.BACKGROUND

;print,'before check color = ',info.top_color
;Verify the actual number of colors
if info.top_color gt !d.n_colors then begin
    max_color = !d.n_colors
    if !P.COLOR eq info.top_color-1 then begin
	!P.COLOR = max_color - 1
    endif else begin
	!P.COLOR = fix(float(!P.COLOR)/float(info.top_color)*float(max_color))
    endelse
    if !P.BACKGROUND eq info.top_color-1 then begin
	!P.BACKGROUND = max_color - 1
    endif else if !P.BACKGROUND gt 0 then begin
	!P.BACKGROUND = fix(float(!P.BACKGROUND)/float(info.top_color)*float(max_color))
    endif
    info.top_color = max_color
    if !P.COLOR GE info.top_color then !P.COLOR = info.top_color-1
    if !P.BACKGROUND GE info.top_color then !P.BACKGROUND = info.top_color-1
endif
;print,'final color = ',info.top_color

; print,'After check top_color, !P.COLOR = ',!P.COLOR

;Verify the gif support and png support
info.gif_out.gif_flag = check_gif_support(info)
info.gif_out.png_flag = check_png_support(info)
;print,'info.gif_out.gif_flag = ',info.gif_out.gif_flag,', info.gif_out.png_flag = ',info.gif_out.png_flag

if info.style.symbol eq 8 and info.style.usersym eq 0 then $
        info.style.usersym = 4
set_user_symbol, info.style.usersym

if info.userdefine.count gt 0 then begin
	userdefine_name = info.userdefine.name(0)
	for i = 1 , info.userdefine.count-1 do begin
		userdefine_name = [userdefine_name, info.userdefine.name(i)]
	endfor
	info = redefine_info(info, userdefine_name, 12)
endif

info.browse_image.farray(*) = -1
info.multiple.colorarray(*) = !P.COLOR

;  Check HDF5 is supported
if info.version ge 5.5 then begin
    help,'hdf5',/dlm, output=check_string
    check_string = check_string[0]
    if strpos(check_string,"Unknow") ne -1 then info.hdf5.exist = 0 $
	else info.hdf5.exist = 1
endif else info.hdf5.exist = 0

if info.hdf5.exist eq 1 then begin
    resolve_routine, 'get_hdf5_objinfo', /IS_FUNCTION
    resolve_routine, 'read_sdn_data', /IS_FUNCTION
    resolve_routine, 'read_hdf5_sdn_data'
    resolve_routine, 'cdn_field_range_dialogue'
endif

print,'info.hdf5.exist = ',info.hdf5.exist

if keyword_set(hdf421) then begin
    ;  Assume the HDF 4.2r1 shared library is created.
    if(hdf421 eq 1 and info.library_status) then info.hdf421 = 1
    ;  If the HDF 4.2r1 is available in IDL, don't need to use external C library
    hdf_lib_info,major=major,minor=minor
    hdf_version = double(major) + double(minor)/10
    if hdf_version gt 4.16 then nfo.hdf421 = 0
    hdf_lib_info,version=ver
    print,'info.hdf421 = ',info.hdf421
    print,'the current version of the HDF Library is: ',ver
endif

!P.FONT = info.char.font
if info.char.font gt -1 then begin
    ;  use pixmap to avoid a window pop up
    result = check_font(info.char.fontname, info.char.font)
    if result eq 1 then begin
	window, /pixmap
	if !D.Name eq 'X' and info.char.font eq 0 then begin
	    device, set_font = info.char.fontname
	endif else begin
	    if info.char.font eq 0 then begin
		device, set_font = info.char.fontname, $
		    set_character_size = [info.char.fontsize, info.char.spacesize]
	    endif else begin
		device, set_font = info.char.fontname, $
		    set_character_size = [info.char.fontsize, info.char.spacesize], $
		    /tt_font
	    endelse
	endelse
	wdelete
    endif
endif

defsysv, '!UserStop', 1
defsysv, '!UserPause', 1
defsysv, '!UserDone', 1

; print,'Before create_gui, !P.COLOR = ',!P.COLOR

create_gui, info, new_flag

END
